/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],re=function(K){for(var e=[],n=0,C=K.length;n<C;n++)e[n]=se[K[n]];return e};define(se[136],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=C,e.$hb=k,e.$ib=R,e.$jb=j,e.$kb=E,e.$lb=u,e.$nb=g,e.$ob=p,e.$pb=v,e.$qb=m,e.$rb=d;function n(y,w){const b=C(y,w);if(b!==-1)return y[b]}function C(y,w,b=y.length-1){for(let f=b;f>=0;f--){const h=y[f];if(w(h))return f}return-1}function k(y,w){const b=R(y,w);return b===-1?void 0:y[b]}function R(y,w,b=0,f=y.length){let h=b,S=f;for(;h<S;){const a=Math.floor((h+S)/2);w(y[a])?h=a+1:S=a}return h-1}function j(y,w){const b=E(y,w);return b===y.length?void 0:y[b]}function E(y,w,b=0,f=y.length){let h=b,S=f;for(;h<S;){const a=Math.floor((h+S)/2);w(y[a])?S=a:h=a+1}return h}function u(y,w,b=0,f=y.length){const h=E(y,w,b,f);return h===y.length?-1:h}class c{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(c.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const b=R(this.e,w,this.c);return this.c=b+1,b===-1?void 0:this.e[b]}}e.$mb=c;function g(y,w){if(y.length===0)return;let b=y[0];for(let f=1;f<y.length;f++){const h=y[f];w(h,b)>0&&(b=h)}return b}function p(y,w){if(y.length===0)return;let b=y[0];for(let f=1;f<y.length;f++){const h=y[f];w(h,b)>=0&&(b=h)}return b}function v(y,w){return g(y,(b,f)=>-w(b,f))}function m(y,w){if(y.length===0)return-1;let b=0;for(let f=1;f<y.length;f++){const h=y[f];w(h,y[b])>0&&(b=f)}return b}function d(y,w){for(const b of y){const f=w(b);if(f!==void 0)return f}}}),define(se[137],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=C,e.$M=k,e.$N=R;function n(j,E){const u=Object.create(null);for(const c of j){const g=E(c);let p=u[g];p||(p=u[g]=[]),p.push(c)}return u}function C(j,E){const u=[],c=[];for(const g of j)E.has(g)||u.push(g);for(const g of E)j.has(g)||c.push(g);return{removed:u,added:c}}function k(j,E){const u=[],c=[];for(const[g,p]of j)E.has(g)||u.push(p);for(const[g,p]of E)j.has(g)||c.push(p);return{removed:u,added:c}}function R(j,E){const u=new Set;for(const c of E)j.has(c)&&u.add(c);return u}}),define(se[138],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0t=e.$9t=e.$8t=e.$7t=void 0;function n(E,u){const c=Math.pow(10,u);return Math.round(E*c)/c}class C{constructor(u,c,g,p=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,u))|0,this.g=Math.min(255,Math.max(0,c))|0,this.b=Math.min(255,Math.max(0,g))|0,this.a=n(Math.max(Math.min(1,p),0),3)}static equals(u,c){return u.r===c.r&&u.g===c.g&&u.b===c.b&&u.a===c.a}}e.$7t=C;class k{constructor(u,c,g,p){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.l=n(Math.max(Math.min(1,g),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.l===c.l&&u.a===c.a}static fromRGBA(u){const c=u.r/255,g=u.g/255,p=u.b/255,v=u.a,m=Math.max(c,g,p),d=Math.min(c,g,p);let y=0,w=0;const b=(d+m)/2,f=m-d;if(f>0){switch(w=Math.min(b<=.5?f/(2*b):f/(2-2*b),1),m){case c:y=(g-p)/f+(g<p?6:0);break;case g:y=(p-c)/f+2;break;case p:y=(c-g)/f+4;break}y*=60,y=Math.round(y)}return new k(y,w,b,v)}static i(u,c,g){return g<0&&(g+=1),g>1&&(g-=1),g<1/6?u+(c-u)*6*g:g<1/2?c:g<2/3?u+(c-u)*(2/3-g)*6:u}static toRGBA(u){const c=u.h/360,{s:g,l:p,a:v}=u;let m,d,y;if(g===0)m=d=y=p;else{const w=p<.5?p*(1+g):p+g-p*g,b=2*p-w;m=k.i(b,w,c+1/3),d=k.i(b,w,c),y=k.i(b,w,c-1/3)}return new C(Math.round(m*255),Math.round(d*255),Math.round(y*255),v)}}e.$8t=k;class R{constructor(u,c,g,p){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,u),0)|0,this.s=n(Math.max(Math.min(1,c),0),3),this.v=n(Math.max(Math.min(1,g),0),3),this.a=n(Math.max(Math.min(1,p),0),3)}static equals(u,c){return u.h===c.h&&u.s===c.s&&u.v===c.v&&u.a===c.a}static fromRGBA(u){const c=u.r/255,g=u.g/255,p=u.b/255,v=Math.max(c,g,p),m=Math.min(c,g,p),d=v-m,y=v===0?0:d/v;let w;return d===0?w=0:v===c?w=((g-p)/d%6+6)%6:v===g?w=(p-c)/d+2:w=(c-g)/d+4,new R(Math.round(w*60),y,v,u.a)}static toRGBA(u){const{h:c,s:g,v:p,a:v}=u,m=p*g,d=m*(1-Math.abs(c/60%2-1)),y=p-m;let[w,b,f]=[0,0,0];return c<60?(w=m,b=d):c<120?(w=d,b=m):c<180?(b=m,f=d):c<240?(b=d,f=m):c<300?(w=d,f=m):c<=360&&(w=m,f=d),w=Math.round((w+y)*255),b=Math.round((b+y)*255),f=Math.round((f+y)*255),new C(w,b,f,v)}}e.$9t=R;class j{static fromHex(u){return j.Format.CSS.parseHex(u)||j.red}static equals(u,c){return!u&&!c?!0:!u||!c?!1:u.equals(c)}get hsla(){return this.i?this.i:k.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(u){if(u)if(u instanceof C)this.rgba=u;else if(u instanceof k)this.i=u,this.rgba=k.toRGBA(u);else if(u instanceof R)this.j=u,this.rgba=R.toRGBA(u);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(u){return!!u&&C.equals(this.rgba,u.rgba)&&k.equals(this.hsla,u.hsla)&&R.equals(this.hsva,u.hsva)}getRelativeLuminance(){const u=j.k(this.rgba.r),c=j.k(this.rgba.g),g=j.k(this.rgba.b),p=.2126*u+.7152*c+.0722*g;return n(p,4)}static k(u){const c=u/255;return c<=.03928?c/12.92:Math.pow((c+.055)/1.055,2.4)}getContrastRatio(u){const c=this.getRelativeLuminance(),g=u.getRelativeLuminance();return c>g?(c+.05)/(g+.05):(g+.05)/(c+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(u){const c=this.getRelativeLuminance(),g=u.getRelativeLuminance();return c>g}isDarkerThan(u){const c=this.getRelativeLuminance(),g=u.getRelativeLuminance();return c<g}lighten(u){return new j(new k(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*u,this.hsla.a))}darken(u){return new j(new k(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*u,this.hsla.a))}transparent(u){const{r:c,g,b:p,a:v}=this.rgba;return new j(new C(c,g,p,v*u))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(u){const c=u.rgba,g=this.rgba.a,p=c.a,v=g+p*(1-g);if(v<1e-6)return j.transparent;const m=this.rgba.r*g/v+c.r*p*(1-g)/v,d=this.rgba.g*g/v+c.g*p*(1-g)/v,y=this.rgba.b*g/v+c.b*p*(1-g)/v;return new j(new C(m,d,y,v))}makeOpaque(u){if(this.isOpaque()||u.rgba.a!==1)return this;const{r:c,g,b:p,a:v}=this.rgba;return new j(new C(u.rgba.r-v*(u.rgba.r-c),u.rgba.g-v*(u.rgba.g-g),u.rgba.b-v*(u.rgba.b-p),1))}flatten(...u){const c=u.reduceRight((g,p)=>j.o(p,g));return j.o(this,c)}static o(u,c){const g=1-u.rgba.a;return new j(new C(g*c.rgba.r+u.rgba.a*u.rgba.r,g*c.rgba.g+u.rgba.a*u.rgba.g,g*c.rgba.b+u.rgba.a*u.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(u,c,g){if(u.isLighterThan(c))return u;g=g||.5;const p=u.getRelativeLuminance(),v=c.getRelativeLuminance();return g=g*(v-p)/v,u.lighten(g)}static getDarkerColor(u,c,g){if(u.isDarkerThan(c))return u;g=g||.5;const p=u.getRelativeLuminance(),v=c.getRelativeLuminance();return g=g*(p-v)/p,u.darken(g)}static{this.white=new j(new C(255,255,255,1))}static{this.black=new j(new C(0,0,0,1))}static{this.red=new j(new C(255,0,0,1))}static{this.blue=new j(new C(0,0,255,1))}static{this.green=new j(new C(0,255,0,1))}static{this.cyan=new j(new C(0,255,255,1))}static{this.lightgrey=new j(new C(211,211,211,1))}static{this.transparent=new j(new C(0,0,0,0))}}e.$0t=j,function(E){let u;(function(c){let g;(function(p){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:E.Format.CSS.formatRGBA(t)}p.formatRGB=v;function m(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}p.formatRGBA=m;function d(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:E.Format.CSS.formatHSLA(t)}p.formatHSL=d;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}p.formatHSLA=y;function w(t){const r=t.toString(16);return r.length!==2?"0"+r:r}function b(t){return`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}`}p.formatHex=b;function f(t,r=!1){return r&&t.rgba.a===1?E.Format.CSS.formatHex(t):`#${w(t.rgba.r)}${w(t.rgba.g)}${w(t.rgba.b)}${w(Math.round(t.rgba.a*255))}`}p.formatHexA=f;function h(t){return t.isOpaque()?E.Format.CSS.formatHex(t):E.Format.CSS.formatRGBA(t)}p.format=h;function S(t){const r=t.length;if(r===0||t.charCodeAt(0)!==35)return null;if(r===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new E(new C(s,i,o,1))}if(r===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),l=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new E(new C(s,i,o,l/255))}if(r===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new E(new C(16*s+s,16*i+i,16*o+o))}if(r===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),l=a(t.charCodeAt(4));return new E(new C(16*s+s,16*i+i,16*o+o,(16*l+l)/255))}return null}p.parseHex=S;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(g=c.CSS||(c.CSS={}))})(u=E.Format||(E.Format={}))}(j||(e.$0t=j={}))}),define(se[51],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=C,e.$4h=k,e.$5h=R;function n(j){return(E,u,c)=>{let g=null,p=null;if(typeof c.value=="function"?(g="value",p=c.value):typeof c.get=="function"&&(g="get",p=c.get),!p)throw new Error("not supported");c[g]=j(p,u)}}function C(j,E,u){let c=null,g=null;if(typeof u.value=="function"?(c="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(c="get",g=u.get),!g)throw new Error("not supported");const p=`$memoize$${E}`;u[c]=function(...v){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,v)}),this[p]}}function k(j,E,u){return n((c,g)=>{const p=`$debounce$${g}`,v=`$debounce$result$${g}`;return function(...m){this[v]||(this[v]=u?u():void 0),clearTimeout(this[p]),E&&(this[v]=E(this[v],...m),m=[this[v]]),this[p]=setTimeout(()=>{c.apply(this,m),this[v]=u?u():void 0},j)}})}function R(j,E,u){return n((c,g)=>{const p=`$throttle$timer$${g}`,v=`$throttle$result$${g}`,m=`$throttle$lastRun$${g}`,d=`$throttle$pending$${g}`;return function(...y){if(this[v]||(this[v]=u?u():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),E&&(this[v]=E(this[v],...y)),this[d])return;const w=this[m]+j;w<=Date.now()?(this[m]=Date.now(),c.apply(this,[this[v]]),this[v]=u?u():void 0):(this[d]=!0,this[p]=setTimeout(()=>{this[d]=!1,this[m]=Date.now(),c.apply(this,[this[v]]),this[v]=u?u():void 0},w-Date.now()))}})}}),define(se[15],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=k,e.$1=R,e.$2=j,e.$3=E,e.$4=c,e.$6=p,e.$7=v,e.$8=m,e.$0=y;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function C(a){e.$X.setUnexpectedErrorHandler(a)}function k(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(a){c(a)||e.$X.onUnexpectedError(a)}function j(a){c(a)||e.$X.onUnexpectedExternalError(a)}function E(a){if(a instanceof Error){const{name:t,message:r}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:h.isErrorNoTelemetry(a)}}return a}const u="Canceled";function c(a){return a instanceof g?!0:a instanceof Error&&a.name===u&&a.message===u}class g extends Error{constructor(){super(u),this.name=this.message}}e.$5=g;function p(){const a=new Error(u);return a.name=a.message,a}function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function m(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class d extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=d;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class w extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=w;class b extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=b;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class S extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype)}}e.$cb=S}),define(se[22],re([0,1,15,136]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=k,e.$tb=R,e.$ub=j,e.$vb=E,e.$wb=u,e.$xb=c,e.$yb=g,e.$zb=p,e.$Ab=v,e.$Bb=m,e.$Cb=d,e.$Db=y,e.$Eb=w,e.top=b,e.$Gb=f,e.$Hb=S,e.$Ib=a,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=i,e.$Nb=o,e.$Ob=l,e.$Pb=$,e.$Qb=P,e.$Rb=D,e.$Sb=I,e.$Tb=O,e.$Ub=M,e.$Vb=W,e.$Wb=F,e.$Xb=T,e.$Yb=U,e.$Zb=ae,e.$1b=te,e.$2b=ce,e.$3b=J,e.$4b=V,e.$5b=q,e.$6b=H,e.$7b=oe,e.$0b=Q;function k(z,Y=0){return z[z.length-(1+Y)]}function R(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function j(z,Y,x=(ee,X)=>ee===X){if(z===Y)return!0;if(!z||!Y||z.length!==Y.length)return!1;for(let ee=0,X=z.length;ee<X;ee++)if(!x(z[ee],Y[ee]))return!1;return!0}function E(z,Y){const x=z.length-1;Y<x&&(z[Y]=z[x]),z.pop()}function u(z,Y,x){return c(z.length,ee=>x(z[ee],Y))}function c(z,Y){let x=0,ee=z-1;for(;x<=ee;){const X=(x+ee)/2|0,ue=Y(X);if(ue<0)x=X+1;else if(ue>0)ee=X-1;else return X}return-(x+1)}function g(z,Y,x){if(z=z|0,z>=Y.length)throw new TypeError("invalid index");const ee=Y[Math.floor(Y.length*Math.random())],X=[],ue=[],he=[];for(const pe of Y){const $e=x(pe,ee);$e<0?X.push(pe):$e>0?ue.push(pe):he.push(pe)}return z<X.length?g(z,X,x):z<X.length+he.length?he[0]:g(z-(X.length+he.length),ue,x)}function p(z,Y){const x=[];let ee;for(const X of z.slice(0).sort(Y))!ee||Y(ee[0],X)!==0?(ee=[X],x.push(ee)):ee.push(X);return x}function*v(z,Y){let x,ee;for(const X of z)ee!==void 0&&Y(ee,X)?x.push(X):(x&&(yield x),x=[X]),ee=X;x&&(yield x)}function m(z,Y){for(let x=0;x<=z.length;x++)Y(x===0?void 0:z[x-1],x===z.length?void 0:z[x])}function d(z,Y){for(let x=0;x<z.length;x++)Y(x===0?void 0:z[x-1],z[x],x+1===z.length?void 0:z[x+1])}function y(z,Y,x){const ee=[];function X(pe,$e,ye){if($e===0&&ye.length===0)return;const Se=ee[ee.length-1];Se&&Se.start+Se.deleteCount===pe?(Se.deleteCount+=$e,Se.toInsert.push(...ye)):ee.push({start:pe,deleteCount:$e,toInsert:ye})}let ue=0,he=0;for(;;){if(ue===z.length){X(ue,0,Y.slice(he));break}if(he===Y.length){X(ue,z.length-ue,[]);break}const pe=z[ue],$e=Y[he],ye=x(pe,$e);ye===0?(ue+=1,he+=1):ye<0?(X(ue,1,[]),ue+=1):ye>0&&(X(ue,0,[$e]),he+=1)}return ee}function w(z,Y,x){const ee=y(z,Y,x),X=[],ue=[];for(const he of ee)X.push(...z.slice(he.start,he.start+he.deleteCount)),ue.push(...he.toInsert);return{removed:X,added:ue}}function b(z,Y,x){if(x===0)return[];const ee=z.slice(0,x).sort(Y);return h(z,Y,ee,x,z.length),ee}function f(z,Y,x,ee,X){return x===0?Promise.resolve([]):new Promise((ue,he)=>{(async()=>{const pe=z.length,$e=z.slice(0,x).sort(Y);for(let ye=x,Se=Math.min(x+ee,pe);ye<pe;ye=Se,Se=Math.min(Se+ee,pe)){if(ye>x&&await new Promise(ke=>setTimeout(ke)),X&&X.isCancellationRequested)throw new n.$5;h(z,Y,$e,ye,Se)}return $e})().then(ue,he)})}function h(z,Y,x,ee,X){for(const ue=x.length;ee<X;ee++){const he=z[ee];if(Y(he,x[ue-1])<0){x.pop();const pe=(0,C.$kb)(x,$e=>Y(he,$e)<0);x.splice(pe,0,he)}}}function S(z){return z.filter(Y=>!!Y)}function a(z){let Y=0;for(let x=0;x<z.length;x++)z[x]&&(z[Y]=z[x],Y+=1);z.length=Y}function t(z,Y,x){z.splice(x,0,z.splice(Y,1)[0])}function r(z){return!Array.isArray(z)||z.length===0}function s(z){return Array.isArray(z)&&z.length>0}function i(z,Y=x=>x){const x=new Set;return z.filter(ee=>{const X=Y(ee);return x.has(X)?!1:(x.add(X),!0)})}function o(z){const Y=new Set;return x=>{const ee=z(x);return Y.has(ee)?!1:(Y.add(ee),!0)}}function l(z,Y){return z.length>0?z[0]:Y}function $(z,Y){return z.length>0?z[z.length-1]:Y}function P(z,Y,x=(ee,X)=>ee===X){let ee=0;for(let X=0,ue=Math.min(z.length,Y.length);X<ue&&x(z[X],Y[X]);X++)ee++;return ee}function D(z,Y){let x=typeof Y=="number"?z:0;typeof Y=="number"?x=z:(x=0,Y=z);const ee=[];if(x<=Y)for(let X=x;X<Y;X++)ee.push(X);else for(let X=x;X>Y;X--)ee.push(X);return ee}function I(z,Y,x){return z.reduce((ee,X)=>(ee[Y(X)]=x?x(X):X,ee),Object.create(null))}function O(z,Y){return z.push(Y),()=>M(z,Y)}function M(z,Y){const x=z.indexOf(Y);if(x>-1)return z.splice(x,1),Y}function W(z,Y,x){const ee=z.slice(0,Y),X=z.slice(Y);return ee.concat(x,X)}function F(z,Y){let x;if(typeof Y=="number"){let ee=Y;x=()=>{const X=Math.sin(ee++)*179426549;return X-Math.floor(X)}}else x=Math.random;for(let ee=z.length-1;ee>0;ee-=1){const X=Math.floor(x()*(ee+1)),ue=z[ee];z[ee]=z[X],z[X]=ue}}function T(z,Y){const x=z.indexOf(Y);x>-1&&(z.splice(x,1),z.unshift(Y))}function U(z,Y){const x=z.indexOf(Y);x>-1&&(z.splice(x,1),z.push(Y))}function ae(z,Y){for(const x of Y)z.push(x)}function te(z,Y){return Array.isArray(z)?z.map(Y):Y(z)}function ce(z){return Array.isArray(z)?z:[z]}function J(z){return z[Math.floor(Math.random()*z.length)]}function V(z,Y,x){const ee=L(z,Y),X=z.length,ue=x.length;z.length=X+ue;for(let he=X-1;he>=ee;he--)z[he+ue]=z[he];for(let he=0;he<ue;he++)z[he+ee]=x[he]}function q(z,Y,x,ee){const X=L(z,Y);let ue=z.splice(X,x);return ue===void 0&&(ue=[]),V(z,X,ee),ue}function L(z,Y){return Y<0?Math.max(Y+z.length,0):Math.min(Y,z.length)}var B;(function(z){function Y(ue){return ue<0}z.isLessThan=Y;function x(ue){return ue<=0}z.isLessThanOrEqual=x;function ee(ue){return ue>0}z.isGreaterThan=ee;function X(ue){return ue===0}z.isNeitherLessOrGreaterThan=X,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(B||(e.CompareResult=B={}));function H(z,Y){return(x,ee)=>Y(z(x),z(ee))}function oe(...z){return(Y,x)=>{for(const ee of z){const X=ee(Y,x);if(!B.isNeitherLessOrGreaterThan(X))return X}return B.neitherLessOrGreaterThan}}const G=(z,Y)=>z-Y;e.$8b=G;const le=(z,Y)=>(0,e.$8b)(z?1:0,Y?1:0);e.$9b=le;function Q(z){return(Y,x)=>-z(Y,x)}class A{constructor(Y){this.g=Y,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Y){let x=this.c;for(;x<this.g.length&&Y(this.g[x]);)x++;const ee=x===this.c?null:this.g.slice(this.c,x);return this.c=x,ee}takeFromEndWhile(Y){let x=this.d;for(;x>=0&&Y(this.g[x]);)x--;const ee=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Y=this.g[this.c];return this.c++,Y}removeLast(){const Y=this.g[this.d];return this.d--,Y}takeCount(Y){const x=this.g.slice(this.c,this.c+Y);return this.c+=Y,x}}e.$$b=A;class N{static{this.empty=new N(Y=>{})}constructor(Y){this.iterate=Y}forEach(Y){this.iterate(x=>(Y(x),!0))}toArray(){const Y=[];return this.iterate(x=>(Y.push(x),!0)),Y}filter(Y){return new N(x=>this.iterate(ee=>Y(ee)?x(ee):!0))}map(Y){return new N(x=>this.iterate(ee=>x(Y(ee))))}some(Y){let x=!1;return this.iterate(ee=>(x=Y(ee),!x)),x}findFirst(Y){let x;return this.iterate(ee=>Y(ee)?(x=ee,!1):!0),x}findLast(Y){let x;return this.iterate(ee=>(Y(ee)&&(x=ee),!0)),x}findLastMaxBy(Y){let x,ee=!0;return this.iterate(X=>((ee||B.isGreaterThan(Y(X,x)))&&(ee=!1,x=X),!0)),x}}e.$_b=N;class _{constructor(Y){this.c=Y}static createSortPermutation(Y,x){const ee=Array.from(Y.keys()).sort((X,ue)=>x(Y[X],Y[ue]));return new _(ee)}apply(Y){return Y.map((x,ee)=>Y[this.c[ee]])}inverse(){const Y=this.c.slice();for(let x=0;x<this.c.length;x++)Y[this.c[x]]=x;return new _(Y)}}e.$ac=_}),define(se[139],re([0,1,15]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$ed=k,e.$fd=R,e.$gd=j,e.$hd=E,e.$id=u;function C(c,g){if(!c)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}function k(c,g="Unreachable"){throw new Error(g)}function R(c,g="unexpected state"){if(!c)throw new n.$cb(`Assertion Failed: ${g}`)}function j(c){c||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function E(c){if(!c()){debugger;c(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function u(c,g){let p=0;for(;p<c.length-1;){const v=c[p],m=c[p+1];if(!g(v,m))return!1;p++}return!0}}),define(se[86],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(C,k){const R=this;let j=!1,E;return function(){if(j)return E;if(j=!0,k)try{E=C.apply(R,arguments)}finally{k()}else E=C.apply(R,arguments);return E}}}),define(se[71],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(C){function k(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=k;const R=Object.freeze([]);function j(){return R}C.empty=j;function*E(t){yield t}C.single=E;function u(t){return k(t)?t:E(t)}C.wrap=u;function c(t){return t||R}C.from=c;function*g(t){for(let r=t.length-1;r>=0;r--)yield t[r]}C.reverse=g;function p(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=p;function v(t){return t[Symbol.iterator]().next().value}C.first=v;function m(t,r){for(const s of t)if(r(s))return!0;return!1}C.some=m;function d(t,r){for(const s of t)if(r(s))return s}C.find=d;function*y(t,r){for(const s of t)r(s)&&(yield s)}C.filter=y;function*w(t,r){let s=0;for(const i of t)yield r(i,s++)}C.map=w;function*b(...t){for(const r of t)yield*r}C.concat=b;function f(t,r,s){let i=s;for(const o of t)i=r(i,o);return i}C.reduce=f;function*h(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}C.slice=h;function S(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const i=t[Symbol.iterator]();for(let o=0;o<r;o++){const l=i.next();if(l.done)return[s,C.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return i}}]}C.consume=S;async function a(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}C.asyncToArray=a})(n||(e.Iterable=n={}))}),define(se[42],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=j,e.$Kn=p,e.$Ln=v,e.$Mn=m,e.$Nn=d,e.$On=y,e.$Pn=w,e.$Qn=b,e.$Rn=f,e.$Sn=h,e.$Tn=S,e.$Un=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var k;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(k||(e.ParseErrorCode=k={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function j(t,r=!1){let s=0;const i=t.length;let o="",l=0,$=16,P=0;function D(U){let ae=0,te=0;for(;ae<U;){const ce=t.charCodeAt(s);if(ce>=48&&ce<=57)te=te*16+ce-48;else if(ce>=65&&ce<=70)te=te*16+ce-65+10;else if(ce>=97&&ce<=102)te=te*16+ce-97+10;else break;s++,ae++}return ae<U&&(te=-1),te}function I(U){s=U,o="",l=0,$=16,P=0}function O(){const U=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&c(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&c(t.charCodeAt(s)))for(s++;s<t.length&&c(t.charCodeAt(s));)s++;else return P=3,t.substring(U,s);let ae=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&c(t.charCodeAt(s))){for(s++;s<t.length&&c(t.charCodeAt(s));)s++;ae=s}else P=3;return t.substring(U,ae)}function M(){let U="",ae=s;for(;;){if(s>=i){U+=t.substring(ae,s),P=2;break}const te=t.charCodeAt(s);if(te===34){U+=t.substring(ae,s),s++;break}if(te===92){if(U+=t.substring(ae,s),s++,s>=i){P=2;break}switch(t.charCodeAt(s++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const J=D(4);J>=0?U+=String.fromCharCode(J):P=4;break}default:P=5}ae=s;continue}if(te>=0&&te<=31)if(u(te)){U+=t.substring(ae,s),P=2;break}else P=6;s++}return U}function W(){if(o="",P=0,l=s,s>=i)return l=i,$=17;let U=t.charCodeAt(s);if(E(U)){do s++,o+=String.fromCharCode(U),U=t.charCodeAt(s);while(E(U));return $=15}if(u(U))return s++,o+=String.fromCharCode(U),U===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),$=14;switch(U){case 123:return s++,$=1;case 125:return s++,$=2;case 91:return s++,$=3;case 93:return s++,$=4;case 58:return s++,$=6;case 44:return s++,$=5;case 34:return s++,o=M(),$=10;case 47:{const ae=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!u(t.charCodeAt(s));)s++;return o=t.substring(ae,s),$=12}if(t.charCodeAt(s+1)===42){s+=2;const te=i-1;let ce=!1;for(;s<te;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,P=1),o=t.substring(ae,s),$=13}return o+=String.fromCharCode(U),s++,$=16}case 45:if(o+=String.fromCharCode(U),s++,s===i||!c(t.charCodeAt(s)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),$=11;default:for(;s<i&&F(U);)s++,U=t.charCodeAt(s);if(l!==s){switch(o=t.substring(l,s),o){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return o+=String.fromCharCode(U),s++,$=16}}function F(U){if(E(U)||u(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let U;do U=W();while(U>=12&&U<=15);return U}return{setPosition:I,getPosition:()=>s,scan:r?T:W,getToken:()=>$,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>P}}function E(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function u(t){return t===10||t===13||t===8232||t===8233}function c(t){return t>=48&&t<=57}var g;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(g||(g={}));function p(t,r){const s=[],i=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function P(D,I,O,M){l.value=D,l.offset=I,l.length=O,l.type=M,l.colonOffset=void 0,o=l}try{h(t,{onObjectBegin:(D,I)=>{if(r<=D)throw i;o=void 0,$=r>D,s.push("")},onObjectProperty:(D,I,O)=>{if(r<I||(P(D,I,O,"property"),s[s.length-1]=D,r<=I+O))throw i},onObjectEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onArrayBegin:(D,I)=>{if(r<=D)throw i;o=void 0,s.push(0)},onArrayEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onLiteralValue:(D,I,O)=>{if(r<I||(P(D,I,O,a(D)),r<=I+O))throw i},onSeparator:(D,I,O)=>{if(r<=I)throw i;if(D===":"&&o&&o.type==="property")o.colonOffset=I,$=!1,o=void 0;else if(D===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:($=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:o,isAtPropertyKey:$,matches:D=>{let I=0;for(let O=0;I<D.length&&O<s.length;O++)if(D[I]===s[O]||D[I]==="*")I++;else if(D[I]!=="**")return!1;return I===D.length}}}function v(t,r=[],s=R.DEFAULT){let i=null,o=[];const l=[];function $(D){Array.isArray(o)?o.push(D):i!==null&&(o[i]=D)}return h(t,{onObjectBegin:()=>{const D={};$(D),l.push(o),o=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const D=[];$(D),l.push(o),o=D,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:$,onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s),o[0]}function m(t,r=[],s=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function l(D){return i.children.push(D),D}h(t,{onObjectBegin:D=>{i=l({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,I,O)=>{i=l({type:"property",offset:I,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:I,length:O,parent:i})},onObjectEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onArrayBegin:(D,I)=>{i=l({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onLiteralValue:(D,I,O)=>{l({type:a(D),offset:I,length:O,parent:i,value:D}),o(I+O)},onSeparator:(D,I,O)=>{i.type==="property"&&(D===":"?i.colonOffset=I:D===","&&o(I))},onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s);const P=i.children[0];return P&&delete P.parent,P}function d(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===i){s=l.children[1],o=!0;break}if(!o)return}else{const o=i;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function w(t){switch(t.type){case"array":return t.children.map(w);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=w(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function f(t,r,s=!1){if(b(t,r,s)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const l=f(i[o],r,s);if(l)return l}return t}}function h(t,r,s=R.DEFAULT){const i=j(t,!1);function o(oe){return oe?()=>oe(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(oe){return oe?G=>oe(G,i.getTokenOffset(),i.getTokenLength()):()=>!0}const $=o(r.onObjectBegin),P=l(r.onObjectProperty),D=o(r.onObjectEnd),I=o(r.onArrayBegin),O=o(r.onArrayEnd),M=l(r.onLiteralValue),W=l(r.onSeparator),F=o(r.onComment),T=l(r.onError),U=s&&s.disallowComments,ae=s&&s.allowTrailingComma;function te(){for(;;){const oe=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:U||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(oe){case 12:case 13:U?ce(10):F();break;case 16:ce(1);break;case 15:case 14:break;default:return oe}}}function ce(oe,G=[],le=[]){if(T(oe),G.length+le.length>0){let Q=i.getToken();for(;Q!==17;){if(G.indexOf(Q)!==-1){te();break}else if(le.indexOf(Q)!==-1)break;Q=te()}}}function J(oe){const G=i.getTokenValue();return oe?M(G):P(G),te(),!0}function V(){switch(i.getToken()){case 11:{let oe=0;try{oe=JSON.parse(i.getTokenValue()),typeof oe!="number"&&(ce(2),oe=0)}catch{ce(2)}M(oe);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return te(),!0}function q(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(J(!1),i.getToken()===6?(W(":"),te(),H()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function L(){$(),te();let oe=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(oe||ce(4,[],[]),W(","),te(),i.getToken()===2&&ae)break}else oe&&ce(6,[],[]);q()||ce(4,[],[2,5]),oe=!0}return D(),i.getToken()!==2?ce(7,[2],[]):te(),!0}function B(){I(),te();let oe=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(oe||ce(4,[],[]),W(","),te(),i.getToken()===4&&ae)break}else oe&&ce(6,[],[]);H()||ce(4,[],[4,5]),oe=!0}return O(),i.getToken()!==4?ce(8,[4],[]):te(),!0}function H(){switch(i.getToken()){case 3:return B();case 1:return L();case 10:return J(!0);default:return V()}}return te(),i.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):H()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function S(t,r){const s=j(t),i=[];let o,l=0,$;do switch($=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:l!==$&&i.push(t.substring(l,$)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),l=s.getPosition();break}while(o!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[140],re([0,1,42]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=C,e.$Wn=k,e.$Xn=E,e.$Yn=u;function C(c,g,p){let v,m,d,y,w;if(g){for(y=g.offset,w=y+g.length,d=y;d>0&&!u(c,d-1);)d--;let $=w;for(;$<c.length&&!u(c,$);)$++;m=c.substring(d,$),v=j(m,p)}else m=c,v=0,d=0,y=0,w=c.length;const b=E(p,c);let f=!1,h=0,S;p.insertSpaces?S=R(" ",p.tabSize||4):S="	";const a=(0,n.$Jn)(m,!1);let t=!1;function r(){return b+R(S,v+h)}function s(){let $=a.scan();for(f=!1;$===15||$===14;)f=f||$===14,$=a.scan();return t=$===16||a.getTokenError()!==0,$}const i=[];function o($,P,D){!t&&P<w&&D>y&&c.substring(P,D)!==$&&i.push({offset:P,length:D-P,content:$})}let l=s();if(l!==17){const $=a.getTokenOffset()+d,P=R(S,v);o(P,d,$)}for(;l!==17;){let $=a.getTokenOffset()+a.getTokenLength()+d,P=s(),D="";for(;!f&&(P===12||P===13);){const O=a.getTokenOffset()+d;o(" ",$,O),$=a.getTokenOffset()+a.getTokenLength()+d,D=P===12?r():"",P=s()}if(P===2)l!==1&&(h--,D=r());else if(P===4)l!==3&&(h--,D=r());else{switch(l){case 3:case 1:h++,D=r();break;case 5:case 12:D=r();break;case 13:f?D=r():D=" ";break;case 6:D=" ";break;case 10:if(P===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:P===12||P===13?D=" ":P!==5&&P!==17&&(t=!0);break;case 16:t=!0;break}f&&(P===12||P===13)&&(D=r())}const I=a.getTokenOffset()+d;o(D,$,I),l=P}return i}function k(c,g){const p=JSON.stringify(c,void 0,g.insertSpaces?g.tabSize||4:"	");return g.eol!==void 0?p.replace(/\r\n|\r|\n/g,g.eol):p}function R(c,g){let p="";for(let v=0;v<g;v++)p+=c;return p}function j(c,g){let p=0,v=0;const m=g.tabSize||4;for(;p<c.length;){const d=c.charAt(p);if(d===" ")v++;else if(d==="	")v+=m;else break;p++}return Math.floor(v/m)}function E(c,g){for(let p=0;p<g.length;p++){const v=g.charAt(p);if(v==="\r")return p+1<g.length&&g.charAt(p+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return c&&c.eol||`
`}function u(c,g){return`\r
`.indexOf(c.charAt(g))!==-1}}),define(se[103],re([0,1,42,140]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=k,e.$1n=R,e.$2n=j,e.$3n=E,e.$4n=u;function k(c,g,p){return R(c,g,void 0,p)}function R(c,g,p,v,m){const d=g.slice(),y=[],w=(0,n.$Mn)(c,y);let b,f;for(;d.length>0&&(f=d.pop(),b=(0,n.$Nn)(w,d),b===void 0&&p!==void 0);)typeof f=="string"?p={[f]:p}:p=[p];if(b)if(b.type==="object"&&typeof f=="string"&&Array.isArray(b.children)){const h=(0,n.$Nn)(b,[f]);if(h!==void 0)if(p===void 0){if(!h.parent)throw new Error("Malformed AST");const S=b.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if(S>0){const r=b.children[S-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return j(c,{offset:a,length:t-a,content:""},v)}else return j(c,{offset:h.offset,length:h.length,content:JSON.stringify(p)},v);else{if(p===void 0)return[];const S=`${JSON.stringify(f)}: ${JSON.stringify(p)}`,a=m?m(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+S}}else b.children.length===0?t={offset:b.offset+1,length:0,content:S}:t={offset:b.offset+1,length:0,content:S+","};return j(c,t,v)}}else if(b.type==="array"&&typeof f=="number"&&Array.isArray(b.children))if(p!==void 0){const h=`${JSON.stringify(p)}`;let S;if(b.children.length===0||f===0)S={offset:b.offset+1,length:0,content:b.children.length===0?h:h+","};else{const a=f===-1||f>b.children.length?b.children.length:f,t=b.children[a-1];S={offset:t.offset+t.length,length:0,content:","+h}}return j(c,S,v)}else{const h=f,S=b.children[h];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===h){const t=b.children[h-1],r=t.offset+t.length,s=b.offset+b.length;a={offset:r,length:s-2-r,content:""}}else a={offset:S.offset,length:b.children[h+1].offset-S.offset,content:""};return j(c,a,v)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${b.type}`);else return p===void 0?[]:j(c,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(p)},v)}function j(c,g,p){let v=E(c,g),m=g.offset,d=g.offset+g.content.length;if(g.length===0||g.content.length===0){for(;m>0&&!(0,C.$Yn)(v,m-1);)m--;for(;d<v.length&&!(0,C.$Yn)(v,d);)d++}const y=(0,C.$Vn)(v,{offset:m,length:d-m},p);for(let b=y.length-1;b>=0;b--){const f=y[b];v=E(v,f),m=Math.min(m,f.offset),d=Math.max(d,f.offset+f.length),d+=f.content.length-f.length}const w=c.length-(v.length-d)-m;return[{offset:m,length:w,content:v.substring(m,d)}]}function E(c,g){return c.substring(0,g.offset)+g.content+c.substring(g.offset+g.length)}function u(c,g){const p=g.slice(0).sort((m,d)=>{const y=m.offset-d.offset;return y===0?m.length-d.length:y});let v=c.length;for(let m=p.length-1;m>=0;m--){const d=p[m];if(d.offset+d.length<=v)c=E(c,d);else throw new Error("Overlapping edit");v=d.offset}return c}}),define(se[62],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(se[104],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class C{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const j=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=j}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,j){const E=new n(R);if(this.a===n.Undefined)this.a=E,this.b=E;else if(j){const c=this.b;this.b=E,E.prev=c,c.next=E}else{const c=this.a;this.a=E,E.next=c,c.prev=E}this.c+=1;let u=!1;return()=>{u||(u=!0,this.e(E))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const j=R.prev;j.next=R.next,R.next.prev=j}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$5c=C}),define(se[32],re([0,1]),function(K,e){"use strict";var n,C,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=R,e.$yc=j,e.$zc=E,e.$Ic=S;function R(a,t,r){let s=a.get(t);return s===void 0&&(s=r,a.set(t,s)),s}function j(a){const t=[];return a.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${a.size}) {${t.join(", ")}}`}function E(a){const t=[];return a.forEach(r=>{t.push(r)}),`Set(${a.size}) {${t.join(", ")}}`}class u{constructor(t,r){this.uri=t,this.value=r}}function c(a){return Array.isArray(a)}class g{static{this.c=t=>t.toString()}constructor(t,r){if(this[n]="ResourceMap",t instanceof g)this.d=new Map(t.d),this.e=r??g.c;else if(c(t)){this.d=new Map,this.e=r??g.c;for(const[s,i]of t)this.set(s,i)}else this.d=new Map,this.e=t??g.c}set(t,r){return this.d.set(this.e(t),new u(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=g;class p{constructor(t,r){this[C]="ResourceSet",!t||typeof t=="function"?this.c=new g(t):(this.c=new g(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((s,i)=>t.call(r,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=p;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class m{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const s=this.c.get(t);if(s)return r!==0&&this.m(s,r),s.value}set(t,r,s=0){let i=this.c.get(t);if(i)i.value=r,s!==0&&this.m(i,s);else{switch(i={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const s=this.g;let i=this.d;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}values(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}entries(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.next,s--;this.d=r,this.f=s,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.previous,s--;this.e=r,this.f=s,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const s=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(s.previous=i,i.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const s=t.next,i=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=i,i.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.$Cc=m;class d extends m{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class y extends d{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Dc=y;class w extends d{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Ec=w;class b{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Fc=b;class f{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((s,i)=>{t.call(r,s,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=f;class h{constructor(){this.c=new Map}add(t,r){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(r)}delete(t,r){const s=this.c.get(t);s&&(s.delete(r),s.size===0&&this.c.delete(t))}forEach(t,r){const s=this.c.get(t);s&&s.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Hc=h;function S(a,t){if(a===t)return!0;if(a.size!==t.size)return!1;for(const[r,s]of a)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!a.has(r))return!1;return!0}}),define(se[2],re([0,1,22,137,32,86,71]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=g,e.$Lc=p,e.$Mc=v,e.$Nc=y,e.$Oc=w,e.$Pc=b,e.$Qc=f,e.$Rc=h,e.$Sc=S,e.$3c=D;const E=!1;let u=null;class c{constructor(){this.b=new Map}static{this.a=0}c(M){let W=this.b.get(M);return W||(W={parent:null,source:null,isSingleton:!1,value:M,idx:c.a++},this.b.set(M,W)),W}trackDisposable(M){const W=this.c(M);W.source||(W.source=new Error().stack)}setParent(M,W){const F=this.c(M);F.parent=W}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,W){const F=W.get(M);if(F)return F;const T=M.parent?this.f(this.c(M.parent),W):M;return W.set(M,T),T}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,M).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(M=10,W){let F;if(W)F=W;else{const ce=new Map,J=[...this.b.values()].filter(q=>q.source!==null&&!this.f(q,ce).isSingleton);if(J.length===0)return;const V=new Set(J.map(q=>q.value));if(F=J.filter(q=>!(q.parent&&V.has(q.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(ce){function J(q,L){for(;q.length>0&&L.some(B=>typeof B=="string"?B===q[0]:q[0].match(B));)q.shift()}const V=ce.source.split(`
`).map(q=>q.trim().replace("at ","")).filter(q=>q!=="");return J(V,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),V.reverse()}const U=new k.$Hc;for(const ce of F){const J=T(ce);for(let V=0;V<=J.length;V++)U.add(J.slice(0,V).join(`
`),ce)}F.sort((0,n.$6b)(ce=>ce.idx,n.$8b));let ae="",te=0;for(const ce of F.slice(0,M)){te++;const J=T(ce),V=[];for(let q=0;q<J.length;q++){let L=J[q];L=`(shared with ${U.get(J.slice(0,q+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const H=U.get(J.slice(0,q).join(`
`)),oe=(0,C.$K)([...H].map(G=>T(G)[q]),G=>G);delete oe[J[q]];for(const[G,le]of Object.entries(oe))V.unshift(`    - stacktraces of ${le.length} other leaks continue with ${G}`);V.unshift(L)}ae+=`


==================== Leaking disposable ${te}/${F.length}: ${ce.value.constructor.name} ====================
${V.join(`
`)}
============================================================

`}return F.length>M&&(ae+=`


... and ${F.length-M} more leaking disposables

`),{leaks:F,details:ae}}}e.$Jc=c;function g(O){u=O}if(E){const O="__is_disposable_tracked__";g(new class{trackDisposable(M){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(W)},3e3)}setParent(M,W){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function p(O){return u?.trackDisposable(O),O}function v(O){u?.markAsDisposed(O)}function m(O,M){u?.setParent(O,M)}function d(O,M){if(u)for(const W of O)u.setParent(W,M)}function y(O){return u?.markAsSingleton(O),O}function w(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function b(O){if(j.Iterable.is(O)){const M=[];for(const W of O)if(W)try{W.dispose()}catch(F){M.push(F)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function f(O){for(const M of O)w(M)&&M.dispose();return[]}function h(...O){const M=S(()=>b(O));return d(O,M),M}function S(O){const M=p({dispose:(0,R.$db)(()=>{v(M),O()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,p(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{b(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return m(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),m(M,null))}}e.$Tc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,p(this),m(this.q,this)}dispose(){v(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Uc=t;class r{constructor(){this.b=!1,p(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&m(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&m(M,null),M}}e.$Vc=r;class s{constructor(M){this.a=new r,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=s;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=i;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,p(this)}set(M){let W=M;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,v(this))},this}}e.$Yc=o;class l{constructor(){this.a=new Map}acquire(M,...W){let F=this.a.get(M);F||(F={counter:0,object:this.b(M,...W)},this.a.set(M,F));const{object:T}=F,U=(0,R.$db)(()=>{--F.counter===0&&(this.c(M,F.object),this.a.delete(M))});return F.counter++,{object:T,dispose:U}}}e.$Zc=l;class ${constructor(M){this.a=M}async acquire(M,...W){const F=this.a.acquire(M,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$1c=$;class P{constructor(M){this.object=M}dispose(){}}e.$2c=P;function D(O){const M=new a;try{O(M)}finally{M.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,p(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{b(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(M)?.dispose(),this.a.set(M,W)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=I}),define(se[72],re([0,1,32]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=void 0,e.$dm=k,e.$em=j;const C=new n.$Dc(1e4);function k(c){return u(c,"NFC",C)}const R=new n.$Dc(1e4);function j(c){return u(c,"NFD",R)}const E=/[^\u0000-\u0080]/;function u(c,g,p){if(!c)return c;const v=p.get(c);if(v)return v;let m;return E.test(c)?m=c.normalize(g):m=c,p.set(c,m),m}e.$fm=function(){const c=/[\u0300-\u036f]/g;return function(g){return j(g).replace(c,"")}}()}),define(se[141],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=n,e.rot=C;function n(E,u,c){return Math.min(Math.max(E,u),c)}function C(E,u){return(u+E%u)%u}class k{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=k;class R{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=R;class j{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const c=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=c,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=j}),function(){function K(k){const R=[];typeof k=="number"&&R.push("code/timeOrigin",k);function j(u){R.push(u,Date.now())}function E(){const u=[];for(let c=0;c<R.length;c+=2)u.push({name:R[c],startTime:R[c+1]});return u}return{mark:j,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const j of performance.getEntriesByType("mark"))R.push({name:j.name,startTime:Math.round(k+j.startTime)});return R}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function n(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:K)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(K){var e={};function n(C){if(e[C])return e[C].exports;var k=e[C]={i:C,l:!1,exports:{}};return K[C].call(k.exports,k,k.exports,n),k.l=!0,k.exports}return n.m=K,n.c=e,n.d=function(C,k,R){n.o(C,k)||Object.defineProperty(C,k,{enumerable:!0,get:R})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,k){if(1&k&&(C=n(C)),8&k||4&k&&typeof C=="object"&&C&&C.__esModule)return C;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:C}),2&k&&typeof C!="string")for(var j in C)n.d(R,j,function(E){return C[E]}.bind(null,j));return R},n.n=function(C){var k=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(k,"a",k),k},n.o=function(C,k){return Object.prototype.hasOwnProperty.call(C,k)},n.p="",n(n.s=0)}([function(K,e,n){(function(C){var k;e=K.exports=le,k=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,E=e.re=[],u=e.src=[],c=0,g=c++;u[g]="0|[1-9]\\d*";var p=c++;u[p]="[0-9]+";var v=c++;u[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=c++;u[m]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var d=c++;u[d]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var y=c++;u[y]="(?:"+u[g]+"|"+u[v]+")";var w=c++;u[w]="(?:"+u[p]+"|"+u[v]+")";var b=c++;u[b]="(?:-("+u[y]+"(?:\\."+u[y]+")*))";var f=c++;u[f]="(?:-?("+u[w]+"(?:\\."+u[w]+")*))";var h=c++;u[h]="[0-9A-Za-z-]+";var S=c++;u[S]="(?:\\+("+u[h]+"(?:\\."+u[h]+")*))";var a=c++,t="v?"+u[m]+u[b]+"?"+u[S]+"?";u[a]="^"+t+"$";var r="[v=\\s]*"+u[d]+u[f]+"?"+u[S]+"?",s=c++;u[s]="^"+r+"$";var i=c++;u[i]="((?:<|>)?=?)";var o=c++;u[o]=u[p]+"|x|X|\\*";var l=c++;u[l]=u[g]+"|x|X|\\*";var $=c++;u[$]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[b]+")?"+u[S]+"?)?)?";var P=c++;u[P]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[f]+")?"+u[S]+"?)?)?";var D=c++;u[D]="^"+u[i]+"\\s*"+u[$]+"$";var I=c++;u[I]="^"+u[i]+"\\s*"+u[P]+"$";var O=c++;u[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=c++;u[M]="(?:~>?)";var W=c++;u[W]="(\\s*)"+u[M]+"\\s+",E[W]=new RegExp(u[W],"g");var F=c++;u[F]="^"+u[M]+u[$]+"$";var T=c++;u[T]="^"+u[M]+u[P]+"$";var U=c++;u[U]="(?:\\^)";var ae=c++;u[ae]="(\\s*)"+u[U]+"\\s+",E[ae]=new RegExp(u[ae],"g");var te=c++;u[te]="^"+u[U]+u[$]+"$";var ce=c++;u[ce]="^"+u[U]+u[P]+"$";var J=c++;u[J]="^"+u[i]+"\\s*("+r+")$|^$";var V=c++;u[V]="^"+u[i]+"\\s*("+t+")$|^$";var q=c++;u[q]="(\\s*)"+u[i]+"\\s*("+r+"|"+u[$]+")",E[q]=new RegExp(u[q],"g");var L=c++;u[L]="^\\s*("+u[$]+")\\s+-\\s+("+u[$]+")\\s*$";var B=c++;u[B]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var H=c++;u[H]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)k(oe,u[oe]),E[oe]||(E[oe]=new RegExp(u[oe]));function G(Z,fe){if(Z instanceof le)return Z;if(typeof Z!="string"||Z.length>R||!(fe?E[s]:E[a]).test(Z))return null;try{return new le(Z,fe)}catch{return null}}function le(Z,fe){if(Z instanceof le){if(Z.loose===fe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(Z,fe);k("SemVer",Z,fe),this.loose=fe;var ge=Z.trim().match(fe?E[s]:E[a]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var Oe=+Pe;if(Oe>=0&&Oe<j)return Oe}return Pe}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(Z,fe){var ge=G(Z,fe);return ge?ge.version:null},e.clean=function(Z,fe){var ge=G(Z.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(Z){return k("SemVer.compare",this.version,this.loose,Z),Z instanceof le||(Z=new le(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},le.prototype.compareMain=function(Z){return Z instanceof le||(Z=new le(Z,this.loose)),A(this.major,Z.major)||A(this.minor,Z.minor)||A(this.patch,Z.patch)},le.prototype.comparePre=function(Z){if(Z instanceof le||(Z=new le(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Pe=Z.prerelease[fe];if(k("prerelease compare",fe,ge,Pe),ge===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if(ge===void 0)return-1;if(ge!==Pe)return A(ge,Pe)}while(++fe)},le.prototype.inc=function(Z,fe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,fe,ge,Pe){typeof ge=="string"&&(Pe=ge,ge=void 0);try{return new le(Z,ge).inc(fe,Pe).version}catch{return null}},e.diff=function(Z,fe){if(Y(Z,fe))return null;var ge=G(Z),Pe=G(fe);if(ge.prerelease.length||Pe.prerelease.length){for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Pe[Oe])return"pre"+Oe;return"prerelease"}for(var Oe in ge)if((Oe==="major"||Oe==="minor"||Oe==="patch")&&ge[Oe]!==Pe[Oe])return Oe},e.compareIdentifiers=A;var Q=/^[0-9]+$/;function A(Z,fe){var ge=Q.test(Z),Pe=Q.test(fe);return ge&&Pe&&(Z=+Z,fe=+fe),ge&&!Pe?-1:Pe&&!ge?1:Z<fe?-1:Z>fe?1:0}function N(Z,fe,ge){return new le(Z,ge).compare(new le(fe,ge))}function _(Z,fe,ge){return N(Z,fe,ge)>0}function z(Z,fe,ge){return N(Z,fe,ge)<0}function Y(Z,fe,ge){return N(Z,fe,ge)===0}function x(Z,fe,ge){return N(Z,fe,ge)!==0}function ee(Z,fe,ge){return N(Z,fe,ge)>=0}function X(Z,fe,ge){return N(Z,fe,ge)<=0}function ue(Z,fe,ge,Pe){var Oe;switch(fe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Oe=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Oe=Z!==ge;break;case"":case"=":case"==":Oe=Y(Z,ge,Pe);break;case"!=":Oe=x(Z,ge,Pe);break;case">":Oe=_(Z,ge,Pe);break;case">=":Oe=ee(Z,ge,Pe);break;case"<":Oe=z(Z,ge,Pe);break;case"<=":Oe=X(Z,ge,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return Oe}function he(Z,fe){if(Z instanceof he){if(Z.loose===fe)return Z;Z=Z.value}if(!(this instanceof he))return new he(Z,fe);k("comparator",Z,fe),this.loose=fe,this.parse(Z),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(Z,fe){return A(fe,Z)},e.major=function(Z,fe){return new le(Z,fe).major},e.minor=function(Z,fe){return new le(Z,fe).minor},e.patch=function(Z,fe){return new le(Z,fe).patch},e.compare=N,e.compareLoose=function(Z,fe){return N(Z,fe,!0)},e.rcompare=function(Z,fe,ge){return N(fe,Z,ge)},e.sort=function(Z,fe){return Z.sort(function(ge,Pe){return e.compare(ge,Pe,fe)})},e.rsort=function(Z,fe){return Z.sort(function(ge,Pe){return e.rcompare(ge,Pe,fe)})},e.gt=_,e.lt=z,e.eq=Y,e.neq=x,e.gte=ee,e.lte=X,e.cmp=ue,e.Comparator=he;var pe={};function $e(Z,fe){if(Z instanceof $e)return Z.loose===fe?Z:new $e(Z.raw,fe);if(Z instanceof he)return new $e(Z.value,fe);if(!(this instanceof $e))return new $e(Z,fe);if(this.loose=fe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function ye(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Se(Z,fe,ge,Pe,Oe,Te,Me,Fe,qe,xe,Ke,Be,He){return((fe=ye(ge)?"":ye(Pe)?">="+ge+".0.0":ye(Oe)?">="+ge+"."+Pe+".0":">="+fe)+" "+(Fe=ye(qe)?"":ye(xe)?"<"+(+qe+1)+".0.0":ye(Ke)?"<"+qe+"."+(+xe+1)+".0":Be?"<="+qe+"."+xe+"."+Ke+"-"+Be:"<="+Fe)).trim()}function ke(Z,fe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(k(Z[ge].semver),Z[ge].semver!==pe&&Z[ge].semver.prerelease.length>0){var Pe=Z[ge].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function Re(Z,fe,ge){try{fe=new $e(fe,ge)}catch{return!1}return fe.test(Z)}function we(Z,fe,ge,Pe){var Oe,Te,Me,Fe,qe;switch(Z=new le(Z,Pe),fe=new $e(fe,Pe),ge){case">":Oe=_,Te=X,Me=z,Fe=">",qe=">=";break;case"<":Oe=z,Te=ee,Me=_,Fe="<",qe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Re(Z,fe,Pe))return!1;for(var xe=0;xe<fe.set.length;++xe){var Ke=fe.set[xe],Be=null,He=null;if(Ke.forEach(function(Xe){Xe.semver===pe&&(Xe=new he(">=0.0.0")),Be=Be||Xe,He=He||Xe,Oe(Xe.semver,Be.semver,Pe)?Be=Xe:Me(Xe.semver,He.semver,Pe)&&(He=Xe)}),Be.operator===Fe||Be.operator===qe||(!He.operator||He.operator===Fe)&&Te(Z,He.semver)||He.operator===qe&&Me(Z,He.semver))return!1}return!0}he.prototype.parse=function(Z){var fe=this.loose?E[J]:E[V],ge=Z.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new le(ge[2],this.loose):this.semver=pe},he.prototype.toString=function(){return this.value},he.prototype.test=function(Z){return k("Comparator.test",Z,this.loose),this.semver===pe||(typeof Z=="string"&&(Z=new le(Z,this.loose)),ue(Z,this.operator,this.semver,this.loose))},he.prototype.intersects=function(Z,fe){if(!(Z instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new $e(Z.value,fe),Re(this.value,ge,fe);if(Z.operator==="")return ge=new $e(this.value,fe),Re(Z.semver,ge,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Oe=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Te=this.semver.version===Z.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Fe=ue(this.semver,"<",Z.semver,fe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),qe=ue(this.semver,">",Z.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Pe||Oe||Te&&Me||Fe||qe},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(Z){var fe=this.loose;Z=Z.trim(),k("range",Z,fe);var ge=fe?E[B]:E[L];Z=Z.replace(ge,Se),k("hyphen replace",Z),Z=Z.replace(E[q],"$1$2$3"),k("comparator trim",Z,E[q]),Z=(Z=(Z=Z.replace(E[W],"$1~")).replace(E[ae],"$1^")).split(/\s+/).join(" ");var Pe=fe?E[J]:E[V],Oe=Z.split(" ").map(function(Te){return function(Me,Fe){return k("comp",Me),Me=function(qe,xe){return qe.trim().split(/\s+/).map(function(Ke){return function(Be,He){k("caret",Be,He);var Xe=He?E[ce]:E[te];return Be.replace(Xe,function(ne,de,me,ve,Ie){var Le;return k("caret",Be,ne,de,me,ve,Ie),ye(de)?Le="":ye(me)?Le=">="+de+".0.0 <"+(+de+1)+".0.0":ye(ve)?Le=de==="0"?">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":">="+de+"."+me+".0 <"+(+de+1)+".0.0":Ie?(k("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=de==="0"?me==="0"?">="+de+"."+me+"."+ve+Ie+" <"+de+"."+me+"."+(+ve+1):">="+de+"."+me+"."+ve+Ie+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+ve+Ie+" <"+(+de+1)+".0.0"):(k("no pr"),Le=de==="0"?me==="0"?">="+de+"."+me+"."+ve+" <"+de+"."+me+"."+(+ve+1):">="+de+"."+me+"."+ve+" <"+de+"."+(+me+1)+".0":">="+de+"."+me+"."+ve+" <"+(+de+1)+".0.0"),k("caret return",Le),Le})}(Ke,xe)}).join(" ")}(Me,Fe),k("caret",Me),Me=function(qe,xe){return qe.trim().split(/\s+/).map(function(Ke){return function(Be,He){var Xe=He?E[T]:E[F];return Be.replace(Xe,function(ne,de,me,ve,Ie){var Le;return k("tilde",Be,ne,de,me,ve,Ie),ye(de)?Le="":ye(me)?Le=">="+de+".0.0 <"+(+de+1)+".0.0":ye(ve)?Le=">="+de+"."+me+".0 <"+de+"."+(+me+1)+".0":Ie?(k("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+de+"."+me+"."+ve+Ie+" <"+de+"."+(+me+1)+".0"):Le=">="+de+"."+me+"."+ve+" <"+de+"."+(+me+1)+".0",k("tilde return",Le),Le})}(Ke,xe)}).join(" ")}(Me,Fe),k("tildes",Me),Me=function(qe,xe){return k("replaceXRanges",qe,xe),qe.split(/\s+/).map(function(Ke){return function(Be,He){Be=Be.trim();var Xe=He?E[I]:E[D];return Be.replace(Xe,function(ne,de,me,ve,Ie,Le){k("xRange",Be,ne,de,me,ve,Ie,Le);var Qe=ye(me),Ze=Qe||ye(ve),_e=Ze||ye(Ie);return de==="="&&_e&&(de=""),Qe?ne=de===">"||de==="<"?"<0.0.0":"*":de&&_e?(Ze&&(ve=0),_e&&(Ie=0),de===">"?(de=">=",Ze?(me=+me+1,ve=0,Ie=0):_e&&(ve=+ve+1,Ie=0)):de==="<="&&(de="<",Ze?me=+me+1:ve=+ve+1),ne=de+me+"."+ve+"."+Ie):Ze?ne=">="+me+".0.0 <"+(+me+1)+".0.0":_e&&(ne=">="+me+"."+ve+".0 <"+me+"."+(+ve+1)+".0"),k("xRange return",ne),ne})}(Ke,xe)}).join(" ")}(Me,Fe),k("xrange",Me),Me=function(qe,xe){return k("replaceStars",qe,xe),qe.trim().replace(E[H],"")}(Me,Fe),k("stars",Me),Me}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(Oe=Oe.filter(function(Te){return!!Te.match(Pe)})),Oe=Oe.map(function(Te){return new he(Te,fe)})},$e.prototype.intersects=function(Z,fe){if(!(Z instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Pe){return Z.set.some(function(Oe){return Oe.every(function(Te){return Pe.intersects(Te,fe)})})})})},e.toComparators=function(Z,fe){return new $e(Z,fe).set.map(function(ge){return ge.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new le(Z,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],Z))return!0;return!1},e.satisfies=Re,e.maxSatisfying=function(Z,fe,ge){var Pe=null,Oe=null;try{var Te=new $e(fe,ge)}catch{return null}return Z.forEach(function(Me){Te.test(Me)&&(Pe&&Oe.compare(Me)!==-1||(Oe=new le(Pe=Me,ge)))}),Pe},e.minSatisfying=function(Z,fe,ge){var Pe=null,Oe=null;try{var Te=new $e(fe,ge)}catch{return null}return Z.forEach(function(Me){Te.test(Me)&&(Pe&&Oe.compare(Me)!==1||(Oe=new le(Pe=Me,ge)))}),Pe},e.validRange=function(Z,fe){try{return new $e(Z,fe).range||"*"}catch{return null}},e.ltr=function(Z,fe,ge){return we(Z,fe,"<",ge)},e.gtr=function(Z,fe,ge){return we(Z,fe,">",ge)},e.outside=we,e.prerelease=function(Z,fe){var ge=G(Z,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,fe,ge){return Z=new $e(Z,ge),fe=new $e(fe,ge),Z.intersects(fe)},e.coerce=function(Z){if(Z instanceof le)return Z;if(typeof Z!="string")return null;var fe=Z.match(E[O]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(K,e){var n,C,k=K.exports={};function R(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function E(w){if(n===setTimeout)return setTimeout(w,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(w,0);try{return n(w,0)}catch{try{return n.call(null,w,0)}catch{return n.call(this,w,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{C=typeof clearTimeout=="function"?clearTimeout:j}catch{C=j}})();var u,c=[],g=!1,p=-1;function v(){g&&u&&(g=!1,u.length?c=u.concat(c):p=-1,c.length&&m())}function m(){if(!g){var w=E(v);g=!0;for(var b=c.length;b;){for(u=c,c=[];++p<b;)u&&u[p].run();p=-1,b=c.length}u=null,g=!1,function(f){if(C===clearTimeout)return clearTimeout(f);if((C===j||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(f);try{C(f)}catch{try{return C.call(null,f)}catch{return C.call(this,f)}}}(w)}}function d(w,b){this.fun=w,this.array=b}function y(){}k.nextTick=function(w){var b=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)b[f-1]=arguments[f];c.push(new d(w,b)),c.length!==1||g||E(m)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=y,k.addListener=y,k.once=y,k.off=y,k.removeListener=y,k.removeAllListeners=y,k.emit=y,k.prependListener=y,k.prependOnceListener=y,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(se[142],re([0,1]),function(K,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class C{constructor(E,u,c){this.level=E,this.key=u,this.value=c,this.forward=[]}}const k=void 0;class R{constructor(E,u=2**16){this.comparator=E,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new C(this.c,k,k)}get size(){return this.f}clear(){this.e=new C(this.c,k,k),this.f=0}has(E){return!!R.g(this,E,this.comparator)}get(E){return R.g(this,E,this.comparator)?.value}set(E,u){return R.h(this,E,u,this.comparator)&&(this.f+=1),this}delete(E){const u=R.k(this,E,this.comparator);return u&&(this.f-=1),u}forEach(E,u){let c=this.e.forward[0];for(;c;)E.call(u,c.value,c.key,this),c=c.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let E=this.e.forward[0];for(;E;)yield[E.key,E.value],E=E.forward[0]}*keys(){let E=this.e.forward[0];for(;E;)yield E.key,E=E.forward[0]}*values(){let E=this.e.forward[0];for(;E;)yield E.value,E=E.forward[0]}toString(){let E="[SkipList]:",u=this.e.forward[0];for(;u;)E+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return E}static g(E,u,c){let g=E.e;for(let p=E.d-1;p>=0;p--)for(;g.forward[p]&&c(g.forward[p].key,u)<0;)g=g.forward[p];if(g=g.forward[0],g&&c(g.key,u)===0)return g}static h(E,u,c,g){const p=[];let v=E.e;for(let m=E.d-1;m>=0;m--){for(;v.forward[m]&&g(v.forward[m].key,u)<0;)v=v.forward[m];p[m]=v}if(v=v.forward[0],v&&g(v.key,u)===0)return v.value=c,!1;{const m=R.j(E);if(m>E.d){for(let d=E.d;d<m;d++)p[d]=E.e;E.d=m}v=new C(m,u,c);for(let d=0;d<m;d++)v.forward[d]=p[d].forward[d],p[d].forward[d]=v;return!0}}static j(E,u=.5){let c=1;for(;Math.random()<u&&c<E.c;)c+=1;return c}static k(E,u,c){const g=[];let p=E.e;for(let v=E.d-1;v>=0;v--){for(;p.forward[v]&&c(p.forward[v].key,u)<0;)p=p.forward[v];g[v]=p}if(p=p.forward[0],!p||c(p.key,u)!==0)return!1;for(let v=0;v<E.d&&g[v].forward[v]===p;v++)g[v].forward[v]=p.forward[v];for(;E.d>0&&E.e.forward[E.d-1]===k;)E.d-=1;return!0}}e.$Ds=R}),define(se[73],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(R){return new C(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=C}),define(se[3],re([0,1,15,86,2,104,73]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=m;const E=!1,u=!1,c=!1;var g;(function(W){W.None=()=>k.$Uc.None;function F($e){if(c){const{onDidAddListener:ye}=$e,Se=y.create();let ke=0;$e.onDidAddListener=()=>{++ke===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Se.print()),ye?.()}}}function T($e,ye){return H($e,()=>{},0,void 0,!0,void 0,ye)}W.defer=T;function U($e){return(ye,Se=null,ke)=>{let Re=!1,we;return we=$e(Z=>{if(!Re)return we?we.dispose():Re=!0,ye.call(Se,Z)},null,ke),Re&&we.dispose(),we}}W.once=U;function ae($e,ye,Se){return L((ke,Re=null,we)=>$e(Z=>ke.call(Re,ye(Z)),null,we),Se)}W.map=ae;function te($e,ye,Se){return L((ke,Re=null,we)=>$e(Z=>{ye(Z),ke.call(Re,Z)},null,we),Se)}W.forEach=te;function ce($e,ye,Se){return L((ke,Re=null,we)=>$e(Z=>ye(Z)&&ke.call(Re,Z),null,we),Se)}W.filter=ce;function J($e){return $e}W.signal=J;function V(...$e){return(ye,Se=null,ke)=>{const Re=(0,k.$Rc)(...$e.map(we=>we(Z=>ye.call(Se,Z))));return B(Re,ke)}}W.any=V;function q($e,ye,Se,ke){let Re=Se;return ae($e,we=>(Re=ye(Re,we),Re),ke)}W.reduce=q;function L($e,ye){let Se;const ke={onWillAddFirstListener(){Se=$e(Re.fire,Re)},onDidRemoveLastListener(){Se?.dispose()}};ye||F(ke);const Re=new a(ke);return ye?.add(Re),Re.event}function B($e,ye){return ye instanceof Array?ye.push($e):ye&&ye.add($e),$e}function H($e,ye,Se=100,ke=!1,Re=!1,we,Z){let fe,ge,Pe,Oe=0,Te;const Me={leakWarningThreshold:we,onWillAddFirstListener(){fe=$e(qe=>{Oe++,ge=ye(ge,qe),ke&&!Pe&&(Fe.fire(ge),ge=void 0),Te=()=>{const xe=ge;ge=void 0,Pe=void 0,(!ke||Oe>1)&&Fe.fire(xe),Oe=0},typeof Se=="number"?(clearTimeout(Pe),Pe=setTimeout(Te,Se)):Pe===void 0&&(Pe=0,queueMicrotask(Te))})},onWillRemoveListener(){Re&&Oe>0&&Te?.()},onDidRemoveLastListener(){Te=void 0,fe.dispose()}};Z||F(Me);const Fe=new a(Me);return Z?.add(Fe),Fe.event}W.debounce=H;function oe($e,ye=0,Se){return W.debounce($e,(ke,Re)=>ke?(ke.push(Re),ke):[Re],ye,void 0,!0,void 0,Se)}W.accumulate=oe;function G($e,ye=(ke,Re)=>ke===Re,Se){let ke=!0,Re;return ce($e,we=>{const Z=ke||!ye(we,Re);return ke=!1,Re=we,Z},Se)}W.latch=G;function le($e,ye,Se){return[W.filter($e,ye,Se),W.filter($e,ke=>!ye(ke),Se)]}W.split=le;function Q($e,ye=!1,Se=[],ke){let Re=Se.slice(),we=$e(ge=>{Re?Re.push(ge):fe.fire(ge)});ke&&ke.add(we);const Z=()=>{Re?.forEach(ge=>fe.fire(ge)),Re=null},fe=new a({onWillAddFirstListener(){we||(we=$e(ge=>fe.fire(ge)),ke&&ke.add(we))},onDidAddFirstListener(){Re&&(ye?setTimeout(Z):Z())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ke&&ke.add(fe),fe.event}W.buffer=Q;function A($e,ye){return(ke,Re,we)=>{const Z=ye(new _);return $e(function(fe){const ge=Z.evaluate(fe);ge!==N&&ke.call(Re,ge)},void 0,we)}}W.chain=A;const N=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(Se=>(ye(Se),Se)),this}filter(ye){return this.f.push(Se=>ye(Se)?Se:N),this}reduce(ye,Se){let ke=Se;return this.f.push(Re=>(ke=ye(ke,Re),ke)),this}latch(ye=(Se,ke)=>Se===ke){let Se=!0,ke;return this.f.push(Re=>{const we=Se||!ye(Re,ke);return Se=!1,ke=Re,we?Re:N}),this}evaluate(ye){for(const Se of this.f)if(ye=Se(ye),ye===N)break;return ye}}function z($e,ye,Se=ke=>ke){const ke=(...fe)=>Z.fire(Se(...fe)),Re=()=>$e.on(ye,ke),we=()=>$e.removeListener(ye,ke),Z=new a({onWillAddFirstListener:Re,onDidRemoveLastListener:we});return Z.event}W.fromNodeEventEmitter=z;function Y($e,ye,Se=ke=>ke){const ke=(...fe)=>Z.fire(Se(...fe)),Re=()=>$e.addEventListener(ye,ke),we=()=>$e.removeEventListener(ye,ke),Z=new a({onWillAddFirstListener:Re,onDidRemoveLastListener:we});return Z.event}W.fromDOMEventEmitter=Y;function x($e){return new Promise(ye=>U($e)(ye))}W.toPromise=x;function ee($e){const ye=new a;return $e.then(Se=>{ye.fire(Se)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}W.fromPromise=ee;function X($e,ye,Se){return ye(Se),$e(ke=>ye(ke))}W.runAndSubscribe=X;class ue{constructor(ye,Se){this._observable=ye,this.f=0,this.g=!1;const ke={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Se||F(ke),this.emitter=new a(ke),Se&&Se.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,Se){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function he($e,ye){return new ue($e,ye).emitter.event}W.fromObservable=he;function pe($e){return(ye,Se,ke)=>{let Re=0,we=!1;const Z={beginUpdate(){Re++},endUpdate(){Re--,Re===0&&($e.reportChanges(),we&&(we=!1,ye.call(Se)))},handlePossibleChange(){},handleChange(){we=!0}};$e.addObserver(Z),$e.reportChanges();const fe={dispose(){$e.removeObserver(Z)}};return ke instanceof k.$Tc?ke.add(fe):Array.isArray(ke)&&ke.push(fe),fe}}W.fromObservableLight=pe})(g||(e.Event=g={}));class p{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${p.f++}`,p.all.add(this)}start(F){this.g=new j.$be,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$de=p;let v=-1;function m(W){const F=v;return v=W,{dispose(){v=F}}}class d{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const U=this.threshold;if(U<=0||T<U)return;this.f||(this.f=new Map);const ae=this.f.get(F.value)||0;if(this.f.set(F.value,ae+1),this.g-=1,this.g<=0){this.g=U*.5;let te,ce=0;for(const[J,V]of this.f)(!te||ce<V)&&(te=J,ce=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${ce}):`),console.warn(te)}return()=>{const te=this.f.get(F.value)||0;this.f.set(F.value,te-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class b{constructor(F){this.value=F,this.id=w++}}const f=2,h=(W,F)=>{if(W instanceof b)F(W);else for(let T=0;T<W.length;T++){const U=W[T];U&&F(U)}},S=E?new FinalizationRegistry(W=>{typeof W=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(W))}):void 0;class a{constructor(F){this.w=0,this.f=F,this.g=v>0||this.f?.leakWarningThreshold?new d(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(u){const F=this.t;queueMicrotask(()=>{h(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,U)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.$Uc.None;if(this.m)return k.$Uc.None;T&&(F=F.bind(T));const ae=new b(F);let te,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ae.stack=y.create(),te=this.g.check(ae.stack,this.w+1)),u&&(ae.stack=ce??y.create()),this.t?this.t instanceof b?(this.u??=new r,this.t=[this.t,ae]):this.t.push(ae):(this.f?.onWillAddFirstListener?.(this),this.t=ae,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,k.$Sc)(()=>{S?.unregister(J),te?.(),this.x(ae)});if(U instanceof k.$Tc?U.add(J):Array.isArray(U)&&U.push(J),S){const V=new Error().stack.split(`
`).slice(2).join(`
`).trim();S.register(J,V,J)}return J},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,U=T.indexOf(F);if(U===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[U]=void 0;const ae=this.u.current===this;if(this.w*f<=T.length){let te=0;for(let ce=0;ce<T.length;ce++)T[ce]?T[te++]=T[ce]:ae&&(this.u.end--,te<this.u.i&&this.u.i--);T.length=te}}y(F,T){if(!F)return;const U=this.f?.onListenerError||n.$1;if(!U){F.value(T);return}try{F.value(T)}catch(ae){U(ae)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof b)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$fe=a;const t=()=>new r;e.$ge=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,U){this.i=0,this.end=U,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(F,T,U){if(this.t)for(this.h||(this.h=new R.$5c),h(this.t,ae=>this.h.push([ae.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[ae,te]=this.h.shift(),ce=[],J={...te,token:T,waitUntil:V=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");U&&(V=U(V,ae)),ce.push(V)}};try{ae(J)}catch(V){(0,n.$1)(V);continue}Object.freeze(ce),await Promise.allSettled(ce).then(V=>{for(const q of V)q.status==="rejected"&&(0,n.$1)(q.reason)})}}}e.$he=s;class i extends a{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$5c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$ie=i;class o extends i{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$je=o;class l extends a{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ke=l;class ${constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const U=()=>{this.g&&this.o(T);const ae=this.h.indexOf(T);this.h.splice(ae,1)};return(0,k.$Sc)((0,C.$db)(U))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$le=$;class P{constructor(F,T,U,ae){this.f=new k.$Tc;const te=this.f.add(new $),ce=this.f.add(new k.$4c);function J(V){ce.set(V,te.add(ae(V)))}for(const V of F)J(V);this.f.add(T(V=>{J(V)})),this.f.add(U(V=>{ce.deleteAndDispose(V)})),this.event=te.event}dispose(){this.f.dispose()}}e.$me=P;class D{constructor(){this.f=[]}wrapEvent(F,T,U){return(ae,te,ce)=>F(J=>{const V=this.f[this.f.length-1];if(!T){V?V.buffers.push(()=>ae.call(te,J)):ae.call(te,J);return}const q=V;if(!q){ae.call(te,T(U,J));return}q.items??=[],q.items.push(J),q.buffers.length===0&&V.buffers.push(()=>{q.reducedResult??=U?q.items.reduce(T,U):q.items.reduce(T),ae.call(te,q.reducedResult)})},void 0,ce)}bufferEvents(F){const T={buffers:new Array};this.f.push(T);const U=F();return this.f.pop(),T.buffers.forEach(ae=>ae()),U}}e.$ne=D;class I{constructor(){this.f=!1,this.g=g.None,this.h=k.$Uc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$oe=I;class O{static const(F){return new M(F)}constructor(F){this.g=F,this.f=new a,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$pe=O;class M{constructor(F){this.value=F,this.onDidChange=g.None}}}),define(se[23],re([0,1,3]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=e.CancellationToken=void 0,e.$re=E;const C=Object.freeze(function(u,c){const g=setTimeout(u.bind(c),0);return{dispose(){clearTimeout(g)}}});var k;(function(u){function c(g){return g===u.None||g===u.Cancelled||g instanceof R?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}u.isCancellationToken=c,u.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),u.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(k||(e.CancellationToken=k={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new n.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(c){this.f=void 0,this.g=void 0,this.g=c&&c.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=k.Cancelled}dispose(c=!1){c&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=k.None}}e.$qe=j;function E(u){const c=new j;return u.add({dispose(){c.cancel()}}),c.token}}),define(se[143],re([0,1,23]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=e.$3e=void 0,e.$4e=k;class C{constructor(u){this.b=u,this.a=null}get(){if(this.a)return this.a;const u=new n.$qe,c=this.b(u.token);return this.a={promise:c,dispose:()=>{this.a=null,u.cancel(),u.dispose()}},this.a}}e.$3e=C;function k(E){return E}class R{constructor(u,c){this.a=void 0,this.b=void 0,typeof u=="function"?(this.c=u,this.d=k):(this.c=c,this.d=u.getCacheKey)}get(u){const c=this.d(u);return this.b!==c&&(this.b=c,this.a=this.c(u)),this.a}}e.$5e=R;class j{get cachedValues(){return this.a}constructor(u,c){this.a=new Map,this.b=new Map,typeof u=="function"?(this.c=u,this.d=k):(this.c=c,this.d=u.getCacheKey)}get(u){const c=this.d(u);if(this.b.has(c))return this.b.get(c);const g=this.c(u);return this.a.set(u,g),this.b.set(c,g),g}}e.$6e=j}),define(se[63],re([0,1,15,2]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=k,e.$te=R,e.$ue=j,e.$ve=E,e.$we=c,e.$xe=g,e.$ye=p,e.$ze=v,e.$Ae=m,e.$Be=d,e.$Ce=y,e.$De=w,e.$Ee=b,e.$Fe=f,e.$Ge=h;function k(S){const a=S;return a?typeof a.read=="function":!1}function R(S){const a=S;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function j(S){const a=S;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function E(S,a){return new u(S,a)}class u{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function c(S,a){const t=[];let r;for(;(r=S.read())!==null;)t.push(r);return a(t)}function g(S,a,t){const r=[];let s;for(;(s=S.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return S.read()}}}function p(S,a){return new Promise((t,r)=>{const s=[];v(S,{onData:i=>{a&&s.push(i)},onError:i=>{a?r(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function v(S,a,t){S.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),S.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),S.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}function m(S,a){return new Promise((t,r)=>{const s=new C.$Tc,i=[],o=P=>{if(i.push(P),i.length>a)return s.dispose(),S.pause(),t({stream:S,buffer:i,ended:!1})},l=P=>(s.dispose(),r(P)),$=()=>(s.dispose(),t({stream:S,buffer:i,ended:!0}));s.add((0,C.$Sc)(()=>S.removeListener("error",l))),S.on("error",l),s.add((0,C.$Sc)(()=>S.removeListener("end",$))),S.on("end",$),s.add((0,C.$Sc)(()=>S.removeListener("data",o))),S.on("data",o)})}function d(S,a){const t=E(a);return t.end(S),t}function y(){const S=E(()=>{throw new Error("not supported")});return S.end(),S}function w(S){let a=!1;return{read:()=>a?null:(a=!0,S)}}function b(S,a,t){const r=E(t);return v(S,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}function f(S,a,t){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?t([S,s]):S)}}}function h(S,a,t){let r=!1;const s=E(t);return v(a,{onData:i=>r?s.write(i):(r=!0,s.write(t([S,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(S)),s.end()}}),s}}),define(se[17],re([0,1,62,63]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=c,e.$Je=g,e.$Ke=p,e.$Le=v,e.$Me=m,e.$Ne=d,e.$Oe=y,e.$Pe=w,e.$Qe=b,e.$Re=f,e.$Se=h,e.$Te=S,e.$Ue=a,e.$Ve=t,e.$We=r,e.$Xe=s,e.$Ye=i,e.$Ze=o,e.$1e=l,e.$2e=D;const k=typeof Buffer<"u",R=new n.$V(()=>new Uint8Array(256));let j,E;class u{static alloc(O){return k?new u(Buffer.allocUnsafe(O)):new u(new Uint8Array(O))}static wrap(O){return k&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new u(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&k?new u(Buffer.from(O)):(j||(j=new TextEncoder),new u(j.encode(O)))}static fromByteArray(O){const M=u.alloc(O.length);for(let W=0,F=O.length;W<F;W++)M.buffer[W]=O[W];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let T=0,U=O.length;T<U;T++)M+=O[T].byteLength}const W=u.alloc(M);let F=0;for(let T=0,U=O.length;T<U;T++){const ae=O[T];W.set(ae,F),F+=ae.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=u.alloc(this.byteLength);return O.set(this),O}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(O,M){return new u(this.buffer.subarray(O,M))}set(O,M){if(O instanceof u)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return v(this.buffer,O)}writeUInt32BE(O,M){m(this.buffer,O,M)}readUInt32LE(O){return d(this.buffer,O)}writeUInt32LE(O,M){y(this.buffer,O,M)}readUInt8(O){return w(this.buffer,O)}writeUInt8(O,M){b(this.buffer,O,M)}indexOf(O,M=0){return c(this.buffer,O instanceof u?O.buffer:O,M)}}e.$He=u;function c(I,O,M=0){const W=O.byteLength,F=I.byteLength;if(W===0)return 0;if(W===1)return I.indexOf(O[0]);if(W>F-M)return-1;const T=R.value;T.fill(O.length);for(let ce=0;ce<O.length;ce++)T[O[ce]]=O.length-ce-1;let U=M+O.length-1,ae=U,te=-1;for(;U<F;)if(I[U]===O[ae]){if(ae===0){te=U;break}U--,ae--}else U+=Math.max(O.length-ae,T[I[U]]),ae=O.length-1;return te}function g(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}function p(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}function v(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}function m(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}function y(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}function w(I,O){return I[O]}function b(I,O,M){I[M]=O}function f(I){return C.$we(I,O=>u.concat(O))}function h(I){return C.$De(I)}function S(I){return C.$ye(I,O=>u.concat(O))}async function a(I){return I.ended?u.concat(I.buffer):u.concat([...I.buffer,await S(I.stream)])}function t(I){return C.$Be(I,O=>u.concat(O))}function r(I){return C.$Ee(I,{data:O=>typeof O=="string"?u.fromString(O):u.wrap(O)},O=>u.concat(O))}function s(I){return C.$ve(O=>u.concat(O),I)}function i(I,O){return C.$Fe(I,O,M=>u.concat(M))}function o(I,O){return C.$Ge(I,O,M=>u.concat(M))}function l(I){let O=0,M=0,W=0;const F=new Uint8Array(Math.floor(I.length/4*3)),T=ae=>{switch(M){case 3:F[W++]=O|ae,M=0;break;case 2:F[W++]=O|ae>>>2,O=ae<<6,M=3;break;case 1:F[W++]=O|ae>>>4,O=ae<<4,M=2;break;default:O=ae<<2,M=1}};for(let ae=0;ae<I.length;ae++){const te=I.charCodeAt(ae);if(te>=65&&te<=90)T(te-65);else if(te>=97&&te<=122)T(te-97+26);else if(te>=48&&te<=57)T(te-48+52);else if(te===43||te===45)T(62);else if(te===47||te===95)T(63);else{if(te===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ae]}`)}}const U=W;for(;M>0;)T(0);return u.wrap(F).slice(0,U)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:I},O=!0,M=!1){const W=M?P:$;let F="";const T=I.byteLength%3;let U=0;for(;U<I.byteLength-T;U+=3){const ae=I[U+0],te=I[U+1],ce=I[U+2];F+=W[ae>>>2],F+=W[(ae<<4|te>>>4)&63],F+=W[(te<<2|ce>>>6)&63],F+=W[ce&63]}if(T===1){const ae=I[U+0];F+=W[ae>>>2],F+=W[ae<<4&63],O&&(F+="==")}else if(T===2){const ae=I[U+0],te=I[U+1];F+=W[ae>>>2],F+=W[(ae<<4|te>>>4)&63],F+=W[te<<2&63],O&&(F+="=")}return F}}),define(se[25],re([0,1,143,62]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.GraphemeBreakType=e.$Xf=e.$Pf=e.$If=e.$Hf=void 0,e.$9e=k,e.$0e=j,e.$$e=u,e.$_e=c,e.$af=g,e.$bf=p,e.$cf=v,e.$df=m,e.$ef=d,e.$ff=y,e.$gf=w,e.$hf=b,e.$if=f,e.$jf=h,e.$kf=S,e.$lf=a,e.$mf=t,e.$nf=r,e.$of=s,e.$pf=i,e.$qf=o,e.$rf=l,e.$sf=$,e.$tf=P,e.$uf=D,e.$vf=I,e.$wf=O,e.$xf=M,e.$yf=W,e.$zf=F,e.$Af=T,e.$Bf=U,e.$Cf=ae,e.$Df=te,e.$Ef=ce,e.$Ff=J,e.$Gf=V,e.$Jf=H,e.$Kf=oe,e.$Lf=G,e.$Mf=le,e.$Nf=N,e.$Of=z,e.$Qf=Y,e.$Rf=x,e.$Sf=ee,e.$Tf=X,e.$Uf=he,e.$Vf=pe,e.$Wf=ye,e.$Yf=Se,e.$Zf=ke,e.$1f=Re,e.$2f=we,e.$3f=Z,e.$4f=fe,e.$5f=ge,e.$6f=Pe,e.$7f=qe;function k(ne){return!ne||typeof ne!="string"?!0:ne.trim().length===0}const R=/{(\d+)}/g;function j(ne,...de){return de.length===0?ne:ne.replace(R,function(me,ve){const Ie=parseInt(ve,10);return isNaN(Ie)||Ie<0||Ie>=de.length?me:de[Ie]})}const E=/{([^}]+)}/g;function u(ne,de){return Object.keys(de).length===0?ne:ne.replace(E,(me,ve)=>de[ve]??me)}function c(ne){return ne.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function g(ne){return ne.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function p(ne){return ne.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(ne,de){let me=0,ve=ne.indexOf(de);for(;ve!==-1;)me++,ve=ne.indexOf(de,ve+de.length);return me}function m(ne,de,me="\u2026"){return ne.length<=de?ne:`${ne.substr(0,de)}${me}`}function d(ne,de,me="\u2026"){if(ne.length<=de)return ne;const ve=Math.ceil(de/2)-me.length/2,Ie=Math.floor(de/2)-me.length/2;return`${ne.substr(0,ve)}${me}${ne.substr(ne.length-Ie)}`}function y(ne,de=" "){const me=w(ne,de);return b(me,de)}function w(ne,de){if(!ne||!de)return ne;const me=de.length;if(me===0||ne.length===0)return ne;let ve=0;for(;ne.indexOf(de,ve)===ve;)ve=ve+me;return ne.substring(ve)}function b(ne,de){if(!ne||!de)return ne;const me=de.length,ve=ne.length;if(me===0||ve===0)return ne;let Ie=ve,Le=-1;for(;Le=ne.lastIndexOf(de,Ie-1),!(Le===-1||Le+me!==Ie);){if(Le===0)return"";Ie=Le}return ne.substring(0,Ie)}function f(ne){return ne.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(ne){return ne.replace(/\*/g,"")}function S(ne,de,me={}){if(!ne)throw new Error("Cannot create regex from empty string");de||(ne=p(ne)),me.wholeWord&&(/\B/.test(ne.charAt(0))||(ne="\\b"+ne),/\B/.test(ne.charAt(ne.length-1))||(ne=ne+"\\b"));let ve="";return me.global&&(ve+="g"),me.matchCase||(ve+="i"),me.multiline&&(ve+="m"),me.unicode&&(ve+="u"),new RegExp(ne,ve)}function a(ne){return ne.source==="^"||ne.source==="^$"||ne.source==="$"||ne.source==="^\\s*$"?!1:!!(ne.exec("")&&ne.lastIndex===0)}function t(ne){return ne.split(/\r\n|\r|\n/)}function r(ne){const de=[],me=ne.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(me.length/2);ve++)de.push(me[2*ve]+(me[2*ve+1]??""));return de}function s(ne){for(let de=0,me=ne.length;de<me;de++){const ve=ne.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}function i(ne,de=0,me=ne.length){for(let ve=de;ve<me;ve++){const Ie=ne.charCodeAt(ve);if(Ie!==32&&Ie!==9)return ne.substring(de,ve)}return ne.substring(de,me)}function o(ne,de=ne.length-1){for(let me=de;me>=0;me--){const ve=ne.charCodeAt(me);if(ve!==32&&ve!==9)return me}return-1}function l(ne,de,me){const ve=[];let Ie=0;for(const Le of ne.matchAll(de)){if(ve.push(ne.slice(Ie,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Ie=Le.index+Le[0].length,ve.push(me(Le[0],...Le.slice(1),Le.index,ne,Le.groups))}return ve.push(ne.slice(Ie)),Promise.all(ve).then(Le=>Le.join(""))}function $(ne,de){return ne<de?-1:ne>de?1:0}function P(ne,de,me=0,ve=ne.length,Ie=0,Le=de.length){for(;me<ve&&Ie<Le;me++,Ie++){const _e=ne.charCodeAt(me),st=de.charCodeAt(Ie);if(_e<st)return-1;if(_e>st)return 1}const Qe=ve-me,Ze=Le-Ie;return Qe<Ze?-1:Qe>Ze?1:0}function D(ne,de){return I(ne,de,0,ne.length,0,de.length)}function I(ne,de,me=0,ve=ne.length,Ie=0,Le=de.length){for(;me<ve&&Ie<Le;me++,Ie++){let _e=ne.charCodeAt(me),st=de.charCodeAt(Ie);if(_e===st)continue;if(_e>=128||st>=128)return P(ne.toLowerCase(),de.toLowerCase(),me,ve,Ie,Le);M(_e)&&(_e-=32),M(st)&&(st-=32);const Ye=_e-st;if(Ye!==0)return Ye}const Qe=ve-me,Ze=Le-Ie;return Qe<Ze?-1:Qe>Ze?1:0}function O(ne){return ne>=48&&ne<=57}function M(ne){return ne>=97&&ne<=122}function W(ne){return ne>=65&&ne<=90}function F(ne,de){return ne.length===de.length&&I(ne,de)===0}function T(ne,de){const me=de.length;return de.length>ne.length?!1:I(ne,de,0,me)===0}function U(ne,de){const me=Math.min(ne.length,de.length);let ve;for(ve=0;ve<me;ve++)if(ne.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return me}function ae(ne,de){const me=Math.min(ne.length,de.length);let ve;const Ie=ne.length-1,Le=de.length-1;for(ve=0;ve<me;ve++)if(ne.charCodeAt(Ie-ve)!==de.charCodeAt(Le-ve))return ve;return me}function te(ne){return 55296<=ne&&ne<=56319}function ce(ne){return 56320<=ne&&ne<=57343}function J(ne,de){return(ne-55296<<10)+(de-56320)+65536}function V(ne,de,me){const ve=ne.charCodeAt(me);if(te(ve)&&me+1<de){const Ie=ne.charCodeAt(me+1);if(ce(Ie))return J(ve,Ie)}return ve}function q(ne,de){const me=ne.charCodeAt(de-1);if(ce(me)&&de>1){const ve=ne.charCodeAt(de-2);if(te(ve))return J(ve,me)}return me}class L{get offset(){return this.e}constructor(de,me=0){this.c=de,this.d=de.length,this.e=me}setOffset(de){this.e=de}prevCodePoint(){const de=q(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=V(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Hf=L;class B{get offset(){return this.c.offset}constructor(de,me=0){this.c=new L(de,me)}nextGraphemeLength(){const de=Me.getInstance(),me=this.c,ve=me.offset;let Ie=de.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Le=me.offset,Qe=de.getGraphemeBreakType(me.nextCodePoint());if(Oe(Ie,Qe)){me.setOffset(Le);break}Ie=Qe}return me.offset-ve}prevGraphemeLength(){const de=Me.getInstance(),me=this.c,ve=me.offset;let Ie=de.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Le=me.offset,Qe=de.getGraphemeBreakType(me.prevCodePoint());if(Oe(Qe,Ie)){me.setOffset(Le);break}Ie=Qe}return ve-me.offset}eol(){return this.c.eol()}}e.$If=B;function H(ne,de){return new B(ne,de).nextGraphemeLength()}function oe(ne,de){return new B(ne,de).prevGraphemeLength()}function G(ne,de){de>0&&ce(ne.charCodeAt(de))&&de--;const me=de+H(ne,de);return[me-oe(ne,me),me]}function le(ne){const de=new B(ne);let me=0;for(;!de.eol();)me++,de.nextGraphemeLength();return me}let Q;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(ne){return Q||(Q=A()),Q.test(ne)}const _=/^[\t\n\r\x20-\x7E]*$/;function z(ne){return _.test(ne)}e.$Pf=/[\u2028\u2029]/;function Y(ne){return e.$Pf.test(ne)}function x(ne){return ne>=11904&&ne<=55215||ne>=63744&&ne<=64255||ne>=65281&&ne<=65374}function ee(ne){return ne>=127462&&ne<=127487||ne===8986||ne===8987||ne===9200||ne===9203||ne>=9728&&ne<=10175||ne===11088||ne===11093||ne>=127744&&ne<=128591||ne>=128640&&ne<=128764||ne>=128992&&ne<=129008||ne>=129280&&ne<=129535||ne>=129648&&ne<=129782}function X(ne,de,me=""){const ve=ne.trimStart();if(ve.length<de)return ve;const Ie=/\b/g;let Le=0;for(;Ie.test(ve)&&!(ve.length-Ie.lastIndex<de);)Le=Ie.lastIndex,Ie.lastIndex+=1;return Le===0?ve:me+ve.substring(Le).trimStart()}const ue=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(ne){let de=0;for(const me of ne.matchAll(ue))de!==me.index&&(yield{isCode:!1,str:ne.substring(de,me.index)}),yield{isCode:!0,str:me[0]},de=me.index+me[0].length;de!==ne.length&&(yield{isCode:!1,str:ne.substring(de)})}function pe(ne){return ne&&(ne=ne.replace(ue,"")),ne}const $e=/\\\[.*?\\\]/g;function ye(ne){return pe(ne).replace($e,"")}e.$Xf="\uFEFF";function Se(ne){return!!(ne&&ne.length>0&&ne.charCodeAt(0)===65279)}function ke(ne){return Se(ne)?ne.substr(1):ne}function Re(ne,de){if(!ne||!de||ne.length<de.length)return!1;const me=de.length,ve=ne.toLowerCase();let Ie=0,Le=-1;for(;Ie<me;){const Qe=ve.indexOf(de[Ie],Le+1);if(Qe<0)return!1;Le=Qe,Ie++}return!0}function we(ne,de=!1){return ne?(de&&(ne=ne.replace(/\\./g,"")),ne.toLowerCase()!==ne):!1}function Z(ne){return ne.charAt(0).toUpperCase()+ne.slice(1)}function fe(ne,de=1){if(de===0)return"";let me=-1;do me=ne.indexOf(`
`,me+1),de--;while(de>0&&me>=0);return me===-1?ne:(ne[me-1]==="\r"&&me--,ne.substr(0,me))}function ge(ne){return ne=ne%(2*26),ne<26?String.fromCharCode(97+ne):String.fromCharCode(65+ne-26)}function Pe(ne){return Me.getInstance().getGraphemeBreakType(ne)}function Oe(ne,de){return ne===0?de!==5&&de!==7:ne===2&&de===3?!1:ne===4||ne===2||ne===3||de===4||de===2||de===3?!0:!(ne===8&&(de===8||de===9||de===11||de===12)||(ne===11||ne===9)&&(de===9||de===10)||(ne===12||ne===10)&&de===10||de===5||de===13||de===7||ne===1||ne===13&&de===14||ne===6&&de===6)}var Te;(function(ne){ne[ne.Other=0]="Other",ne[ne.Prepend=1]="Prepend",ne[ne.CR=2]="CR",ne[ne.LF=3]="LF",ne[ne.Control=4]="Control",ne[ne.Extend=5]="Extend",ne[ne.Regional_Indicator=6]="Regional_Indicator",ne[ne.SpacingMark=7]="SpacingMark",ne[ne.L=8]="L",ne[ne.V=9]="V",ne[ne.T=10]="T",ne[ne.LV=11]="LV",ne[ne.LVT=12]="LVT",ne[ne.ZWJ=13]="ZWJ",ne[ne.Extended_Pictographic=14]="Extended_Pictographic"})(Te||(e.GraphemeBreakType=Te={}));class Me{static{this.c=null}static getInstance(){return Me.c||(Me.c=new Me),Me.c}constructor(){this.d=Fe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const me=this.d,ve=me.length/3;let Ie=1;for(;Ie<=ve;)if(de<me[3*Ie])Ie=2*Ie;else if(de>me[3*Ie+1])Ie=2*Ie+1;else return me[3*Ie+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function qe(ne,de){if(ne===0)return 0;const me=xe(ne,de);if(me!==void 0)return me;const ve=new L(de,ne);return ve.prevCodePoint(),ve.offset}function xe(ne,de){const me=new L(de,ne);let ve=me.prevCodePoint();for(;Ke(ve)||ve===65039||ve===8419;){if(me.offset===0)return;ve=me.prevCodePoint()}if(!ee(ve))return;let Ie=me.offset;return Ie>0&&me.prevCodePoint()===8205&&(Ie=me.offset),Ie}function Ke(ne){return 127995<=ne&&ne<=127999}var Be;(function(ne){ne[ne.zwj=8205]="zwj",ne[ne.emojiVariantSelector=65039]="emojiVariantSelector",ne[ne.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$8f="\xA0";class He{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$5e({getCacheKey:JSON.stringify},de=>{function me(Ye){const ot=new Map;for(let rt=0;rt<Ye.length;rt+=2)ot.set(Ye[rt],Ye[rt+1]);return ot}function ve(Ye,ot){const rt=new Map(Ye);for(const[ct,lt]of ot)rt.set(ct,lt);return rt}function Ie(Ye,ot){if(!Ye)return ot;const rt=new Map;for(const[ct,lt]of Ye)ot.has(ct)&&rt.set(ct,lt);return rt}const Le=this.c.value;let Qe=de.filter(Ye=>!Ye.startsWith("_")&&Ye in Le);Qe.length===0&&(Qe=["_default"]);let Ze;for(const Ye of Qe){const ot=me(Le[Ye]);Ze=Ie(Ze,ot)}const _e=me(Le._common),st=ve(_e,Ze);return new He(st)})}static getInstance(de){return He.d.get(Array.from(de))}static{this.e=new C.$V(()=>Object.keys(He.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return He.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$9f=He;class Xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Xe.c())),this.d}static isInvisibleCharacter(de){return Xe.e().has(de)}static get codePoints(){return Xe.e()}}e.$0f=Xe}),define(se[46],re([0,1,25]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=C,e.$nj=k,e.$oj=R,e.$pj=E,e.$rj=y;function C(b){return k(b,0)}function k(b,f){switch(typeof b){case"object":return b===null?R(349,f):Array.isArray(b)?u(b,f):c(b,f);case"string":return E(b,f);case"boolean":return j(b,f);case"number":return R(b,f);case"undefined":return R(937,f);default:return R(617,f)}}function R(b,f){return(f<<5)-f+b|0}function j(b,f){return R(b?433:863,f)}function E(b,f){f=R(149417,f);for(let h=0,S=b.length;h<S;h++)f=R(b.charCodeAt(h),f);return f}function u(b,f){return f=R(104579,f),b.reduce((h,S)=>k(S,h),f)}function c(b,f){return f=R(181387,f),Object.keys(b).sort().reduce((h,S)=>(h=E(S,h),k(b[S],h)),f)}class g{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=k(f,this.g),this.g}}e.$qj=g;var p;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(p||(p={}));function v(b,f,h=32){const S=h-f,a=~((1<<S)-1);return(b<<f|(a&b)>>>S)>>>0}function m(b,f=0,h=b.byteLength,S=0){for(let a=0;a<h;a++)b[f+a]=S}function d(b,f,h="0"){for(;b.length<f;)b=h+b;return b}function y(b,f=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(h=>h.toString(16).padStart(2,"0")).join(""):d((b>>>0).toString(16),f/4)}class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const h=f.length;if(h===0)return;const S=this.p;let a=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=f.charCodeAt(0),s=0);;){let i=r;if(n.$Df(r))if(s+1<h){const o=f.charCodeAt(s+1);n.$Ef(o)?(s++,i=n.$Ff(r,o)):i=65533}else{t=r;break}else n.$Ef(r)&&(i=65533);if(a=this.w(S,a,i),s++,s<h)r=f.charCodeAt(s);else break}this.r=a,this.u=t}w(f,h,S){return S<128?f[h++]=S:S<2048?(f[h++]=192|(S&1984)>>>6,f[h++]=128|(S&63)>>>0):S<65536?(f[h++]=224|(S&61440)>>>12,f[h++]=128|(S&4032)>>>6,f[h++]=128|(S&63)>>>0):(f[h++]=240|(S&1835008)>>>18,f[h++]=128|(S&258048)>>>12,f[h++]=128|(S&4032)>>>6,f[h++]=128|(S&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,h=this.q;for(let $=0;$<64;$+=4)f.setUint32($,h.getUint32($,!1),!1);for(let $=64;$<320;$+=4)f.setUint32($,v(f.getUint32($-12,!1)^f.getUint32($-32,!1)^f.getUint32($-56,!1)^f.getUint32($-64,!1),1),!1);let S=this.h,a=this.l,t=this.m,r=this.n,s=this.o,i,o,l;for(let $=0;$<80;$++)$<20?(i=a&t|~a&r,o=1518500249):$<40?(i=a^t^r,o=1859775393):$<60?(i=a&t|a&r|t&r,o=2400959708):(i=a^t^r,o=3395469782),l=v(S,5)+i+s+o+f.getUint32($*4,!1)&4294967295,s=r,r=t,t=v(a,30),a=S,S=l;this.h=this.h+S&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$sj=w}),define(se[74],re([0,1,25]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(C||(C={})),function(k){const R="error",j="warning",E="warn",u="info",c="ignore";function g(v){return v?n.$zf(R,v)?k.Error:n.$zf(j,v)||n.$zf(E,v)?k.Warning:n.$zf(u,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=g;function p(v){switch(v){case k.Error:return R;case k.Warning:return j;case k.Info:return u;default:return c}}k.toString=p}(C||(C={})),e.default=C}),define(se[144],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(se[59],re([0,1,22,25]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class k{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const d=m.charCodeAt(0),y=this.b.charCodeAt(this.c);return d-y}value(){return this.b[this.c]}}e.$Ai=k;class R{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,C.$tf)(m,this.b,0,m.length,this.c,this.d):(0,C.$vf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=R;class j{constructor(m=!0,d=!0){this.f=m,this.g=d}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let d=m.length-1;d>=0;d--,this.c--){const y=this.b.charCodeAt(d);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const d=this.b.charCodeAt(this.e);if(d===47||this.f&&d===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,C.$tf)(m,this.b,0,m.length,this.d,this.e):(0,C.$vf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=j;var E;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(E||(E={}));class u{constructor(m,d){this.f=m,this.g=d,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,C.$uf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,C.$uf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,C.$sf)(m,this.c.query);if(this.d[this.e]===5)return(0,C.$sf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=u;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(g||(g={}));class p{static forUris(m=()=>!1,d=()=>!1){return new p(new u(m,d))}static forPaths(m=!1){return new p(new j(void 0,!m))}static forStrings(){return new p(new k)}static forConfigKeys(){return new p(new R)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,d){if(d){const y=d.slice(0);(0,n.$Wb)(y);for(const w of y)this.set(w,m)}else{const y=m.slice(0);(0,n.$Wb)(y);for(const w of y)this.set(w[0],w[1])}}set(m,d){const y=this.b.reset(m);let w;this.c||(this.c=new c,this.c.segment=y.value());const b=[];for(w=this.c;;){const h=y.cmp(w.segment);if(h>0)w.left||(w.left=new c,w.left.segment=y.value()),b.push([-1,w]),w=w.left;else if(h<0)w.right||(w.right=new c,w.right.segment=y.value()),b.push([1,w]),w=w.right;else if(y.hasNext())y.next(),w.mid||(w.mid=new c,w.mid.segment=y.value()),b.push([0,w]),w=w.mid;else break}const f=w.value;w.value=d,w.key=m;for(let h=b.length-1;h>=0;h--){const S=b[h][1];S.updateHeight();const a=S.balanceFactor();if(a<-1||a>1){const t=b[h][0],r=b[h+1][0];if(t===1&&r===1)b[h][1]=S.rotateLeft();else if(t===-1&&r===-1)b[h][1]=S.rotateRight();else if(t===1&&r===-1)S.right=b[h+1][1]=b[h+1][1].rotateRight(),b[h][1]=S.rotateLeft();else if(t===-1&&r===1)S.left=b[h+1][1]=b[h+1][1].rotateLeft(),b[h][1]=S.rotateRight();else throw new Error;if(h>0)switch(b[h-1][0]){case-1:b[h-1][1].left=b[h][1];break;case 1:b[h-1][1].right=b[h][1];break;case 0:b[h-1][1].mid=b[h][1];break}else this.c=b[0][1]}}return f}get(m){return this.d(m)?.value}d(m){const d=this.b.reset(m);let y=this.c;for(;y;){const w=d.cmp(y.segment);if(w>0)y=y.left;else if(w<0)y=y.right;else if(d.hasNext())d.next(),y=y.mid;else break}return y}has(m){const d=this.d(m);return!(d?.value===void 0&&d?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,d){const y=this.b.reset(m),w=[];let b=this.c;for(;b;){const f=y.cmp(b.segment);if(f>0)w.push([-1,b]),b=b.left;else if(f<0)w.push([1,b]),b=b.right;else if(y.hasNext())y.next(),w.push([0,b]),b=b.mid;else break}if(b){if(d?(b.left=void 0,b.mid=void 0,b.right=void 0,b.height=1):(b.key=void 0,b.value=void 0),!b.mid&&!b.value)if(b.left&&b.right){const f=this.f(b.right);if(f.key){const{key:h,value:S,segment:a}=f;this.e(f.key,!1),b.key=h,b.value=S,b.segment=a}}else{const f=b.left??b.right;if(w.length>0){const[h,S]=w[w.length-1];switch(h){case-1:S.left=f;break;case 0:S.mid=f;break;case 1:S.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const h=w[f][1];h.updateHeight();const S=h.balanceFactor();if(S>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),w[f][1]=h.rotateLeft()):S<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),w[f][1]=h.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const d=this.b.reset(m);let y=this.c,w;for(;y;){const b=d.cmp(y.segment);if(b>0)y=y.left;else if(b<0)y=y.right;else if(d.hasNext())d.next(),w=y.value||w,y=y.mid;else break}return y&&y.value||w}findSuperstr(m){return this.g(m,!1)}g(m,d){const y=this.b.reset(m);let w=this.c;for(;w;){const b=y.cmp(w.segment);if(b>0)w=w.left;else if(b<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else return w.mid?this.h(w.mid):d?w.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[d,y]of this)m(y,d)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const d=[];return this.j(m,d),d[Symbol.iterator]()}j(m,d){m&&(m.left&&this.j(m.left,d),m.value&&d.push([m.key,m.value]),m.mid&&this.j(m.mid,d),m.right&&this.j(m.right,d))}_isBalanced(){const m=d=>{if(!d)return!0;const y=d.balanceFactor();return y<-1||y>1?!1:m(d.left)&&m(d.right)};return m(this.c)}}e.$Ei=p}),define(se[12],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=n,e.$_f=C,e.$ag=k,e.$bg=R,e.$cg=j,e.$dg=E,e.$eg=u,e.$fg=c,e.$gg=g,e.$hg=p,e.$ig=v,e.$jg=m,e.$kg=d,e.$lg=w,e.$mg=b,e.$ng=f,e.$og=h,e.$pg=S;function n(a){return typeof a=="string"}function C(a){return Array.isArray(a)&&a.every(t=>n(t))}function k(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function j(a){return typeof a=="number"&&!isNaN(a)}function E(a){return!!a&&typeof a[Symbol.iterator]=="function"}function u(a){return a===!0||a===!1}function c(a){return typeof a>"u"}function g(a){return!p(a)}function p(a){return c(a)||a===null}function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(a){if(p(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function d(...a){const t=[];for(let r=0;r<a.length;r++){const s=a[r];if(p(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const y=Object.prototype.hasOwnProperty;function w(a){if(!k(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}function b(a){return typeof a=="function"}function f(...a){return a.length>0&&a.every(b)}function h(a,t){const r=Math.min(a.length,t.length);for(let s=0;s<r;s++)S(a[s],t[s])}function S(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(b(t)){try{if(a instanceof t)return}catch{}if(!p(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(se[105],re([0,1,12]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=k,e.$Tj=R;const C=Object.create(null);function k(j,E){if((0,n.$$f)(E)){const u=C[E];if(u===void 0)throw new Error(`${j} references an unknown codicon: ${E}`);E=u}return C[j]=E,{id:j}}function R(){return C}}),define(se[145],re([0,1,105]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=void 0,e.$Uj={add:(0,n.$Sj)("add",6e4),plus:(0,n.$Sj)("plus",6e4),gistNew:(0,n.$Sj)("gist-new",6e4),repoCreate:(0,n.$Sj)("repo-create",6e4),lightbulb:(0,n.$Sj)("lightbulb",60001),lightBulb:(0,n.$Sj)("light-bulb",60001),repo:(0,n.$Sj)("repo",60002),repoDelete:(0,n.$Sj)("repo-delete",60002),gistFork:(0,n.$Sj)("gist-fork",60003),repoForked:(0,n.$Sj)("repo-forked",60003),gitPullRequest:(0,n.$Sj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Sj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Sj)("record-keys",60005),keyboard:(0,n.$Sj)("keyboard",60005),tag:(0,n.$Sj)("tag",60006),gitPullRequestLabel:(0,n.$Sj)("git-pull-request-label",60006),tagAdd:(0,n.$Sj)("tag-add",60006),tagRemove:(0,n.$Sj)("tag-remove",60006),person:(0,n.$Sj)("person",60007),personFollow:(0,n.$Sj)("person-follow",60007),personOutline:(0,n.$Sj)("person-outline",60007),personFilled:(0,n.$Sj)("person-filled",60007),gitBranch:(0,n.$Sj)("git-branch",60008),gitBranchCreate:(0,n.$Sj)("git-branch-create",60008),gitBranchDelete:(0,n.$Sj)("git-branch-delete",60008),sourceControl:(0,n.$Sj)("source-control",60008),mirror:(0,n.$Sj)("mirror",60009),mirrorPublic:(0,n.$Sj)("mirror-public",60009),star:(0,n.$Sj)("star",60010),starAdd:(0,n.$Sj)("star-add",60010),starDelete:(0,n.$Sj)("star-delete",60010),starEmpty:(0,n.$Sj)("star-empty",60010),comment:(0,n.$Sj)("comment",60011),commentAdd:(0,n.$Sj)("comment-add",60011),alert:(0,n.$Sj)("alert",60012),warning:(0,n.$Sj)("warning",60012),search:(0,n.$Sj)("search",60013),searchSave:(0,n.$Sj)("search-save",60013),logOut:(0,n.$Sj)("log-out",60014),signOut:(0,n.$Sj)("sign-out",60014),logIn:(0,n.$Sj)("log-in",60015),signIn:(0,n.$Sj)("sign-in",60015),eye:(0,n.$Sj)("eye",60016),eyeUnwatch:(0,n.$Sj)("eye-unwatch",60016),eyeWatch:(0,n.$Sj)("eye-watch",60016),circleFilled:(0,n.$Sj)("circle-filled",60017),primitiveDot:(0,n.$Sj)("primitive-dot",60017),closeDirty:(0,n.$Sj)("close-dirty",60017),debugBreakpoint:(0,n.$Sj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Sj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Sj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Sj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Sj)("primitive-square",60018),edit:(0,n.$Sj)("edit",60019),pencil:(0,n.$Sj)("pencil",60019),info:(0,n.$Sj)("info",60020),issueOpened:(0,n.$Sj)("issue-opened",60020),gistPrivate:(0,n.$Sj)("gist-private",60021),gitForkPrivate:(0,n.$Sj)("git-fork-private",60021),lock:(0,n.$Sj)("lock",60021),mirrorPrivate:(0,n.$Sj)("mirror-private",60021),close:(0,n.$Sj)("close",60022),removeClose:(0,n.$Sj)("remove-close",60022),x:(0,n.$Sj)("x",60022),repoSync:(0,n.$Sj)("repo-sync",60023),sync:(0,n.$Sj)("sync",60023),clone:(0,n.$Sj)("clone",60024),desktopDownload:(0,n.$Sj)("desktop-download",60024),beaker:(0,n.$Sj)("beaker",60025),microscope:(0,n.$Sj)("microscope",60025),vm:(0,n.$Sj)("vm",60026),deviceDesktop:(0,n.$Sj)("device-desktop",60026),file:(0,n.$Sj)("file",60027),fileText:(0,n.$Sj)("file-text",60027),more:(0,n.$Sj)("more",60028),ellipsis:(0,n.$Sj)("ellipsis",60028),kebabHorizontal:(0,n.$Sj)("kebab-horizontal",60028),mailReply:(0,n.$Sj)("mail-reply",60029),reply:(0,n.$Sj)("reply",60029),organization:(0,n.$Sj)("organization",60030),organizationFilled:(0,n.$Sj)("organization-filled",60030),organizationOutline:(0,n.$Sj)("organization-outline",60030),newFile:(0,n.$Sj)("new-file",60031),fileAdd:(0,n.$Sj)("file-add",60031),newFolder:(0,n.$Sj)("new-folder",60032),fileDirectoryCreate:(0,n.$Sj)("file-directory-create",60032),trash:(0,n.$Sj)("trash",60033),trashcan:(0,n.$Sj)("trashcan",60033),history:(0,n.$Sj)("history",60034),clock:(0,n.$Sj)("clock",60034),folder:(0,n.$Sj)("folder",60035),fileDirectory:(0,n.$Sj)("file-directory",60035),symbolFolder:(0,n.$Sj)("symbol-folder",60035),logoGithub:(0,n.$Sj)("logo-github",60036),markGithub:(0,n.$Sj)("mark-github",60036),github:(0,n.$Sj)("github",60036),terminal:(0,n.$Sj)("terminal",60037),console:(0,n.$Sj)("console",60037),repl:(0,n.$Sj)("repl",60037),zap:(0,n.$Sj)("zap",60038),symbolEvent:(0,n.$Sj)("symbol-event",60038),error:(0,n.$Sj)("error",60039),stop:(0,n.$Sj)("stop",60039),variable:(0,n.$Sj)("variable",60040),symbolVariable:(0,n.$Sj)("symbol-variable",60040),array:(0,n.$Sj)("array",60042),symbolArray:(0,n.$Sj)("symbol-array",60042),symbolModule:(0,n.$Sj)("symbol-module",60043),symbolPackage:(0,n.$Sj)("symbol-package",60043),symbolNamespace:(0,n.$Sj)("symbol-namespace",60043),symbolObject:(0,n.$Sj)("symbol-object",60043),symbolMethod:(0,n.$Sj)("symbol-method",60044),symbolFunction:(0,n.$Sj)("symbol-function",60044),symbolConstructor:(0,n.$Sj)("symbol-constructor",60044),symbolBoolean:(0,n.$Sj)("symbol-boolean",60047),symbolNull:(0,n.$Sj)("symbol-null",60047),symbolNumeric:(0,n.$Sj)("symbol-numeric",60048),symbolNumber:(0,n.$Sj)("symbol-number",60048),symbolStructure:(0,n.$Sj)("symbol-structure",60049),symbolStruct:(0,n.$Sj)("symbol-struct",60049),symbolParameter:(0,n.$Sj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Sj)("symbol-type-parameter",60050),symbolKey:(0,n.$Sj)("symbol-key",60051),symbolText:(0,n.$Sj)("symbol-text",60051),symbolReference:(0,n.$Sj)("symbol-reference",60052),goToFile:(0,n.$Sj)("go-to-file",60052),symbolEnum:(0,n.$Sj)("symbol-enum",60053),symbolValue:(0,n.$Sj)("symbol-value",60053),symbolRuler:(0,n.$Sj)("symbol-ruler",60054),symbolUnit:(0,n.$Sj)("symbol-unit",60054),activateBreakpoints:(0,n.$Sj)("activate-breakpoints",60055),archive:(0,n.$Sj)("archive",60056),arrowBoth:(0,n.$Sj)("arrow-both",60057),arrowDown:(0,n.$Sj)("arrow-down",60058),arrowLeft:(0,n.$Sj)("arrow-left",60059),arrowRight:(0,n.$Sj)("arrow-right",60060),arrowSmallDown:(0,n.$Sj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Sj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Sj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Sj)("arrow-small-up",60064),arrowUp:(0,n.$Sj)("arrow-up",60065),bell:(0,n.$Sj)("bell",60066),bold:(0,n.$Sj)("bold",60067),book:(0,n.$Sj)("book",60068),bookmark:(0,n.$Sj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Sj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Sj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Sj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Sj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Sj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Sj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Sj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Sj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Sj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Sj)("briefcase",60076),broadcast:(0,n.$Sj)("broadcast",60077),browser:(0,n.$Sj)("browser",60078),bug:(0,n.$Sj)("bug",60079),calendar:(0,n.$Sj)("calendar",60080),caseSensitive:(0,n.$Sj)("case-sensitive",60081),check:(0,n.$Sj)("check",60082),checklist:(0,n.$Sj)("checklist",60083),chevronDown:(0,n.$Sj)("chevron-down",60084),chevronLeft:(0,n.$Sj)("chevron-left",60085),chevronRight:(0,n.$Sj)("chevron-right",60086),chevronUp:(0,n.$Sj)("chevron-up",60087),chromeClose:(0,n.$Sj)("chrome-close",60088),chromeMaximize:(0,n.$Sj)("chrome-maximize",60089),chromeMinimize:(0,n.$Sj)("chrome-minimize",60090),chromeRestore:(0,n.$Sj)("chrome-restore",60091),circleOutline:(0,n.$Sj)("circle-outline",60092),circle:(0,n.$Sj)("circle",60092),debugBreakpointUnverified:(0,n.$Sj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Sj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Sj)("circle-slash",60093),circuitBoard:(0,n.$Sj)("circuit-board",60094),clearAll:(0,n.$Sj)("clear-all",60095),clippy:(0,n.$Sj)("clippy",60096),closeAll:(0,n.$Sj)("close-all",60097),cloudDownload:(0,n.$Sj)("cloud-download",60098),cloudUpload:(0,n.$Sj)("cloud-upload",60099),code:(0,n.$Sj)("code",60100),collapseAll:(0,n.$Sj)("collapse-all",60101),colorMode:(0,n.$Sj)("color-mode",60102),commentDiscussion:(0,n.$Sj)("comment-discussion",60103),creditCard:(0,n.$Sj)("credit-card",60105),dash:(0,n.$Sj)("dash",60108),dashboard:(0,n.$Sj)("dashboard",60109),database:(0,n.$Sj)("database",60110),debugContinue:(0,n.$Sj)("debug-continue",60111),debugDisconnect:(0,n.$Sj)("debug-disconnect",60112),debugPause:(0,n.$Sj)("debug-pause",60113),debugRestart:(0,n.$Sj)("debug-restart",60114),debugStart:(0,n.$Sj)("debug-start",60115),debugStepInto:(0,n.$Sj)("debug-step-into",60116),debugStepOut:(0,n.$Sj)("debug-step-out",60117),debugStepOver:(0,n.$Sj)("debug-step-over",60118),debugStop:(0,n.$Sj)("debug-stop",60119),debug:(0,n.$Sj)("debug",60120),deviceCameraVideo:(0,n.$Sj)("device-camera-video",60121),deviceCamera:(0,n.$Sj)("device-camera",60122),deviceMobile:(0,n.$Sj)("device-mobile",60123),diffAdded:(0,n.$Sj)("diff-added",60124),diffIgnored:(0,n.$Sj)("diff-ignored",60125),diffModified:(0,n.$Sj)("diff-modified",60126),diffRemoved:(0,n.$Sj)("diff-removed",60127),diffRenamed:(0,n.$Sj)("diff-renamed",60128),diff:(0,n.$Sj)("diff",60129),diffSidebyside:(0,n.$Sj)("diff-sidebyside",60129),discard:(0,n.$Sj)("discard",60130),editorLayout:(0,n.$Sj)("editor-layout",60131),emptyWindow:(0,n.$Sj)("empty-window",60132),exclude:(0,n.$Sj)("exclude",60133),extensions:(0,n.$Sj)("extensions",60134),eyeClosed:(0,n.$Sj)("eye-closed",60135),fileBinary:(0,n.$Sj)("file-binary",60136),fileCode:(0,n.$Sj)("file-code",60137),fileMedia:(0,n.$Sj)("file-media",60138),filePdf:(0,n.$Sj)("file-pdf",60139),fileSubmodule:(0,n.$Sj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Sj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Sj)("file-symlink-file",60142),fileZip:(0,n.$Sj)("file-zip",60143),files:(0,n.$Sj)("files",60144),filter:(0,n.$Sj)("filter",60145),flame:(0,n.$Sj)("flame",60146),foldDown:(0,n.$Sj)("fold-down",60147),foldUp:(0,n.$Sj)("fold-up",60148),fold:(0,n.$Sj)("fold",60149),folderActive:(0,n.$Sj)("folder-active",60150),folderOpened:(0,n.$Sj)("folder-opened",60151),gear:(0,n.$Sj)("gear",60152),gift:(0,n.$Sj)("gift",60153),gistSecret:(0,n.$Sj)("gist-secret",60154),gist:(0,n.$Sj)("gist",60155),gitCommit:(0,n.$Sj)("git-commit",60156),gitCompare:(0,n.$Sj)("git-compare",60157),compareChanges:(0,n.$Sj)("compare-changes",60157),gitMerge:(0,n.$Sj)("git-merge",60158),githubAction:(0,n.$Sj)("github-action",60159),githubAlt:(0,n.$Sj)("github-alt",60160),globe:(0,n.$Sj)("globe",60161),grabber:(0,n.$Sj)("grabber",60162),graph:(0,n.$Sj)("graph",60163),gripper:(0,n.$Sj)("gripper",60164),heart:(0,n.$Sj)("heart",60165),home:(0,n.$Sj)("home",60166),horizontalRule:(0,n.$Sj)("horizontal-rule",60167),hubot:(0,n.$Sj)("hubot",60168),inbox:(0,n.$Sj)("inbox",60169),issueReopened:(0,n.$Sj)("issue-reopened",60171),issues:(0,n.$Sj)("issues",60172),italic:(0,n.$Sj)("italic",60173),jersey:(0,n.$Sj)("jersey",60174),json:(0,n.$Sj)("json",60175),kebabVertical:(0,n.$Sj)("kebab-vertical",60176),key:(0,n.$Sj)("key",60177),law:(0,n.$Sj)("law",60178),lightbulbAutofix:(0,n.$Sj)("lightbulb-autofix",60179),linkExternal:(0,n.$Sj)("link-external",60180),link:(0,n.$Sj)("link",60181),listOrdered:(0,n.$Sj)("list-ordered",60182),listUnordered:(0,n.$Sj)("list-unordered",60183),liveShare:(0,n.$Sj)("live-share",60184),loading:(0,n.$Sj)("loading",60185),location:(0,n.$Sj)("location",60186),mailRead:(0,n.$Sj)("mail-read",60187),mail:(0,n.$Sj)("mail",60188),markdown:(0,n.$Sj)("markdown",60189),megaphone:(0,n.$Sj)("megaphone",60190),mention:(0,n.$Sj)("mention",60191),milestone:(0,n.$Sj)("milestone",60192),gitPullRequestMilestone:(0,n.$Sj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Sj)("mortar-board",60193),move:(0,n.$Sj)("move",60194),multipleWindows:(0,n.$Sj)("multiple-windows",60195),mute:(0,n.$Sj)("mute",60196),noNewline:(0,n.$Sj)("no-newline",60197),note:(0,n.$Sj)("note",60198),octoface:(0,n.$Sj)("octoface",60199),openPreview:(0,n.$Sj)("open-preview",60200),package:(0,n.$Sj)("package",60201),paintcan:(0,n.$Sj)("paintcan",60202),pin:(0,n.$Sj)("pin",60203),play:(0,n.$Sj)("play",60204),run:(0,n.$Sj)("run",60204),plug:(0,n.$Sj)("plug",60205),preserveCase:(0,n.$Sj)("preserve-case",60206),preview:(0,n.$Sj)("preview",60207),project:(0,n.$Sj)("project",60208),pulse:(0,n.$Sj)("pulse",60209),question:(0,n.$Sj)("question",60210),quote:(0,n.$Sj)("quote",60211),radioTower:(0,n.$Sj)("radio-tower",60212),reactions:(0,n.$Sj)("reactions",60213),references:(0,n.$Sj)("references",60214),refresh:(0,n.$Sj)("refresh",60215),regex:(0,n.$Sj)("regex",60216),remoteExplorer:(0,n.$Sj)("remote-explorer",60217),remote:(0,n.$Sj)("remote",60218),remove:(0,n.$Sj)("remove",60219),replaceAll:(0,n.$Sj)("replace-all",60220),replace:(0,n.$Sj)("replace",60221),repoClone:(0,n.$Sj)("repo-clone",60222),repoForcePush:(0,n.$Sj)("repo-force-push",60223),repoPull:(0,n.$Sj)("repo-pull",60224),repoPush:(0,n.$Sj)("repo-push",60225),report:(0,n.$Sj)("report",60226),requestChanges:(0,n.$Sj)("request-changes",60227),rocket:(0,n.$Sj)("rocket",60228),rootFolderOpened:(0,n.$Sj)("root-folder-opened",60229),rootFolder:(0,n.$Sj)("root-folder",60230),rss:(0,n.$Sj)("rss",60231),ruby:(0,n.$Sj)("ruby",60232),saveAll:(0,n.$Sj)("save-all",60233),saveAs:(0,n.$Sj)("save-as",60234),save:(0,n.$Sj)("save",60235),screenFull:(0,n.$Sj)("screen-full",60236),screenNormal:(0,n.$Sj)("screen-normal",60237),searchStop:(0,n.$Sj)("search-stop",60238),server:(0,n.$Sj)("server",60240),settingsGear:(0,n.$Sj)("settings-gear",60241),settings:(0,n.$Sj)("settings",60242),shield:(0,n.$Sj)("shield",60243),smiley:(0,n.$Sj)("smiley",60244),sortPrecedence:(0,n.$Sj)("sort-precedence",60245),splitHorizontal:(0,n.$Sj)("split-horizontal",60246),splitVertical:(0,n.$Sj)("split-vertical",60247),squirrel:(0,n.$Sj)("squirrel",60248),starFull:(0,n.$Sj)("star-full",60249),starHalf:(0,n.$Sj)("star-half",60250),symbolClass:(0,n.$Sj)("symbol-class",60251),symbolColor:(0,n.$Sj)("symbol-color",60252),symbolConstant:(0,n.$Sj)("symbol-constant",60253),symbolEnumMember:(0,n.$Sj)("symbol-enum-member",60254),symbolField:(0,n.$Sj)("symbol-field",60255),symbolFile:(0,n.$Sj)("symbol-file",60256),symbolInterface:(0,n.$Sj)("symbol-interface",60257),symbolKeyword:(0,n.$Sj)("symbol-keyword",60258),symbolMisc:(0,n.$Sj)("symbol-misc",60259),symbolOperator:(0,n.$Sj)("symbol-operator",60260),symbolProperty:(0,n.$Sj)("symbol-property",60261),wrench:(0,n.$Sj)("wrench",60261),wrenchSubaction:(0,n.$Sj)("wrench-subaction",60261),symbolSnippet:(0,n.$Sj)("symbol-snippet",60262),tasklist:(0,n.$Sj)("tasklist",60263),telescope:(0,n.$Sj)("telescope",60264),textSize:(0,n.$Sj)("text-size",60265),threeBars:(0,n.$Sj)("three-bars",60266),thumbsdown:(0,n.$Sj)("thumbsdown",60267),thumbsup:(0,n.$Sj)("thumbsup",60268),tools:(0,n.$Sj)("tools",60269),triangleDown:(0,n.$Sj)("triangle-down",60270),triangleLeft:(0,n.$Sj)("triangle-left",60271),triangleRight:(0,n.$Sj)("triangle-right",60272),triangleUp:(0,n.$Sj)("triangle-up",60273),twitter:(0,n.$Sj)("twitter",60274),unfold:(0,n.$Sj)("unfold",60275),unlock:(0,n.$Sj)("unlock",60276),unmute:(0,n.$Sj)("unmute",60277),unverified:(0,n.$Sj)("unverified",60278),verified:(0,n.$Sj)("verified",60279),versions:(0,n.$Sj)("versions",60280),vmActive:(0,n.$Sj)("vm-active",60281),vmOutline:(0,n.$Sj)("vm-outline",60282),vmRunning:(0,n.$Sj)("vm-running",60283),watch:(0,n.$Sj)("watch",60284),whitespace:(0,n.$Sj)("whitespace",60285),wholeWord:(0,n.$Sj)("whole-word",60286),window:(0,n.$Sj)("window",60287),wordWrap:(0,n.$Sj)("word-wrap",60288),zoomIn:(0,n.$Sj)("zoom-in",60289),zoomOut:(0,n.$Sj)("zoom-out",60290),listFilter:(0,n.$Sj)("list-filter",60291),listFlat:(0,n.$Sj)("list-flat",60292),listSelection:(0,n.$Sj)("list-selection",60293),selection:(0,n.$Sj)("selection",60293),listTree:(0,n.$Sj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Sj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Sj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Sj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Sj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Sj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Sj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Sj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Sj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Sj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Sj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Sj)("symbol-string",60301),debugReverseContinue:(0,n.$Sj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Sj)("debug-step-back",60303),debugRestartFrame:(0,n.$Sj)("debug-restart-frame",60304),debugAlt:(0,n.$Sj)("debug-alt",60305),callIncoming:(0,n.$Sj)("call-incoming",60306),callOutgoing:(0,n.$Sj)("call-outgoing",60307),menu:(0,n.$Sj)("menu",60308),expandAll:(0,n.$Sj)("expand-all",60309),feedback:(0,n.$Sj)("feedback",60310),gitPullRequestReviewer:(0,n.$Sj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Sj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Sj)("ungroup-by-ref-type",60312),account:(0,n.$Sj)("account",60313),gitPullRequestAssignee:(0,n.$Sj)("git-pull-request-assignee",60313),bellDot:(0,n.$Sj)("bell-dot",60314),debugConsole:(0,n.$Sj)("debug-console",60315),library:(0,n.$Sj)("library",60316),output:(0,n.$Sj)("output",60317),runAll:(0,n.$Sj)("run-all",60318),syncIgnored:(0,n.$Sj)("sync-ignored",60319),pinned:(0,n.$Sj)("pinned",60320),githubInverted:(0,n.$Sj)("github-inverted",60321),serverProcess:(0,n.$Sj)("server-process",60322),serverEnvironment:(0,n.$Sj)("server-environment",60323),pass:(0,n.$Sj)("pass",60324),issueClosed:(0,n.$Sj)("issue-closed",60324),stopCircle:(0,n.$Sj)("stop-circle",60325),playCircle:(0,n.$Sj)("play-circle",60326),record:(0,n.$Sj)("record",60327),debugAltSmall:(0,n.$Sj)("debug-alt-small",60328),vmConnect:(0,n.$Sj)("vm-connect",60329),cloud:(0,n.$Sj)("cloud",60330),merge:(0,n.$Sj)("merge",60331),export:(0,n.$Sj)("export",60332),graphLeft:(0,n.$Sj)("graph-left",60333),magnet:(0,n.$Sj)("magnet",60334),notebook:(0,n.$Sj)("notebook",60335),redo:(0,n.$Sj)("redo",60336),checkAll:(0,n.$Sj)("check-all",60337),pinnedDirty:(0,n.$Sj)("pinned-dirty",60338),passFilled:(0,n.$Sj)("pass-filled",60339),circleLargeFilled:(0,n.$Sj)("circle-large-filled",60340),circleLarge:(0,n.$Sj)("circle-large",60341),circleLargeOutline:(0,n.$Sj)("circle-large-outline",60341),combine:(0,n.$Sj)("combine",60342),gather:(0,n.$Sj)("gather",60342),table:(0,n.$Sj)("table",60343),variableGroup:(0,n.$Sj)("variable-group",60344),typeHierarchy:(0,n.$Sj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Sj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Sj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Sj)("git-pull-request-create",60348),runAbove:(0,n.$Sj)("run-above",60349),runBelow:(0,n.$Sj)("run-below",60350),notebookTemplate:(0,n.$Sj)("notebook-template",60351),debugRerun:(0,n.$Sj)("debug-rerun",60352),workspaceTrusted:(0,n.$Sj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Sj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Sj)("workspace-unknown",60355),terminalCmd:(0,n.$Sj)("terminal-cmd",60356),terminalDebian:(0,n.$Sj)("terminal-debian",60357),terminalLinux:(0,n.$Sj)("terminal-linux",60358),terminalPowershell:(0,n.$Sj)("terminal-powershell",60359),terminalTmux:(0,n.$Sj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Sj)("terminal-ubuntu",60361),terminalBash:(0,n.$Sj)("terminal-bash",60362),arrowSwap:(0,n.$Sj)("arrow-swap",60363),copy:(0,n.$Sj)("copy",60364),personAdd:(0,n.$Sj)("person-add",60365),filterFilled:(0,n.$Sj)("filter-filled",60366),wand:(0,n.$Sj)("wand",60367),debugLineByLine:(0,n.$Sj)("debug-line-by-line",60368),inspect:(0,n.$Sj)("inspect",60369),layers:(0,n.$Sj)("layers",60370),layersDot:(0,n.$Sj)("layers-dot",60371),layersActive:(0,n.$Sj)("layers-active",60372),compass:(0,n.$Sj)("compass",60373),compassDot:(0,n.$Sj)("compass-dot",60374),compassActive:(0,n.$Sj)("compass-active",60375),azure:(0,n.$Sj)("azure",60376),issueDraft:(0,n.$Sj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Sj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Sj)("git-pull-request-draft",60379),debugAll:(0,n.$Sj)("debug-all",60380),debugCoverage:(0,n.$Sj)("debug-coverage",60381),runErrors:(0,n.$Sj)("run-errors",60382),folderLibrary:(0,n.$Sj)("folder-library",60383),debugContinueSmall:(0,n.$Sj)("debug-continue-small",60384),beakerStop:(0,n.$Sj)("beaker-stop",60385),graphLine:(0,n.$Sj)("graph-line",60386),graphScatter:(0,n.$Sj)("graph-scatter",60387),pieChart:(0,n.$Sj)("pie-chart",60388),bracket:(0,n.$Sj)("bracket",60175),bracketDot:(0,n.$Sj)("bracket-dot",60389),bracketError:(0,n.$Sj)("bracket-error",60390),lockSmall:(0,n.$Sj)("lock-small",60391),azureDevops:(0,n.$Sj)("azure-devops",60392),verifiedFilled:(0,n.$Sj)("verified-filled",60393),newline:(0,n.$Sj)("newline",60394),layout:(0,n.$Sj)("layout",60395),layoutActivitybarLeft:(0,n.$Sj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Sj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Sj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Sj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Sj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Sj)("layout-panel-right",60401),layoutPanel:(0,n.$Sj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Sj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Sj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Sj)("layout-statusbar",60405),layoutMenubar:(0,n.$Sj)("layout-menubar",60406),layoutCentered:(0,n.$Sj)("layout-centered",60407),target:(0,n.$Sj)("target",60408),indent:(0,n.$Sj)("indent",60409),recordSmall:(0,n.$Sj)("record-small",60410),errorSmall:(0,n.$Sj)("error-small",60411),terminalDecorationError:(0,n.$Sj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Sj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Sj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Sj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Sj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Sj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Sj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Sj)("layout-sidebar-left-off",60418),blank:(0,n.$Sj)("blank",60419),heartFilled:(0,n.$Sj)("heart-filled",60420),map:(0,n.$Sj)("map",60421),mapHorizontal:(0,n.$Sj)("map-horizontal",60421),foldHorizontal:(0,n.$Sj)("fold-horizontal",60421),mapFilled:(0,n.$Sj)("map-filled",60422),mapHorizontalFilled:(0,n.$Sj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Sj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Sj)("circle-small",60423),bellSlash:(0,n.$Sj)("bell-slash",60424),bellSlashDot:(0,n.$Sj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Sj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Sj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Sj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Sj)("search-fuzzy",60429),commentDraft:(0,n.$Sj)("comment-draft",60430),send:(0,n.$Sj)("send",60431),sparkle:(0,n.$Sj)("sparkle",60432),insert:(0,n.$Sj)("insert",60433),mic:(0,n.$Sj)("mic",60434),thumbsdownFilled:(0,n.$Sj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Sj)("thumbsup-filled",60436),coffee:(0,n.$Sj)("coffee",60437),snake:(0,n.$Sj)("snake",60438),game:(0,n.$Sj)("game",60439),vr:(0,n.$Sj)("vr",60440),chip:(0,n.$Sj)("chip",60441),piano:(0,n.$Sj)("piano",60442),music:(0,n.$Sj)("music",60443),micFilled:(0,n.$Sj)("mic-filled",60444),repoFetch:(0,n.$Sj)("repo-fetch",60445),copilot:(0,n.$Sj)("copilot",60446),lightbulbSparkle:(0,n.$Sj)("lightbulb-sparkle",60447),robot:(0,n.$Sj)("robot",60448),sparkleFilled:(0,n.$Sj)("sparkle-filled",60449),diffSingle:(0,n.$Sj)("diff-single",60450),diffMultiple:(0,n.$Sj)("diff-multiple",60451),surroundWith:(0,n.$Sj)("surround-with",60452),share:(0,n.$Sj)("share",60453),gitStash:(0,n.$Sj)("git-stash",60454),gitStashApply:(0,n.$Sj)("git-stash-apply",60455),gitStashPop:(0,n.$Sj)("git-stash-pop",60456),vscode:(0,n.$Sj)("vscode",60457),vscodeInsiders:(0,n.$Sj)("vscode-insiders",60458),codeOss:(0,n.$Sj)("code-oss",60459),runCoverage:(0,n.$Sj)("run-coverage",60460),runAllCoverage:(0,n.$Sj)("run-all-coverage",60461),coverage:(0,n.$Sj)("coverage",60462),githubProject:(0,n.$Sj)("github-project",60463),mapVertical:(0,n.$Sj)("map-vertical",60464),foldVertical:(0,n.$Sj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Sj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Sj)("fold-vertical-filled",60465),goToSearch:(0,n.$Sj)("go-to-search",60466),percentage:(0,n.$Sj)("percentage",60467),sortPercentage:(0,n.$Sj)("sort-percentage",60467),attach:(0,n.$Sj)("attach",60468)}}),define(se[75],re([0,1,105,145]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xj=e.$Wj=void 0,e.$Vj=k;function k(){return Object.values(e.$Xj)}e.$Wj={dialogError:(0,n.$Sj)("dialog-error","error"),dialogWarning:(0,n.$Sj)("dialog-warning","warning"),dialogInfo:(0,n.$Sj)("dialog-info","info"),dialogClose:(0,n.$Sj)("dialog-close","close"),treeItemExpanded:(0,n.$Sj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Sj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Sj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Sj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Sj)("tree-item-loading","loading"),menuSelection:(0,n.$Sj)("menu-selection","check"),menuSubmenu:(0,n.$Sj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Sj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Sj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Sj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Sj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Sj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Sj)("toolbar-more","more"),quickInputBack:(0,n.$Sj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Sj)("drop-down-button",60084),symbolCustomColor:(0,n.$Sj)("symbol-customcolor",60252),exportIcon:(0,n.$Sj)("export",60332),workspaceUnspecified:(0,n.$Sj)("workspace-unspecified",60355),newLine:(0,n.$Sj)("newline",60394),thumbsDownFilled:(0,n.$Sj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Sj)("thumbsup-filled",60436),gitFetch:(0,n.$Sj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Sj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Sj)("debug-breakpoint-pending",60377)},e.$Xj={...C.$Uj,...e.$Wj}}),define(se[35],re([0,1,12]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=C,e.$6n=k,e.$7n=j,e.$8n=u,e.$9n=c,e.$0n=g,e.$$n=p,e.$_n=v,e.$ao=m,e.$bo=d,e.$co=y,e.$do=w,e.$eo=b;function C(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const h=Array.isArray(f)?[]:{};return Object.entries(f).forEach(([S,a])=>{h[S]=a&&typeof a=="object"?C(a):a}),h}function k(f){if(!f||typeof f!="object")return f;const h=[f];for(;h.length>0;){const S=h.shift();Object.freeze(S);for(const a in S)if(R.call(S,a)){const t=S[a];typeof t=="object"&&!Object.isFrozen(t)&&!(0,n.$bg)(t)&&h.push(t)}}return f}const R=Object.prototype.hasOwnProperty;function j(f,h){return E(f,h,new Set)}function E(f,h,S){if((0,n.$hg)(f))return f;const a=h(f);if(typeof a<"u")return a;if(Array.isArray(f)){const t=[];for(const r of f)t.push(E(r,h,S));return t}if((0,n.$ag)(f)){if(S.has(f))throw new Error("Cannot clone recursive data-structure");S.add(f);const t={};for(const r in f)R.call(f,r)&&(t[r]=E(f[r],h,S));return S.delete(f),t}return f}function u(f,h,S=!0){return(0,n.$ag)(f)?((0,n.$ag)(h)&&Object.keys(h).forEach(a=>{a in f?S&&((0,n.$ag)(f[a])&&(0,n.$ag)(h[a])?u(f[a],h[a],S):f[a]=h[a]):f[a]=h[a]}),f):h}function c(f,h){if(f===h)return!0;if(f==null||h===null||h===void 0||typeof f!=typeof h||typeof f!="object"||Array.isArray(f)!==Array.isArray(h))return!1;let S,a;if(Array.isArray(f)){if(f.length!==h.length)return!1;for(S=0;S<f.length;S++)if(!c(f[S],h[S]))return!1}else{const t=[];for(a in f)t.push(a);t.sort();const r=[];for(a in h)r.push(a);if(r.sort(),!c(t,r))return!1;for(S=0;S<t.length;S++)if(!c(f[t[S]],h[t[S]]))return!1}return!0}function g(f){const h=new Set;return JSON.stringify(f,(S,a)=>{if((0,n.$ag)(a)||Array.isArray(a)){if(h.has(a))return"[Circular]";h.add(a)}return typeof a=="bigint"?`[BigInt ${a.toString()}]`:a})}function p(f,h){const S=Object.create(null);return!f||!h||Object.keys(h).forEach(t=>{const r=f[t],s=h[t];c(r,s)||(S[t]=s)}),S}function v(f,h){const S=h.toLowerCase(),a=Object.keys(f).find(t=>t.toLowerCase()===S);return a?f[a]:f[h]}function m(f,h){const S=Object.create(null);for(const[a,t]of Object.entries(f))h(a,t)&&(S[a]=t);return S}function d(f){let h=[];for(;Object.prototype!==f;)h=h.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return h}function y(f){const h=[];for(const S of d(f))typeof f[S]=="function"&&h.push(S);return h}function w(f,h){const S=t=>function(){const r=Array.prototype.slice.call(arguments,0);return h(t,r)},a={};for(const t of f)a[t]=S(t);return a}function b(f,h){const S={};for(const[a,t]of Object.entries(f))S[a]=h(t,a);return S}}),define(se[106],re([0,1,75]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=k;var C;(function(j){function E(u){return u&&typeof u=="object"&&typeof u.id=="string"}j.isThemeColor=E})(C||(e.ThemeColor=C={}));function k(j){return{id:j}}var R;(function(j){j.iconNameSegment="[A-Za-z0-9]+",j.iconNameExpression="[A-Za-z0-9-]+",j.iconModifierExpression="~[A-Za-z]+",j.iconNameCharacter="[A-Za-z0-9~-]";const E=new RegExp(`^(${j.iconNameExpression})(${j.iconModifierExpression})?$`);function u(f){const h=E.exec(f.id);if(!h)return u(n.$Xj.error);const[,S,a]=h,t=["codicon","codicon-"+S];return a&&t.push("codicon-modifier-"+a.substring(1)),t}j.asClassNameArray=u;function c(f){return u(f).join(" ")}j.asClassName=c;function g(f){return"."+u(f).join(".")}j.asCSSSelector=g;function p(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||C.isThemeColor(f.color))}j.isThemeIcon=p;const v=new RegExp(`^\\$\\((${j.iconNameExpression}(?:${j.iconModifierExpression})?)\\)$`);function m(f){const h=v.exec(f);if(!h)return;const[,S]=h;return{id:S}}j.fromString=m;function d(f){return{id:f}}j.fromId=d;function y(f,h){let S=f.id;const a=S.lastIndexOf("~");return a!==-1&&(S=S.substring(0,a)),h&&(S=`${S}~${h}`),{id:S}}j.modify=y;function w(f){const h=f.id.lastIndexOf("~");if(h!==-1)return f.id.substring(h+1)}j.getModifier=w;function b(f,h){return f.id===h.id&&f.color?.id===h.color?.id}j.isEqual=b})(R||(e.ThemeIcon=R={}))}),define(se[33],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=C;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(k){return n.test(k)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let u=0;u<E.length;u++)E[u]=Math.floor(Math.random()*256);return E};const R=new Uint8Array(16),j=[];for(let E=0;E<256;E++)j.push(E.toString(16).padStart(2,"0"));return function(){k(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let u=0,c="";return c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+="-",c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c+=j[R[u++]],c}}()}),define(se[146],re([0,1,87,43,86]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bW=R;async function R(j,E){if(await new Promise((g,p)=>{const v=C.createReadStream(j),m=n.createHash("sha256");v.pipe(m);const d=(0,k.$db)((y,w)=>{v.removeAllListeners(),m.removeAllListeners(),y?p(y):g(w)});v.once("error",d),v.once("end",d),m.once("error",d),m.once("data",y=>d(void 0,y.toString("hex")))})!==E)throw new Error("Hash mismatch")}}),define(se[147],re([0,1,26]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=R;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(j){const E=j.replace(/\-/g,":").toLowerCase();return!C.has(E)}function R(){const j=(0,n.networkInterfaces)();for(const E in j){const u=j[E];if(u){for(const{mac:c}of u)if(k(c))return c}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[107],re([0,1,88]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=void 0,e.$Wg=C,e.$Yg=R;function C(E,u,c,g=1){let p=!1;return new Promise(v=>{const m=setTimeout(()=>{if(!p)return p=!0,v(0)},c);k(E,u,g,d=>{if(!p)return p=!0,clearTimeout(m),v(d)})})}function k(E,u,c,g){if(u===0)return g(0);const p=new n.Socket;p.once("connect",()=>(j(p),k(E+c,u-1,c,g))),p.once("data",()=>{}),p.once("error",v=>(j(p),v.code!=="ECONNREFUSED"?k(E+c,u-1,c,g):g(E))),p.connect(E,"127.0.0.1")}e.$Xg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(E,u,c,g="127.0.0.1"){let p=!1,v,m=1;const d=n.createServer({pauseOnConnect:!0});function y(w,b){p||(p=!0,d.removeAllListeners(),d.close(),v&&clearTimeout(v),b(w))}return new Promise(w=>{v=setTimeout(()=>{y(0,w)},c),d.on("listening",()=>{y(E,w)}),d.on("error",b=>{b&&(b.code==="EADDRINUSE"||b.code==="EACCES")&&m<u?(E++,m++,d.listen(E,g)):y(0,w)}),d.on("close",()=>{y(0,w)}),d.listen(E,g)})}function j(E){try{E.removeAllListeners("connect"),E.removeAllListeners("error"),E.end(),E.destroy(),E.unref()}catch(u){console.error(u)}}}),function(){function K(){function e(){return process.uncHostAllowlist}function n(u){const c=new Set;if(Array.isArray(u))for(const g of u)typeof g=="string"&&c.add(g);return Array.from(c)}function C(){const u=e();return u?Array.from(u):[]}function k(u){if(process.platform!=="win32")return;const c=e();if(c)if(typeof u=="string")c.add(u.toLowerCase());else for(const g of n(u))k(g)}function R(u){if(typeof u!="string")return;const c=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let g;for(const p of c){if(u.indexOf(p)!==0)continue;const m=u.indexOf("\\",p.length);if(m===-1)continue;const d=u.substring(p.length,m);if(d){g=d;break}}return g}function j(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function E(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:k,getUNCHost:R,disableUNCAccessRestrictions:j,isUNCAccessRestrictionsDisabled:E}}typeof define=="function"?define("vs/base/node/unc",[],function(){return K()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=K():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(se[148],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hW=e.$gW=void 0,e.$gW="vscode:contextmenu",e.$hW="vscode:onCloseContextMenu"}),define(se[149],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oW=void 0;class n{constructor(k,R){this.a=k,this.onMessage=R}send(k){try{this.a.send("vscode:message",k.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$oW=n}),define(se[150],re([11,10]),function(K,e){return K.create("vs/base/common/date",e)}),define(se[151],re([0,1,150]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=c,e.$5m=g,e.$6m=p;const C=60,k=C*60,R=k*24,j=R*7,E=R*30,u=R*365;function c(v,m,d,y){typeof v!="number"&&(v=v.getTime());const w=Math.round((new Date().getTime()-v)/1e3);if(w<-30)return(0,n.localize)(0,null,c(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,n.localize)(1,null);let b;return w<C?(b=w,m?b===1?d?(0,n.localize)(2,null,b):(0,n.localize)(3,null,b):d?(0,n.localize)(4,null,b):(0,n.localize)(5,null,b):b===1?d?(0,n.localize)(6,null,b):(0,n.localize)(7,null,b):d?(0,n.localize)(8,null,b):(0,n.localize)(9,null,b)):w<k?(b=Math.floor(w/C),m?b===1?d?(0,n.localize)(10,null,b):(0,n.localize)(11,null,b):d?(0,n.localize)(12,null,b):(0,n.localize)(13,null,b):b===1?d?(0,n.localize)(14,null,b):(0,n.localize)(15,null,b):d?(0,n.localize)(16,null,b):(0,n.localize)(17,null,b)):w<R?(b=Math.floor(w/k),m?b===1?d?(0,n.localize)(18,null,b):(0,n.localize)(19,null,b):d?(0,n.localize)(20,null,b):(0,n.localize)(21,null,b):b===1?d?(0,n.localize)(22,null,b):(0,n.localize)(23,null,b):d?(0,n.localize)(24,null,b):(0,n.localize)(25,null,b)):w<j?(b=Math.floor(w/R),m?b===1?(0,n.localize)(26,null,b):(0,n.localize)(27,null,b):b===1?(0,n.localize)(28,null,b):(0,n.localize)(29,null,b)):w<E?(b=Math.floor(w/j),m?b===1?d?(0,n.localize)(30,null,b):(0,n.localize)(31,null,b):d?(0,n.localize)(32,null,b):(0,n.localize)(33,null,b):b===1?d?(0,n.localize)(34,null,b):(0,n.localize)(35,null,b):d?(0,n.localize)(36,null,b):(0,n.localize)(37,null,b)):w<u?(b=Math.floor(w/E),m?b===1?d?(0,n.localize)(38,null,b):(0,n.localize)(39,null,b):d?(0,n.localize)(40,null,b):(0,n.localize)(41,null,b):b===1?d?(0,n.localize)(42,null,b):(0,n.localize)(43,null,b):d?(0,n.localize)(44,null,b):(0,n.localize)(45,null,b)):(b=Math.floor(w/u),m?b===1?d?(0,n.localize)(46,null,b):(0,n.localize)(47,null,b):d?(0,n.localize)(48,null,b):(0,n.localize)(49,null,b):b===1?d?(0,n.localize)(50,null,b):(0,n.localize)(51,null,b):d?(0,n.localize)(52,null,b):(0,n.localize)(53,null,b))}function g(v,m){const d=Math.abs(v/1e3);return d<1?m?(0,n.localize)(54,null,v):(0,n.localize)(55,null,v):d<C?m?(0,n.localize)(56,null,Math.round(v)/1e3):(0,n.localize)(57,null,Math.round(v)/1e3):d<k?m?(0,n.localize)(58,null,Math.round(v/(1e3*C))):(0,n.localize)(59,null,Math.round(v/(1e3*C))):d<R?m?(0,n.localize)(60,null,Math.round(v/(1e3*k))):(0,n.localize)(61,null,Math.round(v/(1e3*k))):(0,n.localize)(62,null,Math.round(v/(1e3*R)))}function p(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[152],re([11,10]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(se[47],re([0,1,22,12,152]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=u,e.$kj=c,e.$lj=g;function R(p,v){return v&&(p.stack||p.stacktrace)?k.localize(0,null,E(p),j(p.stack)||j(p.stacktrace)):E(p)}function j(p){return Array.isArray(p)?p.join(`
`):p}function E(p){return p.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${p.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof p.code=="string"&&typeof p.errno=="number"&&typeof p.syscall=="string"?k.localize(1,null,p.message):p.message||k.localize(2,null)}function u(p=null,v=!1){if(!p)return k.localize(3,null);if(Array.isArray(p)){const m=n.$Hb(p),d=u(m[0],v);return m.length>1?k.localize(4,null,d,m.length):d}if(C.$$f(p))return p;if(p.detail){const m=p.detail;if(m.error)return R(m.error,v);if(m.exception)return R(m.exception,v)}return p.stack?R(p,v):p.message?p.message:k.localize(5,null)}function c(p){const v=p;return v instanceof Error&&Array.isArray(v.actions)}function g(p,v){let m;return typeof p=="string"?m=new Error(p):m=p,m.actions=v,m}}),define(se[153],re([11,10]),function(K,e){return K.create("vs/base/common/jsonErrorMessages",e)}),define(se[154],re([0,1,153]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=C;function C(k){switch(k){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(se[155],re([11,10]),function(K,e){return K.create("vs/base/common/platform",e)}),define(se[4],re([0,1,155]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=P,e.$J=D,e.$g="en";let C=!1,k=!1,R=!1,j=!1,E=!1,u=!1,c=!1,g=!1,p=!1,v=!1,m,d=e.$g,y=e.$g,w,b;const f=globalThis;let h;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?h=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(h=process);const S=typeof h?.versions?.electron=="string",a=S&&h?.type==="renderer";if(typeof h=="object"){C=h.platform==="win32",k=h.platform==="darwin",R=h.platform==="linux",j=R&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,c=S,p=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$g,d=e.$g;const I=h.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];m=O.locale,y=O.osLocale,d=M||e.$g,w=O._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!a?(b=navigator.userAgent,C=b.indexOf("Windows")>=0,k=b.indexOf("Macintosh")>=0,g=(b.indexOf("Macintosh")>=0||b.indexOf("iPad")>=0||b.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=b.indexOf("Linux")>=0,v=b?.indexOf("Mobi")>=0,u=!0,m=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,d=m,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;k?s=1:C?s=3:R&&(s=2),e.$i=C,e.$j=k,e.$k=R,e.$l=j,e.$m=E,e.$n=c,e.$o=u,e.$p=u&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=g,e.$s=v,e.$t=p,e.$u=s,e.$v=b,e.$w=d;var i;(function(I){function O(){return e.$w}I.value=O;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=M;function W(){return e.$w==="en"}I.isDefault=W})(i||(e.Language=i={})),e.$x=m,e.$y=y,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const I=[];f.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let W=0,F=I.length;W<F;W++){const T=I[W];if(T.id===M.data.vscodeScheduleAsyncWork){I.splice(W,1),T.callback();return}}});let O=0;return M=>{const W=++O;I.push({id:W,callback:M}),f.postMessage({vscodeScheduleAsyncWork:W},"*")}}return I=>setTimeout(I)})();var o;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=k||g?2:C?1:3;let l=!0,$=!1;function P(){if(!$){$=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,l=new Uint16Array(I.buffer)[0]===513}return l}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(I){return parseFloat(I)>=20}}),define(se[36],re([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let C;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const R=k.process;C={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$dc=C.platform,e.$ec=C.arch}),define(se[9],re([0,1,36]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const C=65,k=97,R=90,j=122,E=46,u=47,c=92,g=58,p=63;class v extends Error{constructor(r,s,i){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const l=r.indexOf(".")!==-1?"property":"argument";let $=`The "${r}" ${l} ${o} of type ${s}`;$+=`. Received type ${typeof i}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function d(t,r){if(typeof t!="string")throw new v(r,"string",t)}const y=n.$dc==="win32";function w(t){return t===u||t===c}function b(t){return t===u}function f(t){return t>=C&&t<=R||t>=k&&t<=j}function h(t,r,s,i){let o="",l=0,$=-1,P=0,D=0;for(let I=0;I<=t.length;++I){if(I<t.length)D=t.charCodeAt(I);else{if(i(D))break;D=u}if(i(D)){if(!($===I-1||P===1))if(P===2){if(o.length<2||l!==2||o.charCodeAt(o.length-1)!==E||o.charCodeAt(o.length-2)!==E){if(o.length>2){const O=o.lastIndexOf(s);O===-1?(o="",l=0):(o=o.slice(0,O),l=o.length-1-o.lastIndexOf(s)),$=I,P=0;continue}else if(o.length!==0){o="",l=0,$=I,P=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",l=2)}else o.length>0?o+=`${s}${t.slice($+1,I)}`:o=t.slice($+1,I),l=I-$-1;$=I,P=0}else D===E&&P!==-1?++P:P=-1}return o}function S(t,r){m(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.$fc={resolve(...t){let r="",s="",i=!1;for(let o=t.length-1;o>=-1;o--){let l;if(o>=0){if(l=t[o],d(l,"path"),l.length===0)continue}else r.length===0?l=n.cwd():(l=n.env[`=${r}`]||n.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===c)&&(l=`${r}\\`));const $=l.length;let P=0,D="",I=!1;const O=l.charCodeAt(0);if($===1)w(O)&&(P=1,I=!0);else if(w(O))if(I=!0,w(l.charCodeAt(1))){let M=2,W=M;for(;M<$&&!w(l.charCodeAt(M));)M++;if(M<$&&M!==W){const F=l.slice(W,M);for(W=M;M<$&&w(l.charCodeAt(M));)M++;if(M<$&&M!==W){for(W=M;M<$&&!w(l.charCodeAt(M));)M++;(M===$||M!==W)&&(D=`\\\\${F}\\${l.slice(W,M)}`,P=M)}}}else P=1;else f(O)&&l.charCodeAt(1)===g&&(D=l.slice(0,2),P=2,$>2&&w(l.charCodeAt(2))&&(I=!0,P=3));if(D.length>0)if(r.length>0){if(D.toLowerCase()!==r.toLowerCase())continue}else r=D;if(i){if(r.length>0)break}else if(s=`${l.slice(P)}\\${s}`,i=I,I&&r.length>0)break}return s=h(s,!i,"\\",w),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){d(t,"path");const r=t.length;if(r===0)return".";let s=0,i,o=!1;const l=t.charCodeAt(0);if(r===1)return b(l)?"\\":t;if(w(l))if(o=!0,w(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!w(t.charCodeAt(P));)P++;if(P<r&&P!==D){const I=t.slice(D,P);for(D=P;P<r&&w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!w(t.charCodeAt(P));)P++;if(P===r)return`\\\\${I}\\${t.slice(D)}\\`;P!==D&&(i=`\\\\${I}\\${t.slice(D,P)}`,s=P)}}}else s=1;else f(l)&&t.charCodeAt(1)===g&&(i=t.slice(0,2),s=2,r>2&&w(t.charCodeAt(2))&&(o=!0,s=3));let $=s<r?h(t.slice(s),!o,"\\",w):"";return $.length===0&&!o&&($="."),$.length>0&&w(t.charCodeAt(r-1))&&($+="\\"),i===void 0?o?`\\${$}`:$:o?`${i}\\${$}`:`${i}${$}`},isAbsolute(t){d(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return w(s)||r>2&&f(s)&&t.charCodeAt(1)===g&&w(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let l=0;l<t.length;++l){const $=t[l];d($,"path"),$.length>0&&(r===void 0?r=s=$:r+=`\\${$}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof s=="string"&&w(s.charCodeAt(0))){++o;const l=s.length;l>1&&w(s.charCodeAt(1))&&(++o,l>2&&(w(s.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&w(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.$fc.normalize(r)},relative(t,r){if(d(t,"from"),d(r,"to"),t===r)return"";const s=e.$fc.resolve(t),i=e.$fc.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===c;)o++;let l=t.length;for(;l-1>o&&t.charCodeAt(l-1)===c;)l--;const $=l-o;let P=0;for(;P<r.length&&r.charCodeAt(P)===c;)P++;let D=r.length;for(;D-1>P&&r.charCodeAt(D-1)===c;)D--;const I=D-P,O=$<I?$:I;let M=-1,W=0;for(;W<O;W++){const T=t.charCodeAt(o+W);if(T!==r.charCodeAt(P+W))break;T===c&&(M=W)}if(W!==O){if(M===-1)return i}else{if(I>O){if(r.charCodeAt(P+W)===c)return i.slice(P+W+1);if(W===2)return i.slice(P+W)}$>O&&(t.charCodeAt(o+W)===c?M=W:W===2&&(M=3)),M===-1&&(M=0)}let F="";for(W=o+M+1;W<=l;++W)(W===l||t.charCodeAt(W)===c)&&(F+=F.length===0?"..":"\\..");return P+=M,F.length>0?`${F}${i.slice(P,D)}`:(i.charCodeAt(P)===c&&++P,i.slice(P,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===c){if(r.charCodeAt(1)===c){const s=r.charCodeAt(2);if(s!==p&&s!==E)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(f(r.charCodeAt(0))&&r.charCodeAt(1)===g&&r.charCodeAt(2)===c)return`\\\\?\\${r}`;return t},dirname(t){d(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const o=t.charCodeAt(0);if(r===1)return w(o)?t:".";if(w(o)){if(s=i=1,w(t.charCodeAt(1))){let P=2,D=P;for(;P<r&&!w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&w(t.charCodeAt(P));)P++;if(P<r&&P!==D){for(D=P;P<r&&!w(t.charCodeAt(P));)P++;if(P===r)return t;P!==D&&(s=i=P+1)}}}}else f(o)&&t.charCodeAt(1)===g&&(s=r>2&&w(t.charCodeAt(2))?3:2,i=s);let l=-1,$=!0;for(let P=r-1;P>=i;--P)if(w(t.charCodeAt(P))){if(!$){l=P;break}}else $=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,r){r!==void 0&&d(r,"ext"),d(t,"path");let s=0,i=-1,o=!0,l;if(t.length>=2&&f(t.charCodeAt(0))&&t.charCodeAt(1)===g&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let $=r.length-1,P=-1;for(l=t.length-1;l>=s;--l){const D=t.charCodeAt(l);if(w(D)){if(!o){s=l+1;break}}else P===-1&&(o=!1,P=l+1),$>=0&&(D===r.charCodeAt($)?--$===-1&&(i=l):($=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=s;--l)if(w(t.charCodeAt(l))){if(!o){s=l+1;break}}else i===-1&&(o=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){d(t,"path");let r=0,s=-1,i=0,o=-1,l=!0,$=0;t.length>=2&&t.charCodeAt(1)===g&&f(t.charCodeAt(0))&&(r=i=2);for(let P=t.length-1;P>=r;--P){const D=t.charCodeAt(P);if(w(D)){if(!l){i=P+1;break}continue}o===-1&&(l=!1,o=P+1),D===E?s===-1?s=P:$!==1&&($=1):s!==-1&&($=-1)}return s===-1||o===-1||$===0||$===1&&s===o-1&&s===i+1?"":t.slice(s,o)},format:S.bind(null,"\\"),parse(t){d(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,o=t.charCodeAt(0);if(s===1)return w(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(w(o)){if(i=1,w(t.charCodeAt(1))){let M=2,W=M;for(;M<s&&!w(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&w(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&!w(t.charCodeAt(M));)M++;M===s?i=M:M!==W&&(i=M+1)}}}}else if(f(o)&&t.charCodeAt(1)===g){if(s<=2)return r.root=r.dir=t,r;if(i=2,w(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let l=-1,$=i,P=-1,D=!0,I=t.length-1,O=0;for(;I>=i;--I){if(o=t.charCodeAt(I),w(o)){if(!D){$=I+1;break}continue}P===-1&&(D=!1,P=I+1),o===E?l===-1?l=I:O!==1&&(O=1):l!==-1&&(O=-1)}return P!==-1&&(l===-1||O===0||O===1&&l===P-1&&l===$+1?r.base=r.name=t.slice($,P):(r.name=t.slice($,l),r.base=t.slice($,P),r.ext=t.slice(l,P))),$>0&&$!==i?r.dir=t.slice(0,$-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const r=n.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>n.cwd()})();e.$gc={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const o=i>=0?t[i]:a();d(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===u)}return r=h(r,!s,"/",b),s?`/${r}`:r.length>0?r:"."},normalize(t){if(d(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===u,s=t.charCodeAt(t.length-1)===u;return t=h(t,!r,"/",b),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return d(t,"path"),t.length>0&&t.charCodeAt(0)===u},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];d(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(d(t,"from"),d(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const s=1,i=t.length,o=i-s,l=1,$=r.length-l,P=o<$?o:$;let D=-1,I=0;for(;I<P;I++){const M=t.charCodeAt(s+I);if(M!==r.charCodeAt(l+I))break;M===u&&(D=I)}if(I===P)if($>P){if(r.charCodeAt(l+I)===u)return r.slice(l+I+1);if(I===0)return r.slice(l+I)}else o>P&&(t.charCodeAt(s+I)===u?D=I:I===0&&(D=0));let O="";for(I=s+D+1;I<=i;++I)(I===i||t.charCodeAt(I)===u)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(l+D)}`},toNamespacedPath(t){return t},dirname(t){if(d(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===u;let s=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===u){if(!i){s=o;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&d(r,"ext"),d(t,"path");let s=0,i=-1,o=!0,l;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let $=r.length-1,P=-1;for(l=t.length-1;l>=0;--l){const D=t.charCodeAt(l);if(D===u){if(!o){s=l+1;break}}else P===-1&&(o=!1,P=l+1),$>=0&&(D===r.charCodeAt($)?--$===-1&&(i=l):($=-1,i=P))}return s===i?i=P:i===-1&&(i=t.length),t.slice(s,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===u){if(!o){s=l+1;break}}else i===-1&&(o=!1,i=l+1);return i===-1?"":t.slice(s,i)},extname(t){d(t,"path");let r=-1,s=0,i=-1,o=!0,l=0;for(let $=t.length-1;$>=0;--$){const P=t.charCodeAt($);if(P===u){if(!o){s=$+1;break}continue}i===-1&&(o=!1,i=$+1),P===E?r===-1?r=$:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||i===-1||l===0||l===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:S.bind(null,"/"),parse(t){d(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===u;let i;s?(r.root="/",i=1):i=0;let o=-1,l=0,$=-1,P=!0,D=t.length-1,I=0;for(;D>=i;--D){const O=t.charCodeAt(D);if(O===u){if(!P){l=D+1;break}continue}$===-1&&(P=!1,$=D+1),O===E?o===-1?o=D:I!==1&&(I=1):o!==-1&&(I=-1)}if($!==-1){const O=l===0&&s?1:l;o===-1||I===0||I===1&&o===$-1&&o===l+1?r.base=r.name=t.slice(O,$):(r.name=t.slice(O,o),r.base=t.slice(O,$),r.ext=t.slice(o,$))}return l>0?r.dir=t.slice(0,l-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=y?e.$fc.normalize:e.$gc.normalize,e.$ic=y?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=y?e.$fc.join:e.$gc.join,e.$kc=y?e.$fc.resolve:e.$gc.resolve,e.$lc=y?e.$fc.relative:e.$gc.relative,e.$mc=y?e.$fc.dirname:e.$gc.dirname,e.$nc=y?e.$fc.basename:e.$gc.basename,e.$oc=y?e.$fc.extname:e.$gc.extname,e.$pc=y?e.$fc.format:e.$gc.format,e.$qc=y?e.$fc.parse:e.$gc.parse,e.$rc=y?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=y?e.$fc.sep:e.$gc.sep,e.$tc=y?e.$fc.delimiter:e.$gc.delimiter}),define(se[31],re([0,1,9,4,25,12]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=j,e.$rg=E,e.$sg=u,e.$tg=c,e.$ug=g,e.$vg=d,e.$wg=y,e.$xg=w,e.$yg=b,e.$zg=f,e.$Ag=h,e.$Bg=S,e.$Cg=a,e.$Dg=t,e.$Eg=r,e.$Fg=s,e.$Gg=l;function j($){return $===47||$===92}function E($){return $.replace(/[\\/]/g,n.$gc.sep)}function u($){return $.indexOf("/")===-1&&($=E($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function c($,P=n.$gc.sep){if(!$)return"";const D=$.length,I=$.charCodeAt(0);if(j(I)){if(j($.charCodeAt(1))&&!j($.charCodeAt(2))){let M=3;const W=M;for(;M<D&&!j($.charCodeAt(M));M++);if(W!==M&&!j($.charCodeAt(M+1))){for(M+=1;M<D;M++)if(j($.charCodeAt(M)))return $.slice(0,M+1).replace(/[\\/]/g,P)}}return P}else if(b(I)&&$.charCodeAt(1)===58)return j($.charCodeAt(2))?$.slice(0,2)+P:$.slice(0,2);let O=$.indexOf("://");if(O!==-1){for(O+=3;O<D;O++)if(j($.charCodeAt(O)))return $.slice(0,O+1)}return""}function g($){if(!C.$i||!$||$.length<5)return!1;let P=$.charCodeAt(0);if(P!==92||(P=$.charCodeAt(1),P!==92))return!1;let D=2;const I=D;for(;D<$.length&&(P=$.charCodeAt(D),P!==92);D++);return!(I===D||(P=$.charCodeAt(D+1),isNaN(P)||P===92))}const p=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d($,P=C.$i){const D=P?p:v;return!(!$||$.length===0||/^\s+$/.test($)||(D.lastIndex=0,D.test($))||P&&m.test($)||$==="."||$===".."||P&&$[$.length-1]==="."||P&&$.length!==$.trim().length||$.length>255)}function y($,P,D){const I=$===P;return!D||I?I:!$||!P?!1:(0,k.$zf)($,P)}function w($,P,D,I=n.sep){if($===P)return!0;if(!$||!P||P.length>$.length)return!1;if(D){if(!(0,k.$Af)($,P))return!1;if(P.length===$.length)return!0;let M=P.length;return P.charAt(P.length-1)===I&&M--,$.charAt(M)===I}return P.charAt(P.length-1)!==I&&(P+=I),$.indexOf(P)===0}function b($){return $>=65&&$<=90||$>=97&&$<=122}function f($,P){return C.$i&&$.endsWith(":")&&($+=n.sep),(0,n.$ic)($)||($=(0,n.$jc)(P,$)),$=(0,n.$hc)($),h($)}function h($){return C.$i?($=(0,k.$hf)($,n.sep),$.endsWith(":")&&($+=n.sep)):($=(0,k.$hf)($,n.sep),$||($=n.sep)),$}function S($){const P=(0,n.$hc)($);return C.$i?$.length>3?!1:a(P)&&($.length===2||P.charCodeAt(2)===92):P===n.$gc.sep}function a($,P=C.$i){return P?b($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function t($,P=C.$i){return a($,P)?$[0]:void 0}function r($,P,D){return P.length>$.length?-1:$===P?0:(D&&($=$.toLowerCase(),P=P.toLowerCase()),$.indexOf(P))}function s($){const P=$.split(":");let D,I,O;for(const M of P){const W=Number(M);(0,R.$cg)(W)?I===void 0?I=W:O===void 0&&(O=W):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:O!==void 0?O:I!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l($,P,D=8){let I="";for(let M=0;M<D;M++){let W;M===0&&C.$i&&!P&&(D===3||D===4)?W=o:W=i,I+=W.charAt(Math.floor(Math.random()*W.length))}let O;return P?O=`${P}-${I}`:O=I,$?(0,n.$jc)($,O):O}}),define(se[76],re([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=R,e.$pm=j;var C;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(C||(e.Source=C={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function R(E,...u){const c=u.reduce((v,m)=>(v[m]=!0,v),{}),g=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(v=>!c[v]).forEach(v=>{for(let m=0;m<g.length;m++)if(v.search(g[m])!==-1){delete E[v];break}})}function j(E){E&&(delete E.DEBUG,n.$j&&delete E.DYLD_LIBRARY_PATH,n.$k&&delete E.LD_PRELOAD)}}),define(se[7],re([0,1,9,4]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=d,e.$wc=S;const k=/^\w[\w\d+.-]*$/,R=/^\//,j=/^\/\//;function E(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!k.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function u(i,o){return!i&&!o?"file":i}function c(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==p&&(o=p+o):o=p;break}return o}const g="",p="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,l,$,P,D,I=!1){typeof o=="object"?(this.scheme=o.scheme||g,this.authority=o.authority||g,this.path=o.path||g,this.query=o.query||g,this.fragment=o.fragment||g):(this.scheme=u(o,I),this.authority=l||g,this.path=c(this.scheme,$||g),this.query=P||g,this.fragment=D||g,E(this,I))}get fsPath(){return S(this,!1)}with(o){if(!o)return this;let{scheme:l,authority:$,path:P,query:D,fragment:I}=o;return l===void 0?l=this.scheme:l===null&&(l=g),$===void 0?$=this.authority:$===null&&($=g),P===void 0?P=this.path:P===null&&(P=g),D===void 0?D=this.query:D===null&&(D=g),I===void 0?I=this.fragment:I===null&&(I=g),l===this.scheme&&$===this.authority&&P===this.path&&D===this.query&&I===this.fragment?this:new w(l,$,P,D,I)}static parse(o,l=!1){const $=v.exec(o);return $?new w($[2]||g,s($[4]||g),s($[5]||g),s($[7]||g),s($[9]||g),l):new w(g,g,g,g,g)}static file(o){let l=g;if(C.$i&&(o=o.replace(/\\/g,p)),o[0]===p&&o[1]===p){const $=o.indexOf(p,2);$===-1?(l=o.substring(2),o=p):(l=o.substring(2,$),o=o.substring($)||p)}return new w("file",l,o,g,g)}static from(o,l){return new w(o.scheme,o.authority,o.path,o.query,o.fragment,l)}static joinPath(o,...l){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return C.$i&&o.scheme==="file"?$=m.file(n.$fc.join(S(o,!0),...l)).path:$=n.$gc.join(o.path,...l),o.with({path:$})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const l=new w(o);return l._formatted=o.external??null,l._fsPath=o._sep===y?o.fsPath??null:null,l}}else return o}}e.URI=m;function d(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const y=C.$i?1:void 0;class w extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=S(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=y),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const b={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(i,o,l){let $,P=-1;for(let D=0;D<i.length;D++){const I=i.charCodeAt(D);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||o&&I===47||l&&I===91||l&&I===93||l&&I===58)P!==-1&&($+=encodeURIComponent(i.substring(P,D)),P=-1),$!==void 0&&($+=i.charAt(D));else{$===void 0&&($=i.substr(0,D));const O=b[I];O!==void 0?(P!==-1&&($+=encodeURIComponent(i.substring(P,D)),P=-1),$+=O):P===-1&&(P=D)}}return P!==-1&&($+=encodeURIComponent(i.substring(P))),$!==void 0?$:i}function h(i){let o;for(let l=0;l<i.length;l++){const $=i.charCodeAt(l);$===35||$===63?(o===void 0&&(o=i.substr(0,l)),o+=b[$]):o!==void 0&&(o+=i[l])}return o!==void 0?o:i}function S(i,o){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,C.$i&&(l=l.replace(/\//g,"\\")),l}function a(i,o){const l=o?h:f;let $="",{scheme:P,authority:D,path:I,query:O,fragment:M}=i;if(P&&($+=P,$+=":"),(D||P==="file")&&($+=p,$+=p),D){let W=D.indexOf("@");if(W!==-1){const F=D.substr(0,W);D=D.substr(W+1),W=F.lastIndexOf(":"),W===-1?$+=l(F,!1,!1):($+=l(F.substr(0,W),!1,!1),$+=":",$+=l(F.substr(W+1),!1,!0)),$+="@"}D=D.toLowerCase(),W=D.lastIndexOf(":"),W===-1?$+=l(D,!1,!0):($+=l(D.substr(0,W),!1,!0),$+=D.substr(W))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const W=I.charCodeAt(1);W>=65&&W<=90&&(I=`/${String.fromCharCode(W+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const W=I.charCodeAt(0);W>=65&&W<=90&&(I=`${String.fromCharCode(W+32)}:${I.substr(2)}`)}$+=l(I,!0,!1)}return O&&($+="?",$+=l(O,!1,!1)),M&&($+="#",$+=o?M:f(M,!1,!1)),$}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,o=>t(o)):i}}),define(se[156],re([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=C,e.$1q=k,e.$2q=R,e.log=E;function C(c){const g=c;return g&&typeof g.type=="string"&&typeof g.severity=="string"}function k(c){const g=[];let p;try{const v=JSON.parse(c.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),p=m.__$stack),g.push(...v)}catch{g.push("Unable to log remote console arguments",c.arguments)}return{args:g,stack:p}}function R(c){if(typeof c!="string")return R(k(c).stack);const g=c;if(g){const p=j(g),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(v&&v.length===4)return{uri:n.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function j(c){if(!c)return c;const g=c.indexOf(`
`);return g===-1?c:c.substring(0,g)}function E(c,g){const{args:p,stack:v}=k(c),m=typeof p[0]=="string"&&p.length===1;let d=j(v);d&&(d=`(${d.trim()})`);let y=[];if(typeof p[0]=="string"?d&&m?y=[`%c[${g}] %c${p[0]} %c${d}`,u("blue"),u(""),u("grey")]:y=[`%c[${g}] %c${p[0]}`,u("blue"),u(""),...p.slice(1)]:y=[`%c[${g}]%`,u("blue"),...p],d&&!m&&y.push(d),typeof console[c.severity]!="function")throw new Error("Unknown console method");console[c.severity].apply(console,y)}function u(c){return`color: ${c}`}}),define(se[77],re([0,1,17,7]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=k,e.$7h=R,e.$8h=E;function k(u){return JSON.stringify(u,j)}function R(u){let c=JSON.parse(u);return c=E(c),c}function j(u,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:c.flags}:c}function E(u,c=0){if(!u||c>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return C.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof n.$He||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let g=0;g<u.length;++g)u[g]=E(u[g],c+1);else for(const g in u)Object.hasOwnProperty.call(u,g)&&(u[g]=E(u[g],c+1))}return u}}),define(se[13],re([0,1,15,4,25,7,9]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=u,e.$Ig=c,e.$Mg=p;var E;(function(d){d.inMemory="inmemory",d.vscode="vscode",d.internal="private",d.walkThrough="walkThrough",d.walkThroughSnippet="walkThroughSnippet",d.http="http",d.https="https",d.file="file",d.mailto="mailto",d.untitled="untitled",d.data="data",d.command="command",d.vscodeRemote="vscode-remote",d.vscodeRemoteResource="vscode-remote-resource",d.vscodeManagedRemoteResource="vscode-managed-remote-resource",d.vscodeUserData="vscode-userdata",d.vscodeCustomEditor="vscode-custom-editor",d.vscodeNotebookCell="vscode-notebook-cell",d.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",d.vscodeNotebookCellOutput="vscode-notebook-cell-output",d.vscodeInteractiveInput="vscode-interactive-input",d.vscodeSettings="vscode-settings",d.vscodeWorkspaceTrust="vscode-workspace-trust",d.vscodeTerminal="vscode-terminal",d.vscodeChatCodeBlock="vscode-chat-code-block",d.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",d.vscodeChatSesssion="vscode-chat-editor",d.webviewPanel="webview-panel",d.vscodeWebview="vscode-webview",d.extension="extension",d.vscodeFileResource="vscode-file",d.tmp="tmp",d.vsls="vsls",d.vscodeSourceControl="vscode-scm",d.commentsInput="comment",d.codeSetting="code-setting"})(E||(e.Schemas=E={}));function u(d,y){return R.URI.isUri(d)?(0,k.$zf)(d.scheme,y):(0,k.$Af)(d,y+":")}function c(d,...y){return y.some(w=>u(d,w))}e.$Jg="vscode-tkn",e.$Kg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y,w){this.f=p(y,w)}getServerRootPath(){return this.f}get g(){return j.$gc.join(this.f,E.vscodeRemoteResource)}set(y,w,b){this.a[y]=w,this.b[y]=b}setConnectionToken(y,w){this.c[y]=w}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(a){return n.$1(a),y}const w=y.authority;let b=this.a[w];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const f=this.b[w],h=this.c[w];let S=`path=${encodeURIComponent(y.path)}`;return typeof h=="string"&&(S+=`&${e.$Kg}=${encodeURIComponent(h)}`),R.URI.from({scheme:C.$o?this.d:E.vscodeRemoteResource,authority:`${b}:${f}`,path:this.g,query:S})}}e.$Lg=new g;function p(d,y){return j.$gc.join(y??"/",`${d.quality??"oss"}-${d.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class v{static{this.a=e.$Rg}asBrowserUri(y){const w=this.b(y,K);return this.uriToBrowserUri(w)}uriToBrowserUri(y){return y.scheme===E.vscodeRemote?e.$Lg.rewrite(y):y.scheme===E.file&&(C.$m||C.$q===`${E.vscodeFileResource}://${v.a}`)?y.with({scheme:E.vscodeFileResource,authority:y.authority||v.a,query:null,fragment:null}):y}asFileUri(y){const w=this.b(y,K);return this.uriToFileUri(w)}uriToFileUri(y){return y.scheme===E.vscodeFileResource?y.with({scheme:E.file,authority:y.authority!==v.a?y.authority:null,query:null,fragment:null}):y}b(y,w){return R.URI.isUri(y)?y:R.URI.parse(w.toUrl(y))}}e.$Sg=new v;var m;(function(d){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);d.CoopAndCoep=Object.freeze(y.get("3"));const w="vscode-coi";function b(h){let S;typeof h=="string"?S=new URL(h).searchParams:h instanceof URL?S=h.searchParams:R.URI.isUri(h)&&(S=new URL(h.toString(!0)).searchParams);const a=S?.get(w);if(a)return y.get(a)}d.getHeadersFromQuery=b;function f(h,S,a){if(!globalThis.crossOriginIsolated)return;const t=S&&a?"3":a?"2":"1";h instanceof URLSearchParams?h.set(w,t):h[w]=t}d.addSearchParam=f})(m||(e.COI=m={}))}),define(se[19],re([0,1,31,13,9,4,25,7]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=u,e.$ih=g,e.$jh=v;function u(m){return(0,E.$wc)(m,!0)}class c{constructor(d){this.a=d}compare(d,y,w=!1){return d===y?0:(0,j.$sf)(this.getComparisonKey(d,w),this.getComparisonKey(y,w))}isEqual(d,y,w=!1){return d===y?!0:!d||!y?!1:this.getComparisonKey(d,w)===this.getComparisonKey(y,w)}getComparisonKey(d,y=!1){return d.with({path:this.a(d)?d.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(d){return this.a(d)}isEqualOrParent(d,y,w=!1){if(d.scheme===y.scheme){if(d.scheme===C.Schemas.file)return n.$xg(u(d),u(y),this.a(d))&&d.query===y.query&&(w||d.fragment===y.fragment);if((0,e.$eh)(d.authority,y.authority))return n.$xg(d.path,y.path,this.a(d),"/")&&d.query===y.query&&(w||d.fragment===y.fragment)}return!1}joinPath(d,...y){return E.URI.joinPath(d,...y)}basenameOrAuthority(d){return(0,e.$9g)(d)||d.authority}basename(d){return k.$gc.basename(d.path)}extname(d){return k.$gc.extname(d.path)}dirname(d){if(d.path.length===0)return d;let y;return d.scheme===C.Schemas.file?y=E.URI.file(k.$mc(u(d))).path:(y=k.$gc.dirname(d.path),d.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),y="/")),d.with({path:y})}normalizePath(d){if(!d.path.length)return d;let y;return d.scheme===C.Schemas.file?y=E.URI.file(k.$hc(u(d))).path:y=k.$gc.normalize(d.path),d.with({path:y})}relativePath(d,y){if(d.scheme!==y.scheme||!(0,e.$eh)(d.authority,y.authority))return;if(d.scheme===C.Schemas.file){const f=k.$lc(u(d),u(y));return R.$i?n.$rg(f):f}let w=d.path||"/";const b=y.path||"/";if(this.a(d)){let f=0;for(const h=Math.min(w.length,b.length);f<h&&!(w.charCodeAt(f)!==b.charCodeAt(f)&&w.charAt(f).toLowerCase()!==b.charAt(f).toLowerCase());f++);w=b.substr(0,f)+w.substr(f)}return k.$gc.relative(w,b)}resolvePath(d,y){if(d.scheme===C.Schemas.file){const w=E.URI.file(k.$kc(u(d),y));return d.with({authority:w.authority,path:w.path})}return y=n.$sg(y),d.with({path:k.$gc.resolve(d.path,y)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,y){return d===y||d!==void 0&&y!==void 0&&(0,j.$zf)(d,y)}hasTrailingPathSeparator(d,y=k.sep){if(d.scheme===C.Schemas.file){const w=u(d);return w.length>n.$tg(w).length&&w[w.length-1]===y}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,y=k.sep){return(0,e.$fh)(d,y)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,y=k.sep){let w=!1;if(d.scheme===C.Schemas.file){const b=u(d);w=b!==void 0&&b.length===n.$tg(b).length&&b[b.length-1]===y}else{y="/";const b=d.path;w=b.length===1&&b.charCodeAt(b.length-1)===47}return!w&&!(0,e.$fh)(d,y)?d.with({path:d.path+"/"}):d}}e.$1g=c,e.$2g=new c(()=>!1),e.$3g=new c(m=>m.scheme===C.Schemas.file?!R.$k:!0),e.$4g=new c(m=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function g(m,d){const y=[];for(let w=0;w<m.length;w++){const b=d(m[w]);m.some((f,h)=>h===w?!1:(0,e.$6g)(b,d(f)))||y.push(m[w])}return y}var p;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function d(y){const w=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(h=>{const[S,a]=h.split(":");S&&a&&w.set(S,a)});const f=y.path.substring(0,y.path.indexOf(";"));return f&&w.set(m.META_DATA_MIME,f),w}m.parseMetaData=d})(p||(e.DataUri=p={}));function v(m,d,y){if(d){let w=m.path;return w&&w[0]!==k.$gc.sep&&(w=k.$gc.sep+w),m.with({scheme:y,authority:d,path:w})}return m.with({scheme:y})}}),define(se[8],re([0,1,23,15,3,2,19,4,144,62]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=g,e.$lh=p,e.$mh=v,e.$nh=m,e.$oh=d,e.$ph=y,e.$qh=w,e.$rh=b,e.$zh=l,e.$Ah=$,e.$Bh=P,e.$Ch=D,e.$Dh=I,e.$Sh=L,e.$1h=Y;function g(ee){return!!ee&&typeof ee.then=="function"}function p(ee){const X=new n.$qe,ue=ee(X.token),he=new Promise((pe,$e)=>{const ye=X.token.onCancellationRequested(()=>{ye.dispose(),$e(new C.$5)});Promise.resolve(ue).then(Se=>{ye.dispose(),X.dispose(),pe(Se)},Se=>{ye.dispose(),X.dispose(),$e(Se)})});return new class{cancel(){X.cancel(),X.dispose()}then(pe,$e){return he.then(pe,$e)}catch(pe){return this.then(void 0,pe)}finally(pe){return he.finally(pe)}}}function v(ee,X,ue){return new Promise((he,pe)=>{const $e=X.onCancellationRequested(()=>{$e.dispose(),he(ue)});ee.then(he,pe).finally(()=>$e.dispose())})}function m(ee,X){return new Promise((ue,he)=>{const pe=X.onCancellationRequested(()=>{pe.dispose(),he(new C.$5)});ee.then(ue,he).finally(()=>pe.dispose())})}async function d(ee){let X=-1;const ue=ee.map((he,pe)=>he.then($e=>(X=pe,$e)));try{return await Promise.race(ue)}finally{ee.forEach((he,pe)=>{pe!==X&&he.cancel()})}}function y(ee,X,ue){let he;const pe=setTimeout(()=>{he?.(void 0),ue?.()},X);return Promise.race([ee.finally(()=>clearTimeout(pe)),new Promise($e=>he=$e)])}function w(ee){return new Promise((X,ue)=>{const he=ee();g(he)?he.then(X,ue):X(he)})}function b(){let ee,X;return{promise:new Promise((he,pe)=>{ee=he,X=pe}),resolve:ee,reject:X}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(X){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=X,!this.b){const ue=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(ue,ue).then(he)})}return new Promise((ue,he)=>{this.b.then(ue,he)})}return this.a=X(),new Promise((ue,he)=>{this.a.then(pe=>{this.a=null,ue(pe)},pe=>{this.a=null,he(pe)})})}dispose(){this.f=!0}}e.$sh=f;class h{constructor(){this.a=Promise.resolve(null)}queue(X){return this.a=this.a.then(()=>X(),()=>X())}}e.$th=h;class S{constructor(){this.a=new Map}queue(X,ue){const pe=(this.a.get(X)??Promise.resolve()).catch(()=>{}).then(ue).finally(()=>{this.a.get(X)===pe&&this.a.delete(X)});return this.a.set(X,pe),pe}}e.$uh=S;const a=(ee,X)=>{let ue=!0;const he=setTimeout(()=>{ue=!1,X()},ee);return{isTriggered:()=>ue,dispose:()=>{clearTimeout(he),ue=!1}}},t=ee=>{let X=!0;return queueMicrotask(()=>{X&&(X=!1,ee())}),{isTriggered:()=>X,dispose:()=>{X=!1}}};class r{constructor(X){this.defaultDelay=X,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(X,ue=this.defaultDelay){this.g=X,this.h(),this.b||(this.b=new Promise((pe,$e)=>{this.d=pe,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=ue===u.$ce?t(he):a(ue,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=r;class s{constructor(X){this.a=new r(X),this.b=new f}trigger(X,ue){return this.a.trigger(()=>this.b.queue(X),ue)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=s;class i{constructor(){this.a=!1,this.b=new Promise((X,ue)=>{this.d=X})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=i;class o extends i{constructor(X){super(),this.f=setTimeout(()=>this.open(),X)}open(){clearTimeout(this.f),super.open()}}e.$yh=o;function l(ee,X){return X?new Promise((ue,he)=>{const pe=setTimeout(()=>{$e.dispose(),ue()},ee),$e=X.onCancellationRequested(()=>{clearTimeout(pe),$e.dispose(),he(new C.$5)})}):p(ue=>l(ee,ue))}function $(ee,X=0,ue){const he=setTimeout(()=>{ee(),ue&&pe.dispose()},X),pe=(0,R.$Sc)(()=>{clearTimeout(he),ue?.deleteAndLeak(pe)});return ue?.add(pe),pe}function P(ee){const X=[];let ue=0;const he=ee.length;function pe(){return ue<he?ee[ue++]():null}function $e(ye){ye!=null&&X.push(ye);const Se=pe();return Se?Se.then($e):Promise.resolve(X)}return Promise.resolve(null).then($e)}function D(ee,X=he=>!!he,ue=null){let he=0;const pe=ee.length,$e=()=>{if(he>=pe)return Promise.resolve(ue);const ye=ee[he++];return Promise.resolve(ye()).then(ke=>X(ke)?Promise.resolve(ke):$e())};return $e()}function I(ee,X=he=>!!he,ue=null){if(ee.length===0)return Promise.resolve(ue);let he=ee.length;const pe=()=>{he=-1;for(const $e of ee)$e.cancel?.()};return new Promise(($e,ye)=>{for(const Se of ee)Se.then(ke=>{--he>=0&&X(ke)?(pe(),$e(ke)):he===0&&$e(ue)}).catch(ke=>{--he>=0&&(pe(),ye(ke))})})}class O{constructor(X){this.a=0,this.b=!1,this.f=X,this.g=[],this.d=0,this.h=new k.$fe}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(X){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((ue,he)=>{this.g.push({factory:X,c:ue,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const X=this.g.shift();this.d++;const ue=X.factory();ue.then(X.c,X.e),ue.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=O;class M extends O{constructor(){super(1)}}e.$Fh=M;class W{constructor(){this.a=new B,this.b=0}queue(X){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,X())):this.a.run(this.b++,X())}}e.$Gh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const X=new G;return this.b.add(X),X.p}g(){for(const[,X]of this.a)if(X.size>0)return!1;return!0}queueSize(X,ue=j.$2g){const he=ue.getComparisonKey(X);return this.a.get(he)?.size??0}queueFor(X,ue,he=j.$2g){const pe=he.getComparisonKey(X);let $e=this.a.get(pe);if(!$e){$e=new M;const ye=this.f++,Se=k.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(pe),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$4c),this.d.set(ye,Se),this.a.set(pe,$e)}return $e.queue(ue)}h(){this.g()&&this.j()}j(){for(const X of this.b)X.complete();this.b.clear()}dispose(){for(const[,X]of this.a)X.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=F;class T{constructor(X,ue){this.a=-1,typeof X=="function"&&typeof ue=="number"&&this.setIfNotSet(X,ue)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(X,ue){this.cancel(),this.a=setTimeout(()=>{this.a=-1,X()},ue)}setIfNotSet(X,ue){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,X()},ue))}}e.$Ih=T;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(X,ue,he=globalThis){this.cancel();const pe=he.setInterval(()=>{X()},ue);this.d=(0,R.$Sc)(()=>{he.clearInterval(pe),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=U;class ae{constructor(X,ue){this.b=-1,this.a=X,this.d=ue,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(X=this.d){this.cancel(),this.b=setTimeout(this.f,X)}get delay(){return this.d}set delay(X){this.d=X}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=ae;class te{constructor(X,ue){ue%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ue}ms is not a multiple of 1000ms.`),this.a=X,this.b=ue,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(X=this.b){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(X/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=te;class ce extends ae{constructor(X,ue){super(X,ue),this.j=[]}work(X){this.j.push(X),this.isScheduled()||this.schedule()}h(){const X=this.j;this.j=[],this.a?.(X)}dispose(){this.j=[],super.dispose()}}e.$Mh=ce;class J extends R.$Uc{constructor(X,ue){super(),this.g=X,this.h=ue,this.a=[],this.b=this.B(new R.$Vc),this.f=!1}get pending(){return this.a.length}work(X){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+X.length>this.g.maxBufferedWork)return!1}else if(this.pending+X.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const ue of X)this.a.push(ue);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ae(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(ee,X)=>{(0,E.$B)(()=>{if(ue)return;const he=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let ue=!1;return{dispose(){ue||(ue=!0)}}}:e.$Ph=(ee,X,ue)=>{const he=ee.requestIdleCallback(X,typeof ue=="number"?{timeout:ue}:void 0);let pe=!1;return{dispose(){pe||(pe=!0,ee.cancelIdleCallback(he))}}},e.$Oh=ee=>(0,e.$Ph)(globalThis,ee)}();class V{constructor(X,ue){this.g=!1,this.d=()=>{try{this.j=ue()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(X,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=V;class q extends V{constructor(X){super(globalThis,X)}}e.$Rh=q;async function L(ee,X,ue){let he;for(let pe=0;pe<ue;pe++)try{return await ee()}catch($e){he=$e,await l(X)}throw he}class B{isRunning(X){return typeof X=="number"?this.a?.taskId===X:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(X,ue,he){return this.a={taskId:X,cancel:()=>he?.(),promise:ue},ue.then(()=>this.d(X),()=>this.d(X)),ue}d(X){this.a&&X===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const X=this.b;this.b=void 0,X.run().then(X.promiseResolve,X.promiseReject)}}queue(X){if(this.b)this.b.run=X;else{const{promise:ue,resolve:he,reject:pe}=b();this.b={run:X,promise:ue,promiseResolve:he,promiseReject:pe}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=B;class H{constructor(X,ue=()=>Date.now()){this.d=X,this.f=ue,this.a=0,this.b=0}increment(){const X=this.f();return X-this.a>this.d&&(this.a=X,this.b=0),this.b++,this.b}}e.$Uh=H;var oe;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(oe||(oe={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((X,ue)=>{this.a=X,this.b=ue})}complete(X){return new Promise(ue=>{this.a(X),this.d={outcome:0,value:X},ue()})}error(X){return new Promise(ue=>{this.b(X),this.d={outcome:1,value:X},ue()})}cancel(){return this.error(new C.$5)}}e.$Vh=G;var le;(function(ee){async function X(he){let pe;const $e=await Promise.all(he.map(ye=>ye.then(Se=>Se,Se=>{pe||(pe=Se)})));if(typeof pe<"u")throw pe;return $e}ee.settled=X;function ue(he){return new Promise(async(pe,$e)=>{try{await he(pe,$e)}catch(ye){$e(ye)}})}ee.withAsyncBody=ue})(le||(e.Promises=le={}));class Q{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(X){this.a=void 0,this.b=void 0,this.d=!1,this.promise=X.then(ue=>(this.a=ue,this.d=!0,ue),ue=>{throw this.b=ue,this.d=!0,ue})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=Q;class A{constructor(X){this.b=X,this.a=new c.$V(()=>new Q(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=A;var N;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(X){return new _(ue=>{ue.emitMany(X)})}static fromPromise(X){return new _(async ue=>{ue.emitMany(await X)})}static fromPromises(X){return new _(async ue=>{await Promise.all(X.map(async he=>ue.emitOne(await he)))})}static merge(X){return new _(async ue=>{await Promise.all(X.map(async he=>{for await(const pe of he)ue.emitOne(pe)}))})}static{this.EMPTY=_.fromArray([])}constructor(X,ue){this.a=0,this.b=[],this.d=null,this.f=ue,this.g=new k.$fe,queueMicrotask(async()=>{const he={emitOne:pe=>this.h(pe),emitMany:pe=>this.j(pe),reject:pe=>this.l(pe)};try{await Promise.resolve(X(he)),this.k()}catch(pe){this.l(pe)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let X=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(X<this.b.length)return{done:!1,value:this.b[X++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(X,ue){return new _(async he=>{for await(const pe of X)he.emitOne(ue(pe))})}map(X){return _.map(this,X)}static filter(X,ue){return new _(async he=>{for await(const pe of X)ue(pe)&&he.emitOne(pe)})}filter(X){return _.filter(this,X)}static coalesce(X){return _.filter(X,ue=>!!ue)}coalesce(){return _.coalesce(this)}static async toPromise(X){const ue=[];for await(const he of X)ue.push(he);return ue}toPromise(){return _.toPromise(this)}h(X){this.a===0&&(this.b.push(X),this.g.fire())}j(X){this.a===0&&(this.b=this.b.concat(X),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(X){this.a===0&&(this.a=2,this.d=X,this.g.fire())}}e.$Yh=_;class z extends _{constructor(X,ue){super(ue),this.m=X}cancel(){this.m.cancel()}}e.$Zh=z;function Y(ee){const X=new n.$qe,ue=ee(X.token);return new z(X,async he=>{const pe=X.token.onCancellationRequested(()=>{pe.dispose(),X.dispose(),he.reject(new C.$5)});try{for await(const $e of ue){if(X.token.isCancellationRequested)return;he.emitOne($e)}pe.dispose(),X.dispose()}catch($e){pe.dispose(),X.dispose(),he.reject($e)}})}class x{constructor(X){this.a=new G,this.b=new _(pe=>{if(ue){pe.reject(ue);return}return he&&pe.emitMany(he),this.d=$e=>pe.reject($e),this.f=$e=>pe.emitOne($e),this.a.p},X);let ue,he;this.f=pe=>{he||(he=[]),he.push(pe)},this.d=pe=>{ue||(ue=pe)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(X){this.d(X),this.a.complete()}emitOne(X){this.f(X)}}e.$2h=x}),define(se[108],re([0,1,22,8,31,32,9,4,25]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=c,e.$qk=d,e.$rk=M,e.$sk=W,e.$tk=F,e.$uk=T,e.$vk=U,e.$wk=J;function c(){return Object.create(null)}e.$ok="**",e.$pk="/";const g="[/\\\\]",p="[^/\\\\]",v=/\//g;function m(V,q){switch(V){case 0:return"";case 1:return`${p}*?`;default:return`(?:${g}|${p}+${g}${q?`|${g}${p}+`:""})*?`}}function d(V,q){if(!V)return[];const L=[];let B=!1,H=!1,oe="";for(const G of V){switch(G){case q:if(!B&&!H){L.push(oe),oe="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":H=!0;break;case"]":H=!1;break}oe+=G}return oe&&L.push(oe),L}function y(V){if(!V)return"";let q="";const L=d(V,e.$pk);if(L.every(B=>B===e.$ok))q=".*";else{let B=!1;L.forEach((H,oe)=>{if(H===e.$ok){if(B)return;q+=m(2,oe===L.length-1)}else{let G=!1,le="",Q=!1,A="";for(const N of H){if(N!=="}"&&G){le+=N;continue}if(Q&&(N!=="]"||!A)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!A?_="^":N===e.$pk?_="":_=(0,u.$bf)(N),A+=_;continue}switch(N){case"{":G=!0;continue;case"[":Q=!0;continue;case"}":{const z=`(?:${d(le,",").map(Y=>y(Y)).join("|")})`;q+=z,G=!1,le="";break}case"]":{q+="["+A+"]",Q=!1,A="";break}case"?":q+=p;continue;case"*":q+=m(1);continue;default:q+=(0,u.$bf)(N)}}oe<L.length-1&&(L[oe+1]!==e.$ok||oe+2<L.length)&&(q+=g)}B=H===e.$ok})}return q}const w=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),r=function(){return!1},s=function(){return null};function i(V,q){if(!V)return s;let L;typeof V!="string"?L=V.pattern:L=V,L=L.trim();const B=`${L}_${!!q.trimForExclusions}`;let H=t.get(B);if(H)return o(H,V);let oe;return w.test(L)?H=$(L.substr(4),L):(oe=b.exec(l(L,q)))?H=P(oe[1],L):(q.trimForExclusions?h:f).test(L)?H=D(L,q):(oe=S.exec(l(L,q)))?H=I(oe[1].substr(1),L,!0):(oe=a.exec(l(L,q)))?H=I(oe[1],L,!1):H=O(L),t.set(B,H),o(H,V)}function o(V,q){if(typeof q=="string")return V;const L=function(B,H){return(0,k.$xg)(B,q.base,!E.$k)?V((0,u.$gf)(B.substr(q.base.length),j.sep),H):null};return L.allBasenames=V.allBasenames,L.allPaths=V.allPaths,L.basenames=V.basenames,L.patterns=V.patterns,L}function l(V,q){return q.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function $(V,q){return function(L,B){return typeof L=="string"&&L.endsWith(V)?q:null}}function P(V,q){const L=`/${V}`,B=`\\${V}`,H=function(G,le){return typeof G!="string"?null:le?le===V?q:null:G===V||G.endsWith(L)||G.endsWith(B)?q:null},oe=[V];return H.basenames=oe,H.patterns=[q],H.allBasenames=oe,H}function D(V,q){const L=ce(V.slice(1,-1).split(",").map(le=>i(le,q)).filter(le=>le!==s),V),B=L.length;if(!B)return s;if(B===1)return L[0];const H=function(le,Q){for(let A=0,N=L.length;A<N;A++)if(L[A](le,Q))return V;return null},oe=L.find(le=>!!le.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const G=L.reduce((le,Q)=>Q.allPaths?le.concat(Q.allPaths):le,[]);return G.length&&(H.allPaths=G),H}function I(V,q,L){const B=j.sep===j.$gc.sep,H=B?V:V.replace(v,j.sep),oe=j.sep+H,G=j.$gc.sep+V;let le;return L?le=function(Q,A){return typeof Q=="string"&&(Q===H||Q.endsWith(oe)||!B&&(Q===V||Q.endsWith(G)))?q:null}:le=function(Q,A){return typeof Q=="string"&&(Q===H||!B&&Q===V)?q:null},le.allPaths=[(L?"*/":"./")+V],le}function O(V){try{const q=new RegExp(`^${y(V)}$`);return function(L){return q.lastIndex=0,typeof L=="string"&&q.test(L)?V:null}}catch{return s}}function M(V,q,L){return!V||typeof q!="string"?!1:W(V)(q,void 0,L)}function W(V,q={}){if(!V)return r;if(typeof V=="string"||F(V)){const L=i(V,q);if(L===s)return r;const B=function(H,oe){return!!L(H,oe)};return L.allBasenames&&(B.allBasenames=L.allBasenames),L.allPaths&&(B.allPaths=L.allPaths),B}return ae(V,q)}function F(V){const q=V;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}function T(V){return V.allBasenames||[]}function U(V){return V.allPaths||[]}function ae(V,q){const L=ce(Object.getOwnPropertyNames(V).map(le=>te(le,V[le],q)).filter(le=>le!==s)),B=L.length;if(!B)return s;if(!L.some(le=>!!le.requiresSiblings)){if(B===1)return L[0];const le=function(N,_){let z;for(let Y=0,x=L.length;Y<x;Y++){const ee=L[Y](N,_);if(typeof ee=="string")return ee;(0,C.$kh)(ee)&&(z||(z=[]),z.push(ee))}return z?(async()=>{for(const Y of z){const x=await Y;if(typeof x=="string")return x}return null})():null},Q=L.find(N=>!!N.allBasenames);Q&&(le.allBasenames=Q.allBasenames);const A=L.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return A.length&&(le.allPaths=A),le}const H=function(le,Q,A){let N,_;for(let z=0,Y=L.length;z<Y;z++){const x=L[z];x.requiresSiblings&&A&&(Q||(Q=(0,j.$nc)(le)),N||(N=Q.substr(0,Q.length-(0,j.$oc)(le).length)));const ee=x(le,Q,N,A);if(typeof ee=="string")return ee;(0,C.$kh)(ee)&&(_||(_=[]),_.push(ee))}return _?(async()=>{for(const z of _){const Y=await z;if(typeof Y=="string")return Y}return null})():null},oe=L.find(le=>!!le.allBasenames);oe&&(H.allBasenames=oe.allBasenames);const G=L.reduce((le,Q)=>Q.allPaths?le.concat(Q.allPaths):le,[]);return G.length&&(H.allPaths=G),H}function te(V,q,L){if(q===!1)return s;const B=i(V,L);if(B===s)return s;if(typeof q=="boolean")return B;if(q){const H=q.when;if(typeof H=="string"){const oe=(G,le,Q,A)=>{if(!A||!B(G,le))return null;const N=H.replace("$(basename)",()=>Q),_=A(N);return(0,C.$kh)(_)?_.then(z=>z?V:null):_?V:null};return oe.requiresSiblings=!0,oe}}return B}function ce(V,q){const L=V.filter(le=>!!le.basenames);if(L.length<2)return V;const B=L.reduce((le,Q)=>{const A=Q.basenames;return A?le.concat(A):le},[]);let H;if(q){H=[];for(let le=0,Q=B.length;le<Q;le++)H.push(q)}else H=L.reduce((le,Q)=>{const A=Q.patterns;return A?le.concat(A):le},[]);const oe=function(le,Q){if(typeof le!="string")return null;if(!Q){let N;for(N=le.length;N>0;N--){const _=le.charCodeAt(N-1);if(_===47||_===92)break}Q=le.substr(N)}const A=B.indexOf(Q);return A!==-1?H[A]:null};oe.basenames=B,oe.patterns=H,oe.allBasenames=B;const G=V.filter(le=>!le.basenames);return G.push(oe),G}function J(V,q){return(0,n.$ub)(V,q,(L,B)=>typeof L=="string"&&typeof B=="string"?L===B:typeof L!="string"&&typeof B!="string"?L.base===B.base&&L.pattern===B.pattern:!1)}}),define(se[48],re([0,1,22,31,9,4,19,25]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hw=u,e.$Iw=g,e.$Jw=v,e.$Kw=m,e.$Lw=b,e.$Mw=h,e.$Nw=S,e.$Ow=a,e.$Pw=t,e.$Qw=r;function u(i,o){const{os:l,tildify:$,relative:P}=o;if(P){const O=c(i,P,l);if(typeof O=="string")return O}let D=i.fsPath;if(l===1&&!R.$i?D=D.replace(/\//g,"\\"):l!==1&&R.$i&&(D=D.replace(/\\/g,"/")),l!==1&&$?.userHome){const O=$.userHome.fsPath;let M;i.scheme!==$.userHome.scheme&&i.path[0]===k.$gc.sep&&i.path[1]!==k.$gc.sep?M=$.userHome.with({path:i.path}).fsPath:M=D,D=v(M,O,l)}return(l===1?k.$fc:k.$gc).normalize(g(D,l===1))}function c(i,o,l){const $=l===1?k.$fc:k.$gc,P=l===3?j.$2g:j.$4g,D=o.getWorkspace(),I=(0,n.$Ob)(D.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path[0]===k.$gc.sep&&i.path[1]!==k.$gc.sep&&(i=I.uri.with({path:i.path}));const O=o.getWorkspaceFolder(i);if(!O)return;let M;if(P.isEqual(O.uri,i)?M="":M=P.relativePath(O.uri,i)??"",M&&(M=$.normalize(M)),D.folders.length>1&&!o.noPrefix){const W=O.name?O.name:P.basenameOrAuthority(O.uri);M=M?`${W} \u2022 ${M}`:W}return M}function g(i,o=R.$i){return(0,C.$Cg)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}let p=Object.create(null);function v(i,o,l=R.OS){if(l===1||!i||!o)return i;let $=p.original===o?p.normalized:void 0;$||($=o,R.$i&&($=(0,C.$rg)($)),$=`${(0,E.$hf)($,k.$gc.sep)}${k.$gc.sep}`,p={original:o,normalized:$});let P=i;return R.$i&&(P=(0,C.$rg)(P)),(l===3?P.startsWith($):(0,E.$Af)(P,$))?`~/${P.substr($.length)}`:i}function m(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}const d="\u2026",y="\\\\",w="~";function b(i,o=k.sep){const l=new Array(i.length);let $=!1;for(let P=0;P<i.length;P++){const D=i[P];if(D===""){l[P]=`.${o}`;continue}if(!D){l[P]=D;continue}$=!0;let I="",O=D;O.indexOf(y)===0?(I=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(o)===0?(I=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length)):O.indexOf(w)===0&&(I=O.substr(0,O.indexOf(w)+w.length),O=O.substr(O.indexOf(w)+w.length));const M=O.split(o);for(let W=1;$&&W<=M.length;W++)for(let F=M.length-W;$&&F>=0;F--){$=!1;let T=M.slice(F,F+W).join(o);for(let U=0;!$&&U<i.length;U++)if(U!==P&&i[U]&&i[U].indexOf(T)>-1){const ae=F+W===M.length,te=F>0&&i[U].indexOf(o)>-1?o+T:T,ce=i[U].endsWith(te);$=!ae||ce}if(!$){let U="";(M[0].endsWith(":")||I!=="")&&(F===1&&(F=0,W++,T=M[0]+o+T),F>0&&(U=M[0]+o),U=I+U),F>0&&(U=U+d+o),U=U+T,F+W<M.length&&(U=U+o+d),l[P]=U}}$&&(l[P]=D)}return l}var f;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function h(i,o=Object.create(null)){const l=[];let $=!1,P="";for(const D of i)if(D==="$"||$&&D==="{")P&&l.push({value:P,type:f.TEXT}),P="",$=!0;else if(D==="}"&&$){const I=o[P];if(typeof I=="string")I.length&&l.push({value:I,type:f.VARIABLE});else if(I){const O=l[l.length-1];(!O||O.type!==f.SEPARATOR)&&l.push({value:I.label,type:f.SEPARATOR})}P="",$=!1}else P+=D;return P&&!$&&l.push({value:P,type:f.TEXT}),l.filter((D,I)=>{if(D.type===f.SEPARATOR){const O=l[I-1],M=l[I+1];return[O,M].every(W=>W&&(W.type===f.VARIABLE||W.type===f.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function S(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function a(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,""):R.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function r(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const l=s(i.substring(0,o)),$=i.substring(o);return{name:l.name+$,parentPath:l.parentPath}}}return s(i)}function s(i){const o=i.indexOf("/")!==-1?k.$gc:k.$fc,l=o.basename(i),$=o.dirname(i);return l.length?{name:l,parentPath:$}:{name:$,parentPath:""}}}),define(se[157],re([0,1,17,7]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=E,e.$Dn=c,e.$En=g;function k(p){return p.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const m=this.a.transformIncoming(v);return m===v?v:k(C.URI.from(m))}transformOutgoing(v){const m=this.a.transformOutgoing(v);return m===v?v:k(C.URI.from(m))}transformOutgoingURI(v){const m=this.a.transformOutgoing(v);return m===v?v:C.URI.from(m)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$An=R,e.$Bn=new class{transformIncoming(p){return p}transformOutgoing(p){return p}transformOutgoingURI(p){return p}transformOutgoingScheme(p){return p}};function j(p,v,m){if(!p||m>200)return null;if(typeof p=="object"){if(p instanceof C.URI)return v.transformOutgoing(p);for(const d in p)if(Object.hasOwnProperty.call(p,d)){const y=j(p[d],v,m+1);y!==null&&(p[d]=y)}}return null}function E(p,v){const m=j(p,v,0);return m===null?p:m}function u(p,v,m,d){if(!p||d>200)return null;if(typeof p=="object"){if(p.$mid===1)return m?C.URI.revive(v.transformIncoming(p)):v.transformIncoming(p);if(p instanceof n.$He)return null;for(const y in p)if(Object.hasOwnProperty.call(p,y)){const w=u(p[y],v,m,d+1);w!==null&&(p[y]=w)}}return null}function c(p,v){const m=u(p,v,!1,0);return m===null?p:m}function g(p,v){const m=u(p,v,!0,0);return m===null?p:m}}),define(se[89],re([0,1,26,59,33,147,4]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=u,e.$In=p,e.$Gn=new class{c(v){return this.a||(this.a=C.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,m=0;const d=(0,n.networkInterfaces)();for(const y in d){const w=d[y];if(w)for(const{mac:b,internal:f}of w)f||(m+=1,this.c(b.toUpperCase())&&(v+=1))}this.b=m>0?v/m:0}return this.b}};let E;async function u(v){return E||(E=(async()=>await c(v)||k.$Ug())()),E}async function c(v){try{const m=await new Promise((y,w)=>{K(["crypto"],y,w)}),d=(0,R.$Fn)();return m.createHash("sha256").update(d,"utf8").digest("hex")}catch(m){v(m);return}}const g="Software\\Microsoft\\SQMClient";async function p(v){if(j.$i){const m=await new Promise((d,y)=>{K(["@vscode/windows-registry"],d,y)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",g,"MachineId")||""}catch(d){return v(d),""}}return""}}),define(se[21],re([0,1,43,26,158,8,31,72,9,4,19,7]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=w,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=P;var v;(function(te){te[te.UNLINK=0]="UNLINK",te[te.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function m(te,ce=v.UNLINK,J){if((0,j.$Bg)(te))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?y(te):d(te,J)}async function d(te,ce=(0,j.$Gg)((0,C.tmpdir)())){try{try{await n.promises.rename(te,ce)}catch(J){return J.code==="ENOENT"?void 0:y(te)}y(ce).catch(J=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function y(te){return(0,k.promisify)(n.rm)(te,{recursive:!0,force:!0,maxRetries:3})}function w(te){if((0,j.$Bg)(te))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(te,{recursive:!0,force:!0,maxRetries:3})}async function b(te,ce){return S(await(ce?f(te):(0,k.promisify)(n.readdir)(te)))}async function f(te){try{return await(0,k.promisify)(n.readdir)(te,{withFileTypes:!0})}catch(V){console.warn("[node.js fs] readdir with filetypes failed with error: ",V)}const ce=[],J=await b(te);for(const V of J){let q=!1,L=!1,B=!1;try{const H=await e.Promises.lstat((0,u.$jc)(te,V));q=H.isFile(),L=H.isDirectory(),B=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ce.push({name:V,isFile:()=>q,isDirectory:()=>L,isSymbolicLink:()=>B})}return ce}function h(te){return S(n.readdirSync(te))}function S(te){return te.map(ce=>typeof ce=="string"?c.$j?(0,E.$dm)(ce):ce:(ce.name=c.$j?(0,E.$dm)(ce.name):ce.name,ce))}async function a(te){const ce=await b(te),J=[];for(const V of ce)await r.existsDirectory((0,u.$jc)(te,V))&&J.push(V);return J}function t(te,ce=1e3){return new Promise(J=>{let V=!1;const q=setInterval(()=>{V||(V=!0,n.access(te,L=>{V=!1,L&&(clearInterval(q),J(void 0))}))},ce)})}var r;(function(te){async function ce(q){let L;try{if(L=await e.Promises.lstat(q),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(B){if(B.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(c.$i&&B.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw H}throw B}}te.stat=ce;async function J(q){try{const{stat:L,symbolicLink:B}=await te.stat(q);return L.isFile()&&B?.dangling!==!0}catch{}return!1}te.existsFile=J;async function V(q){try{const{stat:L,symbolicLink:B}=await te.stat(q);return L.isDirectory()&&B?.dangling!==!0}catch{}return!1}te.existsDirectory=V})(r||(e.SymlinkSupport=r={}));const s=new R.$Hh;function i(te,ce,J){return s.queueFor(p.URI.file(te),()=>{const V=D(J);return new Promise((q,L)=>$(te,ce,V,B=>B?L(B):q()))},g.$3g)}let o=!0;function l(te){o=te}function $(te,ce,J,V){if(!o)return n.writeFile(te,ce,{mode:J.mode,flag:J.flag},V);n.open(te,J.flag,J.mode,(q,L)=>{if(q)return V(q);n.writeFile(L,ce,B=>{if(B)return n.close(L,()=>V(B));n.fdatasync(L,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),l(!1)),n.close(L,oe=>V(oe))))})})}function P(te,ce,J){const V=D(J);if(!o)return n.writeFileSync(te,ce,{mode:V.mode,flag:V.flag});const q=n.openSync(te,V.flag,V.mode);try{n.writeFileSync(q,ce);try{n.fdatasyncSync(q)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),l(!1)}}finally{n.closeSync(q)}}function D(te){return te?{mode:typeof te.mode=="number"?te.mode:438,flag:typeof te.flag=="string"?te.flag:"w"}:{mode:438,flag:"w"}}async function I(te,ce,J=6e4){if(te!==ce)try{c.$i&&typeof J=="number"?await O(te,ce,Date.now(),J):await(0,k.promisify)(n.rename)(te,ce)}catch(V){if(te.toLowerCase()!==ce.toLowerCase()&&V.code==="EXDEV"||te.endsWith("."))await M(te,ce,{preserveSymlinks:!1}),await m(te,v.MOVE);else throw V}}async function O(te,ce,J,V,q=0){try{return await(0,k.promisify)(n.rename)(te,ce)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-J>=V)throw console.error(`[node.js fs] rename failed after ${q} retries with error: ${L}`),L;if(q===0){let B=!1;try{const{stat:H}=await r.stat(ce);H.isFile()||(B=!0)}catch{}if(B)throw L}return await(0,R.$zh)(Math.min(100,q*10)),O(te,ce,J,V,q+1)}}async function M(te,ce,J){return F(te,ce,{root:{source:te,target:ce},options:J,handledSourcePaths:new Set})}const W=511;async function F(te,ce,J){if(J.handledSourcePaths.has(te))return;J.handledSourcePaths.add(te);const{stat:V,symbolicLink:q}=await r.stat(te);if(q){if(J.options.preserveSymlinks)try{return await ae(te,ce,J)}catch{}if(q.dangling)return}return V.isDirectory()?T(te,ce,V.mode&W,J):U(te,ce,V.mode&W)}async function T(te,ce,J,V){await e.Promises.mkdir(ce,{recursive:!0,mode:J});const q=await b(te);for(const L of q)await F((0,u.$jc)(te,L),(0,u.$jc)(ce,L),V)}async function U(te,ce,J){await e.Promises.copyFile(te,ce),await e.Promises.chmod(ce,J)}async function ae(te,ce,J){let V=await e.Promises.readlink(te);(0,j.$xg)(V,J.root.source,!c.$k)&&(V=(0,u.$jc)(J.root.target,V.substr(J.root.source.length+1))),await e.Promises.symlink(V,ce)}e.Promises=new class{get access(){return(0,k.promisify)(n.access)}get stat(){return(0,k.promisify)(n.stat)}get lstat(){return(0,k.promisify)(n.lstat)}get utimes(){return(0,k.promisify)(n.utimes)}get read(){return(te,ce,J,V,q)=>new Promise((L,B)=>{n.read(te,ce,J,V,q,(H,oe,G)=>H?B(H):L({bytesRead:oe,buffer:G}))})}get readFile(){return(0,k.promisify)(n.readFile)}get write(){return(te,ce,J,V,q)=>new Promise((L,B)=>{n.write(te,ce,J,V,q,(H,oe,G)=>H?B(H):L({bytesWritten:oe,buffer:G}))})}get appendFile(){return(0,k.promisify)(n.appendFile)}get fdatasync(){return(0,k.promisify)(n.fdatasync)}get truncate(){return(0,k.promisify)(n.truncate)}get copyFile(){return(0,k.promisify)(n.copyFile)}get open(){return(0,k.promisify)(n.open)}get close(){return(0,k.promisify)(n.close)}get symlink(){return(0,k.promisify)(n.symlink)}get readlink(){return(0,k.promisify)(n.readlink)}get chmod(){return(0,k.promisify)(n.chmod)}get mkdir(){return(0,k.promisify)(n.mkdir)}get unlink(){return(0,k.promisify)(n.unlink)}get rmdir(){return(0,k.promisify)(n.rmdir)}get realpath(){return(0,k.promisify)(n.realpath)}async exists(te){try{return await e.Promises.access(te),!0}catch{return!1}}get readdir(){return b}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return m}get rename(){return I}get copy(){return M}}}),define(se[109],re([0,1,43,9,4,25,21]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=E,e.$9q=u,e.$0q=c,e.$$q=g;function E(v){if(k.$k)return v;const m=(0,C.$mc)(v);if(v===m)return v;const d=((0,C.$nc)(v)||v).toLowerCase();try{const w=(0,j.readdirSync)(m).filter(b=>b.toLowerCase()===d);if(w.length===1){const b=E(m);if(b)return(0,C.$jc)(b,w[0])}else if(w.length>1){const b=w.indexOf(d);if(b>=0){const f=E(m);if(f)return(0,C.$jc)(f,w[b])}}}catch{}return null}async function u(v,m){if(k.$k)return v;const d=(0,C.$mc)(v);if(v===d)return v;const y=((0,C.$nc)(v)||v).toLowerCase();try{if(m?.isCancellationRequested)return null;const b=(await j.Promises.readdir(d)).filter(f=>f.toLowerCase()===y);if(b.length===1){const f=await u(d,m);if(f)return(0,C.$jc)(f,b[0])}else if(b.length>1){const f=b.indexOf(y);if(f>=0){const h=await u(d,m);if(h)return(0,C.$jc)(h,b[f])}}}catch{}return null}async function c(v){try{return await j.Promises.realpath(v)}catch{const d=p(v);return await j.Promises.access(d,n.constants.R_OK),d}}function g(v){try{return n.realpathSync(v)}catch{const d=p(v);return n.accessSync(d,n.constants.R_OK),d}}function p(v){return(0,R.$hf)((0,C.$hc)(v),C.sep)}}),define(se[110],re([0,1,26,9,21]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=f,e.$nm=h;const R=/^\d+$/,j=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var u;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(u||(u={}));let c;switch(process.arch){case"ia32":c=1;break;case"arm":case"arm64":c=2;break;default:c=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class p{constructor(a,t,r){this.exePath=a,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:S=!1}={}){return S?c===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:S=!1,findPreview:a=!1}={}){const t=v({useAlternateBitness:S});if(!t)return null;const r=C.$jc(t,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let s=-1,i=null;for(const $ of await k.Promises.readdir(r)){let P=-1;if(a){const I=$.indexOf("-");if(I<0)continue;const O=$.substring(0,I);if(!R.test(O)||$.substring(I+1)!=="preview")continue;P=parseInt(O,10)}else{if(!R.test($))continue;P=parseInt($,10)}if(P<=s)continue;const D=C.$jc(r,$,"pwsh.exe");await k.SymlinkSupport.existsFile(D)&&(i=D,s=P)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",l=a?" Preview":"";return new p(i,`PowerShell${l}${o}`,!0)}async function d({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const a=C.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=S?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const s of await k.Promises.readdir(a))if(t.test(s)){const i=C.$jc(a,s,"pwsh.exe");return new p(i,r)}return null}function y(){const S=C.$jc(n.homedir(),".dotnet","tools","pwsh.exe");return new p(S,".NET Core PowerShell Global Tool")}function w(){const S=C.$jc(process.env.windir,c===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(S,"Windows PowerShell",!0)}async function*b(){let S=await m();S&&(yield S),S=await m({useAlternateBitness:!0}),S&&(yield S),S=await d(),S&&(yield S),S=y(),S&&(yield S),S=await m({findPreview:!0}),S&&(yield S),S=await d({findPreview:!0}),S&&(yield S),S=await m({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=w(),S&&(yield S)}async function*f(){for await(const S of b())await S.exists()&&(yield S)}async function h(){for await(const S of f())return S;return null}}),define(se[90],re([0,1,9,4,36,76,12,21]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=u,e.$rm=c,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function u(p=k.env){return p.comspec||"cmd.exe"}function c(p){let v=[],m=!1;const d=function(y){if(m){v.push(y);return}(!p.send(y,b=>{if(b&&console.error(b),m=!1,v.length>0){const f=v.slice(0);v=[],f.forEach(h=>d(h))}})||C.$i)&&(m=!0)};return{send:d}}var g;(function(p){async function v(m,d,y){if(n.$ic(m))return m;if(d===void 0&&(d=k.cwd()),n.$mc(m)!=="."||(y===void 0&&j.$$f(k.env.PATH)&&(y=k.env.PATH.split(n.$tc)),y===void 0||y.length===0))return n.$jc(d,m);async function b(f){if(await E.Promises.exists(f)){let h;try{h=await E.Promises.stat(f)}catch(S){S.message.startsWith("EACCES")&&(h=await E.Promises.lstat(f))}return h?!h.isDirectory():!1}return!1}for(const f of y){let h;if(n.$ic(f)?h=n.$jc(f,m):h=n.$jc(d,f,m),await b(h))return h;let S=h+".com";if(await b(S)||(S=h+".exe",await b(S)))return S}return n.$jc(d,m)}p.findExecutable=v})(g||(e.win32=g={}))}),define(se[111],re([0,1,49,13]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=k;function k(j){return new Promise((E,u)=>{let c;const g=new Map;function p(m,d,y,w,b){const f=g.get(d);if(m===j||f){const h={name:v(y),cmd:y,pid:m,ppid:d,load:w,mem:b};g.set(m,h),m===j&&(c=h),f&&(f.children||(f.children=[]),f.children.push(h),f.children.length>1&&(f.children=f.children.sort((S,a)=>S.pid-a.pid)))}}function v(m){const d=/--utility-sub-type=network/i,y=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,b=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(y.exec(m))return"electron-crash-reporter";if(w.exec(m))return"winpty-agent";if(b.exec(m))return"conpty-agent";let h=f.exec(m);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?d.exec(m)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const S=/[a-zA-Z-]+\.js/g;let a="";do h=S.exec(m),h&&(a+=h+" ");while(h);return a&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${a})`:m}if(process.platform==="win32"){const m=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substring(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substring(5):d;new Promise((d,y)=>{K(["@vscode/windows-process-tree"],d,y)}).then(d=>{d.getProcessList(j,y=>{if(!y){u(new Error(`Root process ${j} not found`));return}d.getProcessCpuUsage(y,w=>{const b=new Map;w.forEach(f=>{const h=m(f.commandLine||"");b.set(f.pid,{name:v(h),cmd:h,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),c=b.get(j),c?(b.forEach(f=>{const h=b.get(f.ppid);h&&(h.children||(h.children=[]),h.children.push(f))}),b.forEach(f=>{f.children&&(f.children=f.children.sort((h,S)=>h.pid-S.pid))}),E(c)):u(new Error(`Root process ${j} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let m=function(){let d=[c];const y=[];for(;d.length;){const b=d.shift();b&&(y.push(b.pid),b.children&&(d=d.concat(b.children)))}let w=JSON.stringify(C.$Sg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+y.join(" "),(0,n.exec)(w,{},(b,f,h)=>{if(b||h)u(b||new Error(h.toString()));else{const S=f.toString().split(`
`);for(let a=0;a<y.length;a++){const t=g.get(y[a]);t.load=parseFloat(S[a])}if(!c){u(new Error(`Root process ${j} not found`));return}E(c)}})};(0,n.exec)("which ps",{},(d,y,w)=>{if(d||w)if(process.platform!=="linux")u(d||new Error(w.toString()));else{const b=JSON.stringify(C.$Sg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)(b,{},(f,h,S)=>{f||S?u(f||new Error(S.toString())):(R(h,p),m())})}else{const b=y.toString().trim();(0,n.exec)(`${b} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,S,a)=>{h||a&&!a.includes("screen size is bogus")?u(h||new Error(a.toString())):(R(S,p),process.platform==="linux"?m():c?E(c):u(new Error(`Root process ${j} not found`)))})}})}})}function R(j,E){const u=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,c=j.toString().split(`
`);for(const g of c){const p=u.exec(g.trim());p&&p.length===6&&E(parseInt(p[1]),parseInt(p[2]),p[5],parseFloat(p[3]),parseFloat(p[4]))}}}),define(se[112],re([0,1,26,4,110,90]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=j;async function j(p,v){return p===1?C.$i?g():R.$qm(v):u(p,v)}let E=null;function u(p,v){if(C.$k&&p===2||C.$j&&p===3)return"/bin/bash";if(!E){let m;if(C.$i)m="/bin/bash";else{if(m=v.SHELL,!m)try{m=(0,n.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}E=m}return E}let c=null;async function g(){return c||(c=(await(0,k.$nm)()).exePath),c}});var Ee=this&&this.__decorate||function(K,e,n,C){var k=arguments.length,R=k<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(K,e,n,C);else for(var E=K.length-1;E>=0;E--)(j=K[E])&&(R=(k<3?j(R):k>3?j(e,n,R):j(e,n))||R);return k>3&&R&&Object.defineProperty(e,n,R),R};define(se[44],re([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(K,e,n,C,k,R,j,E,u,c,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=l,e.$_h=$,e.$ei=W,e.$fi=F;var m;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(m||(m={}));function d(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(y||(y={}));function w(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(b||(b={}));function f(q){let L=0;for(let B=0;;B+=7){const H=q.read(1);if(L|=(H.buffer[0]&127)<<B,!(H.buffer[0]&128))return L}}const h=s(0);function S(q,L){if(L===0){q.write(h);return}let B=0;for(let oe=L;oe!==0;oe=oe>>>7)B++;const H=k.$He.alloc(B);for(let oe=0;L!==0;oe++)H.buffer[oe]=L&127,L=L>>>7,L>0&&(H.buffer[oe]|=128);q.write(H)}class a{constructor(L){this.b=L,this.a=0}read(L){const B=this.b.slice(this.a,this.a+L);return this.a+=B.byteLength,B}}e.$9h=a;class t{constructor(){this.a=[]}get buffer(){return k.$He.concat(this.a)}write(L){this.a.push(L)}}e.$0h=t;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function s(q){const L=k.$He.alloc(1);return L.writeUInt8(q,0),L}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},o=typeof Buffer<"u";function l(q,L){if(typeof L>"u")q.write(i.Undefined);else if(typeof L=="string"){const B=k.$He.fromString(L);q.write(i.String),S(q,B.byteLength),q.write(B)}else if(o&&Buffer.isBuffer(L)){const B=k.$He.wrap(L);q.write(i.Buffer),S(q,B.byteLength),q.write(B)}else if(L instanceof k.$He)q.write(i.VSBuffer),S(q,L.byteLength),q.write(L);else if(Array.isArray(L)){q.write(i.Array),S(q,L.length);for(const B of L)l(q,B)}else if(typeof L=="number"&&(L|0)===L)q.write(i.Uint),S(q,L);else{const B=k.$He.fromString(JSON.stringify(L));q.write(i.Object),S(q,B.byteLength),q.write(B)}}function $(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(f(q)).toString();case r.Buffer:return q.read(f(q)).buffer;case r.VSBuffer:return q.read(f(q));case r.Array:{const B=f(q),H=[];for(let oe=0;oe<B;oe++)H.push($(q));return H}case r.Object:return JSON.parse(q.read(f(q)).toString());case r.Int:return f(q)}}class P{constructor(L,B,H=null,oe=1e3){this.h=L,this.j=B,this.k=H,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(L,B){this.b.set(L,B),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const B=this.o([L.type]);this.k?.logOutgoing(B,0,1,w(L.type));return}case 201:case 202:case 204:case 203:{const B=this.o([L.type,L.id],L.data);this.k?.logOutgoing(B,L.id,1,w(L.type),L.data);return}}}o(L,B=void 0){const H=new t;return l(H,L),l(H,B),this.p(H.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const B=new a(L),H=$(B),oe=$(B),G=H[0];switch(G){case 100:return this.k?.logIncoming(L.byteLength,H[1],1,`${d(G)}: ${H[2]}.${H[3]}`,oe),this.s({type:G,id:H[1],channelName:H[2],name:H[3],arg:oe});case 102:return this.k?.logIncoming(L.byteLength,H[1],1,`${d(G)}: ${H[2]}.${H[3]}`,oe),this.t({type:G,id:H[1],channelName:H[2],name:H[3],arg:oe});case 101:return this.k?.logIncoming(L.byteLength,H[1],1,`${d(G)}`),this.u({type:G,id:H[1]});case 103:return this.k?.logIncoming(L.byteLength,H[1],1,`${d(G)}`),this.u({type:G,id:H[1]})}}s(L){const B=this.b.get(L.channelName);if(!B){this.v(L);return}const H=new R.$qe;let oe;try{oe=B.call(this.j,L.name,L.arg,H.token)}catch(Q){oe=Promise.reject(Q)}const G=L.id;oe.then(Q=>{this.m({id:G,data:Q,type:201})},Q=>{Q instanceof Error?this.m({id:G,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.m({id:G,data:Q,type:203})}).finally(()=>{le.dispose(),this.d.delete(L.id)});const le=(0,c.$Sc)(()=>H.cancel());this.d.set(L.id,le)}t(L){const B=this.b.get(L.channelName);if(!B){this.v(L);return}const H=L.id,G=B.listen(this.j,L.name,L.arg)(le=>this.m({id:H,data:le,type:204}));this.d.set(L.id,G)}u(L){const B=this.d.get(L.id);B&&(B.dispose(),this.d.delete(L.id))}v(L){let B=this.g.get(L.channelName);B||(B=[],this.g.set(L.channelName,B));const H=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:L,timeoutTimer:H})}w(L){const B=this.g.get(L);if(B){for(const H of B)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$ai=P;var D;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class I{constructor(L,B=null){this.l=L,this.a=!1,this.b=b.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=B}getChannel(L){const B=this;return{call(H,oe,G){return B.a?Promise.reject(new E.$5):B.m(L,H,oe,G)},listen(H,oe){return B.a?u.Event.None:B.o(L,H,oe)}}}m(L,B,H,oe=R.CancellationToken.None){const G=this.g++,Q={id:G,type:100,channelName:L,name:B,arg:H};if(oe.isCancellationRequested)return Promise.reject(new E.$5);let A;return new Promise((_,z)=>{if(oe.isCancellationRequested)return z(new E.$5);const Y=()=>{const ue=he=>{switch(he.type){case 201:this.f.delete(G),_(he.data);break;case 202:{this.f.delete(G);const pe=new Error(he.data.message);pe.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,pe.name=he.data.name,z(pe);break}case 203:this.f.delete(G),z(he.data);break}};this.f.set(G,ue),this.p(Q)};let x=null;this.b===b.Idle?Y():(x=(0,C.$lh)(ue=>this.u()),x.then(()=>{x=null,Y()}));const ee=()=>{x?(x.cancel(),x=null):this.p({id:G,type:101}),z(new E.$5)},X=oe.onCancellationRequested(ee);A=(0,c.$Rc)((0,c.$Sc)(ee),X),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(L,B,H){const oe=this.g++,le={id:oe,type:102,channelName:L,name:B,arg:H};let Q=null;const A=new u.$fe({onWillAddFirstListener:()=>{Q=(0,C.$lh)(_=>this.u()),Q.then(()=>{Q=null,this.d.add(A),this.p(le)})},onDidRemoveLastListener:()=>{Q?(Q.cancel(),Q=null):(this.d.delete(A),this.p({id:oe,type:103}))}}),N=_=>A.fire(_.data);return this.f.set(oe,N),A.event}p(L){switch(L.type){case 100:case 102:{const B=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(B,L.id,0,`${d(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const B=this.q([L.type,L.id]);this.j?.logOutgoing(B,L.id,0,d(L.type));return}}}q(L,B=void 0){const H=new t;return l(H,L),l(H,B),this.r(H.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const B=new a(L),H=$(B),oe=$(B),G=H[0];switch(G){case 200:return this.j?.logIncoming(L.byteLength,0,0,w(G)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,H[1],0,w(G),oe),this.t({type:H[0],id:H[1],data:oe})}}t(L){if(L.type===200){this.b=b.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,c.$Pc)(this.d.values()),this.d.clear()}}e.$bi=I,Ee([j.$3h],I.prototype,"onDidInitializePromise",null);class O{get connections(){const L=[];return this.f.forEach(B=>L.push(B)),L}constructor(L,B,H){this.a=new Map,this.f=new Set,this.g=new u.$fe,this.onDidAddConnection=this.g.event,this.h=new u.$fe,this.onDidRemoveConnection=this.h.event,this.j=new c.$Tc,this.j.add(L(({protocol:oe,onDidClientDisconnect:G})=>{const le=u.Event.once(oe.onMessage);this.j.add(le(Q=>{const A=new a(Q),N=$(A),_=new P(oe,N,B,H),z=new I(oe,B);this.a.forEach((x,ee)=>_.registerChannel(ee,x));const Y={channelServer:_,channelClient:z,ctx:N};this.f.add(Y),this.g.fire(Y),this.j.add(G(()=>{_.dispose(),z.dispose(),this.f.delete(Y),this.h.fire(Y)}))}))}))}getChannel(L,B){const H=this;return{call(oe,G,le){let Q;if((0,v.$mg)(B)){const N=(0,n.$3b)(H.connections.filter(B));Q=N?Promise.resolve(N):u.Event.toPromise(u.Event.filter(H.onDidAddConnection,B))}else Q=B.routeCall(H,oe,G);const A=Q.then(N=>N.channelClient.getChannel(L));return W(A).call(oe,G,le)},listen(oe,G){if((0,v.$mg)(B))return H.k(L,B,oe,G);const le=B.routeEvent(H,oe,G).then(Q=>Q.channelClient.getChannel(L));return W(le).listen(oe,G)}}}k(L,B,H,oe){const G=this;let le;const Q=new u.$fe({onWillAddFirstListener:()=>{le=new c.$Tc;const A=new u.$le,N=new Map,_=Y=>{const ee=Y.channelClient.getChannel(L).listen(H,oe),X=A.add(ee);N.set(Y,X)},z=Y=>{const x=N.get(Y);x&&(x.dispose(),N.delete(Y))};G.connections.filter(B).forEach(_),u.Event.filter(G.onDidAddConnection,B)(_,void 0,le),G.onDidRemoveConnection(z,void 0,le),A.event(Q.fire,Q,le),le.add(A)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return Q.event}registerChannel(L,B){this.a.set(L,B);for(const H of this.f)H.channelServer.registerChannel(L,B)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=O;class M{constructor(L,B,H=null){const oe=new t;l(oe,B),L.send(oe.buffer),this.a=new I(L,H),this.d=new P(L,B,H)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,B){this.d.registerChannel(L,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=M;function W(q){return{call(L,B,H){return q.then(oe=>oe.call(L,B,H))},listen(L,B){const H=new u.$oe;return q.then(oe=>H.input=oe.listen(L,B)),H.event}}}function F(q){let L=!1;return{call(B,H,oe){return L?q.call(B,H,oe):(0,C.$zh)(0).then(()=>L=!0).then(()=>q.call(B,H,oe))},listen(B,H){if(L)return q.listen(B,H);const oe=new u.$oe;return(0,C.$zh)(0).then(()=>L=!0).then(()=>oe.input=q.listen(B,H)),oe.event}}}class T{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const B of L.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$gi=T;var U;(function(q){function L(G,le,Q){const A=G,N=Q&&Q.disableMarshalling,_=new Map;for(const z in A)H(z)&&_.set(z,u.Event.buffer(A[z],!0,void 0,le));return new class{listen(z,Y,x){const ee=_.get(Y);if(ee)return ee;const X=A[Y];if(typeof X=="function"){if(oe(Y))return X.call(A,x);if(H(Y))return _.set(Y,u.Event.buffer(A[Y],!0,void 0,le)),_.get(Y)}throw new E.$bb(`Event not found: ${Y}`)}call(z,Y,x){const ee=A[Y];if(typeof ee=="function"){if(!N&&Array.isArray(x))for(let ue=0;ue<x.length;ue++)x[ue]=(0,g.$8h)(x[ue]);let X=ee.apply(A,x);return X instanceof Promise||(X=Promise.resolve(X)),X}throw new E.$bb(`Method not found: ${Y}`)}}}q.fromService=L;function B(G,le){const Q=le&&le.disableMarshalling;return new Proxy({},{get(A,N){if(typeof N=="string")return le?.properties?.has(N)?le.properties.get(N):oe(N)?function(_){return G.listen(N,_)}:H(N)?G.listen(N):async function(..._){let z;le&&!(0,v.$hg)(le.context)?z=[le.context,..._]:z=_;const Y=await G.call(N,z);return Q?Y:(0,g.$8h)(Y)};throw new E.$bb(`Property not found: ${String(N)}`)}})}q.toService=B;function H(G){return G[0]==="o"&&G[1]==="n"&&p.$yf(G.charCodeAt(2))}function oe(G){return/^onDynamic/.test(G)&&p.$yf(G.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function te(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const L=q.toString();if(L!=="[object Object]")return L}return q}function ce(q){return Array.isArray(q)?q.map(te):te(q)}function J(q,L,B,H,oe,G,le){le=ce(le);const Q=ae[oe],A=Q[H%Q.length];let N=[`%c[${q}]%c[${String(L).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(G)?(N=N.concat(le),N.push(")")):N.push(le),console.log.apply(console,N)}class V{constructor(L,B){this.d=L,this.f=B,this.a=0,this.b=0}logOutgoing(L,B,H,oe,G){this.b+=L,J(this.d,this.b,L,B,H,oe,G)}logIncoming(L,B,H,oe,G){this.a+=L,J(this.f,this.a,L,B,H,oe,G)}}e.$hi=V}),define(se[159],re([0,1,17,3,44]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mW=e.$lW=void 0;class R{constructor(u){this.a=u,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",c=>c.data?n.$He.wrap(c.data):n.$He.alloc(0)),u.start()}send(u){this.a.postMessage(u.buffer)}disconnect(){this.a.close()}}e.$lW=R;class j extends k.$di{constructor(u,c){const g=new R(u);super(g,c),this.b=g}dispose(){this.b.disconnect(),super.dispose()}}e.$mW=j}),define(se[113],re([0,1,17,3,2,44]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.ProtocolConstants=e.$ii=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var E;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let l=0;function $(D,I){if(!o.has(D)){const O=String(++l);o.set(D,O)}return o.get(D)}function P(D,I,O,M){if(!i.enableDiagnostics)return;const W=$(D,I);if(M instanceof n.$He||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const F=n.$He.alloc(M.byteLength);F.set(M),i.records.push({timestamp:Date.now(),id:W,label:I,type:O,buff:F})}else i.records.push({timestamp:Date.now(),id:W,label:I,type:O,data:M})}i.traceSocketEvent=P})(E||(e.SocketDiagnostics=E={}));var u;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(u||(e.SocketCloseEventType=u={}));let c=null;function g(){return c||(c=n.$He.alloc(0)),c}class p{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,l){if(o===0)return g();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const I=this.a[0];return l&&(this.a.shift(),this.b-=o),I}if(this.a[0].byteLength>o){const I=this.a[0].slice(0,o);return l&&(this.a[0]=this.a[0].slice(o),this.b-=o),I}const $=n.$He.alloc(o);let P=0,D=0;for(;o>0;){const I=this.a[D];if(I.byteLength>o){const O=I.slice(0,o);$.set(O,P),P+=o,l&&(this.a[D]=I.slice(o),this.b-=o),o-=o}else $.set(I,P),P+=I.byteLength,l?(this.a.shift(),this.b-=I.byteLength):D++,o-=I.byteLength}return $}}e.$ii=p;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function m(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(d||(e.ProtocolConstants=d={}));class y{constructor(o,l,$,P){this.type=o,this.id=l,this.ack=$,this.data=P,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.$Uc{constructor(o){super(),this.f=this.B(new C.$fe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new p,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,P=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new y($,P,D,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class b{constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=n.$He.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(l,o.data)}g(o,l){const $=this.f===0;return this.d.push(o,l),this.f+=o.byteLength+l.byteLength,$}h(){const o=n.$He.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,l){this.g(o,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class f extends k.$Uc{constructor(o){super(),this.f=new C.$fe,this.onMessage=this.f.event,this.g=new C.$fe,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new b(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new y(1,0,0,o))}}e.$ji=f;class h extends R.$di{static fromSocket(o,l){return new h(new f(o),l)}get onDidDispose(){return this.b.onDidDispose}constructor(o,l,$=null){super(o,l,$),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$ki=h;class S{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$fe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$li=S;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,l=this.a;for(;l;)l=l.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let l=0,$=this.a;for(;$;)o[l++]=$.data,$=$.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const l=new a(o);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let l=0;l<r.a;l++)this.c[l]=o-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),l=(1+r.a)*1e3;let $=0;for(let P=0;P<r.a;P++)o-this.c[P]<=l&&$++;return 1-$/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new S,this.onControlMessage=this.u.event,this.v=new S,this.onMessage=this.v.event,this.w=new S,this.onDidDispose=this.w.event,this.x=new S,this.onSocketClose=this.x.event,this.y=new S,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??r.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new k.$Tc,this.o=o.socket,this.p=this.r.add(new b(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new y(5,0,0,g());this.p.write(o),this.p.flush()}sendPause(){const o=new y(7,0,0,g());this.p.write(o)}sendResume(){const o=new y(8,0,0,g());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,l){this.a=!0,this.r.dispose(),this.r=new k.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new b(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new y(3,0,this.h,g());this.p.write(o);const l=this.b.toArray();for(let $=0,P=l.length;$<P;$++)this.p.write(l[$]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const l=this.b.peek();if(l&&l.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new y(6,0,0,g())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let $=0,P=l.length;$<P;$++)this.p.write(l[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const l=++this.c;this.h=this.g;const $=new y(1,l,this.h,o);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(o){const l=new y(2,0,0,o);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),l=Date.now()-o.writtenTime,$=Date.now()-this.q.lastReadTime,P=Date.now()-this.n;if(l>=2e4&&$>=2e4&&P>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:$});return}const D=Math.max(2e4-l,2e4-$,2e4-P,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new y(3,0,this.h,g());this.p.write(o)}D(){this.h=this.g;const o=new y(9,0,this.h,g());this.p.write(o)}}e.$mi=s}),define(se[37],re([0,1,14,15,13]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iW=void 0;class R{constructor(){this.a=new WeakMap}on(E,u){const c=(g,...p)=>{this.b(E,g)&&u(g,...p)};return this.a.set(u,c),n.ipcMain.on(E,c),this}once(E,u){return n.ipcMain.once(E,(c,...g)=>{this.b(E,c)&&u(c,...g)}),this}handle(E,u){return n.ipcMain.handle(E,(c,...g)=>this.b(E,c)?u(c,...g):Promise.reject(`Invalid channel '${E}' or sender for ipcMain.handle() usage.`)),this}removeHandler(E){return n.ipcMain.removeHandler(E),this}removeListener(E,u){const c=this.a.get(u);return c&&(n.ipcMain.removeListener(E,c),this.a.delete(u)),this}b(E,u){if(!E||!E.startsWith("vscode:"))return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because the channel is unknown.`),!1;const c=u.senderFrame,g=c.url;if(!g||g==="about:blank")return!0;let p="unknown";try{p=new URL(g).host}catch{return(0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a malformed URL '${g}'.`),!1}return p!==k.$Rg?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because of a bad origin of '${p}'.`),!1):c.parent!==null?((0,C.$1)(`Refused to handle ipcMain event for channel '${E}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.$iW=new R}),define(se[160],re([0,1,14,37,148]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jW=R;function R(){C.$iW.on(k.$gW,(E,u,c,g,p)=>{const v=j(E,g,c);v.popup({x:p?p.x:void 0,y:p?p.y:void 0,positioningItem:p?p.positioningItem:void 0,callback:()=>{v&&E.sender.send(k.$hW,u)}})})}function j(E,u,c){const g=new n.Menu;return c.forEach(p=>{let v;p.type==="separator"?v=new n.MenuItem({type:p.type}):Array.isArray(p.submenu)?v=new n.MenuItem({submenu:j(E,u,p.submenu),label:p.label}):v=new n.MenuItem({label:p.label,type:p.type,accelerator:p.accelerator,checked:p.checked,enabled:p.enabled,visible:p.visible,click:(m,d,y)=>E.sender.send(u,p.id,y)}),g.append(v)}),g}}),define(se[161],re([0,1,37,17,3,2,44,149]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pW=void 0;function u(g,p){const v=k.Event.fromNodeEventEmitter(n.$iW,p,(d,y)=>({event:d,message:y})),m=k.Event.filter(v,({event:d})=>d.sender.id===g);return k.Event.map(m,({message:d})=>d&&C.$He.wrap(d))}class c extends j.$ci{static{this.b=new Map}static d(){const p=k.Event.fromNodeEventEmitter(n.$iW,"vscode:hello",({sender:v})=>v);return k.Event.map(p,v=>{const m=v.id;c.b.get(m)?.dispose();const y=new k.$fe;c.b.set(m,(0,R.$Sc)(()=>y.fire()));const w=u(m,"vscode:message"),b=k.Event.any(k.Event.signal(u(m,"vscode:disconnect")),y.event);return{protocol:new E.$oW(v,w),onDidClientDisconnect:b}})}constructor(){super(c.d())}}e.$pW=c}),define(se[114],re([0,1,37,3,33,159]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qW=void 0,e.$rW=E;class j extends R.$mW{constructor(c,g){super({addEventListener:(p,v)=>c.addListener(p,v),removeEventListener:(p,v)=>c.removeListener(p,v),postMessage:p=>c.postMessage(p),start:()=>c.start(),close:()=>c.close()},g)}}e.$qW=j;async function E(u){if(u.isDestroyed()||u.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const c=(0,k.$Ug)();u.webContents.send("vscode:createMessageChannel",c);const g=C.Event.fromNodeEventEmitter(n.$iW,"vscode:createMessageChannelResult",(v,m)=>({nonce:m,port:v.ports[0]})),{port:p}=await C.Event.toPromise(C.Event.once(C.Event.filter(g,v=>v.nonce===c)));return p}}),define(se[162],re([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class d extends m.$ai{constructor(b){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",f=>k.$He.wrap(Buffer.from(f,"base64")))},b),process.once("disconnect",()=>this.dispose())}}e.$4q=d;class y{constructor(b,f){this.i=b,this.j=f,this.c=new Set,this.g=new Map,this.h=new u.$fe,this.onDidProcessExit=this.h.event;const h=f&&f.timeout?f.timeout:6e4;this.b=new C.$vh(h),this.d=null,this.f=null}getChannel(b){const f=this;return{call(h,S,a){return f.k(b,h,S,a)},listen(h,S){return f.l(b,h,S)}}}k(b,f,h,S=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const a=this.n(b),t=(0,C.$lh)(i=>a.call(f,h,i)),r=S.onCancellationRequested(()=>t.cancel()),s=(0,c.$Sc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(b,f,h){if(!this.b)return u.Event.None;this.b.cancel();let S;const a=new u.$fe({onWillAddFirstListener:()=>{S=this.n(b).listen(f,h)(a.fire,a),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const b=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,g.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,v.$pm)(f.env),this.d=(0,n.fork)(this.i,b,f);const h=new u.$fe,a=u.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,j.$Zq)(l)){(0,j.log)(l,`IPC Library: ${this.j.serverName}`);return}h.fire(k.$He.wrap(Buffer.from(l,"base64")))}),t=this.j.useQueue?(0,p.$rm)(this.d):this.d,r=l=>this.d&&this.d.connected&&t.send(l.buffer.toString("base64")),s=h.event,i={send:r,onMessage:s};this.f=new m.$bi(i);const o=()=>this.o();process.once("exit",o),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,$)=>{process.removeListener("exit",o),a.dispose(),this.c.forEach(P=>(0,c.$Pc)(P)),this.c.clear(),l!==0&&$!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+$),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:$})})}return this.f}n(b){let f=this.g.get(b);return f||(f=this.m.getChannel(b),this.g.set(b,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$5q=y}),define(se[115],re([0,1,8,3,2,77,12]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=u;var E;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(E||(e.StorageHint=E={}));function u(v){const m=v;return m?.changed instanceof Map||m?.deleted instanceof Set}var c;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(c||(e.StorageState=c={}));class g extends k.$Uc{static{this.a=100}constructor(m,d=Object.create(null)){super(),this.r=m,this.s=d,this.b=this.B(new C.$ie),this.onDidChangeStorage=this.b.event,this.c=c.None,this.f=new Map,this.g=this.B(new n.$wh(g.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((d,y)=>this.w(y,d)),m.deleted?.forEach(d=>this.w(d,void 0))}finally{this.b.resume()}}w(m,d){if(this.c===c.Closed)return;let y=!1;(0,j.$hg)(d)?y=this.f.delete(m):this.f.get(m)!==d&&(this.f.set(m,d),y=!0),y&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===c.None&&(this.c=c.Initialized,this.s.hint!==E.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,d){const y=this.f.get(m);return(0,j.$hg)(y)?d:y}getBoolean(m,d){const y=this.get(m);return(0,j.$hg)(y)?d:y==="true"}getNumber(m,d){const y=this.get(m);return(0,j.$hg)(y)?d:parseInt(y,10)}getObject(m,d){const y=this.get(m);return(0,j.$hg)(y)?d:(0,R.$7h)(y)}async set(m,d,y=!1){if(this.c===c.Closed)return;if((0,j.$hg)(d))return this.delete(m,y);const w=(0,j.$ag)(d)||Array.isArray(d)?(0,R.$6h)(d):String(d);if(this.f.get(m)!==w)return this.f.set(m,w),this.j.set(m,w),this.h.delete(m),this.b.fire({key:m,external:y}),this.D()}async delete(m,d=!1){if(!(this.c===c.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:d}),this.D()}async optimize(){if(this.c!==c.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=c.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(!(this.c===c.Closed||this.m))return this.D(m)}async D(m){return this.s.hint===E.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===E.STORAGE_IN_MEMORY}}e.$1p=g;class p{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((d,y)=>this.a.set(y,d)),m.delete?.forEach(d=>this.a.delete(d))}async optimize(){}async close(){}}e.$2p=p}),define(se[163],re([0,1,8,3,32,9,21]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NW=void 0;class E{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor(g,p=Object.create(null)){this.g=g,this.h=p,this.c=(0,R.$nc)(this.g),this.d=new u(this.h.logging),this.f=this.n(this.g)}async getItems(){const g=await this.f,p=new Map;return(await this.s(g,"SELECT * FROM ItemTable")).forEach(m=>p.set(m.key,m.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${p.size} rows`),p}async updateItems(g){const p=await this.f;return this.j(p,g)}j(g,p){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${p.insert?(0,k.$yc)(p.insert):"0"}), delete(${p.delete?(0,k.$zc)(p.delete):"0"})`),this.t(g,()=>{const v=p.insert,m=p.delete;if(v&&v.size>0){const d=[];d.push([]);let y=0;v.forEach((w,b)=>{let f=d[y];f.length>E.b&&(y++,f=[],d.push(f)),f.push(b,w)}),d.forEach(w=>{this.u(g,`INSERT INTO ItemTable VALUES ${new Array(w.length/2).fill("(?,?)").join(",")}`,b=>b.run(w),()=>{const b=[];let f=0;return v.forEach((h,S)=>{b.push(S),f+=h.length}),`Keys: ${b.join(", ")} Length: ${f}`})})}if(m&&m.size){const d=[];d.push([]);let y=0;m.forEach(w=>{let b=d[y];b.length>E.b&&(y++,b=[],d.push(b)),b.push(w)}),d.forEach(w=>{this.u(g,`DELETE FROM ItemTable WHERE key IN (${new Array(w.length).fill("?").join(",")})`,b=>b.run(w),()=>{const b=[];return m.forEach(f=>{b.push(f)}),`Keys: ${b.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const g=await this.f;return this.q(g,"VACUUM")}async close(g){this.d.trace(`[storage ${this.c}] close()`);const p=await this.f;return this.k(p,g)}k(g,p){return new Promise((v,m)=>{g.db.close(d=>(d&&this.o(g,`[storage ${this.c}] close(): ${d}`),this.g===E.IN_MEMORY_PATH?v():!g.isErroneous&&!g.isInMemory?this.l().then(v,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),v())):typeof p=="function"?j.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const w=()=>this.k(y,void 0);return this.j(y,{insert:p()}).then(()=>w(),b=>(w(),Promise.reject(b)))})).then(v,m):m(d||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const g=this.m(this.g);return j.Promises.copy(this.g,g,{preserveSymlinks:!1})}m(g){return`${g}.backup`}async checkIntegrity(g){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${g})`);const p=await this.f,v=await this.r(p,g?"PRAGMA integrity_check":"PRAGMA quick_check"),m=g?v.integrity_check:v.quick_check;return p.isErroneous?`${m} (last error: ${p.lastError})`:p.isInMemory?`${m} (in-memory!)`:m}async n(g,p=!0){this.d.trace(`[storage ${this.c}] open(${g}, retryOnBusy: ${p})`);try{return await this.p(g)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&p)return await(0,n.$zh)(E.a),this.n(g,!1);try{await j.Promises.unlink(g);try{await j.Promises.rename(this.m(g),g,!1)}catch{}return await this.p(g)}catch(m){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${m}`),this.p(E.IN_MEMORY_PATH)}}}o(g,p){g.isErroneous=!0,g.lastError=p,this.d.error(p)}p(g){return new Promise((p,v)=>{new Promise((m,d)=>{K(["@vscode/sqlite3"],m,d)}).then(m=>{const d={db:new(this.d.isTracing?m.verbose().Database:m.Database)(g,y=>y?d.db&&y.code!=="SQLITE_CANTOPEN"?d.db.close(()=>v(y)):v(y):this.q(d,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>p(d),w=>d.db.close(()=>v(w)))),isInMemory:g===E.IN_MEMORY_PATH};d.db.on("error",y=>this.o(d,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&d.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},v)})}q(g,p){return new Promise((v,m)=>{g.db.exec(p,d=>d?(this.o(g,`[storage ${this.c}] exec(): ${d}`),m(d)):v())})}r(g,p){return new Promise((v,m)=>{g.db.get(p,(d,y)=>d?(this.o(g,`[storage ${this.c}] get(): ${d}`),m(d)):v(y))})}s(g,p){return new Promise((v,m)=>{g.db.all(p,(d,y)=>d?(this.o(g,`[storage ${this.c}] all(): ${d}`),m(d)):v(y))})}t(g,p){return new Promise((v,m)=>{g.db.serialize(()=>{g.db.run("BEGIN TRANSACTION"),p(),g.db.run("END TRANSACTION",d=>d?(this.o(g,`[storage ${this.c}] transaction(): ${d}`),m(d)):v())})})}u(g,p,v,m){const d=g.db.prepare(p),y=w=>{this.o(g,`[storage ${this.c}] prepare(): ${w} (${p}). Details: ${m()}`)};d.on("error",y),v(d),d.finalize(w=>{w&&y(w),d.removeListener("error",y)})}}e.$NW=E;class u{static{this.a="VSCODE_TRACE_STORAGE"}constructor(g){g&&typeof g.logTrace=="function"&&process.env[u.a]&&(this.b=g.logTrace),g&&typeof g.logError=="function"&&(this.c=g.logError)}get isTracing(){return!!this.b}trace(g){this.b?.(g)}error(g){this.c?.(g)}}}),define(se[164],re([11,10]),function(K,e){return K.create("vs/code/electron-main/app",e)}),define(se[165],re([11,10]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[166],re([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/contextkey",e)}),define(se[167],re([11,10]),function(K,e){return K.create("vs/platform/contextkey/common/scanner",e)}),define(se[168],re([11,10]),function(K,e){return K.create("vs/platform/dialogs/common/dialogs",e)}),define(se[169],re([11,10]),function(K,e){return K.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(se[170],re([11,10]),function(K,e){return K.create("vs/platform/environment/node/argv",e)}),define(se[171],re([11,10]),function(K,e){return K.create("vs/platform/environment/node/argvHelper",e)}),define(se[172],re([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[173],re([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[174],re([11,10]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[175],re([11,10]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[176],re([11,10]),function(K,e){return K.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(se[177],re([11,10]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(se[178],re([11,10]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(se[179],re([11,10]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(se[180],re([11,10]),function(K,e){return K.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(se[181],re([11,10]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[182],re([11,10]),function(K,e){return K.create("vs/platform/issue/electron-main/issueMainService",e)}),define(se[183],re([11,10]),function(K,e){return K.create("vs/platform/log/common/log",e)}),define(se[184],re([11,10]),function(K,e){return K.create("vs/platform/menubar/electron-main/menubar",e)}),define(se[185],re([11,10]),function(K,e){return K.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(se[186],re([11,10]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(se[187],re([11,10]),function(K,e){return K.create("vs/platform/shell/node/shellEnv",e)}),define(se[188],re([11,10]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[189],re([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(se[190],re([11,10]),function(K,e){return K.create("vs/platform/terminal/common/terminalProfiles",e)}),define(se[191],re([11,10]),function(K,e){return K.create("vs/platform/update/common/update.config.contribution",e)}),define(se[192],re([11,10]),function(K,e){return K.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[193],re([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowImpl",e)}),define(se[194],re([11,10]),function(K,e){return K.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(se[195],re([11,10]),function(K,e){return K.create("vs/platform/workspace/common/workspace",e)}),define(se[196],re([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(se[197],re([11,10]),function(K,e){return K.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(se[198],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xfb=n,e.$Yfb=C;function n(k){return k&&k.hasOwnProperty("folderUri")}function C(k){return k&&k.hasOwnProperty("workspace")}}),define(se[199],re([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=C,e.$wcc=k,e.$xcc=R;function C(j){return typeof j?.backupFolder=="string"}function k(j){let E=[];try{Array.isArray(j.workspaces)&&(E=j.workspaces.map(u=>({workspace:{id:u.id,configPath:n.URI.parse(u.configURIPath)},remoteAuthority:u.remoteAuthority})))}catch{}return E}function R(j){let E=[];try{Array.isArray(j.folders)&&(E=j.folders.map(u=>({folderUri:n.URI.parse(u.folderUri),remoteAuthority:u.remoteAuthority})))}catch{}return E}}),define(se[200],re([0,1,15,167]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var k;(function(c){c[c.LParen=0]="LParen",c[c.RParen=1]="RParen",c[c.Neg=2]="Neg",c[c.Eq=3]="Eq",c[c.NotEq=4]="NotEq",c[c.Lt=5]="Lt",c[c.LtEq=6]="LtEq",c[c.Gt=7]="Gt",c[c.GtEq=8]="GtEq",c[c.RegexOp=9]="RegexOp",c[c.RegexStr=10]="RegexStr",c[c.True=11]="True",c[c.False=12]="False",c[c.In=13]="In",c[c.Not=14]="Not",c[c.And=15]="And",c[c.Or=16]="Or",c[c.Str=17]="Str",c[c.QuotedStr=18]="QuotedStr",c[c.Error=19]="Error",c[c.EOF=20]="EOF"})(k||(e.TokenType=k={}));function R(...c){switch(c.length){case 1:return(0,C.localize)(0,null,c[0]);case 2:return(0,C.localize)(1,null,c[0],c[1]);case 3:return(0,C.localize)(2,null,c[0],c[1],c[2]);default:return}}const j=(0,C.localize)(3,null),E=(0,C.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(g){switch(g.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return g.isTripleEq?"===":"==";case 4:return g.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return g.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return g.lexeme;case 18:return g.lexeme;case 19:return g.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(g)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(g=>g.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(g){return this.c=g,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const p=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:p})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const p=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:p})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(g){return this.r()||this.c.charCodeAt(this.e)!==g?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(g){this.f.push({type:g,offset:this.d})}l(g){const p=this.d,v=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:v};this.g.push({offset:p,lexeme:v,additionalInfo:g}),this.f.push(m)}n(){this.m.lastIndex=this.d;const g=this.m.exec(this.c);if(g){this.e=this.d+g[0].length;const p=this.c.substring(this.d,this.e),v=u.b.get(p);v?this.k(v):this.f.push({type:17,lexeme:p,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let g=this.e,p=!1,v=!1;for(;;){if(g>=this.c.length){this.e=g,this.l(E);return}const d=this.c.charCodeAt(g);if(p)p=!1;else if(d===47&&!v){g++;break}else d===91?v=!0:d===92?p=!0:d===93&&(v=!1);g++}for(;g<this.c.length&&u.a.has(this.c.charCodeAt(g));)g++;this.e=g;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=u}),define(se[201],re([0,1,3,2]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;class k{constructor(){this.a=new n.$fe,this.b=new n.$fe,this.c=new n.$fe,this.d=new n.$fe}static{this.ChannelName="extensionhostdebugservice"}call(E,u,c){switch(u){case"close":return Promise.resolve(this.a.fire({sessionId:c[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:c[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:c[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:c[0],port:c[1],subId:c[2]}))}throw new Error("Method not implemented.")}listen(E,u,c){switch(u){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Lo=k;class R extends C.$Uc{constructor(E){super(),this.b=E}reload(E){this.b.call("reload",[E])}get onReload(){return this.b.listen("reload")}close(E){this.b.call("close",[E])}get onClose(){return this.b.listen("close")}attachSession(E,u,c){this.b.call("attach",[E,u,c])}get onAttachSession(){return this.b.listen("attach")}terminateSession(E,u){this.b.call("terminate",[E,u])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(E,u){return this.b.call("openExtensionDevelopmentHostWindow",[E,u])}}e.$Mo=R}),define(se[202],re([0,1,151,51,13,9,36,19,7]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=g,e.$0m=p,e.$7m=/^([^.]+\..+)[:=](.+)$/;class c{get appRoot(){return(0,R.$mc)(k.$Sg.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,R.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,E.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,n.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$jc)(this.userDataPath,"logs",m)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$_g)(u.URI.file((0,R.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=j.env.VSCODE_PORTABLE;return m?u.URI.file((0,R.$jc)(m,"argv.json")):(0,E.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,R.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.$kc)(m):(0,R.$hc)((0,R.$jc)(k.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?u.URI.file((0,R.$kc)(m)):u.URI.file((0,R.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.$kc)(m);const d=j.env.VSCODE_EXTENSIONS;if(d)return d;const y=j.env.VSCODE_PORTABLE;return y?(0,R.$jc)(y,"extensions"):(0,E.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(d=>/^[^:/?#]+?:\/\//.test(d)?u.URI.parse(d):u.URI.file((0,R.$hc)(d)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?u.URI.parse(m):u.URI.file((0,R.$hc)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$7m.test(m))}get extensionLogLevel(){const m=[];for(const d of this.args.log||[]){const y=e.$7m.exec(d);y&&y[1]&&y[2]&&m.push([y[1],y[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,E.$_g)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=j.env.VSCODE_PORTABLE;return m?u.URI.file((0,R.$jc)(m,"policy.json")):(0,E.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,d,y){this.a=m,this.b=d,this.c=y,this.editSessionId=this.args.editSessionId}}e.$8m=c,Ee([C.$3h],c.prototype,"appRoot",null),Ee([C.$3h],c.prototype,"userHome",null),Ee([C.$3h],c.prototype,"userDataPath",null),Ee([C.$3h],c.prototype,"appSettingsHome",null),Ee([C.$3h],c.prototype,"tmpDir",null),Ee([C.$3h],c.prototype,"cacheHome",null),Ee([C.$3h],c.prototype,"stateResource",null),Ee([C.$3h],c.prototype,"userRoamingDataHome",null),Ee([C.$3h],c.prototype,"userDataSyncHome",null),Ee([C.$3h],c.prototype,"sync",null),Ee([C.$3h],c.prototype,"machineSettingsResource",null),Ee([C.$3h],c.prototype,"workspaceStorageHome",null),Ee([C.$3h],c.prototype,"localHistoryHome",null),Ee([C.$3h],c.prototype,"keyboardLayoutResource",null),Ee([C.$3h],c.prototype,"argvResource",null),Ee([C.$3h],c.prototype,"isExtensionDevelopment",null),Ee([C.$3h],c.prototype,"untitledWorkspacesHome",null),Ee([C.$3h],c.prototype,"builtinExtensionsPath",null),Ee([C.$3h],c.prototype,"extensionsPath",null),Ee([C.$3h],c.prototype,"extensionDevelopmentLocationURI",null),Ee([C.$3h],c.prototype,"extensionDevelopmentKind",null),Ee([C.$3h],c.prototype,"extensionTestsLocationURI",null),Ee([C.$3h],c.prototype,"debugExtensionHost",null),Ee([C.$3h],c.prototype,"logLevel",null),Ee([C.$3h],c.prototype,"extensionLogLevel",null),Ee([C.$3h],c.prototype,"serviceMachineIdResource",null),Ee([C.$3h],c.prototype,"disableTelemetry",null),Ee([C.$3h],c.prototype,"disableWorkspaceTrust",null),Ee([C.$3h],c.prototype,"useInMemorySecretStorage",null),Ee([C.$3h],c.prototype,"policyFile",null);function g(v,m){return p(v["inspect-extensions"],v["inspect-brk-extensions"],5870,m,v.debugId,v.extensionEnvironment)}function p(v,m,d,y,w,b){const h=Number(m||v)||(y?null:d),S=h?!!m:!1;let a;if(b)try{a=JSON.parse(b)}catch{}return{port:h,break:S,debugId:w,env:a}}}),define(se[116],re([0,1,313,4,170]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=void 0,e.$vm=E,e.$wm=c,e.$xm=m,e.$ym=d;const R={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.$tm=["tunnel","serve-web"],e.$um={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(34,null)},"disable-lcd-text":{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(36,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(37,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(38,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(y,w,b=j){const f=y.find(l=>l.length>0&&l[0]!=="-"),h={},S=["_"],a=[],t={};let r;for(const l in w){const $=w[l];$.type==="subcommand"?l===f&&(r=$):($.alias&&(h[l]=$.alias),$.type==="string"||$.type==="string[]"?(S.push(l),$.deprecates&&S.push(...$.deprecates)):$.type==="boolean"&&(a.push(l),$.deprecates&&a.push(...$.deprecates)),$.global&&(t[l]=$))}if(r&&f){const l=t;for(const I in r.options)l[I]=r.options[I];const $=y.filter(I=>I!==f),P=b.getSubcommandReporter?b.getSubcommandReporter(f):void 0,D=E($,l,P);return{[f]:D,_:[]}}const s=n(y,{string:S,boolean:a,alias:h}),i={},o=s;i._=s._.map(l=>String(l)).filter(l=>l.length>0),delete o._;for(const l in w){const $=w[l];if($.type==="subcommand")continue;$.alias&&delete o[$.alias];let P=o[l];if($.deprecates)for(const D of $.deprecates)o.hasOwnProperty(D)&&(P||(P=o[D],P&&b.onDeprecatedOption(D,$.deprecationMessage||(0,k.localize)(39,null,l))),delete o[D]);if(typeof P<"u"){if($.type==="string[]"){if(Array.isArray(P)||(P=[P]),!$.allowEmptyValue){const D=P.filter(I=>I.length>0);D.length!==P.length&&(b.onEmptyValue(l),P=D.length>0?D:void 0)}}else $.type==="string"&&(Array.isArray(P)?(P=P.pop(),b.onMultipleValues(l,P)):!P&&!$.allowEmptyValue&&(b.onEmptyValue(l),P=void 0));i[l]=P,$.deprecationMessage&&b.onDeprecatedOption(l,$.deprecationMessage)}delete o[l]}for(const l in o)b.onUnknownOption(l);return i}function u(y,w){let b="";return w.args&&(Array.isArray(w.args)?b=` <${w.args.join("> <")}>`:b=` <${w.args}>`),w.alias?`-${w.alias} --${y}${b}`:`--${y}${b}`}function c(y,w){const b=[];for(const f in y){const h=y[f],S=u(f,h);b.push([S,h.description])}return g(b,w)}function g(y,w){const f=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(w-f<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=w-f-1,S=[];for(const a of y){const t=a[0],r=v(a[1],h),s=p(f-t.length-2);S.push("  "+t+s+r[0]);for(let i=1;i<r.length;i++)S.push(p(f)+r[i])}return S}function p(y){return" ".repeat(y)}function v(y,w){const b=[];for(;y.length;){const f=y.length<w?y.length:y.lastIndexOf(" ",w),h=y.slice(0,f).trim();y=y.slice(f),b.push(h)}return b}function m(y,w,b,f,h){const S=process.stdout.isTTY&&process.stdout.columns||80,a=h?.noInputFiles!==!0?`[${(0,k.localize)(40,null)}...]`:"",t=[`${y} ${b}`];t.push(""),t.push(`${(0,k.localize)(41,null)}: ${w} [${(0,k.localize)(42,null)}]${a}`),t.push(""),h?.noPipe!==!0&&(C.$i?t.push((0,k.localize)(43,null,w)):t.push((0,k.localize)(44,null,w)),t.push(""));const r={},s=[];for(const i in f){const o=f[i];if(o.type==="subcommand")o.description&&s.push({command:i,description:o.description});else if(o.description&&o.cat){let l=r[o.cat];l||(r[o.cat]=l={}),l[i]=o}}for(const i in r){const o=i,l=r[o];l&&(t.push(R[o]),t.push(...c(l,S)),t.push(""))}return s.length&&(t.push((0,k.localize)(45,null)),t.push(...g(s.map(i=>[i.command,i.description]),S)),t.push("")),t.join(`
`)}function d(y,w){return`${y||(0,k.localize)(46,null)}
${w||(0,k.localize)(47,null)}
${process.arch}`}}),define(se[203],re([0,1,88,201,116]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0cc=void 0;class R extends C.$Lo{constructor(E){super(),this.f=E}call(E,u,c){return u==="openExtensionDevelopmentHostWindow"?this.g(c[0],c[1]):super.call(E,u,c)}async g(E,u){const c=(0,k.$vm)(E,k.$um);c.debugRenderer=u;const g=c.extensionDevelopmentPath;if(!g)return{success:!1};const[p]=await this.f.openExtensionDevelopmentHostWindow(g,{context:5,cli:c,forceProfile:c.profile,forceTempProfile:c["profile-temp"]});if(!u)return{success:!0};const v=p.win;if(!v)return{success:!0};const m=v.webContents.debugger;let d=m.isAttached()?1/0:0;const y=(0,n.createServer)(w=>{d++===0&&m.attach();let b=!1;const f=a=>{b||w.write(JSON.stringify(a)+"\0")},h=(a,t,r,s)=>f({method:t,params:r,sessionId:s});v.on("close",()=>{m.removeListener("message",h),w.end(),b=!0}),m.addListener("message",h);let S=Buffer.alloc(0);w.on("data",a=>{S=Buffer.concat([S,a]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let r;try{const s=S.slice(0,t).toString("utf8");S=S.slice(t+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}m.sendCommand(r.method,r.params,r.sessionId).then(s=>f({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>f({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),w.on("error",a=>{console.error("error on cdp pipe:",a)}),w.on("close",()=>{b=!0,--d===0&&m.detach()})});return await new Promise(w=>y.listen(0,w)),v.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$0cc=R}),define(se[64],re([0,1,314,171,116]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=E,e.$Am=u,e.$Bm=c,e.$Cm=g;function R(p,v){const m=(h,S)=>{console.warn((0,C.localize)(0,null,h,S))},d=h=>{console.warn((0,C.localize)(1,null,h))},y=(h,S)=>{console.warn((0,C.localize)(2,null,h,S))},w=h=>({onUnknownOption:S=>{k.$tm.includes(h)||console.warn((0,C.localize)(3,null,S,h))},onMultipleValues:m,onEmptyValue:d,onDeprecatedOption:y,getSubcommandReporter:k.$tm.includes(h)?w:void 0}),b={onUnknownOption:h=>{console.warn((0,C.localize)(4,null,h))},onMultipleValues:m,onEmptyValue:d,onDeprecatedOption:y,getSubcommandReporter:w},f=(0,k.$vm)(p,k.$um,v?b:void 0);return f.goto&&f._.forEach(h=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,C.localize)(5,null))),f}function j(p){const v=p.findIndex(m=>!/^-/.test(m));if(v>-1)return[...p.slice(0,v),...p.slice(v+1)]}function E(p){let[,...v]=p;process.env.VSCODE_DEV&&(v=j(v)||[]);const m=!g(process.env);return R(v,m)}function u(p){let[,,...v]=p;return process.env.VSCODE_DEV&&(v=j(v)||[]),R(v,!0)}function c(p,...v){const m=p.indexOf("--");return m===-1?p.push(...v):p.splice(m,0,...v),p}function g(p){return p.VSCODE_CLI==="1"}}),function(){"use strict";function K(e,n,C){function k(j,E){const u=R(j,E),c=[u];return e.isAbsolute(u)||c.unshift(C),e.resolve(...c)}function R(j,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let c=process.env.VSCODE_APPDATA;if(c)return e.join(c,E);const g=j["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(c=process.env.APPDATA,!c){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");c=e.join(p,"AppData","Roaming")}break;case"darwin":c=e.join(n.homedir(),"Library","Application Support");break;case"linux":c=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(c,E)}return{getUserDataPath:k}}if(typeof define=="function")define(se[204],re([117,26,36]),function(e,n,C){return K(e,n,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=K(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[91],re([0,1,26,202,204]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=j,e.$an=E;class R extends C.$8m{constructor(c,g){super(c,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,k.getUserDataPath)(c,g.nameShort)},g)}}e.$$m=R;function j(u,c){return(0,C.$0m)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,c,u.extensionEnvironment)}function E(u,c){return(0,C.$0m)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,c,u.extensionEnvironment)}}),define(se[205],re([0,1,43,26,31]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qec=R;function R(j){const E=(0,k.$Gg)((0,C.tmpdir)());try{return(0,n.writeFileSync)(E,""),j&&console.log(`Marker file for --wait created: ${E}`),E}catch(u){j&&console.error(`Failed to create marker file for --wait: ${u}`);return}}}),define(se[206],re([0,1,12,173]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=k;function k(j,E,u,c){try{R(j,E,u,c)}catch(g){j.error(g?.message??g)}return E}function R(j,E,u,c){const g=(p,v,m)=>{const d=p[v];if((0,n.$$f)(d)){const y=d,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const b=y.substr(1,w-2);let f=u[b];f===void 0&&c&&(f=c[b]);const h=typeof f=="string"?f:f?.message,S=c?.[b],a=typeof S=="string"?S:S?.message;if(!h){a||j.warn(`[${E.name}]: ${(0,C.localize)(0,null,b)}`);return}if(m&&(v==="title"||v==="category")&&a&&a!==h){const t={value:h,original:a};p[v]=t}else p[v]=h}}else if((0,n.$ag)(d))for(const y in d)d.hasOwnProperty(y)&&(y==="commands"?g(d,y,!0):g(d,y,m));else if(Array.isArray(d))for(let y=0;y<d.length;y++)g(d,y,m)};for(const p in E)E.hasOwnProperty(p)&&g(E,p)}}),define(se[207],re([0,1,19,74,175,208]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=u,e.$Lp=c,e.$Mp=g,e.$Np=p,e.$Op=v,e.$Pp=m,e.$Qp=d;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function u(b){return b=b.trim(),b==="*"||j.test(b)}function c(b){if(!u(b))return null;if(b=b.trim(),b==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=b.match(j);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}function g(b){if(!b)return null;const f=b.majorBase,h=b.majorMustEqual,S=b.minorBase;let a=b.minorMustEqual;const t=b.patchBase;let r=b.patchMustEqual;b.hasCaret&&(f===0||(a=!1),r=!1);let s=0;if(b.preRelease){const i=E.exec(b.preRelease);if(i){const[,o,l,$]=i;s=Date.UTC(Number(o),Number(l)-1,Number($))}}return{majorBase:f,majorMustEqual:h,minorBase:S,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:b.hasGreaterEquals,notBefore:s}}function p(b,f,h){let S;typeof b=="string"?S=g(c(b)):S=b;let a;f instanceof Date?a=f.getTime():typeof f=="string"&&(a=new Date(f).getTime());let t;if(typeof h=="string"?t=g(c(h)):t=h,!S||!t)return!1;const r=S.majorBase,s=S.minorBase,i=S.patchBase;let o=t.majorBase,l=t.minorBase,$=t.patchBase;const P=t.notBefore;let D=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:s>l?!0:s<l||a&&a<P?!1:i>=$:(r===1&&o===0&&(!D||!I||!O)&&(o=1,l=0,$=0,D=!0,I=!1,O=!1),r<o?!1:r>o?!D:s<l?!1:s>l?!I:i<$?!1:i>$?!O:!(a&&a<P))}function v(b,f,h,S,a){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([C.default.Error,k.localize(0,null)]),t;if(typeof S.name!="string")return t.push([C.default.Error,k.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([C.default.Error,k.localize(2,null,"version")]),t;if(!S.engines)return t.push([C.default.Error,k.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([C.default.Error,k.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!w(S.extensionDependencies))return t.push([C.default.Error,k.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!w(S.activationEvents))return t.push([C.default.Error,k.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([C.default.Error,k.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([C.default.Warning,k.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([C.default.Error,k.localize(9,null,"main")]),t;{const i=(0,n.$_g)(h,S.main);(0,n.$6g)(i,h)||t.push([C.default.Warning,k.localize(10,null,i.path,h.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([C.default.Error,k.localize(11,null,"browser")]),t;{const i=(0,n.$_g)(h,S.browser);(0,n.$6g)(i,h)||t.push([C.default.Warning,k.localize(12,null,i.path,h.path)])}}if(!R.valid(S.version))return t.push([C.default.Error,k.localize(13,null)]),t;const r=[];if(!m(b,f,S,a,r))for(const i of r)t.push([C.default.Error,i]);return t}function m(b,f,h,S,a){return S||typeof h.main>"u"&&typeof h.browser>"u"?!0:y(b,f,h.engines.vscode,a)}function d(b,f,h){return b==="*"||y(f,h,b)}function y(b,f,h,S=[]){const a=g(c(h));if(!a)return S.push(k.localize(14,null,h)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return S.push(k.localize(15,null,h)),!1}else if(!a.majorMustEqual)return S.push(k.localize(16,null,h)),!1;return p(b,f,a)?!0:(S.push(k.localize(17,null,b,h)),!1)}function w(b){if(!Array.isArray(b))return!1;for(let f=0,h=b.length;f<h;f++)if(typeof b[f]!="string")return!1;return!0}}),define(se[209],re([0,1,17,33]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=k;async function k(R,j,E){let u=E&&E.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const g=(await j.readFile(R.serviceMachineIdResource)).value.toString();u=(0,C.$Tg)(g)?g:null}catch{u=null}if(!u){u=(0,C.$Ug)();try{await j.writeFile(R.serviceMachineIdResource,n.$He.fromString(u))}catch{}}return E?.store("storage.serviceMachineId",u,-1,1),u}}),define(se[78],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class n{constructor(k,R=[],j=!1){this.ctor=k,this.staticArguments=R,this.supportsDelayedInstantiation=j}}e.$vi=n}),define(se[210],re([0,1,78]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Bs=R,e.$Cs=j;const C=[];var k;(function(E){E[E.Eager=0]="Eager",E[E.Delayed=1]="Delayed"})(k||(e.InstantiationType=k={}));function R(E,u,c){u instanceof n.$vi||(u=new n.$vi(u,[],!!c)),C.push([E,u])}function j(){return C}}),define(se[211],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0;class n{constructor(R,j){this.key=R,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$er=n;class C{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const j of this.a.values())j.outgoing.size===0&&R.push(j);return R}insertEdge(R,j){const E=this.lookupOrInsertNode(R),u=this.lookupOrInsertNode(j);E.outgoing.set(u.key,u),u.incoming.set(E.key,E)}removeNode(R){const j=this.b(R);this.a.delete(j);for(const E of this.a.values())E.outgoing.delete(j),E.incoming.delete(j)}lookupOrInsertNode(R){const j=this.b(R);let E=this.a.get(j);return E||(E=new n(j,R),this.a.set(j,E)),E}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[j,E]of this.a)R.push(`${j}
	(-> incoming)[${[...E.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...E.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,j]of this.a){const E=new Set([R]),u=this.c(j,E);if(u)return u}}c(R,j){for(const[E,u]of R.outgoing){if(j.has(E))return[...j,E].join(" -> ");j.add(E);const c=this.c(u,j);if(c)return c;j.delete(E)}}}e.$fr=C}),define(se[6],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=k,e.$zi=R;var n;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function E(u){return u[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=E})(n||(e._util=n={})),e.$xi=k("instantiationService");function C(j,E,u){E[n.DI_TARGET]===E?E[n.DI_DEPENDENCIES].push({id:j,index:u}):(E[n.DI_DEPENDENCIES]=[{id:j,index:u}],E[n.DI_TARGET]=E)}function k(j){if(n.serviceIds.has(j))return n.serviceIds.get(j);const E=function(u,c,g){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(E,u,g)};return E.toString=()=>j,n.serviceIds.set(j,E),E}function R(j){return j}}),define(se[79],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0,e.$pdc=(0,n.$yi)("auxiliaryWindowsMainService")}),define(se[65],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=void 0,e.$ycc=(0,n.$yi)("backupMainService")}),define(se[18],re([0,1,12,7,6]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=R,e.$7i=j,e.$8i=u,e.$9i=c,e.$0i=g,e.$$i=p,e.$_i=v,e.$aj=d,e.$bj=y,e.$cj=w,e.$5i=(0,k.$yi)("configurationService");function R(b){return b&&typeof b=="object"&&(!b.overrideIdentifier||typeof b.overrideIdentifier=="string")&&(!b.resource||b.resource instanceof C.URI)}function j(b){return b&&typeof b=="object"&&(!b.overrideIdentifiers||Array.isArray(b.overrideIdentifiers))&&!b.overrideIdentifier&&(!b.resource||b.resource instanceof C.URI)}var E;(function(b){b[b.APPLICATION=1]="APPLICATION",b[b.USER=2]="USER",b[b.USER_LOCAL=3]="USER_LOCAL",b[b.USER_REMOTE=4]="USER_REMOTE",b[b.WORKSPACE=5]="WORKSPACE",b[b.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",b[b.DEFAULT=7]="DEFAULT",b[b.MEMORY=8]="MEMORY"})(E||(e.ConfigurationTarget=E={}));function u(b){switch(b){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function c(b){return b.applicationValue!==void 0||b.userValue!==void 0||b.userLocalValue!==void 0||b.userRemoteValue!==void 0||b.workspaceValue!==void 0||b.workspaceFolderValue!==void 0}function g(b,f){const h=Object.create(null);for(const S in b)p(h,S,b[S],f);return h}function p(b,f,h,S){const a=f.split("."),t=a.pop();let r=b;for(let s=0;s<a.length;s++){const i=a[s];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":if(o===null){S(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:S(`Ignoring ${f} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{S(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(r)}`)}else S(`Ignoring ${f} as ${a.join(".")} is ${JSON.stringify(r)}`)}function v(b,f){const h=f.split(".");m(b,h)}function m(b,f){const h=f.shift();if(f.length===0){delete b[h];return}if(Object.keys(b).indexOf(h)!==-1){const S=b[h];typeof S=="object"&&!Array.isArray(S)&&(m(S,f),Object.keys(S).length===0&&delete b[h])}}function d(b,f,h){function S(r,s){let i=r;for(const o of s){if(typeof i!="object"||i===null)return;i=i[o]}return i}const a=f.split("."),t=S(b,a);return typeof t>"u"?h:t}function y(b,f,h){Object.keys(f).forEach(S=>{S!=="__proto__"&&(S in b?n.$ag(b[S])&&n.$ag(f[S])?y(b[S],f[S],h):h&&(b[S]=f[S]):b[S]=f[S])})}function w(b){return b.replace(/[\[\]]/g,"")}}),define(se[118],re([0,1,4,25,200,6,166,15]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=c,e.$xj=r,e.$yj=s,e.$Rj=oe;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",n.$j),u.set("isLinux",n.$k),u.set("isWindows",n.$i),u.set("isWeb",n.$o),u.set("isMacNative",n.$j&&!n.$o),u.set("isEdge",n.$H),u.set("isFirefox",n.$F),u.set("isChrome",n.$E),u.set("isSafari",n.$G);function c(Q,A){if(u.get(Q)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(Q,A)}const g=Object.prototype.hasOwnProperty;var p;(function(Q){Q[Q.False=0]="False",Q[Q.True=1]="True",Q[Q.Defined=2]="Defined",Q[Q.Not=3]="Not",Q[Q.Equals=4]="Equals",Q[Q.NotEquals=5]="NotEquals",Q[Q.And=6]="And",Q[Q.Regex=7]="Regex",Q[Q.NotRegex=8]="NotRegex",Q[Q.Or=9]="Or",Q[Q.In=10]="In",Q[Q.NotIn=11]="NotIn",Q[Q.Greater=12]="Greater",Q[Q.GreaterEquals=13]="GreaterEquals",Q[Q.Smaller=14]="Smaller",Q[Q.SmallerEquals=15]="SmallerEquals"})(p||(e.ContextKeyExprType=p={}));const v={regexParsingWithErrorRecovery:!0},m=(0,j.localize)(0,null),d=(0,j.localize)(1,null),y=(0,j.localize)(2,null),w=(0,j.localize)(3,null),b=(0,j.localize)(4,null),f=(0,j.localize)(5,null),h=(0,j.localize)(6,null),S=(0,j.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=v){this.k=A,this.d=new k.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:d});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),z=_.type===17?f:void 0;throw this.h.push({message:b,offset:_.offset,lexeme:k.$tj.getLexeme(_),additionalInfo:z}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const N=this.o();A.push(N)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const N=this.s();A.push(N)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,w),N?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,w),N}case 17:{const N=A.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const Y=z.lexeme,x=Y.lastIndexOf("/"),ee=x===Y.length-1?void 0:this.w(Y.substring(x+1));let X;try{X=new RegExp(Y.substring(1,x),ee)}catch{throw this.B("REGEX",z)}return te.create(N,X)}switch(z.type){case 10:case 19:{const Y=[z.lexeme];this.z();let x=this.D(),ee=0;for(let $e=0;$e<z.lexeme.length;$e++)z.lexeme.charCodeAt($e)===40?ee++:z.lexeme.charCodeAt($e)===41&&ee--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let $e=0;$e<x.lexeme.length;$e++)x.lexeme.charCodeAt($e)===40?ee++:z.lexeme.charCodeAt($e)===41&&ee--}if(ee<0)break;Y.push(k.$tj.getLexeme(x)),this.z(),x=this.D()}const X=Y.join(""),ue=X.lastIndexOf("/"),he=ue===X.length-1?void 0:this.w(X.substring(ue+1));let pe;try{pe=new RegExp(X.substring(1,ue),he)}catch{throw this.B("REGEX",z)}return t.regex(N,pe)}case 18:{const Y=z.lexeme;this.z();let x=null;if(!(0,C.$9e)(Y)){const ee=Y.indexOf("/"),X=Y.lastIndexOf("/");if(ee!==X&&ee>=0){const ue=Y.slice(ee+1,X),he=Y[X+1]==="i"?"i":"";try{x=new RegExp(ue,he)}catch{throw this.B("REGEX",z)}}}if(x===null)throw this.B("REGEX",z);return te.create(N,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const z=this.u();return t.notIn(N,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(N,z);switch(z){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(N,z);switch(z){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,z)}}case 5:return this.z(),U.create(N,this.u());case 6:return this.z(),ae.create(N,this.u());case 7:return this.z(),F.create(N,this.u());case 8:return this.z(),T.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:h,offset:A.offset,lexeme:"",additionalInfo:S}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,N){if(this.C(A))return this.z();throw this.B(N,this.D())}B(A,N,_){const z=(0,j.localize)(8,null,A,k.$tj.getLexeme(N)),Y=N.offset,x=k.$tj.getLexeme(N);return this.h.push({message:z,offset:Y,lexeme:x,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=a;class t{static false(){return o.INSTANCE}static true(){return l.INSTANCE}static has(A){return $.create(A)}static equals(A,N){return P.create(A,N)}static notEquals(A,N){return O.create(A,N)}static regex(A,N){return te.create(A,N)}static in(A,N){return D.create(A,N)}static notIn(A,N){return I.create(A,N)}static not(A){return M.create(A)}static and(...A){return V.create(A,null,!0)}static or(...A){return q.create(A,null,!0)}static greater(A,N){return F.create(A,N)}static greaterEquals(A,N){return T.create(A,N)}static smaller(A,N){return U.create(A,N)}static smallerEquals(A,N){return ae.create(A,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$wj=t;function r(Q){const A=new a({regexParsingWithErrorRecovery:!1});return Q.map(N=>(A.parse(N),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,j.localize)(9,null,_.additionalInfo):(0,j.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Q,A){const N=Q?Q.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function i(Q,A){return Q.cmp(A)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return l.INSTANCE}}e.$zj=o;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return o.INSTANCE}}e.$Aj=l;class ${static create(A,N=null){const _=u.get(A);return typeof _=="boolean"?_?l.INSTANCE:o.INSTANCE:new $(A,N)}constructor(A,N){this.key=A,this.c=N,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:B(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=u.get(this.key);return typeof A=="boolean"?A?l.INSTANCE:o.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$Bj=$;class P{static create(A,N,_=null){if(typeof N=="boolean")return N?$.create(A,_):M.create(A,_);const z=u.get(A);return typeof z=="boolean"?N===(z?"true":"false")?l.INSTANCE:o.INSTANCE:new P(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=u.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?l.INSTANCE:o.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Cj=P;class D{static create(A,N){return new D(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:H(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?g.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Dj=D;class I{static create(A,N){return new I(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=11,this.c=D.create(A,N)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=I;class O{static create(A,N,_=null){if(typeof N=="boolean")return N?M.create(A,_):$.create(A,_);const z=u.get(A);return typeof z=="boolean"?N===(z?"true":"false")?o.INSTANCE:l.INSTANCE:new O(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=u.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?o.INSTANCE:l.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$Fj=O;class M{static create(A,N=null){const _=u.get(A);return typeof _=="boolean"?_?o.INSTANCE:l.INSTANCE:new M(A,N)}constructor(A,N){this.c=A,this.d=N,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:B(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=u.get(this.c);return typeof A=="boolean"?A?o.INSTANCE:l.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Gj=M;function W(Q,A){if(typeof Q=="string"){const N=parseFloat(Q);isNaN(N)||(Q=N)}return typeof Q=="string"||typeof Q=="number"?A(Q):o.INSTANCE}class F{static create(A,N,_=null){return W(N,z=>new F(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ae.create(this.c,this.d,this)),this.f}}e.$Hj=F;class T{static create(A,N,_=null){return W(N,z=>new T(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$Ij=T;class U{static create(A,N,_=null){return W(N,z=>new U(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Jj=U;class ae{static create(A,N,_=null){return W(N,z=>new ae(A,z,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:H(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Kj=ae;class te{static create(A,N){return new te(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return N<_?-1:N>_?1:0}equals(A){if(A.type===this.type){const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&N===_}return!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Lj=te;class ce{static create(A){return new ce(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ce(this.c.map(A))}negate(){return this.c}}e.$Mj=ce;function J(Q){let A=null;for(let N=0,_=Q.length;N<_;N++){const z=Q[N].substituteConstants();if(Q[N]!==z&&A===null){A=[];for(let Y=0;Y<N;Y++)A[Y]=Q[Y]}A!==null&&(A[N]=z)}return A===null?Q:A}class V{static create(A,N,_){return V.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const z=i(this.expr[N],A.expr[N]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=J(this.expr);return A===this.expr?this:V.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(A))return!1;return!0}static d(A,N,_){const z=[];let Y=!1;for(const x of A)if(x){if(x.type===1){Y=!0;continue}if(x.type===0)return o.INSTANCE;if(x.type===6){z.push(...x.expr);continue}z.push(x)}if(z.length===0&&Y)return l.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];for(;z.length>1;){const x=z[z.length-1];if(x.type!==9)break;z.pop();const ee=z.pop(),X=z.length===0,ue=q.create(x.expr.map(he=>V.create([he,ee],null,_)),null,X);ue&&(z.push(ue),z.sort(i))}if(z.length===1)return z[0];if(_){for(let x=0;x<z.length;x++)for(let ee=x+1;ee<z.length;ee++)if(z[x].negate().equals(z[ee]))return o.INSTANCE;if(z.length===1)return z[0]}return new V(z,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new V(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());this.c=q.create(A,this,!0)}return this.c}}e.$Nj=V;class q{static create(A,N,_){return q.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const z=i(this.expr[N],A.expr[N]);if(z!==0)return z}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=J(this.expr);return A===this.expr?this:q.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(A))return!0;return!1}static d(A,N,_){let z=[],Y=!1;if(A){for(let x=0,ee=A.length;x<ee;x++){const X=A[x];if(X){if(X.type===0){Y=!0;continue}if(X.type===1)return l.INSTANCE;if(X.type===9){z=z.concat(X.expr);continue}z.push(X)}}if(z.length===0&&Y)return o.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let x=1;x<z.length;x++)z[x-1].equals(z[x])&&(z.splice(x,1),x--);if(z.length===1)return z[0];if(_){for(let x=0;x<z.length;x++)for(let ee=x+1;ee<z.length;ee++)if(z[x].negate().equals(z[ee]))return l.INSTANCE;if(z.length===1)return z[0]}return new q(z,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new q(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());for(;A.length>1;){const N=A.shift(),_=A.shift(),z=[];for(const Y of le(N))for(const x of le(_))z.push(V.create([Y,x],null,!1));A.unshift(q.create(z,null,!1))}this.c=q.create(A,this,!0)}return this.c}}e.$Oj=q;class L extends ${static{this.d=[]}static all(){return L.d.values()}constructor(A,N,_){super(A,null),this.f=N,typeof _=="object"?L.d.push({..._,key:A}):_!==!0&&L.d.push({key:A,description:_,type:N!=null?typeof N:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return P.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$Pj=L,e.$Qj=(0,R.$yi)("contextKeyService");function B(Q,A){return Q<A?-1:Q>A?1:0}function H(Q,A,N,_){return Q<N?-1:Q>N?1:A<_?-1:A>_?1:0}function oe(Q,A){if(Q.type===0||A.type===1)return!0;if(Q.type===9)return A.type===9?G(Q.expr,A.expr):!1;if(A.type===9){for(const N of A.expr)if(oe(Q,N))return!0;return!1}if(Q.type===6){if(A.type===6)return G(A.expr,Q.expr);for(const N of Q.expr)if(oe(N,A))return!0;return!1}return Q.equals(A)}function G(Q,A){let N=0,_=0;for(;N<Q.length&&_<A.length;){const z=Q[N].cmp(A[_]);if(z<0)return!1;z===0&&N++,_++}return N===Q.length}function le(Q){return Q.type===9?Q.expr:[Q]}}),define(se[92],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$fn=e.ID=void 0,e.$gn=C,e.ID="diagnosticsService",e.$fn=(0,n.$yi)(e.ID);function C(R){return!!R.hostName&&!!R.errorMessage}class k{async getPerformanceInfo(j,E){return{}}async getSystemInfo(j,E){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,E){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$hn=k}),define(se[119],re([0,1,19,74,168,6,48,4,35]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Tw=e.$Sw=e.$Rw=void 0,e.$Uw=m,e.$Vw=d,e.$Rw=(0,R.$yi)("dialogService");var c;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(c||(c={}));class g{a(w){return this.d(w,c.Confirmation)}b(w){return this.d(w,c.Prompt)}c(w){return this.d(w,c.Input)}d(w,b){const f=[];switch(b){case c.Confirmation:{const h=w;h.primaryButton?f.push(h.primaryButton):f.push((0,k.localize)(0,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,k.localize)(1,null));break}case c.Prompt:{const h=w;Array.isArray(h.buttons)&&h.buttons.length>0&&f.push(...h.buttons.map(S=>S.label)),h.cancelButton&&(h.cancelButton===!0?f.push((0,k.localize)(2,null)):typeof h.cancelButton=="string"?f.push(h.cancelButton):h.cancelButton.label?f.push(h.cancelButton.label):f.push((0,k.localize)(3,null))),f.length===0&&f.push((0,k.localize)(4,null));break}case c.Input:{const h=w;h.primaryButton?f.push(h.primaryButton):f.push((0,k.localize)(5,null)),h.cancelButton?f.push(h.cancelButton):f.push((0,k.localize)(6,null));break}}return f}e(w){if(typeof w=="string")return w;if(typeof w=="number")return w===C.default.Info?"info":w===C.default.Error?"error":w===C.default.Warning?"warning":"none"}f(w,b,f){const h=[...w.buttons??[]];w.cancelButton&&typeof w.cancelButton!="string"&&typeof w.cancelButton!="boolean"&&h.push(w.cancelButton);let S=h[b]?.run({checkboxChecked:f});return S instanceof Promise||(S=Promise.resolve(S)),{result:S,checkboxChecked:f}}}e.$Sw=g,e.$Tw=(0,R.$yi)("fileDialogService");var p;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(p||(e.ConfirmResult=p={}));const v=10;function m(y){const w=[];return w.push(...y.slice(0,v).map(b=>typeof b=="string"?b:(0,n.$9g)(b))),y.length>v&&(y.length-v===1?w.push((0,k.localize)(7,null)):w.push((0,k.localize)(8,null,y.length-v))),w.push(""),w.join(`
`)}function d(y,w){const b=(0,u.$5n)(y);let f=(b.buttons??[]).map(t=>(0,j.$Ow)(t)),h=(y.buttons||[]).map((t,r)=>r),S=0,a=b.cancelId??f.length-1;if(f.length>1){const t=typeof a=="number"?f[a]:void 0;if(E.$k||E.$j){if(typeof t=="string"&&f.length>1&&a!==1){f.splice(a,1),f.splice(1,0,t);const r=h[a];h.splice(a,1),h.splice(1,0,r),a=1}E.$k&&f.length>1&&(f=f.reverse(),h=h.reverse(),S=f.length-1,typeof t=="string"&&(a=S-1))}else if(E.$i&&typeof t=="string"&&f.length>1&&a!==f.length-1){f.splice(a,1),f.push(t);const r=h[a];h.splice(a,1),h.push(r),a=f.length-1}}return b.buttons=f,b.defaultId=S,b.cancelId=a,b.noLink=!0,b.title=b.title||w.nameLong,{options:b,buttonIndeces:h}}}),define(se[120],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$4W=e.$3W=void 0,e.$5W=R,e.$6W=j,e.$3W=(0,n.$yi)("encryptionService"),e.$4W=(0,n.$yi)("encryptionMainService");var C;(function(E){E.kwallet="kwallet",E.kwallet5="kwallet5",E.gnomeLibsecret="gnome-libsecret",E.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var k;(function(E){E.unknown="unknown",E.basicText="basic_text",E.gnomeAny="gnome_any",E.gnomeLibsecret="gnome_libsecret",E.gnomeKeyring="gnome_keyring",E.kwallet="kwallet",E.kwallet5="kwallet5",E.kwallet6="kwallet6",E.dplib="dpapi",E.keychainAccess="keychain_access"})(k||(e.KnownStorageProvider=k={}));function R(E){return E==="kwallet"||E==="kwallet5"||E==="kwallet6"}function j(E){return E==="gnome_any"||E==="gnome_libsecret"||E==="gnome_keyring"}}),define(se[38],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,n.$yi)("environmentService"),e.$Gi=(0,n.$zi)(e.$Fi)}),define(se[121],re([0,1,172,6]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=R,e.$5o=j,e.$6o=E,e.$7o=u,e.$8o=c,e.$9o=g,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionInstallSource",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";var k;(function(h){h.COMMAND="command",h.SETTINGS_SYNC="settingsSync"})(k||(e.ExtensionInstallSource=k={}));function R(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function j(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function E(h,S){switch(h){case 3:return S==="x64"?"win32-x64":S==="arm64"?"win32-arm64":"unknown";case 2:return S==="x64"?"linux-x64":S==="arm64"?"linux-arm64":S==="arm"?"linux-armhf":"unknown";case"alpine":return S==="x64"?"alpine-x64":S==="arm64"?"alpine-arm64":"unknown";case 1:return S==="x64"?"darwin-x64":S==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function u(h,S){return S==="web"&&!h.includes("web")}function c(h,S,a){return u(S,a)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===a}function g(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var p;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var m;(function(h){h.Install="install",h.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var d;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(d||(e.InstallOperation=d={})),e.$0o=(0,C.$yi)("extensionGalleryService");var y;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed",h.DownloadFailedWriting="DownloadFailedWriting"})(y||(e.ExtensionGalleryErrorCode=y={}));class w extends Error{constructor(S,a){super(S),this.code=a,this.name=a}}e.$$o=w;var b;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.DownloadFailedWriting="DownloadFailedWriting",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.ScanningExtension="ScanningExtension",h.ReadUninstalled="ReadUninstalled",h.UnsetUninstalled="UnsetUninstalled",h.Delete="Delete",h.Rename="Rename",h.IntializeDefaultProfile="IntializeDefaultProfile",h.AddToProfile="AddToProfile",h.PostInstall="PostInstall",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Cancelled="Cancelled",h.Unknown="Unknown",h.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));class f extends Error{constructor(S,a){super(S),this.code=a,this.name=a}}e.$_o=f,e.$ap=(0,C.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,C.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,C.$yi)("IExtensionTipsService"),e.$fp=(0,n.localize2)(0,"Extensions"),e.$gp=(0,n.localize2)(1,"Preferences")}),define(se[212],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=void 0,e.$edc=(0,n.$yi)("extensionHostStarter"),e.$fdc="extensionHostStarter"}),define(se[213],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T7b=e.$S7b=void 0,e.$S7b=(0,n.$yi)("externalTerminal"),e.$T7b="Terminal.app"}),define(se[214],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0,e.$hdc=(0,n.$yi)("externalTerminal")}),define(se[215],re([0,1,49,51,13,9,4,76,21,90,176,213]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kdc=e.$jdc=e.$idc=void 0;const v=g.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:d.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class d extends m{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,c.$qm(),t)}spawnTerminal(a,t,r,s){const i=t.windowsExec||d.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=R.$nc(i,".exe").toLowerCase();if(o==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return i.indexOf(" ")>=0&&l.push('""'),l.push(i),o==="wt"&&l.push("-d ."),new Promise(($,P)=>{const D=b(process),I=a.spawn(r,l,{cwd:s,env:D,detached:!0});I.on("error",P),I.on("exit",()=>$())})}async runInTerminal(a,t,r,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:d.getDefaultTerminalWindows(),l=await d.f();return new Promise(($,P)=>{const D=`"${t} - ${v}"`,I=`"${r.join('" "')}" & pause`,O=Object.assign({},b(process),s);Object.keys(O).filter(U=>O[U]===null).forEach(U=>delete O[U]);const M={cwd:t,env:O,windowsVerbatimArguments:!0};let W,F;R.$nc(o,".exe")==="wt"?(W=o,F=["-d",".",d.b,"/c",I]):l?(W=l,F=["-d",".",o,"/c",I]):(W=d.b,F=["/c","start",D,"/wait",o,"/c",`"${I}"`]),n.spawn(W,F,M).on("error",U=>{P(f(U))}),$(void 0)})}static getDefaultTerminalWindows(){if(!d.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");d.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return d.d}static async f(){try{const a=await c.win32.findExecutable("wt");return await u.Promises.exists(a)?a:void 0}catch{return}}}e.$idc=d,Ee([C.$3h],d,"f",null);class y extends m{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.osxExec||p.$T7b;return new Promise((l,$)=>{if(o===p.$T7b||o==="iTerm.app"){const P=o===p.$T7b?"TerminalHelper":"iTermHelper",I=[k.$Sg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${P}.scpt`).fsPath,"-t",a||v,"-w",t];for(const W of r)I.push("-a"),I.push(W);if(s){const W=Object.assign({},b(process),s);for(const F in W){const T=W[F];T===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${T}`))}}let O="";const M=n.spawn(y.b,I);M.on("error",W=>{$(f(W))}),M.stderr.on("data",W=>{O+=W.toString()}),M.on("exit",W=>{if(W===0)l(void 0);else if(O){const F=O.split(`
`,1);$(new Error(F[0]))}else $(new Error(g.localize(1,null,P,W)))})}else $(new Error(g.localize(2,null,o)))})}spawnTerminal(a,t,r){const s=t.osxExec||p.$T7b;return new Promise((i,o)=>{const l=["-a",s];r&&l.push(r);const $=b(process),P=a.spawn("/usr/bin/open",l,{cwd:r,env:$});P.on("error",o),P.on("exit",()=>i())})}}e.$jdc=y;class w extends m{static{this.b=g.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((l,$)=>{const P=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?P.push("-x"):P.push("-e"),P.push("bash"),P.push("-c");const I=`${h(r)}; echo; read -p "${w.b}" -n1;`;P.push(`''${I}''`);const O=Object.assign({},b(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const M={cwd:t,env:O};let W="";const F=n.spawn(D,P,M);F.on("error",T=>{$(f(T))}),F.stderr.on("data",T=>{W+=T.toString()}),F.on("exit",T=>{if(T===0)l(void 0);else if(W){const U=W.split(`
`,1);$(new Error(U[0]))}else $(new Error(g.localize(4,null,D,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!j.$k)w.d=Promise.resolve("xterm");else{const a=await u.Promises.exists("/etc/debian_version");w.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return w.d}spawnTerminal(a,t,r){const s=t.linuxExec?Promise.resolve(t.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(l=>{const $=b(process),P=a.spawn(l,[],{cwd:r,env:$});P.on("error",o),P.on("exit",()=>i())})})}}e.$kdc=w;function b(S){const a={...S.env};return(0,E.$om)(a),a}function f(S){return"errno"in S&&S.errno==="ENOENT"&&"path"in S&&typeof S.path=="string"?new Error(g.localize(5,null,S.path)):S}function h(S){let a="";for(const t of S)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(se[16],re([0,1,59,9,25,12,7,178,6,4,13,62]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=v,e.$7k=w,e.$8k=f,e.$9k=h,e.$0k=S,e.$$k=a,e.$_k=t,e.$al=r,e.$bl=s,e.$cl=i,e.$dl=o,e.$fl=P,e.$gl=D,e.$hl=I,e.$il=O,e.$jl=M,e.$ml=ae,e.$yl=L,e.$zl=B,e.$Bl=oe,e.$5k=(0,u.$yi)("fileService");function v(G){return G.create===!0}var m;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var d;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(d||(e.FilePermission=d={}));var y;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function w(G){const le=G;return!!le&&typeof le.onDidChange=="function"}var b;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})(b||(e.FileSystemProviderCapabilities=b={}));function f(G){return!!(G.capabilities&2)}function h(G){return!!(G.capabilities&8)}function S(G){return!!(G.capabilities&131072)}function a(G){return!!(G.capabilities&4)}function t(G){return!!(G.capabilities&16)}function r(G){return f(G)?!!(G.capabilities&16384):!1}function s(G){return f(G)?!!(G.capabilities&32768):!1}function i(G){return!!(G.capabilities&65536)}function o(G){return!!(G.capabilities&2048)}var l;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class $ extends Error{static create(le,Q){const A=new $(le.toString(),Q);return I(A,Q),A}constructor(le,Q){super(le),this.code=Q}}e.$el=$;function P(G,le){return $.create(G,le)}function D(G){return G||P((0,E.localize)(0,null),l.Unknown)}function I(G,le){return G.name=le?`${le} (FileSystemError)`:"FileSystemError",G}function O(G){if(!G)return l.Unknown;if(G instanceof $)return G.code;const le=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!le)return l.Unknown;switch(le[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function M(G){if(G instanceof te)return G.fileOperationResult;switch(O(G)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}var W;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class F{constructor(le,Q,A){this.resource=le,this.operation=Q,this.target=A}isOperation(le){return this.operation===le}}e.$kl=F;var T;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class U{static{this.a=null}constructor(le,Q){this.c=Q,this.b=void 0,this.d=new p.$V(()=>{const A=n.$Ei.forUris(()=>this.c);return A.fill(this.rawAdded.map(N=>[N,!0])),A}),this.f=new p.$V(()=>{const A=n.$Ei.forUris(()=>this.c);return A.fill(this.rawUpdated.map(N=>[N,!0])),A}),this.g=new p.$V(()=>{const A=n.$Ei.forUris(()=>this.c);return A.fill(this.rawDeleted.map(N=>[N,!0])),A}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const A of le){switch(A.type){case 1:this.rawAdded.push(A.resource);break;case 0:this.rawUpdated.push(A.resource);break;case 2:this.rawDeleted.push(A.resource);break}this.b!==U.a&&(typeof A.cId=="number"?this.b===void 0?this.b=A.cId:this.b!==A.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(le,...Q){return this.h(le,{includeChildren:!1},...Q)}affects(le,...Q){return this.h(le,{includeChildren:!0},...Q)}h(le,Q,...A){if(!le)return!1;const N=A.length>0;return!!((!N||A.includes(1))&&(this.d.value.get(le)||Q.includeChildren&&this.d.value.findSuperstr(le))||(!N||A.includes(0))&&(this.f.value.get(le)||Q.includeChildren&&this.f.value.findSuperstr(le))||(!N||A.includes(2))&&(this.g.value.findSubstr(le)||Q.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$ll=U;function ae(G,le,Q){return!G||!le||G===le||le.length>G.length?!1:(le.charAt(le.length-1)!==C.sep&&(le+=C.sep),Q?(0,k.$Af)(G,le):G.indexOf(le)===0)}class te extends Error{constructor(le,Q,A){super(le),this.fileOperationResult=Q,this.options=A}}e.$nl=te;class ce extends te{constructor(le,Q,A,N){super(le,Q,N),this.fileOperationResult=Q,this.size=A}}e.$ol=ce;class J extends te{constructor(le,Q,A){super(le,2,A),this.stat=Q}}e.$pl=J;var V;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var q;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(q||(e.FileKind=q={})),e.$xl="";function L(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function B(G,le){if(!le.hasProvider(j.URI.from({scheme:G.scheme})))return new Promise(Q=>{const A=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===G.scheme&&N.added&&(A.dispose(),Q())})})}class H{static{this.KB=1024}static{this.MB=H.KB*H.KB}static{this.GB=H.MB*H.KB}static{this.TB=H.GB*H.KB}static formatSize(le){return(0,R.$cg)(le)||(le=0),le<H.KB?(0,E.localize)(1,null,le.toFixed(0)):le<H.MB?(0,E.localize)(2,null,(le/H.KB).toFixed(2)):le<H.GB?(0,E.localize)(3,null,(le/H.MB).toFixed(2)):le<H.TB?(0,E.localize)(4,null,(le/H.GB).toFixed(2)):(0,E.localize)(5,null,(le/H.TB).toFixed(2))}}e.$Al=H;function oe(G){const le=typeof G=="string"||G?.scheme===g.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===g.Schemas.file?1024*H.MB:le?10*H.MB:c.$o?50*H.MB:1024*H.MB}}),define(se[122],re([0,1,17,15,179,16]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=j;async function j(g,p,v,m,d,y){let w;try{await E(g,p,v,m,d,y)}catch(b){w=b}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w<"u"&&v.error(w),v.end()}}async function E(g,p,v,m,d,y){u(y);const w=await g.open(p,{create:!1});try{u(y);let b=0,f=0,h=d&&typeof d.length=="number"?d.length:void 0,S=n.$He.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),a=d&&typeof d.position=="number"?d.position:0,t=0;do f=await g.read(w,a,S.buffer,t,S.byteLength-t),a+=f,t+=f,b+=f,typeof h=="number"&&(h-=f),t===S.byteLength&&(await v.write(m(S)),S=n.$He.alloc(Math.min(d.bufferSize,typeof h=="number"?h:d.bufferSize)),t=0);while(f>0&&(typeof h!="number"||h>0)&&u(y)&&c(b,d));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),v.write(m(S.slice(0,r)))}}catch(b){throw(0,R.$gl)(b)}finally{await g.close(w)}}function u(g){if(g.isCancellationRequested)throw(0,C.$6)();return!0}function c(g,p){if(typeof p?.limits?.size=="number"&&g>p.limits.size)throw(0,R.$fl)((0,k.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[60],re([0,1,108,2,9,4,7,16]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=void 0,e.$Nq=u,e.$Oq=c,e.$Sq=m,e.$Tq=d,e.$Uq=y,e.$Vq=w,e.$Wq=f,e.$Xq=h;function u(S){return typeof S.correlationId=="number"}function c(S){return S.recursive===!0}class g extends C.$Uc{static{this.a=5}constructor(a,t,r,s){super(),this.h=a,this.j=t,this.m=r,this.n=s,this.c=this.B(new C.$Vc),this.f=void 0,this.g=0}s(){const a=new C.$Tc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(t=>this.h(t))),a.add(this.b.onDidLogMessage(t=>this.j(t))),a.add(this.b.onDidError(t=>this.t(t)))}t(a){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pq=g;class p extends g{constructor(a,t,r){super(a,t,r,{type:"node.js",restartOnError:!1})}}e.$Qq=p;class v extends g{constructor(a,t,r){super(a,t,r,{type:"universal",restartOnError:!0})}}e.$Rq=v;function m(S){return S.map(a=>({type:a.type,resource:j.URI.revive(a.resource),cId:a.cId}))}function d(S){const a=new b;for(const t of S)a.processEvent(t);return a.coalesce()}function y(S,a){return typeof a=="string"&&!a.startsWith(n.$ok)&&!(0,k.$ic)(a)?{base:S,pattern:a}:a}function w(S,a){const t=[];for(const r of a)t.push((0,n.$sk)(y(S,r)));return t}class b{constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.b.get(this.c(a));let r=!1;if(t){const s=t.type,i=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?r=!0:s===1&&i===2?(this.b.delete(this.c(a)),this.a.delete(t)):s===2&&i===1?t.type=0:s===1&&i===0||(t.type=i)}else r=!0;r&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(a.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,E.$ml)(r.resource.fsPath,s,!R.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(a)}}function f(S,a){if(typeof a=="number")switch(S.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function h(S){if(typeof S=="number"){const a=[];return S&4&&a.push("Added"),S&8&&a.push("Deleted"),S&2&&a.push("Updated"),a.length===0?"<all>":`[${a.join(", ")}]`}return"<none>"}}),define(se[216],re([0,1,17,47,15,3,2,63,33,16,60]),function(K,e,n,C,k,R,j,E,u,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0,e.$VP="localFilesystem";class p extends j.$Uc{constructor(m,d){super(),this.a=m,this.b=d,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$fe),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$fe),this.onDidWatchError=this.g.event,this.h=(0,u.$Ug)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,d){const{buffer:y}=await this.a.call("readFile",[m,d]);return y}readFileStream(m,d,y){const w=(0,E.$ve)(f=>n.$He.concat(f.map(h=>n.$He.wrap(h))).buffer),b=new j.$Tc;return b.add(this.a.listen("readFileStream",[m,d])(f=>{if(f instanceof n.$He)w.write(f.buffer);else{if(f==="end")w.end();else{let h;if(f instanceof Error)h=f;else{const S=f;h=(0,c.$fl)(S.message??(0,C.$jj)(S),S.code??c.FileSystemProviderErrorCode.Unknown)}w.error(h),w.end()}b.dispose()}})),b.add(y.onCancellationRequested(()=>{w.error((0,k.$6)()),w.end(),b.dispose()})),w}writeFile(m,d,y){return this.a.call("writeFile",[m,n.$He.wrap(d),y])}open(m,d){return this.a.call("open",[m,d])}close(m){return this.a.call("close",[m])}async read(m,d,y,w,b){const[f,h]=await this.a.call("read",[m,d,b]);return y.set(f.buffer.slice(0,h),w),h}write(m,d,y,w,b){return this.a.call("write",[m,d,n.$He.wrap(y),w,b])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,d){return this.a.call("delete",[m,d])}rename(m,d,y){return this.a.call("rename",[m,d,y])}copy(m,d,y){return this.a.call("copy",[m,d,y])}cloneFile(m,d){return this.a.call("cloneFile",[m,d])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const d=m;this.f.fire((0,g.$Sq)(d))}else{const d=m;this.g.fire(d)}}))}watch(m,d){const y=(0,u.$Ug)();return this.a.call("watch",[this.h,y,m,d]),(0,j.$Sc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$WP=p}),define(se[217],re([0,1,43,2,60,3,7,8]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class u extends C.$Uc{constructor(){super(),this.a=this.B(new R.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new C.$4c),this.m=new Set,this.n=5007,this.r=new E.$Vh,this.P=!1,this.B(this.f(g=>this.s(g)))}s(g){this.t(g)&&this.w(g)}t(g){return(0,k.$Nq)(g)}async watch(g){this.r.isSettled||this.r.complete(),this.r=new E.$Vh;try{this.h.clear(),this.g.clear();for(const p of g)this.t(p)?this.h.set(p.correlationId,p):this.g.add(p);for(const[p]of this.j)this.h.has(p)||(this.j.deleteAndDispose(p),this.m.delete(p));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(g=>!this.j.has(g.correlationId))])}isSuspended(g){return typeof g.correlationId!="number"?!1:this.m.has(g.correlationId)?"polling":this.j.has(g.correlationId)}async w(g){if(this.j.has(g.correlationId))return;const p=new C.$Tc;this.j.set(g.correlationId,p),await this.r.p,!p.isDisposed&&(this.z(g,p),this.u())}y(g){this.j.deleteAndDispose(g.correlationId),this.m.delete(g.correlationId),this.u()}z(g,p){this.C(g,p)?(this.N(`reusing an existing recursive watcher to monitor ${g.path}`),this.m.delete(g.correlationId)):(this.D(g,p),this.m.add(g.correlationId))}C(g,p){const v=this.M?.subscribe(g.path,(m,d)=>{p.isDisposed||(m?this.z(g,p):d?.type===1&&this.F(g))});return v?(p.add(v),!0):!1}D(g,p){let v=!1;const m=(d,y)=>{if(p.isDisposed)return;const w=this.G(d),b=this.G(y),f=v;v=w,!w&&(b||f)&&this.F(g)};this.N(`starting fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,n.watchFile)(g.path,{persistent:!1,interval:this.n},m)}catch(d){this.O(`fs.watchFile() failed with error ${d} on path ${g.path} (correlationId: ${g.correlationId})`)}p.add((0,C.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${g.path} (correlationId: ${g.correlationId})`);try{(0,n.unwatchFile)(g.path,m)}catch(d){this.O(`fs.unwatchFile() failed with error ${d} on path ${g.path} (correlationId: ${g.correlationId})`)}}))}F(g){this.N(`detected ${g.path} exists again, resuming watcher (correlationId: ${g.correlationId})`);const p={resource:j.URI.file(g.path),type:1,cId:g.correlationId};this.a.fire([p]),this.H(p,g),this.y(g)}G(g){return g.ctimeMs===0&&g.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(g,p){if(this.P){const v=` >> normalized ${g.type===1?"[ADDED]":g.type===2?"[DELETED]":"[CHANGED]"} ${g.resource.fsPath}`;this.I(v,p)}}I(g,p){this.P&&this.N(`${g}${typeof p.correlationId=="number"?` <${p.correlationId}> `:""}`)}J(g){return`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"}, filter: ${(0,k.$Xq)(g.filter)}, correlationId: ${typeof g.correlationId=="number"?g.correlationId:"<none>"})`}async setVerboseLogging(g){this.P=g}}e.$7q=u}),define(se[218],re([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,e.$ar=w;class y extends j.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(f,h,S,a,t,r){super(),this.s=f,this.t=h,this.u=S,this.w=a,this.y=t,this.z=r,this.c=this.B(new C.$Nh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new C.$Mh(s=>this.M(s),y.b)),this.g=(0,d.$Vq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,d.$Vq)(this.s.path,this.s.includes):void 0,this.j=(0,d.$Nq)(this.s)?this.s.filter:void 0,this.m=new k.$qe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const f=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const h=await m.Promises.stat(f);if(this.m.token.isCancellationRequested)return;this.B(await this.G(f,h.isDirectory()))}catch(f){f.code!=="ENOENT"?this.O(f):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${f})`),this.D()}}D(){this.r=!0,this.w?.()}async F(f){let h=f.path;try{h=await m.Promises.realpath(f.path),f.path===h&&(h=await(0,v.$9q)(f.path,this.m.token)??f.path),f.path!==h&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${h})`)}catch{}return h}async G(f,h){const S=new j.$Tc;return this.H(f,h,S)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(f,h,S)),S}H(f,h,S){if(h)return!1;const a=p.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!S.isDisposed)if(r){const i=await this.G(f,h);S.isDisposed?i.dispose():S.add(i)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:s.type,cId:this.s.correlationId},!0)});return t?(S.add(t),!0):!1}async I(f,h,S){if(c.$j&&(0,R.$xg)(f,"/Volumes/",!0)){this.O(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new k.$qe(this.m.token);S.add((0,j.$Sc)(()=>a.dispose(!0)));const t=new j.$Tc;S.add(t);try{const r=p.URI.file(this.s.path),s=(0,u.$nc)(f),i=(0,n.watch)(f);t.add((0,j.$Sc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${f}'`);const o=new Set;if(h)try{for(const $ of await m.Promises.readdir(f))o.add($)}catch($){this.O($)}if(a.token.isCancellationRequested)return;const l=new Map;t.add((0,j.$Sc)(()=>{for(const[,$]of l)$.dispose();l.clear()})),i.on("error",($,P)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${f} for changes using fs.watch() (${$}, ${P})`),this.D())}),i.on("change",($,P)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${$}"] ${P}`);let D="";if(P&&(D=P.toString(),c.$j&&(D=(0,E.$dm)(D))),!(!D||$!=="change"&&$!=="rename"))if(h)if($==="rename"){l.get(D)?.dispose();const I=setTimeout(async()=>{if(l.delete(D),D===s&&!await m.Promises.exists(f)){this.J(r);return}if(a.token.isCancellationRequested)return;const O=await this.N((0,u.$jc)(f,D));if(a.token.isCancellationRequested)return;let M;O?o.has(D)?M=0:(M=1,o.add(D)):(o.delete(D),M=2),this.L({resource:(0,g.$_g)(r,D),type:M,cId:this.s.correlationId})},y.a);l.set(D,(0,j.$Sc)(()=>clearTimeout(I)))}else{let I;o.has(D)?I=0:(I=1,o.add(D)),this.L({resource:(0,g.$_g)(r,D),type:I,cId:this.s.correlationId})}else if($==="rename"||D!==s){const I=setTimeout(async()=>{const O=await m.Promises.exists(f);a.token.isCancellationRequested||(O?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(f,!1))):this.J(r))},y.a);t.clear(),t.add((0,j.$Sc)(()=>clearTimeout(I)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){a.token.isCancellationRequested||this.O(`Failed to watch ${f} for changes using fs.watch() (${r.toString()})`),this.D()}}J(f){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:f,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(f,h=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!h&&this.g.some(S=>S(f.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${f.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(S=>S(f.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}M(f){const h=(0,d.$Tq)(f),S=[];for(const t of h){if((0,d.$Wq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}S.push(t)}if(S.length===0)return;if(this.z)for(const t of S)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(S)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${S[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${S.length}, most recent change: ${S[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(f){if(c.$k)return m.Promises.exists(f);try{const h=(0,u.$nc)(f);return(await m.Promises.readdir((0,u.$mc)(f))).some(a=>a===h)}catch(h){return this.Q(h),!1}}setVerboseLogging(f){this.z=f}O(f){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}P(f){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}Q(f){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}R(f){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${f}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$_q=y;async function w(b,f,h,S,a=512){const t=await m.Promises.open(b,"r"),r=Buffer.allocUnsafe(a),s=new k.$qe(S);let i,o=!1;const l={path:b,excludes:[],recursive:!1},$=new y(l,void 0,P=>{(async()=>{for(const{type:D}of P)if(D===0){if(o)return;o=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(t,r,0,a,null);if(!I||s.token.isCancellationRequested)break;f(r.slice(0,I))}}catch(I){i=new Error(I),s.dispose(!0)}finally{o=!1}}})()});return await $.ready,h(),new Promise((P,D)=>{s.token.onCancellationRequested(async()=>{$.dispose();try{await m.Promises.close(t)}catch(I){i=new Error(I)}i?D(i):P()})})}}),define(se[219],re([0,1,3,108,217,4,218,31]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class u extends k.$7q{constructor(g){super(),this.M=g,this.onDidError=n.Event.None,this.watchers=new Set}async L(g){g=this.X(g);const p=[],v=new Set(Array.from(this.watchers));for(const m of g){const d=this.S(m);d&&(0,C.$wk)(d.request.excludes,m.excludes)&&(0,C.$wk)(d.request.includes,m.includes)?v.delete(d):p.push(m)}p.length&&this.N(`Request to start watching: ${p.map(m=>this.J(m)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map(m=>this.J(m.request)).join(",")}`);for(const m of v)this.W(m);for(const m of p)this.U(m)}S(g){for(const p of this.watchers)if(typeof g.correlationId=="number"||typeof p.request.correlationId=="number"){if(p.request.correlationId===g.correlationId)return p}else if((0,E.$wg)(p.request.path,g.path,!R.$k))return p}U(g){const p=new j.$_q(g,this.M,m=>this.a.fire(m),()=>this.c.fire(g),m=>this.b.fire(m),this.P),v={request:g,instance:p};this.watchers.add(v)}async stop(){await super.stop();for(const g of this.watchers)this.W(g)}W(g){this.N("stopping file watcher",g),this.watchers.delete(g),g.instance.dispose()}X(g){const p=new Map;for(const v of g){const m=R.$k?v.path:v.path.toLowerCase();let d=p.get(v.correlationId);d||(d=new Map,p.set(v.correlationId,d)),d.has(m)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),d.set(m,v)}return Array.from(p.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(g){super.setVerboseLogging(g);for(const p of this.watchers)p.instance.setVerboseLogging(g)}N(g,p){this.P&&this.b.fire({type:"trace",message:this.$(g,p)})}O(g){this.b.fire({type:"warn",message:this.$(g)})}$(g,p){return p?`[File Watcher (node.js)] ${g} (${this.J(p.request)})`:`[File Watcher (node.js)] ${g}`}}e.$br=u}),define(se[220],re([0,1,60,219]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class k extends n.$Qq{constructor(j,E,u){super(j,E,u),this.s()}r(j){return j.add(new C.$br(void 0))}}e.$cr=k}),define(se[221],re([0,1,13,44,162,60]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class j extends R.$Rq{constructor(u,c,g){super(u,c,g),this.s()}r(u){const c=u.add(new k.$5q(n.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(c.onDidProcessExit(({code:g,signal:p})=>this.t(`terminated by itself with code ${g}, signal: ${p} (ETERM)`))),C.ProxyChannel.toService((0,C.$fi)(c.getChannel("watcher")))}}e.$6q=j}),define(se[93],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class n{constructor(...k){this.a=new Map;for(const[R,j]of k)this.set(R,j)}set(k,R){const j=this.a.get(k);return this.a.set(k,R),j}has(k){return this.a.has(k)}get(k){return this.a.get(k)}}e.$wi=n}),define(se[222],re([0,1,8,15,2,78,211,6,93,104]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;const g=!1;class p extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class v{constructor(w=new u.$wi,b=!1,f,h=g){this.i=w,this.j=b,this.k=f,this.l=h,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(E.$xi,this),this._globalGraph=h?f?._globalGraph??new j.$fr(S=>S):void 0}dispose(){if(!this.f){this.f=!0,(0,k.$Pc)(this.h),this.h.clear();for(const w of this.g)(0,k.$Oc)(w)&&w.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(w){this.m();const b=new class extends v{dispose(){this.h.delete(b),super.dispose()}}(w,this.j,this,this.l);return this.h.add(b),b}invokeFunction(w,...b){this.m();const f=d.traceInvocation(this.l,w);let h=!1;try{return w({get:a=>{if(h)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,f);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...b)}finally{h=!0,f.stop()}}createInstance(w,...b){this.m();let f,h;return w instanceof R.$vi?(f=d.traceCreation(this.l,w.ctor),h=this.o(w.ctor,w.staticArguments.concat(b),f)):(f=d.traceCreation(this.l,w),h=this.o(w,b,f)),f.stop(),h}o(w,b=[],f){const h=E._util.getServiceDependencies(w).sort((t,r)=>t.index-r.index),S=[];for(const t of h){const r=this.s(t.id,f);r||this.y(`[createInstance] ${w.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(r)}const a=h.length>0?h[0].index:b.length;if(b.length!==a){console.trace(`[createInstance] First service dependency of ${w.name} at position ${a+1} conflicts with ${b.length} static arguments`);const t=a-b.length;t>0?b=b.concat(new Array(t)):b=b.slice(0,a)}return Reflect.construct(w,b.concat(S))}q(w,b){if(this.i.get(w)instanceof R.$vi)this.i.set(w,b);else if(this.k)this.k.q(w,b);else throw new Error("illegalState - setting UNKNOWN service instance")}r(w){const b=this.i.get(w);return!b&&this.k?this.k.r(w):b}s(w,b){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.r(w);return f instanceof R.$vi?this.u(w,f,b.branch(w,!0)):(b.branch(w,!1),f)}u(w,b,f){if(this.t.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.t.add(w);try{return this.v(w,b,f)}finally{this.t.delete(w)}}v(w,b,f){const h=new j.$fr(t=>t.id.toString());let S=0;const a=[{id:w,desc:b,_trace:f}];for(;a.length;){const t=a.pop();if(h.lookupOrInsertNode(t),S++>1e3)throw new p(h);for(const r of E._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${w} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof R.$vi){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,i),a.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new p(h);break}for(const{data:r}of t){if(this.r(r.id)instanceof R.$vi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}h.removeNode(r)}}return this.r(w)}w(w,b,f=[],h,S){if(this.i.get(w)instanceof R.$vi)return this.x(w,b,f,h,S,this.g);if(this.k)return this.k.w(w,b,f,h,S);throw new Error(`illegalState - creating UNKNOWN service instance ${b.name}`)}x(w,b,f=[],h,S,a){if(h){const t=new v(void 0,this.j,this,this.l);t.c=String(w);const r=new Map,s=new n.$Rh(()=>{const i=t.o(b,f,S);for(const[o,l]of r){const $=i[o];if(typeof $=="function")for(const P of l)P.disposable=$.apply(i,P.listener)}return r.clear(),a.add(i),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let P=r.get(o);return P||(P=new c.$5c,r.set(o,P)),(I,O,M)=>{if(s.isInitialized)return s.value[o](I,O,M);{const W={listener:[I,O,M],disposable:void 0},F=P.push(W);return(0,k.$Sc)(()=>{F(),W.disposable?.dispose()})}}}if(o in i)return i[o];const l=s.value;let $=l[o];return typeof $!="function"||($=$.bind(l),i[o]=$),$},set(i,o,l){return s.value[o]=l,!0},getPrototypeOf(i){return b.prototype}})}else{const t=this.o(b,f,S);return a.add(t),t}}y(w,b){if(b&&console.warn(w),this.j)throw new Error(w)}}e.$gr=v;var m;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(m||(m={}));class d{static{this.all=new Set}static{this.c=new class extends d{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,b){return w?new d(2,b.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):d.c}static traceCreation(w,b){return w?new d(1,b.name):d.c}static{this.f=0}constructor(w,b){this.type=w,this.name=b,this.g=Date.now(),this.h=[]}branch(w,b){const f=new d(3,w.toString());return this.h.push([w,b,f]),f}stop(){const w=Date.now()-this.g;d.f+=w;let b=!1;function f(S,a){const t=[],r=new Array(S+1).join("	");for(const[s,i,o]of a.h)if(i&&o){b=!0,t.push(`${r}CREATES -> ${s}`);const l=f(S+1,o);l&&t.push(l)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${d.f.toFixed(2)}ms)`];(w>2||b)&&d.all.add(h.join(`
`))}}e.$hr=d}),define(se[223],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CKb=e.IssueSource=e.IssueType=void 0;var C;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={}));var k;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(k||(e.IssueSource=k={})),e.$CKb=(0,n.$yi)("issueService")}),define(se[5],re([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=y,e.log=b,e.$gk=$,e.$hk=P,e.$ik=D,e.$jk=I,e.$5j=(0,m.$yi)("logService"),e.$6j=(0,m.$yi)("loggerService");function d(){return new Date().toISOString()}function y(O){return(0,g.$cg)(O)}var w;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$8j=w.Info;function b(O,M,W){switch(M){case w.Trace:O.trace(W);break;case w.Debug:O.debug(W);break;case w.Info:O.info(W);break;case w.Warning:O.warn(W);break;case w.Error:O.error(W);break;case w.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function f(O,M=!1){let W="";for(let F=0;F<O.length;F++){let T=O[F];if(T instanceof Error&&(T=(0,C.$jj)(T,M)),typeof T=="object")try{T=JSON.stringify(T)}catch{}W+=(F>0?" ":"")+T}return W}class h extends j.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new k.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==w.Off&&this.b<=M}}e.$0j=h;class S extends h{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...W){this.f(w.Trace)&&this.g(w.Trace,f([M,...W],!0))}debug(M,...W){this.f(w.Debug)&&this.g(w.Debug,f([M,...W]))}info(M,...W){this.f(w.Info)&&this.g(w.Info,f([M,...W]))}warn(M,...W){this.f(w.Warning)&&this.g(w.Warning,f([M,...W]))}error(M,...W){if(this.f(w.Error))if(M instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=M.stack,this.g(w.Error,f(F))}else this.g(w.Error,f([M,...W]))}flush(){}}e.$$j=S;class a extends h{constructor(M=e.$8j){super(),this.setLevel(M),this.g=!u.$i}trace(M,...W){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...W):console.log(`[main ${d()}]`,M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...W):console.log(`[main ${d()}]`,M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${d()}]\x1B[0m`,M,...W):console.log(`[main ${d()}]`,M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${d()}]\x1B[0m`,M,...W):console.warn(`[main ${d()}]`,M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${d()}]\x1B[0m`,M,...W):console.error(`[main ${d()}]`,M,...W))}flush(){}}e.$_j=a;class t extends h{constructor(M=e.$8j,W=!0){super(),this.g=W,this.setLevel(M)}trace(M,...W){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...W):console.log(M,...W))}debug(M,...W){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...W):console.log(M,...W))}info(M,...W){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...W):console.log(M,...W))}warn(M,...W){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...W):console.log(M,...W))}error(M,...W){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...W):console.error(M,...W))}flush(){}}e.$ak=t;class r extends h{constructor(M,W=e.$8j){super(),this.g=M,this.setLevel(W)}trace(M,...W){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(M),...W])}debug(M,...W){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(M),...W])}info(M,...W){this.f(w.Info)&&this.g.log(w.Info,[this.h(M),...W])}warn(M,...W){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(M),...W])}error(M,...W){this.f(w.Error)&&this.g.log(w.Error,[this.h(M),...W])}h(M){return typeof M=="string"?M:(0,C.$jj)(M,this.f(w.Trace))}flush(){}}e.$bk=r;class s extends h{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const W of this.g)W.setLevel(M);super.setLevel(M)}trace(M,...W){for(const F of this.g)F.trace(M,...W)}debug(M,...W){for(const F of this.g)F.debug(M,...W)}info(M,...W){for(const F of this.g)F.info(M,...W)}warn(M,...W){for(const F of this.g)F.warn(M,...W)}error(M,...W){for(const F of this.g)F.error(M,...W)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$ck=s;class i extends j.$Uc{constructor(M,W,F){if(super(),this.h=M,this.j=W,this.b=new E.$Ac,this.c=this.B(new k.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new k.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new k.$fe),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(M){return(0,g.$$f)(M)?[...this.b.values()].find(W=>W.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,W){const F=this.n(M),T=(0,g.$$f)(M)?M:W?.id??(0,R.$mj)(F.toString()).toString(16);let U=this.b.get(F)?.logger;const ae=W?.logLevel==="always"?w.Trace:W?.logLevel;U||(U=this.s(F,ae??this.getLogLevel(F)??this.h,{...W,id:T}));const te={logger:U,info:{resource:F,id:T,logLevel:ae,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(te.info),this.b.set(F,te),U}n(M){return(0,g.$$f)(M)?(0,c.$_g)(this.j,`${M}.log`):M}setLogLevel(M,W){if(p.URI.isUri(M)){const F=M,T=W,U=this.b.get(F);U&&T!==U.info.logLevel&&(U.info.logLevel=T===this.h?void 0:T,U.logger?.setLevel(T),this.b.set(U.info.resource,U),this.f.fire([F,T]))}else{this.h=M;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,W){const F=this.m(M);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(M){let W;return M&&(W=this.b.get(M)?.info.logLevel),W??this.h}registerLogger(M){const W=this.b.get(M.resource);W?W.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const W=this.b.get(M);W&&(W.logger&&W.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=i;class o{constructor(){this.onDidChangeLogLevel=new k.$fe().event}setLevel(M){}getLevel(){return w.Info}trace(M,...W){}debug(M,...W){}info(M,...W){}warn(M,...W){}error(M,...W){}critical(M,...W){}dispose(){}flush(){}}e.$ek=o;class l extends o{}e.$fk=l;function $(O){if(O.verbose)return w.Trace;if(typeof O.logLevel=="string"){const M=I(O.logLevel.toLowerCase());if(M!==void 0)return M}return e.$8j}function P(O){switch(O){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}function D(O){switch(O){case w.Trace:return{original:"Trace",value:n.localize(0,null)};case w.Debug:return{original:"Debug",value:n.localize(1,null)};case w.Info:return{original:"Info",value:n.localize(2,null)};case w.Warning:return{original:"Warning",value:n.localize(3,null)};case w.Error:return{original:"Error",value:n.localize(4,null)};case w.Off:return{original:"Off",value:n.localize(5,null)}}}function I(O){switch(O){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$kk=new v.$Pj("logLevel",P(w.Info))});var ie=this&&this.__param||function(K,e){return function(n,C){e(n,C,K)}};define(se[224],re([0,1,14,4,5]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ddc=void 0;const R=n.safeStorage;let j=class{constructor(u){this.a=u,n.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(u){this.a.trace("[EncryptionMainService] Encrypting value.");try{const c=JSON.stringify(R.encryptString(u));return this.a.trace("[EncryptionMainService] Encrypted value."),c}catch(c){throw this.a.error(c),c}}async decrypt(u){let c;try{if(c=JSON.parse(u),!c.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${u}`);const g=Buffer.from(c.data);this.a.trace("[EncryptionMainService] Decrypting value.");const p=R.decryptString(g);return this.a.trace("[EncryptionMainService] Decrypted value."),p}catch(g){throw this.a.error(g),g}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const u=R.getSelectedStorageBackend();return Promise.resolve(u)}catch(u){this.a.error(u)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$ddc=j,e.$ddc=j=Ee([ie(0,k.$5j)],j)}),define(se[225],re([0,1,22,8,15,3,31,2,9,60,5]),function(K,e,n,C,k,R,j,E,u,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class p extends E.$Uc{constructor(m,d){super(),this.a=m,this.b=d,this.c=this.B(new R.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$wh(0)),this.w=[],this.y=this.B(new C.$wh(0))}watch(m,d){return d.recursive||this.b?.watcher?.forceUniversal?this.n(m,d):this.z(m,d)}n(m,d){const y={path:this.J(m),excludes:d.excludes,includes:d.includes,recursive:d.recursive,filter:d.filter,correlationId:d.correlationId},w=(0,n.$Tb)(this.j,y);return this.r(),(0,E.$Sc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,k.$1)(m))}s(){this.h||(this.h=this.B(this.t(d=>this.c.fire((0,c.$Sq)(d)),d=>this.G(d),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const d of this.j)(0,c.$Oq)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const d of this.j)(0,c.$Oq)(d)&&m.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,d){const y={path:this.J(m),excludes:d.excludes,includes:d.includes,recursive:!1,filter:d.filter,correlationId:d.correlationId},w=(0,n.$Tb)(this.w,y);return this.C(),(0,E.$Sc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,k.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,c.$Sq)(m)),m=>this.G(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,u.$hc)(m.fsPath)}J(m){const d=this.I(m);return(0,j.$Ag)(d)}}e.$Yq=p}),define(se[226],re([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let a=class extends c.$Uc{static{S=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new j.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$fe),this.Y=this.B(new j.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$Hh)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const i=new c.$Tc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),i.add(s.onDidChangeFile(o=>{const l=new w.$ll(o,!this.S(s));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(o=>this.Z.fire(new Error(o)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,c.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,c.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(i){s.push(i)}}),!this.h.has(r)&&await C.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return u.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,m.$dh)(r))throw new w.$nl((0,y.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const i=new h.$bb;throw i.message=(0,y.localize)(1,null,r.toString()),i}return s}async m(r){const s=await this.j(r);if((0,w.$$k)(s)||(0,w.$8k)(s)||(0,w.$_k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,w.$$k)(s)||(0,w.$8k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(i){throw(0,w.$il)(i)===w.FileSystemProviderErrorCode.FileNotFound?new w.$nl((0,y.localize)(2,null,this.sb(r)),1):(0,w.$gl)(i)}}async s(r,s){const i=await this.j(r),o=this.S(i),l=s?.resolveTo,$=s?.resolveSingleChildDescendants,P=s?.resolveMetadata,D=await i.stat(r);let I;return this.t(i,r,D,void 0,!!P,(O,M)=>(I||(I=g.$Ei.forUris(()=>!o),I.set(r,!0),l&&I.fill(!0,l)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&$?M===1:!1))}async t(r,s,i,o,l,$){const{providerExtUri:P}=this.R(r),D={resource:s,name:P.basename(s),isFile:(i.type&w.FileType.File)!==0,isDirectory:(i.type&w.FileType.Directory)!==0,isSymbolicLink:(i.type&w.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&w.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&w.FilePermission.Locked),etag:(0,w.$yl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&$(D,o)){try{const I=await r.readdir(s),O=await C.Promises.settled(I.map(async([M,W])=>{try{const F=P.joinPath(s,M),T=l?await r.stat(F):{type:W};return await this.t(r,F,T,I.length,l,$)}catch(F){return this.b.trace(F),null}}));D.children=(0,n.$Hb)(O)}catch(I){this.b.trace(I),D.children=[]}return D}return D}async resolveAll(r){return C.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),i=await s.stat(r);return this.t(s,r,i,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(i){return i}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new w.$nl((0,y.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=k.$He.fromString(""),i){await this.u(r,i);const o=await this.writeFile(r,s);return this.r.fire(new w.$kl(r,0,o)),o}async writeFile(r,s,i){const o=this.qb(await this.n(r),r),{providerExtUri:l}=this.R(o);let $=i;if((0,w.$bl)(o)&&!$?.atomic){const P=o.enforceAtomicWriteFile?.(r);P&&($={...i,atomic:P})}try{await this.w(o,r,$)||await this.U(o,l.dirname(r));let D;if((0,w.$8k)(o)&&!(s instanceof k.$He))if((0,d.$te)(s)){const I=await(0,d.$Ae)(s,3);I.ended?D=k.$He.concat(I.buffer):D=I}else D=(0,d.$xe)(s,I=>k.$He.concat(I),3);else D=s;!(0,w.$$k)(o)||(0,w.$8k)(o)&&D instanceof k.$He||(0,w.$8k)(o)&&(0,w.$bl)(o)&&$?.atomic?await this.hb(o,r,$,D):await this.db(o,r,$,D instanceof k.$He?(0,k.$Se)(D):D),this.r.fire(new w.$kl(r,4))}catch(P){throw new w.$nl((0,y.localize)(4,null,this.sb(r),(0,w.$gl)(P).toString()),(0,w.$jl)(P),$)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,i){const o=!!i?.unlock;if(o&&!(r.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(o)throw new Error((0,y.localize)(8,null,this.sb(s)))}let $;try{$=await r.stat(s)}catch{return}if($.type&w.FileType.Directory)throw new w.$nl((0,y.localize)(9,null,this.sb(s)),0,i);if(this.rb(s,$),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==w.$xl&&typeof $.mtime=="number"&&typeof $.size=="number"&&i.mtime<$.mtime&&i.etag!==(0,w.$yl)({mtime:i.mtime,size:$.size}))throw new w.$nl((0,y.localize)(10,null),3,i);return $}async readFile(r,s,i){const o=await this.m(r);return s?.atomic?this.z(o,r,s,i):this.C(o,r,s,i)}async z(r,s,i,o){return new Promise((l,$)=>{this.cb.queueFor(s,async()=>{try{const P=await this.C(r,s,i,o);l(P)}catch(P){$(P)}},this.R(r).providerExtUri)})}async C(r,s,i,o){const l=await this.D(r,s,{...i,preferUnbuffered:!0},o);return{...l,value:await(0,k.$Te)(l.value)}}async readFileStream(r,s,i){const o=await this.m(r);return this.D(o,r,s,i)}async D(r,s,i,o){const l=new R.$qe(o);let $=i;(0,w.$al)(r)&&r.enforceAtomicReadFile?.(s)&&($={...i,atomic:!0});const P=this.J(s,$).then(I=>I,I=>{throw l.dispose(!0),I});let D;try{return typeof $?.etag=="string"&&$.etag!==w.$xl&&await P,$?.atomic&&(0,w.$al)(r)||!((0,w.$$k)(r)||(0,w.$_k)(r))||(0,w.$8k)(r)&&$?.preferUnbuffered?D=this.I(r,s,$):(0,w.$_k)(r)?D=this.G(r,s,l.token,$):D=this.H(r,s,l.token,$),D.on("end",()=>l.dispose()),D.on("error",()=>l.dispose()),{...await P,value:D}}catch(I){throw D&&await(0,d.$ye)(D),this.F(I,s,$)}}F(r,s,i){const o=(0,y.localize)(11,null,this.sb(s),(0,w.$gl)(r).toString());return r instanceof w.$pl?new w.$pl(o,r.stat,i):r instanceof w.$ol?new w.$ol(o,r.fileOperationResult,r.size,r.options):new w.$nl(o,(0,w.$jl)(r),i)}G(r,s,i,o=Object.create(null)){const l=r.readFileStream(s,o,i);return(0,d.$Ee)(l,{data:$=>$ instanceof k.$He?$:k.$He.wrap($),error:$=>this.F($,s,o)},$=>k.$He.concat($))}H(r,s,i,o=Object.create(null)){const l=(0,k.$Xe)();return(0,b.$Lq)(r,s,l,$=>$,{...o,bufferSize:this.a,errorTransformer:$=>this.F($,s,o)},i),l}I(r,s,i){const o=(0,d.$ve)(l=>k.$He.concat(l));return(async()=>{try{let l;i?.atomic&&(0,w.$al)(r)?l=await r.readFile(s,{atomic:!0}):l=await r.readFile(s),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(s,l.byteLength,i),o.end(k.$He.wrap(l))}catch(l){o.error(l),o.end()}})(),o}async J(r,s){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new w.$nl((0,y.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==w.$xl&&s.etag===i.etag)throw new w.$pl((0,y.localize)(13,null),i,s);return this.L(r,i.size,s),i}L(r,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new w.$ol((0,y.localize)(14,null,this.sb(r)),7,s,i)}async canMove(r,s,i){return this.M(r,s,"move",i)}async canCopy(r,s,i){return this.M(r,s,"copy",i)}async M(r,s,i,o){if(r.toString()!==s.toString())try{const l=i==="move"?this.qb(await this.n(r),r):await this.m(r),$=this.qb(await this.n(s),s);await this.Q(l,r,$,s,i,o)}catch(l){return l}return!0}async move(r,s,i){const o=this.qb(await this.n(r),r),l=this.qb(await this.n(s),s),$=await this.N(o,r,l,s,"move",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$kl(r,$==="move"?2:3,P)),P}async copy(r,s,i){const o=await this.m(r),l=this.qb(await this.n(s),s),$=await this.N(o,r,l,s,"copy",!!i),P=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new w.$kl(r,$==="copy"?3:2,P)),P}async N(r,s,i,o,l,$){if(s.toString()===o.toString())return l;const{exists:P,isSameResourceWithDifferentPathCase:D}=await this.Q(r,s,i,o,l,$);if(P&&!D&&$&&await this.del(o,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(o)),l==="copy"){if(r===i&&(0,w.$9k)(r))await r.copy(s,o,{overwrite:$});else{const I=await this.resolve(s);I.isDirectory?await this.P(r,I,i,o):await this.O(r,s,i,o)}return l}else return r===i?(await r.rename(s,o,{overwrite:$}),l):(await this.N(r,s,i,o,"copy",$),await this.del(s,{recursive:!0}),"copy")}async O(r,s,i,o){if((0,w.$$k)(r)&&(0,w.$$k)(i))return this.jb(r,s,i,o);if((0,w.$$k)(r)&&(0,w.$8k)(i))return this.pb(r,s,i,o);if((0,w.$8k)(r)&&(0,w.$$k)(i))return this.nb(r,s,i,o);if((0,w.$8k)(r)&&(0,w.$8k)(i))return this.lb(r,s,i,o)}async P(r,s,i,o){await i.mkdir(o),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async l=>{const $=this.R(i).providerExtUri.joinPath(o,l.name);return l.isDirectory?this.P(r,await this.resolve(l.resource),i,$):this.O(r,l.resource,i,$)}))}async Q(r,s,i,o,l,$){let P=!1;if(r===i){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(r);if(O||(P=I.isEqual(s,o)),P&&l==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(o)));if(!P&&I.isEqualOrParent(o,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(o)))}const D=await this.exists(o);if(D&&!P){if(!$)throw new w.$nl((0,y.localize)(17,null,this.sb(s),this.sb(o)),4);if(r===i){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(s,o))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(o)))}}return{exists:D,isSameResourceWithDifferentPathCase:P}}R(r){const s=this.S(r);return{providerExtUri:s?m.$2g:m.$4g,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new w.$kl(r,0,i)),i}async U(r,s){const i=[],{providerExtUri:o}=this.R(r);for(;!o.isEqual(s,o.dirname(s));)try{if(!((await r.stat(s)).type&w.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(l){if((0,w.$il)(l)!==w.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(o.basename(s)),s=o.dirname(s)}for(let l=i.length-1;l>=0;l--){s=o.joinPath(s,i[l]);try{await r.mkdir(s)}catch($){if((0,w.$il)($)!==w.FileSystemProviderErrorCode.FileExists)throw $}}}async canDelete(r,s){try{await this.W(r,s)}catch(i){return i}return!0}async W(r,s){const i=this.qb(await this.j(r),r),o=!!s?.useTrash;if(o&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(r)));const l=s?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(r)));if(o&&l)throw new Error((0,y.localize)(22,null,this.sb(r)));let $;try{$=await i.stat(r)}catch{}if($)this.rb(r,$);else throw new w.$nl((0,y.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const D=await this.resolve(r);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(r)))}return i}async del(r,s){const i=await this.W(r,s);let o=s;if((0,w.$cl)(i)&&!o?.atomic){const D=i.enforceAtomicDelete?.(r);D&&(o={...s,atomic:D})}const l=!!o?.useTrash,$=!!o?.recursive,P=o?.atomic??!1;await i.delete(r,{recursive:$,useTrash:l,atomic:P}),this.r.fire(new w.$kl(r,1))}async cloneFile(r,s){const i=await this.j(r),o=this.qb(await this.n(s),s);if(!(i===o&&this.R(i).providerExtUri.isEqual(r,s)))return i===o&&(0,w.$0k)(i)?i.cloneFile(r,s):(await this.U(o,this.R(o).providerExtUri.dirname(s)),i===o&&(0,w.$9k)(i)?this.cb.queueFor(r,()=>i.copy(r,s,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,o,s),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:S.ab++})}watch(r,s={recursive:!1,excludes:[]}){const i=new c.$Tc;let o=!1,l=()=>{o=!0};i.add((0,c.$Sc)(()=>l())),(async()=>{try{const P=await this.bb(r,s);o?(0,c.$Pc)(P):l=()=>(0,c.$Pc)(P)}catch(P){this.b.error(P)}})();const $=s.correlationId;if(typeof $=="number"){const P=i.add(new j.$fe);return i.add(this.X.event(I=>{I.correlates($)&&P.fire(I)})),{onDidChange:P.event,dispose:()=>i.dispose()}}return i}async bb(r,s){const i=await this.j(r),o=(0,E.$mj)([this.R(i).providerExtUri.getComparisonKey(r),s]);let l=this.$.get(o);return l||(l={count:0,disposable:i.watch(r,s)},this.$.set(o,l)),l.count+=1,(0,c.$Sc)(()=>{l&&(l.count--,l.count===0&&((0,c.$Pc)(l.disposable),this.$.delete(o)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,c.$Pc)(r.disposable);this.$.clear()}async db(r,s,i,o){return this.cb.queueFor(s,async()=>{const l=await r.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,d.$te)(o)||(0,d.$ue)(o)?await this.eb(r,l,o):await this.fb(r,l,o)}catch($){throw(0,w.$gl)($)}finally{await r.close(l)}},this.R(r).providerExtUri)}async eb(r,s,i){let o=0,l;if((0,d.$ue)(i)){if(i.buffer.length>0){const $=k.$He.concat(i.buffer);await this.gb(r,s,$,$.byteLength,o,0),o+=$.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise(($,P)=>{(0,d.$ze)(l,{onData:async D=>{l.pause();try{await this.gb(r,s,D,D.byteLength,o,0)}catch(I){return P(I)}o+=D.byteLength,setTimeout(()=>l.resume())},onError:D=>P(D),onEnd:()=>$()})})}async fb(r,s,i){let o=0,l;for(;(l=i.read())!==null;)await this.gb(r,s,l,l.byteLength,o,0),o+=l.byteLength}async gb(r,s,i,o,l,$){let P=0;for(;P<o;){const D=await r.write(s,l+P,i.buffer,$+P,o-P);P+=D}}async hb(r,s,i,o){return this.cb.queueFor(s,()=>this.ib(r,s,i,o),this.R(r).providerExtUri)}async ib(r,s,i,o){let l;o instanceof k.$He?l=o:(0,d.$te)(o)?l=await(0,k.$Te)(o):(0,d.$ue)(o)?l=await(0,k.$Ue)(o):l=(0,k.$Re)(o),await r.writeFile(s,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,s,i,o){return this.cb.queueFor(o,()=>this.kb(r,s,i,o),this.R(i).providerExtUri)}async kb(r,s,i,o){let l,$;try{l=await r.open(s,{create:!1}),$=await i.open(o,{create:!0,unlock:!1});const P=k.$He.alloc(this.a);let D=0,I=0,O=0;do O=await r.read(l,D,P.buffer,I,P.byteLength-I),await this.gb(i,$,P,O,D,I),D+=O,I+=O,I===P.byteLength&&(I=0);while(O>0)}catch(P){throw(0,w.$gl)(P)}finally{await C.Promises.settled([typeof l=="number"?r.close(l):Promise.resolve(),typeof $=="number"?i.close($):Promise.resolve()])}}async lb(r,s,i,o){return this.cb.queueFor(o,()=>this.mb(r,s,i,o),this.R(i).providerExtUri)}async mb(r,s,i,o){return i.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,i,o){return this.cb.queueFor(o,()=>this.ob(r,s,i,o),this.R(i).providerExtUri)}async ob(r,s,i,o){const l=await i.open(o,{create:!0,unlock:!1});try{const $=await r.readFile(s);await this.gb(i,l,k.$He.wrap($),$.byteLength,0,0)}catch($){throw(0,w.$gl)($)}finally{await i.close(l)}}async pb(r,s,i,o){const l=await(0,k.$Te)(this.H(r,s,R.CancellationToken.None));await this.hb(i,o,void 0,l)}qb(r,s){if(r.capabilities&2048)throw new w.$nl((0,y.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&w.FilePermission.Readonly)throw new w.$nl((0,y.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===p.Schemas.file?r.fsPath:r.toString(!0)}};e.$Mq=a,e.$Mq=a=S=Ee([ie(0,f.$5j)],a)}),define(se[94],re([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,(()=>{try{(0,C.gracefulify)(n)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$jj)(r)}`)}})();class t extends f.$Yq{static{this.L=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=E.Event.None,this.P=new R.$Ac(o=>v.$3g.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,p.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:i,symbolicLink:o}=await d.SymlinkSupport.stat(this.I(s));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:w.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await d.Promises.readdir(this.I(s),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async l=>{try{let $;l.isSymbolicLink()?$=(await this.stat((0,v.$_g)(s,l.name))).type:$=this.O(l),o.push([l.name,$])}catch($){this.a.trace($)}})),o}catch(i){throw this.hb(i)}}O(s,i){let o;return i?.dangling?o=w.FileType.Unknown:s.isFile()?o=w.FileType.File:s.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,i&&(o|=w.FileType.SymbolicLink),o}async Q(s){const i=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const l=new k.$xh;return this.P.set(s,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,c.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(s)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(s,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),o=await this.Q(s));const l=this.I(s);return await d.Promises.readFile(l)}catch(l){throw this.hb(l)}finally{o?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,i,o){const l=(0,m.$ve)($=>j.$He.concat($.map(P=>j.$He.wrap(P))).buffer);return(0,b.$Lq)(this,s,l,$=>$.buffer,{...i,bufferSize:256*1024},o),l}async writeFile(s,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(s)?this.U(s,(0,v.$_g)((0,v.$$g)(s),`${(0,v.$9g)(s)}${o.atomic.postfix}`),i,o):this.W(s,i,o)}async S(s){try{const i=this.I(s),{symbolicLink:o}=await d.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(s,i,o,l){const $=new c.$Tc;try{$.add(await this.Q(s)),$.add(await this.Q(i)),await this.W(i,o,l,!0);try{await this.rename(i,s,{overwrite:!0})}catch(P){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw P}}finally{$.dispose()}}async W(s,i,o,l){let $;try{const P=this.I(s);if(!o.create||!o.overwrite){if(await d.Promises.exists(P)){if(!o.overwrite)throw(0,w.$fl)((0,y.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.$fl)((0,y.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(s,{create:!0,unlock:o.unlock},l),await this.write($,0,i,0,i.byteLength)}catch(P){throw await this.ib(s,P)}finally{typeof $=="number"&&await this.close($)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,i,o){const l=this.I(s);let $;(0,w.$6k)(i)&&!o&&($=await this.Q(s));let P;try{if((0,w.$6k)(i)&&i.unlock)try{const{stat:I}=await d.SymlinkSupport.stat(l);I.mode&128||await d.Promises.chmod(l,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let D;if((0,w.$6k)(i)){if(p.$i)try{await d.Promises.truncate(l,0),D="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}D||(D="w")}else D="r";P=await d.Promises.open(l,D)}catch(D){throw $?.dispose(),(0,w.$6k)(i)?await this.ib(s,D):this.hb(D)}if(this.X.set(P,0),(0,w.$6k)(i)&&this.Z.set(P,s),$){const D=this.Y.get(P);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${P} (${l})`),this.Y.set(P,$),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${P} (${l})`),D.dispose())}return P}async close(s){const i=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await d.Promises.fdatasync(s)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await d.Promises.close(s)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(s)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,o,l,$){const P=this.ab(s,i);let D=null;try{D=(await d.Promises.read(s,o,l,$,P)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(s,P,D)}return D}ab(s,i){return i===this.X.get(s)?null:i}bb(s,i,o){const l=this.X.get(s);typeof l=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(s,l+o):this.X.delete(s)))}async write(s,i,o,l,$){return(0,k.$Sh)(()=>this.cb(s,i,o,l,$),100,3)}async cb(s,i,o,l,$){const P=this.ab(s,i);let D=null;try{D=(await d.Promises.write(s,o,l,$,P)).bytesWritten}catch(I){throw await this.ib(this.Z.get(s),I)}finally{this.bb(s,P,D)}return D}async mkdir(s){try{await d.Promises.mkdir(this.I(s))}catch(i){throw this.hb(i)}}async delete(s,i){try{const o=this.I(s);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,g.$jc)((0,g.$mc)(o),`${(0,g.$nc)(o)}${i.atomic.postfix}`)),await d.Promises.rm(o,d.RimRafMode.MOVE,l)}else try{await d.Promises.unlink(o)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let $=!1;try{const{stat:P,symbolicLink:D}=await d.SymlinkSupport.stat(o);$=P.isDirectory()&&!D}catch{}if($)await d.Promises.rmdir(o);else throw l}else throw l}}catch(o){throw this.hb(o)}}async rename(s,i,o){const l=this.I(s),$=this.I(i);if(l!==$)try{await this.db(s,i,"move",o.overwrite),await d.Promises.rename(l,$)}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(2,null,(0,g.$nc)(l),(0,g.$nc)((0,g.$mc)($)),P.toString()))),this.hb(P)}}async copy(s,i,o){const l=this.I(s),$=this.I(i);if(l!==$)try{await this.db(s,i,"copy",o.overwrite),await d.Promises.copy(l,$,{preserveSymlinks:!0})}catch(P){throw(P.code==="EINVAL"||P.code==="EBUSY"||P.code==="ENAMETOOLONG")&&(P=new Error((0,y.localize)(3,null,(0,g.$nc)(l),(0,g.$nc)((0,g.$mc)($)),P.toString()))),this.hb(P)}}async db(s,i,o,l){const $=this.I(s),P=this.I(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,u.$wg)($,P,!0)),D){if(o==="copy")throw(0,w.$fl)((0,y.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const O=await this.N(s);if(!O)throw(0,w.$fl)((0,y.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!l)throw(0,w.$fl)((0,y.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);O.type&w.FileType.File&&M.type&w.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.eb(s,i,!1)}async eb(s,i,o){const l=this.I(s),$=this.I(i),P=!!(this.capabilities&1024);if((0,u.$wg)(l,$,!P))return;const D=new c.$Tc;try{D.add(await this.Q(s)),D.add(await this.Q(i)),o&&await d.Promises.mkdir((0,g.$mc)($),{recursive:!0}),await d.Promises.copyFile(l,$)}catch(I){if(I.code==="ENOENT"&&!o)return this.eb(s,i,!0);throw this.hb(I)}finally{D.dispose()}}t(s,i,o){return new S.$6q(l=>s(l),l=>i(l),o)}F(s,i,o){return new a.$cr(l=>s(l),l=>i(l),o)}hb(s){if(s instanceof w.$el)return s;let i=s,o;switch(s.code){case"ENOENT":o=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=w.FileSystemProviderErrorCode.Unknown;break;default:o=w.FileSystemProviderErrorCode.Unknown}return(0,w.$fl)(i,o)}async ib(s,i){let o=this.hb(i);if(s&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await d.SymlinkSupport.stat(this.I(s));l.mode&128||(o=(0,w.$fl)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return o}}e.$dr=t}),define(se[227],re([0,1,3,94,2,17,63,23]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=void 0;class u extends k.$Uc{constructor(p,v){super(),this.a=p,this.b=v,this.F=new Map,this.G=new Map}call(p,v,m){const d=this.c(p);switch(v){case"stat":return this.g(d,m[0]);case"readdir":return this.h(d,m[0]);case"open":return this.r(d,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(d,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(d,m[0],m[1],m[2]);case"rename":return this.z(d,m[0],m[1],m[2]);case"copy":return this.C(d,m[0],m[1],m[2]);case"cloneFile":return this.D(d,m[0],m[1]);case"mkdir":return this.w(d,m[0]);case"delete":return this.y(d,m[0],m[1]);case"watch":return this.I(d,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${v} not found`)}listen(p,v,m){const d=this.c(p);switch(v){case"fileChange":return this.H(d,m[0]);case"readFileStream":return this.m(d,m[0],m[1])}throw new Error(`Unknown event ${v}`)}g(p,v){const m=this.f(p,v,!0);return this.a.stat(m)}h(p,v){const m=this.f(p,v);return this.a.readdir(m)}async j(p,v,m){const d=this.f(p,v,!0),y=await this.a.readFile(d,m);return R.$He.wrap(y)}m(p,v,m){const d=this.f(p,v,!0),y=new E.$qe,w=new n.$fe({onDidRemoveLastListener:()=>{y.cancel()}}),b=this.a.readFileStream(d,m,y.token);return(0,j.$ze)(b,{onData:f=>w.fire(R.$He.wrap(f)),onError:f=>w.fire(f),onEnd:()=>{w.fire("end"),w.dispose(),y.dispose()}}),w.event}n(p,v,m,d){const y=this.f(p,v);return this.a.writeFile(y,m.buffer,d)}r(p,v,m){const d=this.f(p,v,!0);return this.a.open(d,m)}s(p){return this.a.close(p)}async t(p,v,m){const d=R.$He.alloc(m),w=await this.a.read(p,v,d.buffer,0,m);return[d,w]}u(p,v,m,d,y){return this.a.write(p,v,m.buffer,d,y)}w(p,v){const m=this.f(p,v);return this.a.mkdir(m)}y(p,v,m){const d=this.f(p,v);return this.a.delete(d,m)}z(p,v,m,d){const y=this.f(p,v),w=this.f(p,m);return this.a.rename(y,w,d)}C(p,v,m,d){const y=this.f(p,v),w=this.f(p,m);return this.a.copy(y,w,d)}D(p,v,m){const d=this.f(p,v),y=this.f(p,m);return this.a.cloneFile(d,y)}H(p,v){const m=new n.$fe({onWillAddFirstListener:()=>{this.F.set(v,this.L(p,m))},onDidRemoveLastListener:()=>{(0,k.$Pc)(this.F.get(v)),this.F.delete(v)}});return m.event}async I(p,v,m,d,y){const w=this.F.get(v);if(w){const b=this.f(p,d),f=w.watch(m,b,y);this.G.set(v+m,f)}}async J(p,v){const m=p+v,d=this.G.get(m);d&&((0,k.$Pc)(d),this.G.delete(m))}dispose(){super.dispose();for(const[,p]of this.G)p.dispose();this.G.clear();for(const[,p]of this.F)p.dispose();this.F.clear()}}e.$Ns=u;class c extends k.$Uc{constructor(p,v,m,d){super(),this.c=p,this.f=m,this.g=d,this.a=new Map,this.b=this.B(new C.$dr(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(p){const v=this.B(new n.$fe);this.B(v.event(m=>{p.fire(m.map(d=>({resource:this.c.transformOutgoingURI(d.resource),type:d.type,cId:d.cId})))})),this.B(this.b.onDidChangeFile(m=>v.fire(m))),this.B(this.b.onDidWatchError(m=>p.fire(m)))}j(p){}m(p){}watch(p,v,m){const d=this.m(this.g);return Array.isArray(d)&&(m.excludes=[...m.excludes,...d]),this.a.set(p,this.b.watch(v,m)),(0,k.$Sc)(()=>{(0,k.$Pc)(this.a.get(p)),this.a.delete(p)})}dispose(){for(const[,p]of this.a)p.dispose();this.a.clear(),super.dispose()}}e.$Os=c}),define(se[228],re([0,1,14,180,4,7,16,9,227,157,47]),function(K,e,n,C,k,R,j,E,u,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ldc=void 0;class p extends u.$Ns{constructor(d,y,w){super(d,y),this.M=w}c(d){return c.$Bn}f(d,y){return R.URI.revive(y)}async y(d,y,w){if(!w.useTrash)return super.y(d,y,w);const b=this.f(d,y),f=(0,E.$hc)(b.fsPath);try{await n.shell.trashItem(f)}catch(h){throw(0,j.$fl)(k.$i?(0,C.localize)(0,null,(0,E.$nc)(f),(0,g.$jj)(h)):(0,C.localize)(1,null,(0,E.$nc)(f),(0,g.$jj)(h)),j.FileSystemProviderErrorCode.Unknown)}}L(d,y){return new v(d,y,this.b,this.M)}}e.$ldc=p;class v extends u.$Os{watch(d,y,w){if(w.recursive)throw(0,j.$fl)("Recursive file watching is not supported from main process for performance reasons.",j.FileSystemProviderErrorCode.Unavailable);return super.watch(d,y,w)}}}),define(se[229],re([0,1,5]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0;class C extends n.$$j{constructor(R=n.$8j){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(j=>{this.n?.setLevel(j)}))}set logger(R){this.n=R;for(const{level:j,message:E}of this.m)(0,n.log)(R,j,E);this.m=[]}g(R,j){this.n?(0,n.log)(this.n,R,j):this.getLevel()<=R&&this.m.push({level:R,message:j})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$__b=C}),define(se[230],re([0,1,7,3,5,2]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=e.$ds=void 0;class j extends k.$dk{constructor(p,v,m,d,y){super(v,m,d),this.r=p,this.t=y,this.B(y.listen("onDidChangeLogLevel",p)(w=>{(0,k.$7j)(w)?super.setLogLevel(w):super.setLogLevel(n.URI.revive(w[0]),w[1])})),this.B(y.listen("onDidChangeVisibility",p)(([w,b])=>super.setVisibility(n.URI.revive(w),b))),this.B(y.listen("onDidChangeLoggers",p)(({added:w,removed:b})=>{for(const f of w)super.registerLogger({...f,resource:n.URI.revive(f.resource)});for(const f of b)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new k.$bk({log:(p,v)=>{this.t.call("consoleLog",[p,v])}})}registerLogger(p){super.registerLogger(p),this.t.call("registerLogger",[p,this.r])}deregisterLogger(p){super.deregisterLogger(p),this.t.call("deregisterLogger",[p,this.r])}setLogLevel(p,v){super.setLogLevel(p,v),this.t.call("setLogLevel",[p,v])}setVisibility(p,v){super.setVisibility(p,v),this.t.call("setVisibility",[this.n(p),v])}s(p,v,m){return new E(this.t,p,v,m,this.r)}static setLogLevel(p,v,m){return p.call("setLogLevel",[v,m])}}e.$ds=j;class E extends k.$$j{constructor(p,v,m,d,y){super(d?.logLevel==="always"),this.r=p,this.s=v,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[v,d,y]).then(()=>{this.u(this.n),this.m=!0})}g(p,v){const m=[[p,v]];this.m?this.u(m):this.n.push(...m)}u(p){this.r.call("log",[this.s,p])}}class u{constructor(p,v){this.a=p,this.b=v}listen(p,v){const m=this.b(p);switch(v){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,d=>({added:[...d.added].map(y=>this.c(y,m)),removed:[...d.removed].map(y=>this.c(y,m))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,d=>[m.transformOutgoingURI(d[0]),d[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,d=>(0,k.$7j)(d)?d:[m.transformOutgoingURI(d[0]),d[1]])}throw new Error(`Event not found: ${v}`)}async call(p,v,m){const d=this.b(p);switch(v){case"setLogLevel":return(0,k.$7j)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(n.URI.revive(d.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,d)))}throw new Error(`Call not found: ${v}`)}c(p,v){return{...p,resource:v.transformOutgoingURI(p.resource)}}}e.$es=u;class c extends R.$Uc{constructor(p,v){super(),v.call("setLogLevel",[p.getLogLevel()]),this.B(p.onDidChangeLogLevel(m=>v.call("setLogLevel",[m]))),v.call("getRegisteredLoggers").then(m=>{for(const d of m)p.registerLogger({...d,resource:n.URI.revive(d.resource)})}),this.B(v.listen("onDidChangeVisibility")(([m,d])=>p.setVisibility(n.URI.revive(m),d))),this.B(v.listen("onDidChangeLoggers")(({added:m,removed:d})=>{for(const y of m)p.registerLogger({...y,resource:n.URI.revive(y.resource)});for(const y of d)p.deregisterLogger(y.resource)}))}}e.$fs=c}),define(se[231],re([0,1,2,5]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class k extends n.$Uc{constructor(j,E=[]){super(),this.a=new C.$ck([j,...E]),this.B(j.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...E){this.a.trace(j,...E)}debug(j,...E){this.a.debug(j,...E)}info(j,...E){this.a.info(j,...E)}warn(j,...E){this.a.warn(j,...E)}error(j,...E){this.a.error(j,...E)}flush(){this.a.flush()}}e.$bQ=k}),define(se[232],re([0,1,32,7,5]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gec=void 0;class R{constructor(E){this.b=E,this.a=new n.$Ac}listen(E,u,c){switch(u){case"onDidChangeLoggers":return c?this.b.getOnDidChangeLoggersEvent(c):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return c?this.b.getOnDidChangeLogLevelEvent(c):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return c?this.b.getOnDidChangeVisibilityEvent(c):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${u}`)}async call(E,u,c){switch(u){case"createLogger":this.c(C.URI.revive(c[0]),c[1],c[2]);return;case"log":return this.e(C.URI.revive(c[0]),c[1]);case"consoleLog":return this.d(c[0],c[1]);case"setLogLevel":return(0,k.$7j)(c[0])?this.b.setLogLevel(c[0]):this.b.setLogLevel(C.URI.revive(c[0]),c[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(c[0]),c[1]);case"registerLogger":return this.b.registerLogger({...c[0],resource:C.URI.revive(c[0].resource)},c[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(c[0]))}throw new Error(`Call not found: ${u}`)}c(E,u,c){this.a.set(E,this.b.createLogger(E,u,c))}d(E,u){let c=console.log;switch(E){case k.LogLevel.Error:c=console.error;break;case k.LogLevel.Warning:c=console.warn;break;case k.LogLevel.Info:c=console.info;break}c.call(console,...u)}e(E,u){const c=this.a.get(E);if(!c)throw new Error("Create the logger before logging");for(const[g,p]of u)(0,k.log)(c,g,p)}}e.$gec=R}),define(se[233],re([0,1,16,5]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var k;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(k||(k={}));async function R(c,g,p,v,m){try{const d=await new Promise((w,b)=>{K(["@vscode/spdlog"],w,b)});d.setFlushOn(k.Trace);const y=await d.createAsyncRotatingLogger(c,g,p,v);return m?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(d){console.error(d)}return null}function j(c,g,p){switch(g){case C.LogLevel.Trace:c.trace(p);break;case C.LogLevel.Debug:c.debug(p);break;case C.LogLevel.Info:c.info(p);break;case C.LogLevel.Warning:c.warn(p);break;case C.LogLevel.Error:c.error(p);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${g}`)}}function E(c,g){switch(g){case C.LogLevel.Trace:c.setLevel(k.Trace);break;case C.LogLevel.Debug:c.setLevel(k.Debug);break;case C.LogLevel.Info:c.setLevel(k.Info);break;case C.LogLevel.Warning:c.setLevel(k.Warning);break;case C.LogLevel.Error:c.setLevel(k.Error);break;case C.LogLevel.Off:c.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${g}`)}}class u extends C.$$j{constructor(g,p,v,m,d){super(),this.m=[],this.setLevel(d),this.n=this.s(g,p,v,m),this.B(this.onDidChangeLogLevel(y=>{this.r&&E(this.r,y)}))}async s(g,p,v,m){const d=v?6:1,y=30/d*n.$Al.MB,w=await R(g,p,y,d,m);if(w){this.r=w,E(this.r,this.getLevel());for(const{level:b,message:f}of this.m)j(this.r,b,f);this.m=[]}}g(g,p){this.r?j(this.r,g,p):this.getLevel()<=g&&this.m.push({level:g,message:p})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=u}),define(se[234],re([0,1,33,5,233]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class R extends C.$dk{s(E,u,c){return new k.$3P((0,n.$Ug)(),E.fsPath,!c?.donotRotate,!!c?.donotUseFormatters,u)}}e.$4P=R}),define(se[67],re([0,1,32,3,6,5,234]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=e.$Scc=void 0,e.$Scc=(0,k.$zi)(R.$6j);class E extends j.$4P{constructor(){super(...arguments),this.u=new n.$Ac}createLogger(c,g,p){p!==void 0&&this.u.set(this.n(c),p);try{return super.createLogger(c,g)}catch(v){throw this.u.delete(this.n(c)),v}}registerLogger(c,g){g!==void 0&&this.u.set(c.resource,g),super.registerLogger(c)}deregisterLogger(c){this.u.delete(c),super.deregisterLogger(c)}getRegisteredLoggers(c){const g=[];for(const p of super.getRegisteredLoggers())c===this.u.get(p.resource)&&g.push(p);return g}getOnDidChangeLogLevelEvent(c){return C.Event.filter(this.onDidChangeLogLevel,g=>(0,R.$7j)(g)||this.w(g[0],c))}getOnDidChangeVisibilityEvent(c){return C.Event.filter(this.onDidChangeVisibility,([g])=>this.w(g,c))}getOnDidChangeLoggersEvent(c){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,g=>({added:[...g.added].filter(v=>this.w(v.resource,c)),removed:[...g.removed].filter(v=>this.w(v.resource,c))})),g=>g.added.length>0||g.removed.length>0)}deregisterLoggers(c){for(const[g,p]of this.u)p===c&&this.deregisterLogger(g)}w(c,g){const p=this.u.get(c);return p===void 0||p===g}dispose(){super.dispose(),this.u.clear()}}e.$Tcc=E}),define(se[235],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ydc=n,e.$zdc=C,e.$Adc=k,e.$Bdc=R;function n(j){return j.submenu!==void 0}function C(j){return j.id==="vscode.menubar.separator"}function k(j){return j.uri!==void 0}function R(j){return!n(j)&&!C(j)&&!k(j)}}),define(se[39],re([0,1,3,71,2,6]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,R.$yi)("policy");class j extends k.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(c){const g=Object.keys(this.f).length;return this.f={...c,...this.f},g!==Object.keys(this.f).length&&await this.j(c),C.Iterable.reduce(this.g.entries(),(p,[v,m])=>({...p,[v]:m}),{})}getPolicyValue(c){return this.g.get(c)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(c,[g,p])=>({...c,[g]:{definition:p,value:this.g.get(g)}}),{})}}e.$io=j;class E{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=E}),define(se[236],re([0,1,8,3,71,12,16,5,39]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;function c(p,v){const m=[];for(const d of new Set(k.Iterable.concat(p.keys(),v.keys())))p.get(d)!==v.get(d)&&m.push(d);return m}let g=class extends u.$io{constructor(v,m,d){super(),this.m=v,this.n=m,this.s=d,this.c=this.B(new n.$wh(500));const y=C.Event.filter(m.onDidFilesChange,w=>w.affects(v));this.B(m.watch(v)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const m=await this.n.readFile(this.m),d=JSON.parse(m.value.toString());if(!(0,R.$ag)(d))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(d))this.f[y]&&v.set(y,d[y])}catch(m){m.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",m)}return v}async w(){const v=await this.u(),m=c(this.g,v);this.g=v,m.length>0&&this.h.fire(m)}};e.$zec=g,e.$zec=g=Ee([ie(1,j.$5k),ie(2,E.$5j)],g)}),define(se[237],re([0,1,3,2,39]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=void 0;class R{constructor(u){this.b=u,this.a=new C.$Tc}listen(u,c){switch(c){case"onDidChange":return n.Event.map(this.b.onDidChange,g=>g.reduce((p,v)=>({...p,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${c}`)}call(u,c,g){switch(c){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(g)}throw new Error(`Call not found: ${c}`)}dispose(){this.a.dispose()}}e.$0dc=R;class j extends k.$io{constructor(u,c){super(),this.a=c;for(const g in u){const{definition:p,value:v}=u[g];this.f[g]=p,v!==void 0&&this.g.set(g,v)}this.a.listen("onDidChange")(g=>{for(const p in g){const v=g[p];v===null?this.g.delete(p):this.g.set(p,v)}this.h.fire(Object.keys(g))})}async j(u){const c=await this.a.call("updatePolicyDefinitions",u);for(const g in c)this.g.set(g,c[g])}}e.$$dc=j}),define(se[238],re([0,1,39,8,2,5]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let j=class extends n.$io{constructor(u,c){super(),this.m=u,this.n=c,this.a=new C.$sh,this.b=this.B(new k.$Vc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:c}=await new Promise((g,p)=>{K(["@vscode/policy-watcher"],g,p)});await this.a.queue(()=>new Promise((g,p)=>{try{this.b.value=c(this.n,u,v=>{this.t(v),g()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),p(v)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const c in u){const g=u[c];g===void 0?this.g.delete(c):this.g.set(c,g)}this.h.fire(Object.keys(u))}};e.$yec=j,e.$yec=j=Ee([ie(0,R.$5j)],j)}),define(se[80],re([0,1,36]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const R=k.context.configuration();if(R)C=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:R.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(se[27],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,n.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(se[239],re([0,1,8,5]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;let k=class{constructor(j,E,u){this.a=j,this.b=E,this.c=u}async inspect(j){await this.d();const E=this.a.webContents.debugger;await E.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$zh)(j);const u=await E.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),u.profile}async d(){const j=this.a.webContents.debugger;j.attach(),await j.sendCommand("Profiler.enable")}async e(){const j=this.a.webContents.debugger;await j.sendCommand("Profiler.disable"),j.detach()}};e.$odc=k,e.$odc=k=Ee([ie(2,C.$5j)],k)}),define(se[81],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=void 0,e.$Bcc=(0,n.$yi)("protocolMainService")}),define(se[45],re([0,1,139,12]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class k{constructor(){this.a=new Map}add(j,E){n.ok(C.$$f(j)),n.ok(C.$ag(E)),n.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,E)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$fo=new k}),define(se[240],re([0,1,3,45]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function k(E){return E.length>0&&E.charAt(E.length-1)==="#"?E.substring(0,E.length-1):E}class R{constructor(){this.b=new n.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,c){this.a[k(u)]=c,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const j=new R;C.$fo.add(e.$go.JSONContribution,j)}),define(se[52],re([0,1,22,3,12,165,18,240,45]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=y,e.$wo=w,e.$xo=b,e.$yo=h,e.$zo=S;var c;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(c||(e.EditPresentationTypes=c={})),e.$ko={Configuration:"base.contributions.configuration"};var g;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g||(e.ConfigurationScope=g={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const p=u.$fo.as(E.$go.JSONContribution);class v{constructor(){this.h=new Set,this.i=new C.$fe,this.onDidSchemaChange=this.i.event,this.j=new C.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},p.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),p.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),p.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),p.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:i,source:o}of t)for(const l in i)if(r.add(l),e.$uo.test(l)){const $=this.a.get(l),P=$?.valuesSources??new Map;if(o)for(const M of Object.keys(i[l]))P.set(M,o);const D={...$?.value||{},...i[l]};this.a.set(l,{source:o,value:D,valuesSources:P});const I=(0,j.$cj)(l),O={type:"object",default:D,description:R.localize(1,null,I),$ref:e.$ro,defaultDefaultValue:D,source:k.$$f(o)?void 0:o,defaultValueSource:o};s.push(...y(l)),this.d[l]=O,this.b.properties[l]=O}else{this.a.set(l,{value:i[l],source:o});const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:i}of t)for(const o in s){const l=this.a.get(o),$=k.$$f(i)?i:i?.id,P=k.$$f(l?.source)?l?.source:l?.source?.id;if($===P)if(r.add(o),this.a.delete(o),e.$uo.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.w(o,D),this.r(o,D))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,r){const s=i=>{if(i.properties)for(const o in i.properties){r.add(o);const l=this.d[o];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>s(o))};for(const i of t){s(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,s,i,o=3,l){o=k.$hg(t.scope)?o:t.scope;const $=t.properties;if($)for(const D in $){const I=$[D];if(r&&h(D,I)){delete $[D];continue}if(I.source=s,I.defaultDefaultValue=$[D].default,this.w(D,I),e.$uo.test(D)?I.scope=void 0:(I.scope=k.$hg(I.scope)?o:I.scope,I.restricted=k.$hg(I.restricted)?!!i?.includes(D):I.restricted),$[D].hasOwnProperty("included")&&!$[D].included){this.f[D]=$[D],delete $[D];continue}else this.d[D]=$[D],$[D].policy?.name&&this.e.set($[D].policy.name,D);!$[D].deprecationMessage&&$[D].markdownDeprecationMessage&&($[D].deprecationMessage=$[D].markdownDeprecationMessage),l.add(D)}const P=t.allOf;if(P)for(const D of P)this.p(D,r,s,i,o,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const i=s.properties;if(i)for(const l in i)this.r(l,i[l]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$lo.properties[t]=r,r.scope){case 1:e.$mo.properties[t]=r;break;case 2:e.$no.properties[t]=r;break;case 6:e.$oo.properties[t]=r;break;case 3:e.$po.properties[t]=r;break;case 4:e.$qo.properties[t]=r;break;case 5:e.$qo.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$lo.properties[t],r.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$ro};this.w(r,s),e.$lo.properties[r]=s,e.$mo.properties[r]=s,e.$no.properties[r]=s,e.$oo.properties[r]=s,e.$po.properties[r]=s,e.$qo.properties[r]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let i=s?.value,o=s?.source;k.$fg(i)&&(i=r.defaultDefaultValue,o=void 0),k.$fg(i)&&(i=b(r.type)),r.default=i,r.defaultValueSource=o}}const m="\\[([^\\]]+)\\]",d=new RegExp(m,"g");e.$to=`^(${m})+$`,e.$uo=new RegExp(e.$to);function y(a){const t=[];if(e.$uo.test(a)){let r=d.exec(a);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=d.exec(a)}}return(0,n.$Mb)(t)}function w(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}function b(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const f=new v;u.$fo.add(e.$ko.Configuration,f);function h(a,t){return a.trim()?e.$uo.test(a)?R.localize(7,null,a):f.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&f.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,f.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function S(){const a=[],t=f.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(se[123],re([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(K,e,n,C,k,R,j,E,u,c,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=h;function m(r){return Object.isFrozen(r)?r:E.$6n(r)}class d{static createEmptyModel(s){return new d({},[],[],void 0,s)}constructor(s,i,o,l,$){this.b=s,this.c=i,this.d=o,this.raw=l,this.f=$,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof d)return i;const o=new y("",this.f);return o.parseRaw(i),o.configurationModel});this.g=s.reduce((i,o)=>o===i?o:i.merge(o),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,g.$aj)(this.contents,s):this.contents}inspect(s,i){const o=this;return{get value(){return m(o.rawConfiguration.getValue(s))},get override(){return i?m(o.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return m(i?o.rawConfiguration.override(i).getValue(s):o.rawConfiguration.getValue(s))},get overrides(){const l=[];for(const{contents:$,identifiers:P,keys:D}of o.rawConfiguration.overrides){const I=new d($,D,[],void 0,o.f).getValue(s);I!==void 0&&l.push({identifiers:P,value:I})}return l.length?m(l):void 0}}}getOverrideValue(s,i){const o=this.j(i);return o?s?(0,g.$aj)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return n.$Mb(s)}override(s){let i=this.a.get(s);return i||(i=this.h(s),this.a.set(s,i)),i}merge(...s){const i=E.$5n(this.contents),o=E.$5n(this.overrides),l=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const P of s)if($.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.i(i,P.contents);for(const D of P.overrides){const[I]=o.filter(O=>n.$ub(O.identifiers,D.identifiers));I?(this.i(I.contents,D.contents),I.keys.push(...D.keys),I.keys=n.$Mb(I.keys)):o.push(E.$5n(D))}for(const D of P.keys)l.indexOf(D)===-1&&l.push(D)}return new d(i,l,o,$.every(P=>P instanceof d)?void 0:$,this.f)}h(s){const i=this.j(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const l of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let $=this.contents[l];const P=i[l];P&&(typeof $=="object"&&typeof P=="object"?($=E.$5n($),this.i($,P)):$=P),o[l]=$}return new d(o,this.keys,this.overrides,void 0,this.f)}i(s,i){for(const o of Object.keys(i)){if(o in s&&u.$ag(s[o])&&u.$ag(i[o])){this.i(s[o],i[o]);continue}s[o]=E.$5n(i[o])}}j(s){let i=null,o=null;const l=$=>{$&&(o?this.i(o,$):o=E.$5n($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===s?i=$.contents:$.identifiers.includes(s)&&l($.contents);return l(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.k(s,i,!0)}setValue(s,i){this.k(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,g.$_i)(this.contents,s),p.$uo.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.$ub(o.identifiers,(0,p.$vo)(s))),1))}k(s,i,o){(0,g.$$i)(this.contents,s,i,l=>this.f.error(l)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),p.$uo.test(s)&&this.overrides.push({identifiers:(0,p.$vo)(s),keys:Object.keys(this.contents[s]),contents:(0,g.$0i)(this.contents[s],l=>this.f.error(l))})}}e.$Ao=d;class y{constructor(s,i){this.f=s,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||d.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!u.$hg(s)){const o=this.h(s);this.parseRaw(o,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:o,keys:l,overrides:$,restricted:P,hasExcludedProperties:D}=this.i(s,i);this.b=new d(o,l,$,D?[s]:void 0,this.g),this.c=P||[]}h(s){let i={},o=null,l=[];const $=[],P=[];function D(O){Array.isArray(l)?l.push(O):o!==null&&(l[o]=O)}const I={onObjectBegin:()=>{const O={};D(O),$.push(l),l=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{l=$.pop()},onArrayBegin:()=>{const O=[];D(O),$.push(l),l=O,o=null},onArrayEnd:()=>{l=$.pop()},onLiteralValue:D,onError:(O,M,W)=>{P.push({error:O,offset:M,length:W})}};if(s)try{k.$Sn(s,I),i=l[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}i(s,i){const o=v.$fo.as(p.$ko.Configuration).getConfigurationProperties(),l=this.j(s,o,!0,i);s=l.raw;const $=(0,g.$0i)(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),P=Object.keys(s),D=this.l(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:$,keys:P,overrides:D,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(s,i,o,l){let $=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:$};const P={},D=[];for(const I in s)if(p.$uo.test(I)&&o){const O=this.j(s[I],i,!1,l);P[I]=O.raw,$=$||O.hasExcludedProperties,D.push(...O.restricted)}else{const O=i[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&D.push(I),!l.exclude?.includes(I)&&(l.include?.includes(I)||(M===void 0||l.scopes===void 0||l.scopes.includes(M))&&!(l.skipRestricted&&O?.restricted))?P[I]=s[I]:$=!0}return{raw:P,restricted:D,hasExcludedProperties:$}}l(s,i){const o=[];for(const l of Object.keys(s))if(p.$uo.test(l)){const $={};for(const P in s[l])$[P]=s[l][P];o.push({identifiers:(0,p.$vo)(l),keys:Object.keys($),contents:(0,g.$0i)($,i)})}return o}}e.$Bo=y;class w extends R.$Uc{constructor(s,i,o,l,$){super(),this.c=s,this.f=i,this.g=l,this.h=$,this.b=this.B(new C.$fe),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),$),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,P=>P.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,P=>(P.isOperation(0)||P.isOperation(3)||P.isOperation(1)||P.isOperation(4))&&o.isEqual(P.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return d.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=w;class b{constructor(s,i,o,l,$,P,D,I,O,M,W,F,T){this.a=s,this.b=i,this.c=o,this.overrideIdentifiers=l,this.d=$,this.f=P,this.g=D,this.h=I,this.i=O,this.j=M,this.k=W,this.l=F,this.m=T}get value(){return m(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class f{constructor(s,i,o,l,$,P,D,I,O,M){this.j=s,this.l=i,this.m=o,this.n=l,this.p=$,this.q=P,this.r=D,this.s=I,this.t=O,this.u=M,this.h=null,this.i=new j.$Ac,this.v=null}getValue(s,i,o){return this.w(s,i,o).getValue(s)}updateValue(s,i,o={}){let l;o.resource?(l=this.t.get(o.resource),l||(l=d.createEmptyModel(this.u),this.t.set(o.resource,l))):l=this.s,i===void 0?l.removeValue(s):l.setValue(s,i),o.resource||(this.h=null)}inspect(s,i,o){const l=this.w(s,i,o),$=this.A(i.resource,o),P=i.resource?this.t.get(i.resource)||this.s:this.s,D=new Set;for(const I of l.overrides)for(const O of I.identifiers)l.getOverrideValue(s,O)!==void 0&&D.add(O);return new b(s,i,l.getValue(s),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,$||void 0,P)}keys(s){const i=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,i){this.r.set(s,i),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:l,updated:$,removed:P}=a(this.j,s);i=[...l,...$,...P]}for(const l of i)for(const $ of(0,p.$vo)(l)){const P=this.j.getKeysForOverrideIdentifier($),D=s.getKeysForOverrideIdentifier($),I=[...D.filter(O=>P.indexOf(O)===-1),...P.filter(O=>D.indexOf(O)===-1),...P.filter(O=>!E.$9n(this.j.override($).getValue(O),s.override($).getValue(O)))];o.push([$,I])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:l}=a(this.l,s),$=[...i,...o,...l];return $.length&&this.updatePolicyConfiguration(s),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:o,removed:l,overrides:$}=a(this.applicationConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateApplicationConfiguration(s),{keys:P,overrides:$}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:l,overrides:$}=a(this.localUserConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateLocalUserConfiguration(s),{keys:P,overrides:$}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:l,overrides:$}=a(this.remoteUserConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateRemoteUserConfiguration(s),{keys:P,overrides:$}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:l,overrides:$}=a(this.workspaceConfiguration,s),P=[...i,...o,...l];return P.length&&this.updateWorkspaceConfiguration(s),{keys:P,overrides:$}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:l,updated:$,removed:P,overrides:D}=a(o,i),I=[...l,...$,...P];return(I.length||!o)&&this.updateFolderConfiguration(s,i),{keys:I,overrides:D}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:l,removed:$,overrides:P}=a(i,void 0);return{keys:[...o,...l,...$],overrides:P}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,i,o){let l=this.x(i,o);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(l=l.merge(this.l)),l}x({resource:s},i){let o=this.y();if(i&&s){const l=i.getFolder(s);l&&(o=this.z(l.uri)||o);const $=this.t.get(s);$&&(o=o.merge($))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let i=this.i.get(s);if(!i){const o=this.y(),l=this.r.get(s);l?(i=o.merge(l),this.i.set(s,i)):i=o}return i}A(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,i)=>{const{contents:o,overrides:l,keys:$}=this.r.get(i);return s.push([i,{contents:o,overrides:l,keys:$}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.q.keys.forEach(i=>s.add(i)),this.r.forEach(i=>i.keys.forEach(o=>s.add(o))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}D(s){const i=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.q.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(l=>i.add(l))),[...i.values()]}static parse(s,i){const o=this.E(s.defaults,i),l=this.E(s.policy,i),$=this.E(s.application,i),P=this.E(s.user,i),D=this.E(s.workspace,i),I=s.folders.reduce((O,M)=>(O.set(c.URI.revive(M[0]),this.E(M[1],i)),O),new j.$Ac);return new f(o,l,$,P,d.createEmptyModel(i),D,I,d.createEmptyModel(i),new j.$Ac,i)}static E(s,i){return new d(s.contents,s.keys,s.overrides,void 0,i)}}e.$Do=f;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const l of r)l.keys.forEach($=>s.add($)),l.overrides.forEach(([$,P])=>{const D=(0,j.$xc)(i,$,new Set);P.forEach(I=>D.add(I))});const o=[];return i.forEach((l,$)=>o.push([$,[...l.values()]])),{keys:[...s.values()],overrides:o}}class S{constructor(s,i,o,l,$){this.change=s,this.f=i,this.g=o,this.h=l,this.i=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const P of s.keys)this.affectedKeys.add(P);for(const[,P]of s.overrides)for(const D of P)this.affectedKeys.add(D);this.d=this.a;for(const P of this.affectedKeys)this.d+=P+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=f.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,i){const o=this.a+s,l=this.d.indexOf(o);if(l<0)return!1;const $=l+o.length;if($>=this.d.length)return!1;const P=this.d.charCodeAt($);if(P!==this.b&&P!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,I=this.g.getValue(s,i,this.h);return!E.$9n(D,I)}return!0}}e.$Fo=S;function a(r,s){const{added:i,removed:o,updated:l}=t(s?.rawConfiguration,r?.rawConfiguration),$=[],P=r?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const I=D.filter(O=>!P.includes(O));for(const O of I)$.push([O,s.getKeysForOverrideIdentifier(O)])}if(r){const I=P.filter(O=>!D.includes(O));for(const O of I)$.push([O,r.getKeysForOverrideIdentifier(O)])}if(s&&r){for(const I of P)if(D.includes(I)){const O=t({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)});$.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:o,updated:l,overrides:$}}function t(r,s){const i=r?s?r.keys.filter($=>s.keys.indexOf($)===-1):[...r.keys]:[],o=s?r?s.keys.filter($=>r.keys.indexOf($)===-1):[...s.keys]:[],l=[];if(r&&s){for(const $ of s.keys)if(r.keys.indexOf($)!==-1){const P=(0,g.$aj)(s.contents,$),D=(0,g.$aj)(r.contents,$);E.$9n(P,D)||l.push($)}}return{added:i,removed:o,updated:l}}}),define(se[241],re([0,1,22,3,2,35,12,123,52,5,39,45]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class v extends k.$Uc{get configurationModel(){return this.b}constructor(w){super(),this.c=w,this.a=this.B(new C.$fe),this.onDidChangeConfiguration=this.a.event,this.b=E.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(p.$fo.as(u.$ko.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:b})=>this.f(Array.from(w),b))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(w,b){this.j(w,p.$fo.as(u.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}g(){return{}}h(){this.b=E.$Ao.createEmptyModel(this.c);const w=p.$fo.as(u.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(w),w)}j(w,b){const f=this.g();for(const h of w){const S=f[h],a=b[h];S!==void 0?this.b.addValue(h,S):a?this.b.addValue(h,a.default):this.b.removeValue(h)}}}e.$Go=v;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=E.$Ao.createEmptyModel(new c.$fk)}async initialize(){return this.configurationModel}}e.$Ho=m;let d=class extends k.$Uc{get configurationModel(){return this.b}constructor(w,b,f){super(),this.c=w,this.f=b,this.g=f,this.a=this.B(new C.$fe),this.onDidChangeConfiguration=this.a.event,this.b=E.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const b={},f=[],h=p.$fo.as(u.$ko.Configuration).getConfigurationProperties();for(const S of w){const a=h[S];if(!a){f.push(S);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}f.push(S),b[a.policy.name]={type:a.type}}}return(0,j.$lg)(b)||await this.f.updatePolicyDefinitions(b),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const b=p.$fo.as(u.$ko.Configuration).getPolicyConfigurations(),f=(0,n.$Hb)(w.map(h=>b.get(h)));this.m(f,!0)}m(w,b){this.g.trace("PolicyConfiguration#update",w);const f=p.$fo.as(u.$ko.Configuration).getConfigurationProperties(),h=[],S=this.b.isEmpty();for(const a of w){const t=f[a]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(S?r!==void 0:!(0,R.$9n)(this.b.getValue(a),r))&&h.push([a,r])}else this.b.getValue(a)!==void 0&&h.push([a,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const a=this.b;this.b=E.$Ao.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,r]of h)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);b&&this.a.fire(this.b)}}};e.$Io=d,e.$Io=d=Ee([ie(1,g.$ho),ie(2,c.$5j)],d)}),define(se[242],re([0,1,22,8,17,3,42,103,2,32,35,4,19,18,123,52,241,39]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class f extends u.$Uc{constructor(a,t,r,s){super(),this.m=a,this.n=s,this.h=this.B(new R.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$Go(s)),this.c=r instanceof b.$jo?new w.$Ho:this.B(new w.$Io(this.b,r,s)),this.f=this.B(new d.$Co(this.m,{},v.$3g,t,s)),this.a=new d.$Do(this.b.configurationModel,this.c.configurationModel,d.$Ao.createEmptyModel(s),d.$Ao.createEmptyModel(s),d.$Ao.createEmptyModel(s),d.$Ao.createEmptyModel(s),new c.$Ac,d.$Ao.createEmptyModel(s),new c.$Ac,s),this.j=new h(a,t,this),this.g=this.B(new C.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:o})=>this.s(i,o))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new d.$Do(a,t,d.$Ao.createEmptyModel(this.n),r,d.$Ao.createEmptyModel(this.n),d.$Ao.createEmptyModel(this.n),new c.$Ac,d.$Ao.createEmptyModel(this.n),new c.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const r=typeof a=="string"?a:void 0,s=(0,m.$6i)(a)?a:(0,m.$6i)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(a,t,r,s,i){const o=(0,m.$7i)(r)?r:(0,m.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,l=o?s:r;if(l!==void 0&&l!==3&&l!==2)throw new Error(`Unable to write ${a} to target ${l}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,n.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const $=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if($.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,g.$9n)(t,$.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const D=o.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,n.$ub)([...O.identifiers].sort(),D));I&&(o.overrideIdentifiers=I.identifiers)}const P=o?.overrideIdentifiers?.length?[(0,y.$wo)(o.overrideIdentifiers),a]:[a];await this.j.write(P,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,t,2)}s(a,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,r,7)}t(a){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,t,7)}u(a,t,r){const s=new d.$Fo(a,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Jo=f;class h{constructor(a,t,r){this.b=a,this.c=t,this.d=r,this.a=new C.$Fh}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===1)r="{}";else throw o}const s=[];if((0,j.$Ln)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,a,t);r=(0,E.$4n)(r,i),await this.c.writeFile(this.b,k.$He.fromString(r))}f(a,t,r){const{tabSize:s,insertSpaces:i,eol:o}=this.h;if(!t.length){const l=JSON.stringify(r,null,i?" ".repeat(s):"	");return[{content:l,length:l.length,offset:0}]}return(0,E.$1n)(a,t,r,{tabSize:s,insertSpaces:i,eol:o})}get h(){if(!this.g){let a=p.OS===3||p.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[243],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nec=e.$mec=e.$lec=void 0,e.$lec="request",e.$mec="remoteResourceHandler";class n{async routeCall(k,R,j){if(R!==e.$lec)throw new Error(`Call not found: ${R}`);const E=j[0];if(E?.authority){const u=k.connections.find(c=>c.ctx===E.authority);if(u)return u}throw new Error("Caller not found")}routeEvent(k,R){throw new Error(`Event not found: ${R}`)}}e.$nec=n}),define(se[244],re([0,1,15,6]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=c,e.$Jl=(0,C.$yi)("remoteAuthorityResolverService");var k;(function(g){g[g.WebSocket=0]="WebSocket",g[g.Managed=1]="Managed"})(k||(e.RemoteConnectionType=k={}));class R{constructor(p){this.id=p,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=R;class j{constructor(p,v){this.host=p,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=j;var E;(function(g){g.Unknown="Unknown",g.NotAvailable="NotAvailable",g.TemporarilyNotAvailable="TemporarilyNotAvailable",g.NoResolverFound="NoResolverFound",g.InvalidAuthority="InvalidAuthority"})(E||(e.RemoteAuthorityResolverErrorCode=E={}));class u extends n.$bb{static isNotAvailable(p){return p instanceof u&&p._code===E.NotAvailable}static isTemporarilyNotAvailable(p){return p instanceof u&&p._code===E.TemporarilyNotAvailable}static isNoResolverFound(p){return p instanceof u&&p._code===E.NoResolverFound}static isInvalidAuthority(p){return p instanceof u&&p._code===E.InvalidAuthority}static isHandled(p){return p instanceof u&&p.isHandled}constructor(p,v=E.Unknown,m){super(p),this._message=p,this._code=v,this._detail=m,this.isHandled=v===E.NotAvailable&&m===!0,Object.setPrototypeOf(this,u.prototype)}}e.$Ml=u;function c(g){const p=g.indexOf("+");return p===-1?g:g.substring(0,p)}}),define(se[245],re([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Sl=P,e.$Tl=D,e.$Ul=O;const d=30*1e3;var y;(function(Q){Q[Q.Management=1]="Management",Q[Q.ExtensionHost=2]="ExtensionHost",Q[Q.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function w(Q){switch(Q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function b(Q){const A=new k.$qe;return setTimeout(()=>A.cancel(),Q),A.token}function f(Q,A){if(Q.isCancellationRequested||A.isCancellationRequested)return k.CancellationToken.Cancelled;const N=new k.$qe;return Q.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class h{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new E.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$rh)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function S(Q,A){const N=new h(A);return N.registerDisposable(Q.onControlMessage(_=>{const z=JSON.parse(_.toString()),Y=L(z);Y?N.reject(Y):N.resolve(z)})),N.promise}function a(Q,A,N,_,z,Y,x,ee){const X=new h(ee),ue=g.$be.create(!1);return Q.info(`Creating a socket (${x})...`),c.mark(`code/willCreateSocket/${Y}`),A.connect(N,_,z,x).then(he=>{X.didTimeout?(c.mark(`code/didCreateSocketError/${Y}`),Q.info(`Creating a socket (${x}) finished after ${ue.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(c.mark(`code/didCreateSocketOK/${Y}`),Q.info(`Creating a socket (${x}) was successful after ${ue.elapsed()} ms.`),X.resolve(he))},he=>{c.mark(`code/didCreateSocketError/${Y}`),Q.info(`Creating a socket (${x}) returned an error after ${ue.elapsed()} ms.`),Q.error(he),X.reject(he)}),X.promise}function t(Q,A){const N=new h(A);return Q.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function r(Q,A,N,_){const z=G(Q,A);Q.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let Y;try{Y=await a(Q.logService,Q.remoteSocketFactoryService,Q.connectTo,u.$Lg.getServerRootPath(),`reconnectionToken=${Q.reconnectionToken}&reconnection=${Q.reconnectionProtocol?"true":"false"}`,w(A),`renderer-${w(A)}-${Q.reconnectionToken}`,_)}catch(he){throw Q.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),Q.logService.error(he),he}Q.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let x,ee;Q.reconnectionProtocol?(Q.reconnectionProtocol.beginAcceptReconnection(Y,null),x=Q.reconnectionProtocol,ee=!1):(x=new v.$mi({socket:Y}),ee=!0),Q.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const X=await t(Q.signService.createNewMessage((0,p.$Ug)()),_),ue={type:"auth",auth:Q.connectionToken||"00000000000000000000",data:X.data};x.sendControl(C.$He.fromString(JSON.stringify(ue)));try{const he=await S(x,f(_,b(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Se=new Error("Unexpected handshake message");throw Se.code="VSCODE_CONNECTION_ERROR",Se}if(Q.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(Q.signService.validate(X,he.signedData),_)){const Se=new Error("Refused to connect to unsupported server");throw Se.code="VSCODE_CONNECTION_ERROR",Se}const $e=await t(Q.signService.sign(he.data),_),ye={type:"connectionType",commit:Q.commit,signedData:$e,desiredConnectionType:A};return N&&(ye.args=N),Q.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(C.$He.fromString(JSON.stringify(ye))),{protocol:x,ownsProtocol:ee}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(Q.logService.error(`${z} the handshake timed out. Error:`),Q.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(Q.logService.error(`${z} received error control message when negotiating connection. Error:`),Q.logService.error(he)),ee&&q(x),he}}async function s(Q,A,N,_){const z=Date.now(),Y=G(Q,A),{protocol:x,ownsProtocol:ee}=await r(Q,A,N,_),X=new h(_);return X.registerDisposable(x.onControlMessage(ue=>{const he=JSON.parse(ue.toString()),pe=L(he);pe?(Q.logService.error(`${Y} received error control message when negotiating connection. Error:`),Q.logService.error(pe),ee&&q(x),X.reject(pe)):(Q.reconnectionProtocol?.endAcceptReconnection(),Q.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${le(z)}!`),X.resolve({protocol:x,firstMessage:he}))})),X.promise}async function i(Q,A){const{protocol:N}=await s(Q,1,void 0,A);return{protocol:N}}async function o(Q,A,N){const{protocol:_,firstMessage:z}=await s(Q,2,A,N),Y=z&&z.debugPort;return{protocol:_,debugPort:Y}}async function l(Q,A,N){const _=Date.now(),z=G(Q,3),{protocol:Y}=await r(Q,3,A,N);return Q.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${le(_)}!`),Y}async function $(Q,A,N){const{connectTo:_,connectionToken:z}=await Q.addressProvider.getAddress();return{commit:Q.commit,quality:Q.quality,connectTo:_,connectionToken:z,reconnectionToken:A,reconnectionProtocol:N,remoteSocketFactoryService:Q.remoteSocketFactoryService,signService:Q.signService,logService:Q.logService}}async function P(Q,A,N){return I(Q,async _=>{const{protocol:z}=await i(_,k.CancellationToken.None);return new J(Q,A,N,_.reconnectionToken,z)})}async function D(Q,A){return I(Q,async N=>{const{protocol:_,debugPort:z}=await o(N,A,k.CancellationToken.None);return new V(Q,A,N.reconnectionToken,_,z)})}async function I(Q,A){for(let _=1;;_++)try{const z=(0,p.$Ug)(),Y=await $(Q,z,null);return await A(Y)}catch(z){if(_<5)Q.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),Q.logService.error(z);else throw Q.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Q.logService.error(z),ce.triggerPermanentFailure(0,0,m.$Ml.isHandled(z)),z}}async function O(Q,A,N){const _=await $(Q,(0,p.$Ug)(),null);return await l(_,{host:A,port:N},k.CancellationToken.None)}function M(Q){return(0,n.$lh)(A=>new Promise((N,_)=>{const z=setTimeout(N,Q*1e3);A.onCancellationRequested(()=>{clearTimeout(z),N()})}))}var W;(function(Q){Q[Q.ConnectionLost=0]="ConnectionLost",Q[Q.ReconnectionWait=1]="ReconnectionWait",Q[Q.ReconnectionRunning=2]="ReconnectionRunning",Q[Q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Q[Q.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.$Vl=F;class T{constructor(A,N,_,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$Wl=T;class U{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Xl=U;class ae{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Yl=ae;class te{constructor(A,N,_,z){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=z,this.type=3}}e.$Zl=te;class ce extends E.$Uc{static triggerPermanentFailure(A,N,_){this._permanentFailure=!0,this.f=A,this.g=N,this.h=_,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(A,N,_,z,Y){super(),this.t=A,this.u=N,this.reconnectionToken=_,this.protocol=z,this.w=Y,this.m=this.B(new j.$fe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ae(this.reconnectionToken,0,0)),this.B(z.onSocketClose(x=>{const ee=oe(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${ee} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(x=>{const ee=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,E.$Sc)(()=>{const x=ce.j.indexOf(this);x>=0&&ce.j.splice(x,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=oe(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const z=_<N.length?N[_]:N[N.length-1];try{if(z>0){const x=M(z);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,x)),this.u.logService.info(`${A} waiting for ${z} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const Y=await $(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${Y.connectTo}...`),await this.G(Y,b(d)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new ae(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(Y){if(Y.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(m.$Ml.isTemporarilyNotAvailable(Y)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((Y.code==="ETIMEDOUT"||Y.code==="ENETUNREACH"||Y.code==="ECONNREFUSED"||Y.code==="ECONNRESET")&&Y.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if((0,R.$4)(Y)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Y);continue}if(Y instanceof m.$Ml){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,m.$Ml.isHandled(Y));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Y),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,N,_){this.w?ce.triggerPermanentFailure(A,N,_):this.D(A,N,_)}D(A,N,_){this.m.fire(new te(this.reconnectionToken,A,N,_)),q(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$1l=ce;class J extends ce{constructor(A,N,_,z,Y){super(1,A,z,Y,!0),this.client=this.B(new v.$ki(Y,{remoteAuthority:N,clientId:_},A.ipcLogger))}async G(A,N){await i(A,N)}}e.$2l=J;class V extends ce{constructor(A,N,_,z,Y){super(2,A,_,z,!1),this.H=N,this.debugPort=Y}async G(A,N){await o(A,this.H,N)}}e.$3l=V;function q(Q){try{Q.acceptDisconnect();const A=Q.getSocket();Q.dispose(),A.dispose()}catch(A){(0,R.$1)(A)}}function L(Q){if(Q&&Q.type==="error"){const A=new Error(`Connection error: ${Q.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function B(Q,A){for(;Q.length<A;)Q+=" ";return Q}function H(Q,A){return`[remote-connection][${B(w(Q),13)}][${A.substr(0,5)}\u2026]`}function oe(Q,A,N){return`${H(Q,A)}[${N?"reconnect":"initial"}]`}function G(Q,A){return`${oe(A,Q.reconnectionToken,!!Q.reconnectionProtocol)}[${Q.connectTo}]`}function le(Q){return`${Date.now()-Q} ms`}}),define(se[68],re([0,1,13]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=C,e.$Km=k,e.$Lm=R,e.$Mm=j;function C(u){return u.scheme===n.Schemas.vscodeRemote?u.authority:void 0}function k(u){if(!u)return;const c=u.indexOf("+");return c<0?u:u.substr(0,c)}function R(u){const{host:c,port:g}=E(u);if(typeof g>"u")throw new Error(`Invalid remote authority: ${u}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:c,port:g}}function j(u,c){let{host:g,port:p}=E(u);return typeof p>"u"&&(p=c),{host:g,port:p}}function E(u){const c=u.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(c)return{host:c[1],port:parseInt(c[2],10)};const g=u.match(/^(\[[0-9a-z:]+\])$/);if(g)return{host:g[1],port:void 0};const p=u.match(/(.*):(\d+)$/);return p?{host:p[1],port:parseInt(p[2],10)}:{host:u,port:void 0}}}),define(se[124],re([0,1,25,6,68]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=R,e.$Wm=p,e.$Xm=v,e.$Ym=m,e.$Zm=d,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var E;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(E||(e.TargetPlatform=E={}));class u{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,b){if(typeof w>"u"||w===null)return typeof b>"u"||b===null;if(typeof b>"u"||b===null)return!1;if(typeof w=="string"||typeof b=="string"){const f=typeof w=="string"?w:w.value,h=typeof b=="string"?b:b.value;return n.$zf(f,h)}return w._lower===b._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$Tm=u;class c{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const b of w)this.add(b)}add(w){this.c.add(u.toKey(w))}delete(w){return this.c.delete(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}}e.$Um=c;class g{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(u.toKey(w))}get(w){return this.c.get(u.toKey(w))}has(w){return this.c.has(u.toKey(w))}set(w,b){this.c.set(u.toKey(w),b)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=g;function p(y){return v(y)}function v(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function m(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function d(y,w){if(w){const b=`onResolveRemoteAuthority:${(0,k.$Km)(w)}`;return!!y.activationEvents?.includes(b)}return!1}e.$1m=(0,C.$yi)("IBuiltinExtensionsScannerService")}),define(se[246],re([0,1,2,6]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol=(0,C.$yi)("remoteSocketFactoryService");class k{constructor(){this.a={}}register(j,E){return this.a[j]??=[],this.a[j].push(E),(0,n.$Sc)(()=>{const u=this.a[j]?.indexOf(E);typeof u=="number"&&u>=0&&this.a[j]?.splice(u,1)})}b(j){return(this.a[j.type]||[]).find(u=>u.supports(j))}connect(j,E,u,c){const g=this.b(j);if(!g)throw new Error(`No socket factory found for ${j}`);return g.connect(j,E,u,c)}}e.$Pl=k}),define(se[247],re([0,1,26,49,21,117]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=E;let j;async function E(m=!1){return(j===void 0||m)&&(j=u()),j}async function u(){const m=c();if(m===void 0)return!1;if(m>=22e3){const d=p();if(d)return new Promise(y=>{C.execFile(d,["--status"],w=>y(!w))})}else{const d=v();if(d)try{if((await k.Promises.stat(d)).isFile())return!0}catch{}}return!1}function c(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(m)return parseInt(m[3])}function g(m){const d=process.env.SystemRoot;if(d){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(d,y?"Sysnative":"System32",m)}}function p(){return g("wsl.exe")}function v(){return g("lxss\\LxssManager.dll")}}),define(se[53],re([0,1,17,15,2,186,52,6,5,45]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=v,e.$Up=m,e.$Vp=d,e.$Wp=y,e.$Xp=w,e.$Yp=b,e.$Rp=(0,E.$yi)("requestService");class g{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class p extends k.$Uc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,R.localize)(0,null),when:u.$kk.isEqualTo((0,u.$hk)(u.LogLevel.Trace)).serialize()})}async c(a,t,r){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new g(t.headers??{}));try{const i=await r();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,C.$0)(i)),i}}}e.$Sp=p;function v(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}function m(S){return S.res.statusCode===204}async function d(S){return m(S)?null:(await(0,n.$Te)(S.stream)).toString()}async function y(S){if(!v(S))throw new Error("Server returned "+S.res.statusCode);return d(S)}async function w(S){if(!v(S))throw new Error("Server returned "+S.res.statusCode);if(m(S))return null;const t=(await(0,n.$Te)(S.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function b(S){h(S)}let f;function h(S){const a=c.$fo.as(j.$ko.Configuration),t=f;f={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[f],remove:t?[t]:[]})}h(1)}),define(se[248],re([0,1,17,23]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=void 0;class k{constructor(E){this.a=E}listen(E,u){throw new Error("Invalid listen")}call(E,u,c,g=C.CancellationToken.None){switch(u){case"request":return this.a.request(c[0],g).then(async({res:p,stream:v})=>{const m=await(0,n.$Te)(v);return[{statusCode:p.statusCode,headers:p.headers},m]});case"resolveProxy":return this.a.resolveProxy(c[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Yr=k;class R{constructor(E){this.a=E}async request(E,u){const[c,g]=await this.a.call("request",[E],u);return{res:c,stream:(0,n.$Ve)(g)}}async resolveProxy(E){return this.a.call("resolveProxy",[E])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Zr=R}),define(se[249],re([0,1,250,12]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=R;function k(j,E){return j.protocol==="http:"?E.HTTP_PROXY||E.http_proxy||null:j.protocol==="https:"&&(E.HTTPS_PROXY||E.https_proxy||E.HTTP_PROXY||E.http_proxy)||null}async function R(j,E,u={}){const c=(0,n.parse)(j),g=u.proxyUrl||k(c,E);if(!g)return null;const p=(0,n.parse)(g);if(!/^https?:$/.test(p.protocol||""))return null;const v={host:p.hostname||"",port:(p.port?+p.port:0)||(p.protocol==="https"?443:80),auth:p.auth,rejectUnauthorized:(0,C.$eg)(u.strictSSL)?u.strictSSL:!0};return c.protocol==="http:"?new(await new Promise((m,d)=>{K(["http-proxy-agent"],m,d)})).HttpProxyAgent(g,v):new(await new Promise((m,d)=>{K(["https-proxy-agent"],m,d)})).HttpsProxyAgent(g,v)}}),define(se[251],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=e.$Hdc=void 0,e.$Hdc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Idc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Jdc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(se[95],re([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=y;let d;async function y(b,f,h,S){return h["force-disable-user-env"]?(f.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(f.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,p.$Cm)(S)&&!h["force-user-env"]?(f.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,p.$Cm)(S)?f.trace("resolveShellEnv(): running (--force-user-env)"):f.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=v.Promises.withAsyncBody(async(a,t)=>{const r=new R.$qe;let s=1e4;const i=b.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,m.$Dm)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,k.localize)(0,null)))},s);try{a(await w(f,r.token))}catch(l){!(0,E.$4)(l)&&!r.token.isCancellationRequested?t(new Error((0,k.localize)(1,null,(0,j.$jj)(l)))):a({})}finally{clearTimeout(o),r.dispose()}})),d)}async function w(b,f){const h=process.env.ELECTRON_RUN_AS_NODE;b.trace("getUnixShellEnvironment#runAsNode",h);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;b.trace("getUnixShellEnvironment#noAttach",S);const a=(0,c.$Ug)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};b.trace("getUnixShellEnvironment#env",r);const s=await(0,g.$sm)(u.OS,r);return b.trace("getUnixShellEnvironment#shell",s),new Promise((i,o)=>{if(f.isCancellationRequested)return o(new E.$5);const l=(0,C.$nc)(s);let $,P;const D="";/^pwsh(-preview)?$/.test(l)?($=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,P=["-Login","-Command"]):l==="nu"?($=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,P=["-i","-l","-c"]):l==="xonsh"?($=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,P=["-i","-l","-c"]):($=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,l==="tcsh"||l==="csh"?P=["-ic"]:P=["-i","-l","-c"]),b.trace("getUnixShellEnvironment#spawn",JSON.stringify(P),$);const I=(0,n.spawn)(s,[...P,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});f.onCancellationRequested(()=>(I.kill(),o(new E.$5))),I.on("error",W=>{b.error("getUnixShellEnvironment#errorChildProcess",(0,j.$jj)(W)),o(W)});const O=[];I.stdout.on("data",W=>O.push(W));const M=[];I.stderr.on("data",W=>M.push(W)),I.on("close",(W,F)=>{const T=Buffer.concat(O).toString("utf8");b.trace("getUnixShellEnvironment#raw",T);const U=Buffer.concat(M).toString("utf8");if(U.trim()&&b.trace("getUnixShellEnvironment#stderr",U),W||F)return o(new Error((0,k.localize)(2,null,W,F)));const ae=t.exec(T),te=ae?ae[1]:"{}";try{const ce=JSON.parse(te);h?ce.ELECTRON_RUN_AS_NODE=h:delete ce.ELECTRON_RUN_AS_NODE,S?ce.ELECTRON_NO_ATTACH_CONSOLE=S:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,b.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){b.error("getUnixShellEnvironment#errorCaught",(0,j.$jj)(ce)),o(ce)}})})}}),define(se[252],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(k){try{const R=await this.c();if(R){const j=String(n.a++);return this.b.set(j,R),{id:j,data:R.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,R){if(!k.id)return!0;const j=this.b.get(k.id);if(!j)return!1;this.b.delete(k.id);try{return j.validate(R)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(k){try{return await this.d(k)}catch{}return k}}e.$B_b=n}),define(se[96],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql="signService",e.$Rl=(0,n.$yi)(e.$Ql)}),define(se[253],re([0,1,252]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class C extends n.$B_b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(j=>new j.signer().sign(R))}h(){return new Promise((R,j)=>K(["vsda"],R,j))}}e.$xec=C}),define(se[34],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$5P=(0,n.$yi)("stateReadService"),e.$6P=(0,n.$yi)("stateService")}),define(se[125],re([0,1,8,17,2,12,38,16,5]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=e.$7P=e.SaveStrategy=void 0;var c;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(c||(e.SaveStrategy=c={}));class g extends k.$Uc{constructor(d,y,w,b){super(),this.h=d,this.j=y,this.m=w,this.n=b,this.a=Object.create(null),this.b="",this.c=this.B(new n.$wh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.m.error(d)}}getItem(d,y){const w=this.a[d];return(0,R.$hg)(w)?y:w}setItem(d,y){this.setItems([{key:d,data:y}])}setItems(d){let y=!1;for(const{key:w,data:b}of d)this.a[w]!==b&&((0,R.$hg)(b)?(0,R.$fg)(this.a[w])||(this.a[w]=void 0,y=!0):(this.a[w]=b,y=!0));y&&this.s()}removeItem(d){(0,R.$fg)(this.a[d])||(this.a[d]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.n.writeFile(this.h,C.$He.fromString(d),{atomic:{postfix:".vsctmp"}}),this.b=d}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$7P=g;let p=class extends k.$Uc{constructor(d,y,w,b){super(),this.a=this.B(new g(y.stateResource,d,w,b))}async init(){await this.a.init()}getItem(d,y){return this.a.getItem(d,y)}};e.$8P=p,e.$8P=p=Ee([ie(1,j.$Fi),ie(2,u.$5j),ie(3,E.$5k)],p);class v extends p{setItem(d,y){this.a.setItem(d,y)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.$9P=v}),define(se[126],re([0,1,4,36,33]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=j,e.$ip=E;function R(u){if(n.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function j(u,c,g,p,v,m,d,y,w){const b=Object.create(null);b["common.machineId"]=m,b["common.sqmId"]=d,b.sessionID=(0,k.$Ug)()+Date.now(),b.commitHash=p,b.version=v,b["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,n.$h)(n.$u),b["common.nodePlatform"]=C.$dc,b["common.nodeArch"]=g,b["common.product"]=w||"desktop",y&&(b["common.msftInternal"]=y);let f=0;const h=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),n.$l&&(b["common.snap"]="true");const S=R(c);return S&&(b["common.platformDetail"]=S),b}function E(u){const c=C.env.USERDNSDOMAIN;if(!c)return!1;const g=c.toLowerCase();return u.some(p=>g===p)}}),define(se[28],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,n.$yi)("telemetryService"),e.$5l=(0,n.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var C;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var k;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(k||(e.TelemetryConfiguration=k={}))}),define(se[254],re([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0,e.$Is=b,e.$Js=h,e.$Ks=S;const w=new Map;async function b(t,r){const s=`${t}::${r.join(":")}`,i=w.get(s);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,$=new Map,P=2e4;function D(O,M,W,F){const T=M.substring(O.length+1);return C.Promises.withAsyncBody(async U=>{let ae;try{ae=await g.Promises.readdir(M,{withFileTypes:!0})}catch{U();return}if(F.count>=P){F.count+=ae.length,F.maxReached=!0,U();return}let te=ae.length;if(te===0){U();return}let ce=ae;F.count+ae.length>P&&(F.maxReached=!0,te=P-F.count,ce=ae.slice(0,te)),F.count+=ae.length;for(const J of ce)if(J.isDirectory()){if(W.includes(J.name)||await D(O,(0,j.$jc)(M,J.name),W,F),--te===0){U();return}}else{const V=J.name.lastIndexOf(".");if(V>=0){const q=J.name.substring(V+1);q&&l.set(q,(l.get(q)??0)+1)}for(const q of o)q.relativePathPattern?.test(T)!==!1&&q.filePattern.test(J.name)&&$.set(q.tag,($.get(q.tag)??0)+1);if(--te===0){U();return}}})}const I=C.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await D(t,t,r,M);const W=await S(t);O({configFiles:f($),fileTypes:f(l),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:W})});return w.set(s,I),I}function f(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function h(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/m.$Al.GB).toFixed(2)}GB (${(n.freemem()/m.$Al.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(c.$Gn.value()*100)}%`},r=n.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function S(t){try{const r=new Map,s=(0,j.$jc)(t,".vscode","launch.json"),i=await g.Promises.readFile(s),o=[],l=(0,k.$Ln)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,k.$Un)(l)==="object"&&l.configurations)for(const $ of l.configurations){const P=$.type;P&&(r.has(P)?r.set(P,r.get(P)+1):r.set(P,1))}return f(r)}catch{return[]}}let a=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/m.$Al.GB).toFixed(2)}GB (${(n.freemem()/m.$Al.GB).toFixed(2)}GB free)`),E.$i||s.push(`Load (avg):       ${n.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(c.$Gn.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,p.$Hs)(r.mainPID),this.k(r)]).then(async i=>{let[o,l]=i,$=this.m(r,o);return s.forEach(P=>{if((0,v.$gn)(P))$+=`
${P.errorMessage}`,l+=`
${P.errorMessage}`;else if($+=`

Remote: ${P.hostName}`,P.processes&&($+=`
${this.m(r,P.processes)}`),P.workspaceMetadata){l+=`
|  Remote: ${P.hostName}`;for(const D of Object.keys(P.workspaceMetadata)){const I=P.workspaceMetadata[D];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${D}): ${O}`,l+=this.h(I)}}}),{processInfo:$,workspaceInfo:l}})}async getSystemInfo(r,s){const{memory:i,vmHint:o,os:l,cpus:$}=h(),P={os:l,memory:i,cpus:$,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return E.$i||(P.load=`${n.loadavg().map(D=>Math.round(D)).join(", ")}`),E.$k&&(P.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(P)}async getDiagnostics(r,s){const i=[];return(0,p.$Hs)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),s.forEach(l=>{if((0,v.$gn)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(r,l.processes)),l.workspaceMetadata)for(const $ of Object.keys(l.workspaceMetadata)){const P=l.workspaceMetadata[$];let D=`${P.fileCount} files`;P.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${$}): ${D}`),i.push(this.h(P))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const s=[];let o=0;const l=(I,O)=>{const M=` ${I}(${O})`;o+M.length>60?(s.push($),$="|                 ",o=$.length):o+=M.length,$+=M};let $="|      File types:";const P=10,D=r.fileTypes.length>P?P:r.fileTypes.length;for(let I=0;I<D;I++){const O=r.fileTypes[I];l(O.name,O.count)}if(s.push($),r.configFiles.length>=0&&($="|      Conf files:",o=0,r.configFiles.forEach(I=>{l(I.name,I.count)}),s.push($)),r.launchConfigFiles.length>0){let I="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),s.push(I)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const s=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(l=>{const $=u.URI.revive(l);if($.scheme===R.Schemas.file){const P=$.fsPath;i.push(b(P,["node_modules",".git"]).then(D=>{let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),s.push(`|    Folder (${(0,j.$nc)(P)}): ${I}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${P} (${D.toString()})`)}))}else s.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,s){const i=new Map;r.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),r.pidToNames.forEach(({pid:l,name:$})=>i.set(l,$));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,i,o,s,0),o.join(`
`)}n(r,s,i,o,l){const $=l===0;let P;$?P=o.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?P=s.get(o.pid):P=`${"  ".repeat(l)} ${o.name}`;const D=process.platform==="win32"?o.mem:n.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/m.$Al.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${P}`),Array.isArray(o.children)&&o.children.forEach(I=>this.n(r,s,i,I,l+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:i}of r.folders){const o=u.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const l=o.fsPath;try{(await b(l,["node_modules",".git"])).fileTypes.forEach(P=>s.add(P.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const i=u.URI.revive(s);if(i.scheme!==R.Schemas.file)continue;const o=i.fsPath;try{const l=await b(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),l.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})}),l.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})}),l.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$Ls=a,e.$Ls=a=Ee([ie(0,y.$4l),ie(1,d.$lk)],a)}),define(se[255],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;class n{constructor(R){this.b=R}listen(R,j){throw new Error(`Event not found: ${j}`)}call(R,j,{eventName:E,data:u}){return this.b.forEach(c=>c.log(E,u)),Promise.resolve(null)}}e.$Mdc=n;class C{constructor(R){this.b=R}log(R,j){return this.b.call("log",{eventName:R,data:j}).then(void 0,E=>`Failed to log telemetry: ${console.warn(E)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Ndc=C}),define(se[54],re([0,1,35,12,68,126,28]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=g,e.$rp=p,e.$sp=v,e.$tp=m,e.$up=y,e.$vp=b,e.$wp=f,e.$xp=a;class E{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$jp=E;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=u,e.$lp=new u;class c{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.$mp=c,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function g(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function p(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const r=t.getValue(j.$_l),s=t.getValue(j.$am);if(t.getValue(j.$bm)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const r={},s={},i={};w(t,i);for(let o in i){o=o.length>150?o.substr(o.length-149):o;const l=i[o];typeof l=="number"?s[o]=l:typeof l=="boolean"?s[o]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${l.length}`),r[o]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(r[o]=l)}return{properties:r,measurements:s}}const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const r=(0,k.$Km)(t);return d.has(r)?r:"other"}function w(t,r,s=0,i){if(t)for(const o of Object.getOwnPropertyNames(t)){const l=t[o],$=i?i+o:o;Array.isArray(l)?r[$]=(0,n.$0n)(l):l instanceof Date?r[$]=l.toISOString():(0,C.$ag)(l)?s<2?w(l,r,s+1,$+"."):r[$]=(0,n.$0n)(l):r[$]=l}}function b(t,r){const s=t.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,R.$ip)(s)||i}function f(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const P of r)for(;;){const D=P.exec(t);if(!D)break;i.push([D.index,P.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(s="";;){const P=l.exec(t);if(!P)break;const D=i.some(([I,O])=>P.index<O&&I<l.lastIndex);!o.test(P[0])&&!D&&(s+=t.substring($,P.index)+"<REDACTED: user-file-path>",$=l.lastIndex)}return $<t.length&&(s+=t.substr($)),s}function S(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,r){return(0,n.$7n)(t,s=>{if(s instanceof E||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=h(i,r);for(const o of r)i=i.replace(o,"");return i=S(i),i}})}}),define(se[127],re([0,1,25,121,124,4,7,15,36,54]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=g,e.$Ap=d,e.$Bp=y,e.$Cp=w,e.$Dp=b,e.$Ep=f,e.$Fp=h,e.$Gp=S,e.$Ip=a,e.$Jp=r;function g(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,n.$uf)(s.id,i.id)===0}const p=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,l)}static parse(i){const o=p.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,l="undefined"){this.version=o,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?g(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$zp=v;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function d(s){const i=m.exec(s);return i&&i[1]?[w(i[1]),i[2]]:[w(s),void 0]}function y(s,i){return`${s}.${i}`}function w(s){return s.toLowerCase()}function b(s,i){return w(y(s??k.$Pm,i))}function f(s,i){const o=[],l=$=>{for(const P of o)if(P.some(D=>g(i(D),i($))))return P;return null};for(const $ of s){const P=l($);P?P.push($):o.push([$])}return o}function h(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function S(s){return{id:new c.$jp(s.identifier.id),name:new c.$jp(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Hp=new k.$Tm("pprice.better-merge");function a(s,i){const o=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const $=l.shift();if($&&o.every(P=>!g(P.identifier,{id:$}))){const P=s.filter(D=>g(D.identifier,{id:$}));P.length===1&&(o.push(P[0]),l.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(s,i){if(!R.$k)return!1;let o;try{o=(await s.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch($){i.debug("Error while getting the os-release file.",(0,E.$0)($))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const o=await t(s,i),l=(0,C.$6o)(o?"alpine":R.$u,u.$ec);return i.debug("ComputeTargetPlatform:",l),l}}),define(se[256],re([0,1,209,54]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=k;async function k(R,j,E,u,c,g,p){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${j.nameShort})`};if((0,C.$qp)(j,E)&&(0,C.$sp)(u)===3){const m=await(0,n.$$p)(E,c,g);v["X-Market-User-Id"]=m,v["VSCode-SessionId"]=p.machineId||m}return v}}),define(se[257],re([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;let d=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(b,f,h){this.k=f,this.l=h,this.d={},this.i=new n.$Tc,this.j=[],this.b=b.appenders,this.c=b.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=b.piiPaths||[],this.g=3,this.h=!!b.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,R.$bf)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$bf)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(v.$_l)||S.affectsConfiguration(v.$bm)||S.affectsConfiguration(v.$am))&&this.m()}))}setExperimentProperty(b,f){this.d[b]=f}m(){let b=(0,m.$sp)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const h=f.usage?3:f.error?2:0;b=Math.min(b,h)}this.g=b}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(b,f,h){this.g<f||(h=(0,C.$8n)(h,this.d),h=(0,m.$xp)(h,this.j),h=(0,C.$8n)(h,this.c),this.b.forEach(S=>S.log(b,h)))}publicLog(b,f){this.n(b,3,f)}publicLog2(b,f){this.publicLog(b,f)}publicLogError(b,f){this.h&&this.n(b,2,f)}publicLogError2(b,f){this.publicLogError(b,f)}};e.$4r=d,e.$4r=d=Ee([ie(1,E.$5i),ie(2,g.$lk)],d);function y(){const w=(0,j.localize)(0,null,c.default.nameLong),b=c.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",c.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=k.$o?"":(0,j.localize)(3,null),h=(0,j.localize)(4,null),S=(0,j.localize)(5,null),a=(0,j.localize)(6,null),t=(0,j.localize)(7,null),r=`
|       | ${h} | ${S} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,j.localize)(8,null);return`
${w} ${b} ${f}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}p.$fo.as(u.$ko.Configuration).registerConfiguration({id:v.$$l,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[v.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),p.$fo.as(u.$ko.Configuration).registerConfiguration({id:v.$$l,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[v.$bm]:{type:"boolean",markdownDescription:c.default.privacyStatementUrl?(0,j.localize)(16,null,c.default.nameLong,c.default.privacyStatementUrl):(0,j.localize)(15,null,c.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${v.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[258],re([0,1,4,89,28]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=R,e.$dec=j;async function R(E,u){let c=E.getItem(k.$9l);return(typeof c!="string"||n.$j&&c==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(c=await(0,C.$Hn)(u.error.bind(u))),c}async function j(E,u){let c=E.getItem(k.$0l);return typeof c!="string"&&(c=await(0,C.$In)(u.error.bind(u))),c}}),define(se[259],re([0,1,28,258]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=k,e.$fec=R;async function k(j,E){const u=await(0,C.$cec)(j,E);return j.setItem(n.$9l,u),u}async function R(j,E){const u=await(0,C.$dec)(j,E);return j.setItem(n.$0l,u),u}}),define(se[128],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(se[260],re([0,1,4,128]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;const k=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(g){this.collections=g,this.a=new Map,this.b=new Map,g.forEach((p,v)=>{this.d(p,v);const m=p.map.entries();let d=m.next();for(;!d.done;){const y=d.value[1],w=d.value[0];let b=this.a.get(w);if(b||(b=[],this.a.set(w,b)),b.length>0&&b[0].type===C.EnvironmentVariableMutatorType.Replace){d=m.next();continue}const f={extensionIdentifier:v,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};f.scope||delete f.scope,b.unshift(f),d=m.next()}})}async applyToProcessEnvironment(g,p,v){let m;n.$i&&(m={},Object.keys(g).forEach(d=>m[d.toLowerCase()]=d));for(const[d,y]of this.getVariableMap(p)){const w=n.$i&&m[d.toLowerCase()]||d;for(const b of y){const f=v?await v(b.value):b.value;if(b.options?.applyAtProcessCreation??!0)switch(b.type){case C.EnvironmentVariableMutatorType.Append:g[w]=(g[w]||"")+f;break;case C.EnvironmentVariableMutatorType.Prepend:g[w]=f+(g[w]||"");break;case C.EnvironmentVariableMutatorType.Replace:g[w]=f;break}if(b.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${k.get(b.type)}`;g[h]=(g[h]?g[h]+":":"")+d+"="+this.c(f)}}}}c(g){return g.replaceAll(":","\\x3a")}diff(g,p){const v=new Map,m=new Map,d=new Map;if(g.getVariableMap(p).forEach((y,w)=>{const b=this.getVariableMap(p).get(w),f=E(y,b);f&&v.set(w,f)}),this.getVariableMap(p).forEach((y,w)=>{const b=g.getVariableMap(p).get(w),f=E(y,b);f&&d.set(w,f)}),this.getVariableMap(p).forEach((y,w)=>{const b=g.getVariableMap(p).get(w),f=u(y,b);f&&m.set(w,f)}),!(v.size===0&&m.size===0&&d.size===0))return{added:v,changed:m,removed:d}}getVariableMap(g){const p=new Map;for(const v of this.a.values()){const m=v.filter(d=>j(d,g));m.length>0&&p.set(m[0].variable,m)}return p}getDescriptionMap(g){const p=new Map;for(const v of this.b.values()){const m=v.filter(d=>j(d,g,!0));for(const d of m)p.set(d.extensionIdentifier,d.description)}return p}d(g,p){if(!g.descriptionMap)return;const v=g.descriptionMap.entries();let m=v.next();for(;!m.done;){const d=m.value[1],y=m.value[0];let w=this.b.get(y);w||(w=[],this.b.set(y,w));const b={extensionIdentifier:p,scope:d.scope,description:d.description};b.scope||delete b.scope,w.push(b),m=v.next()}}}e.$vs=R;function j(c,g,p=!1){return c.scope?!!(c.scope.workspaceFolder&&g?.workspaceFolder&&c.scope.workspaceFolder.index===g.workspaceFolder.index):p?g===c.scope:!0}function E(c,g){if(!g)return c;const p=new Set;g.forEach(m=>p.add(m.extensionIdentifier));const v=[];return c.forEach(m=>{p.has(m.extensionIdentifier)||v.push(m)}),v.length===0?void 0:v}function u(c,g){if(!g)return;const p=new Map;g.forEach(m=>p.set(m.extensionIdentifier,m));const v=[];return c.forEach(m=>{const d=p.get(m.extensionIdentifier);d&&(m.type!==d.type||m.value!==d.value||m.scope?.workspaceFolder?.index!==d.scope?.workspaceFolder?.index)&&v.push(d)}),v.length===0?void 0:v}}),define(se[261],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ps=n,e.$qs=C,e.$rs=k,e.$ss=R,e.$ts=j,e.$us=E;function n(u){return[...u.entries()]}function C(u){return u?[...u.entries()]:[]}function k(u){return new Map(u)}function R(u){return new Map(u??[])}function j(u){return Array.from(u.entries()).map(c=>[c[0],n(c[1].map),C(c[1].descriptionMap)])}function E(u){return new Map(u.map(c=>[c[0],{map:k(c[1]),descriptionMap:R(c[2])}]))}}),define(se[262],re([0,1,8,23,3,2,5]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gs=void 0;let E=class extends R.$Uc{constructor(c,g){super(),this.h=g,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$fe),this.onCreateRequest=this.g.event,this.b=c===void 0?15e3:c,this.B((0,R.$Sc)(()=>{for(const p of this.f.values())(0,R.$Pc)(p)}))}createRequest(c){return new Promise((g,p)=>{const v=++this.a;this.c.set(v,g),this.g.fire({requestId:v,...c});const m=new C.$qe;(0,n.$zh)(this.b,m.token).then(()=>p(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,R.$Sc)(()=>m.cancel())])})}acceptReply(c,g){const p=this.c.get(c);p?(this.c.delete(c),(0,R.$Pc)(this.f.get(c)||[]),this.f.delete(c),p(g)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${c}`)}};e.$gs=E,e.$gs=E=Ee([ie(1,j.$5j)],E)}),define(se[129],re([0,1,6,118,45]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=e.$bs=e.$as=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$_r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$$r=void 0,e.$$r=new C.$Pj("terminalTabFocusMode",!1,!0);var R;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var j;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var E;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(E||(e.PosixShellType=E={}));var u;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(u||(e.WindowsShellType=u={}));var c;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(c||(e.TitleEventSource=c={}));var g;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(g||(e.TerminalIpcChannels=g={}));var p;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(p||(e.ProcessPropertyType=p={})),e.$_r=(0,n.$yi)("ptyService");var v;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var m;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var d;(function(a){a.TerminalView="view",a.Editor="editor"})(d||(e.TerminalLocationString=d={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var w;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(w||(e.FlowControlConstants=w={}));var b;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})(b||(e.ProfileSource=b={}));var f;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(f||(e.ShellIntegrationStatus=f={}));var h;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$as={Backend:"workbench.contributions.terminal.processBackend"};class S{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}k.$fo.add(e.$as.Backend,new S),e.$bs=(0,n.$yi)("localPtyService"),e.$cs=(0,n.$yi)("terminalLogService")}),define(se[263],re([0,1,75,7,190,106]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=j,e.$is=c,e.$js=g,e.$ks=p;function j(v,m){const d=[{name:null,description:(0,k.localize)(0,null)}];return d.push(...v.map(y=>({name:y.profileName,description:E(y)}))),m&&d.push(...m.map(y=>({name:y.title,description:u(y)}))),{values:d.map(y=>y.name),markdownDescriptions:d.map(y=>y.description)}}function E(v){let m=`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Xj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?m+=`
- args: "${v.args}"`:m+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(m+=`
- overrideName: ${v.overrideName}`),v.color&&(m+=`
- color: ${v.color}`),v.env&&(m+=`
- env: ${JSON.stringify(v.env)}`),m}function u(v){return`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Xj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function c(v,m){if(!v&&!m)return!0;if(typeof v=="string"&&typeof m=="string")return v===m;if(Array.isArray(v)&&Array.isArray(m)){if(v.length!==m.length)return!1;for(let d=0;d<v.length;d++)if(v[d]!==m[d])return!1;return!0}return!1}function g(v,m){if(!v&&!m)return!0;if(!v||!m)return!1;if(R.ThemeIcon.isThemeIcon(v)&&R.ThemeIcon.isThemeIcon(m))return v.id===m.id&&v.color===m.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof m=="object"&&"light"in m&&"dark"in m){const d=v,y=m;if((C.URI.isUri(d.light)||p(d.light))&&(C.URI.isUri(d.dark)||p(d.dark))&&(C.URI.isUri(y.light)||p(y.light))&&(C.URI.isUri(y.dark)||p(y.dark)))return d.light.path===y.light.path&&d.dark.path===y.dark.path}if(C.URI.isUri(v)&&C.URI.isUri(m)||p(v)||p(m)){const d=v,y=m;return d.path===y.path&&d.scheme===y.scheme}return!1}function p(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}}),define(se[264],re([0,1,75,4,189,52,45,263]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ms=e.$ls=void 0,e.$ns=m,e.$os=y,e.$ls={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$ms={type:"string",enum:Array.from((0,n.$Vj)(),w=>w.id),markdownEnumDescriptions:Array.from((0,n.$Vj)(),w=>`$(${w.id})`)};const u={args:{description:(0,k.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,k.localize)(1,null),type:"boolean"},icon:{description:(0,k.localize)(2,null),...e.$ms},color:{description:(0,k.localize)(3,null),...e.$ls},env:{markdownDescription:(0,k.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},c={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(5,null),type:["string","array"],items:{type:"string"}},...u}},g={type:"object",required:["path"],properties:{path:{description:(0,k.localize)(6,null),type:["string"],items:{type:"string"}},...u}};function p(w){const b=w===2?"linux":w===1?"osx":"windows";return(0,k.localize)(7,null,(0,C.$h)(w),'```json\n"terminal.integrated.profile.'+b+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,k.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,k.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,k.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,k.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},g],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:p(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,k.localize)(12,null),enum:["PowerShell","Git Bash"]},...u}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(13,null),type:"string"},id:{description:(0,k.localize)(14,null),type:"string"},title:{description:(0,k.localize)(15,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:p(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(16,null),type:"string"},id:{description:(0,k.localize)(17,null),type:"string"},title:{description:(0,k.localize)(18,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:p(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,k.localize)(19,null),type:"string"},id:{description:(0,k.localize)(20,null),type:"string"},title:{description:(0,k.localize)(21,null),type:"string"},...u}},{type:"null"},c]}},"terminal.integrated.useWslProfiles":{description:(0,k.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,k.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,k.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,k.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,k.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){j.$fo.as(R.$ko.Configuration).registerConfiguration(v),y()}let d;function y(w,b){const f=j.$fo.as(R.$ko.Configuration);let h;w&&(h=(0,E.$hs)(w?.profiles,b));const S=d;d={id:"terminal",order:100,title:(0,k.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,k.localize)(28,null),type:["string","null"],default:null,enum:w?.os===3?h?.values:void 0,markdownEnumDescriptions:w?.os===3?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,k.localize)(29,null),type:["string","null"],default:null,enum:w?.os===2?h?.values:void 0,markdownEnumDescriptions:w?.os===2?h?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,k.localize)(30,null),type:["string","null"],default:null,enum:w?.os===1?h?.values:void 0,markdownEnumDescriptions:w?.os===1?h?.markdownDescriptions:void 0}}},f.updateConfigurations({add:[d],remove:S?[S]:[]})}}),define(se[265],re([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=d,e.$xs=y,e.$ys=w;function d(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let $=0;return l&&l.length===4&&($=parseInt(l[3])),$}async function y(l,$,P,D=E.env,I=g.Promises.exists){if(R.$ic(l))return await I(l)?l:void 0;if($===void 0&&($=E.cwd()),R.$mc(l)!=="."){const F=R.$jc($,l);return await I(F)?F:void 0}const M=(0,k.$_n)(D,"PATH");if(P===void 0&&(0,c.$$f)(M)&&(P=M.split(R.$tc)),P===void 0||P.length===0){const F=R.$jc($,l);return await I(F)?F:void 0}for(const F of P){let T;if(R.$ic(F)?T=R.$jc(F,l):T=R.$jc($,F,l),await I(T))return T;if(j.$i){let U=T+".com";if(await I(U)||(U=T+".exe",await I(U)))return U}}const W=R.$jc($,l);return await I(W)?W:void 0}function w(l,$,P,D,I){const O=j.$i&&(!$.windowsEnableConpty||d()<18309);if(!$.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||O)return;const M=l.args,W=E.$dc==="win32"?R.$nc(l.executable).toLowerCase():R.$nc(l.executable),F=R.$mc(C.$Sg.asFileUri("").fsPath);let T;const U={VSCODE_INJECTION:"1"};if($.shellIntegration.nonce&&(U.VSCODE_NONCE=$.shellIntegration.nonce),j.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!M||i(M)?T=h.get(f.WindowsPwsh):s(M)&&(T=h.get(f.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,u.$0e)(T[T.length-1],F,""),$.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:U}):void 0;if(W==="bash.exe")return!M||M.length===0?T=h.get(f.Bash):o(M)&&(U.VSCODE_SHELL_LOGIN="1",b($,U),T=h.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,u.$0e)(T[T.length-1],F),{newArgs:T,envMixin:U}):void 0;D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(W){case"bash":return!M||M.length===0?T=h.get(f.Bash):o(M)&&(U.VSCODE_SHELL_LOGIN="1",b($,U),T=h.get(f.Bash)),T?(T=[...T],T[T.length-1]=(0,u.$0e)(T[T.length-1],F),{newArgs:T,envMixin:U}):void 0;case"fish":{const ae=P?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",te=R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return U.XDG_DATA_DIRS=`${ae}:${te}`,b($,U),{newArgs:void 0,envMixin:U}}case"pwsh":return!M||i(M)?T=h.get(f.Pwsh):s(M)&&(T=h.get(f.PwshLogin)),T?($.shellIntegration.suggestEnabled&&(U.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,u.$0e)(T[T.length-1],F,""),{newArgs:T,envMixin:U}):void 0;case"zsh":{if(!M||M.length===0?T=h.get(f.Zsh):o(M)?(T=h.get(f.ZshLogin),b($,U)):(M===h.get(f.Zsh)||M===h.get(f.ZshLogin))&&(T=M),!T)return;T=[...T],T[T.length-1]=(0,u.$0e)(T[T.length-1],F);let ae;try{ae=n.userInfo().username}catch{ae="unknown"}const te=R.$jc(n.tmpdir(),`${ae}-${I.applicationName}-zsh`);U.ZDOTDIR=te;const ce=P?.ZDOTDIR??n.homedir()??"~";U.USER_ZDOTDIR=ce;const J=[];return J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$jc(te,".zshrc")}),J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$jc(te,".zprofile")}),J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$jc(te,".zshenv")}),J.push({source:R.$jc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$jc(te,".zlogin")}),{newArgs:T,envMixin:U,filesToCopy:J}}}D.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function b(l,$){if(j.$j&&l.environmentVariableCollections){const P=(0,v.$us)(l.environmentVariableCollections),I=new m.$vs(P).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),O=[];if(I)for(const M of I)M.type===p.EnvironmentVariableMutatorType.Prepend&&O.push(M.value);O.length>0&&($.VSCODE_PATH_PREFIX=O.join(""))}}var f;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(f||(f={}));const h=new Map;h.set(f.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(f.Zsh,["-i"]),h.set(f.ZshLogin,["-il"]),h.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function s(l){return typeof l=="string"?S.includes(l.toLowerCase()):l.length===1&&S.includes(l[0].toLowerCase())||l.length===2&&(S.includes(l[0].toLowerCase())||S.includes(l[1].toLowerCase()))&&(r.includes(l[0].toLowerCase())||r.includes(l[1].toLowerCase()))}function i(l){return typeof l=="string"?r.includes(l.toLowerCase()):l.length===0||l?.length===1&&r.includes(l[0].toLowerCase())}function o(l){return typeof l!="string"&&(l=l.filter($=>!t.includes($.toLowerCase()))),l==="string"&&a.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&a.includes(l[0].toLowerCase())}}),define(se[266],re([0,1,49,75,9,4,12,21,110,265,117]),function(K,e,n,C,k,R,j,E,u,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=d;var p;(function(l){l.UnixShellsPath="/etc/shells"})(p||(p={}));let v,m=!0;function d(l,$,P,D,I=process.env,O,M,W,F){return O=O||{existsFile:E.SymlinkSupport.existsFile,readFile:E.Promises.readFile},R.$i?y(P,O,I,M,D.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:D.getValue("terminal.integrated.profiles.windows"),typeof $=="string"?$:D.getValue("terminal.integrated.defaultProfile.windows"),F,W):s(O,M,P,l&&typeof l=="object"?{...l}:D.getValue(R.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof $=="string"?$:D.getValue(R.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,I)}async function y(l,$,P,D,I,O,M,W,F){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),U=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let ae=!1;(0,c.$ws)()>=16299&&(ae=!0),await h(W);const te=new Map;if(l){te.set("PowerShell",{source:"PowerShell",icon:C.$Xj.terminalPowershell,isAutoDetected:!0}),te.set("Windows PowerShell",{path:`${U}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Xj.terminalPowershell,isAutoDetected:!0}),te.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),te.set("Command Prompt",{path:`${U}\\cmd.exe`,icon:C.$Xj.terminalCmd,isAutoDetected:!0}),te.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),te.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Xj.terminalBash,isAutoDetected:!0});const J=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;te.set("Cmder",{path:`${U}\\cmd.exe`,args:["/K",J],requiresPath:process.env.CMDER_ROOT?J:{path:J,isUnsafe:!0},isAutoDetected:!0})}i(O,te);const ce=await w(te.entries(),M,$,P,D,F);if(l&&I)try{const J=await t(`${U}\\${ae?"wsl":"bash"}.exe`,M);for(const V of J)(!O||!(V.profileName in O))&&ce.push(V)}catch{m&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return ce}async function w(l,$,P,D=process.env,I,O){const M=[];for(const[W,F]of l)M.push(b(W,F,$,P,D,I,O));return(await Promise.all(M)).filter(W=>!!W)}async function b(l,$,P,D,I=process.env,O,M){if($===null)return;let W,F,T;if("source"in $&&!("path"in $)){const ce=v?.get($.source);if(!ce)return;W=ce.paths,F=$.args||ce.args,$.icon?T=f($.icon):ce.icon&&(T=ce.icon)}else W=Array.isArray($.path)?$.path:[$.path],F=R.$i||Array.isArray($.args)?$.args:void 0,T=f($.icon);let U;if(M){const ce=W.map(V=>typeof V=="string"?V:V.path),J=await M(ce);U=new Array(W.length);for(let V=0;V<W.length;V++)typeof W[V]=="string"?U[V]=J[V]:U[V]={path:J[V],isUnsafe:!0}}else U=W.slice();let ae;if($.requiresPath){let ce;if((0,j.$$f)($.requiresPath)?ce=$.requiresPath:(ce=$.requiresPath.path,$.requiresPath.isUnsafe&&(ae=ce)),!await D.existsFile(ce))return}const te=await o(l,P,U,D,I,F,$.env,$.overrideName,$.isAutoDetected,ae);if(!te){O?.debug("Terminal profile not validated",l,W);return}return te.isAutoDetected=$.isAutoDetected,te.icon=T,te.color=$.color,te}function f(l){return typeof l=="string"?{id:l}:l}async function h(l){if(v&&!l)return;const[$,P]=await Promise.all([S(),l||a()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:$,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:P,icon:C.$Xj.terminalPowershell})}async function S(){const l=new Set,$=await(0,c.$xs)("git.exe");if($){const I=(0,g.dirname)($);l.add((0,g.resolve)(I,"../.."))}function P(I,O){O&&I.add(O)}P(l,process.env.ProgramW6432),P(l,process.env.ProgramFiles),P(l,process.env["ProgramFiles(X86)"]),P(l,`${process.env.LocalAppData}\\Program`);const D=[];for(const I of l)D.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const l=[];for await(const $ of(0,u.$mm)())l.push($.exePath);return l}async function t(l,$){const P=[],D=await new Promise((M,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,T)=>{if(F)return W("Problem occurred when getting wsl distros");M(T)})});if(!D)return[];const I=new RegExp(/[\r?\n]/),O=D.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const W=`${M} (WSL)`,F={profileName:W,path:l,args:["-d",`${M}`],isDefault:W===$,icon:r(M),isAutoDetected:!1};P.push(F)}return P}function r(l){return l.includes("Ubuntu")?C.$Xj.terminalUbuntu:l.includes("Debian")?C.$Xj.terminalDebian:C.$Xj.terminalLinux}async function s(l,$,P,D,I,O,M,W){const F=new Map;if(P&&await l.existsFile("/etc/shells")){const T=(await l.readFile("/etc/shells")).toString(),U=(O||T.split(`
`)).map(te=>{const ce=te.indexOf("#");return ce===-1?te:te.substring(0,ce)}).filter(te=>te.trim().length>0),ae=new Map;for(const te of U){let ce=(0,k.$nc)(te),J=ae.get(ce)||0;J++,J>1&&(ce=`${ce} (${J})`),ae.set(ce,J),F.set(ce,{path:te,isAutoDetected:!0})}}return i(D,F),await w(F.entries(),I,l,W,$,M)}function i(l,$){if(l)for(const[P,D]of Object.entries(l))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?$.delete(P):(D.icon=D.icon||$.get(P)?.icon,$.set(P,D))}async function o(l,$,P,D,I,O,M,W,F,T){if(P.length===0)return Promise.resolve(void 0);const U=P.shift();if(U==="")return o(l,$,P,D,I,O,M,W,F);const ae=typeof U!="string"&&U.isUnsafe,te=typeof U=="string"?U:U.path,ce={profileName:l,path:te,args:O,env:M,overrideName:W,isAutoDetected:F,isDefault:l===$,isUnsafePath:ae,requiresUnsafePath:T};if((0,k.$nc)(te)===te){const V=I.PATH?I.PATH.split(k.$tc):void 0,q=await(0,c.$xs)(te,void 0,V,void 0,D.existsFile);return q?(ce.path=q,ce.isFromPath=!0,ce):o(l,$,P,D,I,O)}return await D.existsFile((0,k.$hc)(te))?ce:o(l,$,P,D,I,O,M,W,F)}}),define(se[267],re([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;var w;(function(f){f[f.MaxRestarts=5]="MaxRestarts"})(w||(w={}));let b=class extends C.$Uc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,S,a,t){super(),this.M=h,this.N=S,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$fe),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$fe),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$fe),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$fe),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$fe),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$fe),this.onProcessData=this.D.event,this.F=this.B(new n.$fe),this.onProcessReady=this.F.event,this.G=this.B(new n.$fe),this.onProcessReplay=this.G.event,this.H=this.B(new n.$fe),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$fe),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$fe),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$fe),this.onProcessExit=this.L.event,(0,v.$ns)(),this.B(this.M),this.B((0,C.$Sc)(()=>this.W())),this.j=this.B(new g.$gs(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(k.$i)return process.env;try{return await(0,c.$Im)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),S=h.client;this.O.getLevel()===E.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(S.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=w.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=R.ProxyChannel.toService(S.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new u.$fs(this.P,S.getChannel(p.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,S,a,t,r,s,i,o,l,$,P){const D=setTimeout(()=>this.$(),p.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(h,S,a,t,r,s,i,o,l,$,P);return clearTimeout(D),I}updateTitle(h,S,a){return this.f.updateTitle(h,S,a)}updateIcon(h,S,a,t){return this.f.updateIcon(h,S,a,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,S){return this.f.detachFromProcess(h,S)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,S){return this.f.shutdown(h,S)}input(h,S){return this.f.input(h,S)}processBinary(h,S){return this.f.processBinary(h,S)}resize(h,S,a){return this.f.resize(h,S,a)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,S){return this.f.acknowledgeDataEvent(h,S)}setUnicodeVersion(h,S){return this.f.setUnicodeVersion(h,S)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new y.$be,S=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...S]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,S){return this.f.installAutoReply(h,S)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,d.$sm)(h??k.OS,process.env)}async getProfiles(h,S,a,t=!1){const r=await this.S();return(0,m.$zs)(S,a,t,this.N,r,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,S){return this.f.getWslPath(h,S)}getRevivedPtyNewId(h,S){return this.f.getRevivedPtyNewId(h,S)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,S){return this.f.requestDetachInstance(h,S)}async acceptDetachInstanceReply(h,S){return this.f.acceptDetachInstanceReply(h,S)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,S,a){return this.f.reviveTerminalProcesses(h,S,a)}async refreshProperty(h,S){return this.f.refreshProperty(h,S)}async updateProperty(h,S,a){return this.f.updateProperty(h,S,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?p.HeartbeatConstants.ConnectingBeatInterval:p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,S){return this.j.createRequest({workspaceId:h,originalText:S})}async acceptPtyHostResolvedVariables(h,S){this.j.acceptReply(h,S)}};e.$As=b,e.$As=b=Ee([ie(1,j.$5i),ie(2,E.$5j),ie(3,E.$6j)],b)}),define(se[69],re([0,1,14,3,2,4,18,6,34]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=e.$Ccc=void 0;const c="#FFFFFF",g="#1E1E1E",p="#000000",v="#FFFFFF",m="theme",d="themeBackground",y="windowSplash";var w;(function(f){f.DETECT_COLOR_SCHEME="window.autoDetectColorScheme",f.SYSTEM_COLOR_THEME="window.systemColorTheme"})(w||(w={})),e.$Ccc=(0,E.$yi)("themeMainService");let b=class extends k.$Uc{constructor(h,S){super(),this.b=h,this.c=S,this.a=this.B(new C.$fe),this.onDidChangeColorScheme=this.a.event,R.$k||this.B(this.c.onDidChangeConfiguration(a=>{(a.affectsConfiguration(w.SYSTEM_COLOR_THEME)||a.affectsConfiguration(w.DETECT_COLOR_SCHEME))&&this.f()})),this.f(),this.B(C.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){if(R.$k||this.c.getValue(w.DETECT_COLOR_SCHEME))n.nativeTheme.themeSource="system";else switch(this.c.getValue(w.SYSTEM_COLOR_THEME)){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const h=this.getColorScheme();if(h.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return h.dark?p:v;let S=this.b.getItem(d,null);if(!S)switch(this.g()){case"vs":S=c;break;case"hc-black":S=p;break;case"hc-light":S=v;break;default:S=g}return R.$j&&S.toUpperCase()===g&&(S="#171717"),S}g(){switch(this.b.getItem(m,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(h,S){this.b.setItems([{key:m,data:S.baseTheme},{key:d,data:S.colorInfo.background},{key:y,data:S}]),typeof h=="number"&&this.h(h,S),this.f()}h(h,S){for(const a of n.BrowserWindow.getAllWindows())if(a.id===h){a.setBackgroundColor(S.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$Dcc=b,e.$Dcc=b=Ee([ie(0,u.$6P),ie(1,j.$5i)],b)}),define(se[130],re([0,1,3,7,18,6,5]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=e.$ww=e.$tw=e.$rw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$nw=e.$mw=void 0,e.$ow=c,e.$pw=p,e.$qw=v,e.$sw=m,e.$uw=d,e.$vw=y,e.$mw=(0,R.$yi)("tunnelService"),e.$nw=(0,R.$yi)("sharedTunnelsService");var E;(function(f){f.Http="http",f.Https="https"})(E||(e.TunnelProtocol=E={}));var u;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(u||(e.TunnelPrivacyId=u={}));function c(f){return!!f.forwardPort}var g;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function p(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(h)return{address:h[1],port:+h[2]}}function v(f){if(f.scheme!=="http"&&f.scheme!=="https"||!f.query)return;const h=f.query.split("&");for(const S of h){const a=S.split("=")[1];if(/^https?:/.exec(a)){const t=p(C.URI.parse(a));if(t)return t}}}e.$rw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(f){return e.$rw.indexOf(f)>=0}e.$tw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function d(f){return e.$tw.indexOf(f)>=0}function y(f,h,S,a){if(S===1)return!1;if(S===2&&d(h)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return f<1024}class w{constructor(h,S,a){this.remoteAddress=h,this.localAddress=S,this.b=a,this.a=new n.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ww=w;let b=class{constructor(h,S){this.k=h,this.l=S,this.a=new n.$fe,this.onTunnelOpened=this.a.event,this.b=new n.$fe,this.onTunnelClosed=this.b.event,this.c=new n.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],S=Array.from(this.e.values());for(const a of S){const t=Array.from(a.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&h.push(s)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:S}of h.values())await S.then(a=>typeof a!="string"?a?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,S,a,t,r){this.q(h,S,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:S,localAddress:a,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,S){(d(h)||m(h))&&(h=e.$rw[0]);const a=this.s(h,S);if(a)return++a.refcount,a.value}openTunnel(h,S,a,t,r,s=!1,i,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${S}:${a} on local port ${r}.`);const l=this.f??h;if(!l)return;if(S||(S="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const $=this.t(l,S,a,t,r,s,i,o);return $?$.then(P=>{if(P){if(typeof P=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(S,a),P}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(S,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(P);return(P.tunnelRemoteHost!==S||P.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&P.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),$)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const S=this.e.get(h.tunnelRemoteHost);if(S){const a=S.get(h.tunnelRemotePort);a&&(a.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,a))}}}}async p(h,S,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${S}.`);const t=a.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(S),t}}async closeTunnel(h,S){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${S} `);const a=this.e.get(h);if(a&&a.has(S)){const t=a.get(S);t.refcount=0,await this.p(h,S,t)}}q(h,S,a){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(S,{refcount:1,value:a})}async r(h,S){const a=this.e.get(h);if(a){const t=a.get(S),r=t?await t.value:void 0;(!r||typeof r=="string")&&a.delete(S),a.size===0&&this.e.delete(h)}}s(h,S){const a=[h];m(h)?(a.push(...e.$rw),a.push(...e.$tw)):d(h)&&a.push(...e.$tw);const t=a.map(r=>this.e.get(r));for(const r of t){const s=r?.get(S);if(s)return s}}canTunnel(h){return!!p(h)}u(h,S,a,t,r,s,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${S}:${a} on local port ${t}.`);const o=a;this.j.add(o);const l=t===void 0?a:t,$={elevationRequired:r?this.isPortPrivileged(l):!1},P={remoteAddress:{host:S,port:a},localAddressPort:t,privacy:s,public:s?s!==u.Private:void 0,protocol:i},D=h.forwardPort(P,$);return D?(this.q(S,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),D}};e.$xw=b,e.$xw=b=Ee([ie(0,j.$5j),ie(1,k.$5i)],b)}),define(se[50],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hX=e.$gX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(j){j.Uninitialized="uninitialized",j.Idle="idle",j.Disabled="disabled",j.CheckingForUpdates="checking for updates",j.AvailableForDownload="available for download",j.Downloading="downloading",j.Downloaded="downloaded",j.Updating="updating",j.Ready="ready"})(C||(e.StateType=C={}));var k;(function(j){j[j.Setup=0]="Setup",j[j.Archive=1]="Archive",j[j.Snap=2]="Snap"})(k||(e.UpdateType=k={}));var R;(function(j){j[j.NotBuilt=0]="NotBuilt",j[j.DisabledByEnvironment=1]="DisabledByEnvironment",j[j.ManuallyDisabled=2]="ManuallyDisabled",j[j.MissingConfiguration=3]="MissingConfiguration",j[j.InvalidConfiguration=4]="InvalidConfiguration",j[j.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$gX={Uninitialized:{type:"uninitialized"},Disabled:j=>({type:"disabled",reason:j}),Idle:(j,E)=>({type:"idle",updateType:j,error:E}),CheckingForUpdates:j=>({type:"checking for updates",explicit:j}),AvailableForDownload:j=>({type:"available for download",update:j}),Downloading:{type:"downloading"},Downloaded:j=>({type:"downloaded",update:j}),Updating:j=>({type:"updating",update:j}),Ready:j=>({type:"ready",update:j})},e.$hX=(0,n.$yi)("updateService")}),define(se[268],re([0,1,4,191,52,45]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$fo.as(k.$ko.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(se[269],re([0,1,3,50]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pdc=e.$Odc=void 0;class k{constructor(E){this.a=E}listen(E,u){switch(u){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${u}`)}call(E,u,c){switch(u){case"checkForUpdates":return this.a.checkForUpdates(c);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(c)}throw new Error(`Call not found: ${u}`)}}e.$Odc=k;class R{get state(){return this.b}set state(E){this.b=E,this.a.fire(E)}constructor(E){this.c=E,this.a=new n.$fe,this.onStateChange=this.a.event,this.b=C.$gX.Uninitialized,this.c.listen("onStateChange")(u=>this.state=u),this.c.call("_getInitialState").then(u=>this.state=u)}checkForUpdates(E){return this.c.call("checkForUpdates",E)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(E){return this.c.call("_applySpecificUpdate",E)}}e.$Pdc=R}),define(se[40],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,n.$yi)("IUriIdentityService")}),define(se[270],re([0,1,40,210,16,19,142,3,2]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class c{static{this._clock=0}constructor(v){this.uri=v,this.time=c._clock++}touch(){return this.time=c._clock++,this}}let g=class{constructor(v){this.g=v,this.c=new u.$Tc,this.f=2**16;const m=new Map,d=y=>{let w=m.get(y.scheme);return w===void 0&&(w=v.hasProvider(y)&&!this.g.hasCapability(y,1024),m.set(y.scheme,w)),w};this.c.add(E.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(y=>{m.delete(y.scheme)})),this.extUri=new R.$1g(d),this.d=new j.$Ds((y,w)=>this.extUri.compare(y,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,R.$ah)(v));const m=this.d.get(v);return m?m.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new c(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((d,y)=>d[1].time<y[1].time?1:d[1].time>y[1].time?-1:0);c._clock=0,this.d.clear();const m=this.f*.5;for(let d=0;d<m;d++)this.d.set(v[d][0],v[d][1].touch())}};e.$Es=g,e.$Es=g=Ee([ie(0,k.$5k)],g),(0,C.$Bs)(n.$Cl,g,1)}),define(se[131],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0W=void 0,e.$0W=(0,n.$yi)("urlService")}),define(se[271],re([0,1,7]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ydc=e.$Xdc=e.$Wdc=void 0;class C{constructor(E){this.a=E}listen(E,u){throw new Error(`Event not found: ${u}`)}call(E,u,c){switch(u){case"handleURL":return this.a.handleURL(n.URI.revive(c[0]),c[1])}throw new Error(`Call not found: ${u}`)}}e.$Wdc=C;class k{constructor(E){this.a=E}handleURL(E,u){return this.a.call("handleURL",[E.toJSON(),u])}}e.$Xdc=k;class R{constructor(E,u){this.a=E,this.b=u}async routeCall(E,u,c,g){if(u!=="handleURL")throw new Error(`Call not found: ${u}`);if(Array.isArray(c)&&c.length>0){const p=n.URI.revive(c[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",p.toString(!0)),p.query){const v=/\bwindowId=(\d+)/.exec(p.query);if(v){const m=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${m}"`,p.toString(!0));const d=new RegExp(`window:${m}`),y=E.connections.find(w=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",w.ctx),d.test(w.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",p.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",p.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",p.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(E,u,c,g)}routeEvent(E,u){throw new Error(`Event not found: ${u}`)}}e.$Ydc=R}),define(se[272],re([0,1,8,2,7,27]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_W=e.$$W=void 0;class j extends C.$Uc{constructor(){super(...arguments),this.a=new Set}open(c,g){const p=[...this.a.values()];return(0,n.$Ch)(p.map(v=>()=>v.handleURL(c,g)),void 0,!1).then(v=>v||!1)}registerHandler(c){return this.a.add(c),(0,C.$Sc)(()=>this.a.delete(c))}}e.$$W=j;let E=class extends j{constructor(c){super(),this.b=c}create(c){let{authority:g,path:p,query:v,fragment:m}=c||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return g&&p&&p.indexOf("/")!==0&&(p=`/${p}`),k.URI.from({scheme:this.b.urlProtocol,authority:g,path:p,query:v,fragment:m})}};e.$_W=E,e.$_W=E=Ee([ie(0,R.$lk)],E)}),define(se[273],re([0,1,14,8,3,2,4,7]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zdc=void 0;class u extends R.$Uc{constructor(g,p,v,m,d,y){if(super(),this.c=p,this.f=y,this.a=[],this.b=0,g&&(y.trace("ElectronURLListener initialUrisToHandle:",g.map(f=>f.originalUrl)),this.a=g),j.$i){const f=m.isBuilt?[]:[`"${m.appRoot}"`];f.push("--open-url","--"),n.app.setAsDefaultProtocolClient(d.urlProtocol,process.execPath,f)}const w=k.Event.map(k.Event.fromNodeEventEmitter(n.app,"open-url",(f,h)=>({event:f,url:h})),({event:f,url:h})=>(f.preventDefault(),h));this.B(w(f=>{const h=this.g(f);h&&this.c.open(h,{originalUrl:f})})),v.getWindows().filter(f=>f.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(k.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(g){try{return E.URI.parse(g)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const g=[];for(const p of this.a)await this.c.open(p.uri,{originalUrl:p.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",p.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",p.originalUrl),g.push(p));g.length!==0&&(this.a=g,(0,C.$Ah)(()=>this.h(),500,this.q))}}e.$Zdc=u}),define(se[274],re([0,1,3,2,16,59,32]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class E extends C.$Uc{constructor(c,g,p,v,m,d){super(),this.f=c,this.g=g,this.h=p,this.j=v,this.m=m,this.n=d,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$fe),this.onDidChangeFile=this.a.event,this.b=R.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Bc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const c of this.j.profiles)this.c.add(c.settingsResource),this.c.add(c.keybindingsResource),this.c.add(c.tasksResource),this.c.add(c.extensionsResource)}open(c,g){return this.g.open(this.t(c),g)}close(c){return this.g.close(c)}read(c,g,p,v,m){return this.g.read(c,g,p,v,m)}write(c,g,p,v,m){return this.g.write(c,g,p,v,m)}watch(c,g){this.b.set(c,c);const p=this.g.watch(this.t(c),g);return(0,C.$Sc)(()=>{this.b.delete(c),p.dispose()})}stat(c){return this.g.stat(this.t(c))}mkdir(c){return this.g.mkdir(this.t(c))}rename(c,g,p){return this.g.rename(this.t(c),this.t(g),p)}readFile(c,g){return this.g.readFile(this.t(c),g)}readFileStream(c,g,p){return this.g.readFileStream(this.t(c),g,p)}readdir(c){return this.g.readdir(this.t(c))}enforceAtomicReadFile(c){return this.c.has(c)}writeFile(c,g,p){return this.g.writeFile(this.t(c),g,p)}enforceAtomicWriteFile(c){return this.c.has(c)?{postfix:".vsctmp"}:!1}delete(c,g){return this.g.delete(this.t(c),g)}copy(c,g,p){if((0,k.$9k)(this.g))return this.g.copy(this.t(c),this.t(g),p);throw new Error("copy not supported")}cloneFile(c,g){if((0,k.$0k)(this.g))return this.g.cloneFile(this.t(c),this.t(g));throw new Error("clone not supported")}s(c){const g=[];for(const p of c){if(p.resource.scheme!==this.f)continue;const v=this.u(p.resource);this.b.findSubstr(v)&&g.push({resource:v,type:p.type,cId:p.cId})}g.length&&(this.n.debug("User data changed"),this.a.fire(g))}t(c){return c.with({scheme:this.f})}u(c){return c.with({scheme:this.h})}}e.$Aec=E}),define(se[275],re([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=void 0,e.$hec="utilityProcessWorker"}),define(se[276],re([0,1,6]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1dc=void 0,e.$1dc=(0,n.$yi)("webviewManagerService")}),define(se[277],re([0,1,14,2,13,7]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2dc=void 0;class j extends C.$Uc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const u=this.b.bind(this);n.protocol.registerFileProtocol(k.Schemas.vscodeWebview,u)}b(u,c){try{const g=R.URI.parse(u.url),p=j.a.get(g.path);if(typeof p=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${p}`,m=k.$Sg.asFileUri(v);return c({path:m.fsPath,headers:{...k.COI.getHeadersFromQuery(u.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return c({error:-10})}catch{}return c({error:-2})}}e.$2dc=j}),define(se[55],re([0,1,4]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ND=e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$ED=void 0,e.$FD=C,e.$GD=k,e.$HD=R,e.$ID=j,e.$JD=E,e.$KD=p,e.$LD=v,e.$MD=m,e.$OD=d,e.$PD=y,e.$QD=w,e.$ED={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(b){return typeof b.parentId=="number"}function k(b){return!!b.workspaceUri}function R(b){return!!b.folderUri}function j(b){return!!b.fileUri}function E(b){const f=v(b),h=b.getValue("window.menuBarVisibility");return h==="default"||f&&h==="compact"||n.$j&&n.$m?"classic":h}var u;(function(b){b.TITLE_BAR_STYLE="window.titleBarStyle",b.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(u||(e.TitleBarSetting=u={}));var c;(function(b){b.NATIVE="native",b.CUSTOM="custom"})(c||(e.TitlebarStyle=c={}));var g;(function(b){b.AUTO="auto",b.WINDOWED="windowed",b.NEVER="never"})(g||(e.CustomTitleBarVisibility=g={}));function p(b,f){return!0}function v(b,f){return f||(f=m(b)),f==="native"}function m(b){if(n.$o)return"custom";const f=b.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const a=f.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}e.$ND=35;function d(b){return!(!n.$i||n.$o||v(b))}function y(b){const f=b.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function w(b=0){return Math.pow(1.2,b)}}),define(se[82],re([0,1,14]),function(K,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$scc=e.$rcc=e.UnloadReason=e.LoadReason=void 0;var C;(function(c){c[c.INITIAL=1]="INITIAL",c[c.LOAD=2]="LOAD",c[c.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var k;(function(c){c[c.CLOSE=1]="CLOSE",c[c.QUIT=2]="QUIT",c[c.RELOAD=3]="RELOAD",c[c.LOAD=4]="LOAD"})(k||(e.UnloadReason=k={}));const R=function(c=1){return{width:1024,height:768,mode:c}};e.$rcc=R;const j=function(){const p=n.screen.getPrimaryDisplay().workArea,v=Math.max(p.x+p.width/2-800/2,0),m=Math.max(p.y+p.height/2-600/2,0);return{x:v,y:m,width:800,height:600,mode:1}};e.$scc=j;var E;(function(c){c[c.Maximized=0]="Maximized",c[c.Normal=1]="Normal",c[c.Minimized=2]="Minimized",c[c.Fullscreen=3]="Fullscreen"})(E||(e.WindowMode=E={}));var u;(function(c){c[c.UNRESPONSIVE=1]="UNRESPONSIVE",c[c.PROCESS_GONE=2]="PROCESS_GONE",c[c.LOAD=3]="LOAD"})(u||(e.WindowError=u={}))}),define(se[278],re([0,1,8,3,2]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class R extends k.$Uc{constructor({onDidOpenMainWindow:E,onDidFocusMainWindow:u,getActiveWindowId:c}){super(),this.a=this.B(new k.$Tc),C.Event.latch(C.Event.any(E,u))(this.f,this,this.a),this.b=(0,n.$lh)(()=>c()),(async()=>{try{const p=await this.b;this.c=typeof this.c=="number"?this.c:p}catch{}finally{this.b=void 0}})()}f(E){this.b&&(this.b.cancel(),this.b=void 0),this.c=E}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$8dc=R}),define(se[30],re([0,1,195,9,59,19,7,6,13]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=c,e.$Ji=g,e.$Mi=p,e.$Ni=v,e.$Oi=m,e.$Pi=y,e.$Qi=w,e.$Ti=h,e.$Yi=S,e.$Zi=a,e.$2i=t,e.$3i=r,e.$4i=s,e.$Hi=(0,E.$yi)("contextService");function c(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.uri)}function g(i){return typeof i?.id=="string"&&!c(i)&&!v(i)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function p(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$nc)(i)}:o?e.$Ki:e.$Li;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function v(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.configPath)}function m(i){const o=i;if(o?.uri)return{id:o.id,uri:j.URI.revive(o.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:j.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}var d;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(d||(e.WorkbenchState=d={}));function y(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function w(i){const o=i;return!!(o&&typeof o=="object"&&j.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class b{constructor(o,l,$,P,D){this.h=o,this.j=$,this.k=P,this.l=D,this.c=k.$Ei.forUris(this.l,()=>!0),this.folders=l}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=k.$Ei.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=b;class f{constructor(o,l){this.raw=l,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.$_g)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=f;function h(i){return new f({uri:i,index:0,name:(0,R.$8g)(i)},{uri:i.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,n.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function S(i,o){return R.$3g.isEqualOrParent(i,o.untitledWorkspacesHome)}function a(i){let o;return j.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===u.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$1i}function r(i,o){return!S(i,o)&&!a(i)}function s(i){return(typeof i=="string"?(0,C.$oc)(i):(0,R.$0g)(i))===e.$Vi}}),define(se[56],re([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Acc=e.$zcc=void 0,e.$zcc=(0,v.$yi)("dialogMainService");let w=class{constructor(f,h){this.d=f,this.e=h,this.a=new Map,this.b=new Map,this.c=new C.$Fh}pickFileFolder(f,h){return this.f({...f,pickFolders:!0,pickFiles:!0,title:(0,g.localize)(0,null)},h)}pickFolder(f,h){return this.f({...f,pickFolders:!0,title:(0,g.localize)(1,null)},h)}pickFile(f,h){return this.f({...f,pickFiles:!0,title:(0,g.localize)(2,null)},h)}pickWorkspace(f,h){const S=(0,g.localize)(3,null),a=(0,R.$Ow)((0,g.localize)(4,null)),t=y.$Wi;return this.f({...f,pickFiles:!0,title:S,filters:t,buttonLabel:a},h)}async f(f,h){const S={title:f.title,buttonLabel:f.buttonLabel,filters:f.filters,defaultPath:f.defaultPath};(typeof f.pickFiles=="boolean"||typeof f.pickFolders=="boolean")&&(S.properties=void 0,f.pickFiles&&f.pickFolders&&(S.properties=["multiSelections","openDirectory","openFile","createDirectory"])),S.properties||(S.properties=["multiSelections",f.pickFolders?"openDirectory":"openFile","createDirectory"]),u.$j&&S.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(S,(h||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(f){if(f){let h=this.b.get(f.id);return h||(h=new C.$Fh,this.b.set(f.id,h)),h}else return this.c}showMessageBox(f,h){return this.g(h).queue(async()=>{const{options:S,buttonIndeces:a}=(0,p.$Vw)(f,this.e);let t;return h?t=await n.dialog.showMessageBox(h,S):t=await n.dialog.showMessageBox(S),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(f,h){const S=this.j(f,h);if(!S)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showSaveDialog(h,f):a=await n.dialog.showSaveDialog(f),a.filePath=this.h(a.filePath),a})}finally{(0,j.$Pc)(S)}}h(f){return f&&u.$j&&(f=(0,E.$dm)(f)),f}i(f){return f.map(h=>this.h(h))}async showOpenDialog(f,h){f.defaultPath&&(await c.Promises.exists(f.defaultPath)||(f.defaultPath=void 0));const S=this.j(f,h);if(!S)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let a;return h?a=await n.dialog.showOpenDialog(h,f):a=await n.dialog.showOpenDialog(f),a.filePaths=this.i(a.filePaths),a})}finally{(0,j.$Pc)(S)}}j(f,h){if(!h)return j.$Uc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",f);let S=this.a.get(h.id);S||(S=new Set,this.a.set(h.id,S));const a=(0,k.$mj)(f);if(!S.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",f),S.add(a),(0,j.$Sc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",f),S?.delete(a),S?.size===0&&this.a.delete(h.id)})}};e.$Acc=w,e.$Acc=w=Ee([ie(0,m.$5j),ie(1,d.$lk)],w)}),define(se[279],re([0,1,3,2,77,30]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ldc=void 0;class j extends C.$Uc{static{this.a=100}constructor(u,c){super(),this.f=u,this.g=c,this.b=this.B(new n.$fe),this.c=new Map,this.h(c.applicationStorage,this.b)}h(u,c){this.B(n.Event.debounce(u.onDidChangeStorage,(g,p)=>(g?g.push(p):g=[p],g),j.a)(g=>{g.length&&c.fire(this.j(g,u))}))}j(u,c){const g=new Map,p=new Set;return u.forEach(v=>{const m=c.get(v.key);typeof m=="string"?g.set(v.key,m):p.add(v.key)}),{changed:Array.from(g.entries()),deleted:Array.from(p.values())}}listen(u,c,g){switch(c){case"onDidChangeStorage":{const p=g.profile?(0,k.$8h)(g.profile):void 0;if(!p)return this.b.event;let v=this.c.get(p.id);return v||(v=this.B(new n.$fe),this.h(this.g.profileStorage(p),v),this.c.set(p.id,v)),v.event}}throw new Error(`Event not found: ${c}`)}async call(u,c,g){const p=g.profile?(0,k.$8h)(g.profile):void 0,v=(0,R.$Oi)(g.workspace),m=await this.m(p,v);switch(c){case"getItems":return Array.from(m.items.entries());case"updateItems":{const d=g;if(d.insert)for(const[y,w]of d.insert)m.set(y,w);d.delete?.forEach(y=>m.delete(y));break}case"optimize":return m.optimize();case"isUsed":{const d=g.payload;if(typeof d=="string")return this.g.isUsed(d)}default:throw new Error(`Call not found: ${c}`)}}async m(u,c){let g;c?g=this.g.workspaceStorage(c):u?g=this.g.profileStorage(u):g=this.g.applicationStorage;try{await g.init()}catch(p){this.f.error(`StorageIPC#init: Unable to init ${c?"workspace":u?"profile":"application"} storage due to ${p}`)}return g}}e.$Ldc=j}),define(se[41],re([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=S,e.$Fl=a,e.$Gl=t;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function S(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&j.URI.isUri(o.location)&&j.URI.isUri(o.globalStorageHome)&&j.URI.isUri(o.settingsResource)&&j.URI.isUri(o.keybindingsResource)&&j.URI.isUri(o.tasksResource)&&j.URI.isUri(o.snippetsHome)&&j.URI.isUri(o.extensionsResource))}e.$El=(0,g.$yi)("IUserDataProfilesService");function a(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:o}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:o}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,o,l,$,P,D){return{id:i,name:o,location:l,isDefault:!1,shortName:P?.shortName,icon:P?.icon,globalStorageHome:D&&P?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$_g)(l,"globalStorage"),settingsResource:D&&P?.useDefaultFlags?.settings?D.settingsResource:(0,R.$_g)(l,"settings.json"),keybindingsResource:D&&P?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$_g)(l,"keybindings.json"),tasksResource:D&&P?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$_g)(l,"tasks.json"),snippetsHome:D&&P?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$_g)(l,"snippets"),extensionsResource:D&&P?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$_g)(l,"extensions.json"),cacheHome:(0,R.$_g)($,i),useDefaultFlags:P?.useDefaultFlags,isTransient:P?.transient}}let r=class extends k.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,l,$,P){super(),this.t=o,this.u=l,this.w=$,this.y=P,this.f=!0,this.h=this.B(new C.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Ac,emptyWindows:new Map},this.profilesHome=(0,R.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),l=[o];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,f.$$f)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}l.push(t((0,R.$9g)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},o))}}catch(D){this.y.error(D)}const $=new m.$Ac,P=new Map;if(l.length)try{const D=this.Q();if(D.workspaces)for(const[I,O]of Object.entries(D.workspaces)){const M=j.URI.parse(I),W=l.find(F=>F.id===O);W&&$.set(M,W)}if(D.emptyWindows)for(const[I,O]of Object.entries(D.emptyWindows)){const M=l.find(W=>W.id===O);M&&P.set(I,M)}}catch(D){this.y.error(D)}this.z={profiles:l,workspaces:$,emptyWindows:P}}return this.z}D(){const o=t("__default__profile__",(0,E.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const l="Temp",$=new RegExp(`${(0,b.$bf)(l)}\\s(\\d+)`);let P=0;for(const I of this.profiles){const O=$.exec(I.name),M=O?parseInt(O[1]):0;P=M>P?M:P}const D=`${l} ${P+1}`;return this.createProfile((0,n.$mj)((0,w.$Ug)()).toString(16),D,{transient:!0},o)}async createNamedProfile(o,l,$){return this.createProfile((0,n.$mj)((0,w.$Ug)()).toString(16),o,l,$)}async createProfile(o,l,$,P){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(o,l,$);return P&&await this.setProfileForWorkspace(P,D),D}async F(o,l,$){if(!(0,f.$$f)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let P=this.r.get(l);return P||(P=(async()=>{try{if(this.profiles.find(M=>M.name===l||M.id===o))throw new Error(`Profile with ${l} name already exists`);const I=t(o,l,(0,R.$_g)(this.profilesHome,o),this.g,$,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await y.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(l)}})(),this.r.set(l,P)),P}async updateProfile(o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(P=>P.id===o.id);if(!$)throw new Error(`Profile '${o.name}' does not exist`);return $=t($.id,l.name??$.name,$.location,this.g,{shortName:l.shortName??$.shortName,icon:l.icon===null?void 0:l.icon??$.icon,transient:l.transient??$.isTransient,useDefaultFlags:l.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(P=>P.id===o.id);if(!l)throw new Error(`Profile '${o.name}' does not exist`);const $=[];this.m.fire({profile:l,join(P){$.push(P)}});try{await Promise.allSettled($)}catch(P){this.y.error(P)}for(const P of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(P)?.id&&this.C.emptyWindows.delete(P);for(const P of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(P)?.id&&this.C.workspaces.delete(P);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(P){(0,c.$jl)(P)!==1&&this.y.error(P)}}async setProfileForWorkspace(o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(P=>P.id===l.id);if(!$)throw new Error(`Profile '${l.name}' does not exist`);this.L(o,$)}unsetWorkspace(o,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(l=>l.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(o.map(l=>this.removeProfile(l)))}getProfileForWorkspace(o){const l=this.G(o);return j.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(o){return(0,v.$Ii)(o)?o.uri:(0,v.$Ni)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,o.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,o.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,o.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,o.location)))}I(o,l,$){const P=[...this.profiles,...o],D=[];this.s.profiles=[];for(let I of P)I.isDefault||l.some(O=>I.id===O.id)||(I=$.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):D.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(D),this.z=void 0,this.J(o,l,$)}J(o,l,$){this.h.fire({added:o,removed:l,updated:$,all:this.profiles})}L(o,l,$){$=l?.isTransient?!0:$,$||this.L(o,void 0,!0);const P=this.G(o),D=$?this.s:this.C;j.URI.isUri(P)?(D.workspaces.delete(P),l&&D.workspaces.set(P,l)):(D.emptyWindows.delete(P),l&&D.emptyWindows.set(P,l)),$||this.M()}M(){const o={};for(const[$,P]of this.C.workspaces.entries())o[$.toString()]=P.id;const l={};for(const[$,P]of this.C.emptyWindows.entries())l[$.toString()]=P.id;this.R({workspaces:o,emptyWindows:l}),this.z=void 0}N(o){const l={},$=this.D();if(o.workspaces)for(const[D,I]of Object.entries(o.workspaces)){const O=j.URI.parse(I);l[D]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}const P={};if(o.emptyWindows)for(const[D,I]of Object.entries(o.emptyWindows)){const O=j.URI.parse(I);P[D]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}return{workspaces:l,emptyWindows:P}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=Ee([ie(0,u.$Fi),ie(1,c.$5k),ie(2,d.$Cl),ie(3,p.$5j)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Il=s}),define(se[83],re([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class h extends Error{constructor(s,i){super(s),this.code=i}}e.$sq=h,e.$tq=(0,p.$yi)("IExtensionsProfileScannerService");let S=class extends k.$Uc{constructor(s,i,o,l,$,P){super(),this.j=s,this.m=i,this.n=o,this.r=l,this.s=$,this.t=P,this.b=this.B(new R.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new R.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Ac}scanProfileExtensions(s,i){return this.u(s,void 0,i)}async addExtensionsToProfile(s,i,o){const l=[],$=[];try{return await this.u(i,P=>{const D=[];if(o)D.push(...P);else for(const I of P)s.some(([O])=>(0,c.$yp)(O.identifier,I.identifier)&&O.manifest.version!==I.version)?l.push(I):D.push(I);for(const[I,O]of s){const M=D.findIndex(F=>(0,c.$yp)(F.identifier,I.identifier)&&F.version===I.manifest.version),W={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:O};M===-1?($.push(W),D.push(W)):D.splice(M,1,W)}return $.length&&this.b.fire({extensions:$,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),D}),$.length&&this.c.fire({extensions:$,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),$}catch(P){throw $.length&&this.c.fire({extensions:$,error:P,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:P,profileLocation:i}),P}}async updateMetadata(s,i){const o=[];return await this.u(i,l=>{const $=[];for(const P of l){const D=s.find(([I])=>(0,c.$yp)(I.identifier,P.identifier)&&I.manifest.version===P.version);D&&(P.metadata={...P.metadata,...D[1]},o.push(P)),$.push(P)}return $}),o}async removeExtensionFromProfile(s,i){const o=[];try{await this.u(i,l=>{const $=[];for(const P of l)(0,c.$yp)(P.identifier,s.identifier)?o.push(P):$.push(P);return o.length&&this.f.fire({extensions:o,profileLocation:i}),$}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(l){throw o.length&&this.g.fire({extensions:o,error:l,profileLocation:i}),l}}async u(s,i,o){return this.F(s).queue(async()=>{let l=[],$;try{const P=await this.m.readFile(s);$=JSON.parse(P.value.toString().trim()||"[]")}catch(P){if((0,g.$jl)(P)!==1)throw P;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&($=await this.D()),!$&&o?.bailOutWhenFileNotFound)throw new h((0,w.$0)(P),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.w(s);let P=!1;for(const D of $){a(D)||this.w(s);let I;if((0,y.$$f)(D.relativeLocation)&&D.relativeLocation)I=this.z(D.relativeLocation);else if((0,y.$$f)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{I=E.URI.revive(D.location);const O=this.y(I);O&&(P=!0,D.relativeLocation=O)}(0,y.$fg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(P=!0,D.metadata.hasPreReleaseVersion=!0),l.push({identifier:D.identifier,location:I,version:D.version,metadata:D.metadata})}P&&await this.m.writeFile(s,C.$He.fromString(JSON.stringify($)))}if(i){l=i(l);const P=l.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,C.$He.fromString(JSON.stringify(P)))}return l})}w(s){const i=new h(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let o;try{o=(await this.m.readFile(s)).value.toString()}catch($){if((0,g.$jl)($)===1)return;throw $}this.t.info("Migrating extensions from old default profile location",s.toString());let l;try{const $=JSON.parse(o);Array.isArray($)&&$.every(P=>a(P))?l=$:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.t.error($)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$He.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch($){if((0,g.$jl)($)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw $}try{await this.m.del(s)}catch($){(0,g.$jl)($)!==1&&this.t.error($)}try{await this.m.del(i)}catch($){(0,g.$jl)($)!==1&&this.t.error($)}return l})()),this.C}F(s){let i=this.h.get(s);return i||(i=new n.$Fh,this.h.set(s,i)),i}};e.$uq=S,e.$uq=S=Ee([ie(1,g.$5k),ie(2,m.$El),ie(3,d.$Cl),ie(4,b.$4l),ie(5,v.$5j)],S);function a(r){return(0,y.$ag)(r)&&(0,u.$9o)(r.identifier)&&(t(r.location)||(0,y.$$f)(r.location)&&r.location)&&((0,y.$fg)(r.relativeLocation)||(0,y.$$f)(r.relativeLocation))&&r.version&&(0,y.$$f)(r.version)}function t(r){return r?(0,y.$$f)(r.path)&&(0,y.$$f)(r.scheme):!1}}),define(se[132],re([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i,o,l,$,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=e.$yq=e.$xq=e.Translations=void 0,e.$Aq=ae;var M;(function(ce){function J(V,q){if(V===q)return!0;const L=Object.keys(V),B=new Set;for(const H of Object.keys(q))B.add(H);if(L.length!==B.size)return!1;for(const H of L){if(V[H]!==q[H])return!1;B.delete(H)}return B.size===0}ce.equals=J})(M||(e.Translations=M={})),e.$xq=(0,s.$yi)("IExtensionsScannerService");let W=class extends c.$Uc{constructor(J,V,q,L,B,H,oe,G,le,Q,A,N){super(),this.systemExtensionsLocation=J,this.userExtensionsLocation=V,this.r=q,this.s=L,this.t=B,this.u=H,this.w=oe,this.y=G,this.z=le,this.C=Q,this.D=A,this.F=N,this.g=this.B(new l.$fe),this.onDidChangeCache=this.g.event,this.h=(0,m.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,S.$Jp)(this.w,this.y)),this.G}async scanAllExtensions(J,V,q){const[L,B]=await Promise.all([this.scanSystemExtensions(J),this.scanUserExtensions(V)]),H=q?await this.scanExtensionsUnderDevelopment(J,[...L,...B]):[];return this.L(L,B,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(J){const V=[];V.push(this.M(!!J.useCache,J.language)),V.push(this.N(J.language,!!J.checkControlFile));const[q,L]=await Promise.all(V);return this.J([...q,...L],0,J,!1)}async scanUserExtensions(J){const V=J.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",V);const q=this.D.extUri.isEqual(J.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(V,!!J.profileLocation,1,!J.includeUninstalled,J.language,!0,q,J.productVersion??this.R()),B=J.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let H;try{H=await B.scanExtensions(L)}catch(oe){if(oe instanceof P.$sq&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await B.scanExtensions(L);else throw oe}return H=await this.J(H,1,J,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(J,V){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const q=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===g.Schemas.file).map(async L=>{const B=await this.P(L,!1,1,!0,J.language,!1,void 0,J.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(B)).map(oe=>(oe.type=V.find(G=>(0,S.$yp)(G.identifier,oe.identifier))?.type??oe.type,this.n.validate(oe,B)))}))).flat();return this.J(q,"development",J,!0)}return[]}async scanExistingExtension(J,V,q){const L=await this.P(J,!1,V,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanExtension(L);return!B||!q.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(J,V,q){const L=await this.P(J,!1,V,!0,q.language,!0,void 0,q.productVersion??this.R()),B=await this.n.scanOneOrMultipleExtensions(L);return this.J(B,V,q,!0)}async scanMultipleExtensions(J,V,q){const L=[];return await Promise.all(J.map(async B=>{const H=await this.scanOneOrMultipleExtensions(B,V,q);L.push(...H)})),this.J(L,V,q,!0)}async scanMetadata(J){const V=(0,m.$_g)(J,"package.json"),q=(await this.w.readFile(V)).value.toString();return JSON.parse(q).__metadata}async updateMetadata(J,V){const q=(0,m.$_g)(J,"package.json"),L=(await this.w.readFile(q)).value.toString(),B=JSON.parse(L);V.isMachineScoped===!1&&delete V.isMachineScoped,V.isBuiltin===!1&&delete V.isBuiltin,B.__metadata={...B.__metadata,...V},await this.w.writeFile((0,m.$_g)(J,"package.json"),R.$He.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(J){if(J instanceof P.$sq&&J.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw J}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const J=await this.scanUserExtensions({includeInvalid:!0});if(J.length)await this.u.addExtensionsToProfile(J.map(V=>[V,V.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$He.fromString(JSON.stringify([])))}catch(V){(0,r.$jl)(V)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(V))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(J){this.y.error(J)}finally{this.H=void 0}})()),this.H}async J(J,V,q,L){return q.includeAllVersions||(J=this.L(V===0?J:void 0,V===1?J:void 0,V==="development"?J:void 0,await this.getTargetPlatform(),L)),q.includeInvalid||(J=J.filter(B=>B.isValid)),J.sort((B,H)=>{const oe=p.$nc(B.location.fsPath),G=p.$nc(H.location.fsPath);return oe<G?-1:oe>G?1:0})}L(J,V,q,L,B){const H=(G,le,Q)=>{if(G.isValid&&!le.isValid)return!1;if(G.isValid===le.isValid){if(B&&d.gt(G.manifest.version,le.manifest.version))return this.y.debug(`Skipping extension ${le.location.path} with lower version ${le.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(d.eq(G.manifest.version,le.manifest.version)){if(G.type===0)return this.y.debug(`Skipping extension ${le.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===L)return this.y.debug(`Skipping extension ${le.location.path} from different target platform ${le.targetPlatform}`),!1}}return Q?this.y.warn(`Overwriting user extension ${G.location.path} with ${le.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${le.location.path}.`),!0},oe=new a.$Vm;return J?.forEach(G=>{const le=oe.get(G.identifier.id);(!le||H(le,G,!1))&&oe.set(G.identifier.id,G)}),V?.forEach(G=>{const le=oe.get(G.identifier.id);if(!le&&J&&G.type===0){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!le||H(le,G,!1))&&oe.set(G.identifier.id,G)}),q?.forEach(G=>{const le=oe.get(G.identifier.id);(!le||H(le,G,!0))&&oe.set(G.identifier.id,G),oe.set(G.identifier.id,G)}),[...oe.values()]}async M(J,V){this.y.trace("Started scanning system extensions");const q=await this.P(this.systemExtensionsLocation,!1,0,!0,V,!0,void 0,this.R()),B=await(J&&!q.devMode?this.j:this.n).scanExtensions(q);return this.y.trace("Scanned system extensions:",B.length),B}async N(J,V){const q=this.z.isBuilt?[]:this.C.builtInExtensions;if(!q?.length)return[];this.y.trace("Started scanning dev system extensions");const L=V?await this.O():{},B=[],H=b.URI.file(p.$hc(p.$jc(g.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of q){const le=L[G.name]||"marketplace";switch(le){case"disabled":break;case"marketplace":B.push((0,m.$_g)(H,G.name));break;default:B.push(b.URI.file(le));break}}const oe=await Promise.all(B.map(async G=>this.n.scanExtension(await this.P(G,!1,0,!0,J,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",oe.length),(0,n.$Hb)(oe)}async O(){try{const J=await this.w.readFile(this.r);return JSON.parse(J.value.toString())}catch{return{}}}async P(J,V,q,L,B,H,oe,G){const le=await this.f(B??v.$w),Q=await this.Q(J),A=V&&!this.D.extUri.isEqual(J,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=A?await this.Q(A):void 0;return new F(J,Q,A,N,V,oe,q,L,H,G.version,G.date,this.C.commit,!this.z.isBuilt,B,le)}async Q(J){try{const V=await this.w.stat(J);if(typeof V.mtime=="number")return V.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$yq=W,e.$yq=W=Ee([ie(4,D.$El),ie(5,P.$tq),ie(6,r.$5k),ie(7,i.$5j),ie(8,h.$Fi),ie(9,o.$lk),ie(10,I.$Cl),ie(11,s.$xi)],W);class F{constructor(J,V,q,L,B,H,oe,G,le,Q,A,N,_,z,Y){this.location=J,this.mtime=V,this.applicationExtensionslocation=q,this.applicationExtensionslocationMtime=L,this.profile=B,this.profileScanOptions=H,this.type=oe,this.excludeObsolete=G,this.validate=le,this.productVersion=Q,this.productDate=A,this.productCommit=N,this.devMode=_,this.language=z,this.translations=Y}static createNlsConfiguration(J){return{language:J.language,pseudo:J.language==="pseudo",devMode:J.devMode,translations:J.translations}}static equals(J,V){return(0,m.$5g)(J.location,V.location)&&J.mtime===V.mtime&&(0,m.$5g)(J.applicationExtensionslocation,V.applicationExtensionslocation)&&J.applicationExtensionslocationMtime===V.applicationExtensionslocationMtime&&J.profile===V.profile&&k.$9n(J.profileScanOptions,V.profileScanOptions)&&J.type===V.type&&J.excludeObsolete===V.excludeObsolete&&J.validate===V.validate&&J.productVersion===V.productVersion&&J.productDate===V.productDate&&J.productCommit===V.productCommit&&J.devMode===V.devMode&&J.language===V.language&&M.equals(J.translations,V.translations)}}e.$zq=F;let T=class extends c.$Uc{constructor(J,V,q,L,B){super(),this.f=J,this.g=V,this.h=q,this.j=L,this.m=B}async scanExtensions(J){const V=J.profile?await this.r(J):await this.n(J);let q={};if(J.excludeObsolete&&J.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();q=JSON.parse(L)}catch{}return(0,w.$lg)(q)?V:V.filter(L=>!q[S.$zp.create(L).toString()])}async n(J){const V=await this.j.resolve(J.location);if(!V.children?.length)return[];const q=await Promise.all(V.children.map(async L=>{if(!L.isDirectory||J.type===1&&(0,m.$9g)(L.resource).indexOf(".")===0)return null;const B=new F(L.resource,J.mtime,J.applicationExtensionslocation,J.applicationExtensionslocationMtime,J.profile,J.profileScanOptions,J.type,J.excludeObsolete,J.validate,J.productVersion,J.productDate,J.productCommit,J.devMode,J.language,J.translations);return this.scanExtension(B)}));return(0,n.$Hb)(q).sort((L,B)=>L.location.path<B.location.path?-1:1)}async r(J){let V=await this.s(J.location,()=>!0,J);if(J.applicationExtensionslocation&&!this.h.extUri.isEqual(J.location,J.applicationExtensionslocation)){V=V.filter(L=>!L.metadata?.isApplicationScoped);const q=await this.s(J.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,J);V.push(...q)}return V}async s(J,V,q){const L=await this.g.scanProfileExtensions(J,q.profileScanOptions);if(!L.length)return[];const B=await Promise.all(L.map(async H=>{if(V(H)){const oe=new F(H.location,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(oe,H.metadata)}return null}));return(0,n.$Hb)(B)}async scanOneOrMultipleExtensions(J){try{if(await this.j.exists((0,m.$_g)(J.location,"package.json"))){const V=await this.scanExtension(J);return V?[V]:[]}else return await this.scanExtensions(J)}catch(V){return this.m.error(`Error scanning extensions at ${J.location.path}:`,(0,j.$0)(V)),[]}}async scanExtension(J,V){try{let q=await this.scanExtensionManifest(J.location);if(q){q.publisher||(q.publisher=a.$Pm),V=V??q.__metadata,delete q.__metadata;const L=(0,S.$Dp)(q.publisher,q.name),B=V?.id?{id:L,uuid:V.id}:{id:L},H=V?.isSystem?0:J.type,oe=H===0||!!V?.isBuiltin;q=await this.t(J.location,q,F.createNlsConfiguration(J));const G={type:H,identifier:B,manifest:q,location:J.location,isBuiltin:oe,targetPlatform:V?.targetPlatform??"undefined",publisherDisplayName:V?.publisherDisplayName,metadata:V,isValid:!0,validations:[]};return J.validate?this.validate(G,J):G}}catch(q){J.type!==0&&this.m.error(q)}return null}validate(J,V){let q=!0;const L=(0,t.$Op)(V.productVersion,V.productDate,V.location,J.manifest,J.isBuiltin);for(const[B,H]of L)B===y.default.Error&&(q=!1,this.m.error(this.z(V.location,H)));return J.isValid=q,J.validations=L,J}async scanExtensionManifest(J){const V=(0,m.$_g)(J,"package.json");let q;try{q=(await this.j.readFile(V)).value.toString()}catch(B){return(0,r.$jl)(B)!==1&&this.m.error(this.z(J,(0,f.localize)(0,null,V.path,B.message))),null}let L;try{L=JSON.parse(q)}catch{const H=[];(0,E.$Ln)(q,H);for(const oe of H)this.m.error(this.z(J,(0,f.localize)(1,null,V.path,oe.offset,oe.length,(0,u.$vq)(oe.error))));return null}return(0,E.$Un)(L)!=="object"?(this.m.error(this.z(J,(0,f.localize)(2,null,V.path))),null):L}async t(J,V,q){const L=await this.u(J,V,q);if(L)try{const B=[],H=await this.w(L.default,B);if(B.length>0)return B.forEach(G=>{this.m.error(this.z(J,(0,f.localize)(3,null,L.default?.path,(0,u.$vq)(G.error))))}),V;if((0,E.$Un)(L)!=="object")return this.m.error(this.z(J,(0,f.localize)(4,null,L.default?.path))),V;const oe=L.values||Object.create(null);return(0,O.$wq)(this.m,V,oe,H)}catch{}return V}async u(J,V,q){const L=(0,m.$_g)(J,"package.nls.json"),B=(le,Q)=>{Q.forEach(A=>{this.m.error(this.z(J,(0,f.localize)(5,null,le?.path,(0,u.$vq)(A.error))))})},H=le=>{this.m.error(this.z(J,(0,f.localize)(6,null,le?.path)))},oe=`${V.publisher}.${V.name}`,G=q.translations[oe];if(G)try{const le=b.URI.file(G),Q=(await this.j.readFile(le)).value.toString(),A=[],N=(0,E.$Ln)(Q,A);return A.length>0?(B(le,A),{values:void 0,default:L}):(0,E.$Un)(N)!=="object"?(H(le),{values:void 0,default:L}):{values:N.contents?N.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let Q;try{Q=await this.y(J,q)}catch{return}if(!Q.localized)return{values:void 0,default:Q.original};try{const A=(await this.j.readFile(Q.localized)).value.toString(),N=[],_=(0,E.$Ln)(A,N);return N.length>0?(B(Q.localized,N),{values:void 0,default:Q.original}):(0,E.$Un)(_)!=="object"?(H(Q.localized),{values:void 0,default:Q.original}):{values:_,default:Q.original}}catch{return{values:void 0,default:Q.original}}}}async w(J,V){if(J)try{const q=(await this.j.readFile(J)).value.toString();return(0,E.$Ln)(q,V)}catch{}}y(J,V){return new Promise((q,L)=>{const B=H=>{const oe=(0,m.$_g)(J,`package.nls.${H}.json`);this.j.exists(oe).then(G=>{G&&q({localized:oe,original:(0,m.$_g)(J,"package.nls.json")});const le=H.lastIndexOf("-");le===-1?q({localized:(0,m.$_g)(J,"package.nls.json"),original:null}):(H=H.substring(0,le),B(H))})};if(V.devMode||V.pseudo||!V.language)return q({localized:(0,m.$_g)(J,"package.nls.json"),original:null});B(V.language)})}z(J,V){return`[${J.path}]: ${V}`}};T=Ee([ie(1,P.$tq),ie(2,I.$Cl),ie(3,r.$5k),ie(4,i.$5j)],T);let U=class extends T{constructor(J,V,q,L,B,H,oe){super(V,L,B,H,oe),this.G=J,this.H=q,this.D=this.B(new C.$wh(3e3)),this.F=this.B(new l.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(J){const V=this.M(J),q=await this.I(V);if(this.C=J,q&&q.input&&F.equals(q.input,this.C))return this.m.debug("Using cached extensions scan result",J.location.toString()),this.D.trigger(()=>this.L()),q.result.map(B=>(B.location=b.URI.revive(B.location),B));const L=await super.scanExtensions(J);return await this.J(V,{input:J,result:L}),L}async I(J){try{const V=await this.j.readFile(J),q=JSON.parse(V.value.toString());return{result:q.result,input:(0,$.$8h)(q.input)}}catch(V){this.m.debug("Error while reading the extension cache file:",J.path,(0,j.$0)(V))}return null}async J(J,V){try{await this.j.writeFile(J,R.$He.fromString(JSON.stringify(V)))}catch(q){this.m.debug("Error while writing the extension cache file:",J.path,(0,j.$0)(q))}}async L(){if(!this.C)return;const J=this.M(this.C),V=await this.I(J);if(!V)return;const q=V.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!k.$9n(L,q))try{this.m.info("Invalidating Cache",q,L),await this.j.del(J),this.F.fire()}catch(B){this.m.error(B)}}M(J){const V=this.N(J);return this.h.extUri.joinPath(V.cacheHome,J.type===0?a.$Om:a.$Nm)}N(J){return J.type===0?this.H.defaultProfile:J.profile?this.h.extUri.isEqual(J.location,this.G.extensionsResource)?this.G:this.H.profiles.find(V=>this.h.extUri.isEqual(J.location,V.extensionsResource))??this.G:this.H.defaultProfile}};U=Ee([ie(2,D.$El),ie(3,P.$tq),ie(4,I.$Cl),ie(5,r.$5k),ie(6,i.$5j)],U);function ae(ce,J){const V=(0,S.$Bp)(ce.manifest.publisher,ce.manifest.name);return{id:V,identifier:new a.$Tm(V),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:J,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class te extends W{constructor(J,V,q,L,B,H,oe,G,le,Q,A,N){super(J,V,(0,m.$_g)(q,".vscode-oss-dev","extensions","control.json"),L,B,H,oe,G,le,Q,A,N),this.S=(async()=>{if(v.$z)try{const _=await this.w.readFile(b.URI.file(v.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(J){return this.S}}e.$Bq=te}),define(se[280],re([0,1,5,41,40,28,83,16,38,7]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;let g=class extends j.$uq{constructor(v,m,d,y,w,b){super(c.URI.file(v.extensionsPath),m,d,y,w,b)}};e.$aQ=g,e.$aQ=g=Ee([ie(0,u.$Gi),ie(1,E.$5k),ie(2,C.$El),ie(3,k.$Cl),ie(4,R.$4l),ie(5,n.$5j)],g)}),define(se[281],re([0,1,7,38,83,132,16,6,5,27,40,41]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let v=class extends R.$Bq{constructor(d,y,w,b,f,h,S,a){super(n.URI.file(f.builtinExtensionsPath),n.URI.file(f.extensionsPath),f.userHome,d.defaultProfile,d,y,w,b,f,h,S,a)}};e.$_dc=v,e.$_dc=v=Ee([ie(0,p.$El),ie(1,k.$tq),ie(2,j.$5k),ie(3,u.$5j),ie(4,C.$Gi),ie(5,c.$lk),ie(6,g.$Cl),ie(7,E.$xi)],v)}),define(se[282],re([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rec=void 0;let d=class extends C.$Uc{constructor(w,b,f){super(),this.c=w,this.f=f,this.a=E.$Ei.forPaths(!j.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(w.appRoot),this.addValidFileRoot(w.extensionsPath),this.addValidFileRoot(b.defaultProfile.globalStorageHome.with({scheme:k.Schemas.file}).fsPath),this.addValidFileRoot(w.workspaceStorageHome.with({scheme:k.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:w}=n.session;w.protocol.registerFileProtocol(k.Schemas.vscodeFileResource,(b,f)=>this.j(b,f)),w.protocol.interceptFileProtocol(k.Schemas.file,(b,f)=>this.h(b,f)),this.B((0,C.$Sc)(()=>{w.protocol.unregisterProtocol(k.Schemas.vscodeFileResource),w.protocol.uninterceptProtocol(k.Schemas.file)}))}addValidFileRoot(w){const b=(0,R.$hc)(w);return this.a.get(b)?C.$Uc.None:(this.a.set(b,!0),(0,C.$Sc)(()=>this.a.delete(b)))}h(w,b){const f=u.URI.parse(w.url);return this.f.error(`Refused to load resource ${f.fsPath} from ${k.Schemas.file}: protocol (original URL: ${w.url})`),b({error:-3})}j(w,b){const f=this.m(w);let h;return this.c.crossOriginIsolated&&((0,R.$nc)(f)==="workbench.html"||(0,R.$nc)(f)==="workbench-dev.html"?h=k.COI.CoopAndCoep:h=k.COI.getHeadersFromQuery(w.url)),this.a.findSubstr(f)?b({path:f,headers:h}):this.b.has((0,R.$oc)(f).toLowerCase())?b({path:f}):(this.f.error(`${k.Schemas.vscodeFileResource}: Refused to load resource ${f} from ${k.Schemas.vscodeFileResource}: protocol (original URL: ${w.url})`),b({error:-3}))}m(w){const b=u.URI.parse(w.url),f=k.$Sg.uriToFileUri(b);return(0,R.$hc)(f.fsPath)}createIPCObjectUrl(){let w;const b=u.URI.from({scheme:"vscode",path:(0,c.$Ug)()}),f=b.toString(),h=async()=>w;return g.$iW.handle(f,h),this.f.trace(`IPC Object URL: Registered new channel ${f}.`),{resource:b,update:S=>w=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${f}.`),g.$iW.removeHandler(f)}}}};e.$rec=d,e.$rec=d=Ee([ie(0,p.$Gi),ie(1,m.$El),ie(2,v.$5j)],d)}),define(se[97],re([0,1,8,3,2,66,12,115,6,41]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=m,e.$8p=y,e.$0p=b,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,u.$yi)("storageService");var g;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(g||(e.WillSaveStateReason=g={}));var p;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(p||(e.StorageScope=p={}));var v;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function m(f){const h=f.get(e.$4p);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class d extends k.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:d.a}){super(),this.m=h,this.b=this.B(new C.$ie),this.c=this.B(new C.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new k.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,S,a){return C.Event.filter(this.b.event,t=>t.scope===h&&(S===void 0||t.key===S),a)}n(){this.j.value=(0,n.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,k.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,S){const{key:a,external:t}=S;if(a===e.$4p){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:a,target:this.J(h)[a],external:t})}w(h){this.f.fire({reason:h})}get(h,S,a){return this.P(S)?.get(h,a)}getBoolean(h,S,a){return this.P(S)?.getBoolean(h,a)}getNumber(h,S,a){return this.P(S)?.getNumber(h,a)}getObject(h,S,a){return this.P(S)?.getObject(h,a)}storeAll(h,S){this.y(()=>{for(const a of h)this.store(a.key,a.value,a.scope,a.target,S)})}store(h,S,a,t,r=!1){if((0,j.$hg)(S)){this.remove(h,a,r);return}this.y(()=>{this.z(h,a,t),this.P(a)?.set(h,S,r)})}remove(h,S,a=!1){this.y(()=>{this.z(h,S,void 0),this.P(S)?.delete(h,a)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,S){const a=[],t=this.J(h);for(const r of Object.keys(t))t[r]===S&&a.push(r);return a}z(h,S,a,t=!1){const r=this.J(S);typeof a=="number"?r[h]!==a&&(r[h]=a,this.P(S)?.set(e.$4p,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P(S)?.set(e.$4p,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const S=this.P(h);return S?m(S):Object.create(null)}isNew(h){return this.getBoolean(e.$3p,h)===!0}async flush(h=g.NONE){this.f.fire({reason:h});const S=this.P(-1),a=this.P(0),t=this.P(1);switch(h){case g.NONE:await n.Promises.settled([S?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case g.SHUTDOWN:await n.Promises.settled([S?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,S=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return b(h,S,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,S){return this.w(g.NONE),(0,c.$Dl)(h)?this.R(h,S):this.S(h,S)}M(h,S){return!(h.id===S.id||y(S)&&y(h))}N(h,S,a){this.y(()=>{const t=new Set;for(const[r,s]of h)t.add(r),S.get(r)!==s&&this.u(a,{key:r,external:!0});for(const[r]of S.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$7p=d;function y(f){return f.isDefault||!!f.useDefaultFlags?.globalState}class w extends d{constructor(){super(),this.U=this.B(new E.$1p(new E.$2p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new E.$1p(new E.$2p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new E.$1p(new E.$2p,{hint:E.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$9p=w;async function b(f,h,S,a,t,r){const s=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,o=new Map;f.forEach((M,W)=>{i.set(W,M),o.set(W,s(M))});const l=new Map,$=new Map;h.forEach((M,W)=>{l.set(W,M),$.set(W,s(M))});const P=new Map,D=new Map;S.forEach((M,W)=>{P.set(W,M),D.set(W,s(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const I=[];if(i.forEach((M,W)=>{I.push({key:W,value:M})}),console.table(I),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];l.forEach((W,F)=>{M.push({key:F,value:W})}),console.table(M),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${r})`);const O=[];P.forEach((M,W)=>{O.push({key:W,value:M})}),console.table(O),console.groupEnd(),console.log(D)}}),define(se[283],re([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=e.$1cc=e.$Zcc=void 0;class b extends R.$Uc{static{this.a=2e3}get storage(){return this.f}constructor(s,i){super(),this.m=s,this.n=i,this.b=this.B(new k.$fe),this.onDidChangeStorage=this.b.event,this.c=this.B(new k.$fe),this.onDidCloseStorage=this.c.event,this.f=this.B(new g.$1p(new g.$2p,{hint:g.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new C.$Vh,this.whenInit=this.h.p,this.j=g.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===g.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(o=>this.b.fire(o))),await this.s(s);const i=s.getBoolean(m.$3p);i===void 0?s.set(m.$3p,!0):i&&s.set(m.$3p,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=g.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,i){return this.f.get(s,i)}set(s,i){return this.f.set(s,i)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new E.$be(!1);await this.w(),s.stop(),s.elapsed()>b.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([l,$])=>({key:l,length:$.length})),(l,$)=>$.length-l.length,5).map(l=>`${l.key}:${l.length}`).join(", "),o=(await this.n.stat(u.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=g.StorageState.Closed,await this.f.close()}}class f extends b{static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,j.$jc)(this.z.globalStorageHome.with({scheme:w.Schemas.file}).fsPath,f.y)}constructor(s,i,o,l){super(o,l),this.z=s,this.C=i}async t(){return new g.$1p(new p.$NW(this.path??p.$NW.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:g.StorageHint.STORAGE_IN_MEMORY})}}class h extends f{constructor(s,i,o,l){super(s,i,o,l)}}e.$Zcc=h;class S extends f{constructor(s,i,o,l){super(i.defaultProfile,s,o,l)}async s(s){await super.s(s),this.G(s)}G(s){s.get(d.$7l,void 0)===void 0&&s.set(d.$7l,new Date().toUTCString());const o=s.get(d.$6l,void 0),l=new Date().toUTCString();s.set(d.$8l,typeof o>"u"?null:o),s.set(d.$6l,l)}}e.$1cc=S;class a extends b{static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,j.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,i,o,l,$){super(o,$),this.C=s,this.D=i,this.F=l}async t(){const{storageFilePath:s,wasCreated:i}=await this.H();return new g.$1p(new p.$NW(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?g.StorageHint.STORAGE_IN_MEMORY:i?g.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:p.$NW.IN_MEMORY_PATH,wasCreated:!0};const s=(0,j.$jc)(this.F.workspaceStorageHome.with({scheme:w.Schemas.file}).fsPath,this.C.id),i=(0,j.$jc)(s,a.y);return await c.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await c.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:i,wasCreated:!0})}async I(s){let i;if((0,y.$Ii)(this.C)?i={folder:this.C.uri.toString()}:(0,y.$Ni)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const o=(0,j.$jc)(s,a.z);await c.Promises.exists(o)||await c.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.$2cc=a;class t extends b{get path(){}async t(){return new g.$1p(new g.$2p,{hint:g.StorageHint.STORAGE_IN_MEMORY})}}e.$3cc=t}),define(se[284],re([0,1,3,2,97]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bec=void 0;class R extends C.$Uc{constructor(E,u,c){super(),this.b=E,this.c=u,this.f=c;const g=this.B(new C.$Vc);this.a=this.B(new n.$fe({onWillAddFirstListener:()=>g.value=this.g(),onDidRemoveLastListener:()=>g.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const E=new C.$Tc;return E.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(u,c)=>(u?u.push(c.key):u=[c.key],u),100)(u=>this.h(u))),E.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(u,c)=>{u||(u=new Map);let g=u.get(c.profile.id);return g||u.set(c.profile.id,g={profile:c.profile,keys:[],storage:c.storage}),g.keys.push(c.key),u},100)(u=>this.j(u))),E}h(E){const u=E.includes(k.$4p)?[this.c.defaultProfile]:[],c=[];if(E=E.filter(g=>g!==k.$4p),E.length){const g=(0,k.$6p)(this.b.applicationStorage.storage);c.push({profile:this.c.defaultProfile,changes:E.map(p=>({key:p,scope:0,target:g[p]}))})}this.m(u,c)}j(E){const u=[],c=new Map;for(const[g,p]of E.entries()){p.keys.includes(k.$4p)&&u.push(p.profile);const v=p.keys.filter(m=>m!==k.$4p);if(v.length){const m=(0,k.$6p)(p.storage.storage);c.set(g,{profile:p.profile,changes:v.map(d=>({key:d,scope:0,target:m[d]}))})}}this.m(u,[...c.values()])}m(E,u){(E.length||u.length)&&this.a.fire({valueChanges:u,targetChanges:E})}listen(E,u,c){switch(u){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${u}`)}async call(E,u){throw new Error(`Call not found: ${u}`)}}e.$bec=R}),define(se[285],re([0,1,7,38,16,5,34,40,41,12,125]),function(K,e,n,C,k,R,j,E,u,c,g){"use strict";var p,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=e.$0P=void 0;let m=class extends u.$Hl{static{p=this}static{this.a="profileAssociationsMigration"}constructor(b,f,h,S,a){super(h,S,f,a),this.U=b,this.W=h}O(){return this.U.getItem(p.b,[]).map(f=>({...f,location:(0,c.$$f)(f.location)?this.w.extUri.joinPath(this.profilesHome,f.location):n.URI.revive(f.location)}))}Q(){const b=this.U.getItem(p.c,{});return this.U.getItem(p.a,!1)?b:this.N(b)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$0P=m,e.$0P=m=p=Ee([ie(0,j.$5P),ie(1,E.$Cl),ie(2,C.$Gi),ie(3,k.$5k),ie(4,R.$5j)],m);let d=v=class extends m{constructor(b,f,h,S,a){super(b,f,h,S,a),this.$=b}P(b){b.length?this.$.setItem(v.b,b.map(f=>({...f,location:this.w.extUri.basename(f.location)}))):this.$.removeItem(v.b)}O(){const b=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(b),this.$.setItem("userDataProfilesMigration",!0)),b}R(b){b.emptyWindows||b.workspaces?this.$.setItem(v.c,b):this.$.removeItem(v.c)}Q(){const b="workspaceAndProfileInfo",f=this.$.getItem(b,void 0);if(f){this.$.removeItem(b);const S=f.reduce((a,{workspace:t,profile:r})=>(a[n.URI.revive(t).toString()]=n.URI.revive(r).toString(),a),{});this.$.setItem(v.c,{workspaces:S})}const h=super.Q();return this.$.getItem(v.a,!1)||(this.R(h),this.$.setItem(v.a,!0)),h}};e.$$P=d,e.$$P=d=v=Ee([ie(0,j.$6P),ie(1,E.$Cl),ie(2,C.$Gi),ie(3,k.$5k),ie(4,R.$5j)],d);let y=class extends d{constructor(b,f,h,S){super(new g.$9P(0,f,S,h),b,f,h,S)}async init(){return await this.$.init(),super.init()}};e.$_P=y,e.$_P=y=Ee([ie(0,E.$Cl),ie(1,C.$Gi),ie(2,k.$5k),ie(3,R.$5j)],y)}),define(se[57],re([0,1,38,16,6,5,40,41,285,34]),function(K,e,n,C,k,R,j,E,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Icc=e.$Hcc=void 0,e.$Hcc=(0,k.$zi)(E.$El);let g=class extends u.$$P{constructor(v,m,d,y,w){super(v,m,d,y,w)}getAssociatedEmptyWindows(){const v=[];for(const m of this.C.emptyWindows.keys())v.push({id:m});return v}};e.$Icc=g,e.$Icc=g=Ee([ie(0,c.$6P),ie(1,j.$Cl),ie(2,n.$Gi),ie(3,C.$5k),ie(4,R.$5j)],g)}),define(se[133],re([0,1,19,7,30]),function(K,e,n,C,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=R,e.$Kcc=j,e.$Lcc=E;async function R(u,c,g){for(const v of u){const m=v.openedWorkspace;if((0,k.$Ni)(m)){const d=await g(m);if(d){if(d.folders.some(y=>n.$3g.isEqualOrParent(c,y.uri)))return v}else if(n.$3g.isEqualOrParent(c,m.configPath))return v}}const p=u.filter(v=>(0,k.$Ii)(v.openedWorkspace)&&n.$3g.isEqualOrParent(c,v.openedWorkspace.uri));if(p.length)return p.sort((v,m)=>-(v.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}function j(u,c){for(const g of u)if((0,k.$Ni)(g.openedWorkspace)&&n.$3g.isEqual(g.openedWorkspace.configPath,c)||(0,k.$Ii)(g.openedWorkspace)&&n.$3g.isEqual(g.openedWorkspace.uri,c))return g}function E(u,c){const g=p=>c.some(v=>n.$3g.isEqual(C.URI.file(v),C.URI.file(p)));for(const p of u)if(p.config?.extensionDevelopmentPath?.some(v=>g(v)))return p}}),define(se[98],re([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfb=void 0,e.$1fb=d,e.$2fb=y,e.$3fb=w,e.$4fb=b,e.$5fb=S,e.$6fb=t,e.$7fb=r,e.$8fb=$,e.$9fb=P,e.$Zfb=(0,p.$yi)("workspacesService");function d(D){return D.hasOwnProperty("workspace")}function y(D){return D.hasOwnProperty("folderUri")}function w(D){return D.hasOwnProperty("fileUri")}function b(D){return f(D)||h(D)}function f(D){const I=D;return typeof I?.path=="string"&&(!I.name||typeof I.name=="string")}function h(D){const I=D;return typeof I?.uri=="string"&&(!I.name||typeof I.name=="string")}function S(D,I,O,M,W){if(D.scheme!==M.scheme)return{name:O,uri:D.toString(!0)};let F=I?void 0:W.relativePath(M,D);if(F!==void 0)F.length===0?F=".":u.$i&&(F=a(F));else if(D.scheme===j.Schemas.file)F=D.fsPath,u.$i&&(F=a(F));else if(W.isEqualAuthority(D.authority,M.authority))F=D.path;else return{name:O,uri:D.toString(!0)};return{name:O,path:F}}function a(D){return D=(0,R.$Iw)(D),(0,n.$ug)(D)||(D=(0,n.$rg)(D)),D}function t(D,I,O){const M=[],W=new Set,F=O.dirname(I);for(const T of D){let U;if(f(T))T.path&&(U=O.resolvePath(F,T.path));else if(h(T))try{U=g.URI.parse(T.uri),U.path[0]!==E.$gc.sep&&(U=U.with({path:E.$gc.sep+U.path}))}catch(ae){console.warn(ae)}if(U){const ae=O.getComparisonKey(U);if(!W.has(ae)){W.add(ae);const te=T.name||O.basenameOrAuthority(U);M.push(new m.$Si({uri:U,name:te,index:M.length},T))}}}return M}function r(D,I,O,M,W){const F=s(I,D),T=W.dirname(I),U=W.dirname(M),ae=[];for(const V of F.folders){const q=f(V)?W.resolvePath(T,V.path):g.URI.parse(V.uri);let L;O?L=!1:L=!f(V)||(0,E.$ic)(V.path),ae.push(S(q,L,V.name,U,W))}const te={insertSpaces:!1,tabSize:4,eol:u.$k||u.$j?`
`:`\r
`},ce=k.$1n(D,["folders"],ae,te);let J=k.$4n(D,ce);return(0,c.$eh)(F.remoteAuthority,(0,v.$Jm)(M))&&(J=k.$4n(J,k.$Zn(J,["remoteAuthority"],te))),J}function s(D,I){const O=C.$Ln(I);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(M=>b(M));else throw new Error(`${D} looks like an invalid workspace file.`);return O}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function o(D){return typeof D.folderUri=="string"}function l(D){return typeof D.fileUri=="string"}function $(D,I){const O={workspaces:[],files:[]};if(D){const M=function(F,T){for(let U=0;U<F.length;U++)try{T(F[U],U)}catch(ae){I.warn(`Error restoring recent entry ${JSON.stringify(F[U])}: ${ae.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&M(W.entries,F=>{const T=F.label,U=F.remoteAuthority;i(F)?O.workspaces.push({label:T,remoteAuthority:U,workspace:{id:F.workspace.id,configPath:g.URI.parse(F.workspace.configPath)}}):o(F)?O.workspaces.push({label:T,remoteAuthority:U,folderUri:g.URI.parse(F.folderUri)}):l(F)&&O.files.push({label:T,remoteAuthority:U,fileUri:g.URI.parse(F.fileUri)})})}return O}function P(D){const I={entries:[]};for(const O of D.workspaces)y(O)?I.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):I.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of D.files)I.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return I}}),define(se[99],re([0,1,87,13,4,19]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0,e.$Ncc=j,e.$Occ=E,e.$Pcc=u,e.$Mcc=128/4;function j(c){function g(){let p=c.scheme===C.Schemas.file?(0,R.$Zg)(c):c.toString();return k.$k||(p=p.toLowerCase()),(0,n.createHash)("md5").update(p).digest("hex")}return{id:g(),configPath:c}}function E(c,g){function p(){if(c.scheme!==C.Schemas.file)return(0,n.createHash)("md5").update(c.toString()).digest("hex");if(!g)return;let m;return k.$k?m=g.ino:k.$j?m=g.birthtime.getTime():k.$i&&(typeof g.birthtimeMs=="number"?m=Math.floor(g.birthtimeMs):m=g.birthtime.getTime()),(0,n.createHash)("md5").update(c.fsPath).update(m?String(m):"").digest("hex")}const v=p();if(typeof v=="string")return{id:v,uri:c}}function u(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(se[100],re([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$pi=e.$oi=e.$ni=void 0,e.$qi=s,e.$ri=i,e.$ti=$,e.$ui=P;class y{traceSocketEvent(I,O){d.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,E.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(j.$He.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,E.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ni=y;var w;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var b;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})(b||(b={}));class f extends c.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,W){super(),this.f=this.B(new u.$fe),this.g=this.B(new u.$fe),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new h(this,O,M,W,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,E.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new d.$ii,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let W=2;I.byteLength<126?W+=0:I.byteLength<2**16?W+=2:W+=8;const F=j.$He.alloc(W),T=O?64:0,U=M&15;if(F.writeUInt8(128|T|U,0),I.byteLength<126)F.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){F.writeUInt8(126,1);let ae=1;F.writeUInt8(I.byteLength>>>8&255,++ae),F.writeUInt8(I.byteLength>>>0&255,++ae)}else{F.writeUInt8(127,1);let ae=1;F.writeUInt8(0,++ae),F.writeUInt8(0,++ae),F.writeUInt8(0,++ae),F.writeUInt8(0,++ae),F.writeUInt8(I.byteLength>>>24&255,++ae),F.writeUInt8(I.byteLength>>>16&255,++ae),F.writeUInt8(I.byteLength>>>8&255,++ae),F.writeUInt8(I.byteLength>>>0&255,++ae)}this.socket.write(j.$He.concat([F,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),W=(M&128)>>>7,F=(M&64)>>>6,T=M&15,U=O.readUInt8(1),ae=(U&128)>>>7,te=U&127;this.j.state=2,this.j.readLen=2+(ae?4:0)+(te===126?2:0)+(te===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),W=(M&128)>>>7;let F=M&127,T=1;F===126?F=O.readUInt8(++T)*2**8+O.readUInt8(++T):F===127&&(F=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let U=0;W&&(U=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await u.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$oi=f;class h extends c.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$He.alloc(0)}constructor(I,O,M,W,F,T){super(),this.n=I,this.r=F,this.s=T,this.a=this.B(new u.$fe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new u.$fe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new u.$fe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new S(this.n,W,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,W)=>{I.write(O),I.flush(F=>M(F))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((W,F)=>{I.write(O),M&&I.write(j.$He.fromByteArray([0,0,255,255])),I.flush(T=>W(T))})}}class S extends c.$Uc{get recordedInflateBytes(){return this.j?j.$He.concat(this.f):j.$He.alloc(0)}constructor(I,O,M,W){super(),this.h=I,this.j=O,this.a=this.B(new u.$fe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(j.$He.wrap(F))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=j.$He.concat(this.g);this.g.length=0,I(O)})}}class a extends c.$Uc{constructor(I,O){super(),this.g=I,this.a=this.B(new u.$fe),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(j.$He.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=j.$He.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(D,I){if(I===0)return;const O=D.byteLength>>>2;for(let ae=0;ae<O;ae++){const te=D.readUInt32BE(ae*4);D.writeUInt32BE(te^I,ae*4)}const M=O*4,W=D.byteLength-M,F=I>>>24&255,T=I>>>16&255,U=I>>>8&255;W>=1&&D.writeUInt8(D.readUInt8(M)^F,M),W>=2&&D.writeUInt8(D.readUInt8(M+1)^T,M+1),W>=3&&D.writeUInt8(D.readUInt8(M+2)^U,M+2)}e.$pi=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const D=(0,v.$Ug)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const I=process.platform!=="darwin"&&e.$pi?e.$pi:(0,k.tmpdir)(),O=(0,g.$jc)(I,`vscode-ipc-${D}.sock`);return o(O),O}function i(D,I,O){const W=(0,n.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${I}-sock`;const F=O.substr(0,4),T=I.substr(0,6);let U;return process.platform!=="darwin"&&e.$pi&&!process.env.VSCODE_PORTABLE?U=(0,g.$jc)(e.$pi,`vscode-${W}-${F}-${T}.sock`):U=(0,g.$jc)(D,`${F}-${T}.sock`),o(U),U}function o(D){const I=r[p.$u];typeof I=="number"&&D.length>=I&&console.warn(`WARNING: IPC handle "${D}" is longer than ${I} chars, try a shorter --user-data-dir`)}class l extends m.$ci{static b(I){const O=u.Event.fromNodeEventEmitter(I,"connection");return u.Event.map(O,M=>({protocol:new d.$ji(new y(M,"ipc-server-connection")),onDidClientDisconnect:u.Event.once(u.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(l.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$si=l;function $(D){return new Promise((I,O)=>{const M=(0,C.createServer)();M.on("error",O),M.listen(D,()=>{M.removeListener("error",O),I(new l(M))})})}function P(D,I){return new Promise((O,M)=>{const W=(0,C.createConnection)(D,()=>{W.removeListener("error",M),O(d.$ki.fromSocket(new y(W,`ipc-client${I}`),I))});W.once("error",M)})}}),define(se[24],re([0,1,51,9,4,100,38,91,6]),function(K,e,n,C,k,R,j,E,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ucc=e.$tcc=void 0,e.$tcc=(0,u.$zi)(j.$Fi);class c extends E.$$m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,C.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$ri)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(k.$k){for(const p in process.env)if(p.endsWith("_VSCODE_SNAP_ORIG")){const v=p.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[p]?process.env[v]=process.env[p]:delete process.env[v]}}}restoreSnapExportedVariables(){if(k.$k)for(const p in this.d)process.env[p]=this.d[p],delete this.d[p]}}e.$ucc=c,Ee([n.$3h],c.prototype,"cachedLanguagesPath",null),Ee([n.$3h],c.prototype,"backupHome",null),Ee([n.$3h],c.prototype,"mainIPCHandle",null),Ee([n.$3h],c.prototype,"mainLockfile",null),Ee([n.$3h],c.prototype,"disableUpdates",null),Ee([n.$3h],c.prototype,"crossOriginIsolated",null),Ee([n.$3h],c.prototype,"codeCachePath",null),Ee([n.$3h],c.prototype,"useCodeCache",null)}),define(se[287],re([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=void 0;let h=class{static{f=this}static{this.a="backupWorkspaces"}constructor(a,t,r,s){this.j=a,this.k=t,this.l=r,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=E.$3g,this.i={isEqual:(i,o)=>(0,C.$wg)(i,o,!j.$k)}}async initialize(){const a=this.m.getItem(f.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,c.$wcc)(a)),this.e=await this.v((0,c.$xcc)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==m.$rl.OFF}q(){return this.s()===m.$rl.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||m.$rl.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const r=(0,R.$jc)(this.c,a.workspace.id);return t?this.t(r,t).then(()=>r):r}async t(a,t){if(await u.Promises.exists(a)&&await this.z(a),await u.Promises.exists(t))try{await u.Promises.rename(t,a,!1)}catch(r){this.l.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,R.$jc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,R.$jc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,r=[];for(const s of a){const i=s.workspace;if(!(0,w.$Ni)(i))return[];if(!t.has(i.id)){t.add(i.id);const o=(0,R.$jc)(this.c,i.id);await this.B(o)?i.configPath.scheme!==k.Schemas.file||await u.Promises.exists(i.configPath.fsPath)?r.push(s):await this.z(o):await this.x(o)}}return r}async v(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.folderUri,o=this.h.getComparisonKey(i);if(!r.has(o)){r.add(o);const l=(0,R.$jc)(this.c,this.D(s));await this.B(l)?i.scheme!==k.Schemas.file||await u.Promises.exists(i.fsPath)?t.push(s):await this.z(l):await this.x(l)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const o=(0,R.$jc)(this.c,i);await this.B(o)?t.push(s):await this.x(o)}}return t}async x(a){try{await u.Promises.rm(a,u.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,b.$Pcc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,b.$Pcc)();return{backupFolder:a.id}}async z(a){const t=this.y(),r=(0,R.$jc)(this.c,t.backupFolder);try{await u.Promises.rename(a,r,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,c.$vcc)(a)?t=(0,R.$jc)(this.c,a.backupFolder):(0,y.$Xfb)(a)?t=(0,R.$jc)(this.c,this.D(a)):t=(0,R.$jc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await u.Promises.readdir(a);for(const r of t)try{if((await u.Promises.readdir((0,R.$jc)(a,r))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:r})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return r&&(s.remoteAuthority=r),s}),folders:this.e.map(({folderUri:t,remoteAuthority:r})=>{const s={folderUri:t.toString()};return r&&(s.remoteAuthority=r),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:r})=>{const s={backupFolder:t};return r&&(s.remoteAuthority=r),s})};this.m.setItem(f.a,a)}D(a){const t=a.folderUri;let r;return t.scheme===k.Schemas.file?r=j.$k?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,n.createHash)("md5").update(r).digest("hex")}};e.$9cc=h,e.$9cc=h=f=Ee([ie(0,p.$tcc),ie(1,g.$5i),ie(2,d.$5j),ie(3,v.$6P)],h)}),define(se[20],re([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=e.LifecycleMainPhase=e.ShutdownReason=e.$Xcc=void 0,e.$Xcc=(0,g.$yi)("lifecycleMainService");var y;(function(f){f[f.QUIT=1]="QUIT",f[f.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var w;(function(f){f[f.Starting=1]="Starting",f[f.Ready=2]="Ready",f[f.AfterWindowOpen=3]="AfterWindowOpen",f[f.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let b=class extends j.$Uc{static{d=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,S,a){super(),this.F=h,this.G=S,this.H=a,this.c=this.B(new R.$fe),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$fe),this.onWillShutdown=this.f.event,this.g=this.B(new R.$fe),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$fe),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(d.b),this.m&&this.G.removeItem(d.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),E.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",h);const S=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!E.$j)&&n.app.quit()};n.app.addListener("window-all-closed",S),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",h),n.app.removeListener("window-all-closed",S),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(h){if(this.y)return this.y;const S=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:h,join(t,r){S.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(r.finally(()=>{S.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await k.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const S=this.C.get(this.n);S&&(S.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let S=this.C.get(h);S||(S=new k.$xh,this.C.set(h,S)),await S.wait()}registerWindow(h){const S=new j.$Tc;this.t++,S.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const a=(0,c.$jg)(h.win);S.add(R.Event.fromNodeEventEmitter(a,"close")(t=>{const r=h.id;if(this.r.has(r)){this.r.delete(r);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(s=>{if(s){this.r.delete(r);return}this.r.add(r),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this.h.fire(h),h.close()})})),S.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,S.dispose(),this.t===0&&(!E.$j||this.j)&&this.L(1)}))}registerAuxWindow(h){const S=(0,c.$jg)(h.win),a=new j.$Tc;a.add(R.Event.fromNodeEventEmitter(S,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(R.Event.fromNodeEventEmitter(S,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`),a.dispose()}))}async reload(h,S){await this.unload(h,3)||h.reload(S)}unload(h,S){const a=this.z.get(h.id);if(a)return a;const t=this.M(h,S).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,S){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const a=this.j?2:S,t=await this.P(h,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,a),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,S){return new Promise(a=>{const t=this.s++,r=`vscode:ok${t}`,s=`vscode:cancel${t}`;C.$iW.once(r,()=>{a(!1)}),C.$iW.once(s,()=>{a(!0)}),h.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:S})})}Q(h,S){return new Promise(a=>{const r=`vscode:reply${this.s++}`;C.$iW.once(r,()=>a()),h.send("vscode:onWillUnload",{replyChannel:r,reason:S})})}quit(h){return this.R(h).then(S=>{if(!S&&h)try{if(E.$i){const a=(0,u.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return S})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(d.b,!0),this.u=new Promise(S=>{this.w=S,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const S=process.argv.slice(1);if(h?.addArgs&&S.push(...h.addArgs),h?.removeArgs)for(const r of h.removeArgs){const s=S.indexOf(r);s>=0&&S.splice(s,1)}const a=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:S}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,k.$zh)(1e3),(async()=>{for(const S of n.BrowserWindow.getAllWindows())if(S&&!S.isDestroyed()){let a;S.webContents&&!S.webContents.isDestroyed()?a=new Promise(t=>S.once("closed",t)):a=Promise.resolve(),S.destroy(),await a}})()]),n.app.exit(h)}};e.$Ycc=b,e.$Ycc=b=d=Ee([ie(0,p.$5j),ie(1,v.$6P),ie(2,m.$tcc)],b)}),define(se[288],re([0,1,4,3,2,6,20]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$udc=e.$tdc=void 0,e.$tdc=(0,R.$yi)("keyboardLayoutMainService");let E=class extends k.$Uc{constructor(g){super(),this.a=this.B(new C.$fe),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,g.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const g=await new Promise((p,v)=>{K(["native-keymap"],p,v)});this.c=u(g),n.$t||g.onDidChangeKeyboardLayout(()=>{this.c=u(g),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$udc=E,e.$udc=E=Ee([ie(0,j.$Xcc)],E);function u(c){const g=c.getKeyMap(),p=c.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:p}}}),define(se[289],re([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0,e.$3r=w;let d=class extends p.$Sp{constructor(f,h,S,a){super(a),this.m=f,this.n=h,this.r=S,this.s(),this.B(f.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const f=this.m.getValue("http");this.f=f?.proxy,this.g=!!f?.proxyStrictSSL,this.h=f?.proxyAuthorization}async request(f,h){const{f:S,g:a}=this;let t;try{t=await(0,c.$Im)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(i)))}const r={...process.env,...t},s=f.agent?f.agent:await(0,v.$1r)(f.url||"",r,{proxyUrl:S,strictSSL:a});return f.agent=s,f.strictSSL=a,this.h&&(f.headers={...f.headers||{},"Proxy-Authorization":this.h}),this.c(f.isChromiumNetwork?"electron":"node",f,()=>w(f,h))}async resolveProxy(f){}async loadCertificates(){return(await new Promise((h,S)=>{K(["@vscode/proxy-agent"],h,S)})).loadSystemCertificates({log:this.r})}};e.$2r=d,e.$2r=d=Ee([ie(0,E.$5i),ie(1,u.$Gi),ie(2,g.$5j),ie(3,g.$6j)],d);async function y(b){return((0,n.parse)(b.url).protocol==="https:"?await new Promise((S,a)=>{K(["https"],S,a)}):await new Promise((S,a)=>{K(["http"],S,a)})).request}async function w(b,f){return C.Promises.withAsyncBody(async(h,S)=>{const a=(0,n.parse)(b.url),t=b.getRawRequest?b.getRawRequest(b):await y(b),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:b.type||"GET",headers:b.headers,agent:b.agent,rejectUnauthorized:(0,j.$eg)(b.strictSSL)?b.strictSSL:!0};b.user&&b.password&&(r.auth=b.user+":"+b.password);const s=t(r,i=>{const o=(0,j.$cg)(b.followRedirects)?b.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)w({...b,url:i.headers.location,followRedirects:o-1},f).then(h,S);else{let l=i;!b.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,m.createGunzip)())),h({res:i,stream:(0,k.$We)(l)})}});s.on("error",S),b.timeout&&s.setTimeout(b.timeout),b.isChromiumNetwork&&s.removeHeader("Content-Length"),b.data&&typeof b.data=="string"&&s.write(b.data),s.end(),f.onCancellationRequested(()=>{s.abort(),S(new R.$5)})})}}),define(se[290],re([0,1,14,289]),function(K,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;function k(j){return n.net.request}class R extends C.$2r{request(E,u){return super.request({...E||{},getRawRequest:k,isChromiumNetwork:!0},u)}}e.$wec=R}),define(se[84],re([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=e.$6cc=e.$5cc=e.$4cc=void 0,e.$4cc=(0,E.$yi)("storageMainService");let w=class extends k.$Uc{constructor(h,S,a,t,r,s){super(),this.c=h,this.f=S,this.g=a,this.h=t,this.j=r,this.m=s,this.a=void 0,this.b=this.B(new C.$fe),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.t)h.join("profileStorage",S.close());for(const[,S]of this.w)h.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const S=this.t.get(h.profile.id);S&&h.join(S.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new p.$1cc(this.n(),this.g,this.c,this.j);return this.B(C.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,g.$8p)(h))return this.applicationStorage;let S=this.t.get(h.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),S=this.B(this.u(h)),this.t.set(h.id,S);const a=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:h})));this.B(C.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),a.dispose()}))}return S}u(h){return this.a===2?new p.$3cc(this.c,this.j):new p.$Zcc(h,this.n(),this.c,this.j)}workspaceStorage(h){let S=this.w.get(h.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),S=this.B(this.y(h)),this.w.set(h.id,S),this.B(C.Event.once(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),S}y(h){return this.a===2?new p.$3cc(this.c,this.j):new p.$2cc(h,this.n(),this.c,this.f,this.j)}isUsed(h){const S=n.URI.file(h);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),S))return!0;return!1}};e.$5cc=w,e.$5cc=w=Ee([ie(0,c.$5j),ie(1,R.$Fi),ie(2,m.$Hcc),ie(3,u.$Xcc),ie(4,j.$5k),ie(5,d.$Cl)],w),e.$6cc=(0,E.$yi)("applicationStorageMainService");let b=class extends g.$7p{constructor(h,S){super(),this.s=h,this.U=S,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$7cc=b,e.$7cc=b=Ee([ie(0,v.$El),ie(1,e.$4cc)],b)}),define(se[291],re([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=e.$tec=e.$sec=void 0;async function b(t,r,s,i,o){let l;for(let $=3;$&&(l?.dispose(),l=await new f(t,r,s,i,o).waitForReady(),!(o&&k.$Xg[o]||!k.$Xg[l.tunnelLocalPort]));$--);return l}class f extends E.$Uc{constructor(r,s,i,o,l){super(),this.m=s,this.n=l,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=n.createServer(),this.c=new j.$xh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=$=>this.r($),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,y.$uw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,k.$Yg)(r,2,1e3,s),o=null;return this.b.listen(i,this.m),await this.c.wait(),o=this.b.address(),o||(i=0,this.b.listen(i,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(r){r.pause();const s=(0,y.$sw)(this.tunnelRemoteHost)||(0,y.$uw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$Ul)(this.a,s,this.tunnelRemotePort),o=i.getSocket(),l=i.readEntireBuffer();i.dispose(),l.byteLength>0&&r.write(l.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),o.end()}),r.on("close",()=>o.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),o instanceof R.$ni?o.socket.destroy():o.end()}),o instanceof R.$ni?this.t(r,o):this.s(r,o),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),o.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(w.$He.wrap(i))),r.resume()}t(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$sec=f;let h=class extends y.$xw{constructor(r,s,i,o,l){super(s,l),this.v=r,this.w=i,this.y=o}isPortPrivileged(r){return(0,y.$vw)(r,this.m,u.OS,C.release())}t(r,s,i,o,l,$,P,D){const I=this.s(s,i);if(I)return++I.refcount,I.value;if((0,y.$ow)(r))return this.u(r,s,i,l,$,P,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${l}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=b(O,o,s,i,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,i,M),M}}};e.$tec=h,e.$tec=h=Ee([ie(0,m.$Ol),ie(1,g.$5j),ie(2,d.$Rl),ie(3,p.$lk),ie(4,c.$5i)],h);let S=class extends h{constructor(r,s,i,o,l){super(r,s,i,o,l)}};e.$uec=S,e.$uec=S=Ee([ie(0,m.$Ol),ie(1,g.$5j),ie(2,d.$Rl),ie(3,p.$lk),ie(4,c.$5i)],S);let a=class extends E.$Uc{constructor(r,s,i,o,l){super(),this.b=r,this.c=s,this.f=i,this.g=o,this.h=l,this.a=new Map}async openTunnel(r,s,i,o,l,$,P,D,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${o} on local port ${$}.`),!this.a.has(r)){const O=new S(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(r,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,i,o,l,$,P,D,I)}};e.$vec=a,e.$vec=a=Ee([ie(0,m.$Ol),ie(1,g.$5j),ie(2,p.$lk),ie(3,d.$Rl),ie(4,c.$5i)],a)}),define(se[101],re([0,1,8,23,3,18,24,20,5,27,53,50]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdc=void 0,e.$Qdc=v;function v(d,y,w){return`${w.updateUrl}/api/update/${d}/${y}/${w.commit}`}let m=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,w,b,f,h,S){this.f=y,this.g=w,this.h=b,this.i=f,this.j=h,this.k=S,this.b=p.$gX.Uninitialized,this.c=new k.$fe,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(p.$gX.Disabled(0));return}if(this.h.disableUpdates){this.d(p.$gX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(p.$gX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),w=this.m(y);if(!w){this.d(p.$gX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(w),!this.a){this.d(p.$gX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const b=new URL(this.a);b.searchParams.set("prss","true"),this.a=b.toString()}if(this.d(p.$gX.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,b=>this.j.error(b))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,n.$zh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(w){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(w);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$Rdc=m,e.$Rdc=m=Ee([ie(0,E.$Xcc),ie(1,R.$5i),ie(2,j.$tcc),ie(3,g.$Rp),ie(4,u.$5j),ie(5,c.$lk)],m)}),define(se[292],re([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sdc=void 0;let w=class extends y.$Rdc{get v(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"error",(f,h)=>h)}get w(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return k.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(f,h,S,a)=>({version:S,productVersion:S,timestamp:a}))}constructor(f,h,S,a,t,r,s){super(f,h,a,t,r,s),this.z=S,this.u=new j.$Tc,f.setRelaunchHandler(this)}handleRelaunch(f){return f?.addArgs||f?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(f){this.z.publicLog2("update:error",{messageHash:String((0,R.$mj)(String(f)))}),this.j.error("UpdateService error:",f);const h=this.state.type==="checking for updates"&&this.state.explicit?f:void 0;this.d(d.$gX.Idle(1,h))}s(f){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const S=(0,y.$Qdc)(h,f,this.k);try{n.autoUpdater.setFeedURL({url:S})}catch(a){this.j.error("Failed to set update feed URL",a);return}return S}t(f){this.d(d.$gX.CheckingForUpdates(f)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(d.$gX.Downloading)}F(f){this.state.type==="downloading"&&(this.d(d.$gX.Downloaded(f)),this.z.publicLog2("update:downloaded",{version:f.version}),this.d(d.$gX.Ready(f)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(d.$gX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Sdc=w,Ee([C.$3h],w.prototype,"v",null),Ee([C.$3h],w.prototype,"w",null),Ee([C.$3h],w.prototype,"x",null),Ee([C.$3h],w.prototype,"y",null),e.$Sdc=w=Ee([ie(0,c.$Xcc),ie(1,E.$5i),ie(2,m.$4l),ie(3,u.$tcc),ie(4,v.$Rp),ie(5,g.$5j),ie(6,p.$lk)],w)}),define(se[293],re([0,1,49,43,8,3,9,24,20,5,28,50]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Udc=void 0;let v=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,w,b){if(this.f=y,this.g=b,this.a=p.$gX.Uninitialized,this.b=new R.$fe,this.onStateChange=this.b.event,w.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(p.$gX.Idle(this.k())),this.h(30*1e3).then(void 0,f=>this.g.error(f))}h(y=60*60*1e3){return(0,k.$zh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};v=Ee([ie(0,u.$Xcc),ie(1,E.$tcc),ie(2,c.$5j)],v);let m=class extends v{constructor(y,w,b,f,h,S){super(b,f,h),this.o=y,this.p=w,this.q=S;const a=(0,C.watch)(j.$mc(this.o)),t=R.Event.fromNodeEventEmitter(a,"change",(o,l)=>l),r=R.Event.filter(t,o=>o==="current"),i=R.Event.debounce(r,(o,l)=>l,2e3)(()=>this.checkForUpdates(!1));b.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(p.$gX.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(p.$gX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$gX.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(p.$gX.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+j.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise((b,f)=>(0,C.realpath)(`${j.$mc(this.o)}/current`,(h,S)=>h?f(h):b(S))),w=j.$nc(y);return this.p!==w}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Udc=m,e.$Udc=m=Ee([ie(2,u.$Xcc),ie(3,E.$tcc),ie(4,c.$5j),ie(5,g.$4l)],m)}),define(se[29],re([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(K,e,n,C,k,R,j,E,u,c,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$Ecc=void 0,e.$Fcc=d,e.$Gcc=y,e.$Ecc=(0,k.$yi)("windowsMainService");var m;(function(b){b[b.CLI=0]="CLI",b[b.DOCK=1]="DOCK",b[b.MENU=2]="MENU",b[b.DIALOG=3]="DIALOG",b[b.DESKTOP=4]="DESKTOP",b[b.API=5]="API"})(m||(e.OpenContext=m={}));function d(b,f,h){const S=b.get(E.$Ccc),a=b.get(u.$lk),t=b.get(c.$5i),r=b.get(g.$tcc),s=t.getValue("window"),i={backgroundColor:S.getBackgroundColor(),minWidth:j.$ED.WIDTH,minHeight:j.$ED.HEIGHT,title:a.nameLong,show:f.mode!==0&&f.mode!==3,x:f.x,y:f.y,width:f.width,height:f.height,webPreferences:{...h,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,j.$QD)(f.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(C.$k?i.icon=(0,p.$jc)(r.appRoot,"resources/linux/code.png"):C.$i&&!r.isBuilt&&(i.icon=(0,p.$jc)(r.appRoot,"resources/win32/code_150x150.png")),C.$j&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),C.$j&&!(0,j.$PD)(t)&&(i.fullscreenable=!1),C.$j&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,j.$LD)(t)&&(i.titleBarStyle="hidden",C.$j||(i.frame=!1),(0,j.$OD)(t))){const $=S.getWindowSplash()?.colorInfo.titleBarBackground??S.getBackgroundColor(),P=v.$0t.fromHex($).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:$,symbolColor:P}}return i}function y(b){let f,h=Number.MIN_VALUE;for(const S of b)S.lastFocusTime>h&&(h=S.lastFocusTime,f=S);return f}var w;(function(b){function f(S,a,t=n.screen.getAllDisplays()){if(S.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){S.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){S.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=h(t[0]);if(S.trace("window#validateWindowState: single monitor working area",i),i){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};o(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),o()}return a}if(a.display&&a.mode===3){const i=t.find(o=>o.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){S.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,R.$rcc)(3);return o.x=i.bounds.x,o.y=i.bounds.y,o}}let r,s;try{r=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=h(r),S.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){S.error("window#validateWindowState: error finding display for window state",i)}if(r&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;S.trace("window#validateWindowState: state is outside of the multi-monitor working area")}b.validateWindowState=f;function h(S){if(S.workArea.width>0&&S.workArea.height>0)return S.workArea;if(S.bounds.width>0&&S.bounds.height>0)return S.bounds}})(w||(e.WindowStateValidator=w={}))}),define(se[294],re([0,1,14,23,3,46,2,33,120,5,84,29]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8cc=void 0;var v;(function(d){d[d.Initial=1]="Initial",d[d.StoredCredentialsUsed=2]="StoredCredentialsUsed",d[d.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let m=class extends j.$Uc{constructor(y,w,b,f){super(),this.g=y,this.h=w,this.j=b,this.m=f,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const y=k.Event.fromNodeEventEmitter(n.app,"login",(w,b,f,h,S)=>({event:w,webContents:b,req:f,authInfo:h,callback:S}));this.B(y(this.r,this))}async r({event:y,authInfo:w,req:b,callback:f}){if(!w.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&b.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(w);try{h=await this.b}finally{this.b=void 0}}f(h?.username,h?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const w=await this.t(y);if(w)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),w;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const w=String((0,R.$mj)({scheme:y.scheme,host:y.host,port:y.port}));let b,f;try{const t=this.m.get(this.a+w,-1);if(t){const r=JSON.parse(await this.j.decrypt(t));b=r.username,f=r.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof b=="string"&&typeof f=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:b,password:f};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const S={authInfo:y,username:this.f?.username??b,password:this.f?.password??f,replyChannel:`vscode:proxyAuthResponse:${(0,E.$Ug)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,S),this.c=v.LoginDialogShown;const a=await new Promise(t=>{const r=async(s,i,o)=>{if(i===S.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",r),o){const l={username:o.username,password:o.password};try{if(o.remember){const $=await this.j.encrypt(JSON.stringify(l));this.m.store(this.a+w,$,-1,1)}else this.m.remove(this.a+w,-1)}catch($){this.g.error($)}t({username:l.username,password:l.password})}else t(void 0)};h.win?.webContents.on("ipc-message",r)});return this.f=a,a}};e.$8cc=m,e.$8cc=m=Ee([ie(0,c.$5j),ie(1,p.$Ecc),ie(2,u.$4W),ie(3,g.$6cc)],m)}),define(se[295],re([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(K,e,n,C,k,R,j,E,u,c,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xdc=e.$wdc=e.ID=void 0,e.ID="launchMainService",e.$wdc=(0,c.$yi)(e.ID);let m=class{constructor(y,w,b,f){this.a=y,this.b=w,this.c=b,this.d=f}async start(y,w){this.a.trace("Received data from other instance: ",y,w),k.$j&&n.app.focus({steal:!0});const b=this.e(y);if(b.length){let f=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,C.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(f=h.ready())}f.then(()=>{for(const{uri:h,originalUrl:S}of b)this.c.open(h,{originalUrl:S})})}else return this.f(y,w)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,C.$Hb)(y._urls.map(w=>{try{return{uri:R.URI.parse(w),originalUrl:w}}catch{return null}})):[]}async f(y,w){const b=(0,u.$Cm)(w)?0:4;let f=[];const h=y.wait&&y.waitMarkerFilePath?R.URI.file(y.waitMarkerFilePath):void 0,S=y.remote||void 0,a={context:b,cli:y,userEnv:y["preserve-env"]||b===0?w:void 0,waitMarkerFileURI:h,remoteAuthority:S,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!k.$j}if(t)f=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,a),f=[r]):f=await this.b.open({...a,forceEmpty:!0})}}else f=await this.b.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(h&&f.length===1&&f[0])return Promise.race([f[0].whenClosedOrLoaded,(0,j.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$xdc=m,e.$xdc=m=Ee([ie(0,g.$5j),ie(1,v.$Ecc),ie(2,p.$0W),ie(3,E.$5i)],m)}),define(se[296],re([0,1,2,20,57,30,8,29]),function(K,e,n,C,k,R,j,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=void 0;let u=class extends n.$Uc{constructor(g,p,v){super(),this.a=p,this.b=v,this.B(g.onWillLoadWindow(m=>{m.reason===2&&this.c(m.window)})),this.B(g.onBeforeCloseWindow(m=>this.c(m))),this.B(new j.$Kh(()=>this.g(),30*1e3)).schedule()}async c(g){const p=this.f(g),v=this.a.getProfileForWorkspace(p);v?.isTransient&&(this.a.unsetWorkspace(p,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(g){return g.openedWorkspace??(0,R.$Mi)(g.backupPath,g.isExtensionDevelopmentHost)}g(){const g=this.a.getAssociatedEmptyWindows();if(g.length===0)return;const p=this.b.getWindows().map(v=>this.f(v));for(const v of g)p.some(m=>m.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$aec=u,e.$aec=u=Ee([ie(0,C.$Xcc),ie(1,k.$Hcc),ie(2,E.$Ecc)],u)}),define(se[61],re([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=e.$$cc=void 0;function f(a){return typeof a.responseWindowId=="number"}let h=class extends C.$Uc{static{b=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from(b.b.values())}constructor(t,r,s){super(),this.w=t,this.y=r,this.z=s,this.c=String(++b.a),this.f=this.B(new k.$fe),this.onStdout=this.f.event,this.g=this.B(new k.$fe),this.onStderr=this.g.event,this.h=this.B(new k.$fe),this.onMessage=this.h.event,this.j=this.B(new k.$fe),this.onSpawn=this.j.event,this.m=this.B(new k.$fe),this.onExit=this.m.event,this.n=this.B(new k.$fe),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0,this.u=!1}C(t,r){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,r){case g.default.Error:this.w.error(s);break;case g.default.Warning:this.w.warn(s);break;case g.default.Info:this.w.trace(s);break}}D(){return this.r?(this.C("Cannot start utility process because it is already running...",g.default.Error),!1):!0}start(t){const r=this.F(t);return r&&t.payload&&this.postMessage(t.payload)&&this.C("payload sent via postMessage()",g.default.Info),r}F(t){if(!this.D())return!1;this.t=t;const r=`${this.t.type}-${this.c}`,s=u.$Sg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],o=this.t.execArgv??[],l=this.t.allowLoadingUnsignedLibraries,$=this.t.forceAllocationsToV8Sandbox,P="pipe",D=this.G(t);return this.C("creating new...",g.default.Info),this.r=n.utilityProcess.fork(s,i,{serviceName:r,env:D,execArgv:o,allowLoadingUnsignedLibraries:l,forceAllocationsToV8Sandbox:$,stdio:P}),this.H(this.r,this.t,r),!0}G(t){const r=t.env?{...t.env}:{...(0,d.$5n)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.$i&&((0,w.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,w.getUNCHostAllowlist)().join("\\")),(0,m.$pm)(r);for(const s of Object.keys(r))r[s]=String(r[s]);return r}H(t,r,s){if(t.stdout){const i=new j.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:i.write(o))))}if(t.stderr){const i=new j.StringDecoder("utf-8");this.B(k.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:i.write(o))))}this.B(k.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(k.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&b.b.set(t.pid,{pid:t.pid,name:f(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.C("successfully created",g.default.Info),this.j.fire(t.pid)})),this.B(k.Event.fromNodeEventEmitter(t,"exit")(i=>{const o=this.I(i)?0:i;this.C(`received exit event with code ${o}`,g.default.Info),this.m.fire({pid:this.s,code:o,signal:"unknown"}),this.J()})),this.B(k.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,o)=>({event:i,details:o}))(({details:i})=>{i.type==="Utility"&&i.name===s&&!this.I(i.exitCode)&&(this.C(`crashed with code ${i.exitCode} and reason '${i.reason}'`,g.default.Error),this.y.publicLog2("utilityprocesscrash",{type:r.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.J())}))}once(t,r){const s=this.B(this.h.event(i=>{i===t&&(s.dispose(),r())}))}postMessage(t,r){return this.r?(this.r.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),r}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.C("enabling inspect port",g.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.C("attempting to kill the process...",g.default.Info),this.r.kill()?(this.C("successfully killed the process",g.default.Info),this.u=!0,this.J()):this.C("unable to kill the process",g.default.Warning)}I(t){return t===0?!0:this.u&&t===15}J(){typeof this.s=="number"&&b.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.C("waiting to exit...",g.default.Info),await Promise.race([k.Event.toPromise(this.onExit),(0,E.$zh)(t)]),this.r&&(this.C(`did not exit within ${t}ms, will kill it now...`,g.default.Info),this.kill()))}};e.$$cc=h,e.$$cc=h=b=Ee([ie(0,R.$5j),ie(1,p.$4l),ie(2,v.$Xcc)],h);let S=class extends h{constructor(t,r,s,i){super(t,s,i),this.L=r}start(t){const r=this.L.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.C("Refusing to start utility process because requesting window cannot be found or is destroyed...",g.default.Error),!0;if(!super.F(t))return!1;this.M(r.win,t);const i=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}M(t,r){r.windowLifecycleBound&&(this.B(k.Event.filter(this.z.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(k.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$_cc=S,e.$_cc=S=Ee([ie(0,R.$5j),ie(1,c.$Ecc),ie(2,p.$4l),ie(3,v.$Xcc)],S)}),define(se[297],re([0,1,15,3,5,20,8,61,29,28]),function(K,e,n,C,k,R,j,E,u,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;let p=class{static{g=this}static{this.a=0}constructor(m,d,y,w){this.d=m,this.f=d,this.g=y,this.h=w,this.b=new Map,this.c=!1,this.f.onWillShutdown(b=>{this.c=!0,b.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(m){const d=this.b.get(m);if(!d)throw new Error("Unknown extension host!");return d}onDynamicStdout(m){return this.i(m).onStdout}onDynamicStderr(m){return this.i(m).onStderr}onDynamicMessage(m){return this.i(m).onMessage}onDynamicExit(m){return this.i(m).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const m=String(++g.a),d=new E.$_cc(this.d,this.g,this.h,this.f);return this.b.set(m,d),d.onExit(({pid:y,code:w,signal:b})=>{this.d.info(`Extension host with pid ${y} exited with code: ${w}, signal: ${b}.`),setTimeout(()=>{d.dispose(),this.b.delete(m)}),setTimeout(()=>{try{process.kill(y,0),this.d.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:m}}async start(m,d){if(this.c)throw(0,n.$6)();const y=this.i(m);return y.start({...d,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:d.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m}),{pid:await C.Event.toPromise(y.onSpawn)}}async enableInspectPort(m){if(this.c)throw(0,n.$6)();const d=this.b.get(m);return d?d.enableInspectPort():!1}async kill(m){if(this.c)throw(0,n.$6)();const d=this.b.get(m);d&&d.kill()}async _killAllNow(){for(const[,m]of this.b)m.kill()}async _waitForAllExit(m){const d=[];for(const[,y]of this.b)d.push(y.waitForExit(m));return j.Promises.settled(d).then(()=>{})}};e.$gdc=p,e.$gdc=p=g=Ee([ie(0,k.$5j),ie(1,R.$Xcc),ie(2,u.$Ecc),ie(3,c.$4l)],p)}),define(se[298],re([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kdc=void 0;let w=class extends k.$Uc{constructor(f,h,S,a,t,r,s,i){super(),this.f=f,this.g=h,this.h=S,this.j=a,this.m=t,this.n=r,this.r=s,this.s=i,this.a=new C.$xh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$iW.on(y.$Idc.request,(f,h)=>this.u(f,h,y.$Idc.response)),n.$iW.on(y.$Jdc.request,(f,h)=>this.u(f,h,y.$Jdc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(f,h,S){this.n.trace(`[SharedProcess] onWindowConnection for: ${S}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(S);if(f.sender.isDestroyed())return a.close();f.sender.postMessage(S,h,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(y.$Hdc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const f=new C.$Vh;this.b?.once(y.$Hdc.initDone,()=>f.complete()),await f.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const f=new C.$Vh;this.b?.once(y.$Hdc.ipcReady,()=>f.complete()),await f.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new p.$$cc(this.n,v.$lp,this.m)),this.c=this.b.onMessage(S=>{typeof S.warning=="string"?this.n.warn(S.warning):typeof S.error=="string"&&this.n.error(S.error)});const f=(0,m.$an)(this.h.args,this.h.isBuilt);let h;f.port&&(h=["--nolazy"],f.break?h.push(`--inspect-brk=${f.port}`):h.push(`--inspect=${f.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:h})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(f){return await this.C,(0,d.$jg)(this.b).connect(f)}};e.$Kdc=w,e.$Kdc=w=Ee([ie(2,R.$tcc),ie(3,u.$El),ie(4,j.$Xcc),ie(5,E.$5j),ie(6,g.$Scc),ie(7,c.$ho)],w)}),define(se[299],re([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kec=void 0;let y=class extends g.$Uc{constructor(b,f,h,S,a){super(),this.f=b,this.g=f,this.h=h,this.j=S,this.m=a,this.a=void 0,this.b=new p.$fe,this.onRequestConnection=this.b.event,this.c=new p.$fe,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),c.$iW.on("vscode:createPtyHostMessageChannel",(t,r)=>this.r(t,r)),this.B((0,g.$Sc)(()=>{c.$iW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new E.$$cc(this.m,j.$lp,this.j);const b=(0,C.$_m)(this.h.args,this.h.isBuilt),f=b.port?["--nolazy",`--inspect${b.break?"-brk":""}=${b.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:f,args:["--logsPath",this.h.logsHome.with({scheme:d.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),S=new u.$qW(h,"ptyHost"),a=new g.$Tc;return a.add(S),a.add((0,g.$Sc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:S,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const b={...(0,v.$5n)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},f=this.g.getValue("terminal.integrated.developer.ptyHost.latency");f&&typeof f=="number"&&(b.VSCODE_LATENCY=String(f));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&(b.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),b}r(b,f){this.b.fire();const h=this.a.connect();if(b.sender.isDestroyed()){h.close();return}b.sender.postMessage("vscode:createPtyHostMessageChannelResult",f,[h])}};e.$kec=y,e.$kec=y=Ee([ie(1,m.$5i),ie(2,n.$tcc),ie(3,k.$Xcc),ie(4,R.$5j)],y)}),define(se[300],re([0,1,2,6,5,29,61,28,46,3,8,20]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jec=e.$iec=void 0,e.$iec=(0,C.$yi)("utilityProcessWorker");let v=class extends n.$Uc{constructor(y,w,b,f){super(),this.b=y,this.c=w,this.f=b,this.g=f,this.a=new Map}async createWorker(y){const w=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${w})`);const b=this.h(y);this.a.has(b)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${w})`),this.disposeWorker(y));const f=new m(this.b,this.c,this.f,this.g,y);if(!f.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(b,f);const h=new g.$Vh;return c.Event.once(f.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(b),h.complete({reason:S})}),h.p}h(y){return(0,u.$mj)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const w=this.h(y),b=this.a.get(w);b&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),b.kill(),this.a.delete(w))}};e.$jec=v,e.$jec=v=Ee([ie(0,k.$5j),ie(1,R.$Ecc),ie(2,E.$4l),ie(3,p.$Xcc)],v);let m=class extends n.$Uc{constructor(y,w,b,f,h){super(),this.c=y,this.f=w,this.g=b,this.h=f,this.j=h,this.a=this.B(new c.$fe),this.onDidTerminate=this.a.event,this.b=new j.$_cc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const w=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:w,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};m=Ee([ie(0,k.$5j),ie(1,R.$Ecc),ie(2,E.$4l),ie(3,p.$Xcc)],m)}),define(se[301],re([0,1,14,3,2,277,29]),function(K,e,n,C,k,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3dc=void 0;let E=class extends k.$Uc{constructor(c){super(),this.b=c,this.a=this.B(new C.$fe),this.onFoundInFrame=this.a.event,this.B(new R.$2dc)}async setIgnoreMenuShortcuts(c,g){let p;if(typeof c.windowId=="number"){const{windowId:v}=c,m=this.b.getWindowById(v);if(!m?.win)throw new Error(`Invalid windowId: ${v}`);p=m.win.webContents}else{const{webContentsId:v}=c;if(p=n.webContents.fromId(v),!p)throw new Error(`Invalid webContentsId: ${v}`)}p.isDestroyed()||p.setIgnoreMenuShortcuts(g)}async findInFrame(c,g,p,v){const d=this.c(c,g);if(typeof d.findInFrame=="function"){d.findInFrame(p,{findNext:v.findNext,forward:v.forward});const y=(w,b)=>{b.finalUpdate&&(this.a.fire(b),d.removeListener("found-in-frame",y))};d.on("found-in-frame",y)}}async stopFindInFrame(c,g,p){const m=this.c(c,g);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(p.keepSelection?"keepSelection":"clearSelection")}c(c,g){const p=this.b.getWindowById(c.windowId);if(!p?.win)throw new Error(`Invalid windowId: ${c}`);const v=p.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===g);if(!v)throw new Error(`Unknown frame: ${g}`);return v}};e.$3dc=E,e.$3dc=E=Ee([ie(0,j.$Ecc)],E)}),define(se[302],re([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$4dc=void 0,e.$5dc=w,e.$6dc=f;let y=class extends C.$Uc{static{d=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,r,s,i){super(),this.g=a,this.h=t,this.j=r,this.m=s,this.n=i,this.b=w(this.h.getItem(d.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const r=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.w(r),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?k.$j&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.w(i);return o.uiState.mode===3&&(a.has(o.uiState.display)?k.$j&&o.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const s=f(t);this.h.setItem(d.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(r=>{const s=(0,m.$Ni)(a.openedWorkspace)&&r.workspace?.id===a.openedWorkspace.id,i=(0,m.$Ii)(a.openedWorkspace)&&r.folderUri&&R.$3g.isEqual(r.folderUri,a.openedWorkspace.uri);(s||i)&&(r.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,m.$Ni)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,m.$Ii)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),r=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||r?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const $=a.workspace;if((0,m.$Ni)($)){const D=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===$.id).map(I=>I.uiState);if(D.length)return D[0]}if((0,m.$Ii)($)){const D=this.state.openedWindows.filter(I=>I.folderUri&&R.$3g.isEqual(I.folderUri,$.uri)).map(I=>I.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(I=>I.backupPath===a.backupPath).map(I=>I.uiState);if(D.length)return D[0]}const P=this.c||this.state.lastActiveWindow;if(!t&&P)return P.uiState}let r;const s=n.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(k.$j){const $=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint($)}!r&&t&&(r=n.screen.getDisplayMatching(t.getBounds())),r||(r=n.screen.getPrimaryDisplay()||s[0])}let i=(0,v.$rcc)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const o=this.n.getValue("window");let l=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,l=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,l=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const $=t.serializeWindowState();$.mode===3?i.mode=3:i={...$,zoomLevel:void 0},l=i.mode!==3&&o.newWindowDimensions==="offset"}}return l&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===a.x||r.y===a.y);)a.x+=30,a.y+=30;return a}};e.$4dc=y,e.$4dc=y=d=Ee([ie(0,p.$Ecc),ie(1,g.$6P),ie(2,u.$Xcc),ie(3,c.$5j),ie(4,E.$5i)],y);function w(S){const a={openedWindows:[]},t=S||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=b(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=b(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(r=>b(r))),a}function b(S){const a={uiState:S.uiState};return S.backupPath&&(a.backupPath=S.backupPath),S.remoteAuthority&&(a.remoteAuthority=S.remoteAuthority),S.folder&&(a.folderUri=j.URI.parse(S.folder)),S.workspaceIdentifier&&(a.workspace={id:S.workspaceIdentifier.id,configPath:j.URI.parse(S.workspaceIdentifier.configURIPath)}),a}function f(S){return{lastActiveWindow:S.lastActiveWindow&&h(S.lastActiveWindow),lastPluginDevelopmentHostWindow:S.lastPluginDevelopmentHostWindow&&h(S.lastPluginDevelopmentHostWindow),openedWindows:S.openedWindows.map(a=>h(a))}}function h(S){return{workspaceIdentifier:S.workspace&&{id:S.workspace.id,configURIPath:S.workspace.configPath.toString()},folder:S.folderUri&&S.folderUri.toString(),backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.uiState}}}),define(se[58],re([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=e.$Qcc=void 0,e.$Qcc=(0,d.$yi)("workspacesManagementMainService");let a=class extends R.$Uc{constructor(r,s,i,o,l){super(),this.g=r,this.h=s,this.j=i,this.m=o,this.n=l,this.a=this.B(new C.$fe),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$fe),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await c.Promises.readdir(this.c.with({scheme:j.Schemas.file}).fsPath)).map(s=>(0,u.$_g)(this.c,s,f.$Xi));for(const s of r){const i=(0,S.$Ncc)(s),o=await this.resolveLocalWorkspace(s);o?this.f.push({workspace:i,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.r(r,s=>c.Promises.readFile(s,"utf8"))}r(r,s){if(this.s(r)&&r.scheme===j.Schemas.file)try{const i=s(r.fsPath);return i instanceof Promise?i.then(o=>this.t(r,o),o=>{}):this.t(r,i)}catch{return}}s(r){return(0,f.$Yi)(r,this.g)||(0,f.$4i)(r)}t(r,s){try{const i=this.u(r,s),o=(0,S.$Ncc)(r);return{id:o.id,configPath:o.configPath,folders:(0,h.$6fb)(i.folders,o.configPath,u.$3g),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(r,s){const i=(0,k.$Ln)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(o=>(0,h.$4fb)(o));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(r,s){const{workspace:i,storedWorkspace:o}=this.w(r,s),l=i.configPath.fsPath;return await c.Promises.mkdir((0,E.$mc)(l),{recursive:!0}),await c.Promises.writeFile(l,JSON.stringify(o,null,"	")),this.f.push({workspace:i,remoteAuthority:s}),i}w(r=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,u.$_g)(this.c,i),l=(0,u.$_g)(o,f.$Xi),$=[];for(const P of r)$.push((0,h.$5fb)(P.uri,!0,P.name,o,u.$3g));return{workspace:(0,S.$Ncc)(l),storedWorkspace:{folders:$,remoteAuthority:s}}}async getWorkspaceIdentifier(r){return(0,S.$Ncc)(r)}isUntitledWorkspace(r){return(0,f.$Yi)(r.configPath,this.g)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.y(r),this.j.isEnabled()&&this.j.unsetWorkspace(r),this.a.fire(r))}async y(r){const s=(0,u.$Zg)(r.configPath);try{await c.Promises.rm((0,E.$mc)(s));const i=(0,E.$jc)(this.g.workspaceStorageHome.with({scheme:j.Schemas.file}).fsPath,r.id);await c.Promises.exists(i)&&await c.Promises.writeFile((0,E.$jc)(i,"obsolete"),""),this.f=this.f.filter(o=>o.workspace.id!==r.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,s,i){if(!r||!r.win||!r.isReady||!await this.z(r,s,i))return;const l=await this.C(r,(0,S.$Ncc)(i));if(l)return this.b.fire({window:r,workspace:l.workspace}),l}async z(r,s,i){return i?(0,f.$Ni)(r.openedWorkspace)&&u.$3g.isEqual(r.openedWorkspace.configPath,i)?!1:(0,b.$Kcc)(s,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,g.localize)(0,null)],message:(0,g.localize)(1,null,(0,u.$9g)(i)),detail:(0,g.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(r,s){if(!r.config)return;r.focus();let i;return r.config.extensionDevelopmentPath||(r.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority},r.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority})),(0,f.$Ni)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=s,r.config.backupPath=i,{workspace:s,backupPath:i}}};e.$Rcc=a,e.$Rcc=a=Ee([ie(0,m.$tcc),ie(1,y.$5j),ie(2,w.$Hcc),ie(3,p.$ycc),ie(4,v.$zcc)],a)}),define(se[134],re([0,1,14,37,23,6,29,30,58,12,5,61]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=e.$bdc=e.ID=void 0,e.ID="diagnosticsMainService",e.$bdc=(0,R.$yi)(e.ID);let v=class{constructor(d,y,w){this.a=d,this.b=y,this.c=w}async getRemoteDiagnostics(d){const y=this.a.getWindows();return(await Promise.all(y.map(async b=>{const f=b.remoteAuthority;if(!f)return;const h=`vscode:getDiagnosticInfoResponse${b.id}`,S={includeProcesses:d.includeProcesses,folders:d.includeWorkspaceMetadata?await this.f(b):void 0};return new Promise(a=>{b.sendWhenReady("vscode:getDiagnosticInfo",k.CancellationToken.None,{replyChannel:h,args:S}),C.$iW.once(h,(t,r)=>{r||a({hostName:f,errorMessage:`Unable to resolve connection to '${f}'.`}),a(r)}),setTimeout(()=>{a({hostName:f,errorMessage:`Connection to '${f}' could not be established`})},5e3)})}))).filter(b=>!!b)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const d=[];for(const w of n.BrowserWindow.getAllWindows()){const b=this.a.getWindowById(w.id);b?d.push(await this.d(b)):d.push(this.e(w))}const y=[];for(const{pid:w,name:b}of p.$$cc.getAll())y.push({pid:w,name:b});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:d,pidToNames:y,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(d){const y=await this.f(d),w=(0,c.$jg)(d.win);return this.e(w,y,d.remoteAuthority)}e(d,y=[],w){return{id:d.id,pid:d.webContents.getOSProcessId(),title:d.getTitle(),folderURIs:y,remoteAuthority:w}}async f(d){const y=[],w=d.openedWorkspace;if((0,E.$Ii)(w))y.push(w.uri);else if((0,E.$Ni)(w)){const b=await this.b.resolveLocalWorkspace(w.configPath);b&&b.folders.forEach(h=>{y.push(h.uri)})}return y}};e.$cdc=v,e.$cdc=v=Ee([ie(0,j.$Ecc),ie(1,u.$Qcc),ie(2,g.$5j)],v)}),define(se[70],re([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i,o,l,$,P,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=e.$qdc=void 0,e.$qdc=(0,S.$yi)("nativeHostMainService");let M=class extends u.$Uc{constructor(F,T,U,ae,te,ce,J,V,q){super(),this.a=F,this.b=T,this.c=U,this.f=ae,this.g=te,this.h=ce,this.j=J,this.m=V,this.n=q,this.onDidOpenMainWindow=E.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=E.Event.any(E.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:B,y:H})=>({windowId:L.id,x:B,y:H})),E.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:B,y:H})=>({windowId:L.id,x:B,y:H}))),this.onDidMaximizeWindow=E.Event.any(E.Event.map(this.a.onDidMaximizeWindow,L=>L.id),E.Event.map(this.b.onDidMaximizeWindow,L=>L.id)),this.onDidUnmaximizeWindow=E.Event.any(E.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),E.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id)),this.onDidChangeWindowFullScreen=E.Event.any(E.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),E.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,B)=>B.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=E.Event.any(E.Event.map(E.Event.filter(E.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,B)=>B.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=E.Event.any(this.onDidBlurMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,B)=>this.b.getWindowByWebContents(B.webContents)),L=>!!L),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=E.Event.any(this.onDidFocusMainWindow,E.Event.map(E.Event.filter(E.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,B)=>this.b.getWindowByWebContents(B.webContents)),L=>!!L),L=>L.id)),this.onDidResumeOS=E.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new E.$fe),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=E.Event.debounce(E.Event.any(E.Event.filter(E.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(L,B,H)=>H),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),E.Event.fromNodeEventEmitter(C.screen,"display-added"),E.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,T){const U=this.a.getWindows().map(te=>({id:te.id,workspace:te.openedWorkspace??(0,o.$Mi)(te.backupPath,te.isExtensionDevelopmentHost),title:te.win?.getTitle()??"",filename:te.getRepresentedFilename(),dirty:te.isDocumentEdited()})),ae=[];return T.includeAuxiliaryWindows&&ae.push(...this.b.getWindows().map(te=>({id:te.id,parentId:te.parentId,title:te.win?.getTitle()??"",filename:te.getRepresentedFilename()}))),[...U,...ae]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(F,T,U){return Array.isArray(T)?this.s(F,T,U):this.t(F,T)}async s(F,T,U=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:T,cli:this.g.args,forceNewWindow:U.forceNewWindow,forceReuseWindow:U.forceReuseWindow,preferNewWindow:U.preferNewWindow,diffMode:U.diffMode,mergeMode:U.mergeMode,addMode:U.addMode,gotoLineMode:U.gotoLineMode,noRecentEntry:U.noRecentEntry,waitMarkerFileURI:U.waitMarkerFileURI,remoteAuthority:U.remoteAuthority||void 0,forceProfile:U.forceProfile,forceTempProfile:U.forceTempProfile})}async t(F,T){await this.a.openEmptyWindow({context:5,contextWindowId:F},T)}async isFullScreen(F,T){return this.C(T?.targetWindowId,F)?.isFullScreen??!1}async toggleFullScreen(F,T){this.C(T?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,T){this.C(T?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const T=C.screen.getCursorScreenPoint(),U=C.screen.getDisplayNearestPoint(T);return{point:T,display:U.bounds}}async isMaximized(F,T){return this.C(T?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,T){this.C(T?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,T,U){const ae=this.C(U?.targetWindowId,F);if(ae?.win){if(ae.win.isFullScreen()){const te=E.Event.toPromise(E.Event.once(E.Event.fromNodeEventEmitter(ae.win,"leave-full-screen")));ae.win.setFullScreen(!1),await te}ae.win.setBounds(T)}}async updateWindowControls(F,T){this.C(T?.targetWindowId,F)?.updateWindowControls(T)}async focusWindow(F,T){this.C(T?.targetWindowId,F)?.focus({force:T?.force??!1})}async setMinimumSize(F,T,U){const ae=this.D(F);if(ae?.win){const[te,ce]=ae.win.getSize(),[J,V]=ae.win.getMinimumSize(),[q,L]=[T??J,U??V],[B,H]=[Math.max(te,q),Math.max(ce,L)];(J!==q||V!==L)&&ae.win.setMinimumSize(q,L),(te!==B||ce!==H)&&ae.win.setSize(B,H)}}async saveWindowSplash(F,T){this.m.saveWindowSplash(F,T)}async installShellCommand(F){const{source:T,target:U}=await this.u();try{const{symbolicLink:ae}=await y.SymlinkSupport.stat(T);if(ae&&!ae.dangling){const te=await(0,m.$0q)(T);if(U===te)return}await y.Promises.unlink(T)}catch(ae){if(ae.code!=="ENOENT")throw ae}try{await y.Promises.symlink(U,T)}catch(ae){if(ae.code!=="EACCES"&&ae.code!=="ENOENT")throw ae;const{response:te}=await this.showMessageBox(F,{type:"info",message:(0,b.localize)(0,null,this.j.nameShort),buttons:[(0,b.localize)(1,null),(0,b.localize)(2,null)]});if(te===1)throw new O.$5;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${U}' '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ce)}catch{throw new Error((0,b.localize)(3,null,T))}}}async uninstallShellCommand(F){const{source:T}=await this.u();try{await y.Promises.unlink(T)}catch(U){switch(U.code){case"EACCES":{const{response:ae}=await this.showMessageBox(F,{type:"info",message:(0,b.localize)(4,null,this.j.nameShort),buttons:[(0,b.localize)(5,null),(0,b.localize)(6,null)]});if(ae===1)throw new O.$5;try{const te=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(te)}catch{throw new Error((0,b.localize)(7,null,T))}break}case"ENOENT":break;default:throw U}}}async u(){const F=(0,g.$kc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(F))throw new Error((0,b.localize)(8,null,F));return{source:T,target:F}}async showMessageBox(F,T){const U=this.C(T?.targetWindowId,F);return this.c.showMessageBox(T,U?.win??void 0)}async showSaveDialog(F,T){const U=this.C(T?.targetWindowId,F);return this.c.showSaveDialog(T,U?.win??void 0)}async showOpenDialog(F,T){const U=this.C(T?.targetWindowId,F);return this.c.showOpenDialog(T,U?.win??void 0)}async pickFileFolderAndOpen(F,T){const U=await this.c.pickFileFolder(T);U&&await this.w(await Promise.all(U.map(async ae=>await y.SymlinkSupport.existsDirectory(ae)?{folderUri:v.URI.file(ae)}:{fileUri:v.URI.file(ae)})),T,F)}async pickFolderAndOpen(F,T){const U=await this.c.pickFolder(T);U&&await this.w(U.map(ae=>({folderUri:v.URI.file(ae)})),T,F)}async pickFileAndOpen(F,T){const U=await this.c.pickFile(T);U&&await this.w(U.map(ae=>({fileUri:v.URI.file(ae)})),T,F)}async pickWorkspaceAndOpen(F,T){const U=await this.c.pickWorkspace(T);U&&await this.w(U.map(ae=>({workspaceUri:v.URI.file(ae)})),T,F)}async w(F,T,U){await this.a.open({context:3,contextWindowId:U,cli:this.g.args,urisToOpen:F,forceNewWindow:T.forceNewWindow})}async showItemInFolder(F,T){C.shell.showItemInFolder(T)}async setRepresentedFilename(F,T,U){this.C(U?.targetWindowId,F)?.setRepresentedFilename(T)}async setDocumentEdited(F,T,U){this.C(U?.targetWindowId,F)?.setDocumentEdited(T)}async openExternal(F,T){return this.g.unsetSnapExportedVariables(),C.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,T){return C.shell.trashItem(T)}async isAdmin(){let F;return p.$i?F=(await new Promise((T,U)=>{K(["native-is-elevated"],T,U)}))():F=process.getuid?.()===0,F}async writeElevated(F,T,U,ae){const te=await new Promise((ce,J)=>{K(["@vscode/sudo-prompt"],ce,J)});return new Promise((ce,J)=>{const V=[`"${this.z}"`];ae?.unlock&&V.push("--file-chmod"),V.push("--file-write",`"${T.fsPath}"`,`"${U.fsPath}"`);const q={name:this.j.nameLong.replace("-",""),icns:p.$j&&this.g.isBuilt?(0,g.$jc)((0,g.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};te.exec(V.join(" "),q,(L,B,H)=>{B&&this.h.trace(`[sudo-prompt] received stdout: ${B}`),H&&this.h.trace(`[sudo-prompt] received stderr: ${H}`),L?J(L):ce(void 0)})})}async isRunningUnderARM64Translation(){return p.$k||p.$i?!1:C.app.runningUnderARM64Translation}get z(){return p.$i?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.bat"):p.$k?this.g.isBuilt?(0,g.$jc)((0,g.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,g.$jc)(this.g.appRoot,"bin","code"):(0,g.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,k.totalmem)(),freemem:(0,k.freemem)(),loadavg:(0,k.loadavg)()}}async getOSProperties(){return{arch:(0,k.arch)(),platform:(0,k.platform)(),release:(0,k.release)(),type:(0,k.type)(),cpus:(0,k.cpus)()}}async getOSVirtualMachineHint(){return d.$Gn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return p.$i&&(0,P.$ndc)()}async killProcess(F,T,U){process.kill(T,U)}async readClipboardText(F,T){return C.clipboard.readText(T)}async writeClipboardText(F,T,U){return C.clipboard.writeText(T,U)}async readClipboardFindText(F){return C.clipboard.readFindText()}async writeClipboardFindText(F,T){return C.clipboard.writeFindText(T)}async writeClipboardBuffer(F,T,U,ae){return C.clipboard.writeBuffer(T,Buffer.from(U.buffer),ae)}async readClipboardBuffer(F,T){return $.$He.wrap(C.clipboard.readBuffer(T))}async hasClipboard(F,T,U){return C.clipboard.has(T,U)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,T){this.D(F)?.updateTouchBar(T)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,T){return this.f.relaunch(T)}async reload(F,T){const U=this.D(F);if(U){if((0,o.$Ni)(U.openedWorkspace)){const ae=U.openedWorkspace.configPath;if(ae.scheme===c.Schemas.file&&(await this.n.resolveLocalWorkspace(ae))?.transient)return this.openWindow(U.id,{forceReuseWindow:!0})}return this.f.reload(U,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(F,T){return this.C(T?.targetWindowId,F)?.win?.close()}async quit(F){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(F,T){await this.f.kill(T)}async resolveProxy(F,T){return this.D(F)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(F){return(await new Promise((U,ae)=>{K(["@vscode/proxy-agent"],U,ae)})).loadSystemCertificates({log:this.h})}findFreePort(F,T,U,ae,te=1){return(0,w.$Wg)(T,U,ae,te)}async openDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,T,U){const ae=this.D(F);if(!ae||!ae.win)throw new Error;return await new D.$odc(ae.win,T,this.h).inspect(U)}async windowsGetStringRegKey(F,T,U,ae){if(!p.$i)return;const te=await new Promise((ce,J)=>{K(["@vscode/windows-registry"],ce,J)});try{return te.GetStringRegKey(T,U,ae)}catch{return}}C(F,T){return this.D(F)??this.F(F)??this.D(T)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F!="number")return;const T=C.webContents.fromId(F);if(T)return this.b.getWindowByWebContents(T)}};e.$rdc=M,Ee([j.$3h],M.prototype,"z",null),e.$rdc=M=Ee([ie(0,i.$Ecc),ie(1,I.$pdc),ie(2,f.$zcc),ie(3,a.$Xcc),ie(4,h.$tcc),ie(5,t.$5j),ie(6,r.$lk),ie(7,s.$Ccc),ie(8,l.$Qcc)],M)}),define(se[303],re([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;const l="issue.processExplorerWindowState";let $=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,O,M,W,F,T,U,ae,te,ce,J){this.g=I,this.h=O,this.i=M,this.j=W,this.k=F,this.l=T,this.m=U,this.n=ae,this.o=te,this.p=ce,this.q=J,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){p.$iW.on("vscode:listProcesses",async I=>{const O=[];try{O.push({name:(0,v.localize)(0,null),rootProcess:await(0,g.$Hs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$gn)(W)?O.push({name:W.hostName,rootProcess:W}):W.processes&&O.push({name:W.hostName,rootProcess:W.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.t(I,"vscode:listProcessesResponse",O)}),p.$iW.on("vscode:workbenchCommand",(I,O)=>{const{id:M,from:W,args:F}=O;let T;switch(W){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}T?.webContents.send("vscode:runAction",{id:M,from:W,args:F})}),p.$iW.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),p.$iW.on("vscode:pidToNameRequest",async I=>{const O=await this.k.getMainDiagnostics(),M=[];for(const W of O.windows)M.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:F}of r.$$cc.getAll())M.push([W,F]);this.t(I,"vscode:pidToNameResponse",M)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const O=new E.$Tc,M=O.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:h.default}),this.b.loadURL(u.$Sg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const O=new E.$Tc,M=O.add(this.n.createIPCObjectUrl()),W=this.p.getItem(l,void 0),F=P(W)?W:this.v(this.f,800,500);this.d=this.u(F,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:h.default}),this.d.loadURL(u.$Sg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const U=this.d.getSize(),ae=this.d.getPosition();if(!U||!ae)return;const te={width:U[0],height:U[1],x:ae[0],y:ae[1]};this.p.setItem(l,te)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await n.contentTracing.stopRecording(`${(0,j.$Gg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null,I),buttons:[(0,v.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,O)}async $getSystemInfo(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,O)}async $getPerformanceInfo(){try{const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,O)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(6,null),buttons:[(0,v.localize)(7,null),(0,v.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(9,null),buttons:[(0,v.localize)(10,null),(0,v.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $sendReporterMenu(I,O){const M=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",F=new R.$qe;return M.sendWhenReady(W,F.token,{replyChannel:W,extensionId:I,extensionName:O}),await(0,k.$ph)(new Promise(U=>p.$iW.once(`vscode:triggerReporterMenuResponse:${I}`,(ae,te)=>U(te))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),F.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,O,...M){I.sender.isDestroyed()||I.sender.send(O,...M)}u(I,O,M,W){const F=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:M.title,backgroundColor:M.backgroundColor||o.a,webPreferences:{preload:u.$Sg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$QD)(M.zoomLevel),sandbox:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}v(I,O,M){let W;const F=n.screen.getAllDisplays();if(F.length===1)W=F[0];else{if(c.$j){const ae=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(ae)}!W&&I&&(W=n.screen.getDisplayMatching(I.getBounds())),W||(W=n.screen.getPrimaryDisplay()||F[0])}const T=W.bounds,U={width:O,height:M,x:T.x+T.width/2-O/2,y:T.y+T.height/2-M/2};return T.width>0&&T.height>0&&(U.x<T.x&&(U.x=T.x),U.y<T.y&&(U.y=T.y),U.x>T.x+T.width&&(U.x=T.x),U.y>T.y+T.height&&(U.y=T.y),U.width>T.width&&(U.width=T.width),U.height>T.height&&(U.height=T.height)),U}};e.$sdc=$,e.$sdc=$=o=Ee([ie(1,w.$tcc),ie(2,b.$5j),ie(3,m.$fn),ie(4,d.$bdc),ie(5,y.$zcc),ie(6,f.$qdc),ie(7,a.$Bcc),ie(8,S.$lk),ie(9,t.$6P),ie(10,i.$Ecc)],$);function P(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(se[304],re([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(K,e,n,C,k,R,j,E,u,c,g,p,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tdc=void 0;let m=class extends v.$Rdc{constructor(y,w,b,f,h,S,a,t){super(y,w,f,h,S,t),this.e=b,this.u=a}s(y){return(0,v.$Qdc)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(p.$gX.CheckingForUpdates(y)),this.i.request({url:this.a},n.CancellationToken.None).then(c.$Xp).then(w=>{!w||!w.url||!w.version||!w.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(p.$gX.Idle(1))):this.d(p.$gX.AvailableForDownload(w))}).then(void 0,w=>{this.j.error(w);const b=y?w.message||w:void 0;this.d(p.$gX.Idle(1,b))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(p.$gX.Idle(1))}};e.$Tdc=m,e.$Tdc=m=Ee([ie(0,R.$Xcc),ie(1,C.$5i),ie(2,g.$4l),ie(3,k.$tcc),ie(4,c.$Rp),ie(5,j.$5j),ie(6,E.$qdc),ie(7,u.$lk)],m)}),define(se[305],re([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vdc=void 0;async function s($,P=1e3){for(;!$();)await(0,R.$zh)(P)}let i;function o(){return typeof i>"u"&&(i=C.existsSync(c.$jc(c.$mc(process.execPath),"unins000.exe"))?0:1),i}let l=class extends r.$Rdc{get cachePath(){const P=c.$jc((0,k.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(P,{recursive:!0}).then(()=>P)}constructor(P,D,I,O,M,W,F,T,U){super(P,D,O,M,W,U),this.u=I,this.v=F,this.w=T,P.setRelaunchHandler(this)}handleRelaunch(P){return P?.addArgs||P?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$gX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(P){let D=`win32-${process.arch}`;return o()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,r.$Qdc)(D,P,this.k)}t(P){this.a&&(this.d(t.$gX.CheckingForUpdates(P)),this.i.request({url:this.a},j.CancellationToken.None).then(S.$Xp).then(D=>{const I=o();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!P}),this.d(t.$gX.Idle(I)),Promise.resolve(null)):I===1?(this.d(t.$gX.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$gX.Downloading),this.C(D.version).then(()=>this.B(D.version).then(O=>v.Promises.exists(O).then(M=>{if(M)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:D.url},j.CancellationToken.None).then(F=>this.v.writeFile(g.URI.file(W),F.stream)).then(D.sha256hash?()=>(0,p.$bW)(W,D.sha256hash):()=>{}).then(()=>v.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$gX.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$gX.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,u.$mj)(String(D)))}),this.j.error(D);const I=P?D.message||D:void 0;this.d(t.$gX.Idle(o(),I))}))}async o(P){P.update.url&&this.w.openExternal(void 0,P.update.url),this.d(t.$gX.Idle(o()))}async B(P){const D=await this.cachePath;return c.$jc(D,`CodeSetup-${this.k.quality}-${P}.exe`)}async C(P=null){const D=P?W=>!new RegExp(`${this.k.quality}-${P}\\.exe$`).test(W):()=>!0,I=await this.cachePath,M=(await v.Promises.readdir(I)).filter(D).map(async W=>{try{await v.Promises.unlink(c.$jc(I,W))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const P=this.state.update;this.d(t.$gX.Updating(P));const D=await this.cachePath;this.e.updateFilePath=c.$jc(D,`CodeSetup-${this.k.quality}-${P.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$gX.Idle(o()))});const O=`${this.k.win32MutexName}-ready`,M=await new Promise((W,F)=>{K(["@vscode/windows-mutex"],W,F)});s(()=>M.isActive(O)).then(()=>this.d(t.$gX.Ready(P)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(P){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(t.$gX.Downloading),this.e={packagePath:P},this.d(t.$gX.Downloaded(I)),D?this.k.target==="user"&&this.p():this.d(t.$gX.Ready(I))}};e.$Vdc=l,Ee([E.$3h],l.prototype,"cachePath",null),e.$Vdc=l=Ee([ie(0,w.$Xcc),ie(1,m.$5i),ie(2,a.$4l),ie(3,d.$tcc),ie(4,S.$Rp),ie(5,b.$5j),ie(6,y.$5k),ie(7,f.$qdc),ie(8,h.$lk)],l)}),define(se[135],re([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i,o,l,$,P,D,I,O,M,W,F,T,U,ae,te){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=e.$Ucc=void 0;var ce;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(ce||(ce={}));class J extends E.$Uc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(j.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(j.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(j.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(j.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(j.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(j.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const B=!(0,P.$LD)(this.r);if(g.$j&&B&&L.setSheetOffset((0,g.$J)((0,m.release)())?28:22),B&&(g.$i&&(0,P.$OD)(this.r)||g.$j)){const H=this.s.getItem(J.D);H?this.updateWindowControls({height:H}):this.updateWindowControls({height:P.$ND})}g.$i&&B&&L.hookWindowMessage(278,()=>{const[oe,G]=L.getPosition(),le=n.screen.getCursorScreenPoint(),Q=le.x-oe,A=le.y-G;return!(Q>30&&A>=0&&A<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:Q,y:A})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),g.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(L,B,H,oe){super(),this.r=L,this.s=B,this.t=H,this.u=oe,this.a=this.B(new j.$fe),this.onDidClose=this.a.event,this.b=this.B(new j.$fe),this.onDidMaximize=this.b.event,this.c=this.B(new j.$fe),this.onDidUnmaximize=this.c.event,this.f=this.B(new j.$fe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new j.$fe),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new j.$fe),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,P.$OD)(this.r),this.G=void 0,this.H=void 0}w(L,B=n.screen.getAllDisplays().length>0){const H=this.r.getValue("window"),oe=g.$j&&H?.nativeTabs===!0;(g.$j||g.$i)&&B&&(!oe||n.BrowserWindow.getAllWindows().length===1)&&[L.width,L.height,L.x,L.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:L.width,height:L.height,x:L.x,y:L.y}),(L.mode===0||L.mode===3)&&(this.m?.maximize(),L.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(L){g.$j?this.win?.setRepresentedFilename(L):this.z=L}getRepresentedFilename(){return g.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(L){g.$j&&this.win?.setDocumentEdited(L),this.C=L}isDocumentEdited(){return g.$j?!!this.win?.isDocumentEdited():!!this.C}focus(L){g.$j&&L?.force&&n.app.focus({steal:!0});const B=this.win;B&&(B.isMinimized()&&B.restore(),B.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(g.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.D="windowControlHeight"}updateWindowControls(L){const B=this.win;if(B){if(L.height&&this.s.setItem(V.D,L.height),g.$i&&this.F)B.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(g.$j&&L.height!==void 0){const H=(L.height-15)/2;H?B.setWindowButtonPosition({x:H,y:H}):B.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(L,B){(0,P.$PD)(this.r)?this.J(L,B):this.M(L)}get isFullScreen(){if(g.$j&&typeof this.G=="boolean")return this.G;const L=this.win,B=L?.isFullScreen(),H=L?.isSimpleFullScreen();return!!(B||H)}J(L,B){const H=this.win;H?.isSimpleFullScreen()&&H?.setSimpleFullScreen(!1),this.L(L,B)}L(L,B){if(g.$j){this.G=L;const oe=this.H=new C.$Vh;(async()=>{const G=await Promise.race([oe.p,(0,C.$zh)(1e4).then(()=>!1)]);this.H===oe&&(this.G=void 0,this.H=void 0,!G&&L&&B&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}M(L){const B=this.win;B?.isFullScreen()&&this.L(!1,!1),B?.setSimpleFullScreen(L),B?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Ucc=J;let V=class extends J{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const L=this.hb.profiles.find(B=>B.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.hb.getProfileForWorkspace(this.config.workspace??(0,I.$Mi)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(L,B,H,oe,G,le,Q,A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye,Se){super(_,ye,oe,B),this.fb=H,this.gb=G,this.hb=le,this.ib=Q,this.jb=A,this.kb=N,this.lb=z,this.mb=Y,this.nb=x,this.ob=ee,this.pb=X,this.qb=ue,this.rb=he,this.sb=pe,this.tb=$e,this.N=this.B(new j.$fe),this.onWillLoad=this.N.event,this.O=this.B(new j.$fe),this.onDidSignalReady=this.O.event,this.P=this.B(new j.$fe),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[ke,Re]=this.Eb(L.state);this.U=ke,this.u.trace("window#ctor: using window state",ke);const we=Se.invokeFunction(D.$Fcc,this.U,{preload:u.$Sg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,c.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(we),(0,c.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Re),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.X.push(L)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(L=>{function B(){H.dispose(),oe.dispose(),L()}const H=this.onDidClose(()=>B()),oe=this.onWillLoad(()=>B())})}vb(){this.B(j.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(B,H)=>H)(B=>this.yb(2,{...B}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(B,H,oe)=>({exitCode:H,reason:oe}))(({exitCode:B,reason:H})=>this.yb(3,{reason:H,exitCode:B}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(B=>B.preventDefault())),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",k.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",k.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(B=>this.Bb(B))),this.B(this.mb.onDidDeleteUntitledWorkspace(B=>this.Ab(B)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(B,H)=>{const oe=await this.xb();H({cancel:!1,requestHeaders:Object.assign(B.requestHeaders,oe)})})}xb(){return this.wb||(this.wb=(0,s.$_p)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(L,B){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${B?.reason||"<unknown>"}, code: ${B?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:L,reason:B?.reason,code:B?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:oe}=await this.pb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.S?.workspace?(0,v.localize)(5,null):void 0},this.m);if(H!==2){const G=H===0;await this.zb(G,oe)}}else if(L===2){let H;B?H=(0,v.localize)(7,null,B.reason,B.exitCode??"<unknown>"):H=(0,v.localize)(6,null);const{response:oe,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:H,detail:this.S?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.S?.workspace?(0,v.localize)(13,null):void 0},this.m),le=oe===0;await this.zb(le,G)}break}}async zb(L,B){const H=this.S?.workspace;if(B&&H)try{const oe=this.kb.workspaceStorage(H);await oe.init(),oe.delete("memento/workbench.parts.editor"),await oe.close()}catch(oe){this.u.error(oe)}this.P.fire();try{if(L&&this.S){let oe,G;(0,I.$Ii)(H)?oe={folderUri:H.uri}:(0,I.$Ni)(H)?oe={workspaceUri:H.configPath}:G=!0,(0,ae.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:oe?[oe]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(L){this.S?.workspace?.id===L.id&&(this.S.workspace=void 0)}Bb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const B=this.Gb();B!==this.W&&(this.W=B,this.Hb(B))}if(!L||L.affectsConfiguration("http.proxy")){let B=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;B?.endsWith("/")&&(B=B.substr(0,B.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((B||"").indexOf("@")===-1&&(B!==this.Z||H!==this.$)){this.Z=B,this.$=H;const oe=B||"",G=H?`${H},<local>`:"<local>";this.u.trace(`Setting proxy to '${oe}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:oe,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(L){g.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,B=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!B.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),B.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(L,B),this.ub===0?this.S=L:this.db=L,this.ub=1,this.m.loadURL(u.$Sg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new C.$Kh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:L.workspace,reason:B.isReload?3:H?2:1})}Cb(L,B){const H=(this.S??this.db)?.userEnv;if(H){const oe=(0,f.$Cm)(H)&&!(0,f.$Cm)(L.userEnv),G=this.isExtensionDevelopmentHost;(oe||G)&&(L.userEnv={...H,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),B.disableExtensions!==void 0&&(L["disable-extensions"]=B.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.lb.getWindowSplash(),L.zoomLevel=this.Jb(),L.isCustomZoomLevel=typeof this.ab=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,c.mark)("code/willOpenNewWindow"),L.perfMarks=(0,c.getMarks)(),this.bb.update(L)}async reload(L){const B=Object.assign({},this.S);B.workspace=await this.Db(B),delete B.filesToOpenOrCreate,delete B.filesToDiff,delete B.filesToMerge,delete B.filesToWait,this.isExtensionDevelopmentHost&&L&&(B.verbose=L.verbose,B.debugId=L.debugId,B.extensionEnvironment=L.extensionEnvironment,B["inspect-extensions"]=L["inspect-extensions"],B["inspect-brk-extensions"]=L["inspect-brk-extensions"],B["extensions-dir"]=L["extensions-dir"]),B.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),B.isInitialStartup=!1,B.policiesData=this.gb.serialize(),B.continueOn=this.t.continueOn,B.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},B.logLevel=this.fb.getLogLevel(),B.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(B,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Db(L){if((0,I.$Ni)(L.workspace)){const B=L.workspace.configPath;if(B.scheme===u.Schemas.file&&!await this.ib.exists(B))return}else if((0,I.$Ii)(L.workspace)){const B=L.workspace.uri;if(B.scheme===u.Schemas.file&&!await this.ib.exists(B))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$rcc)();if(this.isFullScreen){let H;try{H=n.screen.getDisplayMatching(this.getBounds())}catch{}const oe=(0,M.$rcc)();return{mode:3,display:H?H.id:void 0,width:this.U.width||oe.width,height:this.U.height||oe.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const L=Object.create(null);let B;if(!g.$j&&this.m.isMaximized()?B=0:B=1,B===0?L.mode=0:L.mode=1,B===1||B===0){let H;B===1?H=this.getBounds():H=this.m.getNormalBounds(),L.x=H.x,L.y=H.y,L.width=H.width,L.height=H.height}return L.zoomLevel=this.ab,L}Eb(L){(0,c.mark)("code/willRestoreCodeWindowState");let B=!1;if(L){this.ab=L.zoomLevel;try{const H=n.screen.getAllDisplays();B=H.length>1,L=D.WindowStateValidator.validateWindowState(this.u,L,H)}catch(H){this.u.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}}return(0,c.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$rcc)(),B]}getBounds(){const[L,B]=this.m.getPosition(),[H,oe]=this.m.getSize();return{x:L,y:B,width:H,height:oe}}I(L,B){super.I(L,B),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",k.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let L=(0,P.$JD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Hb(L,B=!0){g.$j||(L==="toggle"&&B&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Ib(L)}):this.Ib(L))}Ib(L){const B=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!B),this.m.autoHideMenuBar=B;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.ab=L}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,B,...H){this.isReady?this.send(L,...H):this.ready().then(()=>{B.isCancellationRequested||this.send(L,...H)})}send(L,...B){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...B)}catch(H){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.Q}: ${(0,R.$jj)(H)}`)}}}updateTouchBar(L){g.$j&&this.Y.forEach((B,H)=>{const oe=L[H];B.segments=this.Mb(oe)})}Kb(){if(g.$j){for(let L=0;L<10;L++){const B=this.Lb();this.Y.push(B)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(L=[]){const B=this.Mb(L),H=new n.TouchBar.TouchBarSegmentedControl({segments:B,mode:"buttons",segmentStyle:"automatic",change:oe=>{this.sendWhenReady("vscode:runAction",k.CancellationToken.None,{id:H.segments[oe].id,from:"touchbar"})}});return H}Mb(L=[]){return L.map(H=>{let oe;H.icon&&!l.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===u.Schemas.file&&(oe=n.nativeImage.createFromPath(p.URI.revive(H.icon.dark).fsPath),oe.isEmpty()&&(oe=void 0));let G;return typeof H.title=="string"?G=H.title:G=H.title.value,{id:H.id,label:oe?void 0:G,icon:oe}})}matches(L){return this.m?.webContents.id===L.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Vcc=V,e.$Vcc=V=Ee([ie(1,a.$5j),ie(2,U.$Scc),ie(3,b.$tcc),ie(4,W.$ho),ie(5,T.$Hcc),ie(6,h.$5k),ie(7,i.$6cc),ie(8,i.$4cc),ie(9,y.$5i),ie(10,$.$Ccc),ie(11,O.$Qcc),ie(12,d.$ycc),ie(13,o.$4l),ie(14,w.$zcc),ie(15,S.$Xcc),ie(16,t.$lk),ie(17,r.$Bcc),ie(18,D.$Ecc),ie(19,F.$6P),ie(20,te.$xi)],V)}),define(se[306],re([0,1,14,4,18,24,20,5,34,55,135]),function(K,e,n,C,k,R,j,E,u,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wcc=void 0;let p=class extends g.$Ucc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(m,d,y,w,b,f){super(w,b,d,y),this.O=m,this.P=f,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(m){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),m&&!this.N&&(this.N=!0,this.w({x:m.x,y:m.y,width:m.width,height:m.height,mode:m.show===!1?0:1})))}Q(){if(this.m)return;const m=n.BrowserWindow.fromWebContents(this.O);m&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(m),m.setMenu(null),(C.$i||C.$k)&&(0,c.$LD)(this.r)&&m.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(m){return this.O.id===m.id}};e.$Wcc=p,e.$Wcc=p=Ee([ie(1,R.$tcc),ie(2,E.$5j),ie(3,k.$5i),ie(4,u.$6P),ie(5,j.$Xcc)],p)}),define(se[307],re([0,1,14,3,2,13,37,306,6,5,82,29]),function(K,e,n,C,k,R,j,E,u,c,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oec=void 0;let v=class extends k.$Uc{constructor(d,y){super(),this.h=d,this.j=y,this.a=this.B(new C.$fe),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new C.$fe),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new C.$fe),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new C.$fe),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(d,y)=>{const w=this.getWindowByWebContents(y.webContents);if(w)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow();else{const b=new k.$Tc;b.add(C.Event.fromNodeEventEmitter(y.webContents,"did-create-window",(f,h)=>({browserWindow:f,details:h}))(({browserWindow:f,details:h})=>{const S=this.getWindowByWebContents(f.webContents);S&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),S.tryClaimWindow(h.options))})),b.add(C.Event.fromNodeEventEmitter(y,"closed")(()=>b.dispose()))}}),j.$iW.handle("vscode:registerAuxiliaryWindow",async(d,y)=>{const w=this.getWindowByWebContents(d.sender);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=y),d.sender.id})}createWindow(d){return this.h.invokeFunction(p.$Fcc,this.n(d),{preload:R.$Sg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(d){const y={},w=d.features.split(",");for(const f of w){const[h,S]=f.split("=");switch(h){case"width":y.width=parseInt(S,10);break;case"height":y.height=parseInt(S,10);break;case"left":y.x=parseInt(S,10);break;case"top":y.y=parseInt(S,10);break;case"window-maximized":y.mode=0;break;case"window-fullscreen":y.mode=3;break}}const b=p.WindowStateValidator.validateWindowState(this.j,y)??(0,g.$scc)();return this.j.trace("[aux window] using window state",b),b}registerWindow(d){const y=new k.$Tc,w=this.h.createInstance(E.$Wcc,d);this.g.set(w.id,w),y.add((0,k.$Sc)(()=>this.g.delete(w.id))),y.add(w.onDidMaximize(()=>this.a.fire(w))),y.add(w.onDidUnmaximize(()=>this.b.fire(w))),y.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),y.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),y.add(w.onDidTriggerSystemContextMenu(({x:b,y:f})=>this.f.fire({window:w,x:b,y:f}))),C.Event.once(w.onDidClose)(()=>y.dispose())}getWindowByWebContents(d){const y=this.g.get(d.id);return y?.matches(d)?y:void 0}getFocusedWindow(){const d=n.BrowserWindow.getFocusedWindow();if(d)return this.getWindowByWebContents(d.webContents)}getLastActiveWindow(){return(0,p.$Gcc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$oec=v,e.$oec=v=Ee([ie(0,u.$xi),ie(1,c.$5j)],v)}),define(se[85],re([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ddc=e.$Cdc=void 0,e.$Cdc=(0,d.$yi)("workspacesHistoryMainService");let s=class extends E.$Uc{static{r=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(o,l,$,P,D){super(),this.f=o,this.g=l,this.h=$,this.j=P,this.m=D,this.c=this.B(new R.$fe),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new k.$wh(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let l=[],$=[];for(const D of o)if((0,f.$1fb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(l,D.workspace)&&l.push(D);else if((0,f.$2fb)(D))this.y(l,D.folderUri)||l.push(D);else{const I=this.z($,D.fileUri),O=D.fileUri.scheme===u.Schemas.file&&r.G.indexOf((0,g.$9g)(D.fileUri))>=0;!I&&!O&&($.push(D),c.$i&&D.fileUri.scheme===u.Schemas.file&&n.app.addRecentDocument(D.fileUri.fsPath))}const P=await this.r({workspaces:l,files:$});l=P.workspaces,$=P.files,l.length>r.a&&(l.length=r.a),$.length>r.a&&($.length=r.a),await this.t({workspaces:l,files:$}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(o){const l=I=>{const O=this.u(I);for(const M of o)if(g.$3g.isEqual(M,O))return!1;return!0},$=await this.getRecentlyOpened(),P=$.workspaces.filter(l),D=$.files.filter(l);(P.length!==$.workspaces.length||D.length!==$.files.length)&&(await this.t({files:D,workspaces:P}),this.c.fire(),c.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:l}=await this.m.showMessageBox({type:"warning",buttons:[(0,m.localize)(0,null),(0,m.localize)(1,null)],message:(0,m.localize)(2,null),detail:(0,m.localize)(3,null),cancelId:1});if(l!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(o){const l=new a.$Ac(D=>g.$3g.getComparisonKey(D));if(o?.workspaces)for(const D of o.workspaces)l.set(this.u(D),D);const $=new a.$Ac(D=>g.$3g.getComparisonKey(D));if(o?.files)for(const D of o.files)$.set(this.u(D),D);const P=await this.s();for(const D of P.workspaces){const I=l.get(this.u(D));I?I.label=I.label??D.label:l.set(this.u(D),D)}for(const D of P.files){const I=$.get(this.u(D));I?I.label=I.label??D.label:$.set(this.u(D),D)}return{workspaces:[...l.values()],files:[...$.values()]}}async s(){await this.j.whenReady;let o;const l=this.j.get(r.b,-1);if(typeof l=="string")try{o=JSON.parse(l)}catch($){this.f.error("Unexpected error parsing opened paths list",$)}return(0,f.$8fb)(o,this.f)}async t(o){await this.j.whenReady,this.j.store(r.b,JSON.stringify((0,f.$9fb)(o)),-1,1)}u(o){return(0,f.$2fb)(o)?o.folderUri:(0,f.$3fb)(o)?o.fileUri:o.workspace.configPath}w(o,l){return!!o.find($=>(0,f.$1fb)($)&&$.workspace.id===l.id)}y(o,l){return!!o.find($=>(0,f.$2fb)($)&&g.$3g.isEqual($.folderUri,l))}z(o,l){return!!o.find($=>g.$3g.isEqual($.fileUri,l))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG","git-rebase-todo"]}async I(){c.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!c.$i)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(4,null),description:(0,m.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const l=[];for(const D of n.app.getJumpListSettings().removedItems){const I=D.args;if(I){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);O&&l.push(p.URI.parse(O[2]))}}await this.removeRecentlyOpened(l);let $=!1;const P=(0,C.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,r.F).map(D=>{const I=(0,f.$1fb)(D)?D.workspace:D.folderUri,{title:O,description:M}=this.L(I,D.label);let W;return p.URI.isUri(I)?W=`--folder-uri "${I.toString()}"`:($=!0,W=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));P.length>0&&o.push({type:"custom",name:$?(0,m.localize)(6,null):(0,m.localize)(7,null),items:P})}o.push({type:"recent"});try{const l=n.app.setJumpList(o);l&&l!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${l}`)}catch(l){this.f.warn("updateWindowsJumpList#setJumpList",l)}}L(o,l){if(l)return{title:(0,j.$Qw)(l).name,description:l};if(p.URI.isUri(o))return{title:(0,g.$9g)(o),description:this.M(o)};if(this.g.isUntitledWorkspace(o))return{title:(0,m.localize)(8,null),description:""};let $=(0,g.$9g)(o.configPath);return $.endsWith(h.$Ui)&&($=$.substr(0,$.length-h.$Ui.length-1)),{title:(0,m.localize)(9,null,$),description:this.M(o.configPath)}}M(o){return o.scheme==="file"?(0,j.$Iw)(o.fsPath):o.toString()}async N(){if(!c.$j)return;n.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),l=[];let $=0;for(let D=0;D<o.workspaces.length&&$<r.C;D++){const I=this.u(o.workspaces[D]);if(I.scheme===u.Schemas.file){const O=(0,g.$Zg)(I);await v.Promises.exists(O)&&(l.push(O),$++)}}const P=[];for(let D=0;D<o.files.length&&$<r.D;D++){const I=this.u(o.files[D]);if(I.scheme===u.Schemas.file){const O=(0,g.$Zg)(I);if(r.G.includes((0,g.$9g)(I))||l.includes(O))continue;await v.Promises.exists(O)&&(P.push(O),$++)}}P.reverse().forEach(D=>n.app.addRecentDocument(D)),l.reverse().forEach(D=>n.app.addRecentDocument(D))}};e.$Ddc=s,e.$Ddc=s=r=Ee([ie(0,w.$5j),ie(1,S.$Qcc),ie(2,y.$Xcc),ie(3,b.$6cc),ie(4,t.$zcc)],s)}),define(se[308],re([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Edc=void 0;const s="menu";let i=class{static{r=this}static{this.a="lastKnownMenubarData"}constructor($,P,D,I,O,M,W,F,T,U,ae,te){this.n=$,this.o=P,this.p=D,this.q=I,this.r=O,this.s=M,this.t=W,this.u=F,this.v=T,this.w=U,this.x=ae,this.y=te,this.m=Object.create(null),this.g=new C.$Kh(()=>this.F(),0),this.h=new C.$Kh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(j.$j||(0,S.$LD)(P))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const $=this.t.getItem(r.a);$&&($.menus&&(this.k=$.menus),$.keybindings&&(this.l=$.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(M,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(M,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(M,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(M,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const $=this.x.youTubeUrl;$&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab($,"openYouTubeUrl"));const P=this.x.requestFeatureUrl;P&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(P,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(j.$w){const M=I.indexOf("?")>0?"&":"?";this.ab(`${I}${M}lang=${j.$w}`,"openLicenseUrl")}else this.ab(I,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount($=>this.G($)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const $=this.o.getValue("window.enableMenuBarMnemonics");return typeof $!="boolean"?!0:$}get D(){if(!j.$j)return!1;const $=this.o.getValue("window.nativeTabs");return typeof $!="boolean"?!1:$}updateMenu($,P){this.k=$.menus,this.l=$.keybindings,this.t.setItem(r.a,$),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G($){j.$j&&($.oldCount===0&&$.newCount>0||$.oldCount>0&&$.newCount===0)&&(this.d=$.newCount===0,this.E())}H(){if(!j.$j)return;const $=n.BrowserWindow.getFocusedWindow();this.f=!$||!!this.y.getWindowByWebContents($.webContents),this.E()}I(){const $=n.Menu.getApplicationMenu();if($&&this.j.push($),Object.keys(this.k).length===0){this.J(j.$j?new n.Menu:null);return}const P=new n.Menu;let D;if(j.$j){const O=new n.Menu;D=new n.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),P.append(D)}if(j.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.cb(u.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(O)}if(this.M("File")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(1,null)),submenu:O});this.O(O,"File"),P.append(M)}if(this.M("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(2,null)),submenu:O});this.O(O,"Edit"),P.append(M)}if(this.M("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(3,null)),submenu:O});this.O(O,"Selection"),P.append(M)}if(this.M("View")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(4,null)),submenu:O});this.O(O,"View"),P.append(M)}if(this.M("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(5,null)),submenu:O});this.O(O,"Go"),P.append(M)}if(this.M("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(6,null)),submenu:O});this.O(O,"Run"),P.append(M)}if(this.M("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(7,null)),submenu:O});this.O(O,"Terminal"),P.append(M)}let I;if(this.M("Window")){const O=new n.Menu;I=new n.MenuItem({label:this.cb(u.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(I&&P.append(I),this.M("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(u.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),P.append(M)}P.items&&P.items.length>0?this.J(P):this.J(null),this.h.schedule()}J($){if(n.Menu.setApplicationMenu($),$)for(const P of this.y.getWindows())P.win?.setMenu(null)}K($){const P=this.W(u.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let I;if(this.M("Preferences")){const te=new n.Menu;this.O(te,"Preferences"),I=new n.MenuItem({label:this.cb(u.localize(11,null)),submenu:te})}const O=new n.Menu,M=new n.MenuItem({label:u.localize(12,null),role:"services",submenu:O}),W=new n.MenuItem({label:u.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:u.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new n.MenuItem({label:u.localize(15,null),role:"unhide"}),U=new n.MenuItem(this.$("workbench.action.quit",{label:u.localize(16,null,this.x.nameLong),click:async(te,ce,J)=>{const V=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||V?.win?.isMinimized())&&await this.L(J)&&this.w.quit(void 0)}})),ae=[P];ae.push(...D),I&&ae.push(o(),I),ae.push(o(),M,o(),W,F,T,o(),U),ae.forEach(te=>$.append(te))}async L($){if(this.p.getWindowCount()===0)return!0;const P=this.o.getValue("window.confirmBeforeClose");if(P==="always"||P==="keyboardOnly"&&this.S($)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[u.localize(17,null),u.localize(18,null)],message:u.localize(19,null)});return D===0}return!0}M($){if(!j.$j&&!(0,S.$LD)(this.o))return!1;switch($){case"File":case"Help":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[$];case"Window":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[$]}}N($,P){P.forEach(D=>{if((0,d.$zdc)(D))$.append(o());else if((0,d.$ydc)(D)){const I=new n.Menu,O=new n.MenuItem({label:this.cb(D.label),submenu:I});this.N(I,D.submenu.items),$.append(O)}else(0,d.$Adc)(D)?$.append(this.Q(D)):(0,d.$Bdc)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P($),j.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?$.append(new n.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):$.append(this.W(D.label,D.id,!1,D.checked)):$.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):$.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O($,P){this.k&&this.k[P]&&this.N($,this.k[P].items)}P($){const P=this.V();P.length&&(P.forEach(D=>$.append(D)),$.append(o()))}Q($){const P=E.URI.revive($.uri),D=$.id,I=D==="openRecentFile"?{fileUri:P}:D==="openRecentWorkspace"?{workspaceUri:P}:{folderUri:P};return new n.MenuItem(this.$(D,{label:$.label,click:async(O,M,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:$.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([P])}},!1))}R($){return!!($&&(!j.$j&&($.ctrlKey||$.shiftKey)||j.$j&&($.metaKey||$.altKey)))}S($){return!!($.triggeredByAccelerator||$.altKey||$.ctrlKey||$.metaKey||$.shiftKey)}T($,P,D){const I={label:this.cb($),role:D,enabled:!0};return new n.MenuItem(this.Z(P,I))}U($){const P=new n.MenuItem({label:u.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:u.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:u.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(u.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(o()),M.push(this.W(u.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(u.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(u.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(u.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(u.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[P,D,o(),O,...M,o(),I].forEach(W=>$.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(u.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:u.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(u.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:u.localize(32,null),enabled:!1})];case"downloaded":return j.$j?[]:[new n.MenuItem({label:this.cb(u.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:u.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(u.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W($,P,D,I){const O=this.cb($),M=typeof P=="function"?P:(ae,te,ce)=>{const J=ae?ae.userSettingsLabel:null;let V=P;Array.isArray(P)&&(V=this.R(ce)?P[1]:P[0]),J&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:J}):this.Y({type:"commandId",commandId:V})},W=typeof D=="boolean"?D:this.p.getWindowCount()>0,F=typeof I=="boolean"?I:!1,T={label:O,click:M,enabled:W};F&&(T.type="checkbox",T.checked=F);let U;return typeof P=="string"?U=P:Array.isArray(P)&&(U=P[0]),j.$j&&(U==="editor.action.clipboardCutAction"?T.role="cut":U==="editor.action.clipboardCopyAction"?T.role="copy":U==="editor.action.clipboardPasteAction"&&(T.role="paste"),U==="undo"?T.click=this.X(M,{inDevTools:ae=>ae.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):U==="redo"?T.click=this.X(M,{inDevTools:ae=>ae.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):U==="editor.action.selectAll"&&(T.click=this.X(M,{inDevTools:ae=>ae.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(U,T))}X($,P){return(D,I,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return P.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return P.inDevTools(M.webContents.devToolsWebContents);$(D,I||M,O)}}Y($){let P=n.BrowserWindow.getFocusedWindow();if(P){const I=this.y.getWindowByWebContents(P.webContents);I&&(P=this.p.getWindowById(I.parentId)?.win??null)}if(!P){const I=this.p.getLastActiveWindow();I?.win?.isMinimized()&&(P=I.win)}const D=P?this.p.getWindowById(P.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",$),j.$j&&!this.q.isBuilt&&!D.isReady&&($.type==="commandId"&&$.commandId==="workbench.action.toggleDevTools"||$.type!=="commandId"&&$.userSettingsLabel==="alt+cmd+i"))return!1;if($.type==="commandId"){const I={id:$.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",k.CancellationToken.None,I)}else{const I={userSettingsLabel:$.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",k.CancellationToken.None,I)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",$),!1}Z($,P){const D=typeof $=="string"?this.l[$]:void 0;if(D?.label){if(D.isNative!==!1)P.accelerator=D.label,P.userSettingsLabel=D.userSettingsLabel;else if(typeof P.label=="string"){const I=P.label.indexOf("[");I>=0?P.label=`${P.label.substr(0,I)} [${D.label}]`:P.label=`${P.label} [${D.label}]`}}else P.accelerator=void 0;return P}$($,P,D=!P.accelerator){D&&(P=this.Z($,P));const I=P.click;return P.click=(O,M,W)=>{this.bb($),I?.(O,M,W)},P}ab($,P){this.w.openExternal(void 0,$),this.bb(P)}bb($){this.r.publicLog2("workbenchActionExecuted",{id:$,from:s})}cb($){return(0,R.$Nw)($,!this.C)}};e.$Edc=i,e.$Edc=i=r=Ee([ie(0,h.$hX),ie(1,g.$5i),ie(2,a.$Ecc),ie(3,p.$tcc),ie(4,f.$4l),ie(5,t.$Cdc),ie(6,b.$6P),ie(7,v.$Xcc),ie(8,m.$5j),ie(9,y.$qdc),ie(10,w.$lk),ie(11,c.$pdc)],i);function o(){return new n.MenuItem({type:"separator"})}}),define(se[309],re([0,1,6,20,5,308]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gdc=e.$Fdc=void 0,e.$Fdc=(0,n.$yi)("menubarMainService");let j=class{constructor(u,c,g){this.b=u,this.c=c,this.d=g,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$Edc)}async updateMenubar(u,c){this.d.trace("menubarService#updateMenubar",u),(await this.a).updateMenu(c,u)}};e.$Gdc=j,e.$Gdc=j=Ee([ie(0,n.$xi),ie(1,C.$Xcc),ie(2,k.$5j)],j)}),define(se[310],re([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i,o,l,$,P,D,I,O,M,W,F,T,U,ae,te,ce,J,V,q,L,B,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7dc=void 0;function oe(Q){return(0,ae.$Ni)(Q?.workspace)}function G(Q){return(0,ae.$Ii)(Q?.workspace)}let le=class extends p.$Uc{constructor(A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye,Se,ke,Re,we,Z,fe,ge){super(),this.s=A,this.t=N,this.u=_,this.w=z,this.z=Y,this.C=x,this.D=ee,this.F=X,this.G=ue,this.H=he,this.I=pe,this.J=$e,this.L=ye,this.M=Se,this.N=ke,this.O=Re,this.P=we,this.Q=Z,this.R=fe,this.S=ge,this.a=this.B(new u.$fe),this.onDidOpenWindow=this.a.event,this.b=this.B(new u.$fe),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new u.$fe),this.onDidDestroyWindow=this.c.event,this.f=this.B(new u.$fe),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new u.$fe),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new u.$fe),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new u.$fe),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new u.$fe),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new U.$4dc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new p.$Tc;if(N.add(u.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,N){const _=this.F.args,z=N?.remoteAuthority||void 0,Y=!0,x=N?.forceReuseWindow,ee=!x;return this.open({...A,cli:_,forceEmpty:Y,forceNewWindow:ee,forceReuseWindow:x,remoteAuthority:z})}openExistingWindow(A,N){A.focus(),this.W(N,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],_=[],z=[],Y=[],x=[];let ee,X=0;const ue=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",ue);for(const Se of ue)G(Se)?A.addMode?N.push(Se):_.push(Se):oe(Se)?z.push(Se):Se.fileUri?(ee||(ee={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Se.remoteAuthority}),ee.filesToOpenOrCreate.push(Se)):Se.backupPath?x.push({backupFolder:(0,m.$nc)(Se.backupPath),remoteAuthority:Se.remoteAuthority}):X++;A.diffMode&&ee&&ee.filesToOpenOrCreate.length>=2&&(ee.filesToDiff=ee.filesToOpenOrCreate.slice(0,2),ee.filesToOpenOrCreate=[]),A.mergeMode&&ee&&ee.filesToOpenOrCreate.length===4&&(ee.filesToMerge=ee.filesToOpenOrCreate.slice(0,4),ee.filesToOpenOrCreate=[],ee.filesToDiff=[]),ee&&A.waitMarkerFileURI&&(ee.filesToWait={paths:(0,j.$Hb)([...ee.filesToDiff,ee.filesToMerge[3],...ee.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(Y.push(...this.M.getUntitledWorkspaces()),z.push(...Y),x.push(...this.I.getEmptyWindowBackups())):x.length=0;const{windows:he,filesOpenedInWindow:pe}=await this.X(A,z,_,x,X,ee,N);if(this.w.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${_.length}, emptyToRestore: ${x.length}, emptyToOpen: ${X})`),he.length>1)if(pe)pe.focus();else{const Se=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Re=!0;if(Se){const we=he.filter(Z=>this.r.state.lastActiveWindow&&Z.backupPath===this.r.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ke=!1,Re=!1)}if(ke)for(let we=he.length-1;we>=0;we--){const Z=he[we];if(!(Z.openedWorkspace&&Y.some(fe=>Z.openedWorkspace&&fe.workspace.id===Z.openedWorkspace.id)||Z.backupPath&&x.some(fe=>Z.backupPath&&fe.backupFolder===(0,m.$nc)(Z.backupPath)))){Z.focus(),Re=!1;break}}Re&&he[he.length-1].focus()}const $e=ee&&ee.filesToDiff.length>0,ye=ee&&ee.filesToMerge.length>0;if(!he.some(Se=>Se.isExtensionDevelopmentHost)&&!$e&&!ye&&!A.noRecentEntry){const Se=[];for(const ke of ue)oe(ke)&&!ke.transient?Se.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):G(ke)?Se.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Se.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.L.addRecentlyOpened(Se)}return this.W(A,he),he}W(A,N){const _=A.waitMarkerFileURI;A.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,N,_,z,Y,x,ee){const X=[];let ue;function he(we,Z){X.push(we),Z&&(ue=we,x=void 0)}let{openFolderInNewWindow:pe,openFilesInNewWindow:$e}=this.ob(A);if(!A.initialStartup&&ee.length>0){const we=ee[0].remoteAuthority,Z=this.ub(we);Z&&he(this.$(Z,ee.map(fe=>fe.workspace.uri)))}const ye=_.length+N.length+z.length;if(x&&ye===0){const we=x.filesToOpenOrCreate[0]||x.filesToDiff[0]||x.filesToMerge[3],Z=this.getWindows().filter(ge=>x&&(0,b.$eh)(ge.remoteAuthority,x.remoteAuthority));let fe;we?.fileUri&&!$e&&((A.context===4||A.context===0||A.context===1)&&(fe=await(0,T.$Jcc)(Z,we.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(Z))),fe?(0,ae.$Ni)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ae.$Ii)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):he(this.Y(A,fe,x),!0):he(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:x,forceNewWindow:!0,remoteAuthority:x.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Se=(0,j.$Mb)(N,we=>we.workspace.id);if(Se.length>0){const we=(0,j.$Hb)(Se.map(Z=>(0,T.$Kcc)(this.getWindows(),Z.workspace.configPath)));if(we.length>0){const Z=we[0],fe=(0,b.$eh)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;he(this.Y(A,Z,fe),!!fe),pe=!0}for(const Z of Se){if(we.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===Z.workspace.id))continue;const fe=Z.remoteAuthority,ge=(0,b.$eh)(x?.remoteAuthority,fe)?x:void 0;he(await this.bb(A,Z,pe,ge),!!ge),pe=!0}}const ke=(0,j.$Mb)(_,we=>b.$3g.getComparisonKey(we.workspace.uri));if(ke.length>0){const we=(0,j.$Hb)(ke.map(Z=>(0,T.$Kcc)(this.getWindows(),Z.workspace.uri)));if(we.length>0){const Z=we[0],fe=(0,b.$eh)(x?.remoteAuthority,Z.remoteAuthority)?x:void 0;he(this.Y(A,Z,fe),!!fe),pe=!0}for(const Z of ke){if(we.some(Pe=>(0,ae.$Ii)(Pe.openedWorkspace)&&b.$3g.isEqual(Pe.openedWorkspace.uri,Z.workspace.uri)))continue;const fe=Z.remoteAuthority,ge=(0,b.$eh)(x?.remoteAuthority,fe)?x:void 0;he(await this.bb(A,Z,pe,ge),!!ge),pe=!0}}const Re=(0,j.$Mb)(z,we=>we.backupFolder);if(Re.length>0)for(const we of Re){const Z=we.remoteAuthority,fe=(0,b.$eh)(x?.remoteAuthority,Z)?x:void 0;he(await this.ab(A,!0,Z,fe,we),!!fe),pe=!0}if(X.length===0||x){x&&!Y&&Y++;const we=x?x.remoteAuthority:A.remoteAuthority;for(let Z=0;Z<Y;Z++)he(await this.ab(A,pe,we,x),!!x),pe=!0}return{windows:(0,j.$Mb)(X),filesOpenedInWindow:ue}}Y(A,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const z={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",E.CancellationToken.None,z),N}Z(A){let N=A;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const z=this.S.getWindowByWebContents(_.webContents);z&&z.parentId===A.id&&(N=z)}N.focus()}$(A,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),A.focus();const _={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",E.CancellationToken.None,_),A}ab(A,N,_,z,Y){this.w.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:_,filesToOpen:z,forceNewWindow:N});let x;return!N&&typeof A.contextWindowId=="number"&&(x=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:x,emptyWindowBackupInfo:Y,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,N,_,z,Y){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:z}),!_&&!Y&&typeof A.contextWindowId=="number"&&(Y=this.getWindowById(A.contextWindowId)),this.pb({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:Y,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let N,_=!1,z=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=await this.db(A),_=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=await this.eb(A.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),z=!0),!A.addMode&&_){const Y=N.filter(x=>G(x));if(Y.length>1){const x=Y[0].remoteAuthority;if(Y.every(ee=>(0,b.$eh)(ee.remoteAuthority,x))){const ee=await this.M.createUntitledWorkspace(Y.map(X=>({uri:X.workspace.uri})));N.push({workspace:ee,remoteAuthority:x}),N=N.filter(X=>!G(X))}}}if(A.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const Y=await this.gb();N.unshift(...Y.filter(x=>oe(x)||G(x)||x.backupPath))}return N}async db(A){const N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,j.$Hb)(A.urisToOpen||[]).map(async z=>{const Y=await this.ib(z,N);if(Y)return Y.label=z.label,Y;const x=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,S.localize)(0,null)],message:x.scheme===v.Schemas.file?(0,S.localize)(1,null):(0,S.localize)(2,null),detail:x.scheme===v.Schemas.file?(0,S.localize)(3,null,(0,g.$Hw)(x,{os:y.OS,tildify:this.F})):(0,S.localize)(4,null,x.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,j.$Hb)(_)}async eb(A){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},z=A["folder-uri"];if(z){const ee=await Promise.all(z.map(X=>{const ue=this.fb(X);if(ue)return this.ib({folderUri:ue},_)}));N.push(...(0,j.$Hb)(ee))}const Y=A["file-uri"];if(Y){const ee=await Promise.all(Y.map(X=>{const ue=this.fb(X);if(ue)return this.ib((0,ae.$4i)(X)?{workspaceUri:ue}:{fileUri:ue},_)}));N.push(...(0,j.$Hb)(ee))}const x=await Promise.all(A._.map(ee=>_.remoteAuthority?this.nb(ee,_):this.lb(ee,_)));return N.push(...(0,j.$Hb)(x)),N}fb(A){try{const N=h.URI.parse(A);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${A}, ${N.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];A!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async z=>{if(z.workspace){const Y=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(oe(Y))return Y}else if(z.folderUri){const Y=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(G(Y))return Y}else if(A!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,j.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,N=Object.create(null)){const _=this.kb(A);return _.scheme===v.Schemas.file?((0,M.$ID)(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(A,N)}jb(A,N){let _=this.kb(A);const z=(0,I.$Jm)(_)||N.remoteAuthority;if(_=(0,b.$gh)((0,b.$ah)(_)),(0,M.$ID)(A)){if(N.gotoLineMode){const{path:Y,line:x,column:ee}=(0,c.$Fg)(_.path);return{fileUri:_.with({path:Y}),options:{selection:x?{startLineNumber:x,startColumn:ee||1}:void 0},remoteAuthority:z}}return{fileUri:_,remoteAuthority:z}}else if((0,M.$GD)(A))return{workspace:(0,te.$Ncc)(_),remoteAuthority:z};return{workspace:(0,te.$Occ)(_),remoteAuthority:z}}kb(A){return(0,M.$GD)(A)?A.workspaceUri:(0,M.$HD)(A)?A.folderUri:A.fileUri}async lb(A,N,_){let z,Y;N.gotoLineMode&&({path:A,line:z,column:Y}=(0,c.$Fg)(A)),A=(0,c.$zg)((0,m.$hc)(A),(0,w.cwd)());try{const x=await C.Promises.stat(A);if(x.isFile()){if(!N.forceOpenWorkspaceAsFile){const ee=await this.M.resolveLocalWorkspace(h.URI.file(A));if(ee)return ee.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:ee.id,configPath:ee.configPath},type:i.FileType.File,exists:!0,remoteAuthority:ee.remoteAuthority,transient:ee.transient}}return{fileUri:h.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:Y||1}:void 0}}}else{if(x.isDirectory())return{workspace:(0,te.$Occ)(h.URI.file(A),x),type:i.FileType.Directory,exists:!0};if(!y.$i&&A==="/dev/null")return{fileUri:h.URI.file(A),type:i.FileType.File,exists:!0}}}catch(x){if(x.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,N);const ee=h.URI.file(A);if(this.L.removeRecentlyOpened([ee]),N.ignoreFileNotFound)return{fileUri:ee,type:i.FileType.File,exists:!1}}}async mb(A,N){const _=h.URI.file(A),{response:z,checkboxChecked:Y}=await this.O.showMessageBox({type:"warning",buttons:[(0,S.localize)(5,null),(0,S.localize)(6,null),(0,S.localize)(7,null)],message:(0,S.localize)(8,null,_.authority),detail:(0,S.localize)(9,null,(0,g.$Hw)(_,{os:y.OS,tildify:this.F})),checkboxLabel:(0,S.localize)(10,null,_.authority),cancelId:1});if(z===0){if((0,k.addUNCHostToAllowlist)(_.authority),Y){const x={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(x.channel,x.args),this.sendToOpeningWindow(x.channel,x.args)}return this.lb(A,N,!0)}if(z===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,N)}nb(A,N){const _=A.charCodeAt(0),z=N.remoteAuthority;let Y,x;N.gotoLineMode&&({path:A,line:Y,column:x}=(0,c.$Fg)(A)),_!==47&&((0,c.$yg)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,c.$rg)(A)),A=`/${A}`);const ee=h.URI.from({scheme:v.Schemas.vscodeRemote,authority:z,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,ae.$4i)(A))return N.forceOpenWorkspaceAsFile?{fileUri:ee,options:{selection:Y?{startLineNumber:Y,startColumn:x||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,te.$Ncc)(ee),remoteAuthority:z};if(N.gotoLineMode||m.$gc.basename(A).indexOf(".")!==-1)return{fileUri:ee,options:{selection:Y?{startLineNumber:Y,startColumn:x||1}:void 0},remoteAuthority:z}}return{workspace:(0,te.$Occ)(ee),remoteAuthority:z}}ob(A){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",z=N?.openFilesInNewWindow||"off";let Y=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(Y=_==="on");let x=!1;return A.forceNewWindow||A.forceReuseWindow?x=!!A.forceNewWindow&&!A.forceReuseWindow:(y.$j?A.context===1&&(x=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(x=!0),!A.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(x=z==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:x}}async openExtensionDevelopmentHostWindow(A,N){const _=(0,T.$Lcc)(this.getWindows(),A);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let z=N.cli["folder-uri"]||[],Y=N.cli["file-uri"]||[],x=N.cli._;if(!x.length&&!z.length&&!Y.length&&!N.cli.extensionTestsPath){const ue=this.r.state.lastPluginDevelopmentHostWindow,he=ue?.workspace??ue?.folderUri;he&&(h.URI.isUri(he)?he.scheme===v.Schemas.file?x=[he.fsPath]:z=[he.toString()]:he.configPath.scheme===v.Schemas.file?x=[(0,b.$Zg)(he.configPath)]:Y=[he.configPath.toString()])}let ee=N.remoteAuthority;for(const ue of A)if(ue.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=h.URI.parse(ue),pe=(0,I.$Jm)(he);pe&&(ee?(0,b.$eh)(pe,ee)||this.w.error("more than one extension development path authority"):ee=pe)}x=x.filter(ue=>{const he=h.URI.file(ue);return(0,T.$Kcc)(this.getWindows(),he)?!1:(0,b.$eh)((0,I.$Jm)(he),ee)}),z=z.filter(ue=>{const he=this.fb(ue);return he&&(0,T.$Kcc)(this.getWindows(),he)?!1:he?(0,b.$eh)((0,I.$Jm)(he),ee):!1}),Y=Y.filter(ue=>{const he=this.fb(ue);return he&&(0,T.$Kcc)(this.getWindows(),he)?!1:he?(0,b.$eh)((0,I.$Jm)(he),ee):!1}),N.cli._=x,N.cli["folder-uri"]=z,N.cli["file-uri"]=Y;const X={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!x.length&&!z.length&&!Y.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:ee,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(X)}async pb(A){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),z=_?.profile??this.G.defaultProfile;let Y;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(Y=A.windowToUse||_,Y&&Y.focus());const x={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,m.$jc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:P.default,isInitialStartup:A.initialStartup,perfMarks:(0,d.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(Y){const ee=Y.config;!x.extensionDevelopmentPath&&ee?.extensionDevelopmentPath&&(x.extensionDevelopmentPath=ee.extensionDevelopmentPath,x.extensionDevelopmentKind=ee.extensionDevelopmentKind,x["enable-proposed-api"]=ee["enable-proposed-api"],x.verbose=ee.verbose,x["inspect-extensions"]=ee["inspect-extensions"],x["inspect-brk-extensions"]=ee["inspect-brk-extensions"],x.debugId=ee.debugId,x.extensionEnvironment=ee.extensionEnvironment,x["extensions-dir"]=ee["extensions-dir"],x["disable-extensions"]=ee["disable-extensions"]),x.loggers={global:x.loggers.global,window:ee?.loggers.window??x.loggers.window}}else{const ee=this.r.getNewWindowState(x);(0,d.mark)("code/willCreateCodeWindow");const X=Y=this.N.createInstance(W.$Vcc,{state:ee,extensionDevelopmentPath:x.extensionDevelopmentPath,isExtensionTestHost:!!x.extensionTestsPath});(0,d.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(X),this.n.set(X.id,X),this.a.fire(X),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const ue=new p.$Tc;ue.add(X.onDidSignalReady(()=>this.b.fire(X))),ue.add(u.Event.once(X.onDidClose)(()=>this.sb(X,ue))),ue.add(u.Event.once(X.onDidDestroy)(()=>this.tb(X))),ue.add(X.onDidMaximize(()=>this.g.fire(X))),ue.add(X.onDidUnmaximize(()=>this.h.fire(X))),ue.add(X.onDidEnterFullScreen(()=>this.j.fire({window:X,fullscreen:!0}))),ue.add(X.onDidLeaveFullScreen(()=>this.j.fire({window:X,fullscreen:!1}))),ue.add(X.onDidTriggerSystemContextMenu(({x:pe,y:$e})=>this.m.fire({window:X,x:pe,y:$e})));const he=(0,f.$jg)(X.win?.webContents);he.removeAllListeners("devtools-reload-page"),ue.add(u.Event.fromNodeEventEmitter(he,"devtools-reload-page")(()=>this.H.reload(X))),this.H.registerWindow(X)}return x.windowId=Y.id,Y.isReady?this.H.unload(Y,4).then(async ee=>{ee||await this.qb(Y,x,A,z)}):await this.qb(Y,x,A,z),Y}async qb(A,N,_,z){if(N.extensionDevelopmentPath||((0,ae.$Ni)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ae.$Ii)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,te.$Pcc)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const Y=N.workspace??(0,ae.$Mi)(N.backupPath,!1),x=this.rb(_,Y,z),ee=x instanceof Promise?await x:x;N.profiles.profile=ee,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(Y,ee)}A.load(N)}rb(A,N,_){return A.forceProfile?this.G.profiles.find(z=>z.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(A,N){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(N=>(0,b.$eh)(N.remoteAuthority,A)))}vb(A){return(0,F.$Gcc)(A)}sendToFocused(A,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,E.CancellationToken.None,...N)}sendToOpeningWindow(A,...N){this.B(u.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,E.CancellationToken.None,...N)}))}sendToAll(A,N,_){for(const z of this.getWindows())_&&_.indexOf(z.id)>=0||z.sendWhenReady(A,E.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const N=n.BrowserWindow.fromWebContents(A);if(!N)return;const _=this.getWindowById(N.id);return _?.matches(A)?_:void 0}};e.$7dc=le,e.$7dc=le=Ee([ie(3,$.$5j),ie(4,B.$Scc),ie(5,O.$6P),ie(6,q.$ho),ie(7,s.$tcc),ie(8,L.$Hcc),ie(9,l.$Xcc),ie(10,a.$ycc),ie(11,t.$5i),ie(12,ce.$Cdc),ie(13,J.$Qcc),ie(14,o.$xi),ie(15,r.$zcc),ie(16,i.$5k),ie(17,D.$Bcc),ie(18,V.$Ccc),ie(19,H.$pdc)],le)}),define(se[311],re([0,1,65,29,85,58]),function(K,e,n,C,k,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;let j=class{constructor(u,c,g,p){this.a=u,this.b=c,this.c=g,this.d=p,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(u,c){const g=this.b.getWindowById(u);if(g)return this.a.enterWorkspace(g,this.b.getWindows(),c)}createUntitledWorkspace(u,c,g){return this.a.createUntitledWorkspace(c,g)}deleteUntitledWorkspace(u,c){return this.a.deleteUntitledWorkspace(c)}getWorkspaceIdentifier(u,c){return this.a.getWorkspaceIdentifier(c)}getRecentlyOpened(u){return this.c.getRecentlyOpened()}addRecentlyOpened(u,c){return this.c.addRecentlyOpened(c)}removeRecentlyOpened(u,c){return this.c.removeRecentlyOpened(c)}clearRecentlyOpened(u){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$9dc=j,e.$9dc=j=Ee([ie(0,R.$Qcc),ie(1,C.$Ecc),ie(2,k.$Cdc),ie(3,n.$ycc)],j)}),define(se[312],re([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i,o,l,$,P,D,I,O,M,W,F,T,U,ae,te,ce,J,V,q,L,B,H,oe,G,le,Q,A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye,Se,ke,Re,we,Z,fe,ge,Pe,Oe,Te,Me,Fe,qe,xe,Ke,Be,He,Xe,ne,de,me,ve,Ie,Le,Qe,Ze,_e,st,Ye,ot,rt,ct,lt,Et,kt,Pt,ut,mt,jt,It,Dt,ht,Ct,wt,ft,At,Rt,dt,Ot,pt,Mt,bt){"use strict";var gt;Object.defineProperty(e,"__esModule",{value:!0}),e.$pec=void 0;let $t=class extends m.$Uc{static{gt=this}static{this.a={[d.Schemas.file]:"security.promptForLocalFileProtocolHandling",[d.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(je,De,Ae,be,Ce,ze,Ue,Ge,We,Ne,Ve,Je){super(),this.g=je,this.h=De,this.j=Ae,this.m=be,this.n=Ce,this.s=ze,this.t=Ue,this.u=Ge,this.w=We,this.y=Ne,this.z=Ve,this.C=Je,this.D(),this.F()}D(){const je=We=>We?.startsWith(`${d.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((We,Ne,Ve,Je)=>je(Je.requestingUrl)?Ve(De.has(Ne)):Ve(!1)),n.session.defaultSession.setPermissionCheckHandler((We,Ne,Ve,Je)=>je(Je.requestingUrl)?De.has(Ne):!1);const Ae=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,d.Schemas.vscodeManagedRemoteResource,"devtools"]),be=We=>{for(let Ne=We;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},Ce=We=>We.resourceType==="xhr"||be(We.frame),ze=We=>{const Ne=We.frame;if(!Ne||!this.b)return!1;const Ve=n.BrowserWindow.getAllWindows();for(const Je of Ve)if(Ne.processId===Je.webContents.mainFrame.processId)return!0;return!1},Ue=(We,Ne)=>{if(We.path!=="/index.html")return!0;const Ve=Ne.frame;if(!Ve||!this.b)return!1;for(const Je of this.b.getWindows())if(Je.win&&Ve.processId===Je.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((We,Ne)=>{const Ve=f.URI.parse(We.url);return Ve.scheme===d.Schemas.vscodeWebview&&!Ue(Ve,We)?(this.m.error("Blocked vscode-webview request",We.url),Ne({cancel:!0})):Ve.scheme===d.Schemas.vscodeFileResource&&!ze(We)?(this.m.error("Blocked vscode-file request",We.url),Ne({cancel:!0})):Ve.path.endsWith(".svg")&&!Ae.has(Ve.scheme)?Ne({cancel:!Ce(We)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{const Ve=We.responseHeaders,Je=Ve["content-type"]||Ve["Content-Type"];if(Je&&Array.isArray(Je)){const et=f.URI.parse(We.url);if(et.path.endsWith(".svg")&&Ae.has(et.scheme))return Ve["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:Ve});if(!et.path.endsWith(d.Schemas.vscodeRemoteResource)&&Je.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!Ce(We)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ve=We.responseHeaders??Object.create(null);if(Ve["Access-Control-Allow-Origin"]===void 0)return Ve["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:Ve})}return Ne({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,y.$jc)(this.s.codeCachePath,"chrome")),w.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,u.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,u.$Z)(Ae)||(0,u.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,u.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,S.$jW)(),n.app.on("accessibility-support-changed",(Ae,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),n.app.on("activate",async(Ae,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Ae,be)=>{be?.opener?.url.startsWith(`${d.Schemas.vscodeFileResource}://${d.$Rg}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),be.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ce)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let je=[],De;n.app.on("open-file",(Ae,be)=>{be=(0,bt.$dm)(be),this.m.trace("app#open-file: ",be),Ae.preventDefault(),je.push((0,ve.$4i)(be)?{workspaceUri:f.URI.file(be)}:{fileUri:f.URI.file(be)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:je,gotoLineMode:!1,preferNewWindow:!0}),je=[],De=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),k.$iW.handle("vscode:fetchShellEnv",Ae=>{const be=this.b?.getWindowByWebContents(Ae.sender);let Ce,ze;return be?.config?(Ce=be.config,ze={...process.env,...be.config.userEnv}):(Ce=this.s.args,ze=process.env),this.X(Ce,ze,!1)}),k.$iW.handle("vscode:writeNlsFile",(Ae,be,Ce)=>{const ze=this.G([be]);if(!ze||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(ze,j.$He.fromString(Ce))}),k.$iW.handle("vscode:readNlsFile",async(Ae,...be)=>{const Ce=this.G(be);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),k.$iW.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),k.$iW.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),k.$iW.on("vscode:reloadWindow",Ae=>Ae.sender.reload()),k.$iW.handle("vscode:notifyZoomLevel",async(Ae,be)=>{const Ce=this.b?.getWindowByWebContents(Ae.sender);Ce&&Ce.notifyZoomLevel(be)})}G(je){let De;for(const Ae of je)typeof Ae=="string"&&(typeof De!="string"?De=Ae:De=(0,y.$jc)(De,Ae));if(!(typeof De!="string"||!(0,y.$ic)(De)||!(0,c.$xg)(De,this.s.cachedLanguagesPath,!w.$k)))return f.URI.file(De)}H(je){if(je){const De={message:`[uncaught exception in main]: ${je.message}`,stack:je.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${je}`),je.stack&&this.m.error(je.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const je=this.z.win32AppUserModelId;w.$i&&je&&n.app.setAppUserModelId(je);try{w.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const De=new t.$pW;this.t.onWillShutdown(Ne=>{Ne.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,be]=await Promise.all([(0,mt.$eec)(this.w,this.m),(0,mt.$fec)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Ce,sharedProcessClient:ze}=this.P(Ae,be),Ue=await this.Q(Ae,be,Ce);this.B(Ue.createInstance(s.$8cc)),this.B(Ue.createInstance(kt.$aec)),Ue.invokeFunction(Ne=>this.R(Ne,De,ze));const Ge=await Ue.invokeFunction(Ne=>this.I(Ne,De));this.J(De),this.t.phase=2,await Ue.invokeFunction(Ne=>this.S(Ne,Ge)),this.t.phase=3,this.U(),this.B(new ut.$Kh(()=>{this.B((0,ut.$Oh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(je,De){const Ae=this.b=je.get(ne.$Ecc),be=je.get(Fe.$0W),Ce=this.f=je.get(x.$qdc),ze=je.get(O.$zcc),Ue=this;be.registerHandler({async handleURL(et,nt){return Ue.O(Ae,ze,be,et,nt)}});const Ge=this.B(new me.$8dc({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),We=new a.$gi(et=>Ge.getActiveClientId().then(nt=>et===nt)),Ne=new qe.$Ydc(We,this.m),Ve=De.getChannel("urlHandler",Ne);be.registerHandler(new qe.$Xdc(Ve));const Je=await this.L(Ae,ze);return this.B(new Ke.$Zdc(Je?.urls,be,Ae,this.s,this.z,this.m)),Je}J(je){const De=()=>({statusCode:404,data:"Not found"}),Ae=new Ot.$V(()=>je.getChannel(dt.$mec,new dt.$nec));n.protocol.registerBufferProtocol(d.Schemas.vscodeManagedRemoteResource,(be,Ce)=>{const ze=f.URI.parse(be.url);if(!ze.authority.startsWith("window:"))return Ce(De());Ae.value.call(dt.$lec,[ze]).then(Ue=>Ce({...Ue,data:Buffer.from(Ue.body,"base64")}),Ue=>{this.m.warn("error dispatching remote resource call",Ue),Ce({statusCode:500,data:String(Ue)})})})}async L(je,De){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ae.length+be.length===0)return;const Ce=[...Ae,...be].map(Ge=>{try{return{uri:f.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),ze=[],Ue=[];for(const Ge of Ce){if(!Ge)continue;const We=this.N(Ge.uri);if(We)if(await this.M(We,je,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),We),ze.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),Ue.push(Ge)}return{urls:Ue,openables:ze}}async M(je,De,Ae){let be,Ce;if((0,Xe.$GD)(je)?(be=je.workspaceUri,Ce=(0,i.localize)(0,null,be.scheme===d.Schemas.file?(0,v.$Hw)(be,{os:w.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,Xe.$HD)(je)?(be=je.folderUri,Ce=(0,i.localize)(1,null,be.scheme===d.Schemas.file?(0,v.$Hw)(be,{os:w.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=je.fileUri,Ce=(0,i.localize)(2,null,be.scheme===d.Schemas.file?(0,v.$Hw)(be,{os:w.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==d.Schemas.file&&be.scheme!==d.Schemas.vscodeRemote||this.u.getValue(gt.a[be.scheme])===!1)return!1;const{response:Ue,checkboxChecked:Ge}=await Ae.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:be.scheme===d.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(Ue!==0)return!0;if(Ge){const We={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===d.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(je){if(je.path){if(je.authority===d.Schemas.file){const De=f.URI.file(je.fsPath);return(0,ve.$4i)(De)?{workspaceUri:De}:{fileUri:De}}else if(je.authority===d.Schemas.vscodeRemote){const De=je.path.indexOf(y.$gc.sep,1);if(De!==-1){const Ae=je.path.substring(1,De),be=je.path.substring(De);let Ce=je.query;const ze=new URLSearchParams(je.query);ze.get("windowId")==="_blank"&&(ze.delete("windowId"),Ce=ze.toString());const Ue=f.URI.from({scheme:d.Schemas.vscodeRemote,authority:Ae,path:be,query:Ce,fragment:je.fragment});return(0,ve.$4i)(be)?{workspaceUri:Ue}:/:[\d]+$/.test(be)?{fileUri:Ue}:{folderUri:Ue}}}}}async O(je,De,Ae,be,Ce){this.m.trace("app#handleProtocolUrl():",be.toString(!0),Ce),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:f.URI.parse(be.query).path,query:""}));let ze=!1;const Ue=new URLSearchParams(be.query);Ue.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),Ue.delete("windowId"),be=be.with({query:Ue.toString()}),ze=!0):w.$j&&je.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),ze=!0);const Ge=Ue.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),Ue.delete("continueOn"),be=be.with({query:Ue.toString()}),this.s.continueOn=Ge??void 0);const We=this.N(be);return We?await this.M(We,je,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,be.toString(!0)),(0,wt.$Ob)(await je.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:ze,gotoLineMode:!0}))?.focus(),!0):ze?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,wt.$Ob)(await je.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,X.$Jm)(be)}))?.ready(),Ae.open(be,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ce),!1)}P(je,De){const Ae=this.B(this.j.createInstance(ue.$Kdc,je,De)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const ze=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new r.$qW(ze,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),be))(),sharedProcessClient:be}}async Q(je,De,Ae){const be=new G.$wi;switch(process.platform){case"win32":be.set(fe.$hX,new H.$vi(Me.$Vdc));break;case"linux":w.$l?be.set(fe.$hX,new H.$vi(Te.$Udc,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$hX,new H.$vi(Oe.$Tdc));break;case"darwin":be.set(fe.$hX,new H.$vi(Pe.$Sdc));break}be.set(ne.$Ecc,new H.$vi(de.$7dc,[je,De,this.h],!1)),be.set(pt.$pdc,new H.$vi(Mt.$oec,void 0,!1));const Ce=new O.$Acc(this.m,this.z);be.set(O.$zcc,Ce),be.set(N.$wdc,new H.$vi(N.$xdc,void 0,!1)),be.set(I.$bdc,new H.$vi(I.$cdc,void 0,!1)),be.set(D.$fn,a.ProxyChannel.toService((0,a.$ei)(Ae.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(le.$CKb,new H.$vi(Q.$sdc,[this.h])),be.set(M.$4W,new H.$vi(W.$ddc)),be.set(A.$tdc,new H.$vi(A.$udc)),be.set(x.$qdc,new H.$vi(x.$rdc,void 0,!1)),be.set(Be.$1dc,new H.$vi(He.$3dc)),be.set(Y.$Fdc,new H.$vi(Y.$Gdc)),be.set(ae.$edc,new H.$vi(te.$gdc)),be.set(ye.$4cc,new H.$vi(ye.$5cc)),be.set(ye.$6cc,new H.$vi(ye.$7cc));const ze=new At.$kec({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),Ue=new Rt.$As(ze,this.u,this.m,this.n);be.set(ft.$bs,Ue),w.$i?be.set(ce.$hdc,new H.$vi(J.$idc)):w.$j?be.set(ce.$hdc,new H.$vi(J.$jdc)):w.$k&&be.set(ce.$hdc,new H.$vi(J.$kdc));const Ge=new l.$9cc(this.s,this.u,this.m,this.w);be.set(o.$ycc,Ge);const We=new Ze.$Rcc(this.s,this.m,this.C,Ge,Ce);if(be.set(Ze.$Qcc,We),be.set(Ie.$Zfb,new H.$vi(Qe.$9dc,void 0,!1)),be.set(Le.$Cdc,new H.$vi(Le.$Ddc,void 0,!1)),be.set(Fe.$0W,new H.$vi(xe.$_W,void 0,!1)),(0,Z.$qp)(this.z,this.s)){const Ne=(0,Z.$vp)(this.z,this.u),Ve=(0,a.$ei)(Ae.then(at=>at.getChannel("telemetryAppender"))),Je=new Re.$Ndc(Ve),et=(0,Se.$hp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,je,De,Ne),nt=(0,Z.$wp)(this.s),tt={appenders:[Je],commonProperties:et,piiPaths:nt,sendErrorTelemetry:!0};be.set(ke.$4l,new H.$vi(we.$4r,[tt],!1))}else be.set(ke.$4l,Z.$lp);return be.set(ct.$tq,new H.$vi(jt.$aQ,void 0,!0)),be.set(lt.$xq,new H.$vi(Et.$_dc,void 0,!0)),be.set(ht.$iec,new H.$vi(ht.$jec,void 0,!0)),await ut.Promises.settled([Ge.initialize(),We.initialize()]),this.j.createChild(be)}R(je,De,Ae){const be=this.B(new m.$Tc),Ce=a.ProxyChannel.fromService(je.get(N.$wdc),be,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const ze=a.ProxyChannel.fromService(je.get(I.$bdc),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",ze);const Ue=be.add(new st.$0dc(je.get(_e.$ho)));De.registerChannel("policy",Ue),Ae.then(it=>it.registerChannel("policy",Ue));const Ge=this.y.getProvider(d.Schemas.file);(0,b.$ig)(Ge instanceof B.$dr);const We=be.add(new L.$ldc(Ge,this.m,this.s));De.registerChannel(V.$VP,We),Ae.then(it=>it.registerChannel(V.$VP,We));const Ne=a.ProxyChannel.fromService(je.get(Ye.$Hcc),be);De.registerChannel("userDataProfiles",Ne),Ae.then(it=>it.registerChannel("userDataProfiles",Ne));const Ve=new ot.$Yr(je.get(rt.$Rp));Ae.then(it=>it.registerChannel("request",Ve));const Je=new ge.$Odc(je.get(fe.$hX));De.registerChannel("update",Je);const et=a.ProxyChannel.fromService(je.get(le.$CKb),be);De.registerChannel("issue",et);const nt=a.ProxyChannel.fromService(je.get(M.$4W),be);De.registerChannel("encryption",nt);const tt=a.ProxyChannel.fromService(je.get(he.$Rl),be);De.registerChannel("sign",tt);const at=a.ProxyChannel.fromService(je.get(A.$tdc),be);De.registerChannel("keyboardLayout",at),this.f=je.get(x.$qdc);const yt=a.ProxyChannel.fromService(this.f,be);De.registerChannel("nativeHost",yt),Ae.then(it=>it.registerChannel("nativeHost",yt));const Lt=a.ProxyChannel.fromService(je.get(Ie.$Zfb),be);De.registerChannel("workspaces",Lt);const Ft=a.ProxyChannel.fromService(je.get(Y.$Fdc),be);De.registerChannel("menubar",Ft);const Wt=a.ProxyChannel.fromService(je.get(Fe.$0W),be);De.registerChannel("url",Wt);const Nt=a.ProxyChannel.fromService(je.get(Be.$1dc),be);De.registerChannel("webview",Nt);const vt=be.add(new $e.$Ldc(this.m,je.get(ye.$4cc)));De.registerChannel("storage",vt),Ae.then(it=>it.registerChannel("storage",vt));const Tt=be.add(new Pt.$bec(je.get(ye.$4cc),je.get(Ye.$Hcc),this.m));Ae.then(it=>it.registerChannel("profileStorageListener",Tt));const zt=a.ProxyChannel.fromService(je.get(ft.$bs),be);De.registerChannel(ft.TerminalIpcChannels.LocalPty,zt);const Bt=a.ProxyChannel.fromService(je.get(ce.$hdc),be);De.registerChannel("externalTerminal",Bt);const St=new It.$gec(je.get(Dt.$Scc));De.registerChannel("logger",St),Ae.then(it=>it.registerChannel("logger",St));const qt=new P.$0cc(je.get(ne.$Ecc));De.registerChannel("extensionhostdebugservice",qt);const Ut=a.ProxyChannel.fromService(je.get(ae.$edc),be);De.registerChannel(ae.$fdc,Ut);const Ht=a.ProxyChannel.fromService(je.get(ht.$iec),be);De.registerChannel(Ct.$hec,Ht)}async S(je,De){const Ae=this.b=je.get(ne.$Ecc);this.c=je.get(pt.$pdc);const be=(0,T.$Cm)(process.env)?0:4,Ce=this.s.args;if(De){if(De.openables.length>0)return Ae.open({context:be,cli:Ce,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const tt of De.urls){const at=new URLSearchParams(tt.uri.query);if(at.get("windowId")==="_blank")return at.delete("windowId"),tt.originalUrl=tt.uri.toString(!0),tt.uri=tt.uri.with({query:at.toString()}),Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const ze=global.macOpenFiles,Ue=Ce._.length,Ge=!!Ce["folder-uri"],We=!!Ce["file-uri"],Ne=Ce["skip-add-to-recently-opened"]===!0,Ve=Ce.wait&&Ce.waitMarkerFilePath?f.URI.file(Ce.waitMarkerFilePath):void 0,Je=Ce.remote||void 0,et=Ce.profile,nt=Ce["profile-temp"];if(!Ue&&!Ge&&!We){if(Ce["new-window"]||et||nt)return Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0,remoteAuthority:Je,forceProfile:et,forceTempProfile:nt});if(ze.length)return Ae.open({context:1,cli:Ce,urisToOpen:ze.map(tt=>(tt=(0,bt.$dm)(tt),(0,ve.$4i)(tt)?{workspaceUri:f.URI.file(tt)}:{fileUri:f.URI.file(tt)})),noRecentEntry:Ne,waitMarkerFileURI:Ve,initialStartup:!0})}return Ae.open({context:be,cli:Ce,forceNewWindow:Ce["new-window"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:Ne,waitMarkerFileURI:Ve,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Je,forceProfile:et,forceTempProfile:nt})}U(){this.W(),n.protocol.registerHttpProtocol(d.Schemas.vscodeRemoteResource,(je,De)=>{De({url:je.url.replace(/^vscode-remote-resource:/,"http:"),method:je.method})}),this.X(this.s.args,process.env,!0),this.Y(),w.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const je=this.z.win32MutexName;if(w.$i&&je)try{const De=await new Promise((be,Ce)=>{K(["@vscode/windows-mutex"],be,Ce)}),Ae=new De.Mutex(je);g.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(De){this.m.error(De)}}async X(je,De,Ae){try{return await(0,U.$Im)(this.u,this.m,je,De)}catch(be){const Ce=(0,E.$jj)(be);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,p.$Tn)(De)),Ce=(0,Z.$sp)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const ze=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$Ug)()}"`,"}"],Ue=De.substring(0,De.length-2).concat(`,
`,ze.join(`
`));await this.y.writeFile(this.s.argvResource,j.$He.fromString(Ue))}else{const ze=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);ze!==De&&await this.y.writeFile(this.s.argvResource,j.$He.fromString(ze))}}catch(je){this.m.error(je)}}};e.$pec=$t,e.$pec=$t=gt=Ee([ie(2,oe.$xi),ie(3,z.$5j),ie(4,z.$6j),ie(5,F.$tcc),ie(6,_.$Xcc),ie(7,$.$5i),ie(8,pe.$6P),ie(9,q.$5k),ie(10,ee.$lk),ie(11,Ye.$Hcc)],$t)}),define(se[317],re([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(K,e,n,C,k,R,j,E,u,c,g,p,v,m,d,y,w,b,f,h,S,a,t,r,s,i,o,l,$,P,D,I,O,M,W,F,T,U,ae,te,ce,J,V,q,L,B,H,oe,G,le,Q,A,N,_,z,Y,x,ee,X,ue,he,pe,$e,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(we){console.error(we.message),n.app.exit(1)}}async a(){(0,u.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[we,Z,fe,ge,Pe,Oe,Te,Me]=this.b();try{try{await this.d(fe,Me,ge,Pe,Te)}catch(Fe){throw this.g(fe,Te,Fe),Fe}await we.invokeFunction(async Fe=>{const qe=Fe.get(U.$5j),xe=Fe.get(F.$Xcc),Ke=Fe.get(P.$5k),Be=Fe.get(U.$6j),He=await this.f(qe,fe,xe,we,Te,!0);return f.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(Xe=>{qe.warn(`app#startup(): Error writing main lockfile: ${Xe.stack}`)}),Oe.logger=Be.createLogger("main",{name:(0,t.localize)(0,null)}),g.Event.once(xe.onWillShutdown)(Xe=>{Ke.dispose(),ge.dispose(),Xe.join("instanceLockfile",f.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),we.createInstance(a.$pec,He,Z).startup()})}catch(Fe){we.invokeFunction(this.j,Fe)}}b(){const we=new W.$wi,Z=new Y.$Tc;process.once("exit",()=>Z.dispose());const fe={_serviceBrand:void 0,...ae.default};we.set(te.$lk,fe);const ge=new o.$ucc(this.k(),fe),Pe=this.c(ge);we.set(o.$tcc,ge);const Oe=new X.$Tcc((0,U.$gk)(ge),ge.logsHome);we.set(X.$Scc,Oe);const Te=new T.$__b(Oe.getLogLevel()),Me=Z.add(new ue.$bQ(Te,[new U.$_j(Oe.getLogLevel())]));we.set(U.$5j,Me);const Fe=new D.$Mq(Me);we.set(P.$5k,Fe);const qe=new I.$dr(Me);Fe.registerProvider(v.Schemas.file,qe);const xe=new ee.$Es(Fe);we.set(x.$Cl,xe);const Ke=new pe.$9P(1,ge,Me,Fe);we.set(G.$5P,Ke),we.set(G.$6P,Ke);const Be=new A.$Icc(Ke,xe,ge,Fe,Me);we.set(A.$Hcc,Be),Fe.registerProvider(v.Schemas.vscodeUserData,new $e.$Aec(v.Schemas.file,qe,v.Schemas.vscodeUserData,Be,xe,Me));const He=y.$i&&fe.win32RegValueName?Z.add(new _.$yec(Me,fe.win32RegValueName)):ge.policyFile?Z.add(new z.$zec(ge.policyFile,Fe,Me)):new N.$jo;we.set(N.$ho,He);const Xe=new s.$Jo(Be.defaultProfile.settingsResource,Fe,He,Me);return we.set(r.$5i,Xe),we.set(F.$Xcc,new O.$vi(F.$Ycc,void 0,!1)),we.set(L.$Rp,new O.$vi(B.$wec,void 0,!0)),we.set(Q.$Ccc,new O.$vi(Q.$Dcc)),we.set(H.$Rl,new O.$vi(oe.$xec,void 0,!1)),we.set(V.$mw,new O.$vi(q.$uec)),we.set(ce.$Bcc,new J.$rec(ge,Be,Me)),[new M.$gr(we,!0),Pe,ge,Xe,Ke,Te,fe,Be]}c(we){const Z={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const ge=process.env[fe];typeof ge=="string"&&(Z[fe]=ge)}),Object.assign(process.env,Z),Z}async d(we,Z,fe,ge,Pe){await j.Promises.settled([Promise.all([this.e(we.extensionsPath),we.codeCachePath,we.logsHome.with({scheme:v.Schemas.file}).fsPath,Z.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,we.backupHome].map(Oe=>Oe?f.Promises.mkdir(Oe,{recursive:!0}):void 0)),ge.init(),fe.initialize()]),Z.init()}e(we){if(y.$i){const Z=(0,ye.getUNCHost)(we);Z&&(0,ye.addUNCHostToAllowlist)(Z)}return we}async f(we,Z,fe,ge,Pe,Oe){let Te;try{(0,d.mark)("code/willStartMainServer"),Te=await(0,S.$ti)(Z.mainIPCHandle),(0,d.mark)("code/didStartMainServer"),g.Event.once(fe.onWillShutdown)(()=>Te.dispose())}catch(Me){if(Me.code!=="EADDRINUSE")throw this.g(Z,Pe,Me),Me;let Fe;try{Fe=await(0,S.$ui)(Z.mainIPCHandle,"main")}catch(Be){if(!Oe||y.$i||Be.code!=="ECONNREFUSED")throw Be.code==="EPERM"&&this.h((0,t.localize)(1,null,Pe.nameShort),(0,t.localize)(2,null),Pe),Be;try{(0,C.unlinkSync)(Z.mainIPCHandle)}catch(He){throw we.warn("Could not delete obsolete instance handle",He),He}return this.f(we,Z,fe,ge,Pe,!1)}if(Z.extensionTestsLocationURI&&!Z.debugExtensionHost.break){const Be=`Running extension tests from the command line is currently only supported if no other instance of ${Pe.nameShort} is running.`;throw we.error(Be),Fe.dispose(),new Error(Be)}let qe;!Z.args.wait&&!Z.args.status&&(qe=setTimeout(()=>{this.h((0,t.localize)(3,null,Pe.nameShort),(0,t.localize)(4,null),Pe)},1e4));const xe=h.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Ke=h.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(Z.args.status)return ge.invokeFunction(async()=>{const Be=new i.$Ls(le.$lp,Pe),He=await Ke.getMainDiagnostics(),Xe=await Ke.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),ne=await Be.getDiagnostics(He,Xe);throw console.log(ne),new u.$ab});throw y.$i&&await this.i(xe,we),we.trace("Sending env to running instance..."),await xe.start(Z.args,process.env),Fe.dispose(),qe&&clearTimeout(qe),new u.$ab("Sent env to running instance. Terminating...")}if(Z.args.status)throw console.log((0,t.localize)(5,null,Pe.nameShort)),new u.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Te}g(we,Z,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const ge=(0,R.$Hb)([we.userDataPath,we.extensionsPath,S.$pi]).map(Pe=>(0,p.$Hw)(k.URI.file(Pe),{os:y.OS,tildify:we}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,E.$jj)(fe),ge.join(`
`)),Z)}}h(we,Z,fe){n.dialog.showMessageBoxSync((0,he.$Vw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:Z},fe).options)}async i(we,Z){if(y.$i){const fe=await we.getMainProcessId();Z.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((ge,Pe)=>{K(["windows-foreground-love"],ge,Pe)})).allowSetForegroundWindow(fe)}catch(ge){Z.error(ge)}}}j(we,Z){const fe=we.get(U.$5j),ge=we.get(F.$Xcc);let Pe=0;Z&&(Z.isExpected?Z.message&&fe.trace(Z.message):(Pe=1,Z.stack?fe.error(Z.stack):fe.error(`Startup error: ${Z.toString()}`))),ge.kill(Pe)}k(){const we=this.l((0,l.$zm)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Z=(0,$.$qec)(we.verbose);Z&&((0,l.$Bm)(process.argv,"--waitMarkerFilePath",Z),we.waitMarkerFilePath=Z)}return we}l(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Z=this.m(we._,we.goto);we._=Z}return we}m(we,Z){const fe=(0,w.cwd)(),ge=we.map(Te=>{let Me=String(Te),Fe;Z&&(Fe=(0,c.$Fg)(Me),Me=Fe.path),Me&&(Me=this.n(fe,Me));const qe=(0,c.$zg)(Me,fe),xe=(0,m.$nc)(qe);return xe&&!(0,c.$vg)(xe)?null:Z&&Fe?(Fe.path=qe,this.o(Fe)):qe}),Pe=y.$i||y.$j,Oe=(0,R.$Mb)(ge,Te=>Te&&Pe?Te.toLowerCase():Te||"");return(0,R.$Hb)(Oe)}n(we,Z){return y.$i&&(Z=(0,b.$hf)(Z,'"')),Z=(0,b.$ff)((0,b.$ff)(Z," "),"	"),y.$i&&(Z=(0,m.$kc)(we,Z),Z=(0,b.$hf)(Z,".")),Z}o(we){const Z=[we.path];return typeof we.line=="number"&&Z.push(String(we.line)),typeof we.column=="number"&&Z.push(String(we.column)),Z.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bbc4ba1eff648ee542972589216f211b7a6a08f2/core/vs/code/electron-main/main.js.map
