/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(X){for(var e=[],O=0,D=X.length;O<D;O++)e[O]=se[X[O]];return e};define(se[73],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const I=new Map,N=new Map,A=new Map,P=new Map;function l(y,p){y.has(p.detail)||y.set(p.detail,-p.timestamp)}function a(y,p){const R=y.get(p.detail);R&&(R>=0||y.set(p.detail,R+p.timestamp))}let u=[];typeof X=="function"&&typeof X.getStats=="function"&&(u=X.getStats().slice(0).sort((y,p)=>y.timestamp-p.timestamp));for(const y of u)switch(y.type){case 10:l(I,y);break;case 11:case 12:a(I,y);break;case 21:l(N,y);break;case 22:a(N,y);break;case 33:l(A,y);break;case 34:a(A,y);break;case 31:l(P,y);break;case 32:a(P,y);break}let v=0;A.forEach(y=>v+=y);function b(y){const p=[];return y.forEach((R,d)=>p.push([d,R])),p}return{amdLoad:b(I),amdInvoke:b(N),nodeRequire:b(A),nodeEval:b(P),nodeRequireTotal:v}}static toMarkdownTable(I,N){let A="";const P=[];return I.forEach((l,a)=>{P[a]=l.length}),N.forEach(l=>{l.forEach((a,u)=>{typeof a>"u"&&(a=l[u]="-");const v=a.toString().length;P[u]=Math.max(v,P[u])})}),I.forEach((l,a)=>{A+=`| ${l+" ".repeat(P[a]-l.toString().length)} `}),A+=`|
`,I.forEach((l,a)=>{A+=`| ${"-".repeat(P[a])} `}),A+=`|
`,N.forEach(l=>{l.forEach((a,u)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(P[u]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=O}),define(se[54],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=D,e.$4h=I,e.$5h=N;function O(A){return(P,l,a)=>{let u=null,v=null;if(typeof a.value=="function"?(u="value",v=a.value):typeof a.get=="function"&&(u="get",v=a.get),!v)throw new Error("not supported");a[u]=A(v,l)}}function D(A,P,l){let a=null,u=null;if(typeof l.value=="function"?(a="value",u=l.value,u.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(a="get",u=l.get),!u)throw new Error("not supported");const v=`$memoize$${P}`;l[a]=function(...b){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:u.apply(this,b)}),this[v]}}function I(A,P,l){return O((a,u)=>{const v=`$debounce$${u}`,b=`$debounce$result$${u}`;return function(...y){this[b]||(this[b]=l?l():void 0),clearTimeout(this[v]),P&&(this[b]=P(this[b],...y),y=[this[b]]),this[v]=setTimeout(()=>{a.apply(this,y),this[b]=l?l():void 0},A)}})}function N(A,P,l){return O((a,u)=>{const v=`$throttle$timer$${u}`,b=`$throttle$result$${u}`,y=`$throttle$lastRun$${u}`,p=`$throttle$pending$${u}`;return function(...R){if(this[b]||(this[b]=l?l():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[b]=P(this[b],...R)),this[p])return;const d=this[y]+A;d<=Date.now()?(this[y]=Date.now(),a.apply(this,[this[b]]),this[b]=l?l():void 0):(this[p]=!0,this[v]=setTimeout(()=>{this[p]=!1,this[y]=Date.now(),a.apply(this,[this[b]]),this[b]=l?l():void 0},d-Date.now()))}})}}),define(se[74],re([0,1,9]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=D,e.$ed=I,e.$fd=N,e.$gd=A,e.$hd=P,e.$id=l;function D(a,u){if(!a)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}function I(a,u="Unreachable"){throw new Error(u)}function N(a,u="unexpected state"){if(!a)throw new O.$cb(`Assertion Failed: ${u}`)}function A(a){a||(0,O.$1)(new O.$cb("Soft Assertion Failed"))}function P(a){if(!a()){debugger;a(),(0,O.$1)(new O.$cb("Assertion Failed"))}}function l(a,u){let v=0;for(;v<a.length-1;){const b=a[v],y=a[v+1];if(!u(b,y))return!1;v++}return!0}}),define(se[38],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=A,e.$Kn=v,e.$Ln=b,e.$Mn=y,e.$Nn=p,e.$On=R,e.$Pn=d,e.$Qn=c,e.$Rn=w,e.$Sn=$,e.$Tn=m,e.$Un=f;var O;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var D;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var N;(function(n){n.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(n,r=!1){let t=0;const i=n.length;let s="",o=0,h=16,S=0;function k(ie){let ue=0,le=0;for(;ue<ie;){const ce=n.charCodeAt(t);if(ce>=48&&ce<=57)le=le*16+ce-48;else if(ce>=65&&ce<=70)le=le*16+ce-65+10;else if(ce>=97&&ce<=102)le=le*16+ce-97+10;else break;t++,ue++}return ue<ie&&(le=-1),le}function j(ie){t=ie,s="",o=0,h=16,S=0}function L(){const ie=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&a(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&a(n.charCodeAt(t)))for(t++;t<n.length&&a(n.charCodeAt(t));)t++;else return S=3,n.substring(ie,t);let ue=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&a(n.charCodeAt(t))){for(t++;t<n.length&&a(n.charCodeAt(t));)t++;ue=t}else S=3;return n.substring(ie,ue)}function q(){let ie="",ue=t;for(;;){if(t>=i){ie+=n.substring(ue,t),S=2;break}const le=n.charCodeAt(t);if(le===34){ie+=n.substring(ue,t),t++;break}if(le===92){if(ie+=n.substring(ue,t),t++,t>=i){S=2;break}switch(n.charCodeAt(t++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const V=k(4);V>=0?ie+=String.fromCharCode(V):S=4;break}default:S=5}ue=t;continue}if(le>=0&&le<=31)if(l(le)){ie+=n.substring(ue,t),S=2;break}else S=6;t++}return ie}function C(){if(s="",S=0,o=t,t>=i)return o=i,h=17;let ie=n.charCodeAt(t);if(P(ie)){do t++,s+=String.fromCharCode(ie),ie=n.charCodeAt(t);while(P(ie));return h=15}if(l(ie))return t++,s+=String.fromCharCode(ie),ie===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),h=14;switch(ie){case 123:return t++,h=1;case 125:return t++,h=2;case 91:return t++,h=3;case 93:return t++,h=4;case 58:return t++,h=6;case 44:return t++,h=5;case 34:return t++,s=q(),h=10;case 47:{const ue=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!l(n.charCodeAt(t));)t++;return s=n.substring(ue,t),h=12}if(n.charCodeAt(t+1)===42){t+=2;const le=i-1;let ce=!1;for(;t<le;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,ce=!0;break}t++}return ce||(t++,S=1),s=n.substring(ue,t),h=13}return s+=String.fromCharCode(ie),t++,h=16}case 45:if(s+=String.fromCharCode(ie),t++,t===i||!a(n.charCodeAt(t)))return h=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=L(),h=11;default:for(;t<i&&J(ie);)t++,ie=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return h=8;case"false":return h=9;case"null":return h=7}return h=16}return s+=String.fromCharCode(ie),t++,h=16}}function J(ie){if(P(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let ie;do ie=C();while(ie>=12&&ie<=15);return ie}return{setPosition:j,getPosition:()=>t,scan:r?ne:C,getToken:()=>h,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>S}}function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var u;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(u||(u={}));function v(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let h=!1;function S(k,j,L,q){o.value=k,o.offset=j,o.length=L,o.type=q,o.colonOffset=void 0,s=o}try{$(n,{onObjectBegin:(k,j)=>{if(r<=k)throw i;s=void 0,h=r>k,t.push("")},onObjectProperty:(k,j,L)=>{if(r<j||(S(k,j,L,"property"),t[t.length-1]=k,r<=j+L))throw i},onObjectEnd:(k,j)=>{if(r<=k)throw i;s=void 0,t.pop()},onArrayBegin:(k,j)=>{if(r<=k)throw i;s=void 0,t.push(0)},onArrayEnd:(k,j)=>{if(r<=k)throw i;s=void 0,t.pop()},onLiteralValue:(k,j,L)=>{if(r<j||(S(k,j,L,f(k)),r<=j+L))throw i},onSeparator:(k,j,L)=>{if(r<=j)throw i;if(k===":"&&s&&s.type==="property")s.colonOffset=j,h=!1,s=void 0;else if(k===","){const q=t[t.length-1];typeof q=="number"?t[t.length-1]=q+1:(h=!0,t[t.length-1]=""),s=void 0}}})}catch(k){if(k!==i)throw k}return{path:t,previousNode:s,isAtPropertyKey:h,matches:k=>{let j=0;for(let L=0;j<k.length&&L<t.length;L++)if(k[j]===t[L]||k[j]==="*")j++;else if(k[j]!=="**")return!1;return j===k.length}}}function b(n,r=[],t=N.DEFAULT){let i=null,s=[];const o=[];function h(k){Array.isArray(s)?s.push(k):i!==null&&(s[i]=k)}return $(n,{onObjectBegin:()=>{const k={};h(k),o.push(s),s=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const k=[];h(k),o.push(s),s=k,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:h,onError:(k,j,L)=>{r.push({error:k,offset:j,length:L})}},t),s[0]}function y(n,r=[],t=N.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function o(k){return i.children.push(k),k}$(n,{onObjectBegin:k=>{i=o({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,j,L)=>{i=o({type:"property",offset:j,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:j,length:L,parent:i})},onObjectEnd:(k,j)=>{i.length=k+j-i.offset,i=i.parent,s(k+j)},onArrayBegin:(k,j)=>{i=o({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,j)=>{i.length=k+j-i.offset,i=i.parent,s(k+j)},onLiteralValue:(k,j,L)=>{o({type:f(k),offset:j,length:L,parent:i,value:k}),s(j+L)},onSeparator:(k,j,L)=>{i.type==="property"&&(k===":"?i.colonOffset=j:k===","&&s(j))},onError:(k,j,L)=>{r.push({error:k,offset:j,length:L})}},t);const S=i.children[0];return S&&delete S.parent,S}function p(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}function R(n){if(!n.parent||!n.parent.children)return[];const r=R(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}function d(n){switch(n.type){case"array":return n.children.map(d);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=d(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function c(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}function w(n,r,t=!1){if(c(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=w(i[s],r,t);if(o)return o}return n}}function $(n,r,t=N.DEFAULT){const i=A(n,!1);function s(Y){return Y?()=>Y(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,i.getTokenOffset(),i.getTokenLength()):()=>!0}const h=s(r.onObjectBegin),S=o(r.onObjectProperty),k=s(r.onObjectEnd),j=s(r.onArrayBegin),L=s(r.onArrayEnd),q=o(r.onLiteralValue),C=o(r.onSeparator),J=s(r.onComment),ne=o(r.onError),ie=t&&t.disallowComments,ue=t&&t.allowTrailingComma;function le(){for(;;){const Y=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:ie?ce(10):J();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],F=[]){if(ne(Y),_.length+F.length>0){let U=i.getToken();for(;U!==17;){if(_.indexOf(U)!==-1){le();break}else if(F.indexOf(U)!==-1)break;U=le()}}}function V(Y){const _=i.getTokenValue();return Y?q(_):S(_),le(),!0}function Z(){switch(i.getToken()){case 11:{let Y=0;try{Y=JSON.parse(i.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}q(Y);break}case 7:q(null);break;case 8:q(!0);break;case 9:q(!1);break;default:return!1}return le(),!0}function B(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(V(!1),i.getToken()===6?(C(":"),le(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function T(){h(),le();let Y=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),C(","),le(),i.getToken()===2&&ue)break}else Y&&ce(6,[],[]);B()||ce(4,[],[2,5]),Y=!0}return k(),i.getToken()!==2?ce(7,[2],[]):le(),!0}function H(){j(),le();let Y=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Y||ce(4,[],[]),C(","),le(),i.getToken()===4&&ue)break}else Y&&ce(6,[],[]);Q()||ce(4,[],[4,5]),Y=!0}return L(),i.getToken()!==4?ce(8,[4],[]):le(),!0}function Q(){switch(i.getToken()){case 3:return H();case 1:return T();case 10:return V(!0);default:return Z()}}return le(),i.getToken()===17?t.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function m(n,r){const t=A(n),i=[];let s,o=0,h;do switch(h=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==h&&i.push(n.substring(o,h)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[75],re([0,1,38]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=D,e.$Wn=I,e.$Xn=P,e.$Yn=l;function D(a,u,v){let b,y,p,R,d;if(u){for(R=u.offset,d=R+u.length,p=R;p>0&&!l(a,p-1);)p--;let h=d;for(;h<a.length&&!l(a,h);)h++;y=a.substring(p,h),b=A(y,v)}else y=a,b=0,p=0,R=0,d=a.length;const c=P(v,a);let w=!1,$=0,m;v.insertSpaces?m=N(" ",v.tabSize||4):m="	";const f=(0,O.$Jn)(y,!1);let n=!1;function r(){return c+N(m,b+$)}function t(){let h=f.scan();for(w=!1;h===15||h===14;)w=w||h===14,h=f.scan();return n=h===16||f.getTokenError()!==0,h}const i=[];function s(h,S,k){!n&&S<d&&k>R&&a.substring(S,k)!==h&&i.push({offset:S,length:k-S,content:h})}let o=t();if(o!==17){const h=f.getTokenOffset()+p,S=N(m,b);s(S,p,h)}for(;o!==17;){let h=f.getTokenOffset()+f.getTokenLength()+p,S=t(),k="";for(;!w&&(S===12||S===13);){const L=f.getTokenOffset()+p;s(" ",h,L),h=f.getTokenOffset()+f.getTokenLength()+p,k=S===12?r():"",S=t()}if(S===2)o!==1&&($--,k=r());else if(S===4)o!==3&&($--,k=r());else{switch(o){case 3:case 1:$++,k=r();break;case 5:case 12:k=r();break;case 13:w?k=r():k=" ";break;case 6:k=" ";break;case 10:if(S===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?k=" ":S!==5&&S!==17&&(n=!0);break;case 16:n=!0;break}w&&(S===12||S===13)&&(k=r())}const j=f.getTokenOffset()+p;s(k,h,j),o=S}return i}function I(a,u){const v=JSON.stringify(a,void 0,u.insertSpaces?u.tabSize||4:"	");return u.eol!==void 0?v.replace(/\r\n|\r|\n/g,u.eol):v}function N(a,u){let v="";for(let b=0;b<u;b++)v+=a;return v}function A(a,u){let v=0,b=0;const y=u.tabSize||4;for(;v<a.length;){const p=a.charAt(v);if(p===" ")b++;else if(p==="	")b+=y;else break;v++}return Math.floor(b/y)}function P(a,u){for(let v=0;v<u.length;v++){const b=u.charAt(v);if(b==="\r")return v+1<u.length&&u.charAt(v+1)===`
`?`\r
`:"\r";if(b===`
`)return`
`}return a&&a.eol||`
`}function l(a,u){return`\r
`.indexOf(a.charAt(u))!==-1}}),define(se[76],re([0,1,38,75]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=I,e.$1n=N,e.$2n=A,e.$3n=P,e.$4n=l;function I(a,u,v){return N(a,u,void 0,v)}function N(a,u,v,b,y){const p=u.slice(),R=[],d=(0,O.$Mn)(a,R);let c,w;for(;p.length>0&&(w=p.pop(),c=(0,O.$Nn)(d,p),c===void 0&&v!==void 0);)typeof w=="string"?v={[w]:v}:v=[v];if(c)if(c.type==="object"&&typeof w=="string"&&Array.isArray(c.children)){const $=(0,O.$Nn)(c,[w]);if($!==void 0)if(v===void 0){if(!$.parent)throw new Error("Malformed AST");const m=c.children.indexOf($.parent);let f,n=$.parent.offset+$.parent.length;if(m>0){const r=c.children[m-1];f=r.offset+r.length}else f=c.offset+1,c.children.length>1&&(n=c.children[1].offset);return A(a,{offset:f,length:n-f,content:""},b)}else return A(a,{offset:$.offset,length:$.length,content:JSON.stringify(v)},b);else{if(v===void 0)return[];const m=`${JSON.stringify(w)}: ${JSON.stringify(v)}`,f=y?y(c.children.map(r=>r.children[0].value)):c.children.length;let n;if(f>0){const r=c.children[f-1];n={offset:r.offset+r.length,length:0,content:","+m}}else c.children.length===0?n={offset:c.offset+1,length:0,content:m}:n={offset:c.offset+1,length:0,content:m+","};return A(a,n,b)}}else if(c.type==="array"&&typeof w=="number"&&Array.isArray(c.children))if(v!==void 0){const $=`${JSON.stringify(v)}`;let m;if(c.children.length===0||w===0)m={offset:c.offset+1,length:0,content:c.children.length===0?$:$+","};else{const f=w===-1||w>c.children.length?c.children.length:w,n=c.children[f-1];m={offset:n.offset+n.length,length:0,content:","+$}}return A(a,m,b)}else{const $=w,m=c.children[$];let f;if(c.children.length===1)f={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===$){const n=c.children[$-1],r=n.offset+n.length,t=c.offset+c.length;f={offset:r,length:t-2-r,content:""}}else f={offset:m.offset,length:c.children[$+1].offset-m.offset,content:""};return A(a,f,b)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${c.type}`);else return v===void 0?[]:A(a,{offset:d?d.offset:0,length:d?d.length:0,content:JSON.stringify(v)},b)}function A(a,u,v){let b=P(a,u),y=u.offset,p=u.offset+u.content.length;if(u.length===0||u.content.length===0){for(;y>0&&!(0,D.$Yn)(b,y-1);)y--;for(;p<b.length&&!(0,D.$Yn)(b,p);)p++}const R=(0,D.$Vn)(b,{offset:y,length:p-y},v);for(let c=R.length-1;c>=0;c--){const w=R[c];b=P(b,w),y=Math.min(y,w.offset),p=Math.max(p,w.offset+w.length),p+=w.content.length-w.length}const d=a.length-(b.length-p)-y;return[{offset:y,length:d,content:b.substring(y,p)}]}function P(a,u){return a.substring(0,u.offset)+u.content+a.substring(u.offset+u.length)}function l(a,u){const v=u.slice(0).sort((y,p)=>{const R=y.offset-p.offset;return R===0?y.length-p.length:R});let b=a.length;for(let y=v.length-1;y>=0;y--){const p=v[y];if(p.offset+p.length<=b)a=P(a,p);else throw new Error("Overlapping edit");b=p.offset}return a}}),define(se[77],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=O,e.rot=D;function O(P,l,a){return Math.min(Math.max(P,l),a)}function D(P,l){return(l+P%l)%l}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=I;class N{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=N;class A{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const a=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=A}),function(){function X(I){const N=[];typeof I=="number"&&N.push("code/timeOrigin",I);function A(l){N.push(l,Date.now())}function P(){const l=[];for(let a=0;a<N.length;a+=2)l.push({name:N[a],startTime:N[a+1]});return l}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(I+A.startTime)});return N}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function O(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=O(D))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var D in O)(typeof exports=="object"?exports:X)[D]=O[D]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function O(D){if(e[D])return e[D].exports;var I=e[D]={i:D,l:!1,exports:{}};return X[D].call(I.exports,I,I.exports,O),I.l=!0,I.exports}return O.m=X,O.c=e,O.d=function(D,I,N){O.o(D,I)||Object.defineProperty(D,I,{enumerable:!0,get:N})},O.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},O.t=function(D,I){if(1&I&&(D=O(D)),8&I||4&I&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(O.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&I&&typeof D!="string")for(var A in D)O.d(N,A,function(P){return D[P]}.bind(null,A));return N},O.n=function(D){var I=D&&D.__esModule?function(){return D.default}:function(){return D};return O.d(I,"a",I),I},O.o=function(D,I){return Object.prototype.hasOwnProperty.call(D,I)},O.p="",O(O.s=0)}([function(X,e,O){(function(D){var I;e=X.exports=F,I=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],l=e.src=[],a=0,u=a++;l[u]="0|[1-9]\\d*";var v=a++;l[v]="[0-9]+";var b=a++;l[b]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=a++;l[y]="("+l[u]+")\\.("+l[u]+")\\.("+l[u]+")";var p=a++;l[p]="("+l[v]+")\\.("+l[v]+")\\.("+l[v]+")";var R=a++;l[R]="(?:"+l[u]+"|"+l[b]+")";var d=a++;l[d]="(?:"+l[v]+"|"+l[b]+")";var c=a++;l[c]="(?:-("+l[R]+"(?:\\."+l[R]+")*))";var w=a++;l[w]="(?:-?("+l[d]+"(?:\\."+l[d]+")*))";var $=a++;l[$]="[0-9A-Za-z-]+";var m=a++;l[m]="(?:\\+("+l[$]+"(?:\\."+l[$]+")*))";var f=a++,n="v?"+l[y]+l[c]+"?"+l[m]+"?";l[f]="^"+n+"$";var r="[v=\\s]*"+l[p]+l[w]+"?"+l[m]+"?",t=a++;l[t]="^"+r+"$";var i=a++;l[i]="((?:<|>)?=?)";var s=a++;l[s]=l[v]+"|x|X|\\*";var o=a++;l[o]=l[u]+"|x|X|\\*";var h=a++;l[h]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[m]+"?)?)?";var S=a++;l[S]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[w]+")?"+l[m]+"?)?)?";var k=a++;l[k]="^"+l[i]+"\\s*"+l[h]+"$";var j=a++;l[j]="^"+l[i]+"\\s*"+l[S]+"$";var L=a++;l[L]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var q=a++;l[q]="(?:~>?)";var C=a++;l[C]="(\\s*)"+l[q]+"\\s+",P[C]=new RegExp(l[C],"g");var J=a++;l[J]="^"+l[q]+l[h]+"$";var ne=a++;l[ne]="^"+l[q]+l[S]+"$";var ie=a++;l[ie]="(?:\\^)";var ue=a++;l[ue]="(\\s*)"+l[ie]+"\\s+",P[ue]=new RegExp(l[ue],"g");var le=a++;l[le]="^"+l[ie]+l[h]+"$";var ce=a++;l[ce]="^"+l[ie]+l[S]+"$";var V=a++;l[V]="^"+l[i]+"\\s*("+r+")$|^$";var Z=a++;l[Z]="^"+l[i]+"\\s*("+n+")$|^$";var B=a++;l[B]="(\\s*)"+l[i]+"\\s*("+r+"|"+l[h]+")",P[B]=new RegExp(l[B],"g");var T=a++;l[T]="^\\s*("+l[h]+")\\s+-\\s+("+l[h]+")\\s*$";var H=a++;l[H]="^\\s*("+l[S]+")\\s+-\\s+("+l[S]+")\\s*$";var Q=a++;l[Q]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)I(Y,l[Y]),P[Y]||(P[Y]=new RegExp(l[Y]));function _(x,K){if(x instanceof F)return x;if(typeof x!="string"||x.length>N||!(K?P[t]:P[f]).test(x))return null;try{return new F(x,K)}catch{return null}}function F(x,K){if(x instanceof F){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof F))return new F(x,K);I("SemVer",x,K),this.loose=K;var ee=x.trim().match(K?P[t]:P[f]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ve=+ge;if(ve>=0&&ve<A)return ve}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,K){var ee=_(x,K);return ee?ee.version:null},e.clean=function(x,K){var ee=_(x.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof F||(x=new F(x,this.loose)),this.compareMain(x)||this.comparePre(x)},F.prototype.compareMain=function(x){return x instanceof F||(x=new F(x,this.loose)),g(this.major,x.major)||g(this.minor,x.minor)||g(this.patch,x.patch)},F.prototype.comparePre=function(x){if(x instanceof F||(x=new F(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=x.prerelease[K];if(I("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return g(ee,ge)}while(++K)},F.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new F(x,ee).inc(K,ge).version}catch{return null}},e.diff=function(x,K){if(G(x,K))return null;var ee=_(x),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return"pre"+ve;return"prerelease"}for(var ve in ee)if((ve==="major"||ve==="minor"||ve==="patch")&&ee[ve]!==ge[ve])return ve},e.compareIdentifiers=g;var U=/^[0-9]+$/;function g(x,K){var ee=U.test(x),ge=U.test(K);return ee&&ge&&(x=+x,K=+K),ee&&!ge?-1:ge&&!ee?1:x<K?-1:x>K?1:0}function E(x,K,ee){return new F(x,ee).compare(new F(K,ee))}function z(x,K,ee){return E(x,K,ee)>0}function M(x,K,ee){return E(x,K,ee)<0}function G(x,K,ee){return E(x,K,ee)===0}function W(x,K,ee){return E(x,K,ee)!==0}function te(x,K,ee){return E(x,K,ee)>=0}function ae(x,K,ee){return E(x,K,ee)<=0}function he(x,K,ee,ge){var ve;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),ve=x!==ee;break;case"":case"=":case"==":ve=G(x,ee,ge);break;case"!=":ve=W(x,ee,ge);break;case">":ve=z(x,ee,ge);break;case">=":ve=te(x,ee,ge);break;case"<":ve=M(x,ee,ge);break;case"<=":ve=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return ve}function pe(x,K){if(x instanceof pe){if(x.loose===K)return x;x=x.value}if(!(this instanceof pe))return new pe(x,K);I("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(x,K){return g(K,x)},e.major=function(x,K){return new F(x,K).major},e.minor=function(x,K){return new F(x,K).minor},e.patch=function(x,K){return new F(x,K).patch},e.compare=E,e.compareLoose=function(x,K){return E(x,K,!0)},e.rcompare=function(x,K,ee){return E(K,x,ee)},e.sort=function(x,K){return x.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(x,K){return x.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=z,e.lt=M,e.eq=G,e.neq=W,e.gte=te,e.lte=ae,e.cmp=he,e.Comparator=pe;var ye={};function fe(x,K){if(x instanceof fe)return x.loose===K?x:new fe(x.raw,K);if(x instanceof pe)return new fe(x.value,K);if(!(this instanceof fe))return new fe(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,K,ee,ge,ve,Oe,Se,Le,je,Ae,qe,De,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(ve)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(je)?"":me(Ae)?"<"+(+je+1)+".0.0":me(qe)?"<"+je+"."+(+Ae+1)+".0":De?"<="+je+"."+Ae+"."+qe+"-"+De:"<="+Le)).trim()}function we(x,K){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<x.length;ee++)if(I(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(x,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(x)}function Ie(x,K,ee,ge){var ve,Oe,Se,Le,je;switch(x=new F(x,ge),K=new fe(K,ge),ee){case">":ve=z,Oe=ae,Se=M,Le=">",je=">=";break;case"<":ve=M,Oe=te,Se=z,Le="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var qe=K.set[Ae],De=null,Ne=null;if(qe.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),De=De||ze,Ne=Ne||ze,ve(ze.semver,De.semver,ge)?De=ze:Se(ze.semver,Ne.semver,ge)&&(Ne=ze)}),De.operator===Le||De.operator===je||(!Ne.operator||Ne.operator===Le)&&Oe(x,Ne.semver)||Ne.operator===je&&Se(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var K=this.loose?P[V]:P[Z],ee=x.match(K);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new F(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new F(x,this.loose)),he(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,K){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(x.value,K),Ee(this.value,ee,K);if(x.operator==="")return ee=new fe(this.value,K),Ee(x.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Oe=this.semver.version===x.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=he(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),je=he(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||ve||Oe&&Se||Le||je},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),I("range",x,K);var ee=K?P[H]:P[T];x=x.replace(ee,de),I("hyphen replace",x),x=x.replace(P[B],"$1$2$3"),I("comparator trim",x,P[B]),x=(x=(x=x.replace(P[C],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var ge=K?P[V]:P[Z],ve=x.split(" ").map(function(Oe){return function(Se,Le){return I("comp",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(qe){return function(De,Ne){I("caret",De,Ne);var ze=Ne?P[ce]:P[le];return De.replace(ze,function(Fe,be,Pe,ke,Re){var Ue;return I("caret",De,Fe,be,Pe,ke,Re),me(be)?Ue="":me(Pe)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(ke)?Ue=be==="0"?">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+".0 <"+(+be+1)+".0.0":Re?(I("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+ke+Re+" <"+be+"."+Pe+"."+(+ke+1):">="+be+"."+Pe+"."+ke+Re+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+ke+Re+" <"+(+be+1)+".0.0"):(I("no pr"),Ue=be==="0"?Pe==="0"?">="+be+"."+Pe+"."+ke+" <"+be+"."+Pe+"."+(+ke+1):">="+be+"."+Pe+"."+ke+" <"+be+"."+(+Pe+1)+".0":">="+be+"."+Pe+"."+ke+" <"+(+be+1)+".0.0"),I("caret return",Ue),Ue})}(qe,Ae)}).join(" ")}(Se,Le),I("caret",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(qe){return function(De,Ne){var ze=Ne?P[ne]:P[J];return De.replace(ze,function(Fe,be,Pe,ke,Re){var Ue;return I("tilde",De,Fe,be,Pe,ke,Re),me(be)?Ue="":me(Pe)?Ue=">="+be+".0.0 <"+(+be+1)+".0.0":me(ke)?Ue=">="+be+"."+Pe+".0 <"+be+"."+(+Pe+1)+".0":Re?(I("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Ue=">="+be+"."+Pe+"."+ke+Re+" <"+be+"."+(+Pe+1)+".0"):Ue=">="+be+"."+Pe+"."+ke+" <"+be+"."+(+Pe+1)+".0",I("tilde return",Ue),Ue})}(qe,Ae)}).join(" ")}(Se,Le),I("tildes",Se),Se=function(je,Ae){return I("replaceXRanges",je,Ae),je.split(/\s+/).map(function(qe){return function(De,Ne){De=De.trim();var ze=Ne?P[j]:P[k];return De.replace(ze,function(Fe,be,Pe,ke,Re,Ue){I("xRange",De,Fe,be,Pe,ke,Re,Ue);var Ce=me(Pe),Me=Ce||me(ke),Te=Me||me(Re);return be==="="&&Te&&(be=""),Ce?Fe=be===">"||be==="<"?"<0.0.0":"*":be&&Te?(Me&&(ke=0),Te&&(Re=0),be===">"?(be=">=",Me?(Pe=+Pe+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):be==="<="&&(be="<",Me?Pe=+Pe+1:ke=+ke+1),Fe=be+Pe+"."+ke+"."+Re):Me?Fe=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Te&&(Fe=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),I("xRange return",Fe),Fe})}(qe,Ae)}).join(" ")}(Se,Le),I("xrange",Se),Se=function(je,Ae){return I("replaceStars",je,Ae),je.trim().replace(P[Q],"")}(Se,Le),I("stars",Se),Se}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Oe){return!!Oe.match(ge)})),ve=ve.map(function(Oe){return new pe(Oe,K)})},fe.prototype.intersects=function(x,K){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(ve){return ve.every(function(Oe){return ge.intersects(Oe,K)})})})})},e.toComparators=function(x,K){return new fe(x,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new F(x,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,K,ee){var ge=null,ve=null;try{var Oe=new fe(K,ee)}catch{return null}return x.forEach(function(Se){Oe.test(Se)&&(ge&&ve.compare(Se)!==-1||(ve=new F(ge=Se,ee)))}),ge},e.minSatisfying=function(x,K,ee){var ge=null,ve=null;try{var Oe=new fe(K,ee)}catch{return null}return x.forEach(function(Se){Oe.test(Se)&&(ge&&ve.compare(Se)!==1||(ve=new F(ge=Se,ee)))}),ge},e.validRange=function(x,K){try{return new fe(x,K).range||"*"}catch{return null}},e.ltr=function(x,K,ee){return Ie(x,K,"<",ee)},e.gtr=function(x,K,ee){return Ie(x,K,">",ee)},e.outside=Ie,e.prerelease=function(x,K){var ee=_(x,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,K,ee){return x=new fe(x,ee),K=new fe(K,ee),x.intersects(K)},e.coerce=function(x){if(x instanceof F)return x;if(typeof x!="string")return null;var K=x.match(P[L]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,O(1))},function(X,e){var O,D,I=X.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(d){if(O===setTimeout)return setTimeout(d,0);if((O===N||!O)&&setTimeout)return O=setTimeout,setTimeout(d,0);try{return O(d,0)}catch{try{return O.call(null,d,0)}catch{return O.call(this,d,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:N}catch{O=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var l,a=[],u=!1,v=-1;function b(){u&&l&&(u=!1,l.length?a=l.concat(a):v=-1,a.length&&y())}function y(){if(!u){var d=P(b);u=!0;for(var c=a.length;c;){for(l=a,a=[];++v<c;)l&&l[v].run();v=-1,c=a.length}l=null,u=!1,function(w){if(D===clearTimeout)return clearTimeout(w);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(w);try{D(w)}catch{try{return D.call(null,w)}catch{return D.call(this,w)}}}(d)}}function p(d,c){this.fun=d,this.array=c}function R(){}I.nextTick=function(d){var c=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)c[w-1]=arguments[w];a.push(new p(d,c)),a.length!==1||u||P(y)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=R,I.addListener=R,I.once=R,I.off=R,I.removeListener=R,I.removeAllListeners=R,I.emit=R,I.prependListener=R,I.prependOnceListener=R,I.listeners=function(d){return[]},I.binding=function(d){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(d){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(se[78],re([0,1]),function(X,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class D{constructor(P,l,a){this.level=P,this.key=l,this.value=a,this.forward=[]}}const I=void 0;class N{constructor(P,l=2**16){this.comparator=P,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(l)|0),this.e=new D(this.c,I,I)}get size(){return this.f}clear(){this.e=new D(this.c,I,I),this.f=0}has(P){return!!N.g(this,P,this.comparator)}get(P){return N.g(this,P,this.comparator)?.value}set(P,l){return N.h(this,P,l,this.comparator)&&(this.f+=1),this}delete(P){const l=N.k(this,P,this.comparator);return l&&(this.f-=1),l}forEach(P,l){let a=this.e.forward[0];for(;a;)P.call(l,a.value,a.key,this),a=a.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",l=this.e.forward[0];for(;l;)P+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return P}static g(P,l,a){let u=P.e;for(let v=P.d-1;v>=0;v--)for(;u.forward[v]&&a(u.forward[v].key,l)<0;)u=u.forward[v];if(u=u.forward[0],u&&a(u.key,l)===0)return u}static h(P,l,a,u){const v=[];let b=P.e;for(let y=P.d-1;y>=0;y--){for(;b.forward[y]&&u(b.forward[y].key,l)<0;)b=b.forward[y];v[y]=b}if(b=b.forward[0],b&&u(b.key,l)===0)return b.value=a,!1;{const y=N.j(P);if(y>P.d){for(let p=P.d;p<y;p++)v[p]=P.e;P.d=y}b=new D(y,l,a);for(let p=0;p<y;p++)b.forward[p]=v[p].forward[p],v[p].forward[p]=b;return!0}}static j(P,l=.5){let a=1;for(;Math.random()<l&&a<P.c;)a+=1;return a}static k(P,l,a){const u=[];let v=P.e;for(let b=P.d-1;b>=0;b--){for(;v.forward[b]&&a(v.forward[b].key,l)<0;)v=v.forward[b];u[b]=v}if(v=v.forward[0],!v||a(v.key,l)!==0)return!1;for(let b=0;b<P.d&&u[b].forward[b]===v;b++)u[b].forward[b]=v.forward[b];for(;P.d>0&&P.e.forward[P.d-1]===I;)P.d-=1;return!0}}e.$Ds=N}),define(se[46],re([0,1,9,2]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=I,e.$te=N,e.$ue=A,e.$ve=P,e.$we=a,e.$xe=u,e.$ye=v,e.$ze=b,e.$Ae=y,e.$Be=p,e.$Ce=R,e.$De=d,e.$Ee=c,e.$Fe=w,e.$Ge=$;function I(m){const f=m;return f?typeof f.read=="function":!1}function N(m){const f=m;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}function A(m){const f=m;return f?N(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}function P(m,f){return new l(m,f)}class l{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,O.$1)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let r;switch(f){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(m,f){const n=[];let r;for(;(r=m.read())!==null;)n.push(r);return f(n)}function u(m,f,n){const r=[];let t;for(;(t=m.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?f(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return m.read()}}}function v(m,f){return new Promise((n,r)=>{const t=[];b(m,{onData:i=>{f&&t.push(i)},onError:i=>{f?r(i):n(void 0)},onEnd:()=>{n(f?f(t):void 0)}})})}function b(m,f,n){m.on("error",r=>{n?.isCancellationRequested||f.onError(r)}),m.on("end",()=>{n?.isCancellationRequested||f.onEnd()}),m.on("data",r=>{n?.isCancellationRequested||f.onData(r)})}function y(m,f){return new Promise((n,r)=>{const t=new D.$Tc,i=[],s=S=>{if(i.push(S),i.length>f)return t.dispose(),m.pause(),n({stream:m,buffer:i,ended:!1})},o=S=>(t.dispose(),r(S)),h=()=>(t.dispose(),n({stream:m,buffer:i,ended:!0}));t.add((0,D.$Sc)(()=>m.removeListener("error",o))),m.on("error",o),t.add((0,D.$Sc)(()=>m.removeListener("end",h))),m.on("end",h),t.add((0,D.$Sc)(()=>m.removeListener("data",s))),m.on("data",s)})}function p(m,f){const n=P(f);return n.end(m),n}function R(){const m=P(()=>{throw new Error("not supported")});return m.end(),m}function d(m){let f=!1;return{read:()=>f?null:(f=!0,m)}}function c(m,f,n){const r=P(n);return b(m,{onData:t=>r.write(f.data(t)),onError:t=>r.error(f.error?f.error(t):t),onEnd:()=>r.end()}),r}function w(m,f,n){let r=!1;return{read:()=>{const t=f.read();return r?t:(r=!0,t!==null?n([m,t]):m)}}}function $(m,f,n){let r=!1;const t=P(n);return b(f,{onData:i=>r?t.write(i):(r=!0,t.write(n([m,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(m)),t.end()}}),t}}),define(se[14],re([0,1,169,46]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=a,e.$Je=u,e.$Ke=v,e.$Le=b,e.$Me=y,e.$Ne=p,e.$Oe=R,e.$Pe=d,e.$Qe=c,e.$Re=w,e.$Se=$,e.$Te=m,e.$Ue=f,e.$Ve=n,e.$We=r,e.$Xe=t,e.$Ye=i,e.$Ze=s,e.$1e=o,e.$2e=k;const I=typeof Buffer<"u",N=new O.$V(()=>new Uint8Array(256));let A,P;class l{static alloc(L){return I?new l(Buffer.allocUnsafe(L)):new l(new Uint8Array(L))}static wrap(L){return I&&!Buffer.isBuffer(L)&&(L=Buffer.from(L.buffer,L.byteOffset,L.byteLength)),new l(L)}static fromString(L,q){return!(q?.dontUseNodeBuffer||!1)&&I?new l(Buffer.from(L)):(A||(A=new TextEncoder),new l(A.encode(L)))}static fromByteArray(L){const q=l.alloc(L.length);for(let C=0,J=L.length;C<J;C++)q.buffer[C]=L[C];return q}static concat(L,q){if(typeof q>"u"){q=0;for(let ne=0,ie=L.length;ne<ie;ne++)q+=L[ne].byteLength}const C=l.alloc(q);let J=0;for(let ne=0,ie=L.length;ne<ie;ne++){const ue=L[ne];C.set(ue,J),J+=ue.byteLength}return C}constructor(L){this.buffer=L,this.byteLength=this.buffer.byteLength}clone(){const L=l.alloc(this.byteLength);return L.set(this),L}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(L,q){return new l(this.buffer.subarray(L,q))}set(L,q){if(L instanceof l)this.buffer.set(L.buffer,q);else if(L instanceof Uint8Array)this.buffer.set(L,q);else if(L instanceof ArrayBuffer)this.buffer.set(new Uint8Array(L),q);else if(ArrayBuffer.isView(L))this.buffer.set(new Uint8Array(L.buffer,L.byteOffset,L.byteLength),q);else throw new Error("Unknown argument 'array'")}readUInt32BE(L){return b(this.buffer,L)}writeUInt32BE(L,q){y(this.buffer,L,q)}readUInt32LE(L){return p(this.buffer,L)}writeUInt32LE(L,q){R(this.buffer,L,q)}readUInt8(L){return d(this.buffer,L)}writeUInt8(L,q){c(this.buffer,L,q)}indexOf(L,q=0){return a(this.buffer,L instanceof l?L.buffer:L,q)}}e.$He=l;function a(j,L,q=0){const C=L.byteLength,J=j.byteLength;if(C===0)return 0;if(C===1)return j.indexOf(L[0]);if(C>J-q)return-1;const ne=N.value;ne.fill(L.length);for(let ce=0;ce<L.length;ce++)ne[L[ce]]=L.length-ce-1;let ie=q+L.length-1,ue=ie,le=-1;for(;ie<J;)if(j[ie]===L[ue]){if(ue===0){le=ie;break}ie--,ue--}else ie+=Math.max(L.length-ue,ne[j[ie]]),ue=L.length-1;return le}function u(j,L){return j[L+0]<<0>>>0|j[L+1]<<8>>>0}function v(j,L,q){j[q+0]=L&255,L=L>>>8,j[q+1]=L&255}function b(j,L){return j[L]*2**24+j[L+1]*2**16+j[L+2]*2**8+j[L+3]}function y(j,L,q){j[q+3]=L,L=L>>>8,j[q+2]=L,L=L>>>8,j[q+1]=L,L=L>>>8,j[q]=L}function p(j,L){return j[L+0]<<0>>>0|j[L+1]<<8>>>0|j[L+2]<<16>>>0|j[L+3]<<24>>>0}function R(j,L,q){j[q+0]=L&255,L=L>>>8,j[q+1]=L&255,L=L>>>8,j[q+2]=L&255,L=L>>>8,j[q+3]=L&255}function d(j,L){return j[L]}function c(j,L,q){j[q]=L}function w(j){return D.$we(j,L=>l.concat(L))}function $(j){return D.$De(j)}function m(j){return D.$ye(j,L=>l.concat(L))}async function f(j){return j.ended?l.concat(j.buffer):l.concat([...j.buffer,await m(j.stream)])}function n(j){return D.$Be(j,L=>l.concat(L))}function r(j){return D.$Ee(j,{data:L=>typeof L=="string"?l.fromString(L):l.wrap(L)},L=>l.concat(L))}function t(j){return D.$ve(L=>l.concat(L),j)}function i(j,L){return D.$Fe(j,L,q=>l.concat(q))}function s(j,L){return D.$Ge(j,L,q=>l.concat(q))}function o(j){let L=0,q=0,C=0;const J=new Uint8Array(Math.floor(j.length/4*3)),ne=ue=>{switch(q){case 3:J[C++]=L|ue,q=0;break;case 2:J[C++]=L|ue>>>2,L=ue<<6,q=3;break;case 1:J[C++]=L|ue>>>4,L=ue<<4,q=2;break;default:L=ue<<2,q=1}};for(let ue=0;ue<j.length;ue++){const le=j.charCodeAt(ue);if(le>=65&&le<=90)ne(le-65);else if(le>=97&&le<=122)ne(le-97+26);else if(le>=48&&le<=57)ne(le-48+52);else if(le===43||le===45)ne(62);else if(le===47||le===95)ne(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${j[ue]}`)}}const ie=C;for(;q>0;)ne(0);return l.wrap(J).slice(0,ie)}const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:j},L=!0,q=!1){const C=q?S:h;let J="";const ne=j.byteLength%3;let ie=0;for(;ie<j.byteLength-ne;ie+=3){const ue=j[ie+0],le=j[ie+1],ce=j[ie+2];J+=C[ue>>>2],J+=C[(ue<<4|le>>>4)&63],J+=C[(le<<2|ce>>>6)&63],J+=C[ce&63]}if(ne===1){const ue=j[ie+0];J+=C[ue>>>2],J+=C[ue<<4&63],L&&(J+="==")}else if(ne===2){const ue=j[ie+0],le=j[ie+1];J+=C[ue>>>2],J+=C[(ue<<4|le>>>4)&63],J+=C[le<<2&63],L&&(J+="=")}return J}}),define(se[43],re([0,1,31]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=D,e.$nj=I,e.$oj=N,e.$pj=P,e.$rj=R;function D(c){return I(c,0)}function I(c,w){switch(typeof c){case"object":return c===null?N(349,w):Array.isArray(c)?l(c,w):a(c,w);case"string":return P(c,w);case"boolean":return A(c,w);case"number":return N(c,w);case"undefined":return N(937,w);default:return N(617,w)}}function N(c,w){return(w<<5)-w+c|0}function A(c,w){return N(c?433:863,w)}function P(c,w){w=N(149417,w);for(let $=0,m=c.length;$<m;$++)w=N(c.charCodeAt($),w);return w}function l(c,w){return w=N(104579,w),c.reduce(($,m)=>I(m,$),w)}function a(c,w){return w=N(181387,w),Object.keys(c).sort().reduce(($,m)=>($=P(m,$),I(c[m],$)),w)}class u{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=I(w,this.g),this.g}}e.$qj=u;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function b(c,w,$=32){const m=$-w,f=~((1<<m)-1);return(c<<w|(f&c)>>>m)>>>0}function y(c,w=0,$=c.byteLength,m=0){for(let f=0;f<$;f++)c[w+f]=m}function p(c,w,$="0"){for(;c.length<w;)c=$+c;return c}function R(c,w=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):p((c>>>0).toString(16),w/4)}class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const $=w.length;if($===0)return;const m=this.p;let f=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=w.charCodeAt(0),t=0);;){let i=r;if(O.$Df(r))if(t+1<$){const s=w.charCodeAt(t+1);O.$Ef(s)?(t++,i=O.$Ff(r,s)):i=65533}else{n=r;break}else O.$Ef(r)&&(i=65533);if(f=this.w(m,f,i),t++,t<$)r=w.charCodeAt(t);else break}this.r=f,this.u=n}w(w,$,m){return m<128?w[$++]=m:m<2048?(w[$++]=192|(m&1984)>>>6,w[$++]=128|(m&63)>>>0):m<65536?(w[$++]=224|(m&61440)>>>12,w[$++]=128|(m&4032)>>>6,w[$++]=128|(m&63)>>>0):(w[$++]=240|(m&1835008)>>>18,w[$++]=128|(m&258048)>>>12,w[$++]=128|(m&4032)>>>6,w[$++]=128|(m&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,w[0]=w[64],w[1]=w[65],w[2]=w[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=d.g,$=this.q;for(let h=0;h<64;h+=4)w.setUint32(h,$.getUint32(h,!1),!1);for(let h=64;h<320;h+=4)w.setUint32(h,b(w.getUint32(h-12,!1)^w.getUint32(h-32,!1)^w.getUint32(h-56,!1)^w.getUint32(h-64,!1),1),!1);let m=this.h,f=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let h=0;h<80;h++)h<20?(i=f&n|~f&r,s=1518500249):h<40?(i=f^n^r,s=1859775393):h<60?(i=f&n|f&r|n&r,s=2400959708):(i=f^n^r,s=3395469782),o=b(m,5)+i+t+s+w.getUint32(h*4,!1)&4294967295,t=r,r=n,n=b(f,30),f=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$sj=d}),define(se[55],re([0,1,31]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(D||(D={})),function(I){const N="error",A="warning",P="warn",l="info",a="ignore";function u(b){return b?O.$zf(N,b)?I.Error:O.$zf(A,b)||O.$zf(P,b)?I.Warning:O.$zf(l,b)?I.Info:I.Ignore:I.Ignore}I.fromValue=u;function v(b){switch(b){case I.Error:return N;case I.Warning:return A;case I.Info:return l;default:return a}}I.toString=v}(D||(D={})),e.default=D}),define(se[27],re([0,1,3]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=D,e.$6n=I,e.$7n=A,e.$8n=l,e.$9n=a,e.$0n=u,e.$$n=v,e.$_n=b,e.$ao=y,e.$bo=p,e.$co=R,e.$do=d,e.$eo=c;function D(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const $=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([m,f])=>{$[m]=f&&typeof f=="object"?D(f):f}),$}function I(w){if(!w||typeof w!="object")return w;const $=[w];for(;$.length>0;){const m=$.shift();Object.freeze(m);for(const f in m)if(N.call(m,f)){const n=m[f];typeof n=="object"&&!Object.isFrozen(n)&&!(0,O.$bg)(n)&&$.push(n)}}return w}const N=Object.prototype.hasOwnProperty;function A(w,$){return P(w,$,new Set)}function P(w,$,m){if((0,O.$hg)(w))return w;const f=$(w);if(typeof f<"u")return f;if(Array.isArray(w)){const n=[];for(const r of w)n.push(P(r,$,m));return n}if((0,O.$ag)(w)){if(m.has(w))throw new Error("Cannot clone recursive data-structure");m.add(w);const n={};for(const r in w)N.call(w,r)&&(n[r]=P(w[r],$,m));return m.delete(w),n}return w}function l(w,$,m=!0){return(0,O.$ag)(w)?((0,O.$ag)($)&&Object.keys($).forEach(f=>{f in w?m&&((0,O.$ag)(w[f])&&(0,O.$ag)($[f])?l(w[f],$[f],m):w[f]=$[f]):w[f]=$[f]}),w):$}function a(w,$){if(w===$)return!0;if(w==null||$===null||$===void 0||typeof w!=typeof $||typeof w!="object"||Array.isArray(w)!==Array.isArray($))return!1;let m,f;if(Array.isArray(w)){if(w.length!==$.length)return!1;for(m=0;m<w.length;m++)if(!a(w[m],$[m]))return!1}else{const n=[];for(f in w)n.push(f);n.sort();const r=[];for(f in $)r.push(f);if(r.sort(),!a(n,r))return!1;for(m=0;m<n.length;m++)if(!a(w[n[m]],$[n[m]]))return!1}return!0}function u(w){const $=new Set;return JSON.stringify(w,(m,f)=>{if((0,O.$ag)(f)||Array.isArray(f)){if($.has(f))return"[Circular]";$.add(f)}return typeof f=="bigint"?`[BigInt ${f.toString()}]`:f})}function v(w,$){const m=Object.create(null);return!w||!$||Object.keys($).forEach(n=>{const r=w[n],t=$[n];a(r,t)||(m[n]=t)}),m}function b(w,$){const m=$.toLowerCase(),f=Object.keys(w).find(n=>n.toLowerCase()===m);return f?w[f]:w[$]}function y(w,$){const m=Object.create(null);for(const[f,n]of Object.entries(w))$(f,n)&&(m[f]=n);return m}function p(w){let $=[];for(;Object.prototype!==w;)$=$.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return $}function R(w){const $=[];for(const m of p(w))typeof w[m]=="function"&&$.push(m);return $}function d(w,$){const m=n=>function(){const r=Array.prototype.slice.call(arguments,0);return $(n,r)},f={};for(const n of w)f[n]=m(n);return f}function c(w,$){const m={};for(const[f,n]of Object.entries(w))m[f]=$(n,f);return m}}),define(se[28],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=D;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(I){return O.test(I)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let l=0;l<P.length;l++)P[l]=Math.floor(Math.random()*256);return P};const N=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){I(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let l=0,a="";return a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+="-",a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a+=A[N[l++]],a}}()}),define(se[79],re([0,1,33]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=N;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(A){const P=A.replace(/\-/g,":").toLowerCase();return!D.has(P)}function N(){const A=(0,O.networkInterfaces)();for(const P in A){const l=A[P];if(l){for(const{mac:a}of l)if(I(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[80],re([7,4]),function(X,e){return X.create("vs/base/common/date",e)}),define(se[81],re([0,1,80]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=a,e.$5m=u,e.$6m=v;const D=60,I=D*60,N=I*24,A=N*7,P=N*30,l=N*365;function a(b,y,p,R){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,O.localize)(0,null,a(new Date().getTime()+d*1e3,!1));if(!R&&d<30)return(0,O.localize)(1,null);let c;return d<D?(c=d,y?c===1?p?(0,O.localize)(2,null,c):(0,O.localize)(3,null,c):p?(0,O.localize)(4,null,c):(0,O.localize)(5,null,c):c===1?p?(0,O.localize)(6,null,c):(0,O.localize)(7,null,c):p?(0,O.localize)(8,null,c):(0,O.localize)(9,null,c)):d<I?(c=Math.floor(d/D),y?c===1?p?(0,O.localize)(10,null,c):(0,O.localize)(11,null,c):p?(0,O.localize)(12,null,c):(0,O.localize)(13,null,c):c===1?p?(0,O.localize)(14,null,c):(0,O.localize)(15,null,c):p?(0,O.localize)(16,null,c):(0,O.localize)(17,null,c)):d<N?(c=Math.floor(d/I),y?c===1?p?(0,O.localize)(18,null,c):(0,O.localize)(19,null,c):p?(0,O.localize)(20,null,c):(0,O.localize)(21,null,c):c===1?p?(0,O.localize)(22,null,c):(0,O.localize)(23,null,c):p?(0,O.localize)(24,null,c):(0,O.localize)(25,null,c)):d<A?(c=Math.floor(d/N),y?c===1?(0,O.localize)(26,null,c):(0,O.localize)(27,null,c):c===1?(0,O.localize)(28,null,c):(0,O.localize)(29,null,c)):d<P?(c=Math.floor(d/A),y?c===1?p?(0,O.localize)(30,null,c):(0,O.localize)(31,null,c):p?(0,O.localize)(32,null,c):(0,O.localize)(33,null,c):c===1?p?(0,O.localize)(34,null,c):(0,O.localize)(35,null,c):p?(0,O.localize)(36,null,c):(0,O.localize)(37,null,c)):d<l?(c=Math.floor(d/P),y?c===1?p?(0,O.localize)(38,null,c):(0,O.localize)(39,null,c):p?(0,O.localize)(40,null,c):(0,O.localize)(41,null,c):c===1?p?(0,O.localize)(42,null,c):(0,O.localize)(43,null,c):p?(0,O.localize)(44,null,c):(0,O.localize)(45,null,c)):(c=Math.floor(d/l),y?c===1?p?(0,O.localize)(46,null,c):(0,O.localize)(47,null,c):p?(0,O.localize)(48,null,c):(0,O.localize)(49,null,c):c===1?p?(0,O.localize)(50,null,c):(0,O.localize)(51,null,c):p?(0,O.localize)(52,null,c):(0,O.localize)(53,null,c))}function u(b,y){const p=Math.abs(b/1e3);return p<1?y?(0,O.localize)(54,null,b):(0,O.localize)(55,null,b):p<D?y?(0,O.localize)(56,null,Math.round(b)/1e3):(0,O.localize)(57,null,Math.round(b)/1e3):p<I?y?(0,O.localize)(58,null,Math.round(b/(1e3*D))):(0,O.localize)(59,null,Math.round(b/(1e3*D))):p<N?y?(0,O.localize)(60,null,Math.round(b/(1e3*I))):(0,O.localize)(61,null,Math.round(b/(1e3*I))):(0,O.localize)(62,null,Math.round(b/(1e3*N)))}function v(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[82],re([7,4]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(se[34],re([0,1,19,3,82]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=l,e.$kj=a,e.$lj=u;function N(v,b){return b&&(v.stack||v.stacktrace)?I.localize(0,null,P(v),A(v.stack)||A(v.stacktrace)):P(v)}function A(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?I.localize(1,null,v.message):v.message||I.localize(2,null)}function l(v=null,b=!1){if(!v)return I.localize(3,null);if(Array.isArray(v)){const y=O.$Hb(v),p=l(y[0],b);return y.length>1?I.localize(4,null,p,y.length):p}if(D.$$f(v))return v;if(v.detail){const y=v.detail;if(y.error)return N(y.error,b);if(y.exception)return N(y.exception,b)}return v.stack?N(v,b):v.message?v.message:I.localize(5,null)}function a(v){const b=v;return b instanceof Error&&Array.isArray(b.actions)}function u(v,b){let y;return typeof v=="string"?y=new Error(v):y=v,y.actions=b,y}}),define(se[83],re([7,4]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(se[84],re([0,1,83]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=D;function D(I){switch(I){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}}),define(se[56],re([0,1,12]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=N,e.$pm=A;var D;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(D||(e.Source=D={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function N(P,...l){const a=l.reduce((b,y)=>(b[y]=!0,b),{}),u=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(b=>!a[b]).forEach(b=>{for(let y=0;y<u.length;y++)if(b.search(u[y])!==-1){delete P[b];break}})}function A(P){P&&(delete P.DEBUG,O.$j&&delete P.DYLD_LIBRARY_PATH,O.$k&&delete P.LD_PRELOAD)}}),define(se[85],re([0,1,11]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=D,e.$1q=I,e.$2q=N,e.log=P;function D(a){const u=a;return u&&typeof u.type=="string"&&typeof u.severity=="string"}function I(a){const u=[];let v;try{const b=JSON.parse(a.arguments),y=b[b.length-1];y&&y.__$stack&&(b.pop(),v=y.__$stack),u.push(...b)}catch{u.push("Unable to log remote console arguments",a.arguments)}return{args:u,stack:v}}function N(a){if(typeof a!="string")return N(I(a).stack);const u=a;if(u){const v=A(u),b=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(b&&b.length===4)return{uri:O.URI.file(b[1]),line:Number(b[2]),column:Number(b[3])}}}function A(a){if(!a)return a;const u=a.indexOf(`
`);return u===-1?a:a.substring(0,u)}function P(a,u){const{args:v,stack:b}=I(a),y=typeof v[0]=="string"&&v.length===1;let p=A(b);p&&(p=`(${p.trim()})`);let R=[];if(typeof v[0]=="string"?p&&y?R=[`%c[${u}] %c${v[0]} %c${p}`,l("blue"),l(""),l("grey")]:R=[`%c[${u}] %c${v[0]}`,l("blue"),l(""),...v.slice(1)]:R=[`%c[${u}]%`,l("blue"),...v],p&&!y&&R.push(p),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function l(a){return`color: ${a}`}}),define(se[47],re([0,1,14,11]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=I,e.$7h=N,e.$8h=P;function I(l){return JSON.stringify(l,A)}function N(l){let a=JSON.parse(l);return a=P(a),a}function A(l,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return D.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof O.$He||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let u=0;u<l.length;++u)l[u]=P(l[u],a+1);else for(const u in l)Object.hasOwnProperty.call(l,u)&&(l[u]=P(l[u],a+1))}return l}}),define(se[86],re([0,1,73,15,12,11]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=u;class A{constructor(b,y,p){this.id=b,this.dependencies=y,this.callback=p}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(b,y,p)=>{typeof b!="string"&&(p=y,y=b,b=null),(typeof y!="object"||!Array.isArray(y))&&(p=y,y=null),this.c.push(new A(b,y,p))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){if(b.startsWith(window.location.origin)||b.startsWith("vscode-file://vscode-app"))return b;throw new Error(`[trusted_script_src] Invalid script url: ${b}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(b){return b}})))}async load(b){this.g();const y=await(this.a?this.i(b):this.b?this.h(b):this.j(b));if(!y)throw new Error(`Did not receive a define call from script ${b}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${b}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(b){return new Promise((y,p)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const d=()=>{R.removeEventListener("load",c),R.removeEventListener("error",w)},c=$=>{d(),y(this.c.pop())},w=$=>{d(),p($)};R.addEventListener("load",c),R.addEventListener("error",w),this.f&&(b=this.f.createScriptURL(b)),R.setAttribute("src",b),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(b){return new Promise((y,p)=>{try{this.f&&(b=this.f.createScriptURL(b)),importScripts(b),y(this.c.pop())}catch(R){p(R)}})}async j(b){try{const y=globalThis._VSCODE_NODE_MODULES.fs,p=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,d=N.URI.parse(b).fsPath,c=y.readFileSync(d).toString(),w=R.wrap(c.replace(/^#!.*/,""));return new p.Script(w).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const l=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function u(v,b,y){if(O.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[v]&&(v=a[v]);const p=`${v}/${b}`;if(l.has(p))return l.get(p);let R;if(/^\w[\w\d+.-]*:\/\//.test(p))R=p;else{const $=`${y&&!I.$o?D.$Pg:D.$Og}/${p}`;R=D.$Sg.asBrowserUri($).toString(!0)}const d=P.INSTANCE.load(R);return l.set(p,d),d}else return await new Promise((p,R)=>{X([v],p,R)})}}),define(se[87],re([0,1,33,48,28,79,12]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=l,e.$In=v,e.$Gn=new class{c(b){return this.a||(this.a=D.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(b)}value(){if(this.b===void 0){let b=0,y=0;const p=(0,O.networkInterfaces)();for(const R in p){const d=p[R];if(d)for(const{mac:c,internal:w}of d)w||(y+=1,this.c(c.toUpperCase())&&(b+=1))}this.b=y>0?b/y:0}return this.b}};let P;async function l(b){return P||(P=(async()=>await a(b)||I.$Ug())()),P}async function a(b){try{const y=await new Promise((R,d)=>{X(["crypto"],R,d)}),p=(0,N.$Fn)();return y.createHash("sha256").update(p,"utf8").digest("hex")}catch(y){b(y);return}}const u="Software\\Microsoft\\SQMClient";async function v(b){if(A.$i){const y=await new Promise((p,R)=>{X(["@vscode/windows-registry"],p,R)});try{return y.GetStringRegKey("HKEY_LOCAL_MACHINE",u,"MachineId")||""}catch(p){return b(p),""}}return""}}),define(se[88],re([0,1,33,16,25]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=w,e.$nm=$;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var l;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(l||(l={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let u;process.env.PROCESSOR_ARCHITEW6432?u=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?u=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?u=1:u=0;class v{constructor(f,n,r){this.exePath=f,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await I.SymlinkSupport.existsFile(this.exePath)),this.a}}function b({useAlternateBitness:m=!1}={}){return m?a===0?process.env["ProgramFiles(x86)"]||null:u===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:f=!1}={}){const n=b({useAlternateBitness:m});if(!n)return null;const r=D.$jc(n,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const h of await I.Promises.readdir(r)){let S=-1;if(f){const j=h.indexOf("-");if(j<0)continue;const L=h.substring(0,j);if(!N.test(L)||h.substring(j+1)!=="preview")continue;S=parseInt(L,10)}else{if(!N.test(h))continue;S=parseInt(h,10)}if(S<=t)continue;const k=D.$jc(r,h,"pwsh.exe");await I.SymlinkSupport.existsFile(k)&&(i=k,t=S)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=f?" Preview":"";return new v(i,`PowerShell${o}${s}`,!0)}async function p({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const f=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await I.Promises.readdir(f))if(n.test(t)){const i=D.$jc(f,t,"pwsh.exe");return new v(i,r)}return null}function R(){const m=D.$jc(O.homedir(),".dotnet","tools","pwsh.exe");return new v(m,".NET Core PowerShell Global Tool")}function d(){const m=D.$jc(process.env.windir,a===1&&u!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(m,"Windows PowerShell",!0)}async function*c(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await p(),m&&(yield m),m=R(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await p({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=d(),m&&(yield m)}async function*w(){for await(const m of c())await m.exists()&&(yield m)}async function $(){for await(const m of w())return m;return null}}),define(se[57],re([0,1,16,12,35,56,3,25]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=l,e.$rm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function l(v=I.env){return v.comspec||"cmd.exe"}function a(v){let b=[],y=!1;const p=function(R){if(y){b.push(R);return}(!v.send(R,c=>{if(c&&console.error(c),y=!1,b.length>0){const w=b.slice(0);b=[],w.forEach($=>p($))}})||D.$i)&&(y=!0)};return{send:p}}var u;(function(v){async function b(y,p,R){if(O.$ic(y))return y;if(p===void 0&&(p=I.cwd()),O.$mc(y)!=="."||(R===void 0&&A.$$f(I.env.PATH)&&(R=I.env.PATH.split(O.$tc)),R===void 0||R.length===0))return O.$jc(p,y);async function c(w){if(await P.Promises.exists(w)){let $;try{$=await P.Promises.stat(w)}catch(m){m.message.startsWith("EACCES")&&($=await P.Promises.lstat(w))}return $?!$.isDirectory():!1}return!1}for(const w of R){let $;if(O.$ic(w)?$=O.$jc(w,y):$=O.$jc(p,w,y),await c($))return $;let m=$+".com";if(await c(m)||(m=$+".exe",await c(m)))return m}return O.$jc(p,y)}v.findExecutable=b})(u||(e.win32=u={}))}),define(se[89],re([0,1,33,12,88,57]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=A;async function A(v,b){return v===1?D.$i?u():N.$qm(b):l(v,b)}let P=null;function l(v,b){if(D.$k&&v===2||D.$j&&v===3)return"/bin/bash";if(!P){let y;if(D.$i)y="/bin/bash";else{if(y=b.SHELL,!y)try{y=(0,O.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}P=y}return P}let a=null;async function u(){return a||(a=(await(0,I.$nm)()).exePath),a}});var $e=this&&this.__decorate||function(X,e,O,D){var I=arguments.length,N=I<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,O):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(X,e,O,D);else for(var P=X.length-1;P>=0;P--)(A=X[P])&&(N=(I<3?A(N):I>3?A(e,O,N):A(e,O))||N);return I>3&&N&&Object.defineProperty(e,O,N),N};define(se[58],re([0,1,19,8,14,20,54,9,5,2,47,31,3]),function(X,e,O,D,I,N,A,P,l,a,u,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=o,e.$_h=h,e.$ei=C,e.$fi=J;var y;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(y||(y={}));function p(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(R||(R={}));function d(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function w(B){let T=0;for(let H=0;;H+=7){const Q=B.read(1);if(T|=(Q.buffer[0]&127)<<H,!(Q.buffer[0]&128))return T}}const $=t(0);function m(B,T){if(T===0){B.write($);return}let H=0;for(let Y=T;Y!==0;Y=Y>>>7)H++;const Q=I.$He.alloc(H);for(let Y=0;T!==0;Y++)Q.buffer[Y]=T&127,T=T>>>7,T>0&&(Q.buffer[Y]|=128);B.write(Q)}class f{constructor(T){this.b=T,this.a=0}read(T){const H=this.b.slice(this.a,this.a+T);return this.a+=H.byteLength,H}}e.$9h=f;class n{constructor(){this.a=[]}get buffer(){return I.$He.concat(this.a)}write(T){this.a.push(T)}}e.$0h=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function t(B){const T=I.$He.alloc(1);return T.writeUInt8(B,0),T}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(B,T){if(typeof T>"u")B.write(i.Undefined);else if(typeof T=="string"){const H=I.$He.fromString(T);B.write(i.String),m(B,H.byteLength),B.write(H)}else if(s&&Buffer.isBuffer(T)){const H=I.$He.wrap(T);B.write(i.Buffer),m(B,H.byteLength),B.write(H)}else if(T instanceof I.$He)B.write(i.VSBuffer),m(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(i.Array),m(B,T.length);for(const H of T)o(B,H)}else if(typeof T=="number"&&(T|0)===T)B.write(i.Uint),m(B,T);else{const H=I.$He.fromString(JSON.stringify(T));B.write(i.Object),m(B,H.byteLength),B.write(H)}}function h(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(w(B)).toString();case r.Buffer:return B.read(w(B)).buffer;case r.VSBuffer:return B.read(w(B));case r.Array:{const H=w(B),Q=[];for(let Y=0;Y<H;Y++)Q.push(h(B));return Q}case r.Object:return JSON.parse(B.read(w(B)).toString());case r.Int:return w(B)}}class S{constructor(T,H,Q=null,Y=1e3){this.h=T,this.j=H,this.k=Q,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,H){this.b.set(T,H),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const H=this.o([T.type]);this.k?.logOutgoing(H,0,1,d(T.type));return}case 201:case 202:case 204:case 203:{const H=this.o([T.type,T.id],T.data);this.k?.logOutgoing(H,T.id,1,d(T.type),T.data);return}}}o(T,H=void 0){const Q=new n;return o(Q,T),o(Q,H),this.p(Q.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const H=new f(T),Q=h(H),Y=h(H),_=Q[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Q[1],1,`${p(_)}: ${Q[2]}.${Q[3]}`,Y),this.s({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 102:return this.k?.logIncoming(T.byteLength,Q[1],1,`${p(_)}: ${Q[2]}.${Q[3]}`,Y),this.t({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 101:return this.k?.logIncoming(T.byteLength,Q[1],1,`${p(_)}`),this.u({type:_,id:Q[1]});case 103:return this.k?.logIncoming(T.byteLength,Q[1],1,`${p(_)}`),this.u({type:_,id:Q[1]})}}s(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const Q=new N.$qe;let Y;try{Y=H.call(this.j,T.name,T.arg,Q.token)}catch(U){Y=Promise.reject(U)}const _=T.id;Y.then(U=>{this.m({id:_,data:U,type:201})},U=>{U instanceof Error?this.m({id:_,data:{message:U.message,name:U.name,stack:U.stack?U.stack.split?U.stack.split(`
`):U.stack:void 0},type:202}):this.m({id:_,data:U,type:203})}).finally(()=>{F.dispose(),this.d.delete(T.id)});const F=(0,a.$Sc)(()=>Q.cancel());this.d.set(T.id,F)}t(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const Q=T.id,_=H.listen(this.j,T.name,T.arg)(F=>this.m({id:Q,data:F,type:204}));this.d.set(T.id,_)}u(T){const H=this.d.get(T.id);H&&(H.dispose(),this.d.delete(T.id))}v(T){let H=this.g.get(T.channelName);H||(H=[],this.g.set(T.channelName,H));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:T,timeoutTimer:Q})}w(T){const H=this.g.get(T);if(H){for(const Q of H)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$ai=S;var k;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(k||(e.RequestInitiator=k={}));class j{constructor(T,H=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=H}getChannel(T){const H=this;return{call(Q,Y,_){return H.a?Promise.reject(new P.$5):H.m(T,Q,Y,_)},listen(Q,Y){return H.a?l.Event.None:H.o(T,Q,Y)}}}m(T,H,Q,Y=N.CancellationToken.None){const _=this.g++,U={id:_,type:100,channelName:T,name:H,arg:Q};if(Y.isCancellationRequested)return Promise.reject(new P.$5);let g;return new Promise((z,M)=>{if(Y.isCancellationRequested)return M(new P.$5);const G=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(_),z(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,M(ye);break}case 203:this.f.delete(_),M(pe.data);break}};this.f.set(_,he),this.p(U)};let W=null;this.b===c.Idle?G():(W=(0,D.$lh)(he=>this.u()),W.then(()=>{W=null,G()}));const te=()=>{W?(W.cancel(),W=null):this.p({id:_,type:101}),M(new P.$5)},ae=Y.onCancellationRequested(te);g=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(g)}).finally(()=>{g.dispose(),this.d.delete(g)})}o(T,H,Q){const Y=this.g++,F={id:Y,type:102,channelName:T,name:H,arg:Q};let U=null;const g=new l.$fe({onWillAddFirstListener:()=>{U=(0,D.$lh)(z=>this.u()),U.then(()=>{U=null,this.d.add(g),this.p(F)})},onDidRemoveLastListener:()=>{U?(U.cancel(),U=null):(this.d.delete(g),this.p({id:Y,type:103}))}}),E=z=>g.fire(z.data);return this.f.set(Y,E),g.event}p(T){switch(T.type){case 100:case 102:{const H=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(H,T.id,0,`${p(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const H=this.q([T.type,T.id]);this.j?.logOutgoing(H,T.id,0,p(T.type));return}}}q(T,H=void 0){const Q=new n;return o(Q,T),o(Q,H),this.r(Q.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const H=new f(T),Q=h(H),Y=h(H),_=Q[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,d(_)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Q[1],0,d(_),Y),this.t({type:Q[0],id:Q[1],data:Y})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$bi=j,$e([A.$3h],j.prototype,"onDidInitializePromise",null);class L{get connections(){const T=[];return this.f.forEach(H=>T.push(H)),T}constructor(T,H,Q){this.a=new Map,this.f=new Set,this.g=new l.$fe,this.onDidAddConnection=this.g.event,this.h=new l.$fe,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(T(({protocol:Y,onDidClientDisconnect:_})=>{const F=l.Event.once(Y.onMessage);this.j.add(F(U=>{const g=new f(U),E=h(g),z=new S(Y,E,H,Q),M=new j(Y,H);this.a.forEach((W,te)=>z.registerChannel(te,W));const G={channelServer:z,channelClient:M,ctx:E};this.f.add(G),this.g.fire(G),this.j.add(_(()=>{z.dispose(),M.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(T,H){const Q=this;return{call(Y,_,F){let U;if((0,b.$mg)(H)){const E=(0,O.$3b)(Q.connections.filter(H));U=E?Promise.resolve(E):l.Event.toPromise(l.Event.filter(Q.onDidAddConnection,H))}else U=H.routeCall(Q,Y,_);const g=U.then(E=>E.channelClient.getChannel(T));return C(g).call(Y,_,F)},listen(Y,_){if((0,b.$mg)(H))return Q.k(T,H,Y,_);const F=H.routeEvent(Q,Y,_).then(U=>U.channelClient.getChannel(T));return C(F).listen(Y,_)}}}k(T,H,Q,Y){const _=this;let F;const U=new l.$fe({onWillAddFirstListener:()=>{F=new a.$Tc;const g=new l.$le,E=new Map,z=G=>{const te=G.channelClient.getChannel(T).listen(Q,Y),ae=g.add(te);E.set(G,ae)},M=G=>{const W=E.get(G);W&&(W.dispose(),E.delete(G))};_.connections.filter(H).forEach(z),l.Event.filter(_.onDidAddConnection,H)(z,void 0,F),_.onDidRemoveConnection(M,void 0,F),g.event(U.fire,U,F),F.add(g)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return U.event}registerChannel(T,H){this.a.set(T,H);for(const Q of this.f)Q.channelServer.registerChannel(T,H)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=L;class q{constructor(T,H,Q=null){const Y=new n;o(Y,H),T.send(Y.buffer),this.a=new j(T,Q),this.d=new S(T,H,Q)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,H){this.d.registerChannel(T,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=q;function C(B){return{call(T,H,Q){return B.then(Y=>Y.call(T,H,Q))},listen(T,H){const Q=new l.$oe;return B.then(Y=>Q.input=Y.listen(T,H)),Q.event}}}function J(B){let T=!1;return{call(H,Q,Y){return T?B.call(H,Q,Y):(0,D.$zh)(0).then(()=>T=!0).then(()=>B.call(H,Q,Y))},listen(H,Q){if(T)return B.listen(H,Q);const Y=new l.$oe;return(0,D.$zh)(0).then(()=>T=!0).then(()=>Y.input=B.listen(H,Q)),Y.event}}}class ne{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const H of T.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await l.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$gi=ne;var ie;(function(B){function T(_,F,U){const g=_,E=U&&U.disableMarshalling,z=new Map;for(const M in g)Q(M)&&z.set(M,l.Event.buffer(g[M],!0,void 0,F));return new class{listen(M,G,W){const te=z.get(G);if(te)return te;const ae=g[G];if(typeof ae=="function"){if(Y(G))return ae.call(g,W);if(Q(G))return z.set(G,l.Event.buffer(g[G],!0,void 0,F)),z.get(G)}throw new P.$bb(`Event not found: ${G}`)}call(M,G,W){const te=g[G];if(typeof te=="function"){if(!E&&Array.isArray(W))for(let he=0;he<W.length;he++)W[he]=(0,u.$8h)(W[he]);let ae=te.apply(g,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new P.$bb(`Method not found: ${G}`)}}}B.fromService=T;function H(_,F){const U=F&&F.disableMarshalling;return new Proxy({},{get(g,E){if(typeof E=="string")return F?.properties?.has(E)?F.properties.get(E):Y(E)?function(z){return _.listen(E,z)}:Q(E)?_.listen(E):async function(...z){let M;F&&!(0,b.$hg)(F.context)?M=[F.context,...z]:M=z;const G=await _.call(E,M);return U?G:(0,u.$8h)(G)};throw new P.$bb(`Property not found: ${String(E)}`)}})}B.toService=H;function Q(_){return _[0]==="o"&&_[1]==="n"&&v.$yf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&v.$yf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function ce(B){return Array.isArray(B)?B.map(le):le(B)}function V(B,T,H,Q,Y,_,F){F=ce(F);const U=ue[Y],g=U[Q%U.length];let E=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${g}`];/\($/.test(_)?(E=E.concat(F),E.push(")")):E.push(F),console.log.apply(console,E)}class Z{constructor(T,H){this.d=T,this.f=H,this.a=0,this.b=0}logOutgoing(T,H,Q,Y,_){this.b+=T,V(this.d,this.b,T,H,Q,Y,_)}logIncoming(T,H,Q,Y,_){this.a+=T,V(this.f,this.a,T,H,Q,Y,_)}}e.$hi=Z}),define(se[90],re([0,1,59,8,14,20,85,9,5,2,27,57,56,58]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class p extends y.$ai{constructor(c){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",w=>I.$He.wrap(Buffer.from(w,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$4q=p;class R{constructor(c,w){this.i=c,this.j=w,this.c=new Set,this.g=new Map,this.h=new l.$fe,this.onDidProcessExit=this.h.event;const $=w&&w.timeout?w.timeout:6e4;this.b=new D.$vh($),this.d=null,this.f=null}getChannel(c){const w=this;return{call($,m,f){return w.k(c,$,m,f)},listen($,m){return w.l(c,$,m)}}}k(c,w,$,m=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const f=this.n(c),n=(0,D.$lh)(i=>f.call(w,$,i)),r=m.onCancellationRequested(()=>n.cancel()),t=(0,a.$Sc)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(c,w,$){if(!this.b)return l.Event.None;this.b.cancel();let m;const f=new l.$fe({onWillAddFirstListener:()=>{m=this.n(c).listen(w,$)(f.fire,f),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,u.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,b.$pm)(w.env),this.d=(0,O.fork)(this.i,c,w);const $=new l.$fe,f=l.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,A.$Zq)(o)){(0,A.log)(o,`IPC Library: ${this.j.serverName}`);return}$.fire(I.$He.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,v.$rm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),t=$.event,i={send:r,onMessage:t};this.f=new y.$bi(i);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,h)=>{process.removeListener("exit",s),f.dispose(),this.c.forEach(S=>(0,a.$Pc)(S)),this.c.clear(),o!==0&&h!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+h),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:h})})}return this.f}n(c){let w=this.g.get(c);return w||(w=this.m.getChannel(c),this.g.set(c,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$5q=R}),define(se[91],re([0,1,8,5,2,47,3]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=l;var P;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function l(b){const y=b;return y?.changed instanceof Map||y?.deleted instanceof Set}var a;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(a||(e.StorageState=a={}));class u extends I.$Uc{static{this.a=100}constructor(y,p=Object.create(null)){super(),this.r=y,this.s=p,this.b=this.B(new D.$ie),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new O.$wh(u.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach((p,R)=>this.w(R,p)),y.deleted?.forEach(p=>this.w(p,void 0))}finally{this.b.resume()}}w(y,p){if(this.c===a.Closed)return;let R=!1;(0,A.$hg)(p)?R=this.f.delete(y):this.f.get(y)!==p&&(this.f.set(y,p),R=!0),R&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,p){const R=this.f.get(y);return(0,A.$hg)(R)?p:R}getBoolean(y,p){const R=this.get(y);return(0,A.$hg)(R)?p:R==="true"}getNumber(y,p){const R=this.get(y);return(0,A.$hg)(R)?p:parseInt(R,10)}getObject(y,p){const R=this.get(y);return(0,A.$hg)(R)?p:(0,N.$7h)(R)}async set(y,p,R=!1){if(this.c===a.Closed)return;if((0,A.$hg)(p))return this.delete(y,R);const d=(0,A.$ag)(p)||Array.isArray(p)?(0,N.$6h)(p):String(p);if(this.f.get(y)!==d)return this.f.set(y,d),this.j.set(y,d),this.h.delete(y),this.b.fire({key:y,external:R}),this.D()}async delete(y,p=!1){if(!(this.c===a.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:p}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(!(this.c===a.Closed||this.m))return this.D(y)}async D(y){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$1p=u;class v{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach((p,R)=>this.a.set(R,p)),y.delete?.forEach(p=>this.a.delete(p))}async optimize(){}async close(){}}e.$2p=v}),define(se[92],re([7,4]),function(X,e){return X.create("vs/base/node/zip",e)}),define(se[49],re([0,1,60,8,16,3,25,92]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0,e.zip=d,e.$nq=c,e.$oq=$,e.$kq="end of central directory record signature not found";const l=new RegExp(e.$kq);class a extends Error{constructor(f,n){let r=n.message;switch(f){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=f,this.cause=n}}e.$lq=a;function u(m){const f=m.externalFileAttributes>>16||33188;return[448,56,7].map(n=>f&n).reduce((n,r)=>n+r,f&61440)}function v(m){if(m instanceof a)return m;let f;return l.test(m.message)&&(f="CorruptZip"),new a(f,m)}function b(m,f,n,r,t,i){const s=I.$mc(f),o=I.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(P.localize(0,null,f)));const h=I.$jc(r,f);let S;return i.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((k,j)=>{if(!i.isCancellationRequested)try{S=(0,O.createWriteStream)(h,{mode:n}),S.once("close",()=>k()),S.once("error",j),m.once("error",j),m.pipe(S)}catch(L){j(L)}}))}function y(m,f,n,r){let t=(0,D.$lh)(()=>Promise.resolve()),i=0;const s=r.onCancellationRequested(()=>{t.cancel(),m.close()});return new Promise((o,h)=>{const S=new D.$th,k=j=>{j.isCancellationRequested||(i++,m.readEntry())};m.once("error",h),m.once("close",()=>t.then(()=>{r.isCancellationRequested||m.entryCount===i?o():h(new a("Incomplete",new Error(P.localize(1,null,i,m.entryCount))))},h)),m.readEntry(),m.on("entry",j=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(j.fileName)){k(r);return}const L=j.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(L)){const J=I.$jc(f,L);t=(0,D.$lh)(ne=>A.Promises.mkdir(J,{recursive:!0}).then(()=>k(ne)).then(void 0,h));return}const q=R(m,j),C=u(j);t=(0,D.$lh)(J=>S.queue(()=>q.then(ne=>b(ne,L,C,f,n,J).then(()=>k(J)))).then(null,h))})}).finally(()=>s.dispose())}async function p(m,f=!1){const{open:n}=await new Promise((r,t)=>{X(["yauzl"],r,t)});return new Promise((r,t)=>{n(m,f?{lazyEntries:!0}:void 0,(i,s)=>{i?t(v(i)):r((0,N.$jg)(s))})})}function R(m,f){return new Promise((n,r)=>{m.openReadStream(f,(t,i)=>{t?r(v(t)):n((0,N.$jg)(i))})})}async function d(m,f){const{ZipFile:n}=await new Promise((r,t)=>{X(["yazl"],r,t)});return new Promise((r,t)=>{const i=new n;f.forEach(o=>{o.contents?i.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&i.addFile(o.localPath,o.path)}),i.end();const s=(0,O.createWriteStream)(m);i.outputStream.pipe(s),i.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(m))})}function c(m,f,n={},r){const t=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let i=p(m,!0);return n.overwrite&&(i=i.then(s=>A.Promises.rm(f).then(()=>s))),i.then(s=>y(s,f,{sourcePathRegex:t},r))}function w(m,f){return p(m).then(n=>new Promise((r,t)=>{n.on("entry",i=>{i.fileName===f&&R(n,i).then(s=>r(s),s=>t(s))}),n.once("close",()=>t(new Error(P.localize(2,null,f))))}))}function $(m,f){return w(m,f).then(n=>new Promise((r,t)=>{const i=[];n.once("error",t),n.on("data",s=>i.push(s)),n.on("end",()=>r(Buffer.concat(i)))}))}}),define(se[93],re([7,4]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[94],re([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(se[95],re([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(se[96],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[97],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[98],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(se[99],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[100],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[101],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[102],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[103],re([7,4]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[104],re([7,4]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(se[105],re([7,4]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(se[106],re([7,4]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[107],re([7,4]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[108],re([7,4]),function(X,e){return X.create("vs/platform/log/common/log",e)}),define(se[109],re([7,4]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(se[110],re([7,4]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(se[111],re([7,4]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[112],re([7,4]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[113],re([7,4]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(se[114],re([0,1,9,95]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var I;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(I||(e.TokenType=I={}));function N(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),P=(0,D.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(u){switch(u.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return u.isTripleEq?"===":"==";case 4:return u.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return u.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return u.lexeme;case 18:return u.lexeme;case 19:return u.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(u)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(u=>u.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(u){return this.c=u,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(u){return this.r()||this.c.charCodeAt(this.e)!==u?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(u){this.f.push({type:u,offset:this.d})}l(u){const v=this.d,b=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:b};this.g.push({offset:v,lexeme:b,additionalInfo:u}),this.f.push(y)}n(){this.m.lastIndex=this.d;const u=this.m.exec(this.c);if(u){this.e=this.d+u[0].length;const v=this.c.substring(this.d,this.e),b=l.b.get(v);b?this.k(b):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let u=this.e,v=!1,b=!1;for(;;){if(u>=this.c.length){this.e=u,this.l(P);return}const p=this.c.charCodeAt(u);if(v)v=!1;else if(p===47&&!b){u++;break}else p===91?b=!0:p===92?v=!0:p===93&&(b=!1);u++}for(;u<this.c.length&&l.a.has(this.c.charCodeAt(u));)u++;this.e=u;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=l}),define(se[115],re([0,1,81,54,15,16,35,17,11]),function(X,e,O,D,I,N,A,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=u,e.$0m=v,e.$7m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(I.$Sg.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,P.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const y=(0,O.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",y)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$_g)(l.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=A.env.VSCODE_PORTABLE;return y?l.URI.file((0,N.$jc)(y,"argv.json")):(0,P.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,N.$kc)(y):(0,N.$hc)((0,N.$jc)(I.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const y=this.args["extensions-download-dir"];return y?l.URI.file((0,N.$kc)(y)):l.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,N.$kc)(y);const p=A.env.VSCODE_EXTENSIONS;if(p)return p;const R=A.env.VSCODE_PORTABLE;return R?(0,N.$jc)(R,"extensions"):(0,P.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map(p=>/^[^:/?#]+?:\/\//.test(p)?l.URI.parse(p):l.URI.file((0,N.$hc)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,N.$hc)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return u(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(y=>!e.$7m.test(y))}get extensionLogLevel(){const y=[];for(const p of this.args.log||[]){const R=e.$7m.exec(p);R&&R[1]&&R[2]&&y.push([R[1],R[2]])}return y.length?y:void 0}get serviceMachineIdResource(){return(0,P.$_g)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=A.env.VSCODE_PORTABLE;return y?l.URI.file((0,N.$jc)(y,"policy.json")):(0,P.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this.a}constructor(y,p,R){this.a=y,this.b=p,this.c=R,this.editSessionId=this.args.editSessionId}}e.$8m=a,$e([D.$3h],a.prototype,"appRoot",null),$e([D.$3h],a.prototype,"userHome",null),$e([D.$3h],a.prototype,"userDataPath",null),$e([D.$3h],a.prototype,"appSettingsHome",null),$e([D.$3h],a.prototype,"tmpDir",null),$e([D.$3h],a.prototype,"cacheHome",null),$e([D.$3h],a.prototype,"stateResource",null),$e([D.$3h],a.prototype,"userRoamingDataHome",null),$e([D.$3h],a.prototype,"userDataSyncHome",null),$e([D.$3h],a.prototype,"sync",null),$e([D.$3h],a.prototype,"machineSettingsResource",null),$e([D.$3h],a.prototype,"workspaceStorageHome",null),$e([D.$3h],a.prototype,"localHistoryHome",null),$e([D.$3h],a.prototype,"keyboardLayoutResource",null),$e([D.$3h],a.prototype,"argvResource",null),$e([D.$3h],a.prototype,"isExtensionDevelopment",null),$e([D.$3h],a.prototype,"untitledWorkspacesHome",null),$e([D.$3h],a.prototype,"builtinExtensionsPath",null),$e([D.$3h],a.prototype,"extensionsPath",null),$e([D.$3h],a.prototype,"extensionDevelopmentLocationURI",null),$e([D.$3h],a.prototype,"extensionDevelopmentKind",null),$e([D.$3h],a.prototype,"extensionTestsLocationURI",null),$e([D.$3h],a.prototype,"debugExtensionHost",null),$e([D.$3h],a.prototype,"logLevel",null),$e([D.$3h],a.prototype,"extensionLogLevel",null),$e([D.$3h],a.prototype,"serviceMachineIdResource",null),$e([D.$3h],a.prototype,"disableTelemetry",null),$e([D.$3h],a.prototype,"disableWorkspaceTrust",null),$e([D.$3h],a.prototype,"useInMemorySecretStorage",null),$e([D.$3h],a.prototype,"policyFile",null);function u(b,y){return v(b["inspect-extensions"],b["inspect-brk-extensions"],5870,y,b.debugId,b.extensionEnvironment)}function v(b,y,p,R,d,c){const $=Number(y||b)||(R?null:p),m=$?!!y:!1;let f;if(c)try{f=JSON.parse(c)}catch{}return{port:$,break:m,debugId:d,env:f}}}),function(){"use strict";function X(e,O,D){function I(A,P){const l=N(A,P),a=[l];return e.isAbsolute(l)||a.unshift(D),e.resolve(...a)}function N(A,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const u=A["user-data-dir"];if(u)return u;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(v,"AppData","Roaming")}break;case"darwin":a=e.join(O.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:I}}if(typeof define=="function")define(se[116],re([170,33,35]),function(e,O,D){return X(e,O,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=X(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[117],re([0,1,33,115,116]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=A,e.$an=P;class N extends D.$8m{constructor(a,u){super(a,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,I.getUserDataPath)(a,u.nameShort)},u)}}e.$$m=N;function A(l,a){return(0,D.$0m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,a,l.extensionEnvironment)}function P(l,a){return(0,D.$0m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,a,l.extensionEnvironment)}}),define(se[118],re([0,1,3,99]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=I;function I(A,P,l,a){try{N(A,P,l,a)}catch(u){A.error(u?.message??u)}return P}function N(A,P,l,a){const u=(v,b,y)=>{const p=v[b];if((0,O.$$f)(p)){const R=p,d=R.length;if(d>1&&R[0]==="%"&&R[d-1]==="%"){const c=R.substr(1,d-2);let w=l[c];w===void 0&&a&&(w=a[c]);const $=typeof w=="string"?w:w?.message,m=a?.[c],f=typeof m=="string"?m:m?.message;if(!$){f||A.warn(`[${P.name}]: ${(0,D.localize)(0,null,c)}`);return}if(y&&(b==="title"||b==="category")&&f&&f!==$){const n={value:$,original:f};v[b]=n}else v[b]=$}}else if((0,O.$ag)(p))for(const R in p)p.hasOwnProperty(R)&&(R==="commands"?u(p,R,!0):u(p,R,y));else if(Array.isArray(p))for(let R=0;R<p.length;R++)u(p,R,y)};for(const v in P)P.hasOwnProperty(v)&&u(P,v)}}),define(se[119],re([0,1,49,102]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=I;function I(N){return(0,O.$oq)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}}),define(se[50],re([0,1,17,55,103,44]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=l,e.$Lp=a,e.$Mp=u,e.$Np=v,e.$Op=b,e.$Pp=y,e.$Qp=p;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function l(c){return c=c.trim(),c==="*"||A.test(c)}function a(c){if(!l(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=c.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function u(c){if(!c)return null;const w=c.majorBase,$=c.majorMustEqual,m=c.minorBase;let f=c.minorMustEqual;const n=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(w===0||(f=!1),r=!1);let t=0;if(c.preRelease){const i=P.exec(c.preRelease);if(i){const[,s,o,h]=i;t=Date.UTC(Number(s),Number(o)-1,Number(h))}}return{majorBase:w,majorMustEqual:$,minorBase:m,minorMustEqual:f,patchBase:n,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:t}}function v(c,w,$){let m;typeof c=="string"?m=u(a(c)):m=c;let f;w instanceof Date?f=w.getTime():typeof w=="string"&&(f=new Date(w).getTime());let n;if(typeof $=="string"?n=u(a($)):n=$,!m||!n)return!1;const r=m.majorBase,t=m.minorBase,i=m.patchBase;let s=n.majorBase,o=n.minorBase,h=n.patchBase;const S=n.notBefore;let k=n.majorMustEqual,j=n.minorMustEqual,L=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||f&&f<S?!1:i>=h:(r===1&&s===0&&(!k||!j||!L)&&(s=1,o=0,h=0,k=!0,j=!1,L=!1),r<s?!1:r>s?!k:t<o?!1:t>o?!j:i<h?!1:i>h?!L:!(f&&f<S))}function b(c,w,$,m,f){const n=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return n.push([D.default.Error,I.localize(0,null)]),n;if(typeof m.name!="string")return n.push([D.default.Error,I.localize(1,null,"name")]),n;if(typeof m.version!="string")return n.push([D.default.Error,I.localize(2,null,"version")]),n;if(!m.engines)return n.push([D.default.Error,I.localize(3,null,"engines")]),n;if(typeof m.engines.vscode!="string")return n.push([D.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof m.extensionDependencies<"u"&&!d(m.extensionDependencies))return n.push([D.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof m.activationEvents<"u"){if(!d(m.activationEvents))return n.push([D.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof m.main>"u"&&typeof m.browser>"u")return n.push([D.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&n.push([D.default.Warning,I.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return n.push([D.default.Error,I.localize(9,null,"main")]),n;{const i=(0,O.$_g)($,m.main);(0,O.$6g)(i,$)||n.push([D.default.Warning,I.localize(10,null,i.path,$.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return n.push([D.default.Error,I.localize(11,null,"browser")]),n;{const i=(0,O.$_g)($,m.browser);(0,O.$6g)(i,$)||n.push([D.default.Warning,I.localize(12,null,i.path,$.path)])}}if(!N.valid(m.version))return n.push([D.default.Error,I.localize(13,null)]),n;const r=[];if(!y(c,w,m,f,r))for(const i of r)n.push([D.default.Error,i]);return n}function y(c,w,$,m,f){return m||typeof $.main>"u"&&typeof $.browser>"u"?!0:R(c,w,$.engines.vscode,f)}function p(c,w,$){return c==="*"||R(w,$,c)}function R(c,w,$,m=[]){const f=u(a($));if(!f)return m.push(I.localize(14,null,$)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return m.push(I.localize(15,null,$)),!1}else if(!f.majorMustEqual)return m.push(I.localize(16,null,$)),!1;return v(c,w,f)?!0:(m.push(I.localize(17,null,c,$)),!1)}function d(c){if(!Array.isArray(c))return!1;for(let w=0,$=c.length;w<$;w++)if(typeof c[w]!="string")return!1;return!0}}),define(se[120],re([0,1,14,28]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=I;async function I(N,A,P){let l=P&&P.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const u=(await A.readFile(N.serviceMachineIdResource)).value.toString();l=(0,D.$Tg)(u)?u:null}catch{l=null}if(!l){l=(0,D.$Ug)();try{await A.writeFile(N.serviceMachineIdResource,O.$He.fromString(l))}catch{}}return P?.store("storage.serviceMachineId",l,-1,1),l}}),define(se[51],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class O{constructor(I,N=[],A=!1){this.ctor=I,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$vi=O}),define(se[121],re([0,1,51]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Bs=N,e.$Cs=A;const D=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function N(P,l,a){l instanceof O.$vi||(l=new O.$vi(l,[],!!a)),D.push([P,l])}function A(){return D}}),define(se[122],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0;class O{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$er=O;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const P=this.lookupOrInsertNode(N),l=this.lookupOrInsertNode(A);P.outgoing.set(l.key,l),l.incoming.set(P.key,P)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let P=this.a.get(A);return P||(P=new O(A,N),this.a.set(A,P)),P}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,P]of this.a)N.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const P=new Set([N]),l=this.c(A,P);if(l)return l}}c(N,A){for(const[P,l]of N.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const a=this.c(l,A);if(a)return a;A.delete(P)}}}e.$fr=D}),define(se[29],re([0,1,3,11,10]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=N,e.$7i=A,e.$8i=l,e.$9i=a,e.$0i=u,e.$$i=v,e.$_i=b,e.$aj=p,e.$bj=R,e.$cj=d,e.$5i=(0,I.$yi)("configurationService");function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof D.URI)}function A(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof D.URI)}var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function l(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function u(c,w){const $=Object.create(null);for(const m in c)v($,m,c[m],w);return $}function v(c,w,$,m){const f=w.split("."),n=f.pop();let r=c;for(let t=0;t<f.length;t++){const i=f[t];let s=r[i];switch(typeof s){case"undefined":s=r[i]=Object.create(null);break;case"object":if(s===null){m(`Ignoring ${w} as ${f.slice(0,t+1).join(".")} is null`);return}break;default:m(`Ignoring ${w} as ${f.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=$}catch{m(`Ignoring ${w} as ${f.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${w} as ${f.join(".")} is ${JSON.stringify(r)}`)}function b(c,w){const $=w.split(".");y(c,$)}function y(c,w){const $=w.shift();if(w.length===0){delete c[$];return}if(Object.keys(c).indexOf($)!==-1){const m=c[$];typeof m=="object"&&!Array.isArray(m)&&(y(m,w),Object.keys(m).length===0&&delete c[$])}}function p(c,w,$){function m(r,t){let i=r;for(const s of t){if(typeof i!="object"||i===null)return;i=i[s]}return i}const f=w.split("."),n=m(c,f);return typeof n>"u"?$:n}function R(c,w,$){Object.keys(w).forEach(m=>{m!=="__proto__"&&(m in c?O.$ag(c[m])&&O.$ag(w[m])?R(c[m],w[m],$):$&&(c[m]=w[m]):c[m]=w[m])})}function d(c){return c.replace(/[\[\]]/g,"")}}),define(se[123],re([0,1,12,31,114,10,94,9]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=a,e.$xj=r,e.$yj=t,e.$Rj=Y;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",O.$j),l.set("isLinux",O.$k),l.set("isWindows",O.$i),l.set("isWeb",O.$o),l.set("isMacNative",O.$j&&!O.$o),l.set("isEdge",O.$H),l.set("isFirefox",O.$F),l.set("isChrome",O.$E),l.set("isSafari",O.$G);function a(U,g){if(l.get(U)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(U,g)}const u=Object.prototype.hasOwnProperty;var v;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const b={regexParsingWithErrorRecovery:!0},y=(0,A.localize)(0,null),p=(0,A.localize)(1,null),R=(0,A.localize)(2,null),d=(0,A.localize)(3,null),c=(0,A.localize)(4,null),w=(0,A.localize)(5,null),$=(0,A.localize)(6,null),m=(0,A.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(g=b){this.k=g,this.d=new I.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(g){if(g===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(g).scan(),this.g=0,this.h=[];try{const E=this.l();if(!this.E()){const z=this.D(),M=z.type===17?w:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:I.$tj.getLexeme(z),additionalInfo:M}),f.c}return E}catch(E){if(E!==f.c)throw E;return}}l(){return this.m()}m(){const g=[this.o()];for(;this.y(16);){const E=this.o();g.push(E)}return g.length===1?g[0]:n.or(...g)}o(){const g=[this.s()];for(;this.y(15);){const E=this.s();g.push(E)}return g.length===1?g[0]:n.and(...g)}s(){if(this.y(2)){const g=this.D();switch(g.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const E=this.l();return this.A(1,d),E?.negate()}case 17:return this.z(),q.create(g.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",g)}}return this.t()}t(){const g=this.D();switch(g.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const E=this.l();return this.A(1,d),E}case 17:{const E=g.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const G=M.lexeme,W=G.lastIndexOf("/"),te=W===G.length-1?void 0:this.w(G.substring(W+1));let ae;try{ae=new RegExp(G.substring(1,W),te)}catch{throw this.B("REGEX",M)}return le.create(E,ae)}switch(M.type){case 10:case 19:{const G=[M.lexeme];this.z();let W=this.D(),te=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;G.push(I.$tj.getLexeme(W)),this.z(),W=this.D()}const ae=G.join(""),he=ae.lastIndexOf("/"),pe=he===ae.length-1?void 0:this.w(ae.substring(he+1));let ye;try{ye=new RegExp(ae.substring(1,he),pe)}catch{throw this.B("REGEX",M)}return n.regex(E,ye)}case 18:{const G=M.lexeme;this.z();let W=null;if(!(0,D.$9e)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const he=G.slice(te+1,ae),pe=G[ae+1]==="i"?"i":"";try{W=new RegExp(he,pe)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return le.create(E,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const M=this.u();return n.notIn(E,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return n.equals(E,M);switch(M){case"true":return n.has(E);case"false":return n.not(E);default:return n.equals(E,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return n.notEquals(E,M);switch(M){case"true":return n.not(E);case"false":return n.has(E);default:return n.notEquals(E,M)}}case 5:return this.z(),ie.create(E,this.u());case 6:return this.z(),ue.create(E,this.u());case 7:return this.z(),J.create(E,this.u());case 8:return this.z(),ne.create(E,this.u());case 13:return this.z(),n.in(E,this.u());default:return n.has(E)}}case 20:throw this.h.push({message:$,offset:g.offset,lexeme:"",additionalInfo:m}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const g=this.D();switch(g.type){case 17:case 18:return this.z(),g.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(g){return g.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(g){return this.C(g)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(g,E){if(this.C(g))return this.z();throw this.B(E,this.D())}B(g,E,z){const M=(0,A.localize)(8,null,g,I.$tj.getLexeme(E)),G=E.offset,W=I.$tj.getLexeme(E);return this.h.push({message:M,offset:G,lexeme:W,additionalInfo:z}),f.c}C(g){return this.D().type===g}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=f;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(g){return h.create(g)}static equals(g,E){return S.create(g,E)}static notEquals(g,E){return L.create(g,E)}static regex(g,E){return le.create(g,E)}static in(g,E){return k.create(g,E)}static notIn(g,E){return j.create(g,E)}static not(g){return q.create(g)}static and(...g){return Z.create(g,null,!0)}static or(...g){return B.create(g,null,!0)}static greater(g,E){return J.create(g,E)}static greaterEquals(g,E){return ne.create(g,E)}static smaller(g,E){return ie.create(g,E)}static smallerEquals(g,E){return ue.create(g,E)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(g){return g==null?void 0:this.c.parse(g)}}e.$wj=n;function r(U){const g=new f({regexParsingWithErrorRecovery:!1});return U.map(E=>(g.parse(E),g.lexingErrors.length>0?g.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):g.parsingErrors.length>0?g.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function t(U,g){const E=U?U.substituteConstants():void 0,z=g?g.substituteConstants():void 0;return!E&&!z?!0:!E||!z?!1:E.equals(z)}function i(U,g){return U.cmp(g)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!1}serialize(){return"false"}keys(){return[]}map(g){return this}negate(){return o.INSTANCE}}e.$zj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(g){return this.type-g.type}equals(g){return g.type===this.type}substituteConstants(){return this}evaluate(g){return!0}serialize(){return"true"}keys(){return[]}map(g){return this}negate(){return s.INSTANCE}}e.$Aj=o;class h{static create(g,E=null){const z=l.get(g);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new h(g,E)}constructor(g,E){this.key=g,this.c=E,this.type=2}cmp(g){return g.type!==this.type?this.type-g.type:H(this.key,g.key)}equals(g){return g.type===this.type?this.key===g.key:!1}substituteConstants(){const g=l.get(this.key);return typeof g=="boolean"?g?o.INSTANCE:s.INSTANCE:this}evaluate(g){return!!g.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(g){return g.mapDefined(this.key)}negate(){return this.c||(this.c=q.create(this.key,this)),this.c}}e.$Bj=h;class S{static create(g,E,z=null){if(typeof E=="boolean")return E?h.create(g,z):q.create(g,z);const M=l.get(g);return typeof M=="boolean"?E===(M?"true":"false")?o.INSTANCE:s.INSTANCE:new S(g,E,z)}constructor(g,E,z){this.c=g,this.d=E,this.f=z,this.type=4}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=l.get(this.c);if(typeof g=="boolean"){const E=g?"true":"false";return this.d===E?o.INSTANCE:s.INSTANCE}return this}evaluate(g){return g.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(g){return g.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$Cj=S;class k{static create(g,E){return new k(g,E)}constructor(g,E){this.d=g,this.f=E,this.type=10,this.c=null}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.d,this.f,g.d,g.f)}equals(g){return g.type===this.type?this.d===g.d&&this.f===g.f:!1}substituteConstants(){return this}evaluate(g){const E=g.getValue(this.f),z=g.getValue(this.d);return Array.isArray(E)?E.includes(z):typeof z=="string"&&typeof E=="object"&&E!==null?u.call(E,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(g){return g.mapIn(this.d,this.f)}negate(){return this.c||(this.c=j.create(this.d,this.f)),this.c}}e.$Dj=k;class j{static create(g,E){return new j(g,E)}constructor(g,E){this.d=g,this.f=E,this.type=11,this.c=k.create(g,E)}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(g){return g.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=j;class L{static create(g,E,z=null){if(typeof E=="boolean")return E?q.create(g,z):h.create(g,z);const M=l.get(g);return typeof M=="boolean"?E===(M?"true":"false")?s.INSTANCE:o.INSTANCE:new L(g,E,z)}constructor(g,E,z){this.c=g,this.d=E,this.f=z,this.type=5}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){const g=l.get(this.c);if(typeof g=="boolean"){const E=g?"true":"false";return this.d===E?s.INSTANCE:o.INSTANCE}return this}evaluate(g){return g.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(g){return g.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Fj=L;class q{static create(g,E=null){const z=l.get(g);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new q(g,E)}constructor(g,E){this.c=g,this.d=E,this.type=3}cmp(g){return g.type!==this.type?this.type-g.type:H(this.c,g.c)}equals(g){return g.type===this.type?this.c===g.c:!1}substituteConstants(){const g=l.get(this.c);return typeof g=="boolean"?g?s.INSTANCE:o.INSTANCE:this}evaluate(g){return!g.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(g){return g.mapNot(this.c)}negate(){return this.d||(this.d=h.create(this.c,this)),this.d}}e.$Gj=q;function C(U,g){if(typeof U=="string"){const E=parseFloat(U);isNaN(E)||(U=E)}return typeof U=="string"||typeof U=="number"?g(U):s.INSTANCE}class J{static create(g,E,z=null){return C(E,M=>new J(g,M,z))}constructor(g,E,z){this.c=g,this.d=E,this.f=z,this.type=12}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Hj=J;class ne{static create(g,E,z=null){return C(E,M=>new ne(g,M,z))}constructor(g,E,z){this.c=g,this.d=E,this.f=z,this.type=13}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(g){return g.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Ij=ne;class ie{static create(g,E,z=null){return C(E,M=>new ie(g,M,z))}constructor(g,E,z){this.c=g,this.d=E,this.f=z,this.type=14}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class ue{static create(g,E,z=null){return C(E,M=>new ue(g,M,z))}constructor(g,E,z){this.c=g,this.d=E,this.f=z,this.type=15}cmp(g){return g.type!==this.type?this.type-g.type:Q(this.c,this.d,g.c,g.d)}equals(g){return g.type===this.type?this.c===g.c&&this.d===g.d:!1}substituteConstants(){return this}evaluate(g){return typeof this.d=="string"?!1:parseFloat(g.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(g){return g.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Kj=ue;class le{static create(g,E){return new le(g,E)}constructor(g,E){this.d=g,this.f=E,this.type=7,this.c=null}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.d<g.d)return-1;if(this.d>g.d)return 1;const E=this.f?this.f.source:"",z=g.f?g.f.source:"";return E<z?-1:E>z?1:0}equals(g){if(g.type===this.type){const E=this.f?this.f.source:"",z=g.f?g.f.source:"";return this.d===g.d&&E===z}return!1}substituteConstants(){return this}evaluate(g){const E=g.getValue(this.d);return this.f?this.f.test(E):!1}serialize(){const g=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${g}`}keys(){return[this.d]}map(g){return g.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Lj=le;class ce{static create(g){return new ce(g)}constructor(g){this.c=g,this.type=8}cmp(g){return g.type!==this.type?this.type-g.type:this.c.cmp(g.c)}equals(g){return g.type===this.type?this.c.equals(g.c):!1}substituteConstants(){return this}evaluate(g){return!this.c.evaluate(g)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(g){return new ce(this.c.map(g))}negate(){return this.c}}e.$Mj=ce;function V(U){let g=null;for(let E=0,z=U.length;E<z;E++){const M=U[E].substituteConstants();if(U[E]!==M&&g===null){g=[];for(let G=0;G<E;G++)g[G]=U[G]}g!==null&&(g[E]=M)}return g===null?U:g}class Z{static create(g,E,z){return Z.d(g,E,z)}constructor(g,E){this.expr=g,this.c=E,this.type=6}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let E=0,z=this.expr.length;E<z;E++){const M=i(this.expr[E],g.expr[E]);if(M!==0)return M}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].equals(g.expr[E]))return!1;return!0}return!1}substituteConstants(){const g=V(this.expr);return g===this.expr?this:Z.create(g,this.c,!1)}evaluate(g){for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].evaluate(g))return!1;return!0}static d(g,E,z){const M=[];let G=!1;for(const W of g)if(W){if(W.type===1){G=!0;continue}if(W.type===0)return s.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&G)return o.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(i);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const te=M.pop(),ae=M.length===0,he=B.create(W.expr.map(pe=>Z.create([pe,te],null,z)),null,ae);he&&(M.push(he),M.sort(i))}if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return s.INSTANCE;if(M.length===1)return M[0]}return new Z(M,E)}}serialize(){return this.expr.map(g=>g.serialize()).join(" && ")}keys(){const g=[];for(const E of this.expr)g.push(...E.keys());return g}map(g){return new Z(this.expr.map(E=>E.map(g)),null)}negate(){if(!this.c){const g=[];for(const E of this.expr)g.push(E.negate());this.c=B.create(g,this,!0)}return this.c}}e.$Nj=Z;class B{static create(g,E,z){return B.d(g,E,z)}constructor(g,E){this.expr=g,this.c=E,this.type=9}cmp(g){if(g.type!==this.type)return this.type-g.type;if(this.expr.length<g.expr.length)return-1;if(this.expr.length>g.expr.length)return 1;for(let E=0,z=this.expr.length;E<z;E++){const M=i(this.expr[E],g.expr[E]);if(M!==0)return M}return 0}equals(g){if(g.type===this.type){if(this.expr.length!==g.expr.length)return!1;for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].equals(g.expr[E]))return!1;return!0}return!1}substituteConstants(){const g=V(this.expr);return g===this.expr?this:B.create(g,this.c,!1)}evaluate(g){for(let E=0,z=this.expr.length;E<z;E++)if(this.expr[E].evaluate(g))return!0;return!1}static d(g,E,z){let M=[],G=!1;if(g){for(let W=0,te=g.length;W<te;W++){const ae=g[W];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&G)return s.INSTANCE;M.sort(i)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return o.INSTANCE;if(M.length===1)return M[0]}return new B(M,E)}}serialize(){return this.expr.map(g=>g.serialize()).join(" || ")}keys(){const g=[];for(const E of this.expr)g.push(...E.keys());return g}map(g){return new B(this.expr.map(E=>E.map(g)),null)}negate(){if(!this.c){const g=[];for(const E of this.expr)g.push(E.negate());for(;g.length>1;){const E=g.shift(),z=g.shift(),M=[];for(const G of F(E))for(const W of F(z))M.push(Z.create([G,W],null,!1));g.unshift(B.create(M,null,!1))}this.c=B.create(g,this,!0)}return this.c}}e.$Oj=B;class T extends h{static{this.d=[]}static all(){return T.d.values()}constructor(g,E,z){super(g,null),this.f=E,typeof z=="object"?T.d.push({...z,key:g}):z!==!0&&T.d.push({key:g,description:z,type:E!=null?typeof E:void 0})}bindTo(g){return g.createKey(this.key,this.f)}getValue(g){return g.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(g){return S.create(this.key,g)}notEqualsTo(g){return L.create(this.key,g)}}e.$Pj=T,e.$Qj=(0,N.$yi)("contextKeyService");function H(U,g){return U<g?-1:U>g?1:0}function Q(U,g,E,z){return U<E?-1:U>E?1:g<z?-1:g>z?1:0}function Y(U,g){if(U.type===0||g.type===1)return!0;if(U.type===9)return g.type===9?_(U.expr,g.expr):!1;if(g.type===9){for(const E of g.expr)if(Y(U,E))return!0;return!1}if(U.type===6){if(g.type===6)return _(g.expr,U.expr);for(const E of U.expr)if(Y(E,g))return!0;return!1}return U.equals(g)}function _(U,g){let E=0,z=0;for(;E<U.length&&z<g.length;){const M=U[E].cmp(g[z]);if(M<0)return!1;M===0&&E++,z++}return E===U.length}function F(U){return U.type===9?U.expr:[U]}}),define(se[61],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0,e.$No=(0,O.$yi)("downloadService")}),define(se[18],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,O.$yi)("environmentService"),e.$Gi=(0,O.$zi)(e.$Fi)}),define(se[21],re([0,1,97,10]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=N,e.$5o=A,e.$6o=P,e.$7o=l,e.$8o=a,e.$9o=u,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionInstallSource",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";var I;(function($){$.COMMAND="command",$.SETTINGS_SYNC="settingsSync"})(I||(e.ExtensionInstallSource=I={}));function N($){switch($){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A($){switch($){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P($,m){switch($){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function l($,m){return m==="web"&&!$.includes("web")}function a($,m,f){return l(m,f)?!1:$==="undefined"||$==="universal"?!0:$==="unknown"?!1:$===f}function u($){return $&&typeof $=="object"&&typeof $.id=="string"&&(!$.uuid||typeof $.uuid=="string")}var v;(function($){$[$.NoneOrRelevance=0]="NoneOrRelevance",$[$.LastUpdatedDate=1]="LastUpdatedDate",$[$.Title=2]="Title",$[$.PublisherName=3]="PublisherName",$[$.InstallCount=4]="InstallCount",$[$.PublishedDate=10]="PublishedDate",$[$.AverageRating=6]="AverageRating",$[$.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var b;(function($){$[$.Default=0]="Default",$[$.Ascending=1]="Ascending",$[$.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var y;(function($){$.Install="install",$.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var p;(function($){$[$.None=1]="None",$[$.Install=2]="Install",$[$.Update=3]="Update",$[$.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.$0o=(0,D.$yi)("extensionGalleryService");var R;(function($){$.Timeout="Timeout",$.Cancelled="Cancelled",$.Failed="Failed",$.DownloadFailedWriting="DownloadFailedWriting"})(R||(e.ExtensionGalleryErrorCode=R={}));class d extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.$$o=d;var c;(function($){$.Unsupported="Unsupported",$.Deprecated="Deprecated",$.Malicious="Malicious",$.Incompatible="Incompatible",$.IncompatibleTargetPlatform="IncompatibleTargetPlatform",$.ReleaseVersionNotFound="ReleaseVersionNotFound",$.Invalid="Invalid",$.Download="Download",$.DownloadSignature="DownloadSignature",$.DownloadFailedWriting="DownloadFailedWriting",$.UpdateMetadata="UpdateMetadata",$.Extract="Extract",$.Scanning="Scanning",$.ScanningExtension="ScanningExtension",$.ReadUninstalled="ReadUninstalled",$.UnsetUninstalled="UnsetUninstalled",$.Delete="Delete",$.Rename="Rename",$.IntializeDefaultProfile="IntializeDefaultProfile",$.AddToProfile="AddToProfile",$.PostInstall="PostInstall",$.CorruptZip="CorruptZip",$.IncompleteZip="IncompleteZip",$.Signature="Signature",$.NotAllowed="NotAllowed",$.Gallery="Gallery",$.Cancelled="Cancelled",$.Unknown="Unknown",$.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class w extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.$_o=w,e.$ap=(0,D.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,D.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,D.$yi)("IExtensionTipsService"),e.$fp=(0,O.localize2)(0,"Extensions"),e.$gp=(0,O.localize2)(1,"Preferences")}),define(se[62],re([0,1,14,9,105,13]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=A;async function A(u,v,b,y,p,R){let d;try{await P(u,v,b,y,p,R)}catch(c){d=c}finally{d&&p.errorTransformer&&(d=p.errorTransformer(d)),typeof d<"u"&&b.error(d),b.end()}}async function P(u,v,b,y,p,R){l(R);const d=await u.open(v,{create:!1});try{l(R);let c=0,w=0,$=p&&typeof p.length=="number"?p.length:void 0,m=O.$He.alloc(Math.min(p.bufferSize,typeof $=="number"?$:p.bufferSize)),f=p&&typeof p.position=="number"?p.position:0,n=0;do w=await u.read(d,f,m.buffer,n,m.byteLength-n),f+=w,n+=w,c+=w,typeof $=="number"&&($-=w),n===m.byteLength&&(await b.write(y(m)),m=O.$He.alloc(Math.min(p.bufferSize,typeof $=="number"?$:p.bufferSize)),n=0);while(w>0&&(typeof $!="number"||$>0)&&l(R)&&a(c,p));if(n>0){let r=n;typeof $=="number"&&(r=Math.min(n,$)),b.write(y(m.slice(0,r)))}}catch(c){throw(0,N.$gl)(c)}finally{await u.close(d)}}function l(u){if(u.isCancellationRequested)throw(0,D.$6)();return!0}function a(u,v){if(typeof v?.limits?.size=="number"&&u>v.limits.size)throw(0,N.$fl)((0,I.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[124],re([0,1,60,2,52,5,11,8]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class l extends D.$Uc{constructor(){super(),this.a=this.B(new N.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new N.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new N.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new D.$4c),this.m=new Set,this.n=5007,this.r=new P.$Vh,this.P=!1,this.B(this.f(u=>this.s(u)))}s(u){this.t(u)&&this.w(u)}t(u){return(0,I.$Nq)(u)}async watch(u){this.r.isSettled||this.r.complete(),this.r=new P.$Vh;try{this.h.clear(),this.g.clear();for(const v of u)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(u=>!this.j.has(u.correlationId))])}isSuspended(u){return typeof u.correlationId!="number"?!1:this.m.has(u.correlationId)?"polling":this.j.has(u.correlationId)}async w(u){if(this.j.has(u.correlationId))return;const v=new D.$Tc;this.j.set(u.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(u,v),this.u())}y(u){this.j.deleteAndDispose(u.correlationId),this.m.delete(u.correlationId),this.u()}z(u,v){this.C(u,v)?(this.N(`reusing an existing recursive watcher to monitor ${u.path}`),this.m.delete(u.correlationId)):(this.D(u,v),this.m.add(u.correlationId))}C(u,v){const b=this.M?.subscribe(u.path,(y,p)=>{v.isDisposed||(y?this.z(u,v):p?.type===1&&this.F(u))});return b?(v.add(b),!0):!1}D(u,v){let b=!1;const y=(p,R)=>{if(v.isDisposed)return;const d=this.G(p),c=this.G(R),w=b;b=d,!d&&(c||w)&&this.F(u)};this.N(`starting fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,O.watchFile)(u.path,{persistent:!1,interval:this.n},y)}catch(p){this.O(`fs.watchFile() failed with error ${p} on path ${u.path} (correlationId: ${u.correlationId})`)}v.add((0,D.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${u.path} (correlationId: ${u.correlationId})`);try{(0,O.unwatchFile)(u.path,y)}catch(p){this.O(`fs.unwatchFile() failed with error ${p} on path ${u.path} (correlationId: ${u.correlationId})`)}}))}F(u){this.N(`detected ${u.path} exists again, resuming watcher (correlationId: ${u.correlationId})`);const v={resource:A.URI.file(u.path),type:1,cId:u.correlationId};this.a.fire([v]),this.H(v,u),this.y(u)}G(u){return u.ctimeMs===0&&u.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(u,v){if(this.P){const b=` >> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`;this.I(b,v)}}I(u,v){this.P&&this.N(`${u}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}J(u){return`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, filter: ${(0,I.$Xq)(u.filter)}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`}async setVerboseLogging(u){this.P=u}}e.$7q=l}),define(se[125],re([0,1,5,171,124,12,172,63]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class l extends I.$7q{constructor(u){super(),this.M=u,this.onDidError=O.Event.None,this.watchers=new Set}async L(u){u=this.X(u);const v=[],b=new Set(Array.from(this.watchers));for(const y of u){const p=this.S(y);p&&(0,D.$wk)(p.request.excludes,y.excludes)&&(0,D.$wk)(p.request.includes,y.includes)?b.delete(p):v.push(y)}v.length&&this.N(`Request to start watching: ${v.map(y=>this.J(y)).join(",")}`),b.size&&this.N(`Request to stop watching: ${Array.from(b).map(y=>this.J(y.request)).join(",")}`);for(const y of b)this.W(y);for(const y of v)this.U(y)}S(u){for(const v of this.watchers)if(typeof u.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===u.correlationId)return v}else if((0,P.$wg)(v.request.path,u.path,!N.$k))return v}U(u){const v=new A.$_q(u,this.M,y=>this.a.fire(y),()=>this.c.fire(u),y=>this.b.fire(y),this.P),b={request:u,instance:v};this.watchers.add(b)}async stop(){await super.stop();for(const u of this.watchers)this.W(u)}W(u){this.N("stopping file watcher",u),this.watchers.delete(u),u.instance.dispose()}X(u){const v=new Map;for(const b of u){const y=N.$k?b.path:b.path.toLowerCase();let p=v.get(b.correlationId);p||(p=new Map,v.set(b.correlationId,p)),p.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(b)}`),p.set(y,b)}return Array.from(v.values()).map(b=>Array.from(b.values())).flat()}async setVerboseLogging(u){super.setVerboseLogging(u);for(const v of this.watchers)v.instance.setVerboseLogging(u)}N(u,v){this.P&&this.b.fire({type:"trace",message:this.$(u,v)})}O(u){this.b.fire({type:"warn",message:this.$(u)})}$(u,v){return v?`[File Watcher (node.js)] ${u} (${this.J(v.request)})`:`[File Watcher (node.js)] ${u}`}}e.$br=l}),define(se[126],re([0,1,52,125]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class I extends O.$Qq{constructor(A,P,l){super(A,P,l),this.s()}r(A){return A.add(new D.$br(void 0))}}e.$cr=I}),define(se[127],re([0,1,15,58,90,52]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class A extends N.$Rq{constructor(l,a,u){super(l,a,u),this.s()}r(l){const a=l.add(new I.$5q(O.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(a.onDidProcessExit(({code:u,signal:v})=>this.t(`terminated by itself with code ${u}, signal: ${v} (ETERM)`))),D.ProxyChannel.toService((0,D.$fi)(a.getChannel("watcher")))}}e.$6q=A}),define(se[64],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class O{constructor(...I){this.a=new Map;for(const[N,A]of I)this.set(N,A)}set(I,N){const A=this.a.get(I);return this.a.set(I,N),A}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$wi=O}),define(se[128],re([0,1,8,9,2,51,122,10,64,173]),function(X,e,O,D,I,N,A,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;const u=!1;class v extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class b{constructor(d=new l.$wi,c=!1,w,$=u){this.i=d,this.j=c,this.k=w,this.l=$,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$xi,this),this._globalGraph=$?w?._globalGraph??new A.$fr(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Pc)(this.h),this.h.clear();for(const d of this.g)(0,I.$Oc)(d)&&d.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(d){this.m();const c=new class extends b{dispose(){this.h.delete(c),super.dispose()}}(d,this.j,this,this.l);return this.h.add(c),c}invokeFunction(d,...c){this.m();const w=p.traceInvocation(this.l,d);let $=!1;try{return d({get:f=>{if($)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const n=this.s(f,w);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...c)}finally{$=!0,w.stop()}}createInstance(d,...c){this.m();let w,$;return d instanceof N.$vi?(w=p.traceCreation(this.l,d.ctor),$=this.o(d.ctor,d.staticArguments.concat(c),w)):(w=p.traceCreation(this.l,d),$=this.o(d,c,w)),w.stop(),$}o(d,c=[],w){const $=P._util.getServiceDependencies(d).sort((n,r)=>n.index-r.index),m=[];for(const n of $){const r=this.s(n.id,w);r||this.y(`[createInstance] ${d.name} depends on UNKNOWN service ${n.id}.`,!1),m.push(r)}const f=$.length>0?$[0].index:c.length;if(c.length!==f){console.trace(`[createInstance] First service dependency of ${d.name} at position ${f+1} conflicts with ${c.length} static arguments`);const n=f-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,f)}return Reflect.construct(d,c.concat(m))}q(d,c){if(this.i.get(d)instanceof N.$vi)this.i.set(d,c);else if(this.k)this.k.q(d,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(d){const c=this.i.get(d);return!c&&this.k?this.k.r(d):c}s(d,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const w=this.r(d);return w instanceof N.$vi?this.u(d,w,c.branch(d,!0)):(c.branch(d,!1),w)}u(d,c,w){if(this.t.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.t.add(d);try{return this.v(d,c,w)}finally{this.t.delete(d)}}v(d,c,w){const $=new A.$fr(n=>n.id.toString());let m=0;const f=[{id:d,desc:c,_trace:w}];for(;f.length;){const n=f.pop();if($.lookupOrInsertNode(n),m++>1e3)throw new v($);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const t=this.r(r.id);if(t||this.y(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof N.$vi){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};$.insertEdge(n,i),f.push(i)}}}for(;;){const n=$.roots();if(n.length===0){if(!$.isEmpty())throw new v($);break}for(const{data:r}of n){if(this.r(r.id)instanceof N.$vi){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}$.removeNode(r)}}return this.r(d)}w(d,c,w=[],$,m){if(this.i.get(d)instanceof N.$vi)return this.x(d,c,w,$,m,this.g);if(this.k)return this.k.w(d,c,w,$,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(d,c,w=[],$,m,f){if($){const n=new b(void 0,this.j,this,this.l);n.c=String(d);const r=new Map,t=new O.$Rh(()=>{const i=n.o(c,w,m);for(const[s,o]of r){const h=i[s];if(typeof h=="function")for(const S of o)S.disposable=h.apply(i,S.listener)}return r.clear(),f.add(i),i});return new Proxy(Object.create(null),{get(i,s){if(!t.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=r.get(s);return S||(S=new a.$5c,r.set(s,S)),(j,L,q)=>{if(t.isInitialized)return t.value[s](j,L,q);{const C={listener:[j,L,q],disposable:void 0},J=S.push(C);return(0,I.$Sc)(()=>{J(),C.disposable?.dispose()})}}}if(s in i)return i[s];const o=t.value;let h=o[s];return typeof h!="function"||(h=h.bind(o),i[s]=h),h},set(i,s,o){return t.value[s]=o,!0},getPrototypeOf(i){return c.prototype}})}else{const n=this.o(c,w,m);return f.add(n),n}}y(d,c){if(c&&console.warn(d),this.j)throw new Error(d)}}e.$gr=b;var y;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(y||(y={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,c){return d?new p(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(d,c){return d?new p(1,c.name):p.c}static{this.f=0}constructor(d,c){this.type=d,this.name=c,this.g=Date.now(),this.h=[]}branch(d,c){const w=new p(3,d.toString());return this.h.push([d,c,w]),w}stop(){const d=Date.now()-this.g;p.f+=d;let c=!1;function w(m,f){const n=[],r=new Array(m+1).join("	");for(const[t,i,s]of f.h)if(i&&s){c=!0,n.push(`${r}CREATES -> ${t}`);const o=w(m+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const $=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(d>2||c)&&p.all.add($.join(`
`))}}e.$hr=p});var oe=this&&this.__param||function(X,e){return function(O,D){e(O,D,X)}};define(se[65],re([0,1,20,2,12,107,21,10]),function(X,e,O,D,I,N,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=void 0,e.$Ur=l;function l(u){return u.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Vr=(0,P.$yi)("languagePackService");let a=class extends D.$Uc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new O.$qe;setTimeout(()=>v.cancel(),1e3);let b;try{b=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const p=b.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(d=>d.startsWith("lp-"))).map(R=>{const d=R.properties.localizedLanguages?.[0],c=l(R);return{...this.f(c,d,R),extensionId:R.identifier.id,galleryExtension:R}});return p.push(this.f("en","English")),p}f(v,b,y){const p=b??v;let R;if(p!==v&&(R=`(${v})`),v.toLowerCase()===I.$w.toLowerCase()&&(R??="",R+=(0,N.localize)(0,null)),y?.installCount){R??="";const d=y.installCount;let c;d>1e6?c=`${Math.floor(d/1e5)/10}M`:d>1e3?c=`${Math.floor(d/1e3)}K`:c=String(d),R+=` $(cloud-download) ${c}`}return{id:v,label:p,description:R}}};e.$Wr=a,e.$Wr=a=$e([oe(0,A.$0o)],a)}),define(se[6],re([0,1,108,34,5,43,2,30,12,17,3,11,123,10]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=R,e.log=c,e.$gk=h,e.$hk=S,e.$ik=k,e.$jk=j,e.$5j=(0,y.$yi)("logService"),e.$6j=(0,y.$yi)("loggerService");function p(){return new Date().toISOString()}function R(L){return(0,u.$cg)(L)}var d;(function(L){L[L.Off=0]="Off",L[L.Trace=1]="Trace",L[L.Debug=2]="Debug",L[L.Info=3]="Info",L[L.Warning=4]="Warning",L[L.Error=5]="Error"})(d||(e.LogLevel=d={})),e.$8j=d.Info;function c(L,q,C){switch(q){case d.Trace:L.trace(C);break;case d.Debug:L.debug(C);break;case d.Info:L.info(C);break;case d.Warning:L.warn(C);break;case d.Error:L.error(C);break;case d.Off:break;default:throw new Error(`Invalid log level ${q}`)}}function w(L,q=!1){let C="";for(let J=0;J<L.length;J++){let ne=L[J];if(ne instanceof Error&&(ne=(0,D.$jj)(ne,q)),typeof ne=="object")try{ne=JSON.stringify(ne)}catch{}C+=(J>0?" ":"")+ne}return C}class $ extends A.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new I.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(q){this.b!==q&&(this.b=q,this.c.fire(this.b))}getLevel(){return this.b}f(q){return this.b!==d.Off&&this.b<=q}}e.$0j=$;class m extends ${constructor(q){super(),this.h=q}f(q){return this.h||super.f(q)}trace(q,...C){this.f(d.Trace)&&this.g(d.Trace,w([q,...C],!0))}debug(q,...C){this.f(d.Debug)&&this.g(d.Debug,w([q,...C]))}info(q,...C){this.f(d.Info)&&this.g(d.Info,w([q,...C]))}warn(q,...C){this.f(d.Warning)&&this.g(d.Warning,w([q,...C]))}error(q,...C){if(this.f(d.Error))if(q instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=q.stack,this.g(d.Error,w(J))}else this.g(d.Error,w([q,...C]))}flush(){}}e.$$j=m;class f extends ${constructor(q=e.$8j){super(),this.setLevel(q),this.g=!l.$i}trace(q,...C){this.f(d.Trace)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,q,...C):console.log(`[main ${p()}]`,q,...C))}debug(q,...C){this.f(d.Debug)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,q,...C):console.log(`[main ${p()}]`,q,...C))}info(q,...C){this.f(d.Info)&&(this.g?console.log(`\x1B[90m[main ${p()}]\x1B[0m`,q,...C):console.log(`[main ${p()}]`,q,...C))}warn(q,...C){this.f(d.Warning)&&(this.g?console.warn(`\x1B[93m[main ${p()}]\x1B[0m`,q,...C):console.warn(`[main ${p()}]`,q,...C))}error(q,...C){this.f(d.Error)&&(this.g?console.error(`\x1B[91m[main ${p()}]\x1B[0m`,q,...C):console.error(`[main ${p()}]`,q,...C))}flush(){}}e.$_j=f;class n extends ${constructor(q=e.$8j,C=!0){super(),this.g=C,this.setLevel(q)}trace(q,...C){this.f(d.Trace)&&(this.g?console.log("%cTRACE","color: #888",q,...C):console.log(q,...C))}debug(q,...C){this.f(d.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",q,...C):console.log(q,...C))}info(q,...C){this.f(d.Info)&&(this.g?console.log("%c INFO","color: #33f",q,...C):console.log(q,...C))}warn(q,...C){this.f(d.Warning)&&(this.g?console.log("%c WARN","color: #993",q,...C):console.log(q,...C))}error(q,...C){this.f(d.Error)&&(this.g?console.log("%c  ERR","color: #f33",q,...C):console.error(q,...C))}flush(){}}e.$ak=n;class r extends ${constructor(q,C=e.$8j){super(),this.g=q,this.setLevel(C)}trace(q,...C){this.f(d.Trace)&&this.g.log(d.Trace,[this.h(q),...C])}debug(q,...C){this.f(d.Debug)&&this.g.log(d.Debug,[this.h(q),...C])}info(q,...C){this.f(d.Info)&&this.g.log(d.Info,[this.h(q),...C])}warn(q,...C){this.f(d.Warning)&&this.g.log(d.Warning,[this.h(q),...C])}error(q,...C){this.f(d.Error)&&this.g.log(d.Error,[this.h(q),...C])}h(q){return typeof q=="string"?q:(0,D.$jj)(q,this.f(d.Trace))}flush(){}}e.$bk=r;class t extends ${constructor(q){super(),this.g=q,q.length&&this.setLevel(q[0].getLevel())}setLevel(q){for(const C of this.g)C.setLevel(q);super.setLevel(q)}trace(q,...C){for(const J of this.g)J.trace(q,...C)}debug(q,...C){for(const J of this.g)J.debug(q,...C)}info(q,...C){for(const J of this.g)J.info(q,...C)}warn(q,...C){for(const J of this.g)J.warn(q,...C)}error(q,...C){for(const J of this.g)J.error(q,...C)}flush(){for(const q of this.g)q.flush()}dispose(){for(const q of this.g)q.dispose();super.dispose()}}e.$ck=t;class i extends A.$Uc{constructor(q,C,J){if(super(),this.h=q,this.j=C,this.b=new P.$Ac,this.c=this.B(new I.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$fe),this.onDidChangeVisibility=this.g.event,J)for(const ne of J)this.b.set(ne.resource,{logger:void 0,info:ne})}m(q){return(0,u.$$f)(q)?[...this.b.values()].find(C=>C.info.id===q):this.b.get(q)}getLogger(q){return this.m(q)?.logger}createLogger(q,C){const J=this.n(q),ne=(0,u.$$f)(q)?q:C?.id??(0,N.$mj)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const ue=C?.logLevel==="always"?d.Trace:C?.logLevel;ie||(ie=this.s(J,ue??this.getLogLevel(J)??this.h,{...C,id:ne}));const le={logger:ie,info:{resource:J,id:ne,logLevel:ue,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(le.info),this.b.set(J,le),ie}n(q){return(0,u.$$f)(q)?(0,a.$_g)(this.j,`${q}.log`):q}setLogLevel(q,C){if(v.URI.isUri(q)){const J=q,ne=C,ie=this.b.get(J);ie&&ne!==ie.info.logLevel&&(ie.info.logLevel=ne===this.h?void 0:ne,ie.logger?.setLevel(ne),this.b.set(ie.info.resource,ie),this.f.fire([J,ne]))}else{this.h=q;for(const[J,ne]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&ne.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(q,C){const J=this.m(q);J&&C!==!J.info.hidden&&(J.info.hidden=!C,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,C]))}getLogLevel(q){let C;return q&&(C=this.b.get(q)?.info.logLevel),C??this.h}registerLogger(q){const C=this.b.get(q.resource);C?C.info.hidden!==q.hidden&&this.setVisibility(q.resource,!q.hidden):(this.b.set(q.resource,{info:q,logger:void 0}),this.c.fire({added:[q],removed:[]}))}deregisterLogger(q){const C=this.b.get(q);C&&(C.logger&&C.logger.dispose(),this.b.delete(q),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const q of this.b.values())yield q.info}getRegisteredLogger(q){return this.b.get(q)?.info}dispose(){this.b.forEach(q=>q.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=i;class s{constructor(){this.onDidChangeLogLevel=new I.$fe().event}setLevel(q){}getLevel(){return d.Info}trace(q,...C){}debug(q,...C){}info(q,...C){}warn(q,...C){}error(q,...C){}critical(q,...C){}dispose(){}flush(){}}e.$ek=s;class o extends s{}e.$fk=o;function h(L){if(L.verbose)return d.Trace;if(typeof L.logLevel=="string"){const q=j(L.logLevel.toLowerCase());if(q!==void 0)return q}return e.$8j}function S(L){switch(L){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Off:return"off"}}function k(L){switch(L){case d.Trace:return{original:"Trace",value:O.localize(0,null)};case d.Debug:return{original:"Debug",value:O.localize(1,null)};case d.Info:return{original:"Info",value:O.localize(2,null)};case d.Warning:return{original:"Warning",value:O.localize(3,null)};case d.Error:return{original:"Error",value:O.localize(4,null)};case d.Off:return{original:"Off",value:O.localize(5,null)}}}function j(L){switch(L){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Error;case"off":return d.Off}}e.$kk=new b.$Pj("logLevel",S(d.Info))}),define(se[129],re([0,1,19,8,9,5,63,2,16,52,6]),function(X,e,O,D,I,N,A,P,l,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class v extends P.$Uc{constructor(y,p){super(),this.a=y,this.b=p,this.c=this.B(new N.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$wh(0)),this.w=[],this.y=this.B(new D.$wh(0))}watch(y,p){return p.recursive||this.b?.watcher?.forceUniversal?this.n(y,p):this.z(y,p)}n(y,p){const R={path:this.J(y),excludes:p.excludes,includes:p.includes,recursive:p.recursive,filter:p.filter,correlationId:p.correlationId},d=(0,O.$Tb)(this.j,R);return this.r(),(0,P.$Sc)(()=>{d(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,I.$1)(y))}s(){this.h||(this.h=this.B(this.t(p=>this.c.fire((0,a.$Sq)(p)),p=>this.G(p),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const p of this.j)(0,a.$Oq)(p)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const p of this.j)(0,a.$Oq)(p)&&y.includes(p.path)&&(p.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,p){const R={path:this.J(y),excludes:p.excludes,includes:p.includes,recursive:!1,filter:p.filter,correlationId:p.correlationId},d=(0,O.$Tb)(this.w,R);return this.C(),(0,P.$Sc)(()=>{d(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,I.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,a.$Sq)(y)),y=>this.G(y),this.a.getLevel()===u.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===u.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,l.$hc)(y.fsPath)}J(y){const p=this.I(y);return(0,A.$Ag)(p)}}e.$Yq=v}),define(se[130],re([0,1,19,8,14,20,5,43,66,2,48,15,131,17,46,104,13,62,6,9]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let f=class extends a.$Uc{static{m=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$fe),this.Y=this.B(new A.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$Hh)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,b.mark)(`code/registerFilesystem/${r}`);const i=new a.$Tc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),i.add(t.onDidChangeFile(s=>{const o=new d.$ll(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&i.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),i.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Pc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(i){t.push(i)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&t)}listCapabilities(){return l.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,y.$dh)(r))throw new d.$nl((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const i=new $.$bb;throw i.message=(0,R.localize)(1,null,r.toString()),i}return t}async m(r){const t=await this.j(r);if((0,d.$$k)(t)||(0,d.$8k)(t)||(0,d.$_k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,d.$$k)(t)||(0,d.$8k)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(i){throw(0,d.$il)(i)===d.FileSystemProviderErrorCode.FileNotFound?new d.$nl((0,R.localize)(2,null,this.sb(r)),1):(0,d.$gl)(i)}}async s(r,t){const i=await this.j(r),s=this.S(i),o=t?.resolveTo,h=t?.resolveSingleChildDescendants,S=t?.resolveMetadata,k=await i.stat(r);let j;return this.t(i,r,k,void 0,!!S,(L,q)=>(j||(j=u.$Ei.forUris(()=>!s),j.set(r,!0),o&&j.fill(!0,o)),j.get(L.resource)||j.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&h?q===1:!1))}async t(r,t,i,s,o,h){const{providerExtUri:S}=this.R(r),k={resource:t,name:S.basename(t),isFile:(i.type&d.FileType.File)!==0,isDirectory:(i.type&d.FileType.Directory)!==0,isSymbolicLink:(i.type&d.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&d.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&d.FilePermission.Locked),etag:(0,d.$yl)({mtime:i.mtime,size:i.size}),children:void 0};if(k.isDirectory&&h(k,s)){try{const j=await r.readdir(t),L=await D.Promises.settled(j.map(async([q,C])=>{try{const J=S.joinPath(t,q),ne=o?await r.stat(J):{type:C};return await this.t(r,J,ne,j.length,o,h)}catch(J){return this.b.trace(J),null}}));k.children=(0,O.$Hb)(L)}catch(j){this.b.trace(j),k.children=[]}return k}return k}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),i=await t.stat(r);return this.t(t,r,i,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(i){return i}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new d.$nl((0,R.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=I.$He.fromString(""),i){await this.u(r,i);const s=await this.writeFile(r,t);return this.r.fire(new d.$kl(r,0,s)),s}async writeFile(r,t,i){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let h=i;if((0,d.$bl)(s)&&!h?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(h={...i,atomic:S})}try{await this.w(s,r,h)||await this.U(s,o.dirname(r));let k;if((0,d.$8k)(s)&&!(t instanceof I.$He))if((0,p.$te)(t)){const j=await(0,p.$Ae)(t,3);j.ended?k=I.$He.concat(j.buffer):k=j}else k=(0,p.$xe)(t,j=>I.$He.concat(j),3);else k=t;!(0,d.$$k)(s)||(0,d.$8k)(s)&&k instanceof I.$He||(0,d.$8k)(s)&&(0,d.$bl)(s)&&h?.atomic?await this.hb(s,r,h,k):await this.db(s,r,h,k instanceof I.$He?(0,I.$Se)(k):k),this.r.fire(new d.$kl(r,4))}catch(S){throw new d.$nl((0,R.localize)(4,null,this.sb(r),(0,d.$gl)(S).toString()),(0,d.$jl)(S),h)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,i){const s=!!i?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(t)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(t)));if(s)throw new Error((0,R.localize)(8,null,this.sb(t)))}let h;try{h=await r.stat(t)}catch{return}if(h.type&d.FileType.Directory)throw new d.$nl((0,R.localize)(9,null,this.sb(t)),0,i);if(this.rb(t,h),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==d.$xl&&typeof h.mtime=="number"&&typeof h.size=="number"&&i.mtime<h.mtime&&i.etag!==(0,d.$yl)({mtime:i.mtime,size:h.size}))throw new d.$nl((0,R.localize)(10,null),3,i);return h}async readFile(r,t,i){const s=await this.m(r);return t?.atomic?this.z(s,r,t,i):this.C(s,r,t,i)}async z(r,t,i,s){return new Promise((o,h)=>{this.cb.queueFor(t,async()=>{try{const S=await this.C(r,t,i,s);o(S)}catch(S){h(S)}},this.R(r).providerExtUri)})}async C(r,t,i,s){const o=await this.D(r,t,{...i,preferUnbuffered:!0},s);return{...o,value:await(0,I.$Te)(o.value)}}async readFileStream(r,t,i){const s=await this.m(r);return this.D(s,r,t,i)}async D(r,t,i,s){const o=new N.$qe(s);let h=i;(0,d.$al)(r)&&r.enforceAtomicReadFile?.(t)&&(h={...i,atomic:!0});const S=this.J(t,h).then(j=>j,j=>{throw o.dispose(!0),j});let k;try{return typeof h?.etag=="string"&&h.etag!==d.$xl&&await S,h?.atomic&&(0,d.$al)(r)||!((0,d.$$k)(r)||(0,d.$_k)(r))||(0,d.$8k)(r)&&h?.preferUnbuffered?k=this.I(r,t,h):(0,d.$_k)(r)?k=this.G(r,t,o.token,h):k=this.H(r,t,o.token,h),k.on("end",()=>o.dispose()),k.on("error",()=>o.dispose()),{...await S,value:k}}catch(j){throw k&&await(0,p.$ye)(k),this.F(j,t,h)}}F(r,t,i){const s=(0,R.localize)(11,null,this.sb(t),(0,d.$gl)(r).toString());return r instanceof d.$pl?new d.$pl(s,r.stat,i):r instanceof d.$ol?new d.$ol(s,r.fileOperationResult,r.size,r.options):new d.$nl(s,(0,d.$jl)(r),i)}G(r,t,i,s=Object.create(null)){const o=r.readFileStream(t,s,i);return(0,p.$Ee)(o,{data:h=>h instanceof I.$He?h:I.$He.wrap(h),error:h=>this.F(h,t,s)},h=>I.$He.concat(h))}H(r,t,i,s=Object.create(null)){const o=(0,I.$Xe)();return(0,c.$Lq)(r,t,o,h=>h,{...s,bufferSize:this.a,errorTransformer:h=>this.F(h,t,s)},i),o}I(r,t,i){const s=(0,p.$ve)(o=>I.$He.concat(o));return(async()=>{try{let o;i?.atomic&&(0,d.$al)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.L(t,o.byteLength,i),s.end(I.$He.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new d.$nl((0,R.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==d.$xl&&t.etag===i.etag)throw new d.$pl((0,R.localize)(13,null),i,t);return this.L(r,i.size,t),i}L(r,t,i){if(typeof i?.limits?.size=="number"&&t>i.limits.size)throw new d.$ol((0,R.localize)(14,null,this.sb(r)),7,t,i)}async canMove(r,t,i){return this.M(r,t,"move",i)}async canCopy(r,t,i){return this.M(r,t,"copy",i)}async M(r,t,i,s){if(r.toString()!==t.toString())try{const o=i==="move"?this.qb(await this.n(r),r):await this.m(r),h=this.qb(await this.n(t),t);await this.Q(o,r,h,t,i,s)}catch(o){return o}return!0}async move(r,t,i){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"move",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kl(r,h==="move"?2:3,S)),S}async copy(r,t,i){const s=await this.m(r),o=this.qb(await this.n(t),t),h=await this.N(s,r,o,t,"copy",!!i),S=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new d.$kl(r,h==="copy"?3:2,S)),S}async N(r,t,i,s,o,h){if(t.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:k}=await this.Q(r,t,i,s,o,h);if(S&&!k&&h&&await this.del(s,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(s)),o==="copy"){if(r===i&&(0,d.$9k)(r))await r.copy(t,s,{overwrite:h});else{const j=await this.resolve(t);j.isDirectory?await this.P(r,j,i,s):await this.O(r,t,i,s)}return o}else return r===i?(await r.rename(t,s,{overwrite:h}),o):(await this.N(r,t,i,s,"copy",h),await this.del(t,{recursive:!0}),"copy")}async O(r,t,i,s){if((0,d.$$k)(r)&&(0,d.$$k)(i))return this.jb(r,t,i,s);if((0,d.$$k)(r)&&(0,d.$8k)(i))return this.pb(r,t,i,s);if((0,d.$8k)(r)&&(0,d.$$k)(i))return this.nb(r,t,i,s);if((0,d.$8k)(r)&&(0,d.$8k)(i))return this.lb(r,t,i,s)}async P(r,t,i,s){await i.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const h=this.R(i).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),i,h):this.O(r,o.resource,i,h)}))}async Q(r,t,i,s,o,h){let S=!1;if(r===i){const{providerExtUri:j,isPathCaseSensitive:L}=this.R(r);if(L||(S=j.isEqual(t,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(t),this.sb(s)));if(!S&&j.isEqualOrParent(s,t))throw new Error((0,R.localize)(16,null,this.sb(t),this.sb(s)))}const k=await this.exists(s);if(k&&!S){if(!h)throw new d.$nl((0,R.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===i){const{providerExtUri:j}=this.R(r);if(j.isEqualOrParent(t,s))throw new Error((0,R.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:k,isSameResourceWithDifferentPathCase:S}}R(r){const t=this.S(r);return{providerExtUri:t?y.$2g:y.$4g,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new d.$kl(r,0,i)),i}async U(r,t){const i=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&d.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(t)));break}catch(o){if((0,d.$il)(o)!==d.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(s.basename(t)),t=s.dirname(t)}for(let o=i.length-1;o>=0;o--){t=s.joinPath(t,i[o]);try{await r.mkdir(t)}catch(h){if((0,d.$il)(h)!==d.FileSystemProviderErrorCode.FileExists)throw h}}}async canDelete(r,t){try{await this.W(r,t)}catch(i){return i}return!0}async W(r,t){const i=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(i.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(i.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let h;try{h=await i.stat(r)}catch{}if(h)this.rb(r,h);else throw new d.$nl((0,R.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const k=await this.resolve(r);if(k.isDirectory&&Array.isArray(k.children)&&k.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return i}async del(r,t){const i=await this.W(r,t);let s=t;if((0,d.$cl)(i)&&!s?.atomic){const k=i.enforceAtomicDelete?.(r);k&&(s={...t,atomic:k})}const o=!!s?.useTrash,h=!!s?.recursive,S=s?.atomic??!1;await i.delete(r,{recursive:h,useTrash:o,atomic:S}),this.r.fire(new d.$kl(r,1))}async cloneFile(r,t){const i=await this.j(r),s=this.qb(await this.n(t),t);if(!(i===s&&this.R(i).providerExtUri.isEqual(r,t)))return i===s&&(0,d.$0k)(i)?i.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),i===s&&(0,d.$9k)(i)?this.cb.queueFor(r,()=>i.copy(r,t,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,s,t),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:m.ab++})}watch(r,t={recursive:!1,excludes:[]}){const i=new a.$Tc;let s=!1,o=()=>{s=!0};i.add((0,a.$Sc)(()=>o())),(async()=>{try{const S=await this.bb(r,t);s?(0,a.$Pc)(S):o=()=>(0,a.$Pc)(S)}catch(S){this.b.error(S)}})();const h=t.correlationId;if(typeof h=="number"){const S=i.add(new A.$fe);return i.add(this.X.event(j=>{j.correlates(h)&&S.fire(j)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(r,t){const i=await this.j(r),s=(0,P.$mj)([this.R(i).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:i.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,t,i,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:i?.unlock??!1});try{(0,p.$te)(s)||(0,p.$ue)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(h){throw(0,d.$gl)(h)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,i){let s=0,o;if((0,p.$ue)(i)){if(i.buffer.length>0){const h=I.$He.concat(i.buffer);await this.gb(r,t,h,h.byteLength,s,0),s+=h.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((h,S)=>{(0,p.$ze)(o,{onData:async k=>{o.pause();try{await this.gb(r,t,k,k.byteLength,s,0)}catch(j){return S(j)}s+=k.byteLength,setTimeout(()=>o.resume())},onError:k=>S(k),onEnd:()=>h()})})}async fb(r,t,i){let s=0,o;for(;(o=i.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,i,s,o,h){let S=0;for(;S<s;){const k=await r.write(t,o+S,i.buffer,h+S,s-S);S+=k}}async hb(r,t,i,s){return this.cb.queueFor(t,()=>this.ib(r,t,i,s),this.R(r).providerExtUri)}async ib(r,t,i,s){let o;s instanceof I.$He?o=s:(0,p.$te)(s)?o=await(0,I.$Te)(s):(0,p.$ue)(s)?o=await(0,I.$Ue)(s):o=(0,I.$Re)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,t,i,s){return this.cb.queueFor(s,()=>this.kb(r,t,i,s),this.R(i).providerExtUri)}async kb(r,t,i,s){let o,h;try{o=await r.open(t,{create:!1}),h=await i.open(s,{create:!0,unlock:!1});const S=I.$He.alloc(this.a);let k=0,j=0,L=0;do L=await r.read(o,k,S.buffer,j,S.byteLength-j),await this.gb(i,h,S,L,k,j),k+=L,j+=L,j===S.byteLength&&(j=0);while(L>0)}catch(S){throw(0,d.$gl)(S)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof h=="number"?i.close(h):Promise.resolve()])}}async lb(r,t,i,s){return this.cb.queueFor(s,()=>this.mb(r,t,i,s),this.R(i).providerExtUri)}async mb(r,t,i,s){return i.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,i,s){return this.cb.queueFor(s,()=>this.ob(r,t,i,s),this.R(i).providerExtUri)}async ob(r,t,i,s){const o=await i.open(s,{create:!0,unlock:!1});try{const h=await r.readFile(t);await this.gb(i,o,I.$He.wrap(h),h.byteLength,0,0)}catch(h){throw(0,d.$gl)(h)}finally{await i.close(o)}}async pb(r,t,i,s){const o=await(0,I.$Te)(this.H(r,t,N.CancellationToken.None));await this.hb(i,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new d.$nl((0,R.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&d.FilePermission.Readonly)throw new d.$nl((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===v.Schemas.file?r.fsPath:r.toString(!0)}};e.$Mq=f,e.$Mq=f=m=$e([oe(0,w.$5j)],f)}),define(se[132],re([0,1,60,174,8,30,14,5,63,2,16,12,17,46,25,106,13,62,129,34,127,126]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,(()=>{try{(0,D.gracefulify)(O)}catch(r){console.error(`Error enabling graceful-fs: ${(0,$.$jj)(r)}`)}})();class n extends w.$Yq{static{this.L=!1}constructor(t,i){super(t,i),this.onDidChangeCapabilities=P.Event.None,this.P=new N.$Ac(s=>b.$3g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,v.$k&&(this.M|=1024)),this.M}async stat(t){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.I(t));return{type:this.O(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:d.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const i=await p.Promises.readdir(this.I(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let h;o.isSymbolicLink()?h=(await this.stat((0,b.$_g)(t,o.name))).type:h=this.O(o),s.push([o.name,h])}catch(h){this.a.trace(h)}})),s}catch(i){throw this.hb(i)}}O(t,i){let s;return i?.dangling?s=d.FileType.Unknown:t.isFile()?s=d.FileType.File:t.isDirectory()?s=d.FileType.Directory:s=d.FileType.Unknown,i&&(s|=d.FileType.SymbolicLink),s}async Q(t){const i=this.I(t);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.P.get(t);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new I.$xh;return this.P.set(t,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(t)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(t)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(t)})`),s=await this.Q(t));const o=this.I(t);return await p.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(t){n.L&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,y.$ve)(h=>A.$He.concat(h.map(S=>A.$He.wrap(S))).buffer);return(0,c.$Lq)(this,t,o,h=>h.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(t)?this.U(t,(0,b.$_g)((0,b.$$g)(t),`${(0,b.$9g)(t)}${s.atomic.postfix}`),i,s):this.W(t,i,s)}async S(t){try{const i=this.I(t),{symbolicLink:s}=await p.SymlinkSupport.stat(i);if(s)return!1}catch{}return!0}async U(t,i,s,o){const h=new a.$Tc;try{h.add(await this.Q(t)),h.add(await this.Q(i)),await this.W(i,s,o,!0);try{await this.rename(i,t,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{h.dispose()}}async W(t,i,s,o){let h;try{const S=this.I(t);if(!s.create||!s.overwrite){if(await p.Promises.exists(S)){if(!s.overwrite)throw(0,d.$fl)((0,R.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,d.$fl)((0,R.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}h=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(h,0,i,0,i.byteLength)}catch(S){throw await this.ib(t,S)}finally{typeof h=="number"&&await this.close(h)}}static{this.$=!0}static configureFlushOnWrite(t){n.$=t}async open(t,i,s){const o=this.I(t);let h;(0,d.$6k)(i)&&!s&&(h=await this.Q(t));let S;try{if((0,d.$6k)(i)&&i.unlock)try{const{stat:j}=await p.SymlinkSupport.stat(o);j.mode&128||await p.Promises.chmod(o,j.mode|128)}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}let k;if((0,d.$6k)(i)){if(v.$i)try{await p.Promises.truncate(o,0),k="r+"}catch(j){j.code!=="ENOENT"&&this.a.trace(j)}k||(k="w")}else k="r";S=await p.Promises.open(o,k)}catch(k){throw h?.dispose(),(0,d.$6k)(i)?await this.ib(t,k):this.hb(k)}if(this.X.set(S,0),(0,d.$6k)(i)&&this.Z.set(S,t),h){const k=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.Y.set(S,h),k&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),k.dispose())}return S}async close(t){const i=this.Y.get(t);try{if(this.X.delete(t),this.Z.delete(t)&&n.$)try{await p.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(t)}catch(s){throw this.hb(s)}finally{i&&(this.Y.get(t)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.Y.delete(t)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,h){const S=this.ab(t,i);let k=null;try{k=(await p.Promises.read(t,s,o,h,S)).bytesRead}catch(j){throw this.hb(j)}finally{this.bb(t,S,k)}return k}ab(t,i){return i===this.X.get(t)?null:i}bb(t,i,s){const o=this.X.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.X.set(t,o+s):this.X.delete(t)))}async write(t,i,s,o,h){return(0,I.$Sh)(()=>this.cb(t,i,s,o,h),100,3)}async cb(t,i,s,o,h){const S=this.ab(t,i);let k=null;try{k=(await p.Promises.write(t,s,o,h,S)).bytesWritten}catch(j){throw await this.ib(this.Z.get(t),j)}finally{this.bb(t,S,k)}return k}async mkdir(t){try{await p.Promises.mkdir(this.I(t))}catch(i){throw this.hb(i)}}async delete(t,i){try{const s=this.I(t);if(i.recursive){let o;i?.atomic!==!1&&i.atomic.postfix&&(o=(0,u.$jc)((0,u.$mc)(s),`${(0,u.$nc)(s)}${i.atomic.postfix}`)),await p.Promises.rm(s,p.RimRafMode.MOVE,o)}else try{await p.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let h=!1;try{const{stat:S,symbolicLink:k}=await p.SymlinkSupport.stat(s);h=S.isDirectory()&&!k}catch{}if(h)await p.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"move",s.overwrite),await p.Promises.rename(o,h)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(2,null,(0,u.$nc)(o),(0,u.$nc)((0,u.$mc)(h)),S.toString()))),this.hb(S)}}async copy(t,i,s){const o=this.I(t),h=this.I(i);if(o!==h)try{await this.db(t,i,"copy",s.overwrite),await p.Promises.copy(o,h,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(3,null,(0,u.$nc)(o),(0,u.$nc)((0,u.$mc)(h)),S.toString()))),this.hb(S)}}async db(t,i,s,o){const h=this.I(t),S=this.I(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,l.$wg)(h,S,!0)),k){if(s==="copy")throw(0,d.$fl)((0,R.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const L=await this.N(t);if(!L)throw(0,d.$fl)((0,R.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const q=await this.N(i);if(q){if(!o)throw(0,d.$fl)((0,R.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);L.type&d.FileType.File&&q.type&d.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,i){return this.eb(t,i,!1)}async eb(t,i,s){const o=this.I(t),h=this.I(i),S=!!(this.capabilities&1024);if((0,l.$wg)(o,h,!S))return;const k=new a.$Tc;try{k.add(await this.Q(t)),k.add(await this.Q(i)),s&&await p.Promises.mkdir((0,u.$mc)(h),{recursive:!0}),await p.Promises.copyFile(o,h)}catch(j){if(j.code==="ENOENT"&&!s)return this.eb(t,i,!0);throw this.hb(j)}finally{k.dispose()}}t(t,i,s){return new m.$6q(o=>t(o),o=>i(o),s)}F(t,i,s){return new f.$cr(o=>t(o),o=>i(o),s)}hb(t){if(t instanceof d.$el)return t;let i=t,s;switch(t.code){case"ENOENT":s=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=d.FileSystemProviderErrorCode.Unknown;break;default:s=d.FileSystemProviderErrorCode.Unknown}return(0,d.$fl)(i,s)}async ib(t,i){let s=this.hb(i);if(t&&s.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await p.SymlinkSupport.stat(this.I(t));o.mode&128||(s=(0,d.$fl)(i,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$dr=n}),define(se[133],re([0,1,2,6]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class I extends O.$Uc{constructor(A,P=[]){super(),this.a=new D.$ck([A,...P]),this.B(A.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...P){this.a.trace(A,...P)}debug(A,...P){this.a.debug(A,...P)}info(A,...P){this.a.info(A,...P)}warn(A,...P){this.a.warn(A,...P)}error(A,...P){this.a.error(A,...P)}flush(){this.a.flush()}}e.$bQ=I}),define(se[134],re([0,1,13,6]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I||(I={}));async function N(a,u,v,b,y){try{const p=await new Promise((d,c)=>{X(["@vscode/spdlog"],d,c)});p.setFlushOn(I.Trace);const R=await p.createAsyncRotatingLogger(a,u,v,b);return y?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch(p){console.error(p)}return null}function A(a,u,v){switch(u){case D.LogLevel.Trace:a.trace(v);break;case D.LogLevel.Debug:a.debug(v);break;case D.LogLevel.Info:a.info(v);break;case D.LogLevel.Warning:a.warn(v);break;case D.LogLevel.Error:a.error(v);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${u}`)}}function P(a,u){switch(u){case D.LogLevel.Trace:a.setLevel(I.Trace);break;case D.LogLevel.Debug:a.setLevel(I.Debug);break;case D.LogLevel.Info:a.setLevel(I.Info);break;case D.LogLevel.Warning:a.setLevel(I.Warning);break;case D.LogLevel.Error:a.setLevel(I.Error);break;case D.LogLevel.Off:a.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${u}`)}}class l extends D.$$j{constructor(u,v,b,y,p){super(),this.m=[],this.setLevel(p),this.n=this.s(u,v,b,y),this.B(this.onDidChangeLogLevel(R=>{this.r&&P(this.r,R)}))}async s(u,v,b,y){const p=b?6:1,R=30/p*O.$Al.MB,d=await N(u,v,R,p,y);if(d){this.r=d,P(this.r,this.getLevel());for(const{level:c,message:w}of this.m)A(this.r,c,w);this.m=[]}}g(u,v){this.r?A(this.r,u,v):this.getLevel()<=u&&this.m.push({level:u,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$3P=l}),define(se[135],re([0,1,28,6,134]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;class N extends D.$dk{s(P,l,a){return new I.$3P((0,O.$Ug)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,l)}}e.$4P=N}),define(se[39],re([0,1,5,66,2,10]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,N.$yi)("policy");class A extends I.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const u=Object.keys(this.f).length;return this.f={...a,...this.f},u!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(v,[b,y])=>({...v,[b]:y}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[u,v])=>({...a,[u]:{definition:v,value:this.g.get(u)}}),{})}}e.$io=A;class P{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=P}),define(se[136],re([0,1,8,5,66,3,13,6,39]),function(X,e,O,D,I,N,A,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=void 0;function a(v,b){const y=[];for(const p of new Set(I.Iterable.concat(v.keys(),b.keys())))v.get(p)!==b.get(p)&&y.push(p);return y}let u=class extends l.$io{constructor(b,y,p){super(),this.m=b,this.n=y,this.s=p,this.c=this.B(new O.$wh(500));const R=D.Event.filter(y.onDidFilesChange,d=>d.affects(b));this.B(y.watch(b)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const b=new Map;try{const y=await this.n.readFile(this.m),p=JSON.parse(y.value.toString());if(!(0,N.$ag)(p))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys(p))this.f[R]&&b.set(R,p[R])}catch(y){y.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",y)}return b}async w(){const b=await this.u(),y=a(this.g,b);this.g=b,y.length>0&&this.h.fire(y)}};e.$zec=u,e.$zec=u=$e([oe(1,A.$5k),oe(2,P.$5j)],u)}),define(se[137],re([0,1,39,8,2,6]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yec=void 0;let A=class extends O.$io{constructor(l,a){super(),this.m=l,this.n=a,this.a=new D.$sh,this.b=this.B(new I.$Vc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`);const{createWatcher:a}=await new Promise((u,v)=>{X(["@vscode/policy-watcher"],u,v)});await this.a.queue(()=>new Promise((u,v)=>{try{this.b.value=a(this.n,l,b=>{this.t(b),u()})}catch(b){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",b),v(b)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const a in l){const u=l[a];u===void 0?this.g.delete(a):this.g.set(a,u)}this.h.fire(Object.keys(l))}};e.$yec=A,e.$yec=A=$e([oe(0,N.$5j)],A)}),define(se[32],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,O.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(se[36],re([0,1,74,3]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class I{constructor(){this.a=new Map}add(A,P){O.ok(D.$$f(A)),O.ok(D.$ag(P)),O.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$fo=new I}),define(se[138],re([0,1,5,36]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class N{constructor(){this.b=new O.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,a){this.a[I(l)]=a,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$fo.add(e.$go.JSONContribution,A)}),define(se[40],re([0,1,19,5,3,93,29,138,36]),function(X,e,O,D,I,N,A,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=R,e.$wo=d,e.$xo=c,e.$yo=$,e.$zo=m;var a;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$ko={Configuration:"base.contributions.configuration"};var u;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u||(e.ConfigurationScope=u={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const v=l.$fo.as(P.$go.JSONContribution);class b{constructor(){this.h=new Set,this.i=new D.$fe,this.onDidSchemaChange=this.i.event,this.j=new D.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),v.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),v.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),v.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.$uo.test(o)){const h=this.a.get(o),S=h?.valuesSources??new Map;if(s)for(const q of Object.keys(i[o]))S.set(q,s);const k={...h?.value||{},...i[o]};this.a.set(o,{source:s,value:k,valuesSources:S});const j=(0,A.$cj)(o),L={type:"object",default:k,description:N.localize(1,null,j),$ref:e.$ro,defaultDefaultValue:k,source:I.$$f(s)?void 0:s,defaultValueSource:s};t.push(...R(o)),this.d[o]=L,this.b.properties[o]=L}else{this.a.set(o,{value:i[o],source:s});const h=this.d[o];h&&(this.w(o,h),this.r(o,h))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),h=I.$$f(i)?i:i?.id,S=I.$$f(o?.source)?o?.source:o?.source?.id;if(h===S)if(r.add(s),this.a.delete(s),e.$uo.test(s))delete this.d[s],delete this.b.properties[s];else{const k=this.d[s];k&&(this.w(s,k),this.r(s,k))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=I.$hg(n.scope)?s:n.scope;const h=n.properties;if(h)for(const k in h){const j=h[k];if(r&&$(k,j)){delete h[k];continue}if(j.source=t,j.defaultDefaultValue=h[k].default,this.w(k,j),e.$uo.test(k)?j.scope=void 0:(j.scope=I.$hg(j.scope)?s:j.scope,j.restricted=I.$hg(j.restricted)?!!i?.includes(k):j.restricted),h[k].hasOwnProperty("included")&&!h[k].included){this.f[k]=h[k],delete h[k];continue}else this.d[k]=h[k],h[k].policy?.name&&this.e.set(h[k].policy.name,k);!h[k].deprecationMessage&&h[k].markdownDeprecationMessage&&(h[k].deprecationMessage=h[k].markdownDeprecationMessage),o.add(k)}const S=n.allOf;if(S)for(const k of S)this.p(k,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$lo.properties[n]=r,r.scope){case 1:e.$mo.properties[n]=r;break;case 2:e.$no.properties[n]=r;break;case 6:e.$oo.properties[n]=r;break;case 3:e.$po.properties[n]=r;break;case 4:e.$qo.properties[n]=r;break;case 5:e.$qo.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$lo.properties[n],r.scope){case 1:delete e.$mo.properties[n];break;case 2:delete e.$no.properties[n];break;case 6:delete e.$oo.properties[n];break;case 3:delete e.$po.properties[n];break;case 4:case 5:delete e.$qo.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$ro};this.w(r,t),e.$lo.properties[r]=t,e.$mo.properties[r]=t,e.$no.properties[r]=t,e.$oo.properties[r]=t,e.$po.properties[r]=t,e.$qo.properties[r]=t}}v(){const n={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=n,e.$mo.patternProperties[e.$to]=n,e.$no.patternProperties[e.$to]=n,e.$oo.patternProperties[e.$to]=n,e.$po.patternProperties[e.$to]=n,e.$qo.patternProperties[e.$to]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;I.$fg(i)&&(i=r.defaultDefaultValue,s=void 0),I.$fg(i)&&(i=c(r.type)),r.default=i,r.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",p=new RegExp(y,"g");e.$to=`^(${y})+$`,e.$uo=new RegExp(e.$to);function R(f){const n=[];if(e.$uo.test(f)){let r=p.exec(f);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=p.exec(f)}}return(0,O.$Mb)(n)}function d(f){return f.reduce((n,r)=>`${n}[${r}]`,"")}function c(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new b;l.$fo.add(e.$ko.Configuration,w);function $(f,n){return f.trim()?e.$uo.test(f)?N.localize(7,null,f):w.getConfigurationProperties()[f]!==void 0?N.localize(8,null,f):n.policy?.name&&w.getPolicyConfigurations().get(n.policy?.name)!==void 0?N.localize(9,null,f,n.policy?.name,w.getPolicyConfigurations().get(n.policy?.name)):null:N.localize(6,null)}function m(){const f=[],n=w.getConfigurationProperties();for(const r of Object.keys(n))f.push([r,n[r].scope]);return f.push(["launch",4]),f.push(["task",4]),f}}),define(se[67],re([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(X,e,O,D,I,N,A,P,l,a,u,v,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=$;function y(r){return Object.isFrozen(r)?r:P.$6n(r)}class p{static createEmptyModel(t){return new p({},[],[],void 0,t)}constructor(t,i,s,o,h){this.b=t,this.c=i,this.d=s,this.raw=o,this.f=h,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof p)return i;const s=new R("",this.f);return s.parseRaw(i),s.configurationModel});this.g=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,u.$aj)(this.contents,t):this.contents}inspect(t,i){const s=this;return{get value(){return y(s.rawConfiguration.getValue(t))},get override(){return i?y(s.rawConfiguration.getOverrideValue(t,i)):void 0},get merged(){return y(i?s.rawConfiguration.override(i).getValue(t):s.rawConfiguration.getValue(t))},get overrides(){const o=[];for(const{contents:h,identifiers:S,keys:k}of s.rawConfiguration.overrides){const j=new p(h,k,[],void 0,s.f).getValue(t);j!==void 0&&o.push({identifiers:S,value:j})}return o.length?y(o):void 0}}}getOverrideValue(t,i){const s=this.j(i);return s?t?(0,u.$aj)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return O.$Mb(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return O.$Mb(t)}override(t){let i=this.a.get(t);return i||(i=this.h(t),this.a.set(t,i)),i}merge(...t){const i=P.$5n(this.contents),s=P.$5n(this.overrides),o=[...this.keys],h=this.raw?.length?[...this.raw]:[this];for(const S of t)if(h.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(i,S.contents);for(const k of S.overrides){const[j]=s.filter(L=>O.$ub(L.identifiers,k.identifiers));j?(this.i(j.contents,k.contents),j.keys.push(...k.keys),j.keys=O.$Mb(j.keys)):s.push(P.$5n(k))}for(const k of S.keys)o.indexOf(k)===-1&&o.push(k)}return new p(i,o,s,h.every(S=>S instanceof p)?void 0:h,this.f)}h(t){const i=this.j(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of O.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let h=this.contents[o];const S=i[o];S&&(typeof h=="object"&&typeof S=="object"?(h=P.$5n(h),this.i(h,S)):h=S),s[o]=h}return new p(s,this.keys,this.overrides,void 0,this.f)}i(t,i){for(const s of Object.keys(i)){if(s in t&&l.$ag(t[s])&&l.$ag(i[s])){this.i(t[s],i[s]);continue}t[s]=P.$5n(i[s])}}j(t){let i=null,s=null;const o=h=>{h&&(s?this.i(s,h):s=P.$5n(h))};for(const h of this.overrides)h.identifiers.length===1&&h.identifiers[0]===t?i=h.contents:h.identifiers.includes(t)&&o(h.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.k(t,i,!0)}setValue(t,i){this.k(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,u.$_i)(this.contents,t),v.$uo.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>O.$ub(s.identifiers,(0,v.$vo)(t))),1))}k(t,i,s){(0,u.$$i)(this.contents,t,i,o=>this.f.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),v.$uo.test(t)&&this.overrides.push({identifiers:(0,v.$vo)(t),keys:Object.keys(this.contents[t]),contents:(0,u.$0i)(this.contents[t],o=>this.f.error(o))})}}e.$Ao=p;class R{constructor(t,i){this.f=t,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||p.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!l.$hg(t)){const s=this.h(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:h,restricted:S,hasExcludedProperties:k}=this.i(t,i);this.b=new p(s,o,h,k?[t]:void 0,this.g),this.c=S||[]}h(t){let i={},s=null,o=[];const h=[],S=[];function k(L){Array.isArray(o)?o.push(L):s!==null&&(o[s]=L)}const j={onObjectBegin:()=>{const L={};k(L),h.push(o),o=L,s=null},onObjectProperty:L=>{s=L},onObjectEnd:()=>{o=h.pop()},onArrayBegin:()=>{const L=[];k(L),h.push(o),o=L,s=null},onArrayEnd:()=>{o=h.pop()},onLiteralValue:k,onError:(L,q,C)=>{S.push({error:L,offset:q,length:C})}};if(t)try{I.$Sn(t,j),i=o[0]||{}}catch(L){this.g.error(`Error while parsing settings file ${this.f}: ${L}`),this.d=[L]}return i}i(t,i){const s=b.$fo.as(v.$ko.Configuration).getConfigurationProperties(),o=this.j(t,s,!0,i);t=o.raw;const h=(0,u.$0i)(t,j=>this.g.error(`Conflict in settings file ${this.f}: ${j}`)),S=Object.keys(t),k=this.l(t,j=>this.g.error(`Conflict in settings file ${this.f}: ${j}`));return{contents:h,keys:S,overrides:k,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(t,i,s,o){let h=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:h};const S={},k=[];for(const j in t)if(v.$uo.test(j)&&s){const L=this.j(t[j],i,!1,o);S[j]=L.raw,h=h||L.hasExcludedProperties,k.push(...L.restricted)}else{const L=i[j],q=L?typeof L.scope<"u"?L.scope:3:void 0;L?.restricted&&k.push(j),!o.exclude?.includes(j)&&(o.include?.includes(j)||(q===void 0||o.scopes===void 0||o.scopes.includes(q))&&!(o.skipRestricted&&L?.restricted))?S[j]=t[j]:h=!0}return{raw:S,restricted:k,hasExcludedProperties:h}}l(t,i){const s=[];for(const o of Object.keys(t))if(v.$uo.test(o)){const h={};for(const S in t[o])h[S]=t[o][S];s.push({identifiers:(0,v.$vo)(o),keys:Object.keys(h),contents:(0,u.$0i)(h,i)})}return s}}e.$Bo=R;class d extends N.$Uc{constructor(t,i,s,o,h){super(),this.c=t,this.f=i,this.g=o,this.h=h,this.b=this.B(new D.$fe),this.onDidChange=this.b.event,this.a=new R(this.c.toString(),h),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return p.createEmptyModel(this.h)}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=d;class c{constructor(t,i,s,o,h,S,k,j,L,q,C,J,ne){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=h,this.f=S,this.g=k,this.h=j,this.i=L,this.j=q,this.k=C,this.l=J,this.m=ne}get value(){return y(this.c)}n(t){return t?.value!==void 0||t?.override!==void 0||t?.overrides!==void 0?t:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class w{constructor(t,i,s,o,h,S,k,j,L,q){this.j=t,this.l=i,this.m=s,this.n=o,this.p=h,this.q=S,this.r=k,this.s=j,this.t=L,this.u=q,this.h=null,this.i=new A.$Ac,this.v=null}getValue(t,i,s){return this.w(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=p.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.h=null)}inspect(t,i,s){const o=this.w(t,i,s),h=this.A(i.resource,s),S=i.resource?this.t.get(i.resource)||this.s:this.s,k=new Set;for(const j of o.overrides)for(const L of j.identifiers)o.getOverrideValue(t,L)!==void 0&&k.add(L);return new c(t,i,o.getValue(t),k.size?[...k]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,h||void 0,S)}keys(t){const i=this.A(void 0,t);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.j=t,this.h=null,this.i.clear()}updatePolicyConfiguration(t){this.l=t}updateApplicationConfiguration(t){this.m=t,this.h=null,this.i.clear()}updateLocalUserConfiguration(t){this.n=t,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(t){this.p=t,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(t){this.q=t,this.h=null,this.i.clear()}updateFolderConfiguration(t,i){this.r.set(t,i),this.i.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.i.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:h,removed:S}=f(this.j,t);i=[...o,...h,...S]}for(const o of i)for(const h of(0,v.$vo)(o)){const S=this.j.getKeysForOverrideIdentifier(h),k=t.getKeysForOverrideIdentifier(h),j=[...k.filter(L=>S.indexOf(L)===-1),...S.filter(L=>k.indexOf(L)===-1),...S.filter(L=>!P.$9n(this.j.override(h).getValue(L),t.override(h).getValue(L)))];s.push([h,j])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=f(this.l,t),h=[...i,...s,...o];return h.length&&this.updatePolicyConfiguration(t),{keys:h,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=f(this.applicationConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateApplicationConfiguration(t),{keys:S,overrides:h}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=f(this.localUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateLocalUserConfiguration(t),{keys:S,overrides:h}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=f(this.remoteUserConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateRemoteUserConfiguration(t),{keys:S,overrides:h}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:h}=f(this.workspaceConfiguration,t),S=[...i,...s,...o];return S.length&&this.updateWorkspaceConfiguration(t),{keys:S,overrides:h}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:o,updated:h,removed:S,overrides:k}=f(s,i),j=[...o,...h,...S];return(j.length||!s)&&this.updateFolderConfiguration(t,i),{keys:j,overrides:k}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:h,overrides:S}=f(i,void 0);return{keys:[...s,...o,...h],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(t,i,s){let o=this.x(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(t)!==void 0&&(o=o.merge(this.l)),o}x({resource:t},i){let s=this.y();if(i&&t){const o=i.getFolder(t);o&&(s=this.z(o.uri)||s);const h=this.t.get(t);h&&(s=s.merge(h))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(t){let i=this.i.get(t);if(!i){const s=this.y(),o=this.r.get(t);o?(i=s.merge(o),this.i.set(t,i)):i=s}return i}A(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:h}=this.r.get(i);return t.push([i,{contents:s,overrides:o,keys:h}]),t},[])}}allKeys(){const t=new Set;return this.j.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.q.keys.forEach(i=>t.add(i)),this.r.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}B(){const t=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}D(t){const i=new Set;return this.j.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.q.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t,i){const s=this.E(t.defaults,i),o=this.E(t.policy,i),h=this.E(t.application,i),S=this.E(t.user,i),k=this.E(t.workspace,i),j=t.folders.reduce((L,q)=>(L.set(a.URI.revive(q[0]),this.E(q[1],i)),L),new A.$Ac);return new w(s,o,h,S,p.createEmptyModel(i),k,j,p.createEmptyModel(i),new A.$Ac,i)}static E(t,i){return new p(t.contents,t.keys,t.overrides,void 0,i)}}e.$Do=w;function $(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(h=>t.add(h)),o.overrides.forEach(([h,S])=>{const k=(0,A.$xc)(i,h,new Set);S.forEach(j=>k.add(j))});const s=[];return i.forEach((o,h)=>s.push([h,[...o.values()]])),{keys:[...t.values()],overrides:s}}class m{constructor(t,i,s,o,h){this.change=t,this.f=i,this.g=s,this.h=o,this.i=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of t.keys)this.affectedKeys.add(S);for(const[,S]of t.overrides)for(const k of S)this.affectedKeys.add(k);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=w.parse(this.f.data,this.i)),this.j}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const h=o+s.length;if(h>=this.d.length)return!1;const S=this.d.charCodeAt(h);if(S!==this.b&&S!==this.c)return!1;if(i){const k=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,j=this.g.getValue(t,i,this.h);return!P.$9n(k,j)}return!0}}e.$Fo=m;function f(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),h=[],S=r?.getAllOverrideIdentifiers()||[],k=t?.getAllOverrideIdentifiers()||[];if(t){const j=k.filter(L=>!S.includes(L));for(const L of j)h.push([L,t.getKeysForOverrideIdentifier(L)])}if(r){const j=S.filter(L=>!k.includes(L));for(const L of j)h.push([L,r.getKeysForOverrideIdentifier(L)])}if(t&&r){for(const j of S)if(k.includes(j)){const L=n({contents:r.getOverrideValue(void 0,j)||{},keys:r.getKeysForOverrideIdentifier(j)},{contents:t.getOverrideValue(void 0,j)||{},keys:t.getKeysForOverrideIdentifier(j)});h.push([j,[...L.added,...L.removed,...L.updated]])}}return{added:i,removed:s,updated:o,overrides:h}}function n(r,t){const i=r?t?r.keys.filter(h=>t.keys.indexOf(h)===-1):[...r.keys]:[],s=t?r?t.keys.filter(h=>r.keys.indexOf(h)===-1):[...t.keys]:[],o=[];if(r&&t){for(const h of t.keys)if(r.keys.indexOf(h)!==-1){const S=(0,u.$aj)(t.contents,h),k=(0,u.$aj)(r.contents,h);P.$9n(S,k)||o.push(h)}}return{added:i,removed:s,updated:o}}}),define(se[139],re([0,1,19,5,2,27,3,67,40,6,39,36]),function(X,e,O,D,I,N,A,P,l,a,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class b extends I.$Uc{get configurationModel(){return this.b}constructor(d){super(),this.c=d,this.a=this.B(new D.$fe),this.onDidChangeConfiguration=this.a.event,this.b=P.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$fo.as(l.$ko.Configuration).onDidUpdateConfiguration(({properties:d,defaultsOverrides:c})=>this.f(Array.from(d),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(d,c){this.j(d,v.$fo.as(l.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:d})}g(){return{}}h(){this.b=P.$Ao.createEmptyModel(this.c);const d=v.$fo.as(l.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(d),d)}j(d,c){const w=this.g();for(const $ of d){const m=w[$],f=c[$];m!==void 0?this.b.addValue($,m):f?this.b.addValue($,f.default):this.b.removeValue($)}}}e.$Go=b;class y{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=P.$Ao.createEmptyModel(new a.$fk)}async initialize(){return this.configurationModel}}e.$Ho=y;let p=class extends I.$Uc{get configurationModel(){return this.b}constructor(d,c,w){super(),this.c=d,this.f=c,this.g=w,this.a=this.B(new D.$fe),this.onDidChangeConfiguration=this.a.event,this.b=P.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(d=>this.j(d))),this.B(this.c.onDidChangeConfiguration(async({properties:d})=>this.m(await this.h(d),!0))),this.b}async h(d){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",d);const c={},w=[],$=v.$fo.as(l.$ko.Configuration).getConfigurationProperties();for(const m of d){const f=$[m];if(!f){w.push(m);continue}if(f.policy){if(f.type!=="string"&&f.type!=="number"){this.g.warn(`Policy ${f.policy.name} has unsupported type ${f.type}`);continue}w.push(m),c[f.policy.name]={type:f.type}}}return(0,A.$lg)(c)||await this.f.updatePolicyDefinitions(c),w}j(d){this.g.trace("PolicyConfiguration#onDidChangePolicies",d);const c=v.$fo.as(l.$ko.Configuration).getPolicyConfigurations(),w=(0,O.$Hb)(d.map($=>c.get($)));this.m(w,!0)}m(d,c){this.g.trace("PolicyConfiguration#update",d);const w=v.$fo.as(l.$ko.Configuration).getConfigurationProperties(),$=[],m=this.b.isEmpty();for(const f of d){const n=w[f]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(m?r!==void 0:!(0,N.$9n)(this.b.getValue(f),r))&&$.push([f,r])}else this.b.getValue(f)!==void 0&&$.push([f,void 0])}if($.length){this.g.trace("PolicyConfiguration#changed",$);const f=this.b;this.b=P.$Ao.createEmptyModel(this.g);for(const n of f.keys)this.b.setValue(n,f.getValue(n));for(const[n,r]of $)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);c&&this.a.fire(this.b)}}};e.$Io=p,e.$Io=p=$e([oe(1,u.$ho),oe(2,a.$5j)],p)}),define(se[140],re([0,1,19,8,14,5,38,76,2,30,27,12,17,29,67,40,139,39]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class w extends l.$Uc{constructor(f,n,r,t){super(),this.m=f,this.n=t,this.h=this.B(new N.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new d.$Go(t)),this.c=r instanceof c.$jo?new d.$Ho:this.B(new d.$Io(this.b,r,t)),this.f=this.B(new p.$Co(this.m,{},b.$3g,n,t)),this.a=new p.$Do(this.b.configurationModel,this.c.configurationModel,p.$Ao.createEmptyModel(t),p.$Ao.createEmptyModel(t),p.$Ao.createEmptyModel(t),p.$Ao.createEmptyModel(t),new a.$Ac,p.$Ao.createEmptyModel(t),new a.$Ac,t),this.j=new $(f,n,this),this.g=this.B(new D.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:s})=>this.s(i,s))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[f,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new p.$Do(f,n,p.$Ao.createEmptyModel(this.n),r,p.$Ao.createEmptyModel(this.n),p.$Ao.createEmptyModel(this.n),new a.$Ac,p.$Ao.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(f,n){const r=typeof f=="string"?f:void 0,t=(0,y.$6i)(f)?f:(0,y.$6i)(n)?n:{};return this.a.getValue(r,t,void 0)}async updateValue(f,n,r,t,i){const s=(0,y.$7i)(r)?r:(0,y.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?t:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${f} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,O.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const h=this.inspect(f,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(h.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,u.$9n)(n,h.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const k=s.overrideIdentifiers.sort(),j=this.a.localUserConfiguration.overrides.find(L=>(0,O.$ub)([...L.identifiers].sort(),k));j&&(s.overrideIdentifiers=j.identifiers)}const S=s?.overrideIdentifiers?.length?[(0,R.$wo)(s.overrideIdentifiers),f]:[f];await this.j.write(S,n),await this.reloadConfiguration()}inspect(f,n={}){return this.a.inspect(f,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const f=await this.f.loadConfiguration();this.r(f)}r(f){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(f);this.u(r,n,2)}s(f,n){const r=this.a.toData(),t=this.a.compareAndUpdateDefaultConfiguration(f,n);this.u(t,r,7)}t(f){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(f);this.u(r,n,7)}u(f,n,r){const t=new p.$Fo(f,{data:n},this.a,void 0,this.n);t.source=r,this.h.fire(t)}}e.$Jo=w;class ${constructor(f,n,r){this.b=f,this.c=n,this.d=r,this.a=new D.$Fh}write(f,n){return this.a.queue(()=>this.e(f,n))}async e(f,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const t=[];if((0,A.$Ln)(r,t,{allowTrailingComma:!0,allowEmptyContent:!0}),t.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,f,n);r=(0,P.$4n)(r,i),await this.c.writeFile(this.b,I.$He.fromString(r))}f(f,n,r){const{tabSize:t,insertSpaces:i,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,i?" ".repeat(t):"	");return[{content:o,length:o.length,offset:0}]}return(0,P.$1n)(f,n,r,{tabSize:t,insertSpaces:i,eol:s})}get h(){if(!this.g){let f=v.OS===3||v.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(f=n),this.g={eol:f,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[68],re([0,1,15]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=D,e.$Km=I,e.$Lm=N,e.$Mm=A;function D(l){return l.scheme===O.Schemas.vscodeRemote?l.authority:void 0}function I(l){if(!l)return;const a=l.indexOf("+");return a<0?l:l.substr(0,a)}function N(l){const{host:a,port:u}=P(l);if(typeof u>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:u}}function A(l,a){let{host:u,port:v}=P(l);return typeof v>"u"&&(v=a),{host:u,port:v}}function P(l){const a=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const u=l.match(/^(\[[0-9a-z:]+\])$/);if(u)return{host:u[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(se[37],re([0,1,31,10,68]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=N,e.$Wm=v,e.$Xm=b,e.$Ym=y,e.$Zm=p,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function N(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class l{constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,c){if(typeof d>"u"||d===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof d=="string"||typeof c=="string"){const w=typeof d=="string"?d:d.value,$=typeof c=="string"?c:c.value;return O.$zf(w,$)}return d._lower===c._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$Tm=l;class a{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const c of d)this.add(c)}add(d){this.c.add(l.toKey(d))}delete(d){return this.c.delete(l.toKey(d))}has(d){return this.c.has(l.toKey(d))}}e.$Um=a;class u{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete(l.toKey(d))}get(d){return this.c.get(l.toKey(d))}has(d){return this.c.has(l.toKey(d))}set(d,c){this.c.set(l.toKey(d),c)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=u;function v(R){return b(R)}function b(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function y(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function p(R,d){if(d){const c=`onResolveRemoteAuthority:${(0,I.$Km)(d)}`;return!!R.activationEvents?.includes(c)}return!1}e.$1m=(0,D.$yi)("IBuiltinExtensionsScannerService")}),define(se[141],re([0,1,2,37,13]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class N extends O.$Uc{constructor(P,l,a,u,v){super(),this.a=P,this.b=l,this.c=a,this.f=v,this.B(u.onDidInstallExtensions(b=>this.g(b))),this.B(u.onDidUninstallExtension(b=>this.h(b)))}g(P){for(const l of P)l.local&&this.invalidate(l.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const l of this.a.profiles)this.c.extUri.isEqual(l.extensionsResource,P)&&await this.j(l);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,D.$Nm))}catch(l){(0,I.$jl)(l)!==1&&this.f.error(l)}}}e.$Fq=N}),define(se[45],re([0,1,14,9,2,109,40,10,6,36]),function(X,e,O,D,I,N,A,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=b,e.$Up=y,e.$Vp=p,e.$Wp=R,e.$Xp=d,e.$Yp=c,e.$Rp=(0,P.$yi)("requestService");class u{constructor(f){this.b=f}toJSON(){if(!this.a){const f=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?f[n]="*****":f[n]=this.b[n];this.a=f}return this.a}}class v extends I.$Uc{constructor(f){super(),this.b=0,this.a=f.createLogger("network",{name:(0,N.localize)(0,null),when:l.$kk.isEqualTo((0,l.$hk)(l.LogLevel.Trace)).serialize()})}async c(f,n,r){const t=`${f} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new u(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,D.$0)(i)),i}}}e.$Sp=v;function b(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function y(m){return m.res.statusCode===204}async function p(m){return y(m)?null:(await(0,O.$Te)(m.stream)).toString()}async function R(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);return p(m)}async function d(m){if(!b(m))throw new Error("Server returned "+m.res.statusCode);if(y(m))return null;const n=(await(0,O.$Te)(m.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function c(m){$(m)}let w;function $(m){const f=a.$fo.as(A.$ko.Configuration),n=w;w={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},f.updateConfigurations({add:[w],remove:n?[n]:[]})}$(1)}),define(se[142],re([0,1,20,15,13,45]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;let A=class{constructor(l,a){this.a=l,this.b=a}async download(l,a,u=O.CancellationToken.None){if(l.scheme===D.Schemas.file||l.scheme===D.Schemas.vscodeRemote){await this.b.copy(l,a);return}const v={type:"GET",url:l.toString(!0)},b=await this.a.request(v,u);if(b.res.statusCode===200)await this.b.writeFile(a,b.stream);else{const y=await(0,N.$Wp)(b);throw new Error(`Expected 200, got back ${b.res.statusCode} instead.

${y}`)}}};e.$qQ=A,e.$qQ=A=$e([oe(0,N.$Rp),oe(1,I.$5k)],A)}),define(se[143],re([0,1,144,3]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=N;function I(A,P){return A.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:A.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function N(A,P,l={}){const a=(0,O.parse)(A),u=l.proxyUrl||I(a,P);if(!u)return null;const v=(0,O.parse)(u);if(!/^https?:$/.test(v.protocol||""))return null;const b={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,D.$eg)(l.strictSSL)?l.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((y,p)=>{X(["http-proxy-agent"],y,p)})).HttpProxyAgent(u,b):new(await new Promise((y,p)=>{X(["https-proxy-agent"],y,p)})).HttpsProxyAgent(u,b)}}),define(se[145],re([0,1,59,16,110,20,34,9,12,28,89,175,8,77]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=R;let p;async function R(c,w,$,m){return $["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Cm)(m)&&!$["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Cm)(m)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=b.Promises.withAsyncBody(async(f,n)=>{const r=new N.$qe;let t=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,y.$Dm)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,I.localize)(0,null)))},t);try{f(await d(w,r.token))}catch(o){!(0,P.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,I.localize)(1,null,(0,A.$jj)(o)))):f({})}finally{clearTimeout(s),r.dispose()}})),p)}async function d(c,w){const $=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",$);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",m);const f=(0,a.$Ug)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"({.*})"+f),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const t=await(0,u.$sm)(l.OS,r);return c.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(w.isCancellationRequested)return s(new P.$5);const o=(0,D.$nc)(t);let h,S;const k="";/^pwsh(-preview)?$/.test(o)?(h=`& '${process.execPath}' ${k} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,S=["-Login","-Command"]):o==="nu"?(h=`^'${process.execPath}' ${k} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,S=["-i","-l","-c"]):o==="xonsh"?(h=`import os, json; print("${f}", json.dumps(dict(os.environ)), "${f}")`,S=["-i","-l","-c"]):(h=`'${process.execPath}' ${k} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),h);const j=(0,O.spawn)(t,[...S,h],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(j.kill(),s(new P.$5))),j.on("error",C=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,A.$jj)(C)),s(C)});const L=[];j.stdout.on("data",C=>L.push(C));const q=[];j.stderr.on("data",C=>q.push(C)),j.on("close",(C,J)=>{const ne=Buffer.concat(L).toString("utf8");c.trace("getUnixShellEnvironment#raw",ne);const ie=Buffer.concat(q).toString("utf8");if(ie.trim()&&c.trace("getUnixShellEnvironment#stderr",ie),C||J)return s(new Error((0,I.localize)(2,null,C,J)));const ue=n.exec(ne),le=ue?ue[1]:"{}";try{const ce=JSON.parse(le);$?ce.ELECTRON_RUN_AS_NODE=$:delete ce.ELECTRON_RUN_AS_NODE,m?ce.ELECTRON_NO_ATTACH_CONSOLE=m:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,A.$jj)(ce)),s(ce)}})})}}),define(se[146],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=e.$5P=void 0,e.$5P=(0,O.$yi)("stateReadService"),e.$6P=(0,O.$yi)("stateService")}),define(se[69],re([0,1,8,14,2,3,18,13,6]),function(X,e,O,D,I,N,A,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9P=e.$8P=e.$7P=e.SaveStrategy=void 0;var a;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class u extends I.$Uc{constructor(p,R,d,c){super(),this.h=p,this.j=R,this.m=d,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new O.$wh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(p){p.fileOperationResult!==1&&this.m.error(p)}}getItem(p,R){const d=this.a[p];return(0,N.$hg)(d)?R:d}setItem(p,R){this.setItems([{key:p,data:R}])}setItems(p){let R=!1;for(const{key:d,data:c}of p)this.a[d]!==c&&((0,N.$hg)(c)?(0,N.$fg)(this.a[d])||(this.a[d]=void 0,R=!0):(this.a[d]=c,R=!0));R&&this.s()}removeItem(p){(0,N.$fg)(this.a[p])||(this.a[p]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const p=JSON.stringify(this.a,null,4);if(p!==this.b)try{await this.n.writeFile(this.h,D.$He.fromString(p),{atomic:{postfix:".vsctmp"}}),this.b=p}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$7P=u;let v=class extends I.$Uc{constructor(p,R,d,c){super(),this.a=this.B(new u(R.stateResource,p,d,c))}async init(){await this.a.init()}getItem(p,R){return this.a.getItem(p,R)}};e.$8P=v,e.$8P=v=$e([oe(1,A.$Fi),oe(2,l.$5j),oe(3,P.$5k)],v);class b extends v{setItem(p,R){this.a.setItem(p,R)}setItems(p){this.a.setItems(p)}removeItem(p){this.a.removeItem(p)}close(){return this.a.close()}}e.$9P=b}),define(se[70],re([0,1,12,35,28]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=A,e.$ip=P;function N(l){if(O.$u===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}function A(l,a,u,v,b,y,p,R,d){const c=Object.create(null);c["common.machineId"]=y,c["common.sqmId"]=p,c.sessionID=(0,I.$Ug)()+Date.now(),c.commitHash=v,c.version=b,c["common.platformVersion"]=(l||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,O.$h)(O.$u),c["common.nodePlatform"]=D.$dc,c["common.nodeArch"]=u,c["common.product"]=d||"desktop",R&&(c["common.msftInternal"]=R);let w=0;const $=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-$,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),O.$l&&(c["common.snap"]="true");const m=N(a);return m&&(c["common.platformDetail"]=m),c}function P(l){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const u=a.toLowerCase();return l.some(v=>u===v)}}),define(se[22],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,O.$yi)("telemetryService"),e.$5l=(0,O.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var I;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(se[71],re([0,1,9,10,6,22]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.ExtensionSignatureVerificationCode=e.$dq=void 0,e.$dq=(0,D.$yi)("IExtensionSignatureVerificationService");var A;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(A||(e.ExtensionSignatureVerificationCode=A={}));class P extends Error{constructor(u){super(u),this.code=u}}e.$eq=P;let l=class{constructor(u,v){this.b=u,this.c=v}d(){return this.a||(this.a=new Promise((u,v)=>X(["@vscode/vsce-sign"],async b=>u(b),v))),this.a}async verify(u,v,b,y){let p;try{p=await this.d()}catch(w){return this.b.error("Could not load vsce-sign module",(0,O.$0)(w)),this.b.info(`Extension signature verification is not done: ${u}`),!1}const R=new Date().getTime();let d;try{this.b.trace(`Verifying extension signature for ${u}...`),d=await p.verify(v,b,this.b.getLevel()===I.LogLevel.Trace)}catch(w){d={code:"UnknownError",didExecute:!1,output:(0,O.$0)(w)}}const c=new Date().getTime()-R;if(this.b.info(`Extension signature verification result for ${u}: ${d.code}. Executed: ${d.didExecute}. Duration: ${c}ms.`),this.b.trace(`Extension signature verification output for ${u}:
${d.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:u,code:d.code,duration:c,didExecute:d.didExecute,clientTargetPlatform:y}),d.code==="Success")return!0;throw new P(d.code)}};e.$fq=l,e.$fq=l=$e([oe(0,I.$5j),oe(1,N.$4l)],l)}),define(se[41],re([0,1,27,3,68,70,22]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=u,e.$rp=v,e.$sp=b,e.$tp=y,e.$up=R,e.$vp=c,e.$wp=w,e.$xp=f;class P{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$jp=P;class l{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=l,e.$lp=new l;class a{async publicLog(r,t,i){}async publicLogError(r,t,i){}}e.$mp=a,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function u(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function v(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function b(n){const r=n.getValue(A.$_l),t=n.getValue(A.$am);if(n.getValue(A.$bm)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(n){const r={},t={},i={};d(n,i);for(let s in i){s=s.length>150?s.substr(s.length-149):s;const o=i[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(n){if(!n)return"none";const r=(0,I.$Km)(n);return p.has(r)?r:"other"}function d(n,r,t=0,i){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],h=i?i+s:s;Array.isArray(o)?r[h]=(0,O.$0n)(o):o instanceof Date?r[h]=o.toISOString():(0,D.$ag)(o)?t<2?d(o,r,t+1,h+"."):r[h]=(0,O.$0n)(o):r[h]=o}}function c(n,r){const t=n.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,N.$ip)(t)||i}function w(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function $(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let t=n;const i=[];for(const S of r)for(;;){const k=S.exec(n);if(!k)break;i.push([k.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let h=0;for(t="";;){const S=o.exec(n);if(!S)break;const k=i.some(([j,L])=>S.index<L&&j<o.lastIndex);!s.test(S[0])&&!k&&(t+=n.substring(h,S.index)+"<REDACTED: user-file-path>",h=o.lastIndex)}return h<n.length&&(t+=n.substr(h)),t}function m(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(n))return`<REDACTED: ${t.label}>`;return n}function f(n,r){return(0,O.$7n)(n,t=>{if(t instanceof P||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let i=t.replaceAll("%20"," ");i=$(i,r);for(const s of r)i=i.replace(s,"");return i=m(i),i}})}}),define(se[26],re([0,1,31,21,37,12,11,9,35,41]),function(X,e,O,D,I,N,A,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=u,e.$Ap=p,e.$Bp=R,e.$Cp=d,e.$Dp=c,e.$Ep=w,e.$Fp=$,e.$Gp=m,e.$Ip=f,e.$Jp=r;function u(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,O.$uf)(t.id,i.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new b(i.identifier,s,o)}static parse(i){const s=v.exec(i);return s&&s[1]&&s[2]?new b({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof b?u(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$zp=b;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(t){const i=y.exec(t);return i&&i[1]?[d(i[1]),i[2]]:[d(t),void 0]}function R(t,i){return`${t}.${i}`}function d(t){return t.toLowerCase()}function c(t,i){return d(R(t??I.$Pm,i))}function w(t,i){const s=[],o=h=>{for(const S of s)if(S.some(k=>u(i(k),i(h))))return S;return null};for(const h of t){const S=o(h);S?S.push(h):s.push([h])}return s}function $(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}function m(t){return{id:new a.$jp(t.identifier.id),name:new a.$jp(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$Hp=new I.$Tm("pprice.better-merge");function f(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const h=o.shift();if(h&&s.every(S=>!u(S.identifier,{id:h}))){const S=t.filter(k=>u(k.identifier,{id:h}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(t,i){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(h){i.debug("Error while getting the os-release file.",(0,P.$0)(h))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,D.$6o)(s?"alpine":N.$u,l.$ec);return i.debug("ComputeTargetPlatform:",o),o}}),define(se[147],re([0,1,20,9,15,17,44,11,98,21,26,37]),function(X,e,O,D,I,N,A,P,l,a,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;const b=R=>(0,l.localize)(0,null,R),y=(0,l.localize)(1,null,"ms-dotnettools.csharp");let p=class{constructor(d,c,w){this.a=d,this.b=c,this.d=w}get f(){}async listExtensions(d,c,w){let $=await this.b.getInstalled(1,w);const m=v.$Sm.map(n=>n.toLowerCase());if(c&&c!==""){if(m.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}$=$.filter(n=>n.manifest.categories?n.manifest.categories.map(t=>t.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),m.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,l.localize)(2,null,this.f)),$=$.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let f;for(const n of $)f!==n.identifier.id&&(f=n.identifier.id,this.a.info(d?`${f}@${n.manifest.version}`:f))}async installExtensions(d,c,w,$){const m=[];try{d.length&&this.a.info(this.f?(0,l.localize)(3,null,this.f):(0,l.localize)(4,null));const f=[],n=[],r=(i,s,o)=>{n.push({id:i,version:s!=="prerelease"?s:void 0,installOptions:{...w,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||w.installPreReleaseVersion}})};for(const i of d)if(i instanceof P.URI)f.push({vsix:i,installOptions:w});else{const[s,o]=(0,u.$Ap)(i);r(s,o,!1)}for(const i of c)if(i instanceof P.URI)f.push({vsix:i,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,u.$Ap)(i);r(s,o,!0)}const t=await this.b.getInstalled(void 0,w.profileLocation);if(f.length&&await Promise.all(f.map(async({vsix:i,installOptions:s})=>{try{await this.h(i,s,$,t)}catch(o){this.a.error(o),m.push(i.toString())}})),n.length){const i=await this.g(n,t,$);m.push(...i)}}catch(f){throw this.a.error((0,l.localize)(5,null,(0,D.$0)(f))),f}if(m.length)throw new Error((0,l.localize)(6,null,m.join(", ")))}async updateExtensions(d){const c=await this.b.getInstalled(1,d),w=[];for(const n of c)n.identifier.uuid&&w.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,l.localize)(7,null,w.length));const $=await this.d.getExtensions(w,{compatible:!0},O.CancellationToken.None),m=[];for(const n of $)for(const r of c)(0,u.$yp)(r.identifier,n.identifier)&&(0,A.gt)(n.version,r.manifest.version)&&m.push({extension:n,options:{operation:3,installPreReleaseVersion:r.preRelease,profileLocation:d}});if(!m.length){this.a.info((0,l.localize)(8,null));return}this.a.info((0,l.localize)(9,null,m.map(n=>n.extension.identifier.id).join(", ")));const f=await this.b.installGalleryExtensions(m);for(const n of f)n.error?this.a.error((0,l.localize)(10,null,n.identifier.id,(0,D.$0)(n.error))):this.a.info((0,l.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(d,c,w){if(d=d.filter(({id:n,version:r})=>{const t=c.find(i=>(0,u.$yp)(i.identifier,{id:n}));if(t){if(!w&&(!r||r==="prerelease"&&t.preRelease))return this.a.info((0,l.localize)(12,null,n,t.manifest.version,n)),!1;if(r&&t.manifest.version===r)return this.a.info((0,l.localize)(13,null,`${n}@${r}`)),!1}return!0}),!d.length)return[];const $=[],m=[],f=await this.j(d);if(await Promise.all(d.map(async({id:n,version:r,installOptions:t})=>{const i=f.get(n.toLowerCase());if(!i){this.a.error(`${b(r?`${n}@${r}`:n)}
${y}`),$.push(n);return}try{const o=await this.d.getManifest(i,O.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),$.push(n);return}const s=c.find(o=>(0,u.$yp)(o.identifier,i.identifier));if(s){if(i.version===s.manifest.version){this.a.info((0,l.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,l.localize)(15,null,n,i.version))}t.isBuiltin?this.a.info(r?(0,l.localize)(16,null,n,r):(0,l.localize)(17,null,n)):this.a.info(r?(0,l.localize)(18,null,n,r):(0,l.localize)(19,null,n)),m.push({extension:i,options:{...t,installGivenVersion:!!r}})})),m.length){const n=await this.b.installGalleryExtensions(m);for(const r of n)r.error?(this.a.error((0,l.localize)(20,null,r.identifier.id,(0,D.$0)(r.error))),$.push(r.identifier.id)):this.a.info((0,l.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return $}async h(d,c,w,$){const m=await this.b.getManifest(d);if(!m)throw new Error("Invalid vsix");if(await this.l(m,w,c.profileLocation,$))try{await this.b.install(d,c),this.a.info((0,l.localize)(22,null,(0,N.$9g)(d)))}catch(n){if((0,D.$4)(n))this.a.info((0,l.localize)(23,null,(0,N.$9g)(d)));else throw n}}async j(d){const c=new Map,w=d.some(f=>f.installOptions.installPreReleaseVersion),$=await this.b.getTargetPlatform(),m=[];for(const f of d)a.$Xo.test(f.id)&&m.push({...f,preRelease:w});if(m.length){const f=await this.d.getExtensions(m,{targetPlatform:$},O.CancellationToken.None);for(const n of f)c.set(n.identifier.id.toLowerCase(),n)}return c}k(d){return!0}async l(d,c,w,$){if(!c){const m={id:(0,u.$Dp)(d.publisher,d.name)},f=$.find(n=>(0,u.$yp)(m,n.identifier)&&(0,A.gt)(n.manifest.version,d.version));if(f)return this.a.info((0,l.localize)(24,null,f.identifier.id,f.manifest.version,d.version)),!1}return this.k(d)}async uninstallExtensions(d,c,w){const $=async f=>{if(f instanceof P.URI){const n=await this.b.getManifest(f);return(0,u.$Bp)(n.publisher,n.name)}return f},m=[];for(const f of d){const n=await $(f),t=(await this.b.getInstalled(void 0,w)).filter(i=>(0,u.$yp)(i.identifier,{id:n}));if(!t.length)throw new Error(`${this.m(n)}
${y}`);if(t.some(i=>i.type===0)){this.a.info((0,l.localize)(25,null,n));return}if(!c&&t.some(i=>i.isBuiltin)){this.a.info((0,l.localize)(26,null,n));return}this.a.info((0,l.localize)(27,null,n));for(const i of t)await this.b.uninstall(i,{profileLocation:w}),m.push(i);this.f?this.a.info((0,l.localize)(28,null,n,this.f)):this.a.info((0,l.localize)(29,null,n))}}async locateExtension(d){const c=await this.b.getInstalled();d.forEach(w=>{c.forEach($=>{if($.identifier.id===w&&$.location.scheme===I.Schemas.file){this.a.info($.location.fsPath);return}})})}m(d){return this.f?(0,l.localize)(30,null,d,this.f):(0,l.localize)(31,null,d)}};e.$gq=p,e.$gq=p=$e([oe(1,a.$ap),oe(2,a.$0o)],p)}),define(se[148],re([0,1,5,2,30,26,37]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class P extends D.$Uc{constructor(a,u,v,b,y,p,R){super(),this.f=a,this.g=u,this.h=v,this.j=b,this.m=y,this.n=p,this.r=R,this.a=this.B(new O.$fe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$4c),this.s().then(null,d=>R.error(d))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(u=>(this.c.set(u.id,(0,D.$Rc)(this.n.watch(this.m.extUri.dirname(u.extensionsResource)),this.n.watch(u.extensionsResource))),this.G(u.extensionsResource))))}catch(u){throw this.r.error(u),u}}async w(a){for(const u of a.extensions)this.I(this.L(u.identifier,u.version),a.profileLocation)}async y(a){for(const u of a.extensions){const v=this.L(u.identifier,u.version);a.error?this.J(v,a.profileLocation):this.I(v,a.profileLocation)}}async z(a){for(const u of a.extensions)this.J(this.L(u.identifier,u.version),a.profileLocation)}async C(a){const u=[],v=[];for(const b of a.extensions){const y=this.L(b.identifier,b.version);a.error?this.I(y,a.profileLocation):(this.J(y,a.profileLocation),this.b.has(y)||(this.r.debug("Extension is removed from all profiles",b.identifier.id,b.version),v.push(this.f.scanInstalledExtensionAtLocation(b.location).then(p=>{p?u.push(p):this.r.info("Extension not found at the location",b.location.toString())},p=>this.r.error(p)))))}try{await Promise.all(v),u.length&&await this.H(u)}catch(b){this.r.error(b)}}D(a){for(const u of this.h.profiles)a.contains(u.extensionsResource,0,1)&&this.F(u.extensionsResource)}async F(a){const u=[],v=[],b=await this.j.scanProfileExtensions(a),y=new Set,p=new Set;for(const[R,d]of this.b)d.has(a)&&p.add(R);for(const R of b){const d=this.L(R.identifier,R.version);y.add(d),p.has(d)||(u.push(R.identifier),this.I(d,a))}for(const R of p)if(!y.has(R)){const d=this.M(R);d&&(v.push(d.identifier),this.J(R,a))}(u.length||v.length)&&this.a.fire({added:u.length?{extensions:u,profileLocation:a}:void 0,removed:v.length?{extensions:v,profileLocation:a}:void 0})}async G(a){const u=await this.j.scanProfileExtensions(a);for(const v of u)this.I(this.L(v.identifier,v.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,u){let v=this.b.get(a);v||this.b.set(a,v=new I.$Bc(b=>this.m.extUri.getComparisonKey(b))),v.add(u)}J(a,u){const v=this.b.get(a);v&&v.delete(u),v?.size||this.b.delete(a)}L(a,u){return`${A.$Tm.toKey(a.id)}@${u}`}M(a){const[u,v]=(0,N.$Ap)(a);return v?{identifier:{id:u},version:v}:void 0}}e.$Gq=P}),define(se[149],re([0,1,120,41]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=I;async function I(N,A,P,l,a,u,v){const b={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$qp)(A,P)&&(0,D.$sp)(l)===3){const y=await(0,O.$$p)(P,a,u);b["X-Market-User-Id"]=y,b["VSCode-SessionId"]=v.machineId||y}return b}}),define(se[150],re([0,1,176,19,8,2,15,16,25,18,21,26,6,65,11]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;let R=class extends y.$Wr{constructor($,m,f,n){super(f),this.h=$,this.j=n,this.g=this.B(new d(m,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri($,m){const n=(await this.g.getLanguagePacks())[m];if(!n){this.j.warn(`No language pack found for ${m}`);return}const r=n.translations[$];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const $=await this.g.getLanguagePacks(),m=Object.keys($).map(f=>{const n=$[f];return{...this.f(f,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((f,n)=>f.label.localeCompare(n.label)),m}async m($){$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",$.identifier.id),await this.update())}async n($){const m=await this.g.getLanguagePacks();Object.keys(m).some(f=>m[f]&&m[f].extensions.some(n=>(0,v.$yp)(n.extensionIdentifier,$.identifier)))&&(this.j.info("Removing language packs from the extension",$.identifier.id),await this.update())}async update(){const[$,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),f=await this.g.update(m);return!(0,D.$ub)(Object.keys($),Object.keys(f))}};e.$Xr=R,e.$Xr=R=$e([oe(0,u.$ap),oe(1,a.$Gi),oe(2,u.$0o),oe(3,b.$5j)],R);let d=class extends N.$Uc{constructor($,m){super(),this.j=m,this.c={},this.f=(0,P.$jc)($.userDataPath,"languagepacks.json"),this.g=new I.$Fh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update($){return this.s(m=>{Object.keys(m).forEach(f=>delete m[f]),this.m(m,...$)}).then(()=>this.c)}m($,...m){for(const f of m)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.n($,f);Object.keys($).forEach(f=>this.r($[f]))}n($,m){const f=m.identifier,n=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const r of n)if(m.location.scheme===A.Schemas.file&&c(r)){let t=$[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},$[r.languageId]=t);const i=t.extensions.filter(s=>(0,v.$yp)(s.extensionIdentifier,f))[0];i?i.version=m.manifest.version:t.extensions.push({extensionIdentifier:f,version:m.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,P.$jc)(m.location.fsPath,s.path)}}r($){if($){const m=(0,O.createHash)("md5");for(const f of $.extensions)m.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);$.hash=m.digest("hex")}}s($=()=>null){return this.g.queue(()=>{let m=null;return l.Promises.readFile(this.f,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(m=$(f),f)).then(f=>{for(const r of Object.keys(f))f[r]||delete f[r];this.c=f,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>m,f=>this.j.error(f))})}};d=$e([oe(0,a.$Gi),oe(1,b.$5j)],d);function c(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const $ of w.translations)if(typeof $.id!="string"||typeof $.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(se[151],re([0,1,86,9,27,41]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function l(u,v,b){const y=await(0,O.$_D)("@microsoft/1ds-core-js","dist/ms.core.js"),p=await(0,O.$_D)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new y.AppInsightsCore,d=new p.PostChannel,c={instrumentationKey:u,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(b){c.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:b};c.extensionConfig[d.identifier]=w}return R.initialize(c,[]),R.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),R}class a{constructor(v,b,y,p,R){this.e=v,this.f=b,this.g=y,this.h=R,this.c=A,this.d=P,this.g||(this.g={}),typeof p=="function"?this.a=p():this.a=p,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=l(this.a,this.e,this.h)),this.b.then(b=>{v(b)},b=>{(0,D.$1)(b),console.error(b)})}}log(v,b){if(!this.a)return;b=(0,I.$8n)(b,this.g),b=(0,N.$tp)(b);const y=this.f+"/"+v;try{this.i(p=>{p.pluginVersionString=b?.properties.version??"Unknown",p.track({name:y,baseData:{name:y,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$1P=a}),define(se[152],re([0,1,2,27,12,31,111,29,40,153,32,36,22,41]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;let p=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,w,$){this.k=w,this.l=$,this.d={},this.i=new O.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,N.$bf)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$bf)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(b.$_l)||m.affectsConfiguration(b.$bm)||m.affectsConfiguration(b.$am))&&this.m()}))}setExperimentProperty(c,w){this.d[c]=w}m(){let c=(0,y.$sp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const $=w.usage?3:w.error?2:0;c=Math.min(c,$)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,w,$){this.g<w||($=(0,D.$8n)($,this.d),$=(0,y.$xp)($,this.j),$=(0,D.$8n)($,this.c),this.b.forEach(m=>m.log(c,$)))}publicLog(c,w){this.n(c,3,w)}publicLog2(c,w){this.publicLog(c,w)}publicLogError(c,w){this.h&&this.n(c,2,w)}publicLogError2(c,w){this.publicLogError(c,w)}};e.$4r=p,e.$4r=p=$e([oe(1,P.$5i),oe(2,u.$lk)],p);function R(){const d=(0,A.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=I.$o?"":(0,A.localize)(3,null),$=(0,A.localize)(4,null),m=(0,A.localize)(5,null),f=(0,A.localize)(6,null),n=(0,A.localize)(7,null),r=`
|       | ${$} | ${m} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${d} ${c} ${w}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}v.$fo.as(l.$ko.Configuration).registerConfiguration({id:b.$$l,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[b.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$fo.as(l.$ko.Configuration).registerConfiguration({id:b.$$l,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[b.$bm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${b.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],re([0,1,14,20,177,151]),function(X,e,O,D,I,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;async function A(u,v){const b=await v.request(u,D.CancellationToken.None),y=(await(0,O.$Te)(b.stream)).toString(),p=b.res.statusCode??200;return{headers:b.res.headers,statusCode:p,responseData:y}}async function P(u){const v={method:u.type,headers:u.headers};return new Promise((y,p)=>{const R=I.request(u.url??"",v,d=>{d.on("data",function(c){y({headers:d.headers,statusCode:d.statusCode??200,responseData:c.toString()})}),d.on("error",function(c){p(c)})});R.write(u.data,d=>{d&&p(d)}),R.end()})}async function l(u,v,b){const y=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),p={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:y};try{const R=u?await A(p,u):await P(p);b(R.statusCode,R.headers,R.responseData)}catch{b(0,{})}}class a extends N.$1P{constructor(v,b,y,p,R){const d={sendPOST:(c,w)=>{l(v,c,w)}};super(b,y,p,R,d)}}e.$2P=a}),define(se[155],re([0,1,16,25]),function(X,e,O,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yec=I;async function I(N,A){const P=Object.create(null),l=(u,v)=>{const b=JSON.parse(u);P[v]=b};if(A){const u=[],v=await D.Promises.readdir(A);for(const y of v)try{(await D.Promises.stat((0,O.$jc)(A,y))).isDirectory()&&u.push(y)}catch{}const b=[];for(const y of u)(await D.Promises.readdir((0,O.$jc)(A,y))).filter(R=>R==="telemetry.json").length===1&&b.push(y);for(const y of b){const p=(await D.Promises.readFile((0,O.$jc)(A,y,"telemetry.json"))).toString();l(p,y)}}let a=(await D.Promises.readFile((0,O.$jc)(N,"telemetry-core.json"))).toString();return l(a,"vscode-core"),a=(await D.Promises.readFile((0,O.$jc)(N,"telemetry-extensions.json"))).toString(),l(a,"vscode-extensions"),JSON.stringify(P,null,4)}}),define(se[156],re([0,1,12,87,22]),function(X,e,O,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cec=N,e.$dec=A;async function N(P,l){let a=P.getItem(I.$9l);return(typeof a!="string"||O.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$Hn)(l.error.bind(l))),a}async function A(P,l){let a=P.getItem(I.$0l);return typeof a!="string"&&(a=await(0,D.$In)(l.error.bind(l))),a}}),define(se[23],re([0,1,10]),function(X,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,O.$yi)("IUriIdentityService")}),define(se[157],re([0,1,23,121,13,17,78,5,2]),function(X,e,O,D,I,N,A,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class a{static{this._clock=0}constructor(b){this.uri=b,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let u=class{constructor(b){this.g=b,this.c=new l.$Tc,this.f=2**16;const y=new Map,p=R=>{let d=y.get(R.scheme);return d===void 0&&(d=b.hasProvider(R)&&!this.g.hasCapability(R,1024),y.set(R.scheme,d)),d};this.c.add(P.Event.any(b.onDidChangeFileSystemProviderRegistrations,b.onDidChangeFileSystemProviderCapabilities)(R=>{y.delete(R.scheme)})),this.extUri=new N.$1g(p),this.d=new A.$Ds((R,d)=>this.extUri.compare(R,d,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(b){this.g.hasProvider(b)&&(b=(0,N.$ah)(b));const y=this.d.get(b);return y?y.touch().uri.with({fragment:b.fragment}):(this.d.set(b,new a(b)),this.h(),b)}h(){if(this.d.size<this.f)return;const b=[...this.d.entries()].sort((p,R)=>p[1].time<R[1].time?1:p[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const y=this.f*.5;for(let p=0;p<y;p++)this.d.set(b[p][0],b[p][1].touch())}};e.$Es=u,e.$Es=u=$e([oe(0,I.$5k)],u),(0,D.$Bs)(O.$Cl,u,1)}),define(se[158],re([0,1,5,2,13,48,30]),function(X,e,O,D,I,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class P extends D.$Uc{constructor(a,u,v,b,y,p){super(),this.f=a,this.g=u,this.h=v,this.j=b,this.m=y,this.n=p,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$fe),this.onDidChangeFile=this.a.event,this.b=N.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(b.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,u){return this.g.open(this.t(a),u)}close(a){return this.g.close(a)}read(a,u,v,b,y){return this.g.read(a,u,v,b,y)}write(a,u,v,b,y){return this.g.write(a,u,v,b,y)}watch(a,u){this.b.set(a,a);const v=this.g.watch(this.t(a),u);return(0,D.$Sc)(()=>{this.b.delete(a),v.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,u,v){return this.g.rename(this.t(a),this.t(u),v)}readFile(a,u){return this.g.readFile(this.t(a),u)}readFileStream(a,u,v){return this.g.readFileStream(this.t(a),u,v)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,u,v){return this.g.writeFile(this.t(a),u,v)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,u){return this.g.delete(this.t(a),u)}copy(a,u,v){if((0,I.$9k)(this.g))return this.g.copy(this.t(a),this.t(u),v);throw new Error("copy not supported")}cloneFile(a,u){if((0,I.$0k)(this.g))return this.g.cloneFile(this.t(a),this.t(u));throw new Error("clone not supported")}s(a){const u=[];for(const v of a){if(v.resource.scheme!==this.f)continue;const b=this.u(v.resource);this.b.findSubstr(b)&&u.push({resource:b,type:v.type,cId:v.cId})}u.length&&(this.n.debug("User data changed"),this.a.fire(u))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Aec=P}),define(se[159],re([0,1,113,16,48,17,11,10,15]),function(X,e,O,D,I,N,A,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=a,e.$Ji=u,e.$Mi=v,e.$Ni=b,e.$Oi=y,e.$Pi=R,e.$Qi=d,e.$Ti=$,e.$Yi=m,e.$Zi=f,e.$2i=n,e.$3i=r,e.$4i=t,e.$Hi=(0,P.$yi)("contextService");function a(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}function u(i){return typeof i?.id=="string"&&!a(i)&&!b(i)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function v(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,D.$nc)(i)}:s?e.$Ki:e.$Li;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function b(i){const s=i;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}function y(i){const s=i;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function R(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function d(i){const s=i;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,h,S,k){this.h=s,this.j=h,this.k=S,this.l=k,this.c=I.$Ei.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=I.$Ei.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=c;class w{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$_g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=w;function $(i){return new w({uri:i,index:0,name:(0,N.$8g)(i)},{uri:i.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,O.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function m(i,s){return N.$3g.isEqualOrParent(i,s.untitledWorkspacesHome)}function f(i){let s;return A.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===l.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.$1i}function r(i,s){return!m(i,s)&&!f(i)}function t(i){return(typeof i=="string"?(0,D.$oc)(i):(0,N.$0g)(i))===e.$Vi}}),define(se[24],re([0,1,43,5,2,17,11,112,18,13,10,6,159,30,23,8,28,31,3]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=m,e.$Fl=f,e.$Gl=n;var $;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})($||(e.ProfileResourceType=$={}));function m(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$El=(0,u.$yi)("IUserDataProfilesService");function f(i,s){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:A.URI.revive(i.location).with({scheme:s}),globalStorageHome:A.URI.revive(i.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(i.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(i.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(i.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(i.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(i.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(i.cacheHome).with({scheme:s}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function n(i,s,o,h,S,k){return{id:i,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:k&&S?.useDefaultFlags?.globalState?k.globalStorageHome:(0,N.$_g)(o,"globalStorage"),settingsResource:k&&S?.useDefaultFlags?.settings?k.settingsResource:(0,N.$_g)(o,"settings.json"),keybindingsResource:k&&S?.useDefaultFlags?.keybindings?k.keybindingsResource:(0,N.$_g)(o,"keybindings.json"),tasksResource:k&&S?.useDefaultFlags?.tasks?k.tasksResource:(0,N.$_g)(o,"tasks.json"),snippetsHome:k&&S?.useDefaultFlags?.snippets?k.snippetsHome:(0,N.$_g)(o,"snippets"),extensionsResource:k&&S?.useDefaultFlags?.extensions?k.extensionsResource:(0,N.$_g)(o,"extensions.json"),cacheHome:(0,N.$_g)(h,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends I.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,h,S){super(),this.t=s,this.u=o,this.w=h,this.y=S,this.f=!0,this.h=this.B(new D.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const k of this.O()){if(!k.name||!(0,w.$$f)(k.name)||!k.location){this.y.warn("Skipping the invalid stored profile",k.location||k.name);continue}o.push(n((0,N.$9g)(k.location),k.name,k.location,this.g,{shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags},s))}}catch(k){this.y.error(k)}const h=new y.$Ac,S=new Map;if(o.length)try{const k=this.Q();if(k.workspaces)for(const[j,L]of Object.entries(k.workspaces)){const q=A.URI.parse(j),C=o.find(J=>J.id===L);C&&h.set(q,C)}if(k.emptyWindows)for(const[j,L]of Object.entries(k.emptyWindows)){const q=o.find(C=>C.id===L);q&&S.set(j,q)}}catch(k){this.y.error(k)}this.z={profiles:o,workspaces:h,emptyWindows:S}}return this.z}D(){const s=n("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",h=new RegExp(`${(0,c.$bf)(o)}\\s(\\d+)`);let S=0;for(const j of this.profiles){const L=h.exec(j.name),q=L?parseInt(L[1]):0;S=q>S?q:S}const k=`${o} ${S+1}`;return this.createProfile((0,O.$mj)((0,d.$Ug)()).toString(16),k,{transient:!0},s)}async createNamedProfile(s,o,h){return this.createProfile((0,O.$mj)((0,d.$Ug)()).toString(16),s,o,h)}async createProfile(s,o,h,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=await this.F(s,o,h);return S&&await this.setProfileForWorkspace(S,k),k}async F(s,o,h){if(!(0,w.$$f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{if(this.profiles.find(q=>q.name===o||q.id===s))throw new Error(`Profile with ${o} name already exists`);const j=n(s,o,(0,N.$_g)(this.profilesHome,s),this.g,h,this.defaultProfile);await this.u.createFolder(j.location);const L=[];return this.j.fire({profile:j,join(q){L.push(q)}}),await R.Promises.settled(L),this.I([j],[],[]),j}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let h=this.profiles.find(S=>S.id===s.id);if(!h)throw new Error(`Profile '${s.name}' does not exist`);return h=n(h.id,o.name??h.name,h.location,this.g,{shortName:o.shortName??h.shortName,icon:o.icon===null?void 0:o.icon??h.icon,transient:o.transient??h.isTransient,useDefaultFlags:o.useDefaultFlags??h.useDefaultFlags},this.defaultProfile),this.I([],[],[h]),h}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const h=[];this.m.fire({profile:o,join(S){h.push(S)}});try{await Promise.allSettled(h)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$jl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=this.profiles.find(S=>S.id===o.id);if(!h)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,h)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(h=>!this.w.extUri.isEqual(h.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,b.$Ii)(s)?s.uri:(0,b.$Ni)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,h){const S=[...this.profiles,...s],k=[];this.s.profiles=[];for(let j of S)j.isDefault||o.some(L=>j.id===L.id)||(j=h.find(L=>j.id===L.id)??j,j.isTransient?this.s.profiles.push(j):k.push({location:j.location,name:j.name,shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags}));this.P(k),this.z=void 0,this.J(s,o,h)}J(s,o,h){this.h.fire({added:s,removed:o,updated:h,all:this.profiles})}L(s,o,h){h=o?.isTransient?!0:h,h||this.L(s,void 0,!0);const S=this.G(s),k=h?this.s:this.C;A.URI.isUri(S)?(k.workspaces.delete(S),o&&k.workspaces.set(S,o)):(k.emptyWindows.delete(S),o&&k.emptyWindows.set(S,o)),h||this.M()}M(){const s={};for(const[h,S]of this.C.workspaces.entries())s[h.toString()]=S.id;const o={};for(const[h,S]of this.C.emptyWindows.entries())o[h.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},h=this.D();if(s.workspaces)for(const[k,j]of Object.entries(s.workspaces)){const L=A.URI.parse(j);o[k]=this.w.extUri.isEqual(L,h.location)?h.id:this.w.extUri.basename(L)}const S={};if(s.emptyWindows)for(const[k,j]of Object.entries(s.emptyWindows)){const L=A.URI.parse(j);S[k]=this.w.extUri.isEqual(L,h.location)?h.id:this.w.extUri.basename(L)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=$e([oe(0,l.$Fi),oe(1,a.$5k),oe(2,p.$Cl),oe(3,v.$5j)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Il=t}),define(se[72],re([0,1,19,8,20,9,5,2,12,3,11,96,21,26,37,6,32,22,23,24]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=void 0,e.$qq=f;let m=class extends P.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,s,o,h,S,k){super(),this.z=i,this.C=s,this.D=o,this.F=h,this.G=S,this.H=k,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$fe),this.s=this.B(new A.$fe),this.t=this.B(new A.$fe),this.u=this.B(new A.$fe),this.w=this.B(new A.$fe),this.y=[],this.B((0,P.$Sc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,b.$8o)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{const h=(await this.installGalleryExtensions([{extension:i,options:s}])).find(({identifier:S})=>(0,y.$yp)(S,i.identifier));if(h?.local)return h?.local;throw h?.error?h.error:new b.$_o(`Unknown error while installing extension ${i.identifier.id}`,"Unknown")}catch(o){throw f(o)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new b.$_o(v.localize(0,null),"NotAllowed");const s=[],o=[];return await Promise.allSettled(i.map(async({extension:h,options:S})=>{try{const k=await this.N(h,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});o.push({...k,options:S})}catch(k){s.push({identifier:h.identifier,operation:2,source:h,error:k})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(i,s={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,s)}async toggleAppliationScope(i,s){if((0,p.$Wm)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let o=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(i,this.H.defaultProfile.extensionsResource,s));for(const h of this.H.profiles){const S=(await this.getInstalled(1,h.extensionsResource)).find(k=>(0,y.$yp)(k.identifier,i.identifier));S?this.w.fire(S):this.u.fire({identifier:i.identifier,profileLocation:h.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const s=new Map,o=new Map,h=[],S=(j,L)=>`${y.$zp.create(j).toString()}-${L.toString()}`,k=(j,L,q,C)=>{const J=this.Y(j,L,q),ne=`${(0,y.$Dp)(j.publisher,j.name)}-${q.profileLocation.toString()}`;o.set(ne,{task:J,root:C}),this.n.fire({identifier:J.identifier,source:L,profileLocation:q.profileLocation}),this.F.info("Installing extension:",J.identifier.id),u.URI.isUri(L)||this.j.set(S(L,q.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:j,extension:L,options:q}of i){const C=q.isApplicationScoped||q.isBuiltin||(0,p.$Wm)(j),J={...q,installOnlyNewlyAddedFromExtensionPack:q.installOnlyNewlyAddedFromExtensionPack??!u.URI.isUri(L),isApplicationScoped:C,profileLocation:C?this.H.defaultProfile.extensionsResource:q.profileLocation??this.X(),productVersion:q.productVersion??{version:this.G.version,date:this.G.date}},ne=u.URI.isUri(L)?void 0:this.j.get(S(L,J.profileLocation));ne?(this.F.info("Extension is already requested to install",ne.task.identifier.id),h.push(ne.task.waitUntilTaskIsFinished())):k(j,L,J,void 0)}return await Promise.all([...o.values()].map(async({task:j})=>{if(j.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",j.identifier.id);else try{const L=await this.M(j.identifier,j.manifest,!!j.options.installOnlyNewlyAddedFromExtensionPack,!!j.options.installPreReleaseVersion,j.options.profileLocation,j.options.productVersion),q=await this.getInstalled(void 0,j.options.profileLocation,j.options.productVersion),C={...j.options,context:{...j.options.context,[b.$2o]:!0}};for(const{gallery:J,manifest:ne}of(0,O.$Mb)(L,({gallery:ie})=>ie.identifier.id)){if(o.has(`${J.identifier.id.toLowerCase()}-${C.profileLocation.toString()}`))continue;const ie=this.j.get(S(J,C.profileLocation));if(ie){if(this.J(j,ie.task)){const ue=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,j.identifier.id),ie.waitingTasks.push(j),h.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,le=>le.some(ce=>(0,y.$yp)(ce.identifier,ue)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,j.identifier.id),!le.find(V=>(0,y.$yp)(V.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else q.some(({identifier:ue})=>(0,y.$yp)(ue,J.identifier))||k(ne,J,C,j)}}catch(L){if(u.URI.isUri(j.source))(0,O.$Lb)(j.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",j.identifier.id,L.message),(0,O.$Lb)(j.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",j.identifier.id,L.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",j.identifier.id),L}})),await this.L([...o.entries()].map(async([j,{task:L}])=>{const q=new Date().getTime();let C;try{C=await L.run(),await this.L(this.y.map(J=>J.postInstall(C,L.source,L.options,I.CancellationToken.None)),"PostInstall")}catch(J){const ne=f(J);throw u.URI.isUri(L.source)||n(this.C,L.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.$Gp)(L.source),error:ne,source:L.options.context?.[b.$1o]}),s.set(j,{error:ne,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.profileLocation,applicationScoped:L.options.isApplicationScoped}),this.F.error("Error while installing the extension",L.identifier.id,(0,N.$0)(ne)),ne}if(!u.URI.isUri(L.source)){const J=L.operation===3,ne=J?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.$Gp)(L.source),verificationStatus:L.verificationStatus,duration:new Date().getTime()-q,durationSinceUpdate:ne,source:L.options.context?.[b.$1o]}),l.$o&&L.operation!==3)try{await this.z.reportStatistic(C.manifest.publisher,C.manifest.name,C.manifest.version,"install")}catch{}}s.set(j,{local:C,identifier:L.identifier,operation:L.operation,source:L.source,context:L.options.context,profileLocation:L.profileLocation,applicationScoped:C.isApplicationScoped})})),h.length&&await this.L(h),[...s.values()]}catch(j){const L=(J,ne,ie)=>{const ue=[];J.manifest.extensionDependencies?.length&&ue.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ue.push(...J.manifest.extensionPack);for(const le of ue){if(ie.includes(le.toLowerCase()))continue;ie.push(le.toLowerCase());const ce=s.get(`${le.toLowerCase()}-${ne.toString()}`);ce?.local&&(ie=L(ce.local,ne,ie))}return ie},q=J=>({identifier:J.identifier,operation:2,source:J.source,context:J.options.context,profileLocation:J.profileLocation,error:j}),C=[];for(const[J,{task:ne,root:ie}]of o){const ue=s.get(J);ue?ue.local&&ie&&!s.get(`${ie.identifier.id.toLowerCase()}-${ne.profileLocation.toString()}`)?.local&&(C.push(this.Z(ue.local,{versionOnly:!0,profileLocation:ne.profileLocation})),s.set(J,q(ne))):(ne.cancel(),s.set(J,q(ne)))}for(const[J,{task:ne}]of o){const ie=s.get(J);if(!ie?.local||ne.options.donotIncludePackAndDependencies)continue;L(ie.local,ne.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(le=>o.has(`${le.toLowerCase()}-${ne.profileLocation.toString()}`)&&!s.get(`${le.toLowerCase()}-${ne.profileLocation.toString()}`)?.local)&&(C.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ne.profileLocation})),s.set(J,q(ne)))}throw C.length&&await Promise.allSettled(C.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ne){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,N.$0)(ne))}})),j}finally{for(const{task:j}of o.values())j.source&&!u.URI.isUri(j.source)&&this.j.delete(S(j.source,j.profileLocation));if(s.size){const j=[...s.values()];for(const L of j)L.local&&this.F.info("Extension installed successfully:",L.identifier.id);this.s.fire(j)}}}J(i,s){for(const[,{task:o,waitingTasks:h}]of this.j.entries())if(o===i&&(h.includes(s)||h.some(S=>this.J(S,s)))||o===s&&h[0]&&!this.J(i,h[0]))return!1;return!0}async L(i,s){const o=[],h=[],S=await Promise.allSettled(i);for(const j of S)j.status==="fulfilled"?o.push(j.value):h.push(f(j.reason,s));if(!h.length)return o;if(h.length===1)throw h[0];let k=new b.$_o("","Unknown");for(const j of h)k=new b.$_o(k.message?`${k.message}, ${j.message}`:j.message,j.code!=="Unknown"&&j.code!=="Internal"?j.code:k.code);throw k}async M(i,s,o,h,S,k){if(!this.z.isEnabled())return[];const j=await this.getInstalled(void 0,S,k),L=[],q=[],C=async(J,ne)=>{L.push(J);const ie=ne.extensionDependencies||[],ue=[...ie];if(ne.extensionPack){const le=o?j.find(ce=>(0,y.$yp)(ce.identifier,J)):void 0;for(const ce of ne.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(V=>(0,y.$yp)({id:V},{id:ce}))||ue.every(V=>!(0,y.$yp)({id:V},{id:ce}))&&ue.push(ce)}if(ue.length){const le=ue.filter(ce=>L.every(V=>!(0,y.$yp)(V,{id:ce})));if(le.length){const ce=await this.z.getExtensions(le.map(V=>({id:V,preRelease:h})),I.CancellationToken.None);for(const V of ce){if(L.find(T=>(0,y.$yp)(T,V.identifier)))continue;const Z=ie.some(T=>(0,y.$yp)({id:T},V.identifier));let B;try{B=await this.N(V,!1,h,k)}catch(T){if(Z)throw T;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,N.$0)(T));continue}q.push({gallery:B.extension,manifest:B.manifest}),await C(B.extension.identifier,B.manifest)}}}};return await C(i,s),q}async N(i,s,o,h){let S;const k=await this.getExtensionsControlManifest();if(k.malicious.some(q=>(0,y.$yp)(i.identifier,q)))throw new b.$_o(v.localize(1,null,i.identifier.id),"Malicious");const j=k.deprecated[i.identifier.id.toLowerCase()];if(j?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${j.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:j.extension.id,preRelease:j.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:h},I.CancellationToken.None))[0],!S)throw new b.$_o(v.localize(2,null,i.identifier.id,j.extension.id),"Deprecated")}else{if(!await this.canInstall(i)){const q=await this.getTargetPlatform();throw new b.$_o(v.localize(3,null,i.identifier.id,this.G.nameLong,(0,b.$4o)(q)),"IncompatibleTargetPlatform")}if(S=await this.O(i,s,o,h),!S)throw!o&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],I.CancellationToken.None))[0]?new b.$_o(v.localize(4,null,i.displayName??i.identifier.id),"ReleaseVersionNotFound"):new b.$_o(v.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",S.identifier.id);const L=await this.z.getManifest(S,I.CancellationToken.None);if(L===null)throw new b.$_o(`Missing manifest for extension ${S.identifier.id}`,"Invalid");if(L.version!==S.version)throw new b.$_o(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:S,manifest:L}}async O(i,s,o,h){const S=await this.getTargetPlatform();let k=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(k=(await this.z.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:S,compatible:!0,productVersion:h},I.CancellationToken.None))[0]||null),!k&&await this.z.isExtensionCompatible(i,o,S,h)&&(k=i),k||(s?k=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:S,compatible:!0,productVersion:h},I.CancellationToken.None))[0]||null:k=await this.z.getCompatibleExtension(i,o,S,h)),k}async P(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},h=C=>`${C.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,S=this.m.get(h(i.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),S.waitUntilTaskIsFinished();const k=C=>{const J=this.Z(C,o);return this.m.set(h(J.extension.identifier),J),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${C.identifier.id}@${C.manifest.version}`),this.t.fire({identifier:C.identifier,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped}),J},j=(C,J)=>{J?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${C.identifier.id}@${C.manifest.version}`,J.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${C.identifier.id}@${C.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,y.$Fp)(C),error:J}),this.u.fire({identifier:C.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped})},L=[],q=[];try{L.push(k(i));const C=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const J=this.S(i,C);for(const ne of J)this.m.has(h(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):L.push(k(ne))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(L.map(J=>J.extension),C,i),await this.L(L.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ne=>ne.postUninstall(J.extension,o,I.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}j(J.extension)}catch(ne){const ie=f(ne);throw j(J.extension,ie),ie}finally{q.push(J)}}))}catch(C){const J=f(C);for(const ne of L){try{ne.cancel()}catch{}q.includes(ne)||j(ne.extension,J)}throw J}finally{for(const C of L)this.m.delete(h(C.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",C.extension.identifier.id)}}Q(i,s,o){for(const h of i){const S=this.U(h,s);if(S.length){const k=S.filter(j=>!i.some(L=>(0,y.$yp)(L.identifier,j.identifier)));if(k.length)throw new Error(this.R(h,k,o))}}}R(i,s,o){return o===i?s.length===1?v.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?v.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):v.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?v.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?v.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):v.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const h=i.manifest.extensionPack?i.manifest.extensionPack:[];if(h.length){const S=s.filter(j=>!j.isBuiltin&&h.some(L=>(0,y.$yp)({id:L},j.identifier))),k=[];for(const j of S)k.push(...this.S(j,s,o));return[...S,...k]}return[]}U(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(h=>(0,y.$yp)({id:h},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,N.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$pq=m,e.$pq=m=$e([oe(0,b.$0o),oe(1,c.$4l),oe(2,w.$Cl),oe(3,R.$5j),oe(4,d.$lk),oe(5,$.$El)],m);function f(t,i){if(t instanceof b.$_o)return t;let s;return t instanceof b.$$o?s=new b.$_o(t.message,t.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):s=new b.$_o(t.message,(0,N.$4)(t)?"Cancelled":i??"Internal"),s.stack=t.stack,s}function n(t,i,{extensionData:s,verificationStatus:o,duration:h,error:S,source:k,durationSinceUpdate:j}){let L,q;(0,a.$gg)(o)&&(o===!0?o="Verified":(o===!1||(L="Signature",q=o),o="Unverified")),S&&(L=S.code,S.code==="Signature"&&(q=S.message)),t.publicLog(i,{...s,verificationStatus:o,success:!S,duration:h,errorcode:L,errorcodeDetail:q,durationSinceUpdate:j,source:k})}class r{constructor(){this.d=new D.$xh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,D.$lh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$lh)(i=>new Promise((s,o)=>{const h=i.onCancellationRequested(()=>{h.dispose(),o(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$rq=r}),define(se[42],re([0,1,8,14,2,5,30,11,21,26,13,10,6,24,23,3,9,22]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class $ extends Error{constructor(t,i){super(t),this.code=i}}e.$sq=$,e.$tq=(0,v.$yi)("IExtensionsProfileScannerService");let m=class extends I.$Uc{constructor(t,i,s,o,h,S){super(),this.j=t,this.m=i,this.n=s,this.r=o,this.s=h,this.t=S,this.b=this.B(new N.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new N.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,i){return this.u(t,void 0,i)}async addExtensionsToProfile(t,i,s){const o=[],h=[];try{return await this.u(i,S=>{const k=[];if(s)k.push(...S);else for(const j of S)t.some(([L])=>(0,a.$yp)(L.identifier,j.identifier)&&L.manifest.version!==j.version)?o.push(j):k.push(j);for(const[j,L]of t){const q=k.findIndex(J=>(0,a.$yp)(J.identifier,j.identifier)&&J.version===j.manifest.version),C={identifier:j.identifier,version:j.manifest.version,location:j.location,metadata:L};q===-1?(h.push(C),k.push(C)):k.splice(q,1,C)}return h.length&&this.b.fire({extensions:h,profileLocation:i}),o.length&&this.f.fire({extensions:o,profileLocation:i}),k}),h.length&&this.c.fire({extensions:h,profileLocation:i}),o.length&&this.g.fire({extensions:o,profileLocation:i}),h}catch(S){throw h.length&&this.c.fire({extensions:h,error:S,profileLocation:i}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:i}),S}}async updateMetadata(t,i){const s=[];return await this.u(i,o=>{const h=[];for(const S of o){const k=t.find(([j])=>(0,a.$yp)(j.identifier,S.identifier)&&j.manifest.version===S.version);k&&(S.metadata={...S.metadata,...k[1]},s.push(S)),h.push(S)}return h}),s}async removeExtensionFromProfile(t,i){const s=[];try{await this.u(i,o=>{const h=[];for(const S of o)(0,a.$yp)(S.identifier,t.identifier)?s.push(S):h.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:i}),h}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async u(t,i,s){return this.F(t).queue(async()=>{let o=[],h;try{const S=await this.m.readFile(t);h=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,u.$jl)(S)!==1)throw S;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(h=await this.D()),!h&&s?.bailOutWhenFileNotFound)throw new $((0,d.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(h){Array.isArray(h)||this.w(t);let S=!1;for(const k of h){f(k)||this.w(t);let j;if((0,R.$$f)(k.relativeLocation)&&k.relativeLocation)j=this.z(k.relativeLocation);else if((0,R.$$f)(k.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${k.location}`);continue}else{j=P.URI.revive(k.location);const L=this.y(j);L&&(S=!0,k.relativeLocation=L)}(0,R.$fg)(k.metadata?.hasPreReleaseVersion)&&k.metadata?.preRelease&&(S=!0,k.metadata.hasPreReleaseVersion=!0),o.push({identifier:k.identifier,location:j,version:k.version,metadata:k.metadata})}S&&await this.m.writeFile(t,D.$He.fromString(JSON.stringify(h)))}if(i){o=i(o);const S=o.map(k=>({identifier:k.identifier,version:k.version,location:k.location.toJSON(),relativeLocation:this.y(k.location),metadata:k.metadata}));await this.m.writeFile(t,D.$He.fromString(JSON.stringify(S)))}return o})}w(t){const i=new $(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(h){if((0,u.$jl)(h)===1)return;throw h}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const h=JSON.parse(s);Array.isArray(h)&&h.every(S=>f(S))?o=h:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",h)}catch(h){this.t.error(h)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$He.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(h){if((0,u.$jl)(h)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw h}try{await this.m.del(t)}catch(h){(0,u.$jl)(h)!==1&&this.t.error(h)}try{await this.m.del(i)}catch(h){(0,u.$jl)(h)!==1&&this.t.error(h)}return o})()),this.C}F(t){let i=this.h.get(t);return i||(i=new O.$Fh,this.h.set(t,i)),i}};e.$uq=m,e.$uq=m=$e([oe(1,u.$5k),oe(2,y.$El),oe(3,p.$Cl),oe(4,c.$4l),oe(5,b.$5j)],m);function f(r){return(0,R.$ag)(r)&&(0,l.$9o)(r.identifier)&&(n(r.location)||(0,R.$$f)(r.location)&&r.location)&&((0,R.$fg)(r.relativeLocation)||(0,R.$$f)(r.relativeLocation))&&r.version&&(0,R.$$f)(r.version)}function n(r){return r?(0,R.$$f)(r.path)&&(0,R.$$f)(r.scheme):!1}}),define(se[53],re([0,1,19,8,27,14,9,38,84,2,15,16,12,17,44,55,3,11,100,18,26,37,50,13,10,6,32,5,47,42,24,23,118]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$,m,f,n,r,t,i,s,o,h,S,k,j,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=e.$yq=e.$xq=e.Translations=void 0,e.$Aq=ue;var q;(function(ce){function V(Z,B){if(Z===B)return!0;const T=Object.keys(Z),H=new Set;for(const Q of Object.keys(B))H.add(Q);if(T.length!==H.size)return!1;for(const Q of T){if(Z[Q]!==B[Q])return!1;H.delete(Q)}return H.size===0}ce.equals=V})(q||(e.Translations=q={})),e.$xq=(0,t.$yi)("IExtensionsScannerService");let C=class extends a.$Uc{constructor(V,Z,B,T,H,Q,Y,_,F,U,g,E){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Z,this.r=B,this.s=T,this.t=H,this.u=Q,this.w=Y,this.y=_,this.z=F,this.C=U,this.D=g,this.F=E,this.g=this.B(new o.$fe),this.onDidChangeCache=this.g.event,this.h=(0,y.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Jp)(this.w,this.y)),this.G}async scanAllExtensions(V,Z,B){const[T,H]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Z)]),Q=B?await this.scanExtensionsUnderDevelopment(V,[...T,...H]):[];return this.L(T,H,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Z=[];Z.push(this.M(!!V.useCache,V.language)),Z.push(this.N(V.language,!!V.checkControlFile));const[B,T]=await Promise.all(Z);return this.J([...B,...T],0,V,!1)}async scanUserExtensions(V){const Z=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Z,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,B,V.productVersion??this.R()),H=V.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Q;try{Q=await H.scanExtensions(T)}catch(Y){if(Y instanceof S.$sq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Q=await H.scanExtensions(T);else throw Y}return Q=await this.J(Q,1,V,!0),this.y.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(V,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===u.Schemas.file).map(async T=>{const H=await this.P(T,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(Y=>(Y.type=Z.find(_=>(0,m.$yp)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,H)))}))).flat();return this.J(B,"development",V,!0)}return[]}async scanExistingExtension(V,Z,B){const T=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanExtension(T);return!H||!B.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(V,Z,B){const T=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(T);return this.J(H,Z,B,!0)}async scanMultipleExtensions(V,Z,B){const T=[];return await Promise.all(V.map(async H=>{const Q=await this.scanOneOrMultipleExtensions(H,Z,B);T.push(...Q)})),this.J(T,Z,B,!0)}async scanMetadata(V){const Z=(0,y.$_g)(V,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(V,Z){const B=(0,y.$_g)(V,"package.json"),T=(await this.w.readFile(B)).value.toString(),H=JSON.parse(T);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,H.__metadata={...H.__metadata,...Z},await this.w.writeFile((0,y.$_g)(V,"package.json"),N.$He.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof S.$sq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$He.fromString(JSON.stringify([])))}catch(Z){(0,r.$jl)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Z,B,T){return B.includeAllVersions||(V=this.L(Z===0?V:void 0,Z===1?V:void 0,Z==="development"?V:void 0,await this.getTargetPlatform(),T)),B.includeInvalid||(V=V.filter(H=>H.isValid)),V.sort((H,Q)=>{const Y=v.$nc(H.location.fsPath),_=v.$nc(Q.location.fsPath);return Y<_?-1:Y>_?1:0})}L(V,Z,B,T,H){const Q=(_,F,U)=>{if(_.isValid&&!F.isValid)return!1;if(_.isValid===F.isValid){if(H&&p.gt(_.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if(p.eq(_.manifest.version,F.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return U?this.y.warn(`Overwriting user extension ${_.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${F.location.path}.`),!0},Y=new f.$Vm;return V?.forEach(_=>{const F=Y.get(_.identifier.id);(!F||Q(F,_,!1))&&Y.set(_.identifier.id,_)}),Z?.forEach(_=>{const F=Y.get(_.identifier.id);if(!F&&V&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!F||Q(F,_,!1))&&Y.set(_.identifier.id,_)}),B?.forEach(_=>{const F=Y.get(_.identifier.id);(!F||Q(F,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(V,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),H=await(V&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",H.length),H}async N(V,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Z?await this.O():{},H=[],Q=c.URI.file(v.$hc(v.$jc(u.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of B){const F=T[_.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":H.push((0,y.$_g)(Q,_.name));break;default:H.push(c.URI.file(F));break}}const Y=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,O.$Hb)(Y)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Z,B,T,H,Q,Y,_){const F=await this.f(H??b.$w),U=await this.Q(V),g=Z&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=g?await this.Q(g):void 0;return new J(V,U,g,E,Z,Y,B,T,Q,_.version,_.date,this.C.commit,!this.z.isBuilt,H,F)}async Q(V){try{const Z=await this.w.stat(V);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$yq=C,e.$yq=C=$e([oe(4,k.$El),oe(5,S.$tq),oe(6,r.$5k),oe(7,i.$5j),oe(8,$.$Fi),oe(9,s.$lk),oe(10,j.$Cl),oe(11,t.$xi)],C);class J{constructor(V,Z,B,T,H,Q,Y,_,F,U,g,E,z,M,G){this.location=V,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=T,this.profile=H,this.profileScanOptions=Q,this.type=Y,this.excludeObsolete=_,this.validate=F,this.productVersion=U,this.productDate=g,this.productCommit=E,this.devMode=z,this.language=M,this.translations=G}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Z){return(0,y.$5g)(V.location,Z.location)&&V.mtime===Z.mtime&&(0,y.$5g)(V.applicationExtensionslocation,Z.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&V.profile===Z.profile&&I.$9n(V.profileScanOptions,Z.profileScanOptions)&&V.type===Z.type&&V.excludeObsolete===Z.excludeObsolete&&V.validate===Z.validate&&V.productVersion===Z.productVersion&&V.productDate===Z.productDate&&V.productCommit===Z.productCommit&&V.devMode===Z.devMode&&V.language===Z.language&&q.equals(V.translations,Z.translations)}}e.$zq=J;let ne=class extends a.$Uc{constructor(V,Z,B,T,H){super(),this.f=V,this.g=Z,this.h=B,this.j=T,this.m=H}async scanExtensions(V){const Z=V.profile?await this.r(V):await this.n(V);let B={};if(V.excludeObsolete&&V.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(T)}catch{}return(0,d.$lg)(B)?Z:Z.filter(T=>!B[m.$zp.create(T).toString()])}async n(V){const Z=await this.j.resolve(V.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async T=>{if(!T.isDirectory||V.type===1&&(0,y.$9g)(T.resource).indexOf(".")===0)return null;const H=new J(T.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H)}));return(0,O.$Hb)(B).sort((T,H)=>T.location.path<H.location.path?-1:1)}async r(V){let Z=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Z=Z.filter(T=>!T.metadata?.isApplicationScoped);const B=await this.s(V.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,V);Z.push(...B)}return Z}async s(V,Z,B){const T=await this.g.scanProfileExtensions(V,B.profileScanOptions);if(!T.length)return[];const H=await Promise.all(T.map(async Q=>{if(Z(Q)){const Y=new J(Q.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,Q.metadata)}return null}));return(0,O.$Hb)(H)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,y.$_g)(V.location,"package.json"))){const Z=await this.scanExtension(V);return Z?[Z]:[]}else return await this.scanExtensions(V)}catch(Z){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,A.$0)(Z)),[]}}async scanExtension(V,Z){try{let B=await this.scanExtensionManifest(V.location);if(B){B.publisher||(B.publisher=f.$Pm),Z=Z??B.__metadata,delete B.__metadata;const T=(0,m.$Dp)(B.publisher,B.name),H=Z?.id?{id:T,uuid:Z.id}:{id:T},Q=Z?.isSystem?0:V.type,Y=Q===0||!!Z?.isBuiltin;B=await this.t(V.location,B,J.createNlsConfiguration(V));const _={type:Q,identifier:H,manifest:B,location:V.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return V.validate?this.validate(_,V):_}}catch(B){V.type!==0&&this.m.error(B)}return null}validate(V,Z){let B=!0;const T=(0,n.$Op)(Z.productVersion,Z.productDate,Z.location,V.manifest,V.isBuiltin);for(const[H,Q]of T)H===R.default.Error&&(B=!1,this.m.error(this.z(Z.location,Q)));return V.isValid=B,V.validations=T,V}async scanExtensionManifest(V){const Z=(0,y.$_g)(V,"package.json");let B;try{B=(await this.j.readFile(Z)).value.toString()}catch(H){return(0,r.$jl)(H)!==1&&this.m.error(this.z(V,(0,w.localize)(0,null,Z.path,H.message))),null}let T;try{T=JSON.parse(B)}catch{const Q=[];(0,P.$Ln)(B,Q);for(const Y of Q)this.m.error(this.z(V,(0,w.localize)(1,null,Z.path,Y.offset,Y.length,(0,l.$vq)(Y.error))));return null}return(0,P.$Un)(T)!=="object"?(this.m.error(this.z(V,(0,w.localize)(2,null,Z.path))),null):T}async t(V,Z,B){const T=await this.u(V,Z,B);if(T)try{const H=[],Q=await this.w(T.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(V,(0,w.localize)(3,null,T.default?.path,(0,l.$vq)(_.error))))}),Z;if((0,P.$Un)(T)!=="object")return this.m.error(this.z(V,(0,w.localize)(4,null,T.default?.path))),Z;const Y=T.values||Object.create(null);return(0,L.$wq)(this.m,Z,Y,Q)}catch{}return Z}async u(V,Z,B){const T=(0,y.$_g)(V,"package.nls.json"),H=(F,U)=>{U.forEach(g=>{this.m.error(this.z(V,(0,w.localize)(5,null,F?.path,(0,l.$vq)(g.error))))})},Q=F=>{this.m.error(this.z(V,(0,w.localize)(6,null,F?.path)))},Y=`${Z.publisher}.${Z.name}`,_=B.translations[Y];if(_)try{const F=c.URI.file(_),U=(await this.j.readFile(F)).value.toString(),g=[],E=(0,P.$Ln)(U,g);return g.length>0?(H(F,g),{values:void 0,default:T}):(0,P.$Un)(E)!=="object"?(Q(F),{values:void 0,default:T}):{values:E.contents?E.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let U;try{U=await this.y(V,B)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const g=(await this.j.readFile(U.localized)).value.toString(),E=[],z=(0,P.$Ln)(g,E);return E.length>0?(H(U.localized,E),{values:void 0,default:U.original}):(0,P.$Un)(z)!=="object"?(Q(U.localized),{values:void 0,default:U.original}):{values:z,default:U.original}}catch{return{values:void 0,default:U.original}}}}async w(V,Z){if(V)try{const B=(await this.j.readFile(V)).value.toString();return(0,P.$Ln)(B,Z)}catch{}}y(V,Z){return new Promise((B,T)=>{const H=Q=>{const Y=(0,y.$_g)(V,`package.nls.${Q}.json`);this.j.exists(Y).then(_=>{_&&B({localized:Y,original:(0,y.$_g)(V,"package.nls.json")});const F=Q.lastIndexOf("-");F===-1?B({localized:(0,y.$_g)(V,"package.nls.json"),original:null}):(Q=Q.substring(0,F),H(Q))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,y.$_g)(V,"package.nls.json"),original:null});H(Z.language)})}z(V,Z){return`[${V.path}]: ${Z}`}};ne=$e([oe(1,S.$tq),oe(2,j.$Cl),oe(3,r.$5k),oe(4,i.$5j)],ne);let ie=class extends ne{constructor(V,Z,B,T,H,Q,Y){super(Z,T,H,Q,Y),this.G=V,this.H=B,this.D=this.B(new D.$wh(3e3)),this.F=this.B(new o.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Z=this.M(V),B=await this.I(Z);if(this.C=V,B&&B.input&&J.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),B.result.map(H=>(H.location=c.URI.revive(H.location),H));const T=await super.scanExtensions(V);return await this.J(Z,{input:V,result:T}),T}async I(V){try{const Z=await this.j.readFile(V),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,h.$8h)(B.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",V.path,(0,A.$0)(Z))}return null}async J(V,Z){try{await this.j.writeFile(V,N.$He.fromString(JSON.stringify(Z)))}catch(B){this.m.debug("Error while writing the extension cache file:",V.path,(0,A.$0)(B))}}async L(){if(!this.C)return;const V=this.M(this.C),Z=await this.I(V);if(!Z)return;const B=Z.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!I.$9n(T,B))try{this.m.info("Invalidating Cache",B,T),await this.j.del(V),this.F.fire()}catch(H){this.m.error(H)}}M(V){const Z=this.N(V);return this.h.extUri.joinPath(Z.cacheHome,V.type===0?f.$Om:f.$Nm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(V.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,k.$El),oe(3,S.$tq),oe(4,j.$Cl),oe(5,r.$5k),oe(6,i.$5j)],ie);function ue(ce,V){const Z=(0,m.$Bp)(ce.manifest.publisher,ce.manifest.name);return{id:Z,identifier:new f.$Tm(Z),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:V,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class le extends C{constructor(V,Z,B,T,H,Q,Y,_,F,U,g,E){super(V,Z,(0,y.$_g)(B,".vscode-oss-dev","extensions","control.json"),T,H,Q,Y,_,F,U,g,E),this.S=(async()=>{if(b.$z)try{const z=await this.w.readFile(c.URI.file(b.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$Bq=le}),define(se[160],re([0,1,8,9,2,15,17,44,3,28,25,49,29,18,72,21,26,71,13,6]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let f=class extends I.$Uc{static{m=this}static{this.c=".sigzip"}constructor(r,t,i,s,o,h){super(),this.h=t,this.j=i,this.m=s,this.n=o,this.r=h,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(r,t,i,s){await this.g;const o=(0,A.$_g)(this.extensionsDownloadDir,this.z(r));try{await this.w(r,o,S=>this.j.download(r,S,t))}catch(S){throw(0,p.$qq)(S,"Download")}let h=!1;if(i&&this.t(r)){let S;try{S=await this.u(r)}catch(k){try{await this.delete(o)}catch(j){this.r.error(j)}throw k}try{h=await this.n.verify(r.identifier.id,o.fsPath,S.fsPath,s)}catch(k){if(h=k.code,h==="PackageIsInvalidZip"||h==="SignatureArchiveIsInvalidZip"){try{await this.delete(o)}catch(j){this.r.error(j)}throw new R.$_o(v.$kq,"CorruptZip")}}finally{try{await this.delete(S)}catch(k){this.r.error(k)}}}return{location:o,verificationStatus:h}}t(r){if(!r.isSigned)return this.r.info(`Extension is not signed: ${r.identifier.id}`),!1;const t=this.m.getValue("extensions.verifySignature");return(0,l.$eg)(t)?t:!0}async u(r){await this.g;const t=(0,A.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`);try{await this.j.downloadSignatureArchive(r,t)}catch(i){throw(0,p.$qq)(i,"DownloadSignature")}return t}async w(r,t,i){if(await this.h.exists(t))return;if(t.scheme!==N.Schemas.file){await i(t);return}const s=(0,A.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`);try{await i(s)}catch(o){try{await this.h.del(s)}catch{}throw o}try{await u.Promises.rename(s.fsPath,t.fsPath,2*60*1e3)}catch(o){try{await this.h.del(s)}catch{}if(o.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,t.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(o)}. Deleted the file from downloaded location`,s.path),o}}async delete(r){await this.g,await this.h.del(r)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const t=[],i=[],s=[];for(const S of r.children)if(S.name.endsWith(m.c))s.push(S.resource);else{const k=d.$zp.parse(S.name);k&&i.push([k,S])}const o=(0,d.$Ep)(i,([S])=>S),h=[];for(const S of o)S.sort((k,j)=>P.rcompare(k[0].version,j[0].version)),t.push(...S.slice(1).map(k=>k[1].resource)),h.push(S[0][1]);h.sort((S,k)=>S.mtime-k.mtime),t.push(...h.slice(0,Math.max(0,h.length-this.f)).map(S=>S.resource)),t.push(...s),await O.Promises.settled(t.map(S=>(this.r.trace("Deleting from cache",S.path),this.h.del(S))))}}catch(r){this.r.error(r)}}z(r){return this.f?d.$zp.create(r).toString().toLowerCase():(0,a.$Ug)()}};e.$Cq=f,e.$Cq=f=m=$e([oe(0,y.$Gi),oe(1,w.$5k),oe(2,R.$0o),oe(3,b.$5i),oe(4,c.$dq),oe(5,$.$5j)],f)}),define(se[161],re([0,1,59,8,34,5,2,15,16,25,6,24]),function(X,e,O,D,I,N,A,P,l,a,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let b=class extends A.$Uc{constructor(p,R){super(),this.b=p,this.f=R,this.a=new D.$Eh(5)}async postUninstall(p){const R=this.g(p,"uninstall");R&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(d){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(d)}}));try{await a.Promises.rm(this.m(p))}catch(d){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(d)}}g(p,R){const d=`vscode:${R}`;if(p.location.scheme===P.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[d]=="string"){const c=p.manifest.scripts[d].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${d} should be a node script`),null):{script:(0,l.$jc)(p.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(p,R,d,c,w){return new Promise(($,m)=>{const f=this.j(p,R,d,w);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?m(t):$(void 0)};f.on("error",t=>{r((0,I.$jj)(t)||"Unknown")}),f.on("exit",(t,i)=>{r(t?`post-${R} process exited with code ${t}`:void 0)}),c&&(n=setTimeout(()=>{n=null,f.kill(),m("timed out")},5e3))})}j(p,R,d,c){const w={silent:!0,execArgv:void 0},$=(0,O.fork)(p,[`--type=extension-post-${R}`,...d],w);$.stdout.setEncoding("utf8"),$.stderr.setEncoding("utf8");const m=N.Event.fromNodeEventEmitter($.stdout,"data"),f=N.Event.fromNodeEventEmitter($.stderr,"data");this.B(m(t=>this.f.info(c.identifier.id,c.manifest.version,`post-${R}`,t))),this.B(f(t=>this.f.error(c.identifier.id,c.manifest.version,`post-${R}`,t)));const n=N.Event.any(N.Event.map(m,t=>({data:`%c${t}`,format:[""]}),this.q),N.Event.map(f,t=>({data:`%c${t}`,format:["color: red"]}),this.q));return N.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(t=>{console.group(c.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),$}m(p){return(0,l.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.$Dq=b,e.$Dq=b=$e([oe(0,v.$El),oe(1,u.$5j)],b)}),define(se[162],re([0,1,8,14,20,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,101,61,18,72,21,26,42,53,160,161,119,141,148,50,13,10,6,32,22,23,24]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$,m,f,n,r,t,i,s,o,h,S,k,j,L,q,C,J,ne,ie,ue,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0,e.$Hq=(0,J.$zi)(t.$ap);const V=".vsctmp";let Z=class extends r.$pq{constructor(F,U,g,E,z,M,G,W,te,ae,he,pe){super(F,U,he,g,ae,pe),this.eb=z,this.fb=M,this.gb=G,this.hb=te,this.db=new Map,this.qb=new u.$Bc;const ye=this.B(W.createInstance(S.$Dq));this.ab=this.B(W.createInstance(B,me=>ye.postUninstall(me))),this.bb=this.B(new j.$Fq(pe,te,he,this,this.F)),this.cb=this.B(W.createInstance(h.$Cq));const fe=this.B(new L.$Gq(this,this.eb,pe,M,he,te,g));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Jp)(this.hb,this.F)),this.ib}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const U=await this.ob(F),g=await(0,$.zip)((0,y.$_g)(this.cb.extensionsDownloadDir,(0,c.$Ug)()).fsPath,U);return d.URI.file(g)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:U,cleanup:g}=await this.kb(F),E=b.$kc(U.fsPath);try{return await(0,k.$Eq)(E)}finally{await g()}}getInstalled(F,U=this.H.defaultProfile.extensionsResource,g={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(F??null,U,g)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.ab.scanUserExtensionAtLocation(F)}async install(F,U={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:g,cleanup:E}=await this.kb(F);try{const z=await(0,k.$Eq)(b.$kc(g.fsPath)),M=(0,i.$Dp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,q.$Qp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:z,extension:g,options:U}])).find(({identifier:te})=>(0,i.$yp)(te,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,r.$qq)(new Error(`Unknown error while installing extension ${M}`))}finally{await E()}}async installFromLocation(F,U){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const g=await this.ab.scanUserExtensionAtLocation(F);if(!g||!g.manifest.name||!g.manifest.version)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.tb([[g,{source:"resource"}]],U),this.F.info("Successfully installed extension",g.identifier.id,U.toString()),g}async installExtensionsFromProfile(F,U,g){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,U.toString(),g.toString());const E=(await this.getInstalled(1,U)).filter(z=>F.some(M=>(0,i.$yp)(M,z.identifier)));if(E.length){const z=await Promise.all(E.map(M=>this.ab.scanMetadata(M,U)));await this.tb(E.map((M,G)=>[M,z[G]]),g),this.F.info("Successfully installed extensions",E.map(M=>M.identifier.id),g.toString())}return E}async updateMetadata(F,U,g=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),U.isPreReleaseVersion&&(U.preRelease=!0,U.hasPreReleaseVersion=!0),U.isMachineScoped===!1&&(U.isMachineScoped=void 0),U.isBuiltin===!1&&(U.isBuiltin=void 0),U.pinned===!1&&(U.pinned=void 0),F=await this.ab.updateMetadata(F,U,g),this.bb.invalidate(g),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const U=await this.getTargetPlatform(),[g]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:U,compatible:!0},I.CancellationToken.None);if(!g)throw new Error(m.localize(2,null));await this.ab.setUninstalled(F);try{await this.ab.removeUninstalledExtension(F)}catch(E){throw new Error(m.localize(3,null,(0,N.$jj)(E)))}return this.installFromGallery(g)}$(F,U,g,E){return this.ab.copyExtension(F,U,g,E)}copyExtensions(F,U){return this.ab.copyExtensions(F,U,{version:this.G.version,date:this.G.date})}markAsUninstalled(...F){return this.ab.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(F){this.F.error(F)}}async download(F,U,g){const{location:E}=await this.cb.download(F,U,!g);return E}async kb(F){if(F.scheme===v.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const U=(0,y.$_g)(this.cb.extensionsDownloadDir,(0,c.$Ug)());return await this.gb.download(F,U),this.F.info("Downloaded extension to",U.toString()),{location:U,cleanup:async()=>{try{await this.hb.del(U)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(F,U,g){if(d.URI.isUri(U))return new Q(F,U,g,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const E=i.$zp.create(U).toString();let z=this.db.get(E);return z||(this.db.set(E,z=new H(F,U,g,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(E))),z}Z(F,U){return new Y(F,U.profileLocation,this.fb)}async ob(F){const U=async E=>{let z=await w.Promises.readdir(E);z=z.map(W=>b.$jc(E,W));const M=await Promise.all(z.map(W=>w.Promises.stat(W)));let G=Promise.resolve([]);return M.forEach((W,te)=>{const ae=z[te];W.isFile()&&(G=G.then(he=>[...he,ae])),W.isDirectory()&&(G=G.then(he=>U(ae).then(pe=>[...he,...pe])))}),G};return(await U(F.location.fsPath)).map(E=>({path:`extension/${b.$lc(F.location.fsPath,E)}`,localPath:E}))}async pb({added:F,removed:U}){if(U){const g=F&&this.D.extUri.isEqual(U.profileLocation,F.profileLocation)?U.extensions.filter(E=>F.extensions.every(z=>!(0,i.$yp)(z,E))):U.extensions;for(const E of g)this.F.info("Extensions removed from another source",E.id,U.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:U.profileLocation})}if(F){const E=(await this.getInstalled(1,F.profileLocation)).filter(z=>F.extensions.some(M=>(0,i.$yp)(M,z.identifier)));this.s.fire(E.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(U=>this.qb.add(U)));const F=await this.hb.resolve(this.eb.userExtensionsLocation);for(const U of F.children??[])U.isDirectory&&this.qb.add(U.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(U=>this.sb(U)))}async sb(F){if(!F.affects(this.eb.userExtensionsLocation,1))return;const U=[];for(const g of F.rawAdded){if(this.qb.has(g)||!this.D.extUri.isEqual(this.D.extUri.dirname(g),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(g,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(g).startsWith(".")||!(await this.hb.stat(g)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(g);E&&E.installedTimestamp===void 0&&(this.qb.add(g),U.push(E))}U.length&&(await this.tb(U.map(g=>[g,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",U.map(g=>g.identifier.id)))}async tb(F,U){const g=F.map(E=>E[0]);await this.ub(g),await this.fb.addExtensionsToProfile(F,U),this.s.fire(g.map(E=>({local:E,identifier:E.identifier,operation:1,profileLocation:U})))}async ub(F){const U=await this.ab.getUninstalledExtensions();for(const g of F){const E=i.$zp.create(g);U[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$Iq=Z,e.$Iq=Z=$e([oe(0,t.$0o),oe(1,ue.$4l),oe(2,ne.$5j),oe(3,n.$Gi),oe(4,o.$xq),oe(5,s.$tq),oe(6,f.$No),oe(7,J.$xi),oe(8,C.$5k),oe(9,ie.$lk),oe(10,le.$Cl),oe(11,ce.$El)],Z);let B=class extends a.$Uc{constructor(F,U,g,E,z,M){super(),this.j=F,this.m=U,this.n=g,this.s=E,this.t=z,this.u=M,this.h=this.B(new P.$fe),this.onExtract=this.h.event,this.c=(0,y.$_g)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$Fh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,U,g){try{const E={includeInvalid:!0,profileLocation:U,productVersion:g};let z=[];return F===null||F===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},E,!1)):F===1&&z.push(...await this.n.scanUserExtensions(E)),z=F!==null?z.filter(M=>M.type===F):z,await Promise.all(z.map(M=>this.F(M)))}catch(E){throw(0,r.$qq)(E,"Scanning")}}async scanAllUserExtensions(F){try{const U=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return await Promise.all(U.map(g=>this.F(g)))}catch(U){throw(0,r.$qq)(U,"Scanning")}}async scanUserExtensionAtLocation(F){try{const U=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(U)return await this.F(U)}catch(U){this.u.error(U)}return null}async extractUserExtension(F,U,g,E,z){const M=F.toString(),G=d.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Ug)()}`)),W=d.URI.file(b.$jc(this.n.userExtensionsLocation.fsPath,M));let te=await this.m.exists(W);if(te&&E){try{await this.y(F.id,W,"removeExisting")}catch{throw new t.$_o(m.localize(4,null,W.fsPath,F.id),"Delete")}te=!1}if(te)try{await this.n.updateMetadata(W,g)}catch(ae){throw(0,r.$qq)(ae,"UpdateMetadata")}else try{try{this.u.trace(`Started extracting the extension from ${U} to ${W.fsPath}`),await(0,$.$nq)(U,G.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,F.id)}catch(ae){let he="Extract";throw ae instanceof $.$lq&&(ae.type==="CorruptZip"?he="CorruptZip":ae.type==="Incomplete"&&(he="IncompleteZip")),(0,r.$qq)(ae,he)}try{await this.n.updateMetadata(G,g)}catch(ae){throw(0,r.$qq)(ae,"UpdateMetadata")}try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${W.fsPath}`),await this.C(G.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ae)}. Deleted from extracted location`,G),ae}this.h.fire(W)}catch(ae){try{await this.m.del(G,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(F,U){return U?(await this.w(F,U))?.metadata:this.n.scanMetadata(F.location)}async w(F,U){return(await this.s.scanProfileExtensions(U)).find(E=>(0,i.$yp)(E.identifier,F.identifier))}async updateMetadata(F,U,g){try{g?await this.s.updateMetadata([[F,U]],g):await this.n.updateMetadata(F.location,U)}catch(E){throw(0,r.$qq)(E,"UpdateMetadata")}return this.D(F.location,F.type,g)}async getUninstalledExtensions(){try{return await this.z()}catch(F){throw(0,r.$qq)(F,"ReadUninstalled")}}async setUninstalled(...F){const U=F.map(g=>i.$zp.create(g));await this.z(g=>U.forEach(E=>{g[E.toString()]=!0,this.u.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(F){try{await this.z(U=>delete U[F.toString()])}catch(U){throw(0,r.$qq)(U,"UnsetUninstalled")}}async removeExtension(F,U){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,U)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(U=>delete U[i.$zp.create(F).toString()])}async copyExtension(F,U,g,E){const z=await this.w(F,U),M=await this.w(F,g);if(E={...z?.metadata,...E},M)if(this.t.extUri.isEqual(M.location,F.location))await this.s.updateMetadata([[F,{...M.metadata,...E}]],g);else{const G=await this.D(M.location,F.type,g);await this.s.removeExtensionFromProfile(G,g),await this.s.addExtensionsToProfile([[F,{...M.metadata,...E}]],g)}else await this.s.addExtensionsToProfile([[F,E]],g);return this.D(F.location,F.type,g)}async copyExtensions(F,U,g){const E=await this.scanExtensions(1,F,g),z=await Promise.all(E.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,F)]));await this.s.addExtensionsToProfile(z,U)}async y(F,U,g){this.u.trace(`Deleting ${g} extension from disk`,F,U.fsPath);const E=this.t.extUri.joinPath(this.t.extUri.dirname(U),`${this.t.extUri.basename(U)}.${(0,l.$mj)((0,c.$Ug)()).toString(16)}${V}`);await this.C(U.fsPath,E.fsPath),await this.m.del(E,{recursive:!0}),this.u.info(`Deleted ${g} extension from disk`,F,U.fsPath)}z(F){return this.g.queue(async()=>{let U;try{U=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,C.$jl)(E)!==1)throw E}let g={};if(U)try{g=JSON.parse(U)}catch{}return F&&(F(g),Object.keys(g).length?await this.m.writeFile(this.c,D.$He.fromString(JSON.stringify(g))):await this.m.del(this.c)),g})}async C(F,U){try{await w.Promises.rename(F,U,2*60*1e3)}catch(g){throw(0,r.$qq)(g,"Rename")}}async D(F,U,g){try{if(g){const z=(await this.n.scanUserExtensions({profileLocation:g})).find(M=>this.t.extUri.isEqual(M.location,F));if(z)return await this.F(z)}else{const E=await this.n.scanExistingExtension(F,U,{includeInvalid:!0});if(E)return await this.F(E)}throw new t.$_o(m.localize(5,null,F.path),"ScanningExtension")}catch(E){throw(0,r.$qq)(E,"ScanningExtension")}}async F(F){const U=await this.m.resolve(F.location);let g,E;return U.children&&(g=U.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,E=U.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:g,changelogUrl:E,publisherDisplayName:F.metadata?.publisherDisplayName,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!F.metadata?.hasPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned,isWorkspaceScoped:!1,source:F.metadata?.source??(F.identifier.uuid?"gallery":"vsix")}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const U=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),g=new Set;for(const z of U)F[i.$zp.create(z).toString()]||g.add(z.identifier.id.toLowerCase());try{const z=(0,i.$Ep)(U,M=>M.identifier);await O.Promises.settled(z.map(async M=>{const G=M.sort((W,te)=>p.rcompare(W.manifest.version,te.manifest.version))[0];g.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(z){this.u.error(z)}const E=U.filter(z=>z.metadata&&F[i.$zp.create(z).toString()]);await Promise.allSettled(E.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(U){(0,C.$jl)(U)!==1&&this.u.error(U);return}if(F?.children)try{await Promise.allSettled(F.children.map(async U=>{if(!(!U.isDirectory||!U.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",U.resource.toString());try{await this.m.del(U.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",U.resource.toString())}catch(g){(0,C.$jl)(g)!==1&&this.u.error(g)}}}))}catch{}}};e.$Jq=B,e.$Jq=B=$e([oe(1,C.$5k),oe(2,o.$xq),oe(3,s.$tq),oe(4,le.$Cl),oe(5,ne.$5j)],B);class T extends r.$rq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.$fg)(this.options.operation)?this.l:this.options.operation}constructor(F,U,g,E,z,M,G,W,te,ae){super(),this.manifest=F,this.identifier=U,this.source=g,this.options=E,this.m=z,this.n=M,this.o=G,this.p=W,this.q=te,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[U,g]=await this.w(F);if(this.j=U.isBuiltin||U.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j))try{await this.p.initializeDefaultProfileExtensions()}catch(E){throw(0,r.$qq)(E,"IntializeDefaultProfile")}try{await this.q.addExtensionsToProfile([[U,g]],this.j,!U.isValid)}catch(E){throw(0,r.$qq)(E,"AddToProfile")}return U}async u({zipPath:F,key:U,metadata:g},E,z){let M=await this.v(U);return M?M=await this.m.updateMetadata(M,g):(this.s.trace("Extracting extension...",U.id),M=await this.m.extractUserExtension(U,F,g,E,z),this.s.info("Extracting extension completed.",U.id)),M}async v(F){return(await this.m.getUninstalledExtensions())[F.toString()]?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(E=>i.$zp.create(E).equals(F))):void 0}}class H extends T{constructor(F,U,g,E,z,M,G,W,te,ae,he){super(F,U.identifier,U,g,z,M,G,W,te,ae),this.x=U,this.y=E,this.z=he}async w(F){const g=(await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$yp)(G.identifier,this.x.identifier));g&&(this.l=3);const E={id:this.x.identifier.uuid,publisherId:this.x.publisherId,publisherDisplayName:this.x.publisherDisplayName,targetPlatform:this.x.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||g?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||g?.isMachineScoped,isBuiltin:this.options.isBuiltin||g?.isBuiltin,isSystem:g?.type===0?!0:void 0,updated:!!g,isPreReleaseVersion:this.x.properties.isPreReleaseVersion,hasPreReleaseVersion:g?.hasPreReleaseVersion||this.x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??g?.pinned,preRelease:(0,R.$eg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.x.properties.isPreReleaseVersion||g?.preRelease,source:"gallery"};if(g&&g.type!==0&&g.manifest.version===this.x.version)return[await this.m.updateMetadata(g,E),E];const{verificationStatus:z,location:M}=await this.B(E,F);try{return this.k=z,await this.C(M.fsPath),[await this.u({zipPath:M.fsPath,key:i.$zp.create(this.x),metadata:E},!1,F),E]}catch(G){try{await this.y.delete(M)}catch(W){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,A.$0)(W))}throw G}}async B(F,U){try{return await this.y.download(this.x,this.l,!this.options.donotVerifySignature,this.options.context?.[t.$3o])}catch{this.s.info("Failed downloading. Retry again...",this.x.identifier.id);try{const E=await this.B(F,U);return this.z.publicLog2("extensiongallery:download:retry",{extensionId:this.x.identifier.id,succeeded:!0}),E}catch(E){throw this.z.publicLog2("extensiongallery:download:retry",{extensionId:this.x.identifier.id,succeeded:!1}),E}}}async C(F){try{await(0,k.$Eq)(F)}catch(U){throw(0,r.$qq)(U,"Invalid")}}}e.$Kq=H;class Q extends T{constructor(F,U,g,E,z,M,G,W,te,ae){super(F,{id:(0,i.$Dp)(F.publisher,F.name)},U,g,z,M,G,W,te,ae),this.x=U,this.y=E}async h(F){const U=await super.h(F);return this.B(U,F),U}async w(F){const U=new i.$zp(this.identifier,this.manifest.version),E=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,i.$yp)(this.identifier,G.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||E?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||E?.isMachineScoped,isBuiltin:this.options.isBuiltin||E?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??E?.pinned,source:"vsix"};if(E)if(this.l=3,U.equals(new i.$zp(E.identifier,E.manifest.version)))try{await this.m.removeExtension(E,"existing")}catch{throw new Error(m.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&p.gt(E.manifest.version,this.manifest.version)&&await this.m.setUninstalled(E);else{const G=await this.v(U);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(m.localize(7,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:b.$kc(this.x.fsPath),key:U,metadata:z},!0,F),z]}async B(F,U){try{let[g]=await this.y.getExtensions([{id:F.identifier.id,version:F.manifest.version}],U);if(g||([g]=await this.y.getExtensions([{id:F.identifier.id}],U)),g){const E={id:g.identifier.uuid,publisherDisplayName:g.publisherDisplayName,publisherId:g.publisherId,isPreReleaseVersion:g.properties.isPreReleaseVersion,hasPreReleaseVersion:F.hasPreReleaseVersion||g.properties.isPreReleaseVersion,preRelease:g.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,E,this.options.profileLocation)}}catch{}}}class Y extends r.$rq{constructor(F,U,g){super(),this.extension=F,this.j=U,this.k=g}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],re([0,1,6,24,23,22,42,13,18,11]),function(X,e,O,D,I,N,A,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;let u=class extends A.$uq{constructor(b,y,p,R,d,c){super(a.URI.file(b.extensionsPath),y,p,R,d,c)}};e.$aQ=u,e.$aQ=u=$e([oe(0,l.$Gi),oe(1,P.$5k),oe(2,D.$El),oe(3,I.$Cl),oe(4,N.$4l),oe(5,O.$5j)],u)}),define(se[164],re([0,1,11,18,42,53,13,10,6,32,23,24]),function(X,e,O,D,I,N,A,P,l,a,u,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let b=class extends N.$Bq{constructor(p,R,d,c,w,$,m,f){super(O.URI.file(w.builtinExtensionsPath),O.URI.file(w.extensionsPath),w.userHome,p.defaultProfile,p,R,d,c,w,$,m,f)}};e.$_dc=b,e.$_dc=b=$e([oe(0,v.$El),oe(1,I.$tq),oe(2,A.$5k),oe(3,l.$5j),oe(4,D.$Gi),oe(5,a.$lk),oe(6,u.$Cl),oe(7,P.$xi)],b)}),define(se[165],re([0,1,8,5,2,131,3,91,10,24]),function(X,e,O,D,I,N,A,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=y,e.$8p=R,e.$0p=c,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,l.$yi)("storageService");var u;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(u||(e.WillSaveStateReason=u={}));var v;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var b;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(b||(e.StorageTarget=b={}));function y(w){const $=w.get(e.$4p);if($)try{return JSON.parse($)}catch{}return Object.create(null)}class p extends I.$Uc{static{this.a=60*1e3}constructor($={flushInterval:p.a}){super(),this.m=$,this.b=this.B(new D.$ie),this.c=this.B(new D.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new O.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue($,m,f){return D.Event.filter(this.b.event,n=>n.scope===$&&(m===void 0||n.key===m),f)}n(){this.j.value=(0,O.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u($,m){const{key:f,external:n}=m;if(f===e.$4p){switch($){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:$})}else this.b.fire({scope:$,key:f,target:this.J($)[f],external:n})}w($){this.f.fire({reason:$})}get($,m,f){return this.P(m)?.get($,f)}getBoolean($,m,f){return this.P(m)?.getBoolean($,f)}getNumber($,m,f){return this.P(m)?.getNumber($,f)}getObject($,m,f){return this.P(m)?.getObject($,f)}storeAll($,m){this.y(()=>{for(const f of $)this.store(f.key,f.value,f.scope,f.target,m)})}store($,m,f,n,r=!1){if((0,A.$hg)(m)){this.remove($,f,r);return}this.y(()=>{this.z($,f,n),this.P(f)?.set($,m,r)})}remove($,m,f=!1){this.y(()=>{this.z($,m,void 0),this.P(m)?.delete($,f)})}y($){this.b.pause(),this.c.pause();try{$()}finally{this.b.resume(),this.c.resume()}}keys($,m){const f=[],n=this.J($);for(const r of Object.keys(n))n[r]===m&&f.push(r);return f}z($,m,f,n=!1){const r=this.J(m);typeof f=="number"?r[$]!==f&&(r[$]=f,this.P(m)?.set(e.$4p,JSON.stringify(r),n)):typeof r[$]=="number"&&(delete r[$],this.P(m)?.set(e.$4p,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J($){switch($){case-1:return this.I;case 0:return this.G;default:return this.D}}L($){const m=this.P($);return m?y(m):Object.create(null)}isNew($){return this.getBoolean(e.$3p,$)===!0}async flush($=u.NONE){this.f.fire({reason:$});const m=this.P(-1),f=this.P(0),n=this.P(1);switch($){case u.NONE:await O.Promises.settled([m?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case u.SHUTDOWN:await O.Promises.settled([m?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const $=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,f=this.P(1)?.items??new Map;return c($,m,f,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize($){return await this.flush(),this.P($)?.optimize()}async switch($,m){return this.w(u.NONE),(0,a.$Dl)($)?this.R($,m):this.S($,m)}M($,m){return!($.id===m.id||R(m)&&R($))}N($,m,f){this.y(()=>{const n=new Set;for(const[r,t]of $)n.add(r),m.get(r)!==t&&this.u(f,{key:r,external:!0});for(const[r]of m.items)n.has(r)||this.u(f,{key:r,external:!0})})}}e.$7p=p;function R(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class d extends p{constructor(){super(),this.U=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage($=>this.u(1,$))),this.B(this.W.onDidChangeStorage($=>this.u(0,$))),this.B(this.U.onDidChangeStorage($=>this.u(-1,$)))}P($){switch($){case-1:return this.U;case 0:return this.W;default:return this.X}}Q($){switch($){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope($){return!1}}e.$9p=d;async function c(w,$,m,f,n,r){const t=q=>{try{return JSON.parse(q)}catch{return q}},i=new Map,s=new Map;w.forEach((q,C)=>{i.set(C,q),s.set(C,t(q))});const o=new Map,h=new Map;$.forEach((q,C)=>{o.set(C,q),h.set(C,t(q))});const S=new Map,k=new Map;m.forEach((q,C)=>{S.set(C,q),k.set(C,t(q))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const j=[];if(i.forEach((q,C)=>{j.push({key:C,value:q})}),console.table(j),console.groupEnd(),console.log(s),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const q=[];o.forEach((C,J)=>{q.push({key:J,value:C})}),console.table(q),console.groupEnd(),console.log(h)}console.group(`Storage: Workspace (path: ${r})`);const L=[];S.forEach((q,C)=>{L.push({key:C,value:q})}),console.table(L),console.groupEnd(),console.log(k)}}),define(se[166],re([0,1,19,20,9,12,35,3,11,29,18,21,26,50,13,6,32,45,149,165,22,178]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$aq=Q;const n=N.$o?"web":(0,v.$6o)(N.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(E){E[E.None=0]="None",E[E.IncludeVersions=1]="IncludeVersions",E[E.IncludeFiles=2]="IncludeFiles",E[E.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",E[E.IncludeSharedAccounts=8]="IncludeSharedAccounts",E[E.IncludeVersionProperties=16]="IncludeVersionProperties",E[E.ExcludeNonValidated=32]="ExcludeNonValidated",E[E.IncludeInstallationTargets=64]="IncludeInstallationTargets",E[E.IncludeAssetUri=128]="IncludeAssetUri",E[E.IncludeStatistics=256]="IncludeStatistics",E[E.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",E[E.Unpublished=4096]="Unpublished",E[E.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function i(...E){return String(E.reduce((z,M)=>z|M,0))}var s;(function(E){E[E.Tag=1]="Tag",E[E.ExtensionId=4]="ExtensionId",E[E.Category=5]="Category",E[E.ExtensionName=7]="ExtensionName",E[E.Target=8]="Target",E[E.Featured=9]="Featured",E[E.SearchText=10]="SearchText",E[E.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},h={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class j{constructor(z=k){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,M=this.d.pageSize){return new j({...this.d,pageNumber:z,pageSize:M})}withFilter(z,...M){const G=[...this.d.criteria,...M.length?M.map(W=>({filterType:z,value:W})):[{filterType:z}]];return new j({...this.d,criteria:G})}withSortBy(z){return new j({...this.d,sortBy:z})}withSortOrder(z){return new j({...this.d,sortOrder:z})}withFlags(...z){return new j({...this.d,flags:z.reduce((M,G)=>M|G,0)})}withAssetTypes(...z){return new j({...this.d,assetTypes:z})}withSource(z){return new j({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te,flags:ae,assetTypes:he}=this.d;return{filters:[{criteria:z,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te}],assetTypes:he,flags:ae}}get searchText(){const z=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(E,z){const M=(E||[]).filter(G=>G.statisticName===z)[0];return M?M.value:0}function q(E){const z="Microsoft.VisualStudio.Code.Translation.";return E.files.filter(G=>G.assetType.indexOf(z)===0).reduce((G,W)=>{const te=ne(E,W.assetType);return te&&G.push([W.assetType.substring(z.length),te]),G},[])}function C(E){if(E.properties){const z=E.properties.filter(W=>W.key===o.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=z.filter(W=>M.test(W.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return ne(E,o.Repository)}function J(E){return{uri:`${E.fallbackAssetUri}/${o.VSIX}?redirect=true${E.targetPlatform?`&targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${o.VSIX}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}}function ne(E,z){return E.files.filter(G=>G.assetType===z)[0]?{uri:`${E.assetUri}/${z}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${z}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}:null}function ie(E,z){const M=E.properties?E.properties.filter(W=>W.key===z):[],G=M.length>0&&M[0].value;return G?G.split(",").map(W=>(0,b.$Cp)(W)):[]}function ue(E){const z=E.properties?E.properties.filter(M=>M.key===h.Engine):[];return z.length>0&&z[0].value||""}function le(E){const z=E.properties?E.properties.filter(M=>M.key===h.PreRelease):[];return z.length>0&&z[0].value==="true"}function ce(E){const z=E.properties?E.properties.filter(G=>G.key===h.LocalizedLanguages):[],M=z.length>0&&z[0].value||"";return M?M.split(","):[]}function V(E){return E.properties?.find(z=>z.key===h.SponsorLink)?.value}function Z(E){return E.properties?.find(z=>z.key===h.SupportLink)?.value}function B(E){return E.indexOf("preview")!==-1}function T(E){return E.targetPlatform?(0,v.$5o)(E.targetPlatform):"undefined"}function H(E){const z=(0,O.$Mb)(E.versions.map(T)),M=!!E.tags?.includes(v.$Yo),G=z.indexOf("web");return M?G===-1&&z.push("web"):G!==-1&&z.splice(G,1),z}function Q(E,z){for(let M=0;M<E.length;M++){const G=E[M];if(G.version===E[M-1]?.version){let W=M;if(T(G)===z)for(;W>0&&E[W-1].version===G.version;)W--;W!==M&&(E.splice(M,1),E.splice(W,0,G))}}return E}function Y(E,z,M){E.telemetryData={index:z,querySource:M,queryActivityId:E.queryContext?.[r]}}function _(E,z,M,G){const W=E.versions[0],te={manifest:ne(z,o.Manifest),readme:ne(z,o.Details),changelog:ne(z,o.Changelog),license:ne(z,o.License),repository:C(z),download:J(z),icon:ne(z,o.Icon),signature:ne(z,o.Signature),coreTranslations:q(z)};return{type:"gallery",identifier:{id:(0,b.$Dp)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},name:E.extensionName,version:z.version,displayName:E.displayName,publisherId:E.publisher.publisherId,publisher:E.publisher.publisherName,publisherDisplayName:E.publisher.displayName,publisherDomain:E.publisher.domain?{link:E.publisher.domain,verified:!!E.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(W),description:E.shortDescription??"",installCount:L(E.statistics,"install"),rating:L(E.statistics,"averagerating"),ratingCount:L(E.statistics,"ratingcount"),categories:E.categories||[],tags:E.tags||[],releaseDate:Date.parse(E.releaseDate),lastUpdated:Date.parse(E.lastUpdated),allTargetPlatforms:M,assets:te,properties:{dependencies:ie(z,h.Dependency),extensionPack:ie(z,h.ExtensionPack),engine:ue(z),localizedLanguages:ce(z),targetPlatform:T(z),isPreReleaseVersion:le(z)},hasPreReleaseVersion:le(W),hasReleaseVersion:!0,preview:B(E.flags),isSigned:!!te.signature,queryContext:G,supportLink:Z(W)}}let F=class{constructor(z,M,G,W,te,ae,he,pe){this.k=M,this.l=G,this.n=W,this.o=te,this.q=ae,this.u=he,this.w=pe;const ye=he.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,w.$_p)(he.version,he,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,M,G){const W=D.CancellationToken.isCancellationToken(M)?{}:M,te=D.CancellationToken.isCancellationToken(M)?M:G,ae=[],he=[],pe=[],ye=[];let fe=!0;for(const we of z){we.uuid?he.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!he.length&&!ae.length)return[];let me=new j().withPage(1,z.length);he.length&&(me=me.withFilter(s.ExtensionId,...he)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(W.queryAllVersions||fe)&&(me=me.withFlags(me.flags,t.IncludeVersions)),W.source&&(me=me.withSource(W.source));const{extensions:de}=await this.z(me,{targetPlatform:W.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!W.compatible,productVersion:W.productVersion??{version:this.u.version,date:this.u.date}},te);return W.source&&de.forEach((we,Ee)=>Y(we,Ee,W.source)),de}async getCompatibleExtension(z,M,G,W={version:this.u.version,date:this.u.date}){if((0,v.$7o)(z.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(z,M,G))return z;const te=new j().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:G,compatible:!0,includePreRelease:M,productVersion:W},D.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(z,M,G,W={version:this.u.version,date:this.u.date}){if(!(0,v.$8o)(z.properties.targetPlatform,z.allTargetPlatforms,G)||!M&&z.properties.isPreReleaseVersion)return!1;let te=z.properties.engine;if(!te){const ae=await this.getManifest(z,D.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,y.$Qp)(te,W.version,W.date)}async y(z,M,G,W,te,ae,he={version:this.u.version,date:this.u.date}){if(!(0,v.$8o)(T(M),te,ae)||G!=="any"&&le(M)!==(G==="prerelease"))return!1;if(W)try{const pe=await this.E(z,M);if(!(0,y.$Qp)(pe,he.version,he.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,I.$0)(pe)),!1}return!0}async query(z,M){let G=z.text||"";const W=z.pageSize??50;let te=new j().withPage(1,W);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(s.SearchText,G)),te=te.withSortBy(0)):z.ids?te=te.withFilter(s.ExtensionId,...z.ids):z.names?te=te.withFilter(s.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,Ie)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+Ie,z.source)),{extensions:de,total:we}},{extensions:he,total:pe}=await ae(te,M),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new I.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:he,total:pe,pageSize:te.pageSize,getPage:ye}}async z(z,M,G){const W=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),M.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:he}=await this.B(z,G);if(!(z.flags&t.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,M,he);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,b.$Dp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,P.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(x=>(0,b.$yp)(x,we))?.includePreRelease;if(M.compatible&&(0,v.$7o)(H(de),M.targetPlatform))continue;const Ie=await this.A(de,M,he);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==M.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,Ie])}if(fe.size){const me=new f.$be,de=new j().withFlags(W&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,M,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const Ie=fe.get(Ee.identifier.uuid);ye.push([Ie,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(z,M,G){const W={id:(0,b.$Dp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=M.versions?.find(ye=>(0,b.$yp)(ye,W))?.version,ae=(0,P.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ye=>(0,b.$yp)(ye,W))?.includePreRelease,he=H(z),pe=Q(z.versions,M.targetPlatform);if(M.compatible&&(0,v.$7o)(he,M.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,b.$Dp)(z.publisher.publisherName,z.extensionName),fe,ae?"any":"release",M.compatible,he,M.targetPlatform,M.productVersion))return _(z,fe,he,G);if(te&&fe.version===te)return null}}return te||M.compatible?null:_(z,z.versions[0],he)}async B(z,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,i(t.Unpublished));const G=await this.j,W=JSON.stringify(z.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},ae=new f.$be;let he,pe,ye=0;try{if(he=await this.k.request({type:"POST",url:this.g&&z.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:W,headers:te},M),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Xp)(he);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,I.$4)(fe)?"Cancelled":(0,I.$0)(fe).startsWith("XHR timeout")?"Timeout":"Failed";throw pe=new v.$$o((0,I.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(W.length),duration:ae.elapsed(),success:!!he&&(0,c.$Tp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(z,M,G,W){if(!this.isEnabled())return;const te=N.$o?this.x(`/itemName/${z}.${M}/version/${G}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${M}/${G}/stats?statType=${W}`),ae=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},D.CancellationToken.None)}catch{}}async download(z,M,G){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const W=(0,b.$Gp)(z),te=new Date().getTime(),ae=G===2?"install":G===3?"update":"",he=ae?{uri:`${z.assets.download.uri}${l.URI.parse(z.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${z.assets.download.fallbackUri}${l.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:z.assets.download,pe=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,ye=await this.D(z.identifier.id,he,o.VSIX,pe?{headers:pe}:void 0);try{await this.q.writeFile(M,ye.stream)}catch(fe){try{await this.q.del(M)}catch(me){this.l.warn(`Error while deleting the file ${M.toString()}`,(0,I.$0)(me))}throw new v.$$o((0,I.$0)(fe),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...W,duration:new Date().getTime()-te})}async downloadSignatureArchive(z,M){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const G=await this.D(z.identifier.id,z.assets.signature,o.Signature);try{await this.q.writeFile(M,G.stream)}catch(W){try{await this.q.del(M)}catch(te){this.l.warn(`Error while deleting the file ${M.toString()}`,(0,I.$0)(te))}throw new v.$$o((0,I.$0)(W),"DownloadFailedWriting")}}async getReadme(z,M){if(z.assets.readme){const G=await this.D(z.identifier.id,z.assets.readme,o.Details,{},M);return await(0,c.$Wp)(G)||""}return""}async getManifest(z,M){if(z.assets.manifest){const G=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},M),W=await(0,c.$Wp)(G);return W?JSON.parse(W):null}return null}async C(z,M,G){const W=ne(M,o.Manifest);if(!W)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(z,W,o.Manifest,{headers:te});return await(0,c.$Xp)(ae)}async getCoreTranslation(z,M){const G=z.assets.coreTranslations.filter(W=>W[0]===M.toUpperCase())[0];if(G){const W=await this.D(z.identifier.id,G[1],G[0]),te=await(0,c.$Wp)(W);return te?JSON.parse(te):null}return null}async getChangelog(z,M){if(z.assets.changelog){const G=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},M);return await(0,c.$Wp)(G)||""}return""}async getAllCompatibleVersions(z,M,G){let W=new j().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?W=W.withFilter(s.ExtensionId,z.identifier.uuid):W=W.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(W,D.CancellationToken.None);if(!te.length)return[];const ae=H(te[0]);if((0,v.$7o)(ae,G))return[];const he=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,M?"any":"release",!0,ae,G)&&he.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Q(he,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:le(fe)}));return pe}async D(z,M,G,W={},te=D.CancellationToken.None){const ae=await this.j,he={type:"GET"},pe={...ae,...W.headers||{}};W={...W,...he,headers:pe};const ye=M.uri,fe=M.fallbackUri,me={...W,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,c.$Wp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,I.$4)(de))throw de;const we=(0,I.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:G,message:we});const Ee={...W,url:fe};return this.k.request(Ee,te)}}async E(z,M){let G=ue(M);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:M.version});const W=await this.C(z,M,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");G=W.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.$Xp)(z),G=[],W={},te=[];if(M){for(const ae of M.malicious)G.push({id:ae});if(M.migrateToPreRelease)for(const[ae,he]of Object.entries(M.migrateToPreRelease))(!he.engine||(0,y.$Qp)(he.engine,this.u.version,this.u.date))&&(W[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ae,he]of Object.entries(M.deprecated))he&&(W[ae.toLowerCase()]=(0,P.$eg)(he)?{}:he);if(M.search)for(const ae of M.search)te.push(ae)}return{malicious:G,deprecated:W,search:te}}};F=$e([oe(1,c.$Rp),oe(2,R.$5j),oe(3,u.$Fi),oe(4,m.$4l),oe(5,p.$5k),oe(6,d.$lk),oe(7,a.$5i)],F);let U=class extends F{constructor(z,M,G,W,te,ae,he,pe){super(z,M,G,W,te,ae,he,pe)}};e.$bq=U,e.$bq=U=$e([oe(0,$.$5p),oe(1,c.$Rp),oe(2,R.$5j),oe(3,u.$Fi),oe(4,m.$4l),oe(5,p.$5k),oe(6,d.$lk),oe(7,a.$5i)],U);let g=class extends F{constructor(z,M,G,W,te,ae,he){super(void 0,z,M,G,W,te,ae,he)}};e.$cq=g,e.$cq=g=$e([oe(0,c.$Rp),oe(1,R.$5j),oe(2,u.$Fi),oe(3,m.$4l),oe(4,p.$5k),oe(5,d.$lk),oe(6,a.$5i)],g)}),define(se[167],re([0,1,11,18,13,6,146,23,24,3,69]),function(X,e,O,D,I,N,A,P,l,a,u){"use strict";var v,b;Object.defineProperty(e,"__esModule",{value:!0}),e.$_P=e.$$P=e.$0P=void 0;let y=class extends l.$Hl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,w,$,m,f){super($,m,w,f),this.U=c,this.W=$}O(){return this.U.getItem(v.b,[]).map(w=>({...w,location:(0,a.$$f)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):O.URI.revive(w.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(O.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$0P=y,e.$0P=y=v=$e([oe(0,A.$5P),oe(1,P.$Cl),oe(2,D.$Gi),oe(3,I.$5k),oe(4,N.$5j)],y);let p=b=class extends y{constructor(c,w,$,m,f){super(c,w,$,m,f),this.$=c}P(c){c.length?this.$.setItem(b.b,c.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(b.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(b.c,c):this.$.removeItem(b.c)}Q(){const c="workspaceAndProfileInfo",w=this.$.getItem(c,void 0);if(w){this.$.removeItem(c);const m=w.reduce((f,{workspace:n,profile:r})=>(f[O.URI.revive(n).toString()]=O.URI.revive(r).toString(),f),{});this.$.setItem(b.c,{workspaces:m})}const $=super.Q();return this.$.getItem(b.a,!1)||(this.R($),this.$.setItem(b.a,!0)),$}};e.$$P=p,e.$$P=p=b=$e([oe(0,A.$6P),oe(1,P.$Cl),oe(2,D.$Gi),oe(3,I.$5k),oe(4,N.$5j)],p);let R=class extends p{constructor(c,w,$,m){super(new u.$9P(0,w,m,$),c,w,$,m)}async init(){return await this.$.init(),super.init()}};e.$_P=R,e.$_P=R=$e([oe(0,P.$Cl),oe(1,D.$Gi),oe(2,I.$5k),oe(3,N.$5j)],R)}),define(se[168],re([0,1,144,8,14,9,3,29,18,145,6,45,143,179]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0,e.$3r=d;let p=class extends v.$Sp{constructor(w,$,m,f){super(f),this.m=w,this.n=$,this.r=m,this.s(),this.B(w.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,$){const{f:m,g:f}=this;let n;try{n=await(0,a.$Im)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(i)))}const r={...process.env,...n},t=w.agent?w.agent:await(0,b.$1r)(w.url||"",r,{proxyUrl:m,strictSSL:f});return w.agent=t,w.strictSSL=f,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>d(w,$))}async resolveProxy(w){}async loadCertificates(){return(await new Promise(($,m)=>{X(["@vscode/proxy-agent"],$,m)})).loadSystemCertificates({log:this.r})}};e.$2r=p,e.$2r=p=$e([oe(0,P.$5i),oe(1,l.$Gi),oe(2,u.$5j),oe(3,u.$6j)],p);async function R(c){return((0,O.parse)(c.url).protocol==="https:"?await new Promise((m,f)=>{X(["https"],m,f)}):await new Promise((m,f)=>{X(["http"],m,f)})).request}async function d(c,w){return D.Promises.withAsyncBody(async($,m)=>{const f=(0,O.parse)(c.url),n=c.getRawRequest?c.getRawRequest(c):await R(c),r={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,A.$eg)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const t=n(r,i=>{const s=(0,A.$cg)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&s>0&&i.headers.location)d({...c,url:i.headers.location,followRedirects:s-1},w).then($,m);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,y.createGunzip)())),$({res:i,stream:(0,I.$We)(o)})}});t.on("error",m),c.timeout&&t.setTimeout(c.timeout),c.isChromiumNetwork&&t.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&t.write(c.data),t.end(),w.onCancellationRequested(()=>{t.abort(),m(new N.$5)})})}}),define(se[180],re([0,1,33,8,34,9,2,15,16,12,35,11,25,29,140,61,142,18,117,166,21,71,147,42,53,162,164,13,130,132,51,128,64,65,150,6,136,39,137,153,32,45,168,69,70,22,152,41,154,155,23,157,24,167,156,163,133,135,4,158,181]),function(X,e,O,D,I,N,A,P,l,a,u,v,b,y,p,R,d,c,w,$,m,f,n,r,t,i,s,o,h,S,k,j,L,q,C,J,ne,ie,ue,le,ce,V,Z,B,T,H,Q,Y,_,F,U,g,E,z,M,G,W,te,ae,he,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends A.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const Ie=Ee.get(J.$5j),x=Ee.get(o.$5k),K=Ee.get(c.$Gi),ee=Ee.get(E.$El);Ie.info("CLI main",this.b),this.h(Ie),await this.j(K,x,ee,de),await Promise.all(we.map(ge=>{(0,D.$ph)(ge.flush(),1e3)}))})}async f(){const de=new L.$wi,we={_serviceBrand:void 0,...le.default};de.set(ce.$lk,we);const Ee=new w.$$m(this.b,we);de.set(c.$Gi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:P.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(be=>be?b.Promises.mkdir(be,{recursive:!0}):void 0));const Ie=new te.$4P((0,J.$gk)(Ee),Ee.logsHome);de.set(J.$6j,Ie);const x=this.B(Ie.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];Ie.getLogLevel()===J.LogLevel.Trace&&K.push(new J.$ak(Ie.getLogLevel()));const ee=this.B(new W.$bQ(x,K));de.set(J.$5j,ee);const ge=this.B(new h.$Mq(ee));de.set(o.$5k,ge);const ve=this.B(new S.$dr(ee));ge.registerProvider(P.Schemas.file,ve);const Oe=new g.$Es(ge);de.set(U.$Cl,Oe);const Se=new B.$8P(1,Ee,ee,ge),Le=new z.$0P(Se,Oe,Ee,ge,ee);de.set(E.$El,Le),ge.registerProvider(P.Schemas.vscodeUserData,new he.$Aec(P.Schemas.file,ve,P.Schemas.vscodeUserData,Le,Oe,ee));const je=a.$i&&we.win32RegValueName?this.B(new ue.$yec(ee,we.win32RegValueName)):Ee.policyFile?this.B(new ne.$zec(Ee.policyFile,ge,ee)):new ie.$jo;de.set(ie.$ho,je);const Ae=this.B(new p.$Jo(Le.defaultProfile.settingsResource,ge,je,ee));de.set(y.$5i,Ae),await Promise.all([Se.init(),Ae.initialize()]);let qe;try{qe=await(0,M.$cec)(Se,ee)}catch(be){be.code!=="ENOENT"&&ee.error(be)}const De=await(0,M.$dec)(Se,ee);Le.init(),de.set(U.$Cl,new g.$Es(ge));const Ne=new Z.$2r(Ae,Ee,ee,Ie);de.set(V.$Rp,Ne),de.set(R.$No,new k.$vi(d.$qQ,void 0,!0)),de.set(r.$tq,new k.$vi(G.$aQ,void 0,!0)),de.set(t.$xq,new k.$vi(s.$_dc,void 0,!0)),de.set(f.$dq,new k.$vi(f.$fq,void 0,!0)),de.set(i.$Hq,new k.$vi(i.$Iq,void 0,!0)),de.set(m.$0o,new k.$vi($.$cq,void 0,!0)),de.set(q.$Vr,new k.$vi(C.$Xr,void 0,!1));const ze=[],Fe=(0,Y.$vp)(we,Ae);if((0,Y.$qp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$2P(Ne,Fe,"monacoworkbench",null,we.aiConfig.ariaKey));const be={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,T.$hp)((0,O.release)(),(0,O.hostname)(),process.arch,we.commit,we.version,qe,De,Fe),piiPaths:(0,Y.$wp)(Ee)};de.set(H.$4l,new k.$vi(Q.$4r,[be],!1))}else de.set(H.$4l,Y.$lp);return[new j.$gr(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,N.setUnexpectedErrorHandler)(we=>{const Ee=(0,I.$jj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,N.$Z)(we)||(0,N.$1)(we)}),process.on("unhandledRejection",we=>(0,N.$1)(we))}async j(de,we,Ee,Ie){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$Yec)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?v.URI.file((0,l.$ic)(we)?we:(0,l.$jc)((0,u.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bbc4ba1eff648ee542972589216f211b7a6a08f2/core/vs/code/node/cliProcessMain.js.map
