/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ae=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/base/common/uri","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/platform/files/common/files","vs/base/common/types","vs/base/common/path","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/desktopEnvironmentInfo","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/osDisplayProtocolInfo","fs/promises","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","readline","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ce=function(ne){for(var e=[],D=0,N=ne.length;D<N;D++)e[D]=ae[ne[D]];return e};define(ae[125],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class D{static get(){const L=new Map,A=new Map,O=new Map,I=new Map;function P(l,c){l.has(c.detail)||l.set(c.detail,-c.timestamp)}function d(l,c){const b=l.get(c.detail);b&&(b>=0||l.set(c.detail,b+c.timestamp))}let E=[];typeof ne=="function"&&typeof ne.getStats=="function"&&(E=ne.getStats().slice(0).sort((l,c)=>l.timestamp-c.timestamp));for(const l of E)switch(l.type){case 10:P(L,l);break;case 11:case 12:d(L,l);break;case 21:P(A,l);break;case 22:d(A,l);break;case 33:P(O,l);break;case 34:d(O,l);break;case 31:P(I,l);break;case 32:d(I,l);break}let y=0;O.forEach(l=>y+=l);function p(l){const c=[];return l.forEach((b,m)=>c.push([m,b])),c}return{amdLoad:p(L),amdInvoke:p(A),nodeRequire:p(O),nodeEval:p(I),nodeRequireTotal:y}}static toMarkdownTable(L,A){let O="";const I=[];return L.forEach((P,d)=>{I[d]=P.length}),A.forEach(P=>{P.forEach((d,E)=>{typeof d>"u"&&(d=P[E]="-");const y=d.toString().length;I[E]=Math.max(y,I[E])})}),L.forEach((P,d)=>{O+=`| ${P+" ".repeat(I[d]-P.toString().length)} `}),O+=`|
`,L.forEach((P,d)=>{O+=`| ${"-".repeat(I[d])} `}),O+=`|
`,A.forEach(P=>{P.forEach((d,E)=>{typeof d<"u"&&(O+=`| ${d+" ".repeat(I[E]-d.toString().length)} `)}),O+=`|
`}),O}}e.$U=D}),define(ae[126],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=D,e.$gb=N,e.$hb=L,e.$ib=A,e.$jb=O,e.$kb=I,e.$lb=P,e.$nb=E,e.$ob=y,e.$pb=p,e.$qb=l,e.$rb=c;function D(b,m){const f=N(b,m);if(f!==-1)return b[f]}function N(b,m,f=b.length-1){for(let u=f;u>=0;u--){const h=b[u];if(m(h))return u}return-1}function L(b,m){const f=A(b,m);return f===-1?void 0:b[f]}function A(b,m,f=0,u=b.length){let h=f,g=u;for(;h<g;){const $=Math.floor((h+g)/2);m(b[$])?h=$+1:g=$}return h-1}function O(b,m){const f=I(b,m);return f===b.length?void 0:b[f]}function I(b,m,f=0,u=b.length){let h=f,g=u;for(;h<g;){const $=Math.floor((h+g)/2);m(b[$])?g=$:h=$+1}return h}function P(b,m,f=0,u=b.length){const h=I(b,m,f,u);return h===b.length?-1:h}class d{static{this.assertInvariants=!1}constructor(m){this.e=m,this.c=0}findLastMonotonous(m){if(d.assertInvariants){if(this.d){for(const u of this.e)if(this.d(u)&&!m(u))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=m}const f=A(this.e,m,this.c);return this.c=f+1,f===-1?void 0:this.e[f]}}e.$mb=d;function E(b,m){if(b.length===0)return;let f=b[0];for(let u=1;u<b.length;u++){const h=b[u];m(h,f)>0&&(f=h)}return f}function y(b,m){if(b.length===0)return;let f=b[0];for(let u=1;u<b.length;u++){const h=b[u];m(h,f)>=0&&(f=h)}return f}function p(b,m){return E(b,(f,u)=>-m(f,u))}function l(b,m){if(b.length===0)return-1;let f=0;for(let u=1;u<b.length;u++){const h=b[u];m(h,b[f])>0&&(f=u)}return f}function c(b,m){for(const f of b){const u=m(f);if(u!==void 0)return u}}}),define(ae[127],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=D,e.$L=N,e.$M=L,e.$N=A;function D(O,I){const P=Object.create(null);for(const d of O){const E=I(d);let y=P[E];y||(y=P[E]=[]),y.push(d)}return P}function N(O,I){const P=[],d=[];for(const E of O)I.has(E)||P.push(E);for(const E of I)O.has(E)||d.push(E);return{removed:P,added:d}}function L(O,I){const P=[],d=[];for(const[E,y]of O)I.has(E)||P.push(y);for(const[E,y]of I)O.has(E)||d.push(y);return{removed:P,added:d}}function A(O,I){const P=new Set;for(const d of I)O.has(d)&&P.add(d);return P}}),define(ae[84],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=N,e.$4h=L,e.$5h=A;function D(O){return(I,P,d)=>{let E=null,y=null;if(typeof d.value=="function"?(E="value",y=d.value):typeof d.get=="function"&&(E="get",y=d.get),!y)throw new Error("not supported");d[E]=O(y,P)}}function N(O,I,P){let d=null,E=null;if(typeof P.value=="function"?(d="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(d="get",E=P.get),!E)throw new Error("not supported");const y=`$memoize$${I}`;P[d]=function(...p){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,p)}),this[y]}}function L(O,I,P){return D((d,E)=>{const y=`$debounce$${E}`,p=`$debounce$result$${E}`;return function(...l){this[p]||(this[p]=P?P():void 0),clearTimeout(this[y]),I&&(this[p]=I(this[p],...l),l=[this[p]]),this[y]=setTimeout(()=>{d.apply(this,l),this[p]=P?P():void 0},O)}})}function A(O,I,P){return D((d,E)=>{const y=`$throttle$timer$${E}`,p=`$throttle$result$${E}`,l=`$throttle$lastRun$${E}`,c=`$throttle$pending$${E}`;return function(...b){if(this[p]||(this[p]=P?P():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),I&&(this[p]=I(this[p],...b)),this[c])return;const m=this[l]+O;m<=Date.now()?(this[l]=Date.now(),d.apply(this,[this[p]]),this[p]=P?P():void 0):(this[c]=!0,this[y]=setTimeout(()=>{this[c]=!1,this[l]=Date.now(),d.apply(this,[this[p]]),this[p]=P?P():void 0},m-Date.now()))}})}}),define(ae[7],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=N,e.$Z=L,e.$1=A,e.$2=O,e.$3=I,e.$4=d,e.$6=y,e.$7=p,e.$8=l,e.$0=b;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=D,e.$X=new D;function N($){e.$X.setUnexpectedErrorHandler($)}function L($){if(!$||typeof $!="object")return!1;const t=$;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function A($){d($)||e.$X.onUnexpectedError($)}function O($){d($)||e.$X.onUnexpectedExternalError($)}function I($){if($ instanceof Error){const{name:t,message:r}=$,n=$.stacktrace||$.stack;return{$isError:!0,name:t,message:r,stack:n,noTelemetry:h.isErrorNoTelemetry($)}}return $}const P="Canceled";function d($){return $ instanceof E?!0:$ instanceof Error&&$.name===P&&$.message===P}class E extends Error{constructor(){super(P),this.name=this.message}}e.$5=E;function y(){const $=new Error(P);return $.name=$.message,$}function p($){return $?new Error(`Illegal argument: ${$}`):new Error("Illegal argument")}function l($){return $?new Error(`Illegal state: ${$}`):new Error("Illegal state")}class c extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=c;function b($){return $?$.message?$.message:$.stack?$.stack.split(`
`)[0]:String($):"Error"}class m extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=m;class f extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=f;class u extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=u;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const r=new h;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class g extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype)}}e.$cb=g}),define(ae[17],ce([0,1,7,126]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$9b=e.$8b=e.CompareResult=void 0,e.$sb=L,e.$tb=A,e.$ub=O,e.$vb=I,e.$wb=P,e.$xb=d,e.$yb=E,e.$zb=y,e.$Ab=p,e.$Bb=l,e.$Cb=c,e.$Db=b,e.$Eb=m,e.top=f,e.$Gb=u,e.$Hb=g,e.$Ib=$,e.$Jb=t,e.$Kb=r,e.$Lb=n,e.$Mb=s,e.$Nb=i,e.$Ob=o,e.$Pb=a,e.$Qb=w,e.$Rb=S,e.$Sb=v,e.$Tb=k,e.$Ub=C,e.$Vb=R,e.$Wb=M,e.$Xb=T,e.$Yb=q,e.$Zb=Y,e.$1b=K,e.$2b=Z,e.$3b=G,e.$4b=J,e.$5b=V,e.$6b=se,e.$7b=he,e.$0b=z;function L(U,Q=0){return U[U.length-(1+Q)]}function A(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}function O(U,Q,x=(te,_)=>te===_){if(U===Q)return!0;if(!U||!Q||U.length!==Q.length)return!1;for(let te=0,_=U.length;te<_;te++)if(!x(U[te],Q[te]))return!1;return!0}function I(U,Q){const x=U.length-1;Q<x&&(U[Q]=U[x]),U.pop()}function P(U,Q,x){return d(U.length,te=>x(U[te],Q))}function d(U,Q){let x=0,te=U-1;for(;x<=te;){const _=(x+te)/2|0,oe=Q(_);if(oe<0)x=_+1;else if(oe>0)te=_-1;else return _}return-(x+1)}function E(U,Q,x){if(U=U|0,U>=Q.length)throw new TypeError("invalid index");const te=Q[Math.floor(Q.length*Math.random())],_=[],oe=[],ue=[];for(const $e of Q){const de=x($e,te);de<0?_.push($e):de>0?oe.push($e):ue.push($e)}return U<_.length?E(U,_,x):U<_.length+ue.length?ue[0]:E(U-(_.length+ue.length),oe,x)}function y(U,Q){const x=[];let te;for(const _ of U.slice(0).sort(Q))!te||Q(te[0],_)!==0?(te=[_],x.push(te)):te.push(_);return x}function*p(U,Q){let x,te;for(const _ of U)te!==void 0&&Q(te,_)?x.push(_):(x&&(yield x),x=[_]),te=_;x&&(yield x)}function l(U,Q){for(let x=0;x<=U.length;x++)Q(x===0?void 0:U[x-1],x===U.length?void 0:U[x])}function c(U,Q){for(let x=0;x<U.length;x++)Q(x===0?void 0:U[x-1],U[x],x+1===U.length?void 0:U[x+1])}function b(U,Q,x){const te=[];function _($e,de,ge){if(de===0&&ge.length===0)return;const be=te[te.length-1];be&&be.start+be.deleteCount===$e?(be.deleteCount+=de,be.toInsert.push(...ge)):te.push({start:$e,deleteCount:de,toInsert:ge})}let oe=0,ue=0;for(;;){if(oe===U.length){_(oe,0,Q.slice(ue));break}if(ue===Q.length){_(oe,U.length-oe,[]);break}const $e=U[oe],de=Q[ue],ge=x($e,de);ge===0?(oe+=1,ue+=1):ge<0?(_(oe,1,[]),oe+=1):ge>0&&(_(oe,0,[de]),ue+=1)}return te}function m(U,Q,x){const te=b(U,Q,x),_=[],oe=[];for(const ue of te)_.push(...U.slice(ue.start,ue.start+ue.deleteCount)),oe.push(...ue.toInsert);return{removed:_,added:oe}}function f(U,Q,x){if(x===0)return[];const te=U.slice(0,x).sort(Q);return h(U,Q,te,x,U.length),te}function u(U,Q,x,te,_){return x===0?Promise.resolve([]):new Promise((oe,ue)=>{(async()=>{const $e=U.length,de=U.slice(0,x).sort(Q);for(let ge=x,be=Math.min(x+te,$e);ge<$e;ge=be,be=Math.min(be+te,$e)){if(ge>x&&await new Promise(Ee=>setTimeout(Ee)),_&&_.isCancellationRequested)throw new D.$5;h(U,Q,de,ge,be)}return de})().then(oe,ue)})}function h(U,Q,x,te,_){for(const oe=x.length;te<_;te++){const ue=U[te];if(Q(ue,x[oe-1])<0){x.pop();const $e=(0,N.$kb)(x,de=>Q(ue,de)<0);x.splice($e,0,ue)}}}function g(U){return U.filter(Q=>!!Q)}function $(U){let Q=0;for(let x=0;x<U.length;x++)U[x]&&(U[Q]=U[x],Q+=1);U.length=Q}function t(U,Q,x){U.splice(x,0,U.splice(Q,1)[0])}function r(U){return!Array.isArray(U)||U.length===0}function n(U){return Array.isArray(U)&&U.length>0}function s(U,Q=x=>x){const x=new Set;return U.filter(te=>{const _=Q(te);return x.has(_)?!1:(x.add(_),!0)})}function i(U){const Q=new Set;return x=>{const te=U(x);return Q.has(te)?!1:(Q.add(te),!0)}}function o(U,Q){return U.length>0?U[0]:Q}function a(U,Q){return U.length>0?U[U.length-1]:Q}function w(U,Q,x=(te,_)=>te===_){let te=0;for(let _=0,oe=Math.min(U.length,Q.length);_<oe&&x(U[_],Q[_]);_++)te++;return te}function S(U,Q){let x=typeof Q=="number"?U:0;typeof Q=="number"?x=U:(x=0,Q=U);const te=[];if(x<=Q)for(let _=x;_<Q;_++)te.push(_);else for(let _=x;_>Q;_--)te.push(_);return te}function v(U,Q,x){return U.reduce((te,_)=>(te[Q(_)]=x?x(_):_,te),Object.create(null))}function k(U,Q){return U.push(Q),()=>C(U,Q)}function C(U,Q){const x=U.indexOf(Q);if(x>-1)return U.splice(x,1),Q}function R(U,Q,x){const te=U.slice(0,Q),_=U.slice(Q);return te.concat(x,_)}function M(U,Q){let x;if(typeof Q=="number"){let te=Q;x=()=>{const _=Math.sin(te++)*179426549;return _-Math.floor(_)}}else x=Math.random;for(let te=U.length-1;te>0;te-=1){const _=Math.floor(x()*(te+1)),oe=U[te];U[te]=U[_],U[_]=oe}}function T(U,Q){const x=U.indexOf(Q);x>-1&&(U.splice(x,1),U.unshift(Q))}function q(U,Q){const x=U.indexOf(Q);x>-1&&(U.splice(x,1),U.push(Q))}function Y(U,Q){for(const x of Q)U.push(x)}function K(U,Q){return Array.isArray(U)?U.map(Q):Q(U)}function Z(U){return Array.isArray(U)?U:[U]}function G(U){return U[Math.floor(Math.random()*U.length)]}function J(U,Q,x){const te=H(U,Q),_=U.length,oe=x.length;U.length=_+oe;for(let ue=_-1;ue>=te;ue--)U[ue+oe]=U[ue];for(let ue=0;ue<oe;ue++)U[ue+te]=x[ue]}function V(U,Q,x,te){const _=H(U,Q);let oe=U.splice(_,x);return oe===void 0&&(oe=[]),J(U,_,te),oe}function H(U,Q){return Q<0?Math.max(Q+U.length,0):Math.min(Q,U.length)}var ie;(function(U){function Q(oe){return oe<0}U.isLessThan=Q;function x(oe){return oe<=0}U.isLessThanOrEqual=x;function te(oe){return oe>0}U.isGreaterThan=te;function _(oe){return oe===0}U.isNeitherLessOrGreaterThan=_,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function se(U,Q){return(x,te)=>Q(U(x),U(te))}function he(...U){return(Q,x)=>{for(const te of U){const _=te(Q,x);if(!ie.isNeitherLessOrGreaterThan(_))return _}return ie.neitherLessOrGreaterThan}}const ee=(U,Q)=>U-Q;e.$8b=ee;const W=(U,Q)=>(0,e.$8b)(U?1:0,Q?1:0);e.$9b=W;function z(U){return(Q,x)=>-U(Q,x)}class j{constructor(Q){this.g=Q,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(Q){let x=this.c;for(;x<this.g.length&&Q(this.g[x]);)x++;const te=x===this.c?null:this.g.slice(this.c,x);return this.c=x,te}takeFromEndWhile(Q){let x=this.d;for(;x>=0&&Q(this.g[x]);)x--;const te=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,te}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const Q=this.g[this.c];return this.c++,Q}removeLast(){const Q=this.g[this.d];return this.d--,Q}takeCount(Q){const x=this.g.slice(this.c,this.c+Q);return this.c+=Q,x}}e.$$b=j;class F{static{this.empty=new F(Q=>{})}constructor(Q){this.iterate=Q}forEach(Q){this.iterate(x=>(Q(x),!0))}toArray(){const Q=[];return this.iterate(x=>(Q.push(x),!0)),Q}filter(Q){return new F(x=>this.iterate(te=>Q(te)?x(te):!0))}map(Q){return new F(x=>this.iterate(te=>x(Q(te))))}some(Q){let x=!1;return this.iterate(te=>(x=Q(te),!x)),x}findFirst(Q){let x;return this.iterate(te=>Q(te)?(x=te,!1):!0),x}findLast(Q){let x;return this.iterate(te=>(Q(te)&&(x=te),!0)),x}findLastMaxBy(Q){let x,te=!0;return this.iterate(_=>((te||ie.isGreaterThan(Q(_,x)))&&(te=!1,x=_),!0)),x}}e.$_b=F;class B{constructor(Q){this.c=Q}static createSortPermutation(Q,x){const te=Array.from(Q.keys()).sort((_,oe)=>x(Q[_],Q[oe]));return new B(te)}apply(Q){return Q.map((x,te)=>Q[this.c[te]])}inverse(){const Q=this.c.slice();for(let x=0;x<this.c.length;x++)Q[this.c[x]]=x;return new B(Q)}}e.$ac=B}),define(ae[128],ce([0,1,7]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=N,e.$ed=L,e.$fd=A,e.$gd=O,e.$hd=I,e.$id=P;function N(d,E){if(!d)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}function L(d,E="Unreachable"){throw new Error(E)}function A(d,E="unexpected state"){if(!d)throw new D.$cb(`Assertion Failed: ${E}`)}function O(d){d||(0,D.$1)(new D.$cb("Soft Assertion Failed"))}function I(d){if(!d()){debugger;d(),(0,D.$1)(new D.$cb("Assertion Failed"))}}function P(d,E){let y=0;for(;y<d.length-1;){const p=d[y],l=d[y+1];if(!E(p,l))return!1;y++}return!0}}),define(ae[85],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=D;function D(N,L){const A=this;let O=!1,I;return function(){if(O)return I;if(O=!0,L)try{I=N.apply(A,arguments)}finally{L()}else I=N.apply(A,arguments);return I}}}),define(ae[61],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function L(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=L;const A=Object.freeze([]);function O(){return A}N.empty=O;function*I(t){yield t}N.single=I;function P(t){return L(t)?t:I(t)}N.wrap=P;function d(t){return t||A}N.from=d;function*E(t){for(let r=t.length-1;r>=0;r--)yield t[r]}N.reverse=E;function y(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=y;function p(t){return t[Symbol.iterator]().next().value}N.first=p;function l(t,r){for(const n of t)if(r(n))return!0;return!1}N.some=l;function c(t,r){for(const n of t)if(r(n))return n}N.find=c;function*b(t,r){for(const n of t)r(n)&&(yield n)}N.filter=b;function*m(t,r){let n=0;for(const s of t)yield r(s,n++)}N.map=m;function*f(...t){for(const r of t)yield*r}N.concat=f;function u(t,r,n){let s=n;for(const i of t)s=r(s,i);return s}N.reduce=u;function*h(t,r,n=t.length){for(r<0&&(r+=t.length),n<0?n+=t.length:n>t.length&&(n=t.length);r<n;r++)yield t[r]}N.slice=h;function g(t,r=Number.POSITIVE_INFINITY){const n=[];if(r===0)return[n,t];const s=t[Symbol.iterator]();for(let i=0;i<r;i++){const o=s.next();if(o.done)return[n,N.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}N.consume=g;async function $(t){const r=[];for await(const n of t)r.push(n);return Promise.resolve(r)}N.asyncToArray=$})(D||(e.Iterable=D={}))}),define(ae[35],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=O,e.$Kn=y,e.$Ln=p,e.$Mn=l,e.$Nn=c,e.$On=b,e.$Pn=m,e.$Qn=f,e.$Rn=u,e.$Sn=h,e.$Tn=g,e.$Un=$;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L||(e.ParseErrorCode=L={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function O(t,r=!1){let n=0;const s=t.length;let i="",o=0,a=16,w=0;function S(q){let Y=0,K=0;for(;Y<q;){const Z=t.charCodeAt(n);if(Z>=48&&Z<=57)K=K*16+Z-48;else if(Z>=65&&Z<=70)K=K*16+Z-65+10;else if(Z>=97&&Z<=102)K=K*16+Z-97+10;else break;n++,Y++}return Y<q&&(K=-1),K}function v(q){n=q,i="",o=0,a=16,w=0}function k(){const q=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&d(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&d(t.charCodeAt(n)))for(n++;n<t.length&&d(t.charCodeAt(n));)n++;else return w=3,t.substring(q,n);let Y=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&d(t.charCodeAt(n))){for(n++;n<t.length&&d(t.charCodeAt(n));)n++;Y=n}else w=3;return t.substring(q,Y)}function C(){let q="",Y=n;for(;;){if(n>=s){q+=t.substring(Y,n),w=2;break}const K=t.charCodeAt(n);if(K===34){q+=t.substring(Y,n),n++;break}if(K===92){if(q+=t.substring(Y,n),n++,n>=s){w=2;break}switch(t.charCodeAt(n++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const G=S(4);G>=0?q+=String.fromCharCode(G):w=4;break}default:w=5}Y=n;continue}if(K>=0&&K<=31)if(P(K)){q+=t.substring(Y,n),w=2;break}else w=6;n++}return q}function R(){if(i="",w=0,o=n,n>=s)return o=s,a=17;let q=t.charCodeAt(n);if(I(q)){do n++,i+=String.fromCharCode(q),q=t.charCodeAt(n);while(I(q));return a=15}if(P(q))return n++,i+=String.fromCharCode(q),q===13&&t.charCodeAt(n)===10&&(n++,i+=`
`),a=14;switch(q){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,i=C(),a=10;case 47:{const Y=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!P(t.charCodeAt(n));)n++;return i=t.substring(Y,n),a=12}if(t.charCodeAt(n+1)===42){n+=2;const K=s-1;let Z=!1;for(;n<K;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,Z=!0;break}n++}return Z||(n++,w=1),i=t.substring(Y,n),a=13}return i+=String.fromCharCode(q),n++,a=16}case 45:if(i+=String.fromCharCode(q),n++,n===s||!d(t.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return i+=k(),a=11;default:for(;n<s&&M(q);)n++,q=t.charCodeAt(n);if(o!==n){switch(i=t.substring(o,n),i){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return i+=String.fromCharCode(q),n++,a=16}}function M(q){if(I(q)||P(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=R();while(q>=12&&q<=15);return q}return{setPosition:v,getPosition:()=>n,scan:r?T:R,getToken:()=>a,getTokenValue:()=>i,getTokenOffset:()=>o,getTokenLength:()=>n-o,getTokenError:()=>w}}function I(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function P(t){return t===10||t===13||t===8232||t===8233}function d(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function y(t,r){const n=[],s=new Object;let i;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function w(S,v,k,C){o.value=S,o.offset=v,o.length=k,o.type=C,o.colonOffset=void 0,i=o}try{h(t,{onObjectBegin:(S,v)=>{if(r<=S)throw s;i=void 0,a=r>S,n.push("")},onObjectProperty:(S,v,k)=>{if(r<v||(w(S,v,k,"property"),n[n.length-1]=S,r<=v+k))throw s},onObjectEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onArrayBegin:(S,v)=>{if(r<=S)throw s;i=void 0,n.push(0)},onArrayEnd:(S,v)=>{if(r<=S)throw s;i=void 0,n.pop()},onLiteralValue:(S,v,k)=>{if(r<v||(w(S,v,k,$(S)),r<=v+k))throw s},onSeparator:(S,v,k)=>{if(r<=v)throw s;if(S===":"&&i&&i.type==="property")i.colonOffset=v,a=!1,i=void 0;else if(S===","){const C=n[n.length-1];typeof C=="number"?n[n.length-1]=C+1:(a=!0,n[n.length-1]=""),i=void 0}}})}catch(S){if(S!==s)throw S}return{path:n,previousNode:i,isAtPropertyKey:a,matches:S=>{let v=0;for(let k=0;v<S.length&&k<n.length;k++)if(S[v]===n[k]||S[v]==="*")v++;else if(S[v]!=="**")return!1;return v===S.length}}}function p(t,r=[],n=A.DEFAULT){let s=null,i=[];const o=[];function a(S){Array.isArray(i)?i.push(S):s!==null&&(i[s]=S)}return h(t,{onObjectBegin:()=>{const S={};a(S),o.push(i),i=S,s=null},onObjectProperty:S=>{s=S},onObjectEnd:()=>{i=o.pop()},onArrayBegin:()=>{const S=[];a(S),o.push(i),i=S,s=null},onArrayEnd:()=>{i=o.pop()},onLiteralValue:a,onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n),i[0]}function l(t,r=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function i(S){s.type==="property"&&(s.length=S-s.offset,s=s.parent)}function o(S){return s.children.push(S),S}h(t,{onObjectBegin:S=>{s=o({type:"object",offset:S,length:-1,parent:s,children:[]})},onObjectProperty:(S,v,k)=>{s=o({type:"property",offset:v,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:S,offset:v,length:k,parent:s})},onObjectEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onArrayBegin:(S,v)=>{s=o({type:"array",offset:S,length:-1,parent:s,children:[]})},onArrayEnd:(S,v)=>{s.length=S+v-s.offset,s=s.parent,i(S+v)},onLiteralValue:(S,v,k)=>{o({type:$(S),offset:v,length:k,parent:s,value:S}),i(v+k)},onSeparator:(S,v,k)=>{s.type==="property"&&(S===":"?s.colonOffset=v:S===","&&i(v))},onError:(S,v,k)=>{r.push({error:S,offset:v,length:k})}},n);const w=s.children[0];return w&&delete w.parent,w}function c(t,r){if(!t)return;let n=t;for(const s of r)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let i=!1;for(const o of n.children)if(Array.isArray(o.children)&&o.children[0].value===s){n=o.children[1],i=!0;break}if(!i)return}else{const i=s;if(n.type!=="array"||i<0||!Array.isArray(n.children)||i>=n.children.length)return;n=n.children[i]}return n}function b(t){if(!t.parent||!t.parent.children)return[];const r=b(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;r.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&r.push(n)}return r}function m(t){switch(t.type){case"array":return t.children.map(m);case"object":{const r=Object.create(null);for(const n of t.children){const s=n.children[1];s&&(r[n.children[0].value]=m(s))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function f(t,r,n=!1){return r>=t.offset&&r<t.offset+t.length||n&&r===t.offset+t.length}function u(t,r,n=!1){if(f(t,r,n)){const s=t.children;if(Array.isArray(s))for(let i=0;i<s.length&&s[i].offset<=r;i++){const o=u(s[i],r,n);if(o)return o}return t}}function h(t,r,n=A.DEFAULT){const s=O(t,!1);function i(he){return he?()=>he(s.getTokenOffset(),s.getTokenLength()):()=>!0}function o(he){return he?ee=>he(ee,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=i(r.onObjectBegin),w=o(r.onObjectProperty),S=i(r.onObjectEnd),v=i(r.onArrayBegin),k=i(r.onArrayEnd),C=o(r.onLiteralValue),R=o(r.onSeparator),M=i(r.onComment),T=o(r.onError),q=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function K(){for(;;){const he=s.scan();switch(s.getTokenError()){case 4:Z(14);break;case 5:Z(15);break;case 3:Z(13);break;case 1:q||Z(11);break;case 2:Z(12);break;case 6:Z(16);break}switch(he){case 12:case 13:q?Z(10):M();break;case 16:Z(1);break;case 15:case 14:break;default:return he}}}function Z(he,ee=[],W=[]){if(T(he),ee.length+W.length>0){let z=s.getToken();for(;z!==17;){if(ee.indexOf(z)!==-1){K();break}else if(W.indexOf(z)!==-1)break;z=K()}}}function G(he){const ee=s.getTokenValue();return he?C(ee):w(ee),K(),!0}function J(){switch(s.getToken()){case 11:{let he=0;try{he=JSON.parse(s.getTokenValue()),typeof he!="number"&&(Z(2),he=0)}catch{Z(2)}C(he);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return K(),!0}function V(){return s.getToken()!==10?(Z(3,[],[2,5]),!1):(G(!1),s.getToken()===6?(R(":"),K(),se()||Z(4,[],[2,5])):Z(5,[],[2,5]),!0)}function H(){a(),K();let he=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(he||Z(4,[],[]),R(","),K(),s.getToken()===2&&Y)break}else he&&Z(6,[],[]);V()||Z(4,[],[2,5]),he=!0}return S(),s.getToken()!==2?Z(7,[2],[]):K(),!0}function ie(){v(),K();let he=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(he||Z(4,[],[]),R(","),K(),s.getToken()===4&&Y)break}else he&&Z(6,[],[]);se()||Z(4,[],[4,5]),he=!0}return k(),s.getToken()!==4?Z(8,[4],[]):K(),!0}function se(){switch(s.getToken()){case 3:return ie();case 1:return H();case 10:return G(!0);default:return J()}}return K(),s.getToken()===17?n.allowEmptyContent?!0:(Z(4,[],[]),!1):se()?(s.getToken()!==17&&Z(9,[],[]),!0):(Z(4,[],[]),!1)}function g(t,r){const n=O(t),s=[];let i,o=0,a;do switch(a=n.getPosition(),i=n.scan(),i){case 12:case 13:case 17:o!==a&&s.push(t.substring(o,a)),r!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,r)),o=n.getPosition();break}while(i!==17);return s.join("")}function $(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ae[44],ce([0,1,35]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=N,e.$Wn=L,e.$Xn=I,e.$Yn=P;function N(d,E,y){let p,l,c,b,m;if(E){for(b=E.offset,m=b+E.length,c=b;c>0&&!P(d,c-1);)c--;let a=m;for(;a<d.length&&!P(d,a);)a++;l=d.substring(c,a),p=O(l,y)}else l=d,p=0,c=0,b=0,m=d.length;const f=I(y,d);let u=!1,h=0,g;y.insertSpaces?g=A(" ",y.tabSize||4):g="	";const $=(0,D.$Jn)(l,!1);let t=!1;function r(){return f+A(g,p+h)}function n(){let a=$.scan();for(u=!1;a===15||a===14;)u=u||a===14,a=$.scan();return t=a===16||$.getTokenError()!==0,a}const s=[];function i(a,w,S){!t&&w<m&&S>b&&d.substring(w,S)!==a&&s.push({offset:w,length:S-w,content:a})}let o=n();if(o!==17){const a=$.getTokenOffset()+c,w=A(g,p);i(w,c,a)}for(;o!==17;){let a=$.getTokenOffset()+$.getTokenLength()+c,w=n(),S="";for(;!u&&(w===12||w===13);){const k=$.getTokenOffset()+c;i(" ",a,k),a=$.getTokenOffset()+$.getTokenLength()+c,S=w===12?r():"",w=n()}if(w===2)o!==1&&(h--,S=r());else if(w===4)o!==3&&(h--,S=r());else{switch(o){case 3:case 1:h++,S=r();break;case 5:case 12:S=r();break;case 13:u?S=r():S=" ";break;case 6:S=" ";break;case 10:if(w===6){S="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?S=" ":w!==5&&w!==17&&(t=!0);break;case 16:t=!0;break}u&&(w===12||w===13)&&(S=r())}const v=$.getTokenOffset()+c;i(S,a,v),o=w}return s}function L(d,E){const y=JSON.stringify(d,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?y.replace(/\r\n|\r|\n/g,E.eol):y}function A(d,E){let y="";for(let p=0;p<E;p++)y+=d;return y}function O(d,E){let y=0,p=0;const l=E.tabSize||4;for(;y<d.length;){const c=d.charAt(y);if(c===" ")p++;else if(c==="	")p+=l;else break;y++}return Math.floor(p/l)}function I(d,E){for(let y=0;y<E.length;y++){const p=E.charAt(y);if(p==="\r")return y+1<E.length&&E.charAt(y+1)===`
`?`\r
`:"\r";if(p===`
`)return`
`}return d&&d.eol||`
`}function P(d,E){return`\r
`.indexOf(d.charAt(E))!==-1}}),define(ae[62],ce([0,1,35,44]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=L,e.$1n=A,e.$2n=O,e.$3n=I,e.$4n=P;function L(d,E,y){return A(d,E,void 0,y)}function A(d,E,y,p,l){const c=E.slice(),b=[],m=(0,D.$Mn)(d,b);let f,u;for(;c.length>0&&(u=c.pop(),f=(0,D.$Nn)(m,c),f===void 0&&y!==void 0);)typeof u=="string"?y={[u]:y}:y=[y];if(f)if(f.type==="object"&&typeof u=="string"&&Array.isArray(f.children)){const h=(0,D.$Nn)(f,[u]);if(h!==void 0)if(y===void 0){if(!h.parent)throw new Error("Malformed AST");const g=f.children.indexOf(h.parent);let $,t=h.parent.offset+h.parent.length;if(g>0){const r=f.children[g-1];$=r.offset+r.length}else $=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return O(d,{offset:$,length:t-$,content:""},p)}else return O(d,{offset:h.offset,length:h.length,content:JSON.stringify(y)},p);else{if(y===void 0)return[];const g=`${JSON.stringify(u)}: ${JSON.stringify(y)}`,$=l?l(f.children.map(r=>r.children[0].value)):f.children.length;let t;if($>0){const r=f.children[$-1];t={offset:r.offset+r.length,length:0,content:","+g}}else f.children.length===0?t={offset:f.offset+1,length:0,content:g}:t={offset:f.offset+1,length:0,content:g+","};return O(d,t,p)}}else if(f.type==="array"&&typeof u=="number"&&Array.isArray(f.children))if(y!==void 0){const h=`${JSON.stringify(y)}`;let g;if(f.children.length===0||u===0)g={offset:f.offset+1,length:0,content:f.children.length===0?h:h+","};else{const $=u===-1||u>f.children.length?f.children.length:u,t=f.children[$-1];g={offset:t.offset+t.length,length:0,content:","+h}}return O(d,g,p)}else{const h=u,g=f.children[h];let $;if(f.children.length===1)$={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===h){const t=f.children[h-1],r=t.offset+t.length,n=f.offset+f.length;$={offset:r,length:n-2-r,content:""}}else $={offset:g.offset,length:f.children[h+1].offset-g.offset,content:""};return O(d,$,p)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${f.type}`);else return y===void 0?[]:O(d,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(y)},p)}function O(d,E,y){let p=I(d,E),l=E.offset,c=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;l>0&&!(0,N.$Yn)(p,l-1);)l--;for(;c<p.length&&!(0,N.$Yn)(p,c);)c++}const b=(0,N.$Vn)(p,{offset:l,length:c-l},y);for(let f=b.length-1;f>=0;f--){const u=b[f];p=I(p,u),l=Math.min(l,u.offset),c=Math.max(c,u.offset+u.length),c+=u.content.length-u.length}const m=d.length-(p.length-c)-l;return[{offset:l,length:m,content:p.substring(l,c)}]}function I(d,E){return d.substring(0,E.offset)+E.content+d.substring(E.offset+E.length)}function P(d,E){const y=E.slice(0).sort((l,c)=>{const b=l.offset-c.offset;return b===0?l.length-c.length:b});let p=d.length;for(let l=y.length-1;l>=0;l--){const c=y[l];if(c.offset+c.length<=p)d=I(d,c);else throw new Error("Overlapping edit");p=c.offset}return d}}),define(ae[53],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class D{constructor(L){this.d=L,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(L){this.c=L}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=D}),define(ae[86],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(A){this.element=A,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let A=this.a;for(;A!==D.Undefined;){const O=A.next;A.prev=D.Undefined,A.next=D.Undefined,A=O}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,O){const I=new D(A);if(this.a===D.Undefined)this.a=I,this.b=I;else if(O){const d=this.b;this.b=I,I.prev=d,d.next=I}else{const d=this.a;this.a=I,I.next=d,d.prev=I}this.c+=1;let P=!1;return()=>{P||(P=!0,this.e(I))}}shift(){if(this.a!==D.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==D.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==D.Undefined&&A.next!==D.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===D.Undefined&&A.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):A.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):A.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==D.Undefined;)yield A.element,A=A.next}}e.$5c=N}),define(ae[34],ce([0,1]),function(ne,e){"use strict";var D,N,L;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=void 0,e.$xc=A,e.$yc=O,e.$zc=I,e.$Ic=g;function A($,t,r){let n=$.get(t);return n===void 0&&(n=r,$.set(t,n)),n}function O($){const t=[];return $.forEach((r,n)=>{t.push(`${n} => ${r}`)}),`Map(${$.size}) {${t.join(", ")}}`}function I($){const t=[];return $.forEach(r=>{t.push(r)}),`Set(${$.size}) {${t.join(", ")}}`}class P{constructor(t,r){this.uri=t,this.value=r}}function d($){return Array.isArray($)}class E{static{this.c=t=>t.toString()}constructor(t,r){if(this[D]="ResourceMap",t instanceof E)this.d=new Map(t.d),this.e=r??E.c;else if(d(t)){this.d=new Map,this.e=r??E.c;for(const[n,s]of t)this.set(n,s)}else this.d=new Map,this.e=t??E.c}set(t,r){return this.d.set(this.e(t),new P(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[n,s]of this.d)t(s.value,s.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Ac=E;class y{constructor(t,r){this[N]="ResourceSet",!t||typeof t=="function"?this.c=new E(t):(this.c=new E(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((n,s)=>t.call(r,s,s,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=y;var p;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class l{constructor(){this[L]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const n=this.c.get(t);if(n)return r!==0&&this.m(n,r),n.value}set(t,r,n=0){let s=this.c.get(t);if(s)s.value=r,n!==0&&this.m(s,n);else{switch(s={key:t,value:r,next:void 0,previous:void 0},n){case 0:this.k(s);break;case 1:this.j(s);break;case 2:this.k(s);break;default:this.k(s);break}this.c.set(t,s),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const n=this.g;let s=this.d;for(;s;){if(r?t.bind(r)(s.value,s.key,this):t(s.value,s.key,this),this.g!==n)throw new Error("LinkedMap got modified during iteration.");s=s.next}}keys(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.key,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}values(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:n.value,done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}entries(){const t=this,r=this.g;let n=this.d;const s={[Symbol.iterator](){return s},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(n){const i={value:[n.key,n.value],done:!1};return n=n.next,i}else return{value:void 0,done:!0}}};return s}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.next,n--;this.d=r,this.f=n,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,n=this.size;for(;r&&n>t;)this.c.delete(r.key),r=r.previous,n--;this.e=r,this.f=n,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,n=t.previous;if(!r||!n)throw new Error("Invalid list");r.previous=n,n.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const n=t.next,s=t.previous;t===this.e?(s.next=void 0,this.e=s):(n.previous=s,s.next=n),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const n=t.next,s=t.previous;t===this.d?(n.previous=void 0,this.d=n):(n.previous=s,s.next=n),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,n)=>{t.push([n,r])}),t}fromJSON(t){this.clear();for(const[r,n]of t)this.set(r,n)}}e.$Cc=l;class c extends l{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class b extends c{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Dc=b;class m extends c{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Ec=m;class f{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Fc=f;class u{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,n]of t)this.set(r,n)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((n,s)=>{t.call(r,n,s,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Gc=u;class h{constructor(){this.c=new Map}add(t,r){let n=this.c.get(t);n||(n=new Set,this.c.set(t,n)),n.add(r)}delete(t,r){const n=this.c.get(t);n&&(n.delete(r),n.size===0&&this.c.delete(t))}forEach(t,r){const n=this.c.get(t);n&&n.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Hc=h;function g($,t){if($===t)return!0;if($.size!==t.size)return!1;for(const[r,n]of $)if(!t.has(r)||t.get(r)!==n)return!1;for(const[r]of t)if(!$.has(r))return!1;return!0}}),define(ae[2],ce([0,1,17,127,34,85,61]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Jc=void 0,e.$Kc=E,e.$Lc=y,e.$Mc=p,e.$Nc=b,e.$Oc=m,e.$Pc=f,e.$Qc=u,e.$Rc=h,e.$Sc=g,e.$3c=S;const I=!1;let P=null;class d{constructor(){this.b=new Map}static{this.a=0}c(C){let R=this.b.get(C);return R||(R={parent:null,source:null,isSingleton:!1,value:C,idx:d.a++},this.b.set(C,R)),R}trackDisposable(C){const R=this.c(C);R.source||(R.source=new Error().stack)}setParent(C,R){const M=this.c(C);M.parent=R}markAsDisposed(C){this.b.delete(C)}markAsSingleton(C){this.c(C).isSingleton=!0}f(C,R){const M=R.get(C);if(M)return M;const T=C.parent?this.f(this.c(C.parent),R):C;return R.set(C,T),T}getTrackedDisposables(){const C=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,C).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(C=10,R){let M;if(R)M=R;else{const Z=new Map,G=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,Z).isSingleton);if(G.length===0)return;const J=new Set(G.map(V=>V.value));if(M=G.filter(V=>!(V.parent&&J.has(V.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function T(Z){function G(V,H){for(;V.length>0&&H.some(ie=>typeof ie=="string"?ie===V[0]:V[0].match(ie));)V.shift()}const J=Z.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return G(J,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),J.reverse()}const q=new L.$Hc;for(const Z of M){const G=T(Z);for(let J=0;J<=G.length;J++)q.add(G.slice(0,J).join(`
`),Z)}M.sort((0,D.$6b)(Z=>Z.idx,D.$8b));let Y="",K=0;for(const Z of M.slice(0,C)){K++;const G=T(Z),J=[];for(let V=0;V<G.length;V++){let H=G[V];H=`(shared with ${q.get(G.slice(0,V+1).join(`
`)).size}/${M.length} leaks) at ${H}`;const se=q.get(G.slice(0,V).join(`
`)),he=(0,N.$K)([...se].map(ee=>T(ee)[V]),ee=>ee);delete he[G[V]];for(const[ee,W]of Object.entries(he))J.unshift(`    - stacktraces of ${W.length} other leaks continue with ${ee}`);J.unshift(H)}Y+=`


==================== Leaking disposable ${K}/${M.length}: ${Z.value.constructor.name} ====================
${J.join(`
`)}
============================================================

`}return M.length>C&&(Y+=`


... and ${M.length-C} more leaking disposables

`),{leaks:M,details:Y}}}e.$Jc=d;function E(k){P=k}if(I){const k="__is_disposable_tracked__";E(new class{trackDisposable(C){const R=new Error("Potentially leaked disposable").stack;setTimeout(()=>{C[k]||console.log(R)},3e3)}setParent(C,R){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsDisposed(C){if(C&&C!==t.None)try{C[k]=!0}catch{}}markAsSingleton(C){}})}function y(k){return P?.trackDisposable(k),k}function p(k){P?.markAsDisposed(k)}function l(k,C){P?.setParent(k,C)}function c(k,C){if(P)for(const R of k)P.setParent(R,C)}function b(k){return P?.markAsSingleton(k),k}function m(k){return typeof k=="object"&&k!==null&&typeof k.dispose=="function"&&k.dispose.length===0}function f(k){if(O.Iterable.is(k)){const C=[];for(const R of k)if(R)try{R.dispose()}catch(M){C.push(M)}if(C.length===1)throw C[0];if(C.length>1)throw new AggregateError(C,"Encountered errors while disposing of store");return Array.isArray(k)?[]:k}else if(k)return k.dispose(),k}function u(k){for(const C of k)m(C)&&C.dispose();return[]}function h(...k){const C=g(()=>f(k));return c(k,C),C}function g(k){const C=y({dispose:(0,A.$db)(()=>{p(C),k()})});return C}class ${static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,y(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(C){if(!C)return C;if(C===this)throw new Error("Cannot register a disposable on itself!");return l(C,this),this.g?$.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(C),C}delete(C){if(C){if(C===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(C),C.dispose()}}deleteAndLeak(C){C&&this.f.has(C)&&(this.f.delete(C),l(C,null))}}e.$Tc=$;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new $,y(this),l(this.q,this)}dispose(){p(this),this.q.dispose()}B(C){if(C===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(C)}}e.$Uc=t;class r{constructor(){this.b=!1,y(this)}get value(){return this.b?void 0:this.a}set value(C){this.b||C===this.a||(this.a?.dispose(),C&&l(C,this),this.a=C)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const C=this.a;return this.a=void 0,C&&l(C,null),C}}e.$Vc=r;class n{constructor(C){this.a=new r,this.b=!1,this.a.value=C}get value(){return this.a.value}set value(C){this.b||C===this.a.value||(this.a.value=C)}dispose(){this.b=!0,this.a.dispose()}}e.$Wc=n;class s{constructor(C){this.b=C,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Xc=s;class i{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,y(this)}set(C){let R=C;return this.unset=()=>R=void 0,this.isset=()=>R!==void 0,this.dispose=()=>{R&&(R(),R=void 0,p(this))},this}}e.$Yc=i;class o{constructor(){this.a=new Map}acquire(C,...R){let M=this.a.get(C);M||(M={counter:0,object:this.b(C,...R)},this.a.set(C,M));const{object:T}=M,q=(0,A.$db)(()=>{--M.counter===0&&(this.c(C,M.object),this.a.delete(C))});return M.counter++,{object:T,dispose:q}}}e.$Zc=o;class a{constructor(C){this.a=C}async acquire(C,...R){const M=this.a.acquire(C,...R);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(T){throw M.dispose(),T}}}e.$1c=a;class w{constructor(C){this.object=C}dispose(){}}e.$2c=w;function S(k){const C=new $;try{k(C)}finally{C.dispose()}}class v{constructor(){this.a=new Map,this.b=!1,y(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(C){return this.a.has(C)}get size(){return this.a.size}get(C){return this.a.get(C)}set(C,R,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(C)?.dispose(),this.a.set(C,R)}deleteAndDispose(C){this.a.get(C)?.dispose(),this.a.delete(C)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$4c=v}),define(ae[87],ce([0,1,34]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fm=void 0,e.$dm=L,e.$em=O;const N=new D.$Dc(1e4);function L(d){return P(d,"NFC",N)}const A=new D.$Dc(1e4);function O(d){return P(d,"NFD",A)}const I=/[^\u0000-\u0080]/;function P(d,E,y){if(!d)return d;const p=y.get(d);if(p)return p;let l;return I.test(d)?l=d.normalize(E):l=d,y.set(d,l),l}e.$fm=function(){const d=/[\u0300-\u036f]/g;return function(E){return O(E).replace(d,"")}}()}),function(){function ne(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(P){A.push(P,Date.now())}function I(){const P=[];for(let d=0;d<A.length;d+=2)P.push({name:A[d],startTime:A[d+1]});return P}return{mark:O,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ne():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ne(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),ne()}function D(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function(ne,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:ne)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function(ne){var e={};function D(N){if(e[N])return e[N].exports;var L=e[N]={i:N,l:!1,exports:{}};return ne[N].call(L.exports,L,L.exports,D),L.l=!0,L.exports}return D.m=ne,D.c=e,D.d=function(N,L,A){D.o(N,L)||Object.defineProperty(N,L,{enumerable:!0,get:A})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,L){if(1&L&&(N=D(N)),8&L||4&L&&typeof N=="object"&&N&&N.__esModule)return N;var A=Object.create(null);if(D.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:N}),2&L&&typeof N!="string")for(var O in N)D.d(A,O,function(I){return N[I]}.bind(null,O));return A},D.n=function(N){var L=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(L,"a",L),L},D.o=function(N,L){return Object.prototype.hasOwnProperty.call(N,L)},D.p="",D(D.s=0)}([function(ne,e,D){(function(N){var L;e=ne.exports=W,L=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,I=e.re=[],P=e.src=[],d=0,E=d++;P[E]="0|[1-9]\\d*";var y=d++;P[y]="[0-9]+";var p=d++;P[p]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=d++;P[l]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var c=d++;P[c]="("+P[y]+")\\.("+P[y]+")\\.("+P[y]+")";var b=d++;P[b]="(?:"+P[E]+"|"+P[p]+")";var m=d++;P[m]="(?:"+P[y]+"|"+P[p]+")";var f=d++;P[f]="(?:-("+P[b]+"(?:\\."+P[b]+")*))";var u=d++;P[u]="(?:-?("+P[m]+"(?:\\."+P[m]+")*))";var h=d++;P[h]="[0-9A-Za-z-]+";var g=d++;P[g]="(?:\\+("+P[h]+"(?:\\."+P[h]+")*))";var $=d++,t="v?"+P[l]+P[f]+"?"+P[g]+"?";P[$]="^"+t+"$";var r="[v=\\s]*"+P[c]+P[u]+"?"+P[g]+"?",n=d++;P[n]="^"+r+"$";var s=d++;P[s]="((?:<|>)?=?)";var i=d++;P[i]=P[y]+"|x|X|\\*";var o=d++;P[o]=P[E]+"|x|X|\\*";var a=d++;P[a]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[f]+")?"+P[g]+"?)?)?";var w=d++;P[w]="[v=\\s]*("+P[i]+")(?:\\.("+P[i]+")(?:\\.("+P[i]+")(?:"+P[u]+")?"+P[g]+"?)?)?";var S=d++;P[S]="^"+P[s]+"\\s*"+P[a]+"$";var v=d++;P[v]="^"+P[s]+"\\s*"+P[w]+"$";var k=d++;P[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=d++;P[C]="(?:~>?)";var R=d++;P[R]="(\\s*)"+P[C]+"\\s+",I[R]=new RegExp(P[R],"g");var M=d++;P[M]="^"+P[C]+P[a]+"$";var T=d++;P[T]="^"+P[C]+P[w]+"$";var q=d++;P[q]="(?:\\^)";var Y=d++;P[Y]="(\\s*)"+P[q]+"\\s+",I[Y]=new RegExp(P[Y],"g");var K=d++;P[K]="^"+P[q]+P[a]+"$";var Z=d++;P[Z]="^"+P[q]+P[w]+"$";var G=d++;P[G]="^"+P[s]+"\\s*("+r+")$|^$";var J=d++;P[J]="^"+P[s]+"\\s*("+t+")$|^$";var V=d++;P[V]="(\\s*)"+P[s]+"\\s*("+r+"|"+P[a]+")",I[V]=new RegExp(P[V],"g");var H=d++;P[H]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=d++;P[ie]="^\\s*("+P[w]+")\\s+-\\s+("+P[w]+")\\s*$";var se=d++;P[se]="(<|>)?=?\\s*\\*";for(var he=0;he<35;he++)L(he,P[he]),I[he]||(I[he]=new RegExp(P[he]));function ee(le,we){if(le instanceof W)return le;if(typeof le!="string"||le.length>A||!(we?I[n]:I[$]).test(le))return null;try{return new W(le,we)}catch{return null}}function W(le,we){if(le instanceof W){if(le.loose===we)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof W))return new W(le,we);L("SemVer",le,we),this.loose=we;var pe=le.trim().match(we?I[n]:I[$]);if(!pe)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+pe[1],this.minor=+pe[2],this.patch=+pe[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");pe[4]?this.prerelease=pe[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var De=+Ce;if(De>=0&&De<O)return De}return Ce}):this.prerelease=[],this.build=pe[5]?pe[5].split("."):[],this.format()}e.parse=ee,e.valid=function(le,we){var pe=ee(le,we);return pe?pe.version:null},e.clean=function(le,we){var pe=ee(le.trim().replace(/^[=v]+/,""),we);return pe?pe.version:null},e.SemVer=W,W.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},W.prototype.toString=function(){return this.version},W.prototype.compare=function(le){return L("SemVer.compare",this.version,this.loose,le),le instanceof W||(le=new W(le,this.loose)),this.compareMain(le)||this.comparePre(le)},W.prototype.compareMain=function(le){return le instanceof W||(le=new W(le,this.loose)),j(this.major,le.major)||j(this.minor,le.minor)||j(this.patch,le.patch)},W.prototype.comparePre=function(le){if(le instanceof W||(le=new W(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var we=0;do{var pe=this.prerelease[we],Ce=le.prerelease[we];if(L("prerelease compare",we,pe,Ce),pe===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(pe===void 0)return-1;if(pe!==Ce)return j(pe,Ce)}while(++we)},W.prototype.inc=function(le,we){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var pe=this.prerelease.length;--pe>=0;)typeof this.prerelease[pe]=="number"&&(this.prerelease[pe]++,pe=-2);pe===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,we,pe,Ce){typeof pe=="string"&&(Ce=pe,pe=void 0);try{return new W(le,pe).inc(we,Ce).version}catch{return null}},e.diff=function(le,we){if(Q(le,we))return null;var pe=ee(le),Ce=ee(we);if(pe.prerelease.length||Ce.prerelease.length){for(var De in pe)if((De==="major"||De==="minor"||De==="patch")&&pe[De]!==Ce[De])return"pre"+De;return"prerelease"}for(var De in pe)if((De==="major"||De==="minor"||De==="patch")&&pe[De]!==Ce[De])return De},e.compareIdentifiers=j;var z=/^[0-9]+$/;function j(le,we){var pe=z.test(le),Ce=z.test(we);return pe&&Ce&&(le=+le,we=+we),pe&&!Ce?-1:Ce&&!pe?1:le<we?-1:le>we?1:0}function F(le,we,pe){return new W(le,pe).compare(new W(we,pe))}function B(le,we,pe){return F(le,we,pe)>0}function U(le,we,pe){return F(le,we,pe)<0}function Q(le,we,pe){return F(le,we,pe)===0}function x(le,we,pe){return F(le,we,pe)!==0}function te(le,we,pe){return F(le,we,pe)>=0}function _(le,we,pe){return F(le,we,pe)<=0}function oe(le,we,pe,Ce){var De;switch(we){case"===":typeof le=="object"&&(le=le.version),typeof pe=="object"&&(pe=pe.version),De=le===pe;break;case"!==":typeof le=="object"&&(le=le.version),typeof pe=="object"&&(pe=pe.version),De=le!==pe;break;case"":case"=":case"==":De=Q(le,pe,Ce);break;case"!=":De=x(le,pe,Ce);break;case">":De=B(le,pe,Ce);break;case">=":De=te(le,pe,Ce);break;case"<":De=U(le,pe,Ce);break;case"<=":De=_(le,pe,Ce);break;default:throw new TypeError("Invalid operator: "+we)}return De}function ue(le,we){if(le instanceof ue){if(le.loose===we)return le;le=le.value}if(!(this instanceof ue))return new ue(le,we);L("comparator",le,we),this.loose=we,this.parse(le),this.semver===$e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(le,we){return j(we,le)},e.major=function(le,we){return new W(le,we).major},e.minor=function(le,we){return new W(le,we).minor},e.patch=function(le,we){return new W(le,we).patch},e.compare=F,e.compareLoose=function(le,we){return F(le,we,!0)},e.rcompare=function(le,we,pe){return F(we,le,pe)},e.sort=function(le,we){return le.sort(function(pe,Ce){return e.compare(pe,Ce,we)})},e.rsort=function(le,we){return le.sort(function(pe,Ce){return e.rcompare(pe,Ce,we)})},e.gt=B,e.lt=U,e.eq=Q,e.neq=x,e.gte=te,e.lte=_,e.cmp=oe,e.Comparator=ue;var $e={};function de(le,we){if(le instanceof de)return le.loose===we?le:new de(le.raw,we);if(le instanceof ue)return new de(le.value,we);if(!(this instanceof de))return new de(le,we);if(this.loose=we,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(pe){return this.parseRange(pe.trim())},this).filter(function(pe){return pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function ge(le){return!le||le.toLowerCase()==="x"||le==="*"}function be(le,we,pe,Ce,De,Le,Oe,Te,Ae,qe,Ve,Me,Ne){return((we=ge(pe)?"":ge(Ce)?">="+pe+".0.0":ge(De)?">="+pe+"."+Ce+".0":">="+we)+" "+(Te=ge(Ae)?"":ge(qe)?"<"+(+Ae+1)+".0.0":ge(Ve)?"<"+Ae+"."+(+qe+1)+".0":Me?"<="+Ae+"."+qe+"."+Ve+"-"+Me:"<="+Te)).trim()}function Ee(le,we){for(var pe=0;pe<le.length;pe++)if(!le[pe].test(we))return!1;if(we.prerelease.length){for(pe=0;pe<le.length;pe++)if(L(le[pe].semver),le[pe].semver!==$e&&le[pe].semver.prerelease.length>0){var Ce=le[pe].semver;if(Ce.major===we.major&&Ce.minor===we.minor&&Ce.patch===we.patch)return!0}return!1}return!0}function Pe(le,we,pe){try{we=new de(we,pe)}catch{return!1}return we.test(le)}function Re(le,we,pe,Ce){var De,Le,Oe,Te,Ae;switch(le=new W(le,Ce),we=new de(we,Ce),pe){case">":De=B,Le=_,Oe=U,Te=">",Ae=">=";break;case"<":De=U,Le=te,Oe=B,Te="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Pe(le,we,Ce))return!1;for(var qe=0;qe<we.set.length;++qe){var Ve=we.set[qe],Me=null,Ne=null;if(Ve.forEach(function(Ue){Ue.semver===$e&&(Ue=new ue(">=0.0.0")),Me=Me||Ue,Ne=Ne||Ue,De(Ue.semver,Me.semver,Ce)?Me=Ue:Oe(Ue.semver,Ne.semver,Ce)&&(Ne=Ue)}),Me.operator===Te||Me.operator===Ae||(!Ne.operator||Ne.operator===Te)&&Le(le,Ne.semver)||Ne.operator===Ae&&Oe(le,Ne.semver))return!1}return!0}ue.prototype.parse=function(le){var we=this.loose?I[G]:I[J],pe=le.match(we);if(!pe)throw new TypeError("Invalid comparator: "+le);this.operator=pe[1],this.operator==="="&&(this.operator=""),pe[2]?this.semver=new W(pe[2],this.loose):this.semver=$e},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(le){return L("Comparator.test",le,this.loose),this.semver===$e||(typeof le=="string"&&(le=new W(le,this.loose)),oe(le,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(le,we){if(!(le instanceof ue))throw new TypeError("a Comparator is required");var pe;if(this.operator==="")return pe=new de(le.value,we),Pe(this.value,pe,we);if(le.operator==="")return pe=new de(this.value,we),Pe(le.semver,pe,we);var Ce=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),De=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Le=this.semver.version===le.semver.version,Oe=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),Te=oe(this.semver,"<",le.semver,we)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ae=oe(this.semver,">",le.semver,we)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ce||De||Le&&Oe||Te||Ae},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(le){var we=this.loose;le=le.trim(),L("range",le,we);var pe=we?I[ie]:I[H];le=le.replace(pe,be),L("hyphen replace",le),le=le.replace(I[V],"$1$2$3"),L("comparator trim",le,I[V]),le=(le=(le=le.replace(I[R],"$1~")).replace(I[Y],"$1^")).split(/\s+/).join(" ");var Ce=we?I[G]:I[J],De=le.split(" ").map(function(Le){return function(Oe,Te){return L("comp",Oe),Oe=function(Ae,qe){return Ae.trim().split(/\s+/).map(function(Ve){return function(Me,Ne){L("caret",Me,Ne);var Ue=Ne?I[Z]:I[K];return Me.replace(Ue,function(re,fe,me,ye,ke){var Ie;return L("caret",Me,re,fe,me,ye,ke),ge(fe)?Ie="":ge(me)?Ie=">="+fe+".0.0 <"+(+fe+1)+".0.0":ge(ye)?Ie=fe==="0"?">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+".0 <"+(+fe+1)+".0.0":ke?(L("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ie=fe==="0"?me==="0"?">="+fe+"."+me+"."+ye+ke+" <"+fe+"."+me+"."+(+ye+1):">="+fe+"."+me+"."+ye+ke+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ye+ke+" <"+(+fe+1)+".0.0"):(L("no pr"),Ie=fe==="0"?me==="0"?">="+fe+"."+me+"."+ye+" <"+fe+"."+me+"."+(+ye+1):">="+fe+"."+me+"."+ye+" <"+fe+"."+(+me+1)+".0":">="+fe+"."+me+"."+ye+" <"+(+fe+1)+".0.0"),L("caret return",Ie),Ie})}(Ve,qe)}).join(" ")}(Oe,Te),L("caret",Oe),Oe=function(Ae,qe){return Ae.trim().split(/\s+/).map(function(Ve){return function(Me,Ne){var Ue=Ne?I[T]:I[M];return Me.replace(Ue,function(re,fe,me,ye,ke){var Ie;return L("tilde",Me,re,fe,me,ye,ke),ge(fe)?Ie="":ge(me)?Ie=">="+fe+".0.0 <"+(+fe+1)+".0.0":ge(ye)?Ie=">="+fe+"."+me+".0 <"+fe+"."+(+me+1)+".0":ke?(L("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Ie=">="+fe+"."+me+"."+ye+ke+" <"+fe+"."+(+me+1)+".0"):Ie=">="+fe+"."+me+"."+ye+" <"+fe+"."+(+me+1)+".0",L("tilde return",Ie),Ie})}(Ve,qe)}).join(" ")}(Oe,Te),L("tildes",Oe),Oe=function(Ae,qe){return L("replaceXRanges",Ae,qe),Ae.split(/\s+/).map(function(Ve){return function(Me,Ne){Me=Me.trim();var Ue=Ne?I[v]:I[S];return Me.replace(Ue,function(re,fe,me,ye,ke,Ie){L("xRange",Me,re,fe,me,ye,ke,Ie);var Fe=ge(me),He=Fe||ge(ye),Be=He||ge(ke);return fe==="="&&Be&&(fe=""),Fe?re=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Be?(He&&(ye=0),Be&&(ke=0),fe===">"?(fe=">=",He?(me=+me+1,ye=0,ke=0):Be&&(ye=+ye+1,ke=0)):fe==="<="&&(fe="<",He?me=+me+1:ye=+ye+1),re=fe+me+"."+ye+"."+ke):He?re=">="+me+".0.0 <"+(+me+1)+".0.0":Be&&(re=">="+me+"."+ye+".0 <"+me+"."+(+ye+1)+".0"),L("xRange return",re),re})}(Ve,qe)}).join(" ")}(Oe,Te),L("xrange",Oe),Oe=function(Ae,qe){return L("replaceStars",Ae,qe),Ae.trim().replace(I[se],"")}(Oe,Te),L("stars",Oe),Oe}(Le,we)}).join(" ").split(/\s+/);return this.loose&&(De=De.filter(function(Le){return!!Le.match(Ce)})),De=De.map(function(Le){return new ue(Le,we)})},de.prototype.intersects=function(le,we){if(!(le instanceof de))throw new TypeError("a Range is required");return this.set.some(function(pe){return pe.every(function(Ce){return le.set.some(function(De){return De.every(function(Le){return Ce.intersects(Le,we)})})})})},e.toComparators=function(le,we){return new de(le,we).set.map(function(pe){return pe.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},de.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new W(le,this.loose));for(var we=0;we<this.set.length;we++)if(Ee(this.set[we],le))return!0;return!1},e.satisfies=Pe,e.maxSatisfying=function(le,we,pe){var Ce=null,De=null;try{var Le=new de(we,pe)}catch{return null}return le.forEach(function(Oe){Le.test(Oe)&&(Ce&&De.compare(Oe)!==-1||(De=new W(Ce=Oe,pe)))}),Ce},e.minSatisfying=function(le,we,pe){var Ce=null,De=null;try{var Le=new de(we,pe)}catch{return null}return le.forEach(function(Oe){Le.test(Oe)&&(Ce&&De.compare(Oe)!==1||(De=new W(Ce=Oe,pe)))}),Ce},e.validRange=function(le,we){try{return new de(le,we).range||"*"}catch{return null}},e.ltr=function(le,we,pe){return Re(le,we,"<",pe)},e.gtr=function(le,we,pe){return Re(le,we,">",pe)},e.outside=Re,e.prerelease=function(le,we){var pe=ee(le,we);return pe&&pe.prerelease.length?pe.prerelease:null},e.intersects=function(le,we,pe){return le=new de(le,pe),we=new de(we,pe),le.intersects(we)},e.coerce=function(le){if(le instanceof W)return le;if(typeof le!="string")return null;var we=le.match(I[k]);return we==null?null:ee((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,D(1))},function(ne,e){var D,N,L=ne.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function I(m){if(D===setTimeout)return setTimeout(m,0);if((D===A||!D)&&setTimeout)return D=setTimeout,setTimeout(m,0);try{return D(m,0)}catch{try{return D.call(null,m,0)}catch{return D.call(this,m,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:A}catch{D=A}try{N=typeof clearTimeout=="function"?clearTimeout:O}catch{N=O}})();var P,d=[],E=!1,y=-1;function p(){E&&P&&(E=!1,P.length?d=P.concat(d):y=-1,d.length&&l())}function l(){if(!E){var m=I(p);E=!0;for(var f=d.length;f;){for(P=d,d=[];++y<f;)P&&P[y].run();y=-1,f=d.length}P=null,E=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===O||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(m)}}function c(m,f){this.fun=m,this.array=f}function b(){}L.nextTick=function(m){var f=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)f[u-1]=arguments[u];d.push(new c(m,f)),d.length!==1||E||I(l)},c.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=b,L.addListener=b,L.once=b,L.off=b,L.removeListener=b,L.removeAllListeners=b,L.emit=b,L.prependListener=b,L.prependOnceListener=b,L.listeners=function(m){return[]},L.binding=function(m){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(m){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(ae[129],ce([0,1]),function(ne,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class N{constructor(I,P,d){this.level=I,this.key=P,this.value=d,this.forward=[]}}const L=void 0;class A{constructor(I,P=2**16){this.comparator=I,this[D]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(P)|0),this.e=new N(this.c,L,L)}get size(){return this.f}clear(){this.e=new N(this.c,L,L),this.f=0}has(I){return!!A.g(this,I,this.comparator)}get(I){return A.g(this,I,this.comparator)?.value}set(I,P){return A.h(this,I,P,this.comparator)&&(this.f+=1),this}delete(I){const P=A.k(this,I,this.comparator);return P&&(this.f-=1),P}forEach(I,P){let d=this.e.forward[0];for(;d;)I.call(P,d.value,d.key,this),d=d.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let I=this.e.forward[0];for(;I;)yield[I.key,I.value],I=I.forward[0]}*keys(){let I=this.e.forward[0];for(;I;)yield I.key,I=I.forward[0]}*values(){let I=this.e.forward[0];for(;I;)yield I.value,I=I.forward[0]}toString(){let I="[SkipList]:",P=this.e.forward[0];for(;P;)I+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return I}static g(I,P,d){let E=I.e;for(let y=I.d-1;y>=0;y--)for(;E.forward[y]&&d(E.forward[y].key,P)<0;)E=E.forward[y];if(E=E.forward[0],E&&d(E.key,P)===0)return E}static h(I,P,d,E){const y=[];let p=I.e;for(let l=I.d-1;l>=0;l--){for(;p.forward[l]&&E(p.forward[l].key,P)<0;)p=p.forward[l];y[l]=p}if(p=p.forward[0],p&&E(p.key,P)===0)return p.value=d,!1;{const l=A.j(I);if(l>I.d){for(let c=I.d;c<l;c++)y[c]=I.e;I.d=l}p=new N(l,P,d);for(let c=0;c<l;c++)p.forward[c]=y[c].forward[c],y[c].forward[c]=p;return!0}}static j(I,P=.5){let d=1;for(;Math.random()<P&&d<I.c;)d+=1;return d}static k(I,P,d){const E=[];let y=I.e;for(let p=I.d-1;p>=0;p--){for(;y.forward[p]&&d(y.forward[p].key,P)<0;)y=y.forward[p];E[p]=y}if(y=y.forward[0],!y||d(y.key,P)!==0)return!1;for(let p=0;p<I.d&&E[p].forward[p]===y;p++)E[p].forward[p]=y.forward[p];for(;I.d>0&&I.e.forward[I.d-1]===L;)I.d-=1;return!0}}e.$Ds=A}),define(ae[63],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(A){return new N(A)}constructor(A){this.c=D&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$be=N}),define(ae[3],ce([0,1,7,85,2,86,63]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$de=e.Event=void 0,e.$ee=l;const I=!1,P=!1,d=!1;var E;(function(R){R.None=()=>L.$Uc.None;function M(de){if(d){const{onDidAddListener:ge}=de,be=b.create();let Ee=0;de.onDidAddListener=()=>{++Ee===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),be.print()),ge?.()}}}function T(de,ge){return se(de,()=>{},0,void 0,!0,void 0,ge)}R.defer=T;function q(de){return(ge,be=null,Ee)=>{let Pe=!1,Re;return Re=de(le=>{if(!Pe)return Re?Re.dispose():Pe=!0,ge.call(be,le)},null,Ee),Pe&&Re.dispose(),Re}}R.once=q;function Y(de,ge,be){return H((Ee,Pe=null,Re)=>de(le=>Ee.call(Pe,ge(le)),null,Re),be)}R.map=Y;function K(de,ge,be){return H((Ee,Pe=null,Re)=>de(le=>{ge(le),Ee.call(Pe,le)},null,Re),be)}R.forEach=K;function Z(de,ge,be){return H((Ee,Pe=null,Re)=>de(le=>ge(le)&&Ee.call(Pe,le),null,Re),be)}R.filter=Z;function G(de){return de}R.signal=G;function J(...de){return(ge,be=null,Ee)=>{const Pe=(0,L.$Rc)(...de.map(Re=>Re(le=>ge.call(be,le))));return ie(Pe,Ee)}}R.any=J;function V(de,ge,be,Ee){let Pe=be;return Y(de,Re=>(Pe=ge(Pe,Re),Pe),Ee)}R.reduce=V;function H(de,ge){let be;const Ee={onWillAddFirstListener(){be=de(Pe.fire,Pe)},onDidRemoveLastListener(){be?.dispose()}};ge||M(Ee);const Pe=new $(Ee);return ge?.add(Pe),Pe.event}function ie(de,ge){return ge instanceof Array?ge.push(de):ge&&ge.add(de),de}function se(de,ge,be=100,Ee=!1,Pe=!1,Re,le){let we,pe,Ce,De=0,Le;const Oe={leakWarningThreshold:Re,onWillAddFirstListener(){we=de(Ae=>{De++,pe=ge(pe,Ae),Ee&&!Ce&&(Te.fire(pe),pe=void 0),Le=()=>{const qe=pe;pe=void 0,Ce=void 0,(!Ee||De>1)&&Te.fire(qe),De=0},typeof be=="number"?(clearTimeout(Ce),Ce=setTimeout(Le,be)):Ce===void 0&&(Ce=0,queueMicrotask(Le))})},onWillRemoveListener(){Pe&&De>0&&Le?.()},onDidRemoveLastListener(){Le=void 0,we.dispose()}};le||M(Oe);const Te=new $(Oe);return le?.add(Te),Te.event}R.debounce=se;function he(de,ge=0,be){return R.debounce(de,(Ee,Pe)=>Ee?(Ee.push(Pe),Ee):[Pe],ge,void 0,!0,void 0,be)}R.accumulate=he;function ee(de,ge=(Ee,Pe)=>Ee===Pe,be){let Ee=!0,Pe;return Z(de,Re=>{const le=Ee||!ge(Re,Pe);return Ee=!1,Pe=Re,le},be)}R.latch=ee;function W(de,ge,be){return[R.filter(de,ge,be),R.filter(de,Ee=>!ge(Ee),be)]}R.split=W;function z(de,ge=!1,be=[],Ee){let Pe=be.slice(),Re=de(pe=>{Pe?Pe.push(pe):we.fire(pe)});Ee&&Ee.add(Re);const le=()=>{Pe?.forEach(pe=>we.fire(pe)),Pe=null},we=new $({onWillAddFirstListener(){Re||(Re=de(pe=>we.fire(pe)),Ee&&Ee.add(Re))},onDidAddFirstListener(){Pe&&(ge?setTimeout(le):le())},onDidRemoveLastListener(){Re&&Re.dispose(),Re=null}});return Ee&&Ee.add(we),we.event}R.buffer=z;function j(de,ge){return(Ee,Pe,Re)=>{const le=ge(new B);return de(function(we){const pe=le.evaluate(we);pe!==F&&Ee.call(Pe,pe)},void 0,Re)}}R.chain=j;const F=Symbol("HaltChainable");class B{constructor(){this.f=[]}map(ge){return this.f.push(ge),this}forEach(ge){return this.f.push(be=>(ge(be),be)),this}filter(ge){return this.f.push(be=>ge(be)?be:F),this}reduce(ge,be){let Ee=be;return this.f.push(Pe=>(Ee=ge(Ee,Pe),Ee)),this}latch(ge=(be,Ee)=>be===Ee){let be=!0,Ee;return this.f.push(Pe=>{const Re=be||!ge(Pe,Ee);return be=!1,Ee=Pe,Re?Pe:F}),this}evaluate(ge){for(const be of this.f)if(ge=be(ge),ge===F)break;return ge}}function U(de,ge,be=Ee=>Ee){const Ee=(...we)=>le.fire(be(...we)),Pe=()=>de.on(ge,Ee),Re=()=>de.removeListener(ge,Ee),le=new $({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return le.event}R.fromNodeEventEmitter=U;function Q(de,ge,be=Ee=>Ee){const Ee=(...we)=>le.fire(be(...we)),Pe=()=>de.addEventListener(ge,Ee),Re=()=>de.removeEventListener(ge,Ee),le=new $({onWillAddFirstListener:Pe,onDidRemoveLastListener:Re});return le.event}R.fromDOMEventEmitter=Q;function x(de){return new Promise(ge=>q(de)(ge))}R.toPromise=x;function te(de){const ge=new $;return de.then(be=>{ge.fire(be)},()=>{ge.fire(void 0)}).finally(()=>{ge.dispose()}),ge.event}R.fromPromise=te;function _(de,ge,be){return ge(be),de(Ee=>ge(Ee))}R.runAndSubscribe=_;class oe{constructor(ge,be){this._observable=ge,this.f=0,this.g=!1;const Ee={onWillAddFirstListener:()=>{ge.addObserver(this)},onDidRemoveLastListener:()=>{ge.removeObserver(this)}};be||M(Ee),this.emitter=new $(Ee),be&&be.add(this.emitter)}beginUpdate(ge){this.f++}handlePossibleChange(ge){}handleChange(ge,be){this.g=!0}endUpdate(ge){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ue(de,ge){return new oe(de,ge).emitter.event}R.fromObservable=ue;function $e(de){return(ge,be,Ee)=>{let Pe=0,Re=!1;const le={beginUpdate(){Pe++},endUpdate(){Pe--,Pe===0&&(de.reportChanges(),Re&&(Re=!1,ge.call(be)))},handlePossibleChange(){},handleChange(){Re=!0}};de.addObserver(le),de.reportChanges();const we={dispose(){de.removeObserver(le)}};return Ee instanceof L.$Tc?Ee.add(we):Array.isArray(Ee)&&Ee.push(we),we}}R.fromObservableLight=$e})(E||(e.Event=E={}));class y{static{this.all=new Set}static{this.f=0}constructor(M){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${M}_${y.f++}`,y.all.add(this)}start(M){this.g=new O.$be,this.listenerCount=M}stop(){if(this.g){const M=this.g.elapsed();this.durations.push(M),this.elapsedOverall+=M,this.invocationCount+=1,this.g=void 0}}}e.$de=y;let p=-1;function l(R){const M=p;return p=R,{dispose(){p=M}}}class c{constructor(M,T=Math.random().toString(18).slice(2,5)){this.threshold=M,this.name=T,this.g=0}dispose(){this.f?.clear()}check(M,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const Y=this.f.get(M.value)||0;if(this.f.set(M.value,Y+1),this.g-=1,this.g<=0){this.g=q*.5;let K,Z=0;for(const[G,J]of this.f)(!K||Z<J)&&(K=G,Z=J);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${Z}):`),console.warn(K)}return()=>{const K=this.f.get(M.value)||0;this.f.set(M.value,K-1)}}}class b{static create(){return new b(new Error().stack??"")}constructor(M){this.value=M}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let m=0;class f{constructor(M){this.value=M,this.id=m++}}const u=2,h=(R,M)=>{if(R instanceof f)M(R);else for(let T=0;T<R.length;T++){const q=R[T];q&&M(q)}},g=I?new FinalizationRegistry(R=>{typeof R=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(R))}):void 0;class ${constructor(M){this.w=0,this.f=M,this.g=p>0||this.f?.leakWarningThreshold?new c(this.f?.leakWarningThreshold??p):void 0,this.j=this.f?._profName?new y(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const M=this.t;queueMicrotask(()=>{h(M,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(M,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),L.$Uc.None;if(this.m)return L.$Uc.None;T&&(M=M.bind(T));const Y=new f(M);let K,Z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(Y.stack=b.create(),K=this.g.check(Y.stack,this.w+1)),P&&(Y.stack=Z??b.create()),this.t?this.t instanceof f?(this.u??=new r,this.t=[this.t,Y]):this.t.push(Y):(this.f?.onWillAddFirstListener?.(this),this.t=Y,this.f?.onDidAddFirstListener?.(this)),this.w++;const G=(0,L.$Sc)(()=>{g?.unregister(G),K?.(),this.x(Y)});if(q instanceof L.$Tc?q.add(G):Array.isArray(q)&&q.push(G),g){const J=new Error().stack.split(`
`).slice(2).join(`
`).trim();g.register(G,J,G)}return G},this.q}x(M){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(M);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const Y=this.u.current===this;if(this.w*u<=T.length){let K=0;for(let Z=0;Z<T.length;Z++)T[Z]?T[K++]=T[Z]:Y&&(this.u.end--,K<this.u.i&&this.u.i--);T.length=K}}y(M,T){if(!M)return;const q=this.f?.onListenerError||D.$1;if(!q){M.value(T);return}try{M.value(T)}catch(Y){q(Y)}}z(M){const T=M.current.t;for(;M.i<M.end;)this.y(T[M.i++],M.value);M.reset()}fire(M){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,M);else{const T=this.u;T.enqueue(this,M,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$fe=$;const t=()=>new r;e.$ge=t;class r{constructor(){this.i=-1,this.end=0}enqueue(M,T,q){this.i=0,this.end=q,this.current=M,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class n extends ${async fireAsync(M,T,q){if(this.t)for(this.h||(this.h=new A.$5c),h(this.t,Y=>this.h.push([Y.value,M]));this.h.size>0&&!T.isCancellationRequested;){const[Y,K]=this.h.shift(),Z=[],G={...K,token:T,waitUntil:J=>{if(Object.isFrozen(Z))throw new Error("waitUntil can NOT be called asynchronous");q&&(J=q(J,Y)),Z.push(J)}};try{Y(G)}catch(J){(0,D.$1)(J);continue}Object.freeze(Z),await Promise.allSettled(Z).then(J=>{for(const V of J)V.status==="rejected"&&(0,D.$1)(V.reason)})}}}e.$he=n;class s extends ${get isPaused(){return this.h!==0}constructor(M){super(M),this.h=0,this.s=new A.$5c,this.A=M?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const M=Array.from(this.s);this.s.clear(),super.fire(this.A(M))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(M){this.w&&(this.h!==0?this.s.push(M):super.fire(M))}}e.$ie=s;class i extends s{constructor(M){super(M),this.k=M.delay??100}fire(M){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(M)}}e.$je=i;class o extends ${constructor(M){super(M),this.h=[],this.k=M?.merge}fire(M){this.hasListeners()&&(this.h.push(M),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$ke=o;class a{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(M){const T={event:M,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const Y=this.h.indexOf(T);this.h.splice(Y,1)};return(0,L.$Sc)((0,N.$db)(q))}j(){this.g=!0,this.h.forEach(M=>this.m(M))}k(){this.g=!1,this.h.forEach(M=>this.o(M))}m(M){M.listener=M.event(T=>this.f.fire(T))}o(M){M.listener?.dispose(),M.listener=null}dispose(){this.f.dispose();for(const M of this.h)M.listener?.dispose();this.h=[]}}e.$le=a;class w{constructor(M,T,q,Y){this.f=new L.$Tc;const K=this.f.add(new a),Z=this.f.add(new L.$4c);function G(J){Z.set(J,K.add(Y(J)))}for(const J of M)G(J);this.f.add(T(J=>{G(J)})),this.f.add(q(J=>{Z.deleteAndDispose(J)})),this.event=K.event}dispose(){this.f.dispose()}}e.$me=w;class S{constructor(){this.f=[]}wrapEvent(M,T,q){return(Y,K,Z)=>M(G=>{const J=this.f[this.f.length-1];if(!T){J?J.buffers.push(()=>Y.call(K,G)):Y.call(K,G);return}const V=J;if(!V){Y.call(K,T(q,G));return}V.items??=[],V.items.push(G),V.buffers.length===0&&J.buffers.push(()=>{V.reducedResult??=q?V.items.reduce(T,q):V.items.reduce(T),Y.call(K,V.reducedResult)})},void 0,Z)}bufferEvents(M){const T={buffers:new Array};this.f.push(T);const q=M();return this.f.pop(),T.buffers.forEach(Y=>Y()),q}}e.$ne=S;class v{constructor(){this.f=!1,this.g=E.None,this.h=L.$Uc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(M){this.g=M,this.f&&(this.h.dispose(),this.h=M(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$oe=v;class k{static const(M){return new C(M)}constructor(M){this.g=M,this.f=new $,this.onDidChange=this.f.event}get value(){return this.g}set value(M){M!==this.g&&(this.g=M,this.f.fire(void 0))}}e.$pe=k;class C{constructor(M){this.value=M,this.onDidChange=E.None}}}),define(ae[26],ce([0,1,3]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=e.CancellationToken=void 0,e.$re=I;const N=Object.freeze(function(P,d){const E=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(E)}}});var L;(function(P){function d(E){return E===P.None||E===P.Cancelled||E instanceof A?!0:!E||typeof E!="object"?!1:typeof E.isCancellationRequested=="boolean"&&typeof E.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(L||(e.CancellationToken=L={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$fe),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class O{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=L.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=L.None}}e.$qe=O;function I(P){const d=new O;return P.add({dispose(){d.cancel()}}),d.token}}),define(ae[130],ce([0,1,26]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6e=e.$5e=e.$3e=void 0,e.$4e=L;class N{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new D.$qe,d=this.b(P.token);return this.a={promise:d,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$3e=N;function L(I){return I}class A{constructor(P,d){this.a=void 0,this.b=void 0,typeof P=="function"?(this.c=P,this.d=L):(this.c=d,this.d=P.getCacheKey)}get(P){const d=this.d(P);return this.b!==d&&(this.b=d,this.a=this.c(P)),this.a}}e.$5e=A;class O{get cachedValues(){return this.a}constructor(P,d){this.a=new Map,this.b=new Map,typeof P=="function"?(this.c=P,this.d=L):(this.c=d,this.d=P.getCacheKey)}get(P){const d=this.d(P);if(this.b.has(d))return this.b.get(d);const E=this.c(P);return this.a.set(P,E),this.b.set(d,E),E}}e.$6e=O}),define(ae[50],ce([0,1,7,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=L,e.$te=A,e.$ue=O,e.$ve=I,e.$we=d,e.$xe=E,e.$ye=y,e.$ze=p,e.$Ae=l,e.$Be=c,e.$Ce=b,e.$De=m,e.$Ee=f,e.$Fe=u,e.$Ge=h;function L(g){const $=g;return $?typeof $.read=="function":!1}function A(g){const $=g;return $?[$.on,$.pause,$.resume,$.destroy].every(t=>typeof t=="function"):!1}function O(g){const $=g;return $?A($.stream)&&Array.isArray($.buffer)&&typeof $.ended=="boolean":!1}function I(g,$){return new P(g,$)}class P{constructor($,t){this.e=$,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write($){if(!this.a.destroyed){if(this.a.flowing)this.g($);else if(this.b.data.push($),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error($){this.a.destroyed||(this.a.flowing?this.h($):this.b.error.push($))}end($){this.a.destroyed||(typeof $<"u"&&this.write($),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g($){this.c.data.slice(0).forEach(t=>t($))}h($){this.c.error.length===0?(0,D.$1)($):this.c.error.slice(0).forEach(t=>t($))}i(){this.c.end.slice(0).forEach($=>$())}on($,t){if(!this.a.destroyed)switch($){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener($,t){if(this.a.destroyed)return;let r;switch($){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const n=r.indexOf(t);n>=0&&r.splice(n,1)}}j(){if(this.b.data.length>0){const $=this.e(this.b.data);this.g($),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const $ of this.b.error)this.h($);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(g,$){const t=[];let r;for(;(r=g.read())!==null;)t.push(r);return $(t)}function E(g,$,t){const r=[];let n;for(;(n=g.read())!==null&&r.length<t;)r.push(n);return n===null&&r.length>0?$(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return g.read()}}}function y(g,$){return new Promise((t,r)=>{const n=[];p(g,{onData:s=>{$&&n.push(s)},onError:s=>{$?r(s):t(void 0)},onEnd:()=>{t($?$(n):void 0)}})})}function p(g,$,t){g.on("error",r=>{t?.isCancellationRequested||$.onError(r)}),g.on("end",()=>{t?.isCancellationRequested||$.onEnd()}),g.on("data",r=>{t?.isCancellationRequested||$.onData(r)})}function l(g,$){return new Promise((t,r)=>{const n=new N.$Tc,s=[],i=w=>{if(s.push(w),s.length>$)return n.dispose(),g.pause(),t({stream:g,buffer:s,ended:!1})},o=w=>(n.dispose(),r(w)),a=()=>(n.dispose(),t({stream:g,buffer:s,ended:!0}));n.add((0,N.$Sc)(()=>g.removeListener("error",o))),g.on("error",o),n.add((0,N.$Sc)(()=>g.removeListener("end",a))),g.on("end",a),n.add((0,N.$Sc)(()=>g.removeListener("data",i))),g.on("data",i)})}function c(g,$){const t=I($);return t.end(g),t}function b(){const g=I(()=>{throw new Error("not supported")});return g.end(),g}function m(g){let $=!1;return{read:()=>$?null:($=!0,g)}}function f(g,$,t){const r=I(t);return p(g,{onData:n=>r.write($.data(n)),onError:n=>r.error($.error?$.error(n):n),onEnd:()=>r.end()}),r}function u(g,$,t){let r=!1;return{read:()=>{const n=$.read();return r?n:(r=!0,n!==null?t([g,n]):g)}}}function h(g,$,t){let r=!1;const n=I(t);return p($,{onData:s=>r?n.write(s):(r=!0,n.write(t([g,s]))),onError:s=>n.error(s),onEnd:()=>{r||(r=!0,n.write(g)),n.end()}}),n}}),define(ae[15],ce([0,1,53,50]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=d,e.$Je=E,e.$Ke=y,e.$Le=p,e.$Me=l,e.$Ne=c,e.$Oe=b,e.$Pe=m,e.$Qe=f,e.$Re=u,e.$Se=h,e.$Te=g,e.$Ue=$,e.$Ve=t,e.$We=r,e.$Xe=n,e.$Ye=s,e.$Ze=i,e.$1e=o,e.$2e=S;const L=typeof Buffer<"u",A=new D.$V(()=>new Uint8Array(256));let O,I;class P{static alloc(k){return L?new P(Buffer.allocUnsafe(k)):new P(new Uint8Array(k))}static wrap(k){return L&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new P(k)}static fromString(k,C){return!(C?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(k)):(O||(O=new TextEncoder),new P(O.encode(k)))}static fromByteArray(k){const C=P.alloc(k.length);for(let R=0,M=k.length;R<M;R++)C.buffer[R]=k[R];return C}static concat(k,C){if(typeof C>"u"){C=0;for(let T=0,q=k.length;T<q;T++)C+=k[T].byteLength}const R=P.alloc(C);let M=0;for(let T=0,q=k.length;T<q;T++){const Y=k[T];R.set(Y,M),M+=Y.byteLength}return R}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=P.alloc(this.byteLength);return k.set(this),k}toString(){return L?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(k,C){return new P(this.buffer.subarray(k,C))}set(k,C){if(k instanceof P)this.buffer.set(k.buffer,C);else if(k instanceof Uint8Array)this.buffer.set(k,C);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),C);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return p(this.buffer,k)}writeUInt32BE(k,C){l(this.buffer,k,C)}readUInt32LE(k){return c(this.buffer,k)}writeUInt32LE(k,C){b(this.buffer,k,C)}readUInt8(k){return m(this.buffer,k)}writeUInt8(k,C){f(this.buffer,k,C)}indexOf(k,C=0){return d(this.buffer,k instanceof P?k.buffer:k,C)}}e.$He=P;function d(v,k,C=0){const R=k.byteLength,M=v.byteLength;if(R===0)return 0;if(R===1)return v.indexOf(k[0]);if(R>M-C)return-1;const T=A.value;T.fill(k.length);for(let Z=0;Z<k.length;Z++)T[k[Z]]=k.length-Z-1;let q=C+k.length-1,Y=q,K=-1;for(;q<M;)if(v[q]===k[Y]){if(Y===0){K=q;break}q--,Y--}else q+=Math.max(k.length-Y,T[v[q]]),Y=k.length-1;return K}function E(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0}function y(v,k,C){v[C+0]=k&255,k=k>>>8,v[C+1]=k&255}function p(v,k){return v[k]*2**24+v[k+1]*2**16+v[k+2]*2**8+v[k+3]}function l(v,k,C){v[C+3]=k,k=k>>>8,v[C+2]=k,k=k>>>8,v[C+1]=k,k=k>>>8,v[C]=k}function c(v,k){return v[k+0]<<0>>>0|v[k+1]<<8>>>0|v[k+2]<<16>>>0|v[k+3]<<24>>>0}function b(v,k,C){v[C+0]=k&255,k=k>>>8,v[C+1]=k&255,k=k>>>8,v[C+2]=k&255,k=k>>>8,v[C+3]=k&255}function m(v,k){return v[k]}function f(v,k,C){v[C]=k}function u(v){return N.$we(v,k=>P.concat(k))}function h(v){return N.$De(v)}function g(v){return N.$ye(v,k=>P.concat(k))}async function $(v){return v.ended?P.concat(v.buffer):P.concat([...v.buffer,await g(v.stream)])}function t(v){return N.$Be(v,k=>P.concat(k))}function r(v){return N.$Ee(v,{data:k=>typeof k=="string"?P.fromString(k):P.wrap(k)},k=>P.concat(k))}function n(v){return N.$ve(k=>P.concat(k),v)}function s(v,k){return N.$Fe(v,k,C=>P.concat(C))}function i(v,k){return N.$Ge(v,k,C=>P.concat(C))}function o(v){let k=0,C=0,R=0;const M=new Uint8Array(Math.floor(v.length/4*3)),T=Y=>{switch(C){case 3:M[R++]=k|Y,C=0;break;case 2:M[R++]=k|Y>>>2,k=Y<<6,C=3;break;case 1:M[R++]=k|Y>>>4,k=Y<<4,C=2;break;default:k=Y<<2,C=1}};for(let Y=0;Y<v.length;Y++){const K=v.charCodeAt(Y);if(K>=65&&K<=90)T(K-65);else if(K>=97&&K<=122)T(K-97+26);else if(K>=48&&K<=57)T(K-48+52);else if(K===43||K===45)T(62);else if(K===47||K===95)T(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${v[Y]}`)}}const q=R;for(;C>0;)T(0);return P.wrap(M).slice(0,q)}const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",w="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:v},k=!0,C=!1){const R=C?w:a;let M="";const T=v.byteLength%3;let q=0;for(;q<v.byteLength-T;q+=3){const Y=v[q+0],K=v[q+1],Z=v[q+2];M+=R[Y>>>2],M+=R[(Y<<4|K>>>4)&63],M+=R[(K<<2|Z>>>6)&63],M+=R[Z&63]}if(T===1){const Y=v[q+0];M+=R[Y>>>2],M+=R[Y<<4&63],k&&(M+="==")}else if(T===2){const Y=v[q+0],K=v[q+1];M+=R[Y>>>2],M+=R[(Y<<4|K>>>4)&63],M+=R[K<<2&63],k&&(M+="=")}return M}}),define(ae[27],ce([0,1,130,53]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.GraphemeBreakType=e.$Xf=e.$Pf=e.$If=e.$Hf=void 0,e.$9e=L,e.$0e=O,e.$$e=P,e.$_e=d,e.$af=E,e.$bf=y,e.$cf=p,e.$df=l,e.$ef=c,e.$ff=b,e.$gf=m,e.$hf=f,e.$if=u,e.$jf=h,e.$kf=g,e.$lf=$,e.$mf=t,e.$nf=r,e.$of=n,e.$pf=s,e.$qf=i,e.$rf=o,e.$sf=a,e.$tf=w,e.$uf=S,e.$vf=v,e.$wf=k,e.$xf=C,e.$yf=R,e.$zf=M,e.$Af=T,e.$Bf=q,e.$Cf=Y,e.$Df=K,e.$Ef=Z,e.$Ff=G,e.$Gf=J,e.$Jf=se,e.$Kf=he,e.$Lf=ee,e.$Mf=W,e.$Nf=F,e.$Of=U,e.$Qf=Q,e.$Rf=x,e.$Sf=te,e.$Tf=_,e.$Uf=ue,e.$Vf=$e,e.$Wf=ge,e.$Yf=be,e.$Zf=Ee,e.$1f=Pe,e.$2f=Re,e.$3f=le,e.$4f=we,e.$5f=pe,e.$6f=Ce,e.$7f=Ae;function L(re){return!re||typeof re!="string"?!0:re.trim().length===0}const A=/{(\d+)}/g;function O(re,...fe){return fe.length===0?re:re.replace(A,function(me,ye){const ke=parseInt(ye,10);return isNaN(ke)||ke<0||ke>=fe.length?me:fe[ke]})}const I=/{([^}]+)}/g;function P(re,fe){return Object.keys(fe).length===0?re:re.replace(I,(me,ye)=>fe[ye]??me)}function d(re){return re.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}function E(re){return re.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}function y(re){return re.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function p(re,fe){let me=0,ye=re.indexOf(fe);for(;ye!==-1;)me++,ye=re.indexOf(fe,ye+fe.length);return me}function l(re,fe,me="\u2026"){return re.length<=fe?re:`${re.substr(0,fe)}${me}`}function c(re,fe,me="\u2026"){if(re.length<=fe)return re;const ye=Math.ceil(fe/2)-me.length/2,ke=Math.floor(fe/2)-me.length/2;return`${re.substr(0,ye)}${me}${re.substr(re.length-ke)}`}function b(re,fe=" "){const me=m(re,fe);return f(me,fe)}function m(re,fe){if(!re||!fe)return re;const me=fe.length;if(me===0||re.length===0)return re;let ye=0;for(;re.indexOf(fe,ye)===ye;)ye=ye+me;return re.substring(ye)}function f(re,fe){if(!re||!fe)return re;const me=fe.length,ye=re.length;if(me===0||ye===0)return re;let ke=ye,Ie=-1;for(;Ie=re.lastIndexOf(fe,ke-1),!(Ie===-1||Ie+me!==ke);){if(Ie===0)return"";ke=Ie}return re.substring(0,ke)}function u(re){return re.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function h(re){return re.replace(/\*/g,"")}function g(re,fe,me={}){if(!re)throw new Error("Cannot create regex from empty string");fe||(re=y(re)),me.wholeWord&&(/\B/.test(re.charAt(0))||(re="\\b"+re),/\B/.test(re.charAt(re.length-1))||(re=re+"\\b"));let ye="";return me.global&&(ye+="g"),me.matchCase||(ye+="i"),me.multiline&&(ye+="m"),me.unicode&&(ye+="u"),new RegExp(re,ye)}function $(re){return re.source==="^"||re.source==="^$"||re.source==="$"||re.source==="^\\s*$"?!1:!!(re.exec("")&&re.lastIndex===0)}function t(re){return re.split(/\r\n|\r|\n/)}function r(re){const fe=[],me=re.split(/(\r\n|\r|\n)/);for(let ye=0;ye<Math.ceil(me.length/2);ye++)fe.push(me[2*ye]+(me[2*ye+1]??""));return fe}function n(re){for(let fe=0,me=re.length;fe<me;fe++){const ye=re.charCodeAt(fe);if(ye!==32&&ye!==9)return fe}return-1}function s(re,fe=0,me=re.length){for(let ye=fe;ye<me;ye++){const ke=re.charCodeAt(ye);if(ke!==32&&ke!==9)return re.substring(fe,ye)}return re.substring(fe,me)}function i(re,fe=re.length-1){for(let me=fe;me>=0;me--){const ye=re.charCodeAt(me);if(ye!==32&&ye!==9)return me}return-1}function o(re,fe,me){const ye=[];let ke=0;for(const Ie of re.matchAll(fe)){if(ye.push(re.slice(ke,Ie.index)),Ie.index===void 0)throw new Error("match.index should be defined");ke=Ie.index+Ie[0].length,ye.push(me(Ie[0],...Ie.slice(1),Ie.index,re,Ie.groups))}return ye.push(re.slice(ke)),Promise.all(ye).then(Ie=>Ie.join(""))}function a(re,fe){return re<fe?-1:re>fe?1:0}function w(re,fe,me=0,ye=re.length,ke=0,Ie=fe.length){for(;me<ye&&ke<Ie;me++,ke++){const Be=re.charCodeAt(me),Je=fe.charCodeAt(ke);if(Be<Je)return-1;if(Be>Je)return 1}const Fe=ye-me,He=Ie-ke;return Fe<He?-1:Fe>He?1:0}function S(re,fe){return v(re,fe,0,re.length,0,fe.length)}function v(re,fe,me=0,ye=re.length,ke=0,Ie=fe.length){for(;me<ye&&ke<Ie;me++,ke++){let Be=re.charCodeAt(me),Je=fe.charCodeAt(ke);if(Be===Je)continue;if(Be>=128||Je>=128)return w(re.toLowerCase(),fe.toLowerCase(),me,ye,ke,Ie);C(Be)&&(Be-=32),C(Je)&&(Je-=32);const ze=Be-Je;if(ze!==0)return ze}const Fe=ye-me,He=Ie-ke;return Fe<He?-1:Fe>He?1:0}function k(re){return re>=48&&re<=57}function C(re){return re>=97&&re<=122}function R(re){return re>=65&&re<=90}function M(re,fe){return re.length===fe.length&&v(re,fe)===0}function T(re,fe){const me=fe.length;return fe.length>re.length?!1:v(re,fe,0,me)===0}function q(re,fe){const me=Math.min(re.length,fe.length);let ye;for(ye=0;ye<me;ye++)if(re.charCodeAt(ye)!==fe.charCodeAt(ye))return ye;return me}function Y(re,fe){const me=Math.min(re.length,fe.length);let ye;const ke=re.length-1,Ie=fe.length-1;for(ye=0;ye<me;ye++)if(re.charCodeAt(ke-ye)!==fe.charCodeAt(Ie-ye))return ye;return me}function K(re){return 55296<=re&&re<=56319}function Z(re){return 56320<=re&&re<=57343}function G(re,fe){return(re-55296<<10)+(fe-56320)+65536}function J(re,fe,me){const ye=re.charCodeAt(me);if(K(ye)&&me+1<fe){const ke=re.charCodeAt(me+1);if(Z(ke))return G(ye,ke)}return ye}function V(re,fe){const me=re.charCodeAt(fe-1);if(Z(me)&&fe>1){const ye=re.charCodeAt(fe-2);if(K(ye))return G(ye,me)}return me}class H{get offset(){return this.e}constructor(fe,me=0){this.c=fe,this.d=fe.length,this.e=me}setOffset(fe){this.e=fe}prevCodePoint(){const fe=V(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=J(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$Hf=H;class ie{get offset(){return this.c.offset}constructor(fe,me=0){this.c=new H(fe,me)}nextGraphemeLength(){const fe=Oe.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ie=me.offset,Fe=fe.getGraphemeBreakType(me.nextCodePoint());if(De(ke,Fe)){me.setOffset(Ie);break}ke=Fe}return me.offset-ye}prevGraphemeLength(){const fe=Oe.getInstance(),me=this.c,ye=me.offset;let ke=fe.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ie=me.offset,Fe=fe.getGraphemeBreakType(me.prevCodePoint());if(De(Fe,ke)){me.setOffset(Ie);break}ke=Fe}return ye-me.offset}eol(){return this.c.eol()}}e.$If=ie;function se(re,fe){return new ie(re,fe).nextGraphemeLength()}function he(re,fe){return new ie(re,fe).prevGraphemeLength()}function ee(re,fe){fe>0&&Z(re.charCodeAt(fe))&&fe--;const me=fe+se(re,fe);return[me-he(re,me),me]}function W(re){const fe=new ie(re);let me=0;for(;!fe.eol();)me++,fe.nextGraphemeLength();return me}let z;function j(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(re){return z||(z=j()),z.test(re)}const B=/^[\t\n\r\x20-\x7E]*$/;function U(re){return B.test(re)}e.$Pf=/[\u2028\u2029]/;function Q(re){return e.$Pf.test(re)}function x(re){return re>=11904&&re<=55215||re>=63744&&re<=64255||re>=65281&&re<=65374}function te(re){return re>=127462&&re<=127487||re===8986||re===8987||re===9200||re===9203||re>=9728&&re<=10175||re===11088||re===11093||re>=127744&&re<=128591||re>=128640&&re<=128764||re>=128992&&re<=129008||re>=129280&&re<=129535||re>=129648&&re<=129782}function _(re,fe,me=""){const ye=re.trimStart();if(ye.length<fe)return ye;const ke=/\b/g;let Ie=0;for(;ke.test(ye)&&!(ye.length-ke.lastIndex<fe);)Ie=ke.lastIndex,ke.lastIndex+=1;return Ie===0?ye:me+ye.substring(Ie).trimStart()}const oe=/(?:(?:\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*ue(re){let fe=0;for(const me of re.matchAll(oe))fe!==me.index&&(yield{isCode:!1,str:re.substring(fe,me.index)}),yield{isCode:!0,str:me[0]},fe=me.index+me[0].length;fe!==re.length&&(yield{isCode:!1,str:re.substring(fe)})}function $e(re){return re&&(re=re.replace(oe,"")),re}const de=/\\\[.*?\\\]/g;function ge(re){return $e(re).replace(de,"")}e.$Xf="\uFEFF";function be(re){return!!(re&&re.length>0&&re.charCodeAt(0)===65279)}function Ee(re){return be(re)?re.substr(1):re}function Pe(re,fe){if(!re||!fe||re.length<fe.length)return!1;const me=fe.length,ye=re.toLowerCase();let ke=0,Ie=-1;for(;ke<me;){const Fe=ye.indexOf(fe[ke],Ie+1);if(Fe<0)return!1;Ie=Fe,ke++}return!0}function Re(re,fe=!1){return re?(fe&&(re=re.replace(/\\./g,"")),re.toLowerCase()!==re):!1}function le(re){return re.charAt(0).toUpperCase()+re.slice(1)}function we(re,fe=1){if(fe===0)return"";let me=-1;do me=re.indexOf(`
`,me+1),fe--;while(fe>0&&me>=0);return me===-1?re:(re[me-1]==="\r"&&me--,re.substr(0,me))}function pe(re){return re=re%(2*26),re<26?String.fromCharCode(97+re):String.fromCharCode(65+re-26)}function Ce(re){return Oe.getInstance().getGraphemeBreakType(re)}function De(re,fe){return re===0?fe!==5&&fe!==7:re===2&&fe===3?!1:re===4||re===2||re===3||fe===4||fe===2||fe===3?!0:!(re===8&&(fe===8||fe===9||fe===11||fe===12)||(re===11||re===9)&&(fe===9||fe===10)||(re===12||re===10)&&fe===10||fe===5||fe===13||fe===7||re===1||re===13&&fe===14||re===6&&fe===6)}var Le;(function(re){re[re.Other=0]="Other",re[re.Prepend=1]="Prepend",re[re.CR=2]="CR",re[re.LF=3]="LF",re[re.Control=4]="Control",re[re.Extend=5]="Extend",re[re.Regional_Indicator=6]="Regional_Indicator",re[re.SpacingMark=7]="SpacingMark",re[re.L=8]="L",re[re.V=9]="V",re[re.T=10]="T",re[re.LV=11]="LV",re[re.LVT=12]="LVT",re[re.ZWJ=13]="ZWJ",re[re.Extended_Pictographic=14]="Extended_Pictographic"})(Le||(e.GraphemeBreakType=Le={}));class Oe{static{this.c=null}static getInstance(){return Oe.c||(Oe.c=new Oe),Oe.c}constructor(){this.d=Te()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const me=this.d,ye=me.length/3;let ke=1;for(;ke<=ye;)if(fe<me[3*ke])ke=2*ke;else if(fe>me[3*ke+1])ke=2*ke+1;else return me[3*ke+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(re,fe){if(re===0)return 0;const me=qe(re,fe);if(me!==void 0)return me;const ye=new H(fe,re);return ye.prevCodePoint(),ye.offset}function qe(re,fe){const me=new H(fe,re);let ye=me.prevCodePoint();for(;Ve(ye)||ye===65039||ye===8419;){if(me.offset===0)return;ye=me.prevCodePoint()}if(!te(ye))return;let ke=me.offset;return ke>0&&me.prevCodePoint()===8205&&(ke=me.offset),ke}function Ve(re){return 127995<=re&&re<=127999}var Me;(function(re){re[re.zwj=8205]="zwj",re[re.emojiVariantSelector=65039]="emojiVariantSelector",re[re.enclosingKeyCap=8419]="enclosingKeyCap"})(Me||(Me={})),e.$8f="\xA0";class Ne{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$5e({getCacheKey:JSON.stringify},fe=>{function me(ze){const Ye=new Map;for(let Xe=0;Xe<ze.length;Xe+=2)Ye.set(ze[Xe],ze[Xe+1]);return Ye}function ye(ze,Ye){const Xe=new Map(ze);for(const[tt,nt]of Ye)Xe.set(tt,nt);return Xe}function ke(ze,Ye){if(!ze)return Ye;const Xe=new Map;for(const[tt,nt]of ze)Ye.has(tt)&&Xe.set(tt,nt);return Xe}const Ie=this.c.value;let Fe=fe.filter(ze=>!ze.startsWith("_")&&ze in Ie);Fe.length===0&&(Fe=["_default"]);let He;for(const ze of Fe){const Ye=me(Ie[ze]);He=ke(He,Ye)}const Be=me(Ie._common),Je=ye(Be,He);return new Ne(Je)})}static getInstance(fe){return Ne.d.get(Array.from(fe))}static{this.e=new N.$V(()=>Object.keys(Ne.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Ne.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$9f=Ne;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(fe){return Ue.e().has(fe)}static get codePoints(){return Ue.e()}}e.$0f=Ue}),define(ae[54],ce([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=N,e.$nj=L,e.$oj=A,e.$pj=I,e.$rj=b;function N(f){return L(f,0)}function L(f,u){switch(typeof f){case"object":return f===null?A(349,u):Array.isArray(f)?P(f,u):d(f,u);case"string":return I(f,u);case"boolean":return O(f,u);case"number":return A(f,u);case"undefined":return A(937,u);default:return A(617,u)}}function A(f,u){return(u<<5)-u+f|0}function O(f,u){return A(f?433:863,u)}function I(f,u){u=A(149417,u);for(let h=0,g=f.length;h<g;h++)u=A(f.charCodeAt(h),u);return u}function P(f,u){return u=A(104579,u),f.reduce((h,g)=>L(g,h),u)}function d(f,u){return u=A(181387,u),Object.keys(f).sort().reduce((h,g)=>(h=I(g,h),L(f[g],h)),u)}class E{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=L(u,this.g),this.g}}e.$qj=E;var y;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(y||(y={}));function p(f,u,h=32){const g=h-u,$=~((1<<g)-1);return(f<<u|($&f)>>>g)>>>0}function l(f,u=0,h=f.byteLength,g=0){for(let $=0;$<h;$++)f[u+$]=g}function c(f,u,h="0"){for(;f.length<u;)f=h+f;return f}function b(f,u=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(h=>h.toString(16).padStart(2,"0")).join(""):c((f>>>0).toString(16),u/4)}class m{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const h=u.length;if(h===0)return;const g=this.p;let $=this.r,t=this.u,r,n;for(t!==0?(r=t,n=-1,t=0):(r=u.charCodeAt(0),n=0);;){let s=r;if(D.$Df(r))if(n+1<h){const i=u.charCodeAt(n+1);D.$Ef(i)?(n++,s=D.$Ff(r,i)):s=65533}else{t=r;break}else D.$Ef(r)&&(s=65533);if($=this.w(g,$,s),n++,n<h)r=u.charCodeAt(n);else break}this.r=$,this.u=t}w(u,h,g){return g<128?u[h++]=g:g<2048?(u[h++]=192|(g&1984)>>>6,u[h++]=128|(g&63)>>>0):g<65536?(u[h++]=224|(g&61440)>>>12,u[h++]=128|(g&4032)>>>6,u[h++]=128|(g&63)>>>0):(u[h++]=240|(g&1835008)>>>18,u[h++]=128|(g&258048)>>>12,u[h++]=128|(g&4032)>>>6,u[h++]=128|(g&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,u[0]=u[64],u[1]=u[65],u[2]=u[66]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=m.g,h=this.q;for(let a=0;a<64;a+=4)u.setUint32(a,h.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)u.setUint32(a,p(u.getUint32(a-12,!1)^u.getUint32(a-32,!1)^u.getUint32(a-56,!1)^u.getUint32(a-64,!1),1),!1);let g=this.h,$=this.l,t=this.m,r=this.n,n=this.o,s,i,o;for(let a=0;a<80;a++)a<20?(s=$&t|~$&r,i=1518500249):a<40?(s=$^t^r,i=1859775393):a<60?(s=$&t|$&r|t&r,i=2400959708):(s=$^t^r,i=3395469782),o=p(g,5)+s+n+i+u.getUint32(a*4,!1)&4294967295,n=r,r=t,t=p($,30),$=g,g=o;this.h=this.h+g&4294967295,this.l=this.l+$&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+n&4294967295}}e.$sj=m}),define(ae[88],ce([0,1,27]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(L){L[L.Ignore=0]="Ignore",L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(N||(N={})),function(L){const A="error",O="warning",I="warn",P="info",d="ignore";function E(p){return p?D.$zf(A,p)?L.Error:D.$zf(O,p)||D.$zf(I,p)?L.Warning:D.$zf(P,p)?L.Info:L.Ignore:L.Ignore}L.fromValue=E;function y(p){switch(p){case L.Error:return A;case L.Warning:return O;case L.Info:return P;default:return d}}L.toString=y}(N||(N={})),e.default=N}),define(ae[131],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(ae[51],ce([0,1,17,27]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class L{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const c=l.charCodeAt(0),b=this.b.charCodeAt(this.c);return c-b}value(){return this.b[this.c]}}e.$Ai=L;class A{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,N.$tf)(l,this.b,0,l.length,this.c,this.d):(0,N.$vf)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=A;class O{constructor(l=!0,c=!0){this.f=l,this.g=c}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let c=l.length-1;c>=0;c--,this.c--){const b=this.b.charCodeAt(c);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const c=this.b.charCodeAt(this.e);if(c===47||this.f&&c===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,N.$tf)(l,this.b,0,l.length,this.d,this.e):(0,N.$vf)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=O;var I;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(I||(I={}));class P{constructor(l,c){this.f=l,this.g=c,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new O(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,N.$uf)(l,this.c.scheme);if(this.d[this.e]===2)return(0,N.$uf)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,N.$sf)(l,this.c.query);if(this.d[this.e]===5)return(0,N.$sf)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=P;class d{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var E;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(E||(E={}));class y{static forUris(l=()=>!1,c=()=>!1){return new y(new P(l,c))}static forPaths(l=!1){return new y(new O(void 0,!l))}static forStrings(){return new y(new L)}static forConfigKeys(){return new y(new A)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,c){if(c){const b=c.slice(0);(0,D.$Wb)(b);for(const m of b)this.set(m,l)}else{const b=l.slice(0);(0,D.$Wb)(b);for(const m of b)this.set(m[0],m[1])}}set(l,c){const b=this.b.reset(l);let m;this.c||(this.c=new d,this.c.segment=b.value());const f=[];for(m=this.c;;){const h=b.cmp(m.segment);if(h>0)m.left||(m.left=new d,m.left.segment=b.value()),f.push([-1,m]),m=m.left;else if(h<0)m.right||(m.right=new d,m.right.segment=b.value()),f.push([1,m]),m=m.right;else if(b.hasNext())b.next(),m.mid||(m.mid=new d,m.mid.segment=b.value()),f.push([0,m]),m=m.mid;else break}const u=m.value;m.value=c,m.key=l;for(let h=f.length-1;h>=0;h--){const g=f[h][1];g.updateHeight();const $=g.balanceFactor();if($<-1||$>1){const t=f[h][0],r=f[h+1][0];if(t===1&&r===1)f[h][1]=g.rotateLeft();else if(t===-1&&r===-1)f[h][1]=g.rotateRight();else if(t===1&&r===-1)g.right=f[h+1][1]=f[h+1][1].rotateRight(),f[h][1]=g.rotateLeft();else if(t===-1&&r===1)g.left=f[h+1][1]=f[h+1][1].rotateLeft(),f[h][1]=g.rotateRight();else throw new Error;if(h>0)switch(f[h-1][0]){case-1:f[h-1][1].left=f[h][1];break;case 1:f[h-1][1].right=f[h][1];break;case 0:f[h-1][1].mid=f[h][1];break}else this.c=f[0][1]}}return u}get(l){return this.d(l)?.value}d(l){const c=this.b.reset(l);let b=this.c;for(;b;){const m=c.cmp(b.segment);if(m>0)b=b.left;else if(m<0)b=b.right;else if(c.hasNext())c.next(),b=b.mid;else break}return b}has(l){const c=this.d(l);return!(c?.value===void 0&&c?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,c){const b=this.b.reset(l),m=[];let f=this.c;for(;f;){const u=b.cmp(f.segment);if(u>0)m.push([-1,f]),f=f.left;else if(u<0)m.push([1,f]),f=f.right;else if(b.hasNext())b.next(),m.push([0,f]),f=f.mid;else break}if(f){if(c?(f.left=void 0,f.mid=void 0,f.right=void 0,f.height=1):(f.key=void 0,f.value=void 0),!f.mid&&!f.value)if(f.left&&f.right){const u=this.f(f.right);if(u.key){const{key:h,value:g,segment:$}=u;this.e(u.key,!1),f.key=h,f.value=g,f.segment=$}}else{const u=f.left??f.right;if(m.length>0){const[h,g]=m[m.length-1];switch(h){case-1:g.left=u;break;case 0:g.mid=u;break;case 1:g.right=u;break}}else this.c=u}for(let u=m.length-1;u>=0;u--){const h=m[u][1];h.updateHeight();const g=h.balanceFactor();if(g>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),m[u][1]=h.rotateLeft()):g<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),m[u][1]=h.rotateRight()),u>0)switch(m[u-1][0]){case-1:m[u-1][1].left=m[u][1];break;case 1:m[u-1][1].right=m[u][1];break;case 0:m[u-1][1].mid=m[u][1];break}else this.c=m[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const c=this.b.reset(l);let b=this.c,m;for(;b;){const f=c.cmp(b.segment);if(f>0)b=b.left;else if(f<0)b=b.right;else if(c.hasNext())c.next(),m=b.value||m,b=b.mid;else break}return b&&b.value||m}findSuperstr(l){return this.g(l,!1)}g(l,c){const b=this.b.reset(l);let m=this.c;for(;m;){const f=b.cmp(m.segment);if(f>0)m=m.left;else if(f<0)m=m.right;else if(b.hasNext())b.next(),m=m.mid;else return m.mid?this.h(m.mid):c?m.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[c,b]of this)l(b,c)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const c=[];return this.j(l,c),c[Symbol.iterator]()}j(l,c){l&&(l.left&&this.j(l.left,c),l.value&&c.push([l.key,l.value]),l.mid&&this.j(l.mid,c),l.right&&this.j(l.right,c))}_isBalanced(){const l=c=>{if(!c)return!0;const b=c.balanceFactor();return b<-1||b>1?!1:l(c.left)&&l(c.right)};return l(this.c)}}e.$Ei=y}),define(ae[13],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$f=D,e.$_f=N,e.$ag=L,e.$bg=A,e.$cg=O,e.$dg=I,e.$eg=P,e.$fg=d,e.$gg=E,e.$hg=y,e.$ig=p,e.$jg=l,e.$kg=c,e.$lg=m,e.$mg=f,e.$ng=u,e.$og=h,e.$pg=g;function D($){return typeof $=="string"}function N($){return Array.isArray($)&&$.every(t=>D(t))}function L($){return typeof $=="object"&&$!==null&&!Array.isArray($)&&!($ instanceof RegExp)&&!($ instanceof Date)}function A($){const t=Object.getPrototypeOf(Uint8Array);return typeof $=="object"&&$ instanceof t}function O($){return typeof $=="number"&&!isNaN($)}function I($){return!!$&&typeof $[Symbol.iterator]=="function"}function P($){return $===!0||$===!1}function d($){return typeof $>"u"}function E($){return!y($)}function y($){return d($)||$===null}function p($,t){if(!$)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function l($){if(y($))throw new Error("Assertion Failed: argument is undefined or null");return $}function c(...$){const t=[];for(let r=0;r<$.length;r++){const n=$[r];if(y(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(n)}return t}const b=Object.prototype.hasOwnProperty;function m($){if(!L($))return!1;for(const t in $)if(b.call($,t))return!1;return!0}function f($){return typeof $=="function"}function u(...$){return $.length>0&&$.every(f)}function h($,t){const r=Math.min($.length,t.length);for(let n=0;n<r;n++)g($[n],t[n])}function g($,t){if(D(t)){if(typeof $!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(f(t)){try{if($ instanceof t)return}catch{}if(!y($)&&$.constructor===t||t.length===1&&t.call(void 0,$)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ae[30],ce([0,1,13]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=N,e.$6n=L,e.$7n=O,e.$8n=P,e.$9n=d,e.$0n=E,e.$$n=y,e.$_n=p,e.$ao=l,e.$bo=c,e.$co=b,e.$do=m,e.$eo=f;function N(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const h=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([g,$])=>{h[g]=$&&typeof $=="object"?N($):$}),h}function L(u){if(!u||typeof u!="object")return u;const h=[u];for(;h.length>0;){const g=h.shift();Object.freeze(g);for(const $ in g)if(A.call(g,$)){const t=g[$];typeof t=="object"&&!Object.isFrozen(t)&&!(0,D.$bg)(t)&&h.push(t)}}return u}const A=Object.prototype.hasOwnProperty;function O(u,h){return I(u,h,new Set)}function I(u,h,g){if((0,D.$hg)(u))return u;const $=h(u);if(typeof $<"u")return $;if(Array.isArray(u)){const t=[];for(const r of u)t.push(I(r,h,g));return t}if((0,D.$ag)(u)){if(g.has(u))throw new Error("Cannot clone recursive data-structure");g.add(u);const t={};for(const r in u)A.call(u,r)&&(t[r]=I(u[r],h,g));return g.delete(u),t}return u}function P(u,h,g=!0){return(0,D.$ag)(u)?((0,D.$ag)(h)&&Object.keys(h).forEach($=>{$ in u?g&&((0,D.$ag)(u[$])&&(0,D.$ag)(h[$])?P(u[$],h[$],g):u[$]=h[$]):u[$]=h[$]}),u):h}function d(u,h){if(u===h)return!0;if(u==null||h===null||h===void 0||typeof u!=typeof h||typeof u!="object"||Array.isArray(u)!==Array.isArray(h))return!1;let g,$;if(Array.isArray(u)){if(u.length!==h.length)return!1;for(g=0;g<u.length;g++)if(!d(u[g],h[g]))return!1}else{const t=[];for($ in u)t.push($);t.sort();const r=[];for($ in h)r.push($);if(r.sort(),!d(t,r))return!1;for(g=0;g<t.length;g++)if(!d(u[t[g]],h[t[g]]))return!1}return!0}function E(u){const h=new Set;return JSON.stringify(u,(g,$)=>{if((0,D.$ag)($)||Array.isArray($)){if(h.has($))return"[Circular]";h.add($)}return typeof $=="bigint"?`[BigInt ${$.toString()}]`:$})}function y(u,h){const g=Object.create(null);return!u||!h||Object.keys(h).forEach(t=>{const r=u[t],n=h[t];d(r,n)||(g[t]=n)}),g}function p(u,h){const g=h.toLowerCase(),$=Object.keys(u).find(t=>t.toLowerCase()===g);return $?u[$]:u[h]}function l(u,h){const g=Object.create(null);for(const[$,t]of Object.entries(u))h($,t)&&(g[$]=t);return g}function c(u){let h=[];for(;Object.prototype!==u;)h=h.concat(Object.getOwnPropertyNames(u)),u=Object.getPrototypeOf(u);return h}function b(u){const h=[];for(const g of c(u))typeof u[g]=="function"&&h.push(g);return h}function m(u,h){const g=t=>function(){const r=Array.prototype.slice.call(arguments,0);return h(t,r)},$={};for(const t of u)$[t]=g(t);return $}function f(u,h){const g={};for(const[$,t]of Object.entries(u))g[$]=h(t,$);return g}}),define(ae[32],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=N;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(L){return D.test(L)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let L;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?L=crypto.getRandomValues.bind(crypto):L=function(I){for(let P=0;P<I.length;P++)I[P]=Math.floor(Math.random()*256);return I};const A=new Uint8Array(16),O=[];for(let I=0;I<256;I++)O.push(I.toString(16).padStart(2,"0"));return function(){L(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let P=0,d="";return d+=O[A[P++]],d+=O[A[P++]],d+=O[A[P++]],d+=O[A[P++]],d+="-",d+=O[A[P++]],d+=O[A[P++]],d+="-",d+=O[A[P++]],d+=O[A[P++]],d+="-",d+=O[A[P++]],d+=O[A[P++]],d+="-",d+=O[A[P++]],d+=O[A[P++]],d+=O[A[P++]],d+=O[A[P++]],d+=O[A[P++]],d+=O[A[P++]],d}}()}),define(ae[132],ce([0,1,37]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=A;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(O){const I=O.replace(/\-/g,":").toLowerCase();return!N.has(I)}function A(){const O=(0,D.networkInterfaces)();for(const I in O){const P=O[I];if(P){for(const{mac:d}of P)if(L(d))return d}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ae[133],ce([0,1,273,15]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cW=void 0;class L extends D.Transform{constructor(O){if(super(),typeof O=="number")this.b=O,this.c=1;else{const I=Buffer.isBuffer(O)?O:Buffer.from(O);this.b=I.length===1?I[0]:I,this.c=I.length}}_transform(O,I,P){this.a?this.a=Buffer.concat([this.a,O]):this.a=O;let d=0;for(;d<this.a.length;){const E=typeof this.b=="number"?this.a.indexOf(this.b,d):(0,N.$Ie)(this.a,this.b,d);if(E===-1)break;this.push(this.a.slice(d,E+this.c)),d=E+this.c}this.a=d===this.a.length?void 0:this.a.slice(d),P()}_flush(O){this.a&&this.push(this.a),O()}}e.$cW=L}),define(ae[134],ce([0,1,64]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xg=void 0,e.$Wg=N,e.$Yg=A;function N(I,P,d,E=1){let y=!1;return new Promise(p=>{const l=setTimeout(()=>{if(!y)return y=!0,p(0)},d);L(I,P,E,c=>{if(!y)return y=!0,clearTimeout(l),p(c)})})}function L(I,P,d,E){if(P===0)return E(0);const y=new D.Socket;y.once("connect",()=>(O(y),L(I+d,P-1,d,E))),y.once("data",()=>{}),y.once("error",p=>(O(y),p.code!=="ECONNREFUSED"?L(I+d,P-1,d,E):E(I))),y.connect(I,"127.0.0.1")}e.$Xg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(I,P,d,E="127.0.0.1"){let y=!1,p,l=1;const c=D.createServer({pauseOnConnect:!0});function b(m,f){y||(y=!0,c.removeAllListeners(),c.close(),p&&clearTimeout(p),f(m))}return new Promise(m=>{p=setTimeout(()=>{b(0,m)},d),c.on("listening",()=>{b(I,m)}),c.on("error",f=>{f&&(f.code==="EADDRINUSE"||f.code==="EACCES")&&l<P?(I++,l++,c.listen(I,E)):b(0,m)}),c.on("close",()=>{b(0,m)}),c.listen(I,E)})}function O(I){try{I.removeAllListeners("connect"),I.removeAllListeners("error"),I.end(),I.destroy(),I.unref()}catch(P){console.error(P)}}}),define(ae[135],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uW=D;function D(N){return!!N.parentPort}}),define(ae[136],ce([11,10]),function(ne,e){return ne.create("vs/base/common/date",e)}),define(ae[65],ce([0,1,136]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=d,e.$5m=E,e.$6m=y;const N=60,L=N*60,A=L*24,O=A*7,I=A*30,P=A*365;function d(p,l,c,b){typeof p!="number"&&(p=p.getTime());const m=Math.round((new Date().getTime()-p)/1e3);if(m<-30)return(0,D.localize)(0,null,d(new Date().getTime()+m*1e3,!1));if(!b&&m<30)return(0,D.localize)(1,null);let f;return m<N?(f=m,l?f===1?c?(0,D.localize)(2,null,f):(0,D.localize)(3,null,f):c?(0,D.localize)(4,null,f):(0,D.localize)(5,null,f):f===1?c?(0,D.localize)(6,null,f):(0,D.localize)(7,null,f):c?(0,D.localize)(8,null,f):(0,D.localize)(9,null,f)):m<L?(f=Math.floor(m/N),l?f===1?c?(0,D.localize)(10,null,f):(0,D.localize)(11,null,f):c?(0,D.localize)(12,null,f):(0,D.localize)(13,null,f):f===1?c?(0,D.localize)(14,null,f):(0,D.localize)(15,null,f):c?(0,D.localize)(16,null,f):(0,D.localize)(17,null,f)):m<A?(f=Math.floor(m/L),l?f===1?c?(0,D.localize)(18,null,f):(0,D.localize)(19,null,f):c?(0,D.localize)(20,null,f):(0,D.localize)(21,null,f):f===1?c?(0,D.localize)(22,null,f):(0,D.localize)(23,null,f):c?(0,D.localize)(24,null,f):(0,D.localize)(25,null,f)):m<O?(f=Math.floor(m/A),l?f===1?(0,D.localize)(26,null,f):(0,D.localize)(27,null,f):f===1?(0,D.localize)(28,null,f):(0,D.localize)(29,null,f)):m<I?(f=Math.floor(m/O),l?f===1?c?(0,D.localize)(30,null,f):(0,D.localize)(31,null,f):c?(0,D.localize)(32,null,f):(0,D.localize)(33,null,f):f===1?c?(0,D.localize)(34,null,f):(0,D.localize)(35,null,f):c?(0,D.localize)(36,null,f):(0,D.localize)(37,null,f)):m<P?(f=Math.floor(m/I),l?f===1?c?(0,D.localize)(38,null,f):(0,D.localize)(39,null,f):c?(0,D.localize)(40,null,f):(0,D.localize)(41,null,f):f===1?c?(0,D.localize)(42,null,f):(0,D.localize)(43,null,f):c?(0,D.localize)(44,null,f):(0,D.localize)(45,null,f)):(f=Math.floor(m/P),l?f===1?c?(0,D.localize)(46,null,f):(0,D.localize)(47,null,f):c?(0,D.localize)(48,null,f):(0,D.localize)(49,null,f):f===1?c?(0,D.localize)(50,null,f):(0,D.localize)(51,null,f):c?(0,D.localize)(52,null,f):(0,D.localize)(53,null,f))}function E(p,l){const c=Math.abs(p/1e3);return c<1?l?(0,D.localize)(54,null,p):(0,D.localize)(55,null,p):c<N?l?(0,D.localize)(56,null,Math.round(p)/1e3):(0,D.localize)(57,null,Math.round(p)/1e3):c<L?l?(0,D.localize)(58,null,Math.round(p/(1e3*N))):(0,D.localize)(59,null,Math.round(p/(1e3*N))):c<A?l?(0,D.localize)(60,null,Math.round(p/(1e3*L))):(0,D.localize)(61,null,Math.round(p/(1e3*L))):(0,D.localize)(62,null,Math.round(p/(1e3*A)))}function y(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ae[137],ce([11,10]),function(ne,e){return ne.create("vs/base/common/errorMessage",e)}),define(ae[38],ce([0,1,17,13,137]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=P,e.$kj=d,e.$lj=E;function A(y,p){return p&&(y.stack||y.stacktrace)?L.localize(0,null,I(y),O(y.stack)||O(y.stacktrace)):I(y)}function O(y){return Array.isArray(y)?y.join(`
`):y}function I(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?L.localize(1,null,y.message):y.message||L.localize(2,null)}function P(y=null,p=!1){if(!y)return L.localize(3,null);if(Array.isArray(y)){const l=D.$Hb(y),c=P(l[0],p);return l.length>1?L.localize(4,null,c,l.length):c}if(N.$$f(y))return y;if(y.detail){const l=y.detail;if(l.error)return A(l.error,p);if(l.exception)return A(l.exception,p)}return y.stack?A(y,p):y.message?y.message:L.localize(5,null)}function d(y){const p=y;return p instanceof Error&&Array.isArray(p.actions)}function E(y,p){let l;return typeof y=="string"?l=new Error(y):l=y,l.actions=p,l}}),define(ae[138],ce([11,10]),function(ne,e){return ne.create("vs/base/common/jsonErrorMessages",e)}),define(ae[139],ce([0,1,138]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=N;function N(L){switch(L){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}}),define(ae[140],ce([11,10]),function(ne,e){return ne.create("vs/base/common/platform",e)}),define(ae[5],ce([0,1,140]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=w,e.$J=S,e.$g="en";let N=!1,L=!1,A=!1,O=!1,I=!1,P=!1,d=!1,E=!1,y=!1,p=!1,l,c=e.$g,b=e.$g,m,f;const u=globalThis;let h;typeof u.vscode<"u"&&typeof u.vscode.process<"u"?h=u.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(h=process);const g=typeof h?.versions?.electron=="string",$=g&&h?.type==="renderer";if(typeof h=="object"){N=h.platform==="win32",L=h.platform==="darwin",A=h.platform==="linux",O=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,d=g,y=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,c=e.$g;const v=h.env.VSCODE_NLS_CONFIG;if(v)try{const k=JSON.parse(v),C=k.availableLanguages["*"];l=k.locale,b=k.osLocale,c=C||e.$g,m=k._translationsConfigFile}catch{}I=!0}else typeof navigator=="object"&&!$?(f=navigator.userAgent,N=f.indexOf("Windows")>=0,L=f.indexOf("Macintosh")>=0,E=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=f.indexOf("Linux")>=0,p=f?.indexOf("Mobi")>=0,P=!0,l=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,c=l,b=navigator.language):console.error("Unable to resolve platform.");var t;(function(v){v[v.Web=0]="Web",v[v.Mac=1]="Mac",v[v.Linux=2]="Linux",v[v.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(v){switch(v){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let n=0;L?n=1:N?n=3:A&&(n=2),e.$i=N,e.$j=L,e.$k=A,e.$l=O,e.$m=I,e.$n=d,e.$o=P,e.$p=P&&typeof u.importScripts=="function",e.$q=e.$p?u.origin:void 0,e.$r=E,e.$s=p,e.$t=y,e.$u=n,e.$v=f,e.$w=c;var s;(function(v){function k(){return e.$w}v.value=k;function C(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}v.isDefaultVariant=C;function R(){return e.$w==="en"}v.isDefault=R})(s||(e.Language=s={})),e.$x=l,e.$y=b,e.$z=m,e.$A=typeof u.postMessage=="function"&&!u.importScripts,e.$B=(()=>{if(e.$A){const v=[];u.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let R=0,M=v.length;R<M;R++){const T=v[R];if(T.id===C.data.vscodeScheduleAsyncWork){v.splice(R,1),T.callback();return}}});let k=0;return C=>{const R=++k;v.push({id:R,callback:C}),u.postMessage({vscodeScheduleAsyncWork:R},"*")}}return v=>setTimeout(v)})();var i;(function(v){v[v.Windows=1]="Windows",v[v.Macintosh=2]="Macintosh",v[v.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=L||E?2:N?1:3;let o=!0,a=!1;function w(){if(!a){a=!0;const v=new Uint8Array(2);v[0]=1,v[1]=2,o=new Uint16Array(v.buffer)[0]===513}return o}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function S(v){return parseFloat(v)>=20}}),define(ae[36],ce([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.process<"u"){const A=L.process;N={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(ae[141],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VV=O;var N;(function(I){I.UNKNOWN="UNKNOWN",I.CINNAMON="CINNAMON",I.DEEPIN="DEEPIN",I.GNOME="GNOME",I.KDE3="KDE3",I.KDE4="KDE4",I.KDE5="KDE5",I.KDE6="KDE6",I.PANTHEON="PANTHEON",I.UNITY="UNITY",I.XFCE="XFCE",I.UKUI="UKUI",I.LXQT="LXQT"})(N||(N={}));const L="XDG_CURRENT_DESKTOP",A="KDE_SESSION_VERSION";function O(){const I=D.env[L];if(I){const d=I.split(":").map(E=>E.trim()).filter(E=>E.length>0);for(const E of d)switch(E){case"Unity":{const y=D.env.DESKTOP_SESSION;return y&&y.includes("gnome-fallback")?N.GNOME:N.UNITY}case"Deepin":return N.DEEPIN;case"GNOME":return N.GNOME;case"X-Cinnamon":return N.CINNAMON;case"KDE":{const y=D.env[A];return y==="5"?N.KDE5:y==="6"?N.KDE6:N.KDE4}case"Pantheon":return N.PANTHEON;case"XFCE":return N.XFCE;case"UKUI":return N.UKUI;case"LXQt":return N.LXQT}}const P=D.env.DESKTOP_SESSION;if(P)switch(P){case"deepin":return N.DEEPIN;case"gnome":case"mate":return N.GNOME;case"kde4":case"kde-plasma":return N.KDE4;case"kde":return A in D.env?N.KDE4:N.KDE3;case"xfce":case"xubuntu":return N.XFCE;case"ukui":return N.UKUI}return"GNOME_DESKTOP_SESSION_ID"in D.env?N.GNOME:"KDE_FULL_SESSION"in D.env?A in D.env?N.KDE4:N.KDE3:N.UNKNOWN}}),define(ae[14],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,L=97,A=90,O=122,I=46,P=47,d=92,E=58,y=63;class p extends Error{constructor(r,n,s){let i;typeof n=="string"&&n.indexOf("not ")===0?(i="must not be",n=n.replace(/^not /,"")):i="must be";const o=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${o} ${i} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(t,r){if(t===null||typeof t!="object")throw new p(r,"Object",t)}function c(t,r){if(typeof t!="string")throw new p(r,"string",t)}const b=D.$dc==="win32";function m(t){return t===P||t===d}function f(t){return t===P}function u(t){return t>=N&&t<=A||t>=L&&t<=O}function h(t,r,n,s){let i="",o=0,a=-1,w=0,S=0;for(let v=0;v<=t.length;++v){if(v<t.length)S=t.charCodeAt(v);else{if(s(S))break;S=P}if(s(S)){if(!(a===v-1||w===1))if(w===2){if(i.length<2||o!==2||i.charCodeAt(i.length-1)!==I||i.charCodeAt(i.length-2)!==I){if(i.length>2){const k=i.lastIndexOf(n);k===-1?(i="",o=0):(i=i.slice(0,k),o=i.length-1-i.lastIndexOf(n)),a=v,w=0;continue}else if(i.length!==0){i="",o=0,a=v,w=0;continue}}r&&(i+=i.length>0?`${n}..`:"..",o=2)}else i.length>0?i+=`${n}${t.slice(a+1,v)}`:i=t.slice(a+1,v),o=v-a-1;a=v,w=0}else S===I&&w!==-1?++w:w=-1}return i}function g(t,r){l(r,"pathObject");const n=r.dir||r.root,s=r.base||`${r.name||""}${r.ext||""}`;return n?n===r.root?`${n}${s}`:`${n}${t}${s}`:s}e.$fc={resolve(...t){let r="",n="",s=!1;for(let i=t.length-1;i>=-1;i--){let o;if(i>=0){if(o=t[i],c(o,"path"),o.length===0)continue}else r.length===0?o=D.cwd():(o=D.env[`=${r}`]||D.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===d)&&(o=`${r}\\`));const a=o.length;let w=0,S="",v=!1;const k=o.charCodeAt(0);if(a===1)m(k)&&(w=1,v=!0);else if(m(k))if(v=!0,m(o.charCodeAt(1))){let C=2,R=C;for(;C<a&&!m(o.charCodeAt(C));)C++;if(C<a&&C!==R){const M=o.slice(R,C);for(R=C;C<a&&m(o.charCodeAt(C));)C++;if(C<a&&C!==R){for(R=C;C<a&&!m(o.charCodeAt(C));)C++;(C===a||C!==R)&&(S=`\\\\${M}\\${o.slice(R,C)}`,w=C)}}}else w=1;else u(k)&&o.charCodeAt(1)===E&&(S=o.slice(0,2),w=2,a>2&&m(o.charCodeAt(2))&&(v=!0,w=3));if(S.length>0)if(r.length>0){if(S.toLowerCase()!==r.toLowerCase())continue}else r=S;if(s){if(r.length>0)break}else if(n=`${o.slice(w)}\\${n}`,s=v,v&&r.length>0)break}return n=h(n,!s,"\\",m),s?`${r}\\${n}`:`${r}${n}`||"."},normalize(t){c(t,"path");const r=t.length;if(r===0)return".";let n=0,s,i=!1;const o=t.charCodeAt(0);if(r===1)return f(o)?"\\":t;if(m(o))if(i=!0,m(t.charCodeAt(1))){let w=2,S=w;for(;w<r&&!m(t.charCodeAt(w));)w++;if(w<r&&w!==S){const v=t.slice(S,w);for(S=w;w<r&&m(t.charCodeAt(w));)w++;if(w<r&&w!==S){for(S=w;w<r&&!m(t.charCodeAt(w));)w++;if(w===r)return`\\\\${v}\\${t.slice(S)}\\`;w!==S&&(s=`\\\\${v}\\${t.slice(S,w)}`,n=w)}}}else n=1;else u(o)&&t.charCodeAt(1)===E&&(s=t.slice(0,2),n=2,r>2&&m(t.charCodeAt(2))&&(i=!0,n=3));let a=n<r?h(t.slice(n),!i,"\\",m):"";return a.length===0&&!i&&(a="."),a.length>0&&m(t.charCodeAt(r-1))&&(a+="\\"),s===void 0?i?`\\${a}`:a:i?`${s}\\${a}`:`${s}${a}`},isAbsolute(t){c(t,"path");const r=t.length;if(r===0)return!1;const n=t.charCodeAt(0);return m(n)||r>2&&u(n)&&t.charCodeAt(1)===E&&m(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,n;for(let o=0;o<t.length;++o){const a=t[o];c(a,"path"),a.length>0&&(r===void 0?r=n=a:r+=`\\${a}`)}if(r===void 0)return".";let s=!0,i=0;if(typeof n=="string"&&m(n.charCodeAt(0))){++i;const o=n.length;o>1&&m(n.charCodeAt(1))&&(++i,o>2&&(m(n.charCodeAt(2))?++i:s=!1))}if(s){for(;i<r.length&&m(r.charCodeAt(i));)i++;i>=2&&(r=`\\${r.slice(i)}`)}return e.$fc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r)return"";const n=e.$fc.resolve(t),s=e.$fc.resolve(r);if(n===s||(t=n.toLowerCase(),r=s.toLowerCase(),t===r))return"";let i=0;for(;i<t.length&&t.charCodeAt(i)===d;)i++;let o=t.length;for(;o-1>i&&t.charCodeAt(o-1)===d;)o--;const a=o-i;let w=0;for(;w<r.length&&r.charCodeAt(w)===d;)w++;let S=r.length;for(;S-1>w&&r.charCodeAt(S-1)===d;)S--;const v=S-w,k=a<v?a:v;let C=-1,R=0;for(;R<k;R++){const T=t.charCodeAt(i+R);if(T!==r.charCodeAt(w+R))break;T===d&&(C=R)}if(R!==k){if(C===-1)return s}else{if(v>k){if(r.charCodeAt(w+R)===d)return s.slice(w+R+1);if(R===2)return s.slice(w+R)}a>k&&(t.charCodeAt(i+R)===d?C=R:R===2&&(C=3)),C===-1&&(C=0)}let M="";for(R=i+C+1;R<=o;++R)(R===o||t.charCodeAt(R)===d)&&(M+=M.length===0?"..":"\\..");return w+=C,M.length>0?`${M}${s.slice(w,S)}`:(s.charCodeAt(w)===d&&++w,s.slice(w,S))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$fc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===d){if(r.charCodeAt(1)===d){const n=r.charCodeAt(2);if(n!==y&&n!==I)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===E&&r.charCodeAt(2)===d)return`\\\\?\\${r}`;return t},dirname(t){c(t,"path");const r=t.length;if(r===0)return".";let n=-1,s=0;const i=t.charCodeAt(0);if(r===1)return m(i)?t:".";if(m(i)){if(n=s=1,m(t.charCodeAt(1))){let w=2,S=w;for(;w<r&&!m(t.charCodeAt(w));)w++;if(w<r&&w!==S){for(S=w;w<r&&m(t.charCodeAt(w));)w++;if(w<r&&w!==S){for(S=w;w<r&&!m(t.charCodeAt(w));)w++;if(w===r)return t;w!==S&&(n=s=w+1)}}}}else u(i)&&t.charCodeAt(1)===E&&(n=r>2&&m(t.charCodeAt(2))?3:2,s=n);let o=-1,a=!0;for(let w=r-1;w>=s;--w)if(m(t.charCodeAt(w))){if(!a){o=w;break}}else a=!1;if(o===-1){if(n===-1)return".";o=n}return t.slice(0,o)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(t.length>=2&&u(t.charCodeAt(0))&&t.charCodeAt(1)===E&&(n=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,w=-1;for(o=t.length-1;o>=n;--o){const S=t.charCodeAt(o);if(m(S)){if(!i){n=o+1;break}}else w===-1&&(i=!1,w=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=n;--o)if(m(t.charCodeAt(o))){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=0,n=-1,s=0,i=-1,o=!0,a=0;t.length>=2&&t.charCodeAt(1)===E&&u(t.charCodeAt(0))&&(r=s=2);for(let w=t.length-1;w>=r;--w){const S=t.charCodeAt(w);if(m(S)){if(!o){s=w+1;break}continue}i===-1&&(o=!1,i=w+1),S===I?n===-1?n=w:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||i===-1||a===0||a===1&&n===i-1&&n===s+1?"":t.slice(n,i)},format:g.bind(null,"\\"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.length;let s=0,i=t.charCodeAt(0);if(n===1)return m(i)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(m(i)){if(s=1,m(t.charCodeAt(1))){let C=2,R=C;for(;C<n&&!m(t.charCodeAt(C));)C++;if(C<n&&C!==R){for(R=C;C<n&&m(t.charCodeAt(C));)C++;if(C<n&&C!==R){for(R=C;C<n&&!m(t.charCodeAt(C));)C++;C===n?s=C:C!==R&&(s=C+1)}}}}else if(u(i)&&t.charCodeAt(1)===E){if(n<=2)return r.root=r.dir=t,r;if(s=2,m(t.charCodeAt(2))){if(n===3)return r.root=r.dir=t,r;s=3}}s>0&&(r.root=t.slice(0,s));let o=-1,a=s,w=-1,S=!0,v=t.length-1,k=0;for(;v>=s;--v){if(i=t.charCodeAt(v),m(i)){if(!S){a=v+1;break}continue}w===-1&&(S=!1,w=v+1),i===I?o===-1?o=v:k!==1&&(k=1):o!==-1&&(k=-1)}return w!==-1&&(o===-1||k===0||k===1&&o===w-1&&o===a+1?r.base=r.name=t.slice(a,w):(r.name=t.slice(a,o),r.base=t.slice(a,w),r.ext=t.slice(o,w))),a>0&&a!==s?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const $=(()=>{if(b){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$gc={resolve(...t){let r="",n=!1;for(let s=t.length-1;s>=-1&&!n;s--){const i=s>=0?t[s]:$();c(i,"path"),i.length!==0&&(r=`${i}/${r}`,n=i.charCodeAt(0)===P)}return r=h(r,!n,"/",f),n?`/${r}`:r.length>0?r:"."},normalize(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P,n=t.charCodeAt(t.length-1)===P;return t=h(t,!r,"/",f),t.length===0?r?"/":n?"./":".":(n&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return c(t,"path"),t.length>0&&t.charCodeAt(0)===P},join(...t){if(t.length===0)return".";let r;for(let n=0;n<t.length;++n){const s=t[n];c(s,"path"),s.length>0&&(r===void 0?r=s:r+=`/${s}`)}return r===void 0?".":e.$gc.normalize(r)},relative(t,r){if(c(t,"from"),c(r,"to"),t===r||(t=e.$gc.resolve(t),r=e.$gc.resolve(r),t===r))return"";const n=1,s=t.length,i=s-n,o=1,a=r.length-o,w=i<a?i:a;let S=-1,v=0;for(;v<w;v++){const C=t.charCodeAt(n+v);if(C!==r.charCodeAt(o+v))break;C===P&&(S=v)}if(v===w)if(a>w){if(r.charCodeAt(o+v)===P)return r.slice(o+v+1);if(v===0)return r.slice(o+v)}else i>w&&(t.charCodeAt(n+v)===P?S=v:v===0&&(S=0));let k="";for(v=n+S+1;v<=s;++v)(v===s||t.charCodeAt(v)===P)&&(k+=k.length===0?"..":"/..");return`${k}${r.slice(o+S)}`},toNamespacedPath(t){return t},dirname(t){if(c(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===P;let n=-1,s=!0;for(let i=t.length-1;i>=1;--i)if(t.charCodeAt(i)===P){if(!s){n=i;break}}else s=!1;return n===-1?r?"/":".":r&&n===1?"//":t.slice(0,n)},basename(t,r){r!==void 0&&c(r,"ext"),c(t,"path");let n=0,s=-1,i=!0,o;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,w=-1;for(o=t.length-1;o>=0;--o){const S=t.charCodeAt(o);if(S===P){if(!i){n=o+1;break}}else w===-1&&(i=!1,w=o+1),a>=0&&(S===r.charCodeAt(a)?--a===-1&&(s=o):(a=-1,s=w))}return n===s?s=w:s===-1&&(s=t.length),t.slice(n,s)}for(o=t.length-1;o>=0;--o)if(t.charCodeAt(o)===P){if(!i){n=o+1;break}}else s===-1&&(i=!1,s=o+1);return s===-1?"":t.slice(n,s)},extname(t){c(t,"path");let r=-1,n=0,s=-1,i=!0,o=0;for(let a=t.length-1;a>=0;--a){const w=t.charCodeAt(a);if(w===P){if(!i){n=a+1;break}continue}s===-1&&(i=!1,s=a+1),w===I?r===-1?r=a:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||s===-1||o===0||o===1&&r===s-1&&r===n+1?"":t.slice(r,s)},format:g.bind(null,"/"),parse(t){c(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const n=t.charCodeAt(0)===P;let s;n?(r.root="/",s=1):s=0;let i=-1,o=0,a=-1,w=!0,S=t.length-1,v=0;for(;S>=s;--S){const k=t.charCodeAt(S);if(k===P){if(!w){o=S+1;break}continue}a===-1&&(w=!1,a=S+1),k===I?i===-1?i=S:v!==1&&(v=1):i!==-1&&(v=-1)}if(a!==-1){const k=o===0&&n?1:o;i===-1||v===0||v===1&&i===a-1&&i===o+1?r.base=r.name=t.slice(k,a):(r.name=t.slice(k,i),r.base=t.slice(k,a),r.ext=t.slice(i,a))}return o>0?r.dir=t.slice(0,o-1):n&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=b?e.$fc.normalize:e.$gc.normalize,e.$ic=b?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=b?e.$fc.join:e.$gc.join,e.$kc=b?e.$fc.resolve:e.$gc.resolve,e.$lc=b?e.$fc.relative:e.$gc.relative,e.$mc=b?e.$fc.dirname:e.$gc.dirname,e.$nc=b?e.$fc.basename:e.$gc.basename,e.$oc=b?e.$fc.extname:e.$gc.extname,e.$pc=b?e.$fc.format:e.$gc.format,e.$qc=b?e.$fc.parse:e.$gc.parse,e.$rc=b?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=b?e.$fc.sep:e.$gc.sep,e.$tc=b?e.$fc.delimiter:e.$gc.delimiter}),define(ae[40],ce([0,1,14,5,27,13]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=O,e.$rg=I,e.$sg=P,e.$tg=d,e.$ug=E,e.$vg=c,e.$wg=b,e.$xg=m,e.$yg=f,e.$zg=u,e.$Ag=h,e.$Bg=g,e.$Cg=$,e.$Dg=t,e.$Eg=r,e.$Fg=n,e.$Gg=o;function O(a){return a===47||a===92}function I(a){return a.replace(/[\\/]/g,D.$gc.sep)}function P(a){return a.indexOf("/")===-1&&(a=I(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}function d(a,w=D.$gc.sep){if(!a)return"";const S=a.length,v=a.charCodeAt(0);if(O(v)){if(O(a.charCodeAt(1))&&!O(a.charCodeAt(2))){let C=3;const R=C;for(;C<S&&!O(a.charCodeAt(C));C++);if(R!==C&&!O(a.charCodeAt(C+1))){for(C+=1;C<S;C++)if(O(a.charCodeAt(C)))return a.slice(0,C+1).replace(/[\\/]/g,w)}}return w}else if(f(v)&&a.charCodeAt(1)===58)return O(a.charCodeAt(2))?a.slice(0,2)+w:a.slice(0,2);let k=a.indexOf("://");if(k!==-1){for(k+=3;k<S;k++)if(O(a.charCodeAt(k)))return a.slice(0,k+1)}return""}function E(a){if(!N.$i||!a||a.length<5)return!1;let w=a.charCodeAt(0);if(w!==92||(w=a.charCodeAt(1),w!==92))return!1;let S=2;const v=S;for(;S<a.length&&(w=a.charCodeAt(S),w!==92);S++);return!(v===S||(w=a.charCodeAt(S+1),isNaN(w)||w===92))}const y=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(a,w=N.$i){const S=w?y:p;return!(!a||a.length===0||/^\s+$/.test(a)||(S.lastIndex=0,S.test(a))||w&&l.test(a)||a==="."||a===".."||w&&a[a.length-1]==="."||w&&a.length!==a.trim().length||a.length>255)}function b(a,w,S){const v=a===w;return!S||v?v:!a||!w?!1:(0,L.$zf)(a,w)}function m(a,w,S,v=D.sep){if(a===w)return!0;if(!a||!w||w.length>a.length)return!1;if(S){if(!(0,L.$Af)(a,w))return!1;if(w.length===a.length)return!0;let C=w.length;return w.charAt(w.length-1)===v&&C--,a.charAt(C)===v}return w.charAt(w.length-1)!==v&&(w+=v),a.indexOf(w)===0}function f(a){return a>=65&&a<=90||a>=97&&a<=122}function u(a,w){return N.$i&&a.endsWith(":")&&(a+=D.sep),(0,D.$ic)(a)||(a=(0,D.$jc)(w,a)),a=(0,D.$hc)(a),h(a)}function h(a){return N.$i?(a=(0,L.$hf)(a,D.sep),a.endsWith(":")&&(a+=D.sep)):(a=(0,L.$hf)(a,D.sep),a||(a=D.sep)),a}function g(a){const w=(0,D.$hc)(a);return N.$i?a.length>3?!1:$(w)&&(a.length===2||w.charCodeAt(2)===92):w===D.$gc.sep}function $(a,w=N.$i){return w?f(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}function t(a,w=N.$i){return $(a,w)?a[0]:void 0}function r(a,w,S){return w.length>a.length?-1:a===w?0:(S&&(a=a.toLowerCase(),w=w.toLowerCase()),a.indexOf(w))}function n(a){const w=a.split(":");let S,v,k;for(const C of w){const R=Number(C);(0,A.$cg)(R)?v===void 0?v=R:k===void 0&&(k=R):S=S?[S,C].join(":"):C}if(!S)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:S,line:v!==void 0?v:void 0,column:k!==void 0?k:v!==void 0?1:void 0}}const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(a,w,S=8){let v="";for(let C=0;C<S;C++){let R;C===0&&N.$i&&!w&&(S===3||S===4)?R=i:R=s,v+=R.charAt(Math.floor(Math.random()*R.length))}let k;return w?k=`${w}-${v}`:k=v,a?(0,D.$jc)(a,k):k}}),define(ae[142],ce([0,1,14]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0,e.$Vs=A,e.$Ws=O,e.$Xs=I,e.$Ys=d,e.$Us=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},L={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(E){const y=(0,D.$oc)(E),p=N[y.toLowerCase()];return p!==void 0?p:O(E)}function O(E){const y=(0,D.$oc)(E);return L[y.toLowerCase()]}function I(E){for(const y in L)if(L[y]===E)return y}const P=/^(.+)\/(.+?)(;.+)?$/;function d(E,y){const p=P.exec(E);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:y?void 0:E}}),define(ae[89],ce([0,1,5]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=A,e.$pm=O;var N;(function(I){I[I.stdout=0]="stdout",I[I.stderr=1]="stderr"})(N||(e.Source=N={}));var L;(function(I){I[I.Success=0]="Success",I[I.Unknown=1]="Unknown",I[I.AccessDenied=2]="AccessDenied",I[I.ProcessNotFound=3]="ProcessNotFound"})(L||(e.TerminateResponseCode=L={}));function A(I,...P){const d=P.reduce((p,l)=>(p[l]=!0,p),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(I).filter(p=>!d[p]).forEach(p=>{for(let l=0;l<E.length;l++)if(p.search(E[l])!==-1){delete I[p];break}})}function O(I){I&&(delete I.DEBUG,D.$j&&delete I.DYLD_LIBRARY_PATH,D.$k&&delete I.LD_PRELOAD)}}),define(ae[8],ce([0,1,14,5]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$vc=c,e.$wc=g;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function I(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!L.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(s,i){return!s&&!i?"file":s}function d(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==y&&(i=y+i):i=y;break}return i}const E="",y="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(i){return i instanceof l?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,o,a,w,S,v=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,v),this.authority=o||E,this.path=d(this.scheme,a||E),this.query=w||E,this.fragment=S||E,I(this,v))}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:w,query:S,fragment:v}=i;return o===void 0?o=this.scheme:o===null&&(o=E),a===void 0?a=this.authority:a===null&&(a=E),w===void 0?w=this.path:w===null&&(w=E),S===void 0?S=this.query:S===null&&(S=E),v===void 0?v=this.fragment:v===null&&(v=E),o===this.scheme&&a===this.authority&&w===this.path&&S===this.query&&v===this.fragment?this:new m(o,a,w,S,v)}static parse(i,o=!1){const a=p.exec(i);return a?new m(a[2]||E,n(a[4]||E),n(a[5]||E),n(a[7]||E),n(a[9]||E),o):new m(E,E,E,E,E)}static file(i){let o=E;if(N.$i&&(i=i.replace(/\\/g,y)),i[0]===y&&i[1]===y){const a=i.indexOf(y,2);a===-1?(o=i.substring(2),i=y):(o=i.substring(2,a),i=i.substring(a)||y)}return new m("file",o,i,E,E)}static from(i,o){return new m(i.scheme,i.authority,i.path,i.query,i.fragment,o)}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return N.$i&&i.scheme==="file"?a=l.file(D.$fc.join(g(i,!0),...o)).path:a=D.$gc.join(i.path,...o),i.with({path:a})}toString(i=!1){return $(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof l)return i;{const o=new m(i);return o._formatted=i.external??null,o._fsPath=i._sep===b?i.fsPath??null:null,o}}else return i}}e.URI=l;function c(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}const b=N.$i?1:void 0;class m extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?$(this,!0):(this._formatted||(this._formatted=$(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=b),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const f={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function u(s,i,o){let a,w=-1;for(let S=0;S<s.length;S++){const v=s.charCodeAt(S);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47||o&&v===91||o&&v===93||o&&v===58)w!==-1&&(a+=encodeURIComponent(s.substring(w,S)),w=-1),a!==void 0&&(a+=s.charAt(S));else{a===void 0&&(a=s.substr(0,S));const k=f[v];k!==void 0?(w!==-1&&(a+=encodeURIComponent(s.substring(w,S)),w=-1),a+=k):w===-1&&(w=S)}}return w!==-1&&(a+=encodeURIComponent(s.substring(w))),a!==void 0?a:s}function h(s){let i;for(let o=0;o<s.length;o++){const a=s.charCodeAt(o);a===35||a===63?(i===void 0&&(i=s.substr(0,o)),i+=f[a]):i!==void 0&&(i+=s[o])}return i!==void 0?i:s}function g(s,i){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,N.$i&&(o=o.replace(/\//g,"\\")),o}function $(s,i){const o=i?h:u;let a="",{scheme:w,authority:S,path:v,query:k,fragment:C}=s;if(w&&(a+=w,a+=":"),(S||w==="file")&&(a+=y,a+=y),S){let R=S.indexOf("@");if(R!==-1){const M=S.substr(0,R);S=S.substr(R+1),R=M.lastIndexOf(":"),R===-1?a+=o(M,!1,!1):(a+=o(M.substr(0,R),!1,!1),a+=":",a+=o(M.substr(R+1),!1,!0)),a+="@"}S=S.toLowerCase(),R=S.lastIndexOf(":"),R===-1?a+=o(S,!1,!0):(a+=o(S.substr(0,R),!1,!0),a+=S.substr(R))}if(v){if(v.length>=3&&v.charCodeAt(0)===47&&v.charCodeAt(2)===58){const R=v.charCodeAt(1);R>=65&&R<=90&&(v=`/${String.fromCharCode(R+32)}:${v.substr(3)}`)}else if(v.length>=2&&v.charCodeAt(1)===58){const R=v.charCodeAt(0);R>=65&&R<=90&&(v=`${String.fromCharCode(R+32)}:${v.substr(2)}`)}a+=o(v,!0,!1)}return k&&(a+="?",a+=o(k,!1,!1)),C&&(a+="#",a+=i?C:u(C,!1,!1)),a}function t(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+t(s.substr(3)):s}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(r)?s.replace(r,i=>t(i)):s}}),define(ae[143],ce([0,1,8]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=N,e.$1q=L,e.$2q=A,e.log=I;function N(d){const E=d;return E&&typeof E.type=="string"&&typeof E.severity=="string"}function L(d){const E=[];let y;try{const p=JSON.parse(d.arguments),l=p[p.length-1];l&&l.__$stack&&(p.pop(),y=l.__$stack),E.push(...p)}catch{E.push("Unable to log remote console arguments",d.arguments)}return{args:E,stack:y}}function A(d){if(typeof d!="string")return A(L(d).stack);const E=d;if(E){const y=O(E),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(y||"");if(p&&p.length===4)return{uri:D.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}function O(d){if(!d)return d;const E=d.indexOf(`
`);return E===-1?d:d.substring(0,E)}function I(d,E){const{args:y,stack:p}=L(d),l=typeof y[0]=="string"&&y.length===1;let c=O(p);c&&(c=`(${c.trim()})`);let b=[];if(typeof y[0]=="string"?c&&l?b=[`%c[${E}] %c${y[0]} %c${c}`,P("blue"),P(""),P("grey")]:b=[`%c[${E}] %c${y[0]}`,P("blue"),P(""),...y.slice(1)]:b=[`%c[${E}]%`,P("blue"),...y],c&&!l&&b.push(c),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,b)}function P(d){return`color: ${d}`}}),define(ae[66],ce([0,1,15,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=L,e.$7h=A,e.$8h=I;function L(P){return JSON.stringify(P,O)}function A(P){let d=JSON.parse(P);return d=I(d),d}function O(P,d){return d instanceof RegExp?{$mid:2,source:d.source,flags:d.flags}:d}function I(P,d=0){if(!P||d>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return N.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 17:return new Date(P.source)}if(P instanceof D.$He||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let E=0;E<P.length;++E)P[E]=I(P[E],d+1);else for(const E in P)Object.hasOwnProperty.call(P,E)&&(P[E]=I(P[E],d+1))}return P}}),define(ae[23],ce([0,1,7,5,27,8,14]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=P,e.$Ig=d,e.$Mg=y;var I;(function(c){c.inMemory="inmemory",c.vscode="vscode",c.internal="private",c.walkThrough="walkThrough",c.walkThroughSnippet="walkThroughSnippet",c.http="http",c.https="https",c.file="file",c.mailto="mailto",c.untitled="untitled",c.data="data",c.command="command",c.vscodeRemote="vscode-remote",c.vscodeRemoteResource="vscode-remote-resource",c.vscodeManagedRemoteResource="vscode-managed-remote-resource",c.vscodeUserData="vscode-userdata",c.vscodeCustomEditor="vscode-custom-editor",c.vscodeNotebookCell="vscode-notebook-cell",c.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",c.vscodeNotebookCellOutput="vscode-notebook-cell-output",c.vscodeInteractiveInput="vscode-interactive-input",c.vscodeSettings="vscode-settings",c.vscodeWorkspaceTrust="vscode-workspace-trust",c.vscodeTerminal="vscode-terminal",c.vscodeChatCodeBlock="vscode-chat-code-block",c.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",c.vscodeChatSesssion="vscode-chat-editor",c.webviewPanel="webview-panel",c.vscodeWebview="vscode-webview",c.extension="extension",c.vscodeFileResource="vscode-file",c.tmp="tmp",c.vsls="vsls",c.vscodeSourceControl="vscode-scm",c.commentsInput="comment",c.codeSetting="code-setting"})(I||(e.Schemas=I={}));function P(c,b){return A.URI.isUri(c)?(0,L.$zf)(c.scheme,b):(0,L.$Af)(c,b+":")}function d(c,...b){return b.some(m=>P(c,m))}e.$Jg="vscode-tkn",e.$Kg="tkn";class E{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(b){this.d=b}setDelegate(b){this.e=b}setServerRootPath(b,m){this.f=y(b,m)}getServerRootPath(){return this.f}get g(){return O.$gc.join(this.f,I.vscodeRemoteResource)}set(b,m,f){this.a[b]=m,this.b[b]=f}setConnectionToken(b,m){this.c[b]=m}getPreferredWebSchema(){return this.d}rewrite(b){if(this.e)try{return this.e(b)}catch($){return D.$1($),b}const m=b.authority;let f=this.a[m];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const u=this.b[m],h=this.c[m];let g=`path=${encodeURIComponent(b.path)}`;return typeof h=="string"&&(g+=`&${e.$Kg}=${encodeURIComponent(h)}`),A.URI.from({scheme:N.$o?this.d:I.vscodeRemoteResource,authority:`${f}:${u}`,path:this.g,query:g})}}e.$Lg=new E;function y(c,b){return O.$gc.join(b??"/",`${c.quality??"oss"}-${c.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class p{static{this.a=e.$Rg}asBrowserUri(b){const m=this.b(b,ne);return this.uriToBrowserUri(m)}uriToBrowserUri(b){return b.scheme===I.vscodeRemote?e.$Lg.rewrite(b):b.scheme===I.file&&(N.$m||N.$q===`${I.vscodeFileResource}://${p.a}`)?b.with({scheme:I.vscodeFileResource,authority:b.authority||p.a,query:null,fragment:null}):b}asFileUri(b){const m=this.b(b,ne);return this.uriToFileUri(m)}uriToFileUri(b){return b.scheme===I.vscodeFileResource?b.with({scheme:I.file,authority:b.authority!==p.a?b.authority:null,query:null,fragment:null}):b}b(b,m){return A.URI.isUri(b)?b:A.URI.parse(m.toUrl(b))}}e.$Sg=new p;var l;(function(c){const b=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);c.CoopAndCoep=Object.freeze(b.get("3"));const m="vscode-coi";function f(h){let g;typeof h=="string"?g=new URL(h).searchParams:h instanceof URL?g=h.searchParams:A.URI.isUri(h)&&(g=new URL(h.toString(!0)).searchParams);const $=g?.get(m);if($)return b.get($)}c.getHeadersFromQuery=f;function u(h,g,$){if(!globalThis.crossOriginIsolated)return;const t=g&&$?"3":$?"2":"1";h instanceof URLSearchParams?h.set(m,t):h[m]=t}c.addSearchParam=u})(l||(e.COI=l={}))}),define(ae[144],ce([0,1,125,23,5,8]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_D=E;class O{constructor(p,l,c){this.id=p,this.dependencies=l,this.callback=c}}class I{static{this.INSTANCE=new I}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(p,l,c)=>{typeof p!="string"&&(c=l,l=p,p=null),(typeof l!="object"||!Array.isArray(l))&&(c=l,l=null),this.c.push(new O(p,l,c))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){if(p.startsWith(window.location.origin)||p.startsWith("vscode-file://vscode-app"))return p;throw new Error(`[trusted_script_src] Invalid script url: ${p}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(p){return p}})))}async load(p){this.g();const l=await(this.a?this.i(p):this.b?this.h(p):this.j(p));if(!l)throw new Error(`Did not receive a define call from script ${p}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${p}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(p){return new Promise((l,c)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const m=()=>{b.removeEventListener("load",f),b.removeEventListener("error",u)},f=h=>{m(),l(this.c.pop())},u=h=>{m(),c(h)};b.addEventListener("load",f),b.addEventListener("error",u),this.f&&(p=this.f.createScriptURL(p)),b.setAttribute("src",p),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(p){return new Promise((l,c)=>{try{this.f&&(p=this.f.createScriptURL(p)),importScripts(p),l(this.c.pop())}catch(b){c(b)}})}async j(p){try{const l=globalThis._VSCODE_NODE_MODULES.fs,c=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,m=A.URI.parse(p).fsPath,f=l.readFileSync(m).toString(),u=b.wrap(f.replace(/^#!.*/,""));return new c.Script(u).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const P=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function E(y,p,l){if(D.$T){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[y]&&(y=d[y]);const c=`${y}/${p}`;if(P.has(c))return P.get(c);let b;if(/^\w[\w\d+.-]*:\/\//.test(c))b=c;else{const h=`${l&&!L.$o?N.$Pg:N.$Og}/${c}`;b=N.$Sg.asBrowserUri(h).toString(!0)}const m=I.INSTANCE.load(b);return P.set(c,m),m}else return await new Promise((c,b)=>{ne([y],c,b)})}}),define(ae[20],ce([0,1,40,23,14,5,27,8]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=P,e.$ih=E,e.$jh=p;function P(l){return(0,I.$wc)(l,!0)}class d{constructor(c){this.a=c}compare(c,b,m=!1){return c===b?0:(0,O.$sf)(this.getComparisonKey(c,m),this.getComparisonKey(b,m))}isEqual(c,b,m=!1){return c===b?!0:!c||!b?!1:this.getComparisonKey(c,m)===this.getComparisonKey(b,m)}getComparisonKey(c,b=!1){return c.with({path:this.a(c)?c.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing(c){return this.a(c)}isEqualOrParent(c,b,m=!1){if(c.scheme===b.scheme){if(c.scheme===N.Schemas.file)return D.$xg(P(c),P(b),this.a(c))&&c.query===b.query&&(m||c.fragment===b.fragment);if((0,e.$eh)(c.authority,b.authority))return D.$xg(c.path,b.path,this.a(c),"/")&&c.query===b.query&&(m||c.fragment===b.fragment)}return!1}joinPath(c,...b){return I.URI.joinPath(c,...b)}basenameOrAuthority(c){return(0,e.$9g)(c)||c.authority}basename(c){return L.$gc.basename(c.path)}extname(c){return L.$gc.extname(c.path)}dirname(c){if(c.path.length===0)return c;let b;return c.scheme===N.Schemas.file?b=I.URI.file(L.$mc(P(c))).path:(b=L.$gc.dirname(c.path),c.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),b="/")),c.with({path:b})}normalizePath(c){if(!c.path.length)return c;let b;return c.scheme===N.Schemas.file?b=I.URI.file(L.$hc(P(c))).path:b=L.$gc.normalize(c.path),c.with({path:b})}relativePath(c,b){if(c.scheme!==b.scheme||!(0,e.$eh)(c.authority,b.authority))return;if(c.scheme===N.Schemas.file){const u=L.$lc(P(c),P(b));return A.$i?D.$rg(u):u}let m=c.path||"/";const f=b.path||"/";if(this.a(c)){let u=0;for(const h=Math.min(m.length,f.length);u<h&&!(m.charCodeAt(u)!==f.charCodeAt(u)&&m.charAt(u).toLowerCase()!==f.charAt(u).toLowerCase());u++);m=f.substr(0,u)+m.substr(u)}return L.$gc.relative(m,f)}resolvePath(c,b){if(c.scheme===N.Schemas.file){const m=I.URI.file(L.$kc(P(c),b));return c.with({authority:m.authority,path:m.path})}return b=D.$sg(b),c.with({path:L.$gc.resolve(c.path,b)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,b){return c===b||c!==void 0&&b!==void 0&&(0,O.$zf)(c,b)}hasTrailingPathSeparator(c,b=L.sep){if(c.scheme===N.Schemas.file){const m=P(c);return m.length>D.$tg(m).length&&m[m.length-1]===b}else{const m=c.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,b=L.sep){return(0,e.$fh)(c,b)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,b=L.sep){let m=!1;if(c.scheme===N.Schemas.file){const f=P(c);m=f!==void 0&&f.length===D.$tg(f).length&&f[f.length-1]===b}else{b="/";const f=c.path;m=f.length===1&&f.charCodeAt(f.length-1)===47}return!m&&!(0,e.$fh)(c,b)?c.with({path:c.path+"/"}):c}}e.$1g=d,e.$2g=new d(()=>!1),e.$3g=new d(l=>l.scheme===N.Schemas.file?!A.$k:!0),e.$4g=new d(l=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function E(l,c){const b=[];for(let m=0;m<l.length;m++){const f=c(l[m]);l.some((u,h)=>h===m?!1:(0,e.$6g)(f,c(u)))||b.push(l[m])}return b}var y;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function c(b){const m=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(h=>{const[g,$]=h.split(":");g&&$&&m.set(g,$)});const u=b.path.substring(0,b.path.indexOf(";"));return u&&m.set(l.META_DATA_MIME,u),m}l.parseMetaData=c})(y||(e.DataUri=y={}));function p(l,c,b){if(c){let m=l.path;return m&&m[0]!==L.$gc.sep&&(m=L.$gc.sep+m),l.with({scheme:b,authority:c,path:m})}return l.with({scheme:b})}}),define(ae[6],ce([0,1,26,7,3,2,20,5,131,53]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=E,e.$lh=y,e.$mh=p,e.$nh=l,e.$oh=c,e.$ph=b,e.$qh=m,e.$rh=f,e.$zh=o,e.$Ah=a,e.$Bh=w,e.$Ch=S,e.$Dh=v,e.$Sh=H,e.$1h=Q;function E(te){return!!te&&typeof te.then=="function"}function y(te){const _=new D.$qe,oe=te(_.token),ue=new Promise(($e,de)=>{const ge=_.token.onCancellationRequested(()=>{ge.dispose(),de(new N.$5)});Promise.resolve(oe).then(be=>{ge.dispose(),_.dispose(),$e(be)},be=>{ge.dispose(),_.dispose(),de(be)})});return new class{cancel(){_.cancel(),_.dispose()}then($e,de){return ue.then($e,de)}catch($e){return this.then(void 0,$e)}finally($e){return ue.finally($e)}}}function p(te,_,oe){return new Promise((ue,$e)=>{const de=_.onCancellationRequested(()=>{de.dispose(),ue(oe)});te.then(ue,$e).finally(()=>de.dispose())})}function l(te,_){return new Promise((oe,ue)=>{const $e=_.onCancellationRequested(()=>{$e.dispose(),ue(new N.$5)});te.then(oe,ue).finally(()=>$e.dispose())})}async function c(te){let _=-1;const oe=te.map((ue,$e)=>ue.then(de=>(_=$e,de)));try{return await Promise.race(oe)}finally{te.forEach((ue,$e)=>{$e!==_&&ue.cancel()})}}function b(te,_,oe){let ue;const $e=setTimeout(()=>{ue?.(void 0),oe?.()},_);return Promise.race([te.finally(()=>clearTimeout($e)),new Promise(de=>ue=de)])}function m(te){return new Promise((_,oe)=>{const ue=te();E(ue)?ue.then(_,oe):_(ue)})}function f(){let te,_;return{promise:new Promise((ue,$e)=>{te=ue,_=$e}),resolve:te,reject:_}}class u{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(_){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=_,!this.b){const oe=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(oe,oe).then(ue)})}return new Promise((oe,ue)=>{this.b.then(oe,ue)})}return this.a=_(),new Promise((oe,ue)=>{this.a.then($e=>{this.a=null,oe($e)},$e=>{this.a=null,ue($e)})})}dispose(){this.f=!0}}e.$sh=u;class h{constructor(){this.a=Promise.resolve(null)}queue(_){return this.a=this.a.then(()=>_(),()=>_())}}e.$th=h;class g{constructor(){this.a=new Map}queue(_,oe){const $e=(this.a.get(_)??Promise.resolve()).catch(()=>{}).then(oe).finally(()=>{this.a.get(_)===$e&&this.a.delete(_)});return this.a.set(_,$e),$e}}e.$uh=g;const $=(te,_)=>{let oe=!0;const ue=setTimeout(()=>{oe=!1,_()},te);return{isTriggered:()=>oe,dispose:()=>{clearTimeout(ue),oe=!1}}},t=te=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,te())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};class r{constructor(_){this.defaultDelay=_,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(_,oe=this.defaultDelay){this.g=_,this.h(),this.b||(this.b=new Promise(($e,de)=>{this.d=$e,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const $e=this.g;return this.g=null,$e()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=oe===P.$ce?t(ue):$(oe,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=r;class n{constructor(_){this.a=new r(_),this.b=new u}trigger(_,oe){return this.a.trigger(()=>this.b.queue(_),oe)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=n;class s{constructor(){this.a=!1,this.b=new Promise((_,oe)=>{this.d=_})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=s;class i extends s{constructor(_){super(),this.f=setTimeout(()=>this.open(),_)}open(){clearTimeout(this.f),super.open()}}e.$yh=i;function o(te,_){return _?new Promise((oe,ue)=>{const $e=setTimeout(()=>{de.dispose(),oe()},te),de=_.onCancellationRequested(()=>{clearTimeout($e),de.dispose(),ue(new N.$5)})}):y(oe=>o(te,oe))}function a(te,_=0,oe){const ue=setTimeout(()=>{te(),oe&&$e.dispose()},_),$e=(0,A.$Sc)(()=>{clearTimeout(ue),oe?.deleteAndLeak($e)});return oe?.add($e),$e}function w(te){const _=[];let oe=0;const ue=te.length;function $e(){return oe<ue?te[oe++]():null}function de(ge){ge!=null&&_.push(ge);const be=$e();return be?be.then(de):Promise.resolve(_)}return Promise.resolve(null).then(de)}function S(te,_=ue=>!!ue,oe=null){let ue=0;const $e=te.length,de=()=>{if(ue>=$e)return Promise.resolve(oe);const ge=te[ue++];return Promise.resolve(ge()).then(Ee=>_(Ee)?Promise.resolve(Ee):de())};return de()}function v(te,_=ue=>!!ue,oe=null){if(te.length===0)return Promise.resolve(oe);let ue=te.length;const $e=()=>{ue=-1;for(const de of te)de.cancel?.()};return new Promise((de,ge)=>{for(const be of te)be.then(Ee=>{--ue>=0&&_(Ee)?($e(),de(Ee)):ue===0&&de(oe)}).catch(Ee=>{--ue>=0&&($e(),ge(Ee))})})}class k{constructor(_){this.a=0,this.b=!1,this.f=_,this.g=[],this.d=0,this.h=new L.$fe}whenIdle(){return this.size>0?L.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(_){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((oe,ue)=>{this.g.push({factory:_,c:oe,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const _=this.g.shift();this.d++;const oe=_.factory();oe.then(_.c,_.e),oe.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=k;class C extends k{constructor(){super(1)}}e.$Fh=C;class R{constructor(){this.a=new ie,this.b=0}queue(_){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,_())):this.a.run(this.b++,_())}}e.$Gh=R;class M{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const _=new ee;return this.b.add(_),_.p}g(){for(const[,_]of this.a)if(_.size>0)return!1;return!0}queueSize(_,oe=O.$2g){const ue=oe.getComparisonKey(_);return this.a.get(ue)?.size??0}queueFor(_,oe,ue=O.$2g){const $e=ue.getComparisonKey(_);let de=this.a.get($e);if(!de){de=new C;const ge=this.f++,be=L.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete($e),this.h(),this.d?.deleteAndDispose(ge),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$4c),this.d.set(ge,be),this.a.set($e,de)}return de.queue(oe)}h(){this.g()&&this.j()}j(){for(const _ of this.b)_.complete();this.b.clear()}dispose(){for(const[,_]of this.a)_.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=M;class T{constructor(_,oe){this.a=-1,typeof _=="function"&&typeof oe=="number"&&this.setIfNotSet(_,oe)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(_,oe){this.cancel(),this.a=setTimeout(()=>{this.a=-1,_()},oe)}setIfNotSet(_,oe){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,_()},oe))}}e.$Ih=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(_,oe,ue=globalThis){this.cancel();const $e=ue.setInterval(()=>{_()},oe);this.d=(0,A.$Sc)(()=>{ue.clearInterval($e),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=q;class Y{constructor(_,oe){this.b=-1,this.a=_,this.d=oe,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(_=this.d){this.cancel(),this.b=setTimeout(this.f,_)}get delay(){return this.d}set delay(_){this.d=_}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=Y;class K{constructor(_,oe){oe%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${oe}ms is not a multiple of 1000ms.`),this.a=_,this.b=oe,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(_=this.b){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(_/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=K;class Z extends Y{constructor(_,oe){super(_,oe),this.j=[]}work(_){this.j.push(_),this.isScheduled()||this.schedule()}h(){const _=this.j;this.j=[],this.a?.(_)}dispose(){this.j=[],super.dispose()}}e.$Mh=Z;class G extends A.$Uc{constructor(_,oe){super(),this.g=_,this.h=oe,this.a=[],this.b=this.B(new A.$Vc),this.f=!1}get pending(){return this.a.length}work(_){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+_.length>this.g.maxBufferedWork)return!1}else if(this.pending+_.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const oe of _)this.a.push(oe);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new Y(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=G,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(te,_)=>{(0,I.$B)(()=>{if(oe)return;const ue=Date.now()+15;_(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let oe=!1;return{dispose(){oe||(oe=!0)}}}:e.$Ph=(te,_,oe)=>{const ue=te.requestIdleCallback(_,typeof oe=="number"?{timeout:oe}:void 0);let $e=!1;return{dispose(){$e||($e=!0,te.cancelIdleCallback(ue))}}},e.$Oh=te=>(0,e.$Ph)(globalThis,te)}();class J{constructor(_,oe){this.g=!1,this.d=()=>{try{this.j=oe()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$Ph)(_,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=J;class V extends J{constructor(_){super(globalThis,_)}}e.$Rh=V;async function H(te,_,oe){let ue;for(let $e=0;$e<oe;$e++)try{return await te()}catch(de){ue=de,await o(_)}throw ue}class ie{isRunning(_){return typeof _=="number"?this.a?.taskId===_:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(_,oe,ue){return this.a={taskId:_,cancel:()=>ue?.(),promise:oe},oe.then(()=>this.d(_),()=>this.d(_)),oe}d(_){this.a&&_===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const _=this.b;this.b=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}queue(_){if(this.b)this.b.run=_;else{const{promise:oe,resolve:ue,reject:$e}=f();this.b={run:_,promise:oe,promiseResolve:ue,promiseReject:$e}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=ie;class se{constructor(_,oe=()=>Date.now()){this.d=_,this.f=oe,this.a=0,this.b=0}increment(){const _=this.f();return _-this.a>this.d&&(this.a=_,this.b=0),this.b++,this.b}}e.$Uh=se;var he;(function(te){te[te.Resolved=0]="Resolved",te[te.Rejected=1]="Rejected"})(he||(he={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((_,oe)=>{this.a=_,this.b=oe})}complete(_){return new Promise(oe=>{this.a(_),this.d={outcome:0,value:_},oe()})}error(_){return new Promise(oe=>{this.b(_),this.d={outcome:1,value:_},oe()})}cancel(){return this.error(new N.$5)}}e.$Vh=ee;var W;(function(te){async function _(ue){let $e;const de=await Promise.all(ue.map(ge=>ge.then(be=>be,be=>{$e||($e=be)})));if(typeof $e<"u")throw $e;return de}te.settled=_;function oe(ue){return new Promise(async($e,de)=>{try{await ue($e,de)}catch(ge){de(ge)}})}te.withAsyncBody=oe})(W||(e.Promises=W={}));class z{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(_){this.a=void 0,this.b=void 0,this.d=!1,this.promise=_.then(oe=>(this.a=oe,this.d=!0,oe),oe=>{throw this.b=oe,this.d=!0,oe})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=z;class j{constructor(_){this.b=_,this.a=new d.$V(()=>new z(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=j;var F;(function(te){te[te.Initial=0]="Initial",te[te.DoneOK=1]="DoneOK",te[te.DoneError=2]="DoneError"})(F||(F={}));class B{static fromArray(_){return new B(oe=>{oe.emitMany(_)})}static fromPromise(_){return new B(async oe=>{oe.emitMany(await _)})}static fromPromises(_){return new B(async oe=>{await Promise.all(_.map(async ue=>oe.emitOne(await ue)))})}static merge(_){return new B(async oe=>{await Promise.all(_.map(async ue=>{for await(const $e of ue)oe.emitOne($e)}))})}static{this.EMPTY=B.fromArray([])}constructor(_,oe){this.a=0,this.b=[],this.d=null,this.f=oe,this.g=new L.$fe,queueMicrotask(async()=>{const ue={emitOne:$e=>this.h($e),emitMany:$e=>this.j($e),reject:$e=>this.l($e)};try{await Promise.resolve(_(ue)),this.k()}catch($e){this.l($e)}finally{ue.emitOne=void 0,ue.emitMany=void 0,ue.reject=void 0}})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(_<this.b.length)return{done:!1,value:this.b[_++]};if(this.a===1)return{done:!0,value:void 0};await L.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(_,oe){return new B(async ue=>{for await(const $e of _)ue.emitOne(oe($e))})}map(_){return B.map(this,_)}static filter(_,oe){return new B(async ue=>{for await(const $e of _)oe($e)&&ue.emitOne($e)})}filter(_){return B.filter(this,_)}static coalesce(_){return B.filter(_,oe=>!!oe)}coalesce(){return B.coalesce(this)}static async toPromise(_){const oe=[];for await(const ue of _)oe.push(ue);return oe}toPromise(){return B.toPromise(this)}h(_){this.a===0&&(this.b.push(_),this.g.fire())}j(_){this.a===0&&(this.b=this.b.concat(_),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(_){this.a===0&&(this.a=2,this.d=_,this.g.fire())}}e.$Yh=B;class U extends B{constructor(_,oe){super(oe),this.m=_}cancel(){this.m.cancel()}}e.$Zh=U;function Q(te){const _=new D.$qe,oe=te(_.token);return new U(_,async ue=>{const $e=_.token.onCancellationRequested(()=>{$e.dispose(),_.dispose(),ue.reject(new N.$5)});try{for await(const de of oe){if(_.token.isCancellationRequested)return;ue.emitOne(de)}$e.dispose(),_.dispose()}catch(de){$e.dispose(),_.dispose(),ue.reject(de)}})}class x{constructor(_){this.a=new ee,this.b=new B($e=>{if(oe){$e.reject(oe);return}return ue&&$e.emitMany(ue),this.d=de=>$e.reject(de),this.f=de=>$e.emitOne(de),this.a.p},_);let oe,ue;this.f=$e=>{ue||(ue=[]),ue.push($e)},this.d=$e=>{oe||(oe=$e)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(_){this.d(_),this.a.complete()}emitOne(_){this.f(_)}}e.$2h=x}),define(ae[90],ce([0,1,17,6,40,34,14,5,27]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=d,e.$qk=c,e.$rk=C,e.$sk=R,e.$tk=M,e.$uk=T,e.$vk=q,e.$wk=G;function d(){return Object.create(null)}e.$ok="**",e.$pk="/";const E="[/\\\\]",y="[^/\\\\]",p=/\//g;function l(J,V){switch(J){case 0:return"";case 1:return`${y}*?`;default:return`(?:${E}|${y}+${E}${V?`|${E}${y}+`:""})*?`}}function c(J,V){if(!J)return[];const H=[];let ie=!1,se=!1,he="";for(const ee of J){switch(ee){case V:if(!ie&&!se){H.push(he),he="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":se=!0;break;case"]":se=!1;break}he+=ee}return he&&H.push(he),H}function b(J){if(!J)return"";let V="";const H=c(J,e.$pk);if(H.every(ie=>ie===e.$ok))V=".*";else{let ie=!1;H.forEach((se,he)=>{if(se===e.$ok){if(ie)return;V+=l(2,he===H.length-1)}else{let ee=!1,W="",z=!1,j="";for(const F of se){if(F!=="}"&&ee){W+=F;continue}if(z&&(F!=="]"||!j)){let B;F==="-"?B=F:(F==="^"||F==="!")&&!j?B="^":F===e.$pk?B="":B=(0,P.$bf)(F),j+=B;continue}switch(F){case"{":ee=!0;continue;case"[":z=!0;continue;case"}":{const U=`(?:${c(W,",").map(Q=>b(Q)).join("|")})`;V+=U,ee=!1,W="";break}case"]":{V+="["+j+"]",z=!1,j="";break}case"?":V+=y;continue;case"*":V+=l(1);continue;default:V+=(0,P.$bf)(F)}}he<H.length-1&&(H[he+1]!==e.$ok||he+2<H.length)&&(V+=E)}ie=se===e.$ok})}return V}const m=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,$=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.$Dc(1e4),r=function(){return!1},n=function(){return null};function s(J,V){if(!J)return n;let H;typeof J!="string"?H=J.pattern:H=J,H=H.trim();const ie=`${H}_${!!V.trimForExclusions}`;let se=t.get(ie);if(se)return i(se,J);let he;return m.test(H)?se=a(H.substr(4),H):(he=f.exec(o(H,V)))?se=w(he[1],H):(V.trimForExclusions?h:u).test(H)?se=S(H,V):(he=g.exec(o(H,V)))?se=v(he[1].substr(1),H,!0):(he=$.exec(o(H,V)))?se=v(he[1],H,!1):se=k(H),t.set(ie,se),i(se,J)}function i(J,V){if(typeof V=="string")return J;const H=function(ie,se){return(0,L.$xg)(ie,V.base,!I.$k)?J((0,P.$gf)(ie.substr(V.base.length),O.sep),se):null};return H.allBasenames=J.allBasenames,H.allPaths=J.allPaths,H.basenames=J.basenames,H.patterns=J.patterns,H}function o(J,V){return V.trimForExclusions&&J.endsWith("/**")?J.substr(0,J.length-2):J}function a(J,V){return function(H,ie){return typeof H=="string"&&H.endsWith(J)?V:null}}function w(J,V){const H=`/${J}`,ie=`\\${J}`,se=function(ee,W){return typeof ee!="string"?null:W?W===J?V:null:ee===J||ee.endsWith(H)||ee.endsWith(ie)?V:null},he=[J];return se.basenames=he,se.patterns=[V],se.allBasenames=he,se}function S(J,V){const H=Z(J.slice(1,-1).split(",").map(W=>s(W,V)).filter(W=>W!==n),J),ie=H.length;if(!ie)return n;if(ie===1)return H[0];const se=function(W,z){for(let j=0,F=H.length;j<F;j++)if(H[j](W,z))return J;return null},he=H.find(W=>!!W.allBasenames);he&&(se.allBasenames=he.allBasenames);const ee=H.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return ee.length&&(se.allPaths=ee),se}function v(J,V,H){const ie=O.sep===O.$gc.sep,se=ie?J:J.replace(p,O.sep),he=O.sep+se,ee=O.$gc.sep+J;let W;return H?W=function(z,j){return typeof z=="string"&&(z===se||z.endsWith(he)||!ie&&(z===J||z.endsWith(ee)))?V:null}:W=function(z,j){return typeof z=="string"&&(z===se||!ie&&z===J)?V:null},W.allPaths=[(H?"*/":"./")+J],W}function k(J){try{const V=new RegExp(`^${b(J)}$`);return function(H){return V.lastIndex=0,typeof H=="string"&&V.test(H)?J:null}}catch{return n}}function C(J,V,H){return!J||typeof V!="string"?!1:R(J)(V,void 0,H)}function R(J,V={}){if(!J)return r;if(typeof J=="string"||M(J)){const H=s(J,V);if(H===n)return r;const ie=function(se,he){return!!H(se,he)};return H.allBasenames&&(ie.allBasenames=H.allBasenames),H.allPaths&&(ie.allPaths=H.allPaths),ie}return Y(J,V)}function M(J){const V=J;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}function T(J){return J.allBasenames||[]}function q(J){return J.allPaths||[]}function Y(J,V){const H=Z(Object.getOwnPropertyNames(J).map(W=>K(W,J[W],V)).filter(W=>W!==n)),ie=H.length;if(!ie)return n;if(!H.some(W=>!!W.requiresSiblings)){if(ie===1)return H[0];const W=function(F,B){let U;for(let Q=0,x=H.length;Q<x;Q++){const te=H[Q](F,B);if(typeof te=="string")return te;(0,N.$kh)(te)&&(U||(U=[]),U.push(te))}return U?(async()=>{for(const Q of U){const x=await Q;if(typeof x=="string")return x}return null})():null},z=H.find(F=>!!F.allBasenames);z&&(W.allBasenames=z.allBasenames);const j=H.reduce((F,B)=>B.allPaths?F.concat(B.allPaths):F,[]);return j.length&&(W.allPaths=j),W}const se=function(W,z,j){let F,B;for(let U=0,Q=H.length;U<Q;U++){const x=H[U];x.requiresSiblings&&j&&(z||(z=(0,O.$nc)(W)),F||(F=z.substr(0,z.length-(0,O.$oc)(W).length)));const te=x(W,z,F,j);if(typeof te=="string")return te;(0,N.$kh)(te)&&(B||(B=[]),B.push(te))}return B?(async()=>{for(const U of B){const Q=await U;if(typeof Q=="string")return Q}return null})():null},he=H.find(W=>!!W.allBasenames);he&&(se.allBasenames=he.allBasenames);const ee=H.reduce((W,z)=>z.allPaths?W.concat(z.allPaths):W,[]);return ee.length&&(se.allPaths=ee),se}function K(J,V,H){if(V===!1)return n;const ie=s(J,H);if(ie===n)return n;if(typeof V=="boolean")return ie;if(V){const se=V.when;if(typeof se=="string"){const he=(ee,W,z,j)=>{if(!j||!ie(ee,W))return null;const F=se.replace("$(basename)",()=>z),B=j(F);return(0,N.$kh)(B)?B.then(U=>U?J:null):B?J:null};return he.requiresSiblings=!0,he}}return ie}function Z(J,V){const H=J.filter(W=>!!W.basenames);if(H.length<2)return J;const ie=H.reduce((W,z)=>{const j=z.basenames;return j?W.concat(j):W},[]);let se;if(V){se=[];for(let W=0,z=ie.length;W<z;W++)se.push(V)}else se=H.reduce((W,z)=>{const j=z.patterns;return j?W.concat(j):W},[]);const he=function(W,z){if(typeof W!="string")return null;if(!z){let F;for(F=W.length;F>0;F--){const B=W.charCodeAt(F-1);if(B===47||B===92)break}z=W.substr(F)}const j=ie.indexOf(z);return j!==-1?se[j]:null};he.basenames=ie,he.patterns=se,he.allBasenames=ie;const ee=J.filter(W=>!W.basenames);return ee.push(he),ee}function G(J,V){return(0,D.$ub)(J,V,(H,ie)=>typeof H=="string"&&typeof ie=="string"?H===ie:typeof H!="string"&&typeof ie!="string"?H.base===ie.base&&H.pattern===ie.pattern:!1)}}),define(ae[91],ce([0,1,15,8]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=I,e.$Dn=d,e.$En=E;function L(y){return y.toJSON()}class A{constructor(p){this.a=p}transformIncoming(p){const l=this.a.transformIncoming(p);return l===p?p:L(N.URI.from(l))}transformOutgoing(p){const l=this.a.transformOutgoing(p);return l===p?p:L(N.URI.from(l))}transformOutgoingURI(p){const l=this.a.transformOutgoing(p);return l===p?p:N.URI.from(l)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$An=A,e.$Bn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function O(y,p,l){if(!y||l>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return p.transformOutgoing(y);for(const c in y)if(Object.hasOwnProperty.call(y,c)){const b=O(y[c],p,l+1);b!==null&&(y[c]=b)}}return null}function I(y,p){const l=O(y,p,0);return l===null?y:l}function P(y,p,l,c){if(!y||c>200)return null;if(typeof y=="object"){if(y.$mid===1)return l?N.URI.revive(p.transformIncoming(y)):p.transformIncoming(y);if(y instanceof D.$He)return null;for(const b in y)if(Object.hasOwnProperty.call(y,b)){const m=P(y[b],p,l,c+1);m!==null&&(y[b]=m)}}return null}function d(y,p){const l=P(y,p,!1,0);return l===null?y:l}function E(y,p){const l=P(y,p,!0,0);return l===null?y:l}}),define(ae[145],ce([0,1,37,51,32,132,5]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=P,e.$In=y,e.$Gn=new class{c(p){return this.a||(this.a=N.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(p)}value(){if(this.b===void 0){let p=0,l=0;const c=(0,D.networkInterfaces)();for(const b in c){const m=c[b];if(m)for(const{mac:f,internal:u}of m)u||(l+=1,this.c(f.toUpperCase())&&(p+=1))}this.b=l>0?p/l:0}return this.b}};let I;async function P(p){return I||(I=(async()=>await d(p)||L.$Ug())()),I}async function d(p){try{const l=await new Promise((b,m)=>{ne(["crypto"],b,m)}),c=(0,A.$Fn)();return l.createHash("sha256").update(c,"utf8").digest("hex")}catch(l){p(l);return}}const E="Software\\Microsoft\\SQMClient";async function y(p){if(O.$i){const l=await new Promise((c,b)=>{ne(["@vscode/windows-registry"],c,b)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",E,"MachineId")||""}catch(c){return p(c),""}}return""}}),define(ae[146],ce([0,1,41,147,14,36]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dW=E,e.$eW=y;const O="XDG_SESSION_TYPE",I="WAYLAND_DISPLAY",P="XDG_RUNTIME_DIR";var d;(function(p){p.Wayland="wayland",p.XWayland="xwayland",p.X11="x11",p.Unknown="unknown"})(d||(d={}));async function E(p){const l=A.env[O];if(l)return l==="wayland"||l==="x11"?l:"unknown";if(A.env[I]){const b=A.env[P];if(b){const m=(0,L.$jc)(b,"wayland-0");try{return await(0,N.access)(m,D.constants.R_OK),"wayland"}catch(f){return p(f),"unknown"}}else return"unknown"}else return"x11"}function y(p,l){if(l)switch(l){case"auto":return p;case"x11":return p==="wayland"?"xwayland":"x11";case"wayland":return"wayland";default:return"unknown"}else return p==="wayland"?"xwayland":"x11"}}),define(ae[148],ce([0,1,41,147,274,5]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=O;async function O(I){if(A.$j||A.$i)return;let P;for(const d of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{P=await(0,N.open)(d,D.constants.R_OK);break}catch{}if(!P){I("Unable to retrieve release information from known identifier paths.");return}try{const d=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),E={id:"unknown"};for await(const y of(0,L.createInterface)({input:P.createReadStream(),crlfDelay:1/0})){if(!y.includes("="))continue;const p=y.split("=")[0].toUpperCase().trim();if(d.has(p)){const l=y.split("=")[1].replace(/"/g,"").toLowerCase().trim();p==="ID"||p==="DISTRIB_ID"?E.id=l:p==="ID_LIKE"?E.id_like=l:(p==="VERSION_ID"||p==="DISTRIB_RELEASE")&&(E.version_id=l)}}return E}catch(d){I(d)}}}),define(ae[31],ce([0,1,41,37,275,6,40,87,14,5,20,8]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=m,e.readdirSync=h,e.whenDeleted=t,e.configureFlushOnWrite=o,e.writeFileSync=w;var p;(function(K){K[K.UNLINK=0]="UNLINK",K[K.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function l(K,Z=p.UNLINK,G){if((0,O.$Bg)(K))throw new Error("rimraf - will refuse to recursively delete root");return Z===p.UNLINK?b(K):c(K,G)}async function c(K,Z=(0,O.$Gg)((0,N.tmpdir)())){try{try{await D.promises.rename(K,Z)}catch(G){return G.code==="ENOENT"?void 0:b(K)}b(Z).catch(G=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function b(K){return(0,L.promisify)(D.rm)(K,{recursive:!0,force:!0,maxRetries:3})}function m(K){if((0,O.$Bg)(K))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(K,{recursive:!0,force:!0,maxRetries:3})}async function f(K,Z){return g(await(Z?u(K):(0,L.promisify)(D.readdir)(K)))}async function u(K){try{return await(0,L.promisify)(D.readdir)(K,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const Z=[],G=await f(K);for(const J of G){let V=!1,H=!1,ie=!1;try{const se=await e.Promises.lstat((0,P.$jc)(K,J));V=se.isFile(),H=se.isDirectory(),ie=se.isSymbolicLink()}catch(se){console.warn("[node.js fs] unexpected error from lstat after readdir: ",se)}Z.push({name:J,isFile:()=>V,isDirectory:()=>H,isSymbolicLink:()=>ie})}return Z}function h(K){return g(D.readdirSync(K))}function g(K){return K.map(Z=>typeof Z=="string"?d.$j?(0,I.$dm)(Z):Z:(Z.name=d.$j?(0,I.$dm)(Z.name):Z.name,Z))}async function $(K){const Z=await f(K),G=[];for(const J of Z)await r.existsDirectory((0,P.$jc)(K,J))&&G.push(J);return G}function t(K,Z=1e3){return new Promise(G=>{let J=!1;const V=setInterval(()=>{J||(J=!0,D.access(K,H=>{J=!1,H&&(clearInterval(V),G(void 0))}))},Z)})}var r;(function(K){async function Z(V){let H;try{if(H=await e.Promises.lstat(V),!H.isSymbolicLink())return{stat:H}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:H?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};if(d.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(se){if(se.code==="ENOENT"&&H)return{stat:H,symbolicLink:{dangling:!0}};throw se}throw ie}}K.stat=Z;async function G(V){try{const{stat:H,symbolicLink:ie}=await K.stat(V);return H.isFile()&&ie?.dangling!==!0}catch{}return!1}K.existsFile=G;async function J(V){try{const{stat:H,symbolicLink:ie}=await K.stat(V);return H.isDirectory()&&ie?.dangling!==!0}catch{}return!1}K.existsDirectory=J})(r||(e.SymlinkSupport=r={}));const n=new A.$Hh;function s(K,Z,G){return n.queueFor(y.URI.file(K),()=>{const J=S(G);return new Promise((V,H)=>a(K,Z,J,ie=>ie?H(ie):V()))},E.$3g)}let i=!0;function o(K){i=K}function a(K,Z,G,J){if(!i)return D.writeFile(K,Z,{mode:G.mode,flag:G.flag},J);D.open(K,G.flag,G.mode,(V,H)=>{if(V)return J(V);D.writeFile(H,Z,ie=>{if(ie)return D.close(H,()=>J(ie));D.fdatasync(H,se=>(se&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",se),o(!1)),D.close(H,he=>J(he))))})})}function w(K,Z,G){const J=S(G);if(!i)return D.writeFileSync(K,Z,{mode:J.mode,flag:J.flag});const V=D.openSync(K,J.flag,J.mode);try{D.writeFileSync(V,Z);try{D.fdatasyncSync(V)}catch(H){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",H),o(!1)}}finally{D.closeSync(V)}}function S(K){return K?{mode:typeof K.mode=="number"?K.mode:438,flag:typeof K.flag=="string"?K.flag:"w"}:{mode:438,flag:"w"}}async function v(K,Z,G=6e4){if(K!==Z)try{d.$i&&typeof G=="number"?await k(K,Z,Date.now(),G):await(0,L.promisify)(D.rename)(K,Z)}catch(J){if(K.toLowerCase()!==Z.toLowerCase()&&J.code==="EXDEV"||K.endsWith("."))await C(K,Z,{preserveSymlinks:!1}),await l(K,p.MOVE);else throw J}}async function k(K,Z,G,J,V=0){try{return await(0,L.promisify)(D.rename)(K,Z)}catch(H){if(H.code!=="EACCES"&&H.code!=="EPERM"&&H.code!=="EBUSY")throw H;if(Date.now()-G>=J)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${H}`),H;if(V===0){let ie=!1;try{const{stat:se}=await r.stat(Z);se.isFile()||(ie=!0)}catch{}if(ie)throw H}return await(0,A.$zh)(Math.min(100,V*10)),k(K,Z,G,J,V+1)}}async function C(K,Z,G){return M(K,Z,{root:{source:K,target:Z},options:G,handledSourcePaths:new Set})}const R=511;async function M(K,Z,G){if(G.handledSourcePaths.has(K))return;G.handledSourcePaths.add(K);const{stat:J,symbolicLink:V}=await r.stat(K);if(V){if(G.options.preserveSymlinks)try{return await Y(K,Z,G)}catch{}if(V.dangling)return}return J.isDirectory()?T(K,Z,J.mode&R,G):q(K,Z,J.mode&R)}async function T(K,Z,G,J){await e.Promises.mkdir(Z,{recursive:!0,mode:G});const V=await f(K);for(const H of V)await M((0,P.$jc)(K,H),(0,P.$jc)(Z,H),J)}async function q(K,Z,G){await e.Promises.copyFile(K,Z),await e.Promises.chmod(Z,G)}async function Y(K,Z,G){let J=await e.Promises.readlink(K);(0,O.$xg)(J,G.root.source,!d.$k)&&(J=(0,P.$jc)(G.root.target,J.substr(G.root.source.length+1))),await e.Promises.symlink(J,Z)}e.Promises=new class{get access(){return(0,L.promisify)(D.access)}get stat(){return(0,L.promisify)(D.stat)}get lstat(){return(0,L.promisify)(D.lstat)}get utimes(){return(0,L.promisify)(D.utimes)}get read(){return(K,Z,G,J,V)=>new Promise((H,ie)=>{D.read(K,Z,G,J,V,(se,he,ee)=>se?ie(se):H({bytesRead:he,buffer:ee}))})}get readFile(){return(0,L.promisify)(D.readFile)}get write(){return(K,Z,G,J,V)=>new Promise((H,ie)=>{D.write(K,Z,G,J,V,(se,he,ee)=>se?ie(se):H({bytesWritten:he,buffer:ee}))})}get appendFile(){return(0,L.promisify)(D.appendFile)}get fdatasync(){return(0,L.promisify)(D.fdatasync)}get truncate(){return(0,L.promisify)(D.truncate)}get copyFile(){return(0,L.promisify)(D.copyFile)}get open(){return(0,L.promisify)(D.open)}get close(){return(0,L.promisify)(D.close)}get symlink(){return(0,L.promisify)(D.symlink)}get readlink(){return(0,L.promisify)(D.readlink)}get chmod(){return(0,L.promisify)(D.chmod)}get mkdir(){return(0,L.promisify)(D.mkdir)}get unlink(){return(0,L.promisify)(D.unlink)}get rmdir(){return(0,L.promisify)(D.rmdir)}get realpath(){return(0,L.promisify)(D.realpath)}async exists(K){try{return await e.Promises.access(K),!0}catch{return!1}}get readdir(){return f}get readDirsInDir(){return $}get writeFile(){return s}get rm(){return l}get rename(){return v}get copy(){return C}}}),define(ae[149],ce([0,1,41,14,5,27,31]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=I,e.$9q=P,e.$0q=d,e.$$q=E;function I(p){if(L.$k)return p;const l=(0,N.$mc)(p);if(p===l)return p;const c=((0,N.$nc)(p)||p).toLowerCase();try{const m=(0,O.readdirSync)(l).filter(f=>f.toLowerCase()===c);if(m.length===1){const f=I(l);if(f)return(0,N.$jc)(f,m[0])}else if(m.length>1){const f=m.indexOf(c);if(f>=0){const u=I(l);if(u)return(0,N.$jc)(u,m[f])}}}catch{}return null}async function P(p,l){if(L.$k)return p;const c=(0,N.$mc)(p);if(p===c)return p;const b=((0,N.$nc)(p)||p).toLowerCase();try{if(l?.isCancellationRequested)return null;const f=(await O.Promises.readdir(c)).filter(u=>u.toLowerCase()===b);if(f.length===1){const u=await P(c,l);if(u)return(0,N.$jc)(u,f[0])}else if(f.length>1){const u=f.indexOf(b);if(u>=0){const h=await P(c,l);if(h)return(0,N.$jc)(h,f[u])}}}catch{}return null}async function d(p){try{return await O.Promises.realpath(p)}catch{const c=y(p);return await O.Promises.access(c,D.constants.R_OK),c}}function E(p){try{return D.realpathSync(p)}catch{const c=y(p);return D.accessSync(c,D.constants.R_OK),c}}function y(p){return(0,A.$hf)((0,N.$hc)(p),N.sep)}}),define(ae[150],ce([0,1,14,5,36,89,13,31]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=P,e.$rm=d,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function P(y=L.env){return y.comspec||"cmd.exe"}function d(y){let p=[],l=!1;const c=function(b){if(l){p.push(b);return}(!y.send(b,f=>{if(f&&console.error(f),l=!1,p.length>0){const u=p.slice(0);p=[],u.forEach(h=>c(h))}})||N.$i)&&(l=!0)};return{send:c}}var E;(function(y){async function p(l,c,b){if(D.$ic(l))return l;if(c===void 0&&(c=L.cwd()),D.$mc(l)!=="."||(b===void 0&&O.$$f(L.env.PATH)&&(b=L.env.PATH.split(D.$tc)),b===void 0||b.length===0))return D.$jc(c,l);async function f(u){if(await I.Promises.exists(u)){let h;try{h=await I.Promises.stat(u)}catch(g){g.message.startsWith("EACCES")&&(h=await I.Promises.lstat(u))}return h?!h.isDirectory():!1}return!1}for(const u of b){let h;if(D.$ic(u)?h=D.$jc(u,l):h=D.$jc(c,u,l),await f(h))return h;let g=h+".com";if(await f(g)||(g=h+".exe",await f(g)))return g}return D.$jc(c,l)}y.findExecutable=p})(E||(e.win32=E={}))}),define(ae[151],ce([0,1,67,23]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=L;function L(O){return new Promise((I,P)=>{let d;const E=new Map;function y(l,c,b,m,f){const u=E.get(c);if(l===O||u){const h={name:p(b),cmd:b,pid:l,ppid:c,load:m,mem:f};E.set(l,h),l===O&&(d=h),u&&(u.children||(u.children=[]),u.children.push(h),u.children.length>1&&(u.children=u.children.sort((g,$)=>g.pid-$.pid)))}}function p(l){const c=/--utility-sub-type=network/i,b=/--crashes-directory/i,m=/\\pipe\\winpty-control/i,f=/conhost\.exe.+--headless/i,u=/--type=([a-zA-Z-]+)/;if(b.exec(l))return"electron-crash-reporter";if(m.exec(l))return"winpty-agent";if(f.exec(l))return"conpty-agent";let h=u.exec(l);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?c.exec(l)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const g=/[a-zA-Z-]+\.js/g;let $="";do h=g.exec(l),h&&($+=h+" ");while(h);return $&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${$})`:l}if(process.platform==="win32"){const l=c=>c.indexOf("\\\\?\\")===0||c.indexOf("\\??\\")===0?c.substring(4):c.indexOf('"\\\\?\\')===0||c.indexOf('"\\??\\')===0?'"'+c.substring(5):c;new Promise((c,b)=>{ne(["@vscode/windows-process-tree"],c,b)}).then(c=>{c.getProcessList(O,b=>{if(!b){P(new Error(`Root process ${O} not found`));return}c.getProcessCpuUsage(b,m=>{const f=new Map;m.forEach(u=>{const h=l(u.commandLine||"");f.set(u.pid,{name:p(h),cmd:h,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),d=f.get(O),d?(f.forEach(u=>{const h=f.get(u.ppid);h&&(h.children||(h.children=[]),h.children.push(u))}),f.forEach(u=>{u.children&&(u.children=u.children.sort((h,g)=>h.pid-g.pid))}),I(d)):P(new Error(`Root process ${O} not found`))})},c.ProcessDataFlag.CommandLine|c.ProcessDataFlag.Memory)})}else{let l=function(){let c=[d];const b=[];for(;c.length;){const f=c.shift();f&&(b.push(f.pid),f.children&&(c=c.concat(f.children)))}let m=JSON.stringify(N.$Sg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);m+=" "+b.join(" "),(0,D.exec)(m,{},(f,u,h)=>{if(f||h)P(f||new Error(h.toString()));else{const g=u.toString().split(`
`);for(let $=0;$<b.length;$++){const t=E.get(b[$]);t.load=parseFloat(g[$])}if(!d){P(new Error(`Root process ${O} not found`));return}I(d)}})};(0,D.exec)("which ps",{},(c,b,m)=>{if(c||m)if(process.platform!=="linux")P(c||new Error(m.toString()));else{const f=JSON.stringify(N.$Sg.asFileUri("vs/base/node/ps.sh").fsPath);(0,D.exec)(f,{},(u,h,g)=>{u||g?P(u||new Error(g.toString())):(A(h,y),l())})}else{const f=b.toString().trim();(0,D.exec)(`${f} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,g,$)=>{h||$&&!$.includes("screen size is bogus")?P(h||new Error($.toString())):(A(g,y),process.platform==="linux"?l():d?I(d):P(new Error(`Root process ${O} not found`)))})}})}})}function A(O,I){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,d=O.toString().split(`
`);for(const E of d){const y=P.exec(E.trim());y&&y.length===6&&I(parseInt(y[1]),parseInt(y[2]),y[5],parseFloat(y[3]),parseFloat(y[4]))}}});var ve=this&&this.__decorate||function(ne,e,D,N){var L=arguments.length,A=L<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(ne,e,D,N);else for(var I=ne.length-1;I>=0;I--)(O=ne[I])&&(A=(L<3?O(A):L>3?O(e,D,A):O(e,D))||A);return L>3&&A&&Object.defineProperty(e,D,A),A};define(ae[42],ce([0,1,17,6,15,26,84,7,3,2,66,27,13]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=o,e.$_h=a,e.$ei=R,e.$fi=M;var l;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(l||(l={}));function c(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(b||(b={}));function m(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var f;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})(f||(f={}));function u(V){let H=0;for(let ie=0;;ie+=7){const se=V.read(1);if(H|=(se.buffer[0]&127)<<ie,!(se.buffer[0]&128))return H}}const h=n(0);function g(V,H){if(H===0){V.write(h);return}let ie=0;for(let he=H;he!==0;he=he>>>7)ie++;const se=L.$He.alloc(ie);for(let he=0;H!==0;he++)se.buffer[he]=H&127,H=H>>>7,H>0&&(se.buffer[he]|=128);V.write(se)}class ${constructor(H){this.b=H,this.a=0}read(H){const ie=this.b.slice(this.a,this.a+H);return this.a+=ie.byteLength,ie}}e.$9h=$;class t{constructor(){this.a=[]}get buffer(){return L.$He.concat(this.a)}write(H){this.a.push(H)}}e.$0h=t;var r;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(r||(r={}));function n(V){const H=L.$He.alloc(1);return H.writeUInt8(V,0),H}const s={Undefined:n(r.Undefined),String:n(r.String),Buffer:n(r.Buffer),VSBuffer:n(r.VSBuffer),Array:n(r.Array),Object:n(r.Object),Uint:n(r.Int)},i=typeof Buffer<"u";function o(V,H){if(typeof H>"u")V.write(s.Undefined);else if(typeof H=="string"){const ie=L.$He.fromString(H);V.write(s.String),g(V,ie.byteLength),V.write(ie)}else if(i&&Buffer.isBuffer(H)){const ie=L.$He.wrap(H);V.write(s.Buffer),g(V,ie.byteLength),V.write(ie)}else if(H instanceof L.$He)V.write(s.VSBuffer),g(V,H.byteLength),V.write(H);else if(Array.isArray(H)){V.write(s.Array),g(V,H.length);for(const ie of H)o(V,ie)}else if(typeof H=="number"&&(H|0)===H)V.write(s.Uint),g(V,H);else{const ie=L.$He.fromString(JSON.stringify(H));V.write(s.Object),g(V,ie.byteLength),V.write(ie)}}function a(V){switch(V.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return V.read(u(V)).toString();case r.Buffer:return V.read(u(V)).buffer;case r.VSBuffer:return V.read(u(V));case r.Array:{const ie=u(V),se=[];for(let he=0;he<ie;he++)se.push(a(V));return se}case r.Object:return JSON.parse(V.read(u(V)).toString());case r.Int:return u(V)}}class w{constructor(H,ie,se=null,he=1e3){this.h=H,this.j=ie,this.k=se,this.l=he,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(H,ie){this.b.set(H,ie),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case 200:{const ie=this.o([H.type]);this.k?.logOutgoing(ie,0,1,m(H.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([H.type,H.id],H.data);this.k?.logOutgoing(ie,H.id,1,m(H.type),H.data);return}}}o(H,ie=void 0){const se=new t;return o(se,H),o(se,ie),this.p(se.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const ie=new $(H),se=a(ie),he=a(ie),ee=se[0];switch(ee){case 100:return this.k?.logIncoming(H.byteLength,se[1],1,`${c(ee)}: ${se[2]}.${se[3]}`,he),this.s({type:ee,id:se[1],channelName:se[2],name:se[3],arg:he});case 102:return this.k?.logIncoming(H.byteLength,se[1],1,`${c(ee)}: ${se[2]}.${se[3]}`,he),this.t({type:ee,id:se[1],channelName:se[2],name:se[3],arg:he});case 101:return this.k?.logIncoming(H.byteLength,se[1],1,`${c(ee)}`),this.u({type:ee,id:se[1]});case 103:return this.k?.logIncoming(H.byteLength,se[1],1,`${c(ee)}`),this.u({type:ee,id:se[1]})}}s(H){const ie=this.b.get(H.channelName);if(!ie){this.v(H);return}const se=new A.$qe;let he;try{he=ie.call(this.j,H.name,H.arg,se.token)}catch(z){he=Promise.reject(z)}const ee=H.id;he.then(z=>{this.m({id:ee,data:z,type:201})},z=>{z instanceof Error?this.m({id:ee,data:{message:z.message,name:z.name,stack:z.stack?z.stack.split?z.stack.split(`
`):z.stack:void 0},type:202}):this.m({id:ee,data:z,type:203})}).finally(()=>{W.dispose(),this.d.delete(H.id)});const W=(0,d.$Sc)(()=>se.cancel());this.d.set(H.id,W)}t(H){const ie=this.b.get(H.channelName);if(!ie){this.v(H);return}const se=H.id,ee=ie.listen(this.j,H.name,H.arg)(W=>this.m({id:se,data:W,type:204}));this.d.set(H.id,ee)}u(H){const ie=this.d.get(H.id);ie&&(ie.dispose(),this.d.delete(H.id))}v(H){let ie=this.g.get(H.channelName);ie||(ie=[],this.g.set(H.channelName,ie));const se=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:H,timeoutTimer:se})}w(H){const ie=this.g.get(H);if(ie){for(const se of ie)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$ai=w;var S;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(S||(e.RequestInitiator=S={}));class v{constructor(H,ie=null){this.l=H,this.a=!1,this.b=f.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new P.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ie}getChannel(H){const ie=this;return{call(se,he,ee){return ie.a?Promise.reject(new I.$5):ie.m(H,se,he,ee)},listen(se,he){return ie.a?P.Event.None:ie.o(H,se,he)}}}m(H,ie,se,he=A.CancellationToken.None){const ee=this.g++,z={id:ee,type:100,channelName:H,name:ie,arg:se};if(he.isCancellationRequested)return Promise.reject(new I.$5);let j;return new Promise((B,U)=>{if(he.isCancellationRequested)return U(new I.$5);const Q=()=>{const oe=ue=>{switch(ue.type){case 201:this.f.delete(ee),B(ue.data);break;case 202:{this.f.delete(ee);const $e=new Error(ue.data.message);$e.stack=Array.isArray(ue.data.stack)?ue.data.stack.join(`
`):ue.data.stack,$e.name=ue.data.name,U($e);break}case 203:this.f.delete(ee),U(ue.data);break}};this.f.set(ee,oe),this.p(z)};let x=null;this.b===f.Idle?Q():(x=(0,N.$lh)(oe=>this.u()),x.then(()=>{x=null,Q()}));const te=()=>{x?(x.cancel(),x=null):this.p({id:ee,type:101}),U(new I.$5)},_=he.onCancellationRequested(te);j=(0,d.$Rc)((0,d.$Sc)(te),_),this.d.add(j)}).finally(()=>{j.dispose(),this.d.delete(j)})}o(H,ie,se){const he=this.g++,W={id:he,type:102,channelName:H,name:ie,arg:se};let z=null;const j=new P.$fe({onWillAddFirstListener:()=>{z=(0,N.$lh)(B=>this.u()),z.then(()=>{z=null,this.d.add(j),this.p(W)})},onDidRemoveLastListener:()=>{z?(z.cancel(),z=null):(this.d.delete(j),this.p({id:he,type:103}))}}),F=B=>j.fire(B.data);return this.f.set(he,F),j.event}p(H){switch(H.type){case 100:case 102:{const ie=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(ie,H.id,0,`${c(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const ie=this.q([H.type,H.id]);this.j?.logOutgoing(ie,H.id,0,c(H.type));return}}}q(H,ie=void 0){const se=new t;return o(se,H),o(se,ie),this.r(se.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const ie=new $(H),se=a(ie),he=a(ie),ee=se[0];switch(ee){case 200:return this.j?.logIncoming(H.byteLength,0,0,m(ee)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,se[1],0,m(ee),he),this.t({type:se[0],id:se[1],data:he})}}t(H){if(H.type===200){this.b=f.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}u(){return this.b===f.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,d.$Pc)(this.d.values()),this.d.clear()}}e.$bi=v,ve([O.$3h],v.prototype,"onDidInitializePromise",null);class k{get connections(){const H=[];return this.f.forEach(ie=>H.push(ie)),H}constructor(H,ie,se){this.a=new Map,this.f=new Set,this.g=new P.$fe,this.onDidAddConnection=this.g.event,this.h=new P.$fe,this.onDidRemoveConnection=this.h.event,this.j=new d.$Tc,this.j.add(H(({protocol:he,onDidClientDisconnect:ee})=>{const W=P.Event.once(he.onMessage);this.j.add(W(z=>{const j=new $(z),F=a(j),B=new w(he,F,ie,se),U=new v(he,ie);this.a.forEach((x,te)=>B.registerChannel(te,x));const Q={channelServer:B,channelClient:U,ctx:F};this.f.add(Q),this.g.fire(Q),this.j.add(ee(()=>{B.dispose(),U.dispose(),this.f.delete(Q),this.h.fire(Q)}))}))}))}getChannel(H,ie){const se=this;return{call(he,ee,W){let z;if((0,p.$mg)(ie)){const F=(0,D.$3b)(se.connections.filter(ie));z=F?Promise.resolve(F):P.Event.toPromise(P.Event.filter(se.onDidAddConnection,ie))}else z=ie.routeCall(se,he,ee);const j=z.then(F=>F.channelClient.getChannel(H));return R(j).call(he,ee,W)},listen(he,ee){if((0,p.$mg)(ie))return se.k(H,ie,he,ee);const W=ie.routeEvent(se,he,ee).then(z=>z.channelClient.getChannel(H));return R(W).listen(he,ee)}}}k(H,ie,se,he){const ee=this;let W;const z=new P.$fe({onWillAddFirstListener:()=>{W=new d.$Tc;const j=new P.$le,F=new Map,B=Q=>{const te=Q.channelClient.getChannel(H).listen(se,he),_=j.add(te);F.set(Q,_)},U=Q=>{const x=F.get(Q);x&&(x.dispose(),F.delete(Q))};ee.connections.filter(ie).forEach(B),P.Event.filter(ee.onDidAddConnection,ie)(B,void 0,W),ee.onDidRemoveConnection(U,void 0,W),j.event(z.fire,z,W),W.add(j)},onDidRemoveLastListener:()=>{W?.dispose(),W=void 0}});return z.event}registerChannel(H,ie){this.a.set(H,ie);for(const se of this.f)se.channelServer.registerChannel(H,ie)}dispose(){this.j.dispose();for(const H of this.f)H.channelClient.dispose(),H.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=k;class C{constructor(H,ie,se=null){const he=new t;o(he,ie),H.send(he.buffer),this.a=new v(H,se),this.d=new w(H,ie,se)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,ie){this.d.registerChannel(H,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=C;function R(V){return{call(H,ie,se){return V.then(he=>he.call(H,ie,se))},listen(H,ie){const se=new P.$oe;return V.then(he=>se.input=he.listen(H,ie)),se.event}}}function M(V){let H=!1;return{call(ie,se,he){return H?V.call(ie,se,he):(0,N.$zh)(0).then(()=>H=!0).then(()=>V.call(ie,se,he))},listen(ie,se){if(H)return V.listen(ie,se);const he=new P.$oe;return(0,N.$zh)(0).then(()=>H=!0).then(()=>he.input=V.listen(ie,se)),he.event}}}class T{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const ie of H.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await P.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.$gi=T;var q;(function(V){function H(ee,W,z){const j=ee,F=z&&z.disableMarshalling,B=new Map;for(const U in j)se(U)&&B.set(U,P.Event.buffer(j[U],!0,void 0,W));return new class{listen(U,Q,x){const te=B.get(Q);if(te)return te;const _=j[Q];if(typeof _=="function"){if(he(Q))return _.call(j,x);if(se(Q))return B.set(Q,P.Event.buffer(j[Q],!0,void 0,W)),B.get(Q)}throw new I.$bb(`Event not found: ${Q}`)}call(U,Q,x){const te=j[Q];if(typeof te=="function"){if(!F&&Array.isArray(x))for(let oe=0;oe<x.length;oe++)x[oe]=(0,E.$8h)(x[oe]);let _=te.apply(j,x);return _ instanceof Promise||(_=Promise.resolve(_)),_}throw new I.$bb(`Method not found: ${Q}`)}}}V.fromService=H;function ie(ee,W){const z=W&&W.disableMarshalling;return new Proxy({},{get(j,F){if(typeof F=="string")return W?.properties?.has(F)?W.properties.get(F):he(F)?function(B){return ee.listen(F,B)}:se(F)?ee.listen(F):async function(...B){let U;W&&!(0,p.$hg)(W.context)?U=[W.context,...B]:U=B;const Q=await ee.call(F,U);return z?Q:(0,E.$8h)(Q)};throw new I.$bb(`Property not found: ${String(F)}`)}})}V.toService=ie;function se(ee){return ee[0]==="o"&&ee[1]==="n"&&y.$yf(ee.charCodeAt(2))}function he(ee){return/^onDynamic/.test(ee)&&y.$yf(ee.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function K(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const H=V.toString();if(H!=="[object Object]")return H}return V}function Z(V){return Array.isArray(V)?V.map(K):K(V)}function G(V,H,ie,se,he,ee,W){W=Z(W);const z=Y[he],j=z[se%z.length];let F=[`%c[${V}]%c[${String(H).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(ee)?(F=F.concat(W),F.push(")")):F.push(W),console.log.apply(console,F)}class J{constructor(H,ie){this.d=H,this.f=ie,this.a=0,this.b=0}logOutgoing(H,ie,se,he,ee){this.b+=H,G(this.d,this.b,H,ie,se,he,ee)}logIncoming(H,ie,se,he,ee){this.a+=H,G(this.f,this.a,H,ie,se,he,ee)}}e.$hi=J}),define(ae[68],ce([0,1,15,3,2,42]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mi=e.$li=e.$ki=e.$ji=e.ProtocolConstants=e.$ii=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var O;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(O||(e.SocketDiagnosticsEventType=O={}));var I;(function(s){s.enableDiagnostics=!1,s.records=[];const i=new WeakMap;let o=0;function a(S,v){if(!i.has(S)){const k=String(++o);i.set(S,k)}return i.get(S)}function w(S,v,k,C){if(!s.enableDiagnostics)return;const R=a(S,v);if(C instanceof D.$He||C instanceof Uint8Array||C instanceof ArrayBuffer||ArrayBuffer.isView(C)){const M=D.$He.alloc(C.byteLength);M.set(C),s.records.push({timestamp:Date.now(),id:R,label:v,type:k,buff:M})}else s.records.push({timestamp:Date.now(),id:R,label:v,type:k,data:C})}s.traceSocketEvent=w})(I||(e.SocketDiagnostics=I={}));var P;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P||(e.SocketCloseEventType=P={}));let d=null;function E(){return d||(d=D.$He.alloc(0)),d}class y{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(i){this.a.push(i),this.b+=i.byteLength}read(i){return this.c(i,!0)}peek(i){return this.c(i,!1)}c(i,o){if(i===0)return E();if(i>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===i){const v=this.a[0];return o&&(this.a.shift(),this.b-=i),v}if(this.a[0].byteLength>i){const v=this.a[0].slice(0,i);return o&&(this.a[0]=this.a[0].slice(i),this.b-=i),v}const a=D.$He.alloc(i);let w=0,S=0;for(;i>0;){const v=this.a[S];if(v.byteLength>i){const k=v.slice(0,i);a.set(k,w),w+=i,o&&(this.a[S]=v.slice(i),this.b-=i),i-=i}else a.set(v,w),w+=v.byteLength,o?(this.a.shift(),this.b-=v.byteLength):S++,i-=v.byteLength}return a}}e.$ii=y;var p;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(p||(p={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var c;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(c||(e.ProtocolConstants=c={}));class b{constructor(i,o,a,w){this.type=i,this.id=o,this.ack=a,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends L.$Uc{constructor(i){super(),this.f=this.B(new N.$fe),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=i,this.b=!1,this.c=new y,this.B(this.a.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(i){if(!(!i||i.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(i);this.c.byteLength>=this.g.readLen;){const o=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=o.readUInt32BE(9),this.g.messageType=o.readUInt8(0),this.g.id=o.readUInt32BE(1),this.g.ack=o.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,w=this.g.id,S=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",o),this.f.fire(new b(a,w,S,o)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class f{constructor(i){this.k=null,this.a=!1,this.b=!1,this.c=i,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(i){if(this.a)return;i.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=D.$He.alloc(13);o.writeUInt8(i.type,0),o.writeUInt32BE(i.id,1),o.writeUInt32BE(i.ack,5),o.writeUInt32BE(i.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(i.type),id:i.id,ack:i.ack,messageSize:i.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",i.data),this.j(o,i.data)}g(i,o){const a=this.f===0;return this.d.push(i,o),this.f+=i.byteLength+o.byteLength,a}h(){const i=D.$He.concat(this.d,this.f);return this.d.length=0,this.f=0,i}j(i,o){this.g(i,o)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const i=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:i.byteLength}),this.c.write(i)}}class u extends L.$Uc{constructor(i){super(),this.f=new N.$fe,this.onMessage=this.f.event,this.g=new N.$fe,this.onDidDispose=this.g.event,this.a=i,this.b=this.B(new f(this.a)),this.c=this.B(new m(this.a)),this.B(this.c.onMessage(o=>{o.type===1&&this.f.fire(o.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(i){this.b.write(new b(1,0,0,i))}}e.$ji=u;class h extends A.$di{static fromSocket(i,o){return new h(new u(i),o)}get onDidDispose(){return this.b.onDidDispose}constructor(i,o,a=null){super(i,o,a),this.b=i}dispose(){super.dispose();const i=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),i.end()}}e.$ki=h;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$fe({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(i){this.b?this.d.length>0?this.d.push(i):this.a.fire(i):this.d.push(i)}flushBuffer(){this.d=[]}}e.$li=g;class ${constructor(i){this.data=i,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let i=0,o=this.a;for(;o;)o=o.next,i++;return i}peek(){return this.a?this.a.data:null}toArray(){const i=[];let o=0,a=this.a;for(;a;)i[o++]=a.data,a=a.next;return i}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(i){const o=new $(i);if(!this.a){this.a=o,this.b=o;return}this.b.next=o,this.b=o}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const i=Date.now();for(let o=0;o<r.a;o++)this.c[o]=i-1e3*o;setInterval(()=>{for(let o=r.a;o>=1;o--)this.c[o]=this.c[o-1];this.c[0]=Date.now()},1e3)}d(){const i=Date.now(),o=(1+r.a)*1e3;let a=0;for(let w=0;w<r.a;w++)i-this.c[w]<=o&&a++;return 1-a/r.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(i){this.u=new g,this.onControlMessage=this.u.event,this.v=new g,this.onMessage=this.v.event,this.w=new g,this.onDidDispose=this.w.event,this.x=new g,this.onSocketClose=this.x.event,this.y=new g,this.onSocketTimeout=this.y.event,this.s=i.loadEstimator??r.getInstance(),this.t=i.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new L.$Tc,this.o=i.socket,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(o=>this.z(o))),this.r.add(this.o.onClose(o=>this.x.fire(o))),i.initialChunk&&this.q.acceptChunk(i.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const i=new b(5,0,0,E());this.p.write(i),this.p.flush()}sendPause(){const i=new b(7,0,0,E());this.p.write(i)}sendResume(){const i=new b(8,0,0,E());this.p.write(i)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(i,o){this.a=!0,this.r.dispose(),this.r=new L.$Tc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=i,this.p=this.r.add(new f(this.o)),this.q=this.r.add(new m(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(o)}endAcceptReconnection(){this.a=!1,this.h=this.g;const i=new b(3,0,this.h,E());this.p.write(i);const o=this.b.toArray();for(let a=0,w=o.length;a<w;a++)this.p.write(o[a]);this.B()}acceptDisconnect(){this.w.fire()}z(i){if(i.ack>this.d){this.d=i.ack;do{const o=this.b.peek();if(o&&o.id<=i.ack)this.b.pop();else break}while(!0)}switch(i.type){case 0:break;case 1:{if(i.id>this.g)if(i.id!==this.g+1){const o=Date.now();o-this.m>1e4&&(this.m=o,this.p.write(new b(6,0,0,E())))}else this.g=i.id,this.j=Date.now(),this.A(),this.v.fire(i.data);break}case 2:{this.u.fire(i.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const o=this.b.toArray();for(let a=0,w=o.length;a<w;a++)this.p.write(o[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(i){const o=++this.c;this.h=this.g;const a=new b(1,o,this.h,i);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(i){const o=new b(2,0,0,i);this.p.write(o)}A(){if(this.g<=this.h||this.k)return;const i=Date.now()-this.j;if(i>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-i+5)}B(){if(this.c<=this.d||this.f||this.a)return;const i=this.b.peek(),o=Date.now()-i.writtenTime,a=Date.now()-this.q.lastReadTime,w=Date.now()-this.n;if(o>=2e4&&a>=2e4&&w>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:o,timeSinceLastReceivedSomeData:a});return}const S=Math.max(2e4-o,2e4-a,2e4-w,500);this.f=setTimeout(()=>{this.f=null,this.B()},S)}C(){if(this.g<=this.h)return;this.h=this.g;const i=new b(3,0,this.h,E());this.p.write(i)}D(){this.h=this.g;const i=new b(9,0,this.h,E());this.p.write(i)}}e.$mi=n}),define(ae[92],ce([0,1,67,6,15,26,143,7,3,2,30,150,89,42]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5q=e.$4q=void 0;class c extends l.$ai{constructor(f){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",u=>L.$He.wrap(Buffer.from(u,"base64")))},f),process.once("disconnect",()=>this.dispose())}}e.$4q=c;class b{constructor(f,u){this.i=f,this.j=u,this.c=new Set,this.g=new Map,this.h=new P.$fe,this.onDidProcessExit=this.h.event;const h=u&&u.timeout?u.timeout:6e4;this.b=new N.$vh(h),this.d=null,this.f=null}getChannel(f){const u=this;return{call(h,g,$){return u.k(f,h,g,$)},listen(h,g){return u.l(f,h,g)}}}k(f,u,h,g=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(g.isCancellationRequested)return Promise.reject(I.$6());this.b.cancel();const $=this.n(f),t=(0,N.$lh)(s=>$.call(u,h,s)),r=g.onCancellationRequested(()=>t.cancel()),n=(0,d.$Sc)(()=>t.cancel());return this.c.add(n),t.finally(()=>{r.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(f,u,h){if(!this.b)return P.Event.None;this.b.cancel();let g;const $=new P.$fe({onWillAddFirstListener:()=>{g=this.n(f).listen(u,h)($.fire,$),this.c.add(g)},onDidRemoveLastListener:()=>{this.c.delete(g),g.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return $.event}get m(){if(!this.f){const f=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,E.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,p.$pm)(u.env),this.d=(0,D.fork)(this.i,f,u);const h=new P.$fe,$=P.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,O.$Zq)(o)){(0,O.log)(o,`IPC Library: ${this.j.serverName}`);return}h.fire(L.$He.wrap(Buffer.from(o,"base64")))}),t=this.j.useQueue?(0,y.$rm)(this.d):this.d,r=o=>this.d&&this.d.connected&&t.send(o.buffer.toString("base64")),n=h.event,s={send:r,onMessage:n};this.f=new l.$bi(s);const i=()=>this.o();process.once("exit",i),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,a)=>{process.removeListener("exit",i),$.dispose(),this.c.forEach(w=>(0,d.$Pc)(w)),this.c.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:a})})}return this.f}n(f){let u=this.g.get(f);return u||(u=this.m.getChannel(f),this.g.set(f,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$5q=b}),define(ae[152],ce([0,1,135,15,42,3,13,17]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vW=void 0,e.$wW=E;class P{constructor(p){this.a=p,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",l=>l.data?N.$He.wrap(l.data):N.$He.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}class d extends L.$ci{static b(p){(0,O.$ig)((0,D.$uW)(process),"Electron Utility Process");const l=new A.$fe;return process.parentPort.on("message",c=>{if(p?.handledClientConnection(c))return;const b=(0,I.$Ob)(c.ports);b&&l.fire(b)}),A.Event.map(l.event,c=>({protocol:new P(c),onDidClientDisconnect:A.Event.fromNodeEventEmitter(c,"close")}))}constructor(p){super(d.b(p))}}e.$vW=d;function E(y,p,l){const c=b=>{b.data===p&&(y.removeListener("message",c),l())};y.on("message",c)}}),define(ae[69],ce([0,1,6,3,2,66,13]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=P;var I;(function(p){p[p.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",p[p.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(I||(e.StorageHint=I={}));function P(p){const l=p;return l?.changed instanceof Map||l?.deleted instanceof Set}var d;(function(p){p[p.None=0]="None",p[p.Initialized=1]="Initialized",p[p.Closed=2]="Closed"})(d||(e.StorageState=d={}));class E extends L.$Uc{static{this.a=100}constructor(l,c=Object.create(null)){super(),this.r=l,this.s=c,this.b=this.B(new N.$ie),this.onDidChangeStorage=this.b.event,this.c=d.None,this.f=new Map,this.g=this.B(new D.$wh(E.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach((c,b)=>this.w(b,c)),l.deleted?.forEach(c=>this.w(c,void 0))}finally{this.b.resume()}}w(l,c){if(this.c===d.Closed)return;let b=!1;(0,O.$hg)(c)?b=this.f.delete(l):this.f.get(l)!==c&&(this.f.set(l,c),b=!0),b&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===d.None&&(this.c=d.Initialized,this.s.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,c){const b=this.f.get(l);return(0,O.$hg)(b)?c:b}getBoolean(l,c){const b=this.get(l);return(0,O.$hg)(b)?c:b==="true"}getNumber(l,c){const b=this.get(l);return(0,O.$hg)(b)?c:parseInt(b,10)}getObject(l,c){const b=this.get(l);return(0,O.$hg)(b)?c:(0,A.$7h)(b)}async set(l,c,b=!1){if(this.c===d.Closed)return;if((0,O.$hg)(c))return this.delete(l,b);const m=(0,O.$ag)(c)||Array.isArray(c)?(0,A.$6h)(c):String(c);if(this.f.get(l)!==m)return this.f.set(l,m),this.j.set(l,m),this.h.delete(l),this.b.fire({key:l,external:b}),this.D()}async delete(l,c=!1){if(!(this.c===d.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:c}),this.D()}async optimize(){if(this.c!==d.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=d.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(!(this.c===d.Closed||this.m))return this.D(l)}async D(l){return this.s.hint===I.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===I.STORAGE_IN_MEMORY}}e.$1p=E;class y{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach((c,b)=>this.a.set(b,c)),l.delete?.forEach(c=>this.a.delete(c))}async optimize(){}async close(){}}e.$2p=y}),define(ae[153],ce([11,10]),function(ne,e){return ne.create("vs/base/node/zip",e)}),define(ae[70],ce([0,1,41,6,14,13,31,153]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0,e.zip=m,e.$nq=f,e.$oq=h,e.$kq="end of central directory record signature not found";const P=new RegExp(e.$kq);class d extends Error{constructor($,t){let r=t.message;switch($){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=$,this.cause=t}}e.$lq=d;function E(g){const $=g.externalFileAttributes>>16||33188;return[448,56,7].map(t=>$&t).reduce((t,r)=>t+r,$&61440)}function y(g){if(g instanceof d)return g;let $;return P.test(g.message)&&($="CorruptZip"),new d($,g)}function p(g,$,t,r,n,s){const i=L.$mc($),o=L.$jc(r,i);if(!o.startsWith(r))return Promise.reject(new Error(I.localize(0,null,$)));const a=L.$jc(r,$);let w;return s.onCancellationRequested(()=>{w?.destroy()}),Promise.resolve(O.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((S,v)=>{if(!s.isCancellationRequested)try{w=(0,D.createWriteStream)(a,{mode:t}),w.once("close",()=>S()),w.once("error",v),g.once("error",v),g.pipe(w)}catch(k){v(k)}}))}function l(g,$,t,r){let n=(0,N.$lh)(()=>Promise.resolve()),s=0;const i=r.onCancellationRequested(()=>{n.cancel(),g.close()});return new Promise((o,a)=>{const w=new N.$th,S=v=>{v.isCancellationRequested||(s++,g.readEntry())};g.once("error",a),g.once("close",()=>n.then(()=>{r.isCancellationRequested||g.entryCount===s?o():a(new d("Incomplete",new Error(I.localize(1,null,s,g.entryCount))))},a)),g.readEntry(),g.on("entry",v=>{if(r.isCancellationRequested)return;if(!t.sourcePathRegex.test(v.fileName)){S(r);return}const k=v.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(k)){const M=L.$jc($,k);n=(0,N.$lh)(T=>O.Promises.mkdir(M,{recursive:!0}).then(()=>S(T)).then(void 0,a));return}const C=b(g,v),R=E(v);n=(0,N.$lh)(M=>w.queue(()=>C.then(T=>p(T,k,R,$,t,M).then(()=>S(M)))).then(null,a))})}).finally(()=>i.dispose())}async function c(g,$=!1){const{open:t}=await new Promise((r,n)=>{ne(["yauzl"],r,n)});return new Promise((r,n)=>{t(g,$?{lazyEntries:!0}:void 0,(s,i)=>{s?n(y(s)):r((0,A.$jg)(i))})})}function b(g,$){return new Promise((t,r)=>{g.openReadStream($,(n,s)=>{n?r(y(n)):t((0,A.$jg)(s))})})}async function m(g,$){const{ZipFile:t}=await new Promise((r,n)=>{ne(["yazl"],r,n)});return new Promise((r,n)=>{const s=new t;$.forEach(o=>{o.contents?s.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&s.addFile(o.localPath,o.path)}),s.end();const i=(0,D.createWriteStream)(g);s.outputStream.pipe(i),s.outputStream.once("error",n),i.once("error",n),i.once("finish",()=>r(g))})}function f(g,$,t={},r){const n=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let s=c(g,!0);return t.overwrite&&(s=s.then(i=>O.Promises.rm($).then(()=>i))),s.then(i=>l(i,$,{sourcePathRegex:n},r))}function u(g,$){return c(g).then(t=>new Promise((r,n)=>{t.on("entry",s=>{s.fileName===$&&b(t,s).then(i=>r(i),i=>n(i))}),t.once("close",()=>n(new Error(I.localize(2,null,$))))}))}function h(g,$){return u(g,$).then(t=>new Promise((r,n)=>{const s=[];t.once("error",n),t.on("data",i=>s.push(i)),t.on("end",()=>r(Buffer.concat(s)))}))}}),define(ae[154],ce([11,10]),function(ne,e){return ne.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ae[155],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/contextkey",e)}),define(ae[156],ce([11,10]),function(ne,e){return ne.create("vs/platform/contextkey/common/scanner",e)}),define(ae[157],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ae[158],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ae[159],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ae[160],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ae[161],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ae[162],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ae[163],ce([11,10]),function(ne,e){return ne.create("vs/platform/extensions/common/extensionValidator",e)}),define(ae[164],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/fileService",e)}),define(ae[165],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/files",e)}),define(ae[166],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/common/io",e)}),define(ae[167],ce([11,10]),function(ne,e){return ne.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ae[168],ce([11,10]),function(ne,e){return ne.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ae[169],ce([11,10]),function(ne,e){return ne.create("vs/platform/log/common/log",e)}),define(ae[170],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(ae[171],ce([11,10]),function(ne,e){return ne.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(ae[172],ce([11,10]),function(ne,e){return ne.create("vs/platform/request/common/request",e)}),define(ae[173],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(ae[174],ce([11,10]),function(ne,e){return ne.create("vs/platform/telemetry/common/telemetryService",e)}),define(ae[175],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ae[176],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ae[177],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ae[178],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ae[179],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ae[180],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ae[181],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(ae[182],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ae[183],ce([11,10]),function(ne,e){return ne.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(ae[184],ce([11,10]),function(ne,e){return ne.create("vs/platform/workspace/common/workspace",e)}),define(ae[185],ce([0,1,7,156]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var L;(function(d){d[d.LParen=0]="LParen",d[d.RParen=1]="RParen",d[d.Neg=2]="Neg",d[d.Eq=3]="Eq",d[d.NotEq=4]="NotEq",d[d.Lt=5]="Lt",d[d.LtEq=6]="LtEq",d[d.Gt=7]="Gt",d[d.GtEq=8]="GtEq",d[d.RegexOp=9]="RegexOp",d[d.RegexStr=10]="RegexStr",d[d.True=11]="True",d[d.False=12]="False",d[d.In=13]="In",d[d.Not=14]="Not",d[d.And=15]="And",d[d.Or=16]="Or",d[d.Str=17]="Str",d[d.QuotedStr=18]="QuotedStr",d[d.Error=19]="Error",d[d.EOF=20]="EOF"})(L||(e.TokenType=L={}));function A(...d){switch(d.length){case 1:return(0,N.localize)(0,null,d[0]);case 2:return(0,N.localize)(1,null,d[0],d[1]);case 3:return(0,N.localize)(2,null,d[0],d[1],d[2]);default:return}}const O=(0,N.localize)(3,null),I=(0,N.localize)(4,null);class P{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(E){switch(E.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return E.isTripleEq?"===":"==";case 4:return E.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return E.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return E.lexeme;case 18:return E.lexeme;case 19:return E.lexeme;case 20:return"EOF";default:throw(0,D.$8)(`unhandled token type: ${JSON.stringify(E)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(E=>E.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(E){return this.c=E,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(E){return this.r()||this.c.charCodeAt(this.e)!==E?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(E){this.f.push({type:E,offset:this.d})}l(E){const y=this.d,p=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:p};this.g.push({offset:y,lexeme:p,additionalInfo:E}),this.f.push(l)}n(){this.m.lastIndex=this.d;const E=this.m.exec(this.c);if(E){this.e=this.d+E[0].length;const y=this.c.substring(this.d,this.e),p=P.b.get(y);p?this.k(p):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(O);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let E=this.e,y=!1,p=!1;for(;;){if(E>=this.c.length){this.e=E,this.l(I);return}const c=this.c.charCodeAt(E);if(y)y=!1;else if(c===47&&!p){E++;break}else c===91?p=!0:c===92?y=!0:c===93&&(p=!1);E++}for(;E<this.c.length&&P.a.has(this.c.charCodeAt(E));)E++;this.e=E;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=P}),define(ae[186],ce([0,1,65,84,23,14,36,20,8]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=E,e.$0m=y,e.$7m=/^([^.]+\..+)[:=](.+)$/;class d{get appRoot(){return(0,A.$mc)(L.$Sg.asFileUri("").fsPath)}get userHome(){return P.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return P.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.b.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,I.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:L.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,I.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,D.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",l)}return P.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,I.$_g)(P.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,I.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,I.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,I.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=O.env.VSCODE_PORTABLE;return l?P.URI.file((0,A.$jc)(l,"argv.json")):(0,I.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,A.$kc)(l):(0,A.$hc)((0,A.$jc)(L.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?P.URI.file((0,A.$kc)(l)):P.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,A.$kc)(l);const c=O.env.VSCODE_EXTENSIONS;if(c)return c;const b=O.env.VSCODE_PORTABLE;return b?(0,A.$jc)(b,"extensions"):(0,I.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map(c=>/^[^:/?#]+?:\/\//.test(c)?P.URI.parse(c):P.URI.file((0,A.$hc)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?P.URI.parse(l):P.URI.file((0,A.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!O.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$7m.test(l))}get extensionLogLevel(){const l=[];for(const c of this.args.log||[]){const b=e.$7m.exec(c);b&&b[1]&&b[2]&&l.push([b[1],b[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,I.$_g)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=O.env.VSCODE_PORTABLE;return l?P.URI.file((0,A.$jc)(l,"policy.json")):(0,I.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,c,b){this.a=l,this.b=c,this.c=b,this.editSessionId=this.args.editSessionId}}e.$8m=d,ve([N.$3h],d.prototype,"appRoot",null),ve([N.$3h],d.prototype,"userHome",null),ve([N.$3h],d.prototype,"userDataPath",null),ve([N.$3h],d.prototype,"appSettingsHome",null),ve([N.$3h],d.prototype,"tmpDir",null),ve([N.$3h],d.prototype,"cacheHome",null),ve([N.$3h],d.prototype,"stateResource",null),ve([N.$3h],d.prototype,"userRoamingDataHome",null),ve([N.$3h],d.prototype,"userDataSyncHome",null),ve([N.$3h],d.prototype,"sync",null),ve([N.$3h],d.prototype,"machineSettingsResource",null),ve([N.$3h],d.prototype,"workspaceStorageHome",null),ve([N.$3h],d.prototype,"localHistoryHome",null),ve([N.$3h],d.prototype,"keyboardLayoutResource",null),ve([N.$3h],d.prototype,"argvResource",null),ve([N.$3h],d.prototype,"isExtensionDevelopment",null),ve([N.$3h],d.prototype,"untitledWorkspacesHome",null),ve([N.$3h],d.prototype,"builtinExtensionsPath",null),ve([N.$3h],d.prototype,"extensionsPath",null),ve([N.$3h],d.prototype,"extensionDevelopmentLocationURI",null),ve([N.$3h],d.prototype,"extensionDevelopmentKind",null),ve([N.$3h],d.prototype,"extensionTestsLocationURI",null),ve([N.$3h],d.prototype,"debugExtensionHost",null),ve([N.$3h],d.prototype,"logLevel",null),ve([N.$3h],d.prototype,"extensionLogLevel",null),ve([N.$3h],d.prototype,"serviceMachineIdResource",null),ve([N.$3h],d.prototype,"disableTelemetry",null),ve([N.$3h],d.prototype,"disableWorkspaceTrust",null),ve([N.$3h],d.prototype,"useInMemorySecretStorage",null),ve([N.$3h],d.prototype,"policyFile",null);function E(p,l){return y(p["inspect-extensions"],p["inspect-brk-extensions"],5870,l,p.debugId,p.extensionEnvironment)}function y(p,l,c,b,m,f){const h=Number(l||p)||(b?null:c),g=h?!!l:!1;let $;if(f)try{$=JSON.parse(f)}catch{}return{port:h,break:g,debugId:m,env:$}}}),function(){"use strict";function ne(e,D,N){function L(O,I){const P=A(O,I),d=[P];return e.isAbsolute(P)||d.unshift(N),e.resolve(...d)}function A(O,I){process.env.VSCODE_DEV&&(I="code-oss-dev");const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return e.join(d,I);const E=O["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const y=process.env.USERPROFILE;if(typeof y!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=e.join(y,"AppData","Roaming")}break;case"darwin":d=e.join(D.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(d,I)}return{getUserDataPath:L}}if(typeof define=="function")define(ae[187],ce([276,37,36]),function(e,D,N){return ne(e,D,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),D=require("os");module.exports=ne(e,D,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ae[188],ce([0,1,37,186,187]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=O,e.$an=I;class A extends N.$8m{constructor(d,E){super(d,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,L.getUserDataPath)(d,E.nameShort)},E)}}e.$$m=A;function O(P,d){return(0,N.$0m)(P["inspect-ptyhost"],P["inspect-brk-ptyhost"],5877,d,P.extensionEnvironment)}function I(P,d){return(0,N.$0m)(P["inspect-sharedprocess"],P["inspect-brk-sharedprocess"],5879,d,P.extensionEnvironment)}}),define(ae[189],ce([0,1,13,159]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=L;function L(O,I,P,d){try{A(O,I,P,d)}catch(E){O.error(E?.message??E)}return I}function A(O,I,P,d){const E=(y,p,l)=>{const c=y[p];if((0,D.$$f)(c)){const b=c,m=b.length;if(m>1&&b[0]==="%"&&b[m-1]==="%"){const f=b.substr(1,m-2);let u=P[f];u===void 0&&d&&(u=d[f]);const h=typeof u=="string"?u:u?.message,g=d?.[f],$=typeof g=="string"?g:g?.message;if(!h){$||O.warn(`[${I.name}]: ${(0,N.localize)(0,null,f)}`);return}if(l&&(p==="title"||p==="category")&&$&&$!==h){const t={value:h,original:$};y[p]=t}else y[p]=h}}else if((0,D.$ag)(c))for(const b in c)c.hasOwnProperty(b)&&(b==="commands"?E(c,b,!0):E(c,b,l));else if(Array.isArray(c))for(let b=0;b<c.length;b++)E(c,b,l)};for(const y in I)I.hasOwnProperty(y)&&E(I,y)}}),define(ae[190],ce([0,1,70,162]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=L;function L(A){return(0,D.$oq)(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}}),define(ae[191],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ufc=e.$tfc=void 0;class D{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$tfc=D;class N{constructor(A){this.a=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,I){switch(O){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(I[0])}throw new Error(`Call not found: ${O}`)}}e.$ufc=N}),define(ae[71],ce([0,1,20,88,163,55]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=P,e.$Lp=d,e.$Mp=E,e.$Np=y,e.$Op=p,e.$Pp=l,e.$Qp=c;const O=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,I=/^-(\d{4})(\d{2})(\d{2})$/;function P(f){return f=f.trim(),f==="*"||O.test(f)}function d(f){if(!P(f))return null;if(f=f.trim(),f==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=f.match(O);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}function E(f){if(!f)return null;const u=f.majorBase,h=f.majorMustEqual,g=f.minorBase;let $=f.minorMustEqual;const t=f.patchBase;let r=f.patchMustEqual;f.hasCaret&&(u===0||($=!1),r=!1);let n=0;if(f.preRelease){const s=I.exec(f.preRelease);if(s){const[,i,o,a]=s;n=Date.UTC(Number(i),Number(o)-1,Number(a))}}return{majorBase:u,majorMustEqual:h,minorBase:g,minorMustEqual:$,patchBase:t,patchMustEqual:r,isMinimum:f.hasGreaterEquals,notBefore:n}}function y(f,u,h){let g;typeof f=="string"?g=E(d(f)):g=f;let $;u instanceof Date?$=u.getTime():typeof u=="string"&&($=new Date(u).getTime());let t;if(typeof h=="string"?t=E(d(h)):t=h,!g||!t)return!1;const r=g.majorBase,n=g.minorBase,s=g.patchBase;let i=t.majorBase,o=t.minorBase,a=t.patchBase;const w=t.notBefore;let S=t.majorMustEqual,v=t.minorMustEqual,k=t.patchMustEqual;return t.isMinimum?r>i?!0:r<i?!1:n>o?!0:n<o||$&&$<w?!1:s>=a:(r===1&&i===0&&(!S||!v||!k)&&(i=1,o=0,a=0,S=!0,v=!1,k=!1),r<i?!1:r>i?!S:n<o?!1:n>o?!v:s<a?!1:s>a?!k:!($&&$<w))}function p(f,u,h,g,$){const t=[];if(typeof g.publisher<"u"&&typeof g.publisher!="string")return t.push([N.default.Error,L.localize(0,null)]),t;if(typeof g.name!="string")return t.push([N.default.Error,L.localize(1,null,"name")]),t;if(typeof g.version!="string")return t.push([N.default.Error,L.localize(2,null,"version")]),t;if(!g.engines)return t.push([N.default.Error,L.localize(3,null,"engines")]),t;if(typeof g.engines.vscode!="string")return t.push([N.default.Error,L.localize(4,null,"engines.vscode")]),t;if(typeof g.extensionDependencies<"u"&&!m(g.extensionDependencies))return t.push([N.default.Error,L.localize(5,null,"extensionDependencies")]),t;if(typeof g.activationEvents<"u"){if(!m(g.activationEvents))return t.push([N.default.Error,L.localize(6,null,"activationEvents")]),t;if(typeof g.main>"u"&&typeof g.browser>"u")return t.push([N.default.Error,L.localize(7,null,"activationEvents","main","browser")]),t}if(typeof g.extensionKind<"u"&&typeof g.main>"u"&&t.push([N.default.Warning,L.localize(8,null,"extensionKind")]),typeof g.main<"u"){if(typeof g.main!="string")return t.push([N.default.Error,L.localize(9,null,"main")]),t;{const s=(0,D.$_g)(h,g.main);(0,D.$6g)(s,h)||t.push([N.default.Warning,L.localize(10,null,s.path,h.path)])}}if(typeof g.browser<"u"){if(typeof g.browser!="string")return t.push([N.default.Error,L.localize(11,null,"browser")]),t;{const s=(0,D.$_g)(h,g.browser);(0,D.$6g)(s,h)||t.push([N.default.Warning,L.localize(12,null,s.path,h.path)])}}if(!A.valid(g.version))return t.push([N.default.Error,L.localize(13,null)]),t;const r=[];if(!l(f,u,g,$,r))for(const s of r)t.push([N.default.Error,s]);return t}function l(f,u,h,g,$){return g||typeof h.main>"u"&&typeof h.browser>"u"?!0:b(f,u,h.engines.vscode,$)}function c(f,u,h){return f==="*"||b(u,h,f)}function b(f,u,h,g=[]){const $=E(d(h));if(!$)return g.push(L.localize(14,null,h)),!1;if($.majorBase===0){if(!$.majorMustEqual||!$.minorMustEqual)return g.push(L.localize(15,null,h)),!1}else if(!$.majorMustEqual)return g.push(L.localize(16,null,h)),!1;return y(f,u,$)?!0:(g.push(L.localize(17,null,f,h)),!1)}function m(f){if(!Array.isArray(f))return!1;for(let u=0,h=f.length;u<h;u++)if(typeof f[u]!="string")return!1;return!0}}),define(ae[45],ce([0,1,15,32]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=L;async function L(A,O,I){let P=I&&I.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await O.readFile(A.serviceMachineIdResource)).value.toString();P=(0,N.$Tg)(E)?E:null}catch{P=null}if(!P){P=(0,N.$Ug)();try{await O.writeFile(A.serviceMachineIdResource,D.$He.fromString(P))}catch{}}return I?.store("storage.serviceMachineId",P,-1,1),P}}),define(ae[72],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class D{constructor(L,A=[],O=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.$vi=D}),define(ae[192],ce([0,1,72]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Bs=A,e.$Cs=O;const N=[];var L;(function(I){I[I.Eager=0]="Eager",I[I.Delayed=1]="Delayed"})(L||(e.InstantiationType=L={}));function A(I,P,d){P instanceof D.$vi||(P=new D.$vi(P,[],!!d)),N.push([I,P])}function O(){return N}}),define(ae[193],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=e.$er=void 0;class D{constructor(A,O){this.key=A,this.data=O,this.incoming=new Map,this.outgoing=new Map}}e.$er=D;class N{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const O of this.a.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const I=this.lookupOrInsertNode(A),P=this.lookupOrInsertNode(O);I.outgoing.set(P.key,P),P.incoming.set(I.key,I)}removeNode(A){const O=this.b(A);this.a.delete(O);for(const I of this.a.values())I.outgoing.delete(O),I.incoming.delete(O)}lookupOrInsertNode(A){const O=this.b(A);let I=this.a.get(O);return I||(I=new D(O,A),this.a.set(O,I)),I}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[O,I]of this.a)A.push(`${O}
	(-> incoming)[${[...I.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...I.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,O]of this.a){const I=new Set([A]),P=this.c(O,I);if(P)return P}}c(A,O){for(const[I,P]of A.outgoing){if(O.has(I))return[...O,I].join(" -> ");O.add(I);const d=this.c(P,O);if(d)return d;O.delete(I)}}}e.$fr=N}),define(ae[4],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=L,e.$zi=A;var D;(function(O){O.serviceIds=new Map,O.DI_TARGET="$di$target",O.DI_DEPENDENCIES="$di$dependencies";function I(P){return P[O.DI_DEPENDENCIES]||[]}O.getServiceDependencies=I})(D||(e._util=D={})),e.$xi=L("instantiationService");function N(O,I,P){I[D.DI_TARGET]===I?I[D.DI_DEPENDENCIES].push({id:O,index:P}):(I[D.DI_DEPENDENCIES]=[{id:O,index:P}],I[D.DI_TARGET]=I)}function L(O){if(D.serviceIds.has(O))return D.serviceIds.get(O);const I=function(P,d,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(I,P,E)};return I.toString=()=>O,D.serviceIds.set(O,I),I}function A(O){return O}}),define(ae[194],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6ec=void 0,e.$6ec=(0,D.$yi)("checksumService")}),define(ae[21],ce([0,1,13,8,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=A,e.$7i=O,e.$8i=P,e.$9i=d,e.$0i=E,e.$$i=y,e.$_i=p,e.$aj=c,e.$bj=b,e.$cj=m,e.$5i=(0,L.$yi)("configurationService");function A(f){return f&&typeof f=="object"&&(!f.overrideIdentifier||typeof f.overrideIdentifier=="string")&&(!f.resource||f.resource instanceof N.URI)}function O(f){return f&&typeof f=="object"&&(!f.overrideIdentifiers||Array.isArray(f.overrideIdentifiers))&&!f.overrideIdentifier&&(!f.resource||f.resource instanceof N.URI)}var I;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.USER=2]="USER",f[f.USER_LOCAL=3]="USER_LOCAL",f[f.USER_REMOTE=4]="USER_REMOTE",f[f.WORKSPACE=5]="WORKSPACE",f[f.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",f[f.DEFAULT=7]="DEFAULT",f[f.MEMORY=8]="MEMORY"})(I||(e.ConfigurationTarget=I={}));function P(f){switch(f){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function d(f){return f.applicationValue!==void 0||f.userValue!==void 0||f.userLocalValue!==void 0||f.userRemoteValue!==void 0||f.workspaceValue!==void 0||f.workspaceFolderValue!==void 0}function E(f,u){const h=Object.create(null);for(const g in f)y(h,g,f[g],u);return h}function y(f,u,h,g){const $=u.split("."),t=$.pop();let r=f;for(let n=0;n<$.length;n++){const s=$[n];let i=r[s];switch(typeof i){case"undefined":i=r[s]=Object.create(null);break;case"object":if(i===null){g(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is null`);return}break;default:g(`Ignoring ${u} as ${$.slice(0,n+1).join(".")} is ${JSON.stringify(i)}`);return}r=i}if(typeof r=="object"&&r!==null)try{r[t]=h}catch{g(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}else g(`Ignoring ${u} as ${$.join(".")} is ${JSON.stringify(r)}`)}function p(f,u){const h=u.split(".");l(f,h)}function l(f,u){const h=u.shift();if(u.length===0){delete f[h];return}if(Object.keys(f).indexOf(h)!==-1){const g=f[h];typeof g=="object"&&!Array.isArray(g)&&(l(g,u),Object.keys(g).length===0&&delete f[h])}}function c(f,u,h){function g(r,n){let s=r;for(const i of n){if(typeof s!="object"||s===null)return;s=s[i]}return s}const $=u.split("."),t=g(f,$);return typeof t>"u"?h:t}function b(f,u,h){Object.keys(u).forEach(g=>{g!=="__proto__"&&(g in f?D.$ag(f[g])&&D.$ag(u[g])?b(f[g],u[g],h):h&&(f[g]=u[g]):f[g]=u[g])})}function m(f){return f.replace(/[\[\]]/g,"")}}),define(ae[93],ce([0,1,5,27,185,4,155,7]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=d,e.$xj=r,e.$yj=n,e.$Rj=he;const P=new Map;P.set("false",!1),P.set("true",!0),P.set("isMac",D.$j),P.set("isLinux",D.$k),P.set("isWindows",D.$i),P.set("isWeb",D.$o),P.set("isMacNative",D.$j&&!D.$o),P.set("isEdge",D.$H),P.set("isFirefox",D.$F),P.set("isChrome",D.$E),P.set("isSafari",D.$G);function d(z,j){if(P.get(z)!==void 0)throw(0,I.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");P.set(z,j)}const E=Object.prototype.hasOwnProperty;var y;(function(z){z[z.False=0]="False",z[z.True=1]="True",z[z.Defined=2]="Defined",z[z.Not=3]="Not",z[z.Equals=4]="Equals",z[z.NotEquals=5]="NotEquals",z[z.And=6]="And",z[z.Regex=7]="Regex",z[z.NotRegex=8]="NotRegex",z[z.Or=9]="Or",z[z.In=10]="In",z[z.NotIn=11]="NotIn",z[z.Greater=12]="Greater",z[z.GreaterEquals=13]="GreaterEquals",z[z.Smaller=14]="Smaller",z[z.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const p={regexParsingWithErrorRecovery:!0},l=(0,O.localize)(0,null),c=(0,O.localize)(1,null),b=(0,O.localize)(2,null),m=(0,O.localize)(3,null),f=(0,O.localize)(4,null),u=(0,O.localize)(5,null),h=(0,O.localize)(6,null),g=(0,O.localize)(7,null);class ${static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=p){this.k=j,this.d=new L.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:c});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const B=this.D(),U=B.type===17?u:void 0;throw this.h.push({message:f,offset:B.offset,lexeme:L.$tj.getLexeme(B),additionalInfo:U}),$.c}return F}catch(F){if(F!==$.c)throw F;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const F=this.o();j.push(F)}return j.length===1?j[0]:t.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const F=this.s();j.push(F)}return j.length===1?j[0]:t.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),i.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,m),F?.negate()}case 17:return this.z(),C.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,m),F}case 17:{const F=j.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const Q=U.lexeme,x=Q.lastIndexOf("/"),te=x===Q.length-1?void 0:this.w(Q.substring(x+1));let _;try{_=new RegExp(Q.substring(1,x),te)}catch{throw this.B("REGEX",U)}return K.create(F,_)}switch(U.type){case 10:case 19:{const Q=[U.lexeme];this.z();let x=this.D(),te=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?te++:U.lexeme.charCodeAt(de)===41&&te--;for(;!this.E()&&x.type!==15&&x.type!==16;){switch(x.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let de=0;de<x.lexeme.length;de++)x.lexeme.charCodeAt(de)===40?te++:U.lexeme.charCodeAt(de)===41&&te--}if(te<0)break;Q.push(L.$tj.getLexeme(x)),this.z(),x=this.D()}const _=Q.join(""),oe=_.lastIndexOf("/"),ue=oe===_.length-1?void 0:this.w(_.substring(oe+1));let $e;try{$e=new RegExp(_.substring(1,oe),ue)}catch{throw this.B("REGEX",U)}return t.regex(F,$e)}case 18:{const Q=U.lexeme;this.z();let x=null;if(!(0,N.$9e)(Q)){const te=Q.indexOf("/"),_=Q.lastIndexOf("/");if(te!==_&&te>=0){const oe=Q.slice(te+1,_),ue=Q[_+1]==="i"?"i":"";try{x=new RegExp(oe,ue)}catch{throw this.B("REGEX",U)}}}if(x===null)throw this.B("REGEX",U);return K.create(F,x)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const U=this.u();return t.notIn(F,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return t.equals(F,U);switch(U){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return t.notEquals(F,U);switch(U){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,U)}}case 5:return this.z(),q.create(F,this.u());case 6:return this.z(),Y.create(F,this.u());case 7:return this.z(),M.create(F,this.u());case 8:return this.z(),T.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:h,offset:j.offset,lexeme:"",additionalInfo:g}),$.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,F){if(this.C(j))return this.z();throw this.B(F,this.D())}B(j,F,B){const U=(0,O.localize)(8,null,j,L.$tj.getLexeme(F)),Q=F.offset,x=L.$tj.getLexeme(F);return this.h.push({message:U,offset:Q,lexeme:x,additionalInfo:B}),$.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=$;class t{static false(){return i.INSTANCE}static true(){return o.INSTANCE}static has(j){return a.create(j)}static equals(j,F){return w.create(j,F)}static notEquals(j,F){return k.create(j,F)}static regex(j,F){return K.create(j,F)}static in(j,F){return S.create(j,F)}static notIn(j,F){return v.create(j,F)}static not(j){return C.create(j)}static and(...j){return J.create(j,null,!0)}static or(...j){return V.create(j,null,!0)}static greater(j,F){return M.create(j,F)}static greaterEquals(j,F){return T.create(j,F)}static smaller(j,F){return q.create(j,F)}static smallerEquals(j,F){return Y.create(j,F)}static{this.c=new $({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$wj=t;function r(z){const j=new $({regexParsingWithErrorRecovery:!1});return z.map(F=>(j.parse(F),j.lexingErrors.length>0?j.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,O.localize)(9,null,B.additionalInfo):(0,O.localize)(10,null),offset:B.offset,length:B.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}function n(z,j){const F=z?z.substituteConstants():void 0,B=j?j.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}function s(z,j){return z.cmp(j)}class i{static{this.INSTANCE=new i}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return o.INSTANCE}}e.$zj=i;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return i.INSTANCE}}e.$Aj=o;class a{static create(j,F=null){const B=P.get(j);return typeof B=="boolean"?B?o.INSTANCE:i.INSTANCE:new a(j,F)}constructor(j,F){this.key=j,this.c=F,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=P.get(this.key);return typeof j=="boolean"?j?o.INSTANCE:i.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.$Bj=a;class w{static create(j,F,B=null){if(typeof F=="boolean")return F?a.create(j,B):C.create(j,B);const U=P.get(j);return typeof U=="boolean"?F===(U?"true":"false")?o.INSTANCE:i.INSTANCE:new w(j,F,B)}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=P.get(this.c);if(typeof j=="boolean"){const F=j?"true":"false";return this.d===F?o.INSTANCE:i.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Cj=w;class S{static create(j,F){return new S(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:se(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const F=j.getValue(this.f),B=j.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?E.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$Dj=S;class v{static create(j,F){return new v(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=11,this.c=S.create(j,F)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=v;class k{static create(j,F,B=null){if(typeof F=="boolean")return F?C.create(j,B):a.create(j,B);const U=P.get(j);return typeof U=="boolean"?F===(U?"true":"false")?i.INSTANCE:o.INSTANCE:new k(j,F,B)}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=P.get(this.c);if(typeof j=="boolean"){const F=j?"true":"false";return this.d===F?i.INSTANCE:o.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=w.create(this.c,this.d,this)),this.f}}e.$Fj=k;class C{static create(j,F=null){const B=P.get(j);return typeof B=="boolean"?B?i.INSTANCE:o.INSTANCE:new C(j,F)}constructor(j,F){this.c=j,this.d=F,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=P.get(this.c);return typeof j=="boolean"?j?i.INSTANCE:o.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$Gj=C;function R(z,j){if(typeof z=="string"){const F=parseFloat(z);isNaN(F)||(z=F)}return typeof z=="string"||typeof z=="number"?j(z):i.INSTANCE}class M{static create(j,F,B=null){return R(F,U=>new M(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Hj=M;class T{static create(j,F,B=null){return R(F,U=>new T(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ij=T;class q{static create(j,F,B=null){return R(F,U=>new q(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Jj=q;class Y{static create(j,F,B=null){return R(F,U=>new Y(j,U,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:se(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$Kj=Y;class K{static create(j,F){return new K(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const F=this.f?this.f.source:"",B=j.f?j.f.source:"";return F<B?-1:F>B?1:0}equals(j){if(j.type===this.type){const F=this.f?this.f.source:"",B=j.f?j.f.source:"";return this.d===j.d&&F===B}return!1}substituteConstants(){return this}evaluate(j){const F=j.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=Z.create(this)),this.c}}e.$Lj=K;class Z{static create(j){return new Z(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new Z(this.c.map(j))}negate(){return this.c}}e.$Mj=Z;function G(z){let j=null;for(let F=0,B=z.length;F<B;F++){const U=z[F].substituteConstants();if(z[F]!==U&&j===null){j=[];for(let Q=0;Q<F;Q++)j[Q]=z[Q]}j!==null&&(j[F]=U)}return j===null?z:j}class J{static create(j,F,B){return J.d(j,F,B)}constructor(j,F){this.expr=j,this.c=F,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const U=s(this.expr[F],j.expr[F]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(j.expr[F]))return!1;return!0}return!1}substituteConstants(){const j=G(this.expr);return j===this.expr?this:J.create(j,this.c,!1)}evaluate(j){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(j))return!1;return!0}static d(j,F,B){const U=[];let Q=!1;for(const x of j)if(x){if(x.type===1){Q=!0;continue}if(x.type===0)return i.INSTANCE;if(x.type===6){U.push(...x.expr);continue}U.push(x)}if(U.length===0&&Q)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(s);for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];for(;U.length>1;){const x=U[U.length-1];if(x.type!==9)break;U.pop();const te=U.pop(),_=U.length===0,oe=V.create(x.expr.map(ue=>J.create([ue,te],null,B)),null,_);oe&&(U.push(oe),U.sort(s))}if(U.length===1)return U[0];if(B){for(let x=0;x<U.length;x++)for(let te=x+1;te<U.length;te++)if(U[x].negate().equals(U[te]))return i.INSTANCE;if(U.length===1)return U[0]}return new J(U,F)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const F of this.expr)j.push(...F.keys());return j}map(j){return new J(this.expr.map(F=>F.map(j)),null)}negate(){if(!this.c){const j=[];for(const F of this.expr)j.push(F.negate());this.c=V.create(j,this,!0)}return this.c}}e.$Nj=J;class V{static create(j,F,B){return V.d(j,F,B)}constructor(j,F){this.expr=j,this.c=F,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const U=s(this.expr[F],j.expr[F]);if(U!==0)return U}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(j.expr[F]))return!1;return!0}return!1}substituteConstants(){const j=G(this.expr);return j===this.expr?this:V.create(j,this.c,!1)}evaluate(j){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(j))return!0;return!1}static d(j,F,B){let U=[],Q=!1;if(j){for(let x=0,te=j.length;x<te;x++){const _=j[x];if(_){if(_.type===0){Q=!0;continue}if(_.type===1)return o.INSTANCE;if(_.type===9){U=U.concat(_.expr);continue}U.push(_)}}if(U.length===0&&Q)return i.INSTANCE;U.sort(s)}if(U.length!==0){if(U.length===1)return U[0];for(let x=1;x<U.length;x++)U[x-1].equals(U[x])&&(U.splice(x,1),x--);if(U.length===1)return U[0];if(B){for(let x=0;x<U.length;x++)for(let te=x+1;te<U.length;te++)if(U[x].negate().equals(U[te]))return o.INSTANCE;if(U.length===1)return U[0]}return new V(U,F)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const F of this.expr)j.push(...F.keys());return j}map(j){return new V(this.expr.map(F=>F.map(j)),null)}negate(){if(!this.c){const j=[];for(const F of this.expr)j.push(F.negate());for(;j.length>1;){const F=j.shift(),B=j.shift(),U=[];for(const Q of W(F))for(const x of W(B))U.push(J.create([Q,x],null,!1));j.unshift(V.create(U,null,!1))}this.c=V.create(j,this,!0)}return this.c}}e.$Oj=V;class H extends a{static{this.d=[]}static all(){return H.d.values()}constructor(j,F,B){super(j,null),this.f=F,typeof B=="object"?H.d.push({...B,key:j}):B!==!0&&H.d.push({key:j,description:B,type:F!=null?typeof F:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return w.create(this.key,j)}notEqualsTo(j){return k.create(this.key,j)}}e.$Pj=H,e.$Qj=(0,A.$yi)("contextKeyService");function ie(z,j){return z<j?-1:z>j?1:0}function se(z,j,F,B){return z<F?-1:z>F?1:j<B?-1:j>B?1:0}function he(z,j){if(z.type===0||j.type===1)return!0;if(z.type===9)return j.type===9?ee(z.expr,j.expr):!1;if(j.type===9){for(const F of j.expr)if(he(z,F))return!0;return!1}if(z.type===6){if(j.type===6)return ee(j.expr,z.expr);for(const F of z.expr)if(he(F,j))return!0;return!1}return z.equals(j)}function ee(z,j){let F=0,B=0;for(;F<z.length&&B<j.length;){const U=z[F].cmp(j[B]);if(U<0)return!1;U===0&&F++,B++}return F===z.length}function W(z){return z.type===9?z.expr:[z]}}),define(ae[94],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hn=e.$fn=e.ID=void 0,e.$gn=N,e.ID="diagnosticsService",e.$fn=(0,D.$yi)(e.ID);function N(A){return!!A.hostName&&!!A.errorMessage}class L{async getPerformanceInfo(O,I){return{}}async getSystemInfo(O,I){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(O,I){return""}async getWorkspaceFileExtensions(O){return{extensions:[]}}async reportWorkspaceStats(O){}}e.$hn=L}),define(ae[95],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0,e.$No=(0,D.$yi)("downloadService")}),define(ae[16],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,D.$yi)("environmentService"),e.$Gi=(0,D.$zi)(e.$Fi)}),define(ae[29],ce([0,1,158,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=A,e.$5o=O,e.$6o=I,e.$7o=P,e.$8o=d,e.$9o=E,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionInstallSource",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";var L;(function(h){h.COMMAND="command",h.SETTINGS_SYNC="settingsSync"})(L||(e.ExtensionInstallSource=L={}));function A(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function I(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(h,g){return g==="web"&&!h.includes("web")}function d(h,g,$){return P(g,$)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===$}function E(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}var y;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var p;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(p||(e.SortOrder=p={}));var l;(function(h){h.Install="install",h.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var c;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(c||(e.InstallOperation=c={})),e.$0o=(0,N.$yi)("extensionGalleryService");var b;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed",h.DownloadFailedWriting="DownloadFailedWriting"})(b||(e.ExtensionGalleryErrorCode=b={}));class m extends Error{constructor(g,$){super(g),this.code=$,this.name=$}}e.$$o=m;var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.DownloadFailedWriting="DownloadFailedWriting",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.ScanningExtension="ScanningExtension",h.ReadUninstalled="ReadUninstalled",h.UnsetUninstalled="UnsetUninstalled",h.Delete="Delete",h.Rename="Rename",h.IntializeDefaultProfile="IntializeDefaultProfile",h.AddToProfile="AddToProfile",h.PostInstall="PostInstall",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Cancelled="Cancelled",h.Unknown="Unknown",h.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class u extends Error{constructor(g,$){super(g),this.code=$,this.name=$}}e.$_o=u,e.$ap=(0,N.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,N.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,N.$yi)("IExtensionTipsService"),e.$fp=(0,D.localize2)(0,"Extensions"),e.$gp=(0,D.localize2)(1,"Preferences")}),define(ae[195],ce([0,1,3,2,30,8,91,29]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=e.$iq=e.$hq=void 0;function P(m,f){return m?A.URI.revive(f?f.transformIncoming(m):m):void 0}function d(m,f){return f?f.transformOutgoingURI(m):m}function E(m,f){f=f||O.$Bn;const u=m.manifest;return{...(0,O.$En)({...m,manifest:void 0},f),manifest:u}}function y(m,f){return m?.profileLocation?(0,O.$En)(m,f??O.$Bn):m}function p(m,f){return f?(0,L.$7n)(m,u=>u instanceof A.URI?f.transformOutgoingURI(u):void 0):m}class l{constructor(f,u){this.a=f,this.b=u,this.onInstallExtension=D.Event.buffer(f.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(f.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(f.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(f.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=D.Event.buffer(f.onDidUpdateExtensionMetadata,!0)}listen(f,u){const h=this.b(f);switch(u){case"onInstallExtension":return D.Event.map(this.onInstallExtension,g=>({...g,profileLocation:g.profileLocation?d(g.profileLocation,h):g.profileLocation}));case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,g=>g.map($=>({...$,local:$.local?p($.local,h):$.local,profileLocation:$.profileLocation?d($.profileLocation,h):$.profileLocation})));case"onUninstallExtension":return D.Event.map(this.onUninstallExtension,g=>({...g,profileLocation:g.profileLocation?d(g.profileLocation,h):g.profileLocation}));case"onDidUninstallExtension":return D.Event.map(this.onDidUninstallExtension,g=>({...g,profileLocation:g.profileLocation?d(g.profileLocation,h):g.profileLocation}));case"onDidUpdateExtensionMetadata":return D.Event.map(this.onDidUpdateExtensionMetadata,g=>p(g,h))}throw new Error("Invalid listen")}async call(f,u,h){const g=this.b(f);switch(u){case"zip":{const $=E(h[0],g),t=await this.a.zip($);return d(t,g)}case"unzip":return this.a.unzip(P(h[0],g));case"install":return this.a.install(P(h[0],g),y(h[1],g));case"installFromLocation":return this.a.installFromLocation(P(h[0],g),P(h[1],g));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(h[0],P(h[1],g),P(h[2],g));case"getManifest":return this.a.getManifest(P(h[0],g));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(h[0]);case"installFromGallery":return this.a.installFromGallery(h[0],y(h[1],g));case"installGalleryExtensions":{const $=h[0];return this.a.installGalleryExtensions($.map(({extension:t,options:r})=>({extension:t,options:y(r,g)??{}})))}case"uninstall":return this.a.uninstall(E(h[0],g),y(h[1],g));case"reinstallFromGallery":return this.a.reinstallFromGallery(E(h[0],g));case"getInstalled":return(await this.a.getInstalled(h[0],P(h[1],g),h[2])).map(t=>p(t,g));case"toggleAppliationScope":{const $=await this.a.toggleAppliationScope(E(h[0],g),P(h[1],g));return p($,g)}case"copyExtensions":return this.a.copyExtensions(P(h[0],g),P(h[1],g));case"updateMetadata":{const $=await this.a.updateMetadata(E(h[0],g),h[1],P(h[2],g));return p($,g)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(h[0],h[1],h[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$hq=l;class c extends N.$Uc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(f){super(),this.m=f,this.c=this.B(new D.$fe),this.f=this.B(new D.$fe),this.g=this.B(new D.$fe),this.h=this.B(new D.$fe),this.j=this.B(new D.$fe),this.B(this.m.listen("onInstallExtension")(u=>this.n(this.c,{...u,source:this.r(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(u=>this.n(this.f,u.map(h=>({...h,local:h.local?E(h.local,null):h.local,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(u=>this.n(this.g,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(u=>this.n(this.h,{...u,profileLocation:A.URI.revive(u.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(E(u,null))))}n(f,u){f.fire(u)}r(f){return f?typeof f.path=="string"&&typeof f.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(f){const u=await this.getTargetPlatform();return f.allTargetPlatforms.some(h=>(0,I.$8o)(h,f.allTargetPlatforms,u))}zip(f){return Promise.resolve(this.m.call("zip",[f]).then(u=>A.URI.revive(u)))}unzip(f){return Promise.resolve(this.m.call("unzip",[f]))}install(f,u){return Promise.resolve(this.m.call("install",[f,u])).then(h=>E(h,null))}installFromLocation(f,u){return Promise.resolve(this.m.call("installFromLocation",[f,u])).then(h=>E(h,null))}async installExtensionsFromProfile(f,u,h){return(await this.m.call("installExtensionsFromProfile",[f,u,h])).map($=>E($,null))}getManifest(f){return Promise.resolve(this.m.call("getManifest",[f]))}installFromGallery(f,u){return Promise.resolve(this.m.call("installFromGallery",[f,u])).then(h=>E(h,null))}async installGalleryExtensions(f){return(await this.m.call("installGalleryExtensions",[f])).map(h=>({...h,local:h.local?E(h.local,null):h.local,source:this.r(h.source)?A.URI.revive(h.source):h.source,profileLocation:A.URI.revive(h.profileLocation)}))}uninstall(f,u){if(f.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[f,u]))}reinstallFromGallery(f){return Promise.resolve(this.m.call("reinstallFromGallery",[f])).then(u=>E(u,null))}getInstalled(f=null,u,h){return Promise.resolve(this.m.call("getInstalled",[f,u,h])).then(g=>g.map($=>E($,null)))}updateMetadata(f,u,h){return Promise.resolve(this.m.call("updateMetadata",[f,u,h])).then(g=>E(g,null))}toggleAppliationScope(f,u){return this.m.call("toggleAppliationScope",[f,u]).then(h=>E(h,null))}copyExtensions(f,u){return this.m.call("copyExtensions",[f,u])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(f,u,h){const g=await this.m.call("download",[f,u,h]);return A.URI.revive(g)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$iq=c;class b{constructor(f){this.a=f}listen(f,u){throw new Error("Invalid listen")}call(f,u,h){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(h[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$jq=b}),define(ae[96],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L4b=e.RecommendationsNotificationResult=e.RecommendationSource=void 0,e.$K4b=L;var N;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$L4b=(0,D.$yi)("IExtensionRecommendationNotificationService")}),define(ae[12],ce([0,1,51,14,27,13,8,165,4,5,23,53]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=p,e.$7k=m,e.$8k=u,e.$9k=h,e.$0k=g,e.$$k=$,e.$_k=t,e.$al=r,e.$bl=n,e.$cl=s,e.$dl=i,e.$fl=w,e.$gl=S,e.$hl=v,e.$il=k,e.$jl=C,e.$ml=Y,e.$yl=H,e.$zl=ie,e.$Bl=he,e.$5k=(0,P.$yi)("fileService");function p(ee){return ee.create===!0}var l;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var c;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})(c||(e.FilePermission=c={}));var b;(function(ee){ee[ee.UPDATED=2]="UPDATED",ee[ee.ADDED=4]="ADDED",ee[ee.DELETED=8]="DELETED"})(b||(e.FileChangeFilter=b={}));function m(ee){const W=ee;return!!W&&typeof W.onDidChange=="function"}var f;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(f||(e.FileSystemProviderCapabilities=f={}));function u(ee){return!!(ee.capabilities&2)}function h(ee){return!!(ee.capabilities&8)}function g(ee){return!!(ee.capabilities&131072)}function $(ee){return!!(ee.capabilities&4)}function t(ee){return!!(ee.capabilities&16)}function r(ee){return u(ee)?!!(ee.capabilities&16384):!1}function n(ee){return u(ee)?!!(ee.capabilities&32768):!1}function s(ee){return!!(ee.capabilities&65536)}function i(ee){return!!(ee.capabilities&2048)}var o;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(o||(e.FileSystemProviderErrorCode=o={}));class a extends Error{static create(W,z){const j=new a(W.toString(),z);return v(j,z),j}constructor(W,z){super(W),this.code=z}}e.$el=a;function w(ee,W){return a.create(ee,W)}function S(ee){return ee||w((0,I.localize)(0,null),o.Unknown)}function v(ee,W){return ee.name=W?`${W} (FileSystemError)`:"FileSystemError",ee}function k(ee){if(!ee)return o.Unknown;if(ee instanceof a)return ee.code;const W=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!W)return o.Unknown;switch(W[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}function C(ee){if(ee instanceof K)return ee.fileOperationResult;switch(k(ee)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 9;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileTooLarge:return 7;default:return 10}}var R;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class M{constructor(W,z,j){this.resource=W,this.operation=z,this.target=j}isOperation(W){return this.operation===W}}e.$kl=M;var T;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(W,z){this.c=z,this.b=void 0,this.d=new y.$V(()=>{const j=D.$Ei.forUris(()=>this.c);return j.fill(this.rawAdded.map(F=>[F,!0])),j}),this.f=new y.$V(()=>{const j=D.$Ei.forUris(()=>this.c);return j.fill(this.rawUpdated.map(F=>[F,!0])),j}),this.g=new y.$V(()=>{const j=D.$Ei.forUris(()=>this.c);return j.fill(this.rawDeleted.map(F=>[F,!0])),j}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const j of W){switch(j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}this.b!==q.a&&(typeof j.cId=="number"?this.b===void 0?this.b=j.cId:this.b!==j.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(W,...z){return this.h(W,{includeChildren:!1},...z)}affects(W,...z){return this.h(W,{includeChildren:!0},...z)}h(W,z,...j){if(!W)return!1;const F=j.length>0;return!!((!F||j.includes(1))&&(this.d.value.get(W)||z.includeChildren&&this.d.value.findSuperstr(W))||(!F||j.includes(0))&&(this.f.value.get(W)||z.includeChildren&&this.f.value.findSuperstr(W))||(!F||j.includes(2))&&(this.g.value.findSubstr(W)||z.includeChildren&&this.g.value.findSuperstr(W)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(W){return this.b===W}hasCorrelation(){return typeof this.b=="number"}}e.$ll=q;function Y(ee,W,z){return!ee||!W||ee===W||W.length>ee.length?!1:(W.charAt(W.length-1)!==N.sep&&(W+=N.sep),z?(0,L.$Af)(ee,W):ee.indexOf(W)===0)}class K extends Error{constructor(W,z,j){super(W),this.fileOperationResult=z,this.options=j}}e.$nl=K;class Z extends K{constructor(W,z,j,F){super(W,z,F),this.fileOperationResult=z,this.size=j}}e.$ol=Z;class G extends K{constructor(W,z,j){super(W,2,j),this.stat=z}}e.$pl=G;var J;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(J||(e.FileOperationResult=J={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var V;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(V||(e.FileKind=V={})),e.$xl="";function H(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}async function ie(ee,W){if(!W.hasProvider(O.URI.from({scheme:ee.scheme})))return new Promise(z=>{const j=W.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===ee.scheme&&F.added&&(j.dispose(),z())})})}class se{static{this.KB=1024}static{this.MB=se.KB*se.KB}static{this.GB=se.MB*se.KB}static{this.TB=se.GB*se.KB}static formatSize(W){return(0,A.$cg)(W)||(W=0),W<se.KB?(0,I.localize)(1,null,W.toFixed(0)):W<se.MB?(0,I.localize)(2,null,(W/se.KB).toFixed(2)):W<se.GB?(0,I.localize)(3,null,(W/se.MB).toFixed(2)):W<se.TB?(0,I.localize)(4,null,(W/se.GB).toFixed(2)):(0,I.localize)(5,null,(W/se.TB).toFixed(2))}}e.$Al=se;function he(ee){const W=typeof ee=="string"||ee?.scheme===E.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===E.Schemas.file?1024*se.MB:W?10*se.MB:d.$o?50*se.MB:1024*se.MB}});var X=this&&this.__param||function(ne,e){return function(D,N){e(D,N,ne)}};define(ae[196],ce([0,1,73,50,12]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=void 0;let A=class{constructor(I){this.a=I}async checksum(I){const P=(await this.a.readFileStream(I)).value;return new Promise((d,E)=>{const y=(0,D.createHash)("sha256");(0,N.$ze)(P,{onData:p=>y.update(p.buffer),onError:p=>E(p),onEnd:()=>d(y.digest("base64").replace(/=+$/,""))})})}};e.$7ec=A,e.$7ec=A=ve([X(0,L.$5k)],A)}),define(ae[97],ce([0,1,15,7,166,12]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=O;async function O(E,y,p,l,c,b){let m;try{await I(E,y,p,l,c,b)}catch(f){m=f}finally{m&&c.errorTransformer&&(m=c.errorTransformer(m)),typeof m<"u"&&p.error(m),p.end()}}async function I(E,y,p,l,c,b){P(b);const m=await E.open(y,{create:!1});try{P(b);let f=0,u=0,h=c&&typeof c.length=="number"?c.length:void 0,g=D.$He.alloc(Math.min(c.bufferSize,typeof h=="number"?h:c.bufferSize)),$=c&&typeof c.position=="number"?c.position:0,t=0;do u=await E.read(m,$,g.buffer,t,g.byteLength-t),$+=u,t+=u,f+=u,typeof h=="number"&&(h-=u),t===g.byteLength&&(await p.write(l(g)),g=D.$He.alloc(Math.min(c.bufferSize,typeof h=="number"?h:c.bufferSize)),t=0);while(u>0&&(typeof h!="number"||h>0)&&P(b)&&d(f,c));if(t>0){let r=t;typeof h=="number"&&(r=Math.min(t,h)),p.write(l(g.slice(0,r)))}}catch(f){throw(0,A.$gl)(f)}finally{await E.close(m)}}function P(E){if(E.isCancellationRequested)throw(0,N.$6)();return!0}function d(E,y){if(typeof y?.limits?.size=="number"&&E>y.limits.size)throw(0,A.$fl)((0,L.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ae[46],ce([0,1,90,2,14,5,8,12]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rq=e.$Qq=e.$Pq=void 0,e.$Nq=P,e.$Oq=d,e.$Sq=l,e.$Tq=c,e.$Uq=b,e.$Vq=m,e.$Wq=u,e.$Xq=h;function P(g){return typeof g.correlationId=="number"}function d(g){return g.recursive===!0}class E extends N.$Uc{static{this.a=5}constructor($,t,r,n){super(),this.h=$,this.j=t,this.m=r,this.n=n,this.c=this.B(new N.$Vc),this.f=void 0,this.g=0}s(){const $=new N.$Tc;this.c.value=$,this.b=this.r($),this.b.setVerboseLogging(this.m),$.add(this.b.onDidChangeFile(t=>this.h(t))),$.add(this.b.onDidLogMessage(t=>this.j(t))),$.add(this.b.onDidError(t=>this.t(t)))}t($){this.n.restartOnError?this.g<E.a&&this.f?(this.w(`restarting watcher after error: ${$}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${$}`):this.w($)}u($){this.g++,this.s(),this.watch($)}async watch($){this.f=$,await this.b?.watch($)}async setVerboseLogging($){this.m=$,await this.b?.setVerboseLogging($)}w($){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${$}`})}y($){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${$}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Pq=E;class y extends E{constructor($,t,r){super($,t,r,{type:"node.js",restartOnError:!1})}}e.$Qq=y;class p extends E{constructor($,t,r){super($,t,r,{type:"universal",restartOnError:!0})}}e.$Rq=p;function l(g){return g.map($=>({type:$.type,resource:O.URI.revive($.resource),cId:$.cId}))}function c(g){const $=new f;for(const t of g)$.processEvent(t);return $.coalesce()}function b(g,$){return typeof $=="string"&&!$.startsWith(D.$ok)&&!(0,L.$ic)($)?{base:g,pattern:$}:$}function m(g,$){const t=[];for(const r of $)t.push((0,D.$sk)(b(g,r)));return t}class f{constructor(){this.a=new Set,this.b=new Map}c($){return A.$k?$.resource.fsPath:$.resource.fsPath.toLowerCase()}processEvent($){const t=this.b.get(this.c($));let r=!1;if(t){const n=t.type,s=$.type;t.resource.fsPath!==$.resource.fsPath&&($.type===2||$.type===1)?r=!0:n===1&&s===2?(this.b.delete(this.c($)),this.a.delete(t)):n===2&&s===1?t.type=0:n===1&&s===0||(t.type=s)}else r=!0;r&&(this.a.add($),this.b.set(this.c($),$))}coalesce(){const $=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?($.push(r),!1):!0).sort((r,n)=>r.resource.fsPath.length-n.resource.fsPath.length).filter(r=>t.some(n=>(0,I.$ml)(r.resource.fsPath,n,!A.$k))?!1:(t.push(r.resource.fsPath),!0)).concat($)}}function u(g,$){if(typeof $=="number")switch(g.type){case 1:return($&4)===0;case 2:return($&8)===0;case 0:return($&2)===0}return!1}function h(g){if(typeof g=="number"){const $=[];return g&4&&$.push("Added"),g&8&&$.push("Deleted"),g&2&&$.push("Updated"),$.length===0?"<all>":`[${$.join(", ")}]`}return"<none>"}}),define(ae[197],ce([0,1,15,38,7,3,2,50,32,12,46]),function(ne,e,D,N,L,A,O,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=void 0,e.$VP="localFilesystem";class y extends O.$Uc{constructor(l,c){super(),this.a=l,this.b=c,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$fe),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$fe),this.onDidWatchError=this.g.event,this.h=(0,P.$Ug)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,c){const{buffer:b}=await this.a.call("readFile",[l,c]);return b}readFileStream(l,c,b){const m=(0,I.$ve)(u=>D.$He.concat(u.map(h=>D.$He.wrap(h))).buffer),f=new O.$Tc;return f.add(this.a.listen("readFileStream",[l,c])(u=>{if(u instanceof D.$He)m.write(u.buffer);else{if(u==="end")m.end();else{let h;if(u instanceof Error)h=u;else{const g=u;h=(0,d.$fl)(g.message??(0,N.$jj)(g),g.code??d.FileSystemProviderErrorCode.Unknown)}m.error(h),m.end()}f.dispose()}})),f.add(b.onCancellationRequested(()=>{m.error((0,L.$6)()),m.end(),f.dispose()})),m}writeFile(l,c,b){return this.a.call("writeFile",[l,D.$He.wrap(c),b])}open(l,c){return this.a.call("open",[l,c])}close(l){return this.a.call("close",[l])}async read(l,c,b,m,f){const[u,h]=await this.a.call("read",[l,c,f]);return b.set(u.buffer.slice(0,h),m),h}write(l,c,b,m,f){return this.a.call("write",[l,c,D.$He.wrap(b),m,f])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,c){return this.a.call("delete",[l,c])}rename(l,c,b){return this.a.call("rename",[l,c,b])}copy(l,c,b){return this.a.call("copy",[l,c,b])}cloneFile(l,c){return this.a.call("cloneFile",[l,c])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const c=l;this.f.fire((0,E.$Sq)(c))}else{const c=l;this.g.fire(c)}}))}watch(l,c){const b=(0,P.$Ug)();return this.a.call("watch",[this.h,b,l,c]),(0,O.$Sc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$WP=y}),define(ae[198],ce([0,1,41,2,46,3,8,6]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class P extends N.$Uc{constructor(){super(),this.a=this.B(new A.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new A.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new A.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new N.$4c),this.m=new Set,this.n=5007,this.r=new I.$Vh,this.P=!1,this.B(this.f(E=>this.s(E)))}s(E){this.t(E)&&this.w(E)}t(E){return(0,L.$Nq)(E)}async watch(E){this.r.isSettled||this.r.complete(),this.r=new I.$Vh;try{this.h.clear(),this.g.clear();for(const y of E)this.t(y)?this.h.set(y.correlationId,y):this.g.add(y);for(const[y]of this.j)this.h.has(y)||(this.j.deleteAndDispose(y),this.m.delete(y));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(E=>!this.j.has(E.correlationId))])}isSuspended(E){return typeof E.correlationId!="number"?!1:this.m.has(E.correlationId)?"polling":this.j.has(E.correlationId)}async w(E){if(this.j.has(E.correlationId))return;const y=new N.$Tc;this.j.set(E.correlationId,y),await this.r.p,!y.isDisposed&&(this.z(E,y),this.u())}y(E){this.j.deleteAndDispose(E.correlationId),this.m.delete(E.correlationId),this.u()}z(E,y){this.C(E,y)?(this.N(`reusing an existing recursive watcher to monitor ${E.path}`),this.m.delete(E.correlationId)):(this.D(E,y),this.m.add(E.correlationId))}C(E,y){const p=this.M?.subscribe(E.path,(l,c)=>{y.isDisposed||(l?this.z(E,y):c?.type===1&&this.F(E))});return p?(y.add(p),!0):!1}D(E,y){let p=!1;const l=(c,b)=>{if(y.isDisposed)return;const m=this.G(c),f=this.G(b),u=p;p=m,!m&&(f||u)&&this.F(E)};this.N(`starting fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,D.watchFile)(E.path,{persistent:!1,interval:this.n},l)}catch(c){this.O(`fs.watchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}y.add((0,N.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${E.path} (correlationId: ${E.correlationId})`);try{(0,D.unwatchFile)(E.path,l)}catch(c){this.O(`fs.unwatchFile() failed with error ${c} on path ${E.path} (correlationId: ${E.correlationId})`)}}))}F(E){this.N(`detected ${E.path} exists again, resuming watcher (correlationId: ${E.correlationId})`);const y={resource:O.URI.file(E.path),type:1,cId:E.correlationId};this.a.fire([y]),this.H(y,E),this.y(E)}G(E){return E.ctimeMs===0&&E.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(E,y){if(this.P){const p=` >> normalized ${E.type===1?"[ADDED]":E.type===2?"[DELETED]":"[CHANGED]"} ${E.resource.fsPath}`;this.I(p,y)}}I(E,y){this.P&&this.N(`${E}${typeof y.correlationId=="number"?` <${y.correlationId}> `:""}`)}J(E){return`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, filter: ${(0,L.$Xq)(E.filter)}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`}async setVerboseLogging(E){this.P=E}}e.$7q=P}),define(ae[199],ce([0,1,41,6,26,40,2,87,14,5,20,8,149,31,46]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,e.$ar=m;class b extends O.$Uc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(u,h,g,$,t,r){super(),this.s=u,this.t=h,this.u=g,this.w=$,this.y=t,this.z=r,this.c=this.B(new N.$Nh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},n=>this.u(n))),this.f=this.B(new N.$Mh(n=>this.M(n),b.b)),this.g=(0,c.$Vq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,c.$Vq)(this.s.path,this.s.includes):void 0,this.j=(0,c.$Nq)(this.s)?this.s.filter:void 0,this.m=new L.$qe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const u=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const h=await l.Promises.stat(u);if(this.m.token.isCancellationRequested)return;this.B(await this.G(u,h.isDirectory()))}catch(u){u.code!=="ENOENT"?this.O(u):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${u})`),this.D()}}D(){this.r=!0,this.w?.()}async F(u){let h=u.path;try{h=await l.Promises.realpath(u.path),u.path===h&&(h=await(0,p.$9q)(u.path,this.m.token)??u.path),u.path!==h&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${u.path}, real: ${h})`)}catch{}return h}async G(u,h){const g=new O.$Tc;return this.H(u,h,g)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(u,h,g)),g}H(u,h,g){if(h)return!1;const $=y.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,n)=>{if(!g.isDisposed)if(r){const s=await this.G(u,h);g.isDisposed?s.dispose():g.add(s)}else n&&(typeof n.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:$,type:n.type,cId:this.s.correlationId},!0)});return t?(g.add(t),!0):!1}async I(u,h,g){if(d.$j&&(0,A.$xg)(u,"/Volumes/",!0)){this.O(`Refusing to watch ${u} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const $=new L.$qe(this.m.token);g.add((0,O.$Sc)(()=>$.dispose(!0)));const t=new O.$Tc;g.add(t);try{const r=y.URI.file(this.s.path),n=(0,P.$nc)(u),s=(0,D.watch)(u);t.add((0,O.$Sc)(()=>{s.removeAllListeners(),s.close()})),this.Q(`Started watching: '${u}'`);const i=new Set;if(h)try{for(const a of await l.Promises.readdir(u))i.add(a)}catch(a){this.O(a)}if($.token.isCancellationRequested)return;const o=new Map;t.add((0,O.$Sc)(()=>{for(const[,a]of o)a.dispose();o.clear()})),s.on("error",(a,w)=>{$.token.isCancellationRequested||(this.O(`Failed to watch ${u} for changes using fs.watch() (${a}, ${w})`),this.D())}),s.on("change",(a,w)=>{if($.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${a}"] ${w}`);let S="";if(w&&(S=w.toString(),d.$j&&(S=(0,I.$dm)(S))),!(!S||a!=="change"&&a!=="rename"))if(h)if(a==="rename"){o.get(S)?.dispose();const v=setTimeout(async()=>{if(o.delete(S),S===n&&!await l.Promises.exists(u)){this.J(r);return}if($.token.isCancellationRequested)return;const k=await this.N((0,P.$jc)(u,S));if($.token.isCancellationRequested)return;let C;k?i.has(S)?C=0:(C=1,i.add(S)):(i.delete(S),C=2),this.L({resource:(0,E.$_g)(r,S),type:C,cId:this.s.correlationId})},b.a);o.set(S,(0,O.$Sc)(()=>clearTimeout(v)))}else{let v;i.has(S)?v=0:(v=1,i.add(S)),this.L({resource:(0,E.$_g)(r,S),type:v,cId:this.s.correlationId})}else if(a==="rename"||S!==n){const v=setTimeout(async()=>{const k=await l.Promises.exists(u);$.token.isCancellationRequested||(k?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(u,!1))):this.J(r))},b.a);t.clear(),t.add((0,O.$Sc)(()=>clearTimeout(v)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){$.token.isCancellationRequested||this.O(`Failed to watch ${u} for changes using fs.watch() (${r.toString()})`),this.D()}}J(u){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:u,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(u,h=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.resource.fsPath}`),!h&&this.g.some(g=>g(u.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${u.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(g=>g(u.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${u.resource.fsPath}`):this.f.work(u))}M(u){const h=(0,c.$Tq)(u),g=[];for(const t of h){if((0,c.$Wq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}g.push(t)}if(g.length===0)return;if(this.z)for(const t of g)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(g)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(u){if(d.$k)return l.Promises.exists(u);try{const h=(0,P.$nc)(u);return(await l.Promises.readdir((0,P.$mc)(u))).some($=>$===h)}catch(h){return this.Q(h),!1}}setVerboseLogging(u){this.z=u}O(u){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${u}`})}P(u){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${u}`})}Q(u){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${u}`})}R(u){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${u}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$_q=b;async function m(f,u,h,g,$=512){const t=await l.Promises.open(f,"r"),r=Buffer.allocUnsafe($),n=new L.$qe(g);let s,i=!1;const o={path:f,excludes:[],recursive:!1},a=new b(o,void 0,w=>{(async()=>{for(const{type:S}of w)if(S===0){if(i)return;i=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:v}=await l.Promises.read(t,r,0,$,null);if(!v||n.token.isCancellationRequested)break;u(r.slice(0,v))}}catch(v){s=new Error(v),n.dispose(!0)}finally{i=!1}}})()});return await a.ready,h(),new Promise((w,S)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await l.Promises.close(t)}catch(v){s=new Error(v)}s?S(s):w()})})}}),define(ae[200],ce([0,1,3,90,198,5,199,40]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=void 0;class P extends L.$7q{constructor(E){super(),this.M=E,this.onDidError=D.Event.None,this.watchers=new Set}async L(E){E=this.X(E);const y=[],p=new Set(Array.from(this.watchers));for(const l of E){const c=this.S(l);c&&(0,N.$wk)(c.request.excludes,l.excludes)&&(0,N.$wk)(c.request.includes,l.includes)?p.delete(c):y.push(l)}y.length&&this.N(`Request to start watching: ${y.map(l=>this.J(l)).join(",")}`),p.size&&this.N(`Request to stop watching: ${Array.from(p).map(l=>this.J(l.request)).join(",")}`);for(const l of p)this.W(l);for(const l of y)this.U(l)}S(E){for(const y of this.watchers)if(typeof E.correlationId=="number"||typeof y.request.correlationId=="number"){if(y.request.correlationId===E.correlationId)return y}else if((0,I.$wg)(y.request.path,E.path,!A.$k))return y}U(E){const y=new O.$_q(E,this.M,l=>this.a.fire(l),()=>this.c.fire(E),l=>this.b.fire(l),this.P),p={request:E,instance:y};this.watchers.add(p)}async stop(){await super.stop();for(const E of this.watchers)this.W(E)}W(E){this.N("stopping file watcher",E),this.watchers.delete(E),E.instance.dispose()}X(E){const y=new Map;for(const p of E){const l=A.$k?p.path:p.path.toLowerCase();let c=y.get(p.correlationId);c||(c=new Map,y.set(p.correlationId,c)),c.has(l)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(p)}`),c.set(l,p)}return Array.from(y.values()).map(p=>Array.from(p.values())).flat()}async setVerboseLogging(E){super.setVerboseLogging(E);for(const y of this.watchers)y.instance.setVerboseLogging(E)}N(E,y){this.P&&this.b.fire({type:"trace",message:this.$(E,y)})}O(E){this.b.fire({type:"warn",message:this.$(E)})}$(E,y){return y?`[File Watcher (node.js)] ${E} (${this.J(y.request)})`:`[File Watcher (node.js)] ${E}`}}e.$br=P}),define(ae[201],ce([0,1,46,200]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class L extends D.$Qq{constructor(O,I,P){super(O,I,P),this.s()}r(O){return O.add(new N.$br(void 0))}}e.$cr=L}),define(ae[202],ce([0,1,23,42,92,46]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=void 0;class O extends A.$Rq{constructor(P,d,E){super(P,d,E),this.s()}r(P){const d=P.add(new L.$5q(D.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(d.onDidProcessExit(({code:E,signal:y})=>this.t(`terminated by itself with code ${E}, signal: ${y} (ETERM)`))),N.ProxyChannel.toService((0,N.$fi)(d.getChannel("watcher")))}}e.$6q=O}),define(ae[74],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class D{constructor(...L){this.a=new Map;for(const[A,O]of L)this.set(A,O)}set(L,A){const O=this.a.get(L);return this.a.set(L,A),O}has(L){return this.a.has(L)}get(L){return this.a.get(L)}}e.$wi=D}),define(ae[203],ce([0,1,6,7,2,72,193,4,74,86]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hr=e.$gr=void 0;const E=!1;class y extends Error{constructor(m){super("cyclic dependency between services"),this.message=m.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${m.toString()}`}}class p{constructor(m=new P.$wi,f=!1,u,h=E){this.i=m,this.j=f,this.k=u,this.l=h,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(I.$xi,this),this._globalGraph=h?u?._globalGraph??new O.$fr(g=>g):void 0}dispose(){if(!this.f){this.f=!0,(0,L.$Pc)(this.h),this.h.clear();for(const m of this.g)(0,L.$Oc)(m)&&m.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(m){this.m();const f=new class extends p{dispose(){this.h.delete(f),super.dispose()}}(m,this.j,this,this.l);return this.h.add(f),f}invokeFunction(m,...f){this.m();const u=c.traceInvocation(this.l,m);let h=!1;try{return m({get:$=>{if(h)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.s($,u);if(!t)throw new Error(`[invokeFunction] unknown service '${$}'`);return t}},...f)}finally{h=!0,u.stop()}}createInstance(m,...f){this.m();let u,h;return m instanceof A.$vi?(u=c.traceCreation(this.l,m.ctor),h=this.o(m.ctor,m.staticArguments.concat(f),u)):(u=c.traceCreation(this.l,m),h=this.o(m,f,u)),u.stop(),h}o(m,f=[],u){const h=I._util.getServiceDependencies(m).sort((t,r)=>t.index-r.index),g=[];for(const t of h){const r=this.s(t.id,u);r||this.y(`[createInstance] ${m.name} depends on UNKNOWN service ${t.id}.`,!1),g.push(r)}const $=h.length>0?h[0].index:f.length;if(f.length!==$){console.trace(`[createInstance] First service dependency of ${m.name} at position ${$+1} conflicts with ${f.length} static arguments`);const t=$-f.length;t>0?f=f.concat(new Array(t)):f=f.slice(0,$)}return Reflect.construct(m,f.concat(g))}q(m,f){if(this.i.get(m)instanceof A.$vi)this.i.set(m,f);else if(this.k)this.k.q(m,f);else throw new Error("illegalState - setting UNKNOWN service instance")}r(m){const f=this.i.get(m);return!f&&this.k?this.k.r(m):f}s(m,f){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(m));const u=this.r(m);return u instanceof A.$vi?this.u(m,u,f.branch(m,!0)):(f.branch(m,!1),u)}u(m,f,u){if(this.t.has(m))throw new Error(`illegal state - RECURSIVELY instantiating service '${m}'`);this.t.add(m);try{return this.v(m,f,u)}finally{this.t.delete(m)}}v(m,f,u){const h=new O.$fr(t=>t.id.toString());let g=0;const $=[{id:m,desc:f,_trace:u}];for(;$.length;){const t=$.pop();if(h.lookupOrInsertNode(t),g++>1e3)throw new y(h);for(const r of I._util.getServiceDependencies(t.desc.ctor)){const n=this.r(r.id);if(n||this.y(`[createInstance] ${m} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),n instanceof A.$vi){const s={id:r.id,desc:n,_trace:t._trace.branch(r.id,!0)};h.insertEdge(t,s),$.push(s)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new y(h);break}for(const{data:r}of t){if(this.r(r.id)instanceof A.$vi){const s=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,s)}h.removeNode(r)}}return this.r(m)}w(m,f,u=[],h,g){if(this.i.get(m)instanceof A.$vi)return this.x(m,f,u,h,g,this.g);if(this.k)return this.k.w(m,f,u,h,g);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}x(m,f,u=[],h,g,$){if(h){const t=new p(void 0,this.j,this,this.l);t.c=String(m);const r=new Map,n=new D.$Rh(()=>{const s=t.o(f,u,g);for(const[i,o]of r){const a=s[i];if(typeof a=="function")for(const w of o)w.disposable=a.apply(s,w.listener)}return r.clear(),$.add(s),s});return new Proxy(Object.create(null),{get(s,i){if(!n.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let w=r.get(i);return w||(w=new d.$5c,r.set(i,w)),(v,k,C)=>{if(n.isInitialized)return n.value[i](v,k,C);{const R={listener:[v,k,C],disposable:void 0},M=w.push(R);return(0,L.$Sc)(()=>{M(),R.disposable?.dispose()})}}}if(i in s)return s[i];const o=n.value;let a=o[i];return typeof a!="function"||(a=a.bind(o),s[i]=a),a},set(s,i,o){return n.value[i]=o,!0},getPrototypeOf(s){return f.prototype}})}else{const t=this.o(f,u,g);return $.add(t),t}}y(m,f){if(f&&console.warn(m),this.j)throw new Error(m)}}e.$gr=p;var l;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(l||(l={}));class c{static{this.all=new Set}static{this.c=new class extends c{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(m,f){return m?new c(2,f.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):c.c}static traceCreation(m,f){return m?new c(1,f.name):c.c}static{this.f=0}constructor(m,f){this.type=m,this.name=f,this.g=Date.now(),this.h=[]}branch(m,f){const u=new c(3,m.toString());return this.h.push([m,f,u]),u}stop(){const m=Date.now()-this.g;c.f+=m;let f=!1;function u(g,$){const t=[],r=new Array(g+1).join("	");for(const[n,s,i]of $.h)if(s&&i){f=!0,t.push(`${r}CREATES -> ${n}`);const o=u(g+1,i);o&&t.push(o)}else t.push(`${r}uses -> ${n}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${m.toFixed(2)}ms (grand total ${c.f.toFixed(2)}ms)`];(m>2||f)&&c.all.add(h.join(`
`))}}e.$hr=c}),define(ae[56],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cec=e.$Bec=void 0,e.$Bec=(0,D.$yi)("mainProcessService");class N{constructor(A,O){this.a=A,this.b=O}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,O){this.a.registerChannel(A,O)}}e.$Cec=N}),define(ae[75],ce([0,1,26,2,5,168,29,4]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=e.$Vr=void 0,e.$Ur=P;function P(E){return E.tags.find(y=>y.startsWith("lp-"))?.split("lp-")[1]}e.$Vr=(0,I.$yi)("languagePackService");let d=class extends N.$Uc{constructor(y){super(),this.c=y}async getAvailableLanguages(){const y=new D.$qe;setTimeout(()=>y.cancel(),1e3);let p;try{p=await this.c.query({text:'category:"language packs"',pageSize:20},y.token)}catch{return[]}const c=p.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(m=>m.startsWith("lp-"))).map(b=>{const m=b.properties.localizedLanguages?.[0],f=P(b);return{...this.f(f,m,b),extensionId:b.identifier.id,galleryExtension:b}});return c.push(this.f("en","English")),c}f(y,p,l){const c=p??y;let b;if(c!==y&&(b=`(${y})`),y.toLowerCase()===L.$w.toLowerCase()&&(b??="",b+=(0,A.localize)(0,null)),l?.installCount){b??="";const m=l.installCount;let f;m>1e6?f=`${Math.floor(m/1e5)/10}M`:m>1e3?f=`${Math.floor(m/1e3)}K`:f=String(m),b+=` $(cloud-download) ${f}`}return{id:y,label:c,description:b}}};e.$Wr=d,e.$Wr=d=ve([X(0,O.$0o)],d)}),define(ae[204],ce([0,1,2,75]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ec=void 0;let L=class extends D.$Uc{constructor(O){super(),this.a=O,this.b()}b(){this.a.update()}};e.$3ec=L,e.$3ec=L=ve([X(0,N.$Vr)],L)}),define(ae[9],ce([0,1,169,38,3,54,2,34,5,20,13,8,93,4]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=b,e.log=f,e.$gk=a,e.$hk=w,e.$ik=S,e.$jk=v,e.$5j=(0,l.$yi)("logService"),e.$6j=(0,l.$yi)("loggerService");function c(){return new Date().toISOString()}function b(k){return(0,E.$cg)(k)}var m;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(m||(e.LogLevel=m={})),e.$8j=m.Info;function f(k,C,R){switch(C){case m.Trace:k.trace(R);break;case m.Debug:k.debug(R);break;case m.Info:k.info(R);break;case m.Warning:k.warn(R);break;case m.Error:k.error(R);break;case m.Off:break;default:throw new Error(`Invalid log level ${C}`)}}function u(k,C=!1){let R="";for(let M=0;M<k.length;M++){let T=k[M];if(T instanceof Error&&(T=(0,N.$jj)(T,C)),typeof T=="object")try{T=JSON.stringify(T)}catch{}R+=(M>0?" ":"")+T}return R}class h extends O.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new L.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==m.Off&&this.b<=C}}e.$0j=h;class g extends h{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...R){this.f(m.Trace)&&this.g(m.Trace,u([C,...R],!0))}debug(C,...R){this.f(m.Debug)&&this.g(m.Debug,u([C,...R]))}info(C,...R){this.f(m.Info)&&this.g(m.Info,u([C,...R]))}warn(C,...R){this.f(m.Warning)&&this.g(m.Warning,u([C,...R]))}error(C,...R){if(this.f(m.Error))if(C instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=C.stack,this.g(m.Error,u(M))}else this.g(m.Error,u([C,...R]))}flush(){}}e.$$j=g;class $ extends h{constructor(C=e.$8j){super(),this.setLevel(C),this.g=!P.$i}trace(C,...R){this.f(m.Trace)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...R):console.log(`[main ${c()}]`,C,...R))}debug(C,...R){this.f(m.Debug)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...R):console.log(`[main ${c()}]`,C,...R))}info(C,...R){this.f(m.Info)&&(this.g?console.log(`\x1B[90m[main ${c()}]\x1B[0m`,C,...R):console.log(`[main ${c()}]`,C,...R))}warn(C,...R){this.f(m.Warning)&&(this.g?console.warn(`\x1B[93m[main ${c()}]\x1B[0m`,C,...R):console.warn(`[main ${c()}]`,C,...R))}error(C,...R){this.f(m.Error)&&(this.g?console.error(`\x1B[91m[main ${c()}]\x1B[0m`,C,...R):console.error(`[main ${c()}]`,C,...R))}flush(){}}e.$_j=$;class t extends h{constructor(C=e.$8j,R=!0){super(),this.g=R,this.setLevel(C)}trace(C,...R){this.f(m.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...R):console.log(C,...R))}debug(C,...R){this.f(m.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...R):console.log(C,...R))}info(C,...R){this.f(m.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...R):console.log(C,...R))}warn(C,...R){this.f(m.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...R):console.log(C,...R))}error(C,...R){this.f(m.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...R):console.error(C,...R))}flush(){}}e.$ak=t;class r extends h{constructor(C,R=e.$8j){super(),this.g=C,this.setLevel(R)}trace(C,...R){this.f(m.Trace)&&this.g.log(m.Trace,[this.h(C),...R])}debug(C,...R){this.f(m.Debug)&&this.g.log(m.Debug,[this.h(C),...R])}info(C,...R){this.f(m.Info)&&this.g.log(m.Info,[this.h(C),...R])}warn(C,...R){this.f(m.Warning)&&this.g.log(m.Warning,[this.h(C),...R])}error(C,...R){this.f(m.Error)&&this.g.log(m.Error,[this.h(C),...R])}h(C){return typeof C=="string"?C:(0,N.$jj)(C,this.f(m.Trace))}flush(){}}e.$bk=r;class n extends h{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const R of this.g)R.setLevel(C);super.setLevel(C)}trace(C,...R){for(const M of this.g)M.trace(C,...R)}debug(C,...R){for(const M of this.g)M.debug(C,...R)}info(C,...R){for(const M of this.g)M.info(C,...R)}warn(C,...R){for(const M of this.g)M.warn(C,...R)}error(C,...R){for(const M of this.g)M.error(C,...R)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose();super.dispose()}}e.$ck=n;class s extends O.$Uc{constructor(C,R,M){if(super(),this.h=C,this.j=R,this.b=new I.$Ac,this.c=this.B(new L.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$fe),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(C){return(0,E.$$f)(C)?[...this.b.values()].find(R=>R.info.id===C):this.b.get(C)}getLogger(C){return this.m(C)?.logger}createLogger(C,R){const M=this.n(C),T=(0,E.$$f)(C)?C:R?.id??(0,A.$mj)(M.toString()).toString(16);let q=this.b.get(M)?.logger;const Y=R?.logLevel==="always"?m.Trace:R?.logLevel;q||(q=this.s(M,Y??this.getLogLevel(M)??this.h,{...R,id:T}));const K={logger:q,info:{resource:M,id:T,logLevel:Y,name:R?.name,hidden:R?.hidden,extensionId:R?.extensionId,when:R?.when}};return this.registerLogger(K.info),this.b.set(M,K),q}n(C){return(0,E.$$f)(C)?(0,d.$_g)(this.j,`${C}.log`):C}setLogLevel(C,R){if(y.URI.isUri(C)){const M=C,T=R,q=this.b.get(M);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([M,T]))}else{this.h=C;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,R){const M=this.m(C);M&&R!==!M.info.hidden&&(M.info.hidden=!R,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,R]))}getLogLevel(C){let R;return C&&(R=this.b.get(C)?.info.logLevel),R??this.h}registerLogger(C){const R=this.b.get(C.resource);R?R.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const R=this.b.get(C);R&&(R.logger&&R.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[R.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=s;class i{constructor(){this.onDidChangeLogLevel=new L.$fe().event}setLevel(C){}getLevel(){return m.Info}trace(C,...R){}debug(C,...R){}info(C,...R){}warn(C,...R){}error(C,...R){}critical(C,...R){}dispose(){}flush(){}}e.$ek=i;class o extends i{}e.$fk=o;function a(k){if(k.verbose)return m.Trace;if(typeof k.logLevel=="string"){const C=v(k.logLevel.toLowerCase());if(C!==void 0)return C}return e.$8j}function w(k){switch(k){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Off:return"off"}}function S(k){switch(k){case m.Trace:return{original:"Trace",value:D.localize(0,null)};case m.Debug:return{original:"Debug",value:D.localize(1,null)};case m.Info:return{original:"Info",value:D.localize(2,null)};case m.Warning:return{original:"Warning",value:D.localize(3,null)};case m.Error:return{original:"Error",value:D.localize(4,null)};case m.Off:return{original:"Off",value:D.localize(5,null)}}}function v(k){switch(k){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Error;case"off":return m.Off}}e.$kk=new p.$Pj("logLevel",w(m.Info))}),define(ae[205],ce([0,1,6,7,2,23,14,20,31,16,9]),function(ne,e,D,N,L,A,O,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=void 0;let y=class extends L.$Uc{constructor(l,c){super(),this.a=l,this.b=c,this.B(new D.$Kh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,I.$9g)(this.a.logsHome),c=(0,I.$$g)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,f=(await P.Promises.readdir(c)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==l),u=f.slice(0,Math.max(0,f.length-9));u.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${u.join(", ")}'`),await Promise.all(u.map(h=>P.Promises.rm((0,O.$jc)(c,h)))))}catch(l){(0,N.$1)(l)}}};e.$4ec=y,e.$4ec=y=ve([X(0,d.$Fi),X(1,E.$5j)],y)}),define(ae[206],ce([0,1,17,6,7,3,40,2,14,46,9]),function(ne,e,D,N,L,A,O,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yq=void 0;class y extends I.$Uc{constructor(l,c){super(),this.a=l,this.b=c,this.c=this.B(new A.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$wh(0)),this.w=[],this.y=this.B(new N.$wh(0))}watch(l,c){return c.recursive||this.b?.watcher?.forceUniversal?this.n(l,c):this.z(l,c)}n(l,c){const b={path:this.J(l),excludes:c.excludes,includes:c.includes,recursive:c.recursive,filter:c.filter,correlationId:c.correlationId},m=(0,D.$Tb)(this.j,b);return this.r(),(0,I.$Sc)(()=>{m(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(l=>(0,L.$1)(l))}s(){this.h||(this.h=this.B(this.t(c=>this.c.fire((0,d.$Sq)(c)),c=>this.G(c),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)})));const l=this.b?.watcher?.recursive?.usePolling;if(l===!0)for(const c of this.j)(0,d.$Oq)(c)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(l))for(const c of this.j)(0,d.$Oq)(c)&&l.includes(c.path)&&(c.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(l,c){const b={path:this.J(l),excludes:c.excludes,includes:c.includes,recursive:!1,filter:c.filter,correlationId:c.correlationId},m=(0,D.$Tb)(this.w,b);return this.C(),(0,I.$Sc)(()=>{m(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(l=>(0,L.$1)(l))}D(){return this.u||(this.u=this.B(this.F(l=>this.c.fire((0,d.$Sq)(l)),l=>this.G(l),this.a.getLevel()===E.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===E.LogLevel.Trace)}))),this.u.watch(this.w)}G(l){l.type==="error"&&this.g.fire(l.message),this.H(l)}H(l){this.a[l.type](l.message)}I(l){return(0,P.$hc)(l.fsPath)}J(l){const c=this.I(l);return(0,O.$Ag)(c)}}e.$Yq=y}),define(ae[207],ce([0,1,17,6,15,26,3,54,61,2,51,23,98,20,50,164,12,97,9,7]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=void 0;let $=class extends d.$Uc{static{g=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new O.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new O.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new O.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new O.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new O.$fe),this.Y=this.B(new O.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new O.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new N.$Hh)}registerProvider(r,n){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${r}`);const s=new d.$Tc;return this.h.set(r,n),this.c.fire({added:!0,scheme:r,provider:n}),s.add(n.onDidChangeFile(i=>{const o=new m.$ll(i,!this.S(n));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(i=>this.Z.fire(new Error(i)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:r}))),(0,d.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:n}),this.h.delete(r),(0,d.$Pc)(s)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const n=[];this.f.fire({scheme:r,join(s){n.push(s)}}),!this.h.has(r)&&await N.Promises.settled(n)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,n){const s=this.h.get(r.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return P.Iterable.map(this.h,([r,n])=>({scheme:r,capabilities:n.capabilities}))}async j(r){if(!(0,l.$dh)(r))throw new m.$nl((0,b.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const n=this.h.get(r.scheme);if(!n){const s=new h.$bb;throw s.message=(0,b.localize)(1,null,r.toString()),s}return n}async m(r){const n=await this.j(r);if((0,m.$$k)(n)||(0,m.$8k)(n)||(0,m.$_k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const n=await this.j(r);if((0,m.$$k)(n)||(0,m.$8k)(n))return n;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,n){try{return await this.s(r,n)}catch(s){throw(0,m.$il)(s)===m.FileSystemProviderErrorCode.FileNotFound?new m.$nl((0,b.localize)(2,null,this.sb(r)),1):(0,m.$gl)(s)}}async s(r,n){const s=await this.j(r),i=this.S(s),o=n?.resolveTo,a=n?.resolveSingleChildDescendants,w=n?.resolveMetadata,S=await s.stat(r);let v;return this.t(s,r,S,void 0,!!w,(k,C)=>(v||(v=E.$Ei.forUris(()=>!i),v.set(r,!0),o&&v.fill(!0,o)),v.get(k.resource)||v.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&a?C===1:!1))}async t(r,n,s,i,o,a){const{providerExtUri:w}=this.R(r),S={resource:n,name:w.basename(n),isFile:(s.type&m.FileType.File)!==0,isDirectory:(s.type&m.FileType.Directory)!==0,isSymbolicLink:(s.type&m.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&m.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((s.permissions??0)&m.FilePermission.Locked),etag:(0,m.$yl)({mtime:s.mtime,size:s.size}),children:void 0};if(S.isDirectory&&a(S,i)){try{const v=await r.readdir(n),k=await N.Promises.settled(v.map(async([C,R])=>{try{const M=w.joinPath(n,C),T=o?await r.stat(M):{type:R};return await this.t(r,M,T,v.length,o,a)}catch(M){return this.b.trace(M),null}}));S.children=(0,D.$Hb)(k)}catch(v){this.b.trace(v),S.children=[]}return S}return S}async resolveAll(r){return N.Promises.settled(r.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(r){const n=await this.j(r),s=await n.stat(r);return this.t(n,r,s,void 0,!0,()=>!1)}async exists(r){const n=await this.j(r);try{return!!await n.stat(r)}catch{return!1}}async canCreateFile(r,n){try{await this.u(r,n)}catch(s){return s}return!0}async u(r,n){if(!n?.overwrite&&await this.exists(r))throw new m.$nl((0,b.localize)(3,null,this.sb(r)),3,n)}async createFile(r,n=L.$He.fromString(""),s){await this.u(r,s);const i=await this.writeFile(r,n);return this.r.fire(new m.$kl(r,0,i)),i}async writeFile(r,n,s){const i=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(i);let a=s;if((0,m.$bl)(i)&&!a?.atomic){const w=i.enforceAtomicWriteFile?.(r);w&&(a={...s,atomic:w})}try{await this.w(i,r,a)||await this.U(i,o.dirname(r));let S;if((0,m.$8k)(i)&&!(n instanceof L.$He))if((0,c.$te)(n)){const v=await(0,c.$Ae)(n,3);v.ended?S=L.$He.concat(v.buffer):S=v}else S=(0,c.$xe)(n,v=>L.$He.concat(v),3);else S=n;!(0,m.$$k)(i)||(0,m.$8k)(i)&&S instanceof L.$He||(0,m.$8k)(i)&&(0,m.$bl)(i)&&a?.atomic?await this.hb(i,r,a,S):await this.db(i,r,a,S instanceof L.$He?(0,L.$Se)(S):S),this.r.fire(new m.$kl(r,4))}catch(w){throw new m.$nl((0,b.localize)(4,null,this.sb(r),(0,m.$gl)(w).toString()),(0,m.$jl)(w),a)}return this.resolve(r,{resolveMetadata:!0})}async w(r,n,s){const i=!!s?.unlock;if(i&&!(r.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(r.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(r.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(i)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await r.stat(n)}catch{return}if(a.type&m.FileType.Directory)throw new m.$nl((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==m.$xl&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,m.$yl)({mtime:s.mtime,size:a.size}))throw new m.$nl((0,b.localize)(10,null),3,s);return a}async readFile(r,n,s){const i=await this.m(r);return n?.atomic?this.z(i,r,n,s):this.C(i,r,n,s)}async z(r,n,s,i){return new Promise((o,a)=>{this.cb.queueFor(n,async()=>{try{const w=await this.C(r,n,s,i);o(w)}catch(w){a(w)}},this.R(r).providerExtUri)})}async C(r,n,s,i){const o=await this.D(r,n,{...s,preferUnbuffered:!0},i);return{...o,value:await(0,L.$Te)(o.value)}}async readFileStream(r,n,s){const i=await this.m(r);return this.D(i,r,n,s)}async D(r,n,s,i){const o=new A.$qe(i);let a=s;(0,m.$al)(r)&&r.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const w=this.J(n,a).then(v=>v,v=>{throw o.dispose(!0),v});let S;try{return typeof a?.etag=="string"&&a.etag!==m.$xl&&await w,a?.atomic&&(0,m.$al)(r)||!((0,m.$$k)(r)||(0,m.$_k)(r))||(0,m.$8k)(r)&&a?.preferUnbuffered?S=this.I(r,n,a):(0,m.$_k)(r)?S=this.G(r,n,o.token,a):S=this.H(r,n,o.token,a),S.on("end",()=>o.dispose()),S.on("error",()=>o.dispose()),{...await w,value:S}}catch(v){throw S&&await(0,c.$ye)(S),this.F(v,n,a)}}F(r,n,s){const i=(0,b.localize)(11,null,this.sb(n),(0,m.$gl)(r).toString());return r instanceof m.$pl?new m.$pl(i,r.stat,s):r instanceof m.$ol?new m.$ol(i,r.fileOperationResult,r.size,r.options):new m.$nl(i,(0,m.$jl)(r),s)}G(r,n,s,i=Object.create(null)){const o=r.readFileStream(n,i,s);return(0,c.$Ee)(o,{data:a=>a instanceof L.$He?a:L.$He.wrap(a),error:a=>this.F(a,n,i)},a=>L.$He.concat(a))}H(r,n,s,i=Object.create(null)){const o=(0,L.$Xe)();return(0,f.$Lq)(r,n,o,a=>a,{...i,bufferSize:this.a,errorTransformer:a=>this.F(a,n,i)},s),o}I(r,n,s){const i=(0,c.$ve)(o=>L.$He.concat(o));return(async()=>{try{let o;s?.atomic&&(0,m.$al)(r)?o=await r.readFile(n,{atomic:!0}):o=await r.readFile(n),typeof s?.position=="number"&&(o=o.slice(s.position)),typeof s?.length=="number"&&(o=o.slice(0,s.length)),this.L(n,o.byteLength,s),i.end(L.$He.wrap(o))}catch(o){i.error(o),i.end()}})(),i}async J(r,n){const s=await this.resolve(r,{resolveMetadata:!0});if(s.isDirectory)throw new m.$nl((0,b.localize)(12,null,this.sb(r)),0,n);if(typeof n?.etag=="string"&&n.etag!==m.$xl&&n.etag===s.etag)throw new m.$pl((0,b.localize)(13,null),s,n);return this.L(r,s.size,n),s}L(r,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new m.$ol((0,b.localize)(14,null,this.sb(r)),7,n,s)}async canMove(r,n,s){return this.M(r,n,"move",s)}async canCopy(r,n,s){return this.M(r,n,"copy",s)}async M(r,n,s,i){if(r.toString()!==n.toString())try{const o=s==="move"?this.qb(await this.n(r),r):await this.m(r),a=this.qb(await this.n(n),n);await this.Q(o,r,a,n,s,i)}catch(o){return o}return!0}async move(r,n,s){const i=this.qb(await this.n(r),r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"move",!!s),w=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new m.$kl(r,a==="move"?2:3,w)),w}async copy(r,n,s){const i=await this.m(r),o=this.qb(await this.n(n),n),a=await this.N(i,r,o,n,"copy",!!s),w=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new m.$kl(r,a==="copy"?3:2,w)),w}async N(r,n,s,i,o,a){if(n.toString()===i.toString())return o;const{exists:w,isSameResourceWithDifferentPathCase:S}=await this.Q(r,n,s,i,o,a);if(w&&!S&&a&&await this.del(i,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(i)),o==="copy"){if(r===s&&(0,m.$9k)(r))await r.copy(n,i,{overwrite:a});else{const v=await this.resolve(n);v.isDirectory?await this.P(r,v,s,i):await this.O(r,n,s,i)}return o}else return r===s?(await r.rename(n,i,{overwrite:a}),o):(await this.N(r,n,s,i,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(r,n,s,i){if((0,m.$$k)(r)&&(0,m.$$k)(s))return this.jb(r,n,s,i);if((0,m.$$k)(r)&&(0,m.$8k)(s))return this.pb(r,n,s,i);if((0,m.$8k)(r)&&(0,m.$$k)(s))return this.nb(r,n,s,i);if((0,m.$8k)(r)&&(0,m.$8k)(s))return this.lb(r,n,s,i)}async P(r,n,s,i){await s.mkdir(i),Array.isArray(n.children)&&await N.Promises.settled(n.children.map(async o=>{const a=this.R(s).providerExtUri.joinPath(i,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),s,a):this.O(r,o.resource,s,a)}))}async Q(r,n,s,i,o,a){let w=!1;if(r===s){const{providerExtUri:v,isPathCaseSensitive:k}=this.R(r);if(k||(w=v.isEqual(n,i)),w&&o==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(i)));if(!w&&v.isEqualOrParent(i,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(i)))}const S=await this.exists(i);if(S&&!w){if(!a)throw new m.$nl((0,b.localize)(17,null,this.sb(n),this.sb(i)),4);if(r===s){const{providerExtUri:v}=this.R(r);if(v.isEqualOrParent(n,i))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(i)))}}return{exists:S,isSameResourceWithDifferentPathCase:w}}R(r){const n=this.S(r);return{providerExtUri:n?l.$2g:l.$4g,isPathCaseSensitive:n}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const n=this.qb(await this.j(r),r);await this.U(n,r);const s=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new m.$kl(r,0,s)),s}async U(r,n){const s=[],{providerExtUri:i}=this.R(r);for(;!i.isEqual(n,i.dirname(n));)try{if(!((await r.stat(n)).type&m.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(o){if((0,m.$il)(o)!==m.FileSystemProviderErrorCode.FileNotFound)throw o;s.push(i.basename(n)),n=i.dirname(n)}for(let o=s.length-1;o>=0;o--){n=i.joinPath(n,s[o]);try{await r.mkdir(n)}catch(a){if((0,m.$il)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(r,n){try{await this.W(r,n)}catch(s){return s}return!0}async W(r,n){const s=this.qb(await this.j(r),r),i=!!n?.useTrash;if(i&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(r)));const o=n?.atomic;if(o&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(r)));if(i&&o)throw new Error((0,b.localize)(22,null,this.sb(r)));let a;try{a=await s.stat(r)}catch{}if(a)this.rb(r,a);else throw new m.$nl((0,b.localize)(23,null,this.sb(r)),1);if(!!!n?.recursive){const S=await this.resolve(r);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(r)))}return s}async del(r,n){const s=await this.W(r,n);let i=n;if((0,m.$cl)(s)&&!i?.atomic){const S=s.enforceAtomicDelete?.(r);S&&(i={...n,atomic:S})}const o=!!i?.useTrash,a=!!i?.recursive,w=i?.atomic??!1;await s.delete(r,{recursive:a,useTrash:o,atomic:w}),this.r.fire(new m.$kl(r,1))}async cloneFile(r,n){const s=await this.j(r),i=this.qb(await this.n(n),n);if(!(s===i&&this.R(s).providerExtUri.isEqual(r,n)))return s===i&&(0,m.$0k)(s)?s.cloneFile(r,n):(await this.U(i,this.R(i).providerExtUri.dirname(n)),s===i&&(0,m.$9k)(s)?this.cb.queueFor(r,()=>s.copy(r,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(r,()=>this.O(s,r,i,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(r,n){return this.watch(r,{...n,correlationId:g.ab++})}watch(r,n={recursive:!1,excludes:[]}){const s=new d.$Tc;let i=!1,o=()=>{i=!0};s.add((0,d.$Sc)(()=>o())),(async()=>{try{const w=await this.bb(r,n);i?(0,d.$Pc)(w):o=()=>(0,d.$Pc)(w)}catch(w){this.b.error(w)}})();const a=n.correlationId;if(typeof a=="number"){const w=s.add(new O.$fe);return s.add(this.X.event(v=>{v.correlates(a)&&w.fire(v)})),{onDidChange:w.event,dispose:()=>s.dispose()}}return s}async bb(r,n){const s=await this.j(r),i=(0,I.$mj)([this.R(s).providerExtUri.getComparisonKey(r),n]);let o=this.$.get(i);return o||(o={count:0,disposable:s.watch(r,n)},this.$.set(i,o)),o.count+=1,(0,d.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,d.$Pc)(o.disposable),this.$.delete(i)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,d.$Pc)(r.disposable);this.$.clear()}async db(r,n,s,i){return this.cb.queueFor(n,async()=>{const o=await r.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,c.$te)(i)||(0,c.$ue)(i)?await this.eb(r,o,i):await this.fb(r,o,i)}catch(a){throw(0,m.$gl)(a)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,n,s){let i=0,o;if((0,c.$ue)(s)){if(s.buffer.length>0){const a=L.$He.concat(s.buffer);await this.gb(r,n,a,a.byteLength,i,0),i+=a.byteLength}if(s.ended)return;o=s.stream}else o=s;return new Promise((a,w)=>{(0,c.$ze)(o,{onData:async S=>{o.pause();try{await this.gb(r,n,S,S.byteLength,i,0)}catch(v){return w(v)}i+=S.byteLength,setTimeout(()=>o.resume())},onError:S=>w(S),onEnd:()=>a()})})}async fb(r,n,s){let i=0,o;for(;(o=s.read())!==null;)await this.gb(r,n,o,o.byteLength,i,0),i+=o.byteLength}async gb(r,n,s,i,o,a){let w=0;for(;w<i;){const S=await r.write(n,o+w,s.buffer,a+w,i-w);w+=S}}async hb(r,n,s,i){return this.cb.queueFor(n,()=>this.ib(r,n,s,i),this.R(r).providerExtUri)}async ib(r,n,s,i){let o;i instanceof L.$He?o=i:(0,c.$te)(i)?o=await(0,L.$Te)(i):(0,c.$ue)(i)?o=await(0,L.$Ue)(i):o=(0,L.$Re)(i),await r.writeFile(n,o.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(r,n,s,i){return this.cb.queueFor(i,()=>this.kb(r,n,s,i),this.R(s).providerExtUri)}async kb(r,n,s,i){let o,a;try{o=await r.open(n,{create:!1}),a=await s.open(i,{create:!0,unlock:!1});const w=L.$He.alloc(this.a);let S=0,v=0,k=0;do k=await r.read(o,S,w.buffer,v,w.byteLength-v),await this.gb(s,a,w,k,S,v),S+=k,v+=k,v===w.byteLength&&(v=0);while(k>0)}catch(w){throw(0,m.$gl)(w)}finally{await N.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(r,n,s,i){return this.cb.queueFor(i,()=>this.mb(r,n,s,i),this.R(s).providerExtUri)}async mb(r,n,s,i){return s.writeFile(i,await r.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,n,s,i){return this.cb.queueFor(i,()=>this.ob(r,n,s,i),this.R(s).providerExtUri)}async ob(r,n,s,i){const o=await s.open(i,{create:!0,unlock:!1});try{const a=await r.readFile(n);await this.gb(s,o,L.$He.wrap(a),a.byteLength,0,0)}catch(a){throw(0,m.$gl)(a)}finally{await s.close(o)}}async pb(r,n,s,i){const o=await(0,L.$Te)(this.H(r,n,A.CancellationToken.None));await this.hb(s,i,void 0,o)}qb(r,n){if(r.capabilities&2048)throw new m.$nl((0,b.localize)(25,null,this.sb(n)),6);return r}rb(r,n){if((n.permissions??0)&m.FilePermission.Readonly)throw new m.$nl((0,b.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===y.Schemas.file?r.fsPath:r.toString(!0)}};e.$Mq=$,e.$Mq=$=g=ve([X(0,u.$5j)],$)}),define(ae[208],ce([0,1,41,277,6,34,15,3,40,2,14,5,20,50,31,167,12,97,206,38,202,201]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,h.$jj)(r)}`)}})();class t extends u.$Yq{static{this.L=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=I.Event.None,this.P=new A.$Ac(i=>p.$3g.getComparisonKey(i)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,y.$k&&(this.M|=1024)),this.M}async stat(n){try{const{stat:s,symbolicLink:i}=await c.SymlinkSupport.stat(this.I(n));return{type:this.O(s,i),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:m.FilePermission.Locked}}catch(s){throw this.hb(s)}}async N(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await c.Promises.readdir(this.I(n),{withFileTypes:!0}),i=[];return await Promise.all(s.map(async o=>{try{let a;o.isSymbolicLink()?a=(await this.stat((0,p.$_g)(n,o.name))).type:a=this.O(o),i.push([o.name,a])}catch(a){this.a.trace(a)}})),i}catch(s){throw this.hb(s)}}O(n,s){let i;return s?.dangling?i=m.FileType.Unknown:n.isFile()?i=m.FileType.File:n.isDirectory()?i=m.FileType.Directory:i=m.FileType.Unknown,s&&(i|=m.FileType.SymbolicLink),i}async Q(n){const s=this.I(n);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let i;for(;i=this.P.get(n);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await i.wait();const o=new L.$xh;return this.P.set(n,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,d.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.P.get(n)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.P.delete(n)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),o.open()})}async readFile(n,s){let i;try{s?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(n)})`),i=await this.Q(n));const o=this.I(n);return await c.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{i?.dispose()}}R(n){t.L&&this.a.trace(n)}readFileStream(n,s,i){const o=(0,l.$ve)(a=>O.$He.concat(a.map(w=>O.$He.wrap(w))).buffer);return(0,f.$Lq)(this,n,o,a=>a.buffer,{...s,bufferSize:256*1024},i),o}async writeFile(n,s,i){return i?.atomic!==!1&&i?.atomic?.postfix&&await this.S(n)?this.U(n,(0,p.$_g)((0,p.$$g)(n),`${(0,p.$9g)(n)}${i.atomic.postfix}`),s,i):this.W(n,s,i)}async S(n){try{const s=this.I(n),{symbolicLink:i}=await c.SymlinkSupport.stat(s);if(i)return!1}catch{}return!0}async U(n,s,i,o){const a=new d.$Tc;try{a.add(await this.Q(n)),a.add(await this.Q(s)),await this.W(s,i,o,!0);try{await this.rename(s,n,{overwrite:!0})}catch(w){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw w}}finally{a.dispose()}}async W(n,s,i,o){let a;try{const w=this.I(n);if(!i.create||!i.overwrite){if(await c.Promises.exists(w)){if(!i.overwrite)throw(0,m.$fl)((0,b.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!i.create)throw(0,m.$fl)((0,b.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:i.unlock},o),await this.write(a,0,s,0,s.byteLength)}catch(w){throw await this.ib(n,w)}finally{typeof a=="number"&&await this.close(a)}}static{this.$=!0}static configureFlushOnWrite(n){t.$=n}async open(n,s,i){const o=this.I(n);let a;(0,m.$6k)(s)&&!i&&(a=await this.Q(n));let w;try{if((0,m.$6k)(s)&&s.unlock)try{const{stat:v}=await c.SymlinkSupport.stat(o);v.mode&128||await c.Promises.chmod(o,v.mode|128)}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}let S;if((0,m.$6k)(s)){if(y.$i)try{await c.Promises.truncate(o,0),S="r+"}catch(v){v.code!=="ENOENT"&&this.a.trace(v)}S||(S="w")}else S="r";w=await c.Promises.open(o,S)}catch(S){throw a?.dispose(),(0,m.$6k)(s)?await this.ib(n,S):this.hb(S)}if(this.X.set(w,0),(0,m.$6k)(s)&&this.Z.set(w,n),a){const S=this.Y.get(w);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${w} (${o})`),this.Y.set(w,a),S&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${w} (${o})`),S.dispose())}return w}async close(n){const s=this.Y.get(n);try{if(this.X.delete(n),this.Z.delete(n)&&t.$)try{await c.Promises.fdatasync(n)}catch(i){t.configureFlushOnWrite(!1),this.a.error(i)}return await c.Promises.close(n)}catch(i){throw this.hb(i)}finally{s&&(this.Y.get(n)===s&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.Y.delete(n)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,i,o,a){const w=this.ab(n,s);let S=null;try{S=(await c.Promises.read(n,i,o,a,w)).bytesRead}catch(v){throw this.hb(v)}finally{this.bb(n,w,S)}return S}ab(n,s){return s===this.X.get(n)?null:s}bb(n,s,i){const o=this.X.get(n);typeof o=="number"&&(typeof s=="number"||(typeof i=="number"?this.X.set(n,o+i):this.X.delete(n)))}async write(n,s,i,o,a){return(0,L.$Sh)(()=>this.cb(n,s,i,o,a),100,3)}async cb(n,s,i,o,a){const w=this.ab(n,s);let S=null;try{S=(await c.Promises.write(n,i,o,a,w)).bytesWritten}catch(v){throw await this.ib(this.Z.get(n),v)}finally{this.bb(n,w,S)}return S}async mkdir(n){try{await c.Promises.mkdir(this.I(n))}catch(s){throw this.hb(s)}}async delete(n,s){try{const i=this.I(n);if(s.recursive){let o;s?.atomic!==!1&&s.atomic.postfix&&(o=(0,E.$jc)((0,E.$mc)(i),`${(0,E.$nc)(i)}${s.atomic.postfix}`)),await c.Promises.rm(i,c.RimRafMode.MOVE,o)}else try{await c.Promises.unlink(i)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let a=!1;try{const{stat:w,symbolicLink:S}=await c.SymlinkSupport.stat(i);a=w.isDirectory()&&!S}catch{}if(a)await c.Promises.rmdir(i);else throw o}else throw o}}catch(i){throw this.hb(i)}}async rename(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"move",i.overwrite),await c.Promises.rename(o,a)}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,b.localize)(2,null,(0,E.$nc)(o),(0,E.$nc)((0,E.$mc)(a)),w.toString()))),this.hb(w)}}async copy(n,s,i){const o=this.I(n),a=this.I(s);if(o!==a)try{await this.db(n,s,"copy",i.overwrite),await c.Promises.copy(o,a,{preserveSymlinks:!0})}catch(w){throw(w.code==="EINVAL"||w.code==="EBUSY"||w.code==="ENAMETOOLONG")&&(w=new Error((0,b.localize)(3,null,(0,E.$nc)(o),(0,E.$nc)((0,E.$mc)(a)),w.toString()))),this.hb(w)}}async db(n,s,i,o){const a=this.I(n),w=this.I(s);let S=!1;if(!!(this.capabilities&1024)||(S=(0,P.$wg)(a,w,!0)),S){if(i==="copy")throw(0,m.$fl)((0,b.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(i==="move")return}const k=await this.N(n);if(!k)throw(0,m.$fl)((0,b.localize)(5,null),m.FileSystemProviderErrorCode.FileNotFound);const C=await this.N(s);if(C){if(!o)throw(0,m.$fl)((0,b.localize)(6,null),m.FileSystemProviderErrorCode.FileExists);k.type&m.FileType.File&&C.type&m.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.eb(n,s,!1)}async eb(n,s,i){const o=this.I(n),a=this.I(s),w=!!(this.capabilities&1024);if((0,P.$wg)(o,a,!w))return;const S=new d.$Tc;try{S.add(await this.Q(n)),S.add(await this.Q(s)),i&&await c.Promises.mkdir((0,E.$mc)(a),{recursive:!0}),await c.Promises.copyFile(o,a)}catch(v){if(v.code==="ENOENT"&&!i)return this.eb(n,s,!0);throw this.hb(v)}finally{S.dispose()}}t(n,s,i){return new g.$6q(o=>n(o),o=>s(o),i)}F(n,s,i){return new $.$cr(o=>n(o),o=>s(o),i)}hb(n){if(n instanceof m.$el)return n;let s=n,i;switch(n.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,i=m.FileSystemProviderErrorCode.Unknown;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.$fl)(s,i)}async ib(n,s){let i=this.hb(s);if(n&&i.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await c.SymlinkSupport.stat(this.I(n));o.mode&128||(i=(0,m.$fl)(s,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return i}}e.$dr=t}),define(ae[99],ce([0,1,3,2,4,9]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0,e.$qfc=(0,L.$yi)("sharedProcessLifecycleService");let O=class extends N.$Uc{constructor(P){super(),this.b=P,this.a=this.B(new D.$fe),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$rfc=O,e.$rfc=O=ve([X(0,A.$5j)],O)}),define(ae[209],ce([0,1,8,3,9,2]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=e.$ds=void 0;class O extends L.$dk{constructor(y,p,l,c,b){super(p,l,c),this.r=y,this.t=b,this.B(b.listen("onDidChangeLogLevel",y)(m=>{(0,L.$7j)(m)?super.setLogLevel(m):super.setLogLevel(D.URI.revive(m[0]),m[1])})),this.B(b.listen("onDidChangeVisibility",y)(([m,f])=>super.setVisibility(D.URI.revive(m),f))),this.B(b.listen("onDidChangeLoggers",y)(({added:m,removed:f})=>{for(const u of m)super.registerLogger({...u,resource:D.URI.revive(u.resource)});for(const u of f)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new L.$bk({log:(y,p)=>{this.t.call("consoleLog",[y,p])}})}registerLogger(y){super.registerLogger(y),this.t.call("registerLogger",[y,this.r])}deregisterLogger(y){super.deregisterLogger(y),this.t.call("deregisterLogger",[y,this.r])}setLogLevel(y,p){super.setLogLevel(y,p),this.t.call("setLogLevel",[y,p])}setVisibility(y,p){super.setVisibility(y,p),this.t.call("setVisibility",[this.n(y),p])}s(y,p,l){return new I(this.t,y,p,l,this.r)}static setLogLevel(y,p,l){return y.call("setLogLevel",[p,l])}}e.$ds=O;class I extends L.$$j{constructor(y,p,l,c,b){super(c?.logLevel==="always"),this.r=y,this.s=p,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[p,c,b]).then(()=>{this.u(this.n),this.m=!0})}g(y,p){const l=[[y,p]];this.m?this.u(l):this.n.push(...l)}u(y){this.r.call("log",[this.s,y])}}class P{constructor(y,p){this.a=y,this.b=p}listen(y,p){const l=this.b(y);switch(p){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,c=>({added:[...c.added].map(b=>this.c(b,l)),removed:[...c.removed].map(b=>this.c(b,l))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,c=>[l.transformOutgoingURI(c[0]),c[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,c=>(0,L.$7j)(c)?c:[l.transformOutgoingURI(c[0]),c[1]])}throw new Error(`Event not found: ${p}`)}async call(y,p,l){const c=this.b(y);switch(p){case"setLogLevel":return(0,L.$7j)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(D.URI.revive(c.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,c)))}throw new Error(`Call not found: ${p}`)}c(y,p){return{...y,resource:p.transformOutgoingURI(y.resource)}}}e.$es=P;class d extends A.$Uc{constructor(y,p){super(),p.call("setLogLevel",[y.getLogLevel()]),this.B(y.onDidChangeLogLevel(l=>p.call("setLogLevel",[l]))),p.call("getRegisteredLoggers").then(l=>{for(const c of l)y.registerLogger({...c,resource:D.URI.revive(c.resource)})}),this.B(p.listen("onDidChangeVisibility")(([l,c])=>y.setVisibility(D.URI.revive(l),c))),this.B(p.listen("onDidChangeLoggers")(({added:l,removed:c})=>{for(const b of l)y.registerLogger({...b,resource:D.URI.revive(b.resource)});for(const b of c)y.deregisterLogger(b.resource)}))}}e.$fs=d}),define(ae[210],ce([0,1,2,9]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=void 0;class L extends D.$Uc{constructor(O,I=[]){super(),this.a=new N.$ck([O,...I]),this.B(O.onDidChangeLogLevel(P=>this.setLevel(P)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(O){this.a.setLevel(O)}getLevel(){return this.a.getLevel()}trace(O,...I){this.a.trace(O,...I)}debug(O,...I){this.a.debug(O,...I)}info(O,...I){this.a.info(O,...I)}warn(O,...I){this.a.warn(O,...I)}error(O,...I){this.a.error(O,...I)}flush(){this.a.flush()}}e.$bQ=L}),define(ae[57],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mdc=void 0,e.$mdc=(0,D.$yi)("nativeHostService")}),define(ae[211],ce([0,1,42,56]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;let L=class{constructor(O,I){return this.windowId=O,D.ProxyChannel.toService(I.getChannel("nativeHost"),{context:O,properties:(()=>{const P=new Map;return P.set("windowId",O),P})()})}};e.$Hec=L,e.$Hec=L=ve([X(1,N.$Bec)],L)}),define(ae[58],ce([0,1,3,61,2,4]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,A.$yi)("policy");class O extends L.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new D.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(d){const E=Object.keys(this.f).length;return this.f={...d,...this.f},E!==Object.keys(this.f).length&&await this.j(d),N.Iterable.reduce(this.g.entries(),(y,[p,l])=>({...y,[p]:l}),{})}getPolicyValue(d){return this.g.get(d)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(d,[E,y])=>({...d,[E]:{definition:y,value:this.g.get(E)}}),{})}}e.$io=O;class I{constructor(){this.onDidChange=D.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=I}),define(ae[212],ce([0,1,3,2,58]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=e.$0dc=void 0;class A{constructor(P){this.b=P,this.a=new N.$Tc}listen(P,d){switch(d){case"onDidChange":return D.Event.map(this.b.onDidChange,E=>E.reduce((y,p)=>({...y,[p]:this.b.getPolicyValue(p)??null}),{}),this.a)}throw new Error(`Event not found: ${d}`)}call(P,d,E){switch(d){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(E)}throw new Error(`Call not found: ${d}`)}dispose(){this.a.dispose()}}e.$0dc=A;class O extends L.$io{constructor(P,d){super(),this.a=d;for(const E in P){const{definition:y,value:p}=P[E];this.f[E]=y,p!==void 0&&this.g.set(E,p)}this.a.listen("onDidChange")(E=>{for(const y in E){const p=E[y];p===null?this.g.delete(y):this.g.set(y,p)}this.h.fire(Object.keys(E))})}async j(P){const d=await this.a.call("updatePolicyDefinitions",P);for(const E in d)this.g.set(E,d[E])}}e.$$dc=O}),define(ae[100],ce([0,1,36]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const L=globalThis.vscode;if(typeof L<"u"&&typeof L.context<"u"){const A=L.context.configuration();if(A)N=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:A.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.90.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ae[24],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,D.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(ae[213],ce([0,1,6,7,2,14,31,9,24]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ec=void 0;let d=class extends L.$Uc{constructor(y,p,l){super(),this.b=p,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,y&&this.B(new D.$Kh(()=>{this.f(y)},3e4)).schedule()}async f(y){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const p=Date.now(),l=(0,A.$mc)(y),c=(0,A.$nc)(y),b=await O.Promises.readdir(l);await Promise.all(b.map(async m=>{if(m===c)return;const f=(0,A.$jc)(l,m),u=await O.Promises.stat(f);if(u.isDirectory()&&p-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${m}.`),O.Promises.rm(f)}))}catch(p){(0,N.$1)(p)}}};e.$1ec=d,e.$1ec=d=ve([X(1,P.$lk),X(2,I.$5j)],d)}),define(ae[214],ce([0,1,6,7,2,14,31,16,9,24]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=void 0;let E=class extends L.$Uc{constructor(p,l,c){super(),this.b=p,this.c=l,this.f=c,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new D.$Kh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const p=Object.create(null),l=JSON.parse(await O.Promises.readFile((0,A.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(l)){const h=l[u];p[`${h.hash}.${u}`]=!0}const c=(0,A.$jc)(this.b.userDataPath,"clp");if(!await O.Promises.exists(c))return;const m=await O.Promises.readdir(c);for(const u of m){if(p[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await O.Promises.rm((0,A.$jc)(c,u))}const f=Date.now();for(const u of Object.keys(p)){const h=(0,A.$jc)(c,u),g=await O.Promises.readdir(h);for(const $ of g){if($==="tcf.json")continue;const t=(0,A.$jc)(h,$),r=await O.Promises.stat(t);r.isDirectory()&&f-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$jc)(u,$)}`),await O.Promises.rm(t))}}}catch(p){(0,N.$1)(p)}}};e.$2ec=E,e.$2ec=E=ve([X(0,I.$Gi),X(1,P.$5j),X(2,d.$lk)],E)}),define(ae[215],ce([0,1,14,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$rG=void 0,e.$rG=(0,N.$yi)("IV8InspectProfilingService");var L;(function(A){function O(P){return!!(P.samples&&P.timeDeltas)}A.isValidProfile=O;function I(P,d="noAbsolutePaths"){for(const E of P.nodes)E.callFrame&&E.callFrame.url&&((0,D.$ic)(E.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(E.callFrame.url))&&(E.callFrame.url=(0,D.$jc)(d,(0,D.$nc)(E.callFrame.url)));return P}A.rewriteAbsolutePaths=I})(L||(e.Utils=L={}))}),define(ae[216],ce([0,1,32]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=void 0;class N{constructor(){this.a=new Map}async startProfiling(A){const I=await(await new Promise((d,E)=>{ne(["v8-inspect-profiler"],d,E)})).startProfiling({host:A.host,port:A.port,checkForPaused:!0}),P=(0,D.$Ug)();return this.a.set(P,I),P}async stopProfiling(A){const O=this.a.get(A);if(!O)throw new Error(`UNKNOWN session '${A}'`);const I=await O.stop();return this.a.delete(A),I.profile}}e.$gfc=N}),define(ae[43],ce([0,1,128,13]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class L{constructor(){this.a=new Map}add(O,I){D.ok(N.$$f(O)),D.ok(N.$ag(I)),D.ok(!this.a.has(O),"There is already an extension with this id"),this.a.set(O,I)}knows(O){return this.a.has(O)}as(O){return this.a.get(O)||null}}e.$fo=new L}),define(ae[101],ce([0,1,3,43]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function L(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this.b=new D.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(P,d){this.a[L(P)]=d,this.b.fire(P)}notifySchemaChanged(P){this.b.fire(P)}getSchemaContributions(){return{schemas:this.a}}}const O=new A;N.$fo.add(e.$go.JSONContribution,O)}),define(ae[47],ce([0,1,17,3,13,154,21,101,43]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=b,e.$wo=m,e.$xo=f,e.$yo=h,e.$zo=g;var d;(function($){$.Multiline="multilineText",$.Singleline="singlelineText"})(d||(e.EditPresentationTypes=d={})),e.$ko={Configuration:"base.contributions.configuration"};var E;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.MACHINE=2]="MACHINE",$[$.WINDOW=3]="WINDOW",$[$.RESOURCE=4]="RESOURCE",$[$.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",$[$.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E||(e.ConfigurationScope=E={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const y=P.$fo.as(I.$go.JSONContribution);class p{constructor(){this.h=new Set,this.i=new N.$fe,this.onDidSchemaChange=this.i.event,this.j=new N.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const n=new Set;this.n(t,r,n),y.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const r=new Set;this.o(t,r),y.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const n=new Set;this.o(r,n),this.n(t,!1,n),y.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const n=[];for(const{overrides:s,source:i}of t)for(const o in s)if(r.add(o),e.$uo.test(o)){const a=this.a.get(o),w=a?.valuesSources??new Map;if(i)for(const C of Object.keys(s[o]))w.set(C,i);const S={...a?.value||{},...s[o]};this.a.set(o,{source:i,value:S,valuesSources:w});const v=(0,O.$cj)(o),k={type:"object",default:S,description:A.localize(1,null,v),$ref:e.$ro,defaultDefaultValue:S,source:L.$$f(i)?void 0:i,defaultValueSource:i};n.push(...b(o)),this.d[o]=k,this.b.properties[o]=k}else{this.a.set(o,{value:s[o],source:i});const a=this.d[o];a&&(this.w(o,a),this.r(o,a))}this.m(n)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:n,source:s}of t)for(const i in n){const o=this.a.get(i),a=L.$$f(s)?s:s?.id,w=L.$$f(o?.source)?o?.source:o?.source?.id;if(a===w)if(r.add(i),this.a.delete(i),e.$uo.test(i))delete this.d[i],delete this.b.properties[i];else{const S=this.d[i];S&&(this.w(i,S),this.r(i,S))}}this.u()}deltaConfiguration(t){let r=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,n){t.forEach(s=>{this.p(s,r,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(t,r){const n=s=>{if(s.properties)for(const i in s.properties){r.add(i);const o=this.d[i];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[i],this.s(i,s.properties[i])}s.allOf?.forEach(i=>n(i))};for(const s of t){n(s);const i=this.c.indexOf(s);i!==-1&&this.c.splice(i,1)}}p(t,r=!0,n,s,i=3,o){i=L.$hg(t.scope)?i:t.scope;const a=t.properties;if(a)for(const S in a){const v=a[S];if(r&&h(S,v)){delete a[S];continue}if(v.source=n,v.defaultDefaultValue=a[S].default,this.w(S,v),e.$uo.test(S)?v.scope=void 0:(v.scope=L.$hg(v.scope)?i:v.scope,v.restricted=L.$hg(v.restricted)?!!s?.includes(S):v.restricted),a[S].hasOwnProperty("included")&&!a[S].included){this.f[S]=a[S],delete a[S];continue}else this.d[S]=a[S],a[S].policy?.name&&this.e.set(a[S].policy.name,S);!a[S].deprecationMessage&&a[S].markdownDeprecationMessage&&(a[S].deprecationMessage=a[S].markdownDeprecationMessage),o.add(S)}const w=t.allOf;if(w)for(const S of w)this.p(S,r,n,s,i,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=n=>{const s=n.properties;if(s)for(const o in s)this.r(o,s[o]);n.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$lo.properties[t]=r,r.scope){case 1:e.$mo.properties[t]=r;break;case 2:e.$no.properties[t]=r;break;case 6:e.$oo.properties[t]=r;break;case 3:e.$po.properties[t]=r;break;case 4:e.$qo.properties[t]=r;break;case 5:e.$qo.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$lo.properties[t],r.scope){case 1:delete e.$mo.properties[t];break;case 2:delete e.$no.properties[t];break;case 6:delete e.$oo.properties[t];break;case 3:delete e.$po.properties[t];break;case 4:case 5:delete e.$qo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$ro};this.w(r,n),e.$lo.properties[r]=n,e.$mo.properties[r]=n,e.$no.properties[r]=n,e.$oo.properties[r]=n,e.$po.properties[r]=n,e.$qo.properties[r]=n}}v(){const t={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=t,e.$mo.patternProperties[e.$to]=t,e.$no.patternProperties[e.$to]=t,e.$oo.patternProperties[e.$to]=t,e.$po.patternProperties[e.$to]=t,e.$qo.patternProperties[e.$to]=t,this.i.fire()}w(t,r){const n=this.a.get(t);let s=n?.value,i=n?.source;L.$fg(s)&&(s=r.defaultDefaultValue,i=void 0),L.$fg(s)&&(s=f(r.type)),r.default=s,r.defaultValueSource=i}}const l="\\[([^\\]]+)\\]",c=new RegExp(l,"g");e.$to=`^(${l})+$`,e.$uo=new RegExp(e.$to);function b($){const t=[];if(e.$uo.test($)){let r=c.exec($);for(;r?.length;){const n=r[1].trim();n&&t.push(n),r=c.exec($)}}return(0,D.$Mb)(t)}function m($){return $.reduce((t,r)=>`${t}[${r}]`,"")}function f($){switch(Array.isArray($)?$[0]:$){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const u=new p;P.$fo.add(e.$ko.Configuration,u);function h($,t){return $.trim()?e.$uo.test($)?A.localize(7,null,$):u.getConfigurationProperties()[$]!==void 0?A.localize(8,null,$):t.policy?.name&&u.getPolicyConfigurations().get(t.policy?.name)!==void 0?A.localize(9,null,$,t.policy?.name,u.getPolicyConfigurations().get(t.policy?.name)):null:A.localize(6,null)}function g(){const $=[],t=u.getConfigurationProperties();for(const r of Object.keys(t))$.push([r,t[r].scope]);return $.push(["launch",4]),$.push(["task",4]),$}}),define(ae[76],ce([0,1,17,3,35,2,34,30,13,8,21,47,43]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=h;function l(r){return Object.isFrozen(r)?r:I.$6n(r)}class c{static createEmptyModel(n){return new c({},[],[],void 0,n)}constructor(n,s,i,o,a){this.b=n,this.c=s,this.d=i,this.raw=o,this.f=a,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof c)return s;const i=new b("",this.f);return i.parseRaw(s),i.configurationModel});this.g=n.reduce((s,i)=>i===s?i:s.merge(i),n[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,E.$aj)(this.contents,n):this.contents}inspect(n,s){const i=this;return{get value(){return l(i.rawConfiguration.getValue(n))},get override(){return s?l(i.rawConfiguration.getOverrideValue(n,s)):void 0},get merged(){return l(s?i.rawConfiguration.override(s).getValue(n):i.rawConfiguration.getValue(n))},get overrides(){const o=[];for(const{contents:a,identifiers:w,keys:S}of i.rawConfiguration.overrides){const v=new c(a,S,[],void 0,i.f).getValue(n);v!==void 0&&o.push({identifiers:w,value:v})}return o.length?l(o):void 0}}}getOverrideValue(n,s){const i=this.j(s);return i?n?(0,E.$aj)(i,n):i:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const i of this.overrides)i.identifiers.includes(n)&&s.push(...i.keys);return D.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return D.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.h(n),this.a.set(n,s)),s}merge(...n){const s=I.$5n(this.contents),i=I.$5n(this.overrides),o=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const w of n)if(a.push(...w.raw?.length?w.raw:[w]),!w.isEmpty()){this.i(s,w.contents);for(const S of w.overrides){const[v]=i.filter(k=>D.$ub(k.identifiers,S.identifiers));v?(this.i(v.contents,S.contents),v.keys.push(...S.keys),v.keys=D.$Mb(v.keys)):i.push(I.$5n(S))}for(const S of w.keys)o.indexOf(S)===-1&&o.push(S)}return new c(s,o,i,a.every(w=>w instanceof c)?void 0:a,this.f)}h(n){const s=this.j(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const i={};for(const o of D.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[o];const w=s[o];w&&(typeof a=="object"&&typeof w=="object"?(a=I.$5n(a),this.i(a,w)):a=w),i[o]=a}return new c(i,this.keys,this.overrides,void 0,this.f)}i(n,s){for(const i of Object.keys(s)){if(i in n&&P.$ag(n[i])&&P.$ag(s[i])){this.i(n[i],s[i]);continue}n[i]=I.$5n(s[i])}}j(n){let s=null,i=null;const o=a=>{a&&(i?this.i(i,a):i=I.$5n(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&o(a.contents);return o(s),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.k(n,s,!0)}setValue(n,s){this.k(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,E.$_i)(this.contents,n),y.$uo.test(n)&&this.overrides.splice(this.overrides.findIndex(i=>D.$ub(i.identifiers,(0,y.$vo)(n))),1))}k(n,s,i){(0,E.$$i)(this.contents,n,s,o=>this.f.error(o)),i=i||this.keys.indexOf(n)===-1,i&&this.keys.push(n),y.$uo.test(n)&&this.overrides.push({identifiers:(0,y.$vo)(n),keys:Object.keys(this.contents[n]),contents:(0,E.$0i)(this.contents[n],o=>this.f.error(o))})}}e.$Ao=c;class b{constructor(n,s){this.f=n,this.g=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||c.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!P.$hg(n)){const i=this.h(n);this.parseRaw(i,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:i,keys:o,overrides:a,restricted:w,hasExcludedProperties:S}=this.i(n,s);this.b=new c(i,o,a,S?[n]:void 0,this.g),this.c=w||[]}h(n){let s={},i=null,o=[];const a=[],w=[];function S(k){Array.isArray(o)?o.push(k):i!==null&&(o[i]=k)}const v={onObjectBegin:()=>{const k={};S(k),a.push(o),o=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];S(k),a.push(o),o=k,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:S,onError:(k,C,R)=>{w.push({error:k,offset:C,length:R})}};if(n)try{L.$Sn(n,v),s=o[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return s}i(n,s){const i=p.$fo.as(y.$ko.Configuration).getConfigurationProperties(),o=this.j(n,i,!0,s);n=o.raw;const a=(0,E.$0i)(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`)),w=Object.keys(n),S=this.l(n,v=>this.g.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:a,keys:w,overrides:S,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(n,s,i,o){let a=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const w={},S=[];for(const v in n)if(y.$uo.test(v)&&i){const k=this.j(n[v],s,!1,o);w[v]=k.raw,a=a||k.hasExcludedProperties,S.push(...k.restricted)}else{const k=s[v],C=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&S.push(v),!o.exclude?.includes(v)&&(o.include?.includes(v)||(C===void 0||o.scopes===void 0||o.scopes.includes(C))&&!(o.skipRestricted&&k?.restricted))?w[v]=n[v]:a=!0}return{raw:w,restricted:S,hasExcludedProperties:a}}l(n,s){const i=[];for(const o of Object.keys(n))if(y.$uo.test(o)){const a={};for(const w in n[o])a[w]=n[o][w];i.push({identifiers:(0,y.$vo)(o),keys:Object.keys(a),contents:(0,E.$0i)(a,s)})}return i}}e.$Bo=b;class m extends A.$Uc{constructor(n,s,i,o,a){super(),this.c=n,this.f=s,this.g=o,this.h=a,this.b=this.B(new N.$fe),this.onDidChange=this.b.event,this.a=new b(this.c.toString(),a),this.B(this.g.watch(i.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,w=>w.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,w=>(w.isOperation(0)||w.isOperation(3)||w.isOperation(1)||w.isOperation(4))&&i.isEqual(w.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return c.createEmptyModel(this.h)}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=m;class f{constructor(n,s,i,o,a,w,S,v,k,C,R,M,T){this.a=n,this.b=s,this.c=i,this.overrideIdentifiers=o,this.d=a,this.f=w,this.g=S,this.h=v,this.i=k,this.j=C,this.k=R,this.l=M,this.m=T}get value(){return l(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class u{constructor(n,s,i,o,a,w,S,v,k,C){this.j=n,this.l=s,this.m=i,this.n=o,this.p=a,this.q=w,this.r=S,this.s=v,this.t=k,this.u=C,this.h=null,this.i=new O.$Ac,this.v=null}getValue(n,s,i){return this.w(n,s,i).getValue(n)}updateValue(n,s,i={}){let o;i.resource?(o=this.t.get(i.resource),o||(o=c.createEmptyModel(this.u),this.t.set(i.resource,o))):o=this.s,s===void 0?o.removeValue(n):o.setValue(n,s),i.resource||(this.h=null)}inspect(n,s,i){const o=this.w(n,s,i),a=this.A(s.resource,i),w=s.resource?this.t.get(s.resource)||this.s:this.s,S=new Set;for(const v of o.overrides)for(const k of v.identifiers)o.getOverrideValue(n,k)!==void 0&&S.add(k);return new f(n,s,o.getValue(n),S.size?[...S]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,i?this.q:void 0,a||void 0,w)}keys(n){const s=this.A(void 0,n);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.j=n,this.h=null,this.i.clear()}updatePolicyConfiguration(n){this.l=n}updateApplicationConfiguration(n){this.m=n,this.h=null,this.i.clear()}updateLocalUserConfiguration(n){this.n=n,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(n){this.p=n,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(n){this.q=n,this.h=null,this.i.clear()}updateFolderConfiguration(n,s){this.r.set(n,s),this.i.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.i.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const i=[];if(!s){const{added:o,updated:a,removed:w}=$(this.j,n);s=[...o,...a,...w]}for(const o of s)for(const a of(0,y.$vo)(o)){const w=this.j.getKeysForOverrideIdentifier(a),S=n.getKeysForOverrideIdentifier(a),v=[...S.filter(k=>w.indexOf(k)===-1),...w.filter(k=>S.indexOf(k)===-1),...w.filter(k=>!I.$9n(this.j.override(a).getValue(k),n.override(a).getValue(k)))];i.push([a,v])}return this.updateDefaultConfiguration(n),{keys:s,overrides:i}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:i,removed:o}=$(this.l,n),a=[...s,...i,...o];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.applicationConfiguration,n),w=[...s,...i,...o];return w.length&&this.updateApplicationConfiguration(n),{keys:w,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.localUserConfiguration,n),w=[...s,...i,...o];return w.length&&this.updateLocalUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.remoteUserConfiguration,n),w=[...s,...i,...o];return w.length&&this.updateRemoteUserConfiguration(n),{keys:w,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:i,removed:o,overrides:a}=$(this.workspaceConfiguration,n),w=[...s,...i,...o];return w.length&&this.updateWorkspaceConfiguration(n),{keys:w,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const i=this.folderConfigurations.get(n),{added:o,updated:a,removed:w,overrides:S}=$(i,s),v=[...o,...a,...w];return(v.length||!i)&&this.updateFolderConfiguration(n,s),{keys:v,overrides:S}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:i,updated:o,removed:a,overrides:w}=$(s,void 0);return{keys:[...i,...o,...a],overrides:w}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(n,s,i){let o=this.x(s,i);return s.overrideIdentifier&&(o=o.override(s.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(n)!==void 0&&(o=o.merge(this.l)),o}x({resource:n},s){let i=this.y();if(s&&n){const o=s.getFolder(n);o&&(i=this.z(o.uri)||i);const a=this.t.get(n);a&&(i=i.merge(a))}return i}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(n){let s=this.i.get(n);if(!s){const i=this.y(),o=this.r.get(n);o?(s=i.merge(o),this.i.set(n,s)):s=i}return s}A(n,s){if(s&&n){const i=s.getFolder(n);if(i)return this.r.get(i.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((n,s)=>{const{contents:i,overrides:o,keys:a}=this.r.get(s);return n.push([s,{contents:i,overrides:o,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.j.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.q.keys.forEach(s=>n.add(s)),this.r.forEach(s=>s.keys.forEach(i=>n.add(i))),[...n.values()]}B(){const n=new Set;return this.j.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.q.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.r.forEach(s=>s.getAllOverrideIdentifiers().forEach(i=>n.add(i))),[...n.values()]}D(n){const s=new Set;return this.j.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.q.getKeysForOverrideIdentifier(n).forEach(i=>s.add(i)),this.r.forEach(i=>i.getKeysForOverrideIdentifier(n).forEach(o=>s.add(o))),[...s.values()]}static parse(n,s){const i=this.E(n.defaults,s),o=this.E(n.policy,s),a=this.E(n.application,s),w=this.E(n.user,s),S=this.E(n.workspace,s),v=n.folders.reduce((k,C)=>(k.set(d.URI.revive(C[0]),this.E(C[1],s)),k),new O.$Ac);return new u(i,o,a,w,c.createEmptyModel(s),S,v,c.createEmptyModel(s),new O.$Ac,s)}static E(n,s){return new c(n.contents,n.keys,n.overrides,void 0,s)}}e.$Do=u;function h(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const n=new Set,s=new Map;for(const o of r)o.keys.forEach(a=>n.add(a)),o.overrides.forEach(([a,w])=>{const S=(0,O.$xc)(s,a,new Set);w.forEach(v=>S.add(v))});const i=[];return s.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...n.values()],overrides:i}}class g{constructor(n,s,i,o,a){this.change=n,this.f=s,this.g=i,this.h=o,this.i=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const w of n.keys)this.affectedKeys.add(w);for(const[,w]of n.overrides)for(const S of w)this.affectedKeys.add(S);this.d=this.a;for(const w of this.affectedKeys)this.d+=w+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=u.parse(this.f.data,this.i)),this.j}affectsConfiguration(n,s){const i=this.a+n,o=this.d.indexOf(i);if(o<0)return!1;const a=o+i.length;if(a>=this.d.length)return!1;const w=this.d.charCodeAt(a);if(w!==this.b&&w!==this.c)return!1;if(s){const S=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,v=this.g.getValue(n,s,this.h);return!I.$9n(S,v)}return!0}}e.$Fo=g;function $(r,n){const{added:s,removed:i,updated:o}=t(n?.rawConfiguration,r?.rawConfiguration),a=[],w=r?.getAllOverrideIdentifiers()||[],S=n?.getAllOverrideIdentifiers()||[];if(n){const v=S.filter(k=>!w.includes(k));for(const k of v)a.push([k,n.getKeysForOverrideIdentifier(k)])}if(r){const v=w.filter(k=>!S.includes(k));for(const k of v)a.push([k,r.getKeysForOverrideIdentifier(k)])}if(n&&r){for(const v of w)if(S.includes(v)){const k=t({contents:r.getOverrideValue(void 0,v)||{},keys:r.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});a.push([v,[...k.added,...k.removed,...k.updated]])}}return{added:s,removed:i,updated:o,overrides:a}}function t(r,n){const s=r?n?r.keys.filter(a=>n.keys.indexOf(a)===-1):[...r.keys]:[],i=n?r?n.keys.filter(a=>r.keys.indexOf(a)===-1):[...n.keys]:[],o=[];if(r&&n){for(const a of n.keys)if(r.keys.indexOf(a)!==-1){const w=(0,E.$aj)(n.contents,a),S=(0,E.$aj)(r.contents,a);I.$9n(w,S)||o.push(a)}}return{added:s,removed:i,updated:o}}}),define(ae[217],ce([0,1,17,3,2,30,13,76,47,9,58,43]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class p extends L.$Uc{get configurationModel(){return this.b}constructor(m){super(),this.c=m,this.a=this.B(new N.$fe),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(y.$fo.as(P.$ko.Configuration).onDidUpdateConfiguration(({properties:m,defaultsOverrides:f})=>this.f(Array.from(m),f))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(m,f){this.j(m,y.$fo.as(P.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:m})}g(){return{}}h(){this.b=I.$Ao.createEmptyModel(this.c);const m=y.$fo.as(P.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(m),m)}j(m,f){const u=this.g();for(const h of m){const g=u[h],$=f[h];g!==void 0?this.b.addValue(h,g):$?this.b.addValue(h,$.default):this.b.removeValue(h)}}}e.$Go=p;class l{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=I.$Ao.createEmptyModel(new d.$fk)}async initialize(){return this.configurationModel}}e.$Ho=l;let c=class extends L.$Uc{get configurationModel(){return this.b}constructor(m,f,u){super(),this.c=m,this.f=f,this.g=u,this.a=this.B(new N.$fe),this.onDidChangeConfiguration=this.a.event,this.b=I.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(m=>this.j(m))),this.B(this.c.onDidChangeConfiguration(async({properties:m})=>this.m(await this.h(m),!0))),this.b}async h(m){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",m);const f={},u=[],h=y.$fo.as(P.$ko.Configuration).getConfigurationProperties();for(const g of m){const $=h[g];if(!$){u.push(g);continue}if($.policy){if($.type!=="string"&&$.type!=="number"){this.g.warn(`Policy ${$.policy.name} has unsupported type ${$.type}`);continue}u.push(g),f[$.policy.name]={type:$.type}}}return(0,O.$lg)(f)||await this.f.updatePolicyDefinitions(f),u}j(m){this.g.trace("PolicyConfiguration#onDidChangePolicies",m);const f=y.$fo.as(P.$ko.Configuration).getPolicyConfigurations(),u=(0,D.$Hb)(m.map(h=>f.get(h)));this.m(u,!0)}m(m,f){this.g.trace("PolicyConfiguration#update",m);const u=y.$fo.as(P.$ko.Configuration).getConfigurationProperties(),h=[],g=this.b.isEmpty();for(const $ of m){const t=u[$]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(g?r!==void 0:!(0,A.$9n)(this.b.getValue($),r))&&h.push([$,r])}else this.b.getValue($)!==void 0&&h.push([$,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const $=this.b;this.b=I.$Ao.createEmptyModel(this.g);for(const t of $.keys)this.b.setValue(t,$.getValue(t));for(const[t,r]of h)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);f&&this.a.fire(this.b)}}};e.$Io=c,e.$Io=c=ve([X(1,E.$ho),X(2,d.$5j)],c)}),define(ae[218],ce([0,1,17,6,15,3,35,62,2,34,30,5,20,21,76,47,217,58]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class u extends P.$Uc{constructor($,t,r,n){super(),this.m=$,this.n=n,this.h=this.B(new A.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new m.$Go(n)),this.c=r instanceof f.$jo?new m.$Ho:this.B(new m.$Io(this.b,r,n)),this.f=this.B(new c.$Co(this.m,{},p.$3g,t,n)),this.a=new c.$Do(this.b.configurationModel,this.c.configurationModel,c.$Ao.createEmptyModel(n),c.$Ao.createEmptyModel(n),c.$Ao.createEmptyModel(n),c.$Ao.createEmptyModel(n),new d.$Ac,c.$Ao.createEmptyModel(n),new d.$Ac,n),this.j=new h($,t,this),this.g=this.B(new N.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:s,properties:i})=>this.s(s,i))),this.B(this.c.onDidChangeConfiguration(s=>this.t(s))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[$,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new c.$Do($,t,c.$Ao.createEmptyModel(this.n),r,c.$Ao.createEmptyModel(this.n),c.$Ao.createEmptyModel(this.n),new d.$Ac,c.$Ao.createEmptyModel(this.n),new d.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue($,t){const r=typeof $=="string"?$:void 0,n=(0,l.$6i)($)?$:(0,l.$6i)(t)?t:{};return this.a.getValue(r,n,void 0)}async updateValue($,t,r,n,s){const i=(0,l.$7i)(r)?r:(0,l.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=i?n:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${$} to target ${o}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,D.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect($,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${$} because it is configured in system policy.`);if((0,E.$9n)(t,a.defaultValue)&&(t=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const S=i.overrideIdentifiers.sort(),v=this.a.localUserConfiguration.overrides.find(k=>(0,D.$ub)([...k.identifiers].sort(),S));v&&(i.overrideIdentifiers=v.identifiers)}const w=i?.overrideIdentifiers?.length?[(0,b.$wo)(i.overrideIdentifiers),$]:[$];await this.j.write(w,t),await this.reloadConfiguration()}inspect($,t={}){return this.a.inspect($,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const $=await this.f.loadConfiguration();this.r($)}r($){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration($);this.u(r,t,2)}s($,t){const r=this.a.toData(),n=this.a.compareAndUpdateDefaultConfiguration($,t);this.u(n,r,7)}t($){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration($);this.u(r,t,7)}u($,t,r){const n=new c.$Fo($,{data:t},this.a,void 0,this.n);n.source=r,this.h.fire(n)}}e.$Jo=u;class h{constructor($,t,r){this.b=$,this.c=t,this.d=r,this.a=new N.$Fh}write($,t){return this.a.queue(()=>this.e($,t))}async e($,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)r="{}";else throw i}const n=[];if((0,O.$Ln)(r,n,{allowTrailingComma:!0,allowEmptyContent:!0}),n.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const s=this.f(r,$,t);r=(0,I.$4n)(r,s),await this.c.writeFile(this.b,L.$He.fromString(r))}f($,t,r){const{tabSize:n,insertSpaces:s,eol:i}=this.h;if(!t.length){const o=JSON.stringify(r,null,s?" ".repeat(n):"	");return[{content:o,length:o.length,offset:0}]}return(0,I.$1n)($,t,r,{tabSize:n,insertSpaces:s,eol:i})}get h(){if(!this.g){let $=y.OS===3||y.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&($=t),this.g={eol:$,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ae[219],ce([0,1,15,3,2,68]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xvb=e.$Vvb=e.$Uvb=void 0,e.$Wvb=I;const O=(d,E,y)=>{const p=new Uint8Array(16);for(let b=0;b<16;b++)p[b]=Math.round(Math.random()*256);const l=(0,D.$2e)(D.$He.wrap(p));return[`GET ws://localhost${d}?${E}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$Uvb=O,e.$Vvb=D.$He.fromString(`\r
\r
`);async function I(d,E,y,p,l){d.write(D.$He.fromString((0,e.$Uvb)(E,y,p)));const c=new L.$Tc;try{return await new Promise((b,m)=>{let f;c.add(d.onData(u=>{f?f=D.$He.concat([f,u],f.byteLength+u.byteLength):f=u;const h=f.indexOf(e.$Vvb);if(h===-1)return;b(d),d.pauseData();const g=f.slice(h+e.$Vvb.byteLength);g.byteLength&&l.onData.fire(g)})),c.add(d.onClose(u=>m(u??new Error("socket closed")))),c.add(d.onEnd(()=>m(new Error("socket ended"))))})}catch(b){throw d.dispose(),b}finally{c.dispose()}}class P extends L.$Uc{constructor(E,y){super(),this.g=E,this.a=this.B(new N.$ie),this.onData=(...p)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...p)),this.b=this.B(new N.$fe),this.onDidDispose=this.b.event,this.f=!1,this.B(y.onData),this.B(y.onData.event(p=>this.a.fire(p))),this.onClose=this.B(y.onClose).event,this.onEnd=this.B(y.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(E,y){A.SocketDiagnostics.traceSocketEvent(this,this.g,E,y)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Xvb=P}),define(ae[220],ce([0,1,7,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=d,e.$Jl=(0,N.$yi)("remoteAuthorityResolverService");var L;(function(E){E[E.WebSocket=0]="WebSocket",E[E.Managed=1]="Managed"})(L||(e.RemoteConnectionType=L={}));class A{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=A;class O{constructor(y,p){this.host=y,this.port=p,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=O;var I;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound",E.InvalidAuthority="InvalidAuthority"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class P extends D.$bb{static isNotAvailable(y){return y instanceof P&&y._code===I.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof P&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof P&&y._code===I.NoResolverFound}static isInvalidAuthority(y){return y instanceof P&&y._code===I.InvalidAuthority}static isHandled(y){return y instanceof P&&y.isHandled}constructor(y,p=I.Unknown,l){super(y),this._message=y,this._code=p,this._detail=l,this.isHandled=p===I.NotAvailable&&l===!0,Object.setPrototypeOf(this,P.prototype)}}e.$Ml=P;function d(E){const y=E.indexOf("+");return y===-1?E:E.substring(0,y)}}),define(ae[221],ce([0,1,6,15,26,7,3,2,23,98,63,32,68,220]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Sl=w,e.$Tl=S,e.$Ul=k;const c=30*1e3;var b;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function m(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function f(z){const j=new L.$qe;return setTimeout(()=>j.cancel(),z),j.token}function u(z,j){if(z.isCancellationRequested||j.isCancellationRequested)return L.CancellationToken.Cancelled;const F=new L.$qe;return z.onCancellationRequested(()=>F.cancel()),j.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new I.$Tc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,D.$rh)(),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function g(z,j){const F=new h(j);return F.registerDisposable(z.onControlMessage(B=>{const U=JSON.parse(B.toString()),Q=H(U);Q?F.reject(Q):F.resolve(U)})),F.promise}function $(z,j,F,B,U,Q,x,te){const _=new h(te),oe=E.$be.create(!1);return z.info(`Creating a socket (${x})...`),d.mark(`code/willCreateSocket/${Q}`),j.connect(F,B,U,x).then(ue=>{_.didTimeout?(d.mark(`code/didCreateSocketError/${Q}`),z.info(`Creating a socket (${x}) finished after ${oe.elapsed()} ms, but this is too late and has timed out already.`),ue?.dispose()):(d.mark(`code/didCreateSocketOK/${Q}`),z.info(`Creating a socket (${x}) was successful after ${oe.elapsed()} ms.`),_.resolve(ue))},ue=>{d.mark(`code/didCreateSocketError/${Q}`),z.info(`Creating a socket (${x}) returned an error after ${oe.elapsed()} ms.`),z.error(ue),_.reject(ue)}),_.promise}function t(z,j){const F=new h(j);return z.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function r(z,j,F,B){const U=ee(z,j);z.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let Q;try{Q=await $(z.logService,z.remoteSocketFactoryService,z.connectTo,P.$Lg.getServerRootPath(),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,m(j),`renderer-${m(j)}-${z.reconnectionToken}`,B)}catch(ue){throw z.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ue),ue}z.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let x,te;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(Q,null),x=z.reconnectionProtocol,te=!1):(x=new p.$mi({socket:Q}),te=!0),z.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const _=await t(z.signService.createNewMessage((0,y.$Ug)()),B),oe={type:"auth",auth:z.connectionToken||"00000000000000000000",data:_.data};x.sendControl(N.$He.fromString(JSON.stringify(oe)));try{const ue=await g(x,u(B,f(1e4)));if(ue.type!=="sign"||typeof ue.data!="string"){const be=new Error("Unexpected handshake message");throw be.code="VSCODE_CONNECTION_ERROR",be}if(z.logService.trace(`${U} 4/6. received SignRequest control message.`),!await t(z.signService.validate(_,ue.signedData),B)){const be=new Error("Refused to connect to unsupported server");throw be.code="VSCODE_CONNECTION_ERROR",be}const de=await t(z.signService.sign(ue.data),B),ge={type:"connectionType",commit:z.commit,signedData:de,desiredConnectionType:j};return F&&(ge.args=F),z.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),x.sendControl(N.$He.fromString(JSON.stringify(ge))),{protocol:x,ownsProtocol:te}}catch(ue){throw ue&&ue.code==="ETIMEDOUT"&&(z.logService.error(`${U} the handshake timed out. Error:`),z.logService.error(ue)),ue&&ue.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${U} received error control message when negotiating connection. Error:`),z.logService.error(ue)),te&&V(x),ue}}async function n(z,j,F,B){const U=Date.now(),Q=ee(z,j),{protocol:x,ownsProtocol:te}=await r(z,j,F,B),_=new h(B);return _.registerDisposable(x.onControlMessage(oe=>{const ue=JSON.parse(oe.toString()),$e=H(ue);$e?(z.logService.error(`${Q} received error control message when negotiating connection. Error:`),z.logService.error($e),te&&V(x),_.reject($e)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${Q} 6/6. handshake finished, connection is up and running after ${W(U)}!`),_.resolve({protocol:x,firstMessage:ue}))})),_.promise}async function s(z,j){const{protocol:F}=await n(z,1,void 0,j);return{protocol:F}}async function i(z,j,F){const{protocol:B,firstMessage:U}=await n(z,2,j,F),Q=U&&U.debugPort;return{protocol:B,debugPort:Q}}async function o(z,j,F){const B=Date.now(),U=ee(z,3),{protocol:Q}=await r(z,3,j,F);return z.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${W(B)}!`),Q}async function a(z,j,F){const{connectTo:B,connectionToken:U}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,connectTo:B,connectionToken:U,reconnectionToken:j,reconnectionProtocol:F,remoteSocketFactoryService:z.remoteSocketFactoryService,signService:z.signService,logService:z.logService}}async function w(z,j,F){return v(z,async B=>{const{protocol:U}=await s(B,L.CancellationToken.None);return new G(z,j,F,B.reconnectionToken,U)})}async function S(z,j){return v(z,async F=>{const{protocol:B,debugPort:U}=await i(F,j,L.CancellationToken.None);return new J(z,j,F.reconnectionToken,B,U)})}async function v(z,j){for(let B=1;;B++)try{const U=(0,y.$Ug)(),Q=await a(z,U,null);return await j(Q)}catch(U){if(B<5)z.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(U);else throw z.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(U),Z.triggerPermanentFailure(0,0,l.$Ml.isHandled(U)),U}}async function k(z,j,F){const B=await a(z,(0,y.$Ug)(),null);return await o(B,{host:j,port:F},L.CancellationToken.None)}function C(z){return(0,D.$lh)(j=>new Promise((F,B)=>{const U=setTimeout(F,z*1e3);j.onCancellationRequested(()=>{clearTimeout(U),F()})}))}var R;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(R||(e.PersistentConnectionEventType=R={}));class M{constructor(j,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.type=0}}e.$Vl=M;class T{constructor(j,F,B,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.$Wl=T;class q{constructor(j,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.$Xl=q;class Y{constructor(j,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.$Yl=Y;class K{constructor(j,F,B,U){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=U,this.type=3}}e.$Zl=K;class Z extends I.$Uc{static triggerPermanentFailure(j,F,B){this._permanentFailure=!0,this.f=j,this.g=F,this.h=B,this.j.forEach(U=>U.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(j=>j.y())}static debugPauseSocketWriting(){this.j.forEach(j=>j.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||Z._permanentFailure}constructor(j,F,B,U,Q){super(),this.t=j,this.u=F,this.reconnectionToken=B,this.protocol=U,this.w=Q,this.m=this.B(new O.$fe),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(U.onSocketClose(x=>{const te=he(this.t,this.reconnectionToken,!0);x?x.type===0?(this.u.logService.info(`${te} received socket close event (hadError: ${x.hadError}).`),x.error&&this.u.logService.error(x.error)):(this.u.logService.info(`${te} received socket close event (wasClean: ${x.wasClean}, code: ${x.code}, reason: ${x.reason}).`),x.event&&this.u.logService.error(x.event)):this.u.logService.info(`${te} received socket close event.`),this.y()})),this.B(U.onSocketTimeout(x=>{const te=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${te} received socket timeout event (unacknowledgedMsgCount: ${x.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${x.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${x.timeSinceLastReceivedSomeData}).`),this.y()})),Z.j.push(this),this.B((0,I.$Sc)(()=>{const x=Z.j.indexOf(this);x>=0&&Z.j.splice(x,1)})),this.n&&this.D(Z.f,Z.g,Z.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const j=he(this.t,this.reconnectionToken,!0);this.u.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const U=B<F.length?F[B]:F[F.length-1];try{if(U>0){const x=C(U);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,x)),this.u.logService.info(`${j} waiting for ${U} seconds before reconnecting...`);try{await x}catch{}}if(this.n){this.u.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${j} resolving connection...`);const Q=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${j} connecting to ${Q.connectTo}...`),await this.G(Q,f(c)),this.u.logService.info(`${j} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(Q){if(Q.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(l.$Ml.isTemporarilyNotAvailable(Q)){this.u.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((Q.code==="ETIMEDOUT"||Q.code==="ENETUNREACH"||Q.code==="ECONNREFUSED"||Q.code==="ECONNRESET")&&Q.syscall==="connect"){this.u.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if((0,A.$4)(Q)){this.u.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(Q);continue}if(Q instanceof l.$Ml){this.u.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,l.$Ml.isHandled(Q));break}this.u.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(Q),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(j,F,B){this.w?Z.triggerPermanentFailure(j,F,B):this.D(j,F,B)}D(j,F,B){this.m.fire(new K(this.reconnectionToken,j,F,B)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$1l=Z;class G extends Z{constructor(j,F,B,U,Q){super(1,j,U,Q,!0),this.client=this.B(new p.$ki(Q,{remoteAuthority:F,clientId:B},j.ipcLogger))}async G(j,F){await s(j,F)}}e.$2l=G;class J extends Z{constructor(j,F,B,U,Q){super(2,j,B,U,!1),this.H=F,this.debugPort=Q}async G(j,F){await i(j,this.H,F)}}e.$3l=J;function V(z){try{z.acceptDisconnect();const j=z.getSocket();z.dispose(),j.dispose()}catch(j){(0,A.$1)(j)}}function H(z){if(z&&z.type==="error"){const j=new Error(`Connection error: ${z.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function ie(z,j){for(;z.length<j;)z+=" ";return z}function se(z,j){return`[remote-connection][${ie(m(z),13)}][${j.substr(0,5)}\u2026]`}function he(z,j,F){return`${se(z,j)}[${F?"reconnect":"initial"}]`}function ee(z,j){return`${he(j,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.connectTo}]`}function W(z){return`${Date.now()-z} ms`}}),define(ae[102],ce([0,1,23]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=N,e.$Km=L,e.$Lm=A,e.$Mm=O;function N(P){return P.scheme===D.Schemas.vscodeRemote?P.authority:void 0}function L(P){if(!P)return;const d=P.indexOf("+");return d<0?P:P.substr(0,d)}function A(P){const{host:d,port:E}=I(P);if(typeof E>"u")throw new Error(`Invalid remote authority: ${P}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:d,port:E}}function O(P,d){let{host:E,port:y}=I(P);return typeof y>"u"&&(y=d),{host:E,port:y}}function I(P){const d=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(d)return{host:d[1],port:parseInt(d[2],10)};const E=P.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const y=P.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:P,port:void 0}}}),define(ae[48],ce([0,1,27,4,102]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=A,e.$Wm=y,e.$Xm=p,e.$Ym=l,e.$Zm=c,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var O;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(O||(e.ExtensionType=O={}));var I;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(I||(e.TargetPlatform=I={}));class P{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,f){if(typeof m>"u"||m===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof m=="string"||typeof f=="string"){const u=typeof m=="string"?m:m.value,h=typeof f=="string"?f:f.value;return D.$zf(u,h)}return m._lower===f._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.$Tm=P;class d{get size(){return this.c.size}constructor(m){if(this.c=new Set,m)for(const f of m)this.add(f)}add(m){this.c.add(P.toKey(m))}delete(m){return this.c.delete(P.toKey(m))}has(m){return this.c.has(P.toKey(m))}}e.$Um=d;class E{constructor(){this.c=new Map}clear(){this.c.clear()}delete(m){this.c.delete(P.toKey(m))}get(m){return this.c.get(P.toKey(m))}has(m){return this.c.has(P.toKey(m))}set(m,f){this.c.set(P.toKey(m),f)}values(){return this.c.values()}forEach(m){this.c.forEach(m)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=E;function y(b){return p(b)}function p(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}function l(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}function c(b,m){if(m){const f=`onResolveRemoteAuthority:${(0,L.$Km)(m)}`;return!!b.activationEvents?.includes(f)}return!1}e.$1m=(0,N.$yi)("IBuiltinExtensionsScannerService")}),define(ae[222],ce([0,1,2,48,12]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;class A extends D.$Uc{constructor(I,P,d,E,y){super(),this.a=I,this.b=P,this.c=d,this.f=y,this.B(E.onDidInstallExtensions(p=>this.g(p))),this.B(E.onDidUninstallExtension(p=>this.h(p)))}g(I){for(const P of I)P.local&&this.invalidate(P.profileLocation)}h(I){I.error||this.invalidate(I.profileLocation)}async invalidate(I){if(I)for(const P of this.a.profiles)this.c.extUri.isEqual(P.extensionsResource,I)&&await this.j(P);else await this.j(this.a.defaultProfile)}async j(I){try{await this.b.del(this.c.extUri.joinPath(I.cacheHome,N.$Nm))}catch(P){(0,L.$jl)(P)!==1&&this.f.error(P)}}}e.$Fq=A}),define(ae[103],ce([0,1,2,4]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pl=e.$Ol=void 0,e.$Ol=(0,N.$yi)("remoteSocketFactoryService");class L{constructor(){this.a={}}register(O,I){return this.a[O]??=[],this.a[O].push(I),(0,D.$Sc)(()=>{const P=this.a[O]?.indexOf(I);typeof P=="number"&&P>=0&&this.a[O]?.splice(P,1)})}b(O){return(this.a[O.type]||[]).find(P=>P.supports(O))}connect(O,I,P,d){const E=this.b(O);if(!E)throw new Error(`No socket factory found for ${O}`);return E.connect(O,I,P,d)}}e.$Pl=L}),define(ae[223],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=void 0,e.$dfc=(0,D.$yi)("sharedProcessTunnelService"),e.$efc="sharedProcessTunnel"}),define(ae[104],ce([0,1,4,170]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=e.$mfc=e.$lfc=e.$kfc=e.TunnelStates=e.$jfc=e.$ifc=void 0,e.$ifc=(0,D.$yi)("IRemoteTunnelService"),e.$jfc={active:!1};var L;(function(A){A.disconnected=O=>({type:"disconnected",onTokenFailed:O}),A.connected=(O,I)=>({type:"connected",info:O,serviceInstallFailed:I}),A.connecting=O=>({type:"connecting",progress:O}),A.uninitialized={type:"uninitialized"}})(L||(e.TunnelStates=L={})),e.$kfc="remote.tunnels.access",e.$lfc=e.$kfc+".hostNameOverride",e.$mfc=e.$kfc+".preventSleep",e.$nfc="remoteTunnelService",e.$ofc=(0,N.localize)(0,null)}),define(ae[59],ce([0,1,15,7,2,172,47,4,9,43]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=p,e.$Up=l,e.$Vp=c,e.$Wp=b,e.$Xp=m,e.$Yp=f,e.$Rp=(0,I.$yi)("requestService");class E{constructor($){this.b=$}toJSON(){if(!this.a){const $=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?$[t]="*****":$[t]=this.b[t];this.a=$}return this.a}}class y extends L.$Uc{constructor($){super(),this.b=0,this.a=$.createLogger("network",{name:(0,A.localize)(0,null),when:P.$kk.isEqualTo((0,P.$hk)(P.LogLevel.Trace)).serialize()})}async c($,t,r){const n=`${$} #${++this.b}: ${t.url}`;this.a.trace(`${n} - begin`,t.type,new E(t.headers??{}));try{const s=await r();return this.a.trace(`${n} - end`,t.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,t.type,(0,N.$0)(s)),s}}}e.$Sp=y;function p(g){return g.res.statusCode&&g.res.statusCode>=200&&g.res.statusCode<300||g.res.statusCode===1223}function l(g){return g.res.statusCode===204}async function c(g){return l(g)?null:(await(0,D.$Te)(g.stream)).toString()}async function b(g){if(!p(g))throw new Error("Server returned "+g.res.statusCode);return c(g)}async function m(g){if(!p(g))throw new Error("Server returned "+g.res.statusCode);if(l(g))return null;const t=(await(0,D.$Te)(g.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function f(g){h(g)}let u;function h(g){const $=d.$fo.as(O.$ko.Configuration),t=u;u={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:g,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},$.updateConfigurations({add:[u],remove:t?[t]:[]})}h(1)}),define(ae[224],ce([0,1,26,23,12,59]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qQ=void 0;let O=class{constructor(P,d){this.a=P,this.b=d}async download(P,d,E=D.CancellationToken.None){if(P.scheme===N.Schemas.file||P.scheme===N.Schemas.vscodeRemote){await this.b.copy(P,d);return}const y={type:"GET",url:P.toString(!0)},p=await this.a.request(y,E);if(p.res.statusCode===200)await this.b.writeFile(d,p.stream);else{const l=await(0,A.$Wp)(p);throw new Error(`Expected 200, got back ${p.res.statusCode} instead.

${l}`)}}};e.$qQ=O,e.$qQ=O=ve([X(0,A.$Rp),X(1,L.$5k)],O)}),define(ae[225],ce([0,1,15,26]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=void 0;class L{constructor(I){this.a=I}listen(I,P){throw new Error("Invalid listen")}call(I,P,d,E=N.CancellationToken.None){switch(P){case"request":return this.a.request(d[0],E).then(async({res:y,stream:p})=>{const l=await(0,D.$Te)(p);return[{statusCode:y.statusCode,headers:y.headers},l]});case"resolveProxy":return this.a.resolveProxy(d[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Yr=L;class A{constructor(I){this.a=I}async request(I,P){const[d,E]=await this.a.call("request",[I],P);return{res:d,stream:(0,D.$Ve)(E)}}async resolveProxy(I){return this.a.call("resolveProxy",[I])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Zr=A}),define(ae[226],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jdc=e.$Idc=e.$Hdc=void 0,e.$Hdc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Idc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Jdc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(ae[227],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(L){try{const A=await this.c();if(A){const O=String(D.a++);return this.b.set(O,A),{id:O,data:A.createNewMessage(L)}}}catch{}return{id:"",data:L}}async validate(L,A){if(!L.id)return!0;const O=this.b.get(L.id);if(!O)return!1;this.b.delete(L.id);try{return O.validate(A)==="ok"}catch{return!1}finally{O.dispose?.()}}async sign(L){try{return await this.d(L)}catch{}return L}}e.$B_b=D}),define(ae[105],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rl=e.$Ql=void 0,e.$Ql="signService",e.$Rl=(0,D.$yi)(e.$Ql)}),define(ae[228],ce([0,1,227]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class N extends D.$B_b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(O=>new O.signer().sign(A))}h(){return new Promise((A,O)=>ne(["vsda"],A,O))}}e.$xec=N}),define(ae[77],ce([0,1,3,2]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bLb=e.$aLb=e.$_Kb=e.$$Kb=void 0;class L extends N.$Uc{constructor(y,p,l){super(),this.a=y,this.b=p,this.c=l}async getItems(){const y={profile:this.b,workspace:this.c},p=await this.a.call("getItems",y);return new Map(p)}updateItems(y){const p={profile:this.b,workspace:this.c};return y.insert&&(p.insert=Array.from(y.insert.entries())),y.delete&&(p.delete=Array.from(y.delete.values())),this.a.call("updateItems",p)}optimize(){const y={profile:this.b,workspace:this.c};return this.a.call("optimize",y)}}class A extends L{constructor(y,p){super(y,p,void 0),this.f=this.B(new D.$fe),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(y=>this.h(y)))}h(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this.f.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}}class O extends A{constructor(y){super(y,void 0)}async close(){this.dispose()}}e.$$Kb=O;class I extends A{constructor(y,p){super(y,p)}async close(){this.dispose()}}e.$_Kb=I;class P extends L{constructor(y,p){super(y,void 0,p),this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.$aLb=P;class d{constructor(y){this.a=y}isUsed(y){const p={payload:y,profile:void 0,workspace:void 0};return this.a.call("isUsed",p)}}e.$bLb=d}),define(ae[106],ce([0,1,5,36,32]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=O,e.$ip=I;function A(P){if(D.$u===2&&/^penguin(\.|$)/i.test(P))return"chromebook"}function O(P,d,E,y,p,l,c,b,m){const f=Object.create(null);f["common.machineId"]=l,f["common.sqmId"]=c,f.sessionID=(0,L.$Ug)()+Date.now(),f.commitHash=y,f.version=p,f["common.platformVersion"]=(P||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,D.$h)(D.$u),f["common.nodePlatform"]=N.$dc,f["common.nodeArch"]=E,f["common.product"]=m||"desktop",b&&(f["common.msftInternal"]=b);let u=0;const h=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>u++,enumerable:!0}}),D.$l&&(f["common.snap"]="true");const g=A(d);return g&&(f["common.platformDetail"]=g),f}function I(P){const d=N.env.USERDNSDOMAIN;if(!d)return!1;const E=d.toLowerCase();return P.some(y=>E===y)}}),define(ae[22],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,D.$yi)("telemetryService"),e.$5l=(0,D.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var N;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var L;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(L||(e.TelemetryConfiguration=L={}))}),define(ae[229],ce([0,1,37,6,35,23,14,5,8,145,31,151,94,12,24,22]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0,e.$Is=f,e.$Js=h,e.$Ks=g;const m=new Map;async function f(t,r){const n=`${t}::${r.join(":")}`,s=m.get(n);if(s)return s;const i=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,a=new Map,w=2e4;function S(k,C,R,M){const T=C.substring(k.length+1);return N.Promises.withAsyncBody(async q=>{let Y;try{Y=await E.Promises.readdir(C,{withFileTypes:!0})}catch{q();return}if(M.count>=w){M.count+=Y.length,M.maxReached=!0,q();return}let K=Y.length;if(K===0){q();return}let Z=Y;M.count+Y.length>w&&(M.maxReached=!0,K=w-M.count,Z=Y.slice(0,K)),M.count+=Y.length;for(const G of Z)if(G.isDirectory()){if(R.includes(G.name)||await S(k,(0,O.$jc)(C,G.name),R,M),--K===0){q();return}}else{const J=G.name.lastIndexOf(".");if(J>=0){const V=G.name.substring(J+1);V&&o.set(V,(o.get(V)??0)+1)}for(const V of i)V.relativePathPattern?.test(T)!==!1&&V.filePattern.test(G.name)&&a.set(V.tag,(a.get(V.tag)??0)+1);if(--K===0){q();return}}})}const v=N.Promises.withAsyncBody(async k=>{const C={count:0,maxReached:!1};await S(t,t,r,C);const R=await g(t);k({configFiles:u(a),fileTypes:u(o),fileCount:C.count,maxFilesReached:C.maxReached,launchConfigFiles:R})});return m.set(n,v),v}function u(t){return Array.from(t.entries(),([r,n])=>({name:r,count:n})).sort((r,n)=>n.count-r.count)}function h(){const t={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/l.$Al.GB).toFixed(2)}GB (${(D.freemem()/l.$Al.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(d.$Gn.value()*100)}%`},r=D.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function g(t){try{const r=new Map,n=(0,O.$jc)(t,".vscode","launch.json"),s=await E.Promises.readFile(n),i=[],o=(0,L.$Ln)(s.toString(),i);if(i.length)return console.log(`Unable to parse ${n}`),[];if((0,L.$Un)(o)==="object"&&o.configurations)for(const a of o.configurations){const w=a.type;w&&(r.has(w)?r.set(w,r.get(w)+1):r.set(w,1))}return u(r)}catch{return[]}}let $=class{constructor(r,n){this.c=r,this.d=n}f(r){const n=[];return n.push(`OS Version:       ${r.os}`),n.push(`CPUs:             ${r.cpus}`),n.push(`Memory (System):  ${r.memory}`),n.push(`VM:               ${r.vmHint}`),n.join(`
`)}g(r){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const s=D.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(D.totalmem()/l.$Al.GB).toFixed(2)}GB (${(D.freemem()/l.$Al.GB).toFixed(2)}GB free)`),I.$i||n.push(`Load (avg):       ${D.loadavg().map(i=>Math.round(i)).join(", ")}`),n.push(`VM:               ${Math.round(d.$Gn.value()*100)}%`),n.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${r.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(r,n){return Promise.all([(0,y.$Hs)(r.mainPID),this.k(r)]).then(async s=>{let[i,o]=s,a=this.m(r,i);return n.forEach(w=>{if((0,p.$gn)(w))a+=`
${w.errorMessage}`,o+=`
${w.errorMessage}`;else if(a+=`

Remote: ${w.hostName}`,w.processes&&(a+=`
${this.m(r,w.processes)}`),w.workspaceMetadata){o+=`
|  Remote: ${w.hostName}`;for(const S of Object.keys(w.workspaceMetadata)){const v=w.workspaceMetadata[S];let k=`${v.fileCount} files`;v.maxFilesReached&&(k=`more than ${k}`),o+=`|    Folder (${S}): ${k}`,o+=this.h(v)}}}),{processInfo:a,workspaceInfo:o}})}async getSystemInfo(r,n){const{memory:s,vmHint:i,os:o,cpus:a}=h(),w={os:o,memory:s,cpus:a,vmHint:i,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:n};return I.$i||(w.load=`${D.loadavg().map(S=>Math.round(S)).join(", ")}`),I.$k&&(w.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(w)}async getDiagnostics(r,n){const s=[];return(0,y.$Hs)(r.mainPID).then(async i=>(s.push(""),s.push(this.g(r)),s.push(""),s.push(this.m(r,i)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(r))),n.forEach(o=>{if((0,p.$gn)(o))s.push(`
${o.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${o.hostName}`),s.push(this.f(o.machineInfo)),o.processes&&s.push(this.m(r,o.processes)),o.workspaceMetadata)for(const a of Object.keys(o.workspaceMetadata)){const w=o.workspaceMetadata[a];let S=`${w.fileCount} files`;w.maxFilesReached&&(S=`more than ${S}`),s.push(`Folder (${a}): ${S}`),s.push(this.h(w))}}),s.push(""),s.push(""),s.join(`
`)))}h(r){const n=[];let i=0;const o=(v,k)=>{const C=` ${v}(${k})`;i+C.length>60?(n.push(a),a="|                 ",i=a.length):i+=C.length,a+=C};let a="|      File types:";const w=10,S=r.fileTypes.length>w?w:r.fileTypes.length;for(let v=0;v<S;v++){const k=r.fileTypes[v];o(k.name,k.count)}if(n.push(a),r.configFiles.length>=0&&(a="|      Conf files:",i=0,r.configFiles.forEach(v=>{o(v.name,v.count)}),n.push(a)),r.launchConfigFiles.length>0){let v="|      Launch Configs:";r.launchConfigFiles.forEach(k=>{const C=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`;v+=C}),n.push(v)}return n.join(`
`)}j(r){const n=Math.max(...Object.keys(r).map(s=>s.length));return Object.keys(r).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${r[s]}`).join(`
                  `)}k(r){const n=[],s=[];return r.windows.forEach(i=>{i.folderURIs.length===0||i.remoteAuthority||(n.push(`|  Window (${i.title})`),i.folderURIs.forEach(o=>{const a=P.URI.revive(o);if(a.scheme===A.Schemas.file){const w=a.fsPath;s.push(f(w,["node_modules",".git"]).then(S=>{let v=`${S.fileCount} files`;S.maxFilesReached&&(v=`more than ${v}`),n.push(`|    Folder (${(0,O.$nc)(w)}): ${v}`),n.push(this.h(S))}).catch(S=>{n.push(`|      Error: Unable to collect workspace stats for folder ${w} (${S.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(i=>n.join(`
`)).catch(i=>`Unable to collect workspace stats: ${i}`)}m(r,n){const s=new Map;r.windows.forEach(o=>s.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:a})=>s.set(o,a));const i=[];return i.push("CPU %	Mem MB	   PID	Process"),n&&this.n(r.mainPID,s,i,n,0),i.join(`
`)}n(r,n,s,i,o){const a=o===0;let w;a?w=i.pid===r?`${this.d.applicationName} main`:"remote agent":n.has(i.pid)?w=n.get(i.pid):w=`${"  ".repeat(o)} ${i.name}`;const S=process.platform==="win32"?i.mem:D.totalmem()*(i.mem/100);s.push(`${i.load.toFixed(0).padStart(5," ")}	${(S/l.$Al.MB).toFixed(0).padStart(6," ")}	${i.pid.toFixed(0).padStart(6," ")}	${w}`),Array.isArray(i.children)&&i.children.forEach(v=>this.n(r,n,s,v,o+1))}async getWorkspaceFileExtensions(r){const n=new Set;for(const{uri:s}of r.folders){const i=P.URI.revive(s);if(i.scheme!==A.Schemas.file)continue;const o=i.fsPath;try{(await f(o,["node_modules",".git"])).fileTypes.forEach(w=>n.add(w.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(r){for(const{uri:n}of r.folders){const s=P.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const i=s.fsPath;try{const o=await f(i,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),o.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$Ls=$,e.$Ls=$=ve([X(0,b.$4l),X(1,c.$lk)],$)}),define(ae[107],ce([0,1,7,4,9,22]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.ExtensionSignatureVerificationCode=e.$dq=void 0,e.$dq=(0,N.$yi)("IExtensionSignatureVerificationService");var O;(function(d){d.None="None",d.RequiredArgumentMissing="RequiredArgumentMissing",d.InvalidArgument="InvalidArgument",d.PackageIsUnreadable="PackageIsUnreadable",d.UnhandledException="UnhandledException",d.SignatureManifestIsMissing="SignatureManifestIsMissing",d.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",d.SignatureIsMissing="SignatureIsMissing",d.SignatureIsUnreadable="SignatureIsUnreadable",d.CertificateIsUnreadable="CertificateIsUnreadable",d.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",d.FileAlreadyExists="FileAlreadyExists",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",d.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",d.Success="Success",d.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",d.SignatureIsInvalid="SignatureIsInvalid",d.SignatureManifestIsInvalid="SignatureManifestIsInvalid",d.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",d.EntryIsMissing="EntryIsMissing",d.EntryIsTampered="EntryIsTampered",d.Untrusted="Untrusted",d.CertificateRevoked="CertificateRevoked",d.SignatureIsNotValid="SignatureIsNotValid",d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(O||(e.ExtensionSignatureVerificationCode=O={}));class I extends Error{constructor(E){super(E),this.code=E}}e.$eq=I;let P=class{constructor(E,y){this.b=E,this.c=y}d(){return this.a||(this.a=new Promise((E,y)=>ne(["@vscode/vsce-sign"],async p=>E(p),y))),this.a}async verify(E,y,p,l){let c;try{c=await this.d()}catch(u){return this.b.error("Could not load vsce-sign module",(0,D.$0)(u)),this.b.info(`Extension signature verification is not done: ${E}`),!1}const b=new Date().getTime();let m;try{this.b.trace(`Verifying extension signature for ${E}...`),m=await c.verify(y,p,this.b.getLevel()===L.LogLevel.Trace)}catch(u){m={code:"UnknownError",didExecute:!1,output:(0,D.$0)(u)}}const f=new Date().getTime()-b;if(this.b.info(`Extension signature verification result for ${E}: ${m.code}. Executed: ${m.didExecute}. Duration: ${f}ms.`),this.b.trace(`Extension signature verification output for ${E}:
${m.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:E,code:m.code,duration:f,didExecute:m.didExecute,clientTargetPlatform:l}),m.code==="Success")return!0;throw new I(m.code)}};e.$fq=P,e.$fq=P=ve([X(0,L.$5j),X(1,A.$4l)],P)}),define(ae[108],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ndc=e.$Mdc=void 0;class D{constructor(A){this.b=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:I,data:P}){return this.b.forEach(d=>d.log(I,P)),Promise.resolve(null)}}e.$Mdc=D;class N{constructor(A){this.b=A}log(A,O){return this.b.call("log",{eventName:A,data:O}).then(void 0,I=>`Failed to log telemetry: ${console.warn(I)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Ndc=N}),define(ae[49],ce([0,1,30,13,102,106,22]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=E,e.$rp=y,e.$sp=p,e.$tp=l,e.$up=b,e.$vp=f,e.$wp=u,e.$xp=$;class I{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$jp=I;class P{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=P,e.$lp=new P;class d{async publicLog(r,n,s){}async publicLogError(r,n,s){}}e.$mp=d,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function E(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function y(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function p(t){const r=t.getValue(O.$_l),n=t.getValue(O.$am);if(t.getValue(O.$bm)===!1||n===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function l(t){const r={},n={},s={};m(t,s);for(let i in s){i=i.length>150?i.substr(i.length-149):i;const o=s[i];typeof o=="number"?n[i]=o:typeof o=="boolean"?n[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),r[i]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[i]=o)}return{properties:r,measurements:n}}const c=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(t){if(!t)return"none";const r=(0,L.$Km)(t);return c.has(r)?r:"other"}function m(t,r,n=0,s){if(t)for(const i of Object.getOwnPropertyNames(t)){const o=t[i],a=s?s+i:i;Array.isArray(o)?r[a]=(0,D.$0n)(o):o instanceof Date?r[a]=o.toISOString():(0,N.$ag)(o)?n<2?m(o,r,n+1,a+"."):r[a]=(0,D.$0n)(o):r[a]=o}}function f(t,r){const n=t.msftInternalDomains||[],s=r.getValue("telemetry.internalTesting");return(0,A.$ip)(n)||s}function u(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function h(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const s=[];for(const w of r)for(;;){const S=w.exec(t);if(!S)break;s.push([S.index,w.lastIndex])}const i=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const w=o.exec(t);if(!w)break;const S=s.some(([v,k])=>w.index<k&&v<o.lastIndex);!i.test(w[0])&&!S&&(n+=t.substring(a,w.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<t.length&&(n+=t.substr(a)),n}function g(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of r)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function $(t,r){return(0,D.$7n)(t,n=>{if(n instanceof I||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=h(s,r);for(const i of r)s=s.replace(i,"");return s=g(s),s}})}}),define(ae[33],ce([0,1,27,29,48,5,8,7,36,49]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=E,e.$Ap=c,e.$Bp=b,e.$Cp=m,e.$Dp=f,e.$Ep=u,e.$Fp=h,e.$Gp=g,e.$Ip=$,e.$Jp=r;function E(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,D.$uf)(n.id,s.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class p{static create(s){const i=s.manifest?s.manifest.version:s.version,o=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new p(s.identifier,i,o)}static parse(s){const i=y.exec(s);return i&&i[1]&&i[2]?new p({id:i[1]},i[2],i[4]||void 0):null}constructor(s,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof p?E(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$zp=p;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function c(n){const s=l.exec(n);return s&&s[1]?[m(s[1]),s[2]]:[m(n),void 0]}function b(n,s){return`${n}.${s}`}function m(n){return n.toLowerCase()}function f(n,s){return m(b(n??L.$Pm,s))}function u(n,s){const i=[],o=a=>{for(const w of i)if(w.some(S=>E(s(S),s(a))))return w;return null};for(const a of n){const w=o(a);w?w.push(a):i.push([a])}return i}function h(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}function g(n){return{id:new d.$jp(n.identifier.id),name:new d.$jp(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$Hp=new L.$Tm("pprice.better-merge");function $(n,s){const i=[],o=s.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const a=o.shift();if(a&&i.every(w=>!E(w.identifier,{id:a}))){const w=n.filter(S=>E(S.identifier,{id:a}));w.length===1&&(i.push(w[0]),o.push(...w[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}async function t(n,s){if(!A.$k)return!1;let i;try{i=(await n.readFile(O.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await n.readFile(O.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,I.$0)(a))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(n,s){const i=await t(n,s),o=(0,N.$6o)(i?"alpine":A.$u,P.$ec);return s.debug("ComputeTargetPlatform:",o),o}}),define(ae[230],ce([0,1,17,2,20,8,12,24,6,3,14,5,36,33]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0;let c=class extends N.$Uc{constructor(h,g){super(),this.b=h,this.c=g,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,$])=>this.a.set($.configPath,$))}getConfigBasedTips(h){return this.f(h)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(h){const g=[];for(const[$,t]of this.a)if(!(t.configScheme&&t.configScheme!==h.scheme))try{const r=(await this.b.readFile((0,L.$_g)(h,$))).value.toString();for(const[n,s]of Object.entries(t.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(r))&&g.push({extensionId:n,extensionName:s.name,configName:t.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return g}};e.$Kbc=c,e.$Kbc=c=ve([X(0,O.$5k),X(1,I.$lk)],c);const b="extensionTips/promptedExecutableTips",m="extensionTips/lastPromptedMediumImpExeTime";class f extends c{constructor(h,g,$,t,r,n,s,i){super(s,i),this.r=h,this.s=g,this.t=$,this.u=t,this.w=r,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,i.exeBasedExtensionTips&&Object.entries(i.exeBasedExtensionTips).forEach(([o,a])=>{const w=[],S=[],v=[];Object.entries(a.recommendations).forEach(([k,C])=>{C.important?a.important?w.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):S.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack}):v.push({extensionId:k,extensionName:C.name,isExtensionPack:!!C.isExtensionPack})}),w.length&&this.g.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:w}),S.length&&this.h.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:S}),v.length&&this.j.set(o,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:v})}),(0,P.$Ah)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const h=await this.O(this.g),g=await this.O(this.h);return[...h,...g]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const h=await this.O(this.g),g=await this.O(this.h),$=await this.u.getInstalled();this.m=this.D(h,$),this.n=this.D(g,$)}D(h,g){const $=new Map;h.forEach(i=>$.set(i.extensionId.toLowerCase(),i));const{installed:t,uninstalled:r}=this.N([...$.keys()],g);for(const i of t){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:i,exeName:o.exeName})}for(const i of r){const o=$.get(i);o&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:i,exeName:o.exeName})}const n=this.L(),s=new Map;for(const i of r){const o=$.get(i);if(o&&(!n[o.exeName]||!n[o.exeName].includes(o.extensionId))){let a=s.get(o.exeName);a||(a=[],s.set(o.exeName,a)),a.push(o)}}return s}F(){if(this.m.size===0)return;const[h,g]=[...this.m.entries()][0];this.H(g).then($=>{switch($){case"reacted":this.M(g[0].exeName,g);break;case"ignored":this.m.delete(h);break;case"incompatibleWindow":{const t=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(t(()=>this.F()));break}case"toomany":{const t=this.B(new N.$Vc);t.value=(0,P.$Ah)(()=>{t.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const h=this.I(),g=Date.now()-h,$=7*24*60*60*1e3;if(g<$){const n=this.B(new N.$Vc);n.value=(0,P.$Ah)(()=>{n.dispose(),this.G()},$-g);return}const[t,r]=[...this.n.entries()][0];this.H(r).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(t),this.M(r[0].exeName,r);const s=this.B(new N.$Vc);s.value=(0,P.$Ah)(()=>{s.dispose(),this.G()},$);break}case"ignored":this.n.delete(t),this.G();break;case"incompatibleWindow":{const s=d.Event.once(d.Event.latch(d.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new N.$Vc);s.value=(0,P.$Ah)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(h){const g=await this.u.getInstalled(1),$=h.filter(t=>!t.whenNotInstalled||t.whenNotInstalled.every(r=>g.every(n=>!(0,l.$yp)(n.identifier,{id:r})))).map(({extensionId:t})=>t.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:$,source:3,name:h[0].exeFriendlyName,searchValue:`@exe:"${h[0].exeName}"`})}I(){let h=this.w.getNumber(m,-1);return h||(h=Date.now(),this.J(h)),h}J(h){this.w.store(m,h,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(h,g){const $=this.L();$[h]=g.map(({extensionId:t})=>t.toLowerCase()),this.w.store(b,JSON.stringify($),-1,0)}N(h,g){const $=[],t=[],r=g.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return h.forEach(n=>{r.has(n.toLowerCase())?$.push(n):t.push(n)}),{installed:$,uninstalled:t}}async O(h){const g=[],$=new Map;for(const t of h.keys()){const r=h.get(t);if(!r||!(0,D.$Lb)(r.recommendations))continue;const n=[];y.$i?r.windowsPath&&n.push(r.windowsPath.replace("%USERPROFILE%",()=>p.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>p.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>p.env.ProgramFiles).replace("%APPDATA%",()=>p.env.APPDATA).replace("%WINDIR%",()=>p.env.WINDIR)):(n.push((0,E.$jc)("/usr/local/bin",t)),n.push((0,E.$jc)("/usr/bin",t)),n.push((0,E.$jc)(this.r.fsPath,t)));for(const s of n){let i=$.get(s);if(i===void 0&&(i=await this.b.exists(A.URI.file(s)),$.set(s,i)),i)for(const{extensionId:o,extensionName:a,isExtensionPack:w,whenNotInstalled:S}of r.recommendations)g.push({extensionId:o,extensionName:a,isExtensionPack:w,exeName:t,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:S})}}return g}}e.$Lbc=f}),define(ae[231],ce([0,1,26,33]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$44b=L;async function L(A,O,I,P,d){try{const E=await A.getExtensionsControlManifest();if(!E.deprecated)return;const y=await A.getInstalled(1);for(const[p,l]of Object.entries(E.deprecated)){if(!l?.extension)continue;const{id:c,autoMigrate:b,preRelease:m}=l.extension;if(!b)continue;const f=y.find(h=>(0,N.$yp)(h.identifier,{id:p}));if(!f)continue;const u=(await O.getExtensions([{id:c,preRelease:m}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!u){d.info(`Skipping migrating '${f.identifier.id}' extension because, the comaptible target '${c}' extension is not found`);continue}try{d.info(`Migrating '${f.identifier.id}' extension to '${c}' extension...`);const h=!P.getDisabledExtensions().some($=>(0,N.$yp)($,f.identifier));await A.uninstall(f),d.info(`Uninstalled the unsupported extension '${f.identifier.id}'`);let g=y.find($=>(0,N.$yp)($.identifier,{id:c}));(!g||!g.isPreReleaseVersion&&h)&&(g=await A.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:f.isMachineScoped,operation:4}),d.info(`Installed the pre-release extension '${g.identifier.id}'`),h||(await P.disableExtension(g.identifier),d.info(`Disabled the pre-release extension '${g.identifier.id}' because the unsupported extension '${f.identifier.id}' is disabled`)),b.storage&&(I.addToMigrationList((0,N.$Bp)(f.manifest.publisher,f.manifest.name),(0,N.$Bp)(g.manifest.publisher,g.manifest.name)),d.info("Added pre-release extension to the storage migration list"))),d.info(`Migrated '${f.identifier.id}' extension to '${c}' extension.`)}catch(h){d.error(h)}}}catch(E){d.error(E)}}}),define(ae[232],ce([0,1,3,2,34,33,48]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class I extends N.$Uc{constructor(d,E,y,p,l,c,b){super(),this.f=d,this.g=E,this.h=y,this.j=p,this.m=l,this.n=c,this.r=b,this.a=this.B(new D.$fe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.$4c),this.s().then(null,m=>b.error(m))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(d=>this.u(d.added))),this.B(this.j.onAddExtensions(d=>this.w(d))),this.B(this.j.onDidAddExtensions(d=>this.y(d))),this.B(this.j.onRemoveExtensions(d=>this.z(d))),this.B(this.j.onDidRemoveExtensions(d=>this.C(d))),this.B(this.n.onDidFilesChange(d=>this.D(d)))}async u(d){try{d.length&&await Promise.all(d.map(E=>(this.c.set(E.id,(0,N.$Rc)(this.n.watch(this.m.extUri.dirname(E.extensionsResource)),this.n.watch(E.extensionsResource))),this.G(E.extensionsResource))))}catch(E){throw this.r.error(E),E}}async w(d){for(const E of d.extensions)this.I(this.L(E.identifier,E.version),d.profileLocation)}async y(d){for(const E of d.extensions){const y=this.L(E.identifier,E.version);d.error?this.J(y,d.profileLocation):this.I(y,d.profileLocation)}}async z(d){for(const E of d.extensions)this.J(this.L(E.identifier,E.version),d.profileLocation)}async C(d){const E=[],y=[];for(const p of d.extensions){const l=this.L(p.identifier,p.version);d.error?this.I(l,d.profileLocation):(this.J(l,d.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",p.identifier.id,p.version),y.push(this.f.scanInstalledExtensionAtLocation(p.location).then(c=>{c?E.push(c):this.r.info("Extension not found at the location",p.location.toString())},c=>this.r.error(c)))))}try{await Promise.all(y),E.length&&await this.H(E)}catch(p){this.r.error(p)}}D(d){for(const E of this.h.profiles)d.contains(E.extensionsResource,0,1)&&this.F(E.extensionsResource)}async F(d){const E=[],y=[],p=await this.j.scanProfileExtensions(d),l=new Set,c=new Set;for(const[b,m]of this.b)m.has(d)&&c.add(b);for(const b of p){const m=this.L(b.identifier,b.version);l.add(m),c.has(m)||(E.push(b.identifier),this.I(m,d))}for(const b of c)if(!l.has(b)){const m=this.M(b);m&&(y.push(m.identifier),this.J(b,d))}(E.length||y.length)&&this.a.fire({added:E.length?{extensions:E,profileLocation:d}:void 0,removed:y.length?{extensions:y,profileLocation:d}:void 0})}async G(d){const E=await this.j.scanProfileExtensions(d);for(const y of E)this.I(this.L(y.identifier,y.version),d)}async H(d){d||(d=(await this.f.scanAllUserInstalledExtensions()).filter(y=>!this.b.has(this.L(y.identifier,y.manifest.version)))),d.length&&await this.f.markAsUninstalled(...d)}I(d,E){let y=this.b.get(d);y||this.b.set(d,y=new L.$Bc(p=>this.m.extUri.getComparisonKey(p))),y.add(E)}J(d,E){const y=this.b.get(d);y&&y.delete(E),y?.size||this.b.delete(d)}L(d,E){return`${O.$Tm.toKey(d.id)}@${E}`}M(d){const[E,y]=(0,A.$Ap)(d);return y?{identifier:{id:E},version:y}:void 0}}e.$Gq=I}),define(ae[233],ce([0,1,45,49]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=L;async function L(A,O,I,P,d,E,y){const p={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${O.nameShort})`};if((0,N.$qp)(O,I)&&(0,N.$sp)(P)===3){const l=await(0,D.$$p)(I,d,E);p["X-Market-User-Id"]=l,p["VSCode-SessionId"]=y.machineId||l}return p}}),define(ae[234],ce([0,1,73,17,6,2,23,14,31,16,29,33,9,75,8]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;let b=class extends l.$Wr{constructor(h,g,$,t){super($),this.h=h,this.j=t,this.g=this.B(new m(g,t)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(h,g){const t=(await this.g.getLanguagePacks())[g];if(!t){this.j.warn(`No language pack found for ${g}`);return}const r=t.translations[h];return r?c.URI.file(r):void 0}async getInstalledLanguages(){const h=await this.g.getLanguagePacks(),g=Object.keys(h).map($=>{const t=h[$];return{...this.f($,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return g.push(this.f("en","English")),g.sort(($,t)=>$.label.localeCompare(t.label)),g}async m(h){h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",h.identifier.id),await this.update())}async n(h){const g=await this.g.getLanguagePacks();Object.keys(g).some($=>g[$]&&g[$].extensions.some(t=>(0,y.$yp)(t.extensionIdentifier,h.identifier)))&&(this.j.info("Removing language packs from the extension",h.identifier.id),await this.update())}async update(){const[h,g]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),$=await this.g.update(g);return!(0,N.$ub)(Object.keys(h),Object.keys($))}};e.$Xr=b,e.$Xr=b=ve([X(0,E.$ap),X(1,d.$Gi),X(2,E.$0o),X(3,p.$5j)],b);let m=class extends A.$Uc{constructor(h,g){super(),this.j=g,this.c={},this.f=(0,I.$jc)(h.userDataPath,"languagepacks.json"),this.g=new L.$Fh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(h){return this.s(g=>{Object.keys(g).forEach($=>delete g[$]),this.m(g,...h)}).then(()=>this.c)}m(h,...g){for(const $ of g)$&&$.manifest&&$.manifest.contributes&&$.manifest.contributes.localizations&&$.manifest.contributes.localizations.length&&this.n(h,$);Object.keys(h).forEach($=>this.r(h[$]))}n(h,g){const $=g.identifier,t=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const r of t)if(g.location.scheme===O.Schemas.file&&f(r)){let n=h[r.languageId];n||(n={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},h[r.languageId]=n);const s=n.extensions.filter(i=>(0,y.$yp)(i.extensionIdentifier,$))[0];s?s.version=g.manifest.version:n.extensions.push({extensionIdentifier:$,version:g.manifest.version});for(const i of r.translations)n.translations[i.id]=(0,I.$jc)(g.location.fsPath,i.path)}}r(h){if(h){const g=(0,D.createHash)("md5");for(const $ of h.extensions)g.update($.extensionIdentifier.uuid||$.extensionIdentifier.id).update($.version);h.hash=g.digest("hex")}}s(h=()=>null){return this.g.queue(()=>{let g=null;return P.Promises.readFile(this.f,"utf8").then(void 0,$=>$.code==="ENOENT"?Promise.resolve("{}"):Promise.reject($)).then($=>{try{return JSON.parse($)}catch{return{}}}).then($=>(g=h($),$)).then($=>{for(const r of Object.keys($))$[r]||delete $[r];this.c=$,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),P.Promises.writeFile(this.f,t)}).then(()=>g,$=>this.j.error($))})}};m=ve([X(0,d.$Gi),X(1,p.$5j)],m);function f(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const h of u.translations)if(typeof h.id!="string"||typeof h.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(ae[235],ce([0,1,144,7,30,49]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1P=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0",I="https://mobile.events.data.microsoft.com/ping";async function P(E,y,p){const l=await(0,D.$_D)("@microsoft/1ds-core-js","dist/ms.core.js"),c=await(0,D.$_D)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new l.AppInsightsCore,m=new c.PostChannel,f={instrumentationKey:E,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[m]]};if(p){f.extensionConfig={};const u={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:p};f.extensionConfig[m.identifier]=u}return b.initialize(f,[]),b.addTelemetryInitializer(u=>{u.ext=u.ext??{},u.ext.web=u.ext.web??{},u.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',y&&(u.ext.utc=u.ext.utc??{},u.ext.utc.flags=8462029)}),b}class d{constructor(y,p,l,c,b){this.e=y,this.f=p,this.g=l,this.h=b,this.c=O,this.d=I,this.g||(this.g={}),typeof c=="function"?this.a=c():this.a=c,this.b=null}i(y){if(this.a){if(typeof this.a!="string"){y(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(p=>{y(p)},p=>{(0,N.$1)(p),console.error(p)})}}log(y,p){if(!this.a)return;p=(0,L.$8n)(p,this.g),p=(0,A.$tp)(p);const l=this.f+"/"+y;try{this.i(c=>{c.pluginVersionString=p?.properties.version??"Unknown",c.track({name:l,baseData:{name:l,properties:p?.properties,measurements:p?.measurements}})})}catch{}}flush(){return this.a?new Promise(y=>{this.i(p=>{p.unload(!0,()=>{this.a=void 0,y(void 0)})})}):Promise.resolve(void 0)}}e.$1P=d}),define(ae[109],ce([0,1,2,173,16,9,24,49]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ac=void 0;let P=class extends D.$Uc{constructor(E,y,p,l,c=""){super(),this.b=c;const b=y.getLogger(I.$np);if(b)this.a=this.B(b);else{const f=(0,I.$rp)(l,p)?" (Not Sent)":"",u=()=>(0,I.$qp)(l,p)&&E.getLevel()===A.LogLevel.Trace;this.a=this.B(y.createLogger(I.$np,{name:(0,N.localize)(0,null,f),hidden:!u()})),this.B(E.onDidChangeLogLevel(()=>y.setVisibility(I.$np,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(E,y){this.a.trace(`${this.b}telemetry/${E}`,(0,I.$tp)(y))}};e.$$ac=P,e.$$ac=P=ve([X(0,A.$5j),X(1,A.$6j),X(2,L.$Fi),X(3,O.$lk)],P)}),define(ae[110],ce([0,1,2,30,5,27,174,21,47,100,24,43,22,49]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=void 0;let c=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(f,u,h){this.k=u,this.l=h,this.d={},this.i=new D.$Tc,this.j=[],this.b=f.appenders,this.c=f.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=f.piiPaths||[],this.g=3,this.h=!!f.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const g of this.f)this.j.push(new RegExp((0,A.$bf)(g),"gi")),g.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$bf)(g.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(g=>{(g.affectsConfiguration(p.$_l)||g.affectsConfiguration(p.$bm)||g.affectsConfiguration(p.$am))&&this.m()}))}setExperimentProperty(f,u){this.d[f]=u}m(){let f=(0,l.$sp)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const h=u.usage?3:u.error?2:0;f=Math.min(f,h)}this.g=f}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(f,u,h){this.g<u||(h=(0,N.$8n)(h,this.d),h=(0,l.$xp)(h,this.j),h=(0,N.$8n)(h,this.c),this.b.forEach(g=>g.log(f,h)))}publicLog(f,u){this.n(f,3,u)}publicLog2(f,u){this.publicLog(f,u)}publicLogError(f,u){this.h&&this.n(f,2,u)}publicLogError2(f,u){this.publicLogError(f,u)}};e.$4r=c,e.$4r=c=ve([X(1,I.$5i),X(2,E.$lk)],c);function b(){const m=(0,O.localize)(0,null,d.default.nameLong),f=d.default.privacyStatementUrl?(0,O.localize)(2,null,"https://aka.ms/vscode-telemetry",d.default.privacyStatementUrl):(0,O.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=L.$o?"":(0,O.localize)(3,null),h=(0,O.localize)(4,null),g=(0,O.localize)(5,null),$=(0,O.localize)(6,null),t=(0,O.localize)(7,null),r=`
|       | ${h} | ${g} | ${$} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,O.localize)(8,null);return`
${m} ${f} ${u}

&nbsp;

${t}
${r}

&nbsp;

${n}
`}y.$fo.as(P.$ko.Configuration).registerConfiguration({id:p.$$l,order:1,type:"object",title:(0,O.localize)(9,null),properties:{[p.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,O.localize)(10,null),(0,O.localize)(11,null),(0,O.localize)(12,null),(0,O.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),y.$fo.as(P.$ko.Configuration).registerConfiguration({id:p.$$l,order:110,type:"object",title:(0,O.localize)(14,null),properties:{[p.$bm]:{type:"boolean",markdownDescription:d.default.privacyStatementUrl?(0,O.localize)(16,null,d.default.nameLong,d.default.privacyStatementUrl):(0,O.localize)(15,null,d.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,O.localize)(17,null,`\`#${p.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ae[236],ce([0,1,15,26,278,235]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2P=void 0;async function O(E,y){const p=await y.request(E,N.CancellationToken.None),l=(await(0,D.$Te)(p.stream)).toString(),c=p.res.statusCode??200;return{headers:p.res.headers,statusCode:c,responseData:l}}async function I(E){const y={method:E.type,headers:E.headers};return new Promise((l,c)=>{const b=L.request(E.url??"",y,m=>{m.on("data",function(f){l({headers:m.headers,statusCode:m.statusCode??200,responseData:f.toString()})}),m.on("error",function(f){c(f)})});b.write(E.data,m=>{m&&c(m)}),b.end()})}async function P(E,y,p){const l=typeof y.data=="string"?y.data:new TextDecoder().decode(y.data),c={type:"POST",headers:{...y.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(y.data).toString()},url:y.urlString,data:l};try{const b=E?await O(c,E):await I(c);p(b.statusCode,b.headers,b.responseData)}catch{p(0,{})}}class d extends A.$1P{constructor(y,p,l,c,b){const m={sendPOST:(f,u)=>{P(y,f,u)}};super(p,l,c,b,m)}}e.$2P=d}),define(ae[237],ce([0,1,23,92,21,16,9,24,22,108,109,110]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;let p=class{constructor(c,b,m,f,u,h){this.b=c,this.c=b,this.d=m,this.e=f,this.f=u,this.g=h,this.a=new Map}h(c){if(!this.a.has(c.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const m=[c.id,JSON.stringify(b),c.aiKey],u=new N.$5q(D.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:m,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new d.$Ndc(u),new E.$$ac(this.d,this.e,this.f,this.g,`[${c.id}] `)];this.a.set(c.id,new y.$4r({appenders:h,sendErrorTelemetry:c.sendErrorTelemetry},this.b,this.g))}return this.a.get(c.id)}publicLog(c,b,m){this.h(c).publicLog(b,m)}publicLogError(c,b,m){this.h(c).publicLogError(b,m)}};e.$8ec=p,e.$8ec=p=ve([X(0,L.$5i),X(1,P.$4l),X(2,O.$5j),X(3,O.$6j),X(4,A.$Fi),X(5,I.$lk)],p)}),define(ae[78],ce([0,1,3,8,21,4,9]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xw=e.$ww=e.$tw=e.$rw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$nw=e.$mw=void 0,e.$ow=d,e.$pw=y,e.$qw=p,e.$sw=l,e.$uw=c,e.$vw=b,e.$mw=(0,A.$yi)("tunnelService"),e.$nw=(0,A.$yi)("sharedTunnelsService");var I;(function(u){u.Http="http",u.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(u){u.ConstantPrivate="constantPrivate",u.Private="private",u.Public="public"})(P||(e.TunnelPrivacyId=P={}));function d(u){return!!u.forwardPort}var E;(function(u){u[u.Notify=1]="Notify",u[u.OpenBrowser=2]="OpenBrowser",u[u.OpenPreview=3]="OpenPreview",u[u.Silent=4]="Silent",u[u.Ignore=5]="Ignore",u[u.OpenBrowserOnce=6]="OpenBrowserOnce"})(E||(e.ProvidedOnAutoForward=E={}));function y(u){if(u.scheme!=="http"&&u.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(u.authority);if(h)return{address:h[1],port:+h[2]}}function p(u){if(u.scheme!=="http"&&u.scheme!=="https"||!u.query)return;const h=u.query.split("&");for(const g of h){const $=g.split("=")[1];if(/^https?:/.exec($)){const t=y(N.URI.parse($));if(t)return t}}}e.$rw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(u){return e.$rw.indexOf(u)>=0}e.$tw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function c(u){return e.$tw.indexOf(u)>=0}function b(u,h,g,$){if(g===1)return!1;if(g===2&&c(h)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec($);if(t?.length===4&&parseInt(t[1])>=18)return!1}return u<1024}class m{constructor(h,g,$){this.remoteAddress=h,this.localAddress=g,this.b=$,this.a=new D.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$ww=m;let f=class{constructor(h,g){this.k=h,this.l=g,this.a=new D.$fe,this.onTunnelOpened=this.a.event,this.b=new D.$fe,this.onTunnelClosed=this.b.event,this.c=new D.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],g=Array.from(this.e.values());for(const $ of g){const t=Array.from($.values());for(const r of t){const n=await r.value;n&&typeof n!="string"&&h.push(n)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:g}of h.values())await g.then($=>typeof $!="string"?$?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,g,$,t,r){this.q(h,g,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:g,localAddress:$,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,g){(c(h)||l(h))&&(h=e.$rw[0]);const $=this.s(h,g);if($)return++$.refcount,$.value}openTunnel(h,g,$,t,r,n=!1,s,i){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${$} on local port ${r}.`);const o=this.f??h;if(!o)return;if(g||(g="localhost"),t||(t=this.m),this.f&&this.j.has($)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const a=this.t(o,g,$,t,r,n,s,i);return a?a.then(w=>{if(w){if(typeof w=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(g,$),w}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(g,$);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const S=this.o(w);return(w.tunnelRemoteHost!==g||w.tunnelRemotePort!==$)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),s&&w.privacy!==s&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(S),S}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const g=this.e.get(h.tunnelRemoteHost);if(g){const $=g.get(h.tunnelRemotePort);$&&($.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,$))}}}}async p(h,g,$){if($.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${g}.`);const t=$.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(g),t}}async closeTunnel(h,g){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${g} `);const $=this.e.get(h);if($&&$.has(g)){const t=$.get(g);t.refcount=0,await this.p(h,g,t)}}q(h,g,$){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(g,{refcount:1,value:$})}async r(h,g){const $=this.e.get(h);if($){const t=$.get(g),r=t?await t.value:void 0;(!r||typeof r=="string")&&$.delete(g),$.size===0&&this.e.delete(h)}}s(h,g){const $=[h];l(h)?($.push(...e.$rw),$.push(...e.$tw)):c(h)&&$.push(...e.$tw);const t=$.map(r=>this.e.get(r));for(const r of t){const n=r?.get(g);if(n)return n}}canTunnel(h){return!!y(h)}u(h,g,$,t,r,n,s){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${$} on local port ${t}.`);const i=$;this.j.add(i);const o=t===void 0?$:t,a={elevationRequired:r?this.isPortPrivileged(o):!1},w={remoteAddress:{host:g,port:$},localAddressPort:t,privacy:n,public:n?n!==P.Private:void 0,protocol:s},S=h.forwardPort(w,a);return S?(this.q(g,$,S),S.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(i)})):this.j.delete(i),S}};e.$xw=f,e.$xw=f=ve([X(0,O.$5j),X(1,L.$5i)],f)}),define(ae[238],ce([0,1,9,78,2,7,6]),function(ne,e,D,N,L,A,O){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.$ffc=void 0;class P extends L.$Uc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new O.$Vh),this.b.p)}setAddress(y){this.a=y,this.b&&(this.b.complete(y),this.b=null)}setTunnel(y){this.B(y)}}let d=class extends L.$Uc{static{I=this}static{this.a=0}constructor(y,p){super(),this.f=y,this.g=p,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(y=>y.dispose())}async createTunnel(){return{id:String(++I.a)}}async startTunnel(y,p,l,c,b,m,f){const u=new P,h=await Promise.resolve(this.f.openTunnel(y,u,l,c,b,m,f));if(!h||typeof h=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${c} (remote).`),u.dispose(),new Error("Could not create tunnel");if(this.c.has(p))throw this.c.delete(p),u.dispose(),await h.dispose(),(0,A.$6)();return u.setTunnel(h),this.b.set(p,u),this.g.info(`[SharedProcessTunnelService] Created tunnel ${p}: ${h.localAddress} (local) to ${l}:${c} (remote).`),{tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress}}async setAddress(y,p){const l=this.b.get(y);l&&l.setAddress(p)}async destroyTunnel(y){const p=this.b.get(y);if(p){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${y}.`),this.b.delete(y),await p.dispose();return}this.c.add(y)}};e.$ffc=d,e.$ffc=d=I=ve([X(0,N.$nw),X(1,D.$5j)],d)}),define(ae[28],ce([0,1,4]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,D.$yi)("IUriIdentityService")}),define(ae[239],ce([0,1,28,192,12,20,129,3,2]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class d{static{this._clock=0}constructor(p){this.uri=p,this.time=d._clock++}touch(){return this.time=d._clock++,this}}let E=class{constructor(p){this.g=p,this.c=new P.$Tc,this.f=2**16;const l=new Map,c=b=>{let m=l.get(b.scheme);return m===void 0&&(m=p.hasProvider(b)&&!this.g.hasCapability(b,1024),l.set(b.scheme,m)),m};this.c.add(I.Event.any(p.onDidChangeFileSystemProviderRegistrations,p.onDidChangeFileSystemProviderCapabilities)(b=>{l.delete(b.scheme)})),this.extUri=new A.$1g(c),this.d=new O.$Ds((b,m)=>this.extUri.compare(b,m,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(p){this.g.hasProvider(p)&&(p=(0,A.$ah)(p));const l=this.d.get(p);return l?l.touch().uri.with({fragment:p.fragment}):(this.d.set(p,new d(p)),this.h(),p)}h(){if(this.d.size<this.f)return;const p=[...this.d.entries()].sort((c,b)=>c[1].time<b[1].time?1:c[1].time>b[1].time?-1:0);d._clock=0,this.d.clear();const l=this.f*.5;for(let c=0;c<l;c++)this.d.set(p[c][0],p[c][1].touch())}};e.$Es=E,e.$Es=E=ve([X(0,L.$5k)],E),(0,N.$Bs)(D.$Cl,E,1)}),define(ae[240],ce([0,1,3,2,12,51,34]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aec=void 0;class I extends N.$Uc{constructor(d,E,y,p,l,c){super(),this.f=d,this.g=E,this.h=y,this.j=p,this.m=l,this.n=c,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new D.$fe),this.onDidChangeFile=this.a.event,this.b=A.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new O.$Bc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(p.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const d of this.j.profiles)this.c.add(d.settingsResource),this.c.add(d.keybindingsResource),this.c.add(d.tasksResource),this.c.add(d.extensionsResource)}open(d,E){return this.g.open(this.t(d),E)}close(d){return this.g.close(d)}read(d,E,y,p,l){return this.g.read(d,E,y,p,l)}write(d,E,y,p,l){return this.g.write(d,E,y,p,l)}watch(d,E){this.b.set(d,d);const y=this.g.watch(this.t(d),E);return(0,N.$Sc)(()=>{this.b.delete(d),y.dispose()})}stat(d){return this.g.stat(this.t(d))}mkdir(d){return this.g.mkdir(this.t(d))}rename(d,E,y){return this.g.rename(this.t(d),this.t(E),y)}readFile(d,E){return this.g.readFile(this.t(d),E)}readFileStream(d,E,y){return this.g.readFileStream(this.t(d),E,y)}readdir(d){return this.g.readdir(this.t(d))}enforceAtomicReadFile(d){return this.c.has(d)}writeFile(d,E,y){return this.g.writeFile(this.t(d),E,y)}enforceAtomicWriteFile(d){return this.c.has(d)?{postfix:".vsctmp"}:!1}delete(d,E){return this.g.delete(this.t(d),E)}copy(d,E,y){if((0,L.$9k)(this.g))return this.g.copy(this.t(d),this.t(E),y);throw new Error("copy not supported")}cloneFile(d,E){if((0,L.$0k)(this.g))return this.g.cloneFile(this.t(d),this.t(E));throw new Error("clone not supported")}s(d){const E=[];for(const y of d){if(y.resource.scheme!==this.f)continue;const p=this.u(y.resource);this.b.findSubstr(p)&&E.push({resource:p,type:y.type,cId:y.cId})}E.length&&(this.n.debug("User data changed"),this.a.fire(E))}t(d){return d.with({scheme:this.f})}u(d){return d.with({scheme:this.h})}}e.$Aec=I}),define(ae[79],ce([0,1,62]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.edit=N,e.$QKb=L,e.$RKb=A;function N(O,I,P,d){const E=(0,D.$1n)(O,I,P,d)[0];return E&&(O=O.substring(0,E.offset)+E.content+O.substring(E.offset+E.length)),O}function L(O,I,P){let d=P;for(;d>=0;){if(O.charAt(d)===I.charAt(I.length-1)&&I.length===1)return d+1;if(d--,I.length===2&&d>=0&&O.charAt(d)===I.charAt(0))return d+2}return 0}function A(O,I,P){let d=P;for(;d>=0;)if(O.charAt(d)===I.charAt(I.length-1)&&I.length===1||(d++,I.length===2&&d>=0&&O.charAt(d)===I.charAt(1)))return d;return O.length-1}}),define(ae[241],ce([0,1,30,55,13]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O_b=A;function A(l,c,b,m,f,u){const h=[],g=[],$=[];if(!c){const q=l.filter(({identifier:Y})=>f.every(K=>K.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:h,removed:g,updated:$},remote:q.length>0?{added:q,updated:[],removed:[],all:q}:null}}l=l.map(y),c=c.map(y),b=b?b.map(y):null;const t=new Map,r=q=>{q.uuid&&t.set(q.id.toLowerCase(),q.uuid)};l.forEach(({identifier:q})=>r(q)),c.forEach(({identifier:q})=>r(q)),b?.forEach(({identifier:q})=>r(q)),m?.forEach(({identifier:q})=>r(q)),u?.forEach(q=>r(q));const n=q=>{const Y=q.identifier.uuid||t.get(q.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${q.identifier.id.toLowerCase()}`},s=(q,Y)=>(q.set(n(Y),Y),q),i=l.reduce(s,new Map),o=c.reduce(s,new Map),a=c.reduce((q,Y)=>s(q,(0,D.$5n)(Y)),new Map),w=b?b.reduce(s,new Map):null,S=m.reduce(s,new Map),v=f.reduce((q,Y)=>{const K=t.get(Y.toLowerCase());return q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)},new Set),k=u?u.reduce((q,{id:Y,uuid:K})=>(K=K??t.get(Y.toLowerCase()),q.add(K?`uuid:${K}`:`id:${Y.toLowerCase()}`)),new Set):null,C=O(i,o,v,!1);if(C.added.size>0||C.removed.size>0||C.updated.size>0){const q=O(w,i,v,!1),Y=O(w,o,v,!0),K=(Z,G,J,V)=>{let H,ie,se;return G.installed?(H=V.pinned,se=V.preRelease,H&&(ie=V.version)):(H=J.pinned,se=J.preRelease,H&&(ie=J.version)),H===void 0&&(H=G.pinned,H&&(ie=G.version)),se===void 0&&(se=G.preRelease),{...V,installed:G.installed||J.installed,pinned:H,preRelease:se,version:ie??(J.version&&(!G.installed||N.gt(J.version,G.version))?J.version:G.version),state:P(G,J,w?.get(Z))}};for(const Z of Y.removed.values()){const G=i.get(Z);if(!G)continue;const J=(0,L.$jg)(w?.get(Z)),V=k&&!k.has(Z)&&J.installed;G.installed&&V?g.push(G.identifier):a.set(Z,G)}for(const Z of Y.added.values()){const G=(0,L.$jg)(o.get(Z)),J=i.get(Z);if(J){if(C.updated.has(Z)){const V=K(Z,J,G,G);I(J,G,!1,!1)||$.push(p(V,Z)),a.set(Z,V)}}else G.installed&&h.push(p(G,Z))}for(const Z of Y.updated.values()){const G=(0,L.$jg)(o.get(Z)),J=(0,L.$jg)(w?.get(Z)),V=i.get(Z);if(V)if(k&&!k.has(Z)&&J.installed&&V.installed&&!G.installed)g.push(V.identifier);else{const ie=K(Z,V,G,G);$.push(p(ie,Z)),a.set(Z,ie)}else G.installed&&h.push(p(G,Z))}for(const Z of q.added.values())Y.added.has(Z)||a.set(Z,(0,L.$jg)(i.get(Z)));for(const Z of q.updated.values()){if(Y.removed.has(Z)||Y.updated.has(Z))continue;const G=(0,L.$jg)(i.get(Z)),J=(0,L.$jg)(o.get(Z));a.set(Z,K(Z,G,J,G))}for(const Z of q.removed.values())Y.updated.has(Z)||Y.removed.has(Z)||S.has(Z)||(0,L.$jg)(o.get(Z)).installed&&k&&(k.has(Z)||!(0,L.$jg)(w?.get(Z)).installed||a.delete(Z))}const R=[],M=O(o,a,new Set,!0),T=M.added.size>0||M.updated.size>0||M.removed.size>0;return T&&a.forEach((q,Y)=>R.push(p(q,Y))),{local:{added:h,removed:g,updated:$},remote:T?{added:[...M.added].map(q=>a.get(q)),updated:[...M.updated].map(q=>a.get(q)),removed:[...M.removed].map(q=>o.get(q)),all:R}:null}}function O(l,c,b,m){const f=l?[...l.keys()].filter(t=>!b.has(t)):[],u=[...c.keys()].filter(t=>!b.has(t)),h=u.filter(t=>!f.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),g=f.filter(t=>!u.includes(t)).reduce((t,r)=>(t.add(r),t),new Set),$=new Set;for(const t of f){if(g.has(t))continue;const r=l.get(t),n=c.get(t);(!n||!I(r,n,m,!0))&&$.add(t)}return{added:h,removed:g,updated:$}}function I(l,c,b,m){return!(l.disabled!==c.disabled||!!l.isApplicationScoped!=!!c.isApplicationScoped||m&&l.installed!==c.installed||l.installed&&c.installed&&(l.preRelease!==c.preRelease||l.pinned!==c.pinned||c.pinned&&l.version!==c.version)||!E(l.state,c.state)||b&&l.version!==c.version)}function P(l,c,b){const m=l.state,f=c.state,u=b?.state;if(!c.version||m&&N.gt(l.version,c.version))return m;if(f&&N.gt(c.version,l.version)||!m)return f;if(!f)return m;const h=(0,D.$5n)(m),g=u?d(u,f):{added:Object.keys(f).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set},$=u?d(u,m):{added:Object.keys(m).reduce((t,r)=>(t.add(r),t),new Set),removed:new Set,updated:new Set};for(const t of[...g.added.values(),...g.updated.values()])h[t]=f[t];for(const t of g.removed.values())$.updated.has(t)||delete h[t];return h}function d(l,c){const b=Object.keys(l),m=Object.keys(c),f=m.filter(g=>!b.includes(g)).reduce((g,$)=>(g.add($),g),new Set),u=b.filter(g=>!m.includes(g)).reduce((g,$)=>(g.add($),g),new Set),h=new Set;for(const g of b){if(u.has(g))continue;const $=l[g],t=c[g];(0,D.$9n)($,t)||h.add(g)}return{added:f,removed:u,updated:h}}function E(l={},c={}){const{added:b,removed:m,updated:f}=d(l,c);return b.size===0&&m.size===0&&f.size===0}function y(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function p(l,c){const b={...l,identifier:{id:l.identifier.id,uuid:c.startsWith("uuid:")?c.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete b.disabled,l.installed||delete b.installed,l.state||delete b.state,l.isApplicationScoped||delete b.isApplicationScoped,b}}),define(ae[111],ce([0,1,17,21,4]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Mb=e.$7Mb=void 0,e.$7Mb=(0,L.$yi)("IIgnoredExtensionsManagementService");let A=class{constructor(I){this.a=I}hasToNeverSyncExtension(I){return this.b().includes(I.toLowerCase())}hasToAlwaysSyncExtension(I){return this.b().includes(`-${I.toLowerCase()}`)}updateIgnoredExtensions(I,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return d=d.filter(E=>E!==I&&E!==`-${I}`),P&&d.push(I.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}updateSynchronizedExtensions(I,P){let d=[...this.a.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return d=d.filter(E=>E!==I&&E!==`-${I}`),P&&d.push(`-${I.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",d.length?d:void 0,2)}getIgnoredExtensions(I){const P=I.filter(p=>p.isMachineScoped).map(p=>p.identifier.id.toLowerCase()),d=this.b().map(p=>p.toLowerCase()),E=[],y=[];if(Array.isArray(d))for(const p of d)p.startsWith("-")?y.push(p.substring(1)):E.push(p);return(0,D.$Mb)([...P,...E].filter(p=>!y.includes(p)))}b(){let I=this.a.inspect("settingsSync.ignoredExtensions").userValue;return I!==void 0||(I=this.a.inspect("sync.ignoredExtensions").userValue,I!==void 0)?I:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};e.$8Mb=A,e.$8Mb=A=ve([X(0,N.$5i)],A)}),define(ae[242],ce([0,1,17,35,30,93,79]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U_b=P;function I(g){return(0,N.$Ln)(g)||[]}async function P(g,$,t,r,n){const s=I(g),i=I($),o=t?I(t):null,a=[...s,...i,...o||[]].map(K=>K.key),w=await n.resolveUserBindings(a),S=E(s,i,o,w);if(!S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!1,hasConflicts:!1};if(!S.hasLocalForwarded&&S.hasRemoteForwarded)return{mergeContent:$,hasChanges:!0,hasConflicts:!1};if(S.hasLocalForwarded&&!S.hasRemoteForwarded)return{mergeContent:g,hasChanges:!0,hasConflicts:!1};const v=p(s),k=p(i),C=o?p(o):null,R=c(v,k,w),M=C?c(C,v,w):{added:[...v.keys()].reduce((K,Z)=>(K.add(Z),K),new Set),removed:new Set,updated:new Set},T=C?c(C,k,w):{added:[...k.keys()].reduce((K,Z)=>(K.add(Z),K),new Set),removed:new Set,updated:new Set},q=d(R,M,T);let Y=g;for(const K of q.removed.values())q.conflicts.has(K)||(Y=u(Y,K,r));for(const K of q.added.values()){if(q.conflicts.has(K))continue;const Z=k.get(K);if(Z.some(G=>G.command!==`-${K}`&&S.conflicts.has(w[G.key]))){q.conflicts.add(K);continue}Y=f(Y,Z,r)}for(const K of q.updated.values()){if(q.conflicts.has(K))continue;const Z=k.get(K);if(Z.some(G=>G.command!==`-${K}`&&S.conflicts.has(w[G.key]))){q.conflicts.add(K);continue}Y=h(Y,K,Z,r)}return{mergeContent:Y,hasChanges:!0,hasConflicts:q.conflicts.size>0}}function d(g,$,t){const r=new Set,n=new Set,s=new Set,i=new Set;for(const o of $.removed.values())t.updated.has(o)&&i.add(o);for(const o of t.removed.values())i.has(o)||($.updated.has(o)?i.add(o):n.add(o));for(const o of $.added.values())i.has(o)||t.added.has(o)&&g.updated.has(o)&&i.add(o);for(const o of t.added.values())i.has(o)||($.added.has(o)?g.updated.has(o)&&i.add(o):r.add(o));for(const o of $.updated.values())i.has(o)||t.updated.has(o)&&g.updated.has(o)&&i.add(o);for(const o of t.updated.values())i.has(o)||($.updated.has(o)?g.updated.has(o)&&i.add(o):s.add(o));return{added:r,removed:n,updated:s,conflicts:i}}function E(g,$,t,r){const n=new Set,s=y(g,r),i=y($,r),o=t?y(t,r):null,a=l(s,i);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const w=o?l(o,s):{added:[...s.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const S=o?l(o,i):{added:[...i.keys()].reduce((M,T)=>(M.add(T),M),new Set),removed:new Set,updated:new Set};if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:v,removed:k,updated:C,conflicts:R}=d(a,w,S);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:v,removed:k,updated:C,conflicts:R}}function y(g,$){const t=new Map;for(const r of g){const n=$[r.key];let s=t.get(n);s||(s=[],t.set(n,s)),s.push(r)}return t}function p(g){const $=new Map;for(const t of g){const r=t.command[0]==="-"?t.command.substring(1):t.command;let n=$.get(r);n||(n=[],$.set(r,n)),n.push(t)}return $}function l(g,$){const t=[...g.keys()],r=[...$.keys()],n=r.filter(o=>!t.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),s=t.filter(o=>!r.includes(o)).reduce((o,a)=>(o.add(a),o),new Set),i=new Set;for(const o of t){if(s.has(o))continue;const a=g.get(o).map(S=>({...S,key:o})),w=$.get(o).map(S=>({...S,key:o}));(0,D.$ub)(a,w,(S,v)=>m(S,v))||i.add(o)}return{added:n,removed:s,updated:i}}function c(g,$,t){const r=[...g.keys()],n=[...$.keys()],s=n.filter(a=>!r.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),i=r.filter(a=>!n.includes(a)).reduce((a,w)=>(a.add(w),a),new Set),o=new Set;for(const a of r){if(i.has(a))continue;const w=g.get(a).map(v=>({...v,key:t[v.key]})),S=$.get(a).map(v=>({...v,key:t[v.key]}));b(w,S)||o.add(a)}return{added:s,removed:i,updated:o}}function b(g,$){return!(!(0,D.$ub)(g.filter(({command:t})=>t[0]!=="-"),$.filter(({command:t})=>t[0]!=="-"),(t,r)=>m(t,r))||!(0,D.$ub)(g.filter(({command:t})=>t[0]==="-"),$.filter(({command:t})=>t[0]==="-"),(t,r)=>m(t,r)))}function m(g,$){if(g.command!==$.command||g.key!==$.key)return!1;const t=A.$wj.deserialize(g.when),r=A.$wj.deserialize($.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!L.$9n(g.args,$.args))}function f(g,$,t){for(const r of $)g=O.edit(g,[-1],r,t);return g}function u(g,$,t){const r=I(g);for(let n=r.length-1;n>=0;n--)(r[n].command===$||r[n].command===`-${$}`)&&(g=O.edit(g,[n],void 0,t));return g}function h(g,$,t,r){const n=I(g),s=n.findIndex(i=>i.command===$||i.command===`-${$}`);for(let i=n.length-1;i>=0;i--)(n[i].command===$||n[i].command===`-${$}`)&&(g=O.edit(g,[i],void 0,r));for(let i=t.length-1;i>=0;i--)g=O.edit(g,[s],t[i],r);return g}}),define(ae[243],ce([0,1]),function(ne,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2_b=D,e.$3_b=L;function D(A,O,I){const P={},d={},E=new Set;if(!O)return{local:{added:P,updated:d,removed:[...E.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const y=N(A,O);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{local:{added:P,updated:d,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const p=N(I,A),l=N(I,O),c={},b={},m=new Set,f=new Set;for(const u of p.removed.values())l.updated.has(u)?P[u]=O[u]:m.add(u);for(const u of l.removed.values())f.has(u)||(p.updated.has(u)?f.add(u):E.add(u));for(const u of p.updated.values())f.has(u)||(l.updated.has(u)?y.updated.has(u)&&f.add(u):b[u]=A[u]);for(const u of l.updated.values())f.has(u)||(p.updated.has(u)?y.updated.has(u)&&f.add(u):A[u]!==void 0&&(d[u]=O[u]));for(const u of p.added.values())f.has(u)||(l.added.has(u)?y.updated.has(u)&&f.add(u):c[u]=A[u]);for(const u of l.added.values())f.has(u)||(p.added.has(u)?y.updated.has(u)&&f.add(u):P[u]=O[u]);return{local:{added:P,removed:[...E.values()],updated:d},remote:{added:c,removed:[...m.values()],updated:b},conflicts:[...f.values()]}}function N(A,O){const I=A?Object.keys(A):[],P=O?Object.keys(O):[],d=P.filter(p=>!I.includes(p)).reduce((p,l)=>(p.add(l),p),new Set),E=I.filter(p=>!P.includes(p)).reduce((p,l)=>(p.add(l),p),new Set),y=new Set;for(const p of I){if(E.has(p))continue;const l=A[p],c=O[p];l!==c&&y.add(p)}return{added:d,removed:E,updated:y}}function L(A,O){const{added:I,removed:P,updated:d}=N(A,O);return I.size===0&&P.size===0&&d.size===0}}),define(ae[244],ce([0,1,30]),function(ne,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=N;function N(A,O,I,P){const d={added:[],removed:[],updated:[]};let E={added:[],removed:[],updated:[]};if(!O){const p=A.filter(({id:l})=>!P.includes(l));return p.length?E.added=p:E=null,{local:d,remote:E}}const y=L(A,O,P);if(y.added.length>0||y.removed.length>0||y.updated.length>0){const p=L(I,A,P),l=L(I,O,P);for(const c of l.removed){const b=A.find(m=>m.id===c);b&&d.removed.push(b)}for(const c of l.added){const b=O.find(m=>m.id===c);p.added.includes(c)?y.updated.includes(c)&&d.updated.push(b):d.added.push(b)}for(const c of l.updated)d.updated.push(O.find(b=>b.id===c));for(const c of p.added)l.added.includes(c)||E.added.push(A.find(b=>b.id===c));for(const c of p.updated)l.removed.includes(c)||l.updated.includes(c)||E.updated.push(A.find(b=>b.id===c));for(const c of p.removed){const b=O.find(m=>m.id===c);b&&E.removed.push(b)}}return E.added.length===0&&E.removed.length===0&&E.updated.length===0&&(E=null),{local:d,remote:E}}function L(A,O,I){A=A?A.filter(({id:l})=>!I.includes(l)):[],O=O.filter(({id:l})=>!I.includes(l));const P=A.map(({id:l})=>l),d=O.map(({id:l})=>l),E=d.filter(l=>!P.includes(l)),y=P.filter(l=>!d.includes(l)),p=[];for(const{id:l,name:c,shortName:b,icon:m,useDefaultFlags:f}of A){if(y.includes(l))continue;const u=O.find(h=>h.id===l);(!u||u.name!==c||u.shortName!==b||u.icon!==m||!(0,D.$9n)(u.useDefaultFlags,f))&&p.push(l)}return{added:E,removed:y,updated:p}}}),define(ae[25],ce([0,1,17,13,180,47,29,4,101,43]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Imb=e.$Hmb=e.$Gmb=e.$Fmb=e.$Emb=e.$Dmb=e.$Cmb=e.$Bmb=e.$Amb=e.$ymb=e.MergeState=e.Change=e.SyncStatus=e.$xmb=e.$wmb=e.$vmb=e.UserDataSyncErrorCode=e.$tmb=e.$smb=e.$rmb=e.$qmb=e.$pmb=e.$mmb=e.SyncResource=e.$jmb=e.$imb=void 0,e.$gmb=E,e.$hmb=y,e.$kmb=p,e.$lmb=l,e.$nmb=b,e.$omb=m,e.$umb=f,e.$zmb=s;function E(){const i=d.$fo.as(A.$ko.Configuration).getConfigurationProperties();return Object.keys(i).filter(o=>!!i[o].disallowSyncIgnore)}function y(){const i=d.$fo.as(A.$ko.Configuration).getConfigurationProperties(),o=Object.keys(i).filter(S=>!!i[S].ignoreSync),a=Object.keys(i).filter(S=>i[S].scope===2||i[S].scope===6),w=E();return(0,D.$Mb)([...o,...a,...w])}e.$imb="settingsSync",e.$jmb="settingsSync.keybindingsPerPlatform";function p(){const i="vscode://schemas/ignoredSettings",o=d.$fo.as(A.$ko.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{[e.$jmb]:{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:O.$Wo,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:i,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=d.$fo.as(P.$go.JSONContribution),w=()=>{const S=E(),v=y(),k=Object.keys(A.$lo.properties).filter(M=>!v.includes(M)),C=v.filter(M=>!S.includes(M)),R={items:{type:"string",enum:[...k,...C.map(M=>`-${M}`)]}};a.registerSchema(i,R)};return o.onDidUpdateConfiguration(()=>w())}function l(i){return i&&(0,N.$ag)(i)&&(0,N.$$f)(i.id)&&Array.isArray(i.scopes)}var c;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState",i.Profiles="profiles",i.WorkspaceState="workspaceState"})(c||(e.SyncResource=c={})),e.$mmb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(i,...o){return i?[i,...o]:o}function m(i,o,a,w){return w.joinPath(a.userDataSyncHome,...b(i,o,`lastSync${o}.json`))}e.$pmb=(0,I.$yi)("IUserDataSyncStoreManagementService"),e.$qmb=(0,I.$yi)("IUserDataSyncStoreService"),e.$rmb=(0,I.$yi)("IUserDataSyncLocalStoreService"),e.$smb="x-operation-id",e.$tmb="X-Execution-Id";function f(i){const o={};return o[e.$tmb]=i,o}var u;(function(i){i.Unauthorized="Unauthorized",i.Forbidden="Forbidden",i.NotFound="NotFound",i.MethodNotFound="MethodNotFound",i.Conflict="Conflict",i.Gone="Gone",i.PreconditionFailed="PreconditionFailed",i.TooLarge="TooLarge",i.UpgradeRequired="UpgradeRequired",i.PreconditionRequired="PreconditionRequired",i.TooManyRequests="RemoteTooManyRequests",i.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",i.RequestFailed="RequestFailed",i.RequestCanceled="RequestCanceled",i.RequestTimeout="RequestTimeout",i.RequestProtocolNotSupported="RequestProtocolNotSupported",i.RequestPathNotEscaped="RequestPathNotEscaped",i.RequestHeadersNotObject="RequestHeadersNotObject",i.NoCollection="NoCollection",i.NoRef="NoRef",i.EmptyResponse="EmptyResponse",i.TurnedOff="TurnedOff",i.SessionExpired="SessionExpired",i.ServiceChanged="ServiceChanged",i.DefaultServiceChanged="DefaultServiceChanged",i.LocalTooManyProfiles="LocalTooManyProfiles",i.LocalTooManyRequests="LocalTooManyRequests",i.LocalPreconditionFailed="LocalPreconditionFailed",i.LocalInvalidContent="LocalInvalidContent",i.LocalError="LocalError",i.IncompatibleLocalContent="IncompatibleLocalContent",i.IncompatibleRemoteContent="IncompatibleRemoteContent",i.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class h extends Error{constructor(o,a,w,S){super(o),this.code=a,this.resource=w,this.operationId=S,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$vmb=h;class g extends h{constructor(o,a,w,S,v){super(o,w,void 0,v),this.url=a,this.serverCode=S}}e.$wmb=g;class $ extends h{constructor(o,a){super(o,a)}}e.$xmb=$,function(i){function o(a){if(a instanceof i)return a;const w=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(w&&w[1]){const S=w[2]==="unknown"?void 0:w[2],v=w[3]==="unknown"?void 0:w[3];return new i(a.message,w[1],S,v)}return new i(a.message,"Unknown")}i.toUserDataSyncError=o}(h||(e.$vmb=h={}));var t;(function(i){i.Uninitialized="uninitialized",i.Idle="idle",i.Syncing="syncing",i.HasConflicts="hasConflicts"})(t||(e.SyncStatus=t={}));var r;(function(i){i[i.None=0]="None",i[i.Added=1]="Added",i[i.Modified=2]="Modified",i[i.Deleted=3]="Deleted"})(r||(e.Change=r={}));var n;(function(i){i.Preview="preview",i.Conflict="conflict",i.Accepted="accepted"})(n||(e.MergeState=n={})),e.$ymb="sync.store.url.type";function s(i){return`sync.enable.${i}`}e.$Amb=(0,I.$yi)("IUserDataSyncEnablementService"),e.$Bmb=(0,I.$yi)("IUserDataSyncService"),e.$Cmb=(0,I.$yi)("IUserDataSyncResourceProviderService"),e.$Dmb=(0,I.$yi)("IUserDataAutoSyncService"),e.$Emb=(0,I.$yi)("IUserDataSyncUtilService"),e.$Fmb=(0,I.$yi)("IUserDataSyncLogService"),e.$Gmb="userDataSync",e.$Hmb="vscode-userdata-sync",e.$Imb="preview"}),define(ae[245],ce([0,1,30,25]),function(ne,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mMb=L;function L(O,I,P,d,E){if(!I)return{remote:{added:Object.keys(O),removed:[],updated:[],all:Object.keys(O).length>0?O:null},local:{added:{},removed:[],updated:{}}};const y=A(O,I);if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const p=P?A(P,I):{added:Object.keys(I).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},l=P?A(P,O):{added:Object.keys(O).reduce((u,h)=>(u.add(h),u),new Set),removed:new Set,updated:new Set},c={added:{},removed:[],updated:{}},b=D.$5n(I),m=!P;for(const u of l.added.values())u!==N.$ymb&&m&&p.added.has(u)||(b[u]=O[u]);for(const u of l.updated.values())b[u]=O[u];for(const u of l.removed.values())d.unregistered.includes(u)||delete b[u];for(const u of p.added.values()){const h=I[u];if(d.machine.includes(u)){E.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(P&&l.added.has(u))continue;const g=O[u];g&&g.value===h.value||u===N.$ymb&&m&&l.added.has(u)||(g?c.updated[u]=h:c.added[u]=h)}for(const u of p.updated.values()){const h=I[u];if(d.machine.includes(u)){E.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(u)||l.removed.has(u))continue;const g=O[u];g&&g.value===h.value||(c.updated[u]=h)}for(const u of p.removed.values()){if(d.machine.includes(u)){E.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}l.updated.has(u)||l.removed.has(u)||c.removed.push(u)}const f=A(I,b);return{local:c,remote:{added:[...f.added],updated:[...f.updated],removed:[...f.removed],all:f.added.size===0&&f.removed.size===0&&f.updated.size===0?null:b}}}function A(O,I){const P=Object.keys(O),d=Object.keys(I),E=d.filter(l=>!P.includes(l)).reduce((l,c)=>(l.add(c),l),new Set),y=P.filter(l=>!d.includes(l)).reduce((l,c)=>(l.add(c),l),new Set),p=new Set;for(const l of P){if(y.has(l))continue;const c=O[l],b=I[l];D.$9n(c,b)||p.add(l)}return{added:E,removed:y,updated:p}}}),define(ae[246],ce([0,1,17,35,62,44,30,79,25]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SKb=d,e.$TKb=p,e.$UKb=l,e.$VKb=c,e.$WKb=m,e.$XKb=u;function d(a,w,S){let v=[];S?v=y(S):v=E(w);const k=[],C=[...(0,P.$gmb)()];if(Array.isArray(v))for(const R of v)R.startsWith("-")?C.push(R.substring(1)):k.push(R);return(0,D.$Mb)([...a,...k].filter(R=>!C.includes(R)))}function E(a){let w=a.inspect("settingsSync.ignoredSettings").userValue;return w!==void 0||(w=a.inspect("sync.ignoredSettings").userValue,w!==void 0)?w:a.getValue("settingsSync.ignoredSettings")||[]}function y(a){const w=(0,N.$Ln)(a);return w?w["settingsSync.ignoredSettings"]||w["sync.ignoredSettings"]||[]:[]}function p(a,w){const S=(0,N.$Ln)(a)||{};let v="{}";for(const k of Object.keys(S)){const C=(0,L.$1n)(v,[k],S[k],w);v=(0,L.$4n)(v,C)}return v}function l(a,w,S,v){if(S.length){const k=o(w),C=(0,N.$Ln)(w)||{},R=(0,N.$Ln)(a);if(!R)return a;const M=[];for(const T of S){const q=C[T],Y=R[T];q===void 0?a=I.edit(a,[T],void 0,v):Y!==void 0?a=I.edit(a,[T],q,v):M.push(t(T,k))}M.sort((T,q)=>T.startOffset-q.startOffset),M.forEach(T=>a=u(T.setting.key,w,a,v))}return a}function c(a,w,S,v,k,C){const R=l(a,w,v,C),M=S!==R,T=S!==w;if(!M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:null,remoteContent:R,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:l(w,a,v,C),remoteContent:null,hasConflicts:!1};if(S===null&&m(a)){const F=b(a,w,v)?null:l(w,a,v,C);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let q=a,Y=w;const K=(0,N.$Ln)(a),Z=(0,N.$Ln)(w),G=S?(0,N.$Ln)(S):null,J=v.reduce((F,B)=>(F.add(B),F),new Set),V=f(K,Z,J),H=f(G,K,J),ie=f(G,Z,J),se=new Map,he=new Set,ee=F=>{he.add(F);const B=k.filter(({key:U})=>U===F)[0];B?(q=I.edit(q,[F],B.value,C),Y=I.edit(Y,[F],B.value,C)):se.set(F,{key:F,localValue:K[F],remoteValue:Z[F]})};for(const F of H.removed.values())ie.updated.has(F)?ee(F):Y=I.edit(Y,[F],void 0,C);for(const F of ie.removed.values())he.has(F)||(H.updated.has(F)?ee(F):q=I.edit(q,[F],void 0,C));for(const F of H.updated.values())he.has(F)||(ie.updated.has(F)?V.updated.has(F)&&ee(F):Y=I.edit(Y,[F],K[F],C));for(const F of ie.updated.values())he.has(F)||(H.updated.has(F)?V.updated.has(F)&&ee(F):q=I.edit(q,[F],Z[F],C));for(const F of H.added.values())he.has(F)||(ie.added.has(F)?V.updated.has(F)&&ee(F):Y=u(F,q,Y,C));for(const F of ie.added.values())he.has(F)||(H.added.has(F)?V.updated.has(F)&&ee(F):q=u(F,Y,q,C));const W=se.size>0||!b(q,Y,v),z=W||!b(q,a,[]),j=W||!b(Y,w,[]);return{localContent:z?q:null,remoteContent:j?Y:null,conflictsSettings:[...se.values()],hasConflicts:W}}function b(a,w,S){if(a===w)return!0;const v=(0,N.$Ln)(a),k=(0,N.$Ln)(w),C=S.reduce((T,q)=>(T.add(q),T),new Set),R=o(a).filter(T=>!(T.setting&&C.has(T.setting.key))),M=o(w).filter(T=>!(T.setting&&C.has(T.setting.key)));if(R.length!==M.length)return!1;for(let T=0;T<R.length;T++){const q=R[T],Y=M[T];if(q.setting&&Y.setting){if(q.setting.key!==Y.setting.key||!O.$9n(v[q.setting.key],k[q.setting.key]))return!1}else if(!q.setting&&!Y.setting){if(q.value!==Y.value)return!1}else return!1}return!0}function m(a){return a?o(a).length===0:!0}function f(a,w,S){const v=a?Object.keys(a).filter(T=>!S.has(T)):[],k=Object.keys(w).filter(T=>!S.has(T)),C=k.filter(T=>!v.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),R=v.filter(T=>!k.includes(T)).reduce((T,q)=>(T.add(q),T),new Set),M=new Set;if(a)for(const T of v){if(R.has(T))continue;const q=a[T],Y=w[T];O.$9n(q,Y)||M.add(T)}return{added:C,removed:R,updated:M}}function u(a,w,S,v){const k=(0,N.$Ln)(w),C=o(w),R=o(S),M=h(a,C,R);return g(S,a,k[a],M,R,v)}function h(a,w,S){const v=w.findIndex(C=>C.setting?.key===a),k=w[v-1];if(k){if(k.setting){const R=t(k.setting.key,S);if(R)return{index:S.indexOf(R),insertAfter:!0}}else{const R=r(v,w);if(R){const M=t(R.setting.key,S);if(M){const T=n(S.indexOf(M),S),q=s(w,R,w[v]);if(T){const Y=s(S,M,T),K=i(q,Y);return K?{index:S.indexOf(K),insertAfter:!0}:{index:S.indexOf(T),insertAfter:!1}}else{const Y=s(S,M,S[S.length-1]),K=i(q,Y);return K?{index:S.indexOf(K),insertAfter:!0}:{index:S.length-1,insertAfter:!0}}}}}const C=w[v+1];if(C)if(C.setting){const R=t(C.setting.key,S);if(R)return{index:S.indexOf(R),insertAfter:!1}}else{const R=n(v,w);if(R){const M=t(R.setting.key,S);if(M){const T=r(S.indexOf(M),S),q=s(w,w[v],R);if(T){const Y=s(S,T,M),K=i(q.reverse(),Y.reverse());return K?{index:S.indexOf(K),insertAfter:!1}:{index:S.indexOf(T),insertAfter:!0}}else{const Y=s(S,S[0],M),K=i(q.reverse(),Y.reverse());return K?{index:S.indexOf(K),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:S.length-1,insertAfter:!0}}function g(a,w,S,v,k,C){let R;return v.index===-1?R=(0,L.$1n)(a,[w],S,C):R=$(a,w,S,v,k,C).map(M=>(0,L.$2n)(a,M,C)[0]),(0,L.$4n)(a,R)}function $(a,w,S,v,k,C){const R=`${JSON.stringify(w)}: ${JSON.stringify(S)}`,M=(0,A.$Xn)(C,a),T=k[v.index];if(v.insertAfter){const q=[];if(T.setting)q.push({offset:T.endOffset,length:0,content:","+R});else{const Y=n(v.index,k),K=r(v.index,k),Z=K?.setting?.commaOffset;K&&Z===void 0&&q.push({offset:K.endOffset,length:0,content:","});const G=Z!==void 0&&Z>T.endOffset;q.push({offset:G?Z+1:T.endOffset,length:0,content:Y?M+R+",":M+R})}return q}else{if(T.setting)return[{offset:T.startOffset,length:0,content:R+","}];const q=(k[v.index-1]&&!k[v.index-1].setting?M:"")+R+(n(v.index,k)?",":"")+M;return[{offset:T.startOffset,length:0,content:q}]}}function t(a,w){return w.filter(S=>S.setting?.key===a)[0]}function r(a,w){for(let S=a-1;S>=0;S--)if(w[S].setting)return w[S]}function n(a,w){for(let S=a+1;S<w.length;S++)if(w[S].setting)return w[S]}function s(a,w,S){const v=a.indexOf(w),k=a.indexOf(S);return a.filter((C,R)=>v<R&&R<k)}function i(a,w){if(a.length&&w.length){let S=0;for(;S<w.length&&S<a.length;S++)if(a[S].value!==w[S].value)return w[S-1];return w[S-1]}}function o(a){const w=[];let S=-1,v,k;const C={onObjectBegin:R=>{S++},onObjectProperty:(R,M,T)=>{S===0&&(v=M,k=R)},onObjectEnd:(R,M)=>{S--,S===0&&w.push({startOffset:v,endOffset:R+M,value:a.substring(v,R+M),setting:{key:k,commaOffset:void 0}})},onArrayBegin:(R,M)=>{S++},onArrayEnd:(R,M)=>{S--,S===0&&w.push({startOffset:v,endOffset:R+M,value:a.substring(v,R+M),setting:{key:k,commaOffset:void 0}})},onLiteralValue:(R,M,T)=>{S===0&&w.push({startOffset:v,endOffset:M+T,value:a.substring(v,M+T),setting:{key:k,commaOffset:void 0}})},onSeparator:(R,M,T)=>{if(S===0&&R===","){let q=w.length-1;for(;q>=0&&!w[q].setting;q--);const Y=w[q];Y&&w.splice(q,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:M}})}},onComment:(R,M)=>{S===0&&w.push({startOffset:R,endOffset:R+M,value:a.substring(R,R+M)})}};return(0,N.$Sn)(a,C),w}}),define(ae[80],ce([0,1,3,2,4,25]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BKb=e.$AKb=void 0,e.$AKb=(0,L.$yi)("IUserDataSyncAccountService");let O=class extends N.$Uc{get account(){return this.a}constructor(P,d){super(),this.g=P,this.h=d,this.b=this.B(new D.$fe),this.onDidChangeAccount=this.b.event,this.c=this.B(new D.$fe),this.onTokenFailed=this.c.event,this.f=!1,this.B(P.onTokenFailed(E=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,E),this.updateAccount(void 0),E==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(P.onTokenSucceed(()=>this.f=!1))}async updateAccount(P){(P&&this.a?P.token!==this.a.token||P.authenticationProviderId!==this.a.authenticationProviderId:P!==this.a)&&(this.a=P,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(P))}};e.$BKb=O,e.$BKb=O=ve([X(0,A.$qmb),X(1,A.$Fmb)],O)}),define(ae[247],ce([0,1,20,181,16,9,25]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Mb=void 0;let I=class extends A.$0j{constructor(d,E){super(),this.g=this.B(d.createLogger((0,D.$_g)(E.logsHome,`${O.$Gmb}.log`),{id:O.$Gmb,name:(0,N.localize)(0,null)}))}trace(d,...E){this.g.trace(d,...E)}debug(d,...E){this.g.debug(d,...E)}info(d,...E){this.g.info(d,...E)}warn(d,...E){this.g.warn(d,...E)}error(d,...E){this.g.error(d,...E)}flush(){this.g.flush()}};e.$9Mb=I,e.$9Mb=I=ve([X(0,A.$6j),X(1,L.$Fi)],I)}),define(ae[248],ce([0,1,6,3,2]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=void 0;class A extends L.$Uc{constructor({onDidOpenMainWindow:I,onDidFocusMainWindow:P,getActiveWindowId:d}){super(),this.a=this.B(new L.$Tc),N.Event.latch(N.Event.any(I,P))(this.f,this,this.a),this.b=(0,D.$lh)(()=>d()),(async()=>{try{const y=await this.b;this.c=typeof this.c=="number"?this.c:y}catch{}finally{this.b=void 0}})()}f(I){this.b&&(this.b.cancel(),this.b=void 0),this.c=I}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$8dc=A}),define(ae[112],ce([0,1,184,14,51,20,8,4,23]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=d,e.$Ji=E,e.$Mi=y,e.$Ni=p,e.$Oi=l,e.$Pi=b,e.$Qi=m,e.$Ti=h,e.$Yi=g,e.$Zi=$,e.$2i=t,e.$3i=r,e.$4i=n,e.$Hi=(0,I.$yi)("contextService");function d(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.uri)}function E(s){return typeof s?.id=="string"&&!d(s)&&!p(s)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function y(s,i){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,N.$nc)(s)}:i?e.$Ki:e.$Li;const o=s;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function p(s){const i=s;return typeof i?.id=="string"&&O.URI.isUri(i.configPath)}function l(s){const i=s;if(i?.uri)return{id:i.id,uri:O.URI.revive(i.uri)};const o=s;if(o?.configPath)return{id:o.id,configPath:O.URI.revive(o.configPath)};if(s?.id)return{id:s.id}}var c;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(c||(e.WorkbenchState=c={}));function b(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}function m(s){const i=s;return!!(i&&typeof i=="object"&&O.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}class f{constructor(i,o,a,w,S){this.h=i,this.j=a,this.k=w,this.l=S,this.c=L.$Ei.forUris(this.l,()=>!0),this.folders=o}update(i){this.h=i.id,this.k=i.configuration,this.j=i.transient,this.l=i.l,this.folders=i.folders}get folders(){return this.g}set folders(i){this.g=i,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(i){this.k=i}getFolder(i){return i&&this.c.findSubstr(i)||null}n(){this.c=L.$Ei.forUris(this.l,()=>!0);for(const i of this.folders)this.c.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=f;class u{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,A.$_g)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=u;function h(s){return new u({uri:s,index:0,name:(0,A.$8g)(s)},{uri:s.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,D.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function g(s,i){return A.$3g.isEqualOrParent(s,i.untitledWorkspacesHome)}function $(s){let i;return O.URI.isUri(s)?i=s:i=s.configuration,i?.scheme===P.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(s){return s.id===e.$1i}function r(s,i){return!g(s,i)&&!$(s)}function n(s){return(typeof s=="string"?(0,N.$oc)(s):(0,A.$0g)(s))===e.$Vi}}),define(ae[18],ce([0,1,54,3,2,20,8,175,16,12,4,9,112,34,28,6,32,27,13]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=g,e.$Fl=$,e.$Gl=t;var h;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function g(s){const i=s;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&O.URI.isUri(i.location)&&O.URI.isUri(i.globalStorageHome)&&O.URI.isUri(i.settingsResource)&&O.URI.isUri(i.keybindingsResource)&&O.URI.isUri(i.tasksResource)&&O.URI.isUri(i.snippetsHome)&&O.URI.isUri(i.extensionsResource))}e.$El=(0,E.$yi)("IUserDataProfilesService");function $(s,i){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:O.URI.revive(s.location).with({scheme:i}),globalStorageHome:O.URI.revive(s.globalStorageHome).with({scheme:i}),settingsResource:O.URI.revive(s.settingsResource).with({scheme:i}),keybindingsResource:O.URI.revive(s.keybindingsResource).with({scheme:i}),tasksResource:O.URI.revive(s.tasksResource).with({scheme:i}),snippetsHome:O.URI.revive(s.snippetsHome).with({scheme:i}),extensionsResource:O.URI.revive(s.extensionsResource).with({scheme:i}),cacheHome:O.URI.revive(s.cacheHome).with({scheme:i}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}function t(s,i,o,a,w,S){return{id:s,name:i,location:o,isDefault:!1,shortName:w?.shortName,icon:w?.icon,globalStorageHome:S&&w?.useDefaultFlags?.globalState?S.globalStorageHome:(0,A.$_g)(o,"globalStorage"),settingsResource:S&&w?.useDefaultFlags?.settings?S.settingsResource:(0,A.$_g)(o,"settings.json"),keybindingsResource:S&&w?.useDefaultFlags?.keybindings?S.keybindingsResource:(0,A.$_g)(o,"keybindings.json"),tasksResource:S&&w?.useDefaultFlags?.tasks?S.tasksResource:(0,A.$_g)(o,"tasks.json"),snippetsHome:S&&w?.useDefaultFlags?.snippets?S.snippetsHome:(0,A.$_g)(o,"snippets"),extensionsResource:S&&w?.useDefaultFlags?.extensions?S.extensionsResource:(0,A.$_g)(o,"extensions.json"),cacheHome:(0,A.$_g)(a,s),useDefaultFlags:w?.useDefaultFlags,isTransient:w?.transient}}let r=class extends L.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(i,o,a,w){super(),this.t=i,this.u=o,this.w=a,this.y=w,this.f=!0,this.h=this.B(new N.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(i){this.f!==i&&(this.z=void 0,this.f=i)}isEnabled(){return this.f}get C(){if(!this.z){const i=this.D(),o=[i];if(this.f)try{for(const S of this.O()){if(!S.name||!(0,u.$$f)(S.name)||!S.location){this.y.warn("Skipping the invalid stored profile",S.location||S.name);continue}o.push(t((0,A.$9g)(S.location),S.name,S.location,this.g,{shortName:S.shortName,icon:S.icon,useDefaultFlags:S.useDefaultFlags},i))}}catch(S){this.y.error(S)}const a=new l.$Ac,w=new Map;if(o.length)try{const S=this.Q();if(S.workspaces)for(const[v,k]of Object.entries(S.workspaces)){const C=O.URI.parse(v),R=o.find(M=>M.id===k);R&&a.set(C,R)}if(S.emptyWindows)for(const[v,k]of Object.entries(S.emptyWindows)){const C=o.find(R=>R.id===k);C&&w.set(v,C)}}catch(S){this.y.error(S)}this.z={profiles:o,workspaces:a,emptyWindows:w}}return this.z}D(){const i=t("__default__profile__",(0,I.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...i,extensionsResource:this.S()??i.extensionsResource,isDefault:!0}}async createTransientProfile(i){const o="Temp",a=new RegExp(`${(0,f.$bf)(o)}\\s(\\d+)`);let w=0;for(const v of this.profiles){const k=a.exec(v.name),C=k?parseInt(k[1]):0;w=C>w?C:w}const S=`${o} ${w+1}`;return this.createProfile((0,D.$mj)((0,m.$Ug)()).toString(16),S,{transient:!0},i)}async createNamedProfile(i,o,a){return this.createProfile((0,D.$mj)((0,m.$Ug)()).toString(16),i,o,a)}async createProfile(i,o,a,w){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const S=await this.F(i,o,a);return w&&await this.setProfileForWorkspace(w,S),S}async F(i,o,a){if(!(0,u.$$f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let w=this.r.get(o);return w||(w=(async()=>{try{if(this.profiles.find(C=>C.name===o||C.id===i))throw new Error(`Profile with ${o} name already exists`);const v=t(i,o,(0,A.$_g)(this.profilesHome,i),this.g,a,this.defaultProfile);await this.u.createFolder(v.location);const k=[];return this.j.fire({profile:v,join(C){k.push(C)}}),await b.Promises.settled(k),this.I([v],[],[]),v}finally{this.r.delete(o)}})(),this.r.set(o,w)),w}async updateProfile(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(w=>w.id===i.id);if(!a)throw new Error(`Profile '${i.name}' does not exist`);return a=t(a.id,o.name??a.name,a.location,this.g,{shortName:o.shortName??a.shortName,icon:o.icon===null?void 0:o.icon??a.icon,transient:o.transient??a.isTransient,useDefaultFlags:o.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(w=>w.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);const a=[];this.m.fire({profile:o,join(w){a.push(w)}});try{await Promise.allSettled(a)}catch(w){this.y.error(w)}for(const w of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(w)?.id&&this.C.emptyWindows.delete(w);for(const w of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(w)?.id&&this.C.workspaces.delete(w);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(w){(0,d.$jl)(w)!==1&&this.y.error(w)}}async setProfileForWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(w=>w.id===o.id);if(!a)throw new Error(`Profile '${o.name}' does not exist`);this.L(i,a)}unsetWorkspace(i,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(i,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const i=await this.u.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(o=>o.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(i.map(o=>this.removeProfile(o)))}getProfileForWorkspace(i){const o=this.G(i);return O.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(i){return(0,p.$Ii)(i)?i.uri:(0,p.$Ni)(i)?i.configPath:i.id}H(i){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,i.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,i.location)))}I(i,o,a){const w=[...this.profiles,...i],S=[];this.s.profiles=[];for(let v of w)v.isDefault||o.some(k=>v.id===k.id)||(v=a.find(k=>v.id===k.id)??v,v.isTransient?this.s.profiles.push(v):S.push({location:v.location,name:v.name,shortName:v.shortName,icon:v.icon,useDefaultFlags:v.useDefaultFlags}));this.P(S),this.z=void 0,this.J(i,o,a)}J(i,o,a){this.h.fire({added:i,removed:o,updated:a,all:this.profiles})}L(i,o,a){a=o?.isTransient?!0:a,a||this.L(i,void 0,!0);const w=this.G(i),S=a?this.s:this.C;O.URI.isUri(w)?(S.workspaces.delete(w),o&&S.workspaces.set(w,o)):(S.emptyWindows.delete(w),o&&S.emptyWindows.set(w,o)),a||this.M()}M(){const i={};for(const[a,w]of this.C.workspaces.entries())i[a.toString()]=w.id;const o={};for(const[a,w]of this.C.emptyWindows.entries())o[a.toString()]=w.id;this.R({workspaces:i,emptyWindows:o}),this.z=void 0}N(i){const o={},a=this.D();if(i.workspaces)for(const[S,v]of Object.entries(i.workspaces)){const k=O.URI.parse(v);o[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}const w={};if(i.emptyWindows)for(const[S,v]of Object.entries(i.emptyWindows)){const k=O.URI.parse(v);w[S]=this.w.extUri.isEqual(k,a.location)?a.id:this.w.extUri.basename(k)}return{workspaces:o,emptyWindows:w}}O(){return[]}P(i){throw new Error("not implemented")}Q(){return{}}R(i){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=ve([X(0,P.$Fi),X(1,d.$5k),X(2,c.$Cl),X(3,y.$5j)],r);class n extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(i){this.a=i}Q(){return this.X}R(i){this.X=i}}e.$Il=n}),define(ae[249],ce([0,1,6,2,18]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hfc=void 0;let A=class extends N.$Uc{constructor(I){super(),this.B(new D.$Kh(()=>{I.cleanUp()},10*1e3)).schedule()}};e.$hfc=A,e.$hfc=A=ve([X(0,L.$El)],A)}),define(ae[113],ce([0,1,17,6,26,7,3,2,5,13,8,157,29,33,48,9,24,22,28,18]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=void 0,e.$qq=$;let g=class extends I.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,i,o,a,w,S){super(),this.z=s,this.C=i,this.D=o,this.F=a,this.G=w,this.H=S,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new O.$fe),this.s=this.B(new O.$fe),this.t=this.B(new O.$fe),this.u=this.B(new O.$fe),this.w=this.B(new O.$fe),this.y=[],this.B((0,I.$Sc)(()=>{this.j.forEach(({task:v})=>v.cancel()),this.m.forEach(v=>v.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const i=await this.getTargetPlatform();return s.allTargetPlatforms.some(o=>(0,p.$8o)(o,s.allTargetPlatforms,i))}async installFromGallery(s,i={}){try{const a=(await this.installGalleryExtensions([{extension:s,options:i}])).find(({identifier:w})=>(0,l.$yp)(w,s.identifier));if(a?.local)return a?.local;throw a?.error?a.error:new p.$_o(`Unknown error while installing extension ${s.identifier.id}`,"Unknown")}catch(o){throw $(o)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new p.$_o(y.localize(0,null),"NotAllowed");const i=[],o=[];return await Promise.allSettled(s.map(async({extension:a,options:w})=>{try{const S=await this.N(a,!!w?.installGivenVersion,!!w?.installPreReleaseVersion,w.productVersion??{version:this.G.version,date:this.G.date});o.push({...S,options:w})}catch(S){i.push({identifier:a.identifier,operation:2,source:a,error:S})}})),o.length&&i.push(...await this.I(o)),i}async uninstall(s,i={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.P(s,i)}async toggleAppliationScope(s,i){if((0,c.$Wm)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let o=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)||(o=await this.$(s,this.H.defaultProfile.extensionsResource,i));for(const a of this.H.profiles){const w=(await this.getInstalled(1,a.extensionsResource)).find(S=>(0,l.$yp)(S.identifier,s.identifier));w?this.w.fire(w):this.u.fire({identifier:s.identifier,profileLocation:a.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(i,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(s,i,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.W(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const i=new Map,o=new Map,a=[],w=(v,k)=>`${l.$zp.create(v).toString()}-${k.toString()}`,S=(v,k,C,R)=>{const M=this.Y(v,k,C),T=`${(0,l.$Dp)(v.publisher,v.name)}-${C.profileLocation.toString()}`;o.set(T,{task:M,root:R}),this.n.fire({identifier:M.identifier,source:k,profileLocation:C.profileLocation}),this.F.info("Installing extension:",M.identifier.id),E.URI.isUri(k)||this.j.set(w(k,C.profileLocation),{task:M,waitingTasks:[]})};try{for(const{manifest:v,extension:k,options:C}of s){const R=C.isApplicationScoped||C.isBuiltin||(0,c.$Wm)(v),M={...C,installOnlyNewlyAddedFromExtensionPack:C.installOnlyNewlyAddedFromExtensionPack??!E.URI.isUri(k),isApplicationScoped:R,profileLocation:R?this.H.defaultProfile.extensionsResource:C.profileLocation??this.X(),productVersion:C.productVersion??{version:this.G.version,date:this.G.date}},T=E.URI.isUri(k)?void 0:this.j.get(w(k,M.profileLocation));T?(this.F.info("Extension is already requested to install",T.task.identifier.id),a.push(T.task.waitUntilTaskIsFinished())):S(v,k,M,void 0)}return await Promise.all([...o.values()].map(async({task:v})=>{if(v.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",v.identifier.id);else try{const k=await this.M(v.identifier,v.manifest,!!v.options.installOnlyNewlyAddedFromExtensionPack,!!v.options.installPreReleaseVersion,v.options.profileLocation,v.options.productVersion),C=await this.getInstalled(void 0,v.options.profileLocation,v.options.productVersion),R={...v.options,context:{...v.options.context,[p.$2o]:!0}};for(const{gallery:M,manifest:T}of(0,D.$Mb)(k,({gallery:q})=>q.identifier.id)){if(o.has(`${M.identifier.id.toLowerCase()}-${R.profileLocation.toString()}`))continue;const q=this.j.get(w(M,R.profileLocation));if(q){if(this.J(v,q.task)){const Y=q.task.identifier;this.F.info("Waiting for already requested installing extension",Y.id,v.identifier.id),q.waitingTasks.push(v),a.push(O.Event.toPromise(O.Event.filter(this.onDidInstallExtensions,K=>K.some(Z=>(0,l.$yp)(Z.identifier,Y)))).then(K=>{if(this.F.info("Finished waiting for already requested installing extension",Y.id,v.identifier.id),!K.find(G=>(0,l.$yp)(G.identifier,Y))?.local)throw new Error(`Extension ${Y.id} is not installed`)}))}}else C.some(({identifier:Y})=>(0,l.$yp)(Y,M.identifier))||S(T,M,R,v)}}catch(k){if(E.URI.isUri(v.source))(0,D.$Lb)(v.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",v.identifier.id,k.message),(0,D.$Lb)(v.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",v.identifier.id,k.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",v.identifier.id),k}})),await this.L([...o.entries()].map(async([v,{task:k}])=>{const C=new Date().getTime();let R;try{R=await k.run(),await this.L(this.y.map(M=>M.postInstall(R,k.source,k.options,L.CancellationToken.None)),"PostInstall")}catch(M){const T=$(M);throw E.URI.isUri(k.source)||t(this.C,k.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Gp)(k.source),error:T,source:k.options.context?.[p.$1o]}),i.set(v,{error:T,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:k.options.isApplicationScoped}),this.F.error("Error while installing the extension",k.identifier.id,(0,A.$0)(T)),T}if(!E.URI.isUri(k.source)){const M=k.operation===3,T=M?void 0:(new Date().getTime()-k.source.lastUpdated)/1e3;if(t(this.C,M?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$Gp)(k.source),verificationStatus:k.verificationStatus,duration:new Date().getTime()-C,durationSinceUpdate:T,source:k.options.context?.[p.$1o]}),P.$o&&k.operation!==3)try{await this.z.reportStatistic(R.manifest.publisher,R.manifest.name,R.manifest.version,"install")}catch{}}i.set(v,{local:R,identifier:k.identifier,operation:k.operation,source:k.source,context:k.options.context,profileLocation:k.profileLocation,applicationScoped:R.isApplicationScoped})})),a.length&&await this.L(a),[...i.values()]}catch(v){const k=(M,T,q)=>{const Y=[];M.manifest.extensionDependencies?.length&&Y.push(...M.manifest.extensionDependencies),M.manifest.extensionPack?.length&&Y.push(...M.manifest.extensionPack);for(const K of Y){if(q.includes(K.toLowerCase()))continue;q.push(K.toLowerCase());const Z=i.get(`${K.toLowerCase()}-${T.toString()}`);Z?.local&&(q=k(Z.local,T,q))}return q},C=M=>({identifier:M.identifier,operation:2,source:M.source,context:M.options.context,profileLocation:M.profileLocation,error:v}),R=[];for(const[M,{task:T,root:q}]of o){const Y=i.get(M);Y?Y.local&&q&&!i.get(`${q.identifier.id.toLowerCase()}-${T.profileLocation.toString()}`)?.local&&(R.push(this.Z(Y.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(M,C(T))):(T.cancel(),i.set(M,C(T)))}for(const[M,{task:T}]of o){const q=i.get(M);if(!q?.local||T.options.donotIncludePackAndDependencies)continue;k(q.local,T.profileLocation,[q.local.identifier.id.toLowerCase()]).slice(1).some(K=>o.has(`${K.toLowerCase()}-${T.profileLocation.toString()}`)&&!i.get(`${K.toLowerCase()}-${T.profileLocation.toString()}`)?.local)&&(R.push(this.Z(q.local,{versionOnly:!0,profileLocation:T.profileLocation})),i.set(M,C(T)))}throw R.length&&await Promise.allSettled(R.map(async M=>{try{await M.run(),this.F.info("Rollback: Uninstalled extension",M.extension.identifier.id)}catch(T){this.F.warn("Rollback: Error while uninstalling extension",M.extension.identifier.id,(0,A.$0)(T))}})),v}finally{for(const{task:v}of o.values())v.source&&!E.URI.isUri(v.source)&&this.j.delete(w(v.source,v.profileLocation));if(i.size){const v=[...i.values()];for(const k of v)k.local&&this.F.info("Extension installed successfully:",k.identifier.id);this.s.fire(v)}}}J(s,i){for(const[,{task:o,waitingTasks:a}]of this.j.entries())if(o===s&&(a.includes(i)||a.some(w=>this.J(w,i)))||o===i&&a[0]&&!this.J(s,a[0]))return!1;return!0}async L(s,i){const o=[],a=[],w=await Promise.allSettled(s);for(const v of w)v.status==="fulfilled"?o.push(v.value):a.push($(v.reason,i));if(!a.length)return o;if(a.length===1)throw a[0];let S=new p.$_o("","Unknown");for(const v of a)S=new p.$_o(S.message?`${S.message}, ${v.message}`:v.message,v.code!=="Unknown"&&v.code!=="Internal"?v.code:S.code);throw S}async M(s,i,o,a,w,S){if(!this.z.isEnabled())return[];const v=await this.getInstalled(void 0,w,S),k=[],C=[],R=async(M,T)=>{k.push(M);const q=T.extensionDependencies||[],Y=[...q];if(T.extensionPack){const K=o?v.find(Z=>(0,l.$yp)(Z.identifier,M)):void 0;for(const Z of T.extensionPack)K&&K.manifest.extensionPack&&K.manifest.extensionPack.some(G=>(0,l.$yp)({id:G},{id:Z}))||Y.every(G=>!(0,l.$yp)({id:G},{id:Z}))&&Y.push(Z)}if(Y.length){const K=Y.filter(Z=>k.every(G=>!(0,l.$yp)(G,{id:Z})));if(K.length){const Z=await this.z.getExtensions(K.map(G=>({id:G,preRelease:a})),L.CancellationToken.None);for(const G of Z){if(k.find(H=>(0,l.$yp)(H,G.identifier)))continue;const J=q.some(H=>(0,l.$yp)({id:H},G.identifier));let V;try{V=await this.N(G,!1,a,S)}catch(H){if(J)throw H;this.F.info("Skipping the packed extension as it cannot be installed",G.identifier.id,(0,A.$0)(H));continue}C.push({gallery:V.extension,manifest:V.manifest}),await R(V.extension.identifier,V.manifest)}}}};return await R(s,i),C}async N(s,i,o,a){let w;const S=await this.getExtensionsControlManifest();if(S.malicious.some(C=>(0,l.$yp)(s.identifier,C)))throw new p.$_o(y.localize(1,null,s.identifier.id),"Malicious");const v=S.deprecated[s.identifier.id.toLowerCase()];if(v?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${v.extension.id}' extension instead.`),w=(await this.z.getExtensions([{id:v.extension.id,preRelease:v.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:a},L.CancellationToken.None))[0],!w)throw new p.$_o(y.localize(2,null,s.identifier.id,v.extension.id),"Deprecated")}else{if(!await this.canInstall(s)){const C=await this.getTargetPlatform();throw new p.$_o(y.localize(3,null,s.identifier.id,this.G.nameLong,(0,p.$4o)(C)),"IncompatibleTargetPlatform")}if(w=await this.O(s,i,o,a),!w)throw!o&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],L.CancellationToken.None))[0]?new p.$_o(y.localize(4,null,s.displayName??s.identifier.id),"ReleaseVersionNotFound"):new p.$_o(y.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",w.identifier.id);const k=await this.z.getManifest(w,L.CancellationToken.None);if(k===null)throw new p.$_o(`Missing manifest for extension ${w.identifier.id}`,"Invalid");if(k.version!==w.version)throw new p.$_o(`Cannot install '${w.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:w,manifest:k}}async O(s,i,o,a){const w=await this.getTargetPlatform();let S=null;return!i&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==o&&(S=(await this.z.getExtensions([{...s.identifier,preRelease:o}],{targetPlatform:w,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null),!S&&await this.z.isExtensionCompatible(s,o,w,a)&&(S=s),S||(i?S=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:w,compatible:!0,productVersion:a},L.CancellationToken.None))[0]||null:S=await this.z.getCompatibleExtension(s,o,w,a)),S}async P(s,i){const o={...i,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:i.profileLocation??this.X()},a=R=>`${R.id.toLowerCase()}${o.versionOnly?`-${s.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,w=this.m.get(a(s.identifier));if(w)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),w.waitUntilTaskIsFinished();const S=R=>{const M=this.Z(R,o);return this.m.set(a(M.extension.identifier),M),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${R.identifier.id}@${R.manifest.version}`),this.t.fire({identifier:R.identifier,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped}),M},v=(R,M)=>{M?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${R.identifier.id}@${R.manifest.version}`,M.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${R.identifier.id}@${R.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${R.identifier.id}@${R.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$Fp)(R),error:M}),this.u.fire({identifier:R.identifier,error:M?.code,profileLocation:o.profileLocation,applicationScoped:R.isApplicationScoped})},k=[],C=[];try{k.push(S(s));const R=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const M=this.S(s,R);for(const T of M)this.m.has(a(T.identifier))?this.F.info("Extensions is already requested to uninstall",T.identifier.id):k.push(S(T))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.Q(k.map(M=>M.extension),R,s),await this.L(k.map(async M=>{try{if(await M.run(),await this.L(this.y.map(T=>T.postUninstall(M.extension,o,L.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}v(M.extension)}catch(T){const q=$(T);throw v(M.extension,q),q}finally{C.push(M)}}))}catch(R){const M=$(R);for(const T of k){try{T.cancel()}catch{}C.includes(T)||v(T.extension,M)}throw M}finally{for(const R of k)this.m.delete(a(R.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",R.extension.identifier.id)}}Q(s,i,o){for(const a of s){const w=this.U(a,i);if(w.length){const S=w.filter(v=>!s.some(k=>(0,l.$yp)(k.identifier,v.identifier)));if(S.length)throw new Error(this.R(a,S,o))}}}R(s,i,o){return o===s?i.length===1?y.localize(6,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(7,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?y.localize(9,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?y.localize(10,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):y.localize(11,null,o.manifest.displayName||o.manifest.name,s.manifest.displayName||s.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}S(s,i,o=[]){if(o.indexOf(s)!==-1)return[];o.push(s);const a=s.manifest.extensionPack?s.manifest.extensionPack:[];if(a.length){const w=i.filter(v=>!v.isBuiltin&&a.some(k=>(0,l.$yp)({id:k},v.identifier))),S=[];for(const v of w)S.push(...this.S(v,i,o));return[...w,...S]}return[]}U(s,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(a=>(0,l.$yp)({id:a},s.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(s){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,A.$0)(s)),{malicious:[],deprecated:{},search:[]}}}};e.$pq=g,e.$pq=g=ve([X(0,p.$0o),X(1,f.$4l),X(2,u.$Cl),X(3,b.$5j),X(4,m.$lk),X(5,h.$El)],g);function $(n,s){if(n instanceof p.$_o)return n;let i;return n instanceof p.$$o?i=new p.$_o(n.message,n.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):i=new p.$_o(n.message,(0,A.$4)(n)?"Cancelled":s??"Internal"),i.stack=n.stack,i}function t(n,s,{extensionData:i,verificationStatus:o,duration:a,error:w,source:S,durationSinceUpdate:v}){let k,C;(0,d.$gg)(o)&&(o===!0?o="Verified":(o===!1||(k="Signature",C=o),o="Unverified")),w&&(k=w.code,w.code==="Signature"&&(C=w.message)),n.publicLog(s,{...i,verificationStatus:o,success:!w,duration:a,errorcode:k,errorcodeDetail:C,durationSinceUpdate:v,source:S})}class r{constructor(){this.d=new N.$xh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,N.$lh)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.$lh)(s=>new Promise((i,o)=>{const a=s.onCancellationRequested(()=>{a.dispose(),o(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$rq=r}),define(ae[52],ce([0,1,6,15,2,3,34,8,29,33,12,4,9,18,28,13,7,22]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class h extends Error{constructor(n,s){super(n),this.code=s}}e.$sq=h,e.$tq=(0,y.$yi)("IExtensionsProfileScannerService");let g=class extends L.$Uc{constructor(n,s,i,o,a,w){super(),this.j=n,this.m=s,this.n=i,this.r=o,this.s=a,this.t=w,this.b=this.B(new A.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new A.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new O.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s,i){const o=[],a=[];try{return await this.u(s,w=>{const S=[];if(i)S.push(...w);else for(const v of w)n.some(([k])=>(0,d.$yp)(k.identifier,v.identifier)&&k.manifest.version!==v.version)?o.push(v):S.push(v);for(const[v,k]of n){const C=S.findIndex(M=>(0,d.$yp)(M.identifier,v.identifier)&&M.version===v.manifest.version),R={identifier:v.identifier,version:v.manifest.version,location:v.location,metadata:k};C===-1?(a.push(R),S.push(R)):S.splice(C,1,R)}return a.length&&this.b.fire({extensions:a,profileLocation:s}),o.length&&this.f.fire({extensions:o,profileLocation:s}),S}),a.length&&this.c.fire({extensions:a,profileLocation:s}),o.length&&this.g.fire({extensions:o,profileLocation:s}),a}catch(w){throw a.length&&this.c.fire({extensions:a,error:w,profileLocation:s}),o.length&&this.g.fire({extensions:o,error:w,profileLocation:s}),w}}async updateMetadata(n,s){const i=[];return await this.u(s,o=>{const a=[];for(const w of o){const S=n.find(([v])=>(0,d.$yp)(v.identifier,w.identifier)&&v.manifest.version===w.version);S&&(w.metadata={...w.metadata,...S[1]},i.push(w)),a.push(w)}return a}),i}async removeExtensionFromProfile(n,s){const i=[];try{await this.u(s,o=>{const a=[];for(const w of o)(0,d.$yp)(w.identifier,n.identifier)?i.push(w):a.push(w);return i.length&&this.f.fire({extensions:i,profileLocation:s}),a}),i.length&&this.g.fire({extensions:i,profileLocation:s})}catch(o){throw i.length&&this.g.fire({extensions:i,error:o,profileLocation:s}),o}}async u(n,s,i){return this.F(n).queue(async()=>{let o=[],a;try{const w=await this.m.readFile(n);a=JSON.parse(w.value.toString().trim()||"[]")}catch(w){if((0,E.$jl)(w)!==1)throw w;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&i?.bailOutWhenFileNotFound)throw new h((0,m.$0)(w),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let w=!1;for(const S of a){$(S)||this.w(n);let v;if((0,b.$$f)(S.relativeLocation)&&S.relativeLocation)v=this.z(S.relativeLocation);else if((0,b.$$f)(S.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${S.location}`);continue}else{v=I.URI.revive(S.location);const k=this.y(v);k&&(w=!0,S.relativeLocation=k)}(0,b.$fg)(S.metadata?.hasPreReleaseVersion)&&S.metadata?.preRelease&&(w=!0,S.metadata.hasPreReleaseVersion=!0),o.push({identifier:S.identifier,location:v,version:S.version,metadata:S.metadata})}w&&await this.m.writeFile(n,N.$He.fromString(JSON.stringify(a)))}if(s){o=s(o);const w=o.map(S=>({identifier:S.identifier,version:S.version,location:S.location.toJSON(),relativeLocation:this.y(S.location),metadata:S.metadata}));await this.m.writeFile(n,N.$He.fromString(JSON.stringify(w)))}return o})}w(n){const s=new h(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let i;try{i=(await this.m.readFile(n)).value.toString()}catch(a){if((0,E.$jl)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let o;try{const a=JSON.parse(i);Array.isArray(a)&&a.every(w=>$(w))?o=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,N.$He.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,E.$jl)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,E.$jl)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,E.$jl)(a)!==1&&this.t.error(a)}return o})()),this.C}F(n){let s=this.h.get(n);return s||(s=new D.$Fh,this.h.set(n,s)),s}};e.$uq=g,e.$uq=g=ve([X(1,E.$5k),X(2,l.$El),X(3,c.$Cl),X(4,f.$4l),X(5,p.$5j)],g);function $(r){return(0,b.$ag)(r)&&(0,P.$9o)(r.identifier)&&(t(r.location)||(0,b.$$f)(r.location)&&r.location)&&((0,b.$fg)(r.relativeLocation)||(0,b.$$f)(r.relativeLocation))&&r.version&&(0,b.$$f)(r.version)}function t(r){return r?(0,b.$$f)(r.path)&&(0,b.$$f)(r.scheme):!1}}),define(ae[81],ce([0,1,17,6,30,15,7,35,139,2,23,14,5,20,55,88,13,8,160,16,33,48,71,12,4,9,24,3,66,52,18,28,189]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t,r,n,s,i,o,a,w,S,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=e.$yq=e.$xq=e.Translations=void 0,e.$Aq=Y;var C;(function(Z){function G(J,V){if(J===V)return!0;const H=Object.keys(J),ie=new Set;for(const se of Object.keys(V))ie.add(se);if(H.length!==ie.size)return!1;for(const se of H){if(J[se]!==V[se])return!1;ie.delete(se)}return ie.size===0}Z.equals=G})(C||(e.Translations=C={})),e.$xq=(0,n.$yi)("IExtensionsScannerService");let R=class extends d.$Uc{constructor(G,J,V,H,ie,se,he,ee,W,z,j,F){super(),this.systemExtensionsLocation=G,this.userExtensionsLocation=J,this.r=V,this.s=H,this.t=ie,this.u=se,this.w=he,this.y=ee,this.z=W,this.C=z,this.D=j,this.F=F,this.g=this.B(new o.$fe),this.onDidChangeCache=this.g.event,this.h=(0,l.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,g.$Jp)(this.w,this.y)),this.G}async scanAllExtensions(G,J,V){const[H,ie]=await Promise.all([this.scanSystemExtensions(G),this.scanUserExtensions(J)]),se=V?await this.scanExtensionsUnderDevelopment(G,[...H,...ie]):[];return this.L(H,ie,se,await this.getTargetPlatform(),!0)}async scanSystemExtensions(G){const J=[];J.push(this.M(!!G.useCache,G.language)),J.push(this.N(G.language,!!G.checkControlFile));const[V,H]=await Promise.all(J);return this.J([...V,...H],0,G,!1)}async scanUserExtensions(G){const J=G.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",J);const V=this.D.extUri.isEqual(G.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,H=await this.P(J,!!G.profileLocation,1,!G.includeUninstalled,G.language,!0,V,G.productVersion??this.R()),ie=G.useCache&&!H.devMode&&H.excludeObsolete?this.m:this.n;let se;try{se=await ie.scanExtensions(H)}catch(he){if(he instanceof w.$sq&&he.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),se=await ie.scanExtensions(H);else throw he}return se=await this.J(se,1,G,!0),this.y.trace("Scanned user extensions:",se.length),se}async scanExtensionsUnderDevelopment(G,J){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(H=>H.scheme===E.Schemas.file).map(async H=>{const ie=await this.P(H,!1,1,!0,G.language,!1,void 0,G.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ie)).map(he=>(he.type=J.find(ee=>(0,g.$yp)(ee.identifier,he.identifier))?.type??he.type,this.n.validate(he,ie)))}))).flat();return this.J(V,"development",G,!0)}return[]}async scanExistingExtension(G,J,V){const H=await this.P(G,!1,J,!0,V.language,!0,void 0,V.productVersion??this.R()),ie=await this.n.scanExtension(H);return!ie||!V.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(G,J,V){const H=await this.P(G,!1,J,!0,V.language,!0,void 0,V.productVersion??this.R()),ie=await this.n.scanOneOrMultipleExtensions(H);return this.J(ie,J,V,!0)}async scanMultipleExtensions(G,J,V){const H=[];return await Promise.all(G.map(async ie=>{const se=await this.scanOneOrMultipleExtensions(ie,J,V);H.push(...se)})),this.J(H,J,V,!0)}async scanMetadata(G){const J=(0,l.$_g)(G,"package.json"),V=(await this.w.readFile(J)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(G,J){const V=(0,l.$_g)(G,"package.json"),H=(await this.w.readFile(V)).value.toString(),ie=JSON.parse(H);J.isMachineScoped===!1&&delete J.isMachineScoped,J.isBuiltin===!1&&delete J.isBuiltin,ie.__metadata={...ie.__metadata,...J},await this.w.writeFile((0,l.$_g)(G,"package.json"),A.$He.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(G){if(G instanceof w.$sq&&G.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw G}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const G=await this.scanUserExtensions({includeInvalid:!0});if(G.length)await this.u.addExtensionsToProfile(G.map(J=>[J,J.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$He.fromString(JSON.stringify([])))}catch(J){(0,r.$jl)(J)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,O.$0)(J))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(G){this.y.error(G)}finally{this.H=void 0}})()),this.H}async J(G,J,V,H){return V.includeAllVersions||(G=this.L(J===0?G:void 0,J===1?G:void 0,J==="development"?G:void 0,await this.getTargetPlatform(),H)),V.includeInvalid||(G=G.filter(ie=>ie.isValid)),G.sort((ie,se)=>{const he=y.$nc(ie.location.fsPath),ee=y.$nc(se.location.fsPath);return he<ee?-1:he>ee?1:0})}L(G,J,V,H,ie){const se=(ee,W,z)=>{if(ee.isValid&&!W.isValid)return!1;if(ee.isValid===W.isValid){if(ie&&c.gt(ee.manifest.version,W.manifest.version))return this.y.debug(`Skipping extension ${W.location.path} with lower version ${W.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(c.eq(ee.manifest.version,W.manifest.version)){if(ee.type===0)return this.y.debug(`Skipping extension ${W.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===H)return this.y.debug(`Skipping extension ${W.location.path} from different target platform ${W.targetPlatform}`),!1}}return z?this.y.warn(`Overwriting user extension ${ee.location.path} with ${W.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${W.location.path}.`),!0},he=new $.$Vm;return G?.forEach(ee=>{const W=he.get(ee.identifier.id);(!W||se(W,ee,!1))&&he.set(ee.identifier.id,ee)}),J?.forEach(ee=>{const W=he.get(ee.identifier.id);if(!W&&G&&ee.type===0){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!W||se(W,ee,!1))&&he.set(ee.identifier.id,ee)}),V?.forEach(ee=>{const W=he.get(ee.identifier.id);(!W||se(W,ee,!0))&&he.set(ee.identifier.id,ee),he.set(ee.identifier.id,ee)}),[...he.values()]}async M(G,J){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,J,!0,void 0,this.R()),ie=await(G&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(G,J){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const H=J?await this.O():{},ie=[],se=f.URI.file(y.$hc(y.$jc(E.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of V){const W=H[ee.name]||"marketplace";switch(W){case"disabled":break;case"marketplace":ie.push((0,l.$_g)(se,ee.name));break;default:ie.push(f.URI.file(W));break}}const he=await Promise.all(ie.map(async ee=>this.n.scanExtension(await this.P(ee,!1,0,!0,G,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",he.length),(0,D.$Hb)(he)}async O(){try{const G=await this.w.readFile(this.r);return JSON.parse(G.value.toString())}catch{return{}}}async P(G,J,V,H,ie,se,he,ee){const W=await this.f(ie??p.$w),z=await this.Q(G),j=J&&!this.D.extUri.isEqual(G,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,F=j?await this.Q(j):void 0;return new M(G,z,j,F,J,he,V,H,se,ee.version,ee.date,this.C.commit,!this.z.isBuilt,ie,W)}async Q(G){try{const J=await this.w.stat(G);if(typeof J.mtime=="number")return J.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$yq=R,e.$yq=R=ve([X(4,S.$El),X(5,w.$tq),X(6,r.$5k),X(7,s.$5j),X(8,h.$Fi),X(9,i.$lk),X(10,v.$Cl),X(11,n.$xi)],R);class M{constructor(G,J,V,H,ie,se,he,ee,W,z,j,F,B,U,Q){this.location=G,this.mtime=J,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=H,this.profile=ie,this.profileScanOptions=se,this.type=he,this.excludeObsolete=ee,this.validate=W,this.productVersion=z,this.productDate=j,this.productCommit=F,this.devMode=B,this.language=U,this.translations=Q}static createNlsConfiguration(G){return{language:G.language,pseudo:G.language==="pseudo",devMode:G.devMode,translations:G.translations}}static equals(G,J){return(0,l.$5g)(G.location,J.location)&&G.mtime===J.mtime&&(0,l.$5g)(G.applicationExtensionslocation,J.applicationExtensionslocation)&&G.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&G.profile===J.profile&&L.$9n(G.profileScanOptions,J.profileScanOptions)&&G.type===J.type&&G.excludeObsolete===J.excludeObsolete&&G.validate===J.validate&&G.productVersion===J.productVersion&&G.productDate===J.productDate&&G.productCommit===J.productCommit&&G.devMode===J.devMode&&G.language===J.language&&C.equals(G.translations,J.translations)}}e.$zq=M;let T=class extends d.$Uc{constructor(G,J,V,H,ie){super(),this.f=G,this.g=J,this.h=V,this.j=H,this.m=ie}async scanExtensions(G){const J=G.profile?await this.r(G):await this.n(G);let V={};if(G.excludeObsolete&&G.type===1)try{const H=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(H)}catch{}return(0,m.$lg)(V)?J:J.filter(H=>!V[g.$zp.create(H).toString()])}async n(G){const J=await this.j.resolve(G.location);if(!J.children?.length)return[];const V=await Promise.all(J.children.map(async H=>{if(!H.isDirectory||G.type===1&&(0,l.$9g)(H.resource).indexOf(".")===0)return null;const ie=new M(H.resource,G.mtime,G.applicationExtensionslocation,G.applicationExtensionslocationMtime,G.profile,G.profileScanOptions,G.type,G.excludeObsolete,G.validate,G.productVersion,G.productDate,G.productCommit,G.devMode,G.language,G.translations);return this.scanExtension(ie)}));return(0,D.$Hb)(V).sort((H,ie)=>H.location.path<ie.location.path?-1:1)}async r(G){let J=await this.s(G.location,()=>!0,G);if(G.applicationExtensionslocation&&!this.h.extUri.isEqual(G.location,G.applicationExtensionslocation)){J=J.filter(H=>!H.metadata?.isApplicationScoped);const V=await this.s(G.applicationExtensionslocation,H=>!!H.metadata?.isBuiltin||!!H.metadata?.isApplicationScoped,G);J.push(...V)}return J}async s(G,J,V){const H=await this.g.scanProfileExtensions(G,V.profileScanOptions);if(!H.length)return[];const ie=await Promise.all(H.map(async se=>{if(J(se)){const he=new M(se.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(he,se.metadata)}return null}));return(0,D.$Hb)(ie)}async scanOneOrMultipleExtensions(G){try{if(await this.j.exists((0,l.$_g)(G.location,"package.json"))){const J=await this.scanExtension(G);return J?[J]:[]}else return await this.scanExtensions(G)}catch(J){return this.m.error(`Error scanning extensions at ${G.location.path}:`,(0,O.$0)(J)),[]}}async scanExtension(G,J){try{let V=await this.scanExtensionManifest(G.location);if(V){V.publisher||(V.publisher=$.$Pm),J=J??V.__metadata,delete V.__metadata;const H=(0,g.$Dp)(V.publisher,V.name),ie=J?.id?{id:H,uuid:J.id}:{id:H},se=J?.isSystem?0:G.type,he=se===0||!!J?.isBuiltin;V=await this.t(G.location,V,M.createNlsConfiguration(G));const ee={type:se,identifier:ie,manifest:V,location:G.location,isBuiltin:he,targetPlatform:J?.targetPlatform??"undefined",publisherDisplayName:J?.publisherDisplayName,metadata:J,isValid:!0,validations:[]};return G.validate?this.validate(ee,G):ee}}catch(V){G.type!==0&&this.m.error(V)}return null}validate(G,J){let V=!0;const H=(0,t.$Op)(J.productVersion,J.productDate,J.location,G.manifest,G.isBuiltin);for(const[ie,se]of H)ie===b.default.Error&&(V=!1,this.m.error(this.z(J.location,se)));return G.isValid=V,G.validations=H,G}async scanExtensionManifest(G){const J=(0,l.$_g)(G,"package.json");let V;try{V=(await this.j.readFile(J)).value.toString()}catch(ie){return(0,r.$jl)(ie)!==1&&this.m.error(this.z(G,(0,u.localize)(0,null,J.path,ie.message))),null}let H;try{H=JSON.parse(V)}catch{const se=[];(0,I.$Ln)(V,se);for(const he of se)this.m.error(this.z(G,(0,u.localize)(1,null,J.path,he.offset,he.length,(0,P.$vq)(he.error))));return null}return(0,I.$Un)(H)!=="object"?(this.m.error(this.z(G,(0,u.localize)(2,null,J.path))),null):H}async t(G,J,V){const H=await this.u(G,J,V);if(H)try{const ie=[],se=await this.w(H.default,ie);if(ie.length>0)return ie.forEach(ee=>{this.m.error(this.z(G,(0,u.localize)(3,null,H.default?.path,(0,P.$vq)(ee.error))))}),J;if((0,I.$Un)(H)!=="object")return this.m.error(this.z(G,(0,u.localize)(4,null,H.default?.path))),J;const he=H.values||Object.create(null);return(0,k.$wq)(this.m,J,he,se)}catch{}return J}async u(G,J,V){const H=(0,l.$_g)(G,"package.nls.json"),ie=(W,z)=>{z.forEach(j=>{this.m.error(this.z(G,(0,u.localize)(5,null,W?.path,(0,P.$vq)(j.error))))})},se=W=>{this.m.error(this.z(G,(0,u.localize)(6,null,W?.path)))},he=`${J.publisher}.${J.name}`,ee=V.translations[he];if(ee)try{const W=f.URI.file(ee),z=(await this.j.readFile(W)).value.toString(),j=[],F=(0,I.$Ln)(z,j);return j.length>0?(ie(W,j),{values:void 0,default:H}):(0,I.$Un)(F)!=="object"?(se(W),{values:void 0,default:H}):{values:F.contents?F.contents.package:void 0,default:H}}catch{return{values:void 0,default:H}}else{if(!await this.j.exists(H))return;let z;try{z=await this.y(G,V)}catch{return}if(!z.localized)return{values:void 0,default:z.original};try{const j=(await this.j.readFile(z.localized)).value.toString(),F=[],B=(0,I.$Ln)(j,F);return F.length>0?(ie(z.localized,F),{values:void 0,default:z.original}):(0,I.$Un)(B)!=="object"?(se(z.localized),{values:void 0,default:z.original}):{values:B,default:z.original}}catch{return{values:void 0,default:z.original}}}}async w(G,J){if(G)try{const V=(await this.j.readFile(G)).value.toString();return(0,I.$Ln)(V,J)}catch{}}y(G,J){return new Promise((V,H)=>{const ie=se=>{const he=(0,l.$_g)(G,`package.nls.${se}.json`);this.j.exists(he).then(ee=>{ee&&V({localized:he,original:(0,l.$_g)(G,"package.nls.json")});const W=se.lastIndexOf("-");W===-1?V({localized:(0,l.$_g)(G,"package.nls.json"),original:null}):(se=se.substring(0,W),ie(se))})};if(J.devMode||J.pseudo||!J.language)return V({localized:(0,l.$_g)(G,"package.nls.json"),original:null});ie(J.language)})}z(G,J){return`[${G.path}]: ${J}`}};T=ve([X(1,w.$tq),X(2,v.$Cl),X(3,r.$5k),X(4,s.$5j)],T);let q=class extends T{constructor(G,J,V,H,ie,se,he){super(J,H,ie,se,he),this.G=G,this.H=V,this.D=this.B(new N.$wh(3e3)),this.F=this.B(new o.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(G){const J=this.M(G),V=await this.I(J);if(this.C=G,V&&V.input&&M.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",G.location.toString()),this.D.trigger(()=>this.L()),V.result.map(ie=>(ie.location=f.URI.revive(ie.location),ie));const H=await super.scanExtensions(G);return await this.J(J,{input:G,result:H}),H}async I(G){try{const J=await this.j.readFile(G),V=JSON.parse(J.value.toString());return{result:V.result,input:(0,a.$8h)(V.input)}}catch(J){this.m.debug("Error while reading the extension cache file:",G.path,(0,O.$0)(J))}return null}async J(G,J){try{await this.j.writeFile(G,A.$He.fromString(JSON.stringify(J)))}catch(V){this.m.debug("Error while writing the extension cache file:",G.path,(0,O.$0)(V))}}async L(){if(!this.C)return;const G=this.M(this.C),J=await this.I(G);if(!J)return;const V=J.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!L.$9n(H,V))try{this.m.info("Invalidating Cache",V,H),await this.j.del(G),this.F.fire()}catch(ie){this.m.error(ie)}}M(G){const J=this.N(G);return this.h.extUri.joinPath(J.cacheHome,G.type===0?$.$Om:$.$Nm)}N(G){return G.type===0?this.H.defaultProfile:G.profile?this.h.extUri.isEqual(G.location,this.G.extensionsResource)?this.G:this.H.profiles.find(J=>this.h.extUri.isEqual(G.location,J.extensionsResource))??this.G:this.H.defaultProfile}};q=ve([X(2,S.$El),X(3,w.$tq),X(4,v.$Cl),X(5,r.$5k),X(6,s.$5j)],q);function Y(Z,G){const J=(0,g.$Bp)(Z.manifest.publisher,Z.manifest.name);return{id:J,identifier:new $.$Tm(J),isBuiltin:Z.type===0,isUserBuiltin:Z.type===1&&Z.isBuiltin,isUnderDevelopment:G,extensionLocation:Z.location,uuid:Z.identifier.uuid,targetPlatform:Z.targetPlatform,publisherDisplayName:Z.publisherDisplayName,...Z.manifest}}class K extends R{constructor(G,J,V,H,ie,se,he,ee,W,z,j,F){super(G,J,(0,l.$_g)(V,".vscode-oss-dev","extensions","control.json"),H,ie,se,he,ee,W,z,j,F),this.S=(async()=>{if(p.$z)try{const B=await this.w.readFile(f.URI.file(p.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(G){return this.S}}e.$Bq=K}),define(ae[250],ce([0,1,6,7,2,23,20,55,13,32,31,70,21,16,113,29,33,107,12,9]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;let $=class extends L.$Uc{static{g=this}static{this.c=".sigzip"}constructor(r,n,s,i,o,a){super(),this.h=n,this.j=s,this.m=i,this.n=o,this.r=a,this.extensionsDownloadDir=r.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(r,n,s,i){await this.g;const o=(0,O.$_g)(this.extensionsDownloadDir,this.z(r));try{await this.w(r,o,w=>this.j.download(r,w,n))}catch(w){throw(0,c.$qq)(w,"Download")}let a=!1;if(s&&this.t(r)){let w;try{w=await this.u(r)}catch(S){try{await this.delete(o)}catch(v){this.r.error(v)}throw S}try{a=await this.n.verify(r.identifier.id,o.fsPath,w.fsPath,i)}catch(S){if(a=S.code,a==="PackageIsInvalidZip"||a==="SignatureArchiveIsInvalidZip"){try{await this.delete(o)}catch(v){this.r.error(v)}throw new b.$_o(y.$kq,"CorruptZip")}}finally{try{await this.delete(w)}catch(S){this.r.error(S)}}}return{location:o,verificationStatus:a}}t(r){if(!r.isSigned)return this.r.info(`Extension is not signed: ${r.identifier.id}`),!1;const n=this.m.getValue("extensions.verifySignature");return(0,P.$eg)(n)?n:!0}async u(r){await this.g;const n=(0,O.$_g)(this.extensionsDownloadDir,`.${(0,d.$Ug)()}`);try{await this.j.downloadSignatureArchive(r,n)}catch(s){throw(0,c.$qq)(s,"DownloadSignature")}return n}async w(r,n,s){if(await this.h.exists(n))return;if(n.scheme!==A.Schemas.file){await s(n);return}const i=(0,O.$_g)(this.extensionsDownloadDir,`.${(0,d.$Ug)()}`);try{await s(i)}catch(o){try{await this.h.del(i)}catch{}throw o}try{await E.Promises.rename(i.fsPath,n.fsPath,2*60*1e3)}catch(o){try{await this.h.del(i)}catch{}if(o.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",r.identifier.id,n.path);else throw this.r.info(`Rename failed because of ${(0,N.$0)(o)}. Deleted the file from downloaded location`,i.path),o}}async delete(r){await this.g,await this.h.del(r)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const r=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(r.children){const n=[],s=[],i=[];for(const w of r.children)if(w.name.endsWith(g.c))i.push(w.resource);else{const S=m.$zp.parse(w.name);S&&s.push([S,w])}const o=(0,m.$Ep)(s,([w])=>w),a=[];for(const w of o)w.sort((S,v)=>I.rcompare(S[0].version,v[0].version)),n.push(...w.slice(1).map(S=>S[1].resource)),a.push(w[0][1]);a.sort((w,S)=>w.mtime-S.mtime),n.push(...a.slice(0,Math.max(0,a.length-this.f)).map(w=>w.resource)),n.push(...i),await D.Promises.settled(n.map(w=>(this.r.trace("Deleting from cache",w.path),this.h.del(w))))}}catch(r){this.r.error(r)}}z(r){return this.f?m.$zp.create(r).toString().toLowerCase():(0,d.$Ug)()}};e.$Cq=$,e.$Cq=$=g=ve([X(0,l.$Gi),X(1,u.$5k),X(2,b.$0o),X(3,p.$5i),X(4,f.$dq),X(5,h.$5j)],$)}),define(ae[251],ce([0,1,67,6,38,3,2,23,14,31,9,18]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=void 0;let p=class extends O.$Uc{constructor(c,b){super(),this.b=c,this.f=b,this.a=new N.$Eh(5)}async postUninstall(c){const b=this.g(c,"uninstall");b&&(this.f.info(c.identifier.id,c.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,c),this.f.info("Finished running post uninstall script",c.identifier.id,c.manifest.version)}catch(m){this.f.error("Failed to run post uninstall script",c.identifier.id,c.manifest.version),this.f.error(m)}}));try{await d.Promises.rm(this.m(c))}catch(m){this.f.error("Error while removing extension storage path",c.identifier.id),this.f.error(m)}}g(c,b){const m=`vscode:${b}`;if(c.location.scheme===I.Schemas.file&&c.manifest&&c.manifest.scripts&&typeof c.manifest.scripts[m]=="string"){const f=c.manifest.scripts[m].split(" ");return f.length<2||f[0]!=="node"||!f[1]?(this.f.warn(c.identifier.id,c.manifest.version,`${m} should be a node script`),null):{script:(0,P.$jc)(c.location.fsPath,f[1]),args:f.slice(2)||[]}}return null}h(c,b,m,f,u){return new Promise((h,g)=>{const $=this.j(c,b,m,u);let t;const r=n=>{t&&(clearTimeout(t),t=null),n?g(n):h(void 0)};$.on("error",n=>{r((0,L.$jj)(n)||"Unknown")}),$.on("exit",(n,s)=>{r(n?`post-${b} process exited with code ${n}`:void 0)}),f&&(t=setTimeout(()=>{t=null,$.kill(),g("timed out")},5e3))})}j(c,b,m,f){const u={silent:!0,execArgv:void 0},h=(0,D.fork)(c,[`--type=extension-post-${b}`,...m],u);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const g=A.Event.fromNodeEventEmitter(h.stdout,"data"),$=A.Event.fromNodeEventEmitter(h.stderr,"data");this.B(g(n=>this.f.info(f.identifier.id,f.manifest.version,`post-${b}`,n))),this.B($(n=>this.f.error(f.identifier.id,f.manifest.version,`post-${b}`,n)));const t=A.Event.any(A.Event.map(g,n=>({data:`%c${n}`,format:[""]}),this.q),A.Event.map($,n=>({data:`%c${n}`,format:["color: red"]}),this.q));return A.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100,void 0,void 0,void 0,this.q)(n=>{console.group(f.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}m(c){return(0,P.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,c.identifier.id.toLowerCase())}};e.$Dq=p,e.$Dq=p=ve([X(0,y.$El),X(1,E.$5j)],p)}),define(ae[114],ce([0,1,6,15,26,38,7,3,54,2,34,23,14,20,55,13,8,32,31,70,161,95,16,113,29,33,52,81,250,251,190,222,232,71,12,4,9,24,22,28,18]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t,r,n,s,i,o,a,w,S,v,k,C,R,M,T,q,Y,K,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kq=e.$Jq=e.$Iq=e.$Hq=void 0,e.$Hq=(0,M.$zi)(n.$ap);const G=".vsctmp";let J=class extends r.$pq{constructor(W,z,j,F,B,U,Q,x,te,_,oe,ue){super(W,z,oe,j,_,ue),this.eb=B,this.fb=U,this.gb=Q,this.hb=te,this.db=new Map,this.qb=new E.$Bc;const $e=this.B(x.createInstance(w.$Dq));this.ab=this.B(x.createInstance(V,ge=>$e.postUninstall(ge))),this.bb=this.B(new v.$Fq(ue,te,oe,this,this.F)),this.cb=this.B(x.createInstance(a.$Cq));const de=this.B(new k.$Gq(this,this.eb,ue,U,oe,te,j));this.B(de.onDidChangeExtensionsByAnotherSource(ge=>this.pb(ge))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,s.$Jp)(this.hb,this.F)),this.ib}async zip(W){this.F.trace("ExtensionManagementService#zip",W.identifier.id);const z=await this.ob(W),j=await(0,h.zip)((0,l.$_g)(this.cb.extensionsDownloadDir,(0,f.$Ug)()).fsPath,z);return m.URI.file(j)}async unzip(W){return this.F.trace("ExtensionManagementService#unzip",W.toString()),(await this.install(W)).identifier}async getManifest(W){const{location:z,cleanup:j}=await this.kb(W),F=p.$kc(z.fsPath);try{return await(0,S.$Eq)(F)}finally{await j()}}getInstalled(W,z=this.H.defaultProfile.extensionsResource,j={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(W??null,z,j)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(W){return this.ab.scanUserExtensionAtLocation(W)}async install(W,z={}){this.F.trace("ExtensionManagementService#install",W.toString());const{location:j,cleanup:F}=await this.kb(W);try{const B=await(0,S.$Eq)(p.$kc(j.fsPath)),U=(0,s.$Dp)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,C.$Qp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(g.localize(0,null,U,this.G.version));const x=(await this.I([{manifest:B,extension:j,options:z}])).find(({identifier:te})=>(0,s.$yp)(te,{id:U}));if(x?.local)return x.local;throw x?.error?x.error:(0,r.$qq)(new Error(`Unknown error while installing extension ${U}`))}finally{await F()}}async installFromLocation(W,z){this.F.trace("ExtensionManagementService#installFromLocation",W.toString());const j=await this.ab.scanUserExtensionAtLocation(W);if(!j||!j.manifest.name||!j.manifest.version)throw new Error(`Cannot find a valid extension from the location ${W.toString()}`);return await this.tb([[j,{source:"resource"}]],z),this.F.info("Successfully installed extension",j.identifier.id,z.toString()),j}async installExtensionsFromProfile(W,z,j){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",W,z.toString(),j.toString());const F=(await this.getInstalled(1,z)).filter(B=>W.some(U=>(0,s.$yp)(U,B.identifier)));if(F.length){const B=await Promise.all(F.map(U=>this.ab.scanMetadata(U,z)));await this.tb(F.map((U,Q)=>[U,B[Q]]),j),this.F.info("Successfully installed extensions",F.map(U=>U.identifier.id),j.toString())}return F}async updateMetadata(W,z,j=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",W.identifier.id),z.isPreReleaseVersion&&(z.preRelease=!0,z.hasPreReleaseVersion=!0),z.isMachineScoped===!1&&(z.isMachineScoped=void 0),z.isBuiltin===!1&&(z.isBuiltin=void 0),z.pinned===!1&&(z.pinned=void 0),W=await this.ab.updateMetadata(W,z,j),this.bb.invalidate(j),this.w.fire(W),W}async reinstallFromGallery(W){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",W.identifier.id),!this.z.isEnabled())throw new Error(g.localize(1,null));const z=await this.getTargetPlatform(),[j]=await this.z.getExtensions([{...W.identifier,preRelease:W.preRelease}],{targetPlatform:z,compatible:!0},L.CancellationToken.None);if(!j)throw new Error(g.localize(2,null));await this.ab.setUninstalled(W);try{await this.ab.removeUninstalledExtension(W)}catch(F){throw new Error(g.localize(3,null,(0,A.$jj)(F)))}return this.installFromGallery(j)}$(W,z,j,F){return this.ab.copyExtension(W,z,j,F)}copyExtensions(W,z){return this.ab.copyExtensions(W,z,{version:this.G.version,date:this.G.date})}markAsUninstalled(...W){return this.ab.setUninstalled(...W)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(W){this.F.error(W)}}async download(W,z,j){const{location:F}=await this.cb.download(W,z,!j);return F}async kb(W){if(W.scheme===y.Schemas.file)return{location:W,async cleanup(){}};this.F.trace("Downloading extension from",W.toString());const z=(0,l.$_g)(this.cb.extensionsDownloadDir,(0,f.$Ug)());return await this.gb.download(W,z),this.F.info("Downloaded extension to",z.toString()),{location:z,cleanup:async()=>{try{await this.hb.del(z)}catch(F){this.F.error(F)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(W,z,j){if(m.URI.isUri(z))return new se(W,z,j,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const F=s.$zp.create(z).toString();let B=this.db.get(F);return B||(this.db.set(F,B=new ie(W,z,j,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),B.waitUntilTaskIsFinished().finally(()=>this.db.delete(F))),B}Z(W,z){return new he(W,z.profileLocation,this.fb)}async ob(W){const z=async F=>{let B=await u.Promises.readdir(F);B=B.map(x=>p.$jc(F,x));const U=await Promise.all(B.map(x=>u.Promises.stat(x)));let Q=Promise.resolve([]);return U.forEach((x,te)=>{const _=B[te];x.isFile()&&(Q=Q.then(oe=>[...oe,_])),x.isDirectory()&&(Q=Q.then(oe=>z(_).then(ue=>[...oe,...ue])))}),Q};return(await z(W.location.fsPath)).map(F=>({path:`extension/${p.$lc(W.location.fsPath,F)}`,localPath:F}))}async pb({added:W,removed:z}){if(z){const j=W&&this.D.extUri.isEqual(z.profileLocation,W.profileLocation)?z.extensions.filter(F=>W.extensions.every(B=>!(0,s.$yp)(B,F))):z.extensions;for(const F of j)this.F.info("Extensions removed from another source",F.id,z.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:z.profileLocation})}if(W){const F=(await this.getInstalled(1,W.profileLocation)).filter(B=>W.extensions.some(U=>(0,s.$yp)(U,B.identifier)));this.s.fire(F.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,W.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:W.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(z=>this.qb.add(z)));const W=await this.hb.resolve(this.eb.userExtensionsLocation);for(const z of W.children??[])z.isDirectory&&this.qb.add(z.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(z=>this.sb(z)))}async sb(W){if(!W.affects(this.eb.userExtensionsLocation,1))return;const z=[];for(const j of W.rawAdded){if(this.qb.has(j)||!this.D.extUri.isEqual(this.D.extUri.dirname(j),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(j,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(j).startsWith(".")||!(await this.hb.stat(j)).isDirectory)continue;const F=await this.ab.scanUserExtensionAtLocation(j);F&&F.installedTimestamp===void 0&&(this.qb.add(j),z.push(F))}z.length&&(await this.tb(z.map(j=>[j,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",z.map(j=>j.identifier.id)))}async tb(W,z){const j=W.map(F=>F[0]);await this.ub(j),await this.fb.addExtensionsToProfile(W,z),this.s.fire(j.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:z})))}async ub(W){const z=await this.ab.getUninstalledExtensions();for(const j of W){const F=s.$zp.create(j);z[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.ab.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$Iq=J,e.$Iq=J=ve([X(0,n.$0o),X(1,Y.$4l),X(2,T.$5j),X(3,t.$Gi),X(4,o.$xq),X(5,i.$tq),X(6,$.$No),X(7,M.$xi),X(8,R.$5k),X(9,q.$lk),X(10,K.$Cl),X(11,Z.$El)],J);let V=class extends d.$Uc{constructor(W,z,j,F,B,U){super(),this.j=W,this.m=z,this.n=j,this.s=F,this.t=B,this.u=U,this.h=this.B(new I.$fe),this.onExtract=this.h.event,this.c=(0,l.$_g)(this.n.userExtensionsLocation,".obsolete"),this.g=new D.$Fh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(W,z,j){try{const F={includeInvalid:!0,profileLocation:z,productVersion:j};let B=[];return W===null||W===0?B.push(...await this.n.scanAllExtensions({includeInvalid:!0},F,!1)):W===1&&B.push(...await this.n.scanUserExtensions(F)),B=W!==null?B.filter(U=>U.type===W):B,await Promise.all(B.map(U=>this.F(U)))}catch(F){throw(0,r.$qq)(F,"Scanning")}}async scanAllUserExtensions(W){try{const z=await this.n.scanUserExtensions({includeAllVersions:!W,includeInvalid:!0});return await Promise.all(z.map(j=>this.F(j)))}catch(z){throw(0,r.$qq)(z,"Scanning")}}async scanUserExtensionAtLocation(W){try{const z=await this.n.scanExistingExtension(W,1,{includeInvalid:!0});if(z)return await this.F(z)}catch(z){this.u.error(z)}return null}async extractUserExtension(W,z,j,F,B){const U=W.toString(),Q=m.URI.file(p.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,f.$Ug)()}`)),x=m.URI.file(p.$jc(this.n.userExtensionsLocation.fsPath,U));let te=await this.m.exists(x);if(te&&F){try{await this.y(W.id,x,"removeExisting")}catch{throw new n.$_o(g.localize(4,null,x.fsPath,W.id),"Delete")}te=!1}if(te)try{await this.n.updateMetadata(x,j)}catch(_){throw(0,r.$qq)(_,"UpdateMetadata")}else try{try{this.u.trace(`Started extracting the extension from ${z} to ${x.fsPath}`),await(0,h.$nq)(z,Q.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${x}:`,W.id)}catch(_){let oe="Extract";throw _ instanceof h.$lq&&(_.type==="CorruptZip"?oe="CorruptZip":_.type==="Incomplete"&&(oe="IncompleteZip")),(0,r.$qq)(_,oe)}try{await this.n.updateMetadata(Q,j)}catch(_){throw(0,r.$qq)(_,"UpdateMetadata")}try{this.u.trace(`Started renaming the extension from ${Q.fsPath} to ${x.fsPath}`),await this.C(Q.fsPath,x.fsPath),this.u.info("Renamed to",x.fsPath)}catch(_){if(_.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",W.id);else throw this.u.info(`Rename failed because of ${(0,O.$0)(_)}. Deleted from extracted location`,Q),_}this.h.fire(x)}catch(_){try{await this.m.del(Q,{recursive:!0})}catch{}throw _}return this.D(x,1)}async scanMetadata(W,z){return z?(await this.w(W,z))?.metadata:this.n.scanMetadata(W.location)}async w(W,z){return(await this.s.scanProfileExtensions(z)).find(F=>(0,s.$yp)(F.identifier,W.identifier))}async updateMetadata(W,z,j){try{j?await this.s.updateMetadata([[W,z]],j):await this.n.updateMetadata(W.location,z)}catch(F){throw(0,r.$qq)(F,"UpdateMetadata")}return this.D(W.location,W.type,j)}async getUninstalledExtensions(){try{return await this.z()}catch(W){throw(0,r.$qq)(W,"ReadUninstalled")}}async setUninstalled(...W){const z=W.map(j=>s.$zp.create(j));await this.z(j=>z.forEach(F=>{j[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(W){try{await this.z(z=>delete z[W.toString()])}catch(z){throw(0,r.$qq)(z,"UnsetUninstalled")}}async removeExtension(W,z){if(this.t.extUri.isEqualOrParent(W.location,this.n.userExtensionsLocation))return this.y(W.identifier.id,W.location,z)}async removeUninstalledExtension(W){await this.removeExtension(W,"uninstalled"),await this.z(z=>delete z[s.$zp.create(W).toString()])}async copyExtension(W,z,j,F){const B=await this.w(W,z),U=await this.w(W,j);if(F={...B?.metadata,...F},U)if(this.t.extUri.isEqual(U.location,W.location))await this.s.updateMetadata([[W,{...U.metadata,...F}]],j);else{const Q=await this.D(U.location,W.type,j);await this.s.removeExtensionFromProfile(Q,j),await this.s.addExtensionsToProfile([[W,{...U.metadata,...F}]],j)}else await this.s.addExtensionsToProfile([[W,F]],j);return this.D(W.location,W.type,j)}async copyExtensions(W,z,j){const F=await this.scanExtensions(1,W,j),B=await Promise.all(F.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,W)]));await this.s.addExtensionsToProfile(B,z)}async y(W,z,j){this.u.trace(`Deleting ${j} extension from disk`,W,z.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(z),`${this.t.extUri.basename(z)}.${(0,P.$mj)((0,f.$Ug)()).toString(16)}${G}`);await this.C(z.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${j} extension from disk`,W,z.fsPath)}z(W){return this.g.queue(async()=>{let z;try{z=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,R.$jl)(F)!==1)throw F}let j={};if(z)try{j=JSON.parse(z)}catch{}return W&&(W(j),Object.keys(j).length?await this.m.writeFile(this.c,N.$He.fromString(JSON.stringify(j))):await this.m.del(this.c)),j})}async C(W,z){try{await u.Promises.rename(W,z,2*60*1e3)}catch(j){throw(0,r.$qq)(j,"Rename")}}async D(W,z,j){try{if(j){const B=(await this.n.scanUserExtensions({profileLocation:j})).find(U=>this.t.extUri.isEqual(U.location,W));if(B)return await this.F(B)}else{const F=await this.n.scanExistingExtension(W,z,{includeInvalid:!0});if(F)return await this.F(F)}throw new n.$_o(g.localize(5,null,W.path),"ScanningExtension")}catch(F){throw(0,r.$qq)(F,"ScanningExtension")}}async F(W){const z=await this.m.resolve(W.location);let j,F;return z.children&&(j=z.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=z.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:W.identifier,type:W.type,isBuiltin:W.isBuiltin||!!W.metadata?.isBuiltin,location:W.location,manifest:W.manifest,targetPlatform:W.targetPlatform,validations:W.validations,isValid:W.isValid,readmeUrl:j,changelogUrl:F,publisherDisplayName:W.metadata?.publisherDisplayName,publisherId:W.metadata?.publisherId||null,isApplicationScoped:!!W.metadata?.isApplicationScoped,isMachineScoped:!!W.metadata?.isMachineScoped,isPreReleaseVersion:!!W.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!W.metadata?.hasPreReleaseVersion,preRelease:!!W.metadata?.preRelease,installedTimestamp:W.metadata?.installedTimestamp,updated:!!W.metadata?.updated,pinned:!!W.metadata?.pinned,isWorkspaceScoped:!1,source:W.metadata?.source??(W.identifier.uuid?"gallery":"vsix")}}async G(){const W=await this.getUninstalledExtensions();if(Object.keys(W).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(W));const z=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const B of z)W[s.$zp.create(B).toString()]||j.add(B.identifier.id.toLowerCase());try{const B=(0,s.$Ep)(z,U=>U.identifier);await D.Promises.settled(B.map(async U=>{const Q=U.sort((x,te)=>c.rcompare(x.manifest.version,te.manifest.version))[0];j.has(Q.identifier.id.toLowerCase())||await this.j(await this.F(Q))}))}catch(B){this.u.error(B)}const F=z.filter(B=>B.metadata&&W[s.$zp.create(B).toString()]);await Promise.allSettled(F.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let W;try{W=await this.m.resolve(this.n.userExtensionsLocation)}catch(z){(0,R.$jl)(z)!==1&&this.u.error(z);return}if(W?.children)try{await Promise.allSettled(W.children.map(async z=>{if(!(!z.isDirectory||!z.name.endsWith(G))){this.u.trace("Deleting the temporarily deleted folder",z.resource.toString());try{await this.m.del(z.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",z.resource.toString())}catch(j){(0,R.$jl)(j)!==1&&this.u.error(j)}}}))}catch{}}};e.$Jq=V,e.$Jq=V=ve([X(1,R.$5k),X(2,o.$xq),X(3,i.$tq),X(4,K.$Cl),X(5,T.$5j)],V);class H extends r.$rq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$fg)(this.options.operation)?this.l:this.options.operation}constructor(W,z,j,F,B,U,Q,x,te,_){super(),this.manifest=W,this.identifier=z,this.source=j,this.options=F,this.m=B,this.n=U,this.o=Q,this.p=x,this.q=te,this.s=_,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(W){const[z,j]=await this.w(W);if(this.j=z.isBuiltin||z.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j))try{await this.p.initializeDefaultProfileExtensions()}catch(F){throw(0,r.$qq)(F,"IntializeDefaultProfile")}try{await this.q.addExtensionsToProfile([[z,j]],this.j,!z.isValid)}catch(F){throw(0,r.$qq)(F,"AddToProfile")}return z}async u({zipPath:W,key:z,metadata:j},F,B){let U=await this.v(z);return U?U=await this.m.updateMetadata(U,j):(this.s.trace("Extracting extension...",z.id),U=await this.m.extractUserExtension(z,W,j,F,B),this.s.info("Extracting extension completed.",z.id)),U}async v(W){return(await this.m.getUninstalledExtensions())[W.toString()]?(this.s.trace("Removing the extension from uninstalled list:",W.id),await this.m.setInstalled(W),this.s.info("Removed the extension from uninstalled list:",W.id),(await this.m.scanAllUserExtensions(!0)).find(F=>s.$zp.create(F).equals(W))):void 0}}class ie extends H{constructor(W,z,j,F,B,U,Q,x,te,_,oe){super(W,z.identifier,z,j,B,U,Q,x,te,_),this.x=z,this.y=F,this.z=oe}async w(W){const j=(await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,s.$yp)(Q.identifier,this.x.identifier));j&&(this.l=3);const F={id:this.x.identifier.uuid,publisherId:this.x.publisherId,publisherDisplayName:this.x.publisherDisplayName,targetPlatform:this.x.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.x.properties.isPreReleaseVersion,hasPreReleaseVersion:j?.hasPreReleaseVersion||this.x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned,preRelease:(0,b.$eg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.x.properties.isPreReleaseVersion||j?.preRelease,source:"gallery"};if(j&&j.type!==0&&j.manifest.version===this.x.version)return[await this.m.updateMetadata(j,F),F];const{verificationStatus:B,location:U}=await this.B(F,W);try{return this.k=B,await this.C(U.fsPath),[await this.u({zipPath:U.fsPath,key:s.$zp.create(this.x),metadata:F},!1,W),F]}catch(Q){try{await this.y.delete(U)}catch(x){this.s.warn("Error while deleting the downloaded file",U.toString(),(0,O.$0)(x))}throw Q}}async B(W,z){try{return await this.y.download(this.x,this.l,!this.options.donotVerifySignature,this.options.context?.[n.$3o])}catch{this.s.info("Failed downloading. Retry again...",this.x.identifier.id);try{const F=await this.B(W,z);return this.z.publicLog2("extensiongallery:download:retry",{extensionId:this.x.identifier.id,succeeded:!0}),F}catch(F){throw this.z.publicLog2("extensiongallery:download:retry",{extensionId:this.x.identifier.id,succeeded:!1}),F}}}async C(W){try{await(0,S.$Eq)(W)}catch(z){throw(0,r.$qq)(z,"Invalid")}}}e.$Kq=ie;class se extends H{constructor(W,z,j,F,B,U,Q,x,te,_){super(W,{id:(0,s.$Dp)(W.publisher,W.name)},z,j,B,U,Q,x,te,_),this.x=z,this.y=F}async h(W){const z=await super.h(W);return this.B(z,W),z}async w(W){const z=new s.$zp(this.identifier,this.manifest.version),F=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(Q=>(0,s.$yp)(this.identifier,Q.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??F?.pinned,source:"vsix"};if(F)if(this.l=3,z.equals(new s.$zp(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(g.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&c.gt(F.manifest.version,this.manifest.version)&&await this.m.setUninstalled(F);else{const Q=await this.v(z);if(Q)try{await this.m.removeExtension(Q,"existing")}catch{throw new Error(g.localize(7,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:p.$kc(this.x.fsPath),key:z,metadata:B},!0,W),B]}async B(W,z){try{let[j]=await this.y.getExtensions([{id:W.identifier.id,version:W.manifest.version}],z);if(j||([j]=await this.y.getExtensions([{id:W.identifier.id}],z)),j){const F={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,hasPreReleaseVersion:W.hasPreReleaseVersion||j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(W,F,this.options.profileLocation)}}catch{}}}class he extends r.$rq{constructor(W,z,j){super(),this.extension=W,this.j=z,this.k=j}async h(W){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ae[252],ce([0,1,9,18,28,22,52,12,16,8]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aQ=void 0;let E=class extends O.$uq{constructor(p,l,c,b,m,f){super(d.URI.file(p.extensionsPath),l,c,b,m,f)}};e.$aQ=E,e.$aQ=E=ve([X(0,P.$Gi),X(1,I.$5k),X(2,N.$El),X(3,L.$Cl),X(4,A.$4l),X(5,D.$5j)],E)}),define(ae[253],ce([0,1,8,16,52,81,12,4,9,24,28,18]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_dc=void 0;let p=class extends A.$Bq{constructor(c,b,m,f,u,h,g,$){super(D.URI.file(u.builtinExtensionsPath),D.URI.file(u.extensionsPath),u.userHome,c.defaultProfile,c,b,m,f,u,h,g,$)}};e.$_dc=p,e.$_dc=p=ve([X(0,y.$El),X(1,L.$tq),X(2,O.$5k),X(3,P.$5j),X(4,N.$Gi),X(5,d.$lk),X(6,E.$Cl),X(7,I.$xi)],p)}),define(ae[19],ce([0,1,6,3,2,98,13,69,4,18]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=l,e.$8p=b,e.$0p=f,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,P.$yi)("storageService");var E;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(E||(e.WillSaveStateReason=E={}));var y;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(y||(e.StorageScope=y={}));var p;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(p||(e.StorageTarget=p={}));function l(u){const h=u.get(e.$4p);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}class c extends L.$Uc{static{this.a=60*1e3}constructor(h={flushInterval:c.a}){super(),this.m=h,this.b=this.B(new N.$ie),this.c=this.B(new N.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new D.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new L.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,g,$){return N.Event.filter(this.b.event,t=>t.scope===h&&(g===void 0||t.key===g),$)}n(){this.j.value=(0,D.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,L.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,g){const{key:$,external:t}=g;if($===e.$4p){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:$,target:this.J(h)[$],external:t})}w(h){this.f.fire({reason:h})}get(h,g,$){return this.P(g)?.get(h,$)}getBoolean(h,g,$){return this.P(g)?.getBoolean(h,$)}getNumber(h,g,$){return this.P(g)?.getNumber(h,$)}getObject(h,g,$){return this.P(g)?.getObject(h,$)}storeAll(h,g){this.y(()=>{for(const $ of h)this.store($.key,$.value,$.scope,$.target,g)})}store(h,g,$,t,r=!1){if((0,O.$hg)(g)){this.remove(h,$,r);return}this.y(()=>{this.z(h,$,t),this.P($)?.set(h,g,r)})}remove(h,g,$=!1){this.y(()=>{this.z(h,g,void 0),this.P(g)?.delete(h,$)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,g){const $=[],t=this.J(h);for(const r of Object.keys(t))t[r]===g&&$.push(r);return $}z(h,g,$,t=!1){const r=this.J(g);typeof $=="number"?r[h]!==$&&(r[h]=$,this.P(g)?.set(e.$4p,JSON.stringify(r),t)):typeof r[h]=="number"&&(delete r[h],this.P(g)?.set(e.$4p,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const g=this.P(h);return g?l(g):Object.create(null)}isNew(h){return this.getBoolean(e.$3p,h)===!0}async flush(h=E.NONE){this.f.fire({reason:h});const g=this.P(-1),$=this.P(0),t=this.P(1);switch(h){case E.NONE:await D.Promises.settled([g?.whenFlushed()??Promise.resolve(),$?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await D.Promises.settled([g?.flush(0)??Promise.resolve(),$?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,g=this.P(0)?.items??new Map,$=this.P(1)?.items??new Map;return f(h,g,$,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,g){return this.w(E.NONE),(0,d.$Dl)(h)?this.R(h,g):this.S(h,g)}M(h,g){return!(h.id===g.id||b(g)&&b(h))}N(h,g,$){this.y(()=>{const t=new Set;for(const[r,n]of h)t.add(r),g.get(r)!==n&&this.u($,{key:r,external:!0});for(const[r]of g.items)t.has(r)||this.u($,{key:r,external:!0})})}}e.$7p=c;function b(u){return u.isDefault||!!u.useDefaultFlags?.globalState}class m extends c{constructor(){super(),this.U=this.B(new I.$1p(new I.$2p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new I.$1p(new I.$2p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new I.$1p(new I.$2p,{hint:I.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$9p=m;async function f(u,h,g,$,t,r){const n=C=>{try{return JSON.parse(C)}catch{return C}},s=new Map,i=new Map;u.forEach((C,R)=>{s.set(R,C),i.set(R,n(C))});const o=new Map,a=new Map;h.forEach((C,R)=>{o.set(R,C),a.set(R,n(C))});const w=new Map,S=new Map;g.forEach((C,R)=>{w.set(R,C),S.set(R,n(C))}),console.group($!==t?`Storage: Application (path: ${$})`:`Storage: Application & Profile (path: ${$}, default profile)`);const v=[];if(s.forEach((C,R)=>{v.push({key:R,value:C})}),console.table(v),console.groupEnd(),console.log(i),$!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const C=[];o.forEach((R,M)=>{C.push({key:M,value:R})}),console.table(C),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const k=[];w.forEach((C,R)=>{k.push({key:R,value:C})}),console.table(k),console.groupEnd(),console.log(S)}}),define(ae[115],ce([0,1,3,2,13,29,33,19]),function(ne,e,D,N,L,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zKb=e.$yKb=void 0;let P=class extends N.$Uc{constructor(y,p){super(),this.a=new D.$fe,this.onDidChangeEnablement=this.a.event,this.b=this.B(new d(y)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(p.onDidInstallExtensions(l=>l.forEach(({local:c,operation:b})=>{c&&b===4&&this.f(c.identifier)})))}async enableExtension(y,p){return this.f(y)?(this.a.fire({extensions:[y],source:p}),!0):!1}async disableExtension(y,p){return this.c(y)?(this.a.fire({extensions:[y],source:p}),!0):!1}getDisabledExtensions(){return this.h(A.$bp)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(y){const p=this.getDisabledExtensions();return p.every(l=>!(0,O.$yp)(l,y))?(p.push(y),this.g(p),!0):!1}f(y){const p=this.getDisabledExtensions();for(let l=0;l<p.length;l++){const c=p[l];if((0,O.$yp)(c,y))return p.splice(l,1),this.g(p),!0}return!1}g(y){this.j(A.$bp,y)}h(y){return this.b.get(y,0)}j(y,p){this.b.set(y,p,0)}};e.$yKb=P,e.$yKb=P=ve([X(0,I.$5p),X(1,A.$ap)],P);class d extends N.$Uc{constructor(y){super(),this.c=y,this.a=Object.create(null),this.b=this.B(new D.$fe),this.onDidChange=this.b.event,this.B(y.onDidChangeValue(0,void 0,this.B(new N.$Tc))(p=>this.f(p)))}get(y,p){let l;return p===0?((0,L.$hg)(this.a[y])&&(this.a[y]=this.g(y,p)),l=this.a[y]):l=this.g(y,p),JSON.parse(l)}set(y,p,l){const c=JSON.stringify(p.map(({id:m,uuid:f})=>({id:m,uuid:f})));this.g(y,l)!==c&&(l===0&&(p.length?this.a[y]=c:delete this.a[y]),this.h(y,p.length?c:void 0,l))}f(y){if(!(0,L.$hg)(this.a[y.key])&&this.g(y.key,y.scope)!==this.a[y.key]){const l=this.get(y.key,y.scope);delete this.a[y.key];const c=this.get(y.key,y.scope),b=l.filter(f=>!c.some(u=>(0,O.$yp)(f,u))),m=c.filter(f=>!l.some(u=>(0,O.$yp)(u,f)));(b.length||m.length)&&this.b.fire([...b,...m])}}g(y,p){return this.c.get(y,p,"[]")}h(y,p,l){p?this.c.store(y,p,l,1):this.c.remove(y,l)}}e.$zKb=d}),define(ae[254],ce([0,1,17,26,7,5,36,13,8,21,16,29,33,71,12,9,24,59,233,19,22,63]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$aq=se;const t=A.$o?"web":(0,y.$6o)(A.$u,O.$ec),r="X-Market-Search-Activity-Id";var n;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...F){return String(F.reduce((B,U)=>B|U,0))}var i;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},S={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class v{constructor(B=S){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,U=this.d.pageSize){return new v({...this.d,pageNumber:B,pageSize:U})}withFilter(B,...U){const Q=[...this.d.criteria,...U.length?U.map(x=>({filterType:B,value:x})):[{filterType:B}]];return new v({...this.d,criteria:Q})}withSortBy(B){return new v({...this.d,sortBy:B})}withSortOrder(B){return new v({...this.d,sortOrder:B})}withFlags(...B){return new v({...this.d,flags:B.reduce((U,Q)=>U|Q,0)})}withAssetTypes(...B){return new v({...this.d,assetTypes:B})}withSource(B){return new v({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:U,pageSize:Q,sortBy:x,sortOrder:te,flags:_,assetTypes:oe}=this.d;return{filters:[{criteria:B,pageNumber:U,pageSize:Q,sortBy:x,sortOrder:te}],assetTypes:oe,flags:_}}get searchText(){const B=this.d.criteria.filter(U=>U.filterType===i.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function k(F,B){const U=(F||[]).filter(Q=>Q.statisticName===B)[0];return U?U.value:0}function C(F){const B="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(Q=>Q.assetType.indexOf(B)===0).reduce((Q,x)=>{const te=T(F,x.assetType);return te&&Q.push([x.assetType.substring(B.length),te]),Q},[])}function R(F){if(F.properties){const B=F.properties.filter(x=>x.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),Q=B.filter(x=>U.test(x.value))[0];return Q?{uri:Q.value,fallbackUri:Q.value}:null}return T(F,o.Repository)}function M(F){return{uri:`${F.fallbackAssetUri}/${o.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${o.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function T(F,B){return F.files.filter(Q=>Q.assetType===B)[0]?{uri:`${F.assetUri}/${B}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${B}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function q(F,B){const U=F.properties?F.properties.filter(x=>x.key===B):[],Q=U.length>0&&U[0].value;return Q?Q.split(",").map(x=>(0,p.$Cp)(x)):[]}function Y(F){const B=F.properties?F.properties.filter(U=>U.key===a.Engine):[];return B.length>0&&B[0].value||""}function K(F){const B=F.properties?F.properties.filter(U=>U.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function Z(F){const B=F.properties?F.properties.filter(Q=>Q.key===a.LocalizedLanguages):[],U=B.length>0&&B[0].value||"";return U?U.split(","):[]}function G(F){return F.properties?.find(B=>B.key===a.SponsorLink)?.value}function J(F){return F.properties?.find(B=>B.key===a.SupportLink)?.value}function V(F){return F.indexOf("preview")!==-1}function H(F){return F.targetPlatform?(0,y.$5o)(F.targetPlatform):"undefined"}function ie(F){const B=(0,D.$Mb)(F.versions.map(H)),U=!!F.tags?.includes(y.$Yo),Q=B.indexOf("web");return U?Q===-1&&B.push("web"):Q!==-1&&B.splice(Q,1),B}function se(F,B){for(let U=0;U<F.length;U++){const Q=F[U];if(Q.version===F[U-1]?.version){let x=U;if(H(Q)===B)for(;x>0&&F[x-1].version===Q.version;)x--;x!==U&&(F.splice(U,1),F.splice(x,0,Q))}}return F}function he(F,B,U){F.telemetryData={index:B,querySource:U,queryActivityId:F.queryContext?.[r]}}function ee(F,B,U,Q){const x=F.versions[0],te={manifest:T(B,o.Manifest),readme:T(B,o.Details),changelog:T(B,o.Changelog),license:T(B,o.License),repository:R(B),download:M(B),icon:T(B,o.Icon),signature:T(B,o.Signature),coreTranslations:C(B)};return{type:"gallery",identifier:{id:(0,p.$Dp)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:B.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:G(x),description:F.shortDescription??"",installCount:k(F.statistics,"install"),rating:k(F.statistics,"averagerating"),ratingCount:k(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:U,assets:te,properties:{dependencies:q(B,a.Dependency),extensionPack:q(B,a.ExtensionPack),engine:Y(B),localizedLanguages:Z(B),targetPlatform:H(B),isPreReleaseVersion:K(B)},hasPreReleaseVersion:K(x),hasReleaseVersion:!0,preview:V(F.flags),isSigned:!!te.signature,queryContext:Q,supportLink:J(x)}}let W=class{constructor(B,U,Q,x,te,_,oe,ue){this.k=U,this.l=Q,this.n=x,this.o=te,this.q=_,this.u=oe,this.w=ue;const $e=oe.extensionsGallery,de=$e?.servicePPEUrl&&ue.getValue("_extensionsGallery.enablePPE");this.d=de?$e.servicePPEUrl:$e?.serviceUrl,this.g=de?void 0:$e?.searchUrl,this.h=$e?.controlUrl,this.j=(0,u.$_p)(oe.version,oe,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,U,Q){const x=N.CancellationToken.isCancellationToken(U)?{}:U,te=N.CancellationToken.isCancellationToken(U)?U:Q,_=[],oe=[],ue=[],$e=[];let de=!0;for(const Ee of B){Ee.uuid?oe.push(Ee.uuid):_.push(Ee.id);const Pe=!!(Ee.version||Ee.preRelease);ue.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Pe}),Ee.version&&$e.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Pe}if(!oe.length&&!_.length)return[];let ge=new v().withPage(1,B.length);oe.length&&(ge=ge.withFilter(i.ExtensionId,...oe)),_.length&&(ge=ge.withFilter(i.ExtensionName,..._)),(x.queryAllVersions||de)&&(ge=ge.withFlags(ge.flags,n.IncludeVersions)),x.source&&(ge=ge.withSource(x.source));const{extensions:be}=await this.z(ge,{targetPlatform:x.targetPlatform??t,includePreRelease:ue,versions:$e,compatible:!!x.compatible,productVersion:x.productVersion??{version:this.u.version,date:this.u.date}},te);return x.source&&be.forEach((Ee,Pe)=>he(Ee,Pe,x.source)),be}async getCompatibleExtension(B,U,Q,x={version:this.u.version,date:this.u.date}){if((0,y.$7o)(B.allTargetPlatforms,Q))return null;if(await this.isExtensionCompatible(B,U,Q))return B;const te=new v().withFlags(n.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,B.identifier.uuid),{extensions:_}=await this.z(te,{targetPlatform:Q,compatible:!0,includePreRelease:U,productVersion:x},N.CancellationToken.None);return _[0]||null}async isExtensionCompatible(B,U,Q,x={version:this.u.version,date:this.u.date}){if(!(0,y.$8o)(B.properties.targetPlatform,B.allTargetPlatforms,Q)||!U&&B.properties.isPreReleaseVersion)return!1;let te=B.properties.engine;if(!te){const _=await this.getManifest(B,N.CancellationToken.None);if(!_)throw new Error("Manifest was not found");te=_.engines.vscode}return(0,l.$Qp)(te,x.version,x.date)}async y(B,U,Q,x,te,_,oe={version:this.u.version,date:this.u.date}){if(!(0,y.$8o)(H(U),te,_)||Q!=="any"&&K(U)!==(Q==="prerelease"))return!1;if(x)try{const ue=await this.E(B,U);if(!(0,l.$Qp)(ue,oe.version,oe.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,L.$0)(ue)),!1}return!0}async query(B,U){let Q=B.text||"";const x=B.pageSize??50;let te=new v().withPage(1,x);Q?(Q=Q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,be)=>(te=te.withFilter(i.Category,be||ge),"")),Q=Q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ge,be)=>(te=te.withFilter(i.Tag,be||ge),"")),Q=Q.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(i.Featured),"")),Q=Q.trim(),Q&&(Q=Q.length<200?Q:Q.substring(0,200),te=te.withFilter(i.SearchText,Q)),te=te.withSortBy(0)):B.ids?te=te.withFilter(i.ExtensionId,...B.ids):B.names?te=te.withFilter(i.ExtensionName,...B.names):te=te.withSortBy(4),typeof B.sortBy=="number"&&(te=te.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(te=te.withSortOrder(B.sortOrder)),B.source&&(te=te.withSource(B.source));const _=async(de,ge)=>{const{extensions:be,total:Ee}=await this.z(de,{targetPlatform:t,compatible:!1,includePreRelease:!!B.includePreRelease,productVersion:B.productVersion??{version:this.u.version,date:this.u.date}},ge);return be.forEach((Pe,Re)=>he(Pe,(de.pageNumber-1)*de.pageSize+Re,B.source)),{extensions:be,total:Ee}},{extensions:oe,total:ue}=await _(te,U),$e=async(de,ge)=>{if(ge.isCancellationRequested)throw new L.$5;const{extensions:be}=await _(te.withPage(de+1),ge);return be};return{firstPage:oe,total:ue,pageSize:te.pageSize,getPage:$e}}async z(B,U,Q){const x=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),U.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:te,total:_,context:oe}=await this.B(B,Q);if(!(B.flags&n.IncludeLatestVersionOnly)){const ge=[];for(const be of te){const Ee=await this.A(be,U,oe);Ee&&ge.push(Ee)}return{extensions:ge,total:_}}const $e=[],de=new Map;for(let ge=0;ge<te.length;ge++){const be=te[ge],Ee={id:(0,p.$Dp)(be.publisher.publisherName,be.extensionName),uuid:be.extensionId},Pe=(0,I.$eg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(le=>(0,p.$yp)(le,Ee))?.includePreRelease;if(U.compatible&&(0,y.$7o)(ie(be),U.targetPlatform))continue;const Re=await this.A(be,U,oe);!Re||Re.properties.isPreReleaseVersion&&(!Pe||!Re.hasReleaseVersion)||!Re.properties.isPreReleaseVersion&&Re.properties.targetPlatform!==U.targetPlatform&&Re.hasPreReleaseVersion?de.set(be.extensionId,ge):$e.push([ge,Re])}if(de.size){const ge=new $.$be,be=new v().withFlags(x&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,de.size).withFilter(i.ExtensionId,...de.keys()),{extensions:Ee}=await this.z(be,U,Q);this.o.publicLog2("galleryService:additionalQuery",{duration:ge.elapsed(),count:de.size});for(const Pe of Ee){const Re=de.get(Pe.identifier.uuid);$e.push([Re,Pe])}}return{extensions:$e.sort((ge,be)=>ge[0]-be[0]).map(([,ge])=>ge),total:_}}async A(B,U,Q){const x={id:(0,p.$Dp)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},te=U.versions?.find($e=>(0,p.$yp)($e,x))?.version,_=(0,I.$eg)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find($e=>(0,p.$yp)($e,x))?.includePreRelease,oe=ie(B),ue=se(B.versions,U.targetPlatform);if(U.compatible&&(0,y.$7o)(oe,U.targetPlatform))return null;for(let $e=0;$e<ue.length;$e++){const de=ue[$e];if(!(te&&de.version!==te)){if(await this.y((0,p.$Dp)(B.publisher.publisherName,B.extensionName),de,_?"any":"release",U.compatible,oe,U.targetPlatform,U.productVersion))return ee(B,de,oe,Q);if(te&&de.version===te)return null}}return te||U.compatible?null:ee(B,B.versions[0],oe)}async B(B,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,s(n.Unpublished));const Q=await this.j,x=JSON.stringify(B.raw),te={...Q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)},_=new $.$be;let oe,ue,$e=0;try{if(oe=await this.k.request({type:"POST",url:this.g&&B.criteria.some(ge=>ge.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:x,headers:te},U),oe.res.statusCode&&oe.res.statusCode>=400&&oe.res.statusCode<500)return{galleryExtensions:[],total:$e};const de=await(0,f.$Xp)(oe);if(de){const ge=de.results[0],be=ge.extensions,Ee=ge.resultMetadata&&ge.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return $e=Ee&&Ee.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:be,total:$e,context:{[r]:oe.res.headers.activityid}}}return{galleryExtensions:[],total:$e}}catch(de){const ge=(0,L.$4)(de)?"Cancelled":(0,L.$0)(de).startsWith("XHR timeout")?"Timeout":"Failed";throw ue=new y.$$o((0,L.$0)(de),ge),ue}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(x.length),duration:_.elapsed(),success:!!oe&&(0,f.$Tp)(oe),responseBodySize:oe?.res.headers["Content-Length"],statusCode:oe?String(oe.res.statusCode):void 0,errorCode:ue?.code,count:String($e)})}}async reportStatistic(B,U,Q,x){if(!this.isEnabled())return;const te=A.$o?this.x(`/itemName/${B}.${U}/version/${Q}/statType/${x==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${U}/${Q}/stats?statType=${x}`),_=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.j,Accept:_};try{await this.k.request({type:"POST",url:te,headers:ue},N.CancellationToken.None)}catch{}}async download(B,U,Q){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const x=(0,p.$Gp)(B),te=new Date().getTime(),_=Q===2?"install":Q===3?"update":"",oe=_?{uri:`${B.assets.download.uri}${P.URI.parse(B.assets.download.uri).query?"&":"?"}${_}=true`,fallbackUri:`${B.assets.download.fallbackUri}${P.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${_}=true`}:B.assets.download,ue=B.queryContext?.[r]?{[r]:B.queryContext[r]}:void 0,$e=await this.D(B.identifier.id,oe,o.VSIX,ue?{headers:ue}:void 0);try{await this.q.writeFile(U,$e.stream)}catch(de){try{await this.q.del(U)}catch(ge){this.l.warn(`Error while deleting the file ${U.toString()}`,(0,L.$0)(ge))}throw new y.$$o((0,L.$0)(de),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...x,duration:new Date().getTime()-te})}async downloadSignatureArchive(B,U){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const Q=await this.D(B.identifier.id,B.assets.signature,o.Signature);try{await this.q.writeFile(U,Q.stream)}catch(x){try{await this.q.del(U)}catch(te){this.l.warn(`Error while deleting the file ${U.toString()}`,(0,L.$0)(te))}throw new y.$$o((0,L.$0)(x),"DownloadFailedWriting")}}async getReadme(B,U){if(B.assets.readme){const Q=await this.D(B.identifier.id,B.assets.readme,o.Details,{},U);return await(0,f.$Wp)(Q)||""}return""}async getManifest(B,U){if(B.assets.manifest){const Q=await this.D(B.identifier.id,B.assets.manifest,o.Manifest,{},U),x=await(0,f.$Wp)(Q);return x?JSON.parse(x):null}return null}async C(B,U,Q){const x=T(U,o.Manifest);if(!x)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},_=await this.D(B,x,o.Manifest,{headers:te});return await(0,f.$Xp)(_)}async getCoreTranslation(B,U){const Q=B.assets.coreTranslations.filter(x=>x[0]===U.toUpperCase())[0];if(Q){const x=await this.D(B.identifier.id,Q[1],Q[0]),te=await(0,f.$Wp)(x);return te?JSON.parse(te):null}return null}async getChangelog(B,U){if(B.assets.changelog){const Q=await this.D(B.identifier.id,B.assets.changelog,o.Changelog,{},U);return await(0,f.$Wp)(Q)||""}return""}async getAllCompatibleVersions(B,U,Q){let x=new v().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?x=x.withFilter(i.ExtensionId,B.identifier.uuid):x=x.withFilter(i.ExtensionName,B.identifier.id);const{galleryExtensions:te}=await this.B(x,N.CancellationToken.None);if(!te.length)return[];const _=ie(te[0]);if((0,y.$7o)(_,Q))return[];const oe=[];await Promise.all(te[0].versions.map(async de=>{try{await this.y(B.identifier.id,de,U?"any":"release",!0,_,Q)&&oe.push(de)}catch{}}));const ue=[],$e=new Set;for(const de of se(oe,Q))$e.has(de.version)||($e.add(de.version),ue.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:K(de)}));return ue}async D(B,U,Q,x={},te=N.CancellationToken.None){const _=await this.j,oe={type:"GET"},ue={..._,...x.headers||{}};x={...x,...oe,headers:ue};const $e=U.uri,de=U.fallbackUri,ge={...x,url:$e};try{const be=await this.k.request(ge,te);if(be.res.statusCode===200)return be;const Ee=await(0,f.$Wp)(be);throw new Error(`Expected 200, got back ${be.res.statusCode} instead.

${Ee}`)}catch(be){if((0,L.$4)(be))throw be;const Ee=(0,L.$0)(be);this.o.publicLog2("galleryService:cdnFallback",{extension:B,assetType:Q,message:Ee});const Pe={...x,url:de};return this.k.request(Pe,te)}}async E(B,U){let Q=Y(U);if(!Q){this.o.publicLog2("galleryService:engineFallback",{extension:B,version:U.version});const x=await this.C(B,U,N.CancellationToken.None);if(!x)throw new Error("Manifest was not found");Q=x.engines.vscode}return Q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,f.$Xp)(B),Q=[],x={},te=[];if(U){for(const _ of U.malicious)Q.push({id:_});if(U.migrateToPreRelease)for(const[_,oe]of Object.entries(U.migrateToPreRelease))(!oe.engine||(0,l.$Qp)(oe.engine,this.u.version,this.u.date))&&(x[_.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[_,oe]of Object.entries(U.deprecated))oe&&(x[_.toLowerCase()]=(0,I.$eg)(oe)?{}:oe);if(U.search)for(const _ of U.search)te.push(_)}return{malicious:Q,deprecated:x,search:te}}};W=ve([X(1,f.$Rp),X(2,b.$5j),X(3,E.$Fi),X(4,g.$4l),X(5,c.$5k),X(6,m.$lk),X(7,d.$5i)],W);let z=class extends W{constructor(B,U,Q,x,te,_,oe,ue){super(B,U,Q,x,te,_,oe,ue)}};e.$bq=z,e.$bq=z=ve([X(0,h.$5p),X(1,f.$Rp),X(2,b.$5j),X(3,E.$Fi),X(4,g.$4l),X(5,c.$5k),X(6,m.$lk),X(7,d.$5i)],z);let j=class extends W{constructor(B,U,Q,x,te,_,oe){super(void 0,B,U,Q,x,te,_,oe)}};e.$cq=j,e.$cq=j=ve([X(0,f.$Rp),X(1,b.$5j),X(2,E.$Fi),X(3,g.$4l),X(4,c.$5k),X(5,m.$lk),X(6,d.$5i)],j)}),define(ae[82],ce([0,1,4,3,2,19,33,24,17,9,13]),function(ne,e,D,N,L,A,O,I,P,d,E){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$_v=e.$$v=void 0,e.$$v=(0,D.$yi)("IExtensionStorageService");const p=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends L.$Uc{static{y=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,O.$Cp)(b.id)}@${b.version}`}static c(b){const m=p.exec(b);if(m&&m[1])return{id:m[1],version:m[2]}}static async removeOutdatedExtensionVersions(b,m){const f=await b.getInstalled(),u=[];for(const[h,g]of y.f(m)){const $=f.find(t=>(0,O.$yp)(t.identifier,{id:h}))?.manifest.version;for(const t of g)$!==t&&u.push(y.b({id:h,version:t}))}for(const h of u)m.remove(h,0)}static f(b){const m=new Map,f=b.keys(0,1);for(const u of f){const h=y.c(u);if(h){let g=m.get(h.id.toLowerCase());g||m.set(h.id.toLowerCase(),g=[]),g.push(h.version)}}return m}constructor(b,m,f){super(),this.j=b,this.m=m,this.n=f,this.g=this.B(new N.$fe),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=y.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new L.$Tc))(u=>this.r(u)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const m=y.c(b.key);if(m){if(this.j.get(b.key,0)===void 0)this.h.delete(m.id.toLowerCase());else{let f=this.h.get(m.id.toLowerCase());f||this.h.set(m.id.toLowerCase(),f=[]),f.push(m.version),this.g.fire()}return}}s(b){if((0,E.$$f)(b))return b;const m=b.manifest?b.manifest.publisher:b.publisher,f=b.manifest?b.manifest.name:b.name;return(0,O.$Bp)(m,f)}getExtensionState(b,m){const f=this.s(b),u=this.getExtensionStateRaw(b,m);if(u)try{return JSON.parse(u)}catch(h){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${f}, global: ${m}): ${h}`)}}getExtensionStateRaw(b,m){const f=this.s(b),u=this.j.get(f,m?0:1);return u&&u?.length>y.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${f}, global: ${m}): ${u.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),u}setExtensionState(b,m,f){const u=this.s(b);m===void 0?this.j.remove(u,f?0:1):this.j.store(u,JSON.stringify(m),f?0:1,1)}setKeysForSync(b,m){this.j.store(y.b(b),JSON.stringify(m),0,1)}getKeysForSync(b){const m=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],f=this.j.get(y.b(b),0),u=f?JSON.parse(f):void 0;return u&&m?(0,P.$Mb)([...u,...m]):u||m}addToMigrationList(b,m){if(b!==m){const f=this.t.filter(u=>!u.includes(b)&&!u.includes(m));f.push([b,m]),this.t=f}}getSourceExtensionToMigrate(b){const m=this.t.find(([,f])=>b===f);return m?m[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const m=JSON.parse(b);if(Array.isArray(m))return m}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$_v=l,e.$_v=l=y=ve([X(0,A.$5p),X(1,I.$lk),X(2,d.$5j)],l)}),define(ae[255],ce([0,1,2,29,82,231,114,9,19]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;let d=class extends D.$Uc{constructor(y,p,l,c,b,m){super(),y.cleanUp(),(0,A.$44b)(y,p,l,c,m),L.$_v.removeOutdatedExtensionVersions(y,b)}};e.$pfc=d,e.$pfc=d=ve([X(0,O.$Hq),X(1,N.$0o),X(2,L.$$v),X(3,N.$dp),X(4,P.$5p),X(5,I.$5j)],d)}),define(ae[256],ce([0,1,29,12,24,16,96,57,19,22,230]),function(ne,e,D,N,L,A,O,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wfc=void 0;let y=class extends E.$Lbc{constructor(l,c,b,m,f,u,h,g){super(l.userHome,f,c,b,m,u,h,g)}};e.$wfc=y,e.$wfc=y=ve([X(0,A.$Gi),X(1,d.$4l),X(2,D.$ap),X(3,P.$5p),X(4,I.$mdc),X(5,O.$L4b),X(6,N.$5k),X(7,L.$lk)],y)}),define(ae[257],ce([0,1,104,3,22,16,2,9,14,67,24,5,6,99,21,171,37,19,13,133,20]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sfc=void 0;const $=[D.$lfc,D.$mfc],t="remoteTunnelSession",r="remoteTunnelIsService";let n=class extends O.$Uc{constructor(a,w,S,v,k,C,R){super(),this.y=a,this.z=w,this.C=S,this.D=C,this.F=R,this.f=new N.$fe,this.onDidTokenFailed=this.f.event,this.g=new N.$fe,this.onDidChangeTunnelStatus=this.g.event,this.h=new N.$fe,this.onDidChangeMode=this.h.event,this.n=D.$jfc,this.w=!1,this.I=(M,T)=>{T?this.j.error(M):this.j.info(M)},this.j=this.B(v.createLogger((0,g.$_g)(S.logsHome,`${D.$nfc}.log`),{id:D.$nfc,name:D.$ofc})),this.t=new p.$vh(100),this.B(this.j.onDidChangeLogLevel(M=>this.j.info("Log level changed to "+(0,I.$hk)(M)))),this.B(k.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(C.onDidChangeConfiguration(M=>{$.some(T=>M.affectsConfiguration(T))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=D.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){i(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(w){this.j.error(w)}return this.s}J(){if(!this.u){let a;y.$j?a=this.C.appRoot:a=(0,P.$mc)((0,P.$mc)(this.C.appRoot)),this.u=(0,P.$jc)(a,"bin",`${this.z.tunnelApplicationName}${y.$i?".exe":""}`)}return this.u}async startTunnel(a){if(i(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(w){this.j.error(w)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(D.$jfc);try{a&&this.O("uninstallService",["service","uninstall"])}catch(w){this.j.error(w)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(D.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",w=!1;const S=(T,q)=>{q?this.j.error(T):a+=T,!this.C.isBuilt&&T.startsWith("   Compiling")&&this.G(D.TunnelStates.connecting((0,b.localize)(0,null)))},v=this.O("status",["status"],S);this.r=v;try{if(await v,this.r!==v)return;let T;try{T=JSON.parse(a.trim().split(`
`).find(q=>q.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(D.TunnelStates.disconnected());return}if(w=T.service_installed,this.j.info(T.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!T.tunnel&&!this.n.active){this.G(D.TunnelStates.disconnected());return}}catch(T){this.j.error(T),this.G(D.TunnelStates.disconnected());return}finally{this.r===v&&(this.r=void 0)}const k=this.n.active?this.n.session:void 0;if(k&&k.token){const T=k.token;this.G(D.TunnelStates.connecting((0,b.localize)(1,null,k.accountLabel,k.providerId)));const q=(K,Z)=>{K=K.replaceAll(T,"*".repeat(4)),S(K,Z)},Y=this.O("login",["user","login","--provider",k.providerId,"--access-token",T,"--log",(0,I.$hk)(this.j.getLevel())],q);this.r=Y;try{if(await Y,this.r!==Y)return}catch(K){this.j.error(K),this.r=void 0,this.f.fire(k),this.G(D.TunnelStates.disconnected(k));return}}const C=this.Q();C?this.G(D.TunnelStates.connecting((0,b.localize)(2,null,C))):this.G(D.TunnelStates.connecting((0,b.localize)(3,null)));const R=["--accept-server-license-terms","--log",(0,I.$hk)(this.j.getLevel())];C?R.push("--name",C):R.push("--random-name");let M=!1;return this.n.active&&this.n.asService&&!w&&(M=await this.M(R)===!1),this.N(k,R,M)}async M(a){let w;try{w=await this.O("serviceInstall",["service","install",...a])}catch(S){this.j.error(S),w=1}if(w!==0){const S=(0,b.localize)(4,null);return this.j.warn(S),this.G(D.TunnelStates.connecting(S)),!1}return!0}async N(a,w,S){w.push("--parent-process-id",String(process.pid)),this.P()&&w.push("--no-sleep");let v=!1;const k=this.O("tunnel",w,(C,R)=>{R?this.j.error(C):this.j.info(C),C.includes("Connected to an existing tunnel process")&&(v=!0);const M=C.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(M){const T={link:M[1],domain:M[2],tunnelName:M[4],isAttached:v};this.G(D.TunnelStates.connected(T,S))}else C.match(/error refreshing token/)&&(k.cancel(),this.f.fire(a),this.G(D.TunnelStates.disconnected(a)))});this.r=k,k.finally(()=>{k===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=D.$jfc,this.G(D.TunnelStates.disconnected()))})}O(a,w,S=this.I){return(0,p.$lh)(v=>new Promise((k,C)=>{v.isCancellationRequested&&k(-1);let R;const M=["ignore","pipe","pipe"];if(v.onCancellationRequested(()=>{R&&(this.j.info(`${a} terminating(${R.pid})`),R.kill())}),!this.C.isBuilt)S(`Building tunnel CLI from sources and run
`,!1),S(`${a} Spawning: cargo run -- tunnel ${w.join(" ")}
`,!1),R=(0,d.spawn)("cargo",["run","--","tunnel",...w],{cwd:(0,P.$jc)(this.C.appRoot,"cli"),stdio:M});else{S(`Running tunnel CLI
`,!1);const T=this.J();S(`${a} Spawning: ${T} tunnel ${w.join(" ")}
`,!1),R=(0,d.spawn)(T,["tunnel",...w],{cwd:(0,m.homedir)(),stdio:M})}R.stdout.pipe(new h.$cW(`
`)).on("data",T=>{if(R){const q=T.toString();S(q,!1)}}),R.stderr.pipe(new h.$cW(`
`)).on("data",T=>{if(R){const q=T.toString();S(q,!0)}}),R.on("exit",T=>{R&&(S(`${a} exit(${R.pid}): + ${T} `,!1),R=void 0,k(T||0))}),R.on("error",T=>{R&&(S(`${a} error(${R.pid}): + ${T} `,!0),R=void 0,C())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(D.$mfc)}Q(){let a=this.D.getValue(D.$lfc)||(0,m.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(t,-1),w=this.F.getBoolean(r,-1,!1);if(a){const S=JSON.parse(a);if(S&&(0,u.$$f)(S.accountLabel)&&(0,u.$$f)(S.sessionId)&&(0,u.$$f)(S.providerId))return{active:!0,session:S,asService:w};this.j.error("Problems restoring session from storage, invalid format",S)}}catch(a){this.j.error("Problems restoring session from storage",a)}return D.$jfc}S(a){if(a.active){const w={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(t,JSON.stringify(w),-1,1),this.F.store(r,a.asService,-1,1)}else this.F.remove(t,-1),this.F.remove(r,-1)}};e.$sfc=n,e.$sfc=n=ve([X(0,L.$4l),X(1,E.$lk),X(2,A.$Gi),X(3,I.$6j),X(4,l.$qfc),X(5,c.$5i),X(6,f.$5p)],n);function s(o,a){return o&&a?o.sessionId===a.sessionId&&o.providerId===a.providerId&&o.token===a.token:o===a}const i=(o,a)=>o.active!==a.active?!1:o.active&&a.active?o.asService===a.asService&&s(o.session,a.session):!0}),define(ae[258],ce([0,1,6,2,23,20,69,19,77,18]),function(ne,e,D,N,L,A,O,I,P,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xfc=void 0;class E extends I.$7p{constructor(p,l,c,b){super(),this.bb=p,this.cb=l,this.db=c,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new N.$Tc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new N.$Tc),this.ab=this.hb(this.bb)}fb(){const p=this.B(new P.$$Kb(this.db.getChannel("storage"))),l=this.B(new O.$1p(p));return this.B(l.onDidChangeStorage(c=>this.u(-1,c))),l}gb(p){this.X.clear(),this.W=p;let l;if((0,I.$8p)(p))l=this.U;else{const c=this.X.add(new P.$_Kb(this.db.getChannel("storage"),p));l=this.X.add(new O.$1p(c))}return this.X.add(l.onDidChangeStorage(c=>this.u(0,c))),l}hb(p){this.$.clear(),this.Z=p?.id;let l;if(p){const c=this.$.add(new P.$aLb(this.db.getChannel("storage"),p));l=this.$.add(new O.$1p(c)),this.$.add(l.onDidChangeStorage(b=>this.u(1,b)))}return l}async O(){await D.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(p){switch(p){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(p){switch(p){case-1:return this.s.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:L.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$_g)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:L.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(I.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(p){if(!this.M(this.W,p))return;const l=this.Y,c=l.items;l!==this.U&&await l.close(),this.Y=this.gb(p),await this.Y.init(),this.N(c,this.Y,0)}async S(p,l){const c=this.ab,b=c?.items??new Map;await c?.close(),this.ab=this.hb(p),await this.ab.init(),this.N(b,this.ab,1)}hasScope(p){return(0,d.$Dl)(p)?this.W.id===p.id:this.Z===p.id}}e.$xfc=E}),define(ae[259],ce([0,1,3,2,18,91]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iQ=e.$hQ=void 0;class O{constructor(d,E){this.a=d,this.b=E}listen(d,E){const y=this.b(d);switch(E){case"onDidChangeProfiles":return D.Event.map(this.a.onDidChangeProfiles,p=>({all:p.all.map(l=>(0,A.$Cn)({...l},y)),added:p.added.map(l=>(0,A.$Cn)({...l},y)),removed:p.removed.map(l=>(0,A.$Cn)({...l},y)),updated:p.updated.map(l=>(0,A.$Cn)({...l},y))}))}throw new Error(`Invalid listen ${E}`)}async call(d,E,y){const p=this.b(d);switch(E){case"createProfile":{const l=await this.a.createProfile(y[0],y[1],y[2]);return(0,A.$Cn)({...l},p)}case"updateProfile":{let l=(0,L.$Fl)((0,A.$Dn)(y[0],p),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,y[1]),(0,A.$Cn)({...l},p)}case"removeProfile":{const l=(0,L.$Fl)((0,A.$Dn)(y[0],p),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${E}`)}}e.$hQ=O;class I extends N.$Uc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(d,E,y){super(),this.profilesHome=E,this.f=y,this.a=[],this.b=this.B(new D.$fe),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=d.map(p=>(0,L.$Fl)(p,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(p=>{const l=p.added.map(m=>(0,L.$Fl)(m,this.profilesHome.scheme)),c=p.removed.map(m=>(0,L.$Fl)(m,this.profilesHome.scheme)),b=p.updated.map(m=>(0,L.$Fl)(m,this.profilesHome.scheme));this.a=p.all.map(m=>(0,L.$Fl)(m,this.profilesHome.scheme)),this.b.fire({added:l,removed:c,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(d){this.c=d}isEnabled(){return this.c}async createNamedProfile(d,E,y){const p=await this.f.call("createNamedProfile",[d,E,y]);return(0,L.$Fl)(p,this.profilesHome.scheme)}async createProfile(d,E,y,p){const l=await this.f.call("createProfile",[d,E,y,p]);return(0,L.$Fl)(l,this.profilesHome.scheme)}async createTransientProfile(d){const E=await this.f.call("createTransientProfile",[d]);return(0,L.$Fl)(E,this.profilesHome.scheme)}async setProfileForWorkspace(d,E){await this.f.call("setProfileForWorkspace",[d,E])}removeProfile(d){return this.f.call("removeProfile",[d])}async updateProfile(d,E){const y=await this.f.call("updateProfile",[d,E]);return(0,L.$Fl)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$iQ=I}),define(ae[60],ce([0,1,2,69,4,19,3,77,18]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eLb=e.$dLb=e.$cLb=void 0,e.$cLb=(0,L.$yi)("IUserDataProfileStorageService");let d=class extends D.$Uc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async c=>this.b(c))}async updateStorageData(l,c,b){return this.withProfileScopedStorageService(l,async m=>this.c(m,c,b))}async withProfileScopedStorageService(l,c){if(this.a.hasScope(l))return c(this.a);const b=await this.g(l),m=new y(b);try{await m.initialize();const f=await c(m);return await m.flush(),f}finally{m.dispose(),await this.f(b)}}b(l){const c=new Map,b=m=>{for(const f of l.keys(0,m))c.set(f,{value:l.get(f,0),target:m})};return b(0),b(1),c}c(l,c,b){l.storeAll(Array.from(c.entries()).map(([m,f])=>({key:m,value:f,scope:0,target:b})),!0)}async f(l){try{await l.close()}finally{(0,D.$Oc)(l)&&l.dispose()}}};e.$dLb=d,e.$dLb=d=ve([X(0,A.$5p)],d);class E extends d{constructor(l,c,b,m){super(b),this.j=l;const f=l.getChannel("profileStorageListener"),u=this.B(new D.$Vc);this.h=this.B(new O.$fe({onWillAddFirstListener:()=>{u.value=f.listen("onDidChange")(h=>{m.trace("profile storage changes",h),this.h.fire({targetChanges:h.targetChanges.map(g=>(0,P.$Fl)(g,c.profilesHome.scheme)),valueChanges:h.valueChanges.map(g=>({...g,profile:(0,P.$Fl)(g.profile,c.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(l){const c=this.j.getChannel("storage");return(0,A.$8p)(l)?new I.$$Kb(c):new I.$_Kb(c,l)}}e.$eLb=E;class y extends A.$7p{constructor(l){super({flushInterval:100}),this.s=this.B(new N.$1p(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(ae[260],ce([0,1,19,9,18,56,60]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cfc=void 0;let I=class extends O.$eLb{constructor(d,E,y,p){super(d,E,y,p)}};e.$cfc=I,e.$cfc=I=ve([X(0,A.$Bec),X(1,L.$El),X(2,D.$5p),X(3,N.$5j)],I)}),define(ae[39],ce([0,1,17,6,15,26,3,35,2,27,13,176,21,16,12,9,45,19,22,28,25,18]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lMb=e.$kMb=e.$jMb=e.$iMb=void 0,e.$fMb=t,e.$gMb=r,e.$hMb=n;function t(w){return!!(w&&w.ref!==void 0&&typeof w.ref=="string"&&w.ref!==""&&w.syncData!==void 0&&(w.syncData===null||r(w.syncData)))}function r(w){return!!(w&&w.version!==void 0&&typeof w.version=="number"&&w.content!==void 0&&typeof w.content=="string"&&(Object.keys(w).length===2||Object.keys(w).length===3&&w.machineId!==void 0&&typeof w.machineId=="string"))}function n(w,S){return`${(0,d.$3f)(w)}${S.isDefault?"":` (${S.name})`}`}let s=class extends P.$Uc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(S,v,k,C,R,M,T,q,Y,K,Z,G){super(),this.syncResource=S,this.collection=v,this.G=k,this.H=C,this.I=R,this.J=M,this.L=T,this.M=q,this.N=Y,this.O=K,this.P=Z,this.c=null,this.m="idle",this.n=this.B(new O.$fe),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new O.$fe),this.onDidChangeConflicts=this.t.event,this.u=this.B(new N.$wh(50)),this.w=this.B(new O.$fe),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(S.syncResource,S.profile),this.h=G.extUri,this.f=this.h.joinPath(C.userDataSyncHome,...(0,g.$nmb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource)),this.g=this.h.joinPath(this.f,g.$Imb),this.y=(0,g.$omb)(S.profile.isDefault?void 0:S.profile.id,S.syncResource,C,this.h),this.j=(0,m.$$p)(C,k,R)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const S=await this.c;this.c=null;const v=await this.Y(S.remoteUserData,S.lastSyncUserData,!0,this.ob());this.S(v)}else{this.O.trace(`${this.D}: Checking for local changes...`);const S=await this.getLastSyncUserData();(S?await this.ub(S):!0)&&this.w.fire()}}S(S){this.m!==S&&(this.m=S,this.n.fire(S))}async sync(S,v={}){await this.U(S,!0,this.ob(),v)}async preview(S,v,k={}){return this.U(S,!1,v,k)}async apply(S,v={}){try{this.F={...v};const k=await this.ab(S);return this.S(k),this.c}finally{this.F={}}}async U(S,v,k,C){try{if(this.F={...C},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let R="idle";try{const M=await this.getLastSyncUserData(),T=await this.X(S,M);return R=await this.Y(T,M,v,k),R==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):R==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(R)}}finally{this.F={}}}async replace(S){const v=this.kb(S);if(!v)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const k=await this.getLastSyncUserData(),C=await this.X(null,k),R=await this.W(C),M=await this.qb({ref:C.ref,syncData:v},k,R,this.ob(),A.CancellationToken.None),T=[];for(const q of M){const Y=await this.sb(q,q.remoteResource,void 0,A.CancellationToken.None),{remoteChange:K}=await this.sb(q,q.previewResource,q.remoteContent,A.CancellationToken.None);T.push([q,{...Y,remoteChange:K!==0?K:2}])}await this.tb(C,k,T,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(S){const v=await this.j;return!!S.syncData?.machineId&&S.syncData.machineId===v}async X(S,v){if(v){const k=S?S[this.resource]:void 0;if(v.ref===k||k===void 0&&v.syncData===null)return v}return this.getRemoteUserData(v)}async Y(S,v,k,C){if(S.syncData&&S.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new g.$vmb((0,y.localize)(0,null,this.resource,this.pb,S.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(S,v,k,C)}catch(R){if(R instanceof g.$vmb)switch(R.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(S,v,k,C);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),S=await this.getRemoteUserData(null),v=await this.getLastSyncUserData(),this.Y(S,v,k,C)}throw R}}async Z(S,v,k,C){try{const R=await this.W(S),M=!R&&v===null&&this.gb()!==void 0,T=k&&!M;this.c||(this.c=(0,N.$lh)(Y=>this.eb(S,v,R,T,C,Y)));let q=await this.c;if(k&&M){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of q.resourcePreviews)q=await this.accept(Y.remoteResource)||q}return this.cb(q.resourcePreviews),q.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":k?await this.ab(!1):"syncing"}catch(R){throw this.c=null,R}}async merge(S){return await this.$(S,async v=>{const k=await this.rb(v,A.CancellationToken.None);await this.G.writeFile(v.previewResource,L.$He.fromString(k?.content||""));const C=k&&!k.hasConflicts?await this.sb(v,v.previewResource,void 0,A.CancellationToken.None):void 0;return v.acceptResult=C,v.mergeState=k.hasConflicts?"conflict":C?"accepted":"preview",v.localChange=C?C.localChange:k.localChange,v.remoteChange=C?C.remoteChange:k.remoteChange,v}),this.c}async accept(S,v){return await this.$(S,async k=>{const C=await this.sb(k,S,v,A.CancellationToken.None);return k.acceptResult=C,k.mergeState="accepted",k.localChange=C.localChange,k.remoteChange=C.remoteChange,k}),this.c}async discard(S){return await this.$(S,async v=>{const k=await this.rb(v,A.CancellationToken.None);return await this.G.writeFile(v.previewResource,L.$He.fromString(k.content||"")),v.acceptResult=void 0,v.mergeState="preview",v.localChange=k.localChange,v.remoteChange=k.remoteChange,v}),this.c}async $(S,v){if(!this.c)return;let k=await this.c;const C=k.resourcePreviews.findIndex(({localResource:R,remoteResource:M,previewResource:T})=>this.h.isEqual(R,S)||this.h.isEqual(M,S)||this.h.isEqual(T,S));C!==-1&&(this.c=(0,N.$lh)(async R=>{const M=[...k.resourcePreviews];return M[C]=await v(M[C]),{...k,resourcePreviews:M}}),k=await this.c,this.cb(k.resourcePreviews),k.resourcePreviews.some(({mergeState:R})=>R==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(S){if(!this.c)return"idle";const v=await this.c;return v.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":v.resourcePreviews.some(({mergeState:k})=>k!=="accepted")?"syncing":(await this.tb(v.remoteUserData,v.lastSyncUserData,v.resourcePreviews.map(k=>[k,k.acceptResult]),S),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(S){const v=S.filter(({mergeState:k})=>k==="conflict");(0,D.$ub)(this.s,v,(k,C)=>this.h.isEqual(k.previewResource,C.previewResource))||(this.s=v,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const S=await this.getLastSyncUserData();return!!S&&S.syncData!==null}async db(S){const v=this.c?await this.c:null;if(v)for(const k of v.resourcePreviews){if(this.h.isEqual(k.acceptedResource,S))return k.acceptResult?k.acceptResult.content:null;if(this.h.isEqual(k.remoteResource,S))return k.remoteContent;if(this.h.isEqual(k.localResource,S))return k.localContent;if(this.h.isEqual(k.baseResource,S))return k.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(S){(0,c.$jl)(S)!==1&&this.O.error(S)}}async eb(S,v,k,C,R,M){const T=await this.qb(S,v,k,R,M),q=[];for(const Y of T){const K=Y.previewResource.with({scheme:g.$Hmb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)q.push({...Y,acceptedResource:K,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Z=C?await this.rb(Y,M):void 0;if(M.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,L.$He.fromString(Z?.content||""));const G=Z&&!Z.hasConflicts?await this.sb(Y,Y.previewResource,void 0,M):void 0;q.push({...Y,acceptResult:G,mergeState:Z?.hasConflicts?"conflict":G?"accepted":"preview",localChange:G?G.localChange:Z?Z.localChange:Y.localChange,remoteChange:G?G.remoteChange:Z?Z.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:S,lastSyncUserData:v,resourcePreviews:q,isLastSyncFromCurrentMachine:k}}async getLastSyncUserData(){let S=this.gb();if(S||(S=await this.jb()),!S)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const v=JSON.parse(S),k=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!v.version&&!!k&&v.version!==k,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${v.version} is not compatible with current sync state version ${k}.`),await this.resetLocal(),null;let C,R=1;for(;C===void 0&&R++<6;)try{const M=await this.hb();M&&(M.ref===v.ref?C=M.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(M){if(M instanceof c.$nl&&M.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(M instanceof g.$vmb)throw M;this.O.error(M,R)}}if(C===void 0)try{const M=await this.J.resolveResourceContent(this.resource,v.ref,this.collection,this.F);C=M===null?null:this.kb(M),await this.ib({ref:v.ref,syncData:C})}catch(M){if(M instanceof g.$vmb&&M.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw M}return C===void 0?null:{...v,syncData:C}}async fb(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k=this.M.getResourceSyncStateVersion(this.resource),C={ref:S.ref,version:k,...v};this.I.store(this.z,JSON.stringify(C),-1,1),await this.ib(S)}gb(){return this.I.get(this.z,-1)}async hb(){const S=(await this.G.readFile(this.y)).value.toString();try{const v=S?JSON.parse(S):void 0;if(t(v))return v}catch(v){this.O.error(v)}}async ib(S){await this.G.writeFile(this.y,L.$He.fromString(JSON.stringify(S)))}async jb(){try{const S=await this.G.readFile(this.y),v=JSON.parse(S.value.toString());await this.G.del(this.y),v.ref&&v.content!==void 0?(this.I.store(this.z,JSON.stringify({...v,content:void 0}),-1,1),await this.ib({ref:v.ref,syncData:v.content===null?null:JSON.parse(v.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,v)}catch(S){S instanceof c.$nl&&S.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(S)}return this.I.get(this.z,-1)}async getRemoteUserData(S){const{ref:v,content:k}=await this.lb(S);let C=null;return k!==null&&(C=this.kb(k)),{ref:v,syncData:C}}kb(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.O.error(v)}throw new g.$vmb((0,y.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(S){const v=S?{ref:S.ref,content:S.syncData?JSON.stringify(S.syncData):null}:null;return this.J.readResource(this.resource,v,this.collection,this.F)}async mb(S,v){const k=await this.j,C={version:this.pb,machineId:k,content:S};try{return v=await this.J.writeResource(this.resource,JSON.stringify(C),v,this.collection,this.F),{ref:v,syncData:C}}catch(R){throw R instanceof g.$vmb&&R.code==="TooLarge"&&(R=new g.$vmb(R.message,R.code,this.resource)),R}}async nb(S){const v={version:this.pb,content:S};return this.L.writeResource(this.resource,JSON.stringify(v),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(g.$imb)}};e.$iMb=s,e.$iMb=s=ve([X(2,c.$5k),X(3,l.$Fi),X(4,f.$5p),X(5,g.$qmb),X(6,g.$rmb),X(7,g.$Amb),X(8,u.$4l),X(9,g.$Fmb),X(10,p.$5i),X(11,h.$Cl)],s);let i=class extends s{constructor(S,v,k,C,R,M,T,q,Y,K,Z,G,J){super(v,k,C,R,M,T,q,Y,K,Z,G,J),this.r=S,this.B(this.G.watch(this.h.dirname(S))),this.B(this.G.onDidFilesChange(V=>this.yb(V)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(S,v,k){try{v?await this.G.writeFile(this.r,L.$He.fromString(S),k?void 0:v):await this.G.createFile(this.r,L.$He.fromString(S),{overwrite:k})}catch(C){throw C instanceof c.$nl&&C.fileOperationResult===1||C instanceof c.$nl&&C.fileOperationResult===3?new g.$vmb(C.message,"LocalPreconditionFailed"):C}}async xb(){try{await this.G.del(this.r)}catch(S){if(!(S instanceof c.$nl&&S.fileOperationResult===1))throw S}}yb(S){S.contains(this.r)&&this.Q()}};e.$jMb=i,e.$jMb=i=ve([X(3,c.$5k),X(4,l.$Fi),X(5,f.$5p),X(6,g.$qmb),X(7,g.$rmb),X(8,g.$Amb),X(9,u.$4l),X(10,g.$Fmb),X(11,p.$5i),X(12,h.$Cl)],i);let o=class extends i{constructor(S,v,k,C,R,M,T,q,Y,K,Z,G,J,V){super(S,v,k,C,R,M,T,q,Y,K,Z,J,V),this.zb=G,this.Bb=void 0}Ab(S,v){const k=[],C=(0,I.$Ln)(S,k,{allowEmptyContent:!0,allowTrailingComma:!0});return k.length>0||!(0,E.$fg)(C)&&v!==Array.isArray(C)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$kMb=o,e.$kMb=o=ve([X(3,c.$5k),X(4,l.$Fi),X(5,f.$5p),X(6,g.$qmb),X(7,g.$rmb),X(8,g.$Amb),X(9,u.$4l),X(10,g.$Fmb),X(11,g.$Emb),X(12,p.$5i),X(13,h.$Cl)],o);let a=class{constructor(S,v,k,C,R,M,T){this.resource=S,this.g=v,this.h=k,this.j=C,this.k=R,this.l=M,this.d=T.extUri,this.f=(0,g.$omb)(void 0,this.resource,k,this.d)}async initialize({ref:S,content:v}){if(!v){this.j.info("Remote content does not exist.",this.resource);return}const k=this.m(v);if(k)try{await this.o({ref:S,syncData:k})}catch(C){this.j.error(C)}}m(S){try{const v=JSON.parse(S);if(r(v))return v}catch(v){this.j.error(v)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(S,v={}){if(v.ref||v.version)throw new Error("Cannot have core properties as additional");const k={ref:S.ref,version:void 0,...v};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(k),-1,1),await this.k.writeFile(this.f,L.$He.fromString(JSON.stringify(S)))}};e.$lMb=a,e.$lMb=a=ve([X(1,$.$El),X(2,l.$Fi),X(3,b.$5j),X(4,c.$5k),X(5,f.$5p),X(6,h.$Cl)],a)}),define(ae[116],ce([0,1,6,26,7,3,44,2,27,21,16,115,29,33,82,48,12,4,74,9,19,22,28,18,39,241,111,25,60]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t,r,n,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T_b=e.$S_b=e.$R_b=void 0,e.$P_b=S,e.$Q_b=v;async function w(M,T){const q=JSON.parse(M.content);if(M.version===1||M.version===2){const Y=(await T.getInstalled(0)).filter(K=>K.isBuiltin);for(const K of q)M.version===1&&(K.enabled===!1&&(K.disabled=!0),delete K.enabled),M.version===2&&Y.every(Z=>!(0,l.$yp)(Z.identifier,K.identifier))&&(K.installed=!0)}return q}function S(M){return JSON.parse(M.content)}function v(M,T){return M.sort((q,Y)=>!q.identifier.uuid&&Y.identifier.uuid?-1:q.identifier.uuid&&!Y.identifier.uuid?1:(0,P.$sf)(q.identifier.id,Y.identifier.id)),T?(0,O.$Wn)(M,{}):JSON.stringify(M)}let k=class extends n.$iMb{constructor(T,q,Y,K,Z,G,J,V,H,ie,se,he,ee,W,z,j,F){super({syncResource:"extensions",profile:T},q,K,Y,Z,G,J,he,ee,ie,se,z),this.Cb=V,this.Db=H,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:o.$Hmb,authority:"base"}),this.yb=this.wb.with({scheme:o.$Hmb,authority:"local"}),this.zb=this.wb.with({scheme:o.$Hmb,authority:"remote"}),this.Ab=this.wb.with({scheme:o.$Hmb,authority:"accepted"}),this.Bb=this.Eb.createInstance(C),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:U})=>!!U)),A.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),A.Event.filter(j.onDidChange,B=>B.valueChanges.some(({profile:U,changes:Q})=>this.syncResource.profile.id===U.id&&Q.some(x=>x.key===p.$bp))),W.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(T,q){const Y=T.syncData?await w(T.syncData,this.Cb):null,K=q?.skippedExtensions??[],Z=q?.builtinExtensions??null,G=q?.syncData?await w(q.syncData,this.Cb):null,{localExtensions:J,ignoredExtensions:V}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:H,remote:ie}=(0,s.$O_b)(J,Y,G,K,V,Z),se={local:H,remote:ie,content:this.Hb(J,H.added,H.updated,H.removed),localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:ie!==null?2:0},he=this.Ob(J,!1);return[{skippedExtensions:K,builtinExtensions:Z,baseResource:this.xb,baseContent:G?this.Ob(G,!1):he,localResource:this.yb,localContent:he,localExtensions:J,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:se,localChange:se.localChange,remoteChange:se.remoteChange,acceptedResource:this.Ab}]}async ub(T){const q=T.syncData?await w(T.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:K}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:Z}=(0,s.$O_b)(Y,q,q,T.skippedExtensions||[],K,T.builtinExtensions||[]);return Z!==null}Hb(T,q,Y,K){const Z=[...q,...Y],G=new Set,J=V=>{G.add(V.id.toLowerCase()),V.uuid&&G.add(V.uuid)};Z.forEach(({identifier:V})=>J(V)),K.forEach(J);for(const V of T)G.has(V.identifier.id.toLowerCase())||V.identifier.uuid&&G.has(V.identifier.uuid)||Z.push(V);return this.Ob(Z,!1)}async rb(T,q){return{...T.previewResult,hasConflicts:!1}}async sb(T,q,Y,K){if(this.h.isEqual(q,this.yb))return this.Kb(T);if(this.h.isEqual(q,this.zb))return this.Lb(T);if(this.h.isEqual(q,this.wb))return T.previewResult;throw new Error(`Invalid Resource: ${q.toString()}`)}async Kb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=(0,s.$O_b)(T.localExtensions,null,null,T.skippedExtensions,Y,T.builtinExtensions),{local:Z,remote:G}=K;return{content:T.localContent,local:Z,remote:G,localChange:Z.added.length>0||Z.removed.length>0||Z.updated.length>0?2:0,remoteChange:G!==null?2:0}}async Lb(T){const q=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(q),K=T.remoteContent?JSON.parse(T.remoteContent):null;if(K!==null){const Z=(0,s.$O_b)(T.localExtensions,K,T.localExtensions,[],Y,T.builtinExtensions),{local:G,remote:J}=Z;return{content:T.remoteContent,local:G,remote:J,localChange:G.added.length>0||G.removed.length>0||G.updated.length>0?2:0,remoteChange:J!==null?2:0}}else return{content:T.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(T,q,Y,K){let{skippedExtensions:Z,builtinExtensions:G,localExtensions:J}=Y[0][0];const{local:V,remote:H,localChange:ie,remoteChange:se}=Y[0][1];if(ie===0&&se===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(J)),Z=await this.Bb.updateLocalExtensions(V.added,V.removed,V.updated,Z,this.syncResource.profile)),H){this.O.trace(`${this.D}: Updating remote extensions...`);const he=JSON.stringify(H.all);T=await this.mb(he,K?null:T.ref),this.O.info(`${this.D}: Updated remote extensions.${H.added.length?` Added: ${JSON.stringify(H.added.map(ee=>ee.identifier.id))}.`:""}${H.updated.length?` Updated: ${JSON.stringify(H.updated.map(ee=>ee.identifier.id))}.`:""}${H.removed.length?` Removed: ${JSON.stringify(H.removed.map(ee=>ee.identifier.id))}.`:""}`)}q?.ref!==T.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),G=this.Nb(J,G),await this.fb(T,{skippedExtensions:Z,builtinExtensions:G}),this.O.info(`${this.D}: Updated last synchronized extensions.${Z.length?` Skipped: ${JSON.stringify(Z.map(he=>he.identifier.id))}.`:""}`))}Nb(T,q){const Y=new Set,K=[];for(const Z of T)Y.add(Z.identifier.id.toLowerCase()),Z.installed||K.push(Z.identifier);if(q)for(const Z of q)Y.has(Z.id.toLowerCase())||K.push(Z);return K}async resolveContent(T){if(this.h.isEqual(this.zb,T)||this.h.isEqual(this.xb,T)||this.h.isEqual(this.yb,T)||this.h.isEqual(this.Ab,T)){const q=await this.db(T);return q&&this.Ob(JSON.parse(q),!0)}return null}Ob(T,q){return v(T,q)}async hasLocalData(){try{const{localExtensions:T}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(T.some(q=>q.installed||q.disabled))return!0}catch{}return!1}};e.$R_b=k,e.$R_b=k=ve([X(2,E.$Fi),X(3,m.$5k),X(4,g.$5p),X(5,o.$qmb),X(6,o.$rmb),X(7,p.$ap),X(8,i.$7Mb),X(9,o.$Fmb),X(10,d.$5i),X(11,o.$Amb),X(12,$.$4l),X(13,c.$$v),X(14,t.$Cl),X(15,a.$cLb),X(16,f.$xi)],k);let C=class{constructor(T,q,Y,K,Z,G){this.a=T,this.b=q,this.c=Y,this.d=K,this.f=Z,this.g=G}async getLocalExtensions(T){const q=await this.a.getInstalled(void 0,T.extensionsResource),Y=this.d.getIgnoredExtensions(q);return{localExtensions:await this.j(T,async(Z,G)=>{const J=Z.getDisabledExtensions();return q.map(V=>{const{identifier:H,isBuiltin:ie,manifest:se,preRelease:he,pinned:ee,isApplicationScoped:W}=V,z={identifier:H,preRelease:he,version:se.version,pinned:!!ee};W&&!(0,b.$Wm)(se)&&(z.isApplicationScoped=W),J.some(j=>(0,l.$yp)(j,H))&&(z.disabled=!0),ie||(z.installed=!0);try{const j=G.getKeysForSync({id:H.id,version:se.version});if(j){const F=G.getExtensionState(V,!0)||{};z.state=Object.keys(F).reduce((B,U)=>(j.includes(U)&&(B[U]=F[U]),B),{})}}catch(j){this.g.info(`${(0,n.$hMb)("extensions",T)}: Error while parsing extension state`,(0,L.$0)(j))}return z})}),ignoredExtensions:Y}}async updateLocalExtensions(T,q,Y,K,Z){const G=(0,n.$hMb)("extensions",Z),J=[],V=new Map,H=[],ie=[],se=await this.a.getInstalled(void 0,Z.extensionsResource);if((T.length||Y.length)&&await this.j(Z,async(W,z)=>{await D.Promises.settled([...T,...Y].map(async j=>{const F=se.find(Q=>(0,l.$yp)(Q.identifier,j.identifier));if(F&&F.isBuiltin){j.state&&F.manifest.version===j.version&&this.h(j.state,F,F.manifest.version,z),W.getDisabledExtensions().some(x=>(0,l.$yp)(x,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${G}: Disabling extension...`,j.identifier.id),await W.disableExtension(j.identifier),this.g.info(`${G}: Disabled extension`,j.identifier.id)):(this.g.trace(`${G}: Enabling extension...`,j.identifier.id),await W.enableExtension(j.identifier),this.g.info(`${G}: Enabled extension`,j.identifier.id))),H.push(j.identifier);return}const B=j.pinned?j.version:void 0,U=(await this.c.getExtensions([{...j.identifier,version:B,preRelease:B?void 0:j.preRelease}],N.CancellationToken.None))[0];if(j.state&&(F?F.manifest.version===j.version:U)&&this.h(j.state,F||U,F?.manifest.version,z),U)try{W.getDisabledExtensions().some(x=>(0,l.$yp)(x,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${G}: Disabling extension...`,j.identifier.id,U.version),await W.disableExtension(U.identifier),this.g.info(`${G}: Disabled extension`,j.identifier.id,U.version)):(this.g.trace(`${G}: Enabling extension...`,j.identifier.id,U.version),await W.enableExtension(U.identifier),this.g.info(`${G}: Enabled extension`,j.identifier.id,U.version))),(!F||F.preRelease!==j.preRelease||F.pinned!==j.pinned||B&&F.manifest.version!==B)&&(await this.a.canInstall(U)?(J.push({extension:U,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,pinned:j.pinned,installPreReleaseVersion:j.preRelease,profileLocation:Z.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[p.$Zo]:!0,[p.$1o]:"settingsSync"}}}),V.set(U.identifier.id.toLowerCase(),j)):(this.g.info(`${G}: Skipped synchronizing extension because it cannot be installed.`,U.displayName||U.identifier.id),ie.push(j)))}catch(Q){ie.push(j),this.g.error(Q),this.g.info(`${G}: Skipped synchronizing extension`,U.displayName||U.identifier.id)}else ie.push(j),this.g.info(`${G}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),q.length){const W=se.filter(({identifier:z,isBuiltin:j})=>!j&&q.some(F=>(0,l.$yp)(z,F)));await D.Promises.settled(W.map(async z=>{this.g.trace(`${G}: Uninstalling local extension...`,z.identifier.id),await this.a.uninstall(z,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Z.extensionsResource}),this.g.info(`${G}: Uninstalled local extension.`,z.identifier.id),H.push(z.identifier)}))}const he=await this.a.installGalleryExtensions(J);for(const{identifier:W,local:z,error:j,source:F}of he){const B=F;if(z)this.g.info(`${G}: Installed extension.`,W.id,B.version),H.push(W);else{const U=V.get(W.id.toLowerCase());U&&(ie.push(U),this.g.info(`${G}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),j instanceof p.$_o&&["Incompatible","IncompatibleTargetPlatform"].includes(j.code)?this.g.info(`${G}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):j&&this.g.error(j)}}const ee=[];for(const W of K)H.some(z=>(0,l.$yp)(z,W.identifier))||ee.push(W);for(const W of ie)ee.some(z=>(0,l.$yp)(z.identifier,W.identifier))||ee.push(W);return ee}h(T,q,Y,K){const Z=K.getExtensionState(q,!0)||{},G=Y?K.getKeysForSync({id:q.identifier.id,version:Y}):void 0;G?G.forEach(J=>{Z[J]=T[J]}):Object.keys(T).forEach(J=>Z[J]=T[J]),K.setExtensionState(q,Z,!0)}async j(T,q){return this.b.withProfileScopedStorageService(T,async Y=>{const K=new I.$Tc,Z=this.f.createChild(new u.$wi([g.$5p,Y])),G=K.add(Z.createInstance(y.$yKb)),J=K.add(Z.createInstance(c.$_v));try{return await q(G,J)}finally{K.dispose()}})}};e.$S_b=C,e.$S_b=C=ve([X(0,p.$ap),X(1,a.$cLb),X(2,p.$0o),X(3,i.$7Mb),X(4,f.$xi),X(5,o.$Fmb)],C);let R=class extends n.$lMb{constructor(T,q,Y,K,Z,G,J,V){super("extensions",K,Z,G,Y,J,V),this.p=T,this.q=q}async t(T){return T.syncData?await w(T.syncData,this.p):null}u(T,q){const Y=[],K=[],Z=[];for(const G of T){if(this.q.hasToNeverSyncExtension(G.identifier.id))continue;const J=q.find(V=>(0,l.$yp)(V.identifier,G.identifier));J?(Y.push(J),G.disabled&&Z.push(G.identifier)):G.installed&&(K.push({...G.identifier,preRelease:!!G.preRelease}),G.disabled&&Z.push(G.identifier))}return{installedExtensions:Y,newExtensions:K,disabledExtensions:Z,remoteExtensions:T}}};e.$T_b=R,e.$T_b=R=ve([X(0,p.$ap),X(1,i.$7Mb),X(2,m.$5k),X(3,r.$El),X(4,E.$Fi),X(5,h.$5j),X(6,g.$5p),X(7,t.$Cl)],R)}),define(ae[117],ce([0,1,15,7,3,35,44,5,32,21,16,12,9,45,19,22,28,39,79,245,25,18,60,4]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rMb=e.$qMb=e.$pMb=e.$oMb=void 0,e.$nMb=i;const n="globalState.argv.",s=["locale"];function i(k,C){const R=k.storage?Object.keys(k.storage).sort():[],M={};return R.forEach(T=>M[T]=k.storage[T]),k.storage=M,C?(0,O.$Wn)(k,{}):JSON.stringify(k)}const o=1;let a=class extends f.$iMb{constructor(C,R,M,T,q,Y,K,Z,G,J,V,H,ie,se){super({syncResource:"globalState",profile:C},R,T,Z,H,q,Y,G,J,K,V,ie),this.Bb=M,this.pb=o,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:g.$Hmb,authority:"base"}),this.xb=this.vb.with({scheme:g.$Hmb,authority:"local"}),this.yb=this.vb.with({scheme:g.$Hmb,authority:"remote"}),this.zb=this.vb.with({scheme:g.$Hmb,authority:"accepted"}),this.Ab=se.createInstance(w),this.B(T.watch(this.h.dirname(this.H.argvResource))),this.B(L.Event.any(L.Event.filter(T.onDidFilesChange,he=>he.contains(this.H.argvResource)),L.Event.filter(M.onDidChange,he=>!!(he.targetChanges.some(ee=>this.syncResource.profile.id===ee.id)||he.valueChanges.some(({profile:ee,changes:W})=>this.syncResource.profile.id===ee.id&&W.some(z=>z.target===0)))))(()=>this.Q()))}async qb(C,R,M){const T=C.syncData?JSON.parse(C.syncData.content):null;R=R===null&&M?C:R;const q=R&&R.syncData?JSON.parse(R.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);T?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const K=await this.Jb(q),{local:Z,remote:G}=(0,h.$mMb)(Y.storage,T?T.storage:null,q?q.storage:null,K,this.O),J={content:null,local:Z,remote:G,localChange:Object.keys(Z.added).length>0||Object.keys(Z.updated).length>0||Z.removed.length>0?2:0,remoteChange:G.all!==null?2:0},V=i(Y,!1);return[{baseResource:this.wb,baseContent:q?i(q,!1):V,localResource:this.xb,localContent:V,localUserData:Y,remoteResource:this.yb,remoteContent:T?i(T,!1):null,previewResource:this.vb,previewResult:J,localChange:J.localChange,remoteChange:J.remoteChange,acceptedResource:this.zb,storageKeys:K}]}async ub(C){const R=C.syncData?JSON.parse(C.syncData.content):null;if(R===null)return!0;const M=await this.Ab.getLocalGlobalState(this.syncResource.profile),T=await this.Jb(R),{remote:q}=(0,h.$mMb)(M.storage,R.storage,R.storage,T,this.O);return q.all!==null}async rb(C,R){return{...C.previewResult,hasConflicts:!1}}async sb(C,R,M,T){if(this.h.isEqual(R,this.xb))return this.Gb(C);if(this.h.isEqual(R,this.yb))return this.Hb(C);if(this.h.isEqual(R,this.vb))return C.previewResult;throw new Error(`Invalid Resource: ${R.toString()}`)}async Gb(C){return{content:C.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(C.localUserData.storage),removed:[],updated:[],all:C.localUserData.storage},localChange:0,remoteChange:2}}async Hb(C){if(C.remoteContent!==null){const R=JSON.parse(C.remoteContent),{local:M,remote:T}=(0,h.$mMb)(C.localUserData.storage,R.storage,null,C.storageKeys,this.O);return{content:C.remoteContent,local:M,remote:T,localChange:Object.keys(M.added).length>0||Object.keys(M.updated).length>0||M.removed.length>0?2:0,remoteChange:T!==null?2:0}}else return{content:C.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(C,R,M,T){const{localUserData:q}=M[0][0],{local:Y,remote:K,localChange:Z,remoteChange:G}=M[0][1];if(Z===0&&G===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),Z!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(q)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),G!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const J=JSON.stringify({storage:K.all});C=await this.mb(J,T?null:C.ref),this.O.info(`${this.D}: Updated remote ui state.${K.added.length?` Added: ${K.added}.`:""}${K.updated.length?` Updated: ${K.updated}.`:""}${K.removed.length?` Removed: ${K.removed}.`:""}`)}R?.ref!==C.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(C),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(C){if(this.h.isEqual(this.yb,C)||this.h.isEqual(this.wb,C)||this.h.isEqual(this.xb,C)||this.h.isEqual(this.zb,C)){const R=await this.db(C);return R&&i(JSON.parse(R),!0)}return null}async hasLocalData(){try{const{storage:C}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(C).length>1||C[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(C){const R=await this.Bb.readStorageData(this.syncResource.profile),M=[],T=[];for(const[K,Z]of R)Z.target===0?M.push(K):Z.target===1&&T.push(K);const q=[...M,...T],Y=C?.storage?Object.keys(C.storage).filter(K=>!K.startsWith(n)&&!q.includes(K)&&R.get(K)!==void 0):[];if(!I.$o){const K=[...g.$mmb.map(Z=>(0,g.$zmb)(Z)),g.$ymb];Y.push(...K),T.push(...K)}return{user:M,machine:T,unregistered:Y}}};e.$oMb=a,e.$oMb=a=ve([X(2,t.$cLb),X(3,y.$5k),X(4,g.$qmb),X(5,g.$rmb),X(6,g.$Fmb),X(7,E.$Fi),X(8,g.$Amb),X(9,b.$4l),X(10,d.$5i),X(11,c.$5p),X(12,m.$Cl),X(13,r.$xi)],a);let w=class{constructor(C,R,M,T){this.a=C,this.b=R,this.c=M,this.d=T}async getLocalGlobalState(C){const R={};if(C.isDefault){const T=await this.f(),q=(0,A.$Ln)(T);for(const Y of s)q[Y]!==void 0&&(R[`${n}${Y}`]={version:1,value:q[Y]})}const M=await this.c.readStorageData(C);for(const[T,q]of M)q.value&&q.target===0&&(R[T]={version:1,value:q.value});return{storage:R}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const C=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),C.value.toString()}catch(C){this.d.debug((0,N.$0)(C))}return"{}"}async writeLocalGlobalState({added:C,removed:R,updated:M},T){const q=(0,f.$hMb)("globalState",T),Y={},K=new Map,Z=await this.c.readStorageData(T),G=(J,V)=>{for(const H of J){if(H.startsWith(n)){Y[H.substring(n.length)]=V?V[H].value:void 0;continue}if(V){const ie=V[H];ie.value!==Z.get(H)?.value&&K.set(H,ie.value)}else Z.get(H)!==void 0&&K.set(H,void 0)}};if(G(Object.keys(C),C),G(Object.keys(M),M),G(R),Object.keys(Y).length){this.d.trace(`${q}: Updating locale...`);const J=await this.f();let V=J;for(const H of Object.keys(Y))V=(0,u.edit)(V,[H],Y[H],{});J!==V&&(this.d.trace(`${q}: Updating locale...`),await this.a.writeFile(this.b.argvResource,D.$He.fromString(V)),this.d.info(`${q}: Updated locale.`)),this.d.info(`${q}: Updated locale`)}K.size&&(this.d.trace(`${q}: Updating global state...`),await this.c.updateStorageData(T,K,0),this.d.info(`${q}: Updated global state`,[...K.keys()]))}};e.$pMb=w,e.$pMb=w=ve([X(0,y.$5k),X(1,E.$Fi),X(2,t.$cLb),X(3,g.$Fmb)],w);let S=class extends f.$lMb{constructor(C,R,M,T,q,Y){super("globalState",M,T,q,R,C,Y)}async o(C){const R=C.syncData?JSON.parse(C.syncData.content):null;if(!R){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const M={},T={};for(const q of Object.keys(R.storage))q.startsWith(n)?M[q.substring(n.length)]=R.storage[q].value:this.l.get(q,0)===void 0&&(T[q]=R.storage[q].value);if(Object.keys(M).length){let q="{}";try{q=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(M))q=(0,u.edit)(q,[Y],M[Y],{});await this.k.writeFile(this.h.argvResource,D.$He.fromString(q))}if(Object.keys(T).length){const q=[];for(const Y of Object.keys(T))q.push({key:Y,value:T[Y],scope:0,target:0});this.l.storeAll(q,!0)}}};e.$qMb=S,e.$qMb=S=ve([X(0,c.$5p),X(1,y.$5k),X(2,$.$El),X(3,E.$Fi),X(4,g.$Fmb),X(5,m.$Cl)],S);let v=class{constructor(C,R,M,T,q){this.a=C,this.b=R,this.c=M,this.d=T,this.f=q}getSyncStoreType(C){return this.h(C)?.storage[g.$ymb]?.value}async sync(C){const R=(0,g.$umb)((0,P.$Ug)());try{return await this.g(C,R)}catch(M){if(M instanceof g.$vmb)switch(M.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(C,R)}throw M}}async g(C,R){const M=await this.a.readResource("globalState",null,void 0,R),T=this.h(M)||{storage:{}};T.storage[g.$ymb]={value:C,version:o};const q=await(0,l.$$p)(this.c,this.d,this.b),Y={version:o,machineId:q,content:i(T,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),M.ref,void 0,R)}h({content:C}){if(!C)return null;const R=JSON.parse(C);if((0,f.$gMb)(R))return R?JSON.parse(R.content):null;throw new Error("Invalid remote data")}};e.$rMb=v,e.$rMb=v=ve([X(1,c.$5p),X(2,E.$Fi),X(3,y.$5k),X(4,p.$5j)],v)}),define(ae[118],ce([0,1,17,15,3,35,5,13,177,21,16,12,19,22,28,18,39,242,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$X_b=e.$W_b=void 0,e.$V_b=h;function h(t,r,n){try{const s=JSON.parse(t);if(!r)return(0,I.$fg)(s.all)?null:s.all;switch(O.OS){case 2:return(0,I.$fg)(s.mac)?null:s.mac;case 3:return(0,I.$fg)(s.linux)?null:s.linux;case 1:return(0,I.$fg)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}let g=class extends m.$kMb{constructor(r,n,s,i,o,a,w,S,v,k,C,R,M){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},n,S,v,k,s,i,w,R,o,C,a,M),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:u.$Hmb,authority:"base"}),this.Gb=this.Eb.with({scheme:u.$Hmb,authority:"local"}),this.Hb=this.Eb.with({scheme:u.$Hmb,authority:"remote"}),this.Ib=this.Eb.with({scheme:u.$Hmb,authority:"accepted"}),this.B(L.Event.filter(a.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(r,n,s,i){const o=r.syncData?h(r.syncData.content,i.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?r:n;const a=n?this.Ob(n):null,w=await this.vb(),S=await this.Cb();let v=null,k=!1,C=!1,R=!1;if(o){let q=w?w.value.toString():"[]";if(q=q||"[]",this.Ab(q,!0))throw new u.$vmb((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==q||a!==o){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,f.$U_b)(q,o,a,S,this.zb);Y.hasChanges&&(v=Y.mergeContent,R=Y.hasConflicts,k=R||Y.mergeContent!==q,C=R||Y.mergeContent!==o)}}else w&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),v=w.value.toString(),C=!0);const M={content:R?a:v,localChange:k?w?2:1:0,remoteChange:C?2:0,hasConflicts:R},T=w?w.value.toString():null;return[{fileContent:w,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:T,localChange:M.localChange,remoteResource:this.Hb,remoteContent:o,remoteChange:M.remoteChange,previewResource:this.Eb,previewResult:M,acceptedResource:this.Ib}]}async ub(r){const n=this.Ob(r);if(n===null)return!0;const s=await this.vb(),i=s?s.value.toString():"",o=await this.Cb(),a=await(0,f.$U_b)(i||"[]",n,n,o,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(r,n){return r.previewResult}async sb(r,n,s,i){if(this.h.isEqual(n,this.Gb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(r,n,s,i){const{fileContent:o}=s[0][0];let{content:a,localChange:w,remoteChange:S}=s[0][1];if(w===0&&S===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new u.$vmb((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(w!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),o&&await this.nb(this.Pb(o.value.toString())),await this.wb(a||"[]",o,i),this.O.info(`${this.D}: Updated local keybindings`)),S!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const v=this.Pb(a||"[]",r.syncData?.content);r=await this.mb(v,i?null:r.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==r.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(r,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.vb();if(r){const n=(0,A.$Ln)(r.value.toString());if((0,D.$Lb)(n))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Hb,r)||this.h.isEqual(this.Fb,r)||this.h.isEqual(this.Gb,r)||this.h.isEqual(this.Ib,r)?this.db(r):null}Ob(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Qb()?null:h(r.syncData.content,this.Qb(),this.O)}Pb(r,n){let s={};try{s=JSON.parse(n||"{}")}catch(i){this.O.error(i)}switch(this.Qb()?delete s.all:s.all=r,O.OS){case 2:s.mac=r;break;case 3:s.linux=r;break;case 1:s.windows=r;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(u.$jmb)}};e.$W_b=g,e.$W_b=g=ve([X(2,u.$qmb),X(3,u.$rmb),X(4,u.$Fmb),X(5,d.$5i),X(6,u.$Amb),X(7,y.$5k),X(8,E.$Fi),X(9,p.$5p),X(10,u.$Emb),X(11,l.$4l),X(12,c.$Cl)],g);let $=class extends m.$lMb{constructor(r,n,s,i,o,a){super("keybindings",n,s,i,r,o,a)}async o(r){const n=r.syncData?this.p(r.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.$He.fromString(n)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$Ln)(r.value.toString());return!(0,D.$Lb)(n)}catch(r){return r.fileOperationResult===1}}p(r){try{return h(r,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$X_b=$,e.$X_b=$=ve([X(0,y.$5k),X(1,b.$El),X(2,E.$Fi),X(3,u.$Fmb),X(4,p.$5p),X(5,c.$Cl)],$)}),define(ae[119],ce([0,1,15,3,178,21,76,16,29,12,19,22,28,18,39,246,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1_b=e.$Z_b=void 0,e.$Y_b=u;function f($){return $&&$.settings&&typeof $.settings=="string"&&Object.keys($).length===1}function u($){const t=JSON.parse($);return f(t)?t:{settings:$}}let h=class extends c.$kMb{constructor(t,r,n,s,i,o,a,w,S,v,k,C,R,M){super(t.settingsResource,{syncResource:"settings",profile:t},r,n,s,i,o,a,k,C,w,S,v,M),this.Eb=R,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.$Hmb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$Hmb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$Hmb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$Hmb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(t){const r=await this.getLastSyncUserData(),n=await this.X(t,r),s=this.Lb(n),i=new O.$Bo(m.$imb,this.O);return s?.settings&&i.parse(s.settings),i.configurationModel.getValue(m.$imb)||{}}async qb(t,r,n){const s=await this.vb(),i=await this.Cb(),o=this.Lb(t);r=r===null&&n?t:r;const a=r?this.Lb(r):null,w=await this.Pb();let S=null,v=!1,k=!1,C=!1;if(o){let q=s?s.value.toString().trim():"{}";q=q||"{}",this.Qb(q),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,b.$VKb)(q,o.settings,a?a.settings:null,w,[],i);S=Y.localContent||Y.remoteContent,v=Y.localContent!==null,k=Y.remoteContent!==null,C=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),S=s.value.toString().trim()||"{}",this.Qb(S),k=!0);const R=s?s.value.toString():null,M=a?.settings??null,T={content:C?M:S,localChange:v?2:0,remoteChange:k?2:0,hasConflicts:C};return[{fileContent:s,baseResource:this.baseResource,baseContent:M,localResource:this.localResource,localContent:R,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:o?o.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async ub(t){const r=this.Lb(t);if(r===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",i=await this.Pb(),o=await this.Cb();return(0,b.$VKb)(s||"{}",r.settings,r.settings,i,[],o).remoteContent!==null}async rb(t,r){const n=await this.Cb(),s=await this.Pb();return{...t.previewResult,content:t.previewResult.content?(0,b.$UKb)(t.previewResult.content,"{}",s,n):null}}async sb(t,r,n,s){const i=await this.Cb(),o=await this.Pb();if(this.h.isEqual(r,this.localResource))return{content:t.fileContent?(0,b.$UKb)(t.fileContent.value.toString(),"{}",o,i):null,localChange:0,remoteChange:2};if(this.h.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?(0,b.$UKb)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:0};if(this.h.isEqual(r,this.previewResource))return n===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:n!==null?(0,b.$UKb)(n,t.fileContent?t.fileContent.value.toString():"{}",o,i):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async tb(t,r,n,s){const{fileContent:i}=n[0][0];let{content:o,localChange:a,remoteChange:w}=n[0][1];if(a===0&&w===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),o=o?o.trim():"{}",o=o||"{}",this.Qb(o),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),i&&await this.nb(JSON.stringify(this.Nb(i.value.toString()))),await this.wb(o,i,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),w!==0){const S=await this.Cb(),v=this.Lb(t),k=await this.Pb(o);o=(0,b.$UKb)(o,v?v.settings:"{}",k,S),this.O.trace(`${this.D}: Updating remote settings...`),t=await this.mb(JSON.stringify(this.Nb(o)),s?null:t.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}r?.ref!==t.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(t),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.vb();if(t)return!(0,b.$WKb)(t.value.toString())}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async resolveContent(t){return this.h.isEqual(this.remoteResource,t)||this.h.isEqual(this.localResource,t)||this.h.isEqual(this.acceptedResource,t)||this.h.isEqual(this.baseResource,t)?this.db(t):null}async db(t){let r=await super.db(t);if(r){const n=await this.Cb(),s=await this.Pb();r=(0,b.$UKb)(r,"{}",s,n)}return r}Lb(t){return t.syncData?this.Mb(t.syncData.content):null}Mb(t){try{return u(t)}catch(r){this.O.error(r)}return null}Nb(t){return{settings:t}}async Pb(t){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(N.Event.any(N.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:i})=>!!i)),N.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const r=await this.Ob;return(0,b.$SKb)(r,this.P,t)}Qb(t){if(this.Ab(t,!1))throw new m.$vmb((0,L.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$Z_b=h,e.$Z_b=h=ve([X(2,d.$5k),X(3,I.$Fi),X(4,E.$5p),X(5,m.$qmb),X(6,m.$rmb),X(7,m.$Fmb),X(8,m.$Emb),X(9,A.$5i),X(10,m.$Amb),X(11,y.$4l),X(12,P.$ap),X(13,p.$Cl)],h);let g=class extends c.$lMb{constructor(t,r,n,s,i,o){super("settings",r,n,s,t,i,o)}async o(t){const r=t.syncData?this.p(t.syncData.content):null;if(!r){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,D.$He.fromString(r.settings)),await this.n(t)}async i(){try{const t=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$WKb)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}p(t){try{return u(t)}catch(r){this.j.error(r)}return null}};e.$1_b=g,e.$1_b=g=ve([X(0,d.$5k),X(1,l.$El),X(2,I.$Fi),X(3,m.$Fmb),X(4,E.$5p),X(5,p.$Cl)],g)}),define(ae[120],ce([0,1,15,3,30,21,16,12,19,22,28,18,39,243,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6_b=e.$5_b=void 0,e.$4_b=b;function b(u){return JSON.parse(u.content)}let m=class extends p.$iMb{constructor(h,g,$,t,r,n,s,i,o,a,w,S){super({syncResource:"snippets",profile:h},g,t,$,r,n,s,a,w,i,o,S),this.pb=1,this.vb=h.snippetsHome,this.B(this.G.watch($.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(N.Event.filter(this.G.onDidFilesChange,v=>v.affects(this.vb))(()=>this.Q()))}async qb(h,g,$){const t=await this.Hb(),r=this.Gb(t),n=h.syncData?this.Fb(h.syncData):null;g=g===null&&$?h:g;const s=g&&g.syncData?this.Fb(g.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,l.$2_b)(r,n,s);return this.Bb(i,t,n||{},s||{})}async ub(h){const g=h.syncData?this.Fb(h.syncData):null;if(g===null)return!0;const $=await this.Hb(),t=this.Gb($),r=(0,l.$2_b)(t,g,g);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async rb(h,g){return h.previewResult}async sb(h,g,$,t){if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$Hmb,authority:"local"})))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:h.fileContent?h.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(g,this.g.with({scheme:c.$Hmb,authority:"remote"})))return{content:h.remoteContent,localChange:h.remoteContent!==null?h.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(g,this.g))return $===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:$,localChange:$===null?h.fileContent!==null?3:0:2,remoteChange:$===null?h.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async tb(h,g,$,t){const r=$.map(([n,s])=>({...n,acceptResult:s}));r.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),r.some(({localChange:n})=>n!==0)&&(await this.Cb(r),await this.Db(r,t)),r.some(({remoteChange:n})=>n!==0)&&(h=await this.Eb(r,h,t)),g?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of r)try{await this.G.del(n)}catch{}}Bb(h,g,$,t){const r=new Map;for(const n of Object.keys(h.local.added)){const s={content:h.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of Object.keys(h.local.updated)){const s={content:h.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},i=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:g[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of h.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:g[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of Object.keys(h.remote.added)){const s={content:h.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},i=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:g[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of Object.keys(h.remote.updated)){const s={content:h.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},i=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:g[n],localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of h.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:$[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of h.conflicts){const s={content:t[n]??null,hasConflicts:!0,localChange:g[n]?2:1,remoteChange:$[n]?2:1},i=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:g[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}for(const n of Object.keys(g))if(!r.has(n)){const s={content:g[n]?g[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=g[n]?g[n].value.toString():null;r.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"base"}),baseContent:t[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"local"}),fileContent:g[n]||null,localContent:i,remoteResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"remote"}),remoteContent:$[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:c.$Hmb,authority:"accepted"})})}return[...r.values()]}async resolveContent(h){return this.h.isEqualOrParent(h,this.g.with({scheme:c.$Hmb,authority:"remote"}))||this.h.isEqualOrParent(h,this.g.with({scheme:c.$Hmb,authority:"local"}))||this.h.isEqualOrParent(h,this.g.with({scheme:c.$Hmb,authority:"base"}))||this.h.isEqualOrParent(h,this.g.with({scheme:c.$Hmb,authority:"accepted"}))?this.db(h):null}async hasLocalData(){try{const h=await this.Hb();if(Object.keys(h).length)return!0}catch{}return!1}async Cb(h){const g={};for(const $ of h)$.fileContent&&(g[this.h.basename($.localResource)]=$.fileContent);await this.nb(JSON.stringify(this.Gb(g)))}async Db(h,g){for(const{fileContent:$,acceptResult:t,localResource:r,remoteResource:n,localChange:s}of h)if(s!==0){const i=n?this.h.basename(n):this.h.basename(r),o=this.h.joinPath(this.vb,i);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(o)),await this.G.del(o),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(o))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(o)),await this.G.createFile(o,D.$He.fromString(t.content),{overwrite:g}),this.O.info(`${this.D}: Created snippet`,this.h.basename(o))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(o)),await this.G.writeFile(o,D.$He.fromString(t.content),g?void 0:$),this.O.info(`${this.D}: Updated snippet`,this.h.basename(o)))}}async Eb(h,g,$){const t=g.syncData?this.Fb(g.syncData):{},r=(0,L.$5n)(t);for(const{acceptResult:n,localResource:s,remoteResource:i,remoteChange:o}of h)if(o!==0){const a=s?this.h.basename(s):this.h.basename(i);o===3?delete r[a]:r[a]=n.content}return(0,l.$3_b)(t,r)||(this.O.trace(`${this.D}: Updating remote snippets...`),g=await this.mb(JSON.stringify(r),$?null:g.ref),this.O.info(`${this.D}: Updated remote snippets`)),g}Fb(h){return b(h)}Gb(h){const g={};for(const $ of Object.keys(h))g[$]=h[$].value.toString();return g}async Hb(){const h={};let g;try{g=await this.G.resolve(this.vb)}catch($){if($ instanceof I.$nl&&$.fileOperationResult===1)return h;throw $}for(const $ of g.children||[]){const t=$.resource,r=this.h.extname(t);if(r===".json"||r===".code-snippets"){const n=this.h.relativePath(this.vb,t),s=await this.G.readFile(t);h[n]=s}}return h}};e.$5_b=m,e.$5_b=m=ve([X(2,O.$Fi),X(3,I.$5k),X(4,P.$5p),X(5,c.$qmb),X(6,c.$rmb),X(7,c.$Fmb),X(8,A.$5i),X(9,c.$Amb),X(10,d.$4l),X(11,E.$Cl)],m);let f=class extends p.$lMb{constructor(h,g,$,t,r,n){super("snippets",g,$,t,h,r,n)}async o(h){const g=h.syncData?JSON.parse(h.syncData.content):null;if(!g){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const t of Object.keys(g)){const r=g[t];if(r){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,t);await this.k.createFile(n,D.$He.fromString(r)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(h)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(h){return h.fileOperationResult===1}}};e.$6_b=f,e.$6_b=f=ve([X(0,I.$5k),X(1,y.$El),X(2,O.$Fi),X(3,c.$Fmb),X(4,P.$5p),X(5,E.$Cl)],f)}),define(ae[121],ce([0,1,15,21,16,12,19,22,28,18,39,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9_b=e.$8_b=void 0,e.$7_b=p;function p(m,f){try{return JSON.parse(m).tasks??null}catch(u){return f.error(u),null}}let l=class extends E.$jMb{constructor(f,u,h,g,$,t,r,n,s,i,o,a){super(f.tasksResource,{syncResource:"tasks",profile:f},u,n,s,i,h,g,r,o,$,t,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:y.$Hmb,authority:"base"}),this.Cb=this.Ab.with({scheme:y.$Hmb,authority:"local"}),this.Db=this.Ab.with({scheme:y.$Hmb,authority:"remote"}),this.Eb=this.Ab.with({scheme:y.$Hmb,authority:"accepted"})}async qb(f,u,h,g){const $=f.syncData?p(f.syncData.content,this.O):null;u=u===null&&h?f:u;const t=u?.syncData?p(u.syncData.content,this.O):null,r=await this.vb();let n=null,s=!1,i=!1,o=!1;if(f.syncData){const S=r?r.value.toString():null;if(!t||t!==S||t!==$){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const v=b(S,$,t);n=v.content,o=v.hasConflicts,s=v.hasLocalChanged,i=v.hasRemoteChanged}}else r&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=r.value.toString(),i=!0);const a={content:o?t:n,localChange:s?r?2:1:0,remoteChange:i?2:0,hasConflicts:o},w=r?r.value.toString():null;return[{fileContent:r,baseResource:this.Bb,baseContent:t,localResource:this.Cb,localContent:w,localChange:a.localChange,remoteResource:this.Db,remoteContent:$,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(f){const u=f?.syncData?p(f.syncData.content,this.O):null;if(u===null)return!0;const h=await this.vb(),g=h?h.value.toString():null,$=b(g,u,u);return $.hasLocalChanged||$.hasRemoteChanged}async rb(f,u){return f.previewResult}async sb(f,u,h,g){if(this.h.isEqual(u,this.Cb))return{content:f.fileContent?f.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.Db))return{content:f.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.Ab))return h===void 0?{content:f.previewResult.content,localChange:f.previewResult.localChange,remoteChange:f.previewResult.remoteChange}:{content:h,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async tb(f,u,h,g){const{fileContent:$}=h[0][0],{content:t,localChange:r,remoteChange:n}=h[0][1];if(r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),r!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),$&&await this.nb(JSON.stringify(this.Kb($.value.toString()))),t?await this.wb(t,$,g):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(t));f=await this.mb(s,g?null:f.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}u?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(f){return this.h.isEqual(this.Db,f)||this.h.isEqual(this.Bb,f)||this.h.isEqual(this.Cb,f)||this.h.isEqual(this.Eb,f)?this.db(f):null}Kb(f){return f?{tasks:f}:{}}};e.$8_b=l,e.$8_b=l=ve([X(2,y.$qmb),X(3,y.$rmb),X(4,y.$Fmb),X(5,N.$5i),X(6,y.$Amb),X(7,A.$5k),X(8,L.$Fi),X(9,O.$5p),X(10,I.$4l),X(11,P.$Cl)],l);let c=class extends E.$lMb{constructor(f,u,h,g,$,t){super("tasks",u,h,g,f,$,t),this.c=this.g.defaultProfile.tasksResource}async o(f){const u=f.syncData?p(f.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,D.$He.fromString(u)),await this.n(f)}async p(){return this.k.exists(this.c)}};e.$9_b=c,e.$9_b=c=ve([X(0,A.$5k),X(1,d.$El),X(2,L.$Fi),X(3,y.$Fmb),X(4,O.$5p),X(5,P.$Cl)],c);function b(m,f,u){if(m===null&&f===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(m===f)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const h=u!==m,g=u!==f;return!h&&!g?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:h&&!g?{content:m,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:g&&!h?{content:f,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:m,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ae[122],ce([0,1,44,21,16,12,19,22,28,18,39,244,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pbc=void 0,e.$Qbc=c,e.$Rbc=b;let l=class extends E.$iMb{constructor(f,u,h,g,$,t,r,n,s,i,o,a,w){super({syncResource:"profiles",profile:f},u,g,$,t,r,n,o,a,s,i,w),this.vb=h,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:p.$Hmb,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.$Hmb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.$Hmb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.$Hmb,authority:"accepted"}),this.B(h.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const f=await this.getLastSyncUserData();return f?.syncData?b(f.syncData):null}async getRemoteSyncedProfiles(f){const u=await this.getLastSyncUserData(),h=await this.X(f,u);return h?.syncData?b(h.syncData):null}async qb(f,u,h){if(!this.vb.isEnabled())throw new p.$vmb("Cannot sync profiles because they are disabled","LocalError");const g=f.syncData?b(f.syncData):null,$=u?.syncData?b(u.syncData):null,t=this.Db(),{local:r,remote:n}=(0,y.$Obc)(t,g,$,[]),s={local:r,remote:n,content:$?this.Eb($):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:n!==null?2:0},i=c(t,!1);return[{baseResource:this.baseResource,baseContent:$?this.Eb($):null,localResource:this.localResource,localContent:i,remoteResource:this.remoteResource,remoteContent:g?this.Eb(g):null,remoteProfiles:g,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(f){const u=f?.syncData?b(f.syncData):null,h=this.Db(),{remote:g}=(0,y.$Obc)(h,u,u,[]);return!!g?.added.length||!!g?.removed.length||!!g?.updated.length}async rb(f,u){return{...f.previewResult,hasConflicts:!1}}async sb(f,u,h,g){if(this.h.isEqual(u,this.localResource))return this.Ab(f);if(this.h.isEqual(u,this.remoteResource))return this.Bb(f);if(this.h.isEqual(u,this.previewResource))return f.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async Ab(f){const u=this.Db(),h=(0,y.$Obc)(u,null,null,[]),{local:g,remote:$}=h;return{content:f.localContent,local:g,remote:$,localChange:g.added.length>0||g.removed.length>0||g.updated.length>0?2:0,remoteChange:$!==null?2:0}}async Bb(f){const u=f.remoteContent?JSON.parse(f.remoteContent):null,h=[],g=[];for(const $ of this.Db()){const t=u?.find(r=>r.id===$.id);t&&(h.push({id:$.id,name:$.name,collection:t.collection}),g.push($))}if(u!==null){const $=(0,y.$Obc)(g,u,h,[]),{local:t,remote:r}=$;return{content:f.remoteContent,local:t,remote:r,localChange:t.added.length>0||t.removed.length>0||t.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:f.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(f,u,h,g){const{local:$,remote:t,localChange:r,remoteChange:n}=h[0][1];r===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=h[0][0].remoteProfiles||[];if(s.length+(t?.added.length??0)-(t?.removed.length??0)>20)throw new p.$vmb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0&&(await this.nb(c(this.Db(),!1)),await Promise.all($.removed.map(async i=>{this.O.trace(`${this.D}: Removing '${i.name}' profile...`),await this.vb.removeProfile(i),this.O.info(`${this.D}: Removed profile '${i.name}'.`)})),await Promise.all($.added.map(async i=>{this.O.trace(`${this.D}: Creating '${i.name}' profile...`),await this.vb.createProfile(i.id,i.name,{shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${i.name}'.`)})),await Promise.all($.updated.map(async i=>{const o=this.vb.profiles.find(a=>a.id===i.id);o?(this.O.trace(`${this.D}: Updating '${i.name}' profile...`),await this.vb.updateProfile(o,{name:i.name,shortName:i.shortName,icon:i.icon,useDefaultFlags:i.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${i.name}'.`)):this.O.info(`${this.D}: Could not find profile with id '${i.id}' to update.`)}))),n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const i=[],o=s.length+(t?.added.length??0)<=20;if(o)for(const a of t?.added||[]){const w=await this.J.createCollection(this.F);i.push(w),s.push({id:a.id,name:a.name,collection:w,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of t?.removed||[])s.splice(s.findIndex(({id:w})=>a.id===w),1);for(const a of t?.updated||[]){const w=s.find(({id:S})=>a.id===S);w&&s.splice(s.indexOf(w),1,{...w,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{f=await this.updateRemoteProfiles(s,g?null:f.ref),this.O.info(`${this.D}: Updated remote profiles.${o&&t?.added.length?` Added: ${JSON.stringify(t.added.map(a=>a.name))}.`:""}${t?.updated.length?` Updated: ${JSON.stringify(t.updated.map(a=>a.name))}.`:""}${t?.removed.length?` Removed: ${JSON.stringify(t.removed.map(a=>a.name))}.`:""}`)}catch(a){if(i.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const w of i)await this.J.deleteCollection(w,this.F)}throw a}for(const a of t?.removed||[])await this.J.deleteCollection(a.collection,this.F)}u?.ref!==f.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(f),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(f,u){return this.mb(this.Eb(f),u)}async hasLocalData(){return this.Db().length>0}async resolveContent(f){if(this.h.isEqual(this.remoteResource,f)||this.h.isEqual(this.baseResource,f)||this.h.isEqual(this.localResource,f)||this.h.isEqual(this.acceptedResource,f)){const u=await this.db(f);return u&&(0,D.$Wn)(JSON.parse(u),{})}return null}Db(){return this.vb.profiles.filter(f=>!f.isDefault&&!f.isTransient)}Eb(f){return JSON.stringify([...f].sort((u,h)=>u.name.localeCompare(h.name)))}};e.$Pbc=l,e.$Pbc=l=ve([X(2,d.$El),X(3,A.$5k),X(4,L.$Fi),X(5,O.$5p),X(6,p.$qmb),X(7,p.$rmb),X(8,p.$Fmb),X(9,N.$5i),X(10,p.$Amb),X(11,I.$4l),X(12,P.$Cl)],l);function c(m,f){const u=[...m].sort((h,g)=>h.name.localeCompare(g.name)).map(h=>({id:h.id,name:h.name}));return f?(0,D.$Wn)(u,{}):JSON.stringify(u)}function b(m){return JSON.parse(m.content)}}),define(ae[261],ce([0,1,3,2,5,16,19,22,25]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbc=void 0;const d="sync.enable";let E=class extends N.$Uc{constructor(p,l,c,b){super(),this.c=p,this.f=l,this.g=c,this.h=b,this.a=new D.$fe,this.onDidChangeEnablement=this.a.event,this.b=new D.$fe,this.onDidChangeResourceEnablement=this.b.event,this.B(p.onDidChangeValue(-1,void 0,this.B(new N.$Tc))(m=>this.m(m)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(d,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(p){p&&!this.canToggleEnablement()||(this.f.publicLog2(d,{enabled:p}),this.c.store(d,p,-1,1))}isResourceEnabled(p){return this.c.getBoolean((0,P.$zmb)(p),-1,!0)}setResourceEnablement(p,l){if(this.isResourceEnabled(p)!==l){const c=(0,P.$zmb)(p);this.j(c,l)}}getResourceSyncStateVersion(p){}j(p,l){this.c.store(p,l,-1,L.$o?0:1)}m(p){if(d===p.key){this.a.fire(this.isEnabled());return}const l=P.$mmb.filter(c=>(0,P.$zmb)(c)===p.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$Cbc=E,e.$Cbc=E=ve([X(0,O.$5p),X(1,I.$4l),X(2,A.$Fi),X(3,P.$pmb)],E)}),define(ae[262],ce([0,1,6,15,65,2,20,21,16,12,18,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=void 0;let p=class extends A.$Uc{constructor(c,b,m,f,u){super(),this.a=c,this.b=b,this.c=m,this.f=f,this.g=u,this.h()}async h(){for(const b of this.g.profiles)for(const m of y.$mmb)try{await this.m(this.j(m,b.isDefault?void 0:b.id))}catch(f){this.f.error(f)}let c;try{c=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,d.$jl)(b)!==1&&this.f.error(b);return}if(c.children){for(const b of c.children)if(b.isDirectory&&!this.g.profiles.some(m=>m.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(m){this.f.error(m)}}}async getAllResourceRefs(c,b,m){const f=this.j(c,b,m);try{const u=await this.b.resolve(f);if(u.children)return u.children.filter(g=>g.isFile&&!g.name.startsWith("lastSync")).sort().reverse().map(g=>({ref:g.name,created:this.n(g)}))}catch(u){if((0,d.$jl)(u)!==1)throw u}return[]}async resolveResourceContent(c,b,m,f){const u=this.j(c,m,f),h=(0,O.$_g)(u,b);try{return(await this.b.readFile(h)).value.toString()}catch(g){return this.f.error(g),null}}async writeResource(c,b,m,f,u){const h=this.j(c,f,u),g=(0,O.$_g)(h,`${(0,L.$6m)(m).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(g,N.$He.fromString(b))}catch($){this.f.error($)}}j(c,b,m=this.a.userDataSyncHome){return(0,O.$_g)(m,...b?[b,c]:[c])}async m(c){try{try{if(!await this.b.exists(c))return}catch{return}const b=await this.b.resolve(c);if(b.children){const m=b.children.filter(g=>g.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(g.name)).sort(),f=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=m.filter(g=>Date.now()-this.n(g)>f);const h=m.length-u.length;h<10&&(u=u.slice(10-h)),await D.Promises.settled(u.map(async g=>{this.f.info("Deleting from backup",g.resource.path),await this.b.del(g.resource)}))}}catch(b){this.f.error(b)}}n(c){return new Date(parseInt(c.name.substring(0,4)),parseInt(c.name.substring(4,6))-1,parseInt(c.name.substring(6,8)),parseInt(c.name.substring(9,11)),parseInt(c.name.substring(11,13)),parseInt(c.name.substring(13,15))).getTime()}};e.$Nbc=p,e.$Nbc=p=ve([X(0,P.$Fi),X(1,d.$5k),X(2,I.$5i),X(3,y.$Fmb),X(4,E.$El)],p)}),define(ae[83],ce([0,1,3,2,5,27,182,16,12,4,24,45,19,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$fmb=e.$dmb=void 0,e.$emb=$,e.$dmb=(0,d.$yi)("IUserDataSyncMachinesService");const b="sync.currentMachineName",m="Safari",f="Chrome",u="Edge",h="Firefox",g="Android";function $(n){switch(n){case m:case f:case u:case h:case g:case(0,L.$h)(0):return!0}return!1}function t(){return L.$G?m:L.$E?f:L.$H?u:L.$F?h:L.$I?g:(0,L.$h)(L.$o?0:L.$u)}let r=class extends N.$Uc{static{c=this}static{this.a=1}static{this.b="machines"}constructor(s,i,o,a,w,S){super(),this.h=o,this.j=a,this.m=w,this.n=S,this.c=this.B(new D.$fe),this.onDidChange=this.c.event,this.g=null,this.f=(0,y.$$p)(s,i,o)}async getMachines(s){const i=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===i}))}async addCurrentMachine(s){const i=await this.f,o=await this.s(s);o.machines.some(({id:a})=>a===i)||(o.machines.push({id:i,name:this.r(o.machines),platform:t()}),await this.t(o))}async removeCurrentMachine(s){const i=await this.f,o=await this.s(s),a=o.machines.filter(({id:w})=>w!==i);a.length!==o.machines.length&&(o.machines=a,await this.t(o))}async renameMachine(s,i,o){const a=await this.s(o),w=a.machines.find(({id:S})=>S===s);if(w){w.name=i,await this.t(a);const S=await this.f;s===S&&this.h.store(b,i,-1,1)}}async setEnablements(s){const i=await this.s();for(const[o,a]of s){const w=i.machines.find(S=>S.id===o);w&&(w.disabled=a?void 0:!0)}await this.t(i)}r(s){const i=this.h.get(b,-1);if(i)return i;const o=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${t()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$bf)(o)}\\s#(\\d+)`);let w=0;for(const S of s){const v=a.exec(S.name),k=v?parseInt(v[1]):0;w=k>w?k:w}return`${o} #${w+1}`}async s(s){this.g=await this.u(s);const i=this.w(this.g);if(i.version!==c.a)throw new Error((0,O.localize)(0,null,this.n.nameLong));return i}async t(s){const i=JSON.stringify(s),o=await this.j.writeResource(c.b,i,this.g?.ref||null);this.g={ref:o,content:i},this.c.fire()}async u(s){if(this.g){const i=s&&s.latest?s.latest[c.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.j.readResource(c.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(i){this.m.error(i)}return{version:c.a,machines:[]}}};e.$fmb=r,e.$fmb=r=c=ve([X(0,I.$Fi),X(1,P.$5k),X(2,p.$5p),X(3,l.$qmb),X(4,l.$Fmb),X(5,E.$lk)],r)}),define(ae[263],ce([0,1,6,65,38,7,3,2,5,20,8,179,24,19,22,25,80,83]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tbc=void 0;const u="sync.disableMachineEventually",h="sync.sessionId",g="sync.storeUrl",$="sync.productQuality";let t=class extends I.$Uc{get n(){const s=this.H.get(g,-1);return s?E.URI.parse(s):void 0}set n(s){s?this.H.store(g,s.toString(),-1,1):this.H.remove(g,-1)}get s(){return this.H.get($,-1)}set s(s){s?this.H.store($,s,-1,1):this.H.remove($,-1)}constructor(s,i,o,a,w,S,v,k,C,R){super(),this.u=i,this.w=o,this.y=a,this.z=w,this.C=S,this.D=v,this.F=k,this.G=C,this.H=R,this.a=this.B(new I.$Vc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new O.$fe),this.onError=this.h.event,this.S=[],this.f=this.B(new D.$wh(this.U())),this.j=this.n,this.n=i.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(i.onDidChangeUserDataSyncStore(()=>{(0,d.$5g)(this.n,i.userDataSyncStore?.url)||(this.j=this.n,this.n=i.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(v.onDidChangeAccount(()=>this.I())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(w.onDidChangeLocal(M=>this.triggerSync([M],!1,!1))),this.B(O.Event.filter(this.y.onDidChangeResourceEnablement,([,M])=>M)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:i}=this.L();s?this.a.value===void 0&&(this.a.value=new r(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.O(o))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(i&&this.C.info(i),this.a.clear()):i&&this.y.isEnabled()&&this.C.info(i))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.$6m)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,i,o){try{this.D.account&&!o&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(h,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),i)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const i=b.$vmb.toUserDataSyncError(s);i instanceof b.$xmb&&this.F.publicLog2("autosync/error",{code:i.code,service:this.u.userDataSyncStore.url.toString()}),i.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):i.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):i.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):i.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):i.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):i.code==="UpgradeRequired"||i.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):i.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with newer version than of client. Requires client upgrade.`)):i.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${i.resource} content with older version than of client. Requires server reset.`)):i.code==="ServiceChanged"||i.code==="DefaultServiceChanged"?P.$o&&i.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(i),this.b++),this.h.fire(i)}async P(){this.H.store(u,!0,-1,1),await(0,D.$zh)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(u,-1,!1)}R(){this.H.remove(u,-1)}async triggerSync(s,i,o){if(this.a.value===void 0)return this.f.cancel();if(i&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$Tbc=t,e.$Tbc=t=ve([X(0,p.$lk),X(1,b.$pmb),X(2,b.$qmb),X(3,b.$Amb),X(4,b.$Bmb),X(5,b.$Fmb),X(6,m.$AKb),X(7,c.$4l),X(8,f.$dmb),X(9,l.$5p)],t);class r extends I.$Uc{static{this.a="Interval"}constructor(s,i,o,a,w,S,v,k,C){super(),this.m=s,this.n=i,this.r=o,this.s=a,this.u=w,this.w=S,this.y=v,this.z=k,this.C=C,this.b=this.B(new I.$Vc),this.c=this.B(new O.$fe),this.onDidStartSync=this.c.event,this.f=this.B(new O.$fe),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,I.$Sc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}D(){this.b.value=(0,D.$Ah)(()=>{this.sync(r.a,!1),this.b.value=void 0},this.n)}sync(s,i){const o=(0,D.$lh)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(w){if((0,A.$4)(w))return}return this.H(s,i,a)});return this.j=o,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,d.$5g)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),i=this.r.userDataSyncStore;return!!i&&!!s&&(!(0,d.$5g)(i.defaultUrl,s.defaultUrl)||!(0,d.$5g)(i.insidersUrl,s.insidersUrl)||!(0,d.$5g)(i.stableUrl,s.stableUrl))}async H(s,i,o){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(i,o)}catch(w){if(this.y.error(w),a=w,b.$vmb.toUserDataSyncError(w).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(i,o),a=void 0}catch(S){this.y.error(S),a=S}}this.f.fire(a)}async I(s,i){if(this.h=await this.u.createSyncTask(this.g,s),i.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$xmb((0,y.localize)(0,null),"DefaultServiceChanged"):new b.$xmb((0,y.localize)(1,null),"ServiceChanged"):new b.$xmb((0,y.localize)(2,null),"TurnedOff");const o=this.C.get(h,-1);if(o&&this.g&&o!==this.g.session)throw this.F()?await this.G()?new b.$xmb((0,y.localize)(3,null),"DefaultServiceChanged"):new b.$xmb((0,y.localize)(4,null),"ServiceChanged"):new b.$xmb((0,y.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(i.isCancellationRequested)return;const w=a.find(v=>v.isCurrent);if(w?.disabled)throw new b.$xmb((0,y.localize)(6,null),"TurnedOff");const S=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-S}),this.g===null)try{this.g=await this.s.manifest(null)}catch(v){throw new b.$xmb((0,L.$jj)(v),v instanceof b.$vmb?v.code:"Unknown")}this.g&&this.g.session!==o&&this.C.store(h,this.g.session,-1,1),!i.isCancellationRequested&&(w||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(ae[264],ce([0,1,8,183,16,12,45,19,28,25,18,39,120,119,118,21,121,116,117,4,122,44,27]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=void 0;let n=class{static{r=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(i,o,a,w,S,v,k,C,R,M){this.e=i,this.f=o,this.g=a,this.h=S,this.i=v,this.j=k,this.k=C,this.l=R,this.n=M,this.d=w.extUri}async getRemoteSyncedProfiles(){const i=await this.e.readResource("profiles",null,void 0);if(i.content){const o=this.L(i.content,"profiles");return(0,g.$Rbc)(o)}return[]}async getLocalSyncedProfiles(i){const o=await this.f.getAllResourceRefs("profiles",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("profiles",o[0].ref,void 0,i);if(a){const w=this.L(a,"profiles");return(0,g.$Rbc)(w)}}return[]}async getLocalSyncedMachines(i){const o=await this.f.getAllResourceRefs("machines",void 0,i);if(o.length){const a=await this.f.resolveResourceContent("machines",o[0].ref,void 0,i);if(a)return JSON.parse(a).machines.map(S=>({...S,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(i,o){return(await this.e.getAllResourceRefs(i,o?.collection)).map(({created:w,ref:S})=>({created:w,uri:this.J({remote:!0,syncResource:i,profile:o?.id??this.k.defaultProfile.id,location:void 0,collection:o?.collection,ref:S,node:void 0})}))}async getLocalSyncResourceHandles(i,o,a){return(await this.f.getAllResourceRefs(i,o?.collection,a)).map(({created:S,ref:v})=>({created:S,uri:this.J({remote:!1,syncResource:i,profile:o?.id??this.k.defaultProfile.id,collection:o?.collection,ref:v,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:i}){const o=this.K(i),a=o?this.k.profiles.find(w=>w.id===o.profile):void 0;return o&&a?{profile:a,syncResource:o?.syncResource}:void 0}async getAssociatedResources({uri:i}){const o=this.K(i);if(!o)return[];const a=this.k.profiles.find(w=>w.id===o.profile);switch(o.syncResource){case"settings":return this.s(i,a);case"keybindings":return this.u(i,a);case"tasks":return this.w(i,a);case"snippets":return this.y(i,a);case"globalState":return this.D(i,a);case"extensions":return this.A(i,a);case"profiles":return this.G(i,a);case"workspaceState":return[]}}async getMachineId({uri:i}){const o=this.K(i);if(o){if(o.remote){if(o.ref){const{content:a}=await this.M(o.syncResource,o.ref,o.collection);if(a)return this.L(a,o.syncResource)?.machineId}return}if(o.location){if(o.ref){const a=await this.f.resolveResourceContent(o.syncResource,o.ref,o.collection,o.location);if(a)return this.L(a,o.syncResource)?.machineId}return}return(0,O.$$p)(this.h,this.j,this.i)}}async resolveContent(i){const o=this.K(i);if(!o||o.node===r.a)return null;if(o.ref){const a=await this.o(o.remote,o.syncResource,o.collection,o.ref,o.location);return o.node&&a?this.q(o.syncResource,a,o.node):a}return!o.remote&&!o.node?this.r(o.syncResource,o.profile):null}async o(i,o,a,w,S){if(i){const{content:v}=await this.M(o,w,a);return v}return this.f.resolveResourceContent(o,w,a,S)}q(i,o,a){const w=this.L(o,i);switch(i){case"settings":return this.t(w,a);case"keybindings":return this.v(w,a);case"tasks":return this.x(w,a);case"snippets":return this.z(w,a);case"globalState":return this.E(w,a);case"extensions":return this.B(w,a);case"profiles":return this.H(w,a);case"workspaceState":return null}}async r(i,o){const a=this.k.profiles.find(w=>w.id===o);if(!a)return null;switch(i){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(i,o){const a=this.d.joinPath(i,"settings.json"),w=o?o.settingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:w}]}t(i,o){switch(o){case"settings.json":return(0,l.$Y_b)(i.content).settings}return null}u(i,o){const a=this.d.joinPath(i,"keybindings.json"),w=o?o.keybindingsResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:w}]}v(i,o){switch(o){case"keybindings.json":return(0,c.$V_b)(i.content,!!this.l.getValue(d.$jmb),this.g)}return null}w(i,o){const a=this.d.joinPath(i,"tasks.json"),w=o?o.tasksResource:this.d.joinPath(i,r.a);return[{resource:a,comparableResource:w}]}x(i,o){switch(o){case"tasks.json":return(0,m.$7_b)(i.content,this.g)}return null}async y(i,o){const a=await this.resolveContent(i);if(a){const w=this.L(a,"snippets");if(w){const S=(0,p.$4_b)(w),v=[];for(const k of Object.keys(S)){const C=this.d.joinPath(i,k),R=o?this.d.joinPath(o.snippetsHome,k):this.d.joinPath(i,r.a);v.push({resource:C,comparableResource:R})}return v}}return[]}z(i,o){return(0,p.$4_b)(i)[o]||null}A(i,o){const a=this.d.joinPath(i,"extensions.json"),w=o?this.J({remote:!1,syncResource:"extensions",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:w}]}B(i,o){switch(o){case"extensions.json":return(0,f.$Q_b)((0,f.$P_b)(i),!0)}return null}async C(i){const{localExtensions:o}=await this.n.createInstance(f.$S_b).getLocalExtensions(i);return(0,f.$Q_b)(o,!0)}D(i,o){const a=this.d.joinPath(i,"globalState.json"),w=o?this.J({remote:!1,syncResource:"globalState",profile:o.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(i,r.a);return[{resource:a,comparableResource:w}]}E(i,o){switch(o){case"globalState.json":return(0,u.$nMb)(JSON.parse(i.content),!0)}return null}async F(i){const o=await this.n.createInstance(u.$pMb).getLocalGlobalState(i);return(0,u.$nMb)(o,!0)}G(i,o){const a=this.d.joinPath(i,"profiles.json"),w=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:w}]}H(i,o){switch(o){case"profiles.json":return(0,$.$Wn)(JSON.parse(i.content),{})}return null}async I(i){return(0,g.$Qbc)(this.k.profiles.filter(o=>!o.isDefault&&!o.isTransient),!0)}J(i){const o=i.remote?r.b:r.c,a=[];return i.location&&(a.push(`scheme:${i.location.scheme}`),a.push(`authority:${i.location.authority}`),a.push((0,t.$ff)(i.location.path,"/"))),a.push(`syncResource:${i.syncResource}`),a.push(`profile:${i.profile}`),i.collection&&a.push(`collection:${i.collection}`),i.ref&&a.push(`ref:${i.ref}`),i.node&&a.push(i.node),this.d.joinPath(D.URI.from({scheme:d.$Hmb,authority:o,path:"/",query:i.location?.query,fragment:i.location?.fragment}),...a)}K(i){if(i.scheme!==d.$Hmb)return;const o=[];for(;i.path!=="/";)o.unshift(this.d.basename(i)),i=this.d.dirname(i);if(o.length<2)return;const a=i.authority===r.b;let w,S;const v=[];let k,C,R,M,T;for(;o.length;){const q=o.shift();q.startsWith("scheme:")?w=q.substring(7):q.startsWith("authority:")?S=q.substring(10):q.startsWith("syncResource:")?k=q.substring(13):q.startsWith("profile:")?C=q.substring(8):q.startsWith("collection:")?R=q.substring(11):q.startsWith("ref:")?M=q.substring(4):k?T=q:v.push(q)}return{remote:a,syncResource:k,profile:C,collection:R,ref:M,node:T,location:w&&S!==void 0?this.d.joinPath(D.URI.from({scheme:w,authority:S,query:i.query,fragment:i.fragment,path:"/"}),...v):void 0}}L(i,o){try{const a=JSON.parse(i);if((0,y.$gMb)(a))return a}catch(a){this.g.error(a)}throw new d.$vmb((0,N.localize)(0,null),"IncompatibleRemoteContent",o)}async M(i,o,a){const w=await this.e.resolveResourceContent(i,o,a);return{ref:o,content:w}}};e.$pcc=n,e.$pcc=n=r=ve([X(0,d.$qmb),X(1,d.$rmb),X(2,d.$Fmb),X(3,P.$Cl),X(4,L.$Fi),X(5,I.$5p),X(6,A.$5k),X(7,E.$El),X(8,b.$5i),X(9,h.$xi)],n)}),define(ae[265],ce([0,1,17,6,26,38,3,2,20,13,32,21,29,12,4,19,22,18,116,117,118,119,120,121,122,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t,r,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sbc=void 0;const i="sync.lastSyncTime";let o=class extends I.$Uc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(k,C,R,M,T,q,Y,K,Z,G,J){super(),this.C=k,this.D=C,this.F=R,this.G=M,this.H=T,this.I=q,this.J=Y,this.L=K,this.M=Z,this.N=G,this.O=J,this.f="uninitialized",this.g=this.B(new O.$fe),this.onDidChangeStatus=this.g.event,this.h=this.B(new O.$fe),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new O.$fe),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new O.$fe),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new O.$fe),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new O.$fe),this.onDidResetLocal=this.w.event,this.y=this.B(new O.$fe),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=R.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(i,-1,void 0),this.B((0,I.$Sc)(()=>this.bb()))}async createSyncTask(k,C){this.cb(),this.H.info("Sync started.");const R=new Date().getTime(),M=(0,E.$Ug)();try{const K=(0,s.$umb)(M);C&&(K["Cache-Control"]="no-cache"),k=await this.D.manifest(k,K)}catch(K){const Z=s.$vmb.toUserDataSyncError(K);throw S(Z,M,this.F,this.I),Z}const T=!1,q=this;let Y;return{manifest:k,async run(){if(T)throw new Error("Can run a task only once");Y=(0,N.$lh)(K=>q.P(k,!1,M,K)),await Y.finally(()=>Y=void 0),q.H.info(`Sync done. Took ${new Date().getTime()-R}ms`),q.$()},stop(){return Y?.cancel(),q.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$vmb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const k=new Date().getTime(),C=(0,E.$Ug)(),R=(0,s.$umb)(C);let M;try{M=await this.D.manifest(null,R)}catch(Y){const K=s.$vmb.toUserDataSyncError(Y);throw S(K,C,this.F,this.I),K}await this.resetLocal();const T=this,q=new L.$qe;return{id:C,async merge(){return T.P(M,!0,C,q.token)},async apply(){try{try{await T.R(M,C,q.token)}catch(Y){if(s.$vmb.toUserDataSyncError(Y).code==="MethodNotFound")T.H.info("Client is making invalid requests. Cleaning up data..."),await T.cleanUpRemoteData(),T.H.info("Applying manual sync again..."),await T.R(M,C,q.token);else throw Y}}catch(Y){throw T.H.error(Y),Y}T.H.info(`Sync done. Took ${new Date().getTime()-k}ms`),T.$()},async stop(){q.cancel(),await T.U(),await T.resetLocal()}}}async P(k,C,R,M){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const T=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(T,k,C,R,M));const q=T.enabled.find(Y=>Y.resource==="profiles");if(q){const Y=await q.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.Q(Y,k,C,R,M)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(k,C,R,M,T){for(const q of k){if(T.isCancellationRequested)return;const Y=this.M.profiles.find(Z=>Z.id===q.id);if(!Y){this.H.error(`Profile with id:${q.id} and name: ${q.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",q.name);const K=this.getOrCreateActiveProfileSynchronizer(Y,q);this.n.push(...await this.S(K,C,R,M,T))}for(const[q,Y]of this.z.entries())this.M.profiles.some(K=>K.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(q))}async R(k,C,R){const M=this.ab();for(const Z of M){if(R.isCancellationRequested)return;await Z.apply(C,R)}const T=M.find(Z=>Z.profile.isDefault);if(!T)return;const q=T.enabled.find(Z=>Z.resource==="profiles");if(!q)return;const K=(await q.getRemoteSyncedProfiles(k?.latest??null)||[]).filter(Z=>M.every(G=>G.profile.id!==Z.id));K.length&&await this.Q(K,k,!1,C,R)}async S(k,C,R,M,T){return(await k.sync(C,R,M,T)).map(([Y,K])=>({profile:k.profile,syncResource:Y,error:K}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(k=>k.stop()))}async resolveContent(k){const C=await this.N.resolveContent(k);if(C)return C;for(const R of this.ab())for(const M of R.enabled){const T=await M.resolveContent(k);if(T)return T}return null}async replace(k){this.cb();const C=this.N.resolveUserDataSyncResource(k);if(!C)return;const R=await this.resolveContent(k.uri);R&&await this.W(C.profile,async M=>{if(C.syncResource===M.resource)return await M.replace(R),!0})}async accept(k,C,R,M){this.cb(),await this.W(k.profile,async T=>{if(k.syncResource===T.resource)return await T.accept(C,R),M&&await T.apply((0,d.$eg)(M)?!1:M.force,(0,s.$umb)((0,E.$Ug)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async C=>{if(C.resource!=="globalState"&&await C.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async C=>{if(await C.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(k){this.H.error(k)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(i,-1);for(const[k]of this.z.values())try{await k.resetLocal()}catch(C){this.H.error(C)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const k=await this.N.getRemoteSyncedProfiles(),C=k.map(q=>q.collection),R=await this.D.getAllCollections(),M=R.filter(q=>!C.includes(q));M.length&&(this.H.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(q=>this.D.deleteCollection(q))),this.H.info("Deleted redundant collections on server"));const T=k.filter(q=>R.includes(q.collection));if(T.length!==k.length){const q=this.G.createInstance(n.$Pbc,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await q.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await q.updateRemoteProfiles(T,null),this.H.info("Updated remote profiles on server")}finally{q.dispose()}}}async saveRemoteActivityData(k){this.cb();const C=await this.D.getActivityData();await this.C.writeFile(k,C)}async extractActivityData(k,C){const R=(await this.C.readFile(k)).value.toString(),M=JSON.parse(R);if(M.resources)for(const T in M.resources)for(const q of M.resources[T])await this.O.writeResource(T,q.content,new Date(q.created*1e3),void 0,C);if(M.collections)for(const T in M.collections)for(const q in M.collections[T].resources)for(const Y of M.collections[T].resources?.[q]??[])await this.O.writeResource(q,Y.content,new Date(Y.created*1e3),T,C)}async W(k,C){const R=new I.$Tc;try{const M=this.z.get(k.id);if(M){const Z=await this.X(M[0],C,R);return(0,d.$fg)(Z)?null:Z}if(k.isDefault){const Z=R.add(this.G.createInstance(a,k,void 0)),G=await this.X(Z,C,R);return(0,d.$fg)(G)?null:G}if(this.M.isEnabled())return null;const T=R.add(this.G.createInstance(n.$Pbc,k,void 0)),q=await this.D.manifest(null),K=(await T.getRemoteSyncedProfiles(q?.latest??null)||[]).find(Z=>Z.id===k.id);if(K){const Z=R.add(this.G.createInstance(a,k,K.collection)),G=await this.X(Z,C,R);return(0,d.$fg)(G)?null:G}return null}finally{R.dispose()}}async X(k,C,R){const M=[...k.enabled,...k.disabled.reduce((T,q)=>(q!=="workspaceState"&&T.push(R.add(k.createSynchronizer(q))),T),[])];for(const T of M){const q=await C(T);if(!(0,d.$fg)(q))return q}}Y(k){const C=this.f;this.f!==k&&(this.f=k,this.g.fire(k),C==="hasConflicts"&&this.$())}Z(){const k=this.ab().map(C=>C.conflicts).flat();(0,D.$ub)(this.j,k,(C,R)=>C.profile.id===R.profile.id&&C.syncResource===R.syncResource&&(0,D.$ub)(C.conflicts,R.conflicts,(M,T)=>(0,P.$5g)(M.previewResource,T.previewResource)))||(this.j=k,this.m.fire(k))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(i,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(k,C){let R=this.z.get(k.id);if(R&&R[0].collection!==C?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),R[1].dispose(),R=void 0,this.z.delete(k.id)),!R){const M=new I.$Tc,T=M.add(this.G.createInstance(a,k,C?.collection));M.add(T.onDidChangeStatus(q=>this.Y(q))),M.add(T.onDidChangeConflicts(q=>this.Z())),M.add(T.onDidChangeLocal(q=>this.h.fire(q))),this.z.set(k.id,R=[T,M])}return R[0]}ab(){const k=[];for(const[C]of this.z.values())k.push(C);return k}bb(){this.z.forEach(([,k])=>k.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$Sbc=o,e.$Sbc=o=ve([X(0,l.$5k),X(1,s.$qmb),X(2,s.$pmb),X(3,c.$xi),X(4,s.$Fmb),X(5,m.$4l),X(6,b.$5p),X(7,s.$Amb),X(8,f.$El),X(9,s.$Cmb),X(10,s.$rmb)],o);let a=class extends I.$Uc{get enabled(){return this.f.sort((k,C)=>k[1]-C[1]).map(([k])=>k)}get disabled(){return s.$mmb.filter(k=>!this.r.isResourceEnabled(k))}get status(){return this.g}get conflicts(){return this.m}constructor(k,C,R,M,T,q,Y,K,Z,G){super(),this.profile=k,this.collection=C,this.r=R,this.t=M,this.u=T,this.w=q,this.y=Y,this.z=K,this.C=Z,this.D=G,this.f=[],this.g="idle",this.h=this.B(new O.$fe),this.onDidChangeStatus=this.h.event,this.j=this.B(new O.$fe),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new O.$fe),this.onDidChangeConflicts=this.n.event,this.B(R.onDidChangeResourceEnablement(([J,V])=>this.F(J,V))),this.B((0,I.$Sc)(()=>this.f.splice(0,this.f.length).forEach(([,,J])=>J.dispose())));for(const J of s.$mmb)R.isResourceEnabled(J)&&this.G(J)}F(k,C){C?this.G(k):this.H(k)}G(k){if(this.f.some(([T])=>T.resource===k))return;if(k==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(k==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||k==="workspaceState")return;if(k!=="profiles"&&this.profile.useDefaultFlags?.[k]){this.z.debug(`Skipping syncing ${k} in ${this.profile.name} because it is already synced by default profile`);return}const C=new I.$Tc,R=C.add(this.createSynchronizer(k));C.add(R.onDidChangeStatus(()=>this.L())),C.add(R.onDidChangeConflicts(()=>this.M())),C.add(R.onDidChangeLocal(()=>this.j.fire(k)));const M=this.N(k);this.f.push([R,M,C])}H(k){const C=this.f.findIndex(([R])=>R.resource===k);if(C!==-1){const[[R,,M]]=this.f.splice(C,1);M.dispose(),this.L(),Promise.allSettled([R.stop(),R.resetLocal()]).then(null,T=>this.z.error(T))}}createSynchronizer(k){switch(k){case"settings":return this.t.createInstance($.$Z_b,this.profile,this.collection);case"keybindings":return this.t.createInstance(g.$W_b,this.profile,this.collection);case"snippets":return this.t.createInstance(t.$5_b,this.profile,this.collection);case"tasks":return this.t.createInstance(r.$8_b,this.profile,this.collection);case"globalState":return this.t.createInstance(h.$oMb,this.profile,this.collection);case"extensions":return this.t.createInstance(u.$R_b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$Pbc,this.profile,this.collection)}}async sync(k,C,R,M){if(M.isCancellationRequested)return[];const T=this.enabled;if(!T.length)return[];try{const q=[],Y=(0,s.$umb)(R),K=(this.collection?k?.collections?.[this.collection]?.latest:k?.latest)??null,Z=C?await this.I(K):{};for(const G of T){if(M.isCancellationRequested)return[];if(!this.r.isResourceEnabled(G.resource))return[];try{if(C){const J=await G.preview(K,Z,Y);if(J)for(const V of J.resourcePreviews)(V.localChange!==0||V.remoteChange!==0)&&V.mergeState==="preview"&&await G.merge(V.previewResource)}else await G.sync(K,Y)}catch(J){const V=s.$vmb.toUserDataSyncError(J);if(S(V,R,this.w,this.y),w(J))throw V;this.z.error(J),this.z.error(`${G.resource}: ${(0,A.$jj)(J)}`),q.push([G.resource,V])}}return q}finally{this.L()}}async apply(k,C){const R=(0,s.$umb)(k);for(const M of this.enabled){if(C.isCancellationRequested)return;try{await M.apply(!1,R)}catch(T){const q=s.$vmb.toUserDataSyncError(T);if(S(q,k,this.w,this.y),w(T))throw q;this.z.error(T),this.z.error(`${M.resource}: ${(0,A.$jj)(T)}`)}}}async stop(){for(const k of this.enabled)try{k.status!=="idle"&&await k.stop()}catch(C){this.z.error(C)}}async resetLocal(){for(const k of this.enabled)try{await k.resetLocal()}catch(C){this.z.error(`${k.resource}: ${(0,A.$jj)(C)}`),this.z.error(C)}}async I(k){if(!this.profile.isDefault)return{};const C=this.D.getValue(s.$imb),R=this.enabled.find(M=>M instanceof $.$Z_b);if(R){const M=await R.getRemoteUserDataSyncConfiguration(k);return{...C,...M}}return C}J(k){this.g!==k&&(this.g=k,this.h.fire(k))}L(){return this.M(),this.enabled.some(k=>k.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(k=>k.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const k=this.enabled.filter(C=>C.status==="hasConflicts").filter(C=>C.conflicts.conflicts.length>0).map(C=>C.conflicts);(0,D.$ub)(this.m,k,(C,R)=>C.syncResource===R.syncResource&&(0,D.$ub)(C.conflicts,R.conflicts,(M,T)=>(0,P.$5g)(M.previewResource,T.previewResource)))||(this.m=k,this.n.fire(k))}N(k){switch(k){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=ve([X(2,s.$Amb),X(3,c.$xi),X(4,p.$0o),X(5,s.$pmb),X(6,m.$4l),X(7,s.$Fmb),X(8,f.$El),X(9,y.$5i)],a);function w(v){if(v instanceof s.$vmb)switch(v.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function S(v,k,C,R){R.publicLog2("sync/error",{code:v.code,serverCode:v instanceof s.$wmb?String(v.serverCode):void 0,url:v instanceof s.$wmb?v.url:void 0,resource:v.resource,executionId:k,service:C.userDataSyncStore.url.toString()})}}),define(ae[266],ce([0,1,3,2,8,18,25]),function(ne,e,D,N,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bfc=e.$afc=void 0;function I(p,l){return{...p,profile:(0,A.$Fl)(p.profile,l.profilesHome.scheme)}}function P(p){return{created:p.created,uri:L.URI.revive(p.uri)}}class d{constructor(l,c,b){this.c=l,this.d=c,this.f=b,this.a=new Map,this.b=new D.$fe}listen(l,c){switch(c){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`[UserDataSyncServiceChannel] Event not found: ${c}`)}async call(l,c,b){try{return await this.g(l,c,b)}catch(m){throw this.f.error(m),m}}async g(l,c,b){switch(c){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(L.URI.revive(b[0]));case"accept":return this.c.accept(I(b[0],this.d),L.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(P(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(L.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(L.URI.revive(b[0]),L.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if(c.startsWith("manualSync/")){const m=c.substring(11),f=b[0],u=this.h(f);switch(b=b.slice(1),m){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(l){const c=this.a.get(this.j(l));if(!c)throw new Error(`Manual sync taks not found: ${l}`);return c}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$afc=d;let E=class extends N.$Uc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,c){super(),this.n=c,this.b="uninitialized",this.c=this.B(new D.$fe),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new D.$fe),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new D.$fe),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new D.$fe),this.onSyncErrors=this.m.event,this.a={call(b,m,f){return l.call(b,m,f).then(null,u=>{throw O.$vmb.toUserDataSyncError(u)})},listen(b,m){return l.listen(b,m)}},this.a.call("_getInitialData").then(([b,m,f])=>{this.s(b),this.t(m),f&&this.u(f),this.B(this.a.listen("onDidChangeStatus")(u=>this.s(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.u(u)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(m=>({...m,error:O.$vmb.toUserDataSyncError(m.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),c=this;return new y(l,{async call(m,f,u){return c.a.call(`manualSync/${m}`,[l,...Array.isArray(f)?f:[f]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,c,b,m){return this.a.call("accept",[l,c,b,m])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,c){return this.a.call("extractActivityData",[l,c])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map(c=>({syncResource:c.syncResource,profile:(0,A.$Fl)(c.profile,this.n.profilesHome.scheme),conflicts:c.conflicts.map(b=>({...b,baseResource:L.URI.revive(b.baseResource),localResource:L.URI.revive(b.localResource),remoteResource:L.URI.revive(b.remoteResource),previewResource:L.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$bfc=E,e.$bfc=E=ve([X(1,A.$El)],E);class y extends N.$Uc{constructor(l,c){super(),this.id=l,this.a=c}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(ae[123],ce([0,1,6,26,7,3,2,142,5,20,13,8,32,21,16,12,24,59,45,19,25]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eMb=e.$dMb=e.$cMb=e.$bMb=e.$aMb=void 0;const $="configurationSync.store",t="sync.previous.store",r="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",i=100,o=1e3*60*5;let a=class extends O.$Uc{get userDataSyncStore(){return this.b}get c(){return this.h.get(g.$ymb,-1)}set c(R){this.h.store(g.$ymb,R,-1,P.$o?0:1)}constructor(R,M,T){super(),this.f=R,this.g=M,this.h=T,this.a=this.B(new A.$fe),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const q=this.B(new O.$Tc);this.B(A.Event.filter(T.onDidChangeValue(-1,g.$ymb,q),()=>this.c!==this.userDataSyncStore?.type,q)(()=>this.j()))}j(){this.b=this.m(this.f[$]),this.a.fire()}m(R){if(R&&(R=P.$o&&R.web?{...R,...R.web}:R,(0,E.$$f)(R.url)&&(0,E.$ag)(R.authenticationProviders)&&Object.keys(R.authenticationProviders).every(M=>Array.isArray(R.authenticationProviders[M].scopes)))){const M=R,T=!!M.canSwitch,q=M.url===M.insidersUrl?"insiders":"stable",Y=(T?this.c:void 0)||q,K=Y==="insiders"?M.insidersUrl:Y==="stable"?M.stableUrl:M.url;return{url:y.URI.parse(K),type:Y,defaultType:q,defaultUrl:y.URI.parse(M.url),stableUrl:y.URI.parse(M.stableUrl),insidersUrl:y.URI.parse(M.insidersUrl),canSwitch:T,authenticationProviders:Object.keys(M.authenticationProviders).reduce((Z,G)=>(Z.push({id:G,scopes:M.authenticationProviders[G].scopes}),Z),[])}}}};e.$aMb=a,e.$aMb=a=ve([X(0,m.$lk),X(1,l.$5i),X(2,h.$5p)],a);let w=class extends a{constructor(R,M,T){super(R,M,T);const q=this.h.get(t,-1);q&&(this.n=JSON.parse(q));const Y=this.f[$];Y?this.h.store(t,JSON.stringify(Y),-1,1):this.h.remove(t,-1)}async switch(R){R!==this.c&&(this.c=R,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$bMb=w,e.$bMb=w=ve([X(0,m.$lk),X(1,l.$5i),X(2,h.$5p)],w);let S=class extends O.$Uc{get donotMakeRequestsUntil(){return this.j}constructor(R,M,T,q,Y,K,Z){super(),this.n=T,this.r=q,this.s=Z,this.g=this.B(new A.$fe),this.onTokenFailed=this.g.event,this.h=this.B(new A.$fe),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$fe),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(R),this.c=(0,u.$$p)(Y,K,Z).then(G=>{const J={"X-Client-Name":`${M.applicationName}${P.$o?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(J["X-Client-Commit"]=M.commit),J}),this.f=new k(i,o,this.n,this.r),this.u(),this.B((0,O.$Sc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(R,M){this.b={token:R,type:M}}t(R){this.a=R?(0,d.$_g)(R,"v1"):void 0}u(){const R=this.s.getNumber(r,-1);R&&Date.now()<R&&this.y(new Date(R))}y(R){this.j?.getTime()!==R?.getTime()&&(this.j=R,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(r,this.j.getTime(),-1,1),this.w=(0,D.$lh)(M=>(0,D.$zh)(this.j.getTime()-Date.now(),M).then(()=>this.y(void 0))),this.w.then(null,M=>null)):this.s.remove(r,-1),this.m.fire())}async getAllCollections(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$_g)(this.a,"collection").toString();R={...R},R["Content-Type"]="application/json";const T=await this.D(M,{type:"GET",headers:R},[],N.CancellationToken.None);return(await(0,f.$Xp)(T))?.map(({id:q})=>q)||[]}async createCollection(R={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,d.$_g)(this.a,"collection").toString();R={...R},R["Content-Type"]=I.$Us.text;const T=await this.D(M,{type:"POST",headers:R},[],N.CancellationToken.None),q=await(0,f.$Wp)(T);if(!q)throw new g.$wmb("Server did not return the collection id",M,"NoCollection",T.res.statusCode,T.res.headers[g.$smb]);return q}async deleteCollection(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=R?(0,d.$_g)(this.a,"collection",R).toString():(0,d.$_g)(this.a,"collection").toString();M={...M},await this.D(T,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(R,M){if(!this.a)throw new Error("No settings sync store url configured.");const T=this.z(this.a,M,R),q={},Y=await this.D(T.toString(),{type:"GET",headers:q},[],N.CancellationToken.None);return(await(0,f.$Xp)(Y)||[]).map(({url:Z,created:G})=>({ref:(0,d.$bh)(T,T.with({path:Z})),created:G*1e3}))}async resolveResourceContent(R,M,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$_g)(this.z(this.a,T,R),M).toString();q={...q},q["Cache-Control"]="no-cache";const K=await this.D(Y,{type:"GET",headers:q},[],N.CancellationToken.None);return await(0,f.$Wp)(K)}async deleteResource(R,M,T){if(!this.a)throw new Error("No settings sync store url configured.");const q=M!==null?(0,d.$_g)(this.z(this.a,T,R),M).toString():this.z(this.a,T,R).toString(),Y={};await this.D(q,{type:"DELETE",headers:Y},[],N.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,d.$_g)(this.a,"resource").toString(),M={"Content-Type":I.$Us.text};await this.D(R,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(R,M,T,q={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,d.$_g)(this.z(this.a,T,R),"latest").toString();q={...q},q["Cache-Control"]="no-cache",M&&(q["If-None-Match"]=M.ref);const K=await this.D(Y,{type:"GET",headers:q},[304],N.CancellationToken.None);let Z=null;if(K.res.statusCode===304&&(Z=M),Z===null){const G=K.res.headers.etag;if(!G)throw new g.$wmb("Server did not return the ref",Y,"NoRef",K.res.statusCode,K.res.headers[g.$smb]);const J=await(0,f.$Wp)(K);if(!J&&K.res.statusCode===304)throw new g.$wmb("Empty response",Y,"EmptyResponse",K.res.statusCode,K.res.headers[g.$smb]);Z={ref:G,content:J}}return Z}async writeResource(R,M,T,q,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const K=this.z(this.a,q,R).toString();Y={...Y},Y["Content-Type"]=I.$Us.text,T&&(Y["If-Match"]=T);const Z=await this.D(K,{type:"POST",data:M,headers:Y},[],N.CancellationToken.None),G=Z.res.headers.etag;if(!G)throw new g.$wmb("Server did not return the ref",K,"NoRef",Z.res.statusCode,Z.res.headers[g.$smb]);return G}async manifest(R,M={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,d.$_g)(this.a,"manifest").toString();M={...M},M["Content-Type"]="application/json",R&&(M["If-None-Match"]=R.ref);const q=await this.D(T,{type:"GET",headers:M},[304],N.CancellationToken.None);let Y=null;if(q.res.statusCode===304&&(Y=R),!Y){const Z=q.res.headers.etag;if(!Z)throw new g.$wmb("Server did not return the ref",T,"NoRef",q.res.statusCode,q.res.headers[g.$smb]);const G=await(0,f.$Wp)(q);if(!G&&q.res.statusCode===304)throw new g.$wmb("Empty response",T,"EmptyResponse",q.res.statusCode,q.res.headers[g.$smb]);G&&(Y={...JSON.parse(G),ref:Z})}const K=this.s.get(n,-1);return K&&Y&&K!==Y.session&&this.C(),Y===null&&K&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const R=(0,d.$_g)(this.a,"download").toString(),M={},T=await this.D(R,{type:"GET",headers:M},[],N.CancellationToken.None);if(!(0,f.$Tp)(T))throw new g.$wmb("Server returned "+T.res.statusCode,R,"EmptyResponse",T.res.statusCode,T.res.headers[g.$smb]);if((0,f.$Up)(T))throw new g.$wmb("Empty response",R,"EmptyResponse",T.res.statusCode,T.res.headers[g.$smb]);return T.stream}z(R,M,T){return M?(0,d.$_g)(R,"collection",M,"resource",T):(0,d.$_g)(R,"resource",T)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(R,M,T,q){if(!this.b)throw new g.$wmb("No Auth Token Available",R,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new g.$wmb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;M.headers={...M.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(M.headers),this.r.trace("Sending request to server",{url:R,type:M.type,headers:{...M.headers,authorization:void 0}});let K;try{K=await this.f.request(R,M,q)}catch(H){if(!(H instanceof g.$wmb)){let ie="RequestFailed";const se=(0,L.$0)(H).toLowerCase();se.includes("xhr timeout")?ie="RequestTimeout":se.includes("protocol")&&se.includes("not supported")?ie="RequestProtocolNotSupported":se.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":se.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,L.$4)(H)&&(ie="RequestCanceled"),H=new g.$wmb(`Connection refused for the request '${R}'.`,R,ie,void 0,void 0)}throw this.r.info("Request failed",R),H}const Z=K.res.headers[g.$smb],G={url:R,status:K.res.statusCode,"execution-id":M.headers[g.$tmb],"operation-id":Z},J=(0,f.$Tp)(K)||K.res.statusCode&&T.includes(K.res.statusCode);let V="";if(J?this.r.trace("Request succeeded",G):(V=await(0,f.$Vp)(K)||"",this.r.info("Request failed",G,V)),K.res.statusCode===401||K.res.statusCode===403){if(this.b=void 0,K.res.statusCode===401)throw this.g.fire("Unauthorized"),new g.$wmb(`${M.type} request '${R}' failed because of Unauthorized (401).`,R,"Unauthorized",K.res.statusCode,Z);if(K.res.statusCode===403)throw this.g.fire("Forbidden"),new g.$wmb(`${M.type} request '${R}' failed because the access is forbidden (403).`,R,"Forbidden",K.res.statusCode,Z)}if(this.h.fire(),K.res.statusCode===404)throw new g.$wmb(`${M.type} request '${R}' failed because the requested resource is not found (404).`,R,"NotFound",K.res.statusCode,Z);if(K.res.statusCode===405)throw new g.$wmb(`${M.type} request '${R}' failed because the requested endpoint is not found (405). ${V}`,R,"MethodNotFound",K.res.statusCode,Z);if(K.res.statusCode===409)throw new g.$wmb(`${M.type} request '${R}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,R,"Conflict",K.res.statusCode,Z);if(K.res.statusCode===410)throw new g.$wmb(`${M.type} request '${R}' failed because the requested resource is not longer available (410).`,R,"Gone",K.res.statusCode,Z);if(K.res.statusCode===412)throw new g.$wmb(`${M.type} request '${R}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,R,"PreconditionFailed",K.res.statusCode,Z);if(K.res.statusCode===413)throw new g.$wmb(`${M.type} request '${R}' failed because of too large payload (413).`,R,"TooLarge",K.res.statusCode,Z);if(K.res.statusCode===426)throw new g.$wmb(`${M.type} request '${R}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,R,"UpgradeRequired",K.res.statusCode,Z);if(K.res.statusCode===429){const H=K.res.headers["retry-after"];throw H?(this.y(new Date(Date.now()+parseInt(H)*1e3)),new g.$wmb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"TooManyRequestsAndRetryAfter",K.res.statusCode,Z)):new g.$wmb(`${M.type} request '${R}' failed because of too many requests (429).`,R,"RemoteTooManyRequests",K.res.statusCode,Z)}if(!J)throw new g.$wmb("Server returned "+K.res.statusCode,R,"Unknown",K.res.statusCode,Z);return K}F(R){let M=this.s.get(s,-1);M===void 0&&(M=(0,p.$Ug)(),this.s.store(s,M,-1,1)),R["X-Machine-Session-Id"]=M;const T=this.s.get(n,-1);T!==void 0&&(R["X-User-Session-Id"]=T)}};e.$cMb=S,e.$cMb=S=ve([X(1,m.$lk),X(2,f.$Rp),X(3,g.$Fmb),X(4,c.$Fi),X(5,b.$5k),X(6,h.$5p)],S);let v=class extends S{constructor(R,M,T,q,Y,K,Z){super(R.userDataSyncStore?.url,M,T,q,Y,K,Z),this.B(R.onDidChangeUserDataSyncStore(()=>this.t(R.userDataSyncStore?.url)))}};e.$dMb=v,e.$dMb=v=ve([X(0,g.$pmb),X(1,m.$lk),X(2,f.$Rp),X(3,g.$Fmb),X(4,c.$Fi),X(5,b.$5k),X(6,h.$5p)],v);class k{constructor(R,M,T,q){this.c=R,this.d=M,this.f=T,this.g=q,this.a=[],this.b=void 0}request(R,M,T){if(this.h()&&this.i(),M.url=R,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new g.$wmb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,R,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(R),this.f.request(M,T)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$eMb=k}),define(ae[267],ce([0,1,3,2,8,21,24,19,123]),function(ne,e,D,N,L,A,O,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_ec=e.$$ec=e.$0ec=e.$9ec=void 0;class d{constructor(c){this.a=c}listen(c,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`[UserDataSyncAccountServiceChannel] Event not found: ${b}`)}call(c,b,m){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(m)}throw new Error("Invalid call")}}e.$9ec=d;class E extends N.$Uc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor(c){super(),this.c=c,this.b=this.B(new D.$fe),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(m=>{this.a=m,this.b.fire(m)}))})}updateAccount(c){return this.c.call("updateAccount",c)}}e.$0ec=E;class y{constructor(c){this.a=c}listen(c,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`[UserDataSyncStoreManagementServiceChannel] Event not found: ${b}`)}call(c,b,m){switch(b){case"switch":return this.a.switch(m[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$$ec=y;let p=class extends P.$aMb{constructor(c,b,m,f){super(b,m,f),this.n=c,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch(c){return this.n.call("switch",[c])}async getPreviousUserDataSyncStore(){const c=await this.n.call("getPreviousUserDataSyncStore");return this.r(c)}r(c){return{url:L.URI.revive(c.url),type:c.type,defaultUrl:L.URI.revive(c.defaultUrl),insidersUrl:L.URI.revive(c.insidersUrl),stableUrl:L.URI.revive(c.stableUrl),canSwitch:c.canSwitch,authenticationProviders:c.authenticationProviders}}};e.$_ec=p,e.$_ec=p=ve([X(1,O.$lk),X(2,A.$5i),X(3,I.$5p)],p)}),define(ae[268],ce([0,1,3,57,24,19,22,263,25,80,83]),function(ne,e,D,N,L,A,O,I,P,d,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vfc=void 0;let y=class extends I.$Tbc{constructor(l,c,b,m,f,u,h,g,$,t,r){super(l,c,b,m,f,h,g,$,t,r),this.B(D.Event.debounce(D.Event.any(D.Event.map(u.onDidFocusMainWindow,()=>"windowFocus"),D.Event.map(u.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$vfc=y,e.$vfc=y=ve([X(0,L.$lk),X(1,P.$pmb),X(2,P.$qmb),X(3,P.$Amb),X(4,P.$Bmb),X(5,N.$mdc),X(6,P.$Fmb),X(7,d.$AKb),X(8,O.$4l),X(9,E.$dmb),X(10,A.$5p)],y)}),define(ae[269],ce([0,1,73,23,5,20]),function(ne,e,D,N,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0,e.$Ncc=O,e.$Occ=I,e.$Pcc=P,e.$Mcc=128/4;function O(d){function E(){let y=d.scheme===N.Schemas.file?(0,A.$Zg)(d):d.toString();return L.$k||(y=y.toLowerCase()),(0,D.createHash)("md5").update(y).digest("hex")}return{id:E(),configPath:d}}function I(d,E){function y(){if(d.scheme!==N.Schemas.file)return(0,D.createHash)("md5").update(d.toString()).digest("hex");if(!E)return;let l;return L.$k?l=E.ino:L.$j?l=E.birthtime.getTime():L.$i&&(typeof E.birthtimeMs=="number"?l=Math.floor(E.birthtimeMs):l=E.birthtime.getTime()),(0,D.createHash)("md5").update(d.fsPath).update(l?String(l):"").digest("hex")}const p=y();if(typeof p=="string")return{id:p,uri:d}}function P(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(ae[270],ce([0,1,6,7,2,14,31,16,9,77,112,269,57,56,23]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ec=void 0;let b=class extends L.$Uc{constructor(f,u,h,g){super(),this.a=f,this.b=u,this.c=h,this.f=g,this.B(new D.$Kh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const f=this.a.workspaceStorageHome.with({scheme:c.Schemas.file}).fsPath,u=await O.Promises.readdir(f),h=new d.$bLb(this.f.getChannel("storage"));await Promise.all(u.map(async g=>{const $=(0,A.$jc)(f,g);g.length===y.$Mcc||g===E.$Ki.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===g)||await h.isUsed($)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${g} as it seems to be an unused empty workspace.`),await O.Promises.rm($))}))}catch(f){(0,N.$1)(f)}}};e.$5ec=b,e.$5ec=b=ve([X(0,I.$Gi),X(1,P.$5j),X(2,p.$mdc),X(3,l.$Bec)],b)}),define(ae[124],ce([0,1,73,64,37,279,15,7,3,2,14,5,32,42,68]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$pi=e.$oi=e.$ni=void 0,e.$qi=n,e.$ri=s,e.$ti=a,e.$ui=w;class b{traceSocketEvent(v,k){c.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,v,k)}constructor(v,k=""){this.f=!0,this.debugLabel=k,this.socket=v,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,I.$1)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(v){const k=C=>{this.traceSocketEvent("read",C),v(O.$He.wrap(C))};return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(v){const k=C=>{v({type:0,hadError:C,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(v){const k=()=>{v()};return this.socket.on("end",k),{dispose:()=>this.socket.off("end",k)}}write(v){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",v),this.socket.write(v.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,I.$1)(k)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((v,k)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),v();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),v()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.$ni=b;var m;(function(S){S[S.MinHeaderByteSize=2]="MinHeaderByteSize",S[S.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(m||(m={}));var f;(function(S){S[S.PeekHeader=1]="PeekHeader",S[S.ReadHeader=2]="ReadHeader",S[S.ReadBody=3]="ReadBody",S[S.Fin=4]="Fin"})(f||(f={}));class u extends d.$Uc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(v,k){this.socket.traceSocketEvent(v,k)}constructor(v,k,C,R){super(),this.f=this.B(new P.$fe),this.g=this.B(new P.$fe),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=v,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:k,inflateBytesLength:C?.byteLength||0,recordInflateBytes:R}),this.a=this.B(new h(this,k,C,R,this.f,(M,T)=>this.m(M,T))),this.B(this.a.onError(M=>{console.error(M),(0,I.$1)(M),this.g.fire({type:0,hadError:!0,error:M})})),this.b=new c.$ii,this.B(this.socket.onData(M=>this.n(M))),this.B(this.socket.onClose(async M=>{this.a.isProcessingReadQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(M)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this.f.event(v)}onClose(v){return this.g.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){let k=0;for(;k<v.byteLength;)this.a.writeMessage(v.slice(k,Math.min(k+262144,v.byteLength)),{compressed:!0,opcode:2}),k+=262144}m(v,{compressed:k,opcode:C}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",v);let R=2;v.byteLength<126?R+=0:v.byteLength<2**16?R+=2:R+=8;const M=O.$He.alloc(R),T=k?64:0,q=C&15;if(M.writeUInt8(128|T|q,0),v.byteLength<126)M.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){M.writeUInt8(126,1);let Y=1;M.writeUInt8(v.byteLength>>>8&255,++Y),M.writeUInt8(v.byteLength>>>0&255,++Y)}else{M.writeUInt8(127,1);let Y=1;M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(0,++Y),M.writeUInt8(v.byteLength>>>24&255,++Y),M.writeUInt8(v.byteLength>>>16&255,++Y),M.writeUInt8(v.byteLength>>>8&255,++Y),M.writeUInt8(v.byteLength>>>0&255,++Y)}this.socket.write(O.$He.concat([M,v]))}end(){this.h=!0,this.socket.end()}n(v){if(v.byteLength!==0){for(this.b.acceptChunk(v);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const k=this.b.peek(this.j.readLen),C=k.readUInt8(0),R=(C&128)>>>7,M=(C&64)>>>6,T=C&15,q=k.readUInt8(1),Y=(q&128)>>>7,K=q&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(K===126?2:0)+(K===127?8:0),this.j.fin=R,this.j.firstFrameOfMessage&&(this.j.compressed=!!M),this.j.firstFrameOfMessage=!!R,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const k=this.b.read(this.j.readLen),C=k.readUInt8(1),R=(C&128)>>>7;let M=C&127,T=1;M===126?M=k.readUInt8(++T)*2**8+k.readUInt8(++T):M===127&&(M=k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*0+k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T));let q=0;R&&(q=k.readUInt8(++T)*2**24+k.readUInt8(++T)*2**16+k.readUInt8(++T)*2**8+k.readUInt8(++T)),this.j.state=3,this.j.readLen=M,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const k=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",k),t(k,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",k),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(k,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(k,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await P.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$oi=u;class h extends d.$Uc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:O.$He.alloc(0)}constructor(v,k,C,R,M,T){super(),this.n=v,this.r=M,this.s=T,this.a=this.B(new P.$fe),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new P.$fe),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new P.$fe),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,k?(this.b=this.B(new g(this.n,R,C,{windowBits:15})),this.f=this.B(new $(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(v,k){this.g.push({data:v,options:k}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:v,options:k}=this.g.shift();if(this.f&&k.compressed){const C=await this.w(this.f,v);this.s(C,k)}else this.s(v,{...k,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(v,k){return new Promise((C,R)=>{v.write(k),v.flush(M=>C(M))})}acceptFrame(v,k,C){this.h.push({data:v,isCompressed:k,isLastFrameOfMessage:C}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const v=this.h.shift();if(this.b&&v.isCompressed){const k=await this.C(this.b,v.data,v.isLastFrameOfMessage);this.r.fire(k)}else this.r.fire(v.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(v,k,C){return new Promise((R,M)=>{v.write(k),C&&v.write(O.$He.fromByteArray([0,0,255,255])),v.flush(T=>R(T))})}}class g extends d.$Uc{get recordedInflateBytes(){return this.j?O.$He.concat(this.f):O.$He.alloc(0)}constructor(v,k,C,R){super(),this.h=v,this.j=k,this.a=this.B(new P.$fe),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(R),this.b.on("error",M=>{this.h.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.h.traceSocketEvent("zlibInflateData",M),this.g.push(O.$He.wrap(M))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(v){this.j&&this.f.push(v.clone()),this.h.traceSocketEvent("zlibInflateWrite",v),this.b.write(v.buffer)}flush(v){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const k=O.$He.concat(this.g);this.g.length=0,v(k)})}}class $ extends d.$Uc{constructor(v,k){super(),this.g=v,this.a=this.B(new P.$fe),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(O.$He.wrap(C))})}write(v){this.g.traceSocketEvent("zlibDeflateWrite",v.buffer),this.b.write(v.buffer)}flush(v){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let k=O.$He.concat(this.f);this.f.length=0,k=k.slice(0,k.byteLength-4),v(k)})}}function t(S,v){if(v===0)return;const k=S.byteLength>>>2;for(let Y=0;Y<k;Y++){const K=S.readUInt32BE(Y*4);S.writeUInt32BE(K^v,Y*4)}const C=k*4,R=S.byteLength-C,M=v>>>24&255,T=v>>>16&255,q=v>>>8&255;R>=1&&S.writeUInt8(S.readUInt8(C)^M,C),R>=2&&S.writeUInt8(S.readUInt8(C+1)^T,C+1),R>=3&&S.writeUInt8(S.readUInt8(C+2)^q,C+2)}e.$pi=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function n(){const S=(0,p.$Ug)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${S}-sock`;const v=process.platform!=="darwin"&&e.$pi?e.$pi:(0,L.tmpdir)(),k=(0,E.$jc)(v,`vscode-ipc-${S}.sock`);return i(k),k}function s(S,v,k){const R=(0,D.createHash)("sha256").update(S).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${v}-sock`;const M=k.substr(0,4),T=v.substr(0,6);let q;return process.platform!=="darwin"&&e.$pi&&!process.env.VSCODE_PORTABLE?q=(0,E.$jc)(e.$pi,`vscode-${R}-${M}-${T}.sock`):q=(0,E.$jc)(S,`${M}-${T}.sock`),i(q),q}function i(S){const v=r[y.$u];typeof v=="number"&&S.length>=v&&console.warn(`WARNING: IPC handle "${S}" is longer than ${v} chars, try a shorter --user-data-dir`)}class o extends l.$ci{static b(v){const k=P.Event.fromNodeEventEmitter(v,"connection");return P.Event.map(k,C=>({protocol:new c.$ji(new b(C,"ipc-server-connection")),onDidClientDisconnect:P.Event.once(P.Event.fromNodeEventEmitter(C,"close"))}))}constructor(v){super(o.b(v)),this.d=v}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$si=o;function a(S){return new Promise((v,k)=>{const C=(0,N.createServer)();C.on("error",k),C.listen(S,()=>{C.removeListener("error",k),v(new o(C))})})}function w(S,v){return new Promise((k,C)=>{const R=(0,N.createConnection)(S,()=>{R.removeListener("error",C),k(c.$ki.fromSocket(new b(R,`ipc-client${v}`),v))});R.once("error",C)})}}),define(ae[271],ce([0,1,64,124,219]),function(ne,e,D,N,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=void 0,e.$yfc=new class{supports(A){return!0}connect({host:A,port:O},I,P,d){return new Promise((E,y)=>{const p=D.createConnection({host:A,port:O},()=>{p.removeListener("error",y),p.write((0,L.$Uvb)(I,P,d));const l=c=>{c.toString().indexOf(`\r
\r
`)>=0&&(p.off("data",l),E(new N.$ni(p,d)))};p.on("data",l)});p.setNoDelay(!0),p.once("error",y)})}}}),define(ae[272],ce([0,1,64,37,134,124,6,2,5,21,9,24,221,103,105,78,15]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=e.$uec=e.$tec=e.$sec=void 0;async function f(t,r,n,s,i){let o;for(let a=3;a&&(o?.dispose(),o=await new u(t,r,n,s,i).waitForReady(),!(i&&L.$Xg[i]||!L.$Xg[o.tunnelLocalPort]));a--);return o}class u extends I.$Uc{constructor(r,n,s,i,o){super(),this.m=n,this.n=o,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new O.$xh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,n=(0,b.$uw)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,L.$Yg)(r,2,1e3,n),i=null;return this.b.listen(s,this.m),await this.c.wait(),i=this.b.address(),i||(s=0,this.b.listen(s,this.m),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async r(r){r.pause();const n=(0,b.$sw)(this.tunnelRemoteHost)||(0,b.$uw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,p.$Ul)(this.a,n,this.tunnelRemotePort),i=s.getSocket(),o=s.readEntireBuffer();s.dispose(),o.byteLength>0&&r.write(o.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),i.end()}),r.on("close",()=>i.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),i instanceof A.$ni?i.socket.destroy():i.end()}),i instanceof A.$ni?this.t(r,i):this.s(r,i),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),i.end()})}s(r,n){n.onClose(()=>r.destroy()),n.onEnd(()=>r.end()),n.onData(s=>r.write(s.buffer)),r.on("data",s=>n.write(m.$He.wrap(s))),r.resume()}t(r,n){const s=n.socket;s.on("end",()=>r.end()),s.on("close",()=>r.end()),s.on("error",()=>{r.destroy()}),s.pipe(r),r.pipe(s)}}e.$sec=u;let h=class extends b.$xw{constructor(r,n,s,i,o){super(n,o),this.v=r,this.w=s,this.y=i}isPortPrivileged(r){return(0,b.$vw)(r,this.m,P.OS,N.release())}t(r,n,s,i,o,a,w,S){const v=this.s(n,s);if(v)return++v.refcount,v.value;if((0,b.$ow)(r))return this.u(r,n,s,o,a,w,S);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${o}.`);const k={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},C=f(k,i,n,s,o);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,C),C}}};e.$tec=h,e.$tec=h=ve([X(0,l.$Ol),X(1,E.$5j),X(2,c.$Rl),X(3,y.$lk),X(4,d.$5i)],h);let g=class extends h{constructor(r,n,s,i,o){super(r,n,s,i,o)}};e.$uec=g,e.$uec=g=ve([X(0,l.$Ol),X(1,E.$5j),X(2,c.$Rl),X(3,y.$lk),X(4,d.$5i)],g);let $=class extends I.$Uc{constructor(r,n,s,i,o){super(),this.b=r,this.c=n,this.f=s,this.g=i,this.h=o,this.a=new Map}async openTunnel(r,n,s,i,o,a,w,S,v){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${i} on local port ${a}.`),!this.a.has(r)){const k=new g(this.b,this.c,this.g,this.f,this.h);this.B(k),this.a.set(r,k),k.onTunnelClosed(async()=>{(await k.tunnels).length===0&&(k.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(n,s,i,o,a,w,S,v)}};e.$vec=$,e.$vec=$=ve([X(0,l.$Ol),X(1,E.$5j),X(2,y.$lk),X(3,c.$Rl),X(4,d.$5i)],$)}),define(ae[280],ce([0,1,37,38,7,2,23,8,17,3,42,152,213,214,204,205,270,194,196,21,218,94,229,95,224,16,115,254,29,107,195,114,96,12,207,208,72,4,203,74,75,234,9,209,100,24,59,19,106,22,108,109,110,49,237,82,111,25,80,262,267,247,83,261,265,266,123,60,260,248,105,228,78,272,223,238,28,239,5,240,197,216,215,81,253,18,52,212,58,259,236,249,104,264,255,10,210,99,257,252,225,191,57,211,268,256,56,258,103,271,188,226,148,141,146]),function(ne,e,D,N,L,A,O,I,P,d,E,y,p,l,c,b,m,f,u,h,g,$,t,r,n,s,i,o,a,w,S,v,k,C,R,M,T,q,Y,K,Z,G,J,V,H,ie,se,he,ee,W,z,j,F,B,U,Q,x,te,_,oe,ue,$e,de,ge,be,Ee,Pe,Re,le,we,pe,Ce,De,Le,Oe,Te,Ae,qe,Ve,Me,Ne,Ue,re,fe,me,ye,ke,Ie,Fe,He,Be,Je,ze,Ye,Xe,tt,nt,mt,Pt,Ct,It,Rt,Dt,Ot,jt,Lt,wt,At,pt,Nt,Mt,ot,Ft,Tt,bt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=yt;class qt extends A.$Uc{constructor(Se){super(),this.f=Se,this.a=this.B(new y.$vW(this)),this.b=void 0,this.c=this.B(new d.$fe),this.g()}g(){let Se=!1;const je=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",je),(0,y.$wW)(process.parentPort,ot.$Hdc.exit,je)}async init(){const Se=await this.h();(0,te.$kmb)(),Se.invokeFunction(je=>{const Ge=je.get(J.$5j),We=je.get(W.$4l),Ze=je.get(ye.$El);Ge.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(je),this.m(Ge),this.n(We,Ze),this.B(Ze.onDidChangeProfiles(()=>this.n(We,Ze))),this.r(We,Ge)}),this.B((0,A.$Rc)(Se.createInstance(p.$1ec,this.f.codeCachePath),Se.createInstance(l.$2ec),Se.createInstance(m.$5ec),Se.createInstance(b.$4ec),Se.createInstance(c.$3ec),Se.createInstance(Xe.$pfc),Se.createInstance(Je.$hfc)))}async h(){const Se=new K.$wi,je={_serviceBrand:void 0,...H.default};Se.set(ie.$lk,je);const Ge=new E.$gi(Qe=>Qe==="main"),We=new wt.$Cec(this.a,Ge);Se.set(wt.$Bec,We);const Ze=this.f.policiesData?new Ie.$$dc(this.f.policiesData,We.getChannel("policy")):new Fe.$jo;Se.set(Fe.$ho,Ze);const Ke=new Mt.$$m(this.f.args,je);Se.set(s.$Gi,Ke);const it=new V.$ds(void 0,this.f.logLevel,Ke.logsHome,this.f.loggers.map(Qe=>({...Qe,resource:I.URI.revive(Qe.resource)})),We.getChannel("logger"));Se.set(J.$6j,it);const ct=this.B(it.createLogger("sharedprocess",{name:(0,tt.localize)(0,null)})),ft=this.B(new J.$ak(ct.getLevel())),xe=this.B(new nt.$bQ(ct,[ft]));Se.set(J.$5j,xe),this.b=this.B(new mt.$rfc(xe)),Se.set(mt.$qfc,this.b);const _e=this.B(new R.$Mq(xe));Se.set(C.$5k,_e);const dt=this.B(new M.$dr(xe));_e.registerProvider(O.Schemas.file,dt);const lt=new qe.$Es(_e);Se.set(Ae.$Cl,lt);const et=this.B(new He.$iQ(this.f.profiles.all,I.URI.revive(this.f.profiles.home).with({scheme:Ke.userRoamingDataHome.scheme}),We.getChannel("userDataProfiles")));Se.set(ye.$El,et);const gt=this.B(new Me.$Aec(O.Schemas.file,this.B(new Ne.$WP(We.getChannel(Ne.$VP),{pathCaseSensitive:Ve.$k})),O.Schemas.vscodeUserData,et,lt,xe));_e.registerProvider(O.Schemas.vscodeUserData,gt);const st=this.B(new g.$Jo(et.defaultProfile.settingsResource,_e,Ze,xe));Se.set(h.$5i,st);const $t=new At.$xfc(void 0,{defaultProfile:et.defaultProfile,currentProfile:et.defaultProfile},We,Ke);Se.set(he.$5p,$t),this.B((0,A.$Sc)(()=>$t.flush())),await Promise.all([st.initialize(),$t.initialize()]);const vt=new It.$Zr(We.getChannel("request"));Se.set(se.$Rp,vt),Se.set(f.$6ec,new T.$vi(u.$7ec,void 0,!1)),Se.set(re.$rG,new T.$vi(Ue.$gfc,void 0,!1));const Et=new Ot.$Hec(-1,We);Se.set(Dt.$mdc,Et),Se.set(r.$No,new T.$vi(n.$qQ,void 0,!0));const zt=this.B(new we.$8dc(Et)),Bt=new E.$gi(Qe=>zt.getActiveClientId().then(ut=>Qe===ut));Se.set(k.$L4b,new Rt.$tfc(this.a.getChannel("extensionRecommendationNotification",Bt)));let ht;const rt=[],St=(0,B.$vp)(je,st);if((0,B.$qp)(je,Ke)){const Qe=new j.$$ac(xe,it,Ke,je);if(rt.push(Qe),!(0,B.$rp)(je,Ke)&&je.aiConfig?.ariaKey){const ut=new Be.$2P(vt,St,"monacoworkbench",null,je.aiConfig.ariaKey);this.B((0,A.$Sc)(()=>ut.flush())),rt.push(ut)}ht=new F.$4r({appenders:rt,commonProperties:(0,ee.$hp)((0,D.release)(),(0,D.hostname)(),process.arch,je.commit,je.version,this.f.machineId,this.f.sqmId,St),sendErrorTelemetry:!0,piiPaths:(0,B.$wp)(Ke)},st,je)}else{ht=B.$lp;const Qe=B.$pp;rt.push(Qe)}this.a.registerChannel("telemetryAppender",new z.$Mdc(rt)),Se.set(W.$4l,ht);const Ht=new U.$8ec(st,ht,xe,it,Ke,je);Se.set(W.$5l,Ht),Se.set(ke.$tq,new T.$vi(Ct.$aQ,void 0,!0)),Se.set(fe.$xq,new T.$vi(me.$_dc,void 0,!0)),Se.set(w.$dq,new T.$vi(w.$fq,void 0,!0)),Se.set(v.$Hq,new T.$vi(v.$Iq,void 0,!0)),Se.set(a.$0o,new T.$vi(o.$bq,void 0,!0)),Se.set(a.$ep,new T.$vi(Lt.$wfc,void 0,!1)),Se.set(Z.$Vr,new T.$vi(G.$Xr,void 0,!1)),Se.set($.$fn,new T.$vi(t.$Ls,void 0,!1)),Se.set(_.$AKb,new T.$vi(_.$BKb,void 0,!0)),Se.set(te.$Fmb,new T.$vi($e.$9Mb,void 0,!0)),Se.set(te.$Emb,E.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Qe=>Qe.ctx!=="main"))),Se.set(a.$dp,new T.$vi(i.$yKb,void 0,!1)),Se.set(x.$7Mb,new T.$vi(x.$8Mb,void 0,!0)),Se.set(Q.$$v,new T.$vi(Q.$_v)),Se.set(te.$pmb,new T.$vi(Pe.$bMb,void 0,!0)),Se.set(te.$qmb,new T.$vi(Pe.$dMb,void 0,!0)),Se.set(de.$dmb,new T.$vi(de.$fmb,void 0,!0)),Se.set(te.$rmb,new T.$vi(oe.$Nbc,void 0,!1)),Se.set(te.$Amb,new T.$vi(ge.$Cbc,void 0,!0)),Se.set(te.$Bmb,new T.$vi(be.$Sbc,void 0,!1)),Se.set(Re.$cLb,new T.$vi(le.$cfc,void 0,!0)),Se.set(te.$Cmb,new T.$vi(Ye.$pcc,void 0,!0)),Se.set(pe.$Rl,new T.$vi(Ce.$xec,void 0,!1));const kt=new pt.$Pl;return Se.set(pt.$Ol,kt),kt.register(0,Nt.$yfc),Se.set(De.$nw,new T.$vi(Le.$vec)),Se.set(Oe.$dfc,new T.$vi(Te.$ffc)),Se.set(ze.$ifc,new T.$vi(Pt.$sfc)),new Y.$gr(Se)}j(Se){const je=new S.$hq(Se.get(a.$ap),()=>null);this.a.registerChannel("extensions",je);const Ge=E.ProxyChannel.fromService(Se.get(Z.$Vr),this.q);this.a.registerChannel("languagePacks",Ge);const We=E.ProxyChannel.fromService(Se.get($.$fn),this.q);this.a.registerChannel("diagnostics",We);const Ze=new S.$jq(Se.get(a.$ep));this.a.registerChannel("extensionTipsService",Ze);const Ke=E.ProxyChannel.fromService(Se.get(f.$6ec),this.q);this.a.registerChannel("checksum",Ke);const it=E.ProxyChannel.fromService(Se.get(re.$rG),this.q);this.a.registerChannel("v8InspectProfiling",it);const ct=E.ProxyChannel.fromService(Se.get(de.$dmb),this.q);this.a.registerChannel("userDataSyncMachines",ct);const ft=E.ProxyChannel.fromService(Se.get(W.$5l),this.q);this.a.registerChannel("customEndpointTelemetry",ft);const xe=new ue.$9ec(Se.get(_.$AKb));this.a.registerChannel("userDataSyncAccount",xe);const _e=new ue.$$ec(Se.get(te.$pmb));this.a.registerChannel("userDataSyncStoreManagement",_e);const dt=new Ee.$afc(Se.get(te.$Bmb),Se.get(ye.$El),Se.get(J.$5j));this.a.registerChannel("userDataSync",dt);const lt=this.B(Se.get(q.$xi).createInstance(jt.$vfc));this.a.registerChannel("userDataAutoSync",E.ProxyChannel.fromService(lt,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",E.ProxyChannel.fromService(Se.get(te.$Cmb),this.q));const et=E.ProxyChannel.fromService(Se.get(Oe.$dfc),this.q);this.a.registerChannel(Oe.$efc,et);const gt=E.ProxyChannel.fromService(Se.get(ze.$ifc),this.q);this.a.registerChannel("remoteTunnel",gt)}m(Se){process.on("uncaughtException",je=>(0,L.$1)(je)),process.on("unhandledRejection",je=>(0,L.$1)(je)),(0,L.setUnexpectedErrorHandler)(je=>{const Ge=(0,N.$jj)(je,!0);Ge&&Se.error(`[uncaught exception in sharedProcess]: ${Ge}`)})}n(Se,je){Se.publicLog2("profilesInfo",{count:je.profiles.length})}async r(Se,je){if(Ve.$k){const[Ge,We]=await Promise.all([(0,Ft.$Vg)(je.error.bind(je)),(0,bt.$dW)(je.error.bind(je))]),Ze=(0,Tt.$VV)(),Ke=(0,bt.$eW)(We,this.f.args["ozone-platform"]);Ge&&Se.publicLog2("clientPlatformInfo",{platformId:Ge.id,platformVersionId:Ge.version_id,platformIdLike:Ge.id_like,desktopEnvironment:Ze,displayProtocol:We,codeDisplayProtocol:Ke})}}handledClientConnection(Se){if(Se.data!==ot.$Jdc.response)return!1;const je=(0,P.$Ob)(Se.ports);return je?(this.c.fire(je),!0):!1}}async function yt(at){try{const Se=new qt(at);process.parentPort.postMessage(ot.$Hdc.ipcReady),await Se.init(),process.parentPort.postMessage(ot.$Hdc.initDone)}catch(Se){process.parentPort.postMessage({error:Se.toString()})}}const Ut=setTimeout(()=>{process.parentPort.postMessage({warning:"[SharedProcess] did not receive configuration within 30s..."})},3e4);process.parentPort.once("message",at=>{clearTimeout(Ut),yt(at.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/bbc4ba1eff648ee542972589216f211b7a6a08f2/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
